// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
(function(global, factory) { /* global define, require, module */

    /* AMD */ if (typeof define === 'function' && define.amd)
        define(["protobufjs/minimal"], factory);

    /* CommonJS */ else if (typeof require === 'function' && typeof module === 'object' && module && module.exports)
        module.exports = factory(require("google-gax/build/src/protobuf").protobufMinimal);

})(this, function($protobuf) {
    "use strict";

    // Common aliases
    var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;
    
    // Exported root namespace
    var $root = $protobuf.roots._google_analytics_admin_protos || ($protobuf.roots._google_analytics_admin_protos = {});
    
    $root.google = (function() {
    
        /**
         * Namespace google.
         * @exports google
         * @namespace
         */
        var google = {};
    
        google.analytics = (function() {
    
            /**
             * Namespace analytics.
             * @memberof google
             * @namespace
             */
            var analytics = {};
    
            analytics.admin = (function() {
    
                /**
                 * Namespace admin.
                 * @memberof google.analytics
                 * @namespace
                 */
                var admin = {};
    
                admin.v1alpha = (function() {
    
                    /**
                     * Namespace v1alpha.
                     * @memberof google.analytics.admin
                     * @namespace
                     */
                    var v1alpha = {};
    
                    v1alpha.AccessDimension = (function() {
    
                        /**
                         * Properties of an AccessDimension.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessDimension
                         * @property {string|null} [dimensionName] AccessDimension dimensionName
                         */
    
                        /**
                         * Constructs a new AccessDimension.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessDimension.
                         * @implements IAccessDimension
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessDimension=} [properties] Properties to set
                         */
                        function AccessDimension(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDimension dimensionName.
                         * @member {string} dimensionName
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @instance
                         */
                        AccessDimension.prototype.dimensionName = "";
    
                        /**
                         * Creates a new AccessDimension instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimension=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessDimension} AccessDimension instance
                         */
                        AccessDimension.create = function create(properties) {
                            return new AccessDimension(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDimension message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDimension.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimension} message AccessDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimension.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionName != null && Object.hasOwnProperty.call(message, "dimensionName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.dimensionName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDimension message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDimension.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimension} message AccessDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimension.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDimension message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessDimension} AccessDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimension.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessDimension();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dimensionName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDimension message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessDimension} AccessDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimension.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDimension message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDimension.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                if (!$util.isString(message.dimensionName))
                                    return "dimensionName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDimension message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessDimension} AccessDimension
                         */
                        AccessDimension.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessDimension)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessDimension();
                            if (object.dimensionName != null)
                                message.dimensionName = String(object.dimensionName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDimension message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessDimension} message AccessDimension
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDimension.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.dimensionName = "";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                object.dimensionName = message.dimensionName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDimension to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDimension.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDimension
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessDimension
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDimension.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessDimension";
                        };
    
                        return AccessDimension;
                    })();
    
                    v1alpha.AccessMetric = (function() {
    
                        /**
                         * Properties of an AccessMetric.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessMetric
                         * @property {string|null} [metricName] AccessMetric metricName
                         */
    
                        /**
                         * Constructs a new AccessMetric.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessMetric.
                         * @implements IAccessMetric
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessMetric=} [properties] Properties to set
                         */
                        function AccessMetric(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessMetric metricName.
                         * @member {string} metricName
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @instance
                         */
                        AccessMetric.prototype.metricName = "";
    
                        /**
                         * Creates a new AccessMetric instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetric=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessMetric} AccessMetric instance
                         */
                        AccessMetric.create = function create(properties) {
                            return new AccessMetric(properties);
                        };
    
                        /**
                         * Encodes the specified AccessMetric message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessMetric.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetric} message AccessMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetric.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metricName != null && Object.hasOwnProperty.call(message, "metricName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.metricName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessMetric message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessMetric.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetric} message AccessMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetric.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessMetric message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessMetric} AccessMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetric.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessMetric();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.metricName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessMetric message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessMetric} AccessMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetric.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessMetric message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessMetric.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                if (!$util.isString(message.metricName))
                                    return "metricName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessMetric message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessMetric} AccessMetric
                         */
                        AccessMetric.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessMetric)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessMetric();
                            if (object.metricName != null)
                                message.metricName = String(object.metricName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessMetric message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessMetric} message AccessMetric
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessMetric.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.metricName = "";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                object.metricName = message.metricName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessMetric to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessMetric.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessMetric
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessMetric
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessMetric.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessMetric";
                        };
    
                        return AccessMetric;
                    })();
    
                    v1alpha.AccessDateRange = (function() {
    
                        /**
                         * Properties of an AccessDateRange.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessDateRange
                         * @property {string|null} [startDate] AccessDateRange startDate
                         * @property {string|null} [endDate] AccessDateRange endDate
                         */
    
                        /**
                         * Constructs a new AccessDateRange.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessDateRange.
                         * @implements IAccessDateRange
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessDateRange=} [properties] Properties to set
                         */
                        function AccessDateRange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDateRange startDate.
                         * @member {string} startDate
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @instance
                         */
                        AccessDateRange.prototype.startDate = "";
    
                        /**
                         * AccessDateRange endDate.
                         * @member {string} endDate
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @instance
                         */
                        AccessDateRange.prototype.endDate = "";
    
                        /**
                         * Creates a new AccessDateRange instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDateRange=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessDateRange} AccessDateRange instance
                         */
                        AccessDateRange.create = function create(properties) {
                            return new AccessDateRange(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDateRange message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDateRange.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDateRange} message AccessDateRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDateRange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.startDate != null && Object.hasOwnProperty.call(message, "startDate"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.startDate);
                            if (message.endDate != null && Object.hasOwnProperty.call(message, "endDate"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.endDate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDateRange message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDateRange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDateRange} message AccessDateRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDateRange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDateRange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessDateRange} AccessDateRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDateRange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessDateRange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.startDate = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.endDate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDateRange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessDateRange} AccessDateRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDateRange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDateRange message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDateRange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                if (!$util.isString(message.startDate))
                                    return "startDate: string expected";
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                if (!$util.isString(message.endDate))
                                    return "endDate: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDateRange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessDateRange} AccessDateRange
                         */
                        AccessDateRange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessDateRange)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessDateRange();
                            if (object.startDate != null)
                                message.startDate = String(object.startDate);
                            if (object.endDate != null)
                                message.endDate = String(object.endDate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDateRange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessDateRange} message AccessDateRange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDateRange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.startDate = "";
                                object.endDate = "";
                            }
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = message.startDate;
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = message.endDate;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDateRange to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDateRange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDateRange
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessDateRange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDateRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessDateRange";
                        };
    
                        return AccessDateRange;
                    })();
    
                    v1alpha.AccessFilterExpression = (function() {
    
                        /**
                         * Properties of an AccessFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessFilterExpression
                         * @property {google.analytics.admin.v1alpha.IAccessFilterExpressionList|null} [andGroup] AccessFilterExpression andGroup
                         * @property {google.analytics.admin.v1alpha.IAccessFilterExpressionList|null} [orGroup] AccessFilterExpression orGroup
                         * @property {google.analytics.admin.v1alpha.IAccessFilterExpression|null} [notExpression] AccessFilterExpression notExpression
                         * @property {google.analytics.admin.v1alpha.IAccessFilter|null} [accessFilter] AccessFilterExpression accessFilter
                         */
    
                        /**
                         * Constructs a new AccessFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessFilterExpression.
                         * @implements IAccessFilterExpression
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpression=} [properties] Properties to set
                         */
                        function AccessFilterExpression(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessFilterExpression andGroup.
                         * @member {google.analytics.admin.v1alpha.IAccessFilterExpressionList|null|undefined} andGroup
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.andGroup = null;
    
                        /**
                         * AccessFilterExpression orGroup.
                         * @member {google.analytics.admin.v1alpha.IAccessFilterExpressionList|null|undefined} orGroup
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.orGroup = null;
    
                        /**
                         * AccessFilterExpression notExpression.
                         * @member {google.analytics.admin.v1alpha.IAccessFilterExpression|null|undefined} notExpression
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.notExpression = null;
    
                        /**
                         * AccessFilterExpression accessFilter.
                         * @member {google.analytics.admin.v1alpha.IAccessFilter|null|undefined} accessFilter
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.accessFilter = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessFilterExpression oneExpression.
                         * @member {"andGroup"|"orGroup"|"notExpression"|"accessFilter"|undefined} oneExpression
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @instance
                         */
                        Object.defineProperty(AccessFilterExpression.prototype, "oneExpression", {
                            get: $util.oneOfGetter($oneOfFields = ["andGroup", "orGroup", "notExpression", "accessFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessFilterExpression instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpression=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpression} AccessFilterExpression instance
                         */
                        AccessFilterExpression.create = function create(properties) {
                            return new AccessFilterExpression(properties);
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpression message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessFilterExpression.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpression} message AccessFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpression.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.andGroup != null && Object.hasOwnProperty.call(message, "andGroup"))
                                $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.encode(message.andGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.orGroup != null && Object.hasOwnProperty.call(message, "orGroup"))
                                $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.encode(message.orGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.notExpression != null && Object.hasOwnProperty.call(message, "notExpression"))
                                $root.google.analytics.admin.v1alpha.AccessFilterExpression.encode(message.notExpression, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.accessFilter != null && Object.hasOwnProperty.call(message, "accessFilter"))
                                $root.google.analytics.admin.v1alpha.AccessFilter.encode(message.accessFilter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpression message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessFilterExpression.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpression} message AccessFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpression.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessFilterExpression message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpression} AccessFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpression.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessFilterExpression();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.andGroup = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.orGroup = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.notExpression = $root.google.analytics.admin.v1alpha.AccessFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.accessFilter = $root.google.analytics.admin.v1alpha.AccessFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessFilterExpression message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpression} AccessFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpression.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessFilterExpression message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessFilterExpression.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.verify(message.andGroup);
                                    if (error)
                                        return "andGroup." + error;
                                }
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                if (properties.oneExpression === 1)
                                    return "oneExpression: multiple values";
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.verify(message.orGroup);
                                    if (error)
                                        return "orGroup." + error;
                                }
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                if (properties.oneExpression === 1)
                                    return "oneExpression: multiple values";
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessFilterExpression.verify(message.notExpression);
                                    if (error)
                                        return "notExpression." + error;
                                }
                            }
                            if (message.accessFilter != null && message.hasOwnProperty("accessFilter")) {
                                if (properties.oneExpression === 1)
                                    return "oneExpression: multiple values";
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessFilter.verify(message.accessFilter);
                                    if (error)
                                        return "accessFilter." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessFilterExpression message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpression} AccessFilterExpression
                         */
                        AccessFilterExpression.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessFilterExpression)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessFilterExpression();
                            if (object.andGroup != null) {
                                if (typeof object.andGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilterExpression.andGroup: object expected");
                                message.andGroup = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.fromObject(object.andGroup);
                            }
                            if (object.orGroup != null) {
                                if (typeof object.orGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilterExpression.orGroup: object expected");
                                message.orGroup = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.fromObject(object.orGroup);
                            }
                            if (object.notExpression != null) {
                                if (typeof object.notExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilterExpression.notExpression: object expected");
                                message.notExpression = $root.google.analytics.admin.v1alpha.AccessFilterExpression.fromObject(object.notExpression);
                            }
                            if (object.accessFilter != null) {
                                if (typeof object.accessFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilterExpression.accessFilter: object expected");
                                message.accessFilter = $root.google.analytics.admin.v1alpha.AccessFilter.fromObject(object.accessFilter);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessFilterExpression message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessFilterExpression} message AccessFilterExpression
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessFilterExpression.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                object.andGroup = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.toObject(message.andGroup, options);
                                if (options.oneofs)
                                    object.oneExpression = "andGroup";
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                object.orGroup = $root.google.analytics.admin.v1alpha.AccessFilterExpressionList.toObject(message.orGroup, options);
                                if (options.oneofs)
                                    object.oneExpression = "orGroup";
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                object.notExpression = $root.google.analytics.admin.v1alpha.AccessFilterExpression.toObject(message.notExpression, options);
                                if (options.oneofs)
                                    object.oneExpression = "notExpression";
                            }
                            if (message.accessFilter != null && message.hasOwnProperty("accessFilter")) {
                                object.accessFilter = $root.google.analytics.admin.v1alpha.AccessFilter.toObject(message.accessFilter, options);
                                if (options.oneofs)
                                    object.oneExpression = "accessFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessFilterExpression to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessFilterExpression.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessFilterExpression
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpression
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessFilterExpression.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessFilterExpression";
                        };
    
                        return AccessFilterExpression;
                    })();
    
                    v1alpha.AccessFilterExpressionList = (function() {
    
                        /**
                         * Properties of an AccessFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessFilterExpressionList
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessFilterExpression>|null} [expressions] AccessFilterExpressionList expressions
                         */
    
                        /**
                         * Constructs a new AccessFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessFilterExpressionList.
                         * @implements IAccessFilterExpressionList
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpressionList=} [properties] Properties to set
                         */
                        function AccessFilterExpressionList(properties) {
                            this.expressions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessFilterExpressionList expressions.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessFilterExpression>} expressions
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @instance
                         */
                        AccessFilterExpressionList.prototype.expressions = $util.emptyArray;
    
                        /**
                         * Creates a new AccessFilterExpressionList instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpressionList=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpressionList} AccessFilterExpressionList instance
                         */
                        AccessFilterExpressionList.create = function create(properties) {
                            return new AccessFilterExpressionList(properties);
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpressionList message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessFilterExpressionList.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpressionList} message AccessFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpressionList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.expressions != null && message.expressions.length)
                                for (var i = 0; i < message.expressions.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessFilterExpression.encode(message.expressions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpressionList message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessFilterExpressionList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilterExpressionList} message AccessFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpressionList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessFilterExpressionList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpressionList} AccessFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpressionList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessFilterExpressionList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.expressions && message.expressions.length))
                                            message.expressions = [];
                                        message.expressions.push($root.google.analytics.admin.v1alpha.AccessFilterExpression.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessFilterExpressionList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpressionList} AccessFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpressionList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessFilterExpressionList message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessFilterExpressionList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.expressions != null && message.hasOwnProperty("expressions")) {
                                if (!Array.isArray(message.expressions))
                                    return "expressions: array expected";
                                for (var i = 0; i < message.expressions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessFilterExpression.verify(message.expressions[i]);
                                    if (error)
                                        return "expressions." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessFilterExpressionList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessFilterExpressionList} AccessFilterExpressionList
                         */
                        AccessFilterExpressionList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessFilterExpressionList)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessFilterExpressionList();
                            if (object.expressions) {
                                if (!Array.isArray(object.expressions))
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilterExpressionList.expressions: array expected");
                                message.expressions = [];
                                for (var i = 0; i < object.expressions.length; ++i) {
                                    if (typeof object.expressions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AccessFilterExpressionList.expressions: object expected");
                                    message.expressions[i] = $root.google.analytics.admin.v1alpha.AccessFilterExpression.fromObject(object.expressions[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessFilterExpressionList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessFilterExpressionList} message AccessFilterExpressionList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessFilterExpressionList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.expressions = [];
                            if (message.expressions && message.expressions.length) {
                                object.expressions = [];
                                for (var j = 0; j < message.expressions.length; ++j)
                                    object.expressions[j] = $root.google.analytics.admin.v1alpha.AccessFilterExpression.toObject(message.expressions[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessFilterExpressionList to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessFilterExpressionList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessFilterExpressionList
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessFilterExpressionList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessFilterExpressionList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessFilterExpressionList";
                        };
    
                        return AccessFilterExpressionList;
                    })();
    
                    v1alpha.AccessFilter = (function() {
    
                        /**
                         * Properties of an AccessFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessFilter
                         * @property {google.analytics.admin.v1alpha.IAccessStringFilter|null} [stringFilter] AccessFilter stringFilter
                         * @property {google.analytics.admin.v1alpha.IAccessInListFilter|null} [inListFilter] AccessFilter inListFilter
                         * @property {google.analytics.admin.v1alpha.IAccessNumericFilter|null} [numericFilter] AccessFilter numericFilter
                         * @property {google.analytics.admin.v1alpha.IAccessBetweenFilter|null} [betweenFilter] AccessFilter betweenFilter
                         * @property {string|null} [fieldName] AccessFilter fieldName
                         */
    
                        /**
                         * Constructs a new AccessFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessFilter.
                         * @implements IAccessFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessFilter=} [properties] Properties to set
                         */
                        function AccessFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessFilter stringFilter.
                         * @member {google.analytics.admin.v1alpha.IAccessStringFilter|null|undefined} stringFilter
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.stringFilter = null;
    
                        /**
                         * AccessFilter inListFilter.
                         * @member {google.analytics.admin.v1alpha.IAccessInListFilter|null|undefined} inListFilter
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.inListFilter = null;
    
                        /**
                         * AccessFilter numericFilter.
                         * @member {google.analytics.admin.v1alpha.IAccessNumericFilter|null|undefined} numericFilter
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.numericFilter = null;
    
                        /**
                         * AccessFilter betweenFilter.
                         * @member {google.analytics.admin.v1alpha.IAccessBetweenFilter|null|undefined} betweenFilter
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.betweenFilter = null;
    
                        /**
                         * AccessFilter fieldName.
                         * @member {string} fieldName
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.fieldName = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessFilter oneFilter.
                         * @member {"stringFilter"|"inListFilter"|"numericFilter"|"betweenFilter"|undefined} oneFilter
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @instance
                         */
                        Object.defineProperty(AccessFilter.prototype, "oneFilter", {
                            get: $util.oneOfGetter($oneOfFields = ["stringFilter", "inListFilter", "numericFilter", "betweenFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessFilter} AccessFilter instance
                         */
                        AccessFilter.create = function create(properties) {
                            return new AccessFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilter} message AccessFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fieldName != null && Object.hasOwnProperty.call(message, "fieldName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fieldName);
                            if (message.stringFilter != null && Object.hasOwnProperty.call(message, "stringFilter"))
                                $root.google.analytics.admin.v1alpha.AccessStringFilter.encode(message.stringFilter, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.inListFilter != null && Object.hasOwnProperty.call(message, "inListFilter"))
                                $root.google.analytics.admin.v1alpha.AccessInListFilter.encode(message.inListFilter, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.numericFilter != null && Object.hasOwnProperty.call(message, "numericFilter"))
                                $root.google.analytics.admin.v1alpha.AccessNumericFilter.encode(message.numericFilter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.betweenFilter != null && Object.hasOwnProperty.call(message, "betweenFilter"))
                                $root.google.analytics.admin.v1alpha.AccessBetweenFilter.encode(message.betweenFilter, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessFilter} message AccessFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessFilter} AccessFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2: {
                                        message.stringFilter = $root.google.analytics.admin.v1alpha.AccessStringFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.inListFilter = $root.google.analytics.admin.v1alpha.AccessInListFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.numericFilter = $root.google.analytics.admin.v1alpha.AccessNumericFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.betweenFilter = $root.google.analytics.admin.v1alpha.AccessBetweenFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.fieldName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessFilter} AccessFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessStringFilter.verify(message.stringFilter);
                                    if (error)
                                        return "stringFilter." + error;
                                }
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessInListFilter.verify(message.inListFilter);
                                    if (error)
                                        return "inListFilter." + error;
                                }
                            }
                            if (message.numericFilter != null && message.hasOwnProperty("numericFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessNumericFilter.verify(message.numericFilter);
                                    if (error)
                                        return "numericFilter." + error;
                                }
                            }
                            if (message.betweenFilter != null && message.hasOwnProperty("betweenFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessBetweenFilter.verify(message.betweenFilter);
                                    if (error)
                                        return "betweenFilter." + error;
                                }
                            }
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                if (!$util.isString(message.fieldName))
                                    return "fieldName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessFilter} AccessFilter
                         */
                        AccessFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessFilter();
                            if (object.stringFilter != null) {
                                if (typeof object.stringFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilter.stringFilter: object expected");
                                message.stringFilter = $root.google.analytics.admin.v1alpha.AccessStringFilter.fromObject(object.stringFilter);
                            }
                            if (object.inListFilter != null) {
                                if (typeof object.inListFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilter.inListFilter: object expected");
                                message.inListFilter = $root.google.analytics.admin.v1alpha.AccessInListFilter.fromObject(object.inListFilter);
                            }
                            if (object.numericFilter != null) {
                                if (typeof object.numericFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilter.numericFilter: object expected");
                                message.numericFilter = $root.google.analytics.admin.v1alpha.AccessNumericFilter.fromObject(object.numericFilter);
                            }
                            if (object.betweenFilter != null) {
                                if (typeof object.betweenFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessFilter.betweenFilter: object expected");
                                message.betweenFilter = $root.google.analytics.admin.v1alpha.AccessBetweenFilter.fromObject(object.betweenFilter);
                            }
                            if (object.fieldName != null)
                                message.fieldName = String(object.fieldName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessFilter} message AccessFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.fieldName = "";
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                object.fieldName = message.fieldName;
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                object.stringFilter = $root.google.analytics.admin.v1alpha.AccessStringFilter.toObject(message.stringFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "stringFilter";
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                object.inListFilter = $root.google.analytics.admin.v1alpha.AccessInListFilter.toObject(message.inListFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "inListFilter";
                            }
                            if (message.numericFilter != null && message.hasOwnProperty("numericFilter")) {
                                object.numericFilter = $root.google.analytics.admin.v1alpha.AccessNumericFilter.toObject(message.numericFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "numericFilter";
                            }
                            if (message.betweenFilter != null && message.hasOwnProperty("betweenFilter")) {
                                object.betweenFilter = $root.google.analytics.admin.v1alpha.AccessBetweenFilter.toObject(message.betweenFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "betweenFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessFilter";
                        };
    
                        return AccessFilter;
                    })();
    
                    v1alpha.AccessStringFilter = (function() {
    
                        /**
                         * Properties of an AccessStringFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessStringFilter
                         * @property {google.analytics.admin.v1alpha.AccessStringFilter.MatchType|null} [matchType] AccessStringFilter matchType
                         * @property {string|null} [value] AccessStringFilter value
                         * @property {boolean|null} [caseSensitive] AccessStringFilter caseSensitive
                         */
    
                        /**
                         * Constructs a new AccessStringFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessStringFilter.
                         * @implements IAccessStringFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessStringFilter=} [properties] Properties to set
                         */
                        function AccessStringFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessStringFilter matchType.
                         * @member {google.analytics.admin.v1alpha.AccessStringFilter.MatchType} matchType
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @instance
                         */
                        AccessStringFilter.prototype.matchType = 0;
    
                        /**
                         * AccessStringFilter value.
                         * @member {string} value
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @instance
                         */
                        AccessStringFilter.prototype.value = "";
    
                        /**
                         * AccessStringFilter caseSensitive.
                         * @member {boolean} caseSensitive
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @instance
                         */
                        AccessStringFilter.prototype.caseSensitive = false;
    
                        /**
                         * Creates a new AccessStringFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessStringFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessStringFilter} AccessStringFilter instance
                         */
                        AccessStringFilter.create = function create(properties) {
                            return new AccessStringFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessStringFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessStringFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessStringFilter} message AccessStringFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessStringFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.matchType != null && Object.hasOwnProperty.call(message, "matchType"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.matchType);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.value);
                            if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.caseSensitive);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessStringFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessStringFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessStringFilter} message AccessStringFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessStringFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessStringFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessStringFilter} AccessStringFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessStringFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessStringFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.matchType = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.value = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.caseSensitive = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessStringFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessStringFilter} AccessStringFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessStringFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessStringFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessStringFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                switch (message.matchType) {
                                default:
                                    return "matchType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value"))
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                if (typeof message.caseSensitive !== "boolean")
                                    return "caseSensitive: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessStringFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessStringFilter} AccessStringFilter
                         */
                        AccessStringFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessStringFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessStringFilter();
                            switch (object.matchType) {
                            default:
                                if (typeof object.matchType === "number") {
                                    message.matchType = object.matchType;
                                    break;
                                }
                                break;
                            case "MATCH_TYPE_UNSPECIFIED":
                            case 0:
                                message.matchType = 0;
                                break;
                            case "EXACT":
                            case 1:
                                message.matchType = 1;
                                break;
                            case "BEGINS_WITH":
                            case 2:
                                message.matchType = 2;
                                break;
                            case "ENDS_WITH":
                            case 3:
                                message.matchType = 3;
                                break;
                            case "CONTAINS":
                            case 4:
                                message.matchType = 4;
                                break;
                            case "FULL_REGEXP":
                            case 5:
                                message.matchType = 5;
                                break;
                            case "PARTIAL_REGEXP":
                            case 6:
                                message.matchType = 6;
                                break;
                            }
                            if (object.value != null)
                                message.value = String(object.value);
                            if (object.caseSensitive != null)
                                message.caseSensitive = Boolean(object.caseSensitive);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessStringFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessStringFilter} message AccessStringFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessStringFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.matchType = options.enums === String ? "MATCH_TYPE_UNSPECIFIED" : 0;
                                object.value = "";
                                object.caseSensitive = false;
                            }
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                object.matchType = options.enums === String ? $root.google.analytics.admin.v1alpha.AccessStringFilter.MatchType[message.matchType] === undefined ? message.matchType : $root.google.analytics.admin.v1alpha.AccessStringFilter.MatchType[message.matchType] : message.matchType;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = message.value;
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                object.caseSensitive = message.caseSensitive;
                            return object;
                        };
    
                        /**
                         * Converts this AccessStringFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessStringFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessStringFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessStringFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessStringFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessStringFilter";
                        };
    
                        /**
                         * MatchType enum.
                         * @name google.analytics.admin.v1alpha.AccessStringFilter.MatchType
                         * @enum {number}
                         * @property {number} MATCH_TYPE_UNSPECIFIED=0 MATCH_TYPE_UNSPECIFIED value
                         * @property {number} EXACT=1 EXACT value
                         * @property {number} BEGINS_WITH=2 BEGINS_WITH value
                         * @property {number} ENDS_WITH=3 ENDS_WITH value
                         * @property {number} CONTAINS=4 CONTAINS value
                         * @property {number} FULL_REGEXP=5 FULL_REGEXP value
                         * @property {number} PARTIAL_REGEXP=6 PARTIAL_REGEXP value
                         */
                        AccessStringFilter.MatchType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "MATCH_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EXACT"] = 1;
                            values[valuesById[2] = "BEGINS_WITH"] = 2;
                            values[valuesById[3] = "ENDS_WITH"] = 3;
                            values[valuesById[4] = "CONTAINS"] = 4;
                            values[valuesById[5] = "FULL_REGEXP"] = 5;
                            values[valuesById[6] = "PARTIAL_REGEXP"] = 6;
                            return values;
                        })();
    
                        return AccessStringFilter;
                    })();
    
                    v1alpha.AccessInListFilter = (function() {
    
                        /**
                         * Properties of an AccessInListFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessInListFilter
                         * @property {Array.<string>|null} [values] AccessInListFilter values
                         * @property {boolean|null} [caseSensitive] AccessInListFilter caseSensitive
                         */
    
                        /**
                         * Constructs a new AccessInListFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessInListFilter.
                         * @implements IAccessInListFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessInListFilter=} [properties] Properties to set
                         */
                        function AccessInListFilter(properties) {
                            this.values = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessInListFilter values.
                         * @member {Array.<string>} values
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @instance
                         */
                        AccessInListFilter.prototype.values = $util.emptyArray;
    
                        /**
                         * AccessInListFilter caseSensitive.
                         * @member {boolean} caseSensitive
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @instance
                         */
                        AccessInListFilter.prototype.caseSensitive = false;
    
                        /**
                         * Creates a new AccessInListFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessInListFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessInListFilter} AccessInListFilter instance
                         */
                        AccessInListFilter.create = function create(properties) {
                            return new AccessInListFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessInListFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessInListFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessInListFilter} message AccessInListFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessInListFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.values != null && message.values.length)
                                for (var i = 0; i < message.values.length; ++i)
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.values[i]);
                            if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.caseSensitive);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessInListFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessInListFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessInListFilter} message AccessInListFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessInListFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessInListFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessInListFilter} AccessInListFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessInListFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessInListFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.values && message.values.length))
                                            message.values = [];
                                        message.values.push(reader.string());
                                        break;
                                    }
                                case 2: {
                                        message.caseSensitive = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessInListFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessInListFilter} AccessInListFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessInListFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessInListFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessInListFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.values != null && message.hasOwnProperty("values")) {
                                if (!Array.isArray(message.values))
                                    return "values: array expected";
                                for (var i = 0; i < message.values.length; ++i)
                                    if (!$util.isString(message.values[i]))
                                        return "values: string[] expected";
                            }
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                if (typeof message.caseSensitive !== "boolean")
                                    return "caseSensitive: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessInListFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessInListFilter} AccessInListFilter
                         */
                        AccessInListFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessInListFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessInListFilter();
                            if (object.values) {
                                if (!Array.isArray(object.values))
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessInListFilter.values: array expected");
                                message.values = [];
                                for (var i = 0; i < object.values.length; ++i)
                                    message.values[i] = String(object.values[i]);
                            }
                            if (object.caseSensitive != null)
                                message.caseSensitive = Boolean(object.caseSensitive);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessInListFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessInListFilter} message AccessInListFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessInListFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.values = [];
                            if (options.defaults)
                                object.caseSensitive = false;
                            if (message.values && message.values.length) {
                                object.values = [];
                                for (var j = 0; j < message.values.length; ++j)
                                    object.values[j] = message.values[j];
                            }
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                object.caseSensitive = message.caseSensitive;
                            return object;
                        };
    
                        /**
                         * Converts this AccessInListFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessInListFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessInListFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessInListFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessInListFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessInListFilter";
                        };
    
                        return AccessInListFilter;
                    })();
    
                    v1alpha.AccessNumericFilter = (function() {
    
                        /**
                         * Properties of an AccessNumericFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessNumericFilter
                         * @property {google.analytics.admin.v1alpha.AccessNumericFilter.Operation|null} [operation] AccessNumericFilter operation
                         * @property {google.analytics.admin.v1alpha.INumericValue|null} [value] AccessNumericFilter value
                         */
    
                        /**
                         * Constructs a new AccessNumericFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessNumericFilter.
                         * @implements IAccessNumericFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessNumericFilter=} [properties] Properties to set
                         */
                        function AccessNumericFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessNumericFilter operation.
                         * @member {google.analytics.admin.v1alpha.AccessNumericFilter.Operation} operation
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @instance
                         */
                        AccessNumericFilter.prototype.operation = 0;
    
                        /**
                         * AccessNumericFilter value.
                         * @member {google.analytics.admin.v1alpha.INumericValue|null|undefined} value
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @instance
                         */
                        AccessNumericFilter.prototype.value = null;
    
                        /**
                         * Creates a new AccessNumericFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessNumericFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessNumericFilter} AccessNumericFilter instance
                         */
                        AccessNumericFilter.create = function create(properties) {
                            return new AccessNumericFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessNumericFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessNumericFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessNumericFilter} message AccessNumericFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessNumericFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operation);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                $root.google.analytics.admin.v1alpha.NumericValue.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessNumericFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessNumericFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessNumericFilter} message AccessNumericFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessNumericFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessNumericFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessNumericFilter} AccessNumericFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessNumericFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessNumericFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.operation = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.value = $root.google.analytics.admin.v1alpha.NumericValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessNumericFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessNumericFilter} AccessNumericFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessNumericFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessNumericFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessNumericFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                switch (message.operation) {
                                default:
                                    return "operation: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.analytics.admin.v1alpha.NumericValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessNumericFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessNumericFilter} AccessNumericFilter
                         */
                        AccessNumericFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessNumericFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessNumericFilter();
                            switch (object.operation) {
                            default:
                                if (typeof object.operation === "number") {
                                    message.operation = object.operation;
                                    break;
                                }
                                break;
                            case "OPERATION_UNSPECIFIED":
                            case 0:
                                message.operation = 0;
                                break;
                            case "EQUAL":
                            case 1:
                                message.operation = 1;
                                break;
                            case "LESS_THAN":
                            case 2:
                                message.operation = 2;
                                break;
                            case "LESS_THAN_OR_EQUAL":
                            case 3:
                                message.operation = 3;
                                break;
                            case "GREATER_THAN":
                            case 4:
                                message.operation = 4;
                                break;
                            case "GREATER_THAN_OR_EQUAL":
                            case 5:
                                message.operation = 5;
                                break;
                            }
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessNumericFilter.value: object expected");
                                message.value = $root.google.analytics.admin.v1alpha.NumericValue.fromObject(object.value);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessNumericFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessNumericFilter} message AccessNumericFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessNumericFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = options.enums === String ? "OPERATION_UNSPECIFIED" : 0;
                                object.value = null;
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = options.enums === String ? $root.google.analytics.admin.v1alpha.AccessNumericFilter.Operation[message.operation] === undefined ? message.operation : $root.google.analytics.admin.v1alpha.AccessNumericFilter.Operation[message.operation] : message.operation;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.analytics.admin.v1alpha.NumericValue.toObject(message.value, options);
                            return object;
                        };
    
                        /**
                         * Converts this AccessNumericFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessNumericFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessNumericFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessNumericFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessNumericFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessNumericFilter";
                        };
    
                        /**
                         * Operation enum.
                         * @name google.analytics.admin.v1alpha.AccessNumericFilter.Operation
                         * @enum {number}
                         * @property {number} OPERATION_UNSPECIFIED=0 OPERATION_UNSPECIFIED value
                         * @property {number} EQUAL=1 EQUAL value
                         * @property {number} LESS_THAN=2 LESS_THAN value
                         * @property {number} LESS_THAN_OR_EQUAL=3 LESS_THAN_OR_EQUAL value
                         * @property {number} GREATER_THAN=4 GREATER_THAN value
                         * @property {number} GREATER_THAN_OR_EQUAL=5 GREATER_THAN_OR_EQUAL value
                         */
                        AccessNumericFilter.Operation = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "OPERATION_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EQUAL"] = 1;
                            values[valuesById[2] = "LESS_THAN"] = 2;
                            values[valuesById[3] = "LESS_THAN_OR_EQUAL"] = 3;
                            values[valuesById[4] = "GREATER_THAN"] = 4;
                            values[valuesById[5] = "GREATER_THAN_OR_EQUAL"] = 5;
                            return values;
                        })();
    
                        return AccessNumericFilter;
                    })();
    
                    v1alpha.AccessBetweenFilter = (function() {
    
                        /**
                         * Properties of an AccessBetweenFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessBetweenFilter
                         * @property {google.analytics.admin.v1alpha.INumericValue|null} [fromValue] AccessBetweenFilter fromValue
                         * @property {google.analytics.admin.v1alpha.INumericValue|null} [toValue] AccessBetweenFilter toValue
                         */
    
                        /**
                         * Constructs a new AccessBetweenFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessBetweenFilter.
                         * @implements IAccessBetweenFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessBetweenFilter=} [properties] Properties to set
                         */
                        function AccessBetweenFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessBetweenFilter fromValue.
                         * @member {google.analytics.admin.v1alpha.INumericValue|null|undefined} fromValue
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @instance
                         */
                        AccessBetweenFilter.prototype.fromValue = null;
    
                        /**
                         * AccessBetweenFilter toValue.
                         * @member {google.analytics.admin.v1alpha.INumericValue|null|undefined} toValue
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @instance
                         */
                        AccessBetweenFilter.prototype.toValue = null;
    
                        /**
                         * Creates a new AccessBetweenFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessBetweenFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessBetweenFilter} AccessBetweenFilter instance
                         */
                        AccessBetweenFilter.create = function create(properties) {
                            return new AccessBetweenFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessBetweenFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessBetweenFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessBetweenFilter} message AccessBetweenFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessBetweenFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fromValue != null && Object.hasOwnProperty.call(message, "fromValue"))
                                $root.google.analytics.admin.v1alpha.NumericValue.encode(message.fromValue, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.toValue != null && Object.hasOwnProperty.call(message, "toValue"))
                                $root.google.analytics.admin.v1alpha.NumericValue.encode(message.toValue, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessBetweenFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessBetweenFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessBetweenFilter} message AccessBetweenFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessBetweenFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessBetweenFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessBetweenFilter} AccessBetweenFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessBetweenFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessBetweenFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.fromValue = $root.google.analytics.admin.v1alpha.NumericValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.toValue = $root.google.analytics.admin.v1alpha.NumericValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessBetweenFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessBetweenFilter} AccessBetweenFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessBetweenFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessBetweenFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessBetweenFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.fromValue != null && message.hasOwnProperty("fromValue")) {
                                var error = $root.google.analytics.admin.v1alpha.NumericValue.verify(message.fromValue);
                                if (error)
                                    return "fromValue." + error;
                            }
                            if (message.toValue != null && message.hasOwnProperty("toValue")) {
                                var error = $root.google.analytics.admin.v1alpha.NumericValue.verify(message.toValue);
                                if (error)
                                    return "toValue." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessBetweenFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessBetweenFilter} AccessBetweenFilter
                         */
                        AccessBetweenFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessBetweenFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessBetweenFilter();
                            if (object.fromValue != null) {
                                if (typeof object.fromValue !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessBetweenFilter.fromValue: object expected");
                                message.fromValue = $root.google.analytics.admin.v1alpha.NumericValue.fromObject(object.fromValue);
                            }
                            if (object.toValue != null) {
                                if (typeof object.toValue !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessBetweenFilter.toValue: object expected");
                                message.toValue = $root.google.analytics.admin.v1alpha.NumericValue.fromObject(object.toValue);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessBetweenFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessBetweenFilter} message AccessBetweenFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessBetweenFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.fromValue = null;
                                object.toValue = null;
                            }
                            if (message.fromValue != null && message.hasOwnProperty("fromValue"))
                                object.fromValue = $root.google.analytics.admin.v1alpha.NumericValue.toObject(message.fromValue, options);
                            if (message.toValue != null && message.hasOwnProperty("toValue"))
                                object.toValue = $root.google.analytics.admin.v1alpha.NumericValue.toObject(message.toValue, options);
                            return object;
                        };
    
                        /**
                         * Converts this AccessBetweenFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessBetweenFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessBetweenFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessBetweenFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessBetweenFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessBetweenFilter";
                        };
    
                        return AccessBetweenFilter;
                    })();
    
                    v1alpha.NumericValue = (function() {
    
                        /**
                         * Properties of a NumericValue.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface INumericValue
                         * @property {number|Long|null} [int64Value] NumericValue int64Value
                         * @property {number|null} [doubleValue] NumericValue doubleValue
                         */
    
                        /**
                         * Constructs a new NumericValue.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a NumericValue.
                         * @implements INumericValue
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.INumericValue=} [properties] Properties to set
                         */
                        function NumericValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NumericValue int64Value.
                         * @member {number|Long|null|undefined} int64Value
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @instance
                         */
                        NumericValue.prototype.int64Value = null;
    
                        /**
                         * NumericValue doubleValue.
                         * @member {number|null|undefined} doubleValue
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @instance
                         */
                        NumericValue.prototype.doubleValue = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NumericValue oneValue.
                         * @member {"int64Value"|"doubleValue"|undefined} oneValue
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @instance
                         */
                        Object.defineProperty(NumericValue.prototype, "oneValue", {
                            get: $util.oneOfGetter($oneOfFields = ["int64Value", "doubleValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NumericValue instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.INumericValue=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.NumericValue} NumericValue instance
                         */
                        NumericValue.create = function create(properties) {
                            return new NumericValue(properties);
                        };
    
                        /**
                         * Encodes the specified NumericValue message. Does not implicitly {@link google.analytics.admin.v1alpha.NumericValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.INumericValue} message NumericValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NumericValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.int64Value != null && Object.hasOwnProperty.call(message, "int64Value"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.int64Value);
                            if (message.doubleValue != null && Object.hasOwnProperty.call(message, "doubleValue"))
                                writer.uint32(/* id 2, wireType 1 =*/17).double(message.doubleValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NumericValue message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.NumericValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.INumericValue} message NumericValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NumericValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NumericValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.NumericValue} NumericValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NumericValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.NumericValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.int64Value = reader.int64();
                                        break;
                                    }
                                case 2: {
                                        message.doubleValue = reader.double();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NumericValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.NumericValue} NumericValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NumericValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NumericValue message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NumericValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                properties.oneValue = 1;
                                if (!$util.isInteger(message.int64Value) && !(message.int64Value && $util.isInteger(message.int64Value.low) && $util.isInteger(message.int64Value.high)))
                                    return "int64Value: integer|Long expected";
                            }
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                if (properties.oneValue === 1)
                                    return "oneValue: multiple values";
                                properties.oneValue = 1;
                                if (typeof message.doubleValue !== "number")
                                    return "doubleValue: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NumericValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.NumericValue} NumericValue
                         */
                        NumericValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.NumericValue)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.NumericValue();
                            if (object.int64Value != null)
                                if ($util.Long)
                                    (message.int64Value = $util.Long.fromValue(object.int64Value)).unsigned = false;
                                else if (typeof object.int64Value === "string")
                                    message.int64Value = parseInt(object.int64Value, 10);
                                else if (typeof object.int64Value === "number")
                                    message.int64Value = object.int64Value;
                                else if (typeof object.int64Value === "object")
                                    message.int64Value = new $util.LongBits(object.int64Value.low >>> 0, object.int64Value.high >>> 0).toNumber();
                            if (object.doubleValue != null)
                                message.doubleValue = Number(object.doubleValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NumericValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.NumericValue} message NumericValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NumericValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                if (typeof message.int64Value === "number")
                                    object.int64Value = options.longs === String ? String(message.int64Value) : message.int64Value;
                                else
                                    object.int64Value = options.longs === String ? $util.Long.prototype.toString.call(message.int64Value) : options.longs === Number ? new $util.LongBits(message.int64Value.low >>> 0, message.int64Value.high >>> 0).toNumber() : message.int64Value;
                                if (options.oneofs)
                                    object.oneValue = "int64Value";
                            }
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                object.doubleValue = options.json && !isFinite(message.doubleValue) ? String(message.doubleValue) : message.doubleValue;
                                if (options.oneofs)
                                    object.oneValue = "doubleValue";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NumericValue to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NumericValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NumericValue
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.NumericValue
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NumericValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.NumericValue";
                        };
    
                        return NumericValue;
                    })();
    
                    v1alpha.AccessOrderBy = (function() {
    
                        /**
                         * Properties of an AccessOrderBy.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessOrderBy
                         * @property {google.analytics.admin.v1alpha.AccessOrderBy.IMetricOrderBy|null} [metric] AccessOrderBy metric
                         * @property {google.analytics.admin.v1alpha.AccessOrderBy.IDimensionOrderBy|null} [dimension] AccessOrderBy dimension
                         * @property {boolean|null} [desc] AccessOrderBy desc
                         */
    
                        /**
                         * Constructs a new AccessOrderBy.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessOrderBy.
                         * @implements IAccessOrderBy
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessOrderBy=} [properties] Properties to set
                         */
                        function AccessOrderBy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessOrderBy metric.
                         * @member {google.analytics.admin.v1alpha.AccessOrderBy.IMetricOrderBy|null|undefined} metric
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @instance
                         */
                        AccessOrderBy.prototype.metric = null;
    
                        /**
                         * AccessOrderBy dimension.
                         * @member {google.analytics.admin.v1alpha.AccessOrderBy.IDimensionOrderBy|null|undefined} dimension
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @instance
                         */
                        AccessOrderBy.prototype.dimension = null;
    
                        /**
                         * AccessOrderBy desc.
                         * @member {boolean} desc
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @instance
                         */
                        AccessOrderBy.prototype.desc = false;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessOrderBy oneOrderBy.
                         * @member {"metric"|"dimension"|undefined} oneOrderBy
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @instance
                         */
                        Object.defineProperty(AccessOrderBy.prototype, "oneOrderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["metric", "dimension"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessOrderBy instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessOrderBy=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessOrderBy} AccessOrderBy instance
                         */
                        AccessOrderBy.create = function create(properties) {
                            return new AccessOrderBy(properties);
                        };
    
                        /**
                         * Encodes the specified AccessOrderBy message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessOrderBy.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessOrderBy} message AccessOrderBy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessOrderBy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metric != null && Object.hasOwnProperty.call(message, "metric"))
                                $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy.encode(message.metric, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.dimension != null && Object.hasOwnProperty.call(message, "dimension"))
                                $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.encode(message.dimension, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.desc != null && Object.hasOwnProperty.call(message, "desc"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.desc);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessOrderBy message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessOrderBy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessOrderBy} message AccessOrderBy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessOrderBy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessOrderBy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessOrderBy} AccessOrderBy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessOrderBy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessOrderBy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.metric = $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.dimension = $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.desc = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessOrderBy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessOrderBy} AccessOrderBy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessOrderBy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessOrderBy message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessOrderBy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                properties.oneOrderBy = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy.verify(message.metric);
                                    if (error)
                                        return "metric." + error;
                                }
                            }
                            if (message.dimension != null && message.hasOwnProperty("dimension")) {
                                if (properties.oneOrderBy === 1)
                                    return "oneOrderBy: multiple values";
                                properties.oneOrderBy = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.verify(message.dimension);
                                    if (error)
                                        return "dimension." + error;
                                }
                            }
                            if (message.desc != null && message.hasOwnProperty("desc"))
                                if (typeof message.desc !== "boolean")
                                    return "desc: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessOrderBy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessOrderBy} AccessOrderBy
                         */
                        AccessOrderBy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessOrderBy)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessOrderBy();
                            if (object.metric != null) {
                                if (typeof object.metric !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessOrderBy.metric: object expected");
                                message.metric = $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy.fromObject(object.metric);
                            }
                            if (object.dimension != null) {
                                if (typeof object.dimension !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessOrderBy.dimension: object expected");
                                message.dimension = $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.fromObject(object.dimension);
                            }
                            if (object.desc != null)
                                message.desc = Boolean(object.desc);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessOrderBy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessOrderBy} message AccessOrderBy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessOrderBy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.desc = false;
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                object.metric = $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy.toObject(message.metric, options);
                                if (options.oneofs)
                                    object.oneOrderBy = "metric";
                            }
                            if (message.dimension != null && message.hasOwnProperty("dimension")) {
                                object.dimension = $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.toObject(message.dimension, options);
                                if (options.oneofs)
                                    object.oneOrderBy = "dimension";
                            }
                            if (message.desc != null && message.hasOwnProperty("desc"))
                                object.desc = message.desc;
                            return object;
                        };
    
                        /**
                         * Converts this AccessOrderBy to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessOrderBy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessOrderBy
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessOrderBy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessOrderBy";
                        };
    
                        AccessOrderBy.MetricOrderBy = (function() {
    
                            /**
                             * Properties of a MetricOrderBy.
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                             * @interface IMetricOrderBy
                             * @property {string|null} [metricName] MetricOrderBy metricName
                             */
    
                            /**
                             * Constructs a new MetricOrderBy.
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                             * @classdesc Represents a MetricOrderBy.
                             * @implements IMetricOrderBy
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IMetricOrderBy=} [properties] Properties to set
                             */
                            function MetricOrderBy(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * MetricOrderBy metricName.
                             * @member {string} metricName
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @instance
                             */
                            MetricOrderBy.prototype.metricName = "";
    
                            /**
                             * Creates a new MetricOrderBy instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IMetricOrderBy=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy} MetricOrderBy instance
                             */
                            MetricOrderBy.create = function create(properties) {
                                return new MetricOrderBy(properties);
                            };
    
                            /**
                             * Encodes the specified MetricOrderBy message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IMetricOrderBy} message MetricOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MetricOrderBy.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.metricName != null && Object.hasOwnProperty.call(message, "metricName"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.metricName);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified MetricOrderBy message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IMetricOrderBy} message MetricOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MetricOrderBy.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a MetricOrderBy message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy} MetricOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MetricOrderBy.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.metricName = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a MetricOrderBy message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy} MetricOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MetricOrderBy.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a MetricOrderBy message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            MetricOrderBy.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.metricName != null && message.hasOwnProperty("metricName"))
                                    if (!$util.isString(message.metricName))
                                        return "metricName: string expected";
                                return null;
                            };
    
                            /**
                             * Creates a MetricOrderBy message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy} MetricOrderBy
                             */
                            MetricOrderBy.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy();
                                if (object.metricName != null)
                                    message.metricName = String(object.metricName);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a MetricOrderBy message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy} message MetricOrderBy
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            MetricOrderBy.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.metricName = "";
                                if (message.metricName != null && message.hasOwnProperty("metricName"))
                                    object.metricName = message.metricName;
                                return object;
                            };
    
                            /**
                             * Converts this MetricOrderBy to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            MetricOrderBy.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for MetricOrderBy
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            MetricOrderBy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessOrderBy.MetricOrderBy";
                            };
    
                            return MetricOrderBy;
                        })();
    
                        AccessOrderBy.DimensionOrderBy = (function() {
    
                            /**
                             * Properties of a DimensionOrderBy.
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                             * @interface IDimensionOrderBy
                             * @property {string|null} [dimensionName] DimensionOrderBy dimensionName
                             * @property {google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.OrderType|null} [orderType] DimensionOrderBy orderType
                             */
    
                            /**
                             * Constructs a new DimensionOrderBy.
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy
                             * @classdesc Represents a DimensionOrderBy.
                             * @implements IDimensionOrderBy
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IDimensionOrderBy=} [properties] Properties to set
                             */
                            function DimensionOrderBy(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * DimensionOrderBy dimensionName.
                             * @member {string} dimensionName
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @instance
                             */
                            DimensionOrderBy.prototype.dimensionName = "";
    
                            /**
                             * DimensionOrderBy orderType.
                             * @member {google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.OrderType} orderType
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @instance
                             */
                            DimensionOrderBy.prototype.orderType = 0;
    
                            /**
                             * Creates a new DimensionOrderBy instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IDimensionOrderBy=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy} DimensionOrderBy instance
                             */
                            DimensionOrderBy.create = function create(properties) {
                                return new DimensionOrderBy(properties);
                            };
    
                            /**
                             * Encodes the specified DimensionOrderBy message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IDimensionOrderBy} message DimensionOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DimensionOrderBy.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.dimensionName != null && Object.hasOwnProperty.call(message, "dimensionName"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.dimensionName);
                                if (message.orderType != null && Object.hasOwnProperty.call(message, "orderType"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.orderType);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified DimensionOrderBy message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.IDimensionOrderBy} message DimensionOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DimensionOrderBy.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a DimensionOrderBy message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy} DimensionOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DimensionOrderBy.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.dimensionName = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.orderType = reader.int32();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a DimensionOrderBy message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy} DimensionOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DimensionOrderBy.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a DimensionOrderBy message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DimensionOrderBy.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                    if (!$util.isString(message.dimensionName))
                                        return "dimensionName: string expected";
                                if (message.orderType != null && message.hasOwnProperty("orderType"))
                                    switch (message.orderType) {
                                    default:
                                        return "orderType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                return null;
                            };
    
                            /**
                             * Creates a DimensionOrderBy message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy} DimensionOrderBy
                             */
                            DimensionOrderBy.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy();
                                if (object.dimensionName != null)
                                    message.dimensionName = String(object.dimensionName);
                                switch (object.orderType) {
                                default:
                                    if (typeof object.orderType === "number") {
                                        message.orderType = object.orderType;
                                        break;
                                    }
                                    break;
                                case "ORDER_TYPE_UNSPECIFIED":
                                case 0:
                                    message.orderType = 0;
                                    break;
                                case "ALPHANUMERIC":
                                case 1:
                                    message.orderType = 1;
                                    break;
                                case "CASE_INSENSITIVE_ALPHANUMERIC":
                                case 2:
                                    message.orderType = 2;
                                    break;
                                case "NUMERIC":
                                case 3:
                                    message.orderType = 3;
                                    break;
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a DimensionOrderBy message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy} message DimensionOrderBy
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DimensionOrderBy.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.dimensionName = "";
                                    object.orderType = options.enums === String ? "ORDER_TYPE_UNSPECIFIED" : 0;
                                }
                                if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                    object.dimensionName = message.dimensionName;
                                if (message.orderType != null && message.hasOwnProperty("orderType"))
                                    object.orderType = options.enums === String ? $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.OrderType[message.orderType] === undefined ? message.orderType : $root.google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.OrderType[message.orderType] : message.orderType;
                                return object;
                            };
    
                            /**
                             * Converts this DimensionOrderBy to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DimensionOrderBy.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for DimensionOrderBy
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            DimensionOrderBy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy";
                            };
    
                            /**
                             * OrderType enum.
                             * @name google.analytics.admin.v1alpha.AccessOrderBy.DimensionOrderBy.OrderType
                             * @enum {number}
                             * @property {number} ORDER_TYPE_UNSPECIFIED=0 ORDER_TYPE_UNSPECIFIED value
                             * @property {number} ALPHANUMERIC=1 ALPHANUMERIC value
                             * @property {number} CASE_INSENSITIVE_ALPHANUMERIC=2 CASE_INSENSITIVE_ALPHANUMERIC value
                             * @property {number} NUMERIC=3 NUMERIC value
                             */
                            DimensionOrderBy.OrderType = (function() {
                                var valuesById = {}, values = Object.create(valuesById);
                                values[valuesById[0] = "ORDER_TYPE_UNSPECIFIED"] = 0;
                                values[valuesById[1] = "ALPHANUMERIC"] = 1;
                                values[valuesById[2] = "CASE_INSENSITIVE_ALPHANUMERIC"] = 2;
                                values[valuesById[3] = "NUMERIC"] = 3;
                                return values;
                            })();
    
                            return DimensionOrderBy;
                        })();
    
                        return AccessOrderBy;
                    })();
    
                    v1alpha.AccessDimensionHeader = (function() {
    
                        /**
                         * Properties of an AccessDimensionHeader.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessDimensionHeader
                         * @property {string|null} [dimensionName] AccessDimensionHeader dimensionName
                         */
    
                        /**
                         * Constructs a new AccessDimensionHeader.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessDimensionHeader.
                         * @implements IAccessDimensionHeader
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionHeader=} [properties] Properties to set
                         */
                        function AccessDimensionHeader(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDimensionHeader dimensionName.
                         * @member {string} dimensionName
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @instance
                         */
                        AccessDimensionHeader.prototype.dimensionName = "";
    
                        /**
                         * Creates a new AccessDimensionHeader instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionHeader=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionHeader} AccessDimensionHeader instance
                         */
                        AccessDimensionHeader.create = function create(properties) {
                            return new AccessDimensionHeader(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDimensionHeader message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDimensionHeader.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionHeader} message AccessDimensionHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionHeader.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionName != null && Object.hasOwnProperty.call(message, "dimensionName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.dimensionName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDimensionHeader message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDimensionHeader.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionHeader} message AccessDimensionHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionHeader.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDimensionHeader message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionHeader} AccessDimensionHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionHeader.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessDimensionHeader();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dimensionName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDimensionHeader message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionHeader} AccessDimensionHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionHeader.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDimensionHeader message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDimensionHeader.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                if (!$util.isString(message.dimensionName))
                                    return "dimensionName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDimensionHeader message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionHeader} AccessDimensionHeader
                         */
                        AccessDimensionHeader.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessDimensionHeader)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessDimensionHeader();
                            if (object.dimensionName != null)
                                message.dimensionName = String(object.dimensionName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDimensionHeader message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessDimensionHeader} message AccessDimensionHeader
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDimensionHeader.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.dimensionName = "";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                object.dimensionName = message.dimensionName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDimensionHeader to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDimensionHeader.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDimensionHeader
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionHeader
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDimensionHeader.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessDimensionHeader";
                        };
    
                        return AccessDimensionHeader;
                    })();
    
                    v1alpha.AccessMetricHeader = (function() {
    
                        /**
                         * Properties of an AccessMetricHeader.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessMetricHeader
                         * @property {string|null} [metricName] AccessMetricHeader metricName
                         */
    
                        /**
                         * Constructs a new AccessMetricHeader.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessMetricHeader.
                         * @implements IAccessMetricHeader
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessMetricHeader=} [properties] Properties to set
                         */
                        function AccessMetricHeader(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessMetricHeader metricName.
                         * @member {string} metricName
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @instance
                         */
                        AccessMetricHeader.prototype.metricName = "";
    
                        /**
                         * Creates a new AccessMetricHeader instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetricHeader=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessMetricHeader} AccessMetricHeader instance
                         */
                        AccessMetricHeader.create = function create(properties) {
                            return new AccessMetricHeader(properties);
                        };
    
                        /**
                         * Encodes the specified AccessMetricHeader message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessMetricHeader.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetricHeader} message AccessMetricHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricHeader.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metricName != null && Object.hasOwnProperty.call(message, "metricName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.metricName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessMetricHeader message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessMetricHeader.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetricHeader} message AccessMetricHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricHeader.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessMetricHeader message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessMetricHeader} AccessMetricHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricHeader.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessMetricHeader();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.metricName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessMetricHeader message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessMetricHeader} AccessMetricHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricHeader.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessMetricHeader message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessMetricHeader.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                if (!$util.isString(message.metricName))
                                    return "metricName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessMetricHeader message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessMetricHeader} AccessMetricHeader
                         */
                        AccessMetricHeader.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessMetricHeader)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessMetricHeader();
                            if (object.metricName != null)
                                message.metricName = String(object.metricName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessMetricHeader message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessMetricHeader} message AccessMetricHeader
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessMetricHeader.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.metricName = "";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                object.metricName = message.metricName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessMetricHeader to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessMetricHeader.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessMetricHeader
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessMetricHeader
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessMetricHeader.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessMetricHeader";
                        };
    
                        return AccessMetricHeader;
                    })();
    
                    v1alpha.AccessRow = (function() {
    
                        /**
                         * Properties of an AccessRow.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessRow
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessDimensionValue>|null} [dimensionValues] AccessRow dimensionValues
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessMetricValue>|null} [metricValues] AccessRow metricValues
                         */
    
                        /**
                         * Constructs a new AccessRow.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessRow.
                         * @implements IAccessRow
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessRow=} [properties] Properties to set
                         */
                        function AccessRow(properties) {
                            this.dimensionValues = [];
                            this.metricValues = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessRow dimensionValues.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessDimensionValue>} dimensionValues
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @instance
                         */
                        AccessRow.prototype.dimensionValues = $util.emptyArray;
    
                        /**
                         * AccessRow metricValues.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessMetricValue>} metricValues
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @instance
                         */
                        AccessRow.prototype.metricValues = $util.emptyArray;
    
                        /**
                         * Creates a new AccessRow instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessRow=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessRow} AccessRow instance
                         */
                        AccessRow.create = function create(properties) {
                            return new AccessRow(properties);
                        };
    
                        /**
                         * Encodes the specified AccessRow message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessRow.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessRow} message AccessRow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessRow.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionValues != null && message.dimensionValues.length)
                                for (var i = 0; i < message.dimensionValues.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessDimensionValue.encode(message.dimensionValues[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.metricValues != null && message.metricValues.length)
                                for (var i = 0; i < message.metricValues.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessMetricValue.encode(message.metricValues[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessRow message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessRow.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessRow} message AccessRow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessRow.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessRow message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessRow} AccessRow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessRow.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessRow();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.dimensionValues && message.dimensionValues.length))
                                            message.dimensionValues = [];
                                        message.dimensionValues.push($root.google.analytics.admin.v1alpha.AccessDimensionValue.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        if (!(message.metricValues && message.metricValues.length))
                                            message.metricValues = [];
                                        message.metricValues.push($root.google.analytics.admin.v1alpha.AccessMetricValue.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessRow message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessRow} AccessRow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessRow.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessRow message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessRow.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionValues != null && message.hasOwnProperty("dimensionValues")) {
                                if (!Array.isArray(message.dimensionValues))
                                    return "dimensionValues: array expected";
                                for (var i = 0; i < message.dimensionValues.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessDimensionValue.verify(message.dimensionValues[i]);
                                    if (error)
                                        return "dimensionValues." + error;
                                }
                            }
                            if (message.metricValues != null && message.hasOwnProperty("metricValues")) {
                                if (!Array.isArray(message.metricValues))
                                    return "metricValues: array expected";
                                for (var i = 0; i < message.metricValues.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessMetricValue.verify(message.metricValues[i]);
                                    if (error)
                                        return "metricValues." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessRow message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessRow} AccessRow
                         */
                        AccessRow.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessRow)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessRow();
                            if (object.dimensionValues) {
                                if (!Array.isArray(object.dimensionValues))
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessRow.dimensionValues: array expected");
                                message.dimensionValues = [];
                                for (var i = 0; i < object.dimensionValues.length; ++i) {
                                    if (typeof object.dimensionValues[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AccessRow.dimensionValues: object expected");
                                    message.dimensionValues[i] = $root.google.analytics.admin.v1alpha.AccessDimensionValue.fromObject(object.dimensionValues[i]);
                                }
                            }
                            if (object.metricValues) {
                                if (!Array.isArray(object.metricValues))
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessRow.metricValues: array expected");
                                message.metricValues = [];
                                for (var i = 0; i < object.metricValues.length; ++i) {
                                    if (typeof object.metricValues[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AccessRow.metricValues: object expected");
                                    message.metricValues[i] = $root.google.analytics.admin.v1alpha.AccessMetricValue.fromObject(object.metricValues[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessRow message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessRow} message AccessRow
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessRow.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dimensionValues = [];
                                object.metricValues = [];
                            }
                            if (message.dimensionValues && message.dimensionValues.length) {
                                object.dimensionValues = [];
                                for (var j = 0; j < message.dimensionValues.length; ++j)
                                    object.dimensionValues[j] = $root.google.analytics.admin.v1alpha.AccessDimensionValue.toObject(message.dimensionValues[j], options);
                            }
                            if (message.metricValues && message.metricValues.length) {
                                object.metricValues = [];
                                for (var j = 0; j < message.metricValues.length; ++j)
                                    object.metricValues[j] = $root.google.analytics.admin.v1alpha.AccessMetricValue.toObject(message.metricValues[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessRow to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessRow.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessRow
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessRow
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessRow.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessRow";
                        };
    
                        return AccessRow;
                    })();
    
                    v1alpha.AccessDimensionValue = (function() {
    
                        /**
                         * Properties of an AccessDimensionValue.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessDimensionValue
                         * @property {string|null} [value] AccessDimensionValue value
                         */
    
                        /**
                         * Constructs a new AccessDimensionValue.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessDimensionValue.
                         * @implements IAccessDimensionValue
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionValue=} [properties] Properties to set
                         */
                        function AccessDimensionValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDimensionValue value.
                         * @member {string} value
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @instance
                         */
                        AccessDimensionValue.prototype.value = "";
    
                        /**
                         * Creates a new AccessDimensionValue instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionValue=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionValue} AccessDimensionValue instance
                         */
                        AccessDimensionValue.create = function create(properties) {
                            return new AccessDimensionValue(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDimensionValue message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDimensionValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionValue} message AccessDimensionValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDimensionValue message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessDimensionValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessDimensionValue} message AccessDimensionValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDimensionValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionValue} AccessDimensionValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessDimensionValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDimensionValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionValue} AccessDimensionValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDimensionValue message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDimensionValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value"))
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDimensionValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessDimensionValue} AccessDimensionValue
                         */
                        AccessDimensionValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessDimensionValue)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessDimensionValue();
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDimensionValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessDimensionValue} message AccessDimensionValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDimensionValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = "";
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = message.value;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDimensionValue to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDimensionValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDimensionValue
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessDimensionValue
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDimensionValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessDimensionValue";
                        };
    
                        return AccessDimensionValue;
                    })();
    
                    v1alpha.AccessMetricValue = (function() {
    
                        /**
                         * Properties of an AccessMetricValue.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessMetricValue
                         * @property {string|null} [value] AccessMetricValue value
                         */
    
                        /**
                         * Constructs a new AccessMetricValue.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessMetricValue.
                         * @implements IAccessMetricValue
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessMetricValue=} [properties] Properties to set
                         */
                        function AccessMetricValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessMetricValue value.
                         * @member {string} value
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @instance
                         */
                        AccessMetricValue.prototype.value = "";
    
                        /**
                         * Creates a new AccessMetricValue instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetricValue=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessMetricValue} AccessMetricValue instance
                         */
                        AccessMetricValue.create = function create(properties) {
                            return new AccessMetricValue(properties);
                        };
    
                        /**
                         * Encodes the specified AccessMetricValue message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessMetricValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetricValue} message AccessMetricValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessMetricValue message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessMetricValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessMetricValue} message AccessMetricValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessMetricValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessMetricValue} AccessMetricValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessMetricValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessMetricValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessMetricValue} AccessMetricValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessMetricValue message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessMetricValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value"))
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessMetricValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessMetricValue} AccessMetricValue
                         */
                        AccessMetricValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessMetricValue)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessMetricValue();
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessMetricValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessMetricValue} message AccessMetricValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessMetricValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = "";
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = message.value;
                            return object;
                        };
    
                        /**
                         * Converts this AccessMetricValue to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessMetricValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessMetricValue
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessMetricValue
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessMetricValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessMetricValue";
                        };
    
                        return AccessMetricValue;
                    })();
    
                    v1alpha.AccessQuota = (function() {
    
                        /**
                         * Properties of an AccessQuota.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessQuota
                         * @property {google.analytics.admin.v1alpha.IAccessQuotaStatus|null} [tokensPerDay] AccessQuota tokensPerDay
                         * @property {google.analytics.admin.v1alpha.IAccessQuotaStatus|null} [tokensPerHour] AccessQuota tokensPerHour
                         * @property {google.analytics.admin.v1alpha.IAccessQuotaStatus|null} [concurrentRequests] AccessQuota concurrentRequests
                         * @property {google.analytics.admin.v1alpha.IAccessQuotaStatus|null} [serverErrorsPerProjectPerHour] AccessQuota serverErrorsPerProjectPerHour
                         * @property {google.analytics.admin.v1alpha.IAccessQuotaStatus|null} [tokensPerProjectPerHour] AccessQuota tokensPerProjectPerHour
                         */
    
                        /**
                         * Constructs a new AccessQuota.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessQuota.
                         * @implements IAccessQuota
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessQuota=} [properties] Properties to set
                         */
                        function AccessQuota(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessQuota tokensPerDay.
                         * @member {google.analytics.admin.v1alpha.IAccessQuotaStatus|null|undefined} tokensPerDay
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.tokensPerDay = null;
    
                        /**
                         * AccessQuota tokensPerHour.
                         * @member {google.analytics.admin.v1alpha.IAccessQuotaStatus|null|undefined} tokensPerHour
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.tokensPerHour = null;
    
                        /**
                         * AccessQuota concurrentRequests.
                         * @member {google.analytics.admin.v1alpha.IAccessQuotaStatus|null|undefined} concurrentRequests
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.concurrentRequests = null;
    
                        /**
                         * AccessQuota serverErrorsPerProjectPerHour.
                         * @member {google.analytics.admin.v1alpha.IAccessQuotaStatus|null|undefined} serverErrorsPerProjectPerHour
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.serverErrorsPerProjectPerHour = null;
    
                        /**
                         * AccessQuota tokensPerProjectPerHour.
                         * @member {google.analytics.admin.v1alpha.IAccessQuotaStatus|null|undefined} tokensPerProjectPerHour
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.tokensPerProjectPerHour = null;
    
                        /**
                         * Creates a new AccessQuota instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessQuota=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessQuota} AccessQuota instance
                         */
                        AccessQuota.create = function create(properties) {
                            return new AccessQuota(properties);
                        };
    
                        /**
                         * Encodes the specified AccessQuota message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessQuota.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessQuota} message AccessQuota message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuota.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tokensPerDay != null && Object.hasOwnProperty.call(message, "tokensPerDay"))
                                $root.google.analytics.admin.v1alpha.AccessQuotaStatus.encode(message.tokensPerDay, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.tokensPerHour != null && Object.hasOwnProperty.call(message, "tokensPerHour"))
                                $root.google.analytics.admin.v1alpha.AccessQuotaStatus.encode(message.tokensPerHour, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.concurrentRequests != null && Object.hasOwnProperty.call(message, "concurrentRequests"))
                                $root.google.analytics.admin.v1alpha.AccessQuotaStatus.encode(message.concurrentRequests, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.serverErrorsPerProjectPerHour != null && Object.hasOwnProperty.call(message, "serverErrorsPerProjectPerHour"))
                                $root.google.analytics.admin.v1alpha.AccessQuotaStatus.encode(message.serverErrorsPerProjectPerHour, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.tokensPerProjectPerHour != null && Object.hasOwnProperty.call(message, "tokensPerProjectPerHour"))
                                $root.google.analytics.admin.v1alpha.AccessQuotaStatus.encode(message.tokensPerProjectPerHour, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessQuota message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessQuota.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessQuota} message AccessQuota message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuota.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessQuota message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessQuota} AccessQuota
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuota.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessQuota();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.tokensPerDay = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.tokensPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.concurrentRequests = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.serverErrorsPerProjectPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.tokensPerProjectPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessQuota message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessQuota} AccessQuota
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuota.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessQuota message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessQuota.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.tokensPerDay != null && message.hasOwnProperty("tokensPerDay")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.verify(message.tokensPerDay);
                                if (error)
                                    return "tokensPerDay." + error;
                            }
                            if (message.tokensPerHour != null && message.hasOwnProperty("tokensPerHour")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.verify(message.tokensPerHour);
                                if (error)
                                    return "tokensPerHour." + error;
                            }
                            if (message.concurrentRequests != null && message.hasOwnProperty("concurrentRequests")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.verify(message.concurrentRequests);
                                if (error)
                                    return "concurrentRequests." + error;
                            }
                            if (message.serverErrorsPerProjectPerHour != null && message.hasOwnProperty("serverErrorsPerProjectPerHour")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.verify(message.serverErrorsPerProjectPerHour);
                                if (error)
                                    return "serverErrorsPerProjectPerHour." + error;
                            }
                            if (message.tokensPerProjectPerHour != null && message.hasOwnProperty("tokensPerProjectPerHour")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.verify(message.tokensPerProjectPerHour);
                                if (error)
                                    return "tokensPerProjectPerHour." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessQuota message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessQuota} AccessQuota
                         */
                        AccessQuota.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessQuota)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessQuota();
                            if (object.tokensPerDay != null) {
                                if (typeof object.tokensPerDay !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessQuota.tokensPerDay: object expected");
                                message.tokensPerDay = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.fromObject(object.tokensPerDay);
                            }
                            if (object.tokensPerHour != null) {
                                if (typeof object.tokensPerHour !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessQuota.tokensPerHour: object expected");
                                message.tokensPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.fromObject(object.tokensPerHour);
                            }
                            if (object.concurrentRequests != null) {
                                if (typeof object.concurrentRequests !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessQuota.concurrentRequests: object expected");
                                message.concurrentRequests = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.fromObject(object.concurrentRequests);
                            }
                            if (object.serverErrorsPerProjectPerHour != null) {
                                if (typeof object.serverErrorsPerProjectPerHour !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessQuota.serverErrorsPerProjectPerHour: object expected");
                                message.serverErrorsPerProjectPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.fromObject(object.serverErrorsPerProjectPerHour);
                            }
                            if (object.tokensPerProjectPerHour != null) {
                                if (typeof object.tokensPerProjectPerHour !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessQuota.tokensPerProjectPerHour: object expected");
                                message.tokensPerProjectPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.fromObject(object.tokensPerProjectPerHour);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessQuota message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessQuota} message AccessQuota
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessQuota.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.tokensPerDay = null;
                                object.tokensPerHour = null;
                                object.concurrentRequests = null;
                                object.serverErrorsPerProjectPerHour = null;
                                object.tokensPerProjectPerHour = null;
                            }
                            if (message.tokensPerDay != null && message.hasOwnProperty("tokensPerDay"))
                                object.tokensPerDay = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.toObject(message.tokensPerDay, options);
                            if (message.tokensPerHour != null && message.hasOwnProperty("tokensPerHour"))
                                object.tokensPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.toObject(message.tokensPerHour, options);
                            if (message.concurrentRequests != null && message.hasOwnProperty("concurrentRequests"))
                                object.concurrentRequests = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.toObject(message.concurrentRequests, options);
                            if (message.serverErrorsPerProjectPerHour != null && message.hasOwnProperty("serverErrorsPerProjectPerHour"))
                                object.serverErrorsPerProjectPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.toObject(message.serverErrorsPerProjectPerHour, options);
                            if (message.tokensPerProjectPerHour != null && message.hasOwnProperty("tokensPerProjectPerHour"))
                                object.tokensPerProjectPerHour = $root.google.analytics.admin.v1alpha.AccessQuotaStatus.toObject(message.tokensPerProjectPerHour, options);
                            return object;
                        };
    
                        /**
                         * Converts this AccessQuota to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessQuota.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessQuota
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessQuota
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessQuota.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessQuota";
                        };
    
                        return AccessQuota;
                    })();
    
                    v1alpha.AccessQuotaStatus = (function() {
    
                        /**
                         * Properties of an AccessQuotaStatus.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessQuotaStatus
                         * @property {number|null} [consumed] AccessQuotaStatus consumed
                         * @property {number|null} [remaining] AccessQuotaStatus remaining
                         */
    
                        /**
                         * Constructs a new AccessQuotaStatus.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessQuotaStatus.
                         * @implements IAccessQuotaStatus
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessQuotaStatus=} [properties] Properties to set
                         */
                        function AccessQuotaStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessQuotaStatus consumed.
                         * @member {number} consumed
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @instance
                         */
                        AccessQuotaStatus.prototype.consumed = 0;
    
                        /**
                         * AccessQuotaStatus remaining.
                         * @member {number} remaining
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @instance
                         */
                        AccessQuotaStatus.prototype.remaining = 0;
    
                        /**
                         * Creates a new AccessQuotaStatus instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessQuotaStatus=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessQuotaStatus} AccessQuotaStatus instance
                         */
                        AccessQuotaStatus.create = function create(properties) {
                            return new AccessQuotaStatus(properties);
                        };
    
                        /**
                         * Encodes the specified AccessQuotaStatus message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessQuotaStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessQuotaStatus} message AccessQuotaStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuotaStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.consumed != null && Object.hasOwnProperty.call(message, "consumed"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.consumed);
                            if (message.remaining != null && Object.hasOwnProperty.call(message, "remaining"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.remaining);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessQuotaStatus message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessQuotaStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessQuotaStatus} message AccessQuotaStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuotaStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessQuotaStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessQuotaStatus} AccessQuotaStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuotaStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessQuotaStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.consumed = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.remaining = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessQuotaStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessQuotaStatus} AccessQuotaStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuotaStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessQuotaStatus message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessQuotaStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.consumed != null && message.hasOwnProperty("consumed"))
                                if (!$util.isInteger(message.consumed))
                                    return "consumed: integer expected";
                            if (message.remaining != null && message.hasOwnProperty("remaining"))
                                if (!$util.isInteger(message.remaining))
                                    return "remaining: integer expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessQuotaStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessQuotaStatus} AccessQuotaStatus
                         */
                        AccessQuotaStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessQuotaStatus)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessQuotaStatus();
                            if (object.consumed != null)
                                message.consumed = object.consumed | 0;
                            if (object.remaining != null)
                                message.remaining = object.remaining | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessQuotaStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessQuotaStatus} message AccessQuotaStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessQuotaStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.consumed = 0;
                                object.remaining = 0;
                            }
                            if (message.consumed != null && message.hasOwnProperty("consumed"))
                                object.consumed = message.consumed;
                            if (message.remaining != null && message.hasOwnProperty("remaining"))
                                object.remaining = message.remaining;
                            return object;
                        };
    
                        /**
                         * Converts this AccessQuotaStatus to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessQuotaStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessQuotaStatus
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessQuotaStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessQuotaStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessQuotaStatus";
                        };
    
                        return AccessQuotaStatus;
                    })();
    
                    v1alpha.AnalyticsAdminService = (function() {
    
                        /**
                         * Constructs a new AnalyticsAdminService service.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AnalyticsAdminService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AnalyticsAdminService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (AnalyticsAdminService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AnalyticsAdminService;
    
                        /**
                         * Creates new AnalyticsAdminService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AnalyticsAdminService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AnalyticsAdminService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getAccount}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetAccountCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Account} [response] Account
                         */
    
                        /**
                         * Calls GetAccount.
                         * @function getAccount
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAccountRequest} request GetAccountRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetAccountCallback} callback Node-style callback called with the error, if any, and Account
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getAccount = function getAccount(request, callback) {
                            return this.rpcCall(getAccount, $root.google.analytics.admin.v1alpha.GetAccountRequest, $root.google.analytics.admin.v1alpha.Account, request, callback);
                        }, "name", { value: "GetAccount" });
    
                        /**
                         * Calls GetAccount.
                         * @function getAccount
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAccountRequest} request GetAccountRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Account>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listAccounts}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListAccountsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListAccountsResponse} [response] ListAccountsResponse
                         */
    
                        /**
                         * Calls ListAccounts.
                         * @function listAccounts
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAccountsRequest} request ListAccountsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListAccountsCallback} callback Node-style callback called with the error, if any, and ListAccountsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listAccounts = function listAccounts(request, callback) {
                            return this.rpcCall(listAccounts, $root.google.analytics.admin.v1alpha.ListAccountsRequest, $root.google.analytics.admin.v1alpha.ListAccountsResponse, request, callback);
                        }, "name", { value: "ListAccounts" });
    
                        /**
                         * Calls ListAccounts.
                         * @function listAccounts
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAccountsRequest} request ListAccountsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListAccountsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteAccount}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteAccountCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteAccount.
                         * @function deleteAccount
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteAccountRequest} request DeleteAccountRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteAccountCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteAccount = function deleteAccount(request, callback) {
                            return this.rpcCall(deleteAccount, $root.google.analytics.admin.v1alpha.DeleteAccountRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteAccount" });
    
                        /**
                         * Calls DeleteAccount.
                         * @function deleteAccount
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteAccountRequest} request DeleteAccountRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateAccount}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateAccountCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Account} [response] Account
                         */
    
                        /**
                         * Calls UpdateAccount.
                         * @function updateAccount
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAccountRequest} request UpdateAccountRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateAccountCallback} callback Node-style callback called with the error, if any, and Account
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateAccount = function updateAccount(request, callback) {
                            return this.rpcCall(updateAccount, $root.google.analytics.admin.v1alpha.UpdateAccountRequest, $root.google.analytics.admin.v1alpha.Account, request, callback);
                        }, "name", { value: "UpdateAccount" });
    
                        /**
                         * Calls UpdateAccount.
                         * @function updateAccount
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAccountRequest} request UpdateAccountRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Account>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|provisionAccountTicket}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ProvisionAccountTicketCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ProvisionAccountTicketResponse} [response] ProvisionAccountTicketResponse
                         */
    
                        /**
                         * Calls ProvisionAccountTicket.
                         * @function provisionAccountTicket
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketRequest} request ProvisionAccountTicketRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ProvisionAccountTicketCallback} callback Node-style callback called with the error, if any, and ProvisionAccountTicketResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.provisionAccountTicket = function provisionAccountTicket(request, callback) {
                            return this.rpcCall(provisionAccountTicket, $root.google.analytics.admin.v1alpha.ProvisionAccountTicketRequest, $root.google.analytics.admin.v1alpha.ProvisionAccountTicketResponse, request, callback);
                        }, "name", { value: "ProvisionAccountTicket" });
    
                        /**
                         * Calls ProvisionAccountTicket.
                         * @function provisionAccountTicket
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketRequest} request ProvisionAccountTicketRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ProvisionAccountTicketResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listAccountSummaries}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListAccountSummariesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListAccountSummariesResponse} [response] ListAccountSummariesResponse
                         */
    
                        /**
                         * Calls ListAccountSummaries.
                         * @function listAccountSummaries
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesRequest} request ListAccountSummariesRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListAccountSummariesCallback} callback Node-style callback called with the error, if any, and ListAccountSummariesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listAccountSummaries = function listAccountSummaries(request, callback) {
                            return this.rpcCall(listAccountSummaries, $root.google.analytics.admin.v1alpha.ListAccountSummariesRequest, $root.google.analytics.admin.v1alpha.ListAccountSummariesResponse, request, callback);
                        }, "name", { value: "ListAccountSummaries" });
    
                        /**
                         * Calls ListAccountSummaries.
                         * @function listAccountSummaries
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesRequest} request ListAccountSummariesRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListAccountSummariesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getProperty}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetPropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Property} [response] Property
                         */
    
                        /**
                         * Calls GetProperty.
                         * @function getProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetPropertyRequest} request GetPropertyRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetPropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getProperty = function getProperty(request, callback) {
                            return this.rpcCall(getProperty, $root.google.analytics.admin.v1alpha.GetPropertyRequest, $root.google.analytics.admin.v1alpha.Property, request, callback);
                        }, "name", { value: "GetProperty" });
    
                        /**
                         * Calls GetProperty.
                         * @function getProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetPropertyRequest} request GetPropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listProperties}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListPropertiesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListPropertiesResponse} [response] ListPropertiesResponse
                         */
    
                        /**
                         * Calls ListProperties.
                         * @function listProperties
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListPropertiesRequest} request ListPropertiesRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListPropertiesCallback} callback Node-style callback called with the error, if any, and ListPropertiesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listProperties = function listProperties(request, callback) {
                            return this.rpcCall(listProperties, $root.google.analytics.admin.v1alpha.ListPropertiesRequest, $root.google.analytics.admin.v1alpha.ListPropertiesResponse, request, callback);
                        }, "name", { value: "ListProperties" });
    
                        /**
                         * Calls ListProperties.
                         * @function listProperties
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListPropertiesRequest} request ListPropertiesRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListPropertiesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createProperty}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreatePropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Property} [response] Property
                         */
    
                        /**
                         * Calls CreateProperty.
                         * @function createProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreatePropertyRequest} request CreatePropertyRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreatePropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createProperty = function createProperty(request, callback) {
                            return this.rpcCall(createProperty, $root.google.analytics.admin.v1alpha.CreatePropertyRequest, $root.google.analytics.admin.v1alpha.Property, request, callback);
                        }, "name", { value: "CreateProperty" });
    
                        /**
                         * Calls CreateProperty.
                         * @function createProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreatePropertyRequest} request CreatePropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteProperty}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeletePropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Property} [response] Property
                         */
    
                        /**
                         * Calls DeleteProperty.
                         * @function deleteProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeletePropertyRequest} request DeletePropertyRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeletePropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteProperty = function deleteProperty(request, callback) {
                            return this.rpcCall(deleteProperty, $root.google.analytics.admin.v1alpha.DeletePropertyRequest, $root.google.analytics.admin.v1alpha.Property, request, callback);
                        }, "name", { value: "DeleteProperty" });
    
                        /**
                         * Calls DeleteProperty.
                         * @function deleteProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeletePropertyRequest} request DeletePropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateProperty}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdatePropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Property} [response] Property
                         */
    
                        /**
                         * Calls UpdateProperty.
                         * @function updateProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdatePropertyRequest} request UpdatePropertyRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdatePropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateProperty = function updateProperty(request, callback) {
                            return this.rpcCall(updateProperty, $root.google.analytics.admin.v1alpha.UpdatePropertyRequest, $root.google.analytics.admin.v1alpha.Property, request, callback);
                        }, "name", { value: "UpdateProperty" });
    
                        /**
                         * Calls UpdateProperty.
                         * @function updateProperty
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdatePropertyRequest} request UpdatePropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getUserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetUserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.UserLink} [response] UserLink
                         */
    
                        /**
                         * Calls GetUserLink.
                         * @function getUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetUserLinkRequest} request GetUserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetUserLinkCallback} callback Node-style callback called with the error, if any, and UserLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getUserLink = function getUserLink(request, callback) {
                            return this.rpcCall(getUserLink, $root.google.analytics.admin.v1alpha.GetUserLinkRequest, $root.google.analytics.admin.v1alpha.UserLink, request, callback);
                        }, "name", { value: "GetUserLink" });
    
                        /**
                         * Calls GetUserLink.
                         * @function getUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetUserLinkRequest} request GetUserLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.UserLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchGetUserLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchGetUserLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.BatchGetUserLinksResponse} [response] BatchGetUserLinksResponse
                         */
    
                        /**
                         * Calls BatchGetUserLinks.
                         * @function batchGetUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksRequest} request BatchGetUserLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchGetUserLinksCallback} callback Node-style callback called with the error, if any, and BatchGetUserLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchGetUserLinks = function batchGetUserLinks(request, callback) {
                            return this.rpcCall(batchGetUserLinks, $root.google.analytics.admin.v1alpha.BatchGetUserLinksRequest, $root.google.analytics.admin.v1alpha.BatchGetUserLinksResponse, request, callback);
                        }, "name", { value: "BatchGetUserLinks" });
    
                        /**
                         * Calls BatchGetUserLinks.
                         * @function batchGetUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksRequest} request BatchGetUserLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.BatchGetUserLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listUserLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListUserLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListUserLinksResponse} [response] ListUserLinksResponse
                         */
    
                        /**
                         * Calls ListUserLinks.
                         * @function listUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListUserLinksRequest} request ListUserLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListUserLinksCallback} callback Node-style callback called with the error, if any, and ListUserLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listUserLinks = function listUserLinks(request, callback) {
                            return this.rpcCall(listUserLinks, $root.google.analytics.admin.v1alpha.ListUserLinksRequest, $root.google.analytics.admin.v1alpha.ListUserLinksResponse, request, callback);
                        }, "name", { value: "ListUserLinks" });
    
                        /**
                         * Calls ListUserLinks.
                         * @function listUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListUserLinksRequest} request ListUserLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListUserLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|auditUserLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef AuditUserLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AuditUserLinksResponse} [response] AuditUserLinksResponse
                         */
    
                        /**
                         * Calls AuditUserLinks.
                         * @function auditUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksRequest} request AuditUserLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.AuditUserLinksCallback} callback Node-style callback called with the error, if any, and AuditUserLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.auditUserLinks = function auditUserLinks(request, callback) {
                            return this.rpcCall(auditUserLinks, $root.google.analytics.admin.v1alpha.AuditUserLinksRequest, $root.google.analytics.admin.v1alpha.AuditUserLinksResponse, request, callback);
                        }, "name", { value: "AuditUserLinks" });
    
                        /**
                         * Calls AuditUserLinks.
                         * @function auditUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksRequest} request AuditUserLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AuditUserLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createUserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateUserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.UserLink} [response] UserLink
                         */
    
                        /**
                         * Calls CreateUserLink.
                         * @function createUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateUserLinkRequest} request CreateUserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateUserLinkCallback} callback Node-style callback called with the error, if any, and UserLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createUserLink = function createUserLink(request, callback) {
                            return this.rpcCall(createUserLink, $root.google.analytics.admin.v1alpha.CreateUserLinkRequest, $root.google.analytics.admin.v1alpha.UserLink, request, callback);
                        }, "name", { value: "CreateUserLink" });
    
                        /**
                         * Calls CreateUserLink.
                         * @function createUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateUserLinkRequest} request CreateUserLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.UserLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchCreateUserLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchCreateUserLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.BatchCreateUserLinksResponse} [response] BatchCreateUserLinksResponse
                         */
    
                        /**
                         * Calls BatchCreateUserLinks.
                         * @function batchCreateUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksRequest} request BatchCreateUserLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchCreateUserLinksCallback} callback Node-style callback called with the error, if any, and BatchCreateUserLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchCreateUserLinks = function batchCreateUserLinks(request, callback) {
                            return this.rpcCall(batchCreateUserLinks, $root.google.analytics.admin.v1alpha.BatchCreateUserLinksRequest, $root.google.analytics.admin.v1alpha.BatchCreateUserLinksResponse, request, callback);
                        }, "name", { value: "BatchCreateUserLinks" });
    
                        /**
                         * Calls BatchCreateUserLinks.
                         * @function batchCreateUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksRequest} request BatchCreateUserLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.BatchCreateUserLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateUserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateUserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.UserLink} [response] UserLink
                         */
    
                        /**
                         * Calls UpdateUserLink.
                         * @function updateUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateUserLinkRequest} request UpdateUserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateUserLinkCallback} callback Node-style callback called with the error, if any, and UserLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateUserLink = function updateUserLink(request, callback) {
                            return this.rpcCall(updateUserLink, $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest, $root.google.analytics.admin.v1alpha.UserLink, request, callback);
                        }, "name", { value: "UpdateUserLink" });
    
                        /**
                         * Calls UpdateUserLink.
                         * @function updateUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateUserLinkRequest} request UpdateUserLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.UserLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchUpdateUserLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchUpdateUserLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse} [response] BatchUpdateUserLinksResponse
                         */
    
                        /**
                         * Calls BatchUpdateUserLinks.
                         * @function batchUpdateUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksRequest} request BatchUpdateUserLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchUpdateUserLinksCallback} callback Node-style callback called with the error, if any, and BatchUpdateUserLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchUpdateUserLinks = function batchUpdateUserLinks(request, callback) {
                            return this.rpcCall(batchUpdateUserLinks, $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest, $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse, request, callback);
                        }, "name", { value: "BatchUpdateUserLinks" });
    
                        /**
                         * Calls BatchUpdateUserLinks.
                         * @function batchUpdateUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksRequest} request BatchUpdateUserLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteUserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteUserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteUserLink.
                         * @function deleteUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteUserLinkRequest} request DeleteUserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteUserLinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteUserLink = function deleteUserLink(request, callback) {
                            return this.rpcCall(deleteUserLink, $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteUserLink" });
    
                        /**
                         * Calls DeleteUserLink.
                         * @function deleteUserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteUserLinkRequest} request DeleteUserLinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchDeleteUserLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchDeleteUserLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls BatchDeleteUserLinks.
                         * @function batchDeleteUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteUserLinksRequest} request BatchDeleteUserLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchDeleteUserLinksCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchDeleteUserLinks = function batchDeleteUserLinks(request, callback) {
                            return this.rpcCall(batchDeleteUserLinks, $root.google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "BatchDeleteUserLinks" });
    
                        /**
                         * Calls BatchDeleteUserLinks.
                         * @function batchDeleteUserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteUserLinksRequest} request BatchDeleteUserLinksRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createFirebaseLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateFirebaseLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.FirebaseLink} [response] FirebaseLink
                         */
    
                        /**
                         * Calls CreateFirebaseLink.
                         * @function createFirebaseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateFirebaseLinkRequest} request CreateFirebaseLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateFirebaseLinkCallback} callback Node-style callback called with the error, if any, and FirebaseLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createFirebaseLink = function createFirebaseLink(request, callback) {
                            return this.rpcCall(createFirebaseLink, $root.google.analytics.admin.v1alpha.CreateFirebaseLinkRequest, $root.google.analytics.admin.v1alpha.FirebaseLink, request, callback);
                        }, "name", { value: "CreateFirebaseLink" });
    
                        /**
                         * Calls CreateFirebaseLink.
                         * @function createFirebaseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateFirebaseLinkRequest} request CreateFirebaseLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.FirebaseLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteFirebaseLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteFirebaseLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteFirebaseLink.
                         * @function deleteFirebaseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteFirebaseLinkRequest} request DeleteFirebaseLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteFirebaseLinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteFirebaseLink = function deleteFirebaseLink(request, callback) {
                            return this.rpcCall(deleteFirebaseLink, $root.google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteFirebaseLink" });
    
                        /**
                         * Calls DeleteFirebaseLink.
                         * @function deleteFirebaseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteFirebaseLinkRequest} request DeleteFirebaseLinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listFirebaseLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListFirebaseLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListFirebaseLinksResponse} [response] ListFirebaseLinksResponse
                         */
    
                        /**
                         * Calls ListFirebaseLinks.
                         * @function listFirebaseLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksRequest} request ListFirebaseLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListFirebaseLinksCallback} callback Node-style callback called with the error, if any, and ListFirebaseLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listFirebaseLinks = function listFirebaseLinks(request, callback) {
                            return this.rpcCall(listFirebaseLinks, $root.google.analytics.admin.v1alpha.ListFirebaseLinksRequest, $root.google.analytics.admin.v1alpha.ListFirebaseLinksResponse, request, callback);
                        }, "name", { value: "ListFirebaseLinks" });
    
                        /**
                         * Calls ListFirebaseLinks.
                         * @function listFirebaseLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksRequest} request ListFirebaseLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListFirebaseLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getGlobalSiteTag}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetGlobalSiteTagCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.GlobalSiteTag} [response] GlobalSiteTag
                         */
    
                        /**
                         * Calls GetGlobalSiteTag.
                         * @function getGlobalSiteTag
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetGlobalSiteTagRequest} request GetGlobalSiteTagRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetGlobalSiteTagCallback} callback Node-style callback called with the error, if any, and GlobalSiteTag
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getGlobalSiteTag = function getGlobalSiteTag(request, callback) {
                            return this.rpcCall(getGlobalSiteTag, $root.google.analytics.admin.v1alpha.GetGlobalSiteTagRequest, $root.google.analytics.admin.v1alpha.GlobalSiteTag, request, callback);
                        }, "name", { value: "GetGlobalSiteTag" });
    
                        /**
                         * Calls GetGlobalSiteTag.
                         * @function getGlobalSiteTag
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetGlobalSiteTagRequest} request GetGlobalSiteTagRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.GlobalSiteTag>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createGoogleAdsLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateGoogleAdsLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.GoogleAdsLink} [response] GoogleAdsLink
                         */
    
                        /**
                         * Calls CreateGoogleAdsLink.
                         * @function createGoogleAdsLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateGoogleAdsLinkRequest} request CreateGoogleAdsLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateGoogleAdsLinkCallback} callback Node-style callback called with the error, if any, and GoogleAdsLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createGoogleAdsLink = function createGoogleAdsLink(request, callback) {
                            return this.rpcCall(createGoogleAdsLink, $root.google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest, $root.google.analytics.admin.v1alpha.GoogleAdsLink, request, callback);
                        }, "name", { value: "CreateGoogleAdsLink" });
    
                        /**
                         * Calls CreateGoogleAdsLink.
                         * @function createGoogleAdsLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateGoogleAdsLinkRequest} request CreateGoogleAdsLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.GoogleAdsLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateGoogleAdsLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateGoogleAdsLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.GoogleAdsLink} [response] GoogleAdsLink
                         */
    
                        /**
                         * Calls UpdateGoogleAdsLink.
                         * @function updateGoogleAdsLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleAdsLinkRequest} request UpdateGoogleAdsLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateGoogleAdsLinkCallback} callback Node-style callback called with the error, if any, and GoogleAdsLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateGoogleAdsLink = function updateGoogleAdsLink(request, callback) {
                            return this.rpcCall(updateGoogleAdsLink, $root.google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest, $root.google.analytics.admin.v1alpha.GoogleAdsLink, request, callback);
                        }, "name", { value: "UpdateGoogleAdsLink" });
    
                        /**
                         * Calls UpdateGoogleAdsLink.
                         * @function updateGoogleAdsLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleAdsLinkRequest} request UpdateGoogleAdsLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.GoogleAdsLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteGoogleAdsLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteGoogleAdsLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteGoogleAdsLink.
                         * @function deleteGoogleAdsLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteGoogleAdsLinkRequest} request DeleteGoogleAdsLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteGoogleAdsLinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteGoogleAdsLink = function deleteGoogleAdsLink(request, callback) {
                            return this.rpcCall(deleteGoogleAdsLink, $root.google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteGoogleAdsLink" });
    
                        /**
                         * Calls DeleteGoogleAdsLink.
                         * @function deleteGoogleAdsLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteGoogleAdsLinkRequest} request DeleteGoogleAdsLinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listGoogleAdsLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListGoogleAdsLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse} [response] ListGoogleAdsLinksResponse
                         */
    
                        /**
                         * Calls ListGoogleAdsLinks.
                         * @function listGoogleAdsLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksRequest} request ListGoogleAdsLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListGoogleAdsLinksCallback} callback Node-style callback called with the error, if any, and ListGoogleAdsLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listGoogleAdsLinks = function listGoogleAdsLinks(request, callback) {
                            return this.rpcCall(listGoogleAdsLinks, $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest, $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse, request, callback);
                        }, "name", { value: "ListGoogleAdsLinks" });
    
                        /**
                         * Calls ListGoogleAdsLinks.
                         * @function listGoogleAdsLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksRequest} request ListGoogleAdsLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getDataSharingSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetDataSharingSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DataSharingSettings} [response] DataSharingSettings
                         */
    
                        /**
                         * Calls GetDataSharingSettings.
                         * @function getDataSharingSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDataSharingSettingsRequest} request GetDataSharingSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetDataSharingSettingsCallback} callback Node-style callback called with the error, if any, and DataSharingSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDataSharingSettings = function getDataSharingSettings(request, callback) {
                            return this.rpcCall(getDataSharingSettings, $root.google.analytics.admin.v1alpha.GetDataSharingSettingsRequest, $root.google.analytics.admin.v1alpha.DataSharingSettings, request, callback);
                        }, "name", { value: "GetDataSharingSettings" });
    
                        /**
                         * Calls GetDataSharingSettings.
                         * @function getDataSharingSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDataSharingSettingsRequest} request GetDataSharingSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DataSharingSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.MeasurementProtocolSecret} [response] MeasurementProtocolSecret
                         */
    
                        /**
                         * Calls GetMeasurementProtocolSecret.
                         * @function getMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetMeasurementProtocolSecretRequest} request GetMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and MeasurementProtocolSecret
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getMeasurementProtocolSecret = function getMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(getMeasurementProtocolSecret, $root.google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest, $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret, request, callback);
                        }, "name", { value: "GetMeasurementProtocolSecret" });
    
                        /**
                         * Calls GetMeasurementProtocolSecret.
                         * @function getMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetMeasurementProtocolSecretRequest} request GetMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.MeasurementProtocolSecret>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listMeasurementProtocolSecrets}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListMeasurementProtocolSecretsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse} [response] ListMeasurementProtocolSecretsResponse
                         */
    
                        /**
                         * Calls ListMeasurementProtocolSecrets.
                         * @function listMeasurementProtocolSecrets
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsRequest} request ListMeasurementProtocolSecretsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListMeasurementProtocolSecretsCallback} callback Node-style callback called with the error, if any, and ListMeasurementProtocolSecretsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listMeasurementProtocolSecrets = function listMeasurementProtocolSecrets(request, callback) {
                            return this.rpcCall(listMeasurementProtocolSecrets, $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest, $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse, request, callback);
                        }, "name", { value: "ListMeasurementProtocolSecrets" });
    
                        /**
                         * Calls ListMeasurementProtocolSecrets.
                         * @function listMeasurementProtocolSecrets
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsRequest} request ListMeasurementProtocolSecretsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.MeasurementProtocolSecret} [response] MeasurementProtocolSecret
                         */
    
                        /**
                         * Calls CreateMeasurementProtocolSecret.
                         * @function createMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateMeasurementProtocolSecretRequest} request CreateMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and MeasurementProtocolSecret
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createMeasurementProtocolSecret = function createMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(createMeasurementProtocolSecret, $root.google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest, $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret, request, callback);
                        }, "name", { value: "CreateMeasurementProtocolSecret" });
    
                        /**
                         * Calls CreateMeasurementProtocolSecret.
                         * @function createMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateMeasurementProtocolSecretRequest} request CreateMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.MeasurementProtocolSecret>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteMeasurementProtocolSecret.
                         * @function deleteMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteMeasurementProtocolSecretRequest} request DeleteMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteMeasurementProtocolSecret = function deleteMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(deleteMeasurementProtocolSecret, $root.google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteMeasurementProtocolSecret" });
    
                        /**
                         * Calls DeleteMeasurementProtocolSecret.
                         * @function deleteMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteMeasurementProtocolSecretRequest} request DeleteMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.MeasurementProtocolSecret} [response] MeasurementProtocolSecret
                         */
    
                        /**
                         * Calls UpdateMeasurementProtocolSecret.
                         * @function updateMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateMeasurementProtocolSecretRequest} request UpdateMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and MeasurementProtocolSecret
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateMeasurementProtocolSecret = function updateMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(updateMeasurementProtocolSecret, $root.google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest, $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret, request, callback);
                        }, "name", { value: "UpdateMeasurementProtocolSecret" });
    
                        /**
                         * Calls UpdateMeasurementProtocolSecret.
                         * @function updateMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateMeasurementProtocolSecretRequest} request UpdateMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.MeasurementProtocolSecret>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|acknowledgeUserDataCollection}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef AcknowledgeUserDataCollectionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse} [response] AcknowledgeUserDataCollectionResponse
                         */
    
                        /**
                         * Calls AcknowledgeUserDataCollection.
                         * @function acknowledgeUserDataCollection
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionRequest} request AcknowledgeUserDataCollectionRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.AcknowledgeUserDataCollectionCallback} callback Node-style callback called with the error, if any, and AcknowledgeUserDataCollectionResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.acknowledgeUserDataCollection = function acknowledgeUserDataCollection(request, callback) {
                            return this.rpcCall(acknowledgeUserDataCollection, $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest, $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse, request, callback);
                        }, "name", { value: "AcknowledgeUserDataCollection" });
    
                        /**
                         * Calls AcknowledgeUserDataCollection.
                         * @function acknowledgeUserDataCollection
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionRequest} request AcknowledgeUserDataCollectionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|searchChangeHistoryEvents}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef SearchChangeHistoryEventsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse} [response] SearchChangeHistoryEventsResponse
                         */
    
                        /**
                         * Calls SearchChangeHistoryEvents.
                         * @function searchChangeHistoryEvents
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsRequest} request SearchChangeHistoryEventsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.SearchChangeHistoryEventsCallback} callback Node-style callback called with the error, if any, and SearchChangeHistoryEventsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.searchChangeHistoryEvents = function searchChangeHistoryEvents(request, callback) {
                            return this.rpcCall(searchChangeHistoryEvents, $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest, $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse, request, callback);
                        }, "name", { value: "SearchChangeHistoryEvents" });
    
                        /**
                         * Calls SearchChangeHistoryEvents.
                         * @function searchChangeHistoryEvents
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsRequest} request SearchChangeHistoryEventsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getGoogleSignalsSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetGoogleSignalsSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.GoogleSignalsSettings} [response] GoogleSignalsSettings
                         */
    
                        /**
                         * Calls GetGoogleSignalsSettings.
                         * @function getGoogleSignalsSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetGoogleSignalsSettingsRequest} request GetGoogleSignalsSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetGoogleSignalsSettingsCallback} callback Node-style callback called with the error, if any, and GoogleSignalsSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getGoogleSignalsSettings = function getGoogleSignalsSettings(request, callback) {
                            return this.rpcCall(getGoogleSignalsSettings, $root.google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest, $root.google.analytics.admin.v1alpha.GoogleSignalsSettings, request, callback);
                        }, "name", { value: "GetGoogleSignalsSettings" });
    
                        /**
                         * Calls GetGoogleSignalsSettings.
                         * @function getGoogleSignalsSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetGoogleSignalsSettingsRequest} request GetGoogleSignalsSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.GoogleSignalsSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateGoogleSignalsSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateGoogleSignalsSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.GoogleSignalsSettings} [response] GoogleSignalsSettings
                         */
    
                        /**
                         * Calls UpdateGoogleSignalsSettings.
                         * @function updateGoogleSignalsSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleSignalsSettingsRequest} request UpdateGoogleSignalsSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateGoogleSignalsSettingsCallback} callback Node-style callback called with the error, if any, and GoogleSignalsSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateGoogleSignalsSettings = function updateGoogleSignalsSettings(request, callback) {
                            return this.rpcCall(updateGoogleSignalsSettings, $root.google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest, $root.google.analytics.admin.v1alpha.GoogleSignalsSettings, request, callback);
                        }, "name", { value: "UpdateGoogleSignalsSettings" });
    
                        /**
                         * Calls UpdateGoogleSignalsSettings.
                         * @function updateGoogleSignalsSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleSignalsSettingsRequest} request UpdateGoogleSignalsSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.GoogleSignalsSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createConversionEvent}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateConversionEventCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ConversionEvent} [response] ConversionEvent
                         */
    
                        /**
                         * Calls CreateConversionEvent.
                         * @function createConversionEvent
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateConversionEventRequest} request CreateConversionEventRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateConversionEventCallback} callback Node-style callback called with the error, if any, and ConversionEvent
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createConversionEvent = function createConversionEvent(request, callback) {
                            return this.rpcCall(createConversionEvent, $root.google.analytics.admin.v1alpha.CreateConversionEventRequest, $root.google.analytics.admin.v1alpha.ConversionEvent, request, callback);
                        }, "name", { value: "CreateConversionEvent" });
    
                        /**
                         * Calls CreateConversionEvent.
                         * @function createConversionEvent
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateConversionEventRequest} request CreateConversionEventRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ConversionEvent>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getConversionEvent}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetConversionEventCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ConversionEvent} [response] ConversionEvent
                         */
    
                        /**
                         * Calls GetConversionEvent.
                         * @function getConversionEvent
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetConversionEventRequest} request GetConversionEventRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetConversionEventCallback} callback Node-style callback called with the error, if any, and ConversionEvent
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getConversionEvent = function getConversionEvent(request, callback) {
                            return this.rpcCall(getConversionEvent, $root.google.analytics.admin.v1alpha.GetConversionEventRequest, $root.google.analytics.admin.v1alpha.ConversionEvent, request, callback);
                        }, "name", { value: "GetConversionEvent" });
    
                        /**
                         * Calls GetConversionEvent.
                         * @function getConversionEvent
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetConversionEventRequest} request GetConversionEventRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ConversionEvent>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteConversionEvent}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteConversionEventCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteConversionEvent.
                         * @function deleteConversionEvent
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteConversionEventRequest} request DeleteConversionEventRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteConversionEventCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteConversionEvent = function deleteConversionEvent(request, callback) {
                            return this.rpcCall(deleteConversionEvent, $root.google.analytics.admin.v1alpha.DeleteConversionEventRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteConversionEvent" });
    
                        /**
                         * Calls DeleteConversionEvent.
                         * @function deleteConversionEvent
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteConversionEventRequest} request DeleteConversionEventRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listConversionEvents}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListConversionEventsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListConversionEventsResponse} [response] ListConversionEventsResponse
                         */
    
                        /**
                         * Calls ListConversionEvents.
                         * @function listConversionEvents
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsRequest} request ListConversionEventsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListConversionEventsCallback} callback Node-style callback called with the error, if any, and ListConversionEventsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listConversionEvents = function listConversionEvents(request, callback) {
                            return this.rpcCall(listConversionEvents, $root.google.analytics.admin.v1alpha.ListConversionEventsRequest, $root.google.analytics.admin.v1alpha.ListConversionEventsResponse, request, callback);
                        }, "name", { value: "ListConversionEvents" });
    
                        /**
                         * Calls ListConversionEvents.
                         * @function listConversionEvents
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsRequest} request ListConversionEventsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListConversionEventsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getDisplayVideo360AdvertiserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetDisplayVideo360AdvertiserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} [response] DisplayVideo360AdvertiserLink
                         */
    
                        /**
                         * Calls GetDisplayVideo360AdvertiserLink.
                         * @function getDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkRequest} request GetDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetDisplayVideo360AdvertiserLinkCallback} callback Node-style callback called with the error, if any, and DisplayVideo360AdvertiserLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDisplayVideo360AdvertiserLink = function getDisplayVideo360AdvertiserLink(request, callback) {
                            return this.rpcCall(getDisplayVideo360AdvertiserLink, $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest, $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink, request, callback);
                        }, "name", { value: "GetDisplayVideo360AdvertiserLink" });
    
                        /**
                         * Calls GetDisplayVideo360AdvertiserLink.
                         * @function getDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkRequest} request GetDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listDisplayVideo360AdvertiserLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListDisplayVideo360AdvertiserLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse} [response] ListDisplayVideo360AdvertiserLinksResponse
                         */
    
                        /**
                         * Calls ListDisplayVideo360AdvertiserLinks.
                         * @function listDisplayVideo360AdvertiserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksRequest} request ListDisplayVideo360AdvertiserLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListDisplayVideo360AdvertiserLinksCallback} callback Node-style callback called with the error, if any, and ListDisplayVideo360AdvertiserLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listDisplayVideo360AdvertiserLinks = function listDisplayVideo360AdvertiserLinks(request, callback) {
                            return this.rpcCall(listDisplayVideo360AdvertiserLinks, $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest, $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse, request, callback);
                        }, "name", { value: "ListDisplayVideo360AdvertiserLinks" });
    
                        /**
                         * Calls ListDisplayVideo360AdvertiserLinks.
                         * @function listDisplayVideo360AdvertiserLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksRequest} request ListDisplayVideo360AdvertiserLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createDisplayVideo360AdvertiserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateDisplayVideo360AdvertiserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} [response] DisplayVideo360AdvertiserLink
                         */
    
                        /**
                         * Calls CreateDisplayVideo360AdvertiserLink.
                         * @function createDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkRequest} request CreateDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateDisplayVideo360AdvertiserLinkCallback} callback Node-style callback called with the error, if any, and DisplayVideo360AdvertiserLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createDisplayVideo360AdvertiserLink = function createDisplayVideo360AdvertiserLink(request, callback) {
                            return this.rpcCall(createDisplayVideo360AdvertiserLink, $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest, $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink, request, callback);
                        }, "name", { value: "CreateDisplayVideo360AdvertiserLink" });
    
                        /**
                         * Calls CreateDisplayVideo360AdvertiserLink.
                         * @function createDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkRequest} request CreateDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteDisplayVideo360AdvertiserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteDisplayVideo360AdvertiserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteDisplayVideo360AdvertiserLink.
                         * @function deleteDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkRequest} request DeleteDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteDisplayVideo360AdvertiserLinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteDisplayVideo360AdvertiserLink = function deleteDisplayVideo360AdvertiserLink(request, callback) {
                            return this.rpcCall(deleteDisplayVideo360AdvertiserLink, $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteDisplayVideo360AdvertiserLink" });
    
                        /**
                         * Calls DeleteDisplayVideo360AdvertiserLink.
                         * @function deleteDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkRequest} request DeleteDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateDisplayVideo360AdvertiserLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateDisplayVideo360AdvertiserLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} [response] DisplayVideo360AdvertiserLink
                         */
    
                        /**
                         * Calls UpdateDisplayVideo360AdvertiserLink.
                         * @function updateDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateDisplayVideo360AdvertiserLinkRequest} request UpdateDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateDisplayVideo360AdvertiserLinkCallback} callback Node-style callback called with the error, if any, and DisplayVideo360AdvertiserLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateDisplayVideo360AdvertiserLink = function updateDisplayVideo360AdvertiserLink(request, callback) {
                            return this.rpcCall(updateDisplayVideo360AdvertiserLink, $root.google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest, $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink, request, callback);
                        }, "name", { value: "UpdateDisplayVideo360AdvertiserLink" });
    
                        /**
                         * Calls UpdateDisplayVideo360AdvertiserLink.
                         * @function updateDisplayVideo360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateDisplayVideo360AdvertiserLinkRequest} request UpdateDisplayVideo360AdvertiserLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getDisplayVideo360AdvertiserLinkProposal}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetDisplayVideo360AdvertiserLinkProposalCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} [response] DisplayVideo360AdvertiserLinkProposal
                         */
    
                        /**
                         * Calls GetDisplayVideo360AdvertiserLinkProposal.
                         * @function getDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkProposalRequest} request GetDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetDisplayVideo360AdvertiserLinkProposalCallback} callback Node-style callback called with the error, if any, and DisplayVideo360AdvertiserLinkProposal
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDisplayVideo360AdvertiserLinkProposal = function getDisplayVideo360AdvertiserLinkProposal(request, callback) {
                            return this.rpcCall(getDisplayVideo360AdvertiserLinkProposal, $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest, $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal, request, callback);
                        }, "name", { value: "GetDisplayVideo360AdvertiserLinkProposal" });
    
                        /**
                         * Calls GetDisplayVideo360AdvertiserLinkProposal.
                         * @function getDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkProposalRequest} request GetDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listDisplayVideo360AdvertiserLinkProposals}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListDisplayVideo360AdvertiserLinkProposalsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse} [response] ListDisplayVideo360AdvertiserLinkProposalsResponse
                         */
    
                        /**
                         * Calls ListDisplayVideo360AdvertiserLinkProposals.
                         * @function listDisplayVideo360AdvertiserLinkProposals
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsRequest} request ListDisplayVideo360AdvertiserLinkProposalsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListDisplayVideo360AdvertiserLinkProposalsCallback} callback Node-style callback called with the error, if any, and ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listDisplayVideo360AdvertiserLinkProposals = function listDisplayVideo360AdvertiserLinkProposals(request, callback) {
                            return this.rpcCall(listDisplayVideo360AdvertiserLinkProposals, $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest, $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse, request, callback);
                        }, "name", { value: "ListDisplayVideo360AdvertiserLinkProposals" });
    
                        /**
                         * Calls ListDisplayVideo360AdvertiserLinkProposals.
                         * @function listDisplayVideo360AdvertiserLinkProposals
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsRequest} request ListDisplayVideo360AdvertiserLinkProposalsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createDisplayVideo360AdvertiserLinkProposal}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateDisplayVideo360AdvertiserLinkProposalCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} [response] DisplayVideo360AdvertiserLinkProposal
                         */
    
                        /**
                         * Calls CreateDisplayVideo360AdvertiserLinkProposal.
                         * @function createDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkProposalRequest} request CreateDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateDisplayVideo360AdvertiserLinkProposalCallback} callback Node-style callback called with the error, if any, and DisplayVideo360AdvertiserLinkProposal
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createDisplayVideo360AdvertiserLinkProposal = function createDisplayVideo360AdvertiserLinkProposal(request, callback) {
                            return this.rpcCall(createDisplayVideo360AdvertiserLinkProposal, $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest, $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal, request, callback);
                        }, "name", { value: "CreateDisplayVideo360AdvertiserLinkProposal" });
    
                        /**
                         * Calls CreateDisplayVideo360AdvertiserLinkProposal.
                         * @function createDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkProposalRequest} request CreateDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteDisplayVideo360AdvertiserLinkProposal}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteDisplayVideo360AdvertiserLinkProposalCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteDisplayVideo360AdvertiserLinkProposal.
                         * @function deleteDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkProposalRequest} request DeleteDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteDisplayVideo360AdvertiserLinkProposalCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteDisplayVideo360AdvertiserLinkProposal = function deleteDisplayVideo360AdvertiserLinkProposal(request, callback) {
                            return this.rpcCall(deleteDisplayVideo360AdvertiserLinkProposal, $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteDisplayVideo360AdvertiserLinkProposal" });
    
                        /**
                         * Calls DeleteDisplayVideo360AdvertiserLinkProposal.
                         * @function deleteDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkProposalRequest} request DeleteDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|approveDisplayVideo360AdvertiserLinkProposal}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ApproveDisplayVideo360AdvertiserLinkProposalCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse} [response] ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         */
    
                        /**
                         * Calls ApproveDisplayVideo360AdvertiserLinkProposal.
                         * @function approveDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalRequest} request ApproveDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ApproveDisplayVideo360AdvertiserLinkProposalCallback} callback Node-style callback called with the error, if any, and ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.approveDisplayVideo360AdvertiserLinkProposal = function approveDisplayVideo360AdvertiserLinkProposal(request, callback) {
                            return this.rpcCall(approveDisplayVideo360AdvertiserLinkProposal, $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest, $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse, request, callback);
                        }, "name", { value: "ApproveDisplayVideo360AdvertiserLinkProposal" });
    
                        /**
                         * Calls ApproveDisplayVideo360AdvertiserLinkProposal.
                         * @function approveDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalRequest} request ApproveDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|cancelDisplayVideo360AdvertiserLinkProposal}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CancelDisplayVideo360AdvertiserLinkProposalCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} [response] DisplayVideo360AdvertiserLinkProposal
                         */
    
                        /**
                         * Calls CancelDisplayVideo360AdvertiserLinkProposal.
                         * @function cancelDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICancelDisplayVideo360AdvertiserLinkProposalRequest} request CancelDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CancelDisplayVideo360AdvertiserLinkProposalCallback} callback Node-style callback called with the error, if any, and DisplayVideo360AdvertiserLinkProposal
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.cancelDisplayVideo360AdvertiserLinkProposal = function cancelDisplayVideo360AdvertiserLinkProposal(request, callback) {
                            return this.rpcCall(cancelDisplayVideo360AdvertiserLinkProposal, $root.google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest, $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal, request, callback);
                        }, "name", { value: "CancelDisplayVideo360AdvertiserLinkProposal" });
    
                        /**
                         * Calls CancelDisplayVideo360AdvertiserLinkProposal.
                         * @function cancelDisplayVideo360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICancelDisplayVideo360AdvertiserLinkProposalRequest} request CancelDisplayVideo360AdvertiserLinkProposalRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createCustomDimension}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.CustomDimension} [response] CustomDimension
                         */
    
                        /**
                         * Calls CreateCustomDimension.
                         * @function createCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateCustomDimensionRequest} request CreateCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateCustomDimensionCallback} callback Node-style callback called with the error, if any, and CustomDimension
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createCustomDimension = function createCustomDimension(request, callback) {
                            return this.rpcCall(createCustomDimension, $root.google.analytics.admin.v1alpha.CreateCustomDimensionRequest, $root.google.analytics.admin.v1alpha.CustomDimension, request, callback);
                        }, "name", { value: "CreateCustomDimension" });
    
                        /**
                         * Calls CreateCustomDimension.
                         * @function createCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateCustomDimensionRequest} request CreateCustomDimensionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.CustomDimension>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateCustomDimension}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.CustomDimension} [response] CustomDimension
                         */
    
                        /**
                         * Calls UpdateCustomDimension.
                         * @function updateCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomDimensionRequest} request UpdateCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateCustomDimensionCallback} callback Node-style callback called with the error, if any, and CustomDimension
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateCustomDimension = function updateCustomDimension(request, callback) {
                            return this.rpcCall(updateCustomDimension, $root.google.analytics.admin.v1alpha.UpdateCustomDimensionRequest, $root.google.analytics.admin.v1alpha.CustomDimension, request, callback);
                        }, "name", { value: "UpdateCustomDimension" });
    
                        /**
                         * Calls UpdateCustomDimension.
                         * @function updateCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomDimensionRequest} request UpdateCustomDimensionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.CustomDimension>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listCustomDimensions}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListCustomDimensionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListCustomDimensionsResponse} [response] ListCustomDimensionsResponse
                         */
    
                        /**
                         * Calls ListCustomDimensions.
                         * @function listCustomDimensions
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsRequest} request ListCustomDimensionsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListCustomDimensionsCallback} callback Node-style callback called with the error, if any, and ListCustomDimensionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listCustomDimensions = function listCustomDimensions(request, callback) {
                            return this.rpcCall(listCustomDimensions, $root.google.analytics.admin.v1alpha.ListCustomDimensionsRequest, $root.google.analytics.admin.v1alpha.ListCustomDimensionsResponse, request, callback);
                        }, "name", { value: "ListCustomDimensions" });
    
                        /**
                         * Calls ListCustomDimensions.
                         * @function listCustomDimensions
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsRequest} request ListCustomDimensionsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListCustomDimensionsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|archiveCustomDimension}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ArchiveCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls ArchiveCustomDimension.
                         * @function archiveCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomDimensionRequest} request ArchiveCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ArchiveCustomDimensionCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.archiveCustomDimension = function archiveCustomDimension(request, callback) {
                            return this.rpcCall(archiveCustomDimension, $root.google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "ArchiveCustomDimension" });
    
                        /**
                         * Calls ArchiveCustomDimension.
                         * @function archiveCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomDimensionRequest} request ArchiveCustomDimensionRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getCustomDimension}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.CustomDimension} [response] CustomDimension
                         */
    
                        /**
                         * Calls GetCustomDimension.
                         * @function getCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetCustomDimensionRequest} request GetCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetCustomDimensionCallback} callback Node-style callback called with the error, if any, and CustomDimension
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getCustomDimension = function getCustomDimension(request, callback) {
                            return this.rpcCall(getCustomDimension, $root.google.analytics.admin.v1alpha.GetCustomDimensionRequest, $root.google.analytics.admin.v1alpha.CustomDimension, request, callback);
                        }, "name", { value: "GetCustomDimension" });
    
                        /**
                         * Calls GetCustomDimension.
                         * @function getCustomDimension
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetCustomDimensionRequest} request GetCustomDimensionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.CustomDimension>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createCustomMetric}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.CustomMetric} [response] CustomMetric
                         */
    
                        /**
                         * Calls CreateCustomMetric.
                         * @function createCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateCustomMetricRequest} request CreateCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateCustomMetricCallback} callback Node-style callback called with the error, if any, and CustomMetric
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createCustomMetric = function createCustomMetric(request, callback) {
                            return this.rpcCall(createCustomMetric, $root.google.analytics.admin.v1alpha.CreateCustomMetricRequest, $root.google.analytics.admin.v1alpha.CustomMetric, request, callback);
                        }, "name", { value: "CreateCustomMetric" });
    
                        /**
                         * Calls CreateCustomMetric.
                         * @function createCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateCustomMetricRequest} request CreateCustomMetricRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.CustomMetric>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateCustomMetric}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.CustomMetric} [response] CustomMetric
                         */
    
                        /**
                         * Calls UpdateCustomMetric.
                         * @function updateCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomMetricRequest} request UpdateCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateCustomMetricCallback} callback Node-style callback called with the error, if any, and CustomMetric
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateCustomMetric = function updateCustomMetric(request, callback) {
                            return this.rpcCall(updateCustomMetric, $root.google.analytics.admin.v1alpha.UpdateCustomMetricRequest, $root.google.analytics.admin.v1alpha.CustomMetric, request, callback);
                        }, "name", { value: "UpdateCustomMetric" });
    
                        /**
                         * Calls UpdateCustomMetric.
                         * @function updateCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomMetricRequest} request UpdateCustomMetricRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.CustomMetric>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listCustomMetrics}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListCustomMetricsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListCustomMetricsResponse} [response] ListCustomMetricsResponse
                         */
    
                        /**
                         * Calls ListCustomMetrics.
                         * @function listCustomMetrics
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsRequest} request ListCustomMetricsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListCustomMetricsCallback} callback Node-style callback called with the error, if any, and ListCustomMetricsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listCustomMetrics = function listCustomMetrics(request, callback) {
                            return this.rpcCall(listCustomMetrics, $root.google.analytics.admin.v1alpha.ListCustomMetricsRequest, $root.google.analytics.admin.v1alpha.ListCustomMetricsResponse, request, callback);
                        }, "name", { value: "ListCustomMetrics" });
    
                        /**
                         * Calls ListCustomMetrics.
                         * @function listCustomMetrics
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsRequest} request ListCustomMetricsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListCustomMetricsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|archiveCustomMetric}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ArchiveCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls ArchiveCustomMetric.
                         * @function archiveCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomMetricRequest} request ArchiveCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ArchiveCustomMetricCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.archiveCustomMetric = function archiveCustomMetric(request, callback) {
                            return this.rpcCall(archiveCustomMetric, $root.google.analytics.admin.v1alpha.ArchiveCustomMetricRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "ArchiveCustomMetric" });
    
                        /**
                         * Calls ArchiveCustomMetric.
                         * @function archiveCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomMetricRequest} request ArchiveCustomMetricRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getCustomMetric}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.CustomMetric} [response] CustomMetric
                         */
    
                        /**
                         * Calls GetCustomMetric.
                         * @function getCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetCustomMetricRequest} request GetCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetCustomMetricCallback} callback Node-style callback called with the error, if any, and CustomMetric
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getCustomMetric = function getCustomMetric(request, callback) {
                            return this.rpcCall(getCustomMetric, $root.google.analytics.admin.v1alpha.GetCustomMetricRequest, $root.google.analytics.admin.v1alpha.CustomMetric, request, callback);
                        }, "name", { value: "GetCustomMetric" });
    
                        /**
                         * Calls GetCustomMetric.
                         * @function getCustomMetric
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetCustomMetricRequest} request GetCustomMetricRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.CustomMetric>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getDataRetentionSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetDataRetentionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DataRetentionSettings} [response] DataRetentionSettings
                         */
    
                        /**
                         * Calls GetDataRetentionSettings.
                         * @function getDataRetentionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDataRetentionSettingsRequest} request GetDataRetentionSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetDataRetentionSettingsCallback} callback Node-style callback called with the error, if any, and DataRetentionSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDataRetentionSettings = function getDataRetentionSettings(request, callback) {
                            return this.rpcCall(getDataRetentionSettings, $root.google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest, $root.google.analytics.admin.v1alpha.DataRetentionSettings, request, callback);
                        }, "name", { value: "GetDataRetentionSettings" });
    
                        /**
                         * Calls GetDataRetentionSettings.
                         * @function getDataRetentionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDataRetentionSettingsRequest} request GetDataRetentionSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DataRetentionSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateDataRetentionSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateDataRetentionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DataRetentionSettings} [response] DataRetentionSettings
                         */
    
                        /**
                         * Calls UpdateDataRetentionSettings.
                         * @function updateDataRetentionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateDataRetentionSettingsRequest} request UpdateDataRetentionSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateDataRetentionSettingsCallback} callback Node-style callback called with the error, if any, and DataRetentionSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateDataRetentionSettings = function updateDataRetentionSettings(request, callback) {
                            return this.rpcCall(updateDataRetentionSettings, $root.google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest, $root.google.analytics.admin.v1alpha.DataRetentionSettings, request, callback);
                        }, "name", { value: "UpdateDataRetentionSettings" });
    
                        /**
                         * Calls UpdateDataRetentionSettings.
                         * @function updateDataRetentionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateDataRetentionSettingsRequest} request UpdateDataRetentionSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DataRetentionSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createDataStream}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DataStream} [response] DataStream
                         */
    
                        /**
                         * Calls CreateDataStream.
                         * @function createDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateDataStreamRequest} request CreateDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateDataStreamCallback} callback Node-style callback called with the error, if any, and DataStream
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createDataStream = function createDataStream(request, callback) {
                            return this.rpcCall(createDataStream, $root.google.analytics.admin.v1alpha.CreateDataStreamRequest, $root.google.analytics.admin.v1alpha.DataStream, request, callback);
                        }, "name", { value: "CreateDataStream" });
    
                        /**
                         * Calls CreateDataStream.
                         * @function createDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateDataStreamRequest} request CreateDataStreamRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DataStream>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteDataStream}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteDataStream.
                         * @function deleteDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteDataStreamRequest} request DeleteDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteDataStreamCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteDataStream = function deleteDataStream(request, callback) {
                            return this.rpcCall(deleteDataStream, $root.google.analytics.admin.v1alpha.DeleteDataStreamRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteDataStream" });
    
                        /**
                         * Calls DeleteDataStream.
                         * @function deleteDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteDataStreamRequest} request DeleteDataStreamRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateDataStream}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DataStream} [response] DataStream
                         */
    
                        /**
                         * Calls UpdateDataStream.
                         * @function updateDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateDataStreamRequest} request UpdateDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateDataStreamCallback} callback Node-style callback called with the error, if any, and DataStream
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateDataStream = function updateDataStream(request, callback) {
                            return this.rpcCall(updateDataStream, $root.google.analytics.admin.v1alpha.UpdateDataStreamRequest, $root.google.analytics.admin.v1alpha.DataStream, request, callback);
                        }, "name", { value: "UpdateDataStream" });
    
                        /**
                         * Calls UpdateDataStream.
                         * @function updateDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateDataStreamRequest} request UpdateDataStreamRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DataStream>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listDataStreams}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListDataStreamsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListDataStreamsResponse} [response] ListDataStreamsResponse
                         */
    
                        /**
                         * Calls ListDataStreams.
                         * @function listDataStreams
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsRequest} request ListDataStreamsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListDataStreamsCallback} callback Node-style callback called with the error, if any, and ListDataStreamsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listDataStreams = function listDataStreams(request, callback) {
                            return this.rpcCall(listDataStreams, $root.google.analytics.admin.v1alpha.ListDataStreamsRequest, $root.google.analytics.admin.v1alpha.ListDataStreamsResponse, request, callback);
                        }, "name", { value: "ListDataStreams" });
    
                        /**
                         * Calls ListDataStreams.
                         * @function listDataStreams
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsRequest} request ListDataStreamsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListDataStreamsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getDataStream}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.DataStream} [response] DataStream
                         */
    
                        /**
                         * Calls GetDataStream.
                         * @function getDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDataStreamRequest} request GetDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetDataStreamCallback} callback Node-style callback called with the error, if any, and DataStream
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDataStream = function getDataStream(request, callback) {
                            return this.rpcCall(getDataStream, $root.google.analytics.admin.v1alpha.GetDataStreamRequest, $root.google.analytics.admin.v1alpha.DataStream, request, callback);
                        }, "name", { value: "GetDataStream" });
    
                        /**
                         * Calls GetDataStream.
                         * @function getDataStream
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetDataStreamRequest} request GetDataStreamRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.DataStream>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getAudience}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetAudienceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Audience} [response] Audience
                         */
    
                        /**
                         * Calls GetAudience.
                         * @function getAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAudienceRequest} request GetAudienceRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetAudienceCallback} callback Node-style callback called with the error, if any, and Audience
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getAudience = function getAudience(request, callback) {
                            return this.rpcCall(getAudience, $root.google.analytics.admin.v1alpha.GetAudienceRequest, $root.google.analytics.admin.v1alpha.Audience, request, callback);
                        }, "name", { value: "GetAudience" });
    
                        /**
                         * Calls GetAudience.
                         * @function getAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAudienceRequest} request GetAudienceRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Audience>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listAudiences}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListAudiencesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListAudiencesResponse} [response] ListAudiencesResponse
                         */
    
                        /**
                         * Calls ListAudiences.
                         * @function listAudiences
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAudiencesRequest} request ListAudiencesRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListAudiencesCallback} callback Node-style callback called with the error, if any, and ListAudiencesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listAudiences = function listAudiences(request, callback) {
                            return this.rpcCall(listAudiences, $root.google.analytics.admin.v1alpha.ListAudiencesRequest, $root.google.analytics.admin.v1alpha.ListAudiencesResponse, request, callback);
                        }, "name", { value: "ListAudiences" });
    
                        /**
                         * Calls ListAudiences.
                         * @function listAudiences
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAudiencesRequest} request ListAudiencesRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListAudiencesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createAudience}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateAudienceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Audience} [response] Audience
                         */
    
                        /**
                         * Calls CreateAudience.
                         * @function createAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateAudienceRequest} request CreateAudienceRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateAudienceCallback} callback Node-style callback called with the error, if any, and Audience
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createAudience = function createAudience(request, callback) {
                            return this.rpcCall(createAudience, $root.google.analytics.admin.v1alpha.CreateAudienceRequest, $root.google.analytics.admin.v1alpha.Audience, request, callback);
                        }, "name", { value: "CreateAudience" });
    
                        /**
                         * Calls CreateAudience.
                         * @function createAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateAudienceRequest} request CreateAudienceRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Audience>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateAudience}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateAudienceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.Audience} [response] Audience
                         */
    
                        /**
                         * Calls UpdateAudience.
                         * @function updateAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAudienceRequest} request UpdateAudienceRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateAudienceCallback} callback Node-style callback called with the error, if any, and Audience
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateAudience = function updateAudience(request, callback) {
                            return this.rpcCall(updateAudience, $root.google.analytics.admin.v1alpha.UpdateAudienceRequest, $root.google.analytics.admin.v1alpha.Audience, request, callback);
                        }, "name", { value: "UpdateAudience" });
    
                        /**
                         * Calls UpdateAudience.
                         * @function updateAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAudienceRequest} request UpdateAudienceRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.Audience>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|archiveAudience}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ArchiveAudienceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls ArchiveAudience.
                         * @function archiveAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IArchiveAudienceRequest} request ArchiveAudienceRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ArchiveAudienceCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.archiveAudience = function archiveAudience(request, callback) {
                            return this.rpcCall(archiveAudience, $root.google.analytics.admin.v1alpha.ArchiveAudienceRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "ArchiveAudience" });
    
                        /**
                         * Calls ArchiveAudience.
                         * @function archiveAudience
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IArchiveAudienceRequest} request ArchiveAudienceRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getSearchAds360Link}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetSearchAds360LinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.SearchAds360Link} [response] SearchAds360Link
                         */
    
                        /**
                         * Calls GetSearchAds360Link.
                         * @function getSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetSearchAds360LinkRequest} request GetSearchAds360LinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetSearchAds360LinkCallback} callback Node-style callback called with the error, if any, and SearchAds360Link
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getSearchAds360Link = function getSearchAds360Link(request, callback) {
                            return this.rpcCall(getSearchAds360Link, $root.google.analytics.admin.v1alpha.GetSearchAds360LinkRequest, $root.google.analytics.admin.v1alpha.SearchAds360Link, request, callback);
                        }, "name", { value: "GetSearchAds360Link" });
    
                        /**
                         * Calls GetSearchAds360Link.
                         * @function getSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetSearchAds360LinkRequest} request GetSearchAds360LinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.SearchAds360Link>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listSearchAds360Links}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListSearchAds360LinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListSearchAds360LinksResponse} [response] ListSearchAds360LinksResponse
                         */
    
                        /**
                         * Calls ListSearchAds360Links.
                         * @function listSearchAds360Links
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksRequest} request ListSearchAds360LinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListSearchAds360LinksCallback} callback Node-style callback called with the error, if any, and ListSearchAds360LinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listSearchAds360Links = function listSearchAds360Links(request, callback) {
                            return this.rpcCall(listSearchAds360Links, $root.google.analytics.admin.v1alpha.ListSearchAds360LinksRequest, $root.google.analytics.admin.v1alpha.ListSearchAds360LinksResponse, request, callback);
                        }, "name", { value: "ListSearchAds360Links" });
    
                        /**
                         * Calls ListSearchAds360Links.
                         * @function listSearchAds360Links
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksRequest} request ListSearchAds360LinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListSearchAds360LinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createSearchAds360Link}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateSearchAds360LinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.SearchAds360Link} [response] SearchAds360Link
                         */
    
                        /**
                         * Calls CreateSearchAds360Link.
                         * @function createSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateSearchAds360LinkRequest} request CreateSearchAds360LinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateSearchAds360LinkCallback} callback Node-style callback called with the error, if any, and SearchAds360Link
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createSearchAds360Link = function createSearchAds360Link(request, callback) {
                            return this.rpcCall(createSearchAds360Link, $root.google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest, $root.google.analytics.admin.v1alpha.SearchAds360Link, request, callback);
                        }, "name", { value: "CreateSearchAds360Link" });
    
                        /**
                         * Calls CreateSearchAds360Link.
                         * @function createSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateSearchAds360LinkRequest} request CreateSearchAds360LinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.SearchAds360Link>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteSearchAds360Link}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteSearchAds360LinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteSearchAds360Link.
                         * @function deleteSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteSearchAds360LinkRequest} request DeleteSearchAds360LinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteSearchAds360LinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteSearchAds360Link = function deleteSearchAds360Link(request, callback) {
                            return this.rpcCall(deleteSearchAds360Link, $root.google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteSearchAds360Link" });
    
                        /**
                         * Calls DeleteSearchAds360Link.
                         * @function deleteSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteSearchAds360LinkRequest} request DeleteSearchAds360LinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateSearchAds360Link}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateSearchAds360LinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.SearchAds360Link} [response] SearchAds360Link
                         */
    
                        /**
                         * Calls UpdateSearchAds360Link.
                         * @function updateSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateSearchAds360LinkRequest} request UpdateSearchAds360LinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateSearchAds360LinkCallback} callback Node-style callback called with the error, if any, and SearchAds360Link
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateSearchAds360Link = function updateSearchAds360Link(request, callback) {
                            return this.rpcCall(updateSearchAds360Link, $root.google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest, $root.google.analytics.admin.v1alpha.SearchAds360Link, request, callback);
                        }, "name", { value: "UpdateSearchAds360Link" });
    
                        /**
                         * Calls UpdateSearchAds360Link.
                         * @function updateSearchAds360Link
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateSearchAds360LinkRequest} request UpdateSearchAds360LinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.SearchAds360Link>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getAttributionSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetAttributionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AttributionSettings} [response] AttributionSettings
                         */
    
                        /**
                         * Calls GetAttributionSettings.
                         * @function getAttributionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAttributionSettingsRequest} request GetAttributionSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetAttributionSettingsCallback} callback Node-style callback called with the error, if any, and AttributionSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getAttributionSettings = function getAttributionSettings(request, callback) {
                            return this.rpcCall(getAttributionSettings, $root.google.analytics.admin.v1alpha.GetAttributionSettingsRequest, $root.google.analytics.admin.v1alpha.AttributionSettings, request, callback);
                        }, "name", { value: "GetAttributionSettings" });
    
                        /**
                         * Calls GetAttributionSettings.
                         * @function getAttributionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAttributionSettingsRequest} request GetAttributionSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AttributionSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateAttributionSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateAttributionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AttributionSettings} [response] AttributionSettings
                         */
    
                        /**
                         * Calls UpdateAttributionSettings.
                         * @function updateAttributionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAttributionSettingsRequest} request UpdateAttributionSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateAttributionSettingsCallback} callback Node-style callback called with the error, if any, and AttributionSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateAttributionSettings = function updateAttributionSettings(request, callback) {
                            return this.rpcCall(updateAttributionSettings, $root.google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest, $root.google.analytics.admin.v1alpha.AttributionSettings, request, callback);
                        }, "name", { value: "UpdateAttributionSettings" });
    
                        /**
                         * Calls UpdateAttributionSettings.
                         * @function updateAttributionSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAttributionSettingsRequest} request UpdateAttributionSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AttributionSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|runAccessReport}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef RunAccessReportCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.RunAccessReportResponse} [response] RunAccessReportResponse
                         */
    
                        /**
                         * Calls RunAccessReport.
                         * @function runAccessReport
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportRequest} request RunAccessReportRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.RunAccessReportCallback} callback Node-style callback called with the error, if any, and RunAccessReportResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.runAccessReport = function runAccessReport(request, callback) {
                            return this.rpcCall(runAccessReport, $root.google.analytics.admin.v1alpha.RunAccessReportRequest, $root.google.analytics.admin.v1alpha.RunAccessReportResponse, request, callback);
                        }, "name", { value: "RunAccessReport" });
    
                        /**
                         * Calls RunAccessReport.
                         * @function runAccessReport
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportRequest} request RunAccessReportRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.RunAccessReportResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createAccessBinding}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateAccessBindingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AccessBinding} [response] AccessBinding
                         */
    
                        /**
                         * Calls CreateAccessBinding.
                         * @function createAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateAccessBindingRequest} request CreateAccessBindingRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateAccessBindingCallback} callback Node-style callback called with the error, if any, and AccessBinding
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createAccessBinding = function createAccessBinding(request, callback) {
                            return this.rpcCall(createAccessBinding, $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest, $root.google.analytics.admin.v1alpha.AccessBinding, request, callback);
                        }, "name", { value: "CreateAccessBinding" });
    
                        /**
                         * Calls CreateAccessBinding.
                         * @function createAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateAccessBindingRequest} request CreateAccessBindingRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AccessBinding>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getAccessBinding}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetAccessBindingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AccessBinding} [response] AccessBinding
                         */
    
                        /**
                         * Calls GetAccessBinding.
                         * @function getAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAccessBindingRequest} request GetAccessBindingRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetAccessBindingCallback} callback Node-style callback called with the error, if any, and AccessBinding
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getAccessBinding = function getAccessBinding(request, callback) {
                            return this.rpcCall(getAccessBinding, $root.google.analytics.admin.v1alpha.GetAccessBindingRequest, $root.google.analytics.admin.v1alpha.AccessBinding, request, callback);
                        }, "name", { value: "GetAccessBinding" });
    
                        /**
                         * Calls GetAccessBinding.
                         * @function getAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAccessBindingRequest} request GetAccessBindingRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AccessBinding>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateAccessBinding}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateAccessBindingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AccessBinding} [response] AccessBinding
                         */
    
                        /**
                         * Calls UpdateAccessBinding.
                         * @function updateAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAccessBindingRequest} request UpdateAccessBindingRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateAccessBindingCallback} callback Node-style callback called with the error, if any, and AccessBinding
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateAccessBinding = function updateAccessBinding(request, callback) {
                            return this.rpcCall(updateAccessBinding, $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest, $root.google.analytics.admin.v1alpha.AccessBinding, request, callback);
                        }, "name", { value: "UpdateAccessBinding" });
    
                        /**
                         * Calls UpdateAccessBinding.
                         * @function updateAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateAccessBindingRequest} request UpdateAccessBindingRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AccessBinding>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteAccessBinding}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteAccessBindingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteAccessBinding.
                         * @function deleteAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteAccessBindingRequest} request DeleteAccessBindingRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteAccessBindingCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteAccessBinding = function deleteAccessBinding(request, callback) {
                            return this.rpcCall(deleteAccessBinding, $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteAccessBinding" });
    
                        /**
                         * Calls DeleteAccessBinding.
                         * @function deleteAccessBinding
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteAccessBindingRequest} request DeleteAccessBindingRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listAccessBindings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListAccessBindingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListAccessBindingsResponse} [response] ListAccessBindingsResponse
                         */
    
                        /**
                         * Calls ListAccessBindings.
                         * @function listAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsRequest} request ListAccessBindingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListAccessBindingsCallback} callback Node-style callback called with the error, if any, and ListAccessBindingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listAccessBindings = function listAccessBindings(request, callback) {
                            return this.rpcCall(listAccessBindings, $root.google.analytics.admin.v1alpha.ListAccessBindingsRequest, $root.google.analytics.admin.v1alpha.ListAccessBindingsResponse, request, callback);
                        }, "name", { value: "ListAccessBindings" });
    
                        /**
                         * Calls ListAccessBindings.
                         * @function listAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsRequest} request ListAccessBindingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListAccessBindingsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchCreateAccessBindings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchCreateAccessBindingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse} [response] BatchCreateAccessBindingsResponse
                         */
    
                        /**
                         * Calls BatchCreateAccessBindings.
                         * @function batchCreateAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsRequest} request BatchCreateAccessBindingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchCreateAccessBindingsCallback} callback Node-style callback called with the error, if any, and BatchCreateAccessBindingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchCreateAccessBindings = function batchCreateAccessBindings(request, callback) {
                            return this.rpcCall(batchCreateAccessBindings, $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest, $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse, request, callback);
                        }, "name", { value: "BatchCreateAccessBindings" });
    
                        /**
                         * Calls BatchCreateAccessBindings.
                         * @function batchCreateAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsRequest} request BatchCreateAccessBindingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchGetAccessBindings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchGetAccessBindingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse} [response] BatchGetAccessBindingsResponse
                         */
    
                        /**
                         * Calls BatchGetAccessBindings.
                         * @function batchGetAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsRequest} request BatchGetAccessBindingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchGetAccessBindingsCallback} callback Node-style callback called with the error, if any, and BatchGetAccessBindingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchGetAccessBindings = function batchGetAccessBindings(request, callback) {
                            return this.rpcCall(batchGetAccessBindings, $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest, $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse, request, callback);
                        }, "name", { value: "BatchGetAccessBindings" });
    
                        /**
                         * Calls BatchGetAccessBindings.
                         * @function batchGetAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsRequest} request BatchGetAccessBindingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchUpdateAccessBindings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchUpdateAccessBindingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse} [response] BatchUpdateAccessBindingsResponse
                         */
    
                        /**
                         * Calls BatchUpdateAccessBindings.
                         * @function batchUpdateAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsRequest} request BatchUpdateAccessBindingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchUpdateAccessBindingsCallback} callback Node-style callback called with the error, if any, and BatchUpdateAccessBindingsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchUpdateAccessBindings = function batchUpdateAccessBindings(request, callback) {
                            return this.rpcCall(batchUpdateAccessBindings, $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest, $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse, request, callback);
                        }, "name", { value: "BatchUpdateAccessBindings" });
    
                        /**
                         * Calls BatchUpdateAccessBindings.
                         * @function batchUpdateAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsRequest} request BatchUpdateAccessBindingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|batchDeleteAccessBindings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef BatchDeleteAccessBindingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls BatchDeleteAccessBindings.
                         * @function batchDeleteAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteAccessBindingsRequest} request BatchDeleteAccessBindingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.BatchDeleteAccessBindingsCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.batchDeleteAccessBindings = function batchDeleteAccessBindings(request, callback) {
                            return this.rpcCall(batchDeleteAccessBindings, $root.google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "BatchDeleteAccessBindings" });
    
                        /**
                         * Calls BatchDeleteAccessBindings.
                         * @function batchDeleteAccessBindings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteAccessBindingsRequest} request BatchDeleteAccessBindingsRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getExpandedDataSet}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetExpandedDataSetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ExpandedDataSet} [response] ExpandedDataSet
                         */
    
                        /**
                         * Calls GetExpandedDataSet.
                         * @function getExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetExpandedDataSetRequest} request GetExpandedDataSetRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetExpandedDataSetCallback} callback Node-style callback called with the error, if any, and ExpandedDataSet
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getExpandedDataSet = function getExpandedDataSet(request, callback) {
                            return this.rpcCall(getExpandedDataSet, $root.google.analytics.admin.v1alpha.GetExpandedDataSetRequest, $root.google.analytics.admin.v1alpha.ExpandedDataSet, request, callback);
                        }, "name", { value: "GetExpandedDataSet" });
    
                        /**
                         * Calls GetExpandedDataSet.
                         * @function getExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetExpandedDataSetRequest} request GetExpandedDataSetRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ExpandedDataSet>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listExpandedDataSets}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListExpandedDataSetsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListExpandedDataSetsResponse} [response] ListExpandedDataSetsResponse
                         */
    
                        /**
                         * Calls ListExpandedDataSets.
                         * @function listExpandedDataSets
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsRequest} request ListExpandedDataSetsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListExpandedDataSetsCallback} callback Node-style callback called with the error, if any, and ListExpandedDataSetsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listExpandedDataSets = function listExpandedDataSets(request, callback) {
                            return this.rpcCall(listExpandedDataSets, $root.google.analytics.admin.v1alpha.ListExpandedDataSetsRequest, $root.google.analytics.admin.v1alpha.ListExpandedDataSetsResponse, request, callback);
                        }, "name", { value: "ListExpandedDataSets" });
    
                        /**
                         * Calls ListExpandedDataSets.
                         * @function listExpandedDataSets
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsRequest} request ListExpandedDataSetsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListExpandedDataSetsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createExpandedDataSet}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateExpandedDataSetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ExpandedDataSet} [response] ExpandedDataSet
                         */
    
                        /**
                         * Calls CreateExpandedDataSet.
                         * @function createExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateExpandedDataSetRequest} request CreateExpandedDataSetRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateExpandedDataSetCallback} callback Node-style callback called with the error, if any, and ExpandedDataSet
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createExpandedDataSet = function createExpandedDataSet(request, callback) {
                            return this.rpcCall(createExpandedDataSet, $root.google.analytics.admin.v1alpha.CreateExpandedDataSetRequest, $root.google.analytics.admin.v1alpha.ExpandedDataSet, request, callback);
                        }, "name", { value: "CreateExpandedDataSet" });
    
                        /**
                         * Calls CreateExpandedDataSet.
                         * @function createExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateExpandedDataSetRequest} request CreateExpandedDataSetRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ExpandedDataSet>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateExpandedDataSet}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateExpandedDataSetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ExpandedDataSet} [response] ExpandedDataSet
                         */
    
                        /**
                         * Calls UpdateExpandedDataSet.
                         * @function updateExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateExpandedDataSetRequest} request UpdateExpandedDataSetRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateExpandedDataSetCallback} callback Node-style callback called with the error, if any, and ExpandedDataSet
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateExpandedDataSet = function updateExpandedDataSet(request, callback) {
                            return this.rpcCall(updateExpandedDataSet, $root.google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest, $root.google.analytics.admin.v1alpha.ExpandedDataSet, request, callback);
                        }, "name", { value: "UpdateExpandedDataSet" });
    
                        /**
                         * Calls UpdateExpandedDataSet.
                         * @function updateExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateExpandedDataSetRequest} request UpdateExpandedDataSetRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ExpandedDataSet>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteExpandedDataSet}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteExpandedDataSetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteExpandedDataSet.
                         * @function deleteExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteExpandedDataSetRequest} request DeleteExpandedDataSetRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteExpandedDataSetCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteExpandedDataSet = function deleteExpandedDataSet(request, callback) {
                            return this.rpcCall(deleteExpandedDataSet, $root.google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteExpandedDataSet" });
    
                        /**
                         * Calls DeleteExpandedDataSet.
                         * @function deleteExpandedDataSet
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteExpandedDataSetRequest} request DeleteExpandedDataSetRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getChannelGroup}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetChannelGroupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ChannelGroup} [response] ChannelGroup
                         */
    
                        /**
                         * Calls GetChannelGroup.
                         * @function getChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetChannelGroupRequest} request GetChannelGroupRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetChannelGroupCallback} callback Node-style callback called with the error, if any, and ChannelGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getChannelGroup = function getChannelGroup(request, callback) {
                            return this.rpcCall(getChannelGroup, $root.google.analytics.admin.v1alpha.GetChannelGroupRequest, $root.google.analytics.admin.v1alpha.ChannelGroup, request, callback);
                        }, "name", { value: "GetChannelGroup" });
    
                        /**
                         * Calls GetChannelGroup.
                         * @function getChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetChannelGroupRequest} request GetChannelGroupRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ChannelGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listChannelGroups}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListChannelGroupsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListChannelGroupsResponse} [response] ListChannelGroupsResponse
                         */
    
                        /**
                         * Calls ListChannelGroups.
                         * @function listChannelGroups
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsRequest} request ListChannelGroupsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListChannelGroupsCallback} callback Node-style callback called with the error, if any, and ListChannelGroupsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listChannelGroups = function listChannelGroups(request, callback) {
                            return this.rpcCall(listChannelGroups, $root.google.analytics.admin.v1alpha.ListChannelGroupsRequest, $root.google.analytics.admin.v1alpha.ListChannelGroupsResponse, request, callback);
                        }, "name", { value: "ListChannelGroups" });
    
                        /**
                         * Calls ListChannelGroups.
                         * @function listChannelGroups
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsRequest} request ListChannelGroupsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListChannelGroupsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createChannelGroup}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateChannelGroupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ChannelGroup} [response] ChannelGroup
                         */
    
                        /**
                         * Calls CreateChannelGroup.
                         * @function createChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateChannelGroupRequest} request CreateChannelGroupRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateChannelGroupCallback} callback Node-style callback called with the error, if any, and ChannelGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createChannelGroup = function createChannelGroup(request, callback) {
                            return this.rpcCall(createChannelGroup, $root.google.analytics.admin.v1alpha.CreateChannelGroupRequest, $root.google.analytics.admin.v1alpha.ChannelGroup, request, callback);
                        }, "name", { value: "CreateChannelGroup" });
    
                        /**
                         * Calls CreateChannelGroup.
                         * @function createChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateChannelGroupRequest} request CreateChannelGroupRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ChannelGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateChannelGroup}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateChannelGroupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ChannelGroup} [response] ChannelGroup
                         */
    
                        /**
                         * Calls UpdateChannelGroup.
                         * @function updateChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateChannelGroupRequest} request UpdateChannelGroupRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateChannelGroupCallback} callback Node-style callback called with the error, if any, and ChannelGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateChannelGroup = function updateChannelGroup(request, callback) {
                            return this.rpcCall(updateChannelGroup, $root.google.analytics.admin.v1alpha.UpdateChannelGroupRequest, $root.google.analytics.admin.v1alpha.ChannelGroup, request, callback);
                        }, "name", { value: "UpdateChannelGroup" });
    
                        /**
                         * Calls UpdateChannelGroup.
                         * @function updateChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateChannelGroupRequest} request UpdateChannelGroupRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ChannelGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteChannelGroup}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteChannelGroupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteChannelGroup.
                         * @function deleteChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteChannelGroupRequest} request DeleteChannelGroupRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteChannelGroupCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteChannelGroup = function deleteChannelGroup(request, callback) {
                            return this.rpcCall(deleteChannelGroup, $root.google.analytics.admin.v1alpha.DeleteChannelGroupRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteChannelGroup" });
    
                        /**
                         * Calls DeleteChannelGroup.
                         * @function deleteChannelGroup
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteChannelGroupRequest} request DeleteChannelGroupRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|setAutomatedGa4ConfigurationOptOut}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef SetAutomatedGa4ConfigurationOptOutCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse} [response] SetAutomatedGa4ConfigurationOptOutResponse
                         */
    
                        /**
                         * Calls SetAutomatedGa4ConfigurationOptOut.
                         * @function setAutomatedGa4ConfigurationOptOut
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutRequest} request SetAutomatedGa4ConfigurationOptOutRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.SetAutomatedGa4ConfigurationOptOutCallback} callback Node-style callback called with the error, if any, and SetAutomatedGa4ConfigurationOptOutResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.setAutomatedGa4ConfigurationOptOut = function setAutomatedGa4ConfigurationOptOut(request, callback) {
                            return this.rpcCall(setAutomatedGa4ConfigurationOptOut, $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest, $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse, request, callback);
                        }, "name", { value: "SetAutomatedGa4ConfigurationOptOut" });
    
                        /**
                         * Calls SetAutomatedGa4ConfigurationOptOut.
                         * @function setAutomatedGa4ConfigurationOptOut
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutRequest} request SetAutomatedGa4ConfigurationOptOutRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|fetchAutomatedGa4ConfigurationOptOut}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef FetchAutomatedGa4ConfigurationOptOutCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse} [response] FetchAutomatedGa4ConfigurationOptOutResponse
                         */
    
                        /**
                         * Calls FetchAutomatedGa4ConfigurationOptOut.
                         * @function fetchAutomatedGa4ConfigurationOptOut
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutRequest} request FetchAutomatedGa4ConfigurationOptOutRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.FetchAutomatedGa4ConfigurationOptOutCallback} callback Node-style callback called with the error, if any, and FetchAutomatedGa4ConfigurationOptOutResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.fetchAutomatedGa4ConfigurationOptOut = function fetchAutomatedGa4ConfigurationOptOut(request, callback) {
                            return this.rpcCall(fetchAutomatedGa4ConfigurationOptOut, $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest, $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse, request, callback);
                        }, "name", { value: "FetchAutomatedGa4ConfigurationOptOut" });
    
                        /**
                         * Calls FetchAutomatedGa4ConfigurationOptOut.
                         * @function fetchAutomatedGa4ConfigurationOptOut
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutRequest} request FetchAutomatedGa4ConfigurationOptOutRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getBigQueryLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetBigQueryLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.BigQueryLink} [response] BigQueryLink
                         */
    
                        /**
                         * Calls GetBigQueryLink.
                         * @function getBigQueryLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetBigQueryLinkRequest} request GetBigQueryLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetBigQueryLinkCallback} callback Node-style callback called with the error, if any, and BigQueryLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getBigQueryLink = function getBigQueryLink(request, callback) {
                            return this.rpcCall(getBigQueryLink, $root.google.analytics.admin.v1alpha.GetBigQueryLinkRequest, $root.google.analytics.admin.v1alpha.BigQueryLink, request, callback);
                        }, "name", { value: "GetBigQueryLink" });
    
                        /**
                         * Calls GetBigQueryLink.
                         * @function getBigQueryLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetBigQueryLinkRequest} request GetBigQueryLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.BigQueryLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listBigQueryLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListBigQueryLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListBigQueryLinksResponse} [response] ListBigQueryLinksResponse
                         */
    
                        /**
                         * Calls ListBigQueryLinks.
                         * @function listBigQueryLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksRequest} request ListBigQueryLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListBigQueryLinksCallback} callback Node-style callback called with the error, if any, and ListBigQueryLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listBigQueryLinks = function listBigQueryLinks(request, callback) {
                            return this.rpcCall(listBigQueryLinks, $root.google.analytics.admin.v1alpha.ListBigQueryLinksRequest, $root.google.analytics.admin.v1alpha.ListBigQueryLinksResponse, request, callback);
                        }, "name", { value: "ListBigQueryLinks" });
    
                        /**
                         * Calls ListBigQueryLinks.
                         * @function listBigQueryLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksRequest} request ListBigQueryLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListBigQueryLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getEnhancedMeasurementSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetEnhancedMeasurementSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.EnhancedMeasurementSettings} [response] EnhancedMeasurementSettings
                         */
    
                        /**
                         * Calls GetEnhancedMeasurementSettings.
                         * @function getEnhancedMeasurementSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetEnhancedMeasurementSettingsRequest} request GetEnhancedMeasurementSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetEnhancedMeasurementSettingsCallback} callback Node-style callback called with the error, if any, and EnhancedMeasurementSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getEnhancedMeasurementSettings = function getEnhancedMeasurementSettings(request, callback) {
                            return this.rpcCall(getEnhancedMeasurementSettings, $root.google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest, $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings, request, callback);
                        }, "name", { value: "GetEnhancedMeasurementSettings" });
    
                        /**
                         * Calls GetEnhancedMeasurementSettings.
                         * @function getEnhancedMeasurementSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetEnhancedMeasurementSettingsRequest} request GetEnhancedMeasurementSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.EnhancedMeasurementSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateEnhancedMeasurementSettings}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateEnhancedMeasurementSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.EnhancedMeasurementSettings} [response] EnhancedMeasurementSettings
                         */
    
                        /**
                         * Calls UpdateEnhancedMeasurementSettings.
                         * @function updateEnhancedMeasurementSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateEnhancedMeasurementSettingsRequest} request UpdateEnhancedMeasurementSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateEnhancedMeasurementSettingsCallback} callback Node-style callback called with the error, if any, and EnhancedMeasurementSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateEnhancedMeasurementSettings = function updateEnhancedMeasurementSettings(request, callback) {
                            return this.rpcCall(updateEnhancedMeasurementSettings, $root.google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest, $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings, request, callback);
                        }, "name", { value: "UpdateEnhancedMeasurementSettings" });
    
                        /**
                         * Calls UpdateEnhancedMeasurementSettings.
                         * @function updateEnhancedMeasurementSettings
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateEnhancedMeasurementSettingsRequest} request UpdateEnhancedMeasurementSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.EnhancedMeasurementSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createConnectedSiteTag}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateConnectedSiteTagCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse} [response] CreateConnectedSiteTagResponse
                         */
    
                        /**
                         * Calls CreateConnectedSiteTag.
                         * @function createConnectedSiteTag
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagRequest} request CreateConnectedSiteTagRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateConnectedSiteTagCallback} callback Node-style callback called with the error, if any, and CreateConnectedSiteTagResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createConnectedSiteTag = function createConnectedSiteTag(request, callback) {
                            return this.rpcCall(createConnectedSiteTag, $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest, $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse, request, callback);
                        }, "name", { value: "CreateConnectedSiteTag" });
    
                        /**
                         * Calls CreateConnectedSiteTag.
                         * @function createConnectedSiteTag
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagRequest} request CreateConnectedSiteTagRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteConnectedSiteTag}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteConnectedSiteTagCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteConnectedSiteTag.
                         * @function deleteConnectedSiteTag
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteConnectedSiteTagRequest} request DeleteConnectedSiteTagRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteConnectedSiteTagCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteConnectedSiteTag = function deleteConnectedSiteTag(request, callback) {
                            return this.rpcCall(deleteConnectedSiteTag, $root.google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteConnectedSiteTag" });
    
                        /**
                         * Calls DeleteConnectedSiteTag.
                         * @function deleteConnectedSiteTag
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteConnectedSiteTagRequest} request DeleteConnectedSiteTagRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listConnectedSiteTags}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListConnectedSiteTagsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse} [response] ListConnectedSiteTagsResponse
                         */
    
                        /**
                         * Calls ListConnectedSiteTags.
                         * @function listConnectedSiteTags
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsRequest} request ListConnectedSiteTagsRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListConnectedSiteTagsCallback} callback Node-style callback called with the error, if any, and ListConnectedSiteTagsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listConnectedSiteTags = function listConnectedSiteTags(request, callback) {
                            return this.rpcCall(listConnectedSiteTags, $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest, $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse, request, callback);
                        }, "name", { value: "ListConnectedSiteTags" });
    
                        /**
                         * Calls ListConnectedSiteTags.
                         * @function listConnectedSiteTags
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsRequest} request ListConnectedSiteTagsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|fetchConnectedGa4Property}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef FetchConnectedGa4PropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse} [response] FetchConnectedGa4PropertyResponse
                         */
    
                        /**
                         * Calls FetchConnectedGa4Property.
                         * @function fetchConnectedGa4Property
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyRequest} request FetchConnectedGa4PropertyRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.FetchConnectedGa4PropertyCallback} callback Node-style callback called with the error, if any, and FetchConnectedGa4PropertyResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.fetchConnectedGa4Property = function fetchConnectedGa4Property(request, callback) {
                            return this.rpcCall(fetchConnectedGa4Property, $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest, $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse, request, callback);
                        }, "name", { value: "FetchConnectedGa4Property" });
    
                        /**
                         * Calls FetchConnectedGa4Property.
                         * @function fetchConnectedGa4Property
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyRequest} request FetchConnectedGa4PropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getAdSenseLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetAdSenseLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AdSenseLink} [response] AdSenseLink
                         */
    
                        /**
                         * Calls GetAdSenseLink.
                         * @function getAdSenseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAdSenseLinkRequest} request GetAdSenseLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetAdSenseLinkCallback} callback Node-style callback called with the error, if any, and AdSenseLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getAdSenseLink = function getAdSenseLink(request, callback) {
                            return this.rpcCall(getAdSenseLink, $root.google.analytics.admin.v1alpha.GetAdSenseLinkRequest, $root.google.analytics.admin.v1alpha.AdSenseLink, request, callback);
                        }, "name", { value: "GetAdSenseLink" });
    
                        /**
                         * Calls GetAdSenseLink.
                         * @function getAdSenseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetAdSenseLinkRequest} request GetAdSenseLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AdSenseLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createAdSenseLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateAdSenseLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.AdSenseLink} [response] AdSenseLink
                         */
    
                        /**
                         * Calls CreateAdSenseLink.
                         * @function createAdSenseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateAdSenseLinkRequest} request CreateAdSenseLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateAdSenseLinkCallback} callback Node-style callback called with the error, if any, and AdSenseLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createAdSenseLink = function createAdSenseLink(request, callback) {
                            return this.rpcCall(createAdSenseLink, $root.google.analytics.admin.v1alpha.CreateAdSenseLinkRequest, $root.google.analytics.admin.v1alpha.AdSenseLink, request, callback);
                        }, "name", { value: "CreateAdSenseLink" });
    
                        /**
                         * Calls CreateAdSenseLink.
                         * @function createAdSenseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateAdSenseLinkRequest} request CreateAdSenseLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.AdSenseLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteAdSenseLink}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteAdSenseLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteAdSenseLink.
                         * @function deleteAdSenseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteAdSenseLinkRequest} request DeleteAdSenseLinkRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteAdSenseLinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteAdSenseLink = function deleteAdSenseLink(request, callback) {
                            return this.rpcCall(deleteAdSenseLink, $root.google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteAdSenseLink" });
    
                        /**
                         * Calls DeleteAdSenseLink.
                         * @function deleteAdSenseLink
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteAdSenseLinkRequest} request DeleteAdSenseLinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listAdSenseLinks}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListAdSenseLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListAdSenseLinksResponse} [response] ListAdSenseLinksResponse
                         */
    
                        /**
                         * Calls ListAdSenseLinks.
                         * @function listAdSenseLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksRequest} request ListAdSenseLinksRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListAdSenseLinksCallback} callback Node-style callback called with the error, if any, and ListAdSenseLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listAdSenseLinks = function listAdSenseLinks(request, callback) {
                            return this.rpcCall(listAdSenseLinks, $root.google.analytics.admin.v1alpha.ListAdSenseLinksRequest, $root.google.analytics.admin.v1alpha.ListAdSenseLinksResponse, request, callback);
                        }, "name", { value: "ListAdSenseLinks" });
    
                        /**
                         * Calls ListAdSenseLinks.
                         * @function listAdSenseLinks
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksRequest} request ListAdSenseLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListAdSenseLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|getEventCreateRule}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef GetEventCreateRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.EventCreateRule} [response] EventCreateRule
                         */
    
                        /**
                         * Calls GetEventCreateRule.
                         * @function getEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetEventCreateRuleRequest} request GetEventCreateRuleRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.GetEventCreateRuleCallback} callback Node-style callback called with the error, if any, and EventCreateRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getEventCreateRule = function getEventCreateRule(request, callback) {
                            return this.rpcCall(getEventCreateRule, $root.google.analytics.admin.v1alpha.GetEventCreateRuleRequest, $root.google.analytics.admin.v1alpha.EventCreateRule, request, callback);
                        }, "name", { value: "GetEventCreateRule" });
    
                        /**
                         * Calls GetEventCreateRule.
                         * @function getEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IGetEventCreateRuleRequest} request GetEventCreateRuleRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.EventCreateRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|listEventCreateRules}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef ListEventCreateRulesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.ListEventCreateRulesResponse} [response] ListEventCreateRulesResponse
                         */
    
                        /**
                         * Calls ListEventCreateRules.
                         * @function listEventCreateRules
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesRequest} request ListEventCreateRulesRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.ListEventCreateRulesCallback} callback Node-style callback called with the error, if any, and ListEventCreateRulesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listEventCreateRules = function listEventCreateRules(request, callback) {
                            return this.rpcCall(listEventCreateRules, $root.google.analytics.admin.v1alpha.ListEventCreateRulesRequest, $root.google.analytics.admin.v1alpha.ListEventCreateRulesResponse, request, callback);
                        }, "name", { value: "ListEventCreateRules" });
    
                        /**
                         * Calls ListEventCreateRules.
                         * @function listEventCreateRules
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesRequest} request ListEventCreateRulesRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.ListEventCreateRulesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|createEventCreateRule}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef CreateEventCreateRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.EventCreateRule} [response] EventCreateRule
                         */
    
                        /**
                         * Calls CreateEventCreateRule.
                         * @function createEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateEventCreateRuleRequest} request CreateEventCreateRuleRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.CreateEventCreateRuleCallback} callback Node-style callback called with the error, if any, and EventCreateRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createEventCreateRule = function createEventCreateRule(request, callback) {
                            return this.rpcCall(createEventCreateRule, $root.google.analytics.admin.v1alpha.CreateEventCreateRuleRequest, $root.google.analytics.admin.v1alpha.EventCreateRule, request, callback);
                        }, "name", { value: "CreateEventCreateRule" });
    
                        /**
                         * Calls CreateEventCreateRule.
                         * @function createEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.ICreateEventCreateRuleRequest} request CreateEventCreateRuleRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.EventCreateRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|updateEventCreateRule}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef UpdateEventCreateRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1alpha.EventCreateRule} [response] EventCreateRule
                         */
    
                        /**
                         * Calls UpdateEventCreateRule.
                         * @function updateEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateEventCreateRuleRequest} request UpdateEventCreateRuleRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.UpdateEventCreateRuleCallback} callback Node-style callback called with the error, if any, and EventCreateRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateEventCreateRule = function updateEventCreateRule(request, callback) {
                            return this.rpcCall(updateEventCreateRule, $root.google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest, $root.google.analytics.admin.v1alpha.EventCreateRule, request, callback);
                        }, "name", { value: "UpdateEventCreateRule" });
    
                        /**
                         * Calls UpdateEventCreateRule.
                         * @function updateEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IUpdateEventCreateRuleRequest} request UpdateEventCreateRuleRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1alpha.EventCreateRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1alpha.AnalyticsAdminService|deleteEventCreateRule}.
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @typedef DeleteEventCreateRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteEventCreateRule.
                         * @function deleteEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteEventCreateRuleRequest} request DeleteEventCreateRuleRequest message or plain object
                         * @param {google.analytics.admin.v1alpha.AnalyticsAdminService.DeleteEventCreateRuleCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteEventCreateRule = function deleteEventCreateRule(request, callback) {
                            return this.rpcCall(deleteEventCreateRule, $root.google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteEventCreateRule" });
    
                        /**
                         * Calls DeleteEventCreateRule.
                         * @function deleteEventCreateRule
                         * @memberof google.analytics.admin.v1alpha.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1alpha.IDeleteEventCreateRuleRequest} request DeleteEventCreateRuleRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        return AnalyticsAdminService;
                    })();
    
                    v1alpha.RunAccessReportRequest = (function() {
    
                        /**
                         * Properties of a RunAccessReportRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IRunAccessReportRequest
                         * @property {string|null} [entity] RunAccessReportRequest entity
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessDimension>|null} [dimensions] RunAccessReportRequest dimensions
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessMetric>|null} [metrics] RunAccessReportRequest metrics
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessDateRange>|null} [dateRanges] RunAccessReportRequest dateRanges
                         * @property {google.analytics.admin.v1alpha.IAccessFilterExpression|null} [dimensionFilter] RunAccessReportRequest dimensionFilter
                         * @property {google.analytics.admin.v1alpha.IAccessFilterExpression|null} [metricFilter] RunAccessReportRequest metricFilter
                         * @property {number|Long|null} [offset] RunAccessReportRequest offset
                         * @property {number|Long|null} [limit] RunAccessReportRequest limit
                         * @property {string|null} [timeZone] RunAccessReportRequest timeZone
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessOrderBy>|null} [orderBys] RunAccessReportRequest orderBys
                         * @property {boolean|null} [returnEntityQuota] RunAccessReportRequest returnEntityQuota
                         */
    
                        /**
                         * Constructs a new RunAccessReportRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a RunAccessReportRequest.
                         * @implements IRunAccessReportRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportRequest=} [properties] Properties to set
                         */
                        function RunAccessReportRequest(properties) {
                            this.dimensions = [];
                            this.metrics = [];
                            this.dateRanges = [];
                            this.orderBys = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RunAccessReportRequest entity.
                         * @member {string} entity
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.entity = "";
    
                        /**
                         * RunAccessReportRequest dimensions.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessDimension>} dimensions
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.dimensions = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest metrics.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessMetric>} metrics
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.metrics = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest dateRanges.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessDateRange>} dateRanges
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.dateRanges = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest dimensionFilter.
                         * @member {google.analytics.admin.v1alpha.IAccessFilterExpression|null|undefined} dimensionFilter
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.dimensionFilter = null;
    
                        /**
                         * RunAccessReportRequest metricFilter.
                         * @member {google.analytics.admin.v1alpha.IAccessFilterExpression|null|undefined} metricFilter
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.metricFilter = null;
    
                        /**
                         * RunAccessReportRequest offset.
                         * @member {number|Long} offset
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.offset = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                        /**
                         * RunAccessReportRequest limit.
                         * @member {number|Long} limit
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.limit = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                        /**
                         * RunAccessReportRequest timeZone.
                         * @member {string} timeZone
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.timeZone = "";
    
                        /**
                         * RunAccessReportRequest orderBys.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessOrderBy>} orderBys
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.orderBys = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest returnEntityQuota.
                         * @member {boolean} returnEntityQuota
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.returnEntityQuota = false;
    
                        /**
                         * Creates a new RunAccessReportRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportRequest} RunAccessReportRequest instance
                         */
                        RunAccessReportRequest.create = function create(properties) {
                            return new RunAccessReportRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RunAccessReportRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.RunAccessReportRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportRequest} message RunAccessReportRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.entity != null && Object.hasOwnProperty.call(message, "entity"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.entity);
                            if (message.dimensions != null && message.dimensions.length)
                                for (var i = 0; i < message.dimensions.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessDimension.encode(message.dimensions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.metrics != null && message.metrics.length)
                                for (var i = 0; i < message.metrics.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessMetric.encode(message.metrics[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.dateRanges != null && message.dateRanges.length)
                                for (var i = 0; i < message.dateRanges.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessDateRange.encode(message.dateRanges[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.dimensionFilter != null && Object.hasOwnProperty.call(message, "dimensionFilter"))
                                $root.google.analytics.admin.v1alpha.AccessFilterExpression.encode(message.dimensionFilter, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.metricFilter != null && Object.hasOwnProperty.call(message, "metricFilter"))
                                $root.google.analytics.admin.v1alpha.AccessFilterExpression.encode(message.metricFilter, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.offset != null && Object.hasOwnProperty.call(message, "offset"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int64(message.offset);
                            if (message.limit != null && Object.hasOwnProperty.call(message, "limit"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int64(message.limit);
                            if (message.timeZone != null && Object.hasOwnProperty.call(message, "timeZone"))
                                writer.uint32(/* id 9, wireType 2 =*/74).string(message.timeZone);
                            if (message.orderBys != null && message.orderBys.length)
                                for (var i = 0; i < message.orderBys.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessOrderBy.encode(message.orderBys[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.returnEntityQuota != null && Object.hasOwnProperty.call(message, "returnEntityQuota"))
                                writer.uint32(/* id 11, wireType 0 =*/88).bool(message.returnEntityQuota);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RunAccessReportRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.RunAccessReportRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportRequest} message RunAccessReportRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RunAccessReportRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportRequest} RunAccessReportRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.RunAccessReportRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.entity = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.dimensions && message.dimensions.length))
                                            message.dimensions = [];
                                        message.dimensions.push($root.google.analytics.admin.v1alpha.AccessDimension.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3: {
                                        if (!(message.metrics && message.metrics.length))
                                            message.metrics = [];
                                        message.metrics.push($root.google.analytics.admin.v1alpha.AccessMetric.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 4: {
                                        if (!(message.dateRanges && message.dateRanges.length))
                                            message.dateRanges = [];
                                        message.dateRanges.push($root.google.analytics.admin.v1alpha.AccessDateRange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 5: {
                                        message.dimensionFilter = $root.google.analytics.admin.v1alpha.AccessFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 6: {
                                        message.metricFilter = $root.google.analytics.admin.v1alpha.AccessFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.offset = reader.int64();
                                        break;
                                    }
                                case 8: {
                                        message.limit = reader.int64();
                                        break;
                                    }
                                case 9: {
                                        message.timeZone = reader.string();
                                        break;
                                    }
                                case 10: {
                                        if (!(message.orderBys && message.orderBys.length))
                                            message.orderBys = [];
                                        message.orderBys.push($root.google.analytics.admin.v1alpha.AccessOrderBy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 11: {
                                        message.returnEntityQuota = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RunAccessReportRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportRequest} RunAccessReportRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RunAccessReportRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RunAccessReportRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.entity != null && message.hasOwnProperty("entity"))
                                if (!$util.isString(message.entity))
                                    return "entity: string expected";
                            if (message.dimensions != null && message.hasOwnProperty("dimensions")) {
                                if (!Array.isArray(message.dimensions))
                                    return "dimensions: array expected";
                                for (var i = 0; i < message.dimensions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessDimension.verify(message.dimensions[i]);
                                    if (error)
                                        return "dimensions." + error;
                                }
                            }
                            if (message.metrics != null && message.hasOwnProperty("metrics")) {
                                if (!Array.isArray(message.metrics))
                                    return "metrics: array expected";
                                for (var i = 0; i < message.metrics.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessMetric.verify(message.metrics[i]);
                                    if (error)
                                        return "metrics." + error;
                                }
                            }
                            if (message.dateRanges != null && message.hasOwnProperty("dateRanges")) {
                                if (!Array.isArray(message.dateRanges))
                                    return "dateRanges: array expected";
                                for (var i = 0; i < message.dateRanges.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessDateRange.verify(message.dateRanges[i]);
                                    if (error)
                                        return "dateRanges." + error;
                                }
                            }
                            if (message.dimensionFilter != null && message.hasOwnProperty("dimensionFilter")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessFilterExpression.verify(message.dimensionFilter);
                                if (error)
                                    return "dimensionFilter." + error;
                            }
                            if (message.metricFilter != null && message.hasOwnProperty("metricFilter")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessFilterExpression.verify(message.metricFilter);
                                if (error)
                                    return "metricFilter." + error;
                            }
                            if (message.offset != null && message.hasOwnProperty("offset"))
                                if (!$util.isInteger(message.offset) && !(message.offset && $util.isInteger(message.offset.low) && $util.isInteger(message.offset.high)))
                                    return "offset: integer|Long expected";
                            if (message.limit != null && message.hasOwnProperty("limit"))
                                if (!$util.isInteger(message.limit) && !(message.limit && $util.isInteger(message.limit.low) && $util.isInteger(message.limit.high)))
                                    return "limit: integer|Long expected";
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                if (!$util.isString(message.timeZone))
                                    return "timeZone: string expected";
                            if (message.orderBys != null && message.hasOwnProperty("orderBys")) {
                                if (!Array.isArray(message.orderBys))
                                    return "orderBys: array expected";
                                for (var i = 0; i < message.orderBys.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessOrderBy.verify(message.orderBys[i]);
                                    if (error)
                                        return "orderBys." + error;
                                }
                            }
                            if (message.returnEntityQuota != null && message.hasOwnProperty("returnEntityQuota"))
                                if (typeof message.returnEntityQuota !== "boolean")
                                    return "returnEntityQuota: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a RunAccessReportRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportRequest} RunAccessReportRequest
                         */
                        RunAccessReportRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.RunAccessReportRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.RunAccessReportRequest();
                            if (object.entity != null)
                                message.entity = String(object.entity);
                            if (object.dimensions) {
                                if (!Array.isArray(object.dimensions))
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.dimensions: array expected");
                                message.dimensions = [];
                                for (var i = 0; i < object.dimensions.length; ++i) {
                                    if (typeof object.dimensions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.dimensions: object expected");
                                    message.dimensions[i] = $root.google.analytics.admin.v1alpha.AccessDimension.fromObject(object.dimensions[i]);
                                }
                            }
                            if (object.metrics) {
                                if (!Array.isArray(object.metrics))
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.metrics: array expected");
                                message.metrics = [];
                                for (var i = 0; i < object.metrics.length; ++i) {
                                    if (typeof object.metrics[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.metrics: object expected");
                                    message.metrics[i] = $root.google.analytics.admin.v1alpha.AccessMetric.fromObject(object.metrics[i]);
                                }
                            }
                            if (object.dateRanges) {
                                if (!Array.isArray(object.dateRanges))
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.dateRanges: array expected");
                                message.dateRanges = [];
                                for (var i = 0; i < object.dateRanges.length; ++i) {
                                    if (typeof object.dateRanges[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.dateRanges: object expected");
                                    message.dateRanges[i] = $root.google.analytics.admin.v1alpha.AccessDateRange.fromObject(object.dateRanges[i]);
                                }
                            }
                            if (object.dimensionFilter != null) {
                                if (typeof object.dimensionFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.dimensionFilter: object expected");
                                message.dimensionFilter = $root.google.analytics.admin.v1alpha.AccessFilterExpression.fromObject(object.dimensionFilter);
                            }
                            if (object.metricFilter != null) {
                                if (typeof object.metricFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.metricFilter: object expected");
                                message.metricFilter = $root.google.analytics.admin.v1alpha.AccessFilterExpression.fromObject(object.metricFilter);
                            }
                            if (object.offset != null)
                                if ($util.Long)
                                    (message.offset = $util.Long.fromValue(object.offset)).unsigned = false;
                                else if (typeof object.offset === "string")
                                    message.offset = parseInt(object.offset, 10);
                                else if (typeof object.offset === "number")
                                    message.offset = object.offset;
                                else if (typeof object.offset === "object")
                                    message.offset = new $util.LongBits(object.offset.low >>> 0, object.offset.high >>> 0).toNumber();
                            if (object.limit != null)
                                if ($util.Long)
                                    (message.limit = $util.Long.fromValue(object.limit)).unsigned = false;
                                else if (typeof object.limit === "string")
                                    message.limit = parseInt(object.limit, 10);
                                else if (typeof object.limit === "number")
                                    message.limit = object.limit;
                                else if (typeof object.limit === "object")
                                    message.limit = new $util.LongBits(object.limit.low >>> 0, object.limit.high >>> 0).toNumber();
                            if (object.timeZone != null)
                                message.timeZone = String(object.timeZone);
                            if (object.orderBys) {
                                if (!Array.isArray(object.orderBys))
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.orderBys: array expected");
                                message.orderBys = [];
                                for (var i = 0; i < object.orderBys.length; ++i) {
                                    if (typeof object.orderBys[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportRequest.orderBys: object expected");
                                    message.orderBys[i] = $root.google.analytics.admin.v1alpha.AccessOrderBy.fromObject(object.orderBys[i]);
                                }
                            }
                            if (object.returnEntityQuota != null)
                                message.returnEntityQuota = Boolean(object.returnEntityQuota);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RunAccessReportRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.RunAccessReportRequest} message RunAccessReportRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RunAccessReportRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dimensions = [];
                                object.metrics = [];
                                object.dateRanges = [];
                                object.orderBys = [];
                            }
                            if (options.defaults) {
                                object.entity = "";
                                object.dimensionFilter = null;
                                object.metricFilter = null;
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.offset = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.offset = options.longs === String ? "0" : 0;
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.limit = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.limit = options.longs === String ? "0" : 0;
                                object.timeZone = "";
                                object.returnEntityQuota = false;
                            }
                            if (message.entity != null && message.hasOwnProperty("entity"))
                                object.entity = message.entity;
                            if (message.dimensions && message.dimensions.length) {
                                object.dimensions = [];
                                for (var j = 0; j < message.dimensions.length; ++j)
                                    object.dimensions[j] = $root.google.analytics.admin.v1alpha.AccessDimension.toObject(message.dimensions[j], options);
                            }
                            if (message.metrics && message.metrics.length) {
                                object.metrics = [];
                                for (var j = 0; j < message.metrics.length; ++j)
                                    object.metrics[j] = $root.google.analytics.admin.v1alpha.AccessMetric.toObject(message.metrics[j], options);
                            }
                            if (message.dateRanges && message.dateRanges.length) {
                                object.dateRanges = [];
                                for (var j = 0; j < message.dateRanges.length; ++j)
                                    object.dateRanges[j] = $root.google.analytics.admin.v1alpha.AccessDateRange.toObject(message.dateRanges[j], options);
                            }
                            if (message.dimensionFilter != null && message.hasOwnProperty("dimensionFilter"))
                                object.dimensionFilter = $root.google.analytics.admin.v1alpha.AccessFilterExpression.toObject(message.dimensionFilter, options);
                            if (message.metricFilter != null && message.hasOwnProperty("metricFilter"))
                                object.metricFilter = $root.google.analytics.admin.v1alpha.AccessFilterExpression.toObject(message.metricFilter, options);
                            if (message.offset != null && message.hasOwnProperty("offset"))
                                if (typeof message.offset === "number")
                                    object.offset = options.longs === String ? String(message.offset) : message.offset;
                                else
                                    object.offset = options.longs === String ? $util.Long.prototype.toString.call(message.offset) : options.longs === Number ? new $util.LongBits(message.offset.low >>> 0, message.offset.high >>> 0).toNumber() : message.offset;
                            if (message.limit != null && message.hasOwnProperty("limit"))
                                if (typeof message.limit === "number")
                                    object.limit = options.longs === String ? String(message.limit) : message.limit;
                                else
                                    object.limit = options.longs === String ? $util.Long.prototype.toString.call(message.limit) : options.longs === Number ? new $util.LongBits(message.limit.low >>> 0, message.limit.high >>> 0).toNumber() : message.limit;
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                object.timeZone = message.timeZone;
                            if (message.orderBys && message.orderBys.length) {
                                object.orderBys = [];
                                for (var j = 0; j < message.orderBys.length; ++j)
                                    object.orderBys[j] = $root.google.analytics.admin.v1alpha.AccessOrderBy.toObject(message.orderBys[j], options);
                            }
                            if (message.returnEntityQuota != null && message.hasOwnProperty("returnEntityQuota"))
                                object.returnEntityQuota = message.returnEntityQuota;
                            return object;
                        };
    
                        /**
                         * Converts this RunAccessReportRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RunAccessReportRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RunAccessReportRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RunAccessReportRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.RunAccessReportRequest";
                        };
    
                        return RunAccessReportRequest;
                    })();
    
                    v1alpha.RunAccessReportResponse = (function() {
    
                        /**
                         * Properties of a RunAccessReportResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IRunAccessReportResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessDimensionHeader>|null} [dimensionHeaders] RunAccessReportResponse dimensionHeaders
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessMetricHeader>|null} [metricHeaders] RunAccessReportResponse metricHeaders
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessRow>|null} [rows] RunAccessReportResponse rows
                         * @property {number|null} [rowCount] RunAccessReportResponse rowCount
                         * @property {google.analytics.admin.v1alpha.IAccessQuota|null} [quota] RunAccessReportResponse quota
                         */
    
                        /**
                         * Constructs a new RunAccessReportResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a RunAccessReportResponse.
                         * @implements IRunAccessReportResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportResponse=} [properties] Properties to set
                         */
                        function RunAccessReportResponse(properties) {
                            this.dimensionHeaders = [];
                            this.metricHeaders = [];
                            this.rows = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RunAccessReportResponse dimensionHeaders.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessDimensionHeader>} dimensionHeaders
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.dimensionHeaders = $util.emptyArray;
    
                        /**
                         * RunAccessReportResponse metricHeaders.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessMetricHeader>} metricHeaders
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.metricHeaders = $util.emptyArray;
    
                        /**
                         * RunAccessReportResponse rows.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessRow>} rows
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.rows = $util.emptyArray;
    
                        /**
                         * RunAccessReportResponse rowCount.
                         * @member {number} rowCount
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.rowCount = 0;
    
                        /**
                         * RunAccessReportResponse quota.
                         * @member {google.analytics.admin.v1alpha.IAccessQuota|null|undefined} quota
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.quota = null;
    
                        /**
                         * Creates a new RunAccessReportResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportResponse} RunAccessReportResponse instance
                         */
                        RunAccessReportResponse.create = function create(properties) {
                            return new RunAccessReportResponse(properties);
                        };
    
                        /**
                         * Encodes the specified RunAccessReportResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.RunAccessReportResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportResponse} message RunAccessReportResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionHeaders != null && message.dimensionHeaders.length)
                                for (var i = 0; i < message.dimensionHeaders.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessDimensionHeader.encode(message.dimensionHeaders[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.metricHeaders != null && message.metricHeaders.length)
                                for (var i = 0; i < message.metricHeaders.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessMetricHeader.encode(message.metricHeaders[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.rows != null && message.rows.length)
                                for (var i = 0; i < message.rows.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessRow.encode(message.rows[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.rowCount != null && Object.hasOwnProperty.call(message, "rowCount"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.rowCount);
                            if (message.quota != null && Object.hasOwnProperty.call(message, "quota"))
                                $root.google.analytics.admin.v1alpha.AccessQuota.encode(message.quota, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RunAccessReportResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.RunAccessReportResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IRunAccessReportResponse} message RunAccessReportResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RunAccessReportResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportResponse} RunAccessReportResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.RunAccessReportResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.dimensionHeaders && message.dimensionHeaders.length))
                                            message.dimensionHeaders = [];
                                        message.dimensionHeaders.push($root.google.analytics.admin.v1alpha.AccessDimensionHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        if (!(message.metricHeaders && message.metricHeaders.length))
                                            message.metricHeaders = [];
                                        message.metricHeaders.push($root.google.analytics.admin.v1alpha.AccessMetricHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3: {
                                        if (!(message.rows && message.rows.length))
                                            message.rows = [];
                                        message.rows.push($root.google.analytics.admin.v1alpha.AccessRow.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 4: {
                                        message.rowCount = reader.int32();
                                        break;
                                    }
                                case 5: {
                                        message.quota = $root.google.analytics.admin.v1alpha.AccessQuota.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RunAccessReportResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportResponse} RunAccessReportResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RunAccessReportResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RunAccessReportResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionHeaders != null && message.hasOwnProperty("dimensionHeaders")) {
                                if (!Array.isArray(message.dimensionHeaders))
                                    return "dimensionHeaders: array expected";
                                for (var i = 0; i < message.dimensionHeaders.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessDimensionHeader.verify(message.dimensionHeaders[i]);
                                    if (error)
                                        return "dimensionHeaders." + error;
                                }
                            }
                            if (message.metricHeaders != null && message.hasOwnProperty("metricHeaders")) {
                                if (!Array.isArray(message.metricHeaders))
                                    return "metricHeaders: array expected";
                                for (var i = 0; i < message.metricHeaders.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessMetricHeader.verify(message.metricHeaders[i]);
                                    if (error)
                                        return "metricHeaders." + error;
                                }
                            }
                            if (message.rows != null && message.hasOwnProperty("rows")) {
                                if (!Array.isArray(message.rows))
                                    return "rows: array expected";
                                for (var i = 0; i < message.rows.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessRow.verify(message.rows[i]);
                                    if (error)
                                        return "rows." + error;
                                }
                            }
                            if (message.rowCount != null && message.hasOwnProperty("rowCount"))
                                if (!$util.isInteger(message.rowCount))
                                    return "rowCount: integer expected";
                            if (message.quota != null && message.hasOwnProperty("quota")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessQuota.verify(message.quota);
                                if (error)
                                    return "quota." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RunAccessReportResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.RunAccessReportResponse} RunAccessReportResponse
                         */
                        RunAccessReportResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.RunAccessReportResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.RunAccessReportResponse();
                            if (object.dimensionHeaders) {
                                if (!Array.isArray(object.dimensionHeaders))
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportResponse.dimensionHeaders: array expected");
                                message.dimensionHeaders = [];
                                for (var i = 0; i < object.dimensionHeaders.length; ++i) {
                                    if (typeof object.dimensionHeaders[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportResponse.dimensionHeaders: object expected");
                                    message.dimensionHeaders[i] = $root.google.analytics.admin.v1alpha.AccessDimensionHeader.fromObject(object.dimensionHeaders[i]);
                                }
                            }
                            if (object.metricHeaders) {
                                if (!Array.isArray(object.metricHeaders))
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportResponse.metricHeaders: array expected");
                                message.metricHeaders = [];
                                for (var i = 0; i < object.metricHeaders.length; ++i) {
                                    if (typeof object.metricHeaders[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportResponse.metricHeaders: object expected");
                                    message.metricHeaders[i] = $root.google.analytics.admin.v1alpha.AccessMetricHeader.fromObject(object.metricHeaders[i]);
                                }
                            }
                            if (object.rows) {
                                if (!Array.isArray(object.rows))
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportResponse.rows: array expected");
                                message.rows = [];
                                for (var i = 0; i < object.rows.length; ++i) {
                                    if (typeof object.rows[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportResponse.rows: object expected");
                                    message.rows[i] = $root.google.analytics.admin.v1alpha.AccessRow.fromObject(object.rows[i]);
                                }
                            }
                            if (object.rowCount != null)
                                message.rowCount = object.rowCount | 0;
                            if (object.quota != null) {
                                if (typeof object.quota !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.RunAccessReportResponse.quota: object expected");
                                message.quota = $root.google.analytics.admin.v1alpha.AccessQuota.fromObject(object.quota);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RunAccessReportResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.RunAccessReportResponse} message RunAccessReportResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RunAccessReportResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dimensionHeaders = [];
                                object.metricHeaders = [];
                                object.rows = [];
                            }
                            if (options.defaults) {
                                object.rowCount = 0;
                                object.quota = null;
                            }
                            if (message.dimensionHeaders && message.dimensionHeaders.length) {
                                object.dimensionHeaders = [];
                                for (var j = 0; j < message.dimensionHeaders.length; ++j)
                                    object.dimensionHeaders[j] = $root.google.analytics.admin.v1alpha.AccessDimensionHeader.toObject(message.dimensionHeaders[j], options);
                            }
                            if (message.metricHeaders && message.metricHeaders.length) {
                                object.metricHeaders = [];
                                for (var j = 0; j < message.metricHeaders.length; ++j)
                                    object.metricHeaders[j] = $root.google.analytics.admin.v1alpha.AccessMetricHeader.toObject(message.metricHeaders[j], options);
                            }
                            if (message.rows && message.rows.length) {
                                object.rows = [];
                                for (var j = 0; j < message.rows.length; ++j)
                                    object.rows[j] = $root.google.analytics.admin.v1alpha.AccessRow.toObject(message.rows[j], options);
                            }
                            if (message.rowCount != null && message.hasOwnProperty("rowCount"))
                                object.rowCount = message.rowCount;
                            if (message.quota != null && message.hasOwnProperty("quota"))
                                object.quota = $root.google.analytics.admin.v1alpha.AccessQuota.toObject(message.quota, options);
                            return object;
                        };
    
                        /**
                         * Converts this RunAccessReportResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RunAccessReportResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RunAccessReportResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.RunAccessReportResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RunAccessReportResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.RunAccessReportResponse";
                        };
    
                        return RunAccessReportResponse;
                    })();
    
                    v1alpha.GetAccountRequest = (function() {
    
                        /**
                         * Properties of a GetAccountRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetAccountRequest
                         * @property {string|null} [name] GetAccountRequest name
                         */
    
                        /**
                         * Constructs a new GetAccountRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetAccountRequest.
                         * @implements IGetAccountRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetAccountRequest=} [properties] Properties to set
                         */
                        function GetAccountRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAccountRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @instance
                         */
                        GetAccountRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetAccountRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAccountRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetAccountRequest} GetAccountRequest instance
                         */
                        GetAccountRequest.create = function create(properties) {
                            return new GetAccountRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAccountRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetAccountRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAccountRequest} message GetAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAccountRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetAccountRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAccountRequest} message GetAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAccountRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetAccountRequest} GetAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetAccountRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAccountRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetAccountRequest} GetAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAccountRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAccountRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAccountRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetAccountRequest} GetAccountRequest
                         */
                        GetAccountRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetAccountRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetAccountRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAccountRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetAccountRequest} message GetAccountRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAccountRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetAccountRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAccountRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAccountRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetAccountRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAccountRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetAccountRequest";
                        };
    
                        return GetAccountRequest;
                    })();
    
                    v1alpha.ListAccountsRequest = (function() {
    
                        /**
                         * Properties of a ListAccountsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAccountsRequest
                         * @property {number|null} [pageSize] ListAccountsRequest pageSize
                         * @property {string|null} [pageToken] ListAccountsRequest pageToken
                         * @property {boolean|null} [showDeleted] ListAccountsRequest showDeleted
                         */
    
                        /**
                         * Constructs a new ListAccountsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAccountsRequest.
                         * @implements IListAccountsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAccountsRequest=} [properties] Properties to set
                         */
                        function ListAccountsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @instance
                         */
                        ListAccountsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListAccountsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @instance
                         */
                        ListAccountsRequest.prototype.pageToken = "";
    
                        /**
                         * ListAccountsRequest showDeleted.
                         * @member {boolean} showDeleted
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @instance
                         */
                        ListAccountsRequest.prototype.showDeleted = false;
    
                        /**
                         * Creates a new ListAccountsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAccountsRequest} ListAccountsRequest instance
                         */
                        ListAccountsRequest.create = function create(properties) {
                            return new ListAccountsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountsRequest} message ListAccountsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.pageToken);
                            if (message.showDeleted != null && Object.hasOwnProperty.call(message, "showDeleted"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.showDeleted);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountsRequest} message ListAccountsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAccountsRequest} ListAccountsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAccountsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.showDeleted = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAccountsRequest} ListAccountsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                if (typeof message.showDeleted !== "boolean")
                                    return "showDeleted: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAccountsRequest} ListAccountsRequest
                         */
                        ListAccountsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAccountsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAccountsRequest();
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.showDeleted != null)
                                message.showDeleted = Boolean(object.showDeleted);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAccountsRequest} message ListAccountsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.pageSize = 0;
                                object.pageToken = "";
                                object.showDeleted = false;
                            }
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                object.showDeleted = message.showDeleted;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAccountsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAccountsRequest";
                        };
    
                        return ListAccountsRequest;
                    })();
    
                    v1alpha.ListAccountsResponse = (function() {
    
                        /**
                         * Properties of a ListAccountsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAccountsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAccount>|null} [accounts] ListAccountsResponse accounts
                         * @property {string|null} [nextPageToken] ListAccountsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListAccountsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAccountsResponse.
                         * @implements IListAccountsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAccountsResponse=} [properties] Properties to set
                         */
                        function ListAccountsResponse(properties) {
                            this.accounts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountsResponse accounts.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccount>} accounts
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @instance
                         */
                        ListAccountsResponse.prototype.accounts = $util.emptyArray;
    
                        /**
                         * ListAccountsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @instance
                         */
                        ListAccountsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListAccountsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAccountsResponse} ListAccountsResponse instance
                         */
                        ListAccountsResponse.create = function create(properties) {
                            return new ListAccountsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountsResponse} message ListAccountsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accounts != null && message.accounts.length)
                                for (var i = 0; i < message.accounts.length; ++i)
                                    $root.google.analytics.admin.v1alpha.Account.encode(message.accounts[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountsResponse} message ListAccountsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAccountsResponse} ListAccountsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAccountsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accounts && message.accounts.length))
                                            message.accounts = [];
                                        message.accounts.push($root.google.analytics.admin.v1alpha.Account.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAccountsResponse} ListAccountsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accounts != null && message.hasOwnProperty("accounts")) {
                                if (!Array.isArray(message.accounts))
                                    return "accounts: array expected";
                                for (var i = 0; i < message.accounts.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.Account.verify(message.accounts[i]);
                                    if (error)
                                        return "accounts." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAccountsResponse} ListAccountsResponse
                         */
                        ListAccountsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAccountsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAccountsResponse();
                            if (object.accounts) {
                                if (!Array.isArray(object.accounts))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListAccountsResponse.accounts: array expected");
                                message.accounts = [];
                                for (var i = 0; i < object.accounts.length; ++i) {
                                    if (typeof object.accounts[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListAccountsResponse.accounts: object expected");
                                    message.accounts[i] = $root.google.analytics.admin.v1alpha.Account.fromObject(object.accounts[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAccountsResponse} message ListAccountsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accounts = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.accounts && message.accounts.length) {
                                object.accounts = [];
                                for (var j = 0; j < message.accounts.length; ++j)
                                    object.accounts[j] = $root.google.analytics.admin.v1alpha.Account.toObject(message.accounts[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAccountsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAccountsResponse";
                        };
    
                        return ListAccountsResponse;
                    })();
    
                    v1alpha.DeleteAccountRequest = (function() {
    
                        /**
                         * Properties of a DeleteAccountRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteAccountRequest
                         * @property {string|null} [name] DeleteAccountRequest name
                         */
    
                        /**
                         * Constructs a new DeleteAccountRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteAccountRequest.
                         * @implements IDeleteAccountRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteAccountRequest=} [properties] Properties to set
                         */
                        function DeleteAccountRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAccountRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @instance
                         */
                        DeleteAccountRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteAccountRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAccountRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteAccountRequest} DeleteAccountRequest instance
                         */
                        DeleteAccountRequest.create = function create(properties) {
                            return new DeleteAccountRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAccountRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteAccountRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAccountRequest} message DeleteAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccountRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAccountRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteAccountRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAccountRequest} message DeleteAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccountRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAccountRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteAccountRequest} DeleteAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccountRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteAccountRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAccountRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteAccountRequest} DeleteAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccountRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAccountRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAccountRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAccountRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteAccountRequest} DeleteAccountRequest
                         */
                        DeleteAccountRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteAccountRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteAccountRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAccountRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteAccountRequest} message DeleteAccountRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAccountRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAccountRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAccountRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAccountRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteAccountRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAccountRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteAccountRequest";
                        };
    
                        return DeleteAccountRequest;
                    })();
    
                    v1alpha.UpdateAccountRequest = (function() {
    
                        /**
                         * Properties of an UpdateAccountRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateAccountRequest
                         * @property {google.analytics.admin.v1alpha.IAccount|null} [account] UpdateAccountRequest account
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateAccountRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateAccountRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateAccountRequest.
                         * @implements IUpdateAccountRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateAccountRequest=} [properties] Properties to set
                         */
                        function UpdateAccountRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateAccountRequest account.
                         * @member {google.analytics.admin.v1alpha.IAccount|null|undefined} account
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @instance
                         */
                        UpdateAccountRequest.prototype.account = null;
    
                        /**
                         * UpdateAccountRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @instance
                         */
                        UpdateAccountRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateAccountRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAccountRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateAccountRequest} UpdateAccountRequest instance
                         */
                        UpdateAccountRequest.create = function create(properties) {
                            return new UpdateAccountRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateAccountRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAccountRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAccountRequest} message UpdateAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccountRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                $root.google.analytics.admin.v1alpha.Account.encode(message.account, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateAccountRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAccountRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAccountRequest} message UpdateAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccountRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateAccountRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateAccountRequest} UpdateAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccountRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateAccountRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.account = $root.google.analytics.admin.v1alpha.Account.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateAccountRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateAccountRequest} UpdateAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccountRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateAccountRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateAccountRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.account != null && message.hasOwnProperty("account")) {
                                var error = $root.google.analytics.admin.v1alpha.Account.verify(message.account);
                                if (error)
                                    return "account." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateAccountRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateAccountRequest} UpdateAccountRequest
                         */
                        UpdateAccountRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateAccountRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateAccountRequest();
                            if (object.account != null) {
                                if (typeof object.account !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateAccountRequest.account: object expected");
                                message.account = $root.google.analytics.admin.v1alpha.Account.fromObject(object.account);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateAccountRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateAccountRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateAccountRequest} message UpdateAccountRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateAccountRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.account = null;
                                object.updateMask = null;
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = $root.google.analytics.admin.v1alpha.Account.toObject(message.account, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateAccountRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateAccountRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateAccountRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateAccountRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateAccountRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateAccountRequest";
                        };
    
                        return UpdateAccountRequest;
                    })();
    
                    v1alpha.ProvisionAccountTicketRequest = (function() {
    
                        /**
                         * Properties of a ProvisionAccountTicketRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IProvisionAccountTicketRequest
                         * @property {google.analytics.admin.v1alpha.IAccount|null} [account] ProvisionAccountTicketRequest account
                         * @property {string|null} [redirectUri] ProvisionAccountTicketRequest redirectUri
                         */
    
                        /**
                         * Constructs a new ProvisionAccountTicketRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ProvisionAccountTicketRequest.
                         * @implements IProvisionAccountTicketRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketRequest=} [properties] Properties to set
                         */
                        function ProvisionAccountTicketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProvisionAccountTicketRequest account.
                         * @member {google.analytics.admin.v1alpha.IAccount|null|undefined} account
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @instance
                         */
                        ProvisionAccountTicketRequest.prototype.account = null;
    
                        /**
                         * ProvisionAccountTicketRequest redirectUri.
                         * @member {string} redirectUri
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @instance
                         */
                        ProvisionAccountTicketRequest.prototype.redirectUri = "";
    
                        /**
                         * Creates a new ProvisionAccountTicketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest instance
                         */
                        ProvisionAccountTicketRequest.create = function create(properties) {
                            return new ProvisionAccountTicketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ProvisionAccountTicketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketRequest} message ProvisionAccountTicketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                $root.google.analytics.admin.v1alpha.Account.encode(message.account, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.redirectUri != null && Object.hasOwnProperty.call(message, "redirectUri"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.redirectUri);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ProvisionAccountTicketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketRequest} message ProvisionAccountTicketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ProvisionAccountTicketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.account = $root.google.analytics.admin.v1alpha.Account.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.redirectUri = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProvisionAccountTicketRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProvisionAccountTicketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.account != null && message.hasOwnProperty("account")) {
                                var error = $root.google.analytics.admin.v1alpha.Account.verify(message.account);
                                if (error)
                                    return "account." + error;
                            }
                            if (message.redirectUri != null && message.hasOwnProperty("redirectUri"))
                                if (!$util.isString(message.redirectUri))
                                    return "redirectUri: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ProvisionAccountTicketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest
                         */
                        ProvisionAccountTicketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ProvisionAccountTicketRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ProvisionAccountTicketRequest();
                            if (object.account != null) {
                                if (typeof object.account !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ProvisionAccountTicketRequest.account: object expected");
                                message.account = $root.google.analytics.admin.v1alpha.Account.fromObject(object.account);
                            }
                            if (object.redirectUri != null)
                                message.redirectUri = String(object.redirectUri);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProvisionAccountTicketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ProvisionAccountTicketRequest} message ProvisionAccountTicketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProvisionAccountTicketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.account = null;
                                object.redirectUri = "";
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = $root.google.analytics.admin.v1alpha.Account.toObject(message.account, options);
                            if (message.redirectUri != null && message.hasOwnProperty("redirectUri"))
                                object.redirectUri = message.redirectUri;
                            return object;
                        };
    
                        /**
                         * Converts this ProvisionAccountTicketRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProvisionAccountTicketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProvisionAccountTicketRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProvisionAccountTicketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ProvisionAccountTicketRequest";
                        };
    
                        return ProvisionAccountTicketRequest;
                    })();
    
                    v1alpha.ProvisionAccountTicketResponse = (function() {
    
                        /**
                         * Properties of a ProvisionAccountTicketResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IProvisionAccountTicketResponse
                         * @property {string|null} [accountTicketId] ProvisionAccountTicketResponse accountTicketId
                         */
    
                        /**
                         * Constructs a new ProvisionAccountTicketResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ProvisionAccountTicketResponse.
                         * @implements IProvisionAccountTicketResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketResponse=} [properties] Properties to set
                         */
                        function ProvisionAccountTicketResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProvisionAccountTicketResponse accountTicketId.
                         * @member {string} accountTicketId
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @instance
                         */
                        ProvisionAccountTicketResponse.prototype.accountTicketId = "";
    
                        /**
                         * Creates a new ProvisionAccountTicketResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse instance
                         */
                        ProvisionAccountTicketResponse.create = function create(properties) {
                            return new ProvisionAccountTicketResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ProvisionAccountTicketResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketResponse} message ProvisionAccountTicketResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accountTicketId != null && Object.hasOwnProperty.call(message, "accountTicketId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.accountTicketId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ProvisionAccountTicketResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProvisionAccountTicketResponse} message ProvisionAccountTicketResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ProvisionAccountTicketResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.accountTicketId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProvisionAccountTicketResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProvisionAccountTicketResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accountTicketId != null && message.hasOwnProperty("accountTicketId"))
                                if (!$util.isString(message.accountTicketId))
                                    return "accountTicketId: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ProvisionAccountTicketResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse
                         */
                        ProvisionAccountTicketResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ProvisionAccountTicketResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ProvisionAccountTicketResponse();
                            if (object.accountTicketId != null)
                                message.accountTicketId = String(object.accountTicketId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProvisionAccountTicketResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ProvisionAccountTicketResponse} message ProvisionAccountTicketResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProvisionAccountTicketResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.accountTicketId = "";
                            if (message.accountTicketId != null && message.hasOwnProperty("accountTicketId"))
                                object.accountTicketId = message.accountTicketId;
                            return object;
                        };
    
                        /**
                         * Converts this ProvisionAccountTicketResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProvisionAccountTicketResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProvisionAccountTicketResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ProvisionAccountTicketResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProvisionAccountTicketResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ProvisionAccountTicketResponse";
                        };
    
                        return ProvisionAccountTicketResponse;
                    })();
    
                    v1alpha.GetPropertyRequest = (function() {
    
                        /**
                         * Properties of a GetPropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetPropertyRequest
                         * @property {string|null} [name] GetPropertyRequest name
                         */
    
                        /**
                         * Constructs a new GetPropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetPropertyRequest.
                         * @implements IGetPropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetPropertyRequest=} [properties] Properties to set
                         */
                        function GetPropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetPropertyRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @instance
                         */
                        GetPropertyRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetPropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetPropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetPropertyRequest} GetPropertyRequest instance
                         */
                        GetPropertyRequest.create = function create(properties) {
                            return new GetPropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetPropertyRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetPropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetPropertyRequest} message GetPropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetPropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetPropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetPropertyRequest} message GetPropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetPropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetPropertyRequest} GetPropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetPropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetPropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetPropertyRequest} GetPropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetPropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetPropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetPropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetPropertyRequest} GetPropertyRequest
                         */
                        GetPropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetPropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetPropertyRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetPropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetPropertyRequest} message GetPropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetPropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetPropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetPropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetPropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetPropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetPropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetPropertyRequest";
                        };
    
                        return GetPropertyRequest;
                    })();
    
                    v1alpha.ListPropertiesRequest = (function() {
    
                        /**
                         * Properties of a ListPropertiesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListPropertiesRequest
                         * @property {string|null} [filter] ListPropertiesRequest filter
                         * @property {number|null} [pageSize] ListPropertiesRequest pageSize
                         * @property {string|null} [pageToken] ListPropertiesRequest pageToken
                         * @property {boolean|null} [showDeleted] ListPropertiesRequest showDeleted
                         */
    
                        /**
                         * Constructs a new ListPropertiesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListPropertiesRequest.
                         * @implements IListPropertiesRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListPropertiesRequest=} [properties] Properties to set
                         */
                        function ListPropertiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPropertiesRequest filter.
                         * @member {string} filter
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.filter = "";
    
                        /**
                         * ListPropertiesRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.pageSize = 0;
    
                        /**
                         * ListPropertiesRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.pageToken = "";
    
                        /**
                         * ListPropertiesRequest showDeleted.
                         * @member {boolean} showDeleted
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.showDeleted = false;
    
                        /**
                         * Creates a new ListPropertiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListPropertiesRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesRequest} ListPropertiesRequest instance
                         */
                        ListPropertiesRequest.create = function create(properties) {
                            return new ListPropertiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPropertiesRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListPropertiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListPropertiesRequest} message ListPropertiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.filter);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            if (message.showDeleted != null && Object.hasOwnProperty.call(message, "showDeleted"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.showDeleted);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPropertiesRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListPropertiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListPropertiesRequest} message ListPropertiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPropertiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesRequest} ListPropertiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListPropertiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.showDeleted = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPropertiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesRequest} ListPropertiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPropertiesRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPropertiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.filter != null && message.hasOwnProperty("filter"))
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                if (typeof message.showDeleted !== "boolean")
                                    return "showDeleted: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListPropertiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesRequest} ListPropertiesRequest
                         */
                        ListPropertiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListPropertiesRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListPropertiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.showDeleted != null)
                                message.showDeleted = Boolean(object.showDeleted);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPropertiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListPropertiesRequest} message ListPropertiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPropertiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.filter = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                                object.showDeleted = false;
                            }
                            if (message.filter != null && message.hasOwnProperty("filter"))
                                object.filter = message.filter;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                object.showDeleted = message.showDeleted;
                            return object;
                        };
    
                        /**
                         * Converts this ListPropertiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPropertiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPropertiesRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPropertiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListPropertiesRequest";
                        };
    
                        return ListPropertiesRequest;
                    })();
    
                    v1alpha.ListPropertiesResponse = (function() {
    
                        /**
                         * Properties of a ListPropertiesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListPropertiesResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IProperty>|null} [properties] ListPropertiesResponse properties
                         * @property {string|null} [nextPageToken] ListPropertiesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListPropertiesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListPropertiesResponse.
                         * @implements IListPropertiesResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListPropertiesResponse=} [properties] Properties to set
                         */
                        function ListPropertiesResponse(properties) {
                            this.properties = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPropertiesResponse properties.
                         * @member {Array.<google.analytics.admin.v1alpha.IProperty>} properties
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @instance
                         */
                        ListPropertiesResponse.prototype.properties = $util.emptyArray;
    
                        /**
                         * ListPropertiesResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @instance
                         */
                        ListPropertiesResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListPropertiesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListPropertiesResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesResponse} ListPropertiesResponse instance
                         */
                        ListPropertiesResponse.create = function create(properties) {
                            return new ListPropertiesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListPropertiesResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListPropertiesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListPropertiesResponse} message ListPropertiesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.properties != null && message.properties.length)
                                for (var i = 0; i < message.properties.length; ++i)
                                    $root.google.analytics.admin.v1alpha.Property.encode(message.properties[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPropertiesResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListPropertiesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListPropertiesResponse} message ListPropertiesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPropertiesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesResponse} ListPropertiesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListPropertiesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.properties && message.properties.length))
                                            message.properties = [];
                                        message.properties.push($root.google.analytics.admin.v1alpha.Property.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPropertiesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesResponse} ListPropertiesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPropertiesResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPropertiesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.properties != null && message.hasOwnProperty("properties")) {
                                if (!Array.isArray(message.properties))
                                    return "properties: array expected";
                                for (var i = 0; i < message.properties.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.Property.verify(message.properties[i]);
                                    if (error)
                                        return "properties." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListPropertiesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListPropertiesResponse} ListPropertiesResponse
                         */
                        ListPropertiesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListPropertiesResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListPropertiesResponse();
                            if (object.properties) {
                                if (!Array.isArray(object.properties))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListPropertiesResponse.properties: array expected");
                                message.properties = [];
                                for (var i = 0; i < object.properties.length; ++i) {
                                    if (typeof object.properties[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListPropertiesResponse.properties: object expected");
                                    message.properties[i] = $root.google.analytics.admin.v1alpha.Property.fromObject(object.properties[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPropertiesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListPropertiesResponse} message ListPropertiesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPropertiesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.properties = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.properties && message.properties.length) {
                                object.properties = [];
                                for (var j = 0; j < message.properties.length; ++j)
                                    object.properties[j] = $root.google.analytics.admin.v1alpha.Property.toObject(message.properties[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListPropertiesResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPropertiesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPropertiesResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListPropertiesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPropertiesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListPropertiesResponse";
                        };
    
                        return ListPropertiesResponse;
                    })();
    
                    v1alpha.UpdatePropertyRequest = (function() {
    
                        /**
                         * Properties of an UpdatePropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdatePropertyRequest
                         * @property {google.analytics.admin.v1alpha.IProperty|null} [property] UpdatePropertyRequest property
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdatePropertyRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdatePropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdatePropertyRequest.
                         * @implements IUpdatePropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdatePropertyRequest=} [properties] Properties to set
                         */
                        function UpdatePropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdatePropertyRequest property.
                         * @member {google.analytics.admin.v1alpha.IProperty|null|undefined} property
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @instance
                         */
                        UpdatePropertyRequest.prototype.property = null;
    
                        /**
                         * UpdatePropertyRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @instance
                         */
                        UpdatePropertyRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdatePropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdatePropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdatePropertyRequest} UpdatePropertyRequest instance
                         */
                        UpdatePropertyRequest.create = function create(properties) {
                            return new UpdatePropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdatePropertyRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdatePropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdatePropertyRequest} message UpdatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                $root.google.analytics.admin.v1alpha.Property.encode(message.property, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdatePropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdatePropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdatePropertyRequest} message UpdatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdatePropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdatePropertyRequest} UpdatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdatePropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = $root.google.analytics.admin.v1alpha.Property.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdatePropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdatePropertyRequest} UpdatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdatePropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdatePropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property")) {
                                var error = $root.google.analytics.admin.v1alpha.Property.verify(message.property);
                                if (error)
                                    return "property." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdatePropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdatePropertyRequest} UpdatePropertyRequest
                         */
                        UpdatePropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdatePropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdatePropertyRequest();
                            if (object.property != null) {
                                if (typeof object.property !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdatePropertyRequest.property: object expected");
                                message.property = $root.google.analytics.admin.v1alpha.Property.fromObject(object.property);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdatePropertyRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdatePropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdatePropertyRequest} message UpdatePropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdatePropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = null;
                                object.updateMask = null;
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = $root.google.analytics.admin.v1alpha.Property.toObject(message.property, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdatePropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdatePropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdatePropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdatePropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdatePropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdatePropertyRequest";
                        };
    
                        return UpdatePropertyRequest;
                    })();
    
                    v1alpha.CreatePropertyRequest = (function() {
    
                        /**
                         * Properties of a CreatePropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreatePropertyRequest
                         * @property {google.analytics.admin.v1alpha.IProperty|null} [property] CreatePropertyRequest property
                         */
    
                        /**
                         * Constructs a new CreatePropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreatePropertyRequest.
                         * @implements ICreatePropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreatePropertyRequest=} [properties] Properties to set
                         */
                        function CreatePropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreatePropertyRequest property.
                         * @member {google.analytics.admin.v1alpha.IProperty|null|undefined} property
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @instance
                         */
                        CreatePropertyRequest.prototype.property = null;
    
                        /**
                         * Creates a new CreatePropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreatePropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreatePropertyRequest} CreatePropertyRequest instance
                         */
                        CreatePropertyRequest.create = function create(properties) {
                            return new CreatePropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreatePropertyRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreatePropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreatePropertyRequest} message CreatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreatePropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                $root.google.analytics.admin.v1alpha.Property.encode(message.property, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreatePropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreatePropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreatePropertyRequest} message CreatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreatePropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreatePropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreatePropertyRequest} CreatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreatePropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreatePropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = $root.google.analytics.admin.v1alpha.Property.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreatePropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreatePropertyRequest} CreatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreatePropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreatePropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreatePropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property")) {
                                var error = $root.google.analytics.admin.v1alpha.Property.verify(message.property);
                                if (error)
                                    return "property." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreatePropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreatePropertyRequest} CreatePropertyRequest
                         */
                        CreatePropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreatePropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreatePropertyRequest();
                            if (object.property != null) {
                                if (typeof object.property !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreatePropertyRequest.property: object expected");
                                message.property = $root.google.analytics.admin.v1alpha.Property.fromObject(object.property);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreatePropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreatePropertyRequest} message CreatePropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreatePropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.property = null;
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = $root.google.analytics.admin.v1alpha.Property.toObject(message.property, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreatePropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreatePropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreatePropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreatePropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreatePropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreatePropertyRequest";
                        };
    
                        return CreatePropertyRequest;
                    })();
    
                    v1alpha.DeletePropertyRequest = (function() {
    
                        /**
                         * Properties of a DeletePropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeletePropertyRequest
                         * @property {string|null} [name] DeletePropertyRequest name
                         */
    
                        /**
                         * Constructs a new DeletePropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeletePropertyRequest.
                         * @implements IDeletePropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeletePropertyRequest=} [properties] Properties to set
                         */
                        function DeletePropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeletePropertyRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @instance
                         */
                        DeletePropertyRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeletePropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeletePropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeletePropertyRequest} DeletePropertyRequest instance
                         */
                        DeletePropertyRequest.create = function create(properties) {
                            return new DeletePropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeletePropertyRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeletePropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeletePropertyRequest} message DeletePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeletePropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeletePropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeletePropertyRequest} message DeletePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeletePropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeletePropertyRequest} DeletePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeletePropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeletePropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeletePropertyRequest} DeletePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeletePropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeletePropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeletePropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeletePropertyRequest} DeletePropertyRequest
                         */
                        DeletePropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeletePropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeletePropertyRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeletePropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeletePropertyRequest} message DeletePropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeletePropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeletePropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeletePropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeletePropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeletePropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeletePropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeletePropertyRequest";
                        };
    
                        return DeletePropertyRequest;
                    })();
    
                    v1alpha.GetUserLinkRequest = (function() {
    
                        /**
                         * Properties of a GetUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetUserLinkRequest
                         * @property {string|null} [name] GetUserLinkRequest name
                         */
    
                        /**
                         * Constructs a new GetUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetUserLinkRequest.
                         * @implements IGetUserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetUserLinkRequest=} [properties] Properties to set
                         */
                        function GetUserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetUserLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @instance
                         */
                        GetUserLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetUserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetUserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetUserLinkRequest} GetUserLinkRequest instance
                         */
                        GetUserLinkRequest.create = function create(properties) {
                            return new GetUserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetUserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetUserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetUserLinkRequest} message GetUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetUserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetUserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetUserLinkRequest} message GetUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetUserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetUserLinkRequest} GetUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetUserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetUserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetUserLinkRequest} GetUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetUserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetUserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetUserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetUserLinkRequest} GetUserLinkRequest
                         */
                        GetUserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetUserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetUserLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetUserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetUserLinkRequest} message GetUserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetUserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetUserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetUserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetUserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetUserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetUserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetUserLinkRequest";
                        };
    
                        return GetUserLinkRequest;
                    })();
    
                    v1alpha.BatchGetUserLinksRequest = (function() {
    
                        /**
                         * Properties of a BatchGetUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchGetUserLinksRequest
                         * @property {string|null} [parent] BatchGetUserLinksRequest parent
                         * @property {Array.<string>|null} [names] BatchGetUserLinksRequest names
                         */
    
                        /**
                         * Constructs a new BatchGetUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchGetUserLinksRequest.
                         * @implements IBatchGetUserLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksRequest=} [properties] Properties to set
                         */
                        function BatchGetUserLinksRequest(properties) {
                            this.names = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchGetUserLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @instance
                         */
                        BatchGetUserLinksRequest.prototype.parent = "";
    
                        /**
                         * BatchGetUserLinksRequest names.
                         * @member {Array.<string>} names
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @instance
                         */
                        BatchGetUserLinksRequest.prototype.names = $util.emptyArray;
    
                        /**
                         * Creates a new BatchGetUserLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksRequest} BatchGetUserLinksRequest instance
                         */
                        BatchGetUserLinksRequest.create = function create(properties) {
                            return new BatchGetUserLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchGetUserLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetUserLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksRequest} message BatchGetUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetUserLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.names != null && message.names.length)
                                for (var i = 0; i < message.names.length; ++i)
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.names[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchGetUserLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetUserLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksRequest} message BatchGetUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetUserLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchGetUserLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksRequest} BatchGetUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetUserLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchGetUserLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.names && message.names.length))
                                            message.names = [];
                                        message.names.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchGetUserLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksRequest} BatchGetUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetUserLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchGetUserLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchGetUserLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.names != null && message.hasOwnProperty("names")) {
                                if (!Array.isArray(message.names))
                                    return "names: array expected";
                                for (var i = 0; i < message.names.length; ++i)
                                    if (!$util.isString(message.names[i]))
                                        return "names: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchGetUserLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksRequest} BatchGetUserLinksRequest
                         */
                        BatchGetUserLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchGetUserLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchGetUserLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.names) {
                                if (!Array.isArray(object.names))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchGetUserLinksRequest.names: array expected");
                                message.names = [];
                                for (var i = 0; i < object.names.length; ++i)
                                    message.names[i] = String(object.names[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchGetUserLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchGetUserLinksRequest} message BatchGetUserLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchGetUserLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.names = [];
                            if (options.defaults)
                                object.parent = "";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.names && message.names.length) {
                                object.names = [];
                                for (var j = 0; j < message.names.length; ++j)
                                    object.names[j] = message.names[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchGetUserLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchGetUserLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchGetUserLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchGetUserLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchGetUserLinksRequest";
                        };
    
                        return BatchGetUserLinksRequest;
                    })();
    
                    v1alpha.BatchGetUserLinksResponse = (function() {
    
                        /**
                         * Properties of a BatchGetUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchGetUserLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IUserLink>|null} [userLinks] BatchGetUserLinksResponse userLinks
                         */
    
                        /**
                         * Constructs a new BatchGetUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchGetUserLinksResponse.
                         * @implements IBatchGetUserLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksResponse=} [properties] Properties to set
                         */
                        function BatchGetUserLinksResponse(properties) {
                            this.userLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchGetUserLinksResponse userLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IUserLink>} userLinks
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @instance
                         */
                        BatchGetUserLinksResponse.prototype.userLinks = $util.emptyArray;
    
                        /**
                         * Creates a new BatchGetUserLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksResponse} BatchGetUserLinksResponse instance
                         */
                        BatchGetUserLinksResponse.create = function create(properties) {
                            return new BatchGetUserLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified BatchGetUserLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetUserLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksResponse} message BatchGetUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetUserLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userLinks != null && message.userLinks.length)
                                for (var i = 0; i < message.userLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.UserLink.encode(message.userLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchGetUserLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetUserLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetUserLinksResponse} message BatchGetUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetUserLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchGetUserLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksResponse} BatchGetUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetUserLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchGetUserLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.userLinks && message.userLinks.length))
                                            message.userLinks = [];
                                        message.userLinks.push($root.google.analytics.admin.v1alpha.UserLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchGetUserLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksResponse} BatchGetUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetUserLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchGetUserLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchGetUserLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userLinks != null && message.hasOwnProperty("userLinks")) {
                                if (!Array.isArray(message.userLinks))
                                    return "userLinks: array expected";
                                for (var i = 0; i < message.userLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.UserLink.verify(message.userLinks[i]);
                                    if (error)
                                        return "userLinks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchGetUserLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchGetUserLinksResponse} BatchGetUserLinksResponse
                         */
                        BatchGetUserLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchGetUserLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchGetUserLinksResponse();
                            if (object.userLinks) {
                                if (!Array.isArray(object.userLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchGetUserLinksResponse.userLinks: array expected");
                                message.userLinks = [];
                                for (var i = 0; i < object.userLinks.length; ++i) {
                                    if (typeof object.userLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchGetUserLinksResponse.userLinks: object expected");
                                    message.userLinks[i] = $root.google.analytics.admin.v1alpha.UserLink.fromObject(object.userLinks[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchGetUserLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchGetUserLinksResponse} message BatchGetUserLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchGetUserLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.userLinks = [];
                            if (message.userLinks && message.userLinks.length) {
                                object.userLinks = [];
                                for (var j = 0; j < message.userLinks.length; ++j)
                                    object.userLinks[j] = $root.google.analytics.admin.v1alpha.UserLink.toObject(message.userLinks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchGetUserLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchGetUserLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchGetUserLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchGetUserLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchGetUserLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchGetUserLinksResponse";
                        };
    
                        return BatchGetUserLinksResponse;
                    })();
    
                    v1alpha.ListUserLinksRequest = (function() {
    
                        /**
                         * Properties of a ListUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListUserLinksRequest
                         * @property {string|null} [parent] ListUserLinksRequest parent
                         * @property {number|null} [pageSize] ListUserLinksRequest pageSize
                         * @property {string|null} [pageToken] ListUserLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListUserLinksRequest.
                         * @implements IListUserLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListUserLinksRequest=} [properties] Properties to set
                         */
                        function ListUserLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListUserLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @instance
                         */
                        ListUserLinksRequest.prototype.parent = "";
    
                        /**
                         * ListUserLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @instance
                         */
                        ListUserLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListUserLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @instance
                         */
                        ListUserLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListUserLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListUserLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksRequest} ListUserLinksRequest instance
                         */
                        ListUserLinksRequest.create = function create(properties) {
                            return new ListUserLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListUserLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListUserLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListUserLinksRequest} message ListUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUserLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListUserLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListUserLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListUserLinksRequest} message ListUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUserLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListUserLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksRequest} ListUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUserLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListUserLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListUserLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksRequest} ListUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUserLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListUserLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListUserLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListUserLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksRequest} ListUserLinksRequest
                         */
                        ListUserLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListUserLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListUserLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListUserLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListUserLinksRequest} message ListUserLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListUserLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListUserLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListUserLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListUserLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListUserLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListUserLinksRequest";
                        };
    
                        return ListUserLinksRequest;
                    })();
    
                    v1alpha.ListUserLinksResponse = (function() {
    
                        /**
                         * Properties of a ListUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListUserLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IUserLink>|null} [userLinks] ListUserLinksResponse userLinks
                         * @property {string|null} [nextPageToken] ListUserLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListUserLinksResponse.
                         * @implements IListUserLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListUserLinksResponse=} [properties] Properties to set
                         */
                        function ListUserLinksResponse(properties) {
                            this.userLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListUserLinksResponse userLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IUserLink>} userLinks
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @instance
                         */
                        ListUserLinksResponse.prototype.userLinks = $util.emptyArray;
    
                        /**
                         * ListUserLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @instance
                         */
                        ListUserLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListUserLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListUserLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksResponse} ListUserLinksResponse instance
                         */
                        ListUserLinksResponse.create = function create(properties) {
                            return new ListUserLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListUserLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListUserLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListUserLinksResponse} message ListUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUserLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userLinks != null && message.userLinks.length)
                                for (var i = 0; i < message.userLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.UserLink.encode(message.userLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListUserLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListUserLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListUserLinksResponse} message ListUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUserLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListUserLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksResponse} ListUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUserLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListUserLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.userLinks && message.userLinks.length))
                                            message.userLinks = [];
                                        message.userLinks.push($root.google.analytics.admin.v1alpha.UserLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListUserLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksResponse} ListUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUserLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListUserLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListUserLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userLinks != null && message.hasOwnProperty("userLinks")) {
                                if (!Array.isArray(message.userLinks))
                                    return "userLinks: array expected";
                                for (var i = 0; i < message.userLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.UserLink.verify(message.userLinks[i]);
                                    if (error)
                                        return "userLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListUserLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListUserLinksResponse} ListUserLinksResponse
                         */
                        ListUserLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListUserLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListUserLinksResponse();
                            if (object.userLinks) {
                                if (!Array.isArray(object.userLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListUserLinksResponse.userLinks: array expected");
                                message.userLinks = [];
                                for (var i = 0; i < object.userLinks.length; ++i) {
                                    if (typeof object.userLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListUserLinksResponse.userLinks: object expected");
                                    message.userLinks[i] = $root.google.analytics.admin.v1alpha.UserLink.fromObject(object.userLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListUserLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListUserLinksResponse} message ListUserLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListUserLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.userLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.userLinks && message.userLinks.length) {
                                object.userLinks = [];
                                for (var j = 0; j < message.userLinks.length; ++j)
                                    object.userLinks[j] = $root.google.analytics.admin.v1alpha.UserLink.toObject(message.userLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListUserLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListUserLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListUserLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListUserLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListUserLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListUserLinksResponse";
                        };
    
                        return ListUserLinksResponse;
                    })();
    
                    v1alpha.AuditUserLinksRequest = (function() {
    
                        /**
                         * Properties of an AuditUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAuditUserLinksRequest
                         * @property {string|null} [parent] AuditUserLinksRequest parent
                         * @property {number|null} [pageSize] AuditUserLinksRequest pageSize
                         * @property {string|null} [pageToken] AuditUserLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new AuditUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AuditUserLinksRequest.
                         * @implements IAuditUserLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksRequest=} [properties] Properties to set
                         */
                        function AuditUserLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AuditUserLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @instance
                         */
                        AuditUserLinksRequest.prototype.parent = "";
    
                        /**
                         * AuditUserLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @instance
                         */
                        AuditUserLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * AuditUserLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @instance
                         */
                        AuditUserLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new AuditUserLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksRequest} AuditUserLinksRequest instance
                         */
                        AuditUserLinksRequest.create = function create(properties) {
                            return new AuditUserLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AuditUserLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.AuditUserLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksRequest} message AuditUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditUserLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AuditUserLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AuditUserLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksRequest} message AuditUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditUserLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AuditUserLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksRequest} AuditUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditUserLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AuditUserLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AuditUserLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksRequest} AuditUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditUserLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AuditUserLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuditUserLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AuditUserLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksRequest} AuditUserLinksRequest
                         */
                        AuditUserLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AuditUserLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AuditUserLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AuditUserLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.AuditUserLinksRequest} message AuditUserLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuditUserLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this AuditUserLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuditUserLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AuditUserLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AuditUserLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AuditUserLinksRequest";
                        };
    
                        return AuditUserLinksRequest;
                    })();
    
                    v1alpha.AuditUserLinksResponse = (function() {
    
                        /**
                         * Properties of an AuditUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAuditUserLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAuditUserLink>|null} [userLinks] AuditUserLinksResponse userLinks
                         * @property {string|null} [nextPageToken] AuditUserLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new AuditUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AuditUserLinksResponse.
                         * @implements IAuditUserLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksResponse=} [properties] Properties to set
                         */
                        function AuditUserLinksResponse(properties) {
                            this.userLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AuditUserLinksResponse userLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IAuditUserLink>} userLinks
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @instance
                         */
                        AuditUserLinksResponse.prototype.userLinks = $util.emptyArray;
    
                        /**
                         * AuditUserLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @instance
                         */
                        AuditUserLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new AuditUserLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksResponse} AuditUserLinksResponse instance
                         */
                        AuditUserLinksResponse.create = function create(properties) {
                            return new AuditUserLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified AuditUserLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.AuditUserLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksResponse} message AuditUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditUserLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userLinks != null && message.userLinks.length)
                                for (var i = 0; i < message.userLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AuditUserLink.encode(message.userLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AuditUserLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AuditUserLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLinksResponse} message AuditUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditUserLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AuditUserLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksResponse} AuditUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditUserLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AuditUserLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.userLinks && message.userLinks.length))
                                            message.userLinks = [];
                                        message.userLinks.push($root.google.analytics.admin.v1alpha.AuditUserLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AuditUserLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksResponse} AuditUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditUserLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AuditUserLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuditUserLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userLinks != null && message.hasOwnProperty("userLinks")) {
                                if (!Array.isArray(message.userLinks))
                                    return "userLinks: array expected";
                                for (var i = 0; i < message.userLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AuditUserLink.verify(message.userLinks[i]);
                                    if (error)
                                        return "userLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AuditUserLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AuditUserLinksResponse} AuditUserLinksResponse
                         */
                        AuditUserLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AuditUserLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AuditUserLinksResponse();
                            if (object.userLinks) {
                                if (!Array.isArray(object.userLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.AuditUserLinksResponse.userLinks: array expected");
                                message.userLinks = [];
                                for (var i = 0; i < object.userLinks.length; ++i) {
                                    if (typeof object.userLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AuditUserLinksResponse.userLinks: object expected");
                                    message.userLinks[i] = $root.google.analytics.admin.v1alpha.AuditUserLink.fromObject(object.userLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AuditUserLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.AuditUserLinksResponse} message AuditUserLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuditUserLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.userLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.userLinks && message.userLinks.length) {
                                object.userLinks = [];
                                for (var j = 0; j < message.userLinks.length; ++j)
                                    object.userLinks[j] = $root.google.analytics.admin.v1alpha.AuditUserLink.toObject(message.userLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this AuditUserLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuditUserLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AuditUserLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AuditUserLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AuditUserLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AuditUserLinksResponse";
                        };
    
                        return AuditUserLinksResponse;
                    })();
    
                    v1alpha.CreateUserLinkRequest = (function() {
    
                        /**
                         * Properties of a CreateUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateUserLinkRequest
                         * @property {string|null} [parent] CreateUserLinkRequest parent
                         * @property {boolean|null} [notifyNewUser] CreateUserLinkRequest notifyNewUser
                         * @property {google.analytics.admin.v1alpha.IUserLink|null} [userLink] CreateUserLinkRequest userLink
                         */
    
                        /**
                         * Constructs a new CreateUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateUserLinkRequest.
                         * @implements ICreateUserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateUserLinkRequest=} [properties] Properties to set
                         */
                        function CreateUserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateUserLinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @instance
                         */
                        CreateUserLinkRequest.prototype.parent = "";
    
                        /**
                         * CreateUserLinkRequest notifyNewUser.
                         * @member {boolean} notifyNewUser
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @instance
                         */
                        CreateUserLinkRequest.prototype.notifyNewUser = false;
    
                        /**
                         * CreateUserLinkRequest userLink.
                         * @member {google.analytics.admin.v1alpha.IUserLink|null|undefined} userLink
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @instance
                         */
                        CreateUserLinkRequest.prototype.userLink = null;
    
                        /**
                         * Creates a new CreateUserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateUserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateUserLinkRequest} CreateUserLinkRequest instance
                         */
                        CreateUserLinkRequest.create = function create(properties) {
                            return new CreateUserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateUserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateUserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateUserLinkRequest} message CreateUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateUserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.notifyNewUser != null && Object.hasOwnProperty.call(message, "notifyNewUser"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.notifyNewUser);
                            if (message.userLink != null && Object.hasOwnProperty.call(message, "userLink"))
                                $root.google.analytics.admin.v1alpha.UserLink.encode(message.userLink, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateUserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateUserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateUserLinkRequest} message CreateUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateUserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateUserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateUserLinkRequest} CreateUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateUserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateUserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.notifyNewUser = reader.bool();
                                        break;
                                    }
                                case 3: {
                                        message.userLink = $root.google.analytics.admin.v1alpha.UserLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateUserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateUserLinkRequest} CreateUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateUserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateUserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateUserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.notifyNewUser != null && message.hasOwnProperty("notifyNewUser"))
                                if (typeof message.notifyNewUser !== "boolean")
                                    return "notifyNewUser: boolean expected";
                            if (message.userLink != null && message.hasOwnProperty("userLink")) {
                                var error = $root.google.analytics.admin.v1alpha.UserLink.verify(message.userLink);
                                if (error)
                                    return "userLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateUserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateUserLinkRequest} CreateUserLinkRequest
                         */
                        CreateUserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateUserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateUserLinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.notifyNewUser != null)
                                message.notifyNewUser = Boolean(object.notifyNewUser);
                            if (object.userLink != null) {
                                if (typeof object.userLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateUserLinkRequest.userLink: object expected");
                                message.userLink = $root.google.analytics.admin.v1alpha.UserLink.fromObject(object.userLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateUserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateUserLinkRequest} message CreateUserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateUserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.notifyNewUser = false;
                                object.userLink = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.notifyNewUser != null && message.hasOwnProperty("notifyNewUser"))
                                object.notifyNewUser = message.notifyNewUser;
                            if (message.userLink != null && message.hasOwnProperty("userLink"))
                                object.userLink = $root.google.analytics.admin.v1alpha.UserLink.toObject(message.userLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateUserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateUserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateUserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateUserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateUserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateUserLinkRequest";
                        };
    
                        return CreateUserLinkRequest;
                    })();
    
                    v1alpha.BatchCreateUserLinksRequest = (function() {
    
                        /**
                         * Properties of a BatchCreateUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchCreateUserLinksRequest
                         * @property {string|null} [parent] BatchCreateUserLinksRequest parent
                         * @property {boolean|null} [notifyNewUsers] BatchCreateUserLinksRequest notifyNewUsers
                         * @property {Array.<google.analytics.admin.v1alpha.ICreateUserLinkRequest>|null} [requests] BatchCreateUserLinksRequest requests
                         */
    
                        /**
                         * Constructs a new BatchCreateUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchCreateUserLinksRequest.
                         * @implements IBatchCreateUserLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksRequest=} [properties] Properties to set
                         */
                        function BatchCreateUserLinksRequest(properties) {
                            this.requests = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchCreateUserLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @instance
                         */
                        BatchCreateUserLinksRequest.prototype.parent = "";
    
                        /**
                         * BatchCreateUserLinksRequest notifyNewUsers.
                         * @member {boolean} notifyNewUsers
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @instance
                         */
                        BatchCreateUserLinksRequest.prototype.notifyNewUsers = false;
    
                        /**
                         * BatchCreateUserLinksRequest requests.
                         * @member {Array.<google.analytics.admin.v1alpha.ICreateUserLinkRequest>} requests
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @instance
                         */
                        BatchCreateUserLinksRequest.prototype.requests = $util.emptyArray;
    
                        /**
                         * Creates a new BatchCreateUserLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksRequest} BatchCreateUserLinksRequest instance
                         */
                        BatchCreateUserLinksRequest.create = function create(properties) {
                            return new BatchCreateUserLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchCreateUserLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateUserLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksRequest} message BatchCreateUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateUserLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.notifyNewUsers != null && Object.hasOwnProperty.call(message, "notifyNewUsers"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.notifyNewUsers);
                            if (message.requests != null && message.requests.length)
                                for (var i = 0; i < message.requests.length; ++i)
                                    $root.google.analytics.admin.v1alpha.CreateUserLinkRequest.encode(message.requests[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchCreateUserLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateUserLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksRequest} message BatchCreateUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateUserLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchCreateUserLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksRequest} BatchCreateUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateUserLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchCreateUserLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.notifyNewUsers = reader.bool();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.requests && message.requests.length))
                                            message.requests = [];
                                        message.requests.push($root.google.analytics.admin.v1alpha.CreateUserLinkRequest.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchCreateUserLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksRequest} BatchCreateUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateUserLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchCreateUserLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchCreateUserLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.notifyNewUsers != null && message.hasOwnProperty("notifyNewUsers"))
                                if (typeof message.notifyNewUsers !== "boolean")
                                    return "notifyNewUsers: boolean expected";
                            if (message.requests != null && message.hasOwnProperty("requests")) {
                                if (!Array.isArray(message.requests))
                                    return "requests: array expected";
                                for (var i = 0; i < message.requests.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.CreateUserLinkRequest.verify(message.requests[i]);
                                    if (error)
                                        return "requests." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchCreateUserLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksRequest} BatchCreateUserLinksRequest
                         */
                        BatchCreateUserLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchCreateUserLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchCreateUserLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.notifyNewUsers != null)
                                message.notifyNewUsers = Boolean(object.notifyNewUsers);
                            if (object.requests) {
                                if (!Array.isArray(object.requests))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchCreateUserLinksRequest.requests: array expected");
                                message.requests = [];
                                for (var i = 0; i < object.requests.length; ++i) {
                                    if (typeof object.requests[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchCreateUserLinksRequest.requests: object expected");
                                    message.requests[i] = $root.google.analytics.admin.v1alpha.CreateUserLinkRequest.fromObject(object.requests[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchCreateUserLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchCreateUserLinksRequest} message BatchCreateUserLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchCreateUserLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.requests = [];
                            if (options.defaults) {
                                object.parent = "";
                                object.notifyNewUsers = false;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.notifyNewUsers != null && message.hasOwnProperty("notifyNewUsers"))
                                object.notifyNewUsers = message.notifyNewUsers;
                            if (message.requests && message.requests.length) {
                                object.requests = [];
                                for (var j = 0; j < message.requests.length; ++j)
                                    object.requests[j] = $root.google.analytics.admin.v1alpha.CreateUserLinkRequest.toObject(message.requests[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchCreateUserLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchCreateUserLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchCreateUserLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchCreateUserLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchCreateUserLinksRequest";
                        };
    
                        return BatchCreateUserLinksRequest;
                    })();
    
                    v1alpha.BatchCreateUserLinksResponse = (function() {
    
                        /**
                         * Properties of a BatchCreateUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchCreateUserLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IUserLink>|null} [userLinks] BatchCreateUserLinksResponse userLinks
                         */
    
                        /**
                         * Constructs a new BatchCreateUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchCreateUserLinksResponse.
                         * @implements IBatchCreateUserLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksResponse=} [properties] Properties to set
                         */
                        function BatchCreateUserLinksResponse(properties) {
                            this.userLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchCreateUserLinksResponse userLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IUserLink>} userLinks
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @instance
                         */
                        BatchCreateUserLinksResponse.prototype.userLinks = $util.emptyArray;
    
                        /**
                         * Creates a new BatchCreateUserLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksResponse} BatchCreateUserLinksResponse instance
                         */
                        BatchCreateUserLinksResponse.create = function create(properties) {
                            return new BatchCreateUserLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified BatchCreateUserLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateUserLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksResponse} message BatchCreateUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateUserLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userLinks != null && message.userLinks.length)
                                for (var i = 0; i < message.userLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.UserLink.encode(message.userLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchCreateUserLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateUserLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateUserLinksResponse} message BatchCreateUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateUserLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchCreateUserLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksResponse} BatchCreateUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateUserLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchCreateUserLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.userLinks && message.userLinks.length))
                                            message.userLinks = [];
                                        message.userLinks.push($root.google.analytics.admin.v1alpha.UserLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchCreateUserLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksResponse} BatchCreateUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateUserLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchCreateUserLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchCreateUserLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userLinks != null && message.hasOwnProperty("userLinks")) {
                                if (!Array.isArray(message.userLinks))
                                    return "userLinks: array expected";
                                for (var i = 0; i < message.userLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.UserLink.verify(message.userLinks[i]);
                                    if (error)
                                        return "userLinks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchCreateUserLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchCreateUserLinksResponse} BatchCreateUserLinksResponse
                         */
                        BatchCreateUserLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchCreateUserLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchCreateUserLinksResponse();
                            if (object.userLinks) {
                                if (!Array.isArray(object.userLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchCreateUserLinksResponse.userLinks: array expected");
                                message.userLinks = [];
                                for (var i = 0; i < object.userLinks.length; ++i) {
                                    if (typeof object.userLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchCreateUserLinksResponse.userLinks: object expected");
                                    message.userLinks[i] = $root.google.analytics.admin.v1alpha.UserLink.fromObject(object.userLinks[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchCreateUserLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchCreateUserLinksResponse} message BatchCreateUserLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchCreateUserLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.userLinks = [];
                            if (message.userLinks && message.userLinks.length) {
                                object.userLinks = [];
                                for (var j = 0; j < message.userLinks.length; ++j)
                                    object.userLinks[j] = $root.google.analytics.admin.v1alpha.UserLink.toObject(message.userLinks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchCreateUserLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchCreateUserLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchCreateUserLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchCreateUserLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchCreateUserLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchCreateUserLinksResponse";
                        };
    
                        return BatchCreateUserLinksResponse;
                    })();
    
                    v1alpha.UpdateUserLinkRequest = (function() {
    
                        /**
                         * Properties of an UpdateUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateUserLinkRequest
                         * @property {google.analytics.admin.v1alpha.IUserLink|null} [userLink] UpdateUserLinkRequest userLink
                         */
    
                        /**
                         * Constructs a new UpdateUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateUserLinkRequest.
                         * @implements IUpdateUserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateUserLinkRequest=} [properties] Properties to set
                         */
                        function UpdateUserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateUserLinkRequest userLink.
                         * @member {google.analytics.admin.v1alpha.IUserLink|null|undefined} userLink
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @instance
                         */
                        UpdateUserLinkRequest.prototype.userLink = null;
    
                        /**
                         * Creates a new UpdateUserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateUserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateUserLinkRequest} UpdateUserLinkRequest instance
                         */
                        UpdateUserLinkRequest.create = function create(properties) {
                            return new UpdateUserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateUserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateUserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateUserLinkRequest} message UpdateUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateUserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userLink != null && Object.hasOwnProperty.call(message, "userLink"))
                                $root.google.analytics.admin.v1alpha.UserLink.encode(message.userLink, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateUserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateUserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateUserLinkRequest} message UpdateUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateUserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateUserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateUserLinkRequest} UpdateUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateUserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.userLink = $root.google.analytics.admin.v1alpha.UserLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateUserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateUserLinkRequest} UpdateUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateUserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateUserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateUserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userLink != null && message.hasOwnProperty("userLink")) {
                                var error = $root.google.analytics.admin.v1alpha.UserLink.verify(message.userLink);
                                if (error)
                                    return "userLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateUserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateUserLinkRequest} UpdateUserLinkRequest
                         */
                        UpdateUserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest();
                            if (object.userLink != null) {
                                if (typeof object.userLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateUserLinkRequest.userLink: object expected");
                                message.userLink = $root.google.analytics.admin.v1alpha.UserLink.fromObject(object.userLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateUserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateUserLinkRequest} message UpdateUserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateUserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.userLink = null;
                            if (message.userLink != null && message.hasOwnProperty("userLink"))
                                object.userLink = $root.google.analytics.admin.v1alpha.UserLink.toObject(message.userLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateUserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateUserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateUserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateUserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateUserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateUserLinkRequest";
                        };
    
                        return UpdateUserLinkRequest;
                    })();
    
                    v1alpha.BatchUpdateUserLinksRequest = (function() {
    
                        /**
                         * Properties of a BatchUpdateUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchUpdateUserLinksRequest
                         * @property {string|null} [parent] BatchUpdateUserLinksRequest parent
                         * @property {Array.<google.analytics.admin.v1alpha.IUpdateUserLinkRequest>|null} [requests] BatchUpdateUserLinksRequest requests
                         */
    
                        /**
                         * Constructs a new BatchUpdateUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchUpdateUserLinksRequest.
                         * @implements IBatchUpdateUserLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksRequest=} [properties] Properties to set
                         */
                        function BatchUpdateUserLinksRequest(properties) {
                            this.requests = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchUpdateUserLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @instance
                         */
                        BatchUpdateUserLinksRequest.prototype.parent = "";
    
                        /**
                         * BatchUpdateUserLinksRequest requests.
                         * @member {Array.<google.analytics.admin.v1alpha.IUpdateUserLinkRequest>} requests
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @instance
                         */
                        BatchUpdateUserLinksRequest.prototype.requests = $util.emptyArray;
    
                        /**
                         * Creates a new BatchUpdateUserLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest} BatchUpdateUserLinksRequest instance
                         */
                        BatchUpdateUserLinksRequest.create = function create(properties) {
                            return new BatchUpdateUserLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchUpdateUserLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksRequest} message BatchUpdateUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateUserLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.requests != null && message.requests.length)
                                for (var i = 0; i < message.requests.length; ++i)
                                    $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest.encode(message.requests[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchUpdateUserLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksRequest} message BatchUpdateUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateUserLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchUpdateUserLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest} BatchUpdateUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateUserLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.requests && message.requests.length))
                                            message.requests = [];
                                        message.requests.push($root.google.analytics.admin.v1alpha.UpdateUserLinkRequest.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchUpdateUserLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest} BatchUpdateUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateUserLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchUpdateUserLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchUpdateUserLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.requests != null && message.hasOwnProperty("requests")) {
                                if (!Array.isArray(message.requests))
                                    return "requests: array expected";
                                for (var i = 0; i < message.requests.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest.verify(message.requests[i]);
                                    if (error)
                                        return "requests." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchUpdateUserLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest} BatchUpdateUserLinksRequest
                         */
                        BatchUpdateUserLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.requests) {
                                if (!Array.isArray(object.requests))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest.requests: array expected");
                                message.requests = [];
                                for (var i = 0; i < object.requests.length; ++i) {
                                    if (typeof object.requests[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest.requests: object expected");
                                    message.requests[i] = $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest.fromObject(object.requests[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchUpdateUserLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest} message BatchUpdateUserLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchUpdateUserLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.requests = [];
                            if (options.defaults)
                                object.parent = "";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.requests && message.requests.length) {
                                object.requests = [];
                                for (var j = 0; j < message.requests.length; ++j)
                                    object.requests[j] = $root.google.analytics.admin.v1alpha.UpdateUserLinkRequest.toObject(message.requests[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchUpdateUserLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchUpdateUserLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchUpdateUserLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchUpdateUserLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchUpdateUserLinksRequest";
                        };
    
                        return BatchUpdateUserLinksRequest;
                    })();
    
                    v1alpha.BatchUpdateUserLinksResponse = (function() {
    
                        /**
                         * Properties of a BatchUpdateUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchUpdateUserLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IUserLink>|null} [userLinks] BatchUpdateUserLinksResponse userLinks
                         */
    
                        /**
                         * Constructs a new BatchUpdateUserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchUpdateUserLinksResponse.
                         * @implements IBatchUpdateUserLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksResponse=} [properties] Properties to set
                         */
                        function BatchUpdateUserLinksResponse(properties) {
                            this.userLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchUpdateUserLinksResponse userLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IUserLink>} userLinks
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @instance
                         */
                        BatchUpdateUserLinksResponse.prototype.userLinks = $util.emptyArray;
    
                        /**
                         * Creates a new BatchUpdateUserLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse} BatchUpdateUserLinksResponse instance
                         */
                        BatchUpdateUserLinksResponse.create = function create(properties) {
                            return new BatchUpdateUserLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified BatchUpdateUserLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksResponse} message BatchUpdateUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateUserLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.userLinks != null && message.userLinks.length)
                                for (var i = 0; i < message.userLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.UserLink.encode(message.userLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchUpdateUserLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateUserLinksResponse} message BatchUpdateUserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateUserLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchUpdateUserLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse} BatchUpdateUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateUserLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.userLinks && message.userLinks.length))
                                            message.userLinks = [];
                                        message.userLinks.push($root.google.analytics.admin.v1alpha.UserLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchUpdateUserLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse} BatchUpdateUserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateUserLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchUpdateUserLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchUpdateUserLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.userLinks != null && message.hasOwnProperty("userLinks")) {
                                if (!Array.isArray(message.userLinks))
                                    return "userLinks: array expected";
                                for (var i = 0; i < message.userLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.UserLink.verify(message.userLinks[i]);
                                    if (error)
                                        return "userLinks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchUpdateUserLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse} BatchUpdateUserLinksResponse
                         */
                        BatchUpdateUserLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse();
                            if (object.userLinks) {
                                if (!Array.isArray(object.userLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse.userLinks: array expected");
                                message.userLinks = [];
                                for (var i = 0; i < object.userLinks.length; ++i) {
                                    if (typeof object.userLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse.userLinks: object expected");
                                    message.userLinks[i] = $root.google.analytics.admin.v1alpha.UserLink.fromObject(object.userLinks[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchUpdateUserLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse} message BatchUpdateUserLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchUpdateUserLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.userLinks = [];
                            if (message.userLinks && message.userLinks.length) {
                                object.userLinks = [];
                                for (var j = 0; j < message.userLinks.length; ++j)
                                    object.userLinks[j] = $root.google.analytics.admin.v1alpha.UserLink.toObject(message.userLinks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchUpdateUserLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchUpdateUserLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchUpdateUserLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchUpdateUserLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchUpdateUserLinksResponse";
                        };
    
                        return BatchUpdateUserLinksResponse;
                    })();
    
                    v1alpha.DeleteUserLinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteUserLinkRequest
                         * @property {string|null} [name] DeleteUserLinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteUserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteUserLinkRequest.
                         * @implements IDeleteUserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteUserLinkRequest=} [properties] Properties to set
                         */
                        function DeleteUserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteUserLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @instance
                         */
                        DeleteUserLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteUserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteUserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteUserLinkRequest} DeleteUserLinkRequest instance
                         */
                        DeleteUserLinkRequest.create = function create(properties) {
                            return new DeleteUserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteUserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteUserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteUserLinkRequest} message DeleteUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteUserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteUserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteUserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteUserLinkRequest} message DeleteUserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteUserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteUserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteUserLinkRequest} DeleteUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteUserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteUserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteUserLinkRequest} DeleteUserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteUserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteUserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteUserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteUserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteUserLinkRequest} DeleteUserLinkRequest
                         */
                        DeleteUserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteUserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteUserLinkRequest} message DeleteUserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteUserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteUserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteUserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteUserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteUserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteUserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteUserLinkRequest";
                        };
    
                        return DeleteUserLinkRequest;
                    })();
    
                    v1alpha.BatchDeleteUserLinksRequest = (function() {
    
                        /**
                         * Properties of a BatchDeleteUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchDeleteUserLinksRequest
                         * @property {string|null} [parent] BatchDeleteUserLinksRequest parent
                         * @property {Array.<google.analytics.admin.v1alpha.IDeleteUserLinkRequest>|null} [requests] BatchDeleteUserLinksRequest requests
                         */
    
                        /**
                         * Constructs a new BatchDeleteUserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchDeleteUserLinksRequest.
                         * @implements IBatchDeleteUserLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteUserLinksRequest=} [properties] Properties to set
                         */
                        function BatchDeleteUserLinksRequest(properties) {
                            this.requests = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchDeleteUserLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @instance
                         */
                        BatchDeleteUserLinksRequest.prototype.parent = "";
    
                        /**
                         * BatchDeleteUserLinksRequest requests.
                         * @member {Array.<google.analytics.admin.v1alpha.IDeleteUserLinkRequest>} requests
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @instance
                         */
                        BatchDeleteUserLinksRequest.prototype.requests = $util.emptyArray;
    
                        /**
                         * Creates a new BatchDeleteUserLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteUserLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest} BatchDeleteUserLinksRequest instance
                         */
                        BatchDeleteUserLinksRequest.create = function create(properties) {
                            return new BatchDeleteUserLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchDeleteUserLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteUserLinksRequest} message BatchDeleteUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchDeleteUserLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.requests != null && message.requests.length)
                                for (var i = 0; i < message.requests.length; ++i)
                                    $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest.encode(message.requests[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchDeleteUserLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteUserLinksRequest} message BatchDeleteUserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchDeleteUserLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchDeleteUserLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest} BatchDeleteUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchDeleteUserLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.requests && message.requests.length))
                                            message.requests = [];
                                        message.requests.push($root.google.analytics.admin.v1alpha.DeleteUserLinkRequest.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchDeleteUserLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest} BatchDeleteUserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchDeleteUserLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchDeleteUserLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchDeleteUserLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.requests != null && message.hasOwnProperty("requests")) {
                                if (!Array.isArray(message.requests))
                                    return "requests: array expected";
                                for (var i = 0; i < message.requests.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest.verify(message.requests[i]);
                                    if (error)
                                        return "requests." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchDeleteUserLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest} BatchDeleteUserLinksRequest
                         */
                        BatchDeleteUserLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.requests) {
                                if (!Array.isArray(object.requests))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest.requests: array expected");
                                message.requests = [];
                                for (var i = 0; i < object.requests.length; ++i) {
                                    if (typeof object.requests[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest.requests: object expected");
                                    message.requests[i] = $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest.fromObject(object.requests[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchDeleteUserLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest} message BatchDeleteUserLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchDeleteUserLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.requests = [];
                            if (options.defaults)
                                object.parent = "";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.requests && message.requests.length) {
                                object.requests = [];
                                for (var j = 0; j < message.requests.length; ++j)
                                    object.requests[j] = $root.google.analytics.admin.v1alpha.DeleteUserLinkRequest.toObject(message.requests[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchDeleteUserLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchDeleteUserLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchDeleteUserLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchDeleteUserLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchDeleteUserLinksRequest";
                        };
    
                        return BatchDeleteUserLinksRequest;
                    })();
    
                    v1alpha.CreateFirebaseLinkRequest = (function() {
    
                        /**
                         * Properties of a CreateFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateFirebaseLinkRequest
                         * @property {string|null} [parent] CreateFirebaseLinkRequest parent
                         * @property {google.analytics.admin.v1alpha.IFirebaseLink|null} [firebaseLink] CreateFirebaseLinkRequest firebaseLink
                         */
    
                        /**
                         * Constructs a new CreateFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateFirebaseLinkRequest.
                         * @implements ICreateFirebaseLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateFirebaseLinkRequest=} [properties] Properties to set
                         */
                        function CreateFirebaseLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateFirebaseLinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @instance
                         */
                        CreateFirebaseLinkRequest.prototype.parent = "";
    
                        /**
                         * CreateFirebaseLinkRequest firebaseLink.
                         * @member {google.analytics.admin.v1alpha.IFirebaseLink|null|undefined} firebaseLink
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @instance
                         */
                        CreateFirebaseLinkRequest.prototype.firebaseLink = null;
    
                        /**
                         * Creates a new CreateFirebaseLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateFirebaseLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest instance
                         */
                        CreateFirebaseLinkRequest.create = function create(properties) {
                            return new CreateFirebaseLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateFirebaseLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateFirebaseLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateFirebaseLinkRequest} message CreateFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateFirebaseLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.firebaseLink != null && Object.hasOwnProperty.call(message, "firebaseLink"))
                                $root.google.analytics.admin.v1alpha.FirebaseLink.encode(message.firebaseLink, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateFirebaseLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateFirebaseLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateFirebaseLinkRequest} message CreateFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateFirebaseLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateFirebaseLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateFirebaseLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateFirebaseLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.firebaseLink = $root.google.analytics.admin.v1alpha.FirebaseLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateFirebaseLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateFirebaseLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateFirebaseLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateFirebaseLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink")) {
                                var error = $root.google.analytics.admin.v1alpha.FirebaseLink.verify(message.firebaseLink);
                                if (error)
                                    return "firebaseLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateFirebaseLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest
                         */
                        CreateFirebaseLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateFirebaseLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateFirebaseLinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.firebaseLink != null) {
                                if (typeof object.firebaseLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateFirebaseLinkRequest.firebaseLink: object expected");
                                message.firebaseLink = $root.google.analytics.admin.v1alpha.FirebaseLink.fromObject(object.firebaseLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateFirebaseLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateFirebaseLinkRequest} message CreateFirebaseLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateFirebaseLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.firebaseLink = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink"))
                                object.firebaseLink = $root.google.analytics.admin.v1alpha.FirebaseLink.toObject(message.firebaseLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateFirebaseLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateFirebaseLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateFirebaseLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateFirebaseLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateFirebaseLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateFirebaseLinkRequest";
                        };
    
                        return CreateFirebaseLinkRequest;
                    })();
    
                    v1alpha.DeleteFirebaseLinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteFirebaseLinkRequest
                         * @property {string|null} [name] DeleteFirebaseLinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteFirebaseLinkRequest.
                         * @implements IDeleteFirebaseLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteFirebaseLinkRequest=} [properties] Properties to set
                         */
                        function DeleteFirebaseLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteFirebaseLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @instance
                         */
                        DeleteFirebaseLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteFirebaseLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteFirebaseLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest instance
                         */
                        DeleteFirebaseLinkRequest.create = function create(properties) {
                            return new DeleteFirebaseLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteFirebaseLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteFirebaseLinkRequest} message DeleteFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirebaseLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteFirebaseLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteFirebaseLinkRequest} message DeleteFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirebaseLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteFirebaseLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirebaseLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteFirebaseLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirebaseLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteFirebaseLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteFirebaseLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteFirebaseLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest
                         */
                        DeleteFirebaseLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteFirebaseLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest} message DeleteFirebaseLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteFirebaseLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteFirebaseLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteFirebaseLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteFirebaseLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteFirebaseLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteFirebaseLinkRequest";
                        };
    
                        return DeleteFirebaseLinkRequest;
                    })();
    
                    v1alpha.ListFirebaseLinksRequest = (function() {
    
                        /**
                         * Properties of a ListFirebaseLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListFirebaseLinksRequest
                         * @property {string|null} [parent] ListFirebaseLinksRequest parent
                         * @property {number|null} [pageSize] ListFirebaseLinksRequest pageSize
                         * @property {string|null} [pageToken] ListFirebaseLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListFirebaseLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListFirebaseLinksRequest.
                         * @implements IListFirebaseLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksRequest=} [properties] Properties to set
                         */
                        function ListFirebaseLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListFirebaseLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @instance
                         */
                        ListFirebaseLinksRequest.prototype.parent = "";
    
                        /**
                         * ListFirebaseLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @instance
                         */
                        ListFirebaseLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListFirebaseLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @instance
                         */
                        ListFirebaseLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListFirebaseLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksRequest} ListFirebaseLinksRequest instance
                         */
                        ListFirebaseLinksRequest.create = function create(properties) {
                            return new ListFirebaseLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListFirebaseLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksRequest} message ListFirebaseLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListFirebaseLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksRequest} message ListFirebaseLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksRequest} ListFirebaseLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListFirebaseLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksRequest} ListFirebaseLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListFirebaseLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListFirebaseLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListFirebaseLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksRequest} ListFirebaseLinksRequest
                         */
                        ListFirebaseLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListFirebaseLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListFirebaseLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListFirebaseLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListFirebaseLinksRequest} message ListFirebaseLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListFirebaseLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListFirebaseLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListFirebaseLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListFirebaseLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListFirebaseLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListFirebaseLinksRequest";
                        };
    
                        return ListFirebaseLinksRequest;
                    })();
    
                    v1alpha.ListFirebaseLinksResponse = (function() {
    
                        /**
                         * Properties of a ListFirebaseLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListFirebaseLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IFirebaseLink>|null} [firebaseLinks] ListFirebaseLinksResponse firebaseLinks
                         * @property {string|null} [nextPageToken] ListFirebaseLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListFirebaseLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListFirebaseLinksResponse.
                         * @implements IListFirebaseLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksResponse=} [properties] Properties to set
                         */
                        function ListFirebaseLinksResponse(properties) {
                            this.firebaseLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListFirebaseLinksResponse firebaseLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IFirebaseLink>} firebaseLinks
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @instance
                         */
                        ListFirebaseLinksResponse.prototype.firebaseLinks = $util.emptyArray;
    
                        /**
                         * ListFirebaseLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @instance
                         */
                        ListFirebaseLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListFirebaseLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksResponse} ListFirebaseLinksResponse instance
                         */
                        ListFirebaseLinksResponse.create = function create(properties) {
                            return new ListFirebaseLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListFirebaseLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksResponse} message ListFirebaseLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.firebaseLinks != null && message.firebaseLinks.length)
                                for (var i = 0; i < message.firebaseLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.FirebaseLink.encode(message.firebaseLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListFirebaseLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListFirebaseLinksResponse} message ListFirebaseLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksResponse} ListFirebaseLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListFirebaseLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.firebaseLinks && message.firebaseLinks.length))
                                            message.firebaseLinks = [];
                                        message.firebaseLinks.push($root.google.analytics.admin.v1alpha.FirebaseLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksResponse} ListFirebaseLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListFirebaseLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListFirebaseLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firebaseLinks != null && message.hasOwnProperty("firebaseLinks")) {
                                if (!Array.isArray(message.firebaseLinks))
                                    return "firebaseLinks: array expected";
                                for (var i = 0; i < message.firebaseLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.FirebaseLink.verify(message.firebaseLinks[i]);
                                    if (error)
                                        return "firebaseLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListFirebaseLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListFirebaseLinksResponse} ListFirebaseLinksResponse
                         */
                        ListFirebaseLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListFirebaseLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListFirebaseLinksResponse();
                            if (object.firebaseLinks) {
                                if (!Array.isArray(object.firebaseLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListFirebaseLinksResponse.firebaseLinks: array expected");
                                message.firebaseLinks = [];
                                for (var i = 0; i < object.firebaseLinks.length; ++i) {
                                    if (typeof object.firebaseLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListFirebaseLinksResponse.firebaseLinks: object expected");
                                    message.firebaseLinks[i] = $root.google.analytics.admin.v1alpha.FirebaseLink.fromObject(object.firebaseLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListFirebaseLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListFirebaseLinksResponse} message ListFirebaseLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListFirebaseLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.firebaseLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.firebaseLinks && message.firebaseLinks.length) {
                                object.firebaseLinks = [];
                                for (var j = 0; j < message.firebaseLinks.length; ++j)
                                    object.firebaseLinks[j] = $root.google.analytics.admin.v1alpha.FirebaseLink.toObject(message.firebaseLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListFirebaseLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListFirebaseLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListFirebaseLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListFirebaseLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListFirebaseLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListFirebaseLinksResponse";
                        };
    
                        return ListFirebaseLinksResponse;
                    })();
    
                    v1alpha.GetGlobalSiteTagRequest = (function() {
    
                        /**
                         * Properties of a GetGlobalSiteTagRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetGlobalSiteTagRequest
                         * @property {string|null} [name] GetGlobalSiteTagRequest name
                         */
    
                        /**
                         * Constructs a new GetGlobalSiteTagRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetGlobalSiteTagRequest.
                         * @implements IGetGlobalSiteTagRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetGlobalSiteTagRequest=} [properties] Properties to set
                         */
                        function GetGlobalSiteTagRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGlobalSiteTagRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @instance
                         */
                        GetGlobalSiteTagRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetGlobalSiteTagRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetGlobalSiteTagRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetGlobalSiteTagRequest} GetGlobalSiteTagRequest instance
                         */
                        GetGlobalSiteTagRequest.create = function create(properties) {
                            return new GetGlobalSiteTagRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGlobalSiteTagRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetGlobalSiteTagRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetGlobalSiteTagRequest} message GetGlobalSiteTagRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalSiteTagRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGlobalSiteTagRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetGlobalSiteTagRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetGlobalSiteTagRequest} message GetGlobalSiteTagRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalSiteTagRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGlobalSiteTagRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetGlobalSiteTagRequest} GetGlobalSiteTagRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalSiteTagRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetGlobalSiteTagRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGlobalSiteTagRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetGlobalSiteTagRequest} GetGlobalSiteTagRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalSiteTagRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGlobalSiteTagRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGlobalSiteTagRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGlobalSiteTagRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetGlobalSiteTagRequest} GetGlobalSiteTagRequest
                         */
                        GetGlobalSiteTagRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetGlobalSiteTagRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetGlobalSiteTagRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGlobalSiteTagRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetGlobalSiteTagRequest} message GetGlobalSiteTagRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGlobalSiteTagRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetGlobalSiteTagRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGlobalSiteTagRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGlobalSiteTagRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetGlobalSiteTagRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGlobalSiteTagRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetGlobalSiteTagRequest";
                        };
    
                        return GetGlobalSiteTagRequest;
                    })();
    
                    v1alpha.CreateGoogleAdsLinkRequest = (function() {
    
                        /**
                         * Properties of a CreateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateGoogleAdsLinkRequest
                         * @property {string|null} [parent] CreateGoogleAdsLinkRequest parent
                         * @property {google.analytics.admin.v1alpha.IGoogleAdsLink|null} [googleAdsLink] CreateGoogleAdsLinkRequest googleAdsLink
                         */
    
                        /**
                         * Constructs a new CreateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateGoogleAdsLinkRequest.
                         * @implements ICreateGoogleAdsLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateGoogleAdsLinkRequest=} [properties] Properties to set
                         */
                        function CreateGoogleAdsLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateGoogleAdsLinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @instance
                         */
                        CreateGoogleAdsLinkRequest.prototype.parent = "";
    
                        /**
                         * CreateGoogleAdsLinkRequest googleAdsLink.
                         * @member {google.analytics.admin.v1alpha.IGoogleAdsLink|null|undefined} googleAdsLink
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @instance
                         */
                        CreateGoogleAdsLinkRequest.prototype.googleAdsLink = null;
    
                        /**
                         * Creates a new CreateGoogleAdsLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateGoogleAdsLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest instance
                         */
                        CreateGoogleAdsLinkRequest.create = function create(properties) {
                            return new CreateGoogleAdsLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateGoogleAdsLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateGoogleAdsLinkRequest} message CreateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateGoogleAdsLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.googleAdsLink != null && Object.hasOwnProperty.call(message, "googleAdsLink"))
                                $root.google.analytics.admin.v1alpha.GoogleAdsLink.encode(message.googleAdsLink, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateGoogleAdsLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateGoogleAdsLinkRequest} message CreateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateGoogleAdsLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateGoogleAdsLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateGoogleAdsLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateGoogleAdsLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateGoogleAdsLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateGoogleAdsLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateGoogleAdsLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                var error = $root.google.analytics.admin.v1alpha.GoogleAdsLink.verify(message.googleAdsLink);
                                if (error)
                                    return "googleAdsLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateGoogleAdsLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest
                         */
                        CreateGoogleAdsLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.googleAdsLink != null) {
                                if (typeof object.googleAdsLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest.googleAdsLink: object expected");
                                message.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.fromObject(object.googleAdsLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateGoogleAdsLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest} message CreateGoogleAdsLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateGoogleAdsLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.googleAdsLink = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink"))
                                object.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.toObject(message.googleAdsLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateGoogleAdsLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateGoogleAdsLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateGoogleAdsLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateGoogleAdsLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateGoogleAdsLinkRequest";
                        };
    
                        return CreateGoogleAdsLinkRequest;
                    })();
    
                    v1alpha.UpdateGoogleAdsLinkRequest = (function() {
    
                        /**
                         * Properties of an UpdateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateGoogleAdsLinkRequest
                         * @property {google.analytics.admin.v1alpha.IGoogleAdsLink|null} [googleAdsLink] UpdateGoogleAdsLinkRequest googleAdsLink
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateGoogleAdsLinkRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateGoogleAdsLinkRequest.
                         * @implements IUpdateGoogleAdsLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleAdsLinkRequest=} [properties] Properties to set
                         */
                        function UpdateGoogleAdsLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateGoogleAdsLinkRequest googleAdsLink.
                         * @member {google.analytics.admin.v1alpha.IGoogleAdsLink|null|undefined} googleAdsLink
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @instance
                         */
                        UpdateGoogleAdsLinkRequest.prototype.googleAdsLink = null;
    
                        /**
                         * UpdateGoogleAdsLinkRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @instance
                         */
                        UpdateGoogleAdsLinkRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateGoogleAdsLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleAdsLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest instance
                         */
                        UpdateGoogleAdsLinkRequest.create = function create(properties) {
                            return new UpdateGoogleAdsLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateGoogleAdsLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleAdsLinkRequest} message UpdateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateGoogleAdsLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleAdsLink != null && Object.hasOwnProperty.call(message, "googleAdsLink"))
                                $root.google.analytics.admin.v1alpha.GoogleAdsLink.encode(message.googleAdsLink, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateGoogleAdsLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleAdsLinkRequest} message UpdateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateGoogleAdsLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateGoogleAdsLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateGoogleAdsLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateGoogleAdsLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateGoogleAdsLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateGoogleAdsLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateGoogleAdsLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                var error = $root.google.analytics.admin.v1alpha.GoogleAdsLink.verify(message.googleAdsLink);
                                if (error)
                                    return "googleAdsLink." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateGoogleAdsLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest
                         */
                        UpdateGoogleAdsLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest();
                            if (object.googleAdsLink != null) {
                                if (typeof object.googleAdsLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest.googleAdsLink: object expected");
                                message.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.fromObject(object.googleAdsLink);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateGoogleAdsLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest} message UpdateGoogleAdsLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateGoogleAdsLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.googleAdsLink = null;
                                object.updateMask = null;
                            }
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink"))
                                object.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.toObject(message.googleAdsLink, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateGoogleAdsLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateGoogleAdsLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateGoogleAdsLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateGoogleAdsLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateGoogleAdsLinkRequest";
                        };
    
                        return UpdateGoogleAdsLinkRequest;
                    })();
    
                    v1alpha.DeleteGoogleAdsLinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteGoogleAdsLinkRequest
                         * @property {string|null} [name] DeleteGoogleAdsLinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteGoogleAdsLinkRequest.
                         * @implements IDeleteGoogleAdsLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteGoogleAdsLinkRequest=} [properties] Properties to set
                         */
                        function DeleteGoogleAdsLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGoogleAdsLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @instance
                         */
                        DeleteGoogleAdsLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteGoogleAdsLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteGoogleAdsLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest instance
                         */
                        DeleteGoogleAdsLinkRequest.create = function create(properties) {
                            return new DeleteGoogleAdsLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGoogleAdsLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteGoogleAdsLinkRequest} message DeleteGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGoogleAdsLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGoogleAdsLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteGoogleAdsLinkRequest} message DeleteGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGoogleAdsLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGoogleAdsLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGoogleAdsLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGoogleAdsLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGoogleAdsLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGoogleAdsLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGoogleAdsLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGoogleAdsLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest
                         */
                        DeleteGoogleAdsLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGoogleAdsLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest} message DeleteGoogleAdsLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGoogleAdsLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGoogleAdsLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGoogleAdsLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGoogleAdsLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGoogleAdsLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteGoogleAdsLinkRequest";
                        };
    
                        return DeleteGoogleAdsLinkRequest;
                    })();
    
                    v1alpha.ListGoogleAdsLinksRequest = (function() {
    
                        /**
                         * Properties of a ListGoogleAdsLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListGoogleAdsLinksRequest
                         * @property {string|null} [parent] ListGoogleAdsLinksRequest parent
                         * @property {number|null} [pageSize] ListGoogleAdsLinksRequest pageSize
                         * @property {string|null} [pageToken] ListGoogleAdsLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListGoogleAdsLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListGoogleAdsLinksRequest.
                         * @implements IListGoogleAdsLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksRequest=} [properties] Properties to set
                         */
                        function ListGoogleAdsLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGoogleAdsLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @instance
                         */
                        ListGoogleAdsLinksRequest.prototype.parent = "";
    
                        /**
                         * ListGoogleAdsLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @instance
                         */
                        ListGoogleAdsLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListGoogleAdsLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @instance
                         */
                        ListGoogleAdsLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListGoogleAdsLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest instance
                         */
                        ListGoogleAdsLinksRequest.create = function create(properties) {
                            return new ListGoogleAdsLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksRequest} message ListGoogleAdsLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksRequest} message ListGoogleAdsLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGoogleAdsLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGoogleAdsLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListGoogleAdsLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest
                         */
                        ListGoogleAdsLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGoogleAdsLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest} message ListGoogleAdsLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGoogleAdsLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListGoogleAdsLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGoogleAdsLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGoogleAdsLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGoogleAdsLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListGoogleAdsLinksRequest";
                        };
    
                        return ListGoogleAdsLinksRequest;
                    })();
    
                    v1alpha.ListGoogleAdsLinksResponse = (function() {
    
                        /**
                         * Properties of a ListGoogleAdsLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListGoogleAdsLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IGoogleAdsLink>|null} [googleAdsLinks] ListGoogleAdsLinksResponse googleAdsLinks
                         * @property {string|null} [nextPageToken] ListGoogleAdsLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListGoogleAdsLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListGoogleAdsLinksResponse.
                         * @implements IListGoogleAdsLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksResponse=} [properties] Properties to set
                         */
                        function ListGoogleAdsLinksResponse(properties) {
                            this.googleAdsLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGoogleAdsLinksResponse googleAdsLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IGoogleAdsLink>} googleAdsLinks
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @instance
                         */
                        ListGoogleAdsLinksResponse.prototype.googleAdsLinks = $util.emptyArray;
    
                        /**
                         * ListGoogleAdsLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @instance
                         */
                        ListGoogleAdsLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListGoogleAdsLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse instance
                         */
                        ListGoogleAdsLinksResponse.create = function create(properties) {
                            return new ListGoogleAdsLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksResponse} message ListGoogleAdsLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleAdsLinks != null && message.googleAdsLinks.length)
                                for (var i = 0; i < message.googleAdsLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.GoogleAdsLink.encode(message.googleAdsLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListGoogleAdsLinksResponse} message ListGoogleAdsLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.googleAdsLinks && message.googleAdsLinks.length))
                                            message.googleAdsLinks = [];
                                        message.googleAdsLinks.push($root.google.analytics.admin.v1alpha.GoogleAdsLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGoogleAdsLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGoogleAdsLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.googleAdsLinks != null && message.hasOwnProperty("googleAdsLinks")) {
                                if (!Array.isArray(message.googleAdsLinks))
                                    return "googleAdsLinks: array expected";
                                for (var i = 0; i < message.googleAdsLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.GoogleAdsLink.verify(message.googleAdsLinks[i]);
                                    if (error)
                                        return "googleAdsLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListGoogleAdsLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse
                         */
                        ListGoogleAdsLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse();
                            if (object.googleAdsLinks) {
                                if (!Array.isArray(object.googleAdsLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse.googleAdsLinks: array expected");
                                message.googleAdsLinks = [];
                                for (var i = 0; i < object.googleAdsLinks.length; ++i) {
                                    if (typeof object.googleAdsLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse.googleAdsLinks: object expected");
                                    message.googleAdsLinks[i] = $root.google.analytics.admin.v1alpha.GoogleAdsLink.fromObject(object.googleAdsLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGoogleAdsLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse} message ListGoogleAdsLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGoogleAdsLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.googleAdsLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.googleAdsLinks && message.googleAdsLinks.length) {
                                object.googleAdsLinks = [];
                                for (var j = 0; j < message.googleAdsLinks.length; ++j)
                                    object.googleAdsLinks[j] = $root.google.analytics.admin.v1alpha.GoogleAdsLink.toObject(message.googleAdsLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListGoogleAdsLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGoogleAdsLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGoogleAdsLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGoogleAdsLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListGoogleAdsLinksResponse";
                        };
    
                        return ListGoogleAdsLinksResponse;
                    })();
    
                    v1alpha.GetDataSharingSettingsRequest = (function() {
    
                        /**
                         * Properties of a GetDataSharingSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetDataSharingSettingsRequest
                         * @property {string|null} [name] GetDataSharingSettingsRequest name
                         */
    
                        /**
                         * Constructs a new GetDataSharingSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetDataSharingSettingsRequest.
                         * @implements IGetDataSharingSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetDataSharingSettingsRequest=} [properties] Properties to set
                         */
                        function GetDataSharingSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDataSharingSettingsRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @instance
                         */
                        GetDataSharingSettingsRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDataSharingSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataSharingSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest instance
                         */
                        GetDataSharingSettingsRequest.create = function create(properties) {
                            return new GetDataSharingSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDataSharingSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetDataSharingSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataSharingSettingsRequest} message GetDataSharingSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataSharingSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDataSharingSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetDataSharingSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataSharingSettingsRequest} message GetDataSharingSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataSharingSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDataSharingSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataSharingSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetDataSharingSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDataSharingSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataSharingSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDataSharingSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDataSharingSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDataSharingSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest
                         */
                        GetDataSharingSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetDataSharingSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetDataSharingSettingsRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDataSharingSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetDataSharingSettingsRequest} message GetDataSharingSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDataSharingSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDataSharingSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDataSharingSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDataSharingSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetDataSharingSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDataSharingSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetDataSharingSettingsRequest";
                        };
    
                        return GetDataSharingSettingsRequest;
                    })();
    
                    v1alpha.ListAccountSummariesRequest = (function() {
    
                        /**
                         * Properties of a ListAccountSummariesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAccountSummariesRequest
                         * @property {number|null} [pageSize] ListAccountSummariesRequest pageSize
                         * @property {string|null} [pageToken] ListAccountSummariesRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListAccountSummariesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAccountSummariesRequest.
                         * @implements IListAccountSummariesRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesRequest=} [properties] Properties to set
                         */
                        function ListAccountSummariesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountSummariesRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @instance
                         */
                        ListAccountSummariesRequest.prototype.pageSize = 0;
    
                        /**
                         * ListAccountSummariesRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @instance
                         */
                        ListAccountSummariesRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListAccountSummariesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesRequest} ListAccountSummariesRequest instance
                         */
                        ListAccountSummariesRequest.create = function create(properties) {
                            return new ListAccountSummariesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountSummariesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesRequest} message ListAccountSummariesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountSummariesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesRequest} message ListAccountSummariesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountSummariesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesRequest} ListAccountSummariesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAccountSummariesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountSummariesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesRequest} ListAccountSummariesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountSummariesRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountSummariesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountSummariesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesRequest} ListAccountSummariesRequest
                         */
                        ListAccountSummariesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAccountSummariesRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAccountSummariesRequest();
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountSummariesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAccountSummariesRequest} message ListAccountSummariesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountSummariesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountSummariesRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountSummariesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountSummariesRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountSummariesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAccountSummariesRequest";
                        };
    
                        return ListAccountSummariesRequest;
                    })();
    
                    v1alpha.ListAccountSummariesResponse = (function() {
    
                        /**
                         * Properties of a ListAccountSummariesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAccountSummariesResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAccountSummary>|null} [accountSummaries] ListAccountSummariesResponse accountSummaries
                         * @property {string|null} [nextPageToken] ListAccountSummariesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListAccountSummariesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAccountSummariesResponse.
                         * @implements IListAccountSummariesResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesResponse=} [properties] Properties to set
                         */
                        function ListAccountSummariesResponse(properties) {
                            this.accountSummaries = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountSummariesResponse accountSummaries.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccountSummary>} accountSummaries
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @instance
                         */
                        ListAccountSummariesResponse.prototype.accountSummaries = $util.emptyArray;
    
                        /**
                         * ListAccountSummariesResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @instance
                         */
                        ListAccountSummariesResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListAccountSummariesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesResponse} ListAccountSummariesResponse instance
                         */
                        ListAccountSummariesResponse.create = function create(properties) {
                            return new ListAccountSummariesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountSummariesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesResponse} message ListAccountSummariesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accountSummaries != null && message.accountSummaries.length)
                                for (var i = 0; i < message.accountSummaries.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccountSummary.encode(message.accountSummaries[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccountSummariesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccountSummariesResponse} message ListAccountSummariesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountSummariesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesResponse} ListAccountSummariesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAccountSummariesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accountSummaries && message.accountSummaries.length))
                                            message.accountSummaries = [];
                                        message.accountSummaries.push($root.google.analytics.admin.v1alpha.AccountSummary.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountSummariesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesResponse} ListAccountSummariesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountSummariesResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountSummariesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accountSummaries != null && message.hasOwnProperty("accountSummaries")) {
                                if (!Array.isArray(message.accountSummaries))
                                    return "accountSummaries: array expected";
                                for (var i = 0; i < message.accountSummaries.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccountSummary.verify(message.accountSummaries[i]);
                                    if (error)
                                        return "accountSummaries." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountSummariesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAccountSummariesResponse} ListAccountSummariesResponse
                         */
                        ListAccountSummariesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAccountSummariesResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAccountSummariesResponse();
                            if (object.accountSummaries) {
                                if (!Array.isArray(object.accountSummaries))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListAccountSummariesResponse.accountSummaries: array expected");
                                message.accountSummaries = [];
                                for (var i = 0; i < object.accountSummaries.length; ++i) {
                                    if (typeof object.accountSummaries[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListAccountSummariesResponse.accountSummaries: object expected");
                                    message.accountSummaries[i] = $root.google.analytics.admin.v1alpha.AccountSummary.fromObject(object.accountSummaries[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountSummariesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAccountSummariesResponse} message ListAccountSummariesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountSummariesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accountSummaries = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.accountSummaries && message.accountSummaries.length) {
                                object.accountSummaries = [];
                                for (var j = 0; j < message.accountSummaries.length; ++j)
                                    object.accountSummaries[j] = $root.google.analytics.admin.v1alpha.AccountSummary.toObject(message.accountSummaries[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountSummariesResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountSummariesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountSummariesResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAccountSummariesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountSummariesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAccountSummariesResponse";
                        };
    
                        return ListAccountSummariesResponse;
                    })();
    
                    v1alpha.AcknowledgeUserDataCollectionRequest = (function() {
    
                        /**
                         * Properties of an AcknowledgeUserDataCollectionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAcknowledgeUserDataCollectionRequest
                         * @property {string|null} [property] AcknowledgeUserDataCollectionRequest property
                         * @property {string|null} [acknowledgement] AcknowledgeUserDataCollectionRequest acknowledgement
                         */
    
                        /**
                         * Constructs a new AcknowledgeUserDataCollectionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AcknowledgeUserDataCollectionRequest.
                         * @implements IAcknowledgeUserDataCollectionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionRequest=} [properties] Properties to set
                         */
                        function AcknowledgeUserDataCollectionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AcknowledgeUserDataCollectionRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @instance
                         */
                        AcknowledgeUserDataCollectionRequest.prototype.property = "";
    
                        /**
                         * AcknowledgeUserDataCollectionRequest acknowledgement.
                         * @member {string} acknowledgement
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @instance
                         */
                        AcknowledgeUserDataCollectionRequest.prototype.acknowledgement = "";
    
                        /**
                         * Creates a new AcknowledgeUserDataCollectionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest instance
                         */
                        AcknowledgeUserDataCollectionRequest.create = function create(properties) {
                            return new AcknowledgeUserDataCollectionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionRequest} message AcknowledgeUserDataCollectionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            if (message.acknowledgement != null && Object.hasOwnProperty.call(message, "acknowledgement"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.acknowledgement);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionRequest} message AcknowledgeUserDataCollectionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.acknowledgement = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcknowledgeUserDataCollectionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcknowledgeUserDataCollectionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.acknowledgement != null && message.hasOwnProperty("acknowledgement"))
                                if (!$util.isString(message.acknowledgement))
                                    return "acknowledgement: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AcknowledgeUserDataCollectionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest
                         */
                        AcknowledgeUserDataCollectionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.acknowledgement != null)
                                message.acknowledgement = String(object.acknowledgement);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AcknowledgeUserDataCollectionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest} message AcknowledgeUserDataCollectionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcknowledgeUserDataCollectionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = "";
                                object.acknowledgement = "";
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.acknowledgement != null && message.hasOwnProperty("acknowledgement"))
                                object.acknowledgement = message.acknowledgement;
                            return object;
                        };
    
                        /**
                         * Converts this AcknowledgeUserDataCollectionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcknowledgeUserDataCollectionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcknowledgeUserDataCollectionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcknowledgeUserDataCollectionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionRequest";
                        };
    
                        return AcknowledgeUserDataCollectionRequest;
                    })();
    
                    v1alpha.AcknowledgeUserDataCollectionResponse = (function() {
    
                        /**
                         * Properties of an AcknowledgeUserDataCollectionResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAcknowledgeUserDataCollectionResponse
                         */
    
                        /**
                         * Constructs a new AcknowledgeUserDataCollectionResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AcknowledgeUserDataCollectionResponse.
                         * @implements IAcknowledgeUserDataCollectionResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionResponse=} [properties] Properties to set
                         */
                        function AcknowledgeUserDataCollectionResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new AcknowledgeUserDataCollectionResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse instance
                         */
                        AcknowledgeUserDataCollectionResponse.create = function create(properties) {
                            return new AcknowledgeUserDataCollectionResponse(properties);
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionResponse} message AcknowledgeUserDataCollectionResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAcknowledgeUserDataCollectionResponse} message AcknowledgeUserDataCollectionResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcknowledgeUserDataCollectionResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcknowledgeUserDataCollectionResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates an AcknowledgeUserDataCollectionResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse
                         */
                        AcknowledgeUserDataCollectionResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse)
                                return object;
                            return new $root.google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse();
                        };
    
                        /**
                         * Creates a plain object from an AcknowledgeUserDataCollectionResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse} message AcknowledgeUserDataCollectionResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcknowledgeUserDataCollectionResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this AcknowledgeUserDataCollectionResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcknowledgeUserDataCollectionResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcknowledgeUserDataCollectionResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcknowledgeUserDataCollectionResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AcknowledgeUserDataCollectionResponse";
                        };
    
                        return AcknowledgeUserDataCollectionResponse;
                    })();
    
                    v1alpha.SearchChangeHistoryEventsRequest = (function() {
    
                        /**
                         * Properties of a SearchChangeHistoryEventsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ISearchChangeHistoryEventsRequest
                         * @property {string|null} [account] SearchChangeHistoryEventsRequest account
                         * @property {string|null} [property] SearchChangeHistoryEventsRequest property
                         * @property {Array.<google.analytics.admin.v1alpha.ChangeHistoryResourceType>|null} [resourceType] SearchChangeHistoryEventsRequest resourceType
                         * @property {Array.<google.analytics.admin.v1alpha.ActionType>|null} [action] SearchChangeHistoryEventsRequest action
                         * @property {Array.<string>|null} [actorEmail] SearchChangeHistoryEventsRequest actorEmail
                         * @property {google.protobuf.ITimestamp|null} [earliestChangeTime] SearchChangeHistoryEventsRequest earliestChangeTime
                         * @property {google.protobuf.ITimestamp|null} [latestChangeTime] SearchChangeHistoryEventsRequest latestChangeTime
                         * @property {number|null} [pageSize] SearchChangeHistoryEventsRequest pageSize
                         * @property {string|null} [pageToken] SearchChangeHistoryEventsRequest pageToken
                         */
    
                        /**
                         * Constructs a new SearchChangeHistoryEventsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a SearchChangeHistoryEventsRequest.
                         * @implements ISearchChangeHistoryEventsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsRequest=} [properties] Properties to set
                         */
                        function SearchChangeHistoryEventsRequest(properties) {
                            this.resourceType = [];
                            this.action = [];
                            this.actorEmail = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SearchChangeHistoryEventsRequest account.
                         * @member {string} account
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.account = "";
    
                        /**
                         * SearchChangeHistoryEventsRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.property = "";
    
                        /**
                         * SearchChangeHistoryEventsRequest resourceType.
                         * @member {Array.<google.analytics.admin.v1alpha.ChangeHistoryResourceType>} resourceType
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.resourceType = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsRequest action.
                         * @member {Array.<google.analytics.admin.v1alpha.ActionType>} action
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.action = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsRequest actorEmail.
                         * @member {Array.<string>} actorEmail
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.actorEmail = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsRequest earliestChangeTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} earliestChangeTime
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.earliestChangeTime = null;
    
                        /**
                         * SearchChangeHistoryEventsRequest latestChangeTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} latestChangeTime
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.latestChangeTime = null;
    
                        /**
                         * SearchChangeHistoryEventsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.pageSize = 0;
    
                        /**
                         * SearchChangeHistoryEventsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new SearchChangeHistoryEventsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest instance
                         */
                        SearchChangeHistoryEventsRequest.create = function create(properties) {
                            return new SearchChangeHistoryEventsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsRequest} message SearchChangeHistoryEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.account);
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.property);
                            if (message.resourceType != null && message.resourceType.length) {
                                writer.uint32(/* id 3, wireType 2 =*/26).fork();
                                for (var i = 0; i < message.resourceType.length; ++i)
                                    writer.int32(message.resourceType[i]);
                                writer.ldelim();
                            }
                            if (message.action != null && message.action.length) {
                                writer.uint32(/* id 4, wireType 2 =*/34).fork();
                                for (var i = 0; i < message.action.length; ++i)
                                    writer.int32(message.action[i]);
                                writer.ldelim();
                            }
                            if (message.actorEmail != null && message.actorEmail.length)
                                for (var i = 0; i < message.actorEmail.length; ++i)
                                    writer.uint32(/* id 5, wireType 2 =*/42).string(message.actorEmail[i]);
                            if (message.earliestChangeTime != null && Object.hasOwnProperty.call(message, "earliestChangeTime"))
                                $root.google.protobuf.Timestamp.encode(message.earliestChangeTime, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.latestChangeTime != null && Object.hasOwnProperty.call(message, "latestChangeTime"))
                                $root.google.protobuf.Timestamp.encode(message.latestChangeTime, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 9, wireType 2 =*/74).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsRequest} message SearchChangeHistoryEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.account = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.resourceType && message.resourceType.length))
                                            message.resourceType = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.resourceType.push(reader.int32());
                                        } else
                                            message.resourceType.push(reader.int32());
                                        break;
                                    }
                                case 4: {
                                        if (!(message.action && message.action.length))
                                            message.action = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.action.push(reader.int32());
                                        } else
                                            message.action.push(reader.int32());
                                        break;
                                    }
                                case 5: {
                                        if (!(message.actorEmail && message.actorEmail.length))
                                            message.actorEmail = [];
                                        message.actorEmail.push(reader.string());
                                        break;
                                    }
                                case 6: {
                                        message.earliestChangeTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.latestChangeTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 8: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 9: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SearchChangeHistoryEventsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchChangeHistoryEventsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.account != null && message.hasOwnProperty("account"))
                                if (!$util.isString(message.account))
                                    return "account: string expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.resourceType != null && message.hasOwnProperty("resourceType")) {
                                if (!Array.isArray(message.resourceType))
                                    return "resourceType: array expected";
                                for (var i = 0; i < message.resourceType.length; ++i)
                                    switch (message.resourceType[i]) {
                                    default:
                                        return "resourceType: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 11:
                                    case 12:
                                    case 13:
                                    case 14:
                                    case 15:
                                    case 16:
                                    case 18:
                                    case 20:
                                    case 21:
                                    case 22:
                                    case 24:
                                    case 27:
                                    case 28:
                                    case 29:
                                        break;
                                    }
                            }
                            if (message.action != null && message.hasOwnProperty("action")) {
                                if (!Array.isArray(message.action))
                                    return "action: array expected";
                                for (var i = 0; i < message.action.length; ++i)
                                    switch (message.action[i]) {
                                    default:
                                        return "action: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                            }
                            if (message.actorEmail != null && message.hasOwnProperty("actorEmail")) {
                                if (!Array.isArray(message.actorEmail))
                                    return "actorEmail: array expected";
                                for (var i = 0; i < message.actorEmail.length; ++i)
                                    if (!$util.isString(message.actorEmail[i]))
                                        return "actorEmail: string[] expected";
                            }
                            if (message.earliestChangeTime != null && message.hasOwnProperty("earliestChangeTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.earliestChangeTime);
                                if (error)
                                    return "earliestChangeTime." + error;
                            }
                            if (message.latestChangeTime != null && message.hasOwnProperty("latestChangeTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.latestChangeTime);
                                if (error)
                                    return "latestChangeTime." + error;
                            }
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SearchChangeHistoryEventsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest
                         */
                        SearchChangeHistoryEventsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest();
                            if (object.account != null)
                                message.account = String(object.account);
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.resourceType) {
                                if (!Array.isArray(object.resourceType))
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest.resourceType: array expected");
                                message.resourceType = [];
                                for (var i = 0; i < object.resourceType.length; ++i)
                                    switch (object.resourceType[i]) {
                                    default:
                                        if (typeof object.resourceType[i] === "number") {
                                            message.resourceType[i] = object.resourceType[i];
                                            break;
                                        }
                                    case "CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED":
                                    case 0:
                                        message.resourceType[i] = 0;
                                        break;
                                    case "ACCOUNT":
                                    case 1:
                                        message.resourceType[i] = 1;
                                        break;
                                    case "PROPERTY":
                                    case 2:
                                        message.resourceType[i] = 2;
                                        break;
                                    case "FIREBASE_LINK":
                                    case 6:
                                        message.resourceType[i] = 6;
                                        break;
                                    case "GOOGLE_ADS_LINK":
                                    case 7:
                                        message.resourceType[i] = 7;
                                        break;
                                    case "GOOGLE_SIGNALS_SETTINGS":
                                    case 8:
                                        message.resourceType[i] = 8;
                                        break;
                                    case "CONVERSION_EVENT":
                                    case 9:
                                        message.resourceType[i] = 9;
                                        break;
                                    case "MEASUREMENT_PROTOCOL_SECRET":
                                    case 10:
                                        message.resourceType[i] = 10;
                                        break;
                                    case "CUSTOM_DIMENSION":
                                    case 11:
                                        message.resourceType[i] = 11;
                                        break;
                                    case "CUSTOM_METRIC":
                                    case 12:
                                        message.resourceType[i] = 12;
                                        break;
                                    case "DATA_RETENTION_SETTINGS":
                                    case 13:
                                        message.resourceType[i] = 13;
                                        break;
                                    case "DISPLAY_VIDEO_360_ADVERTISER_LINK":
                                    case 14:
                                        message.resourceType[i] = 14;
                                        break;
                                    case "DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL":
                                    case 15:
                                        message.resourceType[i] = 15;
                                        break;
                                    case "SEARCH_ADS_360_LINK":
                                    case 16:
                                        message.resourceType[i] = 16;
                                        break;
                                    case "DATA_STREAM":
                                    case 18:
                                        message.resourceType[i] = 18;
                                        break;
                                    case "ATTRIBUTION_SETTINGS":
                                    case 20:
                                        message.resourceType[i] = 20;
                                        break;
                                    case "EXPANDED_DATA_SET":
                                    case 21:
                                        message.resourceType[i] = 21;
                                        break;
                                    case "CHANNEL_GROUP":
                                    case 22:
                                        message.resourceType[i] = 22;
                                        break;
                                    case "ENHANCED_MEASUREMENT_SETTINGS":
                                    case 24:
                                        message.resourceType[i] = 24;
                                        break;
                                    case "ADSENSE_LINK":
                                    case 27:
                                        message.resourceType[i] = 27;
                                        break;
                                    case "AUDIENCE":
                                    case 28:
                                        message.resourceType[i] = 28;
                                        break;
                                    case "EVENT_CREATE_RULE":
                                    case 29:
                                        message.resourceType[i] = 29;
                                        break;
                                    }
                            }
                            if (object.action) {
                                if (!Array.isArray(object.action))
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest.action: array expected");
                                message.action = [];
                                for (var i = 0; i < object.action.length; ++i)
                                    switch (object.action[i]) {
                                    default:
                                        if (typeof object.action[i] === "number") {
                                            message.action[i] = object.action[i];
                                            break;
                                        }
                                    case "ACTION_TYPE_UNSPECIFIED":
                                    case 0:
                                        message.action[i] = 0;
                                        break;
                                    case "CREATED":
                                    case 1:
                                        message.action[i] = 1;
                                        break;
                                    case "UPDATED":
                                    case 2:
                                        message.action[i] = 2;
                                        break;
                                    case "DELETED":
                                    case 3:
                                        message.action[i] = 3;
                                        break;
                                    }
                            }
                            if (object.actorEmail) {
                                if (!Array.isArray(object.actorEmail))
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest.actorEmail: array expected");
                                message.actorEmail = [];
                                for (var i = 0; i < object.actorEmail.length; ++i)
                                    message.actorEmail[i] = String(object.actorEmail[i]);
                            }
                            if (object.earliestChangeTime != null) {
                                if (typeof object.earliestChangeTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest.earliestChangeTime: object expected");
                                message.earliestChangeTime = $root.google.protobuf.Timestamp.fromObject(object.earliestChangeTime);
                            }
                            if (object.latestChangeTime != null) {
                                if (typeof object.latestChangeTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest.latestChangeTime: object expected");
                                message.latestChangeTime = $root.google.protobuf.Timestamp.fromObject(object.latestChangeTime);
                            }
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SearchChangeHistoryEventsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest} message SearchChangeHistoryEventsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchChangeHistoryEventsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.resourceType = [];
                                object.action = [];
                                object.actorEmail = [];
                            }
                            if (options.defaults) {
                                object.account = "";
                                object.property = "";
                                object.earliestChangeTime = null;
                                object.latestChangeTime = null;
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = message.account;
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.resourceType && message.resourceType.length) {
                                object.resourceType = [];
                                for (var j = 0; j < message.resourceType.length; ++j)
                                    object.resourceType[j] = options.enums === String ? $root.google.analytics.admin.v1alpha.ChangeHistoryResourceType[message.resourceType[j]] === undefined ? message.resourceType[j] : $root.google.analytics.admin.v1alpha.ChangeHistoryResourceType[message.resourceType[j]] : message.resourceType[j];
                            }
                            if (message.action && message.action.length) {
                                object.action = [];
                                for (var j = 0; j < message.action.length; ++j)
                                    object.action[j] = options.enums === String ? $root.google.analytics.admin.v1alpha.ActionType[message.action[j]] === undefined ? message.action[j] : $root.google.analytics.admin.v1alpha.ActionType[message.action[j]] : message.action[j];
                            }
                            if (message.actorEmail && message.actorEmail.length) {
                                object.actorEmail = [];
                                for (var j = 0; j < message.actorEmail.length; ++j)
                                    object.actorEmail[j] = message.actorEmail[j];
                            }
                            if (message.earliestChangeTime != null && message.hasOwnProperty("earliestChangeTime"))
                                object.earliestChangeTime = $root.google.protobuf.Timestamp.toObject(message.earliestChangeTime, options);
                            if (message.latestChangeTime != null && message.hasOwnProperty("latestChangeTime"))
                                object.latestChangeTime = $root.google.protobuf.Timestamp.toObject(message.latestChangeTime, options);
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this SearchChangeHistoryEventsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchChangeHistoryEventsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SearchChangeHistoryEventsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SearchChangeHistoryEventsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.SearchChangeHistoryEventsRequest";
                        };
    
                        return SearchChangeHistoryEventsRequest;
                    })();
    
                    v1alpha.SearchChangeHistoryEventsResponse = (function() {
    
                        /**
                         * Properties of a SearchChangeHistoryEventsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ISearchChangeHistoryEventsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IChangeHistoryEvent>|null} [changeHistoryEvents] SearchChangeHistoryEventsResponse changeHistoryEvents
                         * @property {string|null} [nextPageToken] SearchChangeHistoryEventsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new SearchChangeHistoryEventsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a SearchChangeHistoryEventsResponse.
                         * @implements ISearchChangeHistoryEventsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsResponse=} [properties] Properties to set
                         */
                        function SearchChangeHistoryEventsResponse(properties) {
                            this.changeHistoryEvents = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SearchChangeHistoryEventsResponse changeHistoryEvents.
                         * @member {Array.<google.analytics.admin.v1alpha.IChangeHistoryEvent>} changeHistoryEvents
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @instance
                         */
                        SearchChangeHistoryEventsResponse.prototype.changeHistoryEvents = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @instance
                         */
                        SearchChangeHistoryEventsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new SearchChangeHistoryEventsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse instance
                         */
                        SearchChangeHistoryEventsResponse.create = function create(properties) {
                            return new SearchChangeHistoryEventsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsResponse} message SearchChangeHistoryEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.changeHistoryEvents != null && message.changeHistoryEvents.length)
                                for (var i = 0; i < message.changeHistoryEvents.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ChangeHistoryEvent.encode(message.changeHistoryEvents[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchChangeHistoryEventsResponse} message SearchChangeHistoryEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.changeHistoryEvents && message.changeHistoryEvents.length))
                                            message.changeHistoryEvents = [];
                                        message.changeHistoryEvents.push($root.google.analytics.admin.v1alpha.ChangeHistoryEvent.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SearchChangeHistoryEventsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchChangeHistoryEventsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.changeHistoryEvents != null && message.hasOwnProperty("changeHistoryEvents")) {
                                if (!Array.isArray(message.changeHistoryEvents))
                                    return "changeHistoryEvents: array expected";
                                for (var i = 0; i < message.changeHistoryEvents.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ChangeHistoryEvent.verify(message.changeHistoryEvents[i]);
                                    if (error)
                                        return "changeHistoryEvents." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SearchChangeHistoryEventsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse
                         */
                        SearchChangeHistoryEventsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse();
                            if (object.changeHistoryEvents) {
                                if (!Array.isArray(object.changeHistoryEvents))
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse.changeHistoryEvents: array expected");
                                message.changeHistoryEvents = [];
                                for (var i = 0; i < object.changeHistoryEvents.length; ++i) {
                                    if (typeof object.changeHistoryEvents[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse.changeHistoryEvents: object expected");
                                    message.changeHistoryEvents[i] = $root.google.analytics.admin.v1alpha.ChangeHistoryEvent.fromObject(object.changeHistoryEvents[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SearchChangeHistoryEventsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse} message SearchChangeHistoryEventsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchChangeHistoryEventsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.changeHistoryEvents = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.changeHistoryEvents && message.changeHistoryEvents.length) {
                                object.changeHistoryEvents = [];
                                for (var j = 0; j < message.changeHistoryEvents.length; ++j)
                                    object.changeHistoryEvents[j] = $root.google.analytics.admin.v1alpha.ChangeHistoryEvent.toObject(message.changeHistoryEvents[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this SearchChangeHistoryEventsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchChangeHistoryEventsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SearchChangeHistoryEventsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SearchChangeHistoryEventsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.SearchChangeHistoryEventsResponse";
                        };
    
                        return SearchChangeHistoryEventsResponse;
                    })();
    
                    v1alpha.GetMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of a GetMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetMeasurementProtocolSecretRequest
                         * @property {string|null} [name] GetMeasurementProtocolSecretRequest name
                         */
    
                        /**
                         * Constructs a new GetMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetMeasurementProtocolSecretRequest.
                         * @implements IGetMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function GetMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetMeasurementProtocolSecretRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @instance
                         */
                        GetMeasurementProtocolSecretRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest instance
                         */
                        GetMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new GetMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetMeasurementProtocolSecretRequest} message GetMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetMeasurementProtocolSecretRequest} message GetMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest
                         */
                        GetMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest} message GetMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetMeasurementProtocolSecretRequest";
                        };
    
                        return GetMeasurementProtocolSecretRequest;
                    })();
    
                    v1alpha.CreateMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of a CreateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateMeasurementProtocolSecretRequest
                         * @property {string|null} [parent] CreateMeasurementProtocolSecretRequest parent
                         * @property {google.analytics.admin.v1alpha.IMeasurementProtocolSecret|null} [measurementProtocolSecret] CreateMeasurementProtocolSecretRequest measurementProtocolSecret
                         */
    
                        /**
                         * Constructs a new CreateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateMeasurementProtocolSecretRequest.
                         * @implements ICreateMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function CreateMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateMeasurementProtocolSecretRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        CreateMeasurementProtocolSecretRequest.prototype.parent = "";
    
                        /**
                         * CreateMeasurementProtocolSecretRequest measurementProtocolSecret.
                         * @member {google.analytics.admin.v1alpha.IMeasurementProtocolSecret|null|undefined} measurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        CreateMeasurementProtocolSecretRequest.prototype.measurementProtocolSecret = null;
    
                        /**
                         * Creates a new CreateMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest instance
                         */
                        CreateMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new CreateMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateMeasurementProtocolSecretRequest} message CreateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.measurementProtocolSecret != null && Object.hasOwnProperty.call(message, "measurementProtocolSecret"))
                                $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.encode(message.measurementProtocolSecret, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateMeasurementProtocolSecretRequest} message CreateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                var error = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.verify(message.measurementProtocolSecret);
                                if (error)
                                    return "measurementProtocolSecret." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest
                         */
                        CreateMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.measurementProtocolSecret != null) {
                                if (typeof object.measurementProtocolSecret !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest.measurementProtocolSecret: object expected");
                                message.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecret);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest} message CreateMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.measurementProtocolSecret = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret"))
                                object.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.toObject(message.measurementProtocolSecret, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateMeasurementProtocolSecretRequest";
                        };
    
                        return CreateMeasurementProtocolSecretRequest;
                    })();
    
                    v1alpha.DeleteMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of a DeleteMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteMeasurementProtocolSecretRequest
                         * @property {string|null} [name] DeleteMeasurementProtocolSecretRequest name
                         */
    
                        /**
                         * Constructs a new DeleteMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteMeasurementProtocolSecretRequest.
                         * @implements IDeleteMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function DeleteMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteMeasurementProtocolSecretRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @instance
                         */
                        DeleteMeasurementProtocolSecretRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest instance
                         */
                        DeleteMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new DeleteMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteMeasurementProtocolSecretRequest} message DeleteMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteMeasurementProtocolSecretRequest} message DeleteMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest
                         */
                        DeleteMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest} message DeleteMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteMeasurementProtocolSecretRequest";
                        };
    
                        return DeleteMeasurementProtocolSecretRequest;
                    })();
    
                    v1alpha.UpdateMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of an UpdateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateMeasurementProtocolSecretRequest
                         * @property {google.analytics.admin.v1alpha.IMeasurementProtocolSecret|null} [measurementProtocolSecret] UpdateMeasurementProtocolSecretRequest measurementProtocolSecret
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateMeasurementProtocolSecretRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateMeasurementProtocolSecretRequest.
                         * @implements IUpdateMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function UpdateMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateMeasurementProtocolSecretRequest measurementProtocolSecret.
                         * @member {google.analytics.admin.v1alpha.IMeasurementProtocolSecret|null|undefined} measurementProtocolSecret
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        UpdateMeasurementProtocolSecretRequest.prototype.measurementProtocolSecret = null;
    
                        /**
                         * UpdateMeasurementProtocolSecretRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        UpdateMeasurementProtocolSecretRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest instance
                         */
                        UpdateMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new UpdateMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateMeasurementProtocolSecretRequest} message UpdateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.measurementProtocolSecret != null && Object.hasOwnProperty.call(message, "measurementProtocolSecret"))
                                $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.encode(message.measurementProtocolSecret, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateMeasurementProtocolSecretRequest} message UpdateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                var error = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.verify(message.measurementProtocolSecret);
                                if (error)
                                    return "measurementProtocolSecret." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest
                         */
                        UpdateMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest();
                            if (object.measurementProtocolSecret != null) {
                                if (typeof object.measurementProtocolSecret !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest.measurementProtocolSecret: object expected");
                                message.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecret);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest} message UpdateMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.measurementProtocolSecret = null;
                                object.updateMask = null;
                            }
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret"))
                                object.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.toObject(message.measurementProtocolSecret, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateMeasurementProtocolSecretRequest";
                        };
    
                        return UpdateMeasurementProtocolSecretRequest;
                    })();
    
                    v1alpha.ListMeasurementProtocolSecretsRequest = (function() {
    
                        /**
                         * Properties of a ListMeasurementProtocolSecretsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListMeasurementProtocolSecretsRequest
                         * @property {string|null} [parent] ListMeasurementProtocolSecretsRequest parent
                         * @property {number|null} [pageSize] ListMeasurementProtocolSecretsRequest pageSize
                         * @property {string|null} [pageToken] ListMeasurementProtocolSecretsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListMeasurementProtocolSecretsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListMeasurementProtocolSecretsRequest.
                         * @implements IListMeasurementProtocolSecretsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsRequest=} [properties] Properties to set
                         */
                        function ListMeasurementProtocolSecretsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListMeasurementProtocolSecretsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @instance
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.parent = "";
    
                        /**
                         * ListMeasurementProtocolSecretsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @instance
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListMeasurementProtocolSecretsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @instance
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListMeasurementProtocolSecretsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest instance
                         */
                        ListMeasurementProtocolSecretsRequest.create = function create(properties) {
                            return new ListMeasurementProtocolSecretsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsRequest} message ListMeasurementProtocolSecretsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsRequest} message ListMeasurementProtocolSecretsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListMeasurementProtocolSecretsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMeasurementProtocolSecretsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListMeasurementProtocolSecretsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest
                         */
                        ListMeasurementProtocolSecretsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListMeasurementProtocolSecretsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest} message ListMeasurementProtocolSecretsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMeasurementProtocolSecretsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListMeasurementProtocolSecretsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListMeasurementProtocolSecretsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListMeasurementProtocolSecretsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsRequest";
                        };
    
                        return ListMeasurementProtocolSecretsRequest;
                    })();
    
                    v1alpha.ListMeasurementProtocolSecretsResponse = (function() {
    
                        /**
                         * Properties of a ListMeasurementProtocolSecretsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListMeasurementProtocolSecretsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IMeasurementProtocolSecret>|null} [measurementProtocolSecrets] ListMeasurementProtocolSecretsResponse measurementProtocolSecrets
                         * @property {string|null} [nextPageToken] ListMeasurementProtocolSecretsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListMeasurementProtocolSecretsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListMeasurementProtocolSecretsResponse.
                         * @implements IListMeasurementProtocolSecretsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsResponse=} [properties] Properties to set
                         */
                        function ListMeasurementProtocolSecretsResponse(properties) {
                            this.measurementProtocolSecrets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListMeasurementProtocolSecretsResponse measurementProtocolSecrets.
                         * @member {Array.<google.analytics.admin.v1alpha.IMeasurementProtocolSecret>} measurementProtocolSecrets
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @instance
                         */
                        ListMeasurementProtocolSecretsResponse.prototype.measurementProtocolSecrets = $util.emptyArray;
    
                        /**
                         * ListMeasurementProtocolSecretsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @instance
                         */
                        ListMeasurementProtocolSecretsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListMeasurementProtocolSecretsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse instance
                         */
                        ListMeasurementProtocolSecretsResponse.create = function create(properties) {
                            return new ListMeasurementProtocolSecretsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsResponse} message ListMeasurementProtocolSecretsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.measurementProtocolSecrets != null && message.measurementProtocolSecrets.length)
                                for (var i = 0; i < message.measurementProtocolSecrets.length; ++i)
                                    $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.encode(message.measurementProtocolSecrets[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListMeasurementProtocolSecretsResponse} message ListMeasurementProtocolSecretsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.measurementProtocolSecrets && message.measurementProtocolSecrets.length))
                                            message.measurementProtocolSecrets = [];
                                        message.measurementProtocolSecrets.push($root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListMeasurementProtocolSecretsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMeasurementProtocolSecretsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.measurementProtocolSecrets != null && message.hasOwnProperty("measurementProtocolSecrets")) {
                                if (!Array.isArray(message.measurementProtocolSecrets))
                                    return "measurementProtocolSecrets: array expected";
                                for (var i = 0; i < message.measurementProtocolSecrets.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.verify(message.measurementProtocolSecrets[i]);
                                    if (error)
                                        return "measurementProtocolSecrets." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListMeasurementProtocolSecretsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse
                         */
                        ListMeasurementProtocolSecretsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse();
                            if (object.measurementProtocolSecrets) {
                                if (!Array.isArray(object.measurementProtocolSecrets))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse.measurementProtocolSecrets: array expected");
                                message.measurementProtocolSecrets = [];
                                for (var i = 0; i < object.measurementProtocolSecrets.length; ++i) {
                                    if (typeof object.measurementProtocolSecrets[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse.measurementProtocolSecrets: object expected");
                                    message.measurementProtocolSecrets[i] = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecrets[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListMeasurementProtocolSecretsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse} message ListMeasurementProtocolSecretsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMeasurementProtocolSecretsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.measurementProtocolSecrets = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.measurementProtocolSecrets && message.measurementProtocolSecrets.length) {
                                object.measurementProtocolSecrets = [];
                                for (var j = 0; j < message.measurementProtocolSecrets.length; ++j)
                                    object.measurementProtocolSecrets[j] = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.toObject(message.measurementProtocolSecrets[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListMeasurementProtocolSecretsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMeasurementProtocolSecretsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListMeasurementProtocolSecretsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListMeasurementProtocolSecretsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListMeasurementProtocolSecretsResponse";
                        };
    
                        return ListMeasurementProtocolSecretsResponse;
                    })();
    
                    v1alpha.GetGoogleSignalsSettingsRequest = (function() {
    
                        /**
                         * Properties of a GetGoogleSignalsSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetGoogleSignalsSettingsRequest
                         * @property {string|null} [name] GetGoogleSignalsSettingsRequest name
                         */
    
                        /**
                         * Constructs a new GetGoogleSignalsSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetGoogleSignalsSettingsRequest.
                         * @implements IGetGoogleSignalsSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetGoogleSignalsSettingsRequest=} [properties] Properties to set
                         */
                        function GetGoogleSignalsSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGoogleSignalsSettingsRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @instance
                         */
                        GetGoogleSignalsSettingsRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetGoogleSignalsSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetGoogleSignalsSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest} GetGoogleSignalsSettingsRequest instance
                         */
                        GetGoogleSignalsSettingsRequest.create = function create(properties) {
                            return new GetGoogleSignalsSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGoogleSignalsSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetGoogleSignalsSettingsRequest} message GetGoogleSignalsSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGoogleSignalsSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGoogleSignalsSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetGoogleSignalsSettingsRequest} message GetGoogleSignalsSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGoogleSignalsSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGoogleSignalsSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest} GetGoogleSignalsSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGoogleSignalsSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGoogleSignalsSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest} GetGoogleSignalsSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGoogleSignalsSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGoogleSignalsSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGoogleSignalsSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGoogleSignalsSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest} GetGoogleSignalsSettingsRequest
                         */
                        GetGoogleSignalsSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGoogleSignalsSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest} message GetGoogleSignalsSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGoogleSignalsSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetGoogleSignalsSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGoogleSignalsSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGoogleSignalsSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGoogleSignalsSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetGoogleSignalsSettingsRequest";
                        };
    
                        return GetGoogleSignalsSettingsRequest;
                    })();
    
                    v1alpha.UpdateGoogleSignalsSettingsRequest = (function() {
    
                        /**
                         * Properties of an UpdateGoogleSignalsSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateGoogleSignalsSettingsRequest
                         * @property {google.analytics.admin.v1alpha.IGoogleSignalsSettings|null} [googleSignalsSettings] UpdateGoogleSignalsSettingsRequest googleSignalsSettings
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateGoogleSignalsSettingsRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateGoogleSignalsSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateGoogleSignalsSettingsRequest.
                         * @implements IUpdateGoogleSignalsSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleSignalsSettingsRequest=} [properties] Properties to set
                         */
                        function UpdateGoogleSignalsSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateGoogleSignalsSettingsRequest googleSignalsSettings.
                         * @member {google.analytics.admin.v1alpha.IGoogleSignalsSettings|null|undefined} googleSignalsSettings
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @instance
                         */
                        UpdateGoogleSignalsSettingsRequest.prototype.googleSignalsSettings = null;
    
                        /**
                         * UpdateGoogleSignalsSettingsRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @instance
                         */
                        UpdateGoogleSignalsSettingsRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateGoogleSignalsSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleSignalsSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest} UpdateGoogleSignalsSettingsRequest instance
                         */
                        UpdateGoogleSignalsSettingsRequest.create = function create(properties) {
                            return new UpdateGoogleSignalsSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateGoogleSignalsSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleSignalsSettingsRequest} message UpdateGoogleSignalsSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateGoogleSignalsSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleSignalsSettings != null && Object.hasOwnProperty.call(message, "googleSignalsSettings"))
                                $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.encode(message.googleSignalsSettings, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateGoogleSignalsSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateGoogleSignalsSettingsRequest} message UpdateGoogleSignalsSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateGoogleSignalsSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateGoogleSignalsSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest} UpdateGoogleSignalsSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateGoogleSignalsSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.googleSignalsSettings = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateGoogleSignalsSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest} UpdateGoogleSignalsSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateGoogleSignalsSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateGoogleSignalsSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateGoogleSignalsSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.googleSignalsSettings != null && message.hasOwnProperty("googleSignalsSettings")) {
                                var error = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.verify(message.googleSignalsSettings);
                                if (error)
                                    return "googleSignalsSettings." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateGoogleSignalsSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest} UpdateGoogleSignalsSettingsRequest
                         */
                        UpdateGoogleSignalsSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest();
                            if (object.googleSignalsSettings != null) {
                                if (typeof object.googleSignalsSettings !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest.googleSignalsSettings: object expected");
                                message.googleSignalsSettings = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.fromObject(object.googleSignalsSettings);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateGoogleSignalsSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest} message UpdateGoogleSignalsSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateGoogleSignalsSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.googleSignalsSettings = null;
                                object.updateMask = null;
                            }
                            if (message.googleSignalsSettings != null && message.hasOwnProperty("googleSignalsSettings"))
                                object.googleSignalsSettings = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.toObject(message.googleSignalsSettings, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateGoogleSignalsSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateGoogleSignalsSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateGoogleSignalsSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateGoogleSignalsSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateGoogleSignalsSettingsRequest";
                        };
    
                        return UpdateGoogleSignalsSettingsRequest;
                    })();
    
                    v1alpha.CreateConversionEventRequest = (function() {
    
                        /**
                         * Properties of a CreateConversionEventRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateConversionEventRequest
                         * @property {google.analytics.admin.v1alpha.IConversionEvent|null} [conversionEvent] CreateConversionEventRequest conversionEvent
                         * @property {string|null} [parent] CreateConversionEventRequest parent
                         */
    
                        /**
                         * Constructs a new CreateConversionEventRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateConversionEventRequest.
                         * @implements ICreateConversionEventRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateConversionEventRequest=} [properties] Properties to set
                         */
                        function CreateConversionEventRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateConversionEventRequest conversionEvent.
                         * @member {google.analytics.admin.v1alpha.IConversionEvent|null|undefined} conversionEvent
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @instance
                         */
                        CreateConversionEventRequest.prototype.conversionEvent = null;
    
                        /**
                         * CreateConversionEventRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @instance
                         */
                        CreateConversionEventRequest.prototype.parent = "";
    
                        /**
                         * Creates a new CreateConversionEventRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConversionEventRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateConversionEventRequest} CreateConversionEventRequest instance
                         */
                        CreateConversionEventRequest.create = function create(properties) {
                            return new CreateConversionEventRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateConversionEventRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateConversionEventRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConversionEventRequest} message CreateConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConversionEventRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.conversionEvent != null && Object.hasOwnProperty.call(message, "conversionEvent"))
                                $root.google.analytics.admin.v1alpha.ConversionEvent.encode(message.conversionEvent, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parent);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateConversionEventRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateConversionEventRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConversionEventRequest} message CreateConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConversionEventRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateConversionEventRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateConversionEventRequest} CreateConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConversionEventRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateConversionEventRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.conversionEvent = $root.google.analytics.admin.v1alpha.ConversionEvent.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateConversionEventRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateConversionEventRequest} CreateConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConversionEventRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateConversionEventRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateConversionEventRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent")) {
                                var error = $root.google.analytics.admin.v1alpha.ConversionEvent.verify(message.conversionEvent);
                                if (error)
                                    return "conversionEvent." + error;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a CreateConversionEventRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateConversionEventRequest} CreateConversionEventRequest
                         */
                        CreateConversionEventRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateConversionEventRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateConversionEventRequest();
                            if (object.conversionEvent != null) {
                                if (typeof object.conversionEvent !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateConversionEventRequest.conversionEvent: object expected");
                                message.conversionEvent = $root.google.analytics.admin.v1alpha.ConversionEvent.fromObject(object.conversionEvent);
                            }
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateConversionEventRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateConversionEventRequest} message CreateConversionEventRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateConversionEventRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.conversionEvent = null;
                                object.parent = "";
                            }
                            if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent"))
                                object.conversionEvent = $root.google.analytics.admin.v1alpha.ConversionEvent.toObject(message.conversionEvent, options);
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            return object;
                        };
    
                        /**
                         * Converts this CreateConversionEventRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateConversionEventRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateConversionEventRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateConversionEventRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateConversionEventRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateConversionEventRequest";
                        };
    
                        return CreateConversionEventRequest;
                    })();
    
                    v1alpha.GetConversionEventRequest = (function() {
    
                        /**
                         * Properties of a GetConversionEventRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetConversionEventRequest
                         * @property {string|null} [name] GetConversionEventRequest name
                         */
    
                        /**
                         * Constructs a new GetConversionEventRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetConversionEventRequest.
                         * @implements IGetConversionEventRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetConversionEventRequest=} [properties] Properties to set
                         */
                        function GetConversionEventRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetConversionEventRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @instance
                         */
                        GetConversionEventRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetConversionEventRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetConversionEventRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetConversionEventRequest} GetConversionEventRequest instance
                         */
                        GetConversionEventRequest.create = function create(properties) {
                            return new GetConversionEventRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetConversionEventRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetConversionEventRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetConversionEventRequest} message GetConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetConversionEventRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetConversionEventRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetConversionEventRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetConversionEventRequest} message GetConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetConversionEventRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetConversionEventRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetConversionEventRequest} GetConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetConversionEventRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetConversionEventRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetConversionEventRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetConversionEventRequest} GetConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetConversionEventRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetConversionEventRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetConversionEventRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetConversionEventRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetConversionEventRequest} GetConversionEventRequest
                         */
                        GetConversionEventRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetConversionEventRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetConversionEventRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetConversionEventRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetConversionEventRequest} message GetConversionEventRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetConversionEventRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetConversionEventRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetConversionEventRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetConversionEventRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetConversionEventRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetConversionEventRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetConversionEventRequest";
                        };
    
                        return GetConversionEventRequest;
                    })();
    
                    v1alpha.DeleteConversionEventRequest = (function() {
    
                        /**
                         * Properties of a DeleteConversionEventRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteConversionEventRequest
                         * @property {string|null} [name] DeleteConversionEventRequest name
                         */
    
                        /**
                         * Constructs a new DeleteConversionEventRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteConversionEventRequest.
                         * @implements IDeleteConversionEventRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteConversionEventRequest=} [properties] Properties to set
                         */
                        function DeleteConversionEventRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteConversionEventRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @instance
                         */
                        DeleteConversionEventRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteConversionEventRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteConversionEventRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteConversionEventRequest} DeleteConversionEventRequest instance
                         */
                        DeleteConversionEventRequest.create = function create(properties) {
                            return new DeleteConversionEventRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteConversionEventRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteConversionEventRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteConversionEventRequest} message DeleteConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteConversionEventRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteConversionEventRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteConversionEventRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteConversionEventRequest} message DeleteConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteConversionEventRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteConversionEventRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteConversionEventRequest} DeleteConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteConversionEventRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteConversionEventRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteConversionEventRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteConversionEventRequest} DeleteConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteConversionEventRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteConversionEventRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteConversionEventRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteConversionEventRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteConversionEventRequest} DeleteConversionEventRequest
                         */
                        DeleteConversionEventRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteConversionEventRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteConversionEventRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteConversionEventRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteConversionEventRequest} message DeleteConversionEventRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteConversionEventRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteConversionEventRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteConversionEventRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteConversionEventRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteConversionEventRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteConversionEventRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteConversionEventRequest";
                        };
    
                        return DeleteConversionEventRequest;
                    })();
    
                    v1alpha.ListConversionEventsRequest = (function() {
    
                        /**
                         * Properties of a ListConversionEventsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListConversionEventsRequest
                         * @property {string|null} [parent] ListConversionEventsRequest parent
                         * @property {number|null} [pageSize] ListConversionEventsRequest pageSize
                         * @property {string|null} [pageToken] ListConversionEventsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListConversionEventsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListConversionEventsRequest.
                         * @implements IListConversionEventsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsRequest=} [properties] Properties to set
                         */
                        function ListConversionEventsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListConversionEventsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @instance
                         */
                        ListConversionEventsRequest.prototype.parent = "";
    
                        /**
                         * ListConversionEventsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @instance
                         */
                        ListConversionEventsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListConversionEventsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @instance
                         */
                        ListConversionEventsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListConversionEventsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsRequest} ListConversionEventsRequest instance
                         */
                        ListConversionEventsRequest.create = function create(properties) {
                            return new ListConversionEventsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListConversionEventsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsRequest} message ListConversionEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListConversionEventsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsRequest} message ListConversionEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListConversionEventsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsRequest} ListConversionEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListConversionEventsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListConversionEventsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsRequest} ListConversionEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListConversionEventsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListConversionEventsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListConversionEventsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsRequest} ListConversionEventsRequest
                         */
                        ListConversionEventsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListConversionEventsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListConversionEventsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListConversionEventsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListConversionEventsRequest} message ListConversionEventsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListConversionEventsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListConversionEventsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListConversionEventsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListConversionEventsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListConversionEventsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListConversionEventsRequest";
                        };
    
                        return ListConversionEventsRequest;
                    })();
    
                    v1alpha.ListConversionEventsResponse = (function() {
    
                        /**
                         * Properties of a ListConversionEventsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListConversionEventsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IConversionEvent>|null} [conversionEvents] ListConversionEventsResponse conversionEvents
                         * @property {string|null} [nextPageToken] ListConversionEventsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListConversionEventsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListConversionEventsResponse.
                         * @implements IListConversionEventsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsResponse=} [properties] Properties to set
                         */
                        function ListConversionEventsResponse(properties) {
                            this.conversionEvents = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListConversionEventsResponse conversionEvents.
                         * @member {Array.<google.analytics.admin.v1alpha.IConversionEvent>} conversionEvents
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @instance
                         */
                        ListConversionEventsResponse.prototype.conversionEvents = $util.emptyArray;
    
                        /**
                         * ListConversionEventsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @instance
                         */
                        ListConversionEventsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListConversionEventsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsResponse} ListConversionEventsResponse instance
                         */
                        ListConversionEventsResponse.create = function create(properties) {
                            return new ListConversionEventsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListConversionEventsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsResponse} message ListConversionEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.conversionEvents != null && message.conversionEvents.length)
                                for (var i = 0; i < message.conversionEvents.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ConversionEvent.encode(message.conversionEvents[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListConversionEventsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConversionEventsResponse} message ListConversionEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListConversionEventsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsResponse} ListConversionEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListConversionEventsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.conversionEvents && message.conversionEvents.length))
                                            message.conversionEvents = [];
                                        message.conversionEvents.push($root.google.analytics.admin.v1alpha.ConversionEvent.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListConversionEventsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsResponse} ListConversionEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListConversionEventsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListConversionEventsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.conversionEvents != null && message.hasOwnProperty("conversionEvents")) {
                                if (!Array.isArray(message.conversionEvents))
                                    return "conversionEvents: array expected";
                                for (var i = 0; i < message.conversionEvents.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ConversionEvent.verify(message.conversionEvents[i]);
                                    if (error)
                                        return "conversionEvents." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListConversionEventsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListConversionEventsResponse} ListConversionEventsResponse
                         */
                        ListConversionEventsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListConversionEventsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListConversionEventsResponse();
                            if (object.conversionEvents) {
                                if (!Array.isArray(object.conversionEvents))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListConversionEventsResponse.conversionEvents: array expected");
                                message.conversionEvents = [];
                                for (var i = 0; i < object.conversionEvents.length; ++i) {
                                    if (typeof object.conversionEvents[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListConversionEventsResponse.conversionEvents: object expected");
                                    message.conversionEvents[i] = $root.google.analytics.admin.v1alpha.ConversionEvent.fromObject(object.conversionEvents[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListConversionEventsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListConversionEventsResponse} message ListConversionEventsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListConversionEventsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.conversionEvents = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.conversionEvents && message.conversionEvents.length) {
                                object.conversionEvents = [];
                                for (var j = 0; j < message.conversionEvents.length; ++j)
                                    object.conversionEvents[j] = $root.google.analytics.admin.v1alpha.ConversionEvent.toObject(message.conversionEvents[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListConversionEventsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListConversionEventsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListConversionEventsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListConversionEventsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListConversionEventsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListConversionEventsResponse";
                        };
    
                        return ListConversionEventsResponse;
                    })();
    
                    v1alpha.GetDisplayVideo360AdvertiserLinkRequest = (function() {
    
                        /**
                         * Properties of a GetDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetDisplayVideo360AdvertiserLinkRequest
                         * @property {string|null} [name] GetDisplayVideo360AdvertiserLinkRequest name
                         */
    
                        /**
                         * Constructs a new GetDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetDisplayVideo360AdvertiserLinkRequest.
                         * @implements IGetDisplayVideo360AdvertiserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         */
                        function GetDisplayVideo360AdvertiserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDisplayVideo360AdvertiserLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDisplayVideo360AdvertiserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest} GetDisplayVideo360AdvertiserLinkRequest instance
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.create = function create(properties) {
                            return new GetDisplayVideo360AdvertiserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDisplayVideo360AdvertiserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkRequest} message GetDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDisplayVideo360AdvertiserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkRequest} message GetDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest} GetDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest} GetDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDisplayVideo360AdvertiserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDisplayVideo360AdvertiserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest} GetDisplayVideo360AdvertiserLinkRequest
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDisplayVideo360AdvertiserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest} message GetDisplayVideo360AdvertiserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDisplayVideo360AdvertiserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDisplayVideo360AdvertiserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDisplayVideo360AdvertiserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkRequest";
                        };
    
                        return GetDisplayVideo360AdvertiserLinkRequest;
                    })();
    
                    v1alpha.ListDisplayVideo360AdvertiserLinksRequest = (function() {
    
                        /**
                         * Properties of a ListDisplayVideo360AdvertiserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListDisplayVideo360AdvertiserLinksRequest
                         * @property {string|null} [parent] ListDisplayVideo360AdvertiserLinksRequest parent
                         * @property {number|null} [pageSize] ListDisplayVideo360AdvertiserLinksRequest pageSize
                         * @property {string|null} [pageToken] ListDisplayVideo360AdvertiserLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListDisplayVideo360AdvertiserLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListDisplayVideo360AdvertiserLinksRequest.
                         * @implements IListDisplayVideo360AdvertiserLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksRequest=} [properties] Properties to set
                         */
                        function ListDisplayVideo360AdvertiserLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDisplayVideo360AdvertiserLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.prototype.parent = "";
    
                        /**
                         * ListDisplayVideo360AdvertiserLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListDisplayVideo360AdvertiserLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListDisplayVideo360AdvertiserLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest} ListDisplayVideo360AdvertiserLinksRequest instance
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.create = function create(properties) {
                            return new ListDisplayVideo360AdvertiserLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksRequest} message ListDisplayVideo360AdvertiserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksRequest} message ListDisplayVideo360AdvertiserLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest} ListDisplayVideo360AdvertiserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest} ListDisplayVideo360AdvertiserLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDisplayVideo360AdvertiserLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDisplayVideo360AdvertiserLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest} ListDisplayVideo360AdvertiserLinksRequest
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDisplayVideo360AdvertiserLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest} message ListDisplayVideo360AdvertiserLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDisplayVideo360AdvertiserLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDisplayVideo360AdvertiserLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDisplayVideo360AdvertiserLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksRequest";
                        };
    
                        return ListDisplayVideo360AdvertiserLinksRequest;
                    })();
    
                    v1alpha.ListDisplayVideo360AdvertiserLinksResponse = (function() {
    
                        /**
                         * Properties of a ListDisplayVideo360AdvertiserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListDisplayVideo360AdvertiserLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink>|null} [displayVideo_360AdvertiserLinks] ListDisplayVideo360AdvertiserLinksResponse displayVideo_360AdvertiserLinks
                         * @property {string|null} [nextPageToken] ListDisplayVideo360AdvertiserLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListDisplayVideo360AdvertiserLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListDisplayVideo360AdvertiserLinksResponse.
                         * @implements IListDisplayVideo360AdvertiserLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksResponse=} [properties] Properties to set
                         */
                        function ListDisplayVideo360AdvertiserLinksResponse(properties) {
                            this.displayVideo_360AdvertiserLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDisplayVideo360AdvertiserLinksResponse displayVideo_360AdvertiserLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink>} displayVideo_360AdvertiserLinks
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.prototype.displayVideo_360AdvertiserLinks = $util.emptyArray;
    
                        /**
                         * ListDisplayVideo360AdvertiserLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListDisplayVideo360AdvertiserLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse} ListDisplayVideo360AdvertiserLinksResponse instance
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.create = function create(properties) {
                            return new ListDisplayVideo360AdvertiserLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksResponse} message ListDisplayVideo360AdvertiserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.displayVideo_360AdvertiserLinks != null && message.displayVideo_360AdvertiserLinks.length)
                                for (var i = 0; i < message.displayVideo_360AdvertiserLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.encode(message.displayVideo_360AdvertiserLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinksResponse} message ListDisplayVideo360AdvertiserLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse} ListDisplayVideo360AdvertiserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.displayVideo_360AdvertiserLinks && message.displayVideo_360AdvertiserLinks.length))
                                            message.displayVideo_360AdvertiserLinks = [];
                                        message.displayVideo_360AdvertiserLinks.push($root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse} ListDisplayVideo360AdvertiserLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDisplayVideo360AdvertiserLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.displayVideo_360AdvertiserLinks != null && message.hasOwnProperty("displayVideo_360AdvertiserLinks")) {
                                if (!Array.isArray(message.displayVideo_360AdvertiserLinks))
                                    return "displayVideo_360AdvertiserLinks: array expected";
                                for (var i = 0; i < message.displayVideo_360AdvertiserLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.verify(message.displayVideo_360AdvertiserLinks[i]);
                                    if (error)
                                        return "displayVideo_360AdvertiserLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDisplayVideo360AdvertiserLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse} ListDisplayVideo360AdvertiserLinksResponse
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse();
                            if (object.displayVideo_360AdvertiserLinks) {
                                if (!Array.isArray(object.displayVideo_360AdvertiserLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse.displayVideo_360AdvertiserLinks: array expected");
                                message.displayVideo_360AdvertiserLinks = [];
                                for (var i = 0; i < object.displayVideo_360AdvertiserLinks.length; ++i) {
                                    if (typeof object.displayVideo_360AdvertiserLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse.displayVideo_360AdvertiserLinks: object expected");
                                    message.displayVideo_360AdvertiserLinks[i] = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.fromObject(object.displayVideo_360AdvertiserLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDisplayVideo360AdvertiserLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse} message ListDisplayVideo360AdvertiserLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.displayVideo_360AdvertiserLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.displayVideo_360AdvertiserLinks && message.displayVideo_360AdvertiserLinks.length) {
                                object.displayVideo_360AdvertiserLinks = [];
                                for (var j = 0; j < message.displayVideo_360AdvertiserLinks.length; ++j)
                                    object.displayVideo_360AdvertiserLinks[j] = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.toObject(message.displayVideo_360AdvertiserLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDisplayVideo360AdvertiserLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDisplayVideo360AdvertiserLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDisplayVideo360AdvertiserLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinksResponse";
                        };
    
                        return ListDisplayVideo360AdvertiserLinksResponse;
                    })();
    
                    v1alpha.CreateDisplayVideo360AdvertiserLinkRequest = (function() {
    
                        /**
                         * Properties of a CreateDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateDisplayVideo360AdvertiserLinkRequest
                         * @property {string|null} [parent] CreateDisplayVideo360AdvertiserLinkRequest parent
                         * @property {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null} [displayVideo_360AdvertiserLink] CreateDisplayVideo360AdvertiserLinkRequest displayVideo_360AdvertiserLink
                         */
    
                        /**
                         * Constructs a new CreateDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateDisplayVideo360AdvertiserLinkRequest.
                         * @implements ICreateDisplayVideo360AdvertiserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         */
                        function CreateDisplayVideo360AdvertiserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateDisplayVideo360AdvertiserLinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.prototype.parent = "";
    
                        /**
                         * CreateDisplayVideo360AdvertiserLinkRequest displayVideo_360AdvertiserLink.
                         * @member {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null|undefined} displayVideo_360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.prototype.displayVideo_360AdvertiserLink = null;
    
                        /**
                         * Creates a new CreateDisplayVideo360AdvertiserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest} CreateDisplayVideo360AdvertiserLinkRequest instance
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.create = function create(properties) {
                            return new CreateDisplayVideo360AdvertiserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateDisplayVideo360AdvertiserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkRequest} message CreateDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.displayVideo_360AdvertiserLink != null && Object.hasOwnProperty.call(message, "displayVideo_360AdvertiserLink"))
                                $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.encode(message.displayVideo_360AdvertiserLink, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateDisplayVideo360AdvertiserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkRequest} message CreateDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest} CreateDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest} CreateDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateDisplayVideo360AdvertiserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink")) {
                                var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.verify(message.displayVideo_360AdvertiserLink);
                                if (error)
                                    return "displayVideo_360AdvertiserLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateDisplayVideo360AdvertiserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest} CreateDisplayVideo360AdvertiserLinkRequest
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.displayVideo_360AdvertiserLink != null) {
                                if (typeof object.displayVideo_360AdvertiserLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest.displayVideo_360AdvertiserLink: object expected");
                                message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.fromObject(object.displayVideo_360AdvertiserLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateDisplayVideo360AdvertiserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest} message CreateDisplayVideo360AdvertiserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.displayVideo_360AdvertiserLink = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink"))
                                object.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.toObject(message.displayVideo_360AdvertiserLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateDisplayVideo360AdvertiserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateDisplayVideo360AdvertiserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateDisplayVideo360AdvertiserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkRequest";
                        };
    
                        return CreateDisplayVideo360AdvertiserLinkRequest;
                    })();
    
                    v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteDisplayVideo360AdvertiserLinkRequest
                         * @property {string|null} [name] DeleteDisplayVideo360AdvertiserLinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteDisplayVideo360AdvertiserLinkRequest.
                         * @implements IDeleteDisplayVideo360AdvertiserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         */
                        function DeleteDisplayVideo360AdvertiserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteDisplayVideo360AdvertiserLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteDisplayVideo360AdvertiserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest} DeleteDisplayVideo360AdvertiserLinkRequest instance
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.create = function create(properties) {
                            return new DeleteDisplayVideo360AdvertiserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteDisplayVideo360AdvertiserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkRequest} message DeleteDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteDisplayVideo360AdvertiserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkRequest} message DeleteDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest} DeleteDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest} DeleteDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteDisplayVideo360AdvertiserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteDisplayVideo360AdvertiserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest} DeleteDisplayVideo360AdvertiserLinkRequest
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteDisplayVideo360AdvertiserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest} message DeleteDisplayVideo360AdvertiserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteDisplayVideo360AdvertiserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteDisplayVideo360AdvertiserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteDisplayVideo360AdvertiserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkRequest";
                        };
    
                        return DeleteDisplayVideo360AdvertiserLinkRequest;
                    })();
    
                    v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest = (function() {
    
                        /**
                         * Properties of an UpdateDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateDisplayVideo360AdvertiserLinkRequest
                         * @property {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null} [displayVideo_360AdvertiserLink] UpdateDisplayVideo360AdvertiserLinkRequest displayVideo_360AdvertiserLink
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateDisplayVideo360AdvertiserLinkRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateDisplayVideo360AdvertiserLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateDisplayVideo360AdvertiserLinkRequest.
                         * @implements IUpdateDisplayVideo360AdvertiserLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         */
                        function UpdateDisplayVideo360AdvertiserLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateDisplayVideo360AdvertiserLinkRequest displayVideo_360AdvertiserLink.
                         * @member {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null|undefined} displayVideo_360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.prototype.displayVideo_360AdvertiserLink = null;
    
                        /**
                         * UpdateDisplayVideo360AdvertiserLinkRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateDisplayVideo360AdvertiserLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDisplayVideo360AdvertiserLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest} UpdateDisplayVideo360AdvertiserLinkRequest instance
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.create = function create(properties) {
                            return new UpdateDisplayVideo360AdvertiserLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateDisplayVideo360AdvertiserLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDisplayVideo360AdvertiserLinkRequest} message UpdateDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.displayVideo_360AdvertiserLink != null && Object.hasOwnProperty.call(message, "displayVideo_360AdvertiserLink"))
                                $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.encode(message.displayVideo_360AdvertiserLink, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateDisplayVideo360AdvertiserLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDisplayVideo360AdvertiserLinkRequest} message UpdateDisplayVideo360AdvertiserLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest} UpdateDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateDisplayVideo360AdvertiserLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest} UpdateDisplayVideo360AdvertiserLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateDisplayVideo360AdvertiserLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink")) {
                                var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.verify(message.displayVideo_360AdvertiserLink);
                                if (error)
                                    return "displayVideo_360AdvertiserLink." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateDisplayVideo360AdvertiserLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest} UpdateDisplayVideo360AdvertiserLinkRequest
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest();
                            if (object.displayVideo_360AdvertiserLink != null) {
                                if (typeof object.displayVideo_360AdvertiserLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest.displayVideo_360AdvertiserLink: object expected");
                                message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.fromObject(object.displayVideo_360AdvertiserLink);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateDisplayVideo360AdvertiserLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest} message UpdateDisplayVideo360AdvertiserLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.displayVideo_360AdvertiserLink = null;
                                object.updateMask = null;
                            }
                            if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink"))
                                object.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.toObject(message.displayVideo_360AdvertiserLink, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateDisplayVideo360AdvertiserLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateDisplayVideo360AdvertiserLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateDisplayVideo360AdvertiserLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateDisplayVideo360AdvertiserLinkRequest";
                        };
    
                        return UpdateDisplayVideo360AdvertiserLinkRequest;
                    })();
    
                    v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest = (function() {
    
                        /**
                         * Properties of a GetDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetDisplayVideo360AdvertiserLinkProposalRequest
                         * @property {string|null} [name] GetDisplayVideo360AdvertiserLinkProposalRequest name
                         */
    
                        /**
                         * Constructs a new GetDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetDisplayVideo360AdvertiserLinkProposalRequest.
                         * @implements IGetDisplayVideo360AdvertiserLinkProposalRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         */
                        function GetDisplayVideo360AdvertiserLinkProposalRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDisplayVideo360AdvertiserLinkProposalRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDisplayVideo360AdvertiserLinkProposalRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest} GetDisplayVideo360AdvertiserLinkProposalRequest instance
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.create = function create(properties) {
                            return new GetDisplayVideo360AdvertiserLinkProposalRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDisplayVideo360AdvertiserLinkProposalRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkProposalRequest} message GetDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDisplayVideo360AdvertiserLinkProposalRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDisplayVideo360AdvertiserLinkProposalRequest} message GetDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest} GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest} GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDisplayVideo360AdvertiserLinkProposalRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDisplayVideo360AdvertiserLinkProposalRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest} GetDisplayVideo360AdvertiserLinkProposalRequest
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDisplayVideo360AdvertiserLinkProposalRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest} message GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDisplayVideo360AdvertiserLinkProposalRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDisplayVideo360AdvertiserLinkProposalRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetDisplayVideo360AdvertiserLinkProposalRequest";
                        };
    
                        return GetDisplayVideo360AdvertiserLinkProposalRequest;
                    })();
    
                    v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest = (function() {
    
                        /**
                         * Properties of a ListDisplayVideo360AdvertiserLinkProposalsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @property {string|null} [parent] ListDisplayVideo360AdvertiserLinkProposalsRequest parent
                         * @property {number|null} [pageSize] ListDisplayVideo360AdvertiserLinkProposalsRequest pageSize
                         * @property {string|null} [pageToken] ListDisplayVideo360AdvertiserLinkProposalsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListDisplayVideo360AdvertiserLinkProposalsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListDisplayVideo360AdvertiserLinkProposalsRequest.
                         * @implements IListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsRequest=} [properties] Properties to set
                         */
                        function ListDisplayVideo360AdvertiserLinkProposalsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDisplayVideo360AdvertiserLinkProposalsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.prototype.parent = "";
    
                        /**
                         * ListDisplayVideo360AdvertiserLinkProposalsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListDisplayVideo360AdvertiserLinkProposalsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListDisplayVideo360AdvertiserLinkProposalsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest} ListDisplayVideo360AdvertiserLinkProposalsRequest instance
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.create = function create(properties) {
                            return new ListDisplayVideo360AdvertiserLinkProposalsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinkProposalsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsRequest} message ListDisplayVideo360AdvertiserLinkProposalsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinkProposalsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsRequest} message ListDisplayVideo360AdvertiserLinkProposalsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinkProposalsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest} ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinkProposalsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest} ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDisplayVideo360AdvertiserLinkProposalsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDisplayVideo360AdvertiserLinkProposalsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest} ListDisplayVideo360AdvertiserLinkProposalsRequest
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDisplayVideo360AdvertiserLinkProposalsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest} message ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDisplayVideo360AdvertiserLinkProposalsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsRequest";
                        };
    
                        return ListDisplayVideo360AdvertiserLinkProposalsRequest;
                    })();
    
                    v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse = (function() {
    
                        /**
                         * Properties of a ListDisplayVideo360AdvertiserLinkProposalsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal>|null} [displayVideo_360AdvertiserLinkProposals] ListDisplayVideo360AdvertiserLinkProposalsResponse displayVideo_360AdvertiserLinkProposals
                         * @property {string|null} [nextPageToken] ListDisplayVideo360AdvertiserLinkProposalsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListDisplayVideo360AdvertiserLinkProposalsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListDisplayVideo360AdvertiserLinkProposalsResponse.
                         * @implements IListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsResponse=} [properties] Properties to set
                         */
                        function ListDisplayVideo360AdvertiserLinkProposalsResponse(properties) {
                            this.displayVideo_360AdvertiserLinkProposals = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDisplayVideo360AdvertiserLinkProposalsResponse displayVideo_360AdvertiserLinkProposals.
                         * @member {Array.<google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal>} displayVideo_360AdvertiserLinkProposals
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.prototype.displayVideo_360AdvertiserLinkProposals = $util.emptyArray;
    
                        /**
                         * ListDisplayVideo360AdvertiserLinkProposalsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @instance
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListDisplayVideo360AdvertiserLinkProposalsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse} ListDisplayVideo360AdvertiserLinkProposalsResponse instance
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.create = function create(properties) {
                            return new ListDisplayVideo360AdvertiserLinkProposalsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinkProposalsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsResponse} message ListDisplayVideo360AdvertiserLinkProposalsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.displayVideo_360AdvertiserLinkProposals != null && message.displayVideo_360AdvertiserLinkProposals.length)
                                for (var i = 0; i < message.displayVideo_360AdvertiserLinkProposals.length; ++i)
                                    $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.encode(message.displayVideo_360AdvertiserLinkProposals[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDisplayVideo360AdvertiserLinkProposalsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDisplayVideo360AdvertiserLinkProposalsResponse} message ListDisplayVideo360AdvertiserLinkProposalsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinkProposalsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse} ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.displayVideo_360AdvertiserLinkProposals && message.displayVideo_360AdvertiserLinkProposals.length))
                                            message.displayVideo_360AdvertiserLinkProposals = [];
                                        message.displayVideo_360AdvertiserLinkProposals.push($root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDisplayVideo360AdvertiserLinkProposalsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse} ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDisplayVideo360AdvertiserLinkProposalsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.displayVideo_360AdvertiserLinkProposals != null && message.hasOwnProperty("displayVideo_360AdvertiserLinkProposals")) {
                                if (!Array.isArray(message.displayVideo_360AdvertiserLinkProposals))
                                    return "displayVideo_360AdvertiserLinkProposals: array expected";
                                for (var i = 0; i < message.displayVideo_360AdvertiserLinkProposals.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.verify(message.displayVideo_360AdvertiserLinkProposals[i]);
                                    if (error)
                                        return "displayVideo_360AdvertiserLinkProposals." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDisplayVideo360AdvertiserLinkProposalsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse} ListDisplayVideo360AdvertiserLinkProposalsResponse
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse();
                            if (object.displayVideo_360AdvertiserLinkProposals) {
                                if (!Array.isArray(object.displayVideo_360AdvertiserLinkProposals))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse.displayVideo_360AdvertiserLinkProposals: array expected");
                                message.displayVideo_360AdvertiserLinkProposals = [];
                                for (var i = 0; i < object.displayVideo_360AdvertiserLinkProposals.length; ++i) {
                                    if (typeof object.displayVideo_360AdvertiserLinkProposals[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse.displayVideo_360AdvertiserLinkProposals: object expected");
                                    message.displayVideo_360AdvertiserLinkProposals[i] = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.fromObject(object.displayVideo_360AdvertiserLinkProposals[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDisplayVideo360AdvertiserLinkProposalsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse} message ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.displayVideo_360AdvertiserLinkProposals = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.displayVideo_360AdvertiserLinkProposals && message.displayVideo_360AdvertiserLinkProposals.length) {
                                object.displayVideo_360AdvertiserLinkProposals = [];
                                for (var j = 0; j < message.displayVideo_360AdvertiserLinkProposals.length; ++j)
                                    object.displayVideo_360AdvertiserLinkProposals[j] = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.toObject(message.displayVideo_360AdvertiserLinkProposals[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDisplayVideo360AdvertiserLinkProposalsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDisplayVideo360AdvertiserLinkProposalsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListDisplayVideo360AdvertiserLinkProposalsResponse";
                        };
    
                        return ListDisplayVideo360AdvertiserLinkProposalsResponse;
                    })();
    
                    v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest = (function() {
    
                        /**
                         * Properties of a CreateDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @property {string|null} [parent] CreateDisplayVideo360AdvertiserLinkProposalRequest parent
                         * @property {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal|null} [displayVideo_360AdvertiserLinkProposal] CreateDisplayVideo360AdvertiserLinkProposalRequest displayVideo_360AdvertiserLinkProposal
                         */
    
                        /**
                         * Constructs a new CreateDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateDisplayVideo360AdvertiserLinkProposalRequest.
                         * @implements ICreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         */
                        function CreateDisplayVideo360AdvertiserLinkProposalRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateDisplayVideo360AdvertiserLinkProposalRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.prototype.parent = "";
    
                        /**
                         * CreateDisplayVideo360AdvertiserLinkProposalRequest displayVideo_360AdvertiserLinkProposal.
                         * @member {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal|null|undefined} displayVideo_360AdvertiserLinkProposal
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.prototype.displayVideo_360AdvertiserLinkProposal = null;
    
                        /**
                         * Creates a new CreateDisplayVideo360AdvertiserLinkProposalRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest} CreateDisplayVideo360AdvertiserLinkProposalRequest instance
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.create = function create(properties) {
                            return new CreateDisplayVideo360AdvertiserLinkProposalRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateDisplayVideo360AdvertiserLinkProposalRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkProposalRequest} message CreateDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.displayVideo_360AdvertiserLinkProposal != null && Object.hasOwnProperty.call(message, "displayVideo_360AdvertiserLinkProposal"))
                                $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.encode(message.displayVideo_360AdvertiserLinkProposal, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateDisplayVideo360AdvertiserLinkProposalRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDisplayVideo360AdvertiserLinkProposalRequest} message CreateDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest} CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayVideo_360AdvertiserLinkProposal = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest} CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateDisplayVideo360AdvertiserLinkProposalRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.displayVideo_360AdvertiserLinkProposal != null && message.hasOwnProperty("displayVideo_360AdvertiserLinkProposal")) {
                                var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.verify(message.displayVideo_360AdvertiserLinkProposal);
                                if (error)
                                    return "displayVideo_360AdvertiserLinkProposal." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateDisplayVideo360AdvertiserLinkProposalRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest} CreateDisplayVideo360AdvertiserLinkProposalRequest
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.displayVideo_360AdvertiserLinkProposal != null) {
                                if (typeof object.displayVideo_360AdvertiserLinkProposal !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest.displayVideo_360AdvertiserLinkProposal: object expected");
                                message.displayVideo_360AdvertiserLinkProposal = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.fromObject(object.displayVideo_360AdvertiserLinkProposal);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateDisplayVideo360AdvertiserLinkProposalRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest} message CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.displayVideo_360AdvertiserLinkProposal = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.displayVideo_360AdvertiserLinkProposal != null && message.hasOwnProperty("displayVideo_360AdvertiserLinkProposal"))
                                object.displayVideo_360AdvertiserLinkProposal = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.toObject(message.displayVideo_360AdvertiserLinkProposal, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateDisplayVideo360AdvertiserLinkProposalRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateDisplayVideo360AdvertiserLinkProposalRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateDisplayVideo360AdvertiserLinkProposalRequest";
                        };
    
                        return CreateDisplayVideo360AdvertiserLinkProposalRequest;
                    })();
    
                    v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest = (function() {
    
                        /**
                         * Properties of a DeleteDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @property {string|null} [name] DeleteDisplayVideo360AdvertiserLinkProposalRequest name
                         */
    
                        /**
                         * Constructs a new DeleteDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteDisplayVideo360AdvertiserLinkProposalRequest.
                         * @implements IDeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         */
                        function DeleteDisplayVideo360AdvertiserLinkProposalRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteDisplayVideo360AdvertiserLinkProposalRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteDisplayVideo360AdvertiserLinkProposalRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest} DeleteDisplayVideo360AdvertiserLinkProposalRequest instance
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.create = function create(properties) {
                            return new DeleteDisplayVideo360AdvertiserLinkProposalRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteDisplayVideo360AdvertiserLinkProposalRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkProposalRequest} message DeleteDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteDisplayVideo360AdvertiserLinkProposalRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDisplayVideo360AdvertiserLinkProposalRequest} message DeleteDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest} DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest} DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteDisplayVideo360AdvertiserLinkProposalRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteDisplayVideo360AdvertiserLinkProposalRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest} DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteDisplayVideo360AdvertiserLinkProposalRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest} message DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteDisplayVideo360AdvertiserLinkProposalRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteDisplayVideo360AdvertiserLinkProposalRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteDisplayVideo360AdvertiserLinkProposalRequest";
                        };
    
                        return DeleteDisplayVideo360AdvertiserLinkProposalRequest;
                    })();
    
                    v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest = (function() {
    
                        /**
                         * Properties of an ApproveDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @property {string|null} [name] ApproveDisplayVideo360AdvertiserLinkProposalRequest name
                         */
    
                        /**
                         * Constructs a new ApproveDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ApproveDisplayVideo360AdvertiserLinkProposalRequest.
                         * @implements IApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         */
                        function ApproveDisplayVideo360AdvertiserLinkProposalRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ApproveDisplayVideo360AdvertiserLinkProposalRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.prototype.name = "";
    
                        /**
                         * Creates a new ApproveDisplayVideo360AdvertiserLinkProposalRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest} ApproveDisplayVideo360AdvertiserLinkProposalRequest instance
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.create = function create(properties) {
                            return new ApproveDisplayVideo360AdvertiserLinkProposalRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ApproveDisplayVideo360AdvertiserLinkProposalRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalRequest} message ApproveDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ApproveDisplayVideo360AdvertiserLinkProposalRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalRequest} message ApproveDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ApproveDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest} ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ApproveDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest} ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ApproveDisplayVideo360AdvertiserLinkProposalRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ApproveDisplayVideo360AdvertiserLinkProposalRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest} ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ApproveDisplayVideo360AdvertiserLinkProposalRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest} message ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this ApproveDisplayVideo360AdvertiserLinkProposalRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalRequest";
                        };
    
                        return ApproveDisplayVideo360AdvertiserLinkProposalRequest;
                    })();
    
                    v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse = (function() {
    
                        /**
                         * Properties of an ApproveDisplayVideo360AdvertiserLinkProposalResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @property {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null} [displayVideo_360AdvertiserLink] ApproveDisplayVideo360AdvertiserLinkProposalResponse displayVideo_360AdvertiserLink
                         */
    
                        /**
                         * Constructs a new ApproveDisplayVideo360AdvertiserLinkProposalResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ApproveDisplayVideo360AdvertiserLinkProposalResponse.
                         * @implements IApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalResponse=} [properties] Properties to set
                         */
                        function ApproveDisplayVideo360AdvertiserLinkProposalResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ApproveDisplayVideo360AdvertiserLinkProposalResponse displayVideo_360AdvertiserLink.
                         * @member {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null|undefined} displayVideo_360AdvertiserLink
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @instance
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.prototype.displayVideo_360AdvertiserLink = null;
    
                        /**
                         * Creates a new ApproveDisplayVideo360AdvertiserLinkProposalResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse} ApproveDisplayVideo360AdvertiserLinkProposalResponse instance
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.create = function create(properties) {
                            return new ApproveDisplayVideo360AdvertiserLinkProposalResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ApproveDisplayVideo360AdvertiserLinkProposalResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalResponse} message ApproveDisplayVideo360AdvertiserLinkProposalResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.displayVideo_360AdvertiserLink != null && Object.hasOwnProperty.call(message, "displayVideo_360AdvertiserLink"))
                                $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.encode(message.displayVideo_360AdvertiserLink, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ApproveDisplayVideo360AdvertiserLinkProposalResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IApproveDisplayVideo360AdvertiserLinkProposalResponse} message ApproveDisplayVideo360AdvertiserLinkProposalResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ApproveDisplayVideo360AdvertiserLinkProposalResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse} ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ApproveDisplayVideo360AdvertiserLinkProposalResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse} ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ApproveDisplayVideo360AdvertiserLinkProposalResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink")) {
                                var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.verify(message.displayVideo_360AdvertiserLink);
                                if (error)
                                    return "displayVideo_360AdvertiserLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ApproveDisplayVideo360AdvertiserLinkProposalResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse} ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse();
                            if (object.displayVideo_360AdvertiserLink != null) {
                                if (typeof object.displayVideo_360AdvertiserLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse.displayVideo_360AdvertiserLink: object expected");
                                message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.fromObject(object.displayVideo_360AdvertiserLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ApproveDisplayVideo360AdvertiserLinkProposalResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse} message ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.displayVideo_360AdvertiserLink = null;
                            if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink"))
                                object.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.toObject(message.displayVideo_360AdvertiserLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this ApproveDisplayVideo360AdvertiserLinkProposalResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ApproveDisplayVideo360AdvertiserLinkProposalResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ApproveDisplayVideo360AdvertiserLinkProposalResponse";
                        };
    
                        return ApproveDisplayVideo360AdvertiserLinkProposalResponse;
                    })();
    
                    v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest = (function() {
    
                        /**
                         * Properties of a CancelDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @property {string|null} [name] CancelDisplayVideo360AdvertiserLinkProposalRequest name
                         */
    
                        /**
                         * Constructs a new CancelDisplayVideo360AdvertiserLinkProposalRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CancelDisplayVideo360AdvertiserLinkProposalRequest.
                         * @implements ICancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICancelDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         */
                        function CancelDisplayVideo360AdvertiserLinkProposalRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CancelDisplayVideo360AdvertiserLinkProposalRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.prototype.name = "";
    
                        /**
                         * Creates a new CancelDisplayVideo360AdvertiserLinkProposalRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICancelDisplayVideo360AdvertiserLinkProposalRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest} CancelDisplayVideo360AdvertiserLinkProposalRequest instance
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.create = function create(properties) {
                            return new CancelDisplayVideo360AdvertiserLinkProposalRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CancelDisplayVideo360AdvertiserLinkProposalRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICancelDisplayVideo360AdvertiserLinkProposalRequest} message CancelDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CancelDisplayVideo360AdvertiserLinkProposalRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICancelDisplayVideo360AdvertiserLinkProposalRequest} message CancelDisplayVideo360AdvertiserLinkProposalRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CancelDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest} CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CancelDisplayVideo360AdvertiserLinkProposalRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest} CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CancelDisplayVideo360AdvertiserLinkProposalRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a CancelDisplayVideo360AdvertiserLinkProposalRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest} CancelDisplayVideo360AdvertiserLinkProposalRequest
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CancelDisplayVideo360AdvertiserLinkProposalRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest} message CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this CancelDisplayVideo360AdvertiserLinkProposalRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CancelDisplayVideo360AdvertiserLinkProposalRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CancelDisplayVideo360AdvertiserLinkProposalRequest";
                        };
    
                        return CancelDisplayVideo360AdvertiserLinkProposalRequest;
                    })();
    
                    v1alpha.GetSearchAds360LinkRequest = (function() {
    
                        /**
                         * Properties of a GetSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetSearchAds360LinkRequest
                         * @property {string|null} [name] GetSearchAds360LinkRequest name
                         */
    
                        /**
                         * Constructs a new GetSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetSearchAds360LinkRequest.
                         * @implements IGetSearchAds360LinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetSearchAds360LinkRequest=} [properties] Properties to set
                         */
                        function GetSearchAds360LinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetSearchAds360LinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @instance
                         */
                        GetSearchAds360LinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetSearchAds360LinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetSearchAds360LinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetSearchAds360LinkRequest} GetSearchAds360LinkRequest instance
                         */
                        GetSearchAds360LinkRequest.create = function create(properties) {
                            return new GetSearchAds360LinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetSearchAds360LinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetSearchAds360LinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetSearchAds360LinkRequest} message GetSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSearchAds360LinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetSearchAds360LinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetSearchAds360LinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetSearchAds360LinkRequest} message GetSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSearchAds360LinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetSearchAds360LinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetSearchAds360LinkRequest} GetSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSearchAds360LinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetSearchAds360LinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetSearchAds360LinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetSearchAds360LinkRequest} GetSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSearchAds360LinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetSearchAds360LinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSearchAds360LinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetSearchAds360LinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetSearchAds360LinkRequest} GetSearchAds360LinkRequest
                         */
                        GetSearchAds360LinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetSearchAds360LinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetSearchAds360LinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetSearchAds360LinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetSearchAds360LinkRequest} message GetSearchAds360LinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSearchAds360LinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetSearchAds360LinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSearchAds360LinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetSearchAds360LinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetSearchAds360LinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetSearchAds360LinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetSearchAds360LinkRequest";
                        };
    
                        return GetSearchAds360LinkRequest;
                    })();
    
                    v1alpha.ListSearchAds360LinksRequest = (function() {
    
                        /**
                         * Properties of a ListSearchAds360LinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListSearchAds360LinksRequest
                         * @property {string|null} [parent] ListSearchAds360LinksRequest parent
                         * @property {number|null} [pageSize] ListSearchAds360LinksRequest pageSize
                         * @property {string|null} [pageToken] ListSearchAds360LinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListSearchAds360LinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListSearchAds360LinksRequest.
                         * @implements IListSearchAds360LinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksRequest=} [properties] Properties to set
                         */
                        function ListSearchAds360LinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListSearchAds360LinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @instance
                         */
                        ListSearchAds360LinksRequest.prototype.parent = "";
    
                        /**
                         * ListSearchAds360LinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @instance
                         */
                        ListSearchAds360LinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListSearchAds360LinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @instance
                         */
                        ListSearchAds360LinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListSearchAds360LinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksRequest} ListSearchAds360LinksRequest instance
                         */
                        ListSearchAds360LinksRequest.create = function create(properties) {
                            return new ListSearchAds360LinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListSearchAds360LinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListSearchAds360LinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksRequest} message ListSearchAds360LinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSearchAds360LinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListSearchAds360LinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListSearchAds360LinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksRequest} message ListSearchAds360LinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSearchAds360LinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListSearchAds360LinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksRequest} ListSearchAds360LinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSearchAds360LinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListSearchAds360LinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListSearchAds360LinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksRequest} ListSearchAds360LinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSearchAds360LinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListSearchAds360LinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListSearchAds360LinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListSearchAds360LinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksRequest} ListSearchAds360LinksRequest
                         */
                        ListSearchAds360LinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListSearchAds360LinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListSearchAds360LinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListSearchAds360LinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListSearchAds360LinksRequest} message ListSearchAds360LinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListSearchAds360LinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListSearchAds360LinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListSearchAds360LinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListSearchAds360LinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListSearchAds360LinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListSearchAds360LinksRequest";
                        };
    
                        return ListSearchAds360LinksRequest;
                    })();
    
                    v1alpha.ListSearchAds360LinksResponse = (function() {
    
                        /**
                         * Properties of a ListSearchAds360LinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListSearchAds360LinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.ISearchAds360Link>|null} [searchAds_360Links] ListSearchAds360LinksResponse searchAds_360Links
                         * @property {string|null} [nextPageToken] ListSearchAds360LinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListSearchAds360LinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListSearchAds360LinksResponse.
                         * @implements IListSearchAds360LinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksResponse=} [properties] Properties to set
                         */
                        function ListSearchAds360LinksResponse(properties) {
                            this.searchAds_360Links = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListSearchAds360LinksResponse searchAds_360Links.
                         * @member {Array.<google.analytics.admin.v1alpha.ISearchAds360Link>} searchAds_360Links
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @instance
                         */
                        ListSearchAds360LinksResponse.prototype.searchAds_360Links = $util.emptyArray;
    
                        /**
                         * ListSearchAds360LinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @instance
                         */
                        ListSearchAds360LinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListSearchAds360LinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksResponse} ListSearchAds360LinksResponse instance
                         */
                        ListSearchAds360LinksResponse.create = function create(properties) {
                            return new ListSearchAds360LinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListSearchAds360LinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListSearchAds360LinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksResponse} message ListSearchAds360LinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSearchAds360LinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.searchAds_360Links != null && message.searchAds_360Links.length)
                                for (var i = 0; i < message.searchAds_360Links.length; ++i)
                                    $root.google.analytics.admin.v1alpha.SearchAds360Link.encode(message.searchAds_360Links[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListSearchAds360LinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListSearchAds360LinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListSearchAds360LinksResponse} message ListSearchAds360LinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSearchAds360LinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListSearchAds360LinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksResponse} ListSearchAds360LinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSearchAds360LinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListSearchAds360LinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.searchAds_360Links && message.searchAds_360Links.length))
                                            message.searchAds_360Links = [];
                                        message.searchAds_360Links.push($root.google.analytics.admin.v1alpha.SearchAds360Link.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListSearchAds360LinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksResponse} ListSearchAds360LinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSearchAds360LinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListSearchAds360LinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListSearchAds360LinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.searchAds_360Links != null && message.hasOwnProperty("searchAds_360Links")) {
                                if (!Array.isArray(message.searchAds_360Links))
                                    return "searchAds_360Links: array expected";
                                for (var i = 0; i < message.searchAds_360Links.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.SearchAds360Link.verify(message.searchAds_360Links[i]);
                                    if (error)
                                        return "searchAds_360Links." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListSearchAds360LinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListSearchAds360LinksResponse} ListSearchAds360LinksResponse
                         */
                        ListSearchAds360LinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListSearchAds360LinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListSearchAds360LinksResponse();
                            if (object.searchAds_360Links) {
                                if (!Array.isArray(object.searchAds_360Links))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListSearchAds360LinksResponse.searchAds_360Links: array expected");
                                message.searchAds_360Links = [];
                                for (var i = 0; i < object.searchAds_360Links.length; ++i) {
                                    if (typeof object.searchAds_360Links[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListSearchAds360LinksResponse.searchAds_360Links: object expected");
                                    message.searchAds_360Links[i] = $root.google.analytics.admin.v1alpha.SearchAds360Link.fromObject(object.searchAds_360Links[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListSearchAds360LinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListSearchAds360LinksResponse} message ListSearchAds360LinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListSearchAds360LinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.searchAds_360Links = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.searchAds_360Links && message.searchAds_360Links.length) {
                                object.searchAds_360Links = [];
                                for (var j = 0; j < message.searchAds_360Links.length; ++j)
                                    object.searchAds_360Links[j] = $root.google.analytics.admin.v1alpha.SearchAds360Link.toObject(message.searchAds_360Links[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListSearchAds360LinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListSearchAds360LinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListSearchAds360LinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListSearchAds360LinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListSearchAds360LinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListSearchAds360LinksResponse";
                        };
    
                        return ListSearchAds360LinksResponse;
                    })();
    
                    v1alpha.CreateSearchAds360LinkRequest = (function() {
    
                        /**
                         * Properties of a CreateSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateSearchAds360LinkRequest
                         * @property {string|null} [parent] CreateSearchAds360LinkRequest parent
                         * @property {google.analytics.admin.v1alpha.ISearchAds360Link|null} [searchAds_360Link] CreateSearchAds360LinkRequest searchAds_360Link
                         */
    
                        /**
                         * Constructs a new CreateSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateSearchAds360LinkRequest.
                         * @implements ICreateSearchAds360LinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateSearchAds360LinkRequest=} [properties] Properties to set
                         */
                        function CreateSearchAds360LinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateSearchAds360LinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @instance
                         */
                        CreateSearchAds360LinkRequest.prototype.parent = "";
    
                        /**
                         * CreateSearchAds360LinkRequest searchAds_360Link.
                         * @member {google.analytics.admin.v1alpha.ISearchAds360Link|null|undefined} searchAds_360Link
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @instance
                         */
                        CreateSearchAds360LinkRequest.prototype.searchAds_360Link = null;
    
                        /**
                         * Creates a new CreateSearchAds360LinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateSearchAds360LinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest} CreateSearchAds360LinkRequest instance
                         */
                        CreateSearchAds360LinkRequest.create = function create(properties) {
                            return new CreateSearchAds360LinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateSearchAds360LinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateSearchAds360LinkRequest} message CreateSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateSearchAds360LinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.searchAds_360Link != null && Object.hasOwnProperty.call(message, "searchAds_360Link"))
                                $root.google.analytics.admin.v1alpha.SearchAds360Link.encode(message.searchAds_360Link, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateSearchAds360LinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateSearchAds360LinkRequest} message CreateSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateSearchAds360LinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateSearchAds360LinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest} CreateSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateSearchAds360LinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateSearchAds360LinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest} CreateSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateSearchAds360LinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateSearchAds360LinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateSearchAds360LinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.searchAds_360Link != null && message.hasOwnProperty("searchAds_360Link")) {
                                var error = $root.google.analytics.admin.v1alpha.SearchAds360Link.verify(message.searchAds_360Link);
                                if (error)
                                    return "searchAds_360Link." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateSearchAds360LinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest} CreateSearchAds360LinkRequest
                         */
                        CreateSearchAds360LinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.searchAds_360Link != null) {
                                if (typeof object.searchAds_360Link !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest.searchAds_360Link: object expected");
                                message.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.fromObject(object.searchAds_360Link);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateSearchAds360LinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest} message CreateSearchAds360LinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateSearchAds360LinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.searchAds_360Link = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.searchAds_360Link != null && message.hasOwnProperty("searchAds_360Link"))
                                object.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.toObject(message.searchAds_360Link, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateSearchAds360LinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateSearchAds360LinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateSearchAds360LinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateSearchAds360LinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateSearchAds360LinkRequest";
                        };
    
                        return CreateSearchAds360LinkRequest;
                    })();
    
                    v1alpha.DeleteSearchAds360LinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteSearchAds360LinkRequest
                         * @property {string|null} [name] DeleteSearchAds360LinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteSearchAds360LinkRequest.
                         * @implements IDeleteSearchAds360LinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteSearchAds360LinkRequest=} [properties] Properties to set
                         */
                        function DeleteSearchAds360LinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSearchAds360LinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @instance
                         */
                        DeleteSearchAds360LinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteSearchAds360LinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteSearchAds360LinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest} DeleteSearchAds360LinkRequest instance
                         */
                        DeleteSearchAds360LinkRequest.create = function create(properties) {
                            return new DeleteSearchAds360LinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSearchAds360LinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteSearchAds360LinkRequest} message DeleteSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSearchAds360LinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSearchAds360LinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteSearchAds360LinkRequest} message DeleteSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSearchAds360LinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSearchAds360LinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest} DeleteSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSearchAds360LinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSearchAds360LinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest} DeleteSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSearchAds360LinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSearchAds360LinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSearchAds360LinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSearchAds360LinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest} DeleteSearchAds360LinkRequest
                         */
                        DeleteSearchAds360LinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSearchAds360LinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest} message DeleteSearchAds360LinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSearchAds360LinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSearchAds360LinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSearchAds360LinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSearchAds360LinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSearchAds360LinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteSearchAds360LinkRequest";
                        };
    
                        return DeleteSearchAds360LinkRequest;
                    })();
    
                    v1alpha.UpdateSearchAds360LinkRequest = (function() {
    
                        /**
                         * Properties of an UpdateSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateSearchAds360LinkRequest
                         * @property {google.analytics.admin.v1alpha.ISearchAds360Link|null} [searchAds_360Link] UpdateSearchAds360LinkRequest searchAds_360Link
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateSearchAds360LinkRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateSearchAds360LinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateSearchAds360LinkRequest.
                         * @implements IUpdateSearchAds360LinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateSearchAds360LinkRequest=} [properties] Properties to set
                         */
                        function UpdateSearchAds360LinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateSearchAds360LinkRequest searchAds_360Link.
                         * @member {google.analytics.admin.v1alpha.ISearchAds360Link|null|undefined} searchAds_360Link
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @instance
                         */
                        UpdateSearchAds360LinkRequest.prototype.searchAds_360Link = null;
    
                        /**
                         * UpdateSearchAds360LinkRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @instance
                         */
                        UpdateSearchAds360LinkRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateSearchAds360LinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateSearchAds360LinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest} UpdateSearchAds360LinkRequest instance
                         */
                        UpdateSearchAds360LinkRequest.create = function create(properties) {
                            return new UpdateSearchAds360LinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateSearchAds360LinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateSearchAds360LinkRequest} message UpdateSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateSearchAds360LinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.searchAds_360Link != null && Object.hasOwnProperty.call(message, "searchAds_360Link"))
                                $root.google.analytics.admin.v1alpha.SearchAds360Link.encode(message.searchAds_360Link, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateSearchAds360LinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateSearchAds360LinkRequest} message UpdateSearchAds360LinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateSearchAds360LinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateSearchAds360LinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest} UpdateSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateSearchAds360LinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateSearchAds360LinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest} UpdateSearchAds360LinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateSearchAds360LinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateSearchAds360LinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateSearchAds360LinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.searchAds_360Link != null && message.hasOwnProperty("searchAds_360Link")) {
                                var error = $root.google.analytics.admin.v1alpha.SearchAds360Link.verify(message.searchAds_360Link);
                                if (error)
                                    return "searchAds_360Link." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateSearchAds360LinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest} UpdateSearchAds360LinkRequest
                         */
                        UpdateSearchAds360LinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest();
                            if (object.searchAds_360Link != null) {
                                if (typeof object.searchAds_360Link !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest.searchAds_360Link: object expected");
                                message.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.fromObject(object.searchAds_360Link);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateSearchAds360LinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest} message UpdateSearchAds360LinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateSearchAds360LinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.searchAds_360Link = null;
                                object.updateMask = null;
                            }
                            if (message.searchAds_360Link != null && message.hasOwnProperty("searchAds_360Link"))
                                object.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.toObject(message.searchAds_360Link, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateSearchAds360LinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateSearchAds360LinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateSearchAds360LinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateSearchAds360LinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateSearchAds360LinkRequest";
                        };
    
                        return UpdateSearchAds360LinkRequest;
                    })();
    
                    v1alpha.CreateCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of a CreateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateCustomDimensionRequest
                         * @property {string|null} [parent] CreateCustomDimensionRequest parent
                         * @property {google.analytics.admin.v1alpha.ICustomDimension|null} [customDimension] CreateCustomDimensionRequest customDimension
                         */
    
                        /**
                         * Constructs a new CreateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateCustomDimensionRequest.
                         * @implements ICreateCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateCustomDimensionRequest=} [properties] Properties to set
                         */
                        function CreateCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateCustomDimensionRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @instance
                         */
                        CreateCustomDimensionRequest.prototype.parent = "";
    
                        /**
                         * CreateCustomDimensionRequest customDimension.
                         * @member {google.analytics.admin.v1alpha.ICustomDimension|null|undefined} customDimension
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @instance
                         */
                        CreateCustomDimensionRequest.prototype.customDimension = null;
    
                        /**
                         * Creates a new CreateCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateCustomDimensionRequest} CreateCustomDimensionRequest instance
                         */
                        CreateCustomDimensionRequest.create = function create(properties) {
                            return new CreateCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateCustomDimensionRequest} message CreateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.customDimension != null && Object.hasOwnProperty.call(message, "customDimension"))
                                $root.google.analytics.admin.v1alpha.CustomDimension.encode(message.customDimension, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateCustomDimensionRequest} message CreateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateCustomDimensionRequest} CreateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateCustomDimensionRequest} CreateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.customDimension != null && message.hasOwnProperty("customDimension")) {
                                var error = $root.google.analytics.admin.v1alpha.CustomDimension.verify(message.customDimension);
                                if (error)
                                    return "customDimension." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateCustomDimensionRequest} CreateCustomDimensionRequest
                         */
                        CreateCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateCustomDimensionRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.customDimension != null) {
                                if (typeof object.customDimension !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateCustomDimensionRequest.customDimension: object expected");
                                message.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.fromObject(object.customDimension);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateCustomDimensionRequest} message CreateCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.customDimension = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.customDimension != null && message.hasOwnProperty("customDimension"))
                                object.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.toObject(message.customDimension, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateCustomDimensionRequest";
                        };
    
                        return CreateCustomDimensionRequest;
                    })();
    
                    v1alpha.UpdateCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of an UpdateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateCustomDimensionRequest
                         * @property {google.analytics.admin.v1alpha.ICustomDimension|null} [customDimension] UpdateCustomDimensionRequest customDimension
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateCustomDimensionRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateCustomDimensionRequest.
                         * @implements IUpdateCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomDimensionRequest=} [properties] Properties to set
                         */
                        function UpdateCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateCustomDimensionRequest customDimension.
                         * @member {google.analytics.admin.v1alpha.ICustomDimension|null|undefined} customDimension
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @instance
                         */
                        UpdateCustomDimensionRequest.prototype.customDimension = null;
    
                        /**
                         * UpdateCustomDimensionRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @instance
                         */
                        UpdateCustomDimensionRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest instance
                         */
                        UpdateCustomDimensionRequest.create = function create(properties) {
                            return new UpdateCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomDimensionRequest} message UpdateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customDimension != null && Object.hasOwnProperty.call(message, "customDimension"))
                                $root.google.analytics.admin.v1alpha.CustomDimension.encode(message.customDimension, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomDimensionRequest} message UpdateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customDimension != null && message.hasOwnProperty("customDimension")) {
                                var error = $root.google.analytics.admin.v1alpha.CustomDimension.verify(message.customDimension);
                                if (error)
                                    return "customDimension." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest
                         */
                        UpdateCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateCustomDimensionRequest();
                            if (object.customDimension != null) {
                                if (typeof object.customDimension !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateCustomDimensionRequest.customDimension: object expected");
                                message.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.fromObject(object.customDimension);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateCustomDimensionRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateCustomDimensionRequest} message UpdateCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customDimension = null;
                                object.updateMask = null;
                            }
                            if (message.customDimension != null && message.hasOwnProperty("customDimension"))
                                object.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.toObject(message.customDimension, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateCustomDimensionRequest";
                        };
    
                        return UpdateCustomDimensionRequest;
                    })();
    
                    v1alpha.ListCustomDimensionsRequest = (function() {
    
                        /**
                         * Properties of a ListCustomDimensionsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListCustomDimensionsRequest
                         * @property {string|null} [parent] ListCustomDimensionsRequest parent
                         * @property {number|null} [pageSize] ListCustomDimensionsRequest pageSize
                         * @property {string|null} [pageToken] ListCustomDimensionsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListCustomDimensionsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListCustomDimensionsRequest.
                         * @implements IListCustomDimensionsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsRequest=} [properties] Properties to set
                         */
                        function ListCustomDimensionsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomDimensionsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @instance
                         */
                        ListCustomDimensionsRequest.prototype.parent = "";
    
                        /**
                         * ListCustomDimensionsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @instance
                         */
                        ListCustomDimensionsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListCustomDimensionsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @instance
                         */
                        ListCustomDimensionsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListCustomDimensionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsRequest} ListCustomDimensionsRequest instance
                         */
                        ListCustomDimensionsRequest.create = function create(properties) {
                            return new ListCustomDimensionsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomDimensionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsRequest} message ListCustomDimensionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomDimensionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsRequest} message ListCustomDimensionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsRequest} ListCustomDimensionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListCustomDimensionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsRequest} ListCustomDimensionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomDimensionsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomDimensionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomDimensionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsRequest} ListCustomDimensionsRequest
                         */
                        ListCustomDimensionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListCustomDimensionsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListCustomDimensionsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomDimensionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListCustomDimensionsRequest} message ListCustomDimensionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomDimensionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomDimensionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomDimensionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomDimensionsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomDimensionsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListCustomDimensionsRequest";
                        };
    
                        return ListCustomDimensionsRequest;
                    })();
    
                    v1alpha.ListCustomDimensionsResponse = (function() {
    
                        /**
                         * Properties of a ListCustomDimensionsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListCustomDimensionsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.ICustomDimension>|null} [customDimensions] ListCustomDimensionsResponse customDimensions
                         * @property {string|null} [nextPageToken] ListCustomDimensionsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListCustomDimensionsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListCustomDimensionsResponse.
                         * @implements IListCustomDimensionsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsResponse=} [properties] Properties to set
                         */
                        function ListCustomDimensionsResponse(properties) {
                            this.customDimensions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomDimensionsResponse customDimensions.
                         * @member {Array.<google.analytics.admin.v1alpha.ICustomDimension>} customDimensions
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @instance
                         */
                        ListCustomDimensionsResponse.prototype.customDimensions = $util.emptyArray;
    
                        /**
                         * ListCustomDimensionsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @instance
                         */
                        ListCustomDimensionsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListCustomDimensionsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsResponse} ListCustomDimensionsResponse instance
                         */
                        ListCustomDimensionsResponse.create = function create(properties) {
                            return new ListCustomDimensionsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomDimensionsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsResponse} message ListCustomDimensionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customDimensions != null && message.customDimensions.length)
                                for (var i = 0; i < message.customDimensions.length; ++i)
                                    $root.google.analytics.admin.v1alpha.CustomDimension.encode(message.customDimensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomDimensionsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomDimensionsResponse} message ListCustomDimensionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsResponse} ListCustomDimensionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListCustomDimensionsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.customDimensions && message.customDimensions.length))
                                            message.customDimensions = [];
                                        message.customDimensions.push($root.google.analytics.admin.v1alpha.CustomDimension.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsResponse} ListCustomDimensionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomDimensionsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomDimensionsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customDimensions != null && message.hasOwnProperty("customDimensions")) {
                                if (!Array.isArray(message.customDimensions))
                                    return "customDimensions: array expected";
                                for (var i = 0; i < message.customDimensions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.CustomDimension.verify(message.customDimensions[i]);
                                    if (error)
                                        return "customDimensions." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomDimensionsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListCustomDimensionsResponse} ListCustomDimensionsResponse
                         */
                        ListCustomDimensionsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListCustomDimensionsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListCustomDimensionsResponse();
                            if (object.customDimensions) {
                                if (!Array.isArray(object.customDimensions))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListCustomDimensionsResponse.customDimensions: array expected");
                                message.customDimensions = [];
                                for (var i = 0; i < object.customDimensions.length; ++i) {
                                    if (typeof object.customDimensions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListCustomDimensionsResponse.customDimensions: object expected");
                                    message.customDimensions[i] = $root.google.analytics.admin.v1alpha.CustomDimension.fromObject(object.customDimensions[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomDimensionsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListCustomDimensionsResponse} message ListCustomDimensionsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomDimensionsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.customDimensions = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.customDimensions && message.customDimensions.length) {
                                object.customDimensions = [];
                                for (var j = 0; j < message.customDimensions.length; ++j)
                                    object.customDimensions[j] = $root.google.analytics.admin.v1alpha.CustomDimension.toObject(message.customDimensions[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomDimensionsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomDimensionsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomDimensionsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListCustomDimensionsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomDimensionsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListCustomDimensionsResponse";
                        };
    
                        return ListCustomDimensionsResponse;
                    })();
    
                    v1alpha.ArchiveCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of an ArchiveCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IArchiveCustomDimensionRequest
                         * @property {string|null} [name] ArchiveCustomDimensionRequest name
                         */
    
                        /**
                         * Constructs a new ArchiveCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ArchiveCustomDimensionRequest.
                         * @implements IArchiveCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomDimensionRequest=} [properties] Properties to set
                         */
                        function ArchiveCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ArchiveCustomDimensionRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @instance
                         */
                        ArchiveCustomDimensionRequest.prototype.name = "";
    
                        /**
                         * Creates a new ArchiveCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest instance
                         */
                        ArchiveCustomDimensionRequest.create = function create(properties) {
                            return new ArchiveCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomDimensionRequest} message ArchiveCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomDimensionRequest} message ArchiveCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ArchiveCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ArchiveCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ArchiveCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ArchiveCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ArchiveCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest
                         */
                        ArchiveCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ArchiveCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest} message ArchiveCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ArchiveCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this ArchiveCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ArchiveCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ArchiveCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ArchiveCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ArchiveCustomDimensionRequest";
                        };
    
                        return ArchiveCustomDimensionRequest;
                    })();
    
                    v1alpha.GetCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of a GetCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetCustomDimensionRequest
                         * @property {string|null} [name] GetCustomDimensionRequest name
                         */
    
                        /**
                         * Constructs a new GetCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetCustomDimensionRequest.
                         * @implements IGetCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetCustomDimensionRequest=} [properties] Properties to set
                         */
                        function GetCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetCustomDimensionRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @instance
                         */
                        GetCustomDimensionRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetCustomDimensionRequest} GetCustomDimensionRequest instance
                         */
                        GetCustomDimensionRequest.create = function create(properties) {
                            return new GetCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetCustomDimensionRequest} message GetCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetCustomDimensionRequest} message GetCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetCustomDimensionRequest} GetCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetCustomDimensionRequest} GetCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetCustomDimensionRequest} GetCustomDimensionRequest
                         */
                        GetCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetCustomDimensionRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetCustomDimensionRequest} message GetCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetCustomDimensionRequest";
                        };
    
                        return GetCustomDimensionRequest;
                    })();
    
                    v1alpha.CreateCustomMetricRequest = (function() {
    
                        /**
                         * Properties of a CreateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateCustomMetricRequest
                         * @property {string|null} [parent] CreateCustomMetricRequest parent
                         * @property {google.analytics.admin.v1alpha.ICustomMetric|null} [customMetric] CreateCustomMetricRequest customMetric
                         */
    
                        /**
                         * Constructs a new CreateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateCustomMetricRequest.
                         * @implements ICreateCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateCustomMetricRequest=} [properties] Properties to set
                         */
                        function CreateCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateCustomMetricRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @instance
                         */
                        CreateCustomMetricRequest.prototype.parent = "";
    
                        /**
                         * CreateCustomMetricRequest customMetric.
                         * @member {google.analytics.admin.v1alpha.ICustomMetric|null|undefined} customMetric
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @instance
                         */
                        CreateCustomMetricRequest.prototype.customMetric = null;
    
                        /**
                         * Creates a new CreateCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateCustomMetricRequest} CreateCustomMetricRequest instance
                         */
                        CreateCustomMetricRequest.create = function create(properties) {
                            return new CreateCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateCustomMetricRequest} message CreateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.customMetric != null && Object.hasOwnProperty.call(message, "customMetric"))
                                $root.google.analytics.admin.v1alpha.CustomMetric.encode(message.customMetric, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateCustomMetricRequest} message CreateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateCustomMetricRequest} CreateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateCustomMetricRequest} CreateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.customMetric != null && message.hasOwnProperty("customMetric")) {
                                var error = $root.google.analytics.admin.v1alpha.CustomMetric.verify(message.customMetric);
                                if (error)
                                    return "customMetric." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateCustomMetricRequest} CreateCustomMetricRequest
                         */
                        CreateCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateCustomMetricRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.customMetric != null) {
                                if (typeof object.customMetric !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateCustomMetricRequest.customMetric: object expected");
                                message.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.fromObject(object.customMetric);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateCustomMetricRequest} message CreateCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.customMetric = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.customMetric != null && message.hasOwnProperty("customMetric"))
                                object.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.toObject(message.customMetric, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateCustomMetricRequest";
                        };
    
                        return CreateCustomMetricRequest;
                    })();
    
                    v1alpha.UpdateCustomMetricRequest = (function() {
    
                        /**
                         * Properties of an UpdateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateCustomMetricRequest
                         * @property {google.analytics.admin.v1alpha.ICustomMetric|null} [customMetric] UpdateCustomMetricRequest customMetric
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateCustomMetricRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateCustomMetricRequest.
                         * @implements IUpdateCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomMetricRequest=} [properties] Properties to set
                         */
                        function UpdateCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateCustomMetricRequest customMetric.
                         * @member {google.analytics.admin.v1alpha.ICustomMetric|null|undefined} customMetric
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @instance
                         */
                        UpdateCustomMetricRequest.prototype.customMetric = null;
    
                        /**
                         * UpdateCustomMetricRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @instance
                         */
                        UpdateCustomMetricRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomMetricRequest} UpdateCustomMetricRequest instance
                         */
                        UpdateCustomMetricRequest.create = function create(properties) {
                            return new UpdateCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomMetricRequest} message UpdateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customMetric != null && Object.hasOwnProperty.call(message, "customMetric"))
                                $root.google.analytics.admin.v1alpha.CustomMetric.encode(message.customMetric, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateCustomMetricRequest} message UpdateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomMetricRequest} UpdateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomMetricRequest} UpdateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customMetric != null && message.hasOwnProperty("customMetric")) {
                                var error = $root.google.analytics.admin.v1alpha.CustomMetric.verify(message.customMetric);
                                if (error)
                                    return "customMetric." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateCustomMetricRequest} UpdateCustomMetricRequest
                         */
                        UpdateCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateCustomMetricRequest();
                            if (object.customMetric != null) {
                                if (typeof object.customMetric !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateCustomMetricRequest.customMetric: object expected");
                                message.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.fromObject(object.customMetric);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateCustomMetricRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateCustomMetricRequest} message UpdateCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customMetric = null;
                                object.updateMask = null;
                            }
                            if (message.customMetric != null && message.hasOwnProperty("customMetric"))
                                object.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.toObject(message.customMetric, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateCustomMetricRequest";
                        };
    
                        return UpdateCustomMetricRequest;
                    })();
    
                    v1alpha.ListCustomMetricsRequest = (function() {
    
                        /**
                         * Properties of a ListCustomMetricsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListCustomMetricsRequest
                         * @property {string|null} [parent] ListCustomMetricsRequest parent
                         * @property {number|null} [pageSize] ListCustomMetricsRequest pageSize
                         * @property {string|null} [pageToken] ListCustomMetricsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListCustomMetricsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListCustomMetricsRequest.
                         * @implements IListCustomMetricsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsRequest=} [properties] Properties to set
                         */
                        function ListCustomMetricsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomMetricsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @instance
                         */
                        ListCustomMetricsRequest.prototype.parent = "";
    
                        /**
                         * ListCustomMetricsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @instance
                         */
                        ListCustomMetricsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListCustomMetricsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @instance
                         */
                        ListCustomMetricsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListCustomMetricsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsRequest} ListCustomMetricsRequest instance
                         */
                        ListCustomMetricsRequest.create = function create(properties) {
                            return new ListCustomMetricsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomMetricsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsRequest} message ListCustomMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomMetricsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsRequest} message ListCustomMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomMetricsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsRequest} ListCustomMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListCustomMetricsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomMetricsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsRequest} ListCustomMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomMetricsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomMetricsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomMetricsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsRequest} ListCustomMetricsRequest
                         */
                        ListCustomMetricsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListCustomMetricsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListCustomMetricsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomMetricsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListCustomMetricsRequest} message ListCustomMetricsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomMetricsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomMetricsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomMetricsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomMetricsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomMetricsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListCustomMetricsRequest";
                        };
    
                        return ListCustomMetricsRequest;
                    })();
    
                    v1alpha.ListCustomMetricsResponse = (function() {
    
                        /**
                         * Properties of a ListCustomMetricsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListCustomMetricsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.ICustomMetric>|null} [customMetrics] ListCustomMetricsResponse customMetrics
                         * @property {string|null} [nextPageToken] ListCustomMetricsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListCustomMetricsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListCustomMetricsResponse.
                         * @implements IListCustomMetricsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsResponse=} [properties] Properties to set
                         */
                        function ListCustomMetricsResponse(properties) {
                            this.customMetrics = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomMetricsResponse customMetrics.
                         * @member {Array.<google.analytics.admin.v1alpha.ICustomMetric>} customMetrics
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @instance
                         */
                        ListCustomMetricsResponse.prototype.customMetrics = $util.emptyArray;
    
                        /**
                         * ListCustomMetricsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @instance
                         */
                        ListCustomMetricsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListCustomMetricsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsResponse} ListCustomMetricsResponse instance
                         */
                        ListCustomMetricsResponse.create = function create(properties) {
                            return new ListCustomMetricsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomMetricsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsResponse} message ListCustomMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customMetrics != null && message.customMetrics.length)
                                for (var i = 0; i < message.customMetrics.length; ++i)
                                    $root.google.analytics.admin.v1alpha.CustomMetric.encode(message.customMetrics[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListCustomMetricsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListCustomMetricsResponse} message ListCustomMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomMetricsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsResponse} ListCustomMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListCustomMetricsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.customMetrics && message.customMetrics.length))
                                            message.customMetrics = [];
                                        message.customMetrics.push($root.google.analytics.admin.v1alpha.CustomMetric.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomMetricsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsResponse} ListCustomMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomMetricsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomMetricsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customMetrics != null && message.hasOwnProperty("customMetrics")) {
                                if (!Array.isArray(message.customMetrics))
                                    return "customMetrics: array expected";
                                for (var i = 0; i < message.customMetrics.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.CustomMetric.verify(message.customMetrics[i]);
                                    if (error)
                                        return "customMetrics." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomMetricsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListCustomMetricsResponse} ListCustomMetricsResponse
                         */
                        ListCustomMetricsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListCustomMetricsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListCustomMetricsResponse();
                            if (object.customMetrics) {
                                if (!Array.isArray(object.customMetrics))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListCustomMetricsResponse.customMetrics: array expected");
                                message.customMetrics = [];
                                for (var i = 0; i < object.customMetrics.length; ++i) {
                                    if (typeof object.customMetrics[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListCustomMetricsResponse.customMetrics: object expected");
                                    message.customMetrics[i] = $root.google.analytics.admin.v1alpha.CustomMetric.fromObject(object.customMetrics[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomMetricsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListCustomMetricsResponse} message ListCustomMetricsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomMetricsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.customMetrics = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.customMetrics && message.customMetrics.length) {
                                object.customMetrics = [];
                                for (var j = 0; j < message.customMetrics.length; ++j)
                                    object.customMetrics[j] = $root.google.analytics.admin.v1alpha.CustomMetric.toObject(message.customMetrics[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomMetricsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomMetricsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomMetricsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListCustomMetricsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomMetricsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListCustomMetricsResponse";
                        };
    
                        return ListCustomMetricsResponse;
                    })();
    
                    v1alpha.ArchiveCustomMetricRequest = (function() {
    
                        /**
                         * Properties of an ArchiveCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IArchiveCustomMetricRequest
                         * @property {string|null} [name] ArchiveCustomMetricRequest name
                         */
    
                        /**
                         * Constructs a new ArchiveCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ArchiveCustomMetricRequest.
                         * @implements IArchiveCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomMetricRequest=} [properties] Properties to set
                         */
                        function ArchiveCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ArchiveCustomMetricRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @instance
                         */
                        ArchiveCustomMetricRequest.prototype.name = "";
    
                        /**
                         * Creates a new ArchiveCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest instance
                         */
                        ArchiveCustomMetricRequest.create = function create(properties) {
                            return new ArchiveCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ArchiveCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomMetricRequest} message ArchiveCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ArchiveCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveCustomMetricRequest} message ArchiveCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ArchiveCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ArchiveCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ArchiveCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ArchiveCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ArchiveCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ArchiveCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest
                         */
                        ArchiveCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ArchiveCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ArchiveCustomMetricRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ArchiveCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ArchiveCustomMetricRequest} message ArchiveCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ArchiveCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this ArchiveCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ArchiveCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ArchiveCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ArchiveCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ArchiveCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ArchiveCustomMetricRequest";
                        };
    
                        return ArchiveCustomMetricRequest;
                    })();
    
                    v1alpha.GetCustomMetricRequest = (function() {
    
                        /**
                         * Properties of a GetCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetCustomMetricRequest
                         * @property {string|null} [name] GetCustomMetricRequest name
                         */
    
                        /**
                         * Constructs a new GetCustomMetricRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetCustomMetricRequest.
                         * @implements IGetCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetCustomMetricRequest=} [properties] Properties to set
                         */
                        function GetCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetCustomMetricRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @instance
                         */
                        GetCustomMetricRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetCustomMetricRequest} GetCustomMetricRequest instance
                         */
                        GetCustomMetricRequest.create = function create(properties) {
                            return new GetCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetCustomMetricRequest} message GetCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetCustomMetricRequest} message GetCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetCustomMetricRequest} GetCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetCustomMetricRequest} GetCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetCustomMetricRequest} GetCustomMetricRequest
                         */
                        GetCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetCustomMetricRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetCustomMetricRequest} message GetCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetCustomMetricRequest";
                        };
    
                        return GetCustomMetricRequest;
                    })();
    
                    v1alpha.GetDataRetentionSettingsRequest = (function() {
    
                        /**
                         * Properties of a GetDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetDataRetentionSettingsRequest
                         * @property {string|null} [name] GetDataRetentionSettingsRequest name
                         */
    
                        /**
                         * Constructs a new GetDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetDataRetentionSettingsRequest.
                         * @implements IGetDataRetentionSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetDataRetentionSettingsRequest=} [properties] Properties to set
                         */
                        function GetDataRetentionSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDataRetentionSettingsRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @instance
                         */
                        GetDataRetentionSettingsRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDataRetentionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataRetentionSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest instance
                         */
                        GetDataRetentionSettingsRequest.create = function create(properties) {
                            return new GetDataRetentionSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDataRetentionSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataRetentionSettingsRequest} message GetDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataRetentionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDataRetentionSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataRetentionSettingsRequest} message GetDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataRetentionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDataRetentionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataRetentionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDataRetentionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataRetentionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDataRetentionSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDataRetentionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDataRetentionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest
                         */
                        GetDataRetentionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDataRetentionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest} message GetDataRetentionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDataRetentionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDataRetentionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDataRetentionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDataRetentionSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDataRetentionSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetDataRetentionSettingsRequest";
                        };
    
                        return GetDataRetentionSettingsRequest;
                    })();
    
                    v1alpha.UpdateDataRetentionSettingsRequest = (function() {
    
                        /**
                         * Properties of an UpdateDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateDataRetentionSettingsRequest
                         * @property {google.analytics.admin.v1alpha.IDataRetentionSettings|null} [dataRetentionSettings] UpdateDataRetentionSettingsRequest dataRetentionSettings
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateDataRetentionSettingsRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateDataRetentionSettingsRequest.
                         * @implements IUpdateDataRetentionSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateDataRetentionSettingsRequest=} [properties] Properties to set
                         */
                        function UpdateDataRetentionSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateDataRetentionSettingsRequest dataRetentionSettings.
                         * @member {google.analytics.admin.v1alpha.IDataRetentionSettings|null|undefined} dataRetentionSettings
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @instance
                         */
                        UpdateDataRetentionSettingsRequest.prototype.dataRetentionSettings = null;
    
                        /**
                         * UpdateDataRetentionSettingsRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @instance
                         */
                        UpdateDataRetentionSettingsRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateDataRetentionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDataRetentionSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest instance
                         */
                        UpdateDataRetentionSettingsRequest.create = function create(properties) {
                            return new UpdateDataRetentionSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateDataRetentionSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDataRetentionSettingsRequest} message UpdateDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataRetentionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dataRetentionSettings != null && Object.hasOwnProperty.call(message, "dataRetentionSettings"))
                                $root.google.analytics.admin.v1alpha.DataRetentionSettings.encode(message.dataRetentionSettings, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateDataRetentionSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDataRetentionSettingsRequest} message UpdateDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataRetentionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateDataRetentionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataRetentionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dataRetentionSettings = $root.google.analytics.admin.v1alpha.DataRetentionSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateDataRetentionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataRetentionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateDataRetentionSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateDataRetentionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings")) {
                                var error = $root.google.analytics.admin.v1alpha.DataRetentionSettings.verify(message.dataRetentionSettings);
                                if (error)
                                    return "dataRetentionSettings." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateDataRetentionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest
                         */
                        UpdateDataRetentionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest();
                            if (object.dataRetentionSettings != null) {
                                if (typeof object.dataRetentionSettings !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest.dataRetentionSettings: object expected");
                                message.dataRetentionSettings = $root.google.analytics.admin.v1alpha.DataRetentionSettings.fromObject(object.dataRetentionSettings);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateDataRetentionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest} message UpdateDataRetentionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateDataRetentionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.dataRetentionSettings = null;
                                object.updateMask = null;
                            }
                            if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings"))
                                object.dataRetentionSettings = $root.google.analytics.admin.v1alpha.DataRetentionSettings.toObject(message.dataRetentionSettings, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateDataRetentionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateDataRetentionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateDataRetentionSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateDataRetentionSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateDataRetentionSettingsRequest";
                        };
    
                        return UpdateDataRetentionSettingsRequest;
                    })();
    
                    v1alpha.CreateDataStreamRequest = (function() {
    
                        /**
                         * Properties of a CreateDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateDataStreamRequest
                         * @property {string|null} [parent] CreateDataStreamRequest parent
                         * @property {google.analytics.admin.v1alpha.IDataStream|null} [dataStream] CreateDataStreamRequest dataStream
                         */
    
                        /**
                         * Constructs a new CreateDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateDataStreamRequest.
                         * @implements ICreateDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateDataStreamRequest=} [properties] Properties to set
                         */
                        function CreateDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateDataStreamRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @instance
                         */
                        CreateDataStreamRequest.prototype.parent = "";
    
                        /**
                         * CreateDataStreamRequest dataStream.
                         * @member {google.analytics.admin.v1alpha.IDataStream|null|undefined} dataStream
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @instance
                         */
                        CreateDataStreamRequest.prototype.dataStream = null;
    
                        /**
                         * Creates a new CreateDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateDataStreamRequest} CreateDataStreamRequest instance
                         */
                        CreateDataStreamRequest.create = function create(properties) {
                            return new CreateDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDataStreamRequest} message CreateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.dataStream != null && Object.hasOwnProperty.call(message, "dataStream"))
                                $root.google.analytics.admin.v1alpha.DataStream.encode(message.dataStream, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateDataStreamRequest} message CreateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateDataStreamRequest} CreateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.dataStream = $root.google.analytics.admin.v1alpha.DataStream.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateDataStreamRequest} CreateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                var error = $root.google.analytics.admin.v1alpha.DataStream.verify(message.dataStream);
                                if (error)
                                    return "dataStream." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateDataStreamRequest} CreateDataStreamRequest
                         */
                        CreateDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateDataStreamRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.dataStream != null) {
                                if (typeof object.dataStream !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateDataStreamRequest.dataStream: object expected");
                                message.dataStream = $root.google.analytics.admin.v1alpha.DataStream.fromObject(object.dataStream);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateDataStreamRequest} message CreateDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.dataStream = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.dataStream != null && message.hasOwnProperty("dataStream"))
                                object.dataStream = $root.google.analytics.admin.v1alpha.DataStream.toObject(message.dataStream, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateDataStreamRequest";
                        };
    
                        return CreateDataStreamRequest;
                    })();
    
                    v1alpha.DeleteDataStreamRequest = (function() {
    
                        /**
                         * Properties of a DeleteDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteDataStreamRequest
                         * @property {string|null} [name] DeleteDataStreamRequest name
                         */
    
                        /**
                         * Constructs a new DeleteDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteDataStreamRequest.
                         * @implements IDeleteDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteDataStreamRequest=} [properties] Properties to set
                         */
                        function DeleteDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteDataStreamRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @instance
                         */
                        DeleteDataStreamRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteDataStreamRequest} DeleteDataStreamRequest instance
                         */
                        DeleteDataStreamRequest.create = function create(properties) {
                            return new DeleteDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDataStreamRequest} message DeleteDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteDataStreamRequest} message DeleteDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteDataStreamRequest} DeleteDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteDataStreamRequest} DeleteDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteDataStreamRequest} DeleteDataStreamRequest
                         */
                        DeleteDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteDataStreamRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteDataStreamRequest} message DeleteDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteDataStreamRequest";
                        };
    
                        return DeleteDataStreamRequest;
                    })();
    
                    v1alpha.UpdateDataStreamRequest = (function() {
    
                        /**
                         * Properties of an UpdateDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateDataStreamRequest
                         * @property {google.analytics.admin.v1alpha.IDataStream|null} [dataStream] UpdateDataStreamRequest dataStream
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateDataStreamRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateDataStreamRequest.
                         * @implements IUpdateDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateDataStreamRequest=} [properties] Properties to set
                         */
                        function UpdateDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateDataStreamRequest dataStream.
                         * @member {google.analytics.admin.v1alpha.IDataStream|null|undefined} dataStream
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @instance
                         */
                        UpdateDataStreamRequest.prototype.dataStream = null;
    
                        /**
                         * UpdateDataStreamRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @instance
                         */
                        UpdateDataStreamRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateDataStreamRequest} UpdateDataStreamRequest instance
                         */
                        UpdateDataStreamRequest.create = function create(properties) {
                            return new UpdateDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDataStreamRequest} message UpdateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dataStream != null && Object.hasOwnProperty.call(message, "dataStream"))
                                $root.google.analytics.admin.v1alpha.DataStream.encode(message.dataStream, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateDataStreamRequest} message UpdateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateDataStreamRequest} UpdateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dataStream = $root.google.analytics.admin.v1alpha.DataStream.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateDataStreamRequest} UpdateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                var error = $root.google.analytics.admin.v1alpha.DataStream.verify(message.dataStream);
                                if (error)
                                    return "dataStream." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateDataStreamRequest} UpdateDataStreamRequest
                         */
                        UpdateDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateDataStreamRequest();
                            if (object.dataStream != null) {
                                if (typeof object.dataStream !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateDataStreamRequest.dataStream: object expected");
                                message.dataStream = $root.google.analytics.admin.v1alpha.DataStream.fromObject(object.dataStream);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateDataStreamRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateDataStreamRequest} message UpdateDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.dataStream = null;
                                object.updateMask = null;
                            }
                            if (message.dataStream != null && message.hasOwnProperty("dataStream"))
                                object.dataStream = $root.google.analytics.admin.v1alpha.DataStream.toObject(message.dataStream, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateDataStreamRequest";
                        };
    
                        return UpdateDataStreamRequest;
                    })();
    
                    v1alpha.ListDataStreamsRequest = (function() {
    
                        /**
                         * Properties of a ListDataStreamsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListDataStreamsRequest
                         * @property {string|null} [parent] ListDataStreamsRequest parent
                         * @property {number|null} [pageSize] ListDataStreamsRequest pageSize
                         * @property {string|null} [pageToken] ListDataStreamsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListDataStreamsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListDataStreamsRequest.
                         * @implements IListDataStreamsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsRequest=} [properties] Properties to set
                         */
                        function ListDataStreamsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDataStreamsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @instance
                         */
                        ListDataStreamsRequest.prototype.parent = "";
    
                        /**
                         * ListDataStreamsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @instance
                         */
                        ListDataStreamsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListDataStreamsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @instance
                         */
                        ListDataStreamsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListDataStreamsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsRequest} ListDataStreamsRequest instance
                         */
                        ListDataStreamsRequest.create = function create(properties) {
                            return new ListDataStreamsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListDataStreamsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsRequest} message ListDataStreamsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListDataStreamsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsRequest} message ListDataStreamsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDataStreamsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsRequest} ListDataStreamsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListDataStreamsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDataStreamsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsRequest} ListDataStreamsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDataStreamsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDataStreamsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDataStreamsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsRequest} ListDataStreamsRequest
                         */
                        ListDataStreamsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListDataStreamsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListDataStreamsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDataStreamsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListDataStreamsRequest} message ListDataStreamsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDataStreamsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDataStreamsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDataStreamsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDataStreamsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDataStreamsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListDataStreamsRequest";
                        };
    
                        return ListDataStreamsRequest;
                    })();
    
                    v1alpha.ListDataStreamsResponse = (function() {
    
                        /**
                         * Properties of a ListDataStreamsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListDataStreamsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IDataStream>|null} [dataStreams] ListDataStreamsResponse dataStreams
                         * @property {string|null} [nextPageToken] ListDataStreamsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListDataStreamsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListDataStreamsResponse.
                         * @implements IListDataStreamsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsResponse=} [properties] Properties to set
                         */
                        function ListDataStreamsResponse(properties) {
                            this.dataStreams = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDataStreamsResponse dataStreams.
                         * @member {Array.<google.analytics.admin.v1alpha.IDataStream>} dataStreams
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @instance
                         */
                        ListDataStreamsResponse.prototype.dataStreams = $util.emptyArray;
    
                        /**
                         * ListDataStreamsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @instance
                         */
                        ListDataStreamsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListDataStreamsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsResponse} ListDataStreamsResponse instance
                         */
                        ListDataStreamsResponse.create = function create(properties) {
                            return new ListDataStreamsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListDataStreamsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsResponse} message ListDataStreamsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dataStreams != null && message.dataStreams.length)
                                for (var i = 0; i < message.dataStreams.length; ++i)
                                    $root.google.analytics.admin.v1alpha.DataStream.encode(message.dataStreams[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListDataStreamsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListDataStreamsResponse} message ListDataStreamsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDataStreamsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsResponse} ListDataStreamsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListDataStreamsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.dataStreams && message.dataStreams.length))
                                            message.dataStreams = [];
                                        message.dataStreams.push($root.google.analytics.admin.v1alpha.DataStream.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDataStreamsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsResponse} ListDataStreamsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDataStreamsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDataStreamsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dataStreams != null && message.hasOwnProperty("dataStreams")) {
                                if (!Array.isArray(message.dataStreams))
                                    return "dataStreams: array expected";
                                for (var i = 0; i < message.dataStreams.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.DataStream.verify(message.dataStreams[i]);
                                    if (error)
                                        return "dataStreams." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDataStreamsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListDataStreamsResponse} ListDataStreamsResponse
                         */
                        ListDataStreamsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListDataStreamsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListDataStreamsResponse();
                            if (object.dataStreams) {
                                if (!Array.isArray(object.dataStreams))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListDataStreamsResponse.dataStreams: array expected");
                                message.dataStreams = [];
                                for (var i = 0; i < object.dataStreams.length; ++i) {
                                    if (typeof object.dataStreams[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListDataStreamsResponse.dataStreams: object expected");
                                    message.dataStreams[i] = $root.google.analytics.admin.v1alpha.DataStream.fromObject(object.dataStreams[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDataStreamsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListDataStreamsResponse} message ListDataStreamsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDataStreamsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.dataStreams = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.dataStreams && message.dataStreams.length) {
                                object.dataStreams = [];
                                for (var j = 0; j < message.dataStreams.length; ++j)
                                    object.dataStreams[j] = $root.google.analytics.admin.v1alpha.DataStream.toObject(message.dataStreams[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDataStreamsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDataStreamsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDataStreamsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListDataStreamsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDataStreamsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListDataStreamsResponse";
                        };
    
                        return ListDataStreamsResponse;
                    })();
    
                    v1alpha.GetDataStreamRequest = (function() {
    
                        /**
                         * Properties of a GetDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetDataStreamRequest
                         * @property {string|null} [name] GetDataStreamRequest name
                         */
    
                        /**
                         * Constructs a new GetDataStreamRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetDataStreamRequest.
                         * @implements IGetDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetDataStreamRequest=} [properties] Properties to set
                         */
                        function GetDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDataStreamRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @instance
                         */
                        GetDataStreamRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetDataStreamRequest} GetDataStreamRequest instance
                         */
                        GetDataStreamRequest.create = function create(properties) {
                            return new GetDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataStreamRequest} message GetDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetDataStreamRequest} message GetDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetDataStreamRequest} GetDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetDataStreamRequest} GetDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetDataStreamRequest} GetDataStreamRequest
                         */
                        GetDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetDataStreamRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetDataStreamRequest} message GetDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetDataStreamRequest";
                        };
    
                        return GetDataStreamRequest;
                    })();
    
                    v1alpha.GetAudienceRequest = (function() {
    
                        /**
                         * Properties of a GetAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetAudienceRequest
                         * @property {string|null} [name] GetAudienceRequest name
                         */
    
                        /**
                         * Constructs a new GetAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetAudienceRequest.
                         * @implements IGetAudienceRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetAudienceRequest=} [properties] Properties to set
                         */
                        function GetAudienceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAudienceRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @instance
                         */
                        GetAudienceRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetAudienceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAudienceRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetAudienceRequest} GetAudienceRequest instance
                         */
                        GetAudienceRequest.create = function create(properties) {
                            return new GetAudienceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAudienceRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetAudienceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAudienceRequest} message GetAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAudienceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAudienceRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetAudienceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAudienceRequest} message GetAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAudienceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAudienceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetAudienceRequest} GetAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAudienceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetAudienceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAudienceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetAudienceRequest} GetAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAudienceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAudienceRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAudienceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAudienceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetAudienceRequest} GetAudienceRequest
                         */
                        GetAudienceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetAudienceRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetAudienceRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAudienceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetAudienceRequest} message GetAudienceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAudienceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetAudienceRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAudienceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAudienceRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetAudienceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAudienceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetAudienceRequest";
                        };
    
                        return GetAudienceRequest;
                    })();
    
                    v1alpha.ListAudiencesRequest = (function() {
    
                        /**
                         * Properties of a ListAudiencesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAudiencesRequest
                         * @property {string|null} [parent] ListAudiencesRequest parent
                         * @property {number|null} [pageSize] ListAudiencesRequest pageSize
                         * @property {string|null} [pageToken] ListAudiencesRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListAudiencesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAudiencesRequest.
                         * @implements IListAudiencesRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAudiencesRequest=} [properties] Properties to set
                         */
                        function ListAudiencesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAudiencesRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @instance
                         */
                        ListAudiencesRequest.prototype.parent = "";
    
                        /**
                         * ListAudiencesRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @instance
                         */
                        ListAudiencesRequest.prototype.pageSize = 0;
    
                        /**
                         * ListAudiencesRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @instance
                         */
                        ListAudiencesRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListAudiencesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAudiencesRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesRequest} ListAudiencesRequest instance
                         */
                        ListAudiencesRequest.create = function create(properties) {
                            return new ListAudiencesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAudiencesRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAudiencesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAudiencesRequest} message ListAudiencesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAudiencesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAudiencesRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAudiencesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAudiencesRequest} message ListAudiencesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAudiencesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAudiencesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesRequest} ListAudiencesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAudiencesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAudiencesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAudiencesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesRequest} ListAudiencesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAudiencesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAudiencesRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAudiencesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAudiencesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesRequest} ListAudiencesRequest
                         */
                        ListAudiencesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAudiencesRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAudiencesRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAudiencesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAudiencesRequest} message ListAudiencesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAudiencesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAudiencesRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAudiencesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAudiencesRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAudiencesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAudiencesRequest";
                        };
    
                        return ListAudiencesRequest;
                    })();
    
                    v1alpha.ListAudiencesResponse = (function() {
    
                        /**
                         * Properties of a ListAudiencesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAudiencesResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAudience>|null} [audiences] ListAudiencesResponse audiences
                         * @property {string|null} [nextPageToken] ListAudiencesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListAudiencesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAudiencesResponse.
                         * @implements IListAudiencesResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAudiencesResponse=} [properties] Properties to set
                         */
                        function ListAudiencesResponse(properties) {
                            this.audiences = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAudiencesResponse audiences.
                         * @member {Array.<google.analytics.admin.v1alpha.IAudience>} audiences
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @instance
                         */
                        ListAudiencesResponse.prototype.audiences = $util.emptyArray;
    
                        /**
                         * ListAudiencesResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @instance
                         */
                        ListAudiencesResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListAudiencesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAudiencesResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesResponse} ListAudiencesResponse instance
                         */
                        ListAudiencesResponse.create = function create(properties) {
                            return new ListAudiencesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListAudiencesResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAudiencesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAudiencesResponse} message ListAudiencesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAudiencesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.audiences != null && message.audiences.length)
                                for (var i = 0; i < message.audiences.length; ++i)
                                    $root.google.analytics.admin.v1alpha.Audience.encode(message.audiences[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAudiencesResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAudiencesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAudiencesResponse} message ListAudiencesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAudiencesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAudiencesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesResponse} ListAudiencesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAudiencesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAudiencesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.audiences && message.audiences.length))
                                            message.audiences = [];
                                        message.audiences.push($root.google.analytics.admin.v1alpha.Audience.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAudiencesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesResponse} ListAudiencesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAudiencesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAudiencesResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAudiencesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.audiences != null && message.hasOwnProperty("audiences")) {
                                if (!Array.isArray(message.audiences))
                                    return "audiences: array expected";
                                for (var i = 0; i < message.audiences.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.Audience.verify(message.audiences[i]);
                                    if (error)
                                        return "audiences." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAudiencesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAudiencesResponse} ListAudiencesResponse
                         */
                        ListAudiencesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAudiencesResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAudiencesResponse();
                            if (object.audiences) {
                                if (!Array.isArray(object.audiences))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListAudiencesResponse.audiences: array expected");
                                message.audiences = [];
                                for (var i = 0; i < object.audiences.length; ++i) {
                                    if (typeof object.audiences[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListAudiencesResponse.audiences: object expected");
                                    message.audiences[i] = $root.google.analytics.admin.v1alpha.Audience.fromObject(object.audiences[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAudiencesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAudiencesResponse} message ListAudiencesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAudiencesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.audiences = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.audiences && message.audiences.length) {
                                object.audiences = [];
                                for (var j = 0; j < message.audiences.length; ++j)
                                    object.audiences[j] = $root.google.analytics.admin.v1alpha.Audience.toObject(message.audiences[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAudiencesResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAudiencesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAudiencesResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAudiencesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAudiencesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAudiencesResponse";
                        };
    
                        return ListAudiencesResponse;
                    })();
    
                    v1alpha.CreateAudienceRequest = (function() {
    
                        /**
                         * Properties of a CreateAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateAudienceRequest
                         * @property {string|null} [parent] CreateAudienceRequest parent
                         * @property {google.analytics.admin.v1alpha.IAudience|null} [audience] CreateAudienceRequest audience
                         */
    
                        /**
                         * Constructs a new CreateAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateAudienceRequest.
                         * @implements ICreateAudienceRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateAudienceRequest=} [properties] Properties to set
                         */
                        function CreateAudienceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateAudienceRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @instance
                         */
                        CreateAudienceRequest.prototype.parent = "";
    
                        /**
                         * CreateAudienceRequest audience.
                         * @member {google.analytics.admin.v1alpha.IAudience|null|undefined} audience
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @instance
                         */
                        CreateAudienceRequest.prototype.audience = null;
    
                        /**
                         * Creates a new CreateAudienceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAudienceRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateAudienceRequest} CreateAudienceRequest instance
                         */
                        CreateAudienceRequest.create = function create(properties) {
                            return new CreateAudienceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateAudienceRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateAudienceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAudienceRequest} message CreateAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateAudienceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.audience != null && Object.hasOwnProperty.call(message, "audience"))
                                $root.google.analytics.admin.v1alpha.Audience.encode(message.audience, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateAudienceRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateAudienceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAudienceRequest} message CreateAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateAudienceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateAudienceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateAudienceRequest} CreateAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateAudienceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateAudienceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.audience = $root.google.analytics.admin.v1alpha.Audience.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateAudienceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateAudienceRequest} CreateAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateAudienceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateAudienceRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateAudienceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.audience != null && message.hasOwnProperty("audience")) {
                                var error = $root.google.analytics.admin.v1alpha.Audience.verify(message.audience);
                                if (error)
                                    return "audience." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateAudienceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateAudienceRequest} CreateAudienceRequest
                         */
                        CreateAudienceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateAudienceRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateAudienceRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.audience != null) {
                                if (typeof object.audience !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateAudienceRequest.audience: object expected");
                                message.audience = $root.google.analytics.admin.v1alpha.Audience.fromObject(object.audience);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateAudienceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateAudienceRequest} message CreateAudienceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateAudienceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.audience = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.audience != null && message.hasOwnProperty("audience"))
                                object.audience = $root.google.analytics.admin.v1alpha.Audience.toObject(message.audience, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateAudienceRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateAudienceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateAudienceRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateAudienceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateAudienceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateAudienceRequest";
                        };
    
                        return CreateAudienceRequest;
                    })();
    
                    v1alpha.UpdateAudienceRequest = (function() {
    
                        /**
                         * Properties of an UpdateAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateAudienceRequest
                         * @property {google.analytics.admin.v1alpha.IAudience|null} [audience] UpdateAudienceRequest audience
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateAudienceRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateAudienceRequest.
                         * @implements IUpdateAudienceRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateAudienceRequest=} [properties] Properties to set
                         */
                        function UpdateAudienceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateAudienceRequest audience.
                         * @member {google.analytics.admin.v1alpha.IAudience|null|undefined} audience
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @instance
                         */
                        UpdateAudienceRequest.prototype.audience = null;
    
                        /**
                         * UpdateAudienceRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @instance
                         */
                        UpdateAudienceRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateAudienceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAudienceRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateAudienceRequest} UpdateAudienceRequest instance
                         */
                        UpdateAudienceRequest.create = function create(properties) {
                            return new UpdateAudienceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateAudienceRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAudienceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAudienceRequest} message UpdateAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAudienceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.audience != null && Object.hasOwnProperty.call(message, "audience"))
                                $root.google.analytics.admin.v1alpha.Audience.encode(message.audience, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateAudienceRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAudienceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAudienceRequest} message UpdateAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAudienceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateAudienceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateAudienceRequest} UpdateAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAudienceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateAudienceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.audience = $root.google.analytics.admin.v1alpha.Audience.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateAudienceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateAudienceRequest} UpdateAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAudienceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateAudienceRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateAudienceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.audience != null && message.hasOwnProperty("audience")) {
                                var error = $root.google.analytics.admin.v1alpha.Audience.verify(message.audience);
                                if (error)
                                    return "audience." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateAudienceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateAudienceRequest} UpdateAudienceRequest
                         */
                        UpdateAudienceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateAudienceRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateAudienceRequest();
                            if (object.audience != null) {
                                if (typeof object.audience !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateAudienceRequest.audience: object expected");
                                message.audience = $root.google.analytics.admin.v1alpha.Audience.fromObject(object.audience);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateAudienceRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateAudienceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateAudienceRequest} message UpdateAudienceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateAudienceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.audience = null;
                                object.updateMask = null;
                            }
                            if (message.audience != null && message.hasOwnProperty("audience"))
                                object.audience = $root.google.analytics.admin.v1alpha.Audience.toObject(message.audience, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateAudienceRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateAudienceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateAudienceRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateAudienceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateAudienceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateAudienceRequest";
                        };
    
                        return UpdateAudienceRequest;
                    })();
    
                    v1alpha.ArchiveAudienceRequest = (function() {
    
                        /**
                         * Properties of an ArchiveAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IArchiveAudienceRequest
                         * @property {string|null} [name] ArchiveAudienceRequest name
                         */
    
                        /**
                         * Constructs a new ArchiveAudienceRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ArchiveAudienceRequest.
                         * @implements IArchiveAudienceRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IArchiveAudienceRequest=} [properties] Properties to set
                         */
                        function ArchiveAudienceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ArchiveAudienceRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @instance
                         */
                        ArchiveAudienceRequest.prototype.name = "";
    
                        /**
                         * Creates a new ArchiveAudienceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveAudienceRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ArchiveAudienceRequest} ArchiveAudienceRequest instance
                         */
                        ArchiveAudienceRequest.create = function create(properties) {
                            return new ArchiveAudienceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ArchiveAudienceRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ArchiveAudienceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveAudienceRequest} message ArchiveAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveAudienceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ArchiveAudienceRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ArchiveAudienceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IArchiveAudienceRequest} message ArchiveAudienceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveAudienceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ArchiveAudienceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ArchiveAudienceRequest} ArchiveAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveAudienceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ArchiveAudienceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ArchiveAudienceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ArchiveAudienceRequest} ArchiveAudienceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveAudienceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ArchiveAudienceRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ArchiveAudienceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ArchiveAudienceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ArchiveAudienceRequest} ArchiveAudienceRequest
                         */
                        ArchiveAudienceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ArchiveAudienceRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ArchiveAudienceRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ArchiveAudienceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ArchiveAudienceRequest} message ArchiveAudienceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ArchiveAudienceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this ArchiveAudienceRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ArchiveAudienceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ArchiveAudienceRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ArchiveAudienceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ArchiveAudienceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ArchiveAudienceRequest";
                        };
    
                        return ArchiveAudienceRequest;
                    })();
    
                    v1alpha.GetAttributionSettingsRequest = (function() {
    
                        /**
                         * Properties of a GetAttributionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetAttributionSettingsRequest
                         * @property {string|null} [name] GetAttributionSettingsRequest name
                         */
    
                        /**
                         * Constructs a new GetAttributionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetAttributionSettingsRequest.
                         * @implements IGetAttributionSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetAttributionSettingsRequest=} [properties] Properties to set
                         */
                        function GetAttributionSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAttributionSettingsRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @instance
                         */
                        GetAttributionSettingsRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetAttributionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAttributionSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetAttributionSettingsRequest} GetAttributionSettingsRequest instance
                         */
                        GetAttributionSettingsRequest.create = function create(properties) {
                            return new GetAttributionSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAttributionSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetAttributionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAttributionSettingsRequest} message GetAttributionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAttributionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAttributionSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetAttributionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAttributionSettingsRequest} message GetAttributionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAttributionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAttributionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetAttributionSettingsRequest} GetAttributionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAttributionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetAttributionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAttributionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetAttributionSettingsRequest} GetAttributionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAttributionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAttributionSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAttributionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAttributionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetAttributionSettingsRequest} GetAttributionSettingsRequest
                         */
                        GetAttributionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetAttributionSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetAttributionSettingsRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAttributionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetAttributionSettingsRequest} message GetAttributionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAttributionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetAttributionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAttributionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAttributionSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetAttributionSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAttributionSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetAttributionSettingsRequest";
                        };
    
                        return GetAttributionSettingsRequest;
                    })();
    
                    v1alpha.UpdateAttributionSettingsRequest = (function() {
    
                        /**
                         * Properties of an UpdateAttributionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateAttributionSettingsRequest
                         * @property {google.analytics.admin.v1alpha.IAttributionSettings|null} [attributionSettings] UpdateAttributionSettingsRequest attributionSettings
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateAttributionSettingsRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateAttributionSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateAttributionSettingsRequest.
                         * @implements IUpdateAttributionSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateAttributionSettingsRequest=} [properties] Properties to set
                         */
                        function UpdateAttributionSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateAttributionSettingsRequest attributionSettings.
                         * @member {google.analytics.admin.v1alpha.IAttributionSettings|null|undefined} attributionSettings
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @instance
                         */
                        UpdateAttributionSettingsRequest.prototype.attributionSettings = null;
    
                        /**
                         * UpdateAttributionSettingsRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @instance
                         */
                        UpdateAttributionSettingsRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateAttributionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAttributionSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest} UpdateAttributionSettingsRequest instance
                         */
                        UpdateAttributionSettingsRequest.create = function create(properties) {
                            return new UpdateAttributionSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateAttributionSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAttributionSettingsRequest} message UpdateAttributionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAttributionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.attributionSettings != null && Object.hasOwnProperty.call(message, "attributionSettings"))
                                $root.google.analytics.admin.v1alpha.AttributionSettings.encode(message.attributionSettings, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateAttributionSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAttributionSettingsRequest} message UpdateAttributionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAttributionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateAttributionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest} UpdateAttributionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAttributionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.attributionSettings = $root.google.analytics.admin.v1alpha.AttributionSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateAttributionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest} UpdateAttributionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAttributionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateAttributionSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateAttributionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.attributionSettings != null && message.hasOwnProperty("attributionSettings")) {
                                var error = $root.google.analytics.admin.v1alpha.AttributionSettings.verify(message.attributionSettings);
                                if (error)
                                    return "attributionSettings." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateAttributionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest} UpdateAttributionSettingsRequest
                         */
                        UpdateAttributionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest();
                            if (object.attributionSettings != null) {
                                if (typeof object.attributionSettings !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest.attributionSettings: object expected");
                                message.attributionSettings = $root.google.analytics.admin.v1alpha.AttributionSettings.fromObject(object.attributionSettings);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateAttributionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest} message UpdateAttributionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateAttributionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.attributionSettings = null;
                                object.updateMask = null;
                            }
                            if (message.attributionSettings != null && message.hasOwnProperty("attributionSettings"))
                                object.attributionSettings = $root.google.analytics.admin.v1alpha.AttributionSettings.toObject(message.attributionSettings, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateAttributionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateAttributionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateAttributionSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateAttributionSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateAttributionSettingsRequest";
                        };
    
                        return UpdateAttributionSettingsRequest;
                    })();
    
                    v1alpha.GetAccessBindingRequest = (function() {
    
                        /**
                         * Properties of a GetAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetAccessBindingRequest
                         * @property {string|null} [name] GetAccessBindingRequest name
                         */
    
                        /**
                         * Constructs a new GetAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetAccessBindingRequest.
                         * @implements IGetAccessBindingRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetAccessBindingRequest=} [properties] Properties to set
                         */
                        function GetAccessBindingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAccessBindingRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @instance
                         */
                        GetAccessBindingRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetAccessBindingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAccessBindingRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetAccessBindingRequest} GetAccessBindingRequest instance
                         */
                        GetAccessBindingRequest.create = function create(properties) {
                            return new GetAccessBindingRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAccessBindingRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetAccessBindingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAccessBindingRequest} message GetAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccessBindingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAccessBindingRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetAccessBindingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAccessBindingRequest} message GetAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccessBindingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAccessBindingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetAccessBindingRequest} GetAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccessBindingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetAccessBindingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAccessBindingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetAccessBindingRequest} GetAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccessBindingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAccessBindingRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAccessBindingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAccessBindingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetAccessBindingRequest} GetAccessBindingRequest
                         */
                        GetAccessBindingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetAccessBindingRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetAccessBindingRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAccessBindingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetAccessBindingRequest} message GetAccessBindingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAccessBindingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetAccessBindingRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAccessBindingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAccessBindingRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetAccessBindingRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAccessBindingRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetAccessBindingRequest";
                        };
    
                        return GetAccessBindingRequest;
                    })();
    
                    v1alpha.BatchGetAccessBindingsRequest = (function() {
    
                        /**
                         * Properties of a BatchGetAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchGetAccessBindingsRequest
                         * @property {string|null} [parent] BatchGetAccessBindingsRequest parent
                         * @property {Array.<string>|null} [names] BatchGetAccessBindingsRequest names
                         */
    
                        /**
                         * Constructs a new BatchGetAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchGetAccessBindingsRequest.
                         * @implements IBatchGetAccessBindingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsRequest=} [properties] Properties to set
                         */
                        function BatchGetAccessBindingsRequest(properties) {
                            this.names = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchGetAccessBindingsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @instance
                         */
                        BatchGetAccessBindingsRequest.prototype.parent = "";
    
                        /**
                         * BatchGetAccessBindingsRequest names.
                         * @member {Array.<string>} names
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @instance
                         */
                        BatchGetAccessBindingsRequest.prototype.names = $util.emptyArray;
    
                        /**
                         * Creates a new BatchGetAccessBindingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest} BatchGetAccessBindingsRequest instance
                         */
                        BatchGetAccessBindingsRequest.create = function create(properties) {
                            return new BatchGetAccessBindingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchGetAccessBindingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsRequest} message BatchGetAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetAccessBindingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.names != null && message.names.length)
                                for (var i = 0; i < message.names.length; ++i)
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.names[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchGetAccessBindingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsRequest} message BatchGetAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetAccessBindingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchGetAccessBindingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest} BatchGetAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetAccessBindingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.names && message.names.length))
                                            message.names = [];
                                        message.names.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchGetAccessBindingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest} BatchGetAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetAccessBindingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchGetAccessBindingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchGetAccessBindingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.names != null && message.hasOwnProperty("names")) {
                                if (!Array.isArray(message.names))
                                    return "names: array expected";
                                for (var i = 0; i < message.names.length; ++i)
                                    if (!$util.isString(message.names[i]))
                                        return "names: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchGetAccessBindingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest} BatchGetAccessBindingsRequest
                         */
                        BatchGetAccessBindingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.names) {
                                if (!Array.isArray(object.names))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest.names: array expected");
                                message.names = [];
                                for (var i = 0; i < object.names.length; ++i)
                                    message.names[i] = String(object.names[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchGetAccessBindingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest} message BatchGetAccessBindingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchGetAccessBindingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.names = [];
                            if (options.defaults)
                                object.parent = "";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.names && message.names.length) {
                                object.names = [];
                                for (var j = 0; j < message.names.length; ++j)
                                    object.names[j] = message.names[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchGetAccessBindingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchGetAccessBindingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchGetAccessBindingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchGetAccessBindingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchGetAccessBindingsRequest";
                        };
    
                        return BatchGetAccessBindingsRequest;
                    })();
    
                    v1alpha.BatchGetAccessBindingsResponse = (function() {
    
                        /**
                         * Properties of a BatchGetAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchGetAccessBindingsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessBinding>|null} [accessBindings] BatchGetAccessBindingsResponse accessBindings
                         */
    
                        /**
                         * Constructs a new BatchGetAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchGetAccessBindingsResponse.
                         * @implements IBatchGetAccessBindingsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsResponse=} [properties] Properties to set
                         */
                        function BatchGetAccessBindingsResponse(properties) {
                            this.accessBindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchGetAccessBindingsResponse accessBindings.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessBinding>} accessBindings
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @instance
                         */
                        BatchGetAccessBindingsResponse.prototype.accessBindings = $util.emptyArray;
    
                        /**
                         * Creates a new BatchGetAccessBindingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse} BatchGetAccessBindingsResponse instance
                         */
                        BatchGetAccessBindingsResponse.create = function create(properties) {
                            return new BatchGetAccessBindingsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified BatchGetAccessBindingsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsResponse} message BatchGetAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetAccessBindingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accessBindings != null && message.accessBindings.length)
                                for (var i = 0; i < message.accessBindings.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessBinding.encode(message.accessBindings[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchGetAccessBindingsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchGetAccessBindingsResponse} message BatchGetAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchGetAccessBindingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchGetAccessBindingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse} BatchGetAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetAccessBindingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accessBindings && message.accessBindings.length))
                                            message.accessBindings = [];
                                        message.accessBindings.push($root.google.analytics.admin.v1alpha.AccessBinding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchGetAccessBindingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse} BatchGetAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchGetAccessBindingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchGetAccessBindingsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchGetAccessBindingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accessBindings != null && message.hasOwnProperty("accessBindings")) {
                                if (!Array.isArray(message.accessBindings))
                                    return "accessBindings: array expected";
                                for (var i = 0; i < message.accessBindings.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessBinding.verify(message.accessBindings[i]);
                                    if (error)
                                        return "accessBindings." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchGetAccessBindingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse} BatchGetAccessBindingsResponse
                         */
                        BatchGetAccessBindingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse();
                            if (object.accessBindings) {
                                if (!Array.isArray(object.accessBindings))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse.accessBindings: array expected");
                                message.accessBindings = [];
                                for (var i = 0; i < object.accessBindings.length; ++i) {
                                    if (typeof object.accessBindings[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse.accessBindings: object expected");
                                    message.accessBindings[i] = $root.google.analytics.admin.v1alpha.AccessBinding.fromObject(object.accessBindings[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchGetAccessBindingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse} message BatchGetAccessBindingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchGetAccessBindingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accessBindings = [];
                            if (message.accessBindings && message.accessBindings.length) {
                                object.accessBindings = [];
                                for (var j = 0; j < message.accessBindings.length; ++j)
                                    object.accessBindings[j] = $root.google.analytics.admin.v1alpha.AccessBinding.toObject(message.accessBindings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchGetAccessBindingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchGetAccessBindingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchGetAccessBindingsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchGetAccessBindingsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchGetAccessBindingsResponse";
                        };
    
                        return BatchGetAccessBindingsResponse;
                    })();
    
                    v1alpha.ListAccessBindingsRequest = (function() {
    
                        /**
                         * Properties of a ListAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAccessBindingsRequest
                         * @property {string|null} [parent] ListAccessBindingsRequest parent
                         * @property {number|null} [pageSize] ListAccessBindingsRequest pageSize
                         * @property {string|null} [pageToken] ListAccessBindingsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAccessBindingsRequest.
                         * @implements IListAccessBindingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsRequest=} [properties] Properties to set
                         */
                        function ListAccessBindingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccessBindingsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @instance
                         */
                        ListAccessBindingsRequest.prototype.parent = "";
    
                        /**
                         * ListAccessBindingsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @instance
                         */
                        ListAccessBindingsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListAccessBindingsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @instance
                         */
                        ListAccessBindingsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListAccessBindingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsRequest} ListAccessBindingsRequest instance
                         */
                        ListAccessBindingsRequest.create = function create(properties) {
                            return new ListAccessBindingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccessBindingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccessBindingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsRequest} message ListAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessBindingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccessBindingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccessBindingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsRequest} message ListAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessBindingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccessBindingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsRequest} ListAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessBindingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAccessBindingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccessBindingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsRequest} ListAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessBindingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccessBindingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccessBindingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccessBindingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsRequest} ListAccessBindingsRequest
                         */
                        ListAccessBindingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAccessBindingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAccessBindingsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccessBindingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAccessBindingsRequest} message ListAccessBindingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccessBindingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccessBindingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccessBindingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccessBindingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccessBindingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAccessBindingsRequest";
                        };
    
                        return ListAccessBindingsRequest;
                    })();
    
                    v1alpha.ListAccessBindingsResponse = (function() {
    
                        /**
                         * Properties of a ListAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAccessBindingsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessBinding>|null} [accessBindings] ListAccessBindingsResponse accessBindings
                         * @property {string|null} [nextPageToken] ListAccessBindingsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAccessBindingsResponse.
                         * @implements IListAccessBindingsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsResponse=} [properties] Properties to set
                         */
                        function ListAccessBindingsResponse(properties) {
                            this.accessBindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccessBindingsResponse accessBindings.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessBinding>} accessBindings
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @instance
                         */
                        ListAccessBindingsResponse.prototype.accessBindings = $util.emptyArray;
    
                        /**
                         * ListAccessBindingsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @instance
                         */
                        ListAccessBindingsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListAccessBindingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsResponse} ListAccessBindingsResponse instance
                         */
                        ListAccessBindingsResponse.create = function create(properties) {
                            return new ListAccessBindingsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccessBindingsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccessBindingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsResponse} message ListAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessBindingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accessBindings != null && message.accessBindings.length)
                                for (var i = 0; i < message.accessBindings.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessBinding.encode(message.accessBindings[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccessBindingsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAccessBindingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAccessBindingsResponse} message ListAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccessBindingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccessBindingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsResponse} ListAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessBindingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAccessBindingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accessBindings && message.accessBindings.length))
                                            message.accessBindings = [];
                                        message.accessBindings.push($root.google.analytics.admin.v1alpha.AccessBinding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccessBindingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsResponse} ListAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccessBindingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccessBindingsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccessBindingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accessBindings != null && message.hasOwnProperty("accessBindings")) {
                                if (!Array.isArray(message.accessBindings))
                                    return "accessBindings: array expected";
                                for (var i = 0; i < message.accessBindings.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessBinding.verify(message.accessBindings[i]);
                                    if (error)
                                        return "accessBindings." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccessBindingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAccessBindingsResponse} ListAccessBindingsResponse
                         */
                        ListAccessBindingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAccessBindingsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAccessBindingsResponse();
                            if (object.accessBindings) {
                                if (!Array.isArray(object.accessBindings))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListAccessBindingsResponse.accessBindings: array expected");
                                message.accessBindings = [];
                                for (var i = 0; i < object.accessBindings.length; ++i) {
                                    if (typeof object.accessBindings[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListAccessBindingsResponse.accessBindings: object expected");
                                    message.accessBindings[i] = $root.google.analytics.admin.v1alpha.AccessBinding.fromObject(object.accessBindings[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccessBindingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAccessBindingsResponse} message ListAccessBindingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccessBindingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accessBindings = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.accessBindings && message.accessBindings.length) {
                                object.accessBindings = [];
                                for (var j = 0; j < message.accessBindings.length; ++j)
                                    object.accessBindings[j] = $root.google.analytics.admin.v1alpha.AccessBinding.toObject(message.accessBindings[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccessBindingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccessBindingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccessBindingsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAccessBindingsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccessBindingsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAccessBindingsResponse";
                        };
    
                        return ListAccessBindingsResponse;
                    })();
    
                    v1alpha.CreateAccessBindingRequest = (function() {
    
                        /**
                         * Properties of a CreateAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateAccessBindingRequest
                         * @property {string|null} [parent] CreateAccessBindingRequest parent
                         * @property {google.analytics.admin.v1alpha.IAccessBinding|null} [accessBinding] CreateAccessBindingRequest accessBinding
                         */
    
                        /**
                         * Constructs a new CreateAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateAccessBindingRequest.
                         * @implements ICreateAccessBindingRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateAccessBindingRequest=} [properties] Properties to set
                         */
                        function CreateAccessBindingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateAccessBindingRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @instance
                         */
                        CreateAccessBindingRequest.prototype.parent = "";
    
                        /**
                         * CreateAccessBindingRequest accessBinding.
                         * @member {google.analytics.admin.v1alpha.IAccessBinding|null|undefined} accessBinding
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @instance
                         */
                        CreateAccessBindingRequest.prototype.accessBinding = null;
    
                        /**
                         * Creates a new CreateAccessBindingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAccessBindingRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateAccessBindingRequest} CreateAccessBindingRequest instance
                         */
                        CreateAccessBindingRequest.create = function create(properties) {
                            return new CreateAccessBindingRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateAccessBindingRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateAccessBindingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAccessBindingRequest} message CreateAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateAccessBindingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.accessBinding != null && Object.hasOwnProperty.call(message, "accessBinding"))
                                $root.google.analytics.admin.v1alpha.AccessBinding.encode(message.accessBinding, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateAccessBindingRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateAccessBindingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAccessBindingRequest} message CreateAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateAccessBindingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateAccessBindingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateAccessBindingRequest} CreateAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateAccessBindingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.accessBinding = $root.google.analytics.admin.v1alpha.AccessBinding.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateAccessBindingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateAccessBindingRequest} CreateAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateAccessBindingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateAccessBindingRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateAccessBindingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.accessBinding != null && message.hasOwnProperty("accessBinding")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessBinding.verify(message.accessBinding);
                                if (error)
                                    return "accessBinding." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateAccessBindingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateAccessBindingRequest} CreateAccessBindingRequest
                         */
                        CreateAccessBindingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.accessBinding != null) {
                                if (typeof object.accessBinding !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateAccessBindingRequest.accessBinding: object expected");
                                message.accessBinding = $root.google.analytics.admin.v1alpha.AccessBinding.fromObject(object.accessBinding);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateAccessBindingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateAccessBindingRequest} message CreateAccessBindingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateAccessBindingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.accessBinding = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.accessBinding != null && message.hasOwnProperty("accessBinding"))
                                object.accessBinding = $root.google.analytics.admin.v1alpha.AccessBinding.toObject(message.accessBinding, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateAccessBindingRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateAccessBindingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateAccessBindingRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateAccessBindingRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateAccessBindingRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateAccessBindingRequest";
                        };
    
                        return CreateAccessBindingRequest;
                    })();
    
                    v1alpha.BatchCreateAccessBindingsRequest = (function() {
    
                        /**
                         * Properties of a BatchCreateAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchCreateAccessBindingsRequest
                         * @property {string|null} [parent] BatchCreateAccessBindingsRequest parent
                         * @property {Array.<google.analytics.admin.v1alpha.ICreateAccessBindingRequest>|null} [requests] BatchCreateAccessBindingsRequest requests
                         */
    
                        /**
                         * Constructs a new BatchCreateAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchCreateAccessBindingsRequest.
                         * @implements IBatchCreateAccessBindingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsRequest=} [properties] Properties to set
                         */
                        function BatchCreateAccessBindingsRequest(properties) {
                            this.requests = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchCreateAccessBindingsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @instance
                         */
                        BatchCreateAccessBindingsRequest.prototype.parent = "";
    
                        /**
                         * BatchCreateAccessBindingsRequest requests.
                         * @member {Array.<google.analytics.admin.v1alpha.ICreateAccessBindingRequest>} requests
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @instance
                         */
                        BatchCreateAccessBindingsRequest.prototype.requests = $util.emptyArray;
    
                        /**
                         * Creates a new BatchCreateAccessBindingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest} BatchCreateAccessBindingsRequest instance
                         */
                        BatchCreateAccessBindingsRequest.create = function create(properties) {
                            return new BatchCreateAccessBindingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchCreateAccessBindingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsRequest} message BatchCreateAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateAccessBindingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.requests != null && message.requests.length)
                                for (var i = 0; i < message.requests.length; ++i)
                                    $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest.encode(message.requests[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchCreateAccessBindingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsRequest} message BatchCreateAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateAccessBindingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchCreateAccessBindingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest} BatchCreateAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateAccessBindingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.requests && message.requests.length))
                                            message.requests = [];
                                        message.requests.push($root.google.analytics.admin.v1alpha.CreateAccessBindingRequest.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchCreateAccessBindingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest} BatchCreateAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateAccessBindingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchCreateAccessBindingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchCreateAccessBindingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.requests != null && message.hasOwnProperty("requests")) {
                                if (!Array.isArray(message.requests))
                                    return "requests: array expected";
                                for (var i = 0; i < message.requests.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest.verify(message.requests[i]);
                                    if (error)
                                        return "requests." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchCreateAccessBindingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest} BatchCreateAccessBindingsRequest
                         */
                        BatchCreateAccessBindingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.requests) {
                                if (!Array.isArray(object.requests))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest.requests: array expected");
                                message.requests = [];
                                for (var i = 0; i < object.requests.length; ++i) {
                                    if (typeof object.requests[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest.requests: object expected");
                                    message.requests[i] = $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest.fromObject(object.requests[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchCreateAccessBindingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest} message BatchCreateAccessBindingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchCreateAccessBindingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.requests = [];
                            if (options.defaults)
                                object.parent = "";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.requests && message.requests.length) {
                                object.requests = [];
                                for (var j = 0; j < message.requests.length; ++j)
                                    object.requests[j] = $root.google.analytics.admin.v1alpha.CreateAccessBindingRequest.toObject(message.requests[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchCreateAccessBindingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchCreateAccessBindingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchCreateAccessBindingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchCreateAccessBindingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchCreateAccessBindingsRequest";
                        };
    
                        return BatchCreateAccessBindingsRequest;
                    })();
    
                    v1alpha.BatchCreateAccessBindingsResponse = (function() {
    
                        /**
                         * Properties of a BatchCreateAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchCreateAccessBindingsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessBinding>|null} [accessBindings] BatchCreateAccessBindingsResponse accessBindings
                         */
    
                        /**
                         * Constructs a new BatchCreateAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchCreateAccessBindingsResponse.
                         * @implements IBatchCreateAccessBindingsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsResponse=} [properties] Properties to set
                         */
                        function BatchCreateAccessBindingsResponse(properties) {
                            this.accessBindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchCreateAccessBindingsResponse accessBindings.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessBinding>} accessBindings
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @instance
                         */
                        BatchCreateAccessBindingsResponse.prototype.accessBindings = $util.emptyArray;
    
                        /**
                         * Creates a new BatchCreateAccessBindingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse} BatchCreateAccessBindingsResponse instance
                         */
                        BatchCreateAccessBindingsResponse.create = function create(properties) {
                            return new BatchCreateAccessBindingsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified BatchCreateAccessBindingsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsResponse} message BatchCreateAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateAccessBindingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accessBindings != null && message.accessBindings.length)
                                for (var i = 0; i < message.accessBindings.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessBinding.encode(message.accessBindings[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchCreateAccessBindingsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchCreateAccessBindingsResponse} message BatchCreateAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchCreateAccessBindingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchCreateAccessBindingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse} BatchCreateAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateAccessBindingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accessBindings && message.accessBindings.length))
                                            message.accessBindings = [];
                                        message.accessBindings.push($root.google.analytics.admin.v1alpha.AccessBinding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchCreateAccessBindingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse} BatchCreateAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchCreateAccessBindingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchCreateAccessBindingsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchCreateAccessBindingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accessBindings != null && message.hasOwnProperty("accessBindings")) {
                                if (!Array.isArray(message.accessBindings))
                                    return "accessBindings: array expected";
                                for (var i = 0; i < message.accessBindings.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessBinding.verify(message.accessBindings[i]);
                                    if (error)
                                        return "accessBindings." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchCreateAccessBindingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse} BatchCreateAccessBindingsResponse
                         */
                        BatchCreateAccessBindingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse();
                            if (object.accessBindings) {
                                if (!Array.isArray(object.accessBindings))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse.accessBindings: array expected");
                                message.accessBindings = [];
                                for (var i = 0; i < object.accessBindings.length; ++i) {
                                    if (typeof object.accessBindings[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse.accessBindings: object expected");
                                    message.accessBindings[i] = $root.google.analytics.admin.v1alpha.AccessBinding.fromObject(object.accessBindings[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchCreateAccessBindingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse} message BatchCreateAccessBindingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchCreateAccessBindingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accessBindings = [];
                            if (message.accessBindings && message.accessBindings.length) {
                                object.accessBindings = [];
                                for (var j = 0; j < message.accessBindings.length; ++j)
                                    object.accessBindings[j] = $root.google.analytics.admin.v1alpha.AccessBinding.toObject(message.accessBindings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchCreateAccessBindingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchCreateAccessBindingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchCreateAccessBindingsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchCreateAccessBindingsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchCreateAccessBindingsResponse";
                        };
    
                        return BatchCreateAccessBindingsResponse;
                    })();
    
                    v1alpha.UpdateAccessBindingRequest = (function() {
    
                        /**
                         * Properties of an UpdateAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateAccessBindingRequest
                         * @property {google.analytics.admin.v1alpha.IAccessBinding|null} [accessBinding] UpdateAccessBindingRequest accessBinding
                         */
    
                        /**
                         * Constructs a new UpdateAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateAccessBindingRequest.
                         * @implements IUpdateAccessBindingRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateAccessBindingRequest=} [properties] Properties to set
                         */
                        function UpdateAccessBindingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateAccessBindingRequest accessBinding.
                         * @member {google.analytics.admin.v1alpha.IAccessBinding|null|undefined} accessBinding
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @instance
                         */
                        UpdateAccessBindingRequest.prototype.accessBinding = null;
    
                        /**
                         * Creates a new UpdateAccessBindingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAccessBindingRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateAccessBindingRequest} UpdateAccessBindingRequest instance
                         */
                        UpdateAccessBindingRequest.create = function create(properties) {
                            return new UpdateAccessBindingRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateAccessBindingRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAccessBindingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAccessBindingRequest} message UpdateAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccessBindingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accessBinding != null && Object.hasOwnProperty.call(message, "accessBinding"))
                                $root.google.analytics.admin.v1alpha.AccessBinding.encode(message.accessBinding, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateAccessBindingRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateAccessBindingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateAccessBindingRequest} message UpdateAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccessBindingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateAccessBindingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateAccessBindingRequest} UpdateAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccessBindingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.accessBinding = $root.google.analytics.admin.v1alpha.AccessBinding.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateAccessBindingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateAccessBindingRequest} UpdateAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccessBindingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateAccessBindingRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateAccessBindingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accessBinding != null && message.hasOwnProperty("accessBinding")) {
                                var error = $root.google.analytics.admin.v1alpha.AccessBinding.verify(message.accessBinding);
                                if (error)
                                    return "accessBinding." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateAccessBindingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateAccessBindingRequest} UpdateAccessBindingRequest
                         */
                        UpdateAccessBindingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest();
                            if (object.accessBinding != null) {
                                if (typeof object.accessBinding !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateAccessBindingRequest.accessBinding: object expected");
                                message.accessBinding = $root.google.analytics.admin.v1alpha.AccessBinding.fromObject(object.accessBinding);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateAccessBindingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateAccessBindingRequest} message UpdateAccessBindingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateAccessBindingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.accessBinding = null;
                            if (message.accessBinding != null && message.hasOwnProperty("accessBinding"))
                                object.accessBinding = $root.google.analytics.admin.v1alpha.AccessBinding.toObject(message.accessBinding, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateAccessBindingRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateAccessBindingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateAccessBindingRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateAccessBindingRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateAccessBindingRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateAccessBindingRequest";
                        };
    
                        return UpdateAccessBindingRequest;
                    })();
    
                    v1alpha.BatchUpdateAccessBindingsRequest = (function() {
    
                        /**
                         * Properties of a BatchUpdateAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchUpdateAccessBindingsRequest
                         * @property {string|null} [parent] BatchUpdateAccessBindingsRequest parent
                         * @property {Array.<google.analytics.admin.v1alpha.IUpdateAccessBindingRequest>|null} [requests] BatchUpdateAccessBindingsRequest requests
                         */
    
                        /**
                         * Constructs a new BatchUpdateAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchUpdateAccessBindingsRequest.
                         * @implements IBatchUpdateAccessBindingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsRequest=} [properties] Properties to set
                         */
                        function BatchUpdateAccessBindingsRequest(properties) {
                            this.requests = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchUpdateAccessBindingsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @instance
                         */
                        BatchUpdateAccessBindingsRequest.prototype.parent = "";
    
                        /**
                         * BatchUpdateAccessBindingsRequest requests.
                         * @member {Array.<google.analytics.admin.v1alpha.IUpdateAccessBindingRequest>} requests
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @instance
                         */
                        BatchUpdateAccessBindingsRequest.prototype.requests = $util.emptyArray;
    
                        /**
                         * Creates a new BatchUpdateAccessBindingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest} BatchUpdateAccessBindingsRequest instance
                         */
                        BatchUpdateAccessBindingsRequest.create = function create(properties) {
                            return new BatchUpdateAccessBindingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchUpdateAccessBindingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsRequest} message BatchUpdateAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateAccessBindingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.requests != null && message.requests.length)
                                for (var i = 0; i < message.requests.length; ++i)
                                    $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest.encode(message.requests[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchUpdateAccessBindingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsRequest} message BatchUpdateAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateAccessBindingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchUpdateAccessBindingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest} BatchUpdateAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateAccessBindingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.requests && message.requests.length))
                                            message.requests = [];
                                        message.requests.push($root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchUpdateAccessBindingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest} BatchUpdateAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateAccessBindingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchUpdateAccessBindingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchUpdateAccessBindingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.requests != null && message.hasOwnProperty("requests")) {
                                if (!Array.isArray(message.requests))
                                    return "requests: array expected";
                                for (var i = 0; i < message.requests.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest.verify(message.requests[i]);
                                    if (error)
                                        return "requests." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchUpdateAccessBindingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest} BatchUpdateAccessBindingsRequest
                         */
                        BatchUpdateAccessBindingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.requests) {
                                if (!Array.isArray(object.requests))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest.requests: array expected");
                                message.requests = [];
                                for (var i = 0; i < object.requests.length; ++i) {
                                    if (typeof object.requests[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest.requests: object expected");
                                    message.requests[i] = $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest.fromObject(object.requests[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchUpdateAccessBindingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest} message BatchUpdateAccessBindingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchUpdateAccessBindingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.requests = [];
                            if (options.defaults)
                                object.parent = "";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.requests && message.requests.length) {
                                object.requests = [];
                                for (var j = 0; j < message.requests.length; ++j)
                                    object.requests[j] = $root.google.analytics.admin.v1alpha.UpdateAccessBindingRequest.toObject(message.requests[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchUpdateAccessBindingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchUpdateAccessBindingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchUpdateAccessBindingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchUpdateAccessBindingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchUpdateAccessBindingsRequest";
                        };
    
                        return BatchUpdateAccessBindingsRequest;
                    })();
    
                    v1alpha.BatchUpdateAccessBindingsResponse = (function() {
    
                        /**
                         * Properties of a BatchUpdateAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchUpdateAccessBindingsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAccessBinding>|null} [accessBindings] BatchUpdateAccessBindingsResponse accessBindings
                         */
    
                        /**
                         * Constructs a new BatchUpdateAccessBindingsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchUpdateAccessBindingsResponse.
                         * @implements IBatchUpdateAccessBindingsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsResponse=} [properties] Properties to set
                         */
                        function BatchUpdateAccessBindingsResponse(properties) {
                            this.accessBindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchUpdateAccessBindingsResponse accessBindings.
                         * @member {Array.<google.analytics.admin.v1alpha.IAccessBinding>} accessBindings
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @instance
                         */
                        BatchUpdateAccessBindingsResponse.prototype.accessBindings = $util.emptyArray;
    
                        /**
                         * Creates a new BatchUpdateAccessBindingsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse} BatchUpdateAccessBindingsResponse instance
                         */
                        BatchUpdateAccessBindingsResponse.create = function create(properties) {
                            return new BatchUpdateAccessBindingsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified BatchUpdateAccessBindingsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsResponse} message BatchUpdateAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateAccessBindingsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accessBindings != null && message.accessBindings.length)
                                for (var i = 0; i < message.accessBindings.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AccessBinding.encode(message.accessBindings[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchUpdateAccessBindingsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchUpdateAccessBindingsResponse} message BatchUpdateAccessBindingsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchUpdateAccessBindingsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchUpdateAccessBindingsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse} BatchUpdateAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateAccessBindingsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accessBindings && message.accessBindings.length))
                                            message.accessBindings = [];
                                        message.accessBindings.push($root.google.analytics.admin.v1alpha.AccessBinding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchUpdateAccessBindingsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse} BatchUpdateAccessBindingsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchUpdateAccessBindingsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchUpdateAccessBindingsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchUpdateAccessBindingsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accessBindings != null && message.hasOwnProperty("accessBindings")) {
                                if (!Array.isArray(message.accessBindings))
                                    return "accessBindings: array expected";
                                for (var i = 0; i < message.accessBindings.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AccessBinding.verify(message.accessBindings[i]);
                                    if (error)
                                        return "accessBindings." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchUpdateAccessBindingsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse} BatchUpdateAccessBindingsResponse
                         */
                        BatchUpdateAccessBindingsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse();
                            if (object.accessBindings) {
                                if (!Array.isArray(object.accessBindings))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse.accessBindings: array expected");
                                message.accessBindings = [];
                                for (var i = 0; i < object.accessBindings.length; ++i) {
                                    if (typeof object.accessBindings[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse.accessBindings: object expected");
                                    message.accessBindings[i] = $root.google.analytics.admin.v1alpha.AccessBinding.fromObject(object.accessBindings[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchUpdateAccessBindingsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse} message BatchUpdateAccessBindingsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchUpdateAccessBindingsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accessBindings = [];
                            if (message.accessBindings && message.accessBindings.length) {
                                object.accessBindings = [];
                                for (var j = 0; j < message.accessBindings.length; ++j)
                                    object.accessBindings[j] = $root.google.analytics.admin.v1alpha.AccessBinding.toObject(message.accessBindings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchUpdateAccessBindingsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchUpdateAccessBindingsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchUpdateAccessBindingsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchUpdateAccessBindingsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchUpdateAccessBindingsResponse";
                        };
    
                        return BatchUpdateAccessBindingsResponse;
                    })();
    
                    v1alpha.DeleteAccessBindingRequest = (function() {
    
                        /**
                         * Properties of a DeleteAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteAccessBindingRequest
                         * @property {string|null} [name] DeleteAccessBindingRequest name
                         */
    
                        /**
                         * Constructs a new DeleteAccessBindingRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteAccessBindingRequest.
                         * @implements IDeleteAccessBindingRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteAccessBindingRequest=} [properties] Properties to set
                         */
                        function DeleteAccessBindingRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAccessBindingRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @instance
                         */
                        DeleteAccessBindingRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteAccessBindingRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAccessBindingRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteAccessBindingRequest} DeleteAccessBindingRequest instance
                         */
                        DeleteAccessBindingRequest.create = function create(properties) {
                            return new DeleteAccessBindingRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAccessBindingRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteAccessBindingRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAccessBindingRequest} message DeleteAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccessBindingRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAccessBindingRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteAccessBindingRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAccessBindingRequest} message DeleteAccessBindingRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccessBindingRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAccessBindingRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteAccessBindingRequest} DeleteAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccessBindingRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAccessBindingRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteAccessBindingRequest} DeleteAccessBindingRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccessBindingRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAccessBindingRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAccessBindingRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAccessBindingRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteAccessBindingRequest} DeleteAccessBindingRequest
                         */
                        DeleteAccessBindingRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAccessBindingRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteAccessBindingRequest} message DeleteAccessBindingRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAccessBindingRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAccessBindingRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAccessBindingRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAccessBindingRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteAccessBindingRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAccessBindingRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteAccessBindingRequest";
                        };
    
                        return DeleteAccessBindingRequest;
                    })();
    
                    v1alpha.BatchDeleteAccessBindingsRequest = (function() {
    
                        /**
                         * Properties of a BatchDeleteAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBatchDeleteAccessBindingsRequest
                         * @property {string|null} [parent] BatchDeleteAccessBindingsRequest parent
                         * @property {Array.<google.analytics.admin.v1alpha.IDeleteAccessBindingRequest>|null} [requests] BatchDeleteAccessBindingsRequest requests
                         */
    
                        /**
                         * Constructs a new BatchDeleteAccessBindingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BatchDeleteAccessBindingsRequest.
                         * @implements IBatchDeleteAccessBindingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteAccessBindingsRequest=} [properties] Properties to set
                         */
                        function BatchDeleteAccessBindingsRequest(properties) {
                            this.requests = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BatchDeleteAccessBindingsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @instance
                         */
                        BatchDeleteAccessBindingsRequest.prototype.parent = "";
    
                        /**
                         * BatchDeleteAccessBindingsRequest requests.
                         * @member {Array.<google.analytics.admin.v1alpha.IDeleteAccessBindingRequest>} requests
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @instance
                         */
                        BatchDeleteAccessBindingsRequest.prototype.requests = $util.emptyArray;
    
                        /**
                         * Creates a new BatchDeleteAccessBindingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteAccessBindingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest} BatchDeleteAccessBindingsRequest instance
                         */
                        BatchDeleteAccessBindingsRequest.create = function create(properties) {
                            return new BatchDeleteAccessBindingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BatchDeleteAccessBindingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteAccessBindingsRequest} message BatchDeleteAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchDeleteAccessBindingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.requests != null && message.requests.length)
                                for (var i = 0; i < message.requests.length; ++i)
                                    $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest.encode(message.requests[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BatchDeleteAccessBindingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBatchDeleteAccessBindingsRequest} message BatchDeleteAccessBindingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BatchDeleteAccessBindingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BatchDeleteAccessBindingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest} BatchDeleteAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchDeleteAccessBindingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.requests && message.requests.length))
                                            message.requests = [];
                                        message.requests.push($root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BatchDeleteAccessBindingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest} BatchDeleteAccessBindingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BatchDeleteAccessBindingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BatchDeleteAccessBindingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BatchDeleteAccessBindingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.requests != null && message.hasOwnProperty("requests")) {
                                if (!Array.isArray(message.requests))
                                    return "requests: array expected";
                                for (var i = 0; i < message.requests.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest.verify(message.requests[i]);
                                    if (error)
                                        return "requests." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BatchDeleteAccessBindingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest} BatchDeleteAccessBindingsRequest
                         */
                        BatchDeleteAccessBindingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.requests) {
                                if (!Array.isArray(object.requests))
                                    throw TypeError(".google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest.requests: array expected");
                                message.requests = [];
                                for (var i = 0; i < object.requests.length; ++i) {
                                    if (typeof object.requests[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest.requests: object expected");
                                    message.requests[i] = $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest.fromObject(object.requests[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BatchDeleteAccessBindingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest} message BatchDeleteAccessBindingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BatchDeleteAccessBindingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.requests = [];
                            if (options.defaults)
                                object.parent = "";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.requests && message.requests.length) {
                                object.requests = [];
                                for (var j = 0; j < message.requests.length; ++j)
                                    object.requests[j] = $root.google.analytics.admin.v1alpha.DeleteAccessBindingRequest.toObject(message.requests[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BatchDeleteAccessBindingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BatchDeleteAccessBindingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BatchDeleteAccessBindingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BatchDeleteAccessBindingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BatchDeleteAccessBindingsRequest";
                        };
    
                        return BatchDeleteAccessBindingsRequest;
                    })();
    
                    v1alpha.CreateExpandedDataSetRequest = (function() {
    
                        /**
                         * Properties of a CreateExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateExpandedDataSetRequest
                         * @property {string|null} [parent] CreateExpandedDataSetRequest parent
                         * @property {google.analytics.admin.v1alpha.IExpandedDataSet|null} [expandedDataSet] CreateExpandedDataSetRequest expandedDataSet
                         */
    
                        /**
                         * Constructs a new CreateExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateExpandedDataSetRequest.
                         * @implements ICreateExpandedDataSetRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateExpandedDataSetRequest=} [properties] Properties to set
                         */
                        function CreateExpandedDataSetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateExpandedDataSetRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @instance
                         */
                        CreateExpandedDataSetRequest.prototype.parent = "";
    
                        /**
                         * CreateExpandedDataSetRequest expandedDataSet.
                         * @member {google.analytics.admin.v1alpha.IExpandedDataSet|null|undefined} expandedDataSet
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @instance
                         */
                        CreateExpandedDataSetRequest.prototype.expandedDataSet = null;
    
                        /**
                         * Creates a new CreateExpandedDataSetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateExpandedDataSetRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateExpandedDataSetRequest} CreateExpandedDataSetRequest instance
                         */
                        CreateExpandedDataSetRequest.create = function create(properties) {
                            return new CreateExpandedDataSetRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateExpandedDataSetRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateExpandedDataSetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateExpandedDataSetRequest} message CreateExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateExpandedDataSetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.expandedDataSet != null && Object.hasOwnProperty.call(message, "expandedDataSet"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSet.encode(message.expandedDataSet, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateExpandedDataSetRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateExpandedDataSetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateExpandedDataSetRequest} message CreateExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateExpandedDataSetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateExpandedDataSetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateExpandedDataSetRequest} CreateExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateExpandedDataSetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateExpandedDataSetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateExpandedDataSetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateExpandedDataSetRequest} CreateExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateExpandedDataSetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateExpandedDataSetRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateExpandedDataSetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.expandedDataSet != null && message.hasOwnProperty("expandedDataSet")) {
                                var error = $root.google.analytics.admin.v1alpha.ExpandedDataSet.verify(message.expandedDataSet);
                                if (error)
                                    return "expandedDataSet." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateExpandedDataSetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateExpandedDataSetRequest} CreateExpandedDataSetRequest
                         */
                        CreateExpandedDataSetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateExpandedDataSetRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateExpandedDataSetRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.expandedDataSet != null) {
                                if (typeof object.expandedDataSet !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateExpandedDataSetRequest.expandedDataSet: object expected");
                                message.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.fromObject(object.expandedDataSet);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateExpandedDataSetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateExpandedDataSetRequest} message CreateExpandedDataSetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateExpandedDataSetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.expandedDataSet = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.expandedDataSet != null && message.hasOwnProperty("expandedDataSet"))
                                object.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.toObject(message.expandedDataSet, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateExpandedDataSetRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateExpandedDataSetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateExpandedDataSetRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateExpandedDataSetRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateExpandedDataSetRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateExpandedDataSetRequest";
                        };
    
                        return CreateExpandedDataSetRequest;
                    })();
    
                    v1alpha.UpdateExpandedDataSetRequest = (function() {
    
                        /**
                         * Properties of an UpdateExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateExpandedDataSetRequest
                         * @property {google.analytics.admin.v1alpha.IExpandedDataSet|null} [expandedDataSet] UpdateExpandedDataSetRequest expandedDataSet
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateExpandedDataSetRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateExpandedDataSetRequest.
                         * @implements IUpdateExpandedDataSetRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateExpandedDataSetRequest=} [properties] Properties to set
                         */
                        function UpdateExpandedDataSetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateExpandedDataSetRequest expandedDataSet.
                         * @member {google.analytics.admin.v1alpha.IExpandedDataSet|null|undefined} expandedDataSet
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @instance
                         */
                        UpdateExpandedDataSetRequest.prototype.expandedDataSet = null;
    
                        /**
                         * UpdateExpandedDataSetRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @instance
                         */
                        UpdateExpandedDataSetRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateExpandedDataSetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateExpandedDataSetRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest} UpdateExpandedDataSetRequest instance
                         */
                        UpdateExpandedDataSetRequest.create = function create(properties) {
                            return new UpdateExpandedDataSetRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateExpandedDataSetRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateExpandedDataSetRequest} message UpdateExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateExpandedDataSetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.expandedDataSet != null && Object.hasOwnProperty.call(message, "expandedDataSet"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSet.encode(message.expandedDataSet, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateExpandedDataSetRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateExpandedDataSetRequest} message UpdateExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateExpandedDataSetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateExpandedDataSetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest} UpdateExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateExpandedDataSetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateExpandedDataSetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest} UpdateExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateExpandedDataSetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateExpandedDataSetRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateExpandedDataSetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.expandedDataSet != null && message.hasOwnProperty("expandedDataSet")) {
                                var error = $root.google.analytics.admin.v1alpha.ExpandedDataSet.verify(message.expandedDataSet);
                                if (error)
                                    return "expandedDataSet." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateExpandedDataSetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest} UpdateExpandedDataSetRequest
                         */
                        UpdateExpandedDataSetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest();
                            if (object.expandedDataSet != null) {
                                if (typeof object.expandedDataSet !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest.expandedDataSet: object expected");
                                message.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.fromObject(object.expandedDataSet);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateExpandedDataSetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest} message UpdateExpandedDataSetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateExpandedDataSetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.expandedDataSet = null;
                                object.updateMask = null;
                            }
                            if (message.expandedDataSet != null && message.hasOwnProperty("expandedDataSet"))
                                object.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.toObject(message.expandedDataSet, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateExpandedDataSetRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateExpandedDataSetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateExpandedDataSetRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateExpandedDataSetRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateExpandedDataSetRequest";
                        };
    
                        return UpdateExpandedDataSetRequest;
                    })();
    
                    v1alpha.DeleteExpandedDataSetRequest = (function() {
    
                        /**
                         * Properties of a DeleteExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteExpandedDataSetRequest
                         * @property {string|null} [name] DeleteExpandedDataSetRequest name
                         */
    
                        /**
                         * Constructs a new DeleteExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteExpandedDataSetRequest.
                         * @implements IDeleteExpandedDataSetRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteExpandedDataSetRequest=} [properties] Properties to set
                         */
                        function DeleteExpandedDataSetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteExpandedDataSetRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @instance
                         */
                        DeleteExpandedDataSetRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteExpandedDataSetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteExpandedDataSetRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest} DeleteExpandedDataSetRequest instance
                         */
                        DeleteExpandedDataSetRequest.create = function create(properties) {
                            return new DeleteExpandedDataSetRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteExpandedDataSetRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteExpandedDataSetRequest} message DeleteExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteExpandedDataSetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteExpandedDataSetRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteExpandedDataSetRequest} message DeleteExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteExpandedDataSetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteExpandedDataSetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest} DeleteExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteExpandedDataSetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteExpandedDataSetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest} DeleteExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteExpandedDataSetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteExpandedDataSetRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteExpandedDataSetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteExpandedDataSetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest} DeleteExpandedDataSetRequest
                         */
                        DeleteExpandedDataSetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteExpandedDataSetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest} message DeleteExpandedDataSetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteExpandedDataSetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteExpandedDataSetRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteExpandedDataSetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteExpandedDataSetRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteExpandedDataSetRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteExpandedDataSetRequest";
                        };
    
                        return DeleteExpandedDataSetRequest;
                    })();
    
                    v1alpha.GetExpandedDataSetRequest = (function() {
    
                        /**
                         * Properties of a GetExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetExpandedDataSetRequest
                         * @property {string|null} [name] GetExpandedDataSetRequest name
                         */
    
                        /**
                         * Constructs a new GetExpandedDataSetRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetExpandedDataSetRequest.
                         * @implements IGetExpandedDataSetRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetExpandedDataSetRequest=} [properties] Properties to set
                         */
                        function GetExpandedDataSetRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetExpandedDataSetRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @instance
                         */
                        GetExpandedDataSetRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetExpandedDataSetRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetExpandedDataSetRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetExpandedDataSetRequest} GetExpandedDataSetRequest instance
                         */
                        GetExpandedDataSetRequest.create = function create(properties) {
                            return new GetExpandedDataSetRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetExpandedDataSetRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetExpandedDataSetRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetExpandedDataSetRequest} message GetExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExpandedDataSetRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetExpandedDataSetRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetExpandedDataSetRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetExpandedDataSetRequest} message GetExpandedDataSetRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExpandedDataSetRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetExpandedDataSetRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetExpandedDataSetRequest} GetExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExpandedDataSetRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetExpandedDataSetRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetExpandedDataSetRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetExpandedDataSetRequest} GetExpandedDataSetRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExpandedDataSetRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetExpandedDataSetRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetExpandedDataSetRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetExpandedDataSetRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetExpandedDataSetRequest} GetExpandedDataSetRequest
                         */
                        GetExpandedDataSetRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetExpandedDataSetRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetExpandedDataSetRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetExpandedDataSetRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetExpandedDataSetRequest} message GetExpandedDataSetRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetExpandedDataSetRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetExpandedDataSetRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetExpandedDataSetRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetExpandedDataSetRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetExpandedDataSetRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetExpandedDataSetRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetExpandedDataSetRequest";
                        };
    
                        return GetExpandedDataSetRequest;
                    })();
    
                    v1alpha.ListExpandedDataSetsRequest = (function() {
    
                        /**
                         * Properties of a ListExpandedDataSetsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListExpandedDataSetsRequest
                         * @property {string|null} [parent] ListExpandedDataSetsRequest parent
                         * @property {number|null} [pageSize] ListExpandedDataSetsRequest pageSize
                         * @property {string|null} [pageToken] ListExpandedDataSetsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListExpandedDataSetsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListExpandedDataSetsRequest.
                         * @implements IListExpandedDataSetsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsRequest=} [properties] Properties to set
                         */
                        function ListExpandedDataSetsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListExpandedDataSetsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @instance
                         */
                        ListExpandedDataSetsRequest.prototype.parent = "";
    
                        /**
                         * ListExpandedDataSetsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @instance
                         */
                        ListExpandedDataSetsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListExpandedDataSetsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @instance
                         */
                        ListExpandedDataSetsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListExpandedDataSetsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsRequest} ListExpandedDataSetsRequest instance
                         */
                        ListExpandedDataSetsRequest.create = function create(properties) {
                            return new ListExpandedDataSetsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListExpandedDataSetsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListExpandedDataSetsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsRequest} message ListExpandedDataSetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListExpandedDataSetsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListExpandedDataSetsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListExpandedDataSetsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsRequest} message ListExpandedDataSetsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListExpandedDataSetsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListExpandedDataSetsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsRequest} ListExpandedDataSetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListExpandedDataSetsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListExpandedDataSetsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListExpandedDataSetsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsRequest} ListExpandedDataSetsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListExpandedDataSetsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListExpandedDataSetsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListExpandedDataSetsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListExpandedDataSetsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsRequest} ListExpandedDataSetsRequest
                         */
                        ListExpandedDataSetsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListExpandedDataSetsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListExpandedDataSetsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListExpandedDataSetsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListExpandedDataSetsRequest} message ListExpandedDataSetsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListExpandedDataSetsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListExpandedDataSetsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListExpandedDataSetsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListExpandedDataSetsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListExpandedDataSetsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListExpandedDataSetsRequest";
                        };
    
                        return ListExpandedDataSetsRequest;
                    })();
    
                    v1alpha.ListExpandedDataSetsResponse = (function() {
    
                        /**
                         * Properties of a ListExpandedDataSetsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListExpandedDataSetsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IExpandedDataSet>|null} [expandedDataSets] ListExpandedDataSetsResponse expandedDataSets
                         * @property {string|null} [nextPageToken] ListExpandedDataSetsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListExpandedDataSetsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListExpandedDataSetsResponse.
                         * @implements IListExpandedDataSetsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsResponse=} [properties] Properties to set
                         */
                        function ListExpandedDataSetsResponse(properties) {
                            this.expandedDataSets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListExpandedDataSetsResponse expandedDataSets.
                         * @member {Array.<google.analytics.admin.v1alpha.IExpandedDataSet>} expandedDataSets
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @instance
                         */
                        ListExpandedDataSetsResponse.prototype.expandedDataSets = $util.emptyArray;
    
                        /**
                         * ListExpandedDataSetsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @instance
                         */
                        ListExpandedDataSetsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListExpandedDataSetsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsResponse} ListExpandedDataSetsResponse instance
                         */
                        ListExpandedDataSetsResponse.create = function create(properties) {
                            return new ListExpandedDataSetsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListExpandedDataSetsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListExpandedDataSetsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsResponse} message ListExpandedDataSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListExpandedDataSetsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.expandedDataSets != null && message.expandedDataSets.length)
                                for (var i = 0; i < message.expandedDataSets.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ExpandedDataSet.encode(message.expandedDataSets[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListExpandedDataSetsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListExpandedDataSetsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListExpandedDataSetsResponse} message ListExpandedDataSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListExpandedDataSetsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListExpandedDataSetsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsResponse} ListExpandedDataSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListExpandedDataSetsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListExpandedDataSetsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.expandedDataSets && message.expandedDataSets.length))
                                            message.expandedDataSets = [];
                                        message.expandedDataSets.push($root.google.analytics.admin.v1alpha.ExpandedDataSet.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListExpandedDataSetsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsResponse} ListExpandedDataSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListExpandedDataSetsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListExpandedDataSetsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListExpandedDataSetsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.expandedDataSets != null && message.hasOwnProperty("expandedDataSets")) {
                                if (!Array.isArray(message.expandedDataSets))
                                    return "expandedDataSets: array expected";
                                for (var i = 0; i < message.expandedDataSets.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ExpandedDataSet.verify(message.expandedDataSets[i]);
                                    if (error)
                                        return "expandedDataSets." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListExpandedDataSetsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListExpandedDataSetsResponse} ListExpandedDataSetsResponse
                         */
                        ListExpandedDataSetsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListExpandedDataSetsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListExpandedDataSetsResponse();
                            if (object.expandedDataSets) {
                                if (!Array.isArray(object.expandedDataSets))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListExpandedDataSetsResponse.expandedDataSets: array expected");
                                message.expandedDataSets = [];
                                for (var i = 0; i < object.expandedDataSets.length; ++i) {
                                    if (typeof object.expandedDataSets[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListExpandedDataSetsResponse.expandedDataSets: object expected");
                                    message.expandedDataSets[i] = $root.google.analytics.admin.v1alpha.ExpandedDataSet.fromObject(object.expandedDataSets[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListExpandedDataSetsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListExpandedDataSetsResponse} message ListExpandedDataSetsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListExpandedDataSetsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.expandedDataSets = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.expandedDataSets && message.expandedDataSets.length) {
                                object.expandedDataSets = [];
                                for (var j = 0; j < message.expandedDataSets.length; ++j)
                                    object.expandedDataSets[j] = $root.google.analytics.admin.v1alpha.ExpandedDataSet.toObject(message.expandedDataSets[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListExpandedDataSetsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListExpandedDataSetsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListExpandedDataSetsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListExpandedDataSetsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListExpandedDataSetsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListExpandedDataSetsResponse";
                        };
    
                        return ListExpandedDataSetsResponse;
                    })();
    
                    v1alpha.CreateChannelGroupRequest = (function() {
    
                        /**
                         * Properties of a CreateChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateChannelGroupRequest
                         * @property {string|null} [parent] CreateChannelGroupRequest parent
                         * @property {google.analytics.admin.v1alpha.IChannelGroup|null} [channelGroup] CreateChannelGroupRequest channelGroup
                         */
    
                        /**
                         * Constructs a new CreateChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateChannelGroupRequest.
                         * @implements ICreateChannelGroupRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateChannelGroupRequest=} [properties] Properties to set
                         */
                        function CreateChannelGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateChannelGroupRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @instance
                         */
                        CreateChannelGroupRequest.prototype.parent = "";
    
                        /**
                         * CreateChannelGroupRequest channelGroup.
                         * @member {google.analytics.admin.v1alpha.IChannelGroup|null|undefined} channelGroup
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @instance
                         */
                        CreateChannelGroupRequest.prototype.channelGroup = null;
    
                        /**
                         * Creates a new CreateChannelGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateChannelGroupRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateChannelGroupRequest} CreateChannelGroupRequest instance
                         */
                        CreateChannelGroupRequest.create = function create(properties) {
                            return new CreateChannelGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateChannelGroupRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateChannelGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateChannelGroupRequest} message CreateChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateChannelGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.channelGroup != null && Object.hasOwnProperty.call(message, "channelGroup"))
                                $root.google.analytics.admin.v1alpha.ChannelGroup.encode(message.channelGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateChannelGroupRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateChannelGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateChannelGroupRequest} message CreateChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateChannelGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateChannelGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateChannelGroupRequest} CreateChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateChannelGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateChannelGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateChannelGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateChannelGroupRequest} CreateChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateChannelGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateChannelGroupRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateChannelGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.channelGroup != null && message.hasOwnProperty("channelGroup")) {
                                var error = $root.google.analytics.admin.v1alpha.ChannelGroup.verify(message.channelGroup);
                                if (error)
                                    return "channelGroup." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateChannelGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateChannelGroupRequest} CreateChannelGroupRequest
                         */
                        CreateChannelGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateChannelGroupRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateChannelGroupRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.channelGroup != null) {
                                if (typeof object.channelGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateChannelGroupRequest.channelGroup: object expected");
                                message.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.fromObject(object.channelGroup);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateChannelGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateChannelGroupRequest} message CreateChannelGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateChannelGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.channelGroup = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.channelGroup != null && message.hasOwnProperty("channelGroup"))
                                object.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.toObject(message.channelGroup, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateChannelGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateChannelGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateChannelGroupRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateChannelGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateChannelGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateChannelGroupRequest";
                        };
    
                        return CreateChannelGroupRequest;
                    })();
    
                    v1alpha.UpdateChannelGroupRequest = (function() {
    
                        /**
                         * Properties of an UpdateChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateChannelGroupRequest
                         * @property {google.analytics.admin.v1alpha.IChannelGroup|null} [channelGroup] UpdateChannelGroupRequest channelGroup
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateChannelGroupRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateChannelGroupRequest.
                         * @implements IUpdateChannelGroupRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateChannelGroupRequest=} [properties] Properties to set
                         */
                        function UpdateChannelGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateChannelGroupRequest channelGroup.
                         * @member {google.analytics.admin.v1alpha.IChannelGroup|null|undefined} channelGroup
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @instance
                         */
                        UpdateChannelGroupRequest.prototype.channelGroup = null;
    
                        /**
                         * UpdateChannelGroupRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @instance
                         */
                        UpdateChannelGroupRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateChannelGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateChannelGroupRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateChannelGroupRequest} UpdateChannelGroupRequest instance
                         */
                        UpdateChannelGroupRequest.create = function create(properties) {
                            return new UpdateChannelGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateChannelGroupRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateChannelGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateChannelGroupRequest} message UpdateChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateChannelGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.channelGroup != null && Object.hasOwnProperty.call(message, "channelGroup"))
                                $root.google.analytics.admin.v1alpha.ChannelGroup.encode(message.channelGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateChannelGroupRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateChannelGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateChannelGroupRequest} message UpdateChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateChannelGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateChannelGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateChannelGroupRequest} UpdateChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateChannelGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateChannelGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateChannelGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateChannelGroupRequest} UpdateChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateChannelGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateChannelGroupRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateChannelGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.channelGroup != null && message.hasOwnProperty("channelGroup")) {
                                var error = $root.google.analytics.admin.v1alpha.ChannelGroup.verify(message.channelGroup);
                                if (error)
                                    return "channelGroup." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateChannelGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateChannelGroupRequest} UpdateChannelGroupRequest
                         */
                        UpdateChannelGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateChannelGroupRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateChannelGroupRequest();
                            if (object.channelGroup != null) {
                                if (typeof object.channelGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateChannelGroupRequest.channelGroup: object expected");
                                message.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.fromObject(object.channelGroup);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateChannelGroupRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateChannelGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateChannelGroupRequest} message UpdateChannelGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateChannelGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.channelGroup = null;
                                object.updateMask = null;
                            }
                            if (message.channelGroup != null && message.hasOwnProperty("channelGroup"))
                                object.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.toObject(message.channelGroup, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateChannelGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateChannelGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateChannelGroupRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateChannelGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateChannelGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateChannelGroupRequest";
                        };
    
                        return UpdateChannelGroupRequest;
                    })();
    
                    v1alpha.DeleteChannelGroupRequest = (function() {
    
                        /**
                         * Properties of a DeleteChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteChannelGroupRequest
                         * @property {string|null} [name] DeleteChannelGroupRequest name
                         */
    
                        /**
                         * Constructs a new DeleteChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteChannelGroupRequest.
                         * @implements IDeleteChannelGroupRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteChannelGroupRequest=} [properties] Properties to set
                         */
                        function DeleteChannelGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteChannelGroupRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @instance
                         */
                        DeleteChannelGroupRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteChannelGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteChannelGroupRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteChannelGroupRequest} DeleteChannelGroupRequest instance
                         */
                        DeleteChannelGroupRequest.create = function create(properties) {
                            return new DeleteChannelGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteChannelGroupRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteChannelGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteChannelGroupRequest} message DeleteChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteChannelGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteChannelGroupRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteChannelGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteChannelGroupRequest} message DeleteChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteChannelGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteChannelGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteChannelGroupRequest} DeleteChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteChannelGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteChannelGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteChannelGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteChannelGroupRequest} DeleteChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteChannelGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteChannelGroupRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteChannelGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteChannelGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteChannelGroupRequest} DeleteChannelGroupRequest
                         */
                        DeleteChannelGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteChannelGroupRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteChannelGroupRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteChannelGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteChannelGroupRequest} message DeleteChannelGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteChannelGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteChannelGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteChannelGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteChannelGroupRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteChannelGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteChannelGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteChannelGroupRequest";
                        };
    
                        return DeleteChannelGroupRequest;
                    })();
    
                    v1alpha.GetChannelGroupRequest = (function() {
    
                        /**
                         * Properties of a GetChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetChannelGroupRequest
                         * @property {string|null} [name] GetChannelGroupRequest name
                         */
    
                        /**
                         * Constructs a new GetChannelGroupRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetChannelGroupRequest.
                         * @implements IGetChannelGroupRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetChannelGroupRequest=} [properties] Properties to set
                         */
                        function GetChannelGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetChannelGroupRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @instance
                         */
                        GetChannelGroupRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetChannelGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetChannelGroupRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetChannelGroupRequest} GetChannelGroupRequest instance
                         */
                        GetChannelGroupRequest.create = function create(properties) {
                            return new GetChannelGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetChannelGroupRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetChannelGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetChannelGroupRequest} message GetChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetChannelGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetChannelGroupRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetChannelGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetChannelGroupRequest} message GetChannelGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetChannelGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetChannelGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetChannelGroupRequest} GetChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetChannelGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetChannelGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetChannelGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetChannelGroupRequest} GetChannelGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetChannelGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetChannelGroupRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetChannelGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetChannelGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetChannelGroupRequest} GetChannelGroupRequest
                         */
                        GetChannelGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetChannelGroupRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetChannelGroupRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetChannelGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetChannelGroupRequest} message GetChannelGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetChannelGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetChannelGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetChannelGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetChannelGroupRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetChannelGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetChannelGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetChannelGroupRequest";
                        };
    
                        return GetChannelGroupRequest;
                    })();
    
                    v1alpha.ListChannelGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListChannelGroupsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListChannelGroupsRequest
                         * @property {string|null} [parent] ListChannelGroupsRequest parent
                         * @property {number|null} [pageSize] ListChannelGroupsRequest pageSize
                         * @property {string|null} [pageToken] ListChannelGroupsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListChannelGroupsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListChannelGroupsRequest.
                         * @implements IListChannelGroupsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsRequest=} [properties] Properties to set
                         */
                        function ListChannelGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListChannelGroupsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @instance
                         */
                        ListChannelGroupsRequest.prototype.parent = "";
    
                        /**
                         * ListChannelGroupsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @instance
                         */
                        ListChannelGroupsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListChannelGroupsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @instance
                         */
                        ListChannelGroupsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListChannelGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsRequest} ListChannelGroupsRequest instance
                         */
                        ListChannelGroupsRequest.create = function create(properties) {
                            return new ListChannelGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListChannelGroupsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListChannelGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsRequest} message ListChannelGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListChannelGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListChannelGroupsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListChannelGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsRequest} message ListChannelGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListChannelGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListChannelGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsRequest} ListChannelGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListChannelGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListChannelGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListChannelGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsRequest} ListChannelGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListChannelGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListChannelGroupsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListChannelGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListChannelGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsRequest} ListChannelGroupsRequest
                         */
                        ListChannelGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListChannelGroupsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListChannelGroupsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListChannelGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListChannelGroupsRequest} message ListChannelGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListChannelGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListChannelGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListChannelGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListChannelGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListChannelGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListChannelGroupsRequest";
                        };
    
                        return ListChannelGroupsRequest;
                    })();
    
                    v1alpha.ListChannelGroupsResponse = (function() {
    
                        /**
                         * Properties of a ListChannelGroupsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListChannelGroupsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IChannelGroup>|null} [channelGroups] ListChannelGroupsResponse channelGroups
                         * @property {string|null} [nextPageToken] ListChannelGroupsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListChannelGroupsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListChannelGroupsResponse.
                         * @implements IListChannelGroupsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsResponse=} [properties] Properties to set
                         */
                        function ListChannelGroupsResponse(properties) {
                            this.channelGroups = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListChannelGroupsResponse channelGroups.
                         * @member {Array.<google.analytics.admin.v1alpha.IChannelGroup>} channelGroups
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @instance
                         */
                        ListChannelGroupsResponse.prototype.channelGroups = $util.emptyArray;
    
                        /**
                         * ListChannelGroupsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @instance
                         */
                        ListChannelGroupsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListChannelGroupsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsResponse} ListChannelGroupsResponse instance
                         */
                        ListChannelGroupsResponse.create = function create(properties) {
                            return new ListChannelGroupsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListChannelGroupsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListChannelGroupsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsResponse} message ListChannelGroupsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListChannelGroupsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.channelGroups != null && message.channelGroups.length)
                                for (var i = 0; i < message.channelGroups.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ChannelGroup.encode(message.channelGroups[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListChannelGroupsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListChannelGroupsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListChannelGroupsResponse} message ListChannelGroupsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListChannelGroupsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListChannelGroupsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsResponse} ListChannelGroupsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListChannelGroupsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListChannelGroupsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.channelGroups && message.channelGroups.length))
                                            message.channelGroups = [];
                                        message.channelGroups.push($root.google.analytics.admin.v1alpha.ChannelGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListChannelGroupsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsResponse} ListChannelGroupsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListChannelGroupsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListChannelGroupsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListChannelGroupsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.channelGroups != null && message.hasOwnProperty("channelGroups")) {
                                if (!Array.isArray(message.channelGroups))
                                    return "channelGroups: array expected";
                                for (var i = 0; i < message.channelGroups.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroup.verify(message.channelGroups[i]);
                                    if (error)
                                        return "channelGroups." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListChannelGroupsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListChannelGroupsResponse} ListChannelGroupsResponse
                         */
                        ListChannelGroupsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListChannelGroupsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListChannelGroupsResponse();
                            if (object.channelGroups) {
                                if (!Array.isArray(object.channelGroups))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListChannelGroupsResponse.channelGroups: array expected");
                                message.channelGroups = [];
                                for (var i = 0; i < object.channelGroups.length; ++i) {
                                    if (typeof object.channelGroups[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListChannelGroupsResponse.channelGroups: object expected");
                                    message.channelGroups[i] = $root.google.analytics.admin.v1alpha.ChannelGroup.fromObject(object.channelGroups[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListChannelGroupsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListChannelGroupsResponse} message ListChannelGroupsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListChannelGroupsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.channelGroups = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.channelGroups && message.channelGroups.length) {
                                object.channelGroups = [];
                                for (var j = 0; j < message.channelGroups.length; ++j)
                                    object.channelGroups[j] = $root.google.analytics.admin.v1alpha.ChannelGroup.toObject(message.channelGroups[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListChannelGroupsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListChannelGroupsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListChannelGroupsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListChannelGroupsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListChannelGroupsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListChannelGroupsResponse";
                        };
    
                        return ListChannelGroupsResponse;
                    })();
    
                    v1alpha.SetAutomatedGa4ConfigurationOptOutRequest = (function() {
    
                        /**
                         * Properties of a SetAutomatedGa4ConfigurationOptOutRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ISetAutomatedGa4ConfigurationOptOutRequest
                         * @property {string|null} [property] SetAutomatedGa4ConfigurationOptOutRequest property
                         * @property {boolean|null} [optOut] SetAutomatedGa4ConfigurationOptOutRequest optOut
                         */
    
                        /**
                         * Constructs a new SetAutomatedGa4ConfigurationOptOutRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a SetAutomatedGa4ConfigurationOptOutRequest.
                         * @implements ISetAutomatedGa4ConfigurationOptOutRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutRequest=} [properties] Properties to set
                         */
                        function SetAutomatedGa4ConfigurationOptOutRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetAutomatedGa4ConfigurationOptOutRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @instance
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.prototype.property = "";
    
                        /**
                         * SetAutomatedGa4ConfigurationOptOutRequest optOut.
                         * @member {boolean} optOut
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @instance
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.prototype.optOut = false;
    
                        /**
                         * Creates a new SetAutomatedGa4ConfigurationOptOutRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest} SetAutomatedGa4ConfigurationOptOutRequest instance
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.create = function create(properties) {
                            return new SetAutomatedGa4ConfigurationOptOutRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetAutomatedGa4ConfigurationOptOutRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutRequest} message SetAutomatedGa4ConfigurationOptOutRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            if (message.optOut != null && Object.hasOwnProperty.call(message, "optOut"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.optOut);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetAutomatedGa4ConfigurationOptOutRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutRequest} message SetAutomatedGa4ConfigurationOptOutRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetAutomatedGa4ConfigurationOptOutRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest} SetAutomatedGa4ConfigurationOptOutRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.optOut = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetAutomatedGa4ConfigurationOptOutRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest} SetAutomatedGa4ConfigurationOptOutRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetAutomatedGa4ConfigurationOptOutRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.optOut != null && message.hasOwnProperty("optOut"))
                                if (typeof message.optOut !== "boolean")
                                    return "optOut: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetAutomatedGa4ConfigurationOptOutRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest} SetAutomatedGa4ConfigurationOptOutRequest
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.optOut != null)
                                message.optOut = Boolean(object.optOut);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetAutomatedGa4ConfigurationOptOutRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest} message SetAutomatedGa4ConfigurationOptOutRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = "";
                                object.optOut = false;
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.optOut != null && message.hasOwnProperty("optOut"))
                                object.optOut = message.optOut;
                            return object;
                        };
    
                        /**
                         * Converts this SetAutomatedGa4ConfigurationOptOutRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetAutomatedGa4ConfigurationOptOutRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetAutomatedGa4ConfigurationOptOutRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutRequest";
                        };
    
                        return SetAutomatedGa4ConfigurationOptOutRequest;
                    })();
    
                    v1alpha.SetAutomatedGa4ConfigurationOptOutResponse = (function() {
    
                        /**
                         * Properties of a SetAutomatedGa4ConfigurationOptOutResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ISetAutomatedGa4ConfigurationOptOutResponse
                         */
    
                        /**
                         * Constructs a new SetAutomatedGa4ConfigurationOptOutResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a SetAutomatedGa4ConfigurationOptOutResponse.
                         * @implements ISetAutomatedGa4ConfigurationOptOutResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutResponse=} [properties] Properties to set
                         */
                        function SetAutomatedGa4ConfigurationOptOutResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new SetAutomatedGa4ConfigurationOptOutResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse} SetAutomatedGa4ConfigurationOptOutResponse instance
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.create = function create(properties) {
                            return new SetAutomatedGa4ConfigurationOptOutResponse(properties);
                        };
    
                        /**
                         * Encodes the specified SetAutomatedGa4ConfigurationOptOutResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutResponse} message SetAutomatedGa4ConfigurationOptOutResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetAutomatedGa4ConfigurationOptOutResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISetAutomatedGa4ConfigurationOptOutResponse} message SetAutomatedGa4ConfigurationOptOutResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetAutomatedGa4ConfigurationOptOutResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse} SetAutomatedGa4ConfigurationOptOutResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetAutomatedGa4ConfigurationOptOutResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse} SetAutomatedGa4ConfigurationOptOutResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetAutomatedGa4ConfigurationOptOutResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetAutomatedGa4ConfigurationOptOutResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse} SetAutomatedGa4ConfigurationOptOutResponse
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse)
                                return object;
                            return new $root.google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse();
                        };
    
                        /**
                         * Creates a plain object from a SetAutomatedGa4ConfigurationOptOutResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse} message SetAutomatedGa4ConfigurationOptOutResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this SetAutomatedGa4ConfigurationOptOutResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetAutomatedGa4ConfigurationOptOutResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetAutomatedGa4ConfigurationOptOutResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.SetAutomatedGa4ConfigurationOptOutResponse";
                        };
    
                        return SetAutomatedGa4ConfigurationOptOutResponse;
                    })();
    
                    v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest = (function() {
    
                        /**
                         * Properties of a FetchAutomatedGa4ConfigurationOptOutRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IFetchAutomatedGa4ConfigurationOptOutRequest
                         * @property {string|null} [property] FetchAutomatedGa4ConfigurationOptOutRequest property
                         */
    
                        /**
                         * Constructs a new FetchAutomatedGa4ConfigurationOptOutRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a FetchAutomatedGa4ConfigurationOptOutRequest.
                         * @implements IFetchAutomatedGa4ConfigurationOptOutRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutRequest=} [properties] Properties to set
                         */
                        function FetchAutomatedGa4ConfigurationOptOutRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FetchAutomatedGa4ConfigurationOptOutRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @instance
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.prototype.property = "";
    
                        /**
                         * Creates a new FetchAutomatedGa4ConfigurationOptOutRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest} FetchAutomatedGa4ConfigurationOptOutRequest instance
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.create = function create(properties) {
                            return new FetchAutomatedGa4ConfigurationOptOutRequest(properties);
                        };
    
                        /**
                         * Encodes the specified FetchAutomatedGa4ConfigurationOptOutRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutRequest} message FetchAutomatedGa4ConfigurationOptOutRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FetchAutomatedGa4ConfigurationOptOutRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutRequest} message FetchAutomatedGa4ConfigurationOptOutRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FetchAutomatedGa4ConfigurationOptOutRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest} FetchAutomatedGa4ConfigurationOptOutRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FetchAutomatedGa4ConfigurationOptOutRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest} FetchAutomatedGa4ConfigurationOptOutRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FetchAutomatedGa4ConfigurationOptOutRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a FetchAutomatedGa4ConfigurationOptOutRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest} FetchAutomatedGa4ConfigurationOptOutRequest
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FetchAutomatedGa4ConfigurationOptOutRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest} message FetchAutomatedGa4ConfigurationOptOutRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.property = "";
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            return object;
                        };
    
                        /**
                         * Converts this FetchAutomatedGa4ConfigurationOptOutRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FetchAutomatedGa4ConfigurationOptOutRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FetchAutomatedGa4ConfigurationOptOutRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutRequest";
                        };
    
                        return FetchAutomatedGa4ConfigurationOptOutRequest;
                    })();
    
                    v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse = (function() {
    
                        /**
                         * Properties of a FetchAutomatedGa4ConfigurationOptOutResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IFetchAutomatedGa4ConfigurationOptOutResponse
                         * @property {boolean|null} [optOut] FetchAutomatedGa4ConfigurationOptOutResponse optOut
                         */
    
                        /**
                         * Constructs a new FetchAutomatedGa4ConfigurationOptOutResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a FetchAutomatedGa4ConfigurationOptOutResponse.
                         * @implements IFetchAutomatedGa4ConfigurationOptOutResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutResponse=} [properties] Properties to set
                         */
                        function FetchAutomatedGa4ConfigurationOptOutResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FetchAutomatedGa4ConfigurationOptOutResponse optOut.
                         * @member {boolean} optOut
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @instance
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.prototype.optOut = false;
    
                        /**
                         * Creates a new FetchAutomatedGa4ConfigurationOptOutResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse} FetchAutomatedGa4ConfigurationOptOutResponse instance
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.create = function create(properties) {
                            return new FetchAutomatedGa4ConfigurationOptOutResponse(properties);
                        };
    
                        /**
                         * Encodes the specified FetchAutomatedGa4ConfigurationOptOutResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutResponse} message FetchAutomatedGa4ConfigurationOptOutResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.optOut != null && Object.hasOwnProperty.call(message, "optOut"))
                                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.optOut);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FetchAutomatedGa4ConfigurationOptOutResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchAutomatedGa4ConfigurationOptOutResponse} message FetchAutomatedGa4ConfigurationOptOutResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FetchAutomatedGa4ConfigurationOptOutResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse} FetchAutomatedGa4ConfigurationOptOutResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.optOut = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FetchAutomatedGa4ConfigurationOptOutResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse} FetchAutomatedGa4ConfigurationOptOutResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FetchAutomatedGa4ConfigurationOptOutResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.optOut != null && message.hasOwnProperty("optOut"))
                                if (typeof message.optOut !== "boolean")
                                    return "optOut: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a FetchAutomatedGa4ConfigurationOptOutResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse} FetchAutomatedGa4ConfigurationOptOutResponse
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse();
                            if (object.optOut != null)
                                message.optOut = Boolean(object.optOut);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FetchAutomatedGa4ConfigurationOptOutResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse} message FetchAutomatedGa4ConfigurationOptOutResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.optOut = false;
                            if (message.optOut != null && message.hasOwnProperty("optOut"))
                                object.optOut = message.optOut;
                            return object;
                        };
    
                        /**
                         * Converts this FetchAutomatedGa4ConfigurationOptOutResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FetchAutomatedGa4ConfigurationOptOutResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FetchAutomatedGa4ConfigurationOptOutResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.FetchAutomatedGa4ConfigurationOptOutResponse";
                        };
    
                        return FetchAutomatedGa4ConfigurationOptOutResponse;
                    })();
    
                    v1alpha.GetBigQueryLinkRequest = (function() {
    
                        /**
                         * Properties of a GetBigQueryLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetBigQueryLinkRequest
                         * @property {string|null} [name] GetBigQueryLinkRequest name
                         */
    
                        /**
                         * Constructs a new GetBigQueryLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetBigQueryLinkRequest.
                         * @implements IGetBigQueryLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetBigQueryLinkRequest=} [properties] Properties to set
                         */
                        function GetBigQueryLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetBigQueryLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @instance
                         */
                        GetBigQueryLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetBigQueryLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetBigQueryLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetBigQueryLinkRequest} GetBigQueryLinkRequest instance
                         */
                        GetBigQueryLinkRequest.create = function create(properties) {
                            return new GetBigQueryLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetBigQueryLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetBigQueryLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetBigQueryLinkRequest} message GetBigQueryLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBigQueryLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetBigQueryLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetBigQueryLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetBigQueryLinkRequest} message GetBigQueryLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBigQueryLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetBigQueryLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetBigQueryLinkRequest} GetBigQueryLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBigQueryLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetBigQueryLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetBigQueryLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetBigQueryLinkRequest} GetBigQueryLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBigQueryLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetBigQueryLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetBigQueryLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetBigQueryLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetBigQueryLinkRequest} GetBigQueryLinkRequest
                         */
                        GetBigQueryLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetBigQueryLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetBigQueryLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetBigQueryLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetBigQueryLinkRequest} message GetBigQueryLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetBigQueryLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetBigQueryLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetBigQueryLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetBigQueryLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetBigQueryLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetBigQueryLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetBigQueryLinkRequest";
                        };
    
                        return GetBigQueryLinkRequest;
                    })();
    
                    v1alpha.ListBigQueryLinksRequest = (function() {
    
                        /**
                         * Properties of a ListBigQueryLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListBigQueryLinksRequest
                         * @property {string|null} [parent] ListBigQueryLinksRequest parent
                         * @property {number|null} [pageSize] ListBigQueryLinksRequest pageSize
                         * @property {string|null} [pageToken] ListBigQueryLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListBigQueryLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListBigQueryLinksRequest.
                         * @implements IListBigQueryLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksRequest=} [properties] Properties to set
                         */
                        function ListBigQueryLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListBigQueryLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @instance
                         */
                        ListBigQueryLinksRequest.prototype.parent = "";
    
                        /**
                         * ListBigQueryLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @instance
                         */
                        ListBigQueryLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListBigQueryLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @instance
                         */
                        ListBigQueryLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListBigQueryLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksRequest} ListBigQueryLinksRequest instance
                         */
                        ListBigQueryLinksRequest.create = function create(properties) {
                            return new ListBigQueryLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListBigQueryLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListBigQueryLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksRequest} message ListBigQueryLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBigQueryLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListBigQueryLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListBigQueryLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksRequest} message ListBigQueryLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBigQueryLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListBigQueryLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksRequest} ListBigQueryLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBigQueryLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListBigQueryLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListBigQueryLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksRequest} ListBigQueryLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBigQueryLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListBigQueryLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListBigQueryLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListBigQueryLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksRequest} ListBigQueryLinksRequest
                         */
                        ListBigQueryLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListBigQueryLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListBigQueryLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListBigQueryLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListBigQueryLinksRequest} message ListBigQueryLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListBigQueryLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListBigQueryLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListBigQueryLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListBigQueryLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListBigQueryLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListBigQueryLinksRequest";
                        };
    
                        return ListBigQueryLinksRequest;
                    })();
    
                    v1alpha.ListBigQueryLinksResponse = (function() {
    
                        /**
                         * Properties of a ListBigQueryLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListBigQueryLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IBigQueryLink>|null} [bigqueryLinks] ListBigQueryLinksResponse bigqueryLinks
                         * @property {string|null} [nextPageToken] ListBigQueryLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListBigQueryLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListBigQueryLinksResponse.
                         * @implements IListBigQueryLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksResponse=} [properties] Properties to set
                         */
                        function ListBigQueryLinksResponse(properties) {
                            this.bigqueryLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListBigQueryLinksResponse bigqueryLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IBigQueryLink>} bigqueryLinks
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @instance
                         */
                        ListBigQueryLinksResponse.prototype.bigqueryLinks = $util.emptyArray;
    
                        /**
                         * ListBigQueryLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @instance
                         */
                        ListBigQueryLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListBigQueryLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksResponse} ListBigQueryLinksResponse instance
                         */
                        ListBigQueryLinksResponse.create = function create(properties) {
                            return new ListBigQueryLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListBigQueryLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListBigQueryLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksResponse} message ListBigQueryLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBigQueryLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.bigqueryLinks != null && message.bigqueryLinks.length)
                                for (var i = 0; i < message.bigqueryLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.BigQueryLink.encode(message.bigqueryLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListBigQueryLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListBigQueryLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListBigQueryLinksResponse} message ListBigQueryLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBigQueryLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListBigQueryLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksResponse} ListBigQueryLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBigQueryLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListBigQueryLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.bigqueryLinks && message.bigqueryLinks.length))
                                            message.bigqueryLinks = [];
                                        message.bigqueryLinks.push($root.google.analytics.admin.v1alpha.BigQueryLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListBigQueryLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksResponse} ListBigQueryLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBigQueryLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListBigQueryLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListBigQueryLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.bigqueryLinks != null && message.hasOwnProperty("bigqueryLinks")) {
                                if (!Array.isArray(message.bigqueryLinks))
                                    return "bigqueryLinks: array expected";
                                for (var i = 0; i < message.bigqueryLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.BigQueryLink.verify(message.bigqueryLinks[i]);
                                    if (error)
                                        return "bigqueryLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListBigQueryLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListBigQueryLinksResponse} ListBigQueryLinksResponse
                         */
                        ListBigQueryLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListBigQueryLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListBigQueryLinksResponse();
                            if (object.bigqueryLinks) {
                                if (!Array.isArray(object.bigqueryLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListBigQueryLinksResponse.bigqueryLinks: array expected");
                                message.bigqueryLinks = [];
                                for (var i = 0; i < object.bigqueryLinks.length; ++i) {
                                    if (typeof object.bigqueryLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListBigQueryLinksResponse.bigqueryLinks: object expected");
                                    message.bigqueryLinks[i] = $root.google.analytics.admin.v1alpha.BigQueryLink.fromObject(object.bigqueryLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListBigQueryLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListBigQueryLinksResponse} message ListBigQueryLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListBigQueryLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.bigqueryLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.bigqueryLinks && message.bigqueryLinks.length) {
                                object.bigqueryLinks = [];
                                for (var j = 0; j < message.bigqueryLinks.length; ++j)
                                    object.bigqueryLinks[j] = $root.google.analytics.admin.v1alpha.BigQueryLink.toObject(message.bigqueryLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListBigQueryLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListBigQueryLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListBigQueryLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListBigQueryLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListBigQueryLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListBigQueryLinksResponse";
                        };
    
                        return ListBigQueryLinksResponse;
                    })();
    
                    v1alpha.GetEnhancedMeasurementSettingsRequest = (function() {
    
                        /**
                         * Properties of a GetEnhancedMeasurementSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetEnhancedMeasurementSettingsRequest
                         * @property {string|null} [name] GetEnhancedMeasurementSettingsRequest name
                         */
    
                        /**
                         * Constructs a new GetEnhancedMeasurementSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetEnhancedMeasurementSettingsRequest.
                         * @implements IGetEnhancedMeasurementSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetEnhancedMeasurementSettingsRequest=} [properties] Properties to set
                         */
                        function GetEnhancedMeasurementSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetEnhancedMeasurementSettingsRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @instance
                         */
                        GetEnhancedMeasurementSettingsRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetEnhancedMeasurementSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetEnhancedMeasurementSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest} GetEnhancedMeasurementSettingsRequest instance
                         */
                        GetEnhancedMeasurementSettingsRequest.create = function create(properties) {
                            return new GetEnhancedMeasurementSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetEnhancedMeasurementSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetEnhancedMeasurementSettingsRequest} message GetEnhancedMeasurementSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEnhancedMeasurementSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetEnhancedMeasurementSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetEnhancedMeasurementSettingsRequest} message GetEnhancedMeasurementSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEnhancedMeasurementSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetEnhancedMeasurementSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest} GetEnhancedMeasurementSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEnhancedMeasurementSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetEnhancedMeasurementSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest} GetEnhancedMeasurementSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEnhancedMeasurementSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetEnhancedMeasurementSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetEnhancedMeasurementSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetEnhancedMeasurementSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest} GetEnhancedMeasurementSettingsRequest
                         */
                        GetEnhancedMeasurementSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetEnhancedMeasurementSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest} message GetEnhancedMeasurementSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetEnhancedMeasurementSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetEnhancedMeasurementSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetEnhancedMeasurementSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetEnhancedMeasurementSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetEnhancedMeasurementSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetEnhancedMeasurementSettingsRequest";
                        };
    
                        return GetEnhancedMeasurementSettingsRequest;
                    })();
    
                    v1alpha.UpdateEnhancedMeasurementSettingsRequest = (function() {
    
                        /**
                         * Properties of an UpdateEnhancedMeasurementSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateEnhancedMeasurementSettingsRequest
                         * @property {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings|null} [enhancedMeasurementSettings] UpdateEnhancedMeasurementSettingsRequest enhancedMeasurementSettings
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateEnhancedMeasurementSettingsRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateEnhancedMeasurementSettingsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateEnhancedMeasurementSettingsRequest.
                         * @implements IUpdateEnhancedMeasurementSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateEnhancedMeasurementSettingsRequest=} [properties] Properties to set
                         */
                        function UpdateEnhancedMeasurementSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateEnhancedMeasurementSettingsRequest enhancedMeasurementSettings.
                         * @member {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings|null|undefined} enhancedMeasurementSettings
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @instance
                         */
                        UpdateEnhancedMeasurementSettingsRequest.prototype.enhancedMeasurementSettings = null;
    
                        /**
                         * UpdateEnhancedMeasurementSettingsRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @instance
                         */
                        UpdateEnhancedMeasurementSettingsRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateEnhancedMeasurementSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateEnhancedMeasurementSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest} UpdateEnhancedMeasurementSettingsRequest instance
                         */
                        UpdateEnhancedMeasurementSettingsRequest.create = function create(properties) {
                            return new UpdateEnhancedMeasurementSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateEnhancedMeasurementSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateEnhancedMeasurementSettingsRequest} message UpdateEnhancedMeasurementSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateEnhancedMeasurementSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enhancedMeasurementSettings != null && Object.hasOwnProperty.call(message, "enhancedMeasurementSettings"))
                                $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.encode(message.enhancedMeasurementSettings, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateEnhancedMeasurementSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateEnhancedMeasurementSettingsRequest} message UpdateEnhancedMeasurementSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateEnhancedMeasurementSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateEnhancedMeasurementSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest} UpdateEnhancedMeasurementSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateEnhancedMeasurementSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.enhancedMeasurementSettings = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateEnhancedMeasurementSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest} UpdateEnhancedMeasurementSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateEnhancedMeasurementSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateEnhancedMeasurementSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateEnhancedMeasurementSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.enhancedMeasurementSettings != null && message.hasOwnProperty("enhancedMeasurementSettings")) {
                                var error = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.verify(message.enhancedMeasurementSettings);
                                if (error)
                                    return "enhancedMeasurementSettings." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateEnhancedMeasurementSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest} UpdateEnhancedMeasurementSettingsRequest
                         */
                        UpdateEnhancedMeasurementSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest();
                            if (object.enhancedMeasurementSettings != null) {
                                if (typeof object.enhancedMeasurementSettings !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest.enhancedMeasurementSettings: object expected");
                                message.enhancedMeasurementSettings = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.fromObject(object.enhancedMeasurementSettings);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateEnhancedMeasurementSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest} message UpdateEnhancedMeasurementSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateEnhancedMeasurementSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.enhancedMeasurementSettings = null;
                                object.updateMask = null;
                            }
                            if (message.enhancedMeasurementSettings != null && message.hasOwnProperty("enhancedMeasurementSettings"))
                                object.enhancedMeasurementSettings = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.toObject(message.enhancedMeasurementSettings, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateEnhancedMeasurementSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateEnhancedMeasurementSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateEnhancedMeasurementSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateEnhancedMeasurementSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateEnhancedMeasurementSettingsRequest";
                        };
    
                        return UpdateEnhancedMeasurementSettingsRequest;
                    })();
    
                    v1alpha.CreateConnectedSiteTagRequest = (function() {
    
                        /**
                         * Properties of a CreateConnectedSiteTagRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateConnectedSiteTagRequest
                         * @property {string|null} [property] CreateConnectedSiteTagRequest property
                         * @property {google.analytics.admin.v1alpha.IConnectedSiteTag|null} [connectedSiteTag] CreateConnectedSiteTagRequest connectedSiteTag
                         */
    
                        /**
                         * Constructs a new CreateConnectedSiteTagRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateConnectedSiteTagRequest.
                         * @implements ICreateConnectedSiteTagRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagRequest=} [properties] Properties to set
                         */
                        function CreateConnectedSiteTagRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateConnectedSiteTagRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @instance
                         */
                        CreateConnectedSiteTagRequest.prototype.property = "";
    
                        /**
                         * CreateConnectedSiteTagRequest connectedSiteTag.
                         * @member {google.analytics.admin.v1alpha.IConnectedSiteTag|null|undefined} connectedSiteTag
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @instance
                         */
                        CreateConnectedSiteTagRequest.prototype.connectedSiteTag = null;
    
                        /**
                         * Creates a new CreateConnectedSiteTagRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest} CreateConnectedSiteTagRequest instance
                         */
                        CreateConnectedSiteTagRequest.create = function create(properties) {
                            return new CreateConnectedSiteTagRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateConnectedSiteTagRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagRequest} message CreateConnectedSiteTagRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConnectedSiteTagRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            if (message.connectedSiteTag != null && Object.hasOwnProperty.call(message, "connectedSiteTag"))
                                $root.google.analytics.admin.v1alpha.ConnectedSiteTag.encode(message.connectedSiteTag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateConnectedSiteTagRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagRequest} message CreateConnectedSiteTagRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConnectedSiteTagRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateConnectedSiteTagRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest} CreateConnectedSiteTagRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConnectedSiteTagRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.connectedSiteTag = $root.google.analytics.admin.v1alpha.ConnectedSiteTag.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateConnectedSiteTagRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest} CreateConnectedSiteTagRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConnectedSiteTagRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateConnectedSiteTagRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateConnectedSiteTagRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.connectedSiteTag != null && message.hasOwnProperty("connectedSiteTag")) {
                                var error = $root.google.analytics.admin.v1alpha.ConnectedSiteTag.verify(message.connectedSiteTag);
                                if (error)
                                    return "connectedSiteTag." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateConnectedSiteTagRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest} CreateConnectedSiteTagRequest
                         */
                        CreateConnectedSiteTagRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.connectedSiteTag != null) {
                                if (typeof object.connectedSiteTag !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest.connectedSiteTag: object expected");
                                message.connectedSiteTag = $root.google.analytics.admin.v1alpha.ConnectedSiteTag.fromObject(object.connectedSiteTag);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateConnectedSiteTagRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest} message CreateConnectedSiteTagRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateConnectedSiteTagRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = "";
                                object.connectedSiteTag = null;
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.connectedSiteTag != null && message.hasOwnProperty("connectedSiteTag"))
                                object.connectedSiteTag = $root.google.analytics.admin.v1alpha.ConnectedSiteTag.toObject(message.connectedSiteTag, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateConnectedSiteTagRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateConnectedSiteTagRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateConnectedSiteTagRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateConnectedSiteTagRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateConnectedSiteTagRequest";
                        };
    
                        return CreateConnectedSiteTagRequest;
                    })();
    
                    v1alpha.CreateConnectedSiteTagResponse = (function() {
    
                        /**
                         * Properties of a CreateConnectedSiteTagResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateConnectedSiteTagResponse
                         */
    
                        /**
                         * Constructs a new CreateConnectedSiteTagResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateConnectedSiteTagResponse.
                         * @implements ICreateConnectedSiteTagResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagResponse=} [properties] Properties to set
                         */
                        function CreateConnectedSiteTagResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new CreateConnectedSiteTagResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse} CreateConnectedSiteTagResponse instance
                         */
                        CreateConnectedSiteTagResponse.create = function create(properties) {
                            return new CreateConnectedSiteTagResponse(properties);
                        };
    
                        /**
                         * Encodes the specified CreateConnectedSiteTagResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagResponse} message CreateConnectedSiteTagResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConnectedSiteTagResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateConnectedSiteTagResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateConnectedSiteTagResponse} message CreateConnectedSiteTagResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConnectedSiteTagResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateConnectedSiteTagResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse} CreateConnectedSiteTagResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConnectedSiteTagResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateConnectedSiteTagResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse} CreateConnectedSiteTagResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConnectedSiteTagResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateConnectedSiteTagResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateConnectedSiteTagResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates a CreateConnectedSiteTagResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse} CreateConnectedSiteTagResponse
                         */
                        CreateConnectedSiteTagResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse)
                                return object;
                            return new $root.google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse();
                        };
    
                        /**
                         * Creates a plain object from a CreateConnectedSiteTagResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse} message CreateConnectedSiteTagResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateConnectedSiteTagResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this CreateConnectedSiteTagResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateConnectedSiteTagResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateConnectedSiteTagResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateConnectedSiteTagResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateConnectedSiteTagResponse";
                        };
    
                        return CreateConnectedSiteTagResponse;
                    })();
    
                    v1alpha.DeleteConnectedSiteTagRequest = (function() {
    
                        /**
                         * Properties of a DeleteConnectedSiteTagRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteConnectedSiteTagRequest
                         * @property {string|null} [property] DeleteConnectedSiteTagRequest property
                         * @property {string|null} [tagId] DeleteConnectedSiteTagRequest tagId
                         */
    
                        /**
                         * Constructs a new DeleteConnectedSiteTagRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteConnectedSiteTagRequest.
                         * @implements IDeleteConnectedSiteTagRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteConnectedSiteTagRequest=} [properties] Properties to set
                         */
                        function DeleteConnectedSiteTagRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteConnectedSiteTagRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @instance
                         */
                        DeleteConnectedSiteTagRequest.prototype.property = "";
    
                        /**
                         * DeleteConnectedSiteTagRequest tagId.
                         * @member {string} tagId
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @instance
                         */
                        DeleteConnectedSiteTagRequest.prototype.tagId = "";
    
                        /**
                         * Creates a new DeleteConnectedSiteTagRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteConnectedSiteTagRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest} DeleteConnectedSiteTagRequest instance
                         */
                        DeleteConnectedSiteTagRequest.create = function create(properties) {
                            return new DeleteConnectedSiteTagRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteConnectedSiteTagRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteConnectedSiteTagRequest} message DeleteConnectedSiteTagRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteConnectedSiteTagRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            if (message.tagId != null && Object.hasOwnProperty.call(message, "tagId"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.tagId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteConnectedSiteTagRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteConnectedSiteTagRequest} message DeleteConnectedSiteTagRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteConnectedSiteTagRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteConnectedSiteTagRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest} DeleteConnectedSiteTagRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteConnectedSiteTagRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.tagId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteConnectedSiteTagRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest} DeleteConnectedSiteTagRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteConnectedSiteTagRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteConnectedSiteTagRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteConnectedSiteTagRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.tagId != null && message.hasOwnProperty("tagId"))
                                if (!$util.isString(message.tagId))
                                    return "tagId: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteConnectedSiteTagRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest} DeleteConnectedSiteTagRequest
                         */
                        DeleteConnectedSiteTagRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.tagId != null)
                                message.tagId = String(object.tagId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteConnectedSiteTagRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest} message DeleteConnectedSiteTagRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteConnectedSiteTagRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = "";
                                object.tagId = "";
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.tagId != null && message.hasOwnProperty("tagId"))
                                object.tagId = message.tagId;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteConnectedSiteTagRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteConnectedSiteTagRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteConnectedSiteTagRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteConnectedSiteTagRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteConnectedSiteTagRequest";
                        };
    
                        return DeleteConnectedSiteTagRequest;
                    })();
    
                    v1alpha.ListConnectedSiteTagsRequest = (function() {
    
                        /**
                         * Properties of a ListConnectedSiteTagsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListConnectedSiteTagsRequest
                         * @property {string|null} [property] ListConnectedSiteTagsRequest property
                         */
    
                        /**
                         * Constructs a new ListConnectedSiteTagsRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListConnectedSiteTagsRequest.
                         * @implements IListConnectedSiteTagsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsRequest=} [properties] Properties to set
                         */
                        function ListConnectedSiteTagsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListConnectedSiteTagsRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @instance
                         */
                        ListConnectedSiteTagsRequest.prototype.property = "";
    
                        /**
                         * Creates a new ListConnectedSiteTagsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest} ListConnectedSiteTagsRequest instance
                         */
                        ListConnectedSiteTagsRequest.create = function create(properties) {
                            return new ListConnectedSiteTagsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListConnectedSiteTagsRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsRequest} message ListConnectedSiteTagsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConnectedSiteTagsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListConnectedSiteTagsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsRequest} message ListConnectedSiteTagsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConnectedSiteTagsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListConnectedSiteTagsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest} ListConnectedSiteTagsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConnectedSiteTagsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListConnectedSiteTagsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest} ListConnectedSiteTagsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConnectedSiteTagsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListConnectedSiteTagsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListConnectedSiteTagsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListConnectedSiteTagsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest} ListConnectedSiteTagsRequest
                         */
                        ListConnectedSiteTagsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListConnectedSiteTagsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest} message ListConnectedSiteTagsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListConnectedSiteTagsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.property = "";
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            return object;
                        };
    
                        /**
                         * Converts this ListConnectedSiteTagsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListConnectedSiteTagsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListConnectedSiteTagsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListConnectedSiteTagsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListConnectedSiteTagsRequest";
                        };
    
                        return ListConnectedSiteTagsRequest;
                    })();
    
                    v1alpha.ListConnectedSiteTagsResponse = (function() {
    
                        /**
                         * Properties of a ListConnectedSiteTagsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListConnectedSiteTagsResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IConnectedSiteTag>|null} [connectedSiteTags] ListConnectedSiteTagsResponse connectedSiteTags
                         */
    
                        /**
                         * Constructs a new ListConnectedSiteTagsResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListConnectedSiteTagsResponse.
                         * @implements IListConnectedSiteTagsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsResponse=} [properties] Properties to set
                         */
                        function ListConnectedSiteTagsResponse(properties) {
                            this.connectedSiteTags = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListConnectedSiteTagsResponse connectedSiteTags.
                         * @member {Array.<google.analytics.admin.v1alpha.IConnectedSiteTag>} connectedSiteTags
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @instance
                         */
                        ListConnectedSiteTagsResponse.prototype.connectedSiteTags = $util.emptyArray;
    
                        /**
                         * Creates a new ListConnectedSiteTagsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse} ListConnectedSiteTagsResponse instance
                         */
                        ListConnectedSiteTagsResponse.create = function create(properties) {
                            return new ListConnectedSiteTagsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListConnectedSiteTagsResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsResponse} message ListConnectedSiteTagsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConnectedSiteTagsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.connectedSiteTags != null && message.connectedSiteTags.length)
                                for (var i = 0; i < message.connectedSiteTags.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ConnectedSiteTag.encode(message.connectedSiteTags[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListConnectedSiteTagsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListConnectedSiteTagsResponse} message ListConnectedSiteTagsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConnectedSiteTagsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListConnectedSiteTagsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse} ListConnectedSiteTagsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConnectedSiteTagsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.connectedSiteTags && message.connectedSiteTags.length))
                                            message.connectedSiteTags = [];
                                        message.connectedSiteTags.push($root.google.analytics.admin.v1alpha.ConnectedSiteTag.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListConnectedSiteTagsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse} ListConnectedSiteTagsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConnectedSiteTagsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListConnectedSiteTagsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListConnectedSiteTagsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.connectedSiteTags != null && message.hasOwnProperty("connectedSiteTags")) {
                                if (!Array.isArray(message.connectedSiteTags))
                                    return "connectedSiteTags: array expected";
                                for (var i = 0; i < message.connectedSiteTags.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ConnectedSiteTag.verify(message.connectedSiteTags[i]);
                                    if (error)
                                        return "connectedSiteTags." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListConnectedSiteTagsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse} ListConnectedSiteTagsResponse
                         */
                        ListConnectedSiteTagsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse();
                            if (object.connectedSiteTags) {
                                if (!Array.isArray(object.connectedSiteTags))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse.connectedSiteTags: array expected");
                                message.connectedSiteTags = [];
                                for (var i = 0; i < object.connectedSiteTags.length; ++i) {
                                    if (typeof object.connectedSiteTags[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse.connectedSiteTags: object expected");
                                    message.connectedSiteTags[i] = $root.google.analytics.admin.v1alpha.ConnectedSiteTag.fromObject(object.connectedSiteTags[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListConnectedSiteTagsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse} message ListConnectedSiteTagsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListConnectedSiteTagsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.connectedSiteTags = [];
                            if (message.connectedSiteTags && message.connectedSiteTags.length) {
                                object.connectedSiteTags = [];
                                for (var j = 0; j < message.connectedSiteTags.length; ++j)
                                    object.connectedSiteTags[j] = $root.google.analytics.admin.v1alpha.ConnectedSiteTag.toObject(message.connectedSiteTags[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListConnectedSiteTagsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListConnectedSiteTagsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListConnectedSiteTagsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListConnectedSiteTagsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListConnectedSiteTagsResponse";
                        };
    
                        return ListConnectedSiteTagsResponse;
                    })();
    
                    v1alpha.CreateAdSenseLinkRequest = (function() {
    
                        /**
                         * Properties of a CreateAdSenseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateAdSenseLinkRequest
                         * @property {string|null} [parent] CreateAdSenseLinkRequest parent
                         * @property {google.analytics.admin.v1alpha.IAdSenseLink|null} [adsenseLink] CreateAdSenseLinkRequest adsenseLink
                         */
    
                        /**
                         * Constructs a new CreateAdSenseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateAdSenseLinkRequest.
                         * @implements ICreateAdSenseLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateAdSenseLinkRequest=} [properties] Properties to set
                         */
                        function CreateAdSenseLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateAdSenseLinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @instance
                         */
                        CreateAdSenseLinkRequest.prototype.parent = "";
    
                        /**
                         * CreateAdSenseLinkRequest adsenseLink.
                         * @member {google.analytics.admin.v1alpha.IAdSenseLink|null|undefined} adsenseLink
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @instance
                         */
                        CreateAdSenseLinkRequest.prototype.adsenseLink = null;
    
                        /**
                         * Creates a new CreateAdSenseLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAdSenseLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateAdSenseLinkRequest} CreateAdSenseLinkRequest instance
                         */
                        CreateAdSenseLinkRequest.create = function create(properties) {
                            return new CreateAdSenseLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateAdSenseLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateAdSenseLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAdSenseLinkRequest} message CreateAdSenseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateAdSenseLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.adsenseLink != null && Object.hasOwnProperty.call(message, "adsenseLink"))
                                $root.google.analytics.admin.v1alpha.AdSenseLink.encode(message.adsenseLink, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateAdSenseLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateAdSenseLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateAdSenseLinkRequest} message CreateAdSenseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateAdSenseLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateAdSenseLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateAdSenseLinkRequest} CreateAdSenseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateAdSenseLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateAdSenseLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.adsenseLink = $root.google.analytics.admin.v1alpha.AdSenseLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateAdSenseLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateAdSenseLinkRequest} CreateAdSenseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateAdSenseLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateAdSenseLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateAdSenseLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.adsenseLink != null && message.hasOwnProperty("adsenseLink")) {
                                var error = $root.google.analytics.admin.v1alpha.AdSenseLink.verify(message.adsenseLink);
                                if (error)
                                    return "adsenseLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateAdSenseLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateAdSenseLinkRequest} CreateAdSenseLinkRequest
                         */
                        CreateAdSenseLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateAdSenseLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateAdSenseLinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.adsenseLink != null) {
                                if (typeof object.adsenseLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateAdSenseLinkRequest.adsenseLink: object expected");
                                message.adsenseLink = $root.google.analytics.admin.v1alpha.AdSenseLink.fromObject(object.adsenseLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateAdSenseLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateAdSenseLinkRequest} message CreateAdSenseLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateAdSenseLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.adsenseLink = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.adsenseLink != null && message.hasOwnProperty("adsenseLink"))
                                object.adsenseLink = $root.google.analytics.admin.v1alpha.AdSenseLink.toObject(message.adsenseLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateAdSenseLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateAdSenseLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateAdSenseLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateAdSenseLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateAdSenseLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateAdSenseLinkRequest";
                        };
    
                        return CreateAdSenseLinkRequest;
                    })();
    
                    v1alpha.GetAdSenseLinkRequest = (function() {
    
                        /**
                         * Properties of a GetAdSenseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetAdSenseLinkRequest
                         * @property {string|null} [name] GetAdSenseLinkRequest name
                         */
    
                        /**
                         * Constructs a new GetAdSenseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetAdSenseLinkRequest.
                         * @implements IGetAdSenseLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetAdSenseLinkRequest=} [properties] Properties to set
                         */
                        function GetAdSenseLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAdSenseLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @instance
                         */
                        GetAdSenseLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetAdSenseLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAdSenseLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetAdSenseLinkRequest} GetAdSenseLinkRequest instance
                         */
                        GetAdSenseLinkRequest.create = function create(properties) {
                            return new GetAdSenseLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAdSenseLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetAdSenseLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAdSenseLinkRequest} message GetAdSenseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdSenseLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAdSenseLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetAdSenseLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetAdSenseLinkRequest} message GetAdSenseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAdSenseLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAdSenseLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetAdSenseLinkRequest} GetAdSenseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdSenseLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetAdSenseLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAdSenseLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetAdSenseLinkRequest} GetAdSenseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAdSenseLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAdSenseLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAdSenseLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAdSenseLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetAdSenseLinkRequest} GetAdSenseLinkRequest
                         */
                        GetAdSenseLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetAdSenseLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetAdSenseLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAdSenseLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetAdSenseLinkRequest} message GetAdSenseLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAdSenseLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetAdSenseLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAdSenseLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAdSenseLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetAdSenseLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAdSenseLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetAdSenseLinkRequest";
                        };
    
                        return GetAdSenseLinkRequest;
                    })();
    
                    v1alpha.DeleteAdSenseLinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteAdSenseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteAdSenseLinkRequest
                         * @property {string|null} [name] DeleteAdSenseLinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteAdSenseLinkRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteAdSenseLinkRequest.
                         * @implements IDeleteAdSenseLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteAdSenseLinkRequest=} [properties] Properties to set
                         */
                        function DeleteAdSenseLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAdSenseLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @instance
                         */
                        DeleteAdSenseLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteAdSenseLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAdSenseLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest} DeleteAdSenseLinkRequest instance
                         */
                        DeleteAdSenseLinkRequest.create = function create(properties) {
                            return new DeleteAdSenseLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAdSenseLinkRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAdSenseLinkRequest} message DeleteAdSenseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAdSenseLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAdSenseLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteAdSenseLinkRequest} message DeleteAdSenseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAdSenseLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAdSenseLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest} DeleteAdSenseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAdSenseLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAdSenseLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest} DeleteAdSenseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAdSenseLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAdSenseLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAdSenseLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAdSenseLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest} DeleteAdSenseLinkRequest
                         */
                        DeleteAdSenseLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAdSenseLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest} message DeleteAdSenseLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAdSenseLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAdSenseLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAdSenseLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAdSenseLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAdSenseLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteAdSenseLinkRequest";
                        };
    
                        return DeleteAdSenseLinkRequest;
                    })();
    
                    v1alpha.ListAdSenseLinksRequest = (function() {
    
                        /**
                         * Properties of a ListAdSenseLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAdSenseLinksRequest
                         * @property {string|null} [parent] ListAdSenseLinksRequest parent
                         * @property {number|null} [pageSize] ListAdSenseLinksRequest pageSize
                         * @property {string|null} [pageToken] ListAdSenseLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListAdSenseLinksRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAdSenseLinksRequest.
                         * @implements IListAdSenseLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksRequest=} [properties] Properties to set
                         */
                        function ListAdSenseLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAdSenseLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @instance
                         */
                        ListAdSenseLinksRequest.prototype.parent = "";
    
                        /**
                         * ListAdSenseLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @instance
                         */
                        ListAdSenseLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListAdSenseLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @instance
                         */
                        ListAdSenseLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListAdSenseLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksRequest} ListAdSenseLinksRequest instance
                         */
                        ListAdSenseLinksRequest.create = function create(properties) {
                            return new ListAdSenseLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAdSenseLinksRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAdSenseLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksRequest} message ListAdSenseLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAdSenseLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAdSenseLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAdSenseLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksRequest} message ListAdSenseLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAdSenseLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAdSenseLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksRequest} ListAdSenseLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAdSenseLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAdSenseLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAdSenseLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksRequest} ListAdSenseLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAdSenseLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAdSenseLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAdSenseLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAdSenseLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksRequest} ListAdSenseLinksRequest
                         */
                        ListAdSenseLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAdSenseLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAdSenseLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAdSenseLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAdSenseLinksRequest} message ListAdSenseLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAdSenseLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAdSenseLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAdSenseLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAdSenseLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAdSenseLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAdSenseLinksRequest";
                        };
    
                        return ListAdSenseLinksRequest;
                    })();
    
                    v1alpha.ListAdSenseLinksResponse = (function() {
    
                        /**
                         * Properties of a ListAdSenseLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListAdSenseLinksResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IAdSenseLink>|null} [adsenseLinks] ListAdSenseLinksResponse adsenseLinks
                         * @property {string|null} [nextPageToken] ListAdSenseLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListAdSenseLinksResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListAdSenseLinksResponse.
                         * @implements IListAdSenseLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksResponse=} [properties] Properties to set
                         */
                        function ListAdSenseLinksResponse(properties) {
                            this.adsenseLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAdSenseLinksResponse adsenseLinks.
                         * @member {Array.<google.analytics.admin.v1alpha.IAdSenseLink>} adsenseLinks
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @instance
                         */
                        ListAdSenseLinksResponse.prototype.adsenseLinks = $util.emptyArray;
    
                        /**
                         * ListAdSenseLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @instance
                         */
                        ListAdSenseLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListAdSenseLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksResponse} ListAdSenseLinksResponse instance
                         */
                        ListAdSenseLinksResponse.create = function create(properties) {
                            return new ListAdSenseLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListAdSenseLinksResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListAdSenseLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksResponse} message ListAdSenseLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAdSenseLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.adsenseLinks != null && message.adsenseLinks.length)
                                for (var i = 0; i < message.adsenseLinks.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AdSenseLink.encode(message.adsenseLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAdSenseLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListAdSenseLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListAdSenseLinksResponse} message ListAdSenseLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAdSenseLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAdSenseLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksResponse} ListAdSenseLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAdSenseLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListAdSenseLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.adsenseLinks && message.adsenseLinks.length))
                                            message.adsenseLinks = [];
                                        message.adsenseLinks.push($root.google.analytics.admin.v1alpha.AdSenseLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAdSenseLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksResponse} ListAdSenseLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAdSenseLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAdSenseLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAdSenseLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.adsenseLinks != null && message.hasOwnProperty("adsenseLinks")) {
                                if (!Array.isArray(message.adsenseLinks))
                                    return "adsenseLinks: array expected";
                                for (var i = 0; i < message.adsenseLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AdSenseLink.verify(message.adsenseLinks[i]);
                                    if (error)
                                        return "adsenseLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAdSenseLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListAdSenseLinksResponse} ListAdSenseLinksResponse
                         */
                        ListAdSenseLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListAdSenseLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListAdSenseLinksResponse();
                            if (object.adsenseLinks) {
                                if (!Array.isArray(object.adsenseLinks))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListAdSenseLinksResponse.adsenseLinks: array expected");
                                message.adsenseLinks = [];
                                for (var i = 0; i < object.adsenseLinks.length; ++i) {
                                    if (typeof object.adsenseLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListAdSenseLinksResponse.adsenseLinks: object expected");
                                    message.adsenseLinks[i] = $root.google.analytics.admin.v1alpha.AdSenseLink.fromObject(object.adsenseLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAdSenseLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListAdSenseLinksResponse} message ListAdSenseLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAdSenseLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.adsenseLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.adsenseLinks && message.adsenseLinks.length) {
                                object.adsenseLinks = [];
                                for (var j = 0; j < message.adsenseLinks.length; ++j)
                                    object.adsenseLinks[j] = $root.google.analytics.admin.v1alpha.AdSenseLink.toObject(message.adsenseLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAdSenseLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAdSenseLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAdSenseLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListAdSenseLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAdSenseLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListAdSenseLinksResponse";
                        };
    
                        return ListAdSenseLinksResponse;
                    })();
    
                    v1alpha.FetchConnectedGa4PropertyRequest = (function() {
    
                        /**
                         * Properties of a FetchConnectedGa4PropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IFetchConnectedGa4PropertyRequest
                         * @property {string|null} [property] FetchConnectedGa4PropertyRequest property
                         */
    
                        /**
                         * Constructs a new FetchConnectedGa4PropertyRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a FetchConnectedGa4PropertyRequest.
                         * @implements IFetchConnectedGa4PropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyRequest=} [properties] Properties to set
                         */
                        function FetchConnectedGa4PropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FetchConnectedGa4PropertyRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @instance
                         */
                        FetchConnectedGa4PropertyRequest.prototype.property = "";
    
                        /**
                         * Creates a new FetchConnectedGa4PropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest} FetchConnectedGa4PropertyRequest instance
                         */
                        FetchConnectedGa4PropertyRequest.create = function create(properties) {
                            return new FetchConnectedGa4PropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified FetchConnectedGa4PropertyRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyRequest} message FetchConnectedGa4PropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchConnectedGa4PropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FetchConnectedGa4PropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyRequest} message FetchConnectedGa4PropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchConnectedGa4PropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FetchConnectedGa4PropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest} FetchConnectedGa4PropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchConnectedGa4PropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FetchConnectedGa4PropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest} FetchConnectedGa4PropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchConnectedGa4PropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FetchConnectedGa4PropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FetchConnectedGa4PropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a FetchConnectedGa4PropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest} FetchConnectedGa4PropertyRequest
                         */
                        FetchConnectedGa4PropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FetchConnectedGa4PropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest} message FetchConnectedGa4PropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FetchConnectedGa4PropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.property = "";
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            return object;
                        };
    
                        /**
                         * Converts this FetchConnectedGa4PropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FetchConnectedGa4PropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FetchConnectedGa4PropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FetchConnectedGa4PropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.FetchConnectedGa4PropertyRequest";
                        };
    
                        return FetchConnectedGa4PropertyRequest;
                    })();
    
                    v1alpha.FetchConnectedGa4PropertyResponse = (function() {
    
                        /**
                         * Properties of a FetchConnectedGa4PropertyResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IFetchConnectedGa4PropertyResponse
                         * @property {string|null} [property] FetchConnectedGa4PropertyResponse property
                         */
    
                        /**
                         * Constructs a new FetchConnectedGa4PropertyResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a FetchConnectedGa4PropertyResponse.
                         * @implements IFetchConnectedGa4PropertyResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyResponse=} [properties] Properties to set
                         */
                        function FetchConnectedGa4PropertyResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FetchConnectedGa4PropertyResponse property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @instance
                         */
                        FetchConnectedGa4PropertyResponse.prototype.property = "";
    
                        /**
                         * Creates a new FetchConnectedGa4PropertyResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse} FetchConnectedGa4PropertyResponse instance
                         */
                        FetchConnectedGa4PropertyResponse.create = function create(properties) {
                            return new FetchConnectedGa4PropertyResponse(properties);
                        };
    
                        /**
                         * Encodes the specified FetchConnectedGa4PropertyResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyResponse} message FetchConnectedGa4PropertyResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchConnectedGa4PropertyResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FetchConnectedGa4PropertyResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFetchConnectedGa4PropertyResponse} message FetchConnectedGa4PropertyResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FetchConnectedGa4PropertyResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FetchConnectedGa4PropertyResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse} FetchConnectedGa4PropertyResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchConnectedGa4PropertyResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FetchConnectedGa4PropertyResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse} FetchConnectedGa4PropertyResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FetchConnectedGa4PropertyResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FetchConnectedGa4PropertyResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FetchConnectedGa4PropertyResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a FetchConnectedGa4PropertyResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse} FetchConnectedGa4PropertyResponse
                         */
                        FetchConnectedGa4PropertyResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse();
                            if (object.property != null)
                                message.property = String(object.property);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FetchConnectedGa4PropertyResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse} message FetchConnectedGa4PropertyResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FetchConnectedGa4PropertyResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.property = "";
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            return object;
                        };
    
                        /**
                         * Converts this FetchConnectedGa4PropertyResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FetchConnectedGa4PropertyResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FetchConnectedGa4PropertyResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FetchConnectedGa4PropertyResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.FetchConnectedGa4PropertyResponse";
                        };
    
                        return FetchConnectedGa4PropertyResponse;
                    })();
    
                    v1alpha.CreateEventCreateRuleRequest = (function() {
    
                        /**
                         * Properties of a CreateEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICreateEventCreateRuleRequest
                         * @property {string|null} [parent] CreateEventCreateRuleRequest parent
                         * @property {google.analytics.admin.v1alpha.IEventCreateRule|null} [eventCreateRule] CreateEventCreateRuleRequest eventCreateRule
                         */
    
                        /**
                         * Constructs a new CreateEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CreateEventCreateRuleRequest.
                         * @implements ICreateEventCreateRuleRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICreateEventCreateRuleRequest=} [properties] Properties to set
                         */
                        function CreateEventCreateRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateEventCreateRuleRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @instance
                         */
                        CreateEventCreateRuleRequest.prototype.parent = "";
    
                        /**
                         * CreateEventCreateRuleRequest eventCreateRule.
                         * @member {google.analytics.admin.v1alpha.IEventCreateRule|null|undefined} eventCreateRule
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @instance
                         */
                        CreateEventCreateRuleRequest.prototype.eventCreateRule = null;
    
                        /**
                         * Creates a new CreateEventCreateRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateEventCreateRuleRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CreateEventCreateRuleRequest} CreateEventCreateRuleRequest instance
                         */
                        CreateEventCreateRuleRequest.create = function create(properties) {
                            return new CreateEventCreateRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateEventCreateRuleRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.CreateEventCreateRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateEventCreateRuleRequest} message CreateEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateEventCreateRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.eventCreateRule != null && Object.hasOwnProperty.call(message, "eventCreateRule"))
                                $root.google.analytics.admin.v1alpha.EventCreateRule.encode(message.eventCreateRule, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateEventCreateRuleRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CreateEventCreateRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICreateEventCreateRuleRequest} message CreateEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateEventCreateRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateEventCreateRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CreateEventCreateRuleRequest} CreateEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateEventCreateRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CreateEventCreateRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateEventCreateRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CreateEventCreateRuleRequest} CreateEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateEventCreateRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateEventCreateRuleRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateEventCreateRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.eventCreateRule != null && message.hasOwnProperty("eventCreateRule")) {
                                var error = $root.google.analytics.admin.v1alpha.EventCreateRule.verify(message.eventCreateRule);
                                if (error)
                                    return "eventCreateRule." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateEventCreateRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CreateEventCreateRuleRequest} CreateEventCreateRuleRequest
                         */
                        CreateEventCreateRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CreateEventCreateRuleRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CreateEventCreateRuleRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.eventCreateRule != null) {
                                if (typeof object.eventCreateRule !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.CreateEventCreateRuleRequest.eventCreateRule: object expected");
                                message.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.fromObject(object.eventCreateRule);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateEventCreateRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.CreateEventCreateRuleRequest} message CreateEventCreateRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateEventCreateRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.eventCreateRule = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.eventCreateRule != null && message.hasOwnProperty("eventCreateRule"))
                                object.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.toObject(message.eventCreateRule, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateEventCreateRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateEventCreateRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateEventCreateRuleRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CreateEventCreateRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateEventCreateRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CreateEventCreateRuleRequest";
                        };
    
                        return CreateEventCreateRuleRequest;
                    })();
    
                    v1alpha.UpdateEventCreateRuleRequest = (function() {
    
                        /**
                         * Properties of an UpdateEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUpdateEventCreateRuleRequest
                         * @property {google.analytics.admin.v1alpha.IEventCreateRule|null} [eventCreateRule] UpdateEventCreateRuleRequest eventCreateRule
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateEventCreateRuleRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an UpdateEventCreateRuleRequest.
                         * @implements IUpdateEventCreateRuleRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUpdateEventCreateRuleRequest=} [properties] Properties to set
                         */
                        function UpdateEventCreateRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateEventCreateRuleRequest eventCreateRule.
                         * @member {google.analytics.admin.v1alpha.IEventCreateRule|null|undefined} eventCreateRule
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @instance
                         */
                        UpdateEventCreateRuleRequest.prototype.eventCreateRule = null;
    
                        /**
                         * UpdateEventCreateRuleRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @instance
                         */
                        UpdateEventCreateRuleRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateEventCreateRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateEventCreateRuleRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest} UpdateEventCreateRuleRequest instance
                         */
                        UpdateEventCreateRuleRequest.create = function create(properties) {
                            return new UpdateEventCreateRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateEventCreateRuleRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateEventCreateRuleRequest} message UpdateEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateEventCreateRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.eventCreateRule != null && Object.hasOwnProperty.call(message, "eventCreateRule"))
                                $root.google.analytics.admin.v1alpha.EventCreateRule.encode(message.eventCreateRule, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateEventCreateRuleRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUpdateEventCreateRuleRequest} message UpdateEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateEventCreateRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateEventCreateRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest} UpdateEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateEventCreateRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateEventCreateRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest} UpdateEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateEventCreateRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateEventCreateRuleRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateEventCreateRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.eventCreateRule != null && message.hasOwnProperty("eventCreateRule")) {
                                var error = $root.google.analytics.admin.v1alpha.EventCreateRule.verify(message.eventCreateRule);
                                if (error)
                                    return "eventCreateRule." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateEventCreateRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest} UpdateEventCreateRuleRequest
                         */
                        UpdateEventCreateRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest();
                            if (object.eventCreateRule != null) {
                                if (typeof object.eventCreateRule !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest.eventCreateRule: object expected");
                                message.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.fromObject(object.eventCreateRule);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateEventCreateRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest} message UpdateEventCreateRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateEventCreateRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.eventCreateRule = null;
                                object.updateMask = null;
                            }
                            if (message.eventCreateRule != null && message.hasOwnProperty("eventCreateRule"))
                                object.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.toObject(message.eventCreateRule, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateEventCreateRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateEventCreateRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateEventCreateRuleRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateEventCreateRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UpdateEventCreateRuleRequest";
                        };
    
                        return UpdateEventCreateRuleRequest;
                    })();
    
                    v1alpha.DeleteEventCreateRuleRequest = (function() {
    
                        /**
                         * Properties of a DeleteEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDeleteEventCreateRuleRequest
                         * @property {string|null} [name] DeleteEventCreateRuleRequest name
                         */
    
                        /**
                         * Constructs a new DeleteEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DeleteEventCreateRuleRequest.
                         * @implements IDeleteEventCreateRuleRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDeleteEventCreateRuleRequest=} [properties] Properties to set
                         */
                        function DeleteEventCreateRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteEventCreateRuleRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @instance
                         */
                        DeleteEventCreateRuleRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteEventCreateRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteEventCreateRuleRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest} DeleteEventCreateRuleRequest instance
                         */
                        DeleteEventCreateRuleRequest.create = function create(properties) {
                            return new DeleteEventCreateRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteEventCreateRuleRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteEventCreateRuleRequest} message DeleteEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteEventCreateRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteEventCreateRuleRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDeleteEventCreateRuleRequest} message DeleteEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteEventCreateRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteEventCreateRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest} DeleteEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteEventCreateRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteEventCreateRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest} DeleteEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteEventCreateRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteEventCreateRuleRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteEventCreateRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteEventCreateRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest} DeleteEventCreateRuleRequest
                         */
                        DeleteEventCreateRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteEventCreateRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest} message DeleteEventCreateRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteEventCreateRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteEventCreateRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteEventCreateRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteEventCreateRuleRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteEventCreateRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DeleteEventCreateRuleRequest";
                        };
    
                        return DeleteEventCreateRuleRequest;
                    })();
    
                    v1alpha.GetEventCreateRuleRequest = (function() {
    
                        /**
                         * Properties of a GetEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGetEventCreateRuleRequest
                         * @property {string|null} [name] GetEventCreateRuleRequest name
                         */
    
                        /**
                         * Constructs a new GetEventCreateRuleRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GetEventCreateRuleRequest.
                         * @implements IGetEventCreateRuleRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGetEventCreateRuleRequest=} [properties] Properties to set
                         */
                        function GetEventCreateRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetEventCreateRuleRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @instance
                         */
                        GetEventCreateRuleRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetEventCreateRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetEventCreateRuleRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GetEventCreateRuleRequest} GetEventCreateRuleRequest instance
                         */
                        GetEventCreateRuleRequest.create = function create(properties) {
                            return new GetEventCreateRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetEventCreateRuleRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.GetEventCreateRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetEventCreateRuleRequest} message GetEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEventCreateRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetEventCreateRuleRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GetEventCreateRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGetEventCreateRuleRequest} message GetEventCreateRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEventCreateRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetEventCreateRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GetEventCreateRuleRequest} GetEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEventCreateRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GetEventCreateRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetEventCreateRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GetEventCreateRuleRequest} GetEventCreateRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEventCreateRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetEventCreateRuleRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetEventCreateRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetEventCreateRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GetEventCreateRuleRequest} GetEventCreateRuleRequest
                         */
                        GetEventCreateRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GetEventCreateRuleRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GetEventCreateRuleRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetEventCreateRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.GetEventCreateRuleRequest} message GetEventCreateRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetEventCreateRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetEventCreateRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetEventCreateRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetEventCreateRuleRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GetEventCreateRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetEventCreateRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GetEventCreateRuleRequest";
                        };
    
                        return GetEventCreateRuleRequest;
                    })();
    
                    v1alpha.ListEventCreateRulesRequest = (function() {
    
                        /**
                         * Properties of a ListEventCreateRulesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListEventCreateRulesRequest
                         * @property {string|null} [parent] ListEventCreateRulesRequest parent
                         * @property {number|null} [pageSize] ListEventCreateRulesRequest pageSize
                         * @property {string|null} [pageToken] ListEventCreateRulesRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListEventCreateRulesRequest.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListEventCreateRulesRequest.
                         * @implements IListEventCreateRulesRequest
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesRequest=} [properties] Properties to set
                         */
                        function ListEventCreateRulesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListEventCreateRulesRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @instance
                         */
                        ListEventCreateRulesRequest.prototype.parent = "";
    
                        /**
                         * ListEventCreateRulesRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @instance
                         */
                        ListEventCreateRulesRequest.prototype.pageSize = 0;
    
                        /**
                         * ListEventCreateRulesRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @instance
                         */
                        ListEventCreateRulesRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListEventCreateRulesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesRequest} ListEventCreateRulesRequest instance
                         */
                        ListEventCreateRulesRequest.create = function create(properties) {
                            return new ListEventCreateRulesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListEventCreateRulesRequest message. Does not implicitly {@link google.analytics.admin.v1alpha.ListEventCreateRulesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesRequest} message ListEventCreateRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListEventCreateRulesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListEventCreateRulesRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListEventCreateRulesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesRequest} message ListEventCreateRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListEventCreateRulesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListEventCreateRulesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesRequest} ListEventCreateRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListEventCreateRulesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListEventCreateRulesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListEventCreateRulesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesRequest} ListEventCreateRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListEventCreateRulesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListEventCreateRulesRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListEventCreateRulesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListEventCreateRulesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesRequest} ListEventCreateRulesRequest
                         */
                        ListEventCreateRulesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListEventCreateRulesRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListEventCreateRulesRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListEventCreateRulesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListEventCreateRulesRequest} message ListEventCreateRulesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListEventCreateRulesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListEventCreateRulesRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListEventCreateRulesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListEventCreateRulesRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListEventCreateRulesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListEventCreateRulesRequest";
                        };
    
                        return ListEventCreateRulesRequest;
                    })();
    
                    v1alpha.ListEventCreateRulesResponse = (function() {
    
                        /**
                         * Properties of a ListEventCreateRulesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IListEventCreateRulesResponse
                         * @property {Array.<google.analytics.admin.v1alpha.IEventCreateRule>|null} [eventCreateRules] ListEventCreateRulesResponse eventCreateRules
                         * @property {string|null} [nextPageToken] ListEventCreateRulesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListEventCreateRulesResponse.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ListEventCreateRulesResponse.
                         * @implements IListEventCreateRulesResponse
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesResponse=} [properties] Properties to set
                         */
                        function ListEventCreateRulesResponse(properties) {
                            this.eventCreateRules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListEventCreateRulesResponse eventCreateRules.
                         * @member {Array.<google.analytics.admin.v1alpha.IEventCreateRule>} eventCreateRules
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @instance
                         */
                        ListEventCreateRulesResponse.prototype.eventCreateRules = $util.emptyArray;
    
                        /**
                         * ListEventCreateRulesResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @instance
                         */
                        ListEventCreateRulesResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListEventCreateRulesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesResponse} ListEventCreateRulesResponse instance
                         */
                        ListEventCreateRulesResponse.create = function create(properties) {
                            return new ListEventCreateRulesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListEventCreateRulesResponse message. Does not implicitly {@link google.analytics.admin.v1alpha.ListEventCreateRulesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesResponse} message ListEventCreateRulesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListEventCreateRulesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.eventCreateRules != null && message.eventCreateRules.length)
                                for (var i = 0; i < message.eventCreateRules.length; ++i)
                                    $root.google.analytics.admin.v1alpha.EventCreateRule.encode(message.eventCreateRules[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListEventCreateRulesResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ListEventCreateRulesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.IListEventCreateRulesResponse} message ListEventCreateRulesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListEventCreateRulesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListEventCreateRulesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesResponse} ListEventCreateRulesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListEventCreateRulesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ListEventCreateRulesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.eventCreateRules && message.eventCreateRules.length))
                                            message.eventCreateRules = [];
                                        message.eventCreateRules.push($root.google.analytics.admin.v1alpha.EventCreateRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListEventCreateRulesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesResponse} ListEventCreateRulesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListEventCreateRulesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListEventCreateRulesResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListEventCreateRulesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.eventCreateRules != null && message.hasOwnProperty("eventCreateRules")) {
                                if (!Array.isArray(message.eventCreateRules))
                                    return "eventCreateRules: array expected";
                                for (var i = 0; i < message.eventCreateRules.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.EventCreateRule.verify(message.eventCreateRules[i]);
                                    if (error)
                                        return "eventCreateRules." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListEventCreateRulesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ListEventCreateRulesResponse} ListEventCreateRulesResponse
                         */
                        ListEventCreateRulesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ListEventCreateRulesResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ListEventCreateRulesResponse();
                            if (object.eventCreateRules) {
                                if (!Array.isArray(object.eventCreateRules))
                                    throw TypeError(".google.analytics.admin.v1alpha.ListEventCreateRulesResponse.eventCreateRules: array expected");
                                message.eventCreateRules = [];
                                for (var i = 0; i < object.eventCreateRules.length; ++i) {
                                    if (typeof object.eventCreateRules[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ListEventCreateRulesResponse.eventCreateRules: object expected");
                                    message.eventCreateRules[i] = $root.google.analytics.admin.v1alpha.EventCreateRule.fromObject(object.eventCreateRules[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListEventCreateRulesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {google.analytics.admin.v1alpha.ListEventCreateRulesResponse} message ListEventCreateRulesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListEventCreateRulesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.eventCreateRules = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.eventCreateRules && message.eventCreateRules.length) {
                                object.eventCreateRules = [];
                                for (var j = 0; j < message.eventCreateRules.length; ++j)
                                    object.eventCreateRules[j] = $root.google.analytics.admin.v1alpha.EventCreateRule.toObject(message.eventCreateRules[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListEventCreateRulesResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListEventCreateRulesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListEventCreateRulesResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ListEventCreateRulesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListEventCreateRulesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ListEventCreateRulesResponse";
                        };
    
                        return ListEventCreateRulesResponse;
                    })();
    
                    /**
                     * AudienceFilterScope enum.
                     * @name google.analytics.admin.v1alpha.AudienceFilterScope
                     * @enum {number}
                     * @property {number} AUDIENCE_FILTER_SCOPE_UNSPECIFIED=0 AUDIENCE_FILTER_SCOPE_UNSPECIFIED value
                     * @property {number} AUDIENCE_FILTER_SCOPE_WITHIN_SAME_EVENT=1 AUDIENCE_FILTER_SCOPE_WITHIN_SAME_EVENT value
                     * @property {number} AUDIENCE_FILTER_SCOPE_WITHIN_SAME_SESSION=2 AUDIENCE_FILTER_SCOPE_WITHIN_SAME_SESSION value
                     * @property {number} AUDIENCE_FILTER_SCOPE_ACROSS_ALL_SESSIONS=3 AUDIENCE_FILTER_SCOPE_ACROSS_ALL_SESSIONS value
                     */
                    v1alpha.AudienceFilterScope = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "AUDIENCE_FILTER_SCOPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_EVENT"] = 1;
                        values[valuesById[2] = "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_SESSION"] = 2;
                        values[valuesById[3] = "AUDIENCE_FILTER_SCOPE_ACROSS_ALL_SESSIONS"] = 3;
                        return values;
                    })();
    
                    v1alpha.AudienceDimensionOrMetricFilter = (function() {
    
                        /**
                         * Properties of an AudienceDimensionOrMetricFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceDimensionOrMetricFilter
                         * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IStringFilter|null} [stringFilter] AudienceDimensionOrMetricFilter stringFilter
                         * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IInListFilter|null} [inListFilter] AudienceDimensionOrMetricFilter inListFilter
                         * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericFilter|null} [numericFilter] AudienceDimensionOrMetricFilter numericFilter
                         * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IBetweenFilter|null} [betweenFilter] AudienceDimensionOrMetricFilter betweenFilter
                         * @property {string|null} [fieldName] AudienceDimensionOrMetricFilter fieldName
                         * @property {boolean|null} [atAnyPointInTime] AudienceDimensionOrMetricFilter atAnyPointInTime
                         * @property {number|null} [inAnyNDayPeriod] AudienceDimensionOrMetricFilter inAnyNDayPeriod
                         */
    
                        /**
                         * Constructs a new AudienceDimensionOrMetricFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceDimensionOrMetricFilter.
                         * @implements IAudienceDimensionOrMetricFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceDimensionOrMetricFilter=} [properties] Properties to set
                         */
                        function AudienceDimensionOrMetricFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceDimensionOrMetricFilter stringFilter.
                         * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IStringFilter|null|undefined} stringFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        AudienceDimensionOrMetricFilter.prototype.stringFilter = null;
    
                        /**
                         * AudienceDimensionOrMetricFilter inListFilter.
                         * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IInListFilter|null|undefined} inListFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        AudienceDimensionOrMetricFilter.prototype.inListFilter = null;
    
                        /**
                         * AudienceDimensionOrMetricFilter numericFilter.
                         * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericFilter|null|undefined} numericFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        AudienceDimensionOrMetricFilter.prototype.numericFilter = null;
    
                        /**
                         * AudienceDimensionOrMetricFilter betweenFilter.
                         * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IBetweenFilter|null|undefined} betweenFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        AudienceDimensionOrMetricFilter.prototype.betweenFilter = null;
    
                        /**
                         * AudienceDimensionOrMetricFilter fieldName.
                         * @member {string} fieldName
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        AudienceDimensionOrMetricFilter.prototype.fieldName = "";
    
                        /**
                         * AudienceDimensionOrMetricFilter atAnyPointInTime.
                         * @member {boolean} atAnyPointInTime
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        AudienceDimensionOrMetricFilter.prototype.atAnyPointInTime = false;
    
                        /**
                         * AudienceDimensionOrMetricFilter inAnyNDayPeriod.
                         * @member {number} inAnyNDayPeriod
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        AudienceDimensionOrMetricFilter.prototype.inAnyNDayPeriod = 0;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AudienceDimensionOrMetricFilter oneFilter.
                         * @member {"stringFilter"|"inListFilter"|"numericFilter"|"betweenFilter"|undefined} oneFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         */
                        Object.defineProperty(AudienceDimensionOrMetricFilter.prototype, "oneFilter", {
                            get: $util.oneOfGetter($oneOfFields = ["stringFilter", "inListFilter", "numericFilter", "betweenFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AudienceDimensionOrMetricFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceDimensionOrMetricFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter} AudienceDimensionOrMetricFilter instance
                         */
                        AudienceDimensionOrMetricFilter.create = function create(properties) {
                            return new AudienceDimensionOrMetricFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceDimensionOrMetricFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceDimensionOrMetricFilter} message AudienceDimensionOrMetricFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceDimensionOrMetricFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fieldName != null && Object.hasOwnProperty.call(message, "fieldName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fieldName);
                            if (message.stringFilter != null && Object.hasOwnProperty.call(message, "stringFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.encode(message.stringFilter, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.inListFilter != null && Object.hasOwnProperty.call(message, "inListFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.encode(message.inListFilter, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.numericFilter != null && Object.hasOwnProperty.call(message, "numericFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.encode(message.numericFilter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.betweenFilter != null && Object.hasOwnProperty.call(message, "betweenFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.encode(message.betweenFilter, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.atAnyPointInTime != null && Object.hasOwnProperty.call(message, "atAnyPointInTime"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.atAnyPointInTime);
                            if (message.inAnyNDayPeriod != null && Object.hasOwnProperty.call(message, "inAnyNDayPeriod"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.inAnyNDayPeriod);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceDimensionOrMetricFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceDimensionOrMetricFilter} message AudienceDimensionOrMetricFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceDimensionOrMetricFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceDimensionOrMetricFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter} AudienceDimensionOrMetricFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceDimensionOrMetricFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2: {
                                        message.stringFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.inListFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.numericFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.betweenFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.fieldName = reader.string();
                                        break;
                                    }
                                case 6: {
                                        message.atAnyPointInTime = reader.bool();
                                        break;
                                    }
                                case 7: {
                                        message.inAnyNDayPeriod = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceDimensionOrMetricFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter} AudienceDimensionOrMetricFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceDimensionOrMetricFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceDimensionOrMetricFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceDimensionOrMetricFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.verify(message.stringFilter);
                                    if (error)
                                        return "stringFilter." + error;
                                }
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.verify(message.inListFilter);
                                    if (error)
                                        return "inListFilter." + error;
                                }
                            }
                            if (message.numericFilter != null && message.hasOwnProperty("numericFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.verify(message.numericFilter);
                                    if (error)
                                        return "numericFilter." + error;
                                }
                            }
                            if (message.betweenFilter != null && message.hasOwnProperty("betweenFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.verify(message.betweenFilter);
                                    if (error)
                                        return "betweenFilter." + error;
                                }
                            }
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                if (!$util.isString(message.fieldName))
                                    return "fieldName: string expected";
                            if (message.atAnyPointInTime != null && message.hasOwnProperty("atAnyPointInTime"))
                                if (typeof message.atAnyPointInTime !== "boolean")
                                    return "atAnyPointInTime: boolean expected";
                            if (message.inAnyNDayPeriod != null && message.hasOwnProperty("inAnyNDayPeriod"))
                                if (!$util.isInteger(message.inAnyNDayPeriod))
                                    return "inAnyNDayPeriod: integer expected";
                            return null;
                        };
    
                        /**
                         * Creates an AudienceDimensionOrMetricFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter} AudienceDimensionOrMetricFilter
                         */
                        AudienceDimensionOrMetricFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter();
                            if (object.stringFilter != null) {
                                if (typeof object.stringFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.stringFilter: object expected");
                                message.stringFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.fromObject(object.stringFilter);
                            }
                            if (object.inListFilter != null) {
                                if (typeof object.inListFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.inListFilter: object expected");
                                message.inListFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.fromObject(object.inListFilter);
                            }
                            if (object.numericFilter != null) {
                                if (typeof object.numericFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.numericFilter: object expected");
                                message.numericFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.fromObject(object.numericFilter);
                            }
                            if (object.betweenFilter != null) {
                                if (typeof object.betweenFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.betweenFilter: object expected");
                                message.betweenFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.fromObject(object.betweenFilter);
                            }
                            if (object.fieldName != null)
                                message.fieldName = String(object.fieldName);
                            if (object.atAnyPointInTime != null)
                                message.atAnyPointInTime = Boolean(object.atAnyPointInTime);
                            if (object.inAnyNDayPeriod != null)
                                message.inAnyNDayPeriod = object.inAnyNDayPeriod | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceDimensionOrMetricFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter} message AudienceDimensionOrMetricFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceDimensionOrMetricFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.fieldName = "";
                                object.atAnyPointInTime = false;
                                object.inAnyNDayPeriod = 0;
                            }
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                object.fieldName = message.fieldName;
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                object.stringFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.toObject(message.stringFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "stringFilter";
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                object.inListFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.toObject(message.inListFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "inListFilter";
                            }
                            if (message.numericFilter != null && message.hasOwnProperty("numericFilter")) {
                                object.numericFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.toObject(message.numericFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "numericFilter";
                            }
                            if (message.betweenFilter != null && message.hasOwnProperty("betweenFilter")) {
                                object.betweenFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.toObject(message.betweenFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "betweenFilter";
                            }
                            if (message.atAnyPointInTime != null && message.hasOwnProperty("atAnyPointInTime"))
                                object.atAnyPointInTime = message.atAnyPointInTime;
                            if (message.inAnyNDayPeriod != null && message.hasOwnProperty("inAnyNDayPeriod"))
                                object.inAnyNDayPeriod = message.inAnyNDayPeriod;
                            return object;
                        };
    
                        /**
                         * Converts this AudienceDimensionOrMetricFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceDimensionOrMetricFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceDimensionOrMetricFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceDimensionOrMetricFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter";
                        };
    
                        AudienceDimensionOrMetricFilter.StringFilter = (function() {
    
                            /**
                             * Properties of a StringFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @interface IStringFilter
                             * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.MatchType|null} [matchType] StringFilter matchType
                             * @property {string|null} [value] StringFilter value
                             * @property {boolean|null} [caseSensitive] StringFilter caseSensitive
                             */
    
                            /**
                             * Constructs a new StringFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @classdesc Represents a StringFilter.
                             * @implements IStringFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IStringFilter=} [properties] Properties to set
                             */
                            function StringFilter(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * StringFilter matchType.
                             * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.MatchType} matchType
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.matchType = 0;
    
                            /**
                             * StringFilter value.
                             * @member {string} value
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.value = "";
    
                            /**
                             * StringFilter caseSensitive.
                             * @member {boolean} caseSensitive
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.caseSensitive = false;
    
                            /**
                             * Creates a new StringFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IStringFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter} StringFilter instance
                             */
                            StringFilter.create = function create(properties) {
                                return new StringFilter(properties);
                            };
    
                            /**
                             * Encodes the specified StringFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IStringFilter} message StringFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            StringFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.matchType != null && Object.hasOwnProperty.call(message, "matchType"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.matchType);
                                if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.value);
                                if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                    writer.uint32(/* id 3, wireType 0 =*/24).bool(message.caseSensitive);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified StringFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IStringFilter} message StringFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            StringFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a StringFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter} StringFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            StringFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.matchType = reader.int32();
                                            break;
                                        }
                                    case 2: {
                                            message.value = reader.string();
                                            break;
                                        }
                                    case 3: {
                                            message.caseSensitive = reader.bool();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a StringFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter} StringFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            StringFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a StringFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            StringFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    switch (message.matchType) {
                                    default:
                                        return "matchType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                        break;
                                    }
                                if (message.value != null && message.hasOwnProperty("value"))
                                    if (!$util.isString(message.value))
                                        return "value: string expected";
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    if (typeof message.caseSensitive !== "boolean")
                                        return "caseSensitive: boolean expected";
                                return null;
                            };
    
                            /**
                             * Creates a StringFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter} StringFilter
                             */
                            StringFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter();
                                switch (object.matchType) {
                                default:
                                    if (typeof object.matchType === "number") {
                                        message.matchType = object.matchType;
                                        break;
                                    }
                                    break;
                                case "MATCH_TYPE_UNSPECIFIED":
                                case 0:
                                    message.matchType = 0;
                                    break;
                                case "EXACT":
                                case 1:
                                    message.matchType = 1;
                                    break;
                                case "BEGINS_WITH":
                                case 2:
                                    message.matchType = 2;
                                    break;
                                case "ENDS_WITH":
                                case 3:
                                    message.matchType = 3;
                                    break;
                                case "CONTAINS":
                                case 4:
                                    message.matchType = 4;
                                    break;
                                case "FULL_REGEXP":
                                case 5:
                                    message.matchType = 5;
                                    break;
                                }
                                if (object.value != null)
                                    message.value = String(object.value);
                                if (object.caseSensitive != null)
                                    message.caseSensitive = Boolean(object.caseSensitive);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a StringFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter} message StringFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            StringFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.matchType = options.enums === String ? "MATCH_TYPE_UNSPECIFIED" : 0;
                                    object.value = "";
                                    object.caseSensitive = false;
                                }
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    object.matchType = options.enums === String ? $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.MatchType[message.matchType] === undefined ? message.matchType : $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.MatchType[message.matchType] : message.matchType;
                                if (message.value != null && message.hasOwnProperty("value"))
                                    object.value = message.value;
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    object.caseSensitive = message.caseSensitive;
                                return object;
                            };
    
                            /**
                             * Converts this StringFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            StringFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for StringFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            StringFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter";
                            };
    
                            /**
                             * MatchType enum.
                             * @name google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.StringFilter.MatchType
                             * @enum {number}
                             * @property {number} MATCH_TYPE_UNSPECIFIED=0 MATCH_TYPE_UNSPECIFIED value
                             * @property {number} EXACT=1 EXACT value
                             * @property {number} BEGINS_WITH=2 BEGINS_WITH value
                             * @property {number} ENDS_WITH=3 ENDS_WITH value
                             * @property {number} CONTAINS=4 CONTAINS value
                             * @property {number} FULL_REGEXP=5 FULL_REGEXP value
                             */
                            StringFilter.MatchType = (function() {
                                var valuesById = {}, values = Object.create(valuesById);
                                values[valuesById[0] = "MATCH_TYPE_UNSPECIFIED"] = 0;
                                values[valuesById[1] = "EXACT"] = 1;
                                values[valuesById[2] = "BEGINS_WITH"] = 2;
                                values[valuesById[3] = "ENDS_WITH"] = 3;
                                values[valuesById[4] = "CONTAINS"] = 4;
                                values[valuesById[5] = "FULL_REGEXP"] = 5;
                                return values;
                            })();
    
                            return StringFilter;
                        })();
    
                        AudienceDimensionOrMetricFilter.InListFilter = (function() {
    
                            /**
                             * Properties of an InListFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @interface IInListFilter
                             * @property {Array.<string>|null} [values] InListFilter values
                             * @property {boolean|null} [caseSensitive] InListFilter caseSensitive
                             */
    
                            /**
                             * Constructs a new InListFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @classdesc Represents an InListFilter.
                             * @implements IInListFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IInListFilter=} [properties] Properties to set
                             */
                            function InListFilter(properties) {
                                this.values = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * InListFilter values.
                             * @member {Array.<string>} values
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @instance
                             */
                            InListFilter.prototype.values = $util.emptyArray;
    
                            /**
                             * InListFilter caseSensitive.
                             * @member {boolean} caseSensitive
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @instance
                             */
                            InListFilter.prototype.caseSensitive = false;
    
                            /**
                             * Creates a new InListFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IInListFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter} InListFilter instance
                             */
                            InListFilter.create = function create(properties) {
                                return new InListFilter(properties);
                            };
    
                            /**
                             * Encodes the specified InListFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IInListFilter} message InListFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            InListFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.values != null && message.values.length)
                                    for (var i = 0; i < message.values.length; ++i)
                                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.values[i]);
                                if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).bool(message.caseSensitive);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified InListFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IInListFilter} message InListFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            InListFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an InListFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter} InListFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            InListFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            if (!(message.values && message.values.length))
                                                message.values = [];
                                            message.values.push(reader.string());
                                            break;
                                        }
                                    case 2: {
                                            message.caseSensitive = reader.bool();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an InListFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter} InListFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            InListFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an InListFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            InListFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.values != null && message.hasOwnProperty("values")) {
                                    if (!Array.isArray(message.values))
                                        return "values: array expected";
                                    for (var i = 0; i < message.values.length; ++i)
                                        if (!$util.isString(message.values[i]))
                                            return "values: string[] expected";
                                }
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    if (typeof message.caseSensitive !== "boolean")
                                        return "caseSensitive: boolean expected";
                                return null;
                            };
    
                            /**
                             * Creates an InListFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter} InListFilter
                             */
                            InListFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter();
                                if (object.values) {
                                    if (!Array.isArray(object.values))
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter.values: array expected");
                                    message.values = [];
                                    for (var i = 0; i < object.values.length; ++i)
                                        message.values[i] = String(object.values[i]);
                                }
                                if (object.caseSensitive != null)
                                    message.caseSensitive = Boolean(object.caseSensitive);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an InListFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter} message InListFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            InListFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.values = [];
                                if (options.defaults)
                                    object.caseSensitive = false;
                                if (message.values && message.values.length) {
                                    object.values = [];
                                    for (var j = 0; j < message.values.length; ++j)
                                        object.values[j] = message.values[j];
                                }
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    object.caseSensitive = message.caseSensitive;
                                return object;
                            };
    
                            /**
                             * Converts this InListFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            InListFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for InListFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            InListFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.InListFilter";
                            };
    
                            return InListFilter;
                        })();
    
                        AudienceDimensionOrMetricFilter.NumericValue = (function() {
    
                            /**
                             * Properties of a NumericValue.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @interface INumericValue
                             * @property {number|Long|null} [int64Value] NumericValue int64Value
                             * @property {number|null} [doubleValue] NumericValue doubleValue
                             */
    
                            /**
                             * Constructs a new NumericValue.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @classdesc Represents a NumericValue.
                             * @implements INumericValue
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue=} [properties] Properties to set
                             */
                            function NumericValue(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * NumericValue int64Value.
                             * @member {number|Long|null|undefined} int64Value
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @instance
                             */
                            NumericValue.prototype.int64Value = null;
    
                            /**
                             * NumericValue doubleValue.
                             * @member {number|null|undefined} doubleValue
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @instance
                             */
                            NumericValue.prototype.doubleValue = null;
    
                            // OneOf field names bound to virtual getters and setters
                            var $oneOfFields;
    
                            /**
                             * NumericValue oneValue.
                             * @member {"int64Value"|"doubleValue"|undefined} oneValue
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @instance
                             */
                            Object.defineProperty(NumericValue.prototype, "oneValue", {
                                get: $util.oneOfGetter($oneOfFields = ["int64Value", "doubleValue"]),
                                set: $util.oneOfSetter($oneOfFields)
                            });
    
                            /**
                             * Creates a new NumericValue instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue} NumericValue instance
                             */
                            NumericValue.create = function create(properties) {
                                return new NumericValue(properties);
                            };
    
                            /**
                             * Encodes the specified NumericValue message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue} message NumericValue message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            NumericValue.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.int64Value != null && Object.hasOwnProperty.call(message, "int64Value"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int64(message.int64Value);
                                if (message.doubleValue != null && Object.hasOwnProperty.call(message, "doubleValue"))
                                    writer.uint32(/* id 2, wireType 1 =*/17).double(message.doubleValue);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified NumericValue message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue} message NumericValue message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            NumericValue.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a NumericValue message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue} NumericValue
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            NumericValue.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.int64Value = reader.int64();
                                            break;
                                        }
                                    case 2: {
                                            message.doubleValue = reader.double();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a NumericValue message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue} NumericValue
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            NumericValue.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a NumericValue message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            NumericValue.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                var properties = {};
                                if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                    properties.oneValue = 1;
                                    if (!$util.isInteger(message.int64Value) && !(message.int64Value && $util.isInteger(message.int64Value.low) && $util.isInteger(message.int64Value.high)))
                                        return "int64Value: integer|Long expected";
                                }
                                if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                    if (properties.oneValue === 1)
                                        return "oneValue: multiple values";
                                    properties.oneValue = 1;
                                    if (typeof message.doubleValue !== "number")
                                        return "doubleValue: number expected";
                                }
                                return null;
                            };
    
                            /**
                             * Creates a NumericValue message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue} NumericValue
                             */
                            NumericValue.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue();
                                if (object.int64Value != null)
                                    if ($util.Long)
                                        (message.int64Value = $util.Long.fromValue(object.int64Value)).unsigned = false;
                                    else if (typeof object.int64Value === "string")
                                        message.int64Value = parseInt(object.int64Value, 10);
                                    else if (typeof object.int64Value === "number")
                                        message.int64Value = object.int64Value;
                                    else if (typeof object.int64Value === "object")
                                        message.int64Value = new $util.LongBits(object.int64Value.low >>> 0, object.int64Value.high >>> 0).toNumber();
                                if (object.doubleValue != null)
                                    message.doubleValue = Number(object.doubleValue);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a NumericValue message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue} message NumericValue
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            NumericValue.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                    if (typeof message.int64Value === "number")
                                        object.int64Value = options.longs === String ? String(message.int64Value) : message.int64Value;
                                    else
                                        object.int64Value = options.longs === String ? $util.Long.prototype.toString.call(message.int64Value) : options.longs === Number ? new $util.LongBits(message.int64Value.low >>> 0, message.int64Value.high >>> 0).toNumber() : message.int64Value;
                                    if (options.oneofs)
                                        object.oneValue = "int64Value";
                                }
                                if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                    object.doubleValue = options.json && !isFinite(message.doubleValue) ? String(message.doubleValue) : message.doubleValue;
                                    if (options.oneofs)
                                        object.oneValue = "doubleValue";
                                }
                                return object;
                            };
    
                            /**
                             * Converts this NumericValue to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            NumericValue.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for NumericValue
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            NumericValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue";
                            };
    
                            return NumericValue;
                        })();
    
                        AudienceDimensionOrMetricFilter.NumericFilter = (function() {
    
                            /**
                             * Properties of a NumericFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @interface INumericFilter
                             * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.Operation|null} [operation] NumericFilter operation
                             * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue|null} [value] NumericFilter value
                             */
    
                            /**
                             * Constructs a new NumericFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @classdesc Represents a NumericFilter.
                             * @implements INumericFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericFilter=} [properties] Properties to set
                             */
                            function NumericFilter(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * NumericFilter operation.
                             * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.Operation} operation
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @instance
                             */
                            NumericFilter.prototype.operation = 0;
    
                            /**
                             * NumericFilter value.
                             * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue|null|undefined} value
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @instance
                             */
                            NumericFilter.prototype.value = null;
    
                            /**
                             * Creates a new NumericFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter} NumericFilter instance
                             */
                            NumericFilter.create = function create(properties) {
                                return new NumericFilter(properties);
                            };
    
                            /**
                             * Encodes the specified NumericFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericFilter} message NumericFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            NumericFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operation);
                                if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                    $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };
    
                            /**
                             * Encodes the specified NumericFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericFilter} message NumericFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            NumericFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a NumericFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter} NumericFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            NumericFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.operation = reader.int32();
                                            break;
                                        }
                                    case 2: {
                                            message.value = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.decode(reader, reader.uint32());
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a NumericFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter} NumericFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            NumericFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a NumericFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            NumericFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.operation != null && message.hasOwnProperty("operation"))
                                    switch (message.operation) {
                                    default:
                                        return "operation: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 4:
                                        break;
                                    }
                                if (message.value != null && message.hasOwnProperty("value")) {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.verify(message.value);
                                    if (error)
                                        return "value." + error;
                                }
                                return null;
                            };
    
                            /**
                             * Creates a NumericFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter} NumericFilter
                             */
                            NumericFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter();
                                switch (object.operation) {
                                default:
                                    if (typeof object.operation === "number") {
                                        message.operation = object.operation;
                                        break;
                                    }
                                    break;
                                case "OPERATION_UNSPECIFIED":
                                case 0:
                                    message.operation = 0;
                                    break;
                                case "EQUAL":
                                case 1:
                                    message.operation = 1;
                                    break;
                                case "LESS_THAN":
                                case 2:
                                    message.operation = 2;
                                    break;
                                case "GREATER_THAN":
                                case 4:
                                    message.operation = 4;
                                    break;
                                }
                                if (object.value != null) {
                                    if (typeof object.value !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.value: object expected");
                                    message.value = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.fromObject(object.value);
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a NumericFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter} message NumericFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            NumericFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.operation = options.enums === String ? "OPERATION_UNSPECIFIED" : 0;
                                    object.value = null;
                                }
                                if (message.operation != null && message.hasOwnProperty("operation"))
                                    object.operation = options.enums === String ? $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.Operation[message.operation] === undefined ? message.operation : $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.Operation[message.operation] : message.operation;
                                if (message.value != null && message.hasOwnProperty("value"))
                                    object.value = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.toObject(message.value, options);
                                return object;
                            };
    
                            /**
                             * Converts this NumericFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            NumericFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for NumericFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            NumericFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter";
                            };
    
                            /**
                             * Operation enum.
                             * @name google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericFilter.Operation
                             * @enum {number}
                             * @property {number} OPERATION_UNSPECIFIED=0 OPERATION_UNSPECIFIED value
                             * @property {number} EQUAL=1 EQUAL value
                             * @property {number} LESS_THAN=2 LESS_THAN value
                             * @property {number} GREATER_THAN=4 GREATER_THAN value
                             */
                            NumericFilter.Operation = (function() {
                                var valuesById = {}, values = Object.create(valuesById);
                                values[valuesById[0] = "OPERATION_UNSPECIFIED"] = 0;
                                values[valuesById[1] = "EQUAL"] = 1;
                                values[valuesById[2] = "LESS_THAN"] = 2;
                                values[valuesById[4] = "GREATER_THAN"] = 4;
                                return values;
                            })();
    
                            return NumericFilter;
                        })();
    
                        AudienceDimensionOrMetricFilter.BetweenFilter = (function() {
    
                            /**
                             * Properties of a BetweenFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @interface IBetweenFilter
                             * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue|null} [fromValue] BetweenFilter fromValue
                             * @property {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue|null} [toValue] BetweenFilter toValue
                             */
    
                            /**
                             * Constructs a new BetweenFilter.
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter
                             * @classdesc Represents a BetweenFilter.
                             * @implements IBetweenFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IBetweenFilter=} [properties] Properties to set
                             */
                            function BetweenFilter(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * BetweenFilter fromValue.
                             * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue|null|undefined} fromValue
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @instance
                             */
                            BetweenFilter.prototype.fromValue = null;
    
                            /**
                             * BetweenFilter toValue.
                             * @member {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.INumericValue|null|undefined} toValue
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @instance
                             */
                            BetweenFilter.prototype.toValue = null;
    
                            /**
                             * Creates a new BetweenFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IBetweenFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter} BetweenFilter instance
                             */
                            BetweenFilter.create = function create(properties) {
                                return new BetweenFilter(properties);
                            };
    
                            /**
                             * Encodes the specified BetweenFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IBetweenFilter} message BetweenFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            BetweenFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.fromValue != null && Object.hasOwnProperty.call(message, "fromValue"))
                                    $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.encode(message.fromValue, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.toValue != null && Object.hasOwnProperty.call(message, "toValue"))
                                    $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.encode(message.toValue, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                return writer;
                            };
    
                            /**
                             * Encodes the specified BetweenFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.IBetweenFilter} message BetweenFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            BetweenFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a BetweenFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter} BetweenFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            BetweenFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.fromValue = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 2: {
                                            message.toValue = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.decode(reader, reader.uint32());
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a BetweenFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter} BetweenFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            BetweenFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a BetweenFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            BetweenFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.fromValue != null && message.hasOwnProperty("fromValue")) {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.verify(message.fromValue);
                                    if (error)
                                        return "fromValue." + error;
                                }
                                if (message.toValue != null && message.hasOwnProperty("toValue")) {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.verify(message.toValue);
                                    if (error)
                                        return "toValue." + error;
                                }
                                return null;
                            };
    
                            /**
                             * Creates a BetweenFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter} BetweenFilter
                             */
                            BetweenFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter();
                                if (object.fromValue != null) {
                                    if (typeof object.fromValue !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.fromValue: object expected");
                                    message.fromValue = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.fromObject(object.fromValue);
                                }
                                if (object.toValue != null) {
                                    if (typeof object.toValue !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter.toValue: object expected");
                                    message.toValue = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.fromObject(object.toValue);
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a BetweenFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter} message BetweenFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            BetweenFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.fromValue = null;
                                    object.toValue = null;
                                }
                                if (message.fromValue != null && message.hasOwnProperty("fromValue"))
                                    object.fromValue = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.toObject(message.fromValue, options);
                                if (message.toValue != null && message.hasOwnProperty("toValue"))
                                    object.toValue = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.NumericValue.toObject(message.toValue, options);
                                return object;
                            };
    
                            /**
                             * Converts this BetweenFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            BetweenFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for BetweenFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            BetweenFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.BetweenFilter";
                            };
    
                            return BetweenFilter;
                        })();
    
                        return AudienceDimensionOrMetricFilter;
                    })();
    
                    v1alpha.AudienceEventFilter = (function() {
    
                        /**
                         * Properties of an AudienceEventFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceEventFilter
                         * @property {string|null} [eventName] AudienceEventFilter eventName
                         * @property {google.analytics.admin.v1alpha.IAudienceFilterExpression|null} [eventParameterFilterExpression] AudienceEventFilter eventParameterFilterExpression
                         */
    
                        /**
                         * Constructs a new AudienceEventFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceEventFilter.
                         * @implements IAudienceEventFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceEventFilter=} [properties] Properties to set
                         */
                        function AudienceEventFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceEventFilter eventName.
                         * @member {string} eventName
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @instance
                         */
                        AudienceEventFilter.prototype.eventName = "";
    
                        /**
                         * AudienceEventFilter eventParameterFilterExpression.
                         * @member {google.analytics.admin.v1alpha.IAudienceFilterExpression|null|undefined} eventParameterFilterExpression
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @instance
                         */
                        AudienceEventFilter.prototype.eventParameterFilterExpression = null;
    
                        /**
                         * Creates a new AudienceEventFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceEventFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceEventFilter} AudienceEventFilter instance
                         */
                        AudienceEventFilter.create = function create(properties) {
                            return new AudienceEventFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceEventFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceEventFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceEventFilter} message AudienceEventFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceEventFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.eventName != null && Object.hasOwnProperty.call(message, "eventName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.eventName);
                            if (message.eventParameterFilterExpression != null && Object.hasOwnProperty.call(message, "eventParameterFilterExpression"))
                                $root.google.analytics.admin.v1alpha.AudienceFilterExpression.encode(message.eventParameterFilterExpression, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceEventFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceEventFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceEventFilter} message AudienceEventFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceEventFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceEventFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceEventFilter} AudienceEventFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceEventFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceEventFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.eventName = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.eventParameterFilterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceEventFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceEventFilter} AudienceEventFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceEventFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceEventFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceEventFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                if (!$util.isString(message.eventName))
                                    return "eventName: string expected";
                            if (message.eventParameterFilterExpression != null && message.hasOwnProperty("eventParameterFilterExpression")) {
                                var error = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.verify(message.eventParameterFilterExpression);
                                if (error)
                                    return "eventParameterFilterExpression." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AudienceEventFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceEventFilter} AudienceEventFilter
                         */
                        AudienceEventFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceEventFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceEventFilter();
                            if (object.eventName != null)
                                message.eventName = String(object.eventName);
                            if (object.eventParameterFilterExpression != null) {
                                if (typeof object.eventParameterFilterExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceEventFilter.eventParameterFilterExpression: object expected");
                                message.eventParameterFilterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.fromObject(object.eventParameterFilterExpression);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceEventFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceEventFilter} message AudienceEventFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceEventFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.eventName = "";
                                object.eventParameterFilterExpression = null;
                            }
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                object.eventName = message.eventName;
                            if (message.eventParameterFilterExpression != null && message.hasOwnProperty("eventParameterFilterExpression"))
                                object.eventParameterFilterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.toObject(message.eventParameterFilterExpression, options);
                            return object;
                        };
    
                        /**
                         * Converts this AudienceEventFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceEventFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceEventFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceEventFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceEventFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceEventFilter";
                        };
    
                        return AudienceEventFilter;
                    })();
    
                    v1alpha.AudienceFilterExpression = (function() {
    
                        /**
                         * Properties of an AudienceFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceFilterExpression
                         * @property {google.analytics.admin.v1alpha.IAudienceFilterExpressionList|null} [andGroup] AudienceFilterExpression andGroup
                         * @property {google.analytics.admin.v1alpha.IAudienceFilterExpressionList|null} [orGroup] AudienceFilterExpression orGroup
                         * @property {google.analytics.admin.v1alpha.IAudienceFilterExpression|null} [notExpression] AudienceFilterExpression notExpression
                         * @property {google.analytics.admin.v1alpha.IAudienceDimensionOrMetricFilter|null} [dimensionOrMetricFilter] AudienceFilterExpression dimensionOrMetricFilter
                         * @property {google.analytics.admin.v1alpha.IAudienceEventFilter|null} [eventFilter] AudienceFilterExpression eventFilter
                         */
    
                        /**
                         * Constructs a new AudienceFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceFilterExpression.
                         * @implements IAudienceFilterExpression
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpression=} [properties] Properties to set
                         */
                        function AudienceFilterExpression(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceFilterExpression andGroup.
                         * @member {google.analytics.admin.v1alpha.IAudienceFilterExpressionList|null|undefined} andGroup
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @instance
                         */
                        AudienceFilterExpression.prototype.andGroup = null;
    
                        /**
                         * AudienceFilterExpression orGroup.
                         * @member {google.analytics.admin.v1alpha.IAudienceFilterExpressionList|null|undefined} orGroup
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @instance
                         */
                        AudienceFilterExpression.prototype.orGroup = null;
    
                        /**
                         * AudienceFilterExpression notExpression.
                         * @member {google.analytics.admin.v1alpha.IAudienceFilterExpression|null|undefined} notExpression
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @instance
                         */
                        AudienceFilterExpression.prototype.notExpression = null;
    
                        /**
                         * AudienceFilterExpression dimensionOrMetricFilter.
                         * @member {google.analytics.admin.v1alpha.IAudienceDimensionOrMetricFilter|null|undefined} dimensionOrMetricFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @instance
                         */
                        AudienceFilterExpression.prototype.dimensionOrMetricFilter = null;
    
                        /**
                         * AudienceFilterExpression eventFilter.
                         * @member {google.analytics.admin.v1alpha.IAudienceEventFilter|null|undefined} eventFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @instance
                         */
                        AudienceFilterExpression.prototype.eventFilter = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AudienceFilterExpression expr.
                         * @member {"andGroup"|"orGroup"|"notExpression"|"dimensionOrMetricFilter"|"eventFilter"|undefined} expr
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @instance
                         */
                        Object.defineProperty(AudienceFilterExpression.prototype, "expr", {
                            get: $util.oneOfGetter($oneOfFields = ["andGroup", "orGroup", "notExpression", "dimensionOrMetricFilter", "eventFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AudienceFilterExpression instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpression=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpression} AudienceFilterExpression instance
                         */
                        AudienceFilterExpression.create = function create(properties) {
                            return new AudienceFilterExpression(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceFilterExpression message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceFilterExpression.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpression} message AudienceFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceFilterExpression.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.andGroup != null && Object.hasOwnProperty.call(message, "andGroup"))
                                $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.encode(message.andGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.orGroup != null && Object.hasOwnProperty.call(message, "orGroup"))
                                $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.encode(message.orGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.notExpression != null && Object.hasOwnProperty.call(message, "notExpression"))
                                $root.google.analytics.admin.v1alpha.AudienceFilterExpression.encode(message.notExpression, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.dimensionOrMetricFilter != null && Object.hasOwnProperty.call(message, "dimensionOrMetricFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.encode(message.dimensionOrMetricFilter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.eventFilter != null && Object.hasOwnProperty.call(message, "eventFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceEventFilter.encode(message.eventFilter, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceFilterExpression message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceFilterExpression.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpression} message AudienceFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceFilterExpression.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceFilterExpression message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpression} AudienceFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceFilterExpression.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceFilterExpression();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.andGroup = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.orGroup = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.notExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.dimensionOrMetricFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.eventFilter = $root.google.analytics.admin.v1alpha.AudienceEventFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceFilterExpression message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpression} AudienceFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceFilterExpression.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceFilterExpression message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceFilterExpression.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.verify(message.andGroup);
                                    if (error)
                                        return "andGroup." + error;
                                }
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.verify(message.orGroup);
                                    if (error)
                                        return "orGroup." + error;
                                }
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.verify(message.notExpression);
                                    if (error)
                                        return "notExpression." + error;
                                }
                            }
                            if (message.dimensionOrMetricFilter != null && message.hasOwnProperty("dimensionOrMetricFilter")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.verify(message.dimensionOrMetricFilter);
                                    if (error)
                                        return "dimensionOrMetricFilter." + error;
                                }
                            }
                            if (message.eventFilter != null && message.hasOwnProperty("eventFilter")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceEventFilter.verify(message.eventFilter);
                                    if (error)
                                        return "eventFilter." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AudienceFilterExpression message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpression} AudienceFilterExpression
                         */
                        AudienceFilterExpression.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceFilterExpression)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceFilterExpression();
                            if (object.andGroup != null) {
                                if (typeof object.andGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterExpression.andGroup: object expected");
                                message.andGroup = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.fromObject(object.andGroup);
                            }
                            if (object.orGroup != null) {
                                if (typeof object.orGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterExpression.orGroup: object expected");
                                message.orGroup = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.fromObject(object.orGroup);
                            }
                            if (object.notExpression != null) {
                                if (typeof object.notExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterExpression.notExpression: object expected");
                                message.notExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.fromObject(object.notExpression);
                            }
                            if (object.dimensionOrMetricFilter != null) {
                                if (typeof object.dimensionOrMetricFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterExpression.dimensionOrMetricFilter: object expected");
                                message.dimensionOrMetricFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.fromObject(object.dimensionOrMetricFilter);
                            }
                            if (object.eventFilter != null) {
                                if (typeof object.eventFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterExpression.eventFilter: object expected");
                                message.eventFilter = $root.google.analytics.admin.v1alpha.AudienceEventFilter.fromObject(object.eventFilter);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceFilterExpression message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceFilterExpression} message AudienceFilterExpression
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceFilterExpression.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                object.andGroup = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.toObject(message.andGroup, options);
                                if (options.oneofs)
                                    object.expr = "andGroup";
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                object.orGroup = $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList.toObject(message.orGroup, options);
                                if (options.oneofs)
                                    object.expr = "orGroup";
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                object.notExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.toObject(message.notExpression, options);
                                if (options.oneofs)
                                    object.expr = "notExpression";
                            }
                            if (message.dimensionOrMetricFilter != null && message.hasOwnProperty("dimensionOrMetricFilter")) {
                                object.dimensionOrMetricFilter = $root.google.analytics.admin.v1alpha.AudienceDimensionOrMetricFilter.toObject(message.dimensionOrMetricFilter, options);
                                if (options.oneofs)
                                    object.expr = "dimensionOrMetricFilter";
                            }
                            if (message.eventFilter != null && message.hasOwnProperty("eventFilter")) {
                                object.eventFilter = $root.google.analytics.admin.v1alpha.AudienceEventFilter.toObject(message.eventFilter, options);
                                if (options.oneofs)
                                    object.expr = "eventFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AudienceFilterExpression to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceFilterExpression.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceFilterExpression
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpression
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceFilterExpression.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceFilterExpression";
                        };
    
                        return AudienceFilterExpression;
                    })();
    
                    v1alpha.AudienceFilterExpressionList = (function() {
    
                        /**
                         * Properties of an AudienceFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceFilterExpressionList
                         * @property {Array.<google.analytics.admin.v1alpha.IAudienceFilterExpression>|null} [filterExpressions] AudienceFilterExpressionList filterExpressions
                         */
    
                        /**
                         * Constructs a new AudienceFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceFilterExpressionList.
                         * @implements IAudienceFilterExpressionList
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpressionList=} [properties] Properties to set
                         */
                        function AudienceFilterExpressionList(properties) {
                            this.filterExpressions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceFilterExpressionList filterExpressions.
                         * @member {Array.<google.analytics.admin.v1alpha.IAudienceFilterExpression>} filterExpressions
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @instance
                         */
                        AudienceFilterExpressionList.prototype.filterExpressions = $util.emptyArray;
    
                        /**
                         * Creates a new AudienceFilterExpressionList instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpressionList=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpressionList} AudienceFilterExpressionList instance
                         */
                        AudienceFilterExpressionList.create = function create(properties) {
                            return new AudienceFilterExpressionList(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceFilterExpressionList message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceFilterExpressionList.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpressionList} message AudienceFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceFilterExpressionList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.filterExpressions != null && message.filterExpressions.length)
                                for (var i = 0; i < message.filterExpressions.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AudienceFilterExpression.encode(message.filterExpressions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceFilterExpressionList message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceFilterExpressionList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterExpressionList} message AudienceFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceFilterExpressionList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceFilterExpressionList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpressionList} AudienceFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceFilterExpressionList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.filterExpressions && message.filterExpressions.length))
                                            message.filterExpressions = [];
                                        message.filterExpressions.push($root.google.analytics.admin.v1alpha.AudienceFilterExpression.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceFilterExpressionList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpressionList} AudienceFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceFilterExpressionList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceFilterExpressionList message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceFilterExpressionList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.filterExpressions != null && message.hasOwnProperty("filterExpressions")) {
                                if (!Array.isArray(message.filterExpressions))
                                    return "filterExpressions: array expected";
                                for (var i = 0; i < message.filterExpressions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.verify(message.filterExpressions[i]);
                                    if (error)
                                        return "filterExpressions." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AudienceFilterExpressionList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterExpressionList} AudienceFilterExpressionList
                         */
                        AudienceFilterExpressionList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceFilterExpressionList();
                            if (object.filterExpressions) {
                                if (!Array.isArray(object.filterExpressions))
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterExpressionList.filterExpressions: array expected");
                                message.filterExpressions = [];
                                for (var i = 0; i < object.filterExpressions.length; ++i) {
                                    if (typeof object.filterExpressions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterExpressionList.filterExpressions: object expected");
                                    message.filterExpressions[i] = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.fromObject(object.filterExpressions[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceFilterExpressionList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceFilterExpressionList} message AudienceFilterExpressionList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceFilterExpressionList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.filterExpressions = [];
                            if (message.filterExpressions && message.filterExpressions.length) {
                                object.filterExpressions = [];
                                for (var j = 0; j < message.filterExpressions.length; ++j)
                                    object.filterExpressions[j] = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.toObject(message.filterExpressions[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AudienceFilterExpressionList to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceFilterExpressionList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceFilterExpressionList
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterExpressionList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceFilterExpressionList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceFilterExpressionList";
                        };
    
                        return AudienceFilterExpressionList;
                    })();
    
                    v1alpha.AudienceSimpleFilter = (function() {
    
                        /**
                         * Properties of an AudienceSimpleFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceSimpleFilter
                         * @property {google.analytics.admin.v1alpha.AudienceFilterScope|null} [scope] AudienceSimpleFilter scope
                         * @property {google.analytics.admin.v1alpha.IAudienceFilterExpression|null} [filterExpression] AudienceSimpleFilter filterExpression
                         */
    
                        /**
                         * Constructs a new AudienceSimpleFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceSimpleFilter.
                         * @implements IAudienceSimpleFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceSimpleFilter=} [properties] Properties to set
                         */
                        function AudienceSimpleFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceSimpleFilter scope.
                         * @member {google.analytics.admin.v1alpha.AudienceFilterScope} scope
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @instance
                         */
                        AudienceSimpleFilter.prototype.scope = 0;
    
                        /**
                         * AudienceSimpleFilter filterExpression.
                         * @member {google.analytics.admin.v1alpha.IAudienceFilterExpression|null|undefined} filterExpression
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @instance
                         */
                        AudienceSimpleFilter.prototype.filterExpression = null;
    
                        /**
                         * Creates a new AudienceSimpleFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceSimpleFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceSimpleFilter} AudienceSimpleFilter instance
                         */
                        AudienceSimpleFilter.create = function create(properties) {
                            return new AudienceSimpleFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceSimpleFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceSimpleFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceSimpleFilter} message AudienceSimpleFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceSimpleFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.scope != null && Object.hasOwnProperty.call(message, "scope"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.scope);
                            if (message.filterExpression != null && Object.hasOwnProperty.call(message, "filterExpression"))
                                $root.google.analytics.admin.v1alpha.AudienceFilterExpression.encode(message.filterExpression, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceSimpleFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceSimpleFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceSimpleFilter} message AudienceSimpleFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceSimpleFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceSimpleFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceSimpleFilter} AudienceSimpleFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceSimpleFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceSimpleFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.scope = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.filterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceSimpleFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceSimpleFilter} AudienceSimpleFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceSimpleFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceSimpleFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceSimpleFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                switch (message.scope) {
                                default:
                                    return "scope: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.filterExpression != null && message.hasOwnProperty("filterExpression")) {
                                var error = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.verify(message.filterExpression);
                                if (error)
                                    return "filterExpression." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AudienceSimpleFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceSimpleFilter} AudienceSimpleFilter
                         */
                        AudienceSimpleFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceSimpleFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceSimpleFilter();
                            switch (object.scope) {
                            default:
                                if (typeof object.scope === "number") {
                                    message.scope = object.scope;
                                    break;
                                }
                                break;
                            case "AUDIENCE_FILTER_SCOPE_UNSPECIFIED":
                            case 0:
                                message.scope = 0;
                                break;
                            case "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_EVENT":
                            case 1:
                                message.scope = 1;
                                break;
                            case "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_SESSION":
                            case 2:
                                message.scope = 2;
                                break;
                            case "AUDIENCE_FILTER_SCOPE_ACROSS_ALL_SESSIONS":
                            case 3:
                                message.scope = 3;
                                break;
                            }
                            if (object.filterExpression != null) {
                                if (typeof object.filterExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceSimpleFilter.filterExpression: object expected");
                                message.filterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.fromObject(object.filterExpression);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceSimpleFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceSimpleFilter} message AudienceSimpleFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceSimpleFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.scope = options.enums === String ? "AUDIENCE_FILTER_SCOPE_UNSPECIFIED" : 0;
                                object.filterExpression = null;
                            }
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                object.scope = options.enums === String ? $root.google.analytics.admin.v1alpha.AudienceFilterScope[message.scope] === undefined ? message.scope : $root.google.analytics.admin.v1alpha.AudienceFilterScope[message.scope] : message.scope;
                            if (message.filterExpression != null && message.hasOwnProperty("filterExpression"))
                                object.filterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.toObject(message.filterExpression, options);
                            return object;
                        };
    
                        /**
                         * Converts this AudienceSimpleFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceSimpleFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceSimpleFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceSimpleFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceSimpleFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceSimpleFilter";
                        };
    
                        return AudienceSimpleFilter;
                    })();
    
                    v1alpha.AudienceSequenceFilter = (function() {
    
                        /**
                         * Properties of an AudienceSequenceFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceSequenceFilter
                         * @property {google.analytics.admin.v1alpha.AudienceFilterScope|null} [scope] AudienceSequenceFilter scope
                         * @property {google.protobuf.IDuration|null} [sequenceMaximumDuration] AudienceSequenceFilter sequenceMaximumDuration
                         * @property {Array.<google.analytics.admin.v1alpha.AudienceSequenceFilter.IAudienceSequenceStep>|null} [sequenceSteps] AudienceSequenceFilter sequenceSteps
                         */
    
                        /**
                         * Constructs a new AudienceSequenceFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceSequenceFilter.
                         * @implements IAudienceSequenceFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceSequenceFilter=} [properties] Properties to set
                         */
                        function AudienceSequenceFilter(properties) {
                            this.sequenceSteps = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceSequenceFilter scope.
                         * @member {google.analytics.admin.v1alpha.AudienceFilterScope} scope
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @instance
                         */
                        AudienceSequenceFilter.prototype.scope = 0;
    
                        /**
                         * AudienceSequenceFilter sequenceMaximumDuration.
                         * @member {google.protobuf.IDuration|null|undefined} sequenceMaximumDuration
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @instance
                         */
                        AudienceSequenceFilter.prototype.sequenceMaximumDuration = null;
    
                        /**
                         * AudienceSequenceFilter sequenceSteps.
                         * @member {Array.<google.analytics.admin.v1alpha.AudienceSequenceFilter.IAudienceSequenceStep>} sequenceSteps
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @instance
                         */
                        AudienceSequenceFilter.prototype.sequenceSteps = $util.emptyArray;
    
                        /**
                         * Creates a new AudienceSequenceFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceSequenceFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter} AudienceSequenceFilter instance
                         */
                        AudienceSequenceFilter.create = function create(properties) {
                            return new AudienceSequenceFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceSequenceFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceSequenceFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceSequenceFilter} message AudienceSequenceFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceSequenceFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.scope != null && Object.hasOwnProperty.call(message, "scope"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.scope);
                            if (message.sequenceMaximumDuration != null && Object.hasOwnProperty.call(message, "sequenceMaximumDuration"))
                                $root.google.protobuf.Duration.encode(message.sequenceMaximumDuration, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.sequenceSteps != null && message.sequenceSteps.length)
                                for (var i = 0; i < message.sequenceSteps.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.encode(message.sequenceSteps[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceSequenceFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceSequenceFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceSequenceFilter} message AudienceSequenceFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceSequenceFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceSequenceFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter} AudienceSequenceFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceSequenceFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceSequenceFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.scope = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.sequenceMaximumDuration = $root.google.protobuf.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        if (!(message.sequenceSteps && message.sequenceSteps.length))
                                            message.sequenceSteps = [];
                                        message.sequenceSteps.push($root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceSequenceFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter} AudienceSequenceFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceSequenceFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceSequenceFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceSequenceFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                switch (message.scope) {
                                default:
                                    return "scope: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.sequenceMaximumDuration != null && message.hasOwnProperty("sequenceMaximumDuration")) {
                                var error = $root.google.protobuf.Duration.verify(message.sequenceMaximumDuration);
                                if (error)
                                    return "sequenceMaximumDuration." + error;
                            }
                            if (message.sequenceSteps != null && message.hasOwnProperty("sequenceSteps")) {
                                if (!Array.isArray(message.sequenceSteps))
                                    return "sequenceSteps: array expected";
                                for (var i = 0; i < message.sequenceSteps.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.verify(message.sequenceSteps[i]);
                                    if (error)
                                        return "sequenceSteps." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AudienceSequenceFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter} AudienceSequenceFilter
                         */
                        AudienceSequenceFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceSequenceFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceSequenceFilter();
                            switch (object.scope) {
                            default:
                                if (typeof object.scope === "number") {
                                    message.scope = object.scope;
                                    break;
                                }
                                break;
                            case "AUDIENCE_FILTER_SCOPE_UNSPECIFIED":
                            case 0:
                                message.scope = 0;
                                break;
                            case "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_EVENT":
                            case 1:
                                message.scope = 1;
                                break;
                            case "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_SESSION":
                            case 2:
                                message.scope = 2;
                                break;
                            case "AUDIENCE_FILTER_SCOPE_ACROSS_ALL_SESSIONS":
                            case 3:
                                message.scope = 3;
                                break;
                            }
                            if (object.sequenceMaximumDuration != null) {
                                if (typeof object.sequenceMaximumDuration !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceSequenceFilter.sequenceMaximumDuration: object expected");
                                message.sequenceMaximumDuration = $root.google.protobuf.Duration.fromObject(object.sequenceMaximumDuration);
                            }
                            if (object.sequenceSteps) {
                                if (!Array.isArray(object.sequenceSteps))
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceSequenceFilter.sequenceSteps: array expected");
                                message.sequenceSteps = [];
                                for (var i = 0; i < object.sequenceSteps.length; ++i) {
                                    if (typeof object.sequenceSteps[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceSequenceFilter.sequenceSteps: object expected");
                                    message.sequenceSteps[i] = $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.fromObject(object.sequenceSteps[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceSequenceFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceSequenceFilter} message AudienceSequenceFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceSequenceFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sequenceSteps = [];
                            if (options.defaults) {
                                object.scope = options.enums === String ? "AUDIENCE_FILTER_SCOPE_UNSPECIFIED" : 0;
                                object.sequenceMaximumDuration = null;
                            }
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                object.scope = options.enums === String ? $root.google.analytics.admin.v1alpha.AudienceFilterScope[message.scope] === undefined ? message.scope : $root.google.analytics.admin.v1alpha.AudienceFilterScope[message.scope] : message.scope;
                            if (message.sequenceMaximumDuration != null && message.hasOwnProperty("sequenceMaximumDuration"))
                                object.sequenceMaximumDuration = $root.google.protobuf.Duration.toObject(message.sequenceMaximumDuration, options);
                            if (message.sequenceSteps && message.sequenceSteps.length) {
                                object.sequenceSteps = [];
                                for (var j = 0; j < message.sequenceSteps.length; ++j)
                                    object.sequenceSteps[j] = $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.toObject(message.sequenceSteps[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AudienceSequenceFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceSequenceFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceSequenceFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceSequenceFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceSequenceFilter";
                        };
    
                        AudienceSequenceFilter.AudienceSequenceStep = (function() {
    
                            /**
                             * Properties of an AudienceSequenceStep.
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                             * @interface IAudienceSequenceStep
                             * @property {google.analytics.admin.v1alpha.AudienceFilterScope|null} [scope] AudienceSequenceStep scope
                             * @property {boolean|null} [immediatelyFollows] AudienceSequenceStep immediatelyFollows
                             * @property {google.protobuf.IDuration|null} [constraintDuration] AudienceSequenceStep constraintDuration
                             * @property {google.analytics.admin.v1alpha.IAudienceFilterExpression|null} [filterExpression] AudienceSequenceStep filterExpression
                             */
    
                            /**
                             * Constructs a new AudienceSequenceStep.
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter
                             * @classdesc Represents an AudienceSequenceStep.
                             * @implements IAudienceSequenceStep
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.AudienceSequenceFilter.IAudienceSequenceStep=} [properties] Properties to set
                             */
                            function AudienceSequenceStep(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * AudienceSequenceStep scope.
                             * @member {google.analytics.admin.v1alpha.AudienceFilterScope} scope
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @instance
                             */
                            AudienceSequenceStep.prototype.scope = 0;
    
                            /**
                             * AudienceSequenceStep immediatelyFollows.
                             * @member {boolean} immediatelyFollows
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @instance
                             */
                            AudienceSequenceStep.prototype.immediatelyFollows = false;
    
                            /**
                             * AudienceSequenceStep constraintDuration.
                             * @member {google.protobuf.IDuration|null|undefined} constraintDuration
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @instance
                             */
                            AudienceSequenceStep.prototype.constraintDuration = null;
    
                            /**
                             * AudienceSequenceStep filterExpression.
                             * @member {google.analytics.admin.v1alpha.IAudienceFilterExpression|null|undefined} filterExpression
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @instance
                             */
                            AudienceSequenceStep.prototype.filterExpression = null;
    
                            /**
                             * Creates a new AudienceSequenceStep instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceSequenceFilter.IAudienceSequenceStep=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep} AudienceSequenceStep instance
                             */
                            AudienceSequenceStep.create = function create(properties) {
                                return new AudienceSequenceStep(properties);
                            };
    
                            /**
                             * Encodes the specified AudienceSequenceStep message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceSequenceFilter.IAudienceSequenceStep} message AudienceSequenceStep message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AudienceSequenceStep.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.scope != null && Object.hasOwnProperty.call(message, "scope"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.scope);
                                if (message.immediatelyFollows != null && Object.hasOwnProperty.call(message, "immediatelyFollows"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).bool(message.immediatelyFollows);
                                if (message.constraintDuration != null && Object.hasOwnProperty.call(message, "constraintDuration"))
                                    $root.google.protobuf.Duration.encode(message.constraintDuration, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                                if (message.filterExpression != null && Object.hasOwnProperty.call(message, "filterExpression"))
                                    $root.google.analytics.admin.v1alpha.AudienceFilterExpression.encode(message.filterExpression, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                                return writer;
                            };
    
                            /**
                             * Encodes the specified AudienceSequenceStep message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceSequenceFilter.IAudienceSequenceStep} message AudienceSequenceStep message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AudienceSequenceStep.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an AudienceSequenceStep message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep} AudienceSequenceStep
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AudienceSequenceStep.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.scope = reader.int32();
                                            break;
                                        }
                                    case 2: {
                                            message.immediatelyFollows = reader.bool();
                                            break;
                                        }
                                    case 3: {
                                            message.constraintDuration = $root.google.protobuf.Duration.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 4: {
                                            message.filterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.decode(reader, reader.uint32());
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an AudienceSequenceStep message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep} AudienceSequenceStep
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AudienceSequenceStep.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an AudienceSequenceStep message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            AudienceSequenceStep.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.scope != null && message.hasOwnProperty("scope"))
                                    switch (message.scope) {
                                    default:
                                        return "scope: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                if (message.immediatelyFollows != null && message.hasOwnProperty("immediatelyFollows"))
                                    if (typeof message.immediatelyFollows !== "boolean")
                                        return "immediatelyFollows: boolean expected";
                                if (message.constraintDuration != null && message.hasOwnProperty("constraintDuration")) {
                                    var error = $root.google.protobuf.Duration.verify(message.constraintDuration);
                                    if (error)
                                        return "constraintDuration." + error;
                                }
                                if (message.filterExpression != null && message.hasOwnProperty("filterExpression")) {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.verify(message.filterExpression);
                                    if (error)
                                        return "filterExpression." + error;
                                }
                                return null;
                            };
    
                            /**
                             * Creates an AudienceSequenceStep message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep} AudienceSequenceStep
                             */
                            AudienceSequenceStep.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep();
                                switch (object.scope) {
                                default:
                                    if (typeof object.scope === "number") {
                                        message.scope = object.scope;
                                        break;
                                    }
                                    break;
                                case "AUDIENCE_FILTER_SCOPE_UNSPECIFIED":
                                case 0:
                                    message.scope = 0;
                                    break;
                                case "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_EVENT":
                                case 1:
                                    message.scope = 1;
                                    break;
                                case "AUDIENCE_FILTER_SCOPE_WITHIN_SAME_SESSION":
                                case 2:
                                    message.scope = 2;
                                    break;
                                case "AUDIENCE_FILTER_SCOPE_ACROSS_ALL_SESSIONS":
                                case 3:
                                    message.scope = 3;
                                    break;
                                }
                                if (object.immediatelyFollows != null)
                                    message.immediatelyFollows = Boolean(object.immediatelyFollows);
                                if (object.constraintDuration != null) {
                                    if (typeof object.constraintDuration !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.constraintDuration: object expected");
                                    message.constraintDuration = $root.google.protobuf.Duration.fromObject(object.constraintDuration);
                                }
                                if (object.filterExpression != null) {
                                    if (typeof object.filterExpression !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep.filterExpression: object expected");
                                    message.filterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.fromObject(object.filterExpression);
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an AudienceSequenceStep message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep} message AudienceSequenceStep
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            AudienceSequenceStep.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.scope = options.enums === String ? "AUDIENCE_FILTER_SCOPE_UNSPECIFIED" : 0;
                                    object.immediatelyFollows = false;
                                    object.constraintDuration = null;
                                    object.filterExpression = null;
                                }
                                if (message.scope != null && message.hasOwnProperty("scope"))
                                    object.scope = options.enums === String ? $root.google.analytics.admin.v1alpha.AudienceFilterScope[message.scope] === undefined ? message.scope : $root.google.analytics.admin.v1alpha.AudienceFilterScope[message.scope] : message.scope;
                                if (message.immediatelyFollows != null && message.hasOwnProperty("immediatelyFollows"))
                                    object.immediatelyFollows = message.immediatelyFollows;
                                if (message.constraintDuration != null && message.hasOwnProperty("constraintDuration"))
                                    object.constraintDuration = $root.google.protobuf.Duration.toObject(message.constraintDuration, options);
                                if (message.filterExpression != null && message.hasOwnProperty("filterExpression"))
                                    object.filterExpression = $root.google.analytics.admin.v1alpha.AudienceFilterExpression.toObject(message.filterExpression, options);
                                return object;
                            };
    
                            /**
                             * Converts this AudienceSequenceStep to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            AudienceSequenceStep.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for AudienceSequenceStep
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            AudienceSequenceStep.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceSequenceFilter.AudienceSequenceStep";
                            };
    
                            return AudienceSequenceStep;
                        })();
    
                        return AudienceSequenceFilter;
                    })();
    
                    v1alpha.AudienceFilterClause = (function() {
    
                        /**
                         * Properties of an AudienceFilterClause.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceFilterClause
                         * @property {google.analytics.admin.v1alpha.IAudienceSimpleFilter|null} [simpleFilter] AudienceFilterClause simpleFilter
                         * @property {google.analytics.admin.v1alpha.IAudienceSequenceFilter|null} [sequenceFilter] AudienceFilterClause sequenceFilter
                         * @property {google.analytics.admin.v1alpha.AudienceFilterClause.AudienceClauseType|null} [clauseType] AudienceFilterClause clauseType
                         */
    
                        /**
                         * Constructs a new AudienceFilterClause.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceFilterClause.
                         * @implements IAudienceFilterClause
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterClause=} [properties] Properties to set
                         */
                        function AudienceFilterClause(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceFilterClause simpleFilter.
                         * @member {google.analytics.admin.v1alpha.IAudienceSimpleFilter|null|undefined} simpleFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @instance
                         */
                        AudienceFilterClause.prototype.simpleFilter = null;
    
                        /**
                         * AudienceFilterClause sequenceFilter.
                         * @member {google.analytics.admin.v1alpha.IAudienceSequenceFilter|null|undefined} sequenceFilter
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @instance
                         */
                        AudienceFilterClause.prototype.sequenceFilter = null;
    
                        /**
                         * AudienceFilterClause clauseType.
                         * @member {google.analytics.admin.v1alpha.AudienceFilterClause.AudienceClauseType} clauseType
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @instance
                         */
                        AudienceFilterClause.prototype.clauseType = 0;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AudienceFilterClause filter.
                         * @member {"simpleFilter"|"sequenceFilter"|undefined} filter
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @instance
                         */
                        Object.defineProperty(AudienceFilterClause.prototype, "filter", {
                            get: $util.oneOfGetter($oneOfFields = ["simpleFilter", "sequenceFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AudienceFilterClause instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterClause=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterClause} AudienceFilterClause instance
                         */
                        AudienceFilterClause.create = function create(properties) {
                            return new AudienceFilterClause(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceFilterClause message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceFilterClause.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterClause} message AudienceFilterClause message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceFilterClause.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.clauseType != null && Object.hasOwnProperty.call(message, "clauseType"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.clauseType);
                            if (message.simpleFilter != null && Object.hasOwnProperty.call(message, "simpleFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceSimpleFilter.encode(message.simpleFilter, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.sequenceFilter != null && Object.hasOwnProperty.call(message, "sequenceFilter"))
                                $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.encode(message.sequenceFilter, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceFilterClause message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceFilterClause.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceFilterClause} message AudienceFilterClause message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceFilterClause.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceFilterClause message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterClause} AudienceFilterClause
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceFilterClause.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceFilterClause();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2: {
                                        message.simpleFilter = $root.google.analytics.admin.v1alpha.AudienceSimpleFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.sequenceFilter = $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.clauseType = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceFilterClause message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterClause} AudienceFilterClause
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceFilterClause.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceFilterClause message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceFilterClause.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.simpleFilter != null && message.hasOwnProperty("simpleFilter")) {
                                properties.filter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceSimpleFilter.verify(message.simpleFilter);
                                    if (error)
                                        return "simpleFilter." + error;
                                }
                            }
                            if (message.sequenceFilter != null && message.hasOwnProperty("sequenceFilter")) {
                                if (properties.filter === 1)
                                    return "filter: multiple values";
                                properties.filter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.verify(message.sequenceFilter);
                                    if (error)
                                        return "sequenceFilter." + error;
                                }
                            }
                            if (message.clauseType != null && message.hasOwnProperty("clauseType"))
                                switch (message.clauseType) {
                                default:
                                    return "clauseType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            return null;
                        };
    
                        /**
                         * Creates an AudienceFilterClause message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceFilterClause} AudienceFilterClause
                         */
                        AudienceFilterClause.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceFilterClause)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceFilterClause();
                            if (object.simpleFilter != null) {
                                if (typeof object.simpleFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterClause.simpleFilter: object expected");
                                message.simpleFilter = $root.google.analytics.admin.v1alpha.AudienceSimpleFilter.fromObject(object.simpleFilter);
                            }
                            if (object.sequenceFilter != null) {
                                if (typeof object.sequenceFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.AudienceFilterClause.sequenceFilter: object expected");
                                message.sequenceFilter = $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.fromObject(object.sequenceFilter);
                            }
                            switch (object.clauseType) {
                            default:
                                if (typeof object.clauseType === "number") {
                                    message.clauseType = object.clauseType;
                                    break;
                                }
                                break;
                            case "AUDIENCE_CLAUSE_TYPE_UNSPECIFIED":
                            case 0:
                                message.clauseType = 0;
                                break;
                            case "INCLUDE":
                            case 1:
                                message.clauseType = 1;
                                break;
                            case "EXCLUDE":
                            case 2:
                                message.clauseType = 2;
                                break;
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceFilterClause message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceFilterClause} message AudienceFilterClause
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceFilterClause.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.clauseType = options.enums === String ? "AUDIENCE_CLAUSE_TYPE_UNSPECIFIED" : 0;
                            if (message.clauseType != null && message.hasOwnProperty("clauseType"))
                                object.clauseType = options.enums === String ? $root.google.analytics.admin.v1alpha.AudienceFilterClause.AudienceClauseType[message.clauseType] === undefined ? message.clauseType : $root.google.analytics.admin.v1alpha.AudienceFilterClause.AudienceClauseType[message.clauseType] : message.clauseType;
                            if (message.simpleFilter != null && message.hasOwnProperty("simpleFilter")) {
                                object.simpleFilter = $root.google.analytics.admin.v1alpha.AudienceSimpleFilter.toObject(message.simpleFilter, options);
                                if (options.oneofs)
                                    object.filter = "simpleFilter";
                            }
                            if (message.sequenceFilter != null && message.hasOwnProperty("sequenceFilter")) {
                                object.sequenceFilter = $root.google.analytics.admin.v1alpha.AudienceSequenceFilter.toObject(message.sequenceFilter, options);
                                if (options.oneofs)
                                    object.filter = "sequenceFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AudienceFilterClause to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceFilterClause.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceFilterClause
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceFilterClause
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceFilterClause.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceFilterClause";
                        };
    
                        /**
                         * AudienceClauseType enum.
                         * @name google.analytics.admin.v1alpha.AudienceFilterClause.AudienceClauseType
                         * @enum {number}
                         * @property {number} AUDIENCE_CLAUSE_TYPE_UNSPECIFIED=0 AUDIENCE_CLAUSE_TYPE_UNSPECIFIED value
                         * @property {number} INCLUDE=1 INCLUDE value
                         * @property {number} EXCLUDE=2 EXCLUDE value
                         */
                        AudienceFilterClause.AudienceClauseType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "AUDIENCE_CLAUSE_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "INCLUDE"] = 1;
                            values[valuesById[2] = "EXCLUDE"] = 2;
                            return values;
                        })();
    
                        return AudienceFilterClause;
                    })();
    
                    v1alpha.AudienceEventTrigger = (function() {
    
                        /**
                         * Properties of an AudienceEventTrigger.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudienceEventTrigger
                         * @property {string|null} [eventName] AudienceEventTrigger eventName
                         * @property {google.analytics.admin.v1alpha.AudienceEventTrigger.LogCondition|null} [logCondition] AudienceEventTrigger logCondition
                         */
    
                        /**
                         * Constructs a new AudienceEventTrigger.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AudienceEventTrigger.
                         * @implements IAudienceEventTrigger
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudienceEventTrigger=} [properties] Properties to set
                         */
                        function AudienceEventTrigger(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AudienceEventTrigger eventName.
                         * @member {string} eventName
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @instance
                         */
                        AudienceEventTrigger.prototype.eventName = "";
    
                        /**
                         * AudienceEventTrigger logCondition.
                         * @member {google.analytics.admin.v1alpha.AudienceEventTrigger.LogCondition} logCondition
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @instance
                         */
                        AudienceEventTrigger.prototype.logCondition = 0;
    
                        /**
                         * Creates a new AudienceEventTrigger instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceEventTrigger=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AudienceEventTrigger} AudienceEventTrigger instance
                         */
                        AudienceEventTrigger.create = function create(properties) {
                            return new AudienceEventTrigger(properties);
                        };
    
                        /**
                         * Encodes the specified AudienceEventTrigger message. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceEventTrigger.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceEventTrigger} message AudienceEventTrigger message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceEventTrigger.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.eventName != null && Object.hasOwnProperty.call(message, "eventName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.eventName);
                            if (message.logCondition != null && Object.hasOwnProperty.call(message, "logCondition"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.logCondition);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AudienceEventTrigger message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AudienceEventTrigger.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudienceEventTrigger} message AudienceEventTrigger message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AudienceEventTrigger.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AudienceEventTrigger message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AudienceEventTrigger} AudienceEventTrigger
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceEventTrigger.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AudienceEventTrigger();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.eventName = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.logCondition = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AudienceEventTrigger message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AudienceEventTrigger} AudienceEventTrigger
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AudienceEventTrigger.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AudienceEventTrigger message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AudienceEventTrigger.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                if (!$util.isString(message.eventName))
                                    return "eventName: string expected";
                            if (message.logCondition != null && message.hasOwnProperty("logCondition"))
                                switch (message.logCondition) {
                                default:
                                    return "logCondition: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            return null;
                        };
    
                        /**
                         * Creates an AudienceEventTrigger message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AudienceEventTrigger} AudienceEventTrigger
                         */
                        AudienceEventTrigger.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AudienceEventTrigger)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AudienceEventTrigger();
                            if (object.eventName != null)
                                message.eventName = String(object.eventName);
                            switch (object.logCondition) {
                            default:
                                if (typeof object.logCondition === "number") {
                                    message.logCondition = object.logCondition;
                                    break;
                                }
                                break;
                            case "LOG_CONDITION_UNSPECIFIED":
                            case 0:
                                message.logCondition = 0;
                                break;
                            case "AUDIENCE_JOINED":
                            case 1:
                                message.logCondition = 1;
                                break;
                            case "AUDIENCE_MEMBERSHIP_RENEWED":
                            case 2:
                                message.logCondition = 2;
                                break;
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AudienceEventTrigger message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {google.analytics.admin.v1alpha.AudienceEventTrigger} message AudienceEventTrigger
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AudienceEventTrigger.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.eventName = "";
                                object.logCondition = options.enums === String ? "LOG_CONDITION_UNSPECIFIED" : 0;
                            }
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                object.eventName = message.eventName;
                            if (message.logCondition != null && message.hasOwnProperty("logCondition"))
                                object.logCondition = options.enums === String ? $root.google.analytics.admin.v1alpha.AudienceEventTrigger.LogCondition[message.logCondition] === undefined ? message.logCondition : $root.google.analytics.admin.v1alpha.AudienceEventTrigger.LogCondition[message.logCondition] : message.logCondition;
                            return object;
                        };
    
                        /**
                         * Converts this AudienceEventTrigger to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AudienceEventTrigger.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AudienceEventTrigger
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AudienceEventTrigger
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AudienceEventTrigger.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AudienceEventTrigger";
                        };
    
                        /**
                         * LogCondition enum.
                         * @name google.analytics.admin.v1alpha.AudienceEventTrigger.LogCondition
                         * @enum {number}
                         * @property {number} LOG_CONDITION_UNSPECIFIED=0 LOG_CONDITION_UNSPECIFIED value
                         * @property {number} AUDIENCE_JOINED=1 AUDIENCE_JOINED value
                         * @property {number} AUDIENCE_MEMBERSHIP_RENEWED=2 AUDIENCE_MEMBERSHIP_RENEWED value
                         */
                        AudienceEventTrigger.LogCondition = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "LOG_CONDITION_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "AUDIENCE_JOINED"] = 1;
                            values[valuesById[2] = "AUDIENCE_MEMBERSHIP_RENEWED"] = 2;
                            return values;
                        })();
    
                        return AudienceEventTrigger;
                    })();
    
                    v1alpha.Audience = (function() {
    
                        /**
                         * Properties of an Audience.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAudience
                         * @property {string|null} [name] Audience name
                         * @property {string|null} [displayName] Audience displayName
                         * @property {string|null} [description] Audience description
                         * @property {number|null} [membershipDurationDays] Audience membershipDurationDays
                         * @property {boolean|null} [adsPersonalizationEnabled] Audience adsPersonalizationEnabled
                         * @property {google.analytics.admin.v1alpha.IAudienceEventTrigger|null} [eventTrigger] Audience eventTrigger
                         * @property {google.analytics.admin.v1alpha.Audience.AudienceExclusionDurationMode|null} [exclusionDurationMode] Audience exclusionDurationMode
                         * @property {Array.<google.analytics.admin.v1alpha.IAudienceFilterClause>|null} [filterClauses] Audience filterClauses
                         */
    
                        /**
                         * Constructs a new Audience.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an Audience.
                         * @implements IAudience
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAudience=} [properties] Properties to set
                         */
                        function Audience(properties) {
                            this.filterClauses = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Audience name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.name = "";
    
                        /**
                         * Audience displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.displayName = "";
    
                        /**
                         * Audience description.
                         * @member {string} description
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.description = "";
    
                        /**
                         * Audience membershipDurationDays.
                         * @member {number} membershipDurationDays
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.membershipDurationDays = 0;
    
                        /**
                         * Audience adsPersonalizationEnabled.
                         * @member {boolean} adsPersonalizationEnabled
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.adsPersonalizationEnabled = false;
    
                        /**
                         * Audience eventTrigger.
                         * @member {google.analytics.admin.v1alpha.IAudienceEventTrigger|null|undefined} eventTrigger
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.eventTrigger = null;
    
                        /**
                         * Audience exclusionDurationMode.
                         * @member {google.analytics.admin.v1alpha.Audience.AudienceExclusionDurationMode} exclusionDurationMode
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.exclusionDurationMode = 0;
    
                        /**
                         * Audience filterClauses.
                         * @member {Array.<google.analytics.admin.v1alpha.IAudienceFilterClause>} filterClauses
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         */
                        Audience.prototype.filterClauses = $util.emptyArray;
    
                        /**
                         * Creates a new Audience instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudience=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.Audience} Audience instance
                         */
                        Audience.create = function create(properties) {
                            return new Audience(properties);
                        };
    
                        /**
                         * Encodes the specified Audience message. Does not implicitly {@link google.analytics.admin.v1alpha.Audience.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudience} message Audience message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Audience.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.displayName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.description);
                            if (message.membershipDurationDays != null && Object.hasOwnProperty.call(message, "membershipDurationDays"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.membershipDurationDays);
                            if (message.adsPersonalizationEnabled != null && Object.hasOwnProperty.call(message, "adsPersonalizationEnabled"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.adsPersonalizationEnabled);
                            if (message.eventTrigger != null && Object.hasOwnProperty.call(message, "eventTrigger"))
                                $root.google.analytics.admin.v1alpha.AudienceEventTrigger.encode(message.eventTrigger, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.exclusionDurationMode != null && Object.hasOwnProperty.call(message, "exclusionDurationMode"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.exclusionDurationMode);
                            if (message.filterClauses != null && message.filterClauses.length)
                                for (var i = 0; i < message.filterClauses.length; ++i)
                                    $root.google.analytics.admin.v1alpha.AudienceFilterClause.encode(message.filterClauses[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Audience message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.Audience.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAudience} message Audience message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Audience.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Audience message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.Audience} Audience
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Audience.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.Audience();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.membershipDurationDays = reader.int32();
                                        break;
                                    }
                                case 5: {
                                        message.adsPersonalizationEnabled = reader.bool();
                                        break;
                                    }
                                case 6: {
                                        message.eventTrigger = $root.google.analytics.admin.v1alpha.AudienceEventTrigger.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.exclusionDurationMode = reader.int32();
                                        break;
                                    }
                                case 8: {
                                        if (!(message.filterClauses && message.filterClauses.length))
                                            message.filterClauses = [];
                                        message.filterClauses.push($root.google.analytics.admin.v1alpha.AudienceFilterClause.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Audience message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.Audience} Audience
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Audience.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Audience message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Audience.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.description != null && message.hasOwnProperty("description"))
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            if (message.membershipDurationDays != null && message.hasOwnProperty("membershipDurationDays"))
                                if (!$util.isInteger(message.membershipDurationDays))
                                    return "membershipDurationDays: integer expected";
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled"))
                                if (typeof message.adsPersonalizationEnabled !== "boolean")
                                    return "adsPersonalizationEnabled: boolean expected";
                            if (message.eventTrigger != null && message.hasOwnProperty("eventTrigger")) {
                                var error = $root.google.analytics.admin.v1alpha.AudienceEventTrigger.verify(message.eventTrigger);
                                if (error)
                                    return "eventTrigger." + error;
                            }
                            if (message.exclusionDurationMode != null && message.hasOwnProperty("exclusionDurationMode"))
                                switch (message.exclusionDurationMode) {
                                default:
                                    return "exclusionDurationMode: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.filterClauses != null && message.hasOwnProperty("filterClauses")) {
                                if (!Array.isArray(message.filterClauses))
                                    return "filterClauses: array expected";
                                for (var i = 0; i < message.filterClauses.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.AudienceFilterClause.verify(message.filterClauses[i]);
                                    if (error)
                                        return "filterClauses." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Audience message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.Audience} Audience
                         */
                        Audience.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.Audience)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.Audience();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.membershipDurationDays != null)
                                message.membershipDurationDays = object.membershipDurationDays | 0;
                            if (object.adsPersonalizationEnabled != null)
                                message.adsPersonalizationEnabled = Boolean(object.adsPersonalizationEnabled);
                            if (object.eventTrigger != null) {
                                if (typeof object.eventTrigger !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.Audience.eventTrigger: object expected");
                                message.eventTrigger = $root.google.analytics.admin.v1alpha.AudienceEventTrigger.fromObject(object.eventTrigger);
                            }
                            switch (object.exclusionDurationMode) {
                            default:
                                if (typeof object.exclusionDurationMode === "number") {
                                    message.exclusionDurationMode = object.exclusionDurationMode;
                                    break;
                                }
                                break;
                            case "AUDIENCE_EXCLUSION_DURATION_MODE_UNSPECIFIED":
                            case 0:
                                message.exclusionDurationMode = 0;
                                break;
                            case "EXCLUDE_TEMPORARILY":
                            case 1:
                                message.exclusionDurationMode = 1;
                                break;
                            case "EXCLUDE_PERMANENTLY":
                            case 2:
                                message.exclusionDurationMode = 2;
                                break;
                            }
                            if (object.filterClauses) {
                                if (!Array.isArray(object.filterClauses))
                                    throw TypeError(".google.analytics.admin.v1alpha.Audience.filterClauses: array expected");
                                message.filterClauses = [];
                                for (var i = 0; i < object.filterClauses.length; ++i) {
                                    if (typeof object.filterClauses[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.Audience.filterClauses: object expected");
                                    message.filterClauses[i] = $root.google.analytics.admin.v1alpha.AudienceFilterClause.fromObject(object.filterClauses[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Audience message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {google.analytics.admin.v1alpha.Audience} message Audience
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Audience.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.filterClauses = [];
                            if (options.defaults) {
                                object.name = "";
                                object.displayName = "";
                                object.description = "";
                                object.membershipDurationDays = 0;
                                object.adsPersonalizationEnabled = false;
                                object.eventTrigger = null;
                                object.exclusionDurationMode = options.enums === String ? "AUDIENCE_EXCLUSION_DURATION_MODE_UNSPECIFIED" : 0;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = message.description;
                            if (message.membershipDurationDays != null && message.hasOwnProperty("membershipDurationDays"))
                                object.membershipDurationDays = message.membershipDurationDays;
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled"))
                                object.adsPersonalizationEnabled = message.adsPersonalizationEnabled;
                            if (message.eventTrigger != null && message.hasOwnProperty("eventTrigger"))
                                object.eventTrigger = $root.google.analytics.admin.v1alpha.AudienceEventTrigger.toObject(message.eventTrigger, options);
                            if (message.exclusionDurationMode != null && message.hasOwnProperty("exclusionDurationMode"))
                                object.exclusionDurationMode = options.enums === String ? $root.google.analytics.admin.v1alpha.Audience.AudienceExclusionDurationMode[message.exclusionDurationMode] === undefined ? message.exclusionDurationMode : $root.google.analytics.admin.v1alpha.Audience.AudienceExclusionDurationMode[message.exclusionDurationMode] : message.exclusionDurationMode;
                            if (message.filterClauses && message.filterClauses.length) {
                                object.filterClauses = [];
                                for (var j = 0; j < message.filterClauses.length; ++j)
                                    object.filterClauses[j] = $root.google.analytics.admin.v1alpha.AudienceFilterClause.toObject(message.filterClauses[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Audience to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Audience.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Audience
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.Audience
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Audience.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.Audience";
                        };
    
                        /**
                         * AudienceExclusionDurationMode enum.
                         * @name google.analytics.admin.v1alpha.Audience.AudienceExclusionDurationMode
                         * @enum {number}
                         * @property {number} AUDIENCE_EXCLUSION_DURATION_MODE_UNSPECIFIED=0 AUDIENCE_EXCLUSION_DURATION_MODE_UNSPECIFIED value
                         * @property {number} EXCLUDE_TEMPORARILY=1 EXCLUDE_TEMPORARILY value
                         * @property {number} EXCLUDE_PERMANENTLY=2 EXCLUDE_PERMANENTLY value
                         */
                        Audience.AudienceExclusionDurationMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "AUDIENCE_EXCLUSION_DURATION_MODE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EXCLUDE_TEMPORARILY"] = 1;
                            values[valuesById[2] = "EXCLUDE_PERMANENTLY"] = 2;
                            return values;
                        })();
    
                        return Audience;
                    })();
    
                    v1alpha.ChannelGroupFilter = (function() {
    
                        /**
                         * Properties of a ChannelGroupFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IChannelGroupFilter
                         * @property {google.analytics.admin.v1alpha.ChannelGroupFilter.IStringFilter|null} [stringFilter] ChannelGroupFilter stringFilter
                         * @property {google.analytics.admin.v1alpha.ChannelGroupFilter.IInListFilter|null} [inListFilter] ChannelGroupFilter inListFilter
                         * @property {string|null} [fieldName] ChannelGroupFilter fieldName
                         */
    
                        /**
                         * Constructs a new ChannelGroupFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ChannelGroupFilter.
                         * @implements IChannelGroupFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilter=} [properties] Properties to set
                         */
                        function ChannelGroupFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChannelGroupFilter stringFilter.
                         * @member {google.analytics.admin.v1alpha.ChannelGroupFilter.IStringFilter|null|undefined} stringFilter
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @instance
                         */
                        ChannelGroupFilter.prototype.stringFilter = null;
    
                        /**
                         * ChannelGroupFilter inListFilter.
                         * @member {google.analytics.admin.v1alpha.ChannelGroupFilter.IInListFilter|null|undefined} inListFilter
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @instance
                         */
                        ChannelGroupFilter.prototype.inListFilter = null;
    
                        /**
                         * ChannelGroupFilter fieldName.
                         * @member {string} fieldName
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @instance
                         */
                        ChannelGroupFilter.prototype.fieldName = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ChannelGroupFilter valueFilter.
                         * @member {"stringFilter"|"inListFilter"|undefined} valueFilter
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @instance
                         */
                        Object.defineProperty(ChannelGroupFilter.prototype, "valueFilter", {
                            get: $util.oneOfGetter($oneOfFields = ["stringFilter", "inListFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ChannelGroupFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter} ChannelGroupFilter instance
                         */
                        ChannelGroupFilter.create = function create(properties) {
                            return new ChannelGroupFilter(properties);
                        };
    
                        /**
                         * Encodes the specified ChannelGroupFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilter} message ChannelGroupFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroupFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fieldName != null && Object.hasOwnProperty.call(message, "fieldName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fieldName);
                            if (message.stringFilter != null && Object.hasOwnProperty.call(message, "stringFilter"))
                                $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.encode(message.stringFilter, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.inListFilter != null && Object.hasOwnProperty.call(message, "inListFilter"))
                                $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.encode(message.inListFilter, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChannelGroupFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilter} message ChannelGroupFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroupFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChannelGroupFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter} ChannelGroupFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroupFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2: {
                                        message.stringFilter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.inListFilter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.fieldName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChannelGroupFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter} ChannelGroupFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroupFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChannelGroupFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChannelGroupFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                properties.valueFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.verify(message.stringFilter);
                                    if (error)
                                        return "stringFilter." + error;
                                }
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                if (properties.valueFilter === 1)
                                    return "valueFilter: multiple values";
                                properties.valueFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.verify(message.inListFilter);
                                    if (error)
                                        return "inListFilter." + error;
                                }
                            }
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                if (!$util.isString(message.fieldName))
                                    return "fieldName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ChannelGroupFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter} ChannelGroupFilter
                         */
                        ChannelGroupFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ChannelGroupFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilter();
                            if (object.stringFilter != null) {
                                if (typeof object.stringFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilter.stringFilter: object expected");
                                message.stringFilter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.fromObject(object.stringFilter);
                            }
                            if (object.inListFilter != null) {
                                if (typeof object.inListFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilter.inListFilter: object expected");
                                message.inListFilter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.fromObject(object.inListFilter);
                            }
                            if (object.fieldName != null)
                                message.fieldName = String(object.fieldName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChannelGroupFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.ChannelGroupFilter} message ChannelGroupFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChannelGroupFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.fieldName = "";
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                object.fieldName = message.fieldName;
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                object.stringFilter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.toObject(message.stringFilter, options);
                                if (options.oneofs)
                                    object.valueFilter = "stringFilter";
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                object.inListFilter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.toObject(message.inListFilter, options);
                                if (options.oneofs)
                                    object.valueFilter = "inListFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ChannelGroupFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChannelGroupFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChannelGroupFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChannelGroupFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChannelGroupFilter";
                        };
    
                        ChannelGroupFilter.StringFilter = (function() {
    
                            /**
                             * Properties of a StringFilter.
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                             * @interface IStringFilter
                             * @property {google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.MatchType|null} [matchType] StringFilter matchType
                             * @property {string|null} [value] StringFilter value
                             */
    
                            /**
                             * Constructs a new StringFilter.
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                             * @classdesc Represents a StringFilter.
                             * @implements IStringFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IStringFilter=} [properties] Properties to set
                             */
                            function StringFilter(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * StringFilter matchType.
                             * @member {google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.MatchType} matchType
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.matchType = 0;
    
                            /**
                             * StringFilter value.
                             * @member {string} value
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.value = "";
    
                            /**
                             * Creates a new StringFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IStringFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter} StringFilter instance
                             */
                            StringFilter.create = function create(properties) {
                                return new StringFilter(properties);
                            };
    
                            /**
                             * Encodes the specified StringFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IStringFilter} message StringFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            StringFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.matchType != null && Object.hasOwnProperty.call(message, "matchType"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.matchType);
                                if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.value);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified StringFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IStringFilter} message StringFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            StringFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a StringFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter} StringFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            StringFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.matchType = reader.int32();
                                            break;
                                        }
                                    case 2: {
                                            message.value = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a StringFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter} StringFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            StringFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a StringFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            StringFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    switch (message.matchType) {
                                    default:
                                        return "matchType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                    case 4:
                                    case 5:
                                    case 6:
                                        break;
                                    }
                                if (message.value != null && message.hasOwnProperty("value"))
                                    if (!$util.isString(message.value))
                                        return "value: string expected";
                                return null;
                            };
    
                            /**
                             * Creates a StringFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter} StringFilter
                             */
                            StringFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter();
                                switch (object.matchType) {
                                default:
                                    if (typeof object.matchType === "number") {
                                        message.matchType = object.matchType;
                                        break;
                                    }
                                    break;
                                case "MATCH_TYPE_UNSPECIFIED":
                                case 0:
                                    message.matchType = 0;
                                    break;
                                case "EXACT":
                                case 1:
                                    message.matchType = 1;
                                    break;
                                case "BEGINS_WITH":
                                case 2:
                                    message.matchType = 2;
                                    break;
                                case "ENDS_WITH":
                                case 3:
                                    message.matchType = 3;
                                    break;
                                case "CONTAINS":
                                case 4:
                                    message.matchType = 4;
                                    break;
                                case "FULL_REGEXP":
                                case 5:
                                    message.matchType = 5;
                                    break;
                                case "PARTIAL_REGEXP":
                                case 6:
                                    message.matchType = 6;
                                    break;
                                }
                                if (object.value != null)
                                    message.value = String(object.value);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a StringFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter} message StringFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            StringFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.matchType = options.enums === String ? "MATCH_TYPE_UNSPECIFIED" : 0;
                                    object.value = "";
                                }
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    object.matchType = options.enums === String ? $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.MatchType[message.matchType] === undefined ? message.matchType : $root.google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.MatchType[message.matchType] : message.matchType;
                                if (message.value != null && message.hasOwnProperty("value"))
                                    object.value = message.value;
                                return object;
                            };
    
                            /**
                             * Converts this StringFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            StringFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for StringFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            StringFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter";
                            };
    
                            /**
                             * MatchType enum.
                             * @name google.analytics.admin.v1alpha.ChannelGroupFilter.StringFilter.MatchType
                             * @enum {number}
                             * @property {number} MATCH_TYPE_UNSPECIFIED=0 MATCH_TYPE_UNSPECIFIED value
                             * @property {number} EXACT=1 EXACT value
                             * @property {number} BEGINS_WITH=2 BEGINS_WITH value
                             * @property {number} ENDS_WITH=3 ENDS_WITH value
                             * @property {number} CONTAINS=4 CONTAINS value
                             * @property {number} FULL_REGEXP=5 FULL_REGEXP value
                             * @property {number} PARTIAL_REGEXP=6 PARTIAL_REGEXP value
                             */
                            StringFilter.MatchType = (function() {
                                var valuesById = {}, values = Object.create(valuesById);
                                values[valuesById[0] = "MATCH_TYPE_UNSPECIFIED"] = 0;
                                values[valuesById[1] = "EXACT"] = 1;
                                values[valuesById[2] = "BEGINS_WITH"] = 2;
                                values[valuesById[3] = "ENDS_WITH"] = 3;
                                values[valuesById[4] = "CONTAINS"] = 4;
                                values[valuesById[5] = "FULL_REGEXP"] = 5;
                                values[valuesById[6] = "PARTIAL_REGEXP"] = 6;
                                return values;
                            })();
    
                            return StringFilter;
                        })();
    
                        ChannelGroupFilter.InListFilter = (function() {
    
                            /**
                             * Properties of an InListFilter.
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                             * @interface IInListFilter
                             * @property {Array.<string>|null} [values] InListFilter values
                             */
    
                            /**
                             * Constructs a new InListFilter.
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter
                             * @classdesc Represents an InListFilter.
                             * @implements IInListFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IInListFilter=} [properties] Properties to set
                             */
                            function InListFilter(properties) {
                                this.values = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * InListFilter values.
                             * @member {Array.<string>} values
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @instance
                             */
                            InListFilter.prototype.values = $util.emptyArray;
    
                            /**
                             * Creates a new InListFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IInListFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter} InListFilter instance
                             */
                            InListFilter.create = function create(properties) {
                                return new InListFilter(properties);
                            };
    
                            /**
                             * Encodes the specified InListFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IInListFilter} message InListFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            InListFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.values != null && message.values.length)
                                    for (var i = 0; i < message.values.length; ++i)
                                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.values[i]);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified InListFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.IInListFilter} message InListFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            InListFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an InListFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter} InListFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            InListFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            if (!(message.values && message.values.length))
                                                message.values = [];
                                            message.values.push(reader.string());
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an InListFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter} InListFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            InListFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an InListFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            InListFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.values != null && message.hasOwnProperty("values")) {
                                    if (!Array.isArray(message.values))
                                        return "values: array expected";
                                    for (var i = 0; i < message.values.length; ++i)
                                        if (!$util.isString(message.values[i]))
                                            return "values: string[] expected";
                                }
                                return null;
                            };
    
                            /**
                             * Creates an InListFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter} InListFilter
                             */
                            InListFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter();
                                if (object.values) {
                                    if (!Array.isArray(object.values))
                                        throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter.values: array expected");
                                    message.values = [];
                                    for (var i = 0; i < object.values.length; ++i)
                                        message.values[i] = String(object.values[i]);
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an InListFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter} message InListFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            InListFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.values = [];
                                if (message.values && message.values.length) {
                                    object.values = [];
                                    for (var j = 0; j < message.values.length; ++j)
                                        object.values[j] = message.values[j];
                                }
                                return object;
                            };
    
                            /**
                             * Converts this InListFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            InListFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for InListFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            InListFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChannelGroupFilter.InListFilter";
                            };
    
                            return InListFilter;
                        })();
    
                        return ChannelGroupFilter;
                    })();
    
                    v1alpha.ChannelGroupFilterExpression = (function() {
    
                        /**
                         * Properties of a ChannelGroupFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IChannelGroupFilterExpression
                         * @property {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList|null} [andGroup] ChannelGroupFilterExpression andGroup
                         * @property {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList|null} [orGroup] ChannelGroupFilterExpression orGroup
                         * @property {google.analytics.admin.v1alpha.IChannelGroupFilterExpression|null} [notExpression] ChannelGroupFilterExpression notExpression
                         * @property {google.analytics.admin.v1alpha.IChannelGroupFilter|null} [filter] ChannelGroupFilterExpression filter
                         */
    
                        /**
                         * Constructs a new ChannelGroupFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ChannelGroupFilterExpression.
                         * @implements IChannelGroupFilterExpression
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpression=} [properties] Properties to set
                         */
                        function ChannelGroupFilterExpression(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChannelGroupFilterExpression andGroup.
                         * @member {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList|null|undefined} andGroup
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @instance
                         */
                        ChannelGroupFilterExpression.prototype.andGroup = null;
    
                        /**
                         * ChannelGroupFilterExpression orGroup.
                         * @member {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList|null|undefined} orGroup
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @instance
                         */
                        ChannelGroupFilterExpression.prototype.orGroup = null;
    
                        /**
                         * ChannelGroupFilterExpression notExpression.
                         * @member {google.analytics.admin.v1alpha.IChannelGroupFilterExpression|null|undefined} notExpression
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @instance
                         */
                        ChannelGroupFilterExpression.prototype.notExpression = null;
    
                        /**
                         * ChannelGroupFilterExpression filter.
                         * @member {google.analytics.admin.v1alpha.IChannelGroupFilter|null|undefined} filter
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @instance
                         */
                        ChannelGroupFilterExpression.prototype.filter = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ChannelGroupFilterExpression expr.
                         * @member {"andGroup"|"orGroup"|"notExpression"|"filter"|undefined} expr
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @instance
                         */
                        Object.defineProperty(ChannelGroupFilterExpression.prototype, "expr", {
                            get: $util.oneOfGetter($oneOfFields = ["andGroup", "orGroup", "notExpression", "filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ChannelGroupFilterExpression instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpression=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpression} ChannelGroupFilterExpression instance
                         */
                        ChannelGroupFilterExpression.create = function create(properties) {
                            return new ChannelGroupFilterExpression(properties);
                        };
    
                        /**
                         * Encodes the specified ChannelGroupFilterExpression message. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilterExpression.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpression} message ChannelGroupFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroupFilterExpression.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.andGroup != null && Object.hasOwnProperty.call(message, "andGroup"))
                                $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.encode(message.andGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.orGroup != null && Object.hasOwnProperty.call(message, "orGroup"))
                                $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.encode(message.orGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.notExpression != null && Object.hasOwnProperty.call(message, "notExpression"))
                                $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.encode(message.notExpression, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                $root.google.analytics.admin.v1alpha.ChannelGroupFilter.encode(message.filter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChannelGroupFilterExpression message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilterExpression.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpression} message ChannelGroupFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroupFilterExpression.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChannelGroupFilterExpression message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpression} ChannelGroupFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroupFilterExpression.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.andGroup = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.orGroup = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.notExpression = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.filter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChannelGroupFilterExpression message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpression} ChannelGroupFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroupFilterExpression.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChannelGroupFilterExpression message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChannelGroupFilterExpression.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.verify(message.andGroup);
                                    if (error)
                                        return "andGroup." + error;
                                }
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.verify(message.orGroup);
                                    if (error)
                                        return "orGroup." + error;
                                }
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.verify(message.notExpression);
                                    if (error)
                                        return "notExpression." + error;
                                }
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.verify(message.filter);
                                    if (error)
                                        return "filter." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ChannelGroupFilterExpression message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpression} ChannelGroupFilterExpression
                         */
                        ChannelGroupFilterExpression.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression();
                            if (object.andGroup != null) {
                                if (typeof object.andGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilterExpression.andGroup: object expected");
                                message.andGroup = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.fromObject(object.andGroup);
                            }
                            if (object.orGroup != null) {
                                if (typeof object.orGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilterExpression.orGroup: object expected");
                                message.orGroup = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.fromObject(object.orGroup);
                            }
                            if (object.notExpression != null) {
                                if (typeof object.notExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilterExpression.notExpression: object expected");
                                message.notExpression = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.fromObject(object.notExpression);
                            }
                            if (object.filter != null) {
                                if (typeof object.filter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilterExpression.filter: object expected");
                                message.filter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.fromObject(object.filter);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChannelGroupFilterExpression message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.ChannelGroupFilterExpression} message ChannelGroupFilterExpression
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChannelGroupFilterExpression.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                object.andGroup = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.toObject(message.andGroup, options);
                                if (options.oneofs)
                                    object.expr = "andGroup";
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                object.orGroup = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.toObject(message.orGroup, options);
                                if (options.oneofs)
                                    object.expr = "orGroup";
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                object.notExpression = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.toObject(message.notExpression, options);
                                if (options.oneofs)
                                    object.expr = "notExpression";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = $root.google.analytics.admin.v1alpha.ChannelGroupFilter.toObject(message.filter, options);
                                if (options.oneofs)
                                    object.expr = "filter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ChannelGroupFilterExpression to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChannelGroupFilterExpression.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChannelGroupFilterExpression
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpression
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChannelGroupFilterExpression.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChannelGroupFilterExpression";
                        };
    
                        return ChannelGroupFilterExpression;
                    })();
    
                    v1alpha.ChannelGroupFilterExpressionList = (function() {
    
                        /**
                         * Properties of a ChannelGroupFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IChannelGroupFilterExpressionList
                         * @property {Array.<google.analytics.admin.v1alpha.IChannelGroupFilterExpression>|null} [filterExpressions] ChannelGroupFilterExpressionList filterExpressions
                         */
    
                        /**
                         * Constructs a new ChannelGroupFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ChannelGroupFilterExpressionList.
                         * @implements IChannelGroupFilterExpressionList
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList=} [properties] Properties to set
                         */
                        function ChannelGroupFilterExpressionList(properties) {
                            this.filterExpressions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChannelGroupFilterExpressionList filterExpressions.
                         * @member {Array.<google.analytics.admin.v1alpha.IChannelGroupFilterExpression>} filterExpressions
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @instance
                         */
                        ChannelGroupFilterExpressionList.prototype.filterExpressions = $util.emptyArray;
    
                        /**
                         * Creates a new ChannelGroupFilterExpressionList instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList} ChannelGroupFilterExpressionList instance
                         */
                        ChannelGroupFilterExpressionList.create = function create(properties) {
                            return new ChannelGroupFilterExpressionList(properties);
                        };
    
                        /**
                         * Encodes the specified ChannelGroupFilterExpressionList message. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList} message ChannelGroupFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroupFilterExpressionList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.filterExpressions != null && message.filterExpressions.length)
                                for (var i = 0; i < message.filterExpressions.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.encode(message.filterExpressions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChannelGroupFilterExpressionList message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroupFilterExpressionList} message ChannelGroupFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroupFilterExpressionList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChannelGroupFilterExpressionList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList} ChannelGroupFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroupFilterExpressionList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.filterExpressions && message.filterExpressions.length))
                                            message.filterExpressions = [];
                                        message.filterExpressions.push($root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChannelGroupFilterExpressionList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList} ChannelGroupFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroupFilterExpressionList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChannelGroupFilterExpressionList message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChannelGroupFilterExpressionList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.filterExpressions != null && message.hasOwnProperty("filterExpressions")) {
                                if (!Array.isArray(message.filterExpressions))
                                    return "filterExpressions: array expected";
                                for (var i = 0; i < message.filterExpressions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.verify(message.filterExpressions[i]);
                                    if (error)
                                        return "filterExpressions." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ChannelGroupFilterExpressionList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList} ChannelGroupFilterExpressionList
                         */
                        ChannelGroupFilterExpressionList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList();
                            if (object.filterExpressions) {
                                if (!Array.isArray(object.filterExpressions))
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.filterExpressions: array expected");
                                message.filterExpressions = [];
                                for (var i = 0; i < object.filterExpressions.length; ++i) {
                                    if (typeof object.filterExpressions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList.filterExpressions: object expected");
                                    message.filterExpressions[i] = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.fromObject(object.filterExpressions[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChannelGroupFilterExpressionList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList} message ChannelGroupFilterExpressionList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChannelGroupFilterExpressionList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.filterExpressions = [];
                            if (message.filterExpressions && message.filterExpressions.length) {
                                object.filterExpressions = [];
                                for (var j = 0; j < message.filterExpressions.length; ++j)
                                    object.filterExpressions[j] = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.toObject(message.filterExpressions[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ChannelGroupFilterExpressionList to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChannelGroupFilterExpressionList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChannelGroupFilterExpressionList
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChannelGroupFilterExpressionList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChannelGroupFilterExpressionList";
                        };
    
                        return ChannelGroupFilterExpressionList;
                    })();
    
                    v1alpha.GroupingRule = (function() {
    
                        /**
                         * Properties of a GroupingRule.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGroupingRule
                         * @property {string|null} [displayName] GroupingRule displayName
                         * @property {google.analytics.admin.v1alpha.IChannelGroupFilterExpression|null} [expression] GroupingRule expression
                         */
    
                        /**
                         * Constructs a new GroupingRule.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GroupingRule.
                         * @implements IGroupingRule
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGroupingRule=} [properties] Properties to set
                         */
                        function GroupingRule(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GroupingRule displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @instance
                         */
                        GroupingRule.prototype.displayName = "";
    
                        /**
                         * GroupingRule expression.
                         * @member {google.analytics.admin.v1alpha.IChannelGroupFilterExpression|null|undefined} expression
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @instance
                         */
                        GroupingRule.prototype.expression = null;
    
                        /**
                         * Creates a new GroupingRule instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGroupingRule=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GroupingRule} GroupingRule instance
                         */
                        GroupingRule.create = function create(properties) {
                            return new GroupingRule(properties);
                        };
    
                        /**
                         * Encodes the specified GroupingRule message. Does not implicitly {@link google.analytics.admin.v1alpha.GroupingRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGroupingRule} message GroupingRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GroupingRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.displayName);
                            if (message.expression != null && Object.hasOwnProperty.call(message, "expression"))
                                $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.encode(message.expression, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GroupingRule message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GroupingRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGroupingRule} message GroupingRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GroupingRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GroupingRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GroupingRule} GroupingRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GroupingRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GroupingRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.expression = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GroupingRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GroupingRule} GroupingRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GroupingRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GroupingRule message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GroupingRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.expression != null && message.hasOwnProperty("expression")) {
                                var error = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.verify(message.expression);
                                if (error)
                                    return "expression." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GroupingRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GroupingRule} GroupingRule
                         */
                        GroupingRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GroupingRule)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GroupingRule();
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.expression != null) {
                                if (typeof object.expression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.GroupingRule.expression: object expected");
                                message.expression = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.fromObject(object.expression);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GroupingRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.GroupingRule} message GroupingRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GroupingRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.displayName = "";
                                object.expression = null;
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.expression != null && message.hasOwnProperty("expression"))
                                object.expression = $root.google.analytics.admin.v1alpha.ChannelGroupFilterExpression.toObject(message.expression, options);
                            return object;
                        };
    
                        /**
                         * Converts this GroupingRule to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GroupingRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GroupingRule
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GroupingRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GroupingRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GroupingRule";
                        };
    
                        return GroupingRule;
                    })();
    
                    v1alpha.ChannelGroup = (function() {
    
                        /**
                         * Properties of a ChannelGroup.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IChannelGroup
                         * @property {string|null} [name] ChannelGroup name
                         * @property {string|null} [displayName] ChannelGroup displayName
                         * @property {string|null} [description] ChannelGroup description
                         * @property {Array.<google.analytics.admin.v1alpha.IGroupingRule>|null} [groupingRule] ChannelGroup groupingRule
                         * @property {boolean|null} [systemDefined] ChannelGroup systemDefined
                         */
    
                        /**
                         * Constructs a new ChannelGroup.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ChannelGroup.
                         * @implements IChannelGroup
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IChannelGroup=} [properties] Properties to set
                         */
                        function ChannelGroup(properties) {
                            this.groupingRule = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChannelGroup name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @instance
                         */
                        ChannelGroup.prototype.name = "";
    
                        /**
                         * ChannelGroup displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @instance
                         */
                        ChannelGroup.prototype.displayName = "";
    
                        /**
                         * ChannelGroup description.
                         * @member {string} description
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @instance
                         */
                        ChannelGroup.prototype.description = "";
    
                        /**
                         * ChannelGroup groupingRule.
                         * @member {Array.<google.analytics.admin.v1alpha.IGroupingRule>} groupingRule
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @instance
                         */
                        ChannelGroup.prototype.groupingRule = $util.emptyArray;
    
                        /**
                         * ChannelGroup systemDefined.
                         * @member {boolean} systemDefined
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @instance
                         */
                        ChannelGroup.prototype.systemDefined = false;
    
                        /**
                         * Creates a new ChannelGroup instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroup=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ChannelGroup} ChannelGroup instance
                         */
                        ChannelGroup.create = function create(properties) {
                            return new ChannelGroup(properties);
                        };
    
                        /**
                         * Encodes the specified ChannelGroup message. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroup.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroup} message ChannelGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroup.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.displayName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.description);
                            if (message.groupingRule != null && message.groupingRule.length)
                                for (var i = 0; i < message.groupingRule.length; ++i)
                                    $root.google.analytics.admin.v1alpha.GroupingRule.encode(message.groupingRule[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.systemDefined != null && Object.hasOwnProperty.call(message, "systemDefined"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.systemDefined);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChannelGroup message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChannelGroup.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChannelGroup} message ChannelGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChannelGroup.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChannelGroup message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ChannelGroup} ChannelGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroup.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChannelGroup();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 4: {
                                        if (!(message.groupingRule && message.groupingRule.length))
                                            message.groupingRule = [];
                                        message.groupingRule.push($root.google.analytics.admin.v1alpha.GroupingRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 5: {
                                        message.systemDefined = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChannelGroup message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ChannelGroup} ChannelGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChannelGroup.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChannelGroup message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChannelGroup.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.description != null && message.hasOwnProperty("description"))
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            if (message.groupingRule != null && message.hasOwnProperty("groupingRule")) {
                                if (!Array.isArray(message.groupingRule))
                                    return "groupingRule: array expected";
                                for (var i = 0; i < message.groupingRule.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.GroupingRule.verify(message.groupingRule[i]);
                                    if (error)
                                        return "groupingRule." + error;
                                }
                            }
                            if (message.systemDefined != null && message.hasOwnProperty("systemDefined"))
                                if (typeof message.systemDefined !== "boolean")
                                    return "systemDefined: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a ChannelGroup message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ChannelGroup} ChannelGroup
                         */
                        ChannelGroup.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ChannelGroup)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ChannelGroup();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.groupingRule) {
                                if (!Array.isArray(object.groupingRule))
                                    throw TypeError(".google.analytics.admin.v1alpha.ChannelGroup.groupingRule: array expected");
                                message.groupingRule = [];
                                for (var i = 0; i < object.groupingRule.length; ++i) {
                                    if (typeof object.groupingRule[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChannelGroup.groupingRule: object expected");
                                    message.groupingRule[i] = $root.google.analytics.admin.v1alpha.GroupingRule.fromObject(object.groupingRule[i]);
                                }
                            }
                            if (object.systemDefined != null)
                                message.systemDefined = Boolean(object.systemDefined);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChannelGroup message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {google.analytics.admin.v1alpha.ChannelGroup} message ChannelGroup
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChannelGroup.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.groupingRule = [];
                            if (options.defaults) {
                                object.name = "";
                                object.displayName = "";
                                object.description = "";
                                object.systemDefined = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = message.description;
                            if (message.groupingRule && message.groupingRule.length) {
                                object.groupingRule = [];
                                for (var j = 0; j < message.groupingRule.length; ++j)
                                    object.groupingRule[j] = $root.google.analytics.admin.v1alpha.GroupingRule.toObject(message.groupingRule[j], options);
                            }
                            if (message.systemDefined != null && message.hasOwnProperty("systemDefined"))
                                object.systemDefined = message.systemDefined;
                            return object;
                        };
    
                        /**
                         * Converts this ChannelGroup to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChannelGroup.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChannelGroup
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ChannelGroup
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChannelGroup.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChannelGroup";
                        };
    
                        return ChannelGroup;
                    })();
    
                    v1alpha.ParameterMutation = (function() {
    
                        /**
                         * Properties of a ParameterMutation.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IParameterMutation
                         * @property {string|null} [parameter] ParameterMutation parameter
                         * @property {string|null} [parameterValue] ParameterMutation parameterValue
                         */
    
                        /**
                         * Constructs a new ParameterMutation.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ParameterMutation.
                         * @implements IParameterMutation
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IParameterMutation=} [properties] Properties to set
                         */
                        function ParameterMutation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ParameterMutation parameter.
                         * @member {string} parameter
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @instance
                         */
                        ParameterMutation.prototype.parameter = "";
    
                        /**
                         * ParameterMutation parameterValue.
                         * @member {string} parameterValue
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @instance
                         */
                        ParameterMutation.prototype.parameterValue = "";
    
                        /**
                         * Creates a new ParameterMutation instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {google.analytics.admin.v1alpha.IParameterMutation=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ParameterMutation} ParameterMutation instance
                         */
                        ParameterMutation.create = function create(properties) {
                            return new ParameterMutation(properties);
                        };
    
                        /**
                         * Encodes the specified ParameterMutation message. Does not implicitly {@link google.analytics.admin.v1alpha.ParameterMutation.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {google.analytics.admin.v1alpha.IParameterMutation} message ParameterMutation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParameterMutation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parameter != null && Object.hasOwnProperty.call(message, "parameter"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parameter);
                            if (message.parameterValue != null && Object.hasOwnProperty.call(message, "parameterValue"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parameterValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ParameterMutation message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ParameterMutation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {google.analytics.admin.v1alpha.IParameterMutation} message ParameterMutation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ParameterMutation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ParameterMutation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ParameterMutation} ParameterMutation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParameterMutation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ParameterMutation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parameter = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.parameterValue = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ParameterMutation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ParameterMutation} ParameterMutation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ParameterMutation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ParameterMutation message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ParameterMutation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parameter != null && message.hasOwnProperty("parameter"))
                                if (!$util.isString(message.parameter))
                                    return "parameter: string expected";
                            if (message.parameterValue != null && message.hasOwnProperty("parameterValue"))
                                if (!$util.isString(message.parameterValue))
                                    return "parameterValue: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ParameterMutation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ParameterMutation} ParameterMutation
                         */
                        ParameterMutation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ParameterMutation)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ParameterMutation();
                            if (object.parameter != null)
                                message.parameter = String(object.parameter);
                            if (object.parameterValue != null)
                                message.parameterValue = String(object.parameterValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ParameterMutation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {google.analytics.admin.v1alpha.ParameterMutation} message ParameterMutation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ParameterMutation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parameter = "";
                                object.parameterValue = "";
                            }
                            if (message.parameter != null && message.hasOwnProperty("parameter"))
                                object.parameter = message.parameter;
                            if (message.parameterValue != null && message.hasOwnProperty("parameterValue"))
                                object.parameterValue = message.parameterValue;
                            return object;
                        };
    
                        /**
                         * Converts this ParameterMutation to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ParameterMutation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ParameterMutation
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ParameterMutation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ParameterMutation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ParameterMutation";
                        };
    
                        return ParameterMutation;
                    })();
    
                    v1alpha.EventCreateRule = (function() {
    
                        /**
                         * Properties of an EventCreateRule.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IEventCreateRule
                         * @property {string|null} [name] EventCreateRule name
                         * @property {string|null} [destinationEvent] EventCreateRule destinationEvent
                         * @property {Array.<google.analytics.admin.v1alpha.IMatchingCondition>|null} [eventConditions] EventCreateRule eventConditions
                         * @property {boolean|null} [sourceCopyParameters] EventCreateRule sourceCopyParameters
                         * @property {Array.<google.analytics.admin.v1alpha.IParameterMutation>|null} [parameterMutations] EventCreateRule parameterMutations
                         */
    
                        /**
                         * Constructs a new EventCreateRule.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an EventCreateRule.
                         * @implements IEventCreateRule
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IEventCreateRule=} [properties] Properties to set
                         */
                        function EventCreateRule(properties) {
                            this.eventConditions = [];
                            this.parameterMutations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * EventCreateRule name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @instance
                         */
                        EventCreateRule.prototype.name = "";
    
                        /**
                         * EventCreateRule destinationEvent.
                         * @member {string} destinationEvent
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @instance
                         */
                        EventCreateRule.prototype.destinationEvent = "";
    
                        /**
                         * EventCreateRule eventConditions.
                         * @member {Array.<google.analytics.admin.v1alpha.IMatchingCondition>} eventConditions
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @instance
                         */
                        EventCreateRule.prototype.eventConditions = $util.emptyArray;
    
                        /**
                         * EventCreateRule sourceCopyParameters.
                         * @member {boolean} sourceCopyParameters
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @instance
                         */
                        EventCreateRule.prototype.sourceCopyParameters = false;
    
                        /**
                         * EventCreateRule parameterMutations.
                         * @member {Array.<google.analytics.admin.v1alpha.IParameterMutation>} parameterMutations
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @instance
                         */
                        EventCreateRule.prototype.parameterMutations = $util.emptyArray;
    
                        /**
                         * Creates a new EventCreateRule instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.IEventCreateRule=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.EventCreateRule} EventCreateRule instance
                         */
                        EventCreateRule.create = function create(properties) {
                            return new EventCreateRule(properties);
                        };
    
                        /**
                         * Encodes the specified EventCreateRule message. Does not implicitly {@link google.analytics.admin.v1alpha.EventCreateRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.IEventCreateRule} message EventCreateRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EventCreateRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.destinationEvent != null && Object.hasOwnProperty.call(message, "destinationEvent"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.destinationEvent);
                            if (message.eventConditions != null && message.eventConditions.length)
                                for (var i = 0; i < message.eventConditions.length; ++i)
                                    $root.google.analytics.admin.v1alpha.MatchingCondition.encode(message.eventConditions[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.sourceCopyParameters != null && Object.hasOwnProperty.call(message, "sourceCopyParameters"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.sourceCopyParameters);
                            if (message.parameterMutations != null && message.parameterMutations.length)
                                for (var i = 0; i < message.parameterMutations.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ParameterMutation.encode(message.parameterMutations[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified EventCreateRule message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.EventCreateRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.IEventCreateRule} message EventCreateRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EventCreateRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an EventCreateRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.EventCreateRule} EventCreateRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EventCreateRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.EventCreateRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.destinationEvent = reader.string();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.eventConditions && message.eventConditions.length))
                                            message.eventConditions = [];
                                        message.eventConditions.push($root.google.analytics.admin.v1alpha.MatchingCondition.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 4: {
                                        message.sourceCopyParameters = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        if (!(message.parameterMutations && message.parameterMutations.length))
                                            message.parameterMutations = [];
                                        message.parameterMutations.push($root.google.analytics.admin.v1alpha.ParameterMutation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an EventCreateRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.EventCreateRule} EventCreateRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EventCreateRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an EventCreateRule message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        EventCreateRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.destinationEvent != null && message.hasOwnProperty("destinationEvent"))
                                if (!$util.isString(message.destinationEvent))
                                    return "destinationEvent: string expected";
                            if (message.eventConditions != null && message.hasOwnProperty("eventConditions")) {
                                if (!Array.isArray(message.eventConditions))
                                    return "eventConditions: array expected";
                                for (var i = 0; i < message.eventConditions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.MatchingCondition.verify(message.eventConditions[i]);
                                    if (error)
                                        return "eventConditions." + error;
                                }
                            }
                            if (message.sourceCopyParameters != null && message.hasOwnProperty("sourceCopyParameters"))
                                if (typeof message.sourceCopyParameters !== "boolean")
                                    return "sourceCopyParameters: boolean expected";
                            if (message.parameterMutations != null && message.hasOwnProperty("parameterMutations")) {
                                if (!Array.isArray(message.parameterMutations))
                                    return "parameterMutations: array expected";
                                for (var i = 0; i < message.parameterMutations.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ParameterMutation.verify(message.parameterMutations[i]);
                                    if (error)
                                        return "parameterMutations." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an EventCreateRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.EventCreateRule} EventCreateRule
                         */
                        EventCreateRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.EventCreateRule)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.EventCreateRule();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.destinationEvent != null)
                                message.destinationEvent = String(object.destinationEvent);
                            if (object.eventConditions) {
                                if (!Array.isArray(object.eventConditions))
                                    throw TypeError(".google.analytics.admin.v1alpha.EventCreateRule.eventConditions: array expected");
                                message.eventConditions = [];
                                for (var i = 0; i < object.eventConditions.length; ++i) {
                                    if (typeof object.eventConditions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.EventCreateRule.eventConditions: object expected");
                                    message.eventConditions[i] = $root.google.analytics.admin.v1alpha.MatchingCondition.fromObject(object.eventConditions[i]);
                                }
                            }
                            if (object.sourceCopyParameters != null)
                                message.sourceCopyParameters = Boolean(object.sourceCopyParameters);
                            if (object.parameterMutations) {
                                if (!Array.isArray(object.parameterMutations))
                                    throw TypeError(".google.analytics.admin.v1alpha.EventCreateRule.parameterMutations: array expected");
                                message.parameterMutations = [];
                                for (var i = 0; i < object.parameterMutations.length; ++i) {
                                    if (typeof object.parameterMutations[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.EventCreateRule.parameterMutations: object expected");
                                    message.parameterMutations[i] = $root.google.analytics.admin.v1alpha.ParameterMutation.fromObject(object.parameterMutations[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an EventCreateRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {google.analytics.admin.v1alpha.EventCreateRule} message EventCreateRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        EventCreateRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.eventConditions = [];
                                object.parameterMutations = [];
                            }
                            if (options.defaults) {
                                object.name = "";
                                object.destinationEvent = "";
                                object.sourceCopyParameters = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.destinationEvent != null && message.hasOwnProperty("destinationEvent"))
                                object.destinationEvent = message.destinationEvent;
                            if (message.eventConditions && message.eventConditions.length) {
                                object.eventConditions = [];
                                for (var j = 0; j < message.eventConditions.length; ++j)
                                    object.eventConditions[j] = $root.google.analytics.admin.v1alpha.MatchingCondition.toObject(message.eventConditions[j], options);
                            }
                            if (message.sourceCopyParameters != null && message.hasOwnProperty("sourceCopyParameters"))
                                object.sourceCopyParameters = message.sourceCopyParameters;
                            if (message.parameterMutations && message.parameterMutations.length) {
                                object.parameterMutations = [];
                                for (var j = 0; j < message.parameterMutations.length; ++j)
                                    object.parameterMutations[j] = $root.google.analytics.admin.v1alpha.ParameterMutation.toObject(message.parameterMutations[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this EventCreateRule to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        EventCreateRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for EventCreateRule
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.EventCreateRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        EventCreateRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.EventCreateRule";
                        };
    
                        return EventCreateRule;
                    })();
    
                    v1alpha.MatchingCondition = (function() {
    
                        /**
                         * Properties of a MatchingCondition.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IMatchingCondition
                         * @property {string|null} [field] MatchingCondition field
                         * @property {google.analytics.admin.v1alpha.MatchingCondition.ComparisonType|null} [comparisonType] MatchingCondition comparisonType
                         * @property {string|null} [value] MatchingCondition value
                         * @property {boolean|null} [negated] MatchingCondition negated
                         */
    
                        /**
                         * Constructs a new MatchingCondition.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a MatchingCondition.
                         * @implements IMatchingCondition
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IMatchingCondition=} [properties] Properties to set
                         */
                        function MatchingCondition(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MatchingCondition field.
                         * @member {string} field
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @instance
                         */
                        MatchingCondition.prototype.field = "";
    
                        /**
                         * MatchingCondition comparisonType.
                         * @member {google.analytics.admin.v1alpha.MatchingCondition.ComparisonType} comparisonType
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @instance
                         */
                        MatchingCondition.prototype.comparisonType = 0;
    
                        /**
                         * MatchingCondition value.
                         * @member {string} value
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @instance
                         */
                        MatchingCondition.prototype.value = "";
    
                        /**
                         * MatchingCondition negated.
                         * @member {boolean} negated
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @instance
                         */
                        MatchingCondition.prototype.negated = false;
    
                        /**
                         * Creates a new MatchingCondition instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {google.analytics.admin.v1alpha.IMatchingCondition=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.MatchingCondition} MatchingCondition instance
                         */
                        MatchingCondition.create = function create(properties) {
                            return new MatchingCondition(properties);
                        };
    
                        /**
                         * Encodes the specified MatchingCondition message. Does not implicitly {@link google.analytics.admin.v1alpha.MatchingCondition.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {google.analytics.admin.v1alpha.IMatchingCondition} message MatchingCondition message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingCondition.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.field != null && Object.hasOwnProperty.call(message, "field"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.field);
                            if (message.comparisonType != null && Object.hasOwnProperty.call(message, "comparisonType"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.comparisonType);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.value);
                            if (message.negated != null && Object.hasOwnProperty.call(message, "negated"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.negated);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MatchingCondition message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.MatchingCondition.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {google.analytics.admin.v1alpha.IMatchingCondition} message MatchingCondition message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MatchingCondition.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MatchingCondition message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.MatchingCondition} MatchingCondition
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingCondition.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.MatchingCondition();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.field = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.comparisonType = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.value = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.negated = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MatchingCondition message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.MatchingCondition} MatchingCondition
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MatchingCondition.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MatchingCondition message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MatchingCondition.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.field != null && message.hasOwnProperty("field"))
                                if (!$util.isString(message.field))
                                    return "field: string expected";
                            if (message.comparisonType != null && message.hasOwnProperty("comparisonType"))
                                switch (message.comparisonType) {
                                default:
                                    return "comparisonType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value"))
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            if (message.negated != null && message.hasOwnProperty("negated"))
                                if (typeof message.negated !== "boolean")
                                    return "negated: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a MatchingCondition message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.MatchingCondition} MatchingCondition
                         */
                        MatchingCondition.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.MatchingCondition)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.MatchingCondition();
                            if (object.field != null)
                                message.field = String(object.field);
                            switch (object.comparisonType) {
                            default:
                                if (typeof object.comparisonType === "number") {
                                    message.comparisonType = object.comparisonType;
                                    break;
                                }
                                break;
                            case "COMPARISON_TYPE_UNSPECIFIED":
                            case 0:
                                message.comparisonType = 0;
                                break;
                            case "EQUALS":
                            case 1:
                                message.comparisonType = 1;
                                break;
                            case "EQUALS_CASE_INSENSITIVE":
                            case 2:
                                message.comparisonType = 2;
                                break;
                            case "CONTAINS":
                            case 3:
                                message.comparisonType = 3;
                                break;
                            case "CONTAINS_CASE_INSENSITIVE":
                            case 4:
                                message.comparisonType = 4;
                                break;
                            case "STARTS_WITH":
                            case 5:
                                message.comparisonType = 5;
                                break;
                            case "STARTS_WITH_CASE_INSENSITIVE":
                            case 6:
                                message.comparisonType = 6;
                                break;
                            case "ENDS_WITH":
                            case 7:
                                message.comparisonType = 7;
                                break;
                            case "ENDS_WITH_CASE_INSENSITIVE":
                            case 8:
                                message.comparisonType = 8;
                                break;
                            case "GREATER_THAN":
                            case 9:
                                message.comparisonType = 9;
                                break;
                            case "GREATER_THAN_OR_EQUAL":
                            case 10:
                                message.comparisonType = 10;
                                break;
                            case "LESS_THAN":
                            case 11:
                                message.comparisonType = 11;
                                break;
                            case "LESS_THAN_OR_EQUAL":
                            case 12:
                                message.comparisonType = 12;
                                break;
                            case "REGULAR_EXPRESSION":
                            case 13:
                                message.comparisonType = 13;
                                break;
                            case "REGULAR_EXPRESSION_CASE_INSENSITIVE":
                            case 14:
                                message.comparisonType = 14;
                                break;
                            }
                            if (object.value != null)
                                message.value = String(object.value);
                            if (object.negated != null)
                                message.negated = Boolean(object.negated);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MatchingCondition message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {google.analytics.admin.v1alpha.MatchingCondition} message MatchingCondition
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MatchingCondition.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.field = "";
                                object.comparisonType = options.enums === String ? "COMPARISON_TYPE_UNSPECIFIED" : 0;
                                object.value = "";
                                object.negated = false;
                            }
                            if (message.field != null && message.hasOwnProperty("field"))
                                object.field = message.field;
                            if (message.comparisonType != null && message.hasOwnProperty("comparisonType"))
                                object.comparisonType = options.enums === String ? $root.google.analytics.admin.v1alpha.MatchingCondition.ComparisonType[message.comparisonType] === undefined ? message.comparisonType : $root.google.analytics.admin.v1alpha.MatchingCondition.ComparisonType[message.comparisonType] : message.comparisonType;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = message.value;
                            if (message.negated != null && message.hasOwnProperty("negated"))
                                object.negated = message.negated;
                            return object;
                        };
    
                        /**
                         * Converts this MatchingCondition to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MatchingCondition.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MatchingCondition
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.MatchingCondition
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MatchingCondition.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.MatchingCondition";
                        };
    
                        /**
                         * ComparisonType enum.
                         * @name google.analytics.admin.v1alpha.MatchingCondition.ComparisonType
                         * @enum {number}
                         * @property {number} COMPARISON_TYPE_UNSPECIFIED=0 COMPARISON_TYPE_UNSPECIFIED value
                         * @property {number} EQUALS=1 EQUALS value
                         * @property {number} EQUALS_CASE_INSENSITIVE=2 EQUALS_CASE_INSENSITIVE value
                         * @property {number} CONTAINS=3 CONTAINS value
                         * @property {number} CONTAINS_CASE_INSENSITIVE=4 CONTAINS_CASE_INSENSITIVE value
                         * @property {number} STARTS_WITH=5 STARTS_WITH value
                         * @property {number} STARTS_WITH_CASE_INSENSITIVE=6 STARTS_WITH_CASE_INSENSITIVE value
                         * @property {number} ENDS_WITH=7 ENDS_WITH value
                         * @property {number} ENDS_WITH_CASE_INSENSITIVE=8 ENDS_WITH_CASE_INSENSITIVE value
                         * @property {number} GREATER_THAN=9 GREATER_THAN value
                         * @property {number} GREATER_THAN_OR_EQUAL=10 GREATER_THAN_OR_EQUAL value
                         * @property {number} LESS_THAN=11 LESS_THAN value
                         * @property {number} LESS_THAN_OR_EQUAL=12 LESS_THAN_OR_EQUAL value
                         * @property {number} REGULAR_EXPRESSION=13 REGULAR_EXPRESSION value
                         * @property {number} REGULAR_EXPRESSION_CASE_INSENSITIVE=14 REGULAR_EXPRESSION_CASE_INSENSITIVE value
                         */
                        MatchingCondition.ComparisonType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "COMPARISON_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EQUALS"] = 1;
                            values[valuesById[2] = "EQUALS_CASE_INSENSITIVE"] = 2;
                            values[valuesById[3] = "CONTAINS"] = 3;
                            values[valuesById[4] = "CONTAINS_CASE_INSENSITIVE"] = 4;
                            values[valuesById[5] = "STARTS_WITH"] = 5;
                            values[valuesById[6] = "STARTS_WITH_CASE_INSENSITIVE"] = 6;
                            values[valuesById[7] = "ENDS_WITH"] = 7;
                            values[valuesById[8] = "ENDS_WITH_CASE_INSENSITIVE"] = 8;
                            values[valuesById[9] = "GREATER_THAN"] = 9;
                            values[valuesById[10] = "GREATER_THAN_OR_EQUAL"] = 10;
                            values[valuesById[11] = "LESS_THAN"] = 11;
                            values[valuesById[12] = "LESS_THAN_OR_EQUAL"] = 12;
                            values[valuesById[13] = "REGULAR_EXPRESSION"] = 13;
                            values[valuesById[14] = "REGULAR_EXPRESSION_CASE_INSENSITIVE"] = 14;
                            return values;
                        })();
    
                        return MatchingCondition;
                    })();
    
                    v1alpha.ExpandedDataSetFilter = (function() {
    
                        /**
                         * Properties of an ExpandedDataSetFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IExpandedDataSetFilter
                         * @property {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IStringFilter|null} [stringFilter] ExpandedDataSetFilter stringFilter
                         * @property {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IInListFilter|null} [inListFilter] ExpandedDataSetFilter inListFilter
                         * @property {string|null} [fieldName] ExpandedDataSetFilter fieldName
                         */
    
                        /**
                         * Constructs a new ExpandedDataSetFilter.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ExpandedDataSetFilter.
                         * @implements IExpandedDataSetFilter
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilter=} [properties] Properties to set
                         */
                        function ExpandedDataSetFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExpandedDataSetFilter stringFilter.
                         * @member {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IStringFilter|null|undefined} stringFilter
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @instance
                         */
                        ExpandedDataSetFilter.prototype.stringFilter = null;
    
                        /**
                         * ExpandedDataSetFilter inListFilter.
                         * @member {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IInListFilter|null|undefined} inListFilter
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @instance
                         */
                        ExpandedDataSetFilter.prototype.inListFilter = null;
    
                        /**
                         * ExpandedDataSetFilter fieldName.
                         * @member {string} fieldName
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @instance
                         */
                        ExpandedDataSetFilter.prototype.fieldName = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExpandedDataSetFilter oneFilter.
                         * @member {"stringFilter"|"inListFilter"|undefined} oneFilter
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @instance
                         */
                        Object.defineProperty(ExpandedDataSetFilter.prototype, "oneFilter", {
                            get: $util.oneOfGetter($oneOfFields = ["stringFilter", "inListFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExpandedDataSetFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter} ExpandedDataSetFilter instance
                         */
                        ExpandedDataSetFilter.create = function create(properties) {
                            return new ExpandedDataSetFilter(properties);
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSetFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilter} message ExpandedDataSetFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSetFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fieldName != null && Object.hasOwnProperty.call(message, "fieldName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fieldName);
                            if (message.stringFilter != null && Object.hasOwnProperty.call(message, "stringFilter"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.encode(message.stringFilter, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.inListFilter != null && Object.hasOwnProperty.call(message, "inListFilter"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.encode(message.inListFilter, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSetFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilter} message ExpandedDataSetFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSetFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExpandedDataSetFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter} ExpandedDataSetFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSetFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2: {
                                        message.stringFilter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.inListFilter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.fieldName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExpandedDataSetFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter} ExpandedDataSetFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSetFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExpandedDataSetFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandedDataSetFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.verify(message.stringFilter);
                                    if (error)
                                        return "stringFilter." + error;
                                }
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.verify(message.inListFilter);
                                    if (error)
                                        return "inListFilter." + error;
                                }
                            }
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                if (!$util.isString(message.fieldName))
                                    return "fieldName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ExpandedDataSetFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter} ExpandedDataSetFilter
                         */
                        ExpandedDataSetFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter();
                            if (object.stringFilter != null) {
                                if (typeof object.stringFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilter.stringFilter: object expected");
                                message.stringFilter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.fromObject(object.stringFilter);
                            }
                            if (object.inListFilter != null) {
                                if (typeof object.inListFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilter.inListFilter: object expected");
                                message.inListFilter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.fromObject(object.inListFilter);
                            }
                            if (object.fieldName != null)
                                message.fieldName = String(object.fieldName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExpandedDataSetFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter} message ExpandedDataSetFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandedDataSetFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.fieldName = "";
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                object.fieldName = message.fieldName;
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                object.stringFilter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.toObject(message.stringFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "stringFilter";
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                object.inListFilter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.toObject(message.inListFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "inListFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExpandedDataSetFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandedDataSetFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExpandedDataSetFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExpandedDataSetFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ExpandedDataSetFilter";
                        };
    
                        ExpandedDataSetFilter.StringFilter = (function() {
    
                            /**
                             * Properties of a StringFilter.
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                             * @interface IStringFilter
                             * @property {google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.MatchType|null} [matchType] StringFilter matchType
                             * @property {string|null} [value] StringFilter value
                             * @property {boolean|null} [caseSensitive] StringFilter caseSensitive
                             */
    
                            /**
                             * Constructs a new StringFilter.
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                             * @classdesc Represents a StringFilter.
                             * @implements IStringFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IStringFilter=} [properties] Properties to set
                             */
                            function StringFilter(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * StringFilter matchType.
                             * @member {google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.MatchType} matchType
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.matchType = 0;
    
                            /**
                             * StringFilter value.
                             * @member {string} value
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.value = "";
    
                            /**
                             * StringFilter caseSensitive.
                             * @member {boolean} caseSensitive
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @instance
                             */
                            StringFilter.prototype.caseSensitive = false;
    
                            /**
                             * Creates a new StringFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IStringFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter} StringFilter instance
                             */
                            StringFilter.create = function create(properties) {
                                return new StringFilter(properties);
                            };
    
                            /**
                             * Encodes the specified StringFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IStringFilter} message StringFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            StringFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.matchType != null && Object.hasOwnProperty.call(message, "matchType"))
                                    writer.uint32(/* id 1, wireType 0 =*/8).int32(message.matchType);
                                if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.value);
                                if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                    writer.uint32(/* id 3, wireType 0 =*/24).bool(message.caseSensitive);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified StringFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IStringFilter} message StringFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            StringFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a StringFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter} StringFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            StringFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.matchType = reader.int32();
                                            break;
                                        }
                                    case 2: {
                                            message.value = reader.string();
                                            break;
                                        }
                                    case 3: {
                                            message.caseSensitive = reader.bool();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a StringFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter} StringFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            StringFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a StringFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            StringFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    switch (message.matchType) {
                                    default:
                                        return "matchType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                        break;
                                    }
                                if (message.value != null && message.hasOwnProperty("value"))
                                    if (!$util.isString(message.value))
                                        return "value: string expected";
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    if (typeof message.caseSensitive !== "boolean")
                                        return "caseSensitive: boolean expected";
                                return null;
                            };
    
                            /**
                             * Creates a StringFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter} StringFilter
                             */
                            StringFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter();
                                switch (object.matchType) {
                                default:
                                    if (typeof object.matchType === "number") {
                                        message.matchType = object.matchType;
                                        break;
                                    }
                                    break;
                                case "MATCH_TYPE_UNSPECIFIED":
                                case 0:
                                    message.matchType = 0;
                                    break;
                                case "EXACT":
                                case 1:
                                    message.matchType = 1;
                                    break;
                                case "CONTAINS":
                                case 2:
                                    message.matchType = 2;
                                    break;
                                }
                                if (object.value != null)
                                    message.value = String(object.value);
                                if (object.caseSensitive != null)
                                    message.caseSensitive = Boolean(object.caseSensitive);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a StringFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter} message StringFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            StringFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.matchType = options.enums === String ? "MATCH_TYPE_UNSPECIFIED" : 0;
                                    object.value = "";
                                    object.caseSensitive = false;
                                }
                                if (message.matchType != null && message.hasOwnProperty("matchType"))
                                    object.matchType = options.enums === String ? $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.MatchType[message.matchType] === undefined ? message.matchType : $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.MatchType[message.matchType] : message.matchType;
                                if (message.value != null && message.hasOwnProperty("value"))
                                    object.value = message.value;
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    object.caseSensitive = message.caseSensitive;
                                return object;
                            };
    
                            /**
                             * Converts this StringFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            StringFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for StringFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            StringFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter";
                            };
    
                            /**
                             * MatchType enum.
                             * @name google.analytics.admin.v1alpha.ExpandedDataSetFilter.StringFilter.MatchType
                             * @enum {number}
                             * @property {number} MATCH_TYPE_UNSPECIFIED=0 MATCH_TYPE_UNSPECIFIED value
                             * @property {number} EXACT=1 EXACT value
                             * @property {number} CONTAINS=2 CONTAINS value
                             */
                            StringFilter.MatchType = (function() {
                                var valuesById = {}, values = Object.create(valuesById);
                                values[valuesById[0] = "MATCH_TYPE_UNSPECIFIED"] = 0;
                                values[valuesById[1] = "EXACT"] = 1;
                                values[valuesById[2] = "CONTAINS"] = 2;
                                return values;
                            })();
    
                            return StringFilter;
                        })();
    
                        ExpandedDataSetFilter.InListFilter = (function() {
    
                            /**
                             * Properties of an InListFilter.
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                             * @interface IInListFilter
                             * @property {Array.<string>|null} [values] InListFilter values
                             * @property {boolean|null} [caseSensitive] InListFilter caseSensitive
                             */
    
                            /**
                             * Constructs a new InListFilter.
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter
                             * @classdesc Represents an InListFilter.
                             * @implements IInListFilter
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IInListFilter=} [properties] Properties to set
                             */
                            function InListFilter(properties) {
                                this.values = [];
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * InListFilter values.
                             * @member {Array.<string>} values
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @instance
                             */
                            InListFilter.prototype.values = $util.emptyArray;
    
                            /**
                             * InListFilter caseSensitive.
                             * @member {boolean} caseSensitive
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @instance
                             */
                            InListFilter.prototype.caseSensitive = false;
    
                            /**
                             * Creates a new InListFilter instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IInListFilter=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter} InListFilter instance
                             */
                            InListFilter.create = function create(properties) {
                                return new InListFilter(properties);
                            };
    
                            /**
                             * Encodes the specified InListFilter message. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IInListFilter} message InListFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            InListFilter.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.values != null && message.values.length)
                                    for (var i = 0; i < message.values.length; ++i)
                                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.values[i]);
                                if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).bool(message.caseSensitive);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified InListFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.IInListFilter} message InListFilter message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            InListFilter.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an InListFilter message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter} InListFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            InListFilter.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            if (!(message.values && message.values.length))
                                                message.values = [];
                                            message.values.push(reader.string());
                                            break;
                                        }
                                    case 2: {
                                            message.caseSensitive = reader.bool();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an InListFilter message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter} InListFilter
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            InListFilter.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an InListFilter message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            InListFilter.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.values != null && message.hasOwnProperty("values")) {
                                    if (!Array.isArray(message.values))
                                        return "values: array expected";
                                    for (var i = 0; i < message.values.length; ++i)
                                        if (!$util.isString(message.values[i]))
                                            return "values: string[] expected";
                                }
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    if (typeof message.caseSensitive !== "boolean")
                                        return "caseSensitive: boolean expected";
                                return null;
                            };
    
                            /**
                             * Creates an InListFilter message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter} InListFilter
                             */
                            InListFilter.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter();
                                if (object.values) {
                                    if (!Array.isArray(object.values))
                                        throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter.values: array expected");
                                    message.values = [];
                                    for (var i = 0; i < object.values.length; ++i)
                                        message.values[i] = String(object.values[i]);
                                }
                                if (object.caseSensitive != null)
                                    message.caseSensitive = Boolean(object.caseSensitive);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an InListFilter message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter} message InListFilter
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            InListFilter.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.arrays || options.defaults)
                                    object.values = [];
                                if (options.defaults)
                                    object.caseSensitive = false;
                                if (message.values && message.values.length) {
                                    object.values = [];
                                    for (var j = 0; j < message.values.length; ++j)
                                        object.values[j] = message.values[j];
                                }
                                if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                    object.caseSensitive = message.caseSensitive;
                                return object;
                            };
    
                            /**
                             * Converts this InListFilter to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            InListFilter.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for InListFilter
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            InListFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.ExpandedDataSetFilter.InListFilter";
                            };
    
                            return InListFilter;
                        })();
    
                        return ExpandedDataSetFilter;
                    })();
    
                    v1alpha.ExpandedDataSetFilterExpression = (function() {
    
                        /**
                         * Properties of an ExpandedDataSetFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IExpandedDataSetFilterExpression
                         * @property {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpressionList|null} [andGroup] ExpandedDataSetFilterExpression andGroup
                         * @property {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression|null} [notExpression] ExpandedDataSetFilterExpression notExpression
                         * @property {google.analytics.admin.v1alpha.IExpandedDataSetFilter|null} [filter] ExpandedDataSetFilterExpression filter
                         */
    
                        /**
                         * Constructs a new ExpandedDataSetFilterExpression.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ExpandedDataSetFilterExpression.
                         * @implements IExpandedDataSetFilterExpression
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression=} [properties] Properties to set
                         */
                        function ExpandedDataSetFilterExpression(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExpandedDataSetFilterExpression andGroup.
                         * @member {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpressionList|null|undefined} andGroup
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @instance
                         */
                        ExpandedDataSetFilterExpression.prototype.andGroup = null;
    
                        /**
                         * ExpandedDataSetFilterExpression notExpression.
                         * @member {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression|null|undefined} notExpression
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @instance
                         */
                        ExpandedDataSetFilterExpression.prototype.notExpression = null;
    
                        /**
                         * ExpandedDataSetFilterExpression filter.
                         * @member {google.analytics.admin.v1alpha.IExpandedDataSetFilter|null|undefined} filter
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @instance
                         */
                        ExpandedDataSetFilterExpression.prototype.filter = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExpandedDataSetFilterExpression expr.
                         * @member {"andGroup"|"notExpression"|"filter"|undefined} expr
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @instance
                         */
                        Object.defineProperty(ExpandedDataSetFilterExpression.prototype, "expr", {
                            get: $util.oneOfGetter($oneOfFields = ["andGroup", "notExpression", "filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExpandedDataSetFilterExpression instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression} ExpandedDataSetFilterExpression instance
                         */
                        ExpandedDataSetFilterExpression.create = function create(properties) {
                            return new ExpandedDataSetFilterExpression(properties);
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSetFilterExpression message. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression} message ExpandedDataSetFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSetFilterExpression.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.andGroup != null && Object.hasOwnProperty.call(message, "andGroup"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.encode(message.andGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.notExpression != null && Object.hasOwnProperty.call(message, "notExpression"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.encode(message.notExpression, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.encode(message.filter, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSetFilterExpression message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression} message ExpandedDataSetFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSetFilterExpression.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExpandedDataSetFilterExpression message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression} ExpandedDataSetFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSetFilterExpression.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.andGroup = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.notExpression = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.filter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExpandedDataSetFilterExpression message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression} ExpandedDataSetFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSetFilterExpression.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExpandedDataSetFilterExpression message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandedDataSetFilterExpression.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.verify(message.andGroup);
                                    if (error)
                                        return "andGroup." + error;
                                }
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.verify(message.notExpression);
                                    if (error)
                                        return "notExpression." + error;
                                }
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                if (properties.expr === 1)
                                    return "expr: multiple values";
                                properties.expr = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.verify(message.filter);
                                    if (error)
                                        return "filter." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExpandedDataSetFilterExpression message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression} ExpandedDataSetFilterExpression
                         */
                        ExpandedDataSetFilterExpression.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression();
                            if (object.andGroup != null) {
                                if (typeof object.andGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.andGroup: object expected");
                                message.andGroup = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.fromObject(object.andGroup);
                            }
                            if (object.notExpression != null) {
                                if (typeof object.notExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.notExpression: object expected");
                                message.notExpression = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.fromObject(object.notExpression);
                            }
                            if (object.filter != null) {
                                if (typeof object.filter !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.filter: object expected");
                                message.filter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.fromObject(object.filter);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExpandedDataSetFilterExpression message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression} message ExpandedDataSetFilterExpression
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandedDataSetFilterExpression.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                object.andGroup = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.toObject(message.andGroup, options);
                                if (options.oneofs)
                                    object.expr = "andGroup";
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                object.notExpression = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.toObject(message.notExpression, options);
                                if (options.oneofs)
                                    object.expr = "notExpression";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilter.toObject(message.filter, options);
                                if (options.oneofs)
                                    object.expr = "filter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExpandedDataSetFilterExpression to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandedDataSetFilterExpression.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExpandedDataSetFilterExpression
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExpandedDataSetFilterExpression.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression";
                        };
    
                        return ExpandedDataSetFilterExpression;
                    })();
    
                    v1alpha.ExpandedDataSetFilterExpressionList = (function() {
    
                        /**
                         * Properties of an ExpandedDataSetFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IExpandedDataSetFilterExpressionList
                         * @property {Array.<google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression>|null} [filterExpressions] ExpandedDataSetFilterExpressionList filterExpressions
                         */
    
                        /**
                         * Constructs a new ExpandedDataSetFilterExpressionList.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ExpandedDataSetFilterExpressionList.
                         * @implements IExpandedDataSetFilterExpressionList
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpressionList=} [properties] Properties to set
                         */
                        function ExpandedDataSetFilterExpressionList(properties) {
                            this.filterExpressions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExpandedDataSetFilterExpressionList filterExpressions.
                         * @member {Array.<google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression>} filterExpressions
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @instance
                         */
                        ExpandedDataSetFilterExpressionList.prototype.filterExpressions = $util.emptyArray;
    
                        /**
                         * Creates a new ExpandedDataSetFilterExpressionList instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpressionList=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList} ExpandedDataSetFilterExpressionList instance
                         */
                        ExpandedDataSetFilterExpressionList.create = function create(properties) {
                            return new ExpandedDataSetFilterExpressionList(properties);
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSetFilterExpressionList message. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpressionList} message ExpandedDataSetFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSetFilterExpressionList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.filterExpressions != null && message.filterExpressions.length)
                                for (var i = 0; i < message.filterExpressions.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.encode(message.filterExpressions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSetFilterExpressionList message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpressionList} message ExpandedDataSetFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSetFilterExpressionList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExpandedDataSetFilterExpressionList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList} ExpandedDataSetFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSetFilterExpressionList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.filterExpressions && message.filterExpressions.length))
                                            message.filterExpressions = [];
                                        message.filterExpressions.push($root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExpandedDataSetFilterExpressionList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList} ExpandedDataSetFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSetFilterExpressionList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExpandedDataSetFilterExpressionList message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandedDataSetFilterExpressionList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.filterExpressions != null && message.hasOwnProperty("filterExpressions")) {
                                if (!Array.isArray(message.filterExpressions))
                                    return "filterExpressions: array expected";
                                for (var i = 0; i < message.filterExpressions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.verify(message.filterExpressions[i]);
                                    if (error)
                                        return "filterExpressions." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExpandedDataSetFilterExpressionList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList} ExpandedDataSetFilterExpressionList
                         */
                        ExpandedDataSetFilterExpressionList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList();
                            if (object.filterExpressions) {
                                if (!Array.isArray(object.filterExpressions))
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.filterExpressions: array expected");
                                message.filterExpressions = [];
                                for (var i = 0; i < object.filterExpressions.length; ++i) {
                                    if (typeof object.filterExpressions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList.filterExpressions: object expected");
                                    message.filterExpressions[i] = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.fromObject(object.filterExpressions[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExpandedDataSetFilterExpressionList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList} message ExpandedDataSetFilterExpressionList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandedDataSetFilterExpressionList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.filterExpressions = [];
                            if (message.filterExpressions && message.filterExpressions.length) {
                                object.filterExpressions = [];
                                for (var j = 0; j < message.filterExpressions.length; ++j)
                                    object.filterExpressions[j] = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.toObject(message.filterExpressions[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExpandedDataSetFilterExpressionList to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandedDataSetFilterExpressionList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExpandedDataSetFilterExpressionList
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExpandedDataSetFilterExpressionList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ExpandedDataSetFilterExpressionList";
                        };
    
                        return ExpandedDataSetFilterExpressionList;
                    })();
    
                    v1alpha.ExpandedDataSet = (function() {
    
                        /**
                         * Properties of an ExpandedDataSet.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IExpandedDataSet
                         * @property {string|null} [name] ExpandedDataSet name
                         * @property {string|null} [displayName] ExpandedDataSet displayName
                         * @property {string|null} [description] ExpandedDataSet description
                         * @property {Array.<string>|null} [dimensionNames] ExpandedDataSet dimensionNames
                         * @property {Array.<string>|null} [metricNames] ExpandedDataSet metricNames
                         * @property {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression|null} [dimensionFilterExpression] ExpandedDataSet dimensionFilterExpression
                         * @property {google.protobuf.ITimestamp|null} [dataCollectionStartTime] ExpandedDataSet dataCollectionStartTime
                         */
    
                        /**
                         * Constructs a new ExpandedDataSet.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an ExpandedDataSet.
                         * @implements IExpandedDataSet
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSet=} [properties] Properties to set
                         */
                        function ExpandedDataSet(properties) {
                            this.dimensionNames = [];
                            this.metricNames = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExpandedDataSet name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         */
                        ExpandedDataSet.prototype.name = "";
    
                        /**
                         * ExpandedDataSet displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         */
                        ExpandedDataSet.prototype.displayName = "";
    
                        /**
                         * ExpandedDataSet description.
                         * @member {string} description
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         */
                        ExpandedDataSet.prototype.description = "";
    
                        /**
                         * ExpandedDataSet dimensionNames.
                         * @member {Array.<string>} dimensionNames
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         */
                        ExpandedDataSet.prototype.dimensionNames = $util.emptyArray;
    
                        /**
                         * ExpandedDataSet metricNames.
                         * @member {Array.<string>} metricNames
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         */
                        ExpandedDataSet.prototype.metricNames = $util.emptyArray;
    
                        /**
                         * ExpandedDataSet dimensionFilterExpression.
                         * @member {google.analytics.admin.v1alpha.IExpandedDataSetFilterExpression|null|undefined} dimensionFilterExpression
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         */
                        ExpandedDataSet.prototype.dimensionFilterExpression = null;
    
                        /**
                         * ExpandedDataSet dataCollectionStartTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} dataCollectionStartTime
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         */
                        ExpandedDataSet.prototype.dataCollectionStartTime = null;
    
                        /**
                         * Creates a new ExpandedDataSet instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSet=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSet} ExpandedDataSet instance
                         */
                        ExpandedDataSet.create = function create(properties) {
                            return new ExpandedDataSet(properties);
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSet message. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSet.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSet} message ExpandedDataSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSet.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.displayName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.description);
                            if (message.dimensionNames != null && message.dimensionNames.length)
                                for (var i = 0; i < message.dimensionNames.length; ++i)
                                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.dimensionNames[i]);
                            if (message.metricNames != null && message.metricNames.length)
                                for (var i = 0; i < message.metricNames.length; ++i)
                                    writer.uint32(/* id 5, wireType 2 =*/42).string(message.metricNames[i]);
                            if (message.dimensionFilterExpression != null && Object.hasOwnProperty.call(message, "dimensionFilterExpression"))
                                $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.encode(message.dimensionFilterExpression, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.dataCollectionStartTime != null && Object.hasOwnProperty.call(message, "dataCollectionStartTime"))
                                $root.google.protobuf.Timestamp.encode(message.dataCollectionStartTime, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExpandedDataSet message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ExpandedDataSet.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {google.analytics.admin.v1alpha.IExpandedDataSet} message ExpandedDataSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandedDataSet.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExpandedDataSet message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSet} ExpandedDataSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSet.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ExpandedDataSet();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 4: {
                                        if (!(message.dimensionNames && message.dimensionNames.length))
                                            message.dimensionNames = [];
                                        message.dimensionNames.push(reader.string());
                                        break;
                                    }
                                case 5: {
                                        if (!(message.metricNames && message.metricNames.length))
                                            message.metricNames = [];
                                        message.metricNames.push(reader.string());
                                        break;
                                    }
                                case 6: {
                                        message.dimensionFilterExpression = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.dataCollectionStartTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExpandedDataSet message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSet} ExpandedDataSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandedDataSet.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExpandedDataSet message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandedDataSet.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.description != null && message.hasOwnProperty("description"))
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            if (message.dimensionNames != null && message.hasOwnProperty("dimensionNames")) {
                                if (!Array.isArray(message.dimensionNames))
                                    return "dimensionNames: array expected";
                                for (var i = 0; i < message.dimensionNames.length; ++i)
                                    if (!$util.isString(message.dimensionNames[i]))
                                        return "dimensionNames: string[] expected";
                            }
                            if (message.metricNames != null && message.hasOwnProperty("metricNames")) {
                                if (!Array.isArray(message.metricNames))
                                    return "metricNames: array expected";
                                for (var i = 0; i < message.metricNames.length; ++i)
                                    if (!$util.isString(message.metricNames[i]))
                                        return "metricNames: string[] expected";
                            }
                            if (message.dimensionFilterExpression != null && message.hasOwnProperty("dimensionFilterExpression")) {
                                var error = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.verify(message.dimensionFilterExpression);
                                if (error)
                                    return "dimensionFilterExpression." + error;
                            }
                            if (message.dataCollectionStartTime != null && message.hasOwnProperty("dataCollectionStartTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.dataCollectionStartTime);
                                if (error)
                                    return "dataCollectionStartTime." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExpandedDataSet message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ExpandedDataSet} ExpandedDataSet
                         */
                        ExpandedDataSet.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ExpandedDataSet)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ExpandedDataSet();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.dimensionNames) {
                                if (!Array.isArray(object.dimensionNames))
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSet.dimensionNames: array expected");
                                message.dimensionNames = [];
                                for (var i = 0; i < object.dimensionNames.length; ++i)
                                    message.dimensionNames[i] = String(object.dimensionNames[i]);
                            }
                            if (object.metricNames) {
                                if (!Array.isArray(object.metricNames))
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSet.metricNames: array expected");
                                message.metricNames = [];
                                for (var i = 0; i < object.metricNames.length; ++i)
                                    message.metricNames[i] = String(object.metricNames[i]);
                            }
                            if (object.dimensionFilterExpression != null) {
                                if (typeof object.dimensionFilterExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSet.dimensionFilterExpression: object expected");
                                message.dimensionFilterExpression = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.fromObject(object.dimensionFilterExpression);
                            }
                            if (object.dataCollectionStartTime != null) {
                                if (typeof object.dataCollectionStartTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ExpandedDataSet.dataCollectionStartTime: object expected");
                                message.dataCollectionStartTime = $root.google.protobuf.Timestamp.fromObject(object.dataCollectionStartTime);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExpandedDataSet message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {google.analytics.admin.v1alpha.ExpandedDataSet} message ExpandedDataSet
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandedDataSet.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dimensionNames = [];
                                object.metricNames = [];
                            }
                            if (options.defaults) {
                                object.name = "";
                                object.displayName = "";
                                object.description = "";
                                object.dimensionFilterExpression = null;
                                object.dataCollectionStartTime = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = message.description;
                            if (message.dimensionNames && message.dimensionNames.length) {
                                object.dimensionNames = [];
                                for (var j = 0; j < message.dimensionNames.length; ++j)
                                    object.dimensionNames[j] = message.dimensionNames[j];
                            }
                            if (message.metricNames && message.metricNames.length) {
                                object.metricNames = [];
                                for (var j = 0; j < message.metricNames.length; ++j)
                                    object.metricNames[j] = message.metricNames[j];
                            }
                            if (message.dimensionFilterExpression != null && message.hasOwnProperty("dimensionFilterExpression"))
                                object.dimensionFilterExpression = $root.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression.toObject(message.dimensionFilterExpression, options);
                            if (message.dataCollectionStartTime != null && message.hasOwnProperty("dataCollectionStartTime"))
                                object.dataCollectionStartTime = $root.google.protobuf.Timestamp.toObject(message.dataCollectionStartTime, options);
                            return object;
                        };
    
                        /**
                         * Converts this ExpandedDataSet to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandedDataSet.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExpandedDataSet
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ExpandedDataSet
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExpandedDataSet.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ExpandedDataSet";
                        };
    
                        return ExpandedDataSet;
                    })();
    
                    /**
                     * IndustryCategory enum.
                     * @name google.analytics.admin.v1alpha.IndustryCategory
                     * @enum {number}
                     * @property {number} INDUSTRY_CATEGORY_UNSPECIFIED=0 INDUSTRY_CATEGORY_UNSPECIFIED value
                     * @property {number} AUTOMOTIVE=1 AUTOMOTIVE value
                     * @property {number} BUSINESS_AND_INDUSTRIAL_MARKETS=2 BUSINESS_AND_INDUSTRIAL_MARKETS value
                     * @property {number} FINANCE=3 FINANCE value
                     * @property {number} HEALTHCARE=4 HEALTHCARE value
                     * @property {number} TECHNOLOGY=5 TECHNOLOGY value
                     * @property {number} TRAVEL=6 TRAVEL value
                     * @property {number} OTHER=7 OTHER value
                     * @property {number} ARTS_AND_ENTERTAINMENT=8 ARTS_AND_ENTERTAINMENT value
                     * @property {number} BEAUTY_AND_FITNESS=9 BEAUTY_AND_FITNESS value
                     * @property {number} BOOKS_AND_LITERATURE=10 BOOKS_AND_LITERATURE value
                     * @property {number} FOOD_AND_DRINK=11 FOOD_AND_DRINK value
                     * @property {number} GAMES=12 GAMES value
                     * @property {number} HOBBIES_AND_LEISURE=13 HOBBIES_AND_LEISURE value
                     * @property {number} HOME_AND_GARDEN=14 HOME_AND_GARDEN value
                     * @property {number} INTERNET_AND_TELECOM=15 INTERNET_AND_TELECOM value
                     * @property {number} LAW_AND_GOVERNMENT=16 LAW_AND_GOVERNMENT value
                     * @property {number} NEWS=17 NEWS value
                     * @property {number} ONLINE_COMMUNITIES=18 ONLINE_COMMUNITIES value
                     * @property {number} PEOPLE_AND_SOCIETY=19 PEOPLE_AND_SOCIETY value
                     * @property {number} PETS_AND_ANIMALS=20 PETS_AND_ANIMALS value
                     * @property {number} REAL_ESTATE=21 REAL_ESTATE value
                     * @property {number} REFERENCE=22 REFERENCE value
                     * @property {number} SCIENCE=23 SCIENCE value
                     * @property {number} SPORTS=24 SPORTS value
                     * @property {number} JOBS_AND_EDUCATION=25 JOBS_AND_EDUCATION value
                     * @property {number} SHOPPING=26 SHOPPING value
                     */
                    v1alpha.IndustryCategory = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "INDUSTRY_CATEGORY_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "AUTOMOTIVE"] = 1;
                        values[valuesById[2] = "BUSINESS_AND_INDUSTRIAL_MARKETS"] = 2;
                        values[valuesById[3] = "FINANCE"] = 3;
                        values[valuesById[4] = "HEALTHCARE"] = 4;
                        values[valuesById[5] = "TECHNOLOGY"] = 5;
                        values[valuesById[6] = "TRAVEL"] = 6;
                        values[valuesById[7] = "OTHER"] = 7;
                        values[valuesById[8] = "ARTS_AND_ENTERTAINMENT"] = 8;
                        values[valuesById[9] = "BEAUTY_AND_FITNESS"] = 9;
                        values[valuesById[10] = "BOOKS_AND_LITERATURE"] = 10;
                        values[valuesById[11] = "FOOD_AND_DRINK"] = 11;
                        values[valuesById[12] = "GAMES"] = 12;
                        values[valuesById[13] = "HOBBIES_AND_LEISURE"] = 13;
                        values[valuesById[14] = "HOME_AND_GARDEN"] = 14;
                        values[valuesById[15] = "INTERNET_AND_TELECOM"] = 15;
                        values[valuesById[16] = "LAW_AND_GOVERNMENT"] = 16;
                        values[valuesById[17] = "NEWS"] = 17;
                        values[valuesById[18] = "ONLINE_COMMUNITIES"] = 18;
                        values[valuesById[19] = "PEOPLE_AND_SOCIETY"] = 19;
                        values[valuesById[20] = "PETS_AND_ANIMALS"] = 20;
                        values[valuesById[21] = "REAL_ESTATE"] = 21;
                        values[valuesById[22] = "REFERENCE"] = 22;
                        values[valuesById[23] = "SCIENCE"] = 23;
                        values[valuesById[24] = "SPORTS"] = 24;
                        values[valuesById[25] = "JOBS_AND_EDUCATION"] = 25;
                        values[valuesById[26] = "SHOPPING"] = 26;
                        return values;
                    })();
    
                    /**
                     * ServiceLevel enum.
                     * @name google.analytics.admin.v1alpha.ServiceLevel
                     * @enum {number}
                     * @property {number} SERVICE_LEVEL_UNSPECIFIED=0 SERVICE_LEVEL_UNSPECIFIED value
                     * @property {number} GOOGLE_ANALYTICS_STANDARD=1 GOOGLE_ANALYTICS_STANDARD value
                     * @property {number} GOOGLE_ANALYTICS_360=2 GOOGLE_ANALYTICS_360 value
                     */
                    v1alpha.ServiceLevel = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "SERVICE_LEVEL_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "GOOGLE_ANALYTICS_STANDARD"] = 1;
                        values[valuesById[2] = "GOOGLE_ANALYTICS_360"] = 2;
                        return values;
                    })();
    
                    /**
                     * ActorType enum.
                     * @name google.analytics.admin.v1alpha.ActorType
                     * @enum {number}
                     * @property {number} ACTOR_TYPE_UNSPECIFIED=0 ACTOR_TYPE_UNSPECIFIED value
                     * @property {number} USER=1 USER value
                     * @property {number} SYSTEM=2 SYSTEM value
                     * @property {number} SUPPORT=3 SUPPORT value
                     */
                    v1alpha.ActorType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "ACTOR_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "USER"] = 1;
                        values[valuesById[2] = "SYSTEM"] = 2;
                        values[valuesById[3] = "SUPPORT"] = 3;
                        return values;
                    })();
    
                    /**
                     * ActionType enum.
                     * @name google.analytics.admin.v1alpha.ActionType
                     * @enum {number}
                     * @property {number} ACTION_TYPE_UNSPECIFIED=0 ACTION_TYPE_UNSPECIFIED value
                     * @property {number} CREATED=1 CREATED value
                     * @property {number} UPDATED=2 UPDATED value
                     * @property {number} DELETED=3 DELETED value
                     */
                    v1alpha.ActionType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "ACTION_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "CREATED"] = 1;
                        values[valuesById[2] = "UPDATED"] = 2;
                        values[valuesById[3] = "DELETED"] = 3;
                        return values;
                    })();
    
                    /**
                     * ChangeHistoryResourceType enum.
                     * @name google.analytics.admin.v1alpha.ChangeHistoryResourceType
                     * @enum {number}
                     * @property {number} CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED=0 CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED value
                     * @property {number} ACCOUNT=1 ACCOUNT value
                     * @property {number} PROPERTY=2 PROPERTY value
                     * @property {number} FIREBASE_LINK=6 FIREBASE_LINK value
                     * @property {number} GOOGLE_ADS_LINK=7 GOOGLE_ADS_LINK value
                     * @property {number} GOOGLE_SIGNALS_SETTINGS=8 GOOGLE_SIGNALS_SETTINGS value
                     * @property {number} CONVERSION_EVENT=9 CONVERSION_EVENT value
                     * @property {number} MEASUREMENT_PROTOCOL_SECRET=10 MEASUREMENT_PROTOCOL_SECRET value
                     * @property {number} CUSTOM_DIMENSION=11 CUSTOM_DIMENSION value
                     * @property {number} CUSTOM_METRIC=12 CUSTOM_METRIC value
                     * @property {number} DATA_RETENTION_SETTINGS=13 DATA_RETENTION_SETTINGS value
                     * @property {number} DISPLAY_VIDEO_360_ADVERTISER_LINK=14 DISPLAY_VIDEO_360_ADVERTISER_LINK value
                     * @property {number} DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL=15 DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL value
                     * @property {number} SEARCH_ADS_360_LINK=16 SEARCH_ADS_360_LINK value
                     * @property {number} DATA_STREAM=18 DATA_STREAM value
                     * @property {number} ATTRIBUTION_SETTINGS=20 ATTRIBUTION_SETTINGS value
                     * @property {number} EXPANDED_DATA_SET=21 EXPANDED_DATA_SET value
                     * @property {number} CHANNEL_GROUP=22 CHANNEL_GROUP value
                     * @property {number} ENHANCED_MEASUREMENT_SETTINGS=24 ENHANCED_MEASUREMENT_SETTINGS value
                     * @property {number} ADSENSE_LINK=27 ADSENSE_LINK value
                     * @property {number} AUDIENCE=28 AUDIENCE value
                     * @property {number} EVENT_CREATE_RULE=29 EVENT_CREATE_RULE value
                     */
                    v1alpha.ChangeHistoryResourceType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "ACCOUNT"] = 1;
                        values[valuesById[2] = "PROPERTY"] = 2;
                        values[valuesById[6] = "FIREBASE_LINK"] = 6;
                        values[valuesById[7] = "GOOGLE_ADS_LINK"] = 7;
                        values[valuesById[8] = "GOOGLE_SIGNALS_SETTINGS"] = 8;
                        values[valuesById[9] = "CONVERSION_EVENT"] = 9;
                        values[valuesById[10] = "MEASUREMENT_PROTOCOL_SECRET"] = 10;
                        values[valuesById[11] = "CUSTOM_DIMENSION"] = 11;
                        values[valuesById[12] = "CUSTOM_METRIC"] = 12;
                        values[valuesById[13] = "DATA_RETENTION_SETTINGS"] = 13;
                        values[valuesById[14] = "DISPLAY_VIDEO_360_ADVERTISER_LINK"] = 14;
                        values[valuesById[15] = "DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL"] = 15;
                        values[valuesById[16] = "SEARCH_ADS_360_LINK"] = 16;
                        values[valuesById[18] = "DATA_STREAM"] = 18;
                        values[valuesById[20] = "ATTRIBUTION_SETTINGS"] = 20;
                        values[valuesById[21] = "EXPANDED_DATA_SET"] = 21;
                        values[valuesById[22] = "CHANNEL_GROUP"] = 22;
                        values[valuesById[24] = "ENHANCED_MEASUREMENT_SETTINGS"] = 24;
                        values[valuesById[27] = "ADSENSE_LINK"] = 27;
                        values[valuesById[28] = "AUDIENCE"] = 28;
                        values[valuesById[29] = "EVENT_CREATE_RULE"] = 29;
                        return values;
                    })();
    
                    /**
                     * GoogleSignalsState enum.
                     * @name google.analytics.admin.v1alpha.GoogleSignalsState
                     * @enum {number}
                     * @property {number} GOOGLE_SIGNALS_STATE_UNSPECIFIED=0 GOOGLE_SIGNALS_STATE_UNSPECIFIED value
                     * @property {number} GOOGLE_SIGNALS_ENABLED=1 GOOGLE_SIGNALS_ENABLED value
                     * @property {number} GOOGLE_SIGNALS_DISABLED=2 GOOGLE_SIGNALS_DISABLED value
                     */
                    v1alpha.GoogleSignalsState = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "GOOGLE_SIGNALS_STATE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "GOOGLE_SIGNALS_ENABLED"] = 1;
                        values[valuesById[2] = "GOOGLE_SIGNALS_DISABLED"] = 2;
                        return values;
                    })();
    
                    /**
                     * GoogleSignalsConsent enum.
                     * @name google.analytics.admin.v1alpha.GoogleSignalsConsent
                     * @enum {number}
                     * @property {number} GOOGLE_SIGNALS_CONSENT_UNSPECIFIED=0 GOOGLE_SIGNALS_CONSENT_UNSPECIFIED value
                     * @property {number} GOOGLE_SIGNALS_CONSENT_CONSENTED=2 GOOGLE_SIGNALS_CONSENT_CONSENTED value
                     * @property {number} GOOGLE_SIGNALS_CONSENT_NOT_CONSENTED=1 GOOGLE_SIGNALS_CONSENT_NOT_CONSENTED value
                     */
                    v1alpha.GoogleSignalsConsent = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "GOOGLE_SIGNALS_CONSENT_UNSPECIFIED"] = 0;
                        values[valuesById[2] = "GOOGLE_SIGNALS_CONSENT_CONSENTED"] = 2;
                        values[valuesById[1] = "GOOGLE_SIGNALS_CONSENT_NOT_CONSENTED"] = 1;
                        return values;
                    })();
    
                    /**
                     * LinkProposalInitiatingProduct enum.
                     * @name google.analytics.admin.v1alpha.LinkProposalInitiatingProduct
                     * @enum {number}
                     * @property {number} LINK_PROPOSAL_INITIATING_PRODUCT_UNSPECIFIED=0 LINK_PROPOSAL_INITIATING_PRODUCT_UNSPECIFIED value
                     * @property {number} GOOGLE_ANALYTICS=1 GOOGLE_ANALYTICS value
                     * @property {number} LINKED_PRODUCT=2 LINKED_PRODUCT value
                     */
                    v1alpha.LinkProposalInitiatingProduct = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "LINK_PROPOSAL_INITIATING_PRODUCT_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "GOOGLE_ANALYTICS"] = 1;
                        values[valuesById[2] = "LINKED_PRODUCT"] = 2;
                        return values;
                    })();
    
                    /**
                     * LinkProposalState enum.
                     * @name google.analytics.admin.v1alpha.LinkProposalState
                     * @enum {number}
                     * @property {number} LINK_PROPOSAL_STATE_UNSPECIFIED=0 LINK_PROPOSAL_STATE_UNSPECIFIED value
                     * @property {number} AWAITING_REVIEW_FROM_GOOGLE_ANALYTICS=1 AWAITING_REVIEW_FROM_GOOGLE_ANALYTICS value
                     * @property {number} AWAITING_REVIEW_FROM_LINKED_PRODUCT=2 AWAITING_REVIEW_FROM_LINKED_PRODUCT value
                     * @property {number} WITHDRAWN=3 WITHDRAWN value
                     * @property {number} DECLINED=4 DECLINED value
                     * @property {number} EXPIRED=5 EXPIRED value
                     * @property {number} OBSOLETE=6 OBSOLETE value
                     */
                    v1alpha.LinkProposalState = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "LINK_PROPOSAL_STATE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "AWAITING_REVIEW_FROM_GOOGLE_ANALYTICS"] = 1;
                        values[valuesById[2] = "AWAITING_REVIEW_FROM_LINKED_PRODUCT"] = 2;
                        values[valuesById[3] = "WITHDRAWN"] = 3;
                        values[valuesById[4] = "DECLINED"] = 4;
                        values[valuesById[5] = "EXPIRED"] = 5;
                        values[valuesById[6] = "OBSOLETE"] = 6;
                        return values;
                    })();
    
                    /**
                     * PropertyType enum.
                     * @name google.analytics.admin.v1alpha.PropertyType
                     * @enum {number}
                     * @property {number} PROPERTY_TYPE_UNSPECIFIED=0 PROPERTY_TYPE_UNSPECIFIED value
                     * @property {number} PROPERTY_TYPE_ORDINARY=1 PROPERTY_TYPE_ORDINARY value
                     * @property {number} PROPERTY_TYPE_SUBPROPERTY=2 PROPERTY_TYPE_SUBPROPERTY value
                     * @property {number} PROPERTY_TYPE_ROLLUP=3 PROPERTY_TYPE_ROLLUP value
                     */
                    v1alpha.PropertyType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "PROPERTY_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "PROPERTY_TYPE_ORDINARY"] = 1;
                        values[valuesById[2] = "PROPERTY_TYPE_SUBPROPERTY"] = 2;
                        values[valuesById[3] = "PROPERTY_TYPE_ROLLUP"] = 3;
                        return values;
                    })();
    
                    v1alpha.Account = (function() {
    
                        /**
                         * Properties of an Account.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccount
                         * @property {string|null} [name] Account name
                         * @property {google.protobuf.ITimestamp|null} [createTime] Account createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] Account updateTime
                         * @property {string|null} [displayName] Account displayName
                         * @property {string|null} [regionCode] Account regionCode
                         * @property {boolean|null} [deleted] Account deleted
                         */
    
                        /**
                         * Constructs a new Account.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an Account.
                         * @implements IAccount
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccount=} [properties] Properties to set
                         */
                        function Account(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Account name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @instance
                         */
                        Account.prototype.name = "";
    
                        /**
                         * Account createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @instance
                         */
                        Account.prototype.createTime = null;
    
                        /**
                         * Account updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @instance
                         */
                        Account.prototype.updateTime = null;
    
                        /**
                         * Account displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @instance
                         */
                        Account.prototype.displayName = "";
    
                        /**
                         * Account regionCode.
                         * @member {string} regionCode
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @instance
                         */
                        Account.prototype.regionCode = "";
    
                        /**
                         * Account deleted.
                         * @member {boolean} deleted
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @instance
                         */
                        Account.prototype.deleted = false;
    
                        /**
                         * Creates a new Account instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccount=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.Account} Account instance
                         */
                        Account.create = function create(properties) {
                            return new Account(properties);
                        };
    
                        /**
                         * Encodes the specified Account message. Does not implicitly {@link google.analytics.admin.v1alpha.Account.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccount} message Account message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Account.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.displayName);
                            if (message.regionCode != null && Object.hasOwnProperty.call(message, "regionCode"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.regionCode);
                            if (message.deleted != null && Object.hasOwnProperty.call(message, "deleted"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.deleted);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Account message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.Account.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccount} message Account message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Account.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Account message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.Account} Account
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Account.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.Account();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.regionCode = reader.string();
                                        break;
                                    }
                                case 6: {
                                        message.deleted = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Account message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.Account} Account
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Account.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Account message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Account.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.regionCode != null && message.hasOwnProperty("regionCode"))
                                if (!$util.isString(message.regionCode))
                                    return "regionCode: string expected";
                            if (message.deleted != null && message.hasOwnProperty("deleted"))
                                if (typeof message.deleted !== "boolean")
                                    return "deleted: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an Account message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.Account} Account
                         */
                        Account.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.Account)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.Account();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.Account.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.Account.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.regionCode != null)
                                message.regionCode = String(object.regionCode);
                            if (object.deleted != null)
                                message.deleted = Boolean(object.deleted);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Account message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {google.analytics.admin.v1alpha.Account} message Account
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Account.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.createTime = null;
                                object.updateTime = null;
                                object.displayName = "";
                                object.regionCode = "";
                                object.deleted = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.regionCode != null && message.hasOwnProperty("regionCode"))
                                object.regionCode = message.regionCode;
                            if (message.deleted != null && message.hasOwnProperty("deleted"))
                                object.deleted = message.deleted;
                            return object;
                        };
    
                        /**
                         * Converts this Account to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Account.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Account
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.Account
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Account.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.Account";
                        };
    
                        return Account;
                    })();
    
                    v1alpha.Property = (function() {
    
                        /**
                         * Properties of a Property.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IProperty
                         * @property {string|null} [name] Property name
                         * @property {google.analytics.admin.v1alpha.PropertyType|null} [propertyType] Property propertyType
                         * @property {google.protobuf.ITimestamp|null} [createTime] Property createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] Property updateTime
                         * @property {string|null} [parent] Property parent
                         * @property {string|null} [displayName] Property displayName
                         * @property {google.analytics.admin.v1alpha.IndustryCategory|null} [industryCategory] Property industryCategory
                         * @property {string|null} [timeZone] Property timeZone
                         * @property {string|null} [currencyCode] Property currencyCode
                         * @property {google.analytics.admin.v1alpha.ServiceLevel|null} [serviceLevel] Property serviceLevel
                         * @property {google.protobuf.ITimestamp|null} [deleteTime] Property deleteTime
                         * @property {google.protobuf.ITimestamp|null} [expireTime] Property expireTime
                         * @property {string|null} [account] Property account
                         */
    
                        /**
                         * Constructs a new Property.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a Property.
                         * @implements IProperty
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IProperty=} [properties] Properties to set
                         */
                        function Property(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Property name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.name = "";
    
                        /**
                         * Property propertyType.
                         * @member {google.analytics.admin.v1alpha.PropertyType} propertyType
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.propertyType = 0;
    
                        /**
                         * Property createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.createTime = null;
    
                        /**
                         * Property updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.updateTime = null;
    
                        /**
                         * Property parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.parent = "";
    
                        /**
                         * Property displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.displayName = "";
    
                        /**
                         * Property industryCategory.
                         * @member {google.analytics.admin.v1alpha.IndustryCategory} industryCategory
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.industryCategory = 0;
    
                        /**
                         * Property timeZone.
                         * @member {string} timeZone
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.timeZone = "";
    
                        /**
                         * Property currencyCode.
                         * @member {string} currencyCode
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.currencyCode = "";
    
                        /**
                         * Property serviceLevel.
                         * @member {google.analytics.admin.v1alpha.ServiceLevel} serviceLevel
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.serviceLevel = 0;
    
                        /**
                         * Property deleteTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} deleteTime
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.deleteTime = null;
    
                        /**
                         * Property expireTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} expireTime
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.expireTime = null;
    
                        /**
                         * Property account.
                         * @member {string} account
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         */
                        Property.prototype.account = "";
    
                        /**
                         * Creates a new Property instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProperty=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.Property} Property instance
                         */
                        Property.create = function create(properties) {
                            return new Property(properties);
                        };
    
                        /**
                         * Encodes the specified Property message. Does not implicitly {@link google.analytics.admin.v1alpha.Property.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProperty} message Property message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Property.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parent);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.displayName);
                            if (message.industryCategory != null && Object.hasOwnProperty.call(message, "industryCategory"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.industryCategory);
                            if (message.timeZone != null && Object.hasOwnProperty.call(message, "timeZone"))
                                writer.uint32(/* id 7, wireType 2 =*/58).string(message.timeZone);
                            if (message.currencyCode != null && Object.hasOwnProperty.call(message, "currencyCode"))
                                writer.uint32(/* id 8, wireType 2 =*/66).string(message.currencyCode);
                            if (message.serviceLevel != null && Object.hasOwnProperty.call(message, "serviceLevel"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.serviceLevel);
                            if (message.deleteTime != null && Object.hasOwnProperty.call(message, "deleteTime"))
                                $root.google.protobuf.Timestamp.encode(message.deleteTime, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.expireTime != null && Object.hasOwnProperty.call(message, "expireTime"))
                                $root.google.protobuf.Timestamp.encode(message.expireTime, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                writer.uint32(/* id 13, wireType 2 =*/106).string(message.account);
                            if (message.propertyType != null && Object.hasOwnProperty.call(message, "propertyType"))
                                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.propertyType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Property message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.Property.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {google.analytics.admin.v1alpha.IProperty} message Property message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Property.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Property message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.Property} Property
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Property.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.Property();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 14: {
                                        message.propertyType = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 6: {
                                        message.industryCategory = reader.int32();
                                        break;
                                    }
                                case 7: {
                                        message.timeZone = reader.string();
                                        break;
                                    }
                                case 8: {
                                        message.currencyCode = reader.string();
                                        break;
                                    }
                                case 10: {
                                        message.serviceLevel = reader.int32();
                                        break;
                                    }
                                case 11: {
                                        message.deleteTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 12: {
                                        message.expireTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 13: {
                                        message.account = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Property message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.Property} Property
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Property.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Property message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Property.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                switch (message.propertyType) {
                                default:
                                    return "propertyType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.industryCategory != null && message.hasOwnProperty("industryCategory"))
                                switch (message.industryCategory) {
                                default:
                                    return "industryCategory: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                    break;
                                }
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                if (!$util.isString(message.timeZone))
                                    return "timeZone: string expected";
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                if (!$util.isString(message.currencyCode))
                                    return "currencyCode: string expected";
                            if (message.serviceLevel != null && message.hasOwnProperty("serviceLevel"))
                                switch (message.serviceLevel) {
                                default:
                                    return "serviceLevel: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.deleteTime != null && message.hasOwnProperty("deleteTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.deleteTime);
                                if (error)
                                    return "deleteTime." + error;
                            }
                            if (message.expireTime != null && message.hasOwnProperty("expireTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.expireTime);
                                if (error)
                                    return "expireTime." + error;
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                if (!$util.isString(message.account))
                                    return "account: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a Property message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.Property} Property
                         */
                        Property.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.Property)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.Property();
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.propertyType) {
                            default:
                                if (typeof object.propertyType === "number") {
                                    message.propertyType = object.propertyType;
                                    break;
                                }
                                break;
                            case "PROPERTY_TYPE_UNSPECIFIED":
                            case 0:
                                message.propertyType = 0;
                                break;
                            case "PROPERTY_TYPE_ORDINARY":
                            case 1:
                                message.propertyType = 1;
                                break;
                            case "PROPERTY_TYPE_SUBPROPERTY":
                            case 2:
                                message.propertyType = 2;
                                break;
                            case "PROPERTY_TYPE_ROLLUP":
                            case 3:
                                message.propertyType = 3;
                                break;
                            }
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.Property.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.Property.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            switch (object.industryCategory) {
                            default:
                                if (typeof object.industryCategory === "number") {
                                    message.industryCategory = object.industryCategory;
                                    break;
                                }
                                break;
                            case "INDUSTRY_CATEGORY_UNSPECIFIED":
                            case 0:
                                message.industryCategory = 0;
                                break;
                            case "AUTOMOTIVE":
                            case 1:
                                message.industryCategory = 1;
                                break;
                            case "BUSINESS_AND_INDUSTRIAL_MARKETS":
                            case 2:
                                message.industryCategory = 2;
                                break;
                            case "FINANCE":
                            case 3:
                                message.industryCategory = 3;
                                break;
                            case "HEALTHCARE":
                            case 4:
                                message.industryCategory = 4;
                                break;
                            case "TECHNOLOGY":
                            case 5:
                                message.industryCategory = 5;
                                break;
                            case "TRAVEL":
                            case 6:
                                message.industryCategory = 6;
                                break;
                            case "OTHER":
                            case 7:
                                message.industryCategory = 7;
                                break;
                            case "ARTS_AND_ENTERTAINMENT":
                            case 8:
                                message.industryCategory = 8;
                                break;
                            case "BEAUTY_AND_FITNESS":
                            case 9:
                                message.industryCategory = 9;
                                break;
                            case "BOOKS_AND_LITERATURE":
                            case 10:
                                message.industryCategory = 10;
                                break;
                            case "FOOD_AND_DRINK":
                            case 11:
                                message.industryCategory = 11;
                                break;
                            case "GAMES":
                            case 12:
                                message.industryCategory = 12;
                                break;
                            case "HOBBIES_AND_LEISURE":
                            case 13:
                                message.industryCategory = 13;
                                break;
                            case "HOME_AND_GARDEN":
                            case 14:
                                message.industryCategory = 14;
                                break;
                            case "INTERNET_AND_TELECOM":
                            case 15:
                                message.industryCategory = 15;
                                break;
                            case "LAW_AND_GOVERNMENT":
                            case 16:
                                message.industryCategory = 16;
                                break;
                            case "NEWS":
                            case 17:
                                message.industryCategory = 17;
                                break;
                            case "ONLINE_COMMUNITIES":
                            case 18:
                                message.industryCategory = 18;
                                break;
                            case "PEOPLE_AND_SOCIETY":
                            case 19:
                                message.industryCategory = 19;
                                break;
                            case "PETS_AND_ANIMALS":
                            case 20:
                                message.industryCategory = 20;
                                break;
                            case "REAL_ESTATE":
                            case 21:
                                message.industryCategory = 21;
                                break;
                            case "REFERENCE":
                            case 22:
                                message.industryCategory = 22;
                                break;
                            case "SCIENCE":
                            case 23:
                                message.industryCategory = 23;
                                break;
                            case "SPORTS":
                            case 24:
                                message.industryCategory = 24;
                                break;
                            case "JOBS_AND_EDUCATION":
                            case 25:
                                message.industryCategory = 25;
                                break;
                            case "SHOPPING":
                            case 26:
                                message.industryCategory = 26;
                                break;
                            }
                            if (object.timeZone != null)
                                message.timeZone = String(object.timeZone);
                            if (object.currencyCode != null)
                                message.currencyCode = String(object.currencyCode);
                            switch (object.serviceLevel) {
                            default:
                                if (typeof object.serviceLevel === "number") {
                                    message.serviceLevel = object.serviceLevel;
                                    break;
                                }
                                break;
                            case "SERVICE_LEVEL_UNSPECIFIED":
                            case 0:
                                message.serviceLevel = 0;
                                break;
                            case "GOOGLE_ANALYTICS_STANDARD":
                            case 1:
                                message.serviceLevel = 1;
                                break;
                            case "GOOGLE_ANALYTICS_360":
                            case 2:
                                message.serviceLevel = 2;
                                break;
                            }
                            if (object.deleteTime != null) {
                                if (typeof object.deleteTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.Property.deleteTime: object expected");
                                message.deleteTime = $root.google.protobuf.Timestamp.fromObject(object.deleteTime);
                            }
                            if (object.expireTime != null) {
                                if (typeof object.expireTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.Property.expireTime: object expected");
                                message.expireTime = $root.google.protobuf.Timestamp.fromObject(object.expireTime);
                            }
                            if (object.account != null)
                                message.account = String(object.account);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Property message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {google.analytics.admin.v1alpha.Property} message Property
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Property.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.parent = "";
                                object.createTime = null;
                                object.updateTime = null;
                                object.displayName = "";
                                object.industryCategory = options.enums === String ? "INDUSTRY_CATEGORY_UNSPECIFIED" : 0;
                                object.timeZone = "";
                                object.currencyCode = "";
                                object.serviceLevel = options.enums === String ? "SERVICE_LEVEL_UNSPECIFIED" : 0;
                                object.deleteTime = null;
                                object.expireTime = null;
                                object.account = "";
                                object.propertyType = options.enums === String ? "PROPERTY_TYPE_UNSPECIFIED" : 0;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.industryCategory != null && message.hasOwnProperty("industryCategory"))
                                object.industryCategory = options.enums === String ? $root.google.analytics.admin.v1alpha.IndustryCategory[message.industryCategory] === undefined ? message.industryCategory : $root.google.analytics.admin.v1alpha.IndustryCategory[message.industryCategory] : message.industryCategory;
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                object.timeZone = message.timeZone;
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = message.currencyCode;
                            if (message.serviceLevel != null && message.hasOwnProperty("serviceLevel"))
                                object.serviceLevel = options.enums === String ? $root.google.analytics.admin.v1alpha.ServiceLevel[message.serviceLevel] === undefined ? message.serviceLevel : $root.google.analytics.admin.v1alpha.ServiceLevel[message.serviceLevel] : message.serviceLevel;
                            if (message.deleteTime != null && message.hasOwnProperty("deleteTime"))
                                object.deleteTime = $root.google.protobuf.Timestamp.toObject(message.deleteTime, options);
                            if (message.expireTime != null && message.hasOwnProperty("expireTime"))
                                object.expireTime = $root.google.protobuf.Timestamp.toObject(message.expireTime, options);
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = message.account;
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                object.propertyType = options.enums === String ? $root.google.analytics.admin.v1alpha.PropertyType[message.propertyType] === undefined ? message.propertyType : $root.google.analytics.admin.v1alpha.PropertyType[message.propertyType] : message.propertyType;
                            return object;
                        };
    
                        /**
                         * Converts this Property to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Property.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Property
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.Property
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Property.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.Property";
                        };
    
                        return Property;
                    })();
    
                    v1alpha.DataStream = (function() {
    
                        /**
                         * Properties of a DataStream.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDataStream
                         * @property {google.analytics.admin.v1alpha.DataStream.IWebStreamData|null} [webStreamData] DataStream webStreamData
                         * @property {google.analytics.admin.v1alpha.DataStream.IAndroidAppStreamData|null} [androidAppStreamData] DataStream androidAppStreamData
                         * @property {google.analytics.admin.v1alpha.DataStream.IIosAppStreamData|null} [iosAppStreamData] DataStream iosAppStreamData
                         * @property {string|null} [name] DataStream name
                         * @property {google.analytics.admin.v1alpha.DataStream.DataStreamType|null} [type] DataStream type
                         * @property {string|null} [displayName] DataStream displayName
                         * @property {google.protobuf.ITimestamp|null} [createTime] DataStream createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] DataStream updateTime
                         */
    
                        /**
                         * Constructs a new DataStream.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DataStream.
                         * @implements IDataStream
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDataStream=} [properties] Properties to set
                         */
                        function DataStream(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DataStream webStreamData.
                         * @member {google.analytics.admin.v1alpha.DataStream.IWebStreamData|null|undefined} webStreamData
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.webStreamData = null;
    
                        /**
                         * DataStream androidAppStreamData.
                         * @member {google.analytics.admin.v1alpha.DataStream.IAndroidAppStreamData|null|undefined} androidAppStreamData
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.androidAppStreamData = null;
    
                        /**
                         * DataStream iosAppStreamData.
                         * @member {google.analytics.admin.v1alpha.DataStream.IIosAppStreamData|null|undefined} iosAppStreamData
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.iosAppStreamData = null;
    
                        /**
                         * DataStream name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.name = "";
    
                        /**
                         * DataStream type.
                         * @member {google.analytics.admin.v1alpha.DataStream.DataStreamType} type
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.type = 0;
    
                        /**
                         * DataStream displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.displayName = "";
    
                        /**
                         * DataStream createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.createTime = null;
    
                        /**
                         * DataStream updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        DataStream.prototype.updateTime = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DataStream streamData.
                         * @member {"webStreamData"|"androidAppStreamData"|"iosAppStreamData"|undefined} streamData
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         */
                        Object.defineProperty(DataStream.prototype, "streamData", {
                            get: $util.oneOfGetter($oneOfFields = ["webStreamData", "androidAppStreamData", "iosAppStreamData"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DataStream instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataStream=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DataStream} DataStream instance
                         */
                        DataStream.create = function create(properties) {
                            return new DataStream(properties);
                        };
    
                        /**
                         * Encodes the specified DataStream message. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataStream} message DataStream message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataStream.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.webStreamData != null && Object.hasOwnProperty.call(message, "webStreamData"))
                                $root.google.analytics.admin.v1alpha.DataStream.WebStreamData.encode(message.webStreamData, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.androidAppStreamData != null && Object.hasOwnProperty.call(message, "androidAppStreamData"))
                                $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData.encode(message.androidAppStreamData, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.iosAppStreamData != null && Object.hasOwnProperty.call(message, "iosAppStreamData"))
                                $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData.encode(message.iosAppStreamData, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DataStream message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataStream} message DataStream message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataStream.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DataStream message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DataStream} DataStream
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataStream.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DataStream();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 6: {
                                        message.webStreamData = $root.google.analytics.admin.v1alpha.DataStream.WebStreamData.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.androidAppStreamData = $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 8: {
                                        message.iosAppStreamData = $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.type = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DataStream message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DataStream} DataStream
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataStream.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DataStream message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DataStream.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.webStreamData != null && message.hasOwnProperty("webStreamData")) {
                                properties.streamData = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.DataStream.WebStreamData.verify(message.webStreamData);
                                    if (error)
                                        return "webStreamData." + error;
                                }
                            }
                            if (message.androidAppStreamData != null && message.hasOwnProperty("androidAppStreamData")) {
                                if (properties.streamData === 1)
                                    return "streamData: multiple values";
                                properties.streamData = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData.verify(message.androidAppStreamData);
                                    if (error)
                                        return "androidAppStreamData." + error;
                                }
                            }
                            if (message.iosAppStreamData != null && message.hasOwnProperty("iosAppStreamData")) {
                                if (properties.streamData === 1)
                                    return "streamData: multiple values";
                                properties.streamData = 1;
                                {
                                    var error = $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData.verify(message.iosAppStreamData);
                                    if (error)
                                        return "iosAppStreamData." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DataStream message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DataStream} DataStream
                         */
                        DataStream.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DataStream)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DataStream();
                            if (object.webStreamData != null) {
                                if (typeof object.webStreamData !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DataStream.webStreamData: object expected");
                                message.webStreamData = $root.google.analytics.admin.v1alpha.DataStream.WebStreamData.fromObject(object.webStreamData);
                            }
                            if (object.androidAppStreamData != null) {
                                if (typeof object.androidAppStreamData !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DataStream.androidAppStreamData: object expected");
                                message.androidAppStreamData = $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData.fromObject(object.androidAppStreamData);
                            }
                            if (object.iosAppStreamData != null) {
                                if (typeof object.iosAppStreamData !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DataStream.iosAppStreamData: object expected");
                                message.iosAppStreamData = $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData.fromObject(object.iosAppStreamData);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.type) {
                            default:
                                if (typeof object.type === "number") {
                                    message.type = object.type;
                                    break;
                                }
                                break;
                            case "DATA_STREAM_TYPE_UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "WEB_DATA_STREAM":
                            case 1:
                                message.type = 1;
                                break;
                            case "ANDROID_APP_DATA_STREAM":
                            case 2:
                                message.type = 2;
                                break;
                            case "IOS_APP_DATA_STREAM":
                            case 3:
                                message.type = 3;
                                break;
                            }
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DataStream.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DataStream.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DataStream message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {google.analytics.admin.v1alpha.DataStream} message DataStream
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DataStream.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.type = options.enums === String ? "DATA_STREAM_TYPE_UNSPECIFIED" : 0;
                                object.displayName = "";
                                object.createTime = null;
                                object.updateTime = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.analytics.admin.v1alpha.DataStream.DataStreamType[message.type] === undefined ? message.type : $root.google.analytics.admin.v1alpha.DataStream.DataStreamType[message.type] : message.type;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.webStreamData != null && message.hasOwnProperty("webStreamData")) {
                                object.webStreamData = $root.google.analytics.admin.v1alpha.DataStream.WebStreamData.toObject(message.webStreamData, options);
                                if (options.oneofs)
                                    object.streamData = "webStreamData";
                            }
                            if (message.androidAppStreamData != null && message.hasOwnProperty("androidAppStreamData")) {
                                object.androidAppStreamData = $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData.toObject(message.androidAppStreamData, options);
                                if (options.oneofs)
                                    object.streamData = "androidAppStreamData";
                            }
                            if (message.iosAppStreamData != null && message.hasOwnProperty("iosAppStreamData")) {
                                object.iosAppStreamData = $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData.toObject(message.iosAppStreamData, options);
                                if (options.oneofs)
                                    object.streamData = "iosAppStreamData";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DataStream to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DataStream.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DataStream
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DataStream
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DataStream.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DataStream";
                        };
    
                        DataStream.WebStreamData = (function() {
    
                            /**
                             * Properties of a WebStreamData.
                             * @memberof google.analytics.admin.v1alpha.DataStream
                             * @interface IWebStreamData
                             * @property {string|null} [measurementId] WebStreamData measurementId
                             * @property {string|null} [firebaseAppId] WebStreamData firebaseAppId
                             * @property {string|null} [defaultUri] WebStreamData defaultUri
                             */
    
                            /**
                             * Constructs a new WebStreamData.
                             * @memberof google.analytics.admin.v1alpha.DataStream
                             * @classdesc Represents a WebStreamData.
                             * @implements IWebStreamData
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.DataStream.IWebStreamData=} [properties] Properties to set
                             */
                            function WebStreamData(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * WebStreamData measurementId.
                             * @member {string} measurementId
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @instance
                             */
                            WebStreamData.prototype.measurementId = "";
    
                            /**
                             * WebStreamData firebaseAppId.
                             * @member {string} firebaseAppId
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @instance
                             */
                            WebStreamData.prototype.firebaseAppId = "";
    
                            /**
                             * WebStreamData defaultUri.
                             * @member {string} defaultUri
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @instance
                             */
                            WebStreamData.prototype.defaultUri = "";
    
                            /**
                             * Creates a new WebStreamData instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IWebStreamData=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.DataStream.WebStreamData} WebStreamData instance
                             */
                            WebStreamData.create = function create(properties) {
                                return new WebStreamData(properties);
                            };
    
                            /**
                             * Encodes the specified WebStreamData message. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.WebStreamData.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IWebStreamData} message WebStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            WebStreamData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.measurementId != null && Object.hasOwnProperty.call(message, "measurementId"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.measurementId);
                                if (message.firebaseAppId != null && Object.hasOwnProperty.call(message, "firebaseAppId"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.firebaseAppId);
                                if (message.defaultUri != null && Object.hasOwnProperty.call(message, "defaultUri"))
                                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.defaultUri);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified WebStreamData message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.WebStreamData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IWebStreamData} message WebStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            WebStreamData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a WebStreamData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.DataStream.WebStreamData} WebStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            WebStreamData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DataStream.WebStreamData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.measurementId = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.firebaseAppId = reader.string();
                                            break;
                                        }
                                    case 3: {
                                            message.defaultUri = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a WebStreamData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.DataStream.WebStreamData} WebStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            WebStreamData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a WebStreamData message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            WebStreamData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.measurementId != null && message.hasOwnProperty("measurementId"))
                                    if (!$util.isString(message.measurementId))
                                        return "measurementId: string expected";
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    if (!$util.isString(message.firebaseAppId))
                                        return "firebaseAppId: string expected";
                                if (message.defaultUri != null && message.hasOwnProperty("defaultUri"))
                                    if (!$util.isString(message.defaultUri))
                                        return "defaultUri: string expected";
                                return null;
                            };
    
                            /**
                             * Creates a WebStreamData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.DataStream.WebStreamData} WebStreamData
                             */
                            WebStreamData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.DataStream.WebStreamData)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.DataStream.WebStreamData();
                                if (object.measurementId != null)
                                    message.measurementId = String(object.measurementId);
                                if (object.firebaseAppId != null)
                                    message.firebaseAppId = String(object.firebaseAppId);
                                if (object.defaultUri != null)
                                    message.defaultUri = String(object.defaultUri);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a WebStreamData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.WebStreamData} message WebStreamData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            WebStreamData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.measurementId = "";
                                    object.firebaseAppId = "";
                                    object.defaultUri = "";
                                }
                                if (message.measurementId != null && message.hasOwnProperty("measurementId"))
                                    object.measurementId = message.measurementId;
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    object.firebaseAppId = message.firebaseAppId;
                                if (message.defaultUri != null && message.hasOwnProperty("defaultUri"))
                                    object.defaultUri = message.defaultUri;
                                return object;
                            };
    
                            /**
                             * Converts this WebStreamData to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            WebStreamData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for WebStreamData
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.DataStream.WebStreamData
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            WebStreamData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.DataStream.WebStreamData";
                            };
    
                            return WebStreamData;
                        })();
    
                        DataStream.AndroidAppStreamData = (function() {
    
                            /**
                             * Properties of an AndroidAppStreamData.
                             * @memberof google.analytics.admin.v1alpha.DataStream
                             * @interface IAndroidAppStreamData
                             * @property {string|null} [firebaseAppId] AndroidAppStreamData firebaseAppId
                             * @property {string|null} [packageName] AndroidAppStreamData packageName
                             */
    
                            /**
                             * Constructs a new AndroidAppStreamData.
                             * @memberof google.analytics.admin.v1alpha.DataStream
                             * @classdesc Represents an AndroidAppStreamData.
                             * @implements IAndroidAppStreamData
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.DataStream.IAndroidAppStreamData=} [properties] Properties to set
                             */
                            function AndroidAppStreamData(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * AndroidAppStreamData firebaseAppId.
                             * @member {string} firebaseAppId
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @instance
                             */
                            AndroidAppStreamData.prototype.firebaseAppId = "";
    
                            /**
                             * AndroidAppStreamData packageName.
                             * @member {string} packageName
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @instance
                             */
                            AndroidAppStreamData.prototype.packageName = "";
    
                            /**
                             * Creates a new AndroidAppStreamData instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IAndroidAppStreamData=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData} AndroidAppStreamData instance
                             */
                            AndroidAppStreamData.create = function create(properties) {
                                return new AndroidAppStreamData(properties);
                            };
    
                            /**
                             * Encodes the specified AndroidAppStreamData message. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IAndroidAppStreamData} message AndroidAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AndroidAppStreamData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.firebaseAppId != null && Object.hasOwnProperty.call(message, "firebaseAppId"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.firebaseAppId);
                                if (message.packageName != null && Object.hasOwnProperty.call(message, "packageName"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.packageName);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified AndroidAppStreamData message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IAndroidAppStreamData} message AndroidAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AndroidAppStreamData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an AndroidAppStreamData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData} AndroidAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AndroidAppStreamData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.firebaseAppId = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.packageName = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an AndroidAppStreamData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData} AndroidAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AndroidAppStreamData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an AndroidAppStreamData message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            AndroidAppStreamData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    if (!$util.isString(message.firebaseAppId))
                                        return "firebaseAppId: string expected";
                                if (message.packageName != null && message.hasOwnProperty("packageName"))
                                    if (!$util.isString(message.packageName))
                                        return "packageName: string expected";
                                return null;
                            };
    
                            /**
                             * Creates an AndroidAppStreamData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData} AndroidAppStreamData
                             */
                            AndroidAppStreamData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData();
                                if (object.firebaseAppId != null)
                                    message.firebaseAppId = String(object.firebaseAppId);
                                if (object.packageName != null)
                                    message.packageName = String(object.packageName);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an AndroidAppStreamData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData} message AndroidAppStreamData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            AndroidAppStreamData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.firebaseAppId = "";
                                    object.packageName = "";
                                }
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    object.firebaseAppId = message.firebaseAppId;
                                if (message.packageName != null && message.hasOwnProperty("packageName"))
                                    object.packageName = message.packageName;
                                return object;
                            };
    
                            /**
                             * Converts this AndroidAppStreamData to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            AndroidAppStreamData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for AndroidAppStreamData
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            AndroidAppStreamData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.DataStream.AndroidAppStreamData";
                            };
    
                            return AndroidAppStreamData;
                        })();
    
                        DataStream.IosAppStreamData = (function() {
    
                            /**
                             * Properties of an IosAppStreamData.
                             * @memberof google.analytics.admin.v1alpha.DataStream
                             * @interface IIosAppStreamData
                             * @property {string|null} [firebaseAppId] IosAppStreamData firebaseAppId
                             * @property {string|null} [bundleId] IosAppStreamData bundleId
                             */
    
                            /**
                             * Constructs a new IosAppStreamData.
                             * @memberof google.analytics.admin.v1alpha.DataStream
                             * @classdesc Represents an IosAppStreamData.
                             * @implements IIosAppStreamData
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.DataStream.IIosAppStreamData=} [properties] Properties to set
                             */
                            function IosAppStreamData(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * IosAppStreamData firebaseAppId.
                             * @member {string} firebaseAppId
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @instance
                             */
                            IosAppStreamData.prototype.firebaseAppId = "";
    
                            /**
                             * IosAppStreamData bundleId.
                             * @member {string} bundleId
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @instance
                             */
                            IosAppStreamData.prototype.bundleId = "";
    
                            /**
                             * Creates a new IosAppStreamData instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IIosAppStreamData=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.DataStream.IosAppStreamData} IosAppStreamData instance
                             */
                            IosAppStreamData.create = function create(properties) {
                                return new IosAppStreamData(properties);
                            };
    
                            /**
                             * Encodes the specified IosAppStreamData message. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.IosAppStreamData.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IIosAppStreamData} message IosAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            IosAppStreamData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.firebaseAppId != null && Object.hasOwnProperty.call(message, "firebaseAppId"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.firebaseAppId);
                                if (message.bundleId != null && Object.hasOwnProperty.call(message, "bundleId"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.bundleId);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified IosAppStreamData message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DataStream.IosAppStreamData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IIosAppStreamData} message IosAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            IosAppStreamData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an IosAppStreamData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.DataStream.IosAppStreamData} IosAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            IosAppStreamData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.firebaseAppId = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.bundleId = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an IosAppStreamData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.DataStream.IosAppStreamData} IosAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            IosAppStreamData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an IosAppStreamData message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            IosAppStreamData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    if (!$util.isString(message.firebaseAppId))
                                        return "firebaseAppId: string expected";
                                if (message.bundleId != null && message.hasOwnProperty("bundleId"))
                                    if (!$util.isString(message.bundleId))
                                        return "bundleId: string expected";
                                return null;
                            };
    
                            /**
                             * Creates an IosAppStreamData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.DataStream.IosAppStreamData} IosAppStreamData
                             */
                            IosAppStreamData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.DataStream.IosAppStreamData();
                                if (object.firebaseAppId != null)
                                    message.firebaseAppId = String(object.firebaseAppId);
                                if (object.bundleId != null)
                                    message.bundleId = String(object.bundleId);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an IosAppStreamData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1alpha.DataStream.IosAppStreamData} message IosAppStreamData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            IosAppStreamData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.firebaseAppId = "";
                                    object.bundleId = "";
                                }
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    object.firebaseAppId = message.firebaseAppId;
                                if (message.bundleId != null && message.hasOwnProperty("bundleId"))
                                    object.bundleId = message.bundleId;
                                return object;
                            };
    
                            /**
                             * Converts this IosAppStreamData to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            IosAppStreamData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for IosAppStreamData
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.DataStream.IosAppStreamData
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            IosAppStreamData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.DataStream.IosAppStreamData";
                            };
    
                            return IosAppStreamData;
                        })();
    
                        /**
                         * DataStreamType enum.
                         * @name google.analytics.admin.v1alpha.DataStream.DataStreamType
                         * @enum {number}
                         * @property {number} DATA_STREAM_TYPE_UNSPECIFIED=0 DATA_STREAM_TYPE_UNSPECIFIED value
                         * @property {number} WEB_DATA_STREAM=1 WEB_DATA_STREAM value
                         * @property {number} ANDROID_APP_DATA_STREAM=2 ANDROID_APP_DATA_STREAM value
                         * @property {number} IOS_APP_DATA_STREAM=3 IOS_APP_DATA_STREAM value
                         */
                        DataStream.DataStreamType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "DATA_STREAM_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "WEB_DATA_STREAM"] = 1;
                            values[valuesById[2] = "ANDROID_APP_DATA_STREAM"] = 2;
                            values[valuesById[3] = "IOS_APP_DATA_STREAM"] = 3;
                            return values;
                        })();
    
                        return DataStream;
                    })();
    
                    v1alpha.UserLink = (function() {
    
                        /**
                         * Properties of a UserLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IUserLink
                         * @property {string|null} [name] UserLink name
                         * @property {string|null} [emailAddress] UserLink emailAddress
                         * @property {Array.<string>|null} [directRoles] UserLink directRoles
                         */
    
                        /**
                         * Constructs a new UserLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a UserLink.
                         * @implements IUserLink
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IUserLink=} [properties] Properties to set
                         */
                        function UserLink(properties) {
                            this.directRoles = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UserLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @instance
                         */
                        UserLink.prototype.name = "";
    
                        /**
                         * UserLink emailAddress.
                         * @member {string} emailAddress
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @instance
                         */
                        UserLink.prototype.emailAddress = "";
    
                        /**
                         * UserLink directRoles.
                         * @member {Array.<string>} directRoles
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @instance
                         */
                        UserLink.prototype.directRoles = $util.emptyArray;
    
                        /**
                         * Creates a new UserLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUserLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.UserLink} UserLink instance
                         */
                        UserLink.create = function create(properties) {
                            return new UserLink(properties);
                        };
    
                        /**
                         * Encodes the specified UserLink message. Does not implicitly {@link google.analytics.admin.v1alpha.UserLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUserLink} message UserLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.emailAddress != null && Object.hasOwnProperty.call(message, "emailAddress"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.emailAddress);
                            if (message.directRoles != null && message.directRoles.length)
                                for (var i = 0; i < message.directRoles.length; ++i)
                                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.directRoles[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UserLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.UserLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IUserLink} message UserLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UserLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a UserLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.UserLink} UserLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.UserLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.emailAddress = reader.string();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.directRoles && message.directRoles.length))
                                            message.directRoles = [];
                                        message.directRoles.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a UserLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.UserLink} UserLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UserLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a UserLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UserLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.emailAddress != null && message.hasOwnProperty("emailAddress"))
                                if (!$util.isString(message.emailAddress))
                                    return "emailAddress: string expected";
                            if (message.directRoles != null && message.hasOwnProperty("directRoles")) {
                                if (!Array.isArray(message.directRoles))
                                    return "directRoles: array expected";
                                for (var i = 0; i < message.directRoles.length; ++i)
                                    if (!$util.isString(message.directRoles[i]))
                                        return "directRoles: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a UserLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.UserLink} UserLink
                         */
                        UserLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.UserLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.UserLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.emailAddress != null)
                                message.emailAddress = String(object.emailAddress);
                            if (object.directRoles) {
                                if (!Array.isArray(object.directRoles))
                                    throw TypeError(".google.analytics.admin.v1alpha.UserLink.directRoles: array expected");
                                message.directRoles = [];
                                for (var i = 0; i < object.directRoles.length; ++i)
                                    message.directRoles[i] = String(object.directRoles[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a UserLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.UserLink} message UserLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UserLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.directRoles = [];
                            if (options.defaults) {
                                object.name = "";
                                object.emailAddress = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.emailAddress != null && message.hasOwnProperty("emailAddress"))
                                object.emailAddress = message.emailAddress;
                            if (message.directRoles && message.directRoles.length) {
                                object.directRoles = [];
                                for (var j = 0; j < message.directRoles.length; ++j)
                                    object.directRoles[j] = message.directRoles[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UserLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UserLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UserLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.UserLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UserLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.UserLink";
                        };
    
                        return UserLink;
                    })();
    
                    v1alpha.AuditUserLink = (function() {
    
                        /**
                         * Properties of an AuditUserLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAuditUserLink
                         * @property {string|null} [name] AuditUserLink name
                         * @property {string|null} [emailAddress] AuditUserLink emailAddress
                         * @property {Array.<string>|null} [directRoles] AuditUserLink directRoles
                         * @property {Array.<string>|null} [effectiveRoles] AuditUserLink effectiveRoles
                         */
    
                        /**
                         * Constructs a new AuditUserLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AuditUserLink.
                         * @implements IAuditUserLink
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAuditUserLink=} [properties] Properties to set
                         */
                        function AuditUserLink(properties) {
                            this.directRoles = [];
                            this.effectiveRoles = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AuditUserLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @instance
                         */
                        AuditUserLink.prototype.name = "";
    
                        /**
                         * AuditUserLink emailAddress.
                         * @member {string} emailAddress
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @instance
                         */
                        AuditUserLink.prototype.emailAddress = "";
    
                        /**
                         * AuditUserLink directRoles.
                         * @member {Array.<string>} directRoles
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @instance
                         */
                        AuditUserLink.prototype.directRoles = $util.emptyArray;
    
                        /**
                         * AuditUserLink effectiveRoles.
                         * @member {Array.<string>} effectiveRoles
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @instance
                         */
                        AuditUserLink.prototype.effectiveRoles = $util.emptyArray;
    
                        /**
                         * Creates a new AuditUserLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AuditUserLink} AuditUserLink instance
                         */
                        AuditUserLink.create = function create(properties) {
                            return new AuditUserLink(properties);
                        };
    
                        /**
                         * Encodes the specified AuditUserLink message. Does not implicitly {@link google.analytics.admin.v1alpha.AuditUserLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLink} message AuditUserLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditUserLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.emailAddress != null && Object.hasOwnProperty.call(message, "emailAddress"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.emailAddress);
                            if (message.directRoles != null && message.directRoles.length)
                                for (var i = 0; i < message.directRoles.length; ++i)
                                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.directRoles[i]);
                            if (message.effectiveRoles != null && message.effectiveRoles.length)
                                for (var i = 0; i < message.effectiveRoles.length; ++i)
                                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.effectiveRoles[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AuditUserLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AuditUserLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAuditUserLink} message AuditUserLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditUserLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AuditUserLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AuditUserLink} AuditUserLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditUserLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AuditUserLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.emailAddress = reader.string();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.directRoles && message.directRoles.length))
                                            message.directRoles = [];
                                        message.directRoles.push(reader.string());
                                        break;
                                    }
                                case 4: {
                                        if (!(message.effectiveRoles && message.effectiveRoles.length))
                                            message.effectiveRoles = [];
                                        message.effectiveRoles.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AuditUserLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AuditUserLink} AuditUserLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditUserLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AuditUserLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuditUserLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.emailAddress != null && message.hasOwnProperty("emailAddress"))
                                if (!$util.isString(message.emailAddress))
                                    return "emailAddress: string expected";
                            if (message.directRoles != null && message.hasOwnProperty("directRoles")) {
                                if (!Array.isArray(message.directRoles))
                                    return "directRoles: array expected";
                                for (var i = 0; i < message.directRoles.length; ++i)
                                    if (!$util.isString(message.directRoles[i]))
                                        return "directRoles: string[] expected";
                            }
                            if (message.effectiveRoles != null && message.hasOwnProperty("effectiveRoles")) {
                                if (!Array.isArray(message.effectiveRoles))
                                    return "effectiveRoles: array expected";
                                for (var i = 0; i < message.effectiveRoles.length; ++i)
                                    if (!$util.isString(message.effectiveRoles[i]))
                                        return "effectiveRoles: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AuditUserLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AuditUserLink} AuditUserLink
                         */
                        AuditUserLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AuditUserLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AuditUserLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.emailAddress != null)
                                message.emailAddress = String(object.emailAddress);
                            if (object.directRoles) {
                                if (!Array.isArray(object.directRoles))
                                    throw TypeError(".google.analytics.admin.v1alpha.AuditUserLink.directRoles: array expected");
                                message.directRoles = [];
                                for (var i = 0; i < object.directRoles.length; ++i)
                                    message.directRoles[i] = String(object.directRoles[i]);
                            }
                            if (object.effectiveRoles) {
                                if (!Array.isArray(object.effectiveRoles))
                                    throw TypeError(".google.analytics.admin.v1alpha.AuditUserLink.effectiveRoles: array expected");
                                message.effectiveRoles = [];
                                for (var i = 0; i < object.effectiveRoles.length; ++i)
                                    message.effectiveRoles[i] = String(object.effectiveRoles[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AuditUserLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.AuditUserLink} message AuditUserLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuditUserLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.directRoles = [];
                                object.effectiveRoles = [];
                            }
                            if (options.defaults) {
                                object.name = "";
                                object.emailAddress = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.emailAddress != null && message.hasOwnProperty("emailAddress"))
                                object.emailAddress = message.emailAddress;
                            if (message.directRoles && message.directRoles.length) {
                                object.directRoles = [];
                                for (var j = 0; j < message.directRoles.length; ++j)
                                    object.directRoles[j] = message.directRoles[j];
                            }
                            if (message.effectiveRoles && message.effectiveRoles.length) {
                                object.effectiveRoles = [];
                                for (var j = 0; j < message.effectiveRoles.length; ++j)
                                    object.effectiveRoles[j] = message.effectiveRoles[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AuditUserLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuditUserLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AuditUserLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AuditUserLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AuditUserLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AuditUserLink";
                        };
    
                        return AuditUserLink;
                    })();
    
                    v1alpha.FirebaseLink = (function() {
    
                        /**
                         * Properties of a FirebaseLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IFirebaseLink
                         * @property {string|null} [name] FirebaseLink name
                         * @property {string|null} [project] FirebaseLink project
                         * @property {google.protobuf.ITimestamp|null} [createTime] FirebaseLink createTime
                         */
    
                        /**
                         * Constructs a new FirebaseLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a FirebaseLink.
                         * @implements IFirebaseLink
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IFirebaseLink=} [properties] Properties to set
                         */
                        function FirebaseLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirebaseLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @instance
                         */
                        FirebaseLink.prototype.name = "";
    
                        /**
                         * FirebaseLink project.
                         * @member {string} project
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @instance
                         */
                        FirebaseLink.prototype.project = "";
    
                        /**
                         * FirebaseLink createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @instance
                         */
                        FirebaseLink.prototype.createTime = null;
    
                        /**
                         * Creates a new FirebaseLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFirebaseLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.FirebaseLink} FirebaseLink instance
                         */
                        FirebaseLink.create = function create(properties) {
                            return new FirebaseLink(properties);
                        };
    
                        /**
                         * Encodes the specified FirebaseLink message. Does not implicitly {@link google.analytics.admin.v1alpha.FirebaseLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFirebaseLink} message FirebaseLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirebaseLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.project);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirebaseLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.FirebaseLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IFirebaseLink} message FirebaseLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirebaseLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirebaseLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.FirebaseLink} FirebaseLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirebaseLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.FirebaseLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirebaseLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.FirebaseLink} FirebaseLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirebaseLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirebaseLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirebaseLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirebaseLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.FirebaseLink} FirebaseLink
                         */
                        FirebaseLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.FirebaseLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.FirebaseLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.FirebaseLink.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirebaseLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.FirebaseLink} message FirebaseLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirebaseLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.project = "";
                                object.createTime = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            return object;
                        };
    
                        /**
                         * Converts this FirebaseLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirebaseLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirebaseLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.FirebaseLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirebaseLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.FirebaseLink";
                        };
    
                        return FirebaseLink;
                    })();
    
                    v1alpha.GlobalSiteTag = (function() {
    
                        /**
                         * Properties of a GlobalSiteTag.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGlobalSiteTag
                         * @property {string|null} [name] GlobalSiteTag name
                         * @property {string|null} [snippet] GlobalSiteTag snippet
                         */
    
                        /**
                         * Constructs a new GlobalSiteTag.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GlobalSiteTag.
                         * @implements IGlobalSiteTag
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGlobalSiteTag=} [properties] Properties to set
                         */
                        function GlobalSiteTag(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GlobalSiteTag name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @instance
                         */
                        GlobalSiteTag.prototype.name = "";
    
                        /**
                         * GlobalSiteTag snippet.
                         * @member {string} snippet
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @instance
                         */
                        GlobalSiteTag.prototype.snippet = "";
    
                        /**
                         * Creates a new GlobalSiteTag instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGlobalSiteTag=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GlobalSiteTag} GlobalSiteTag instance
                         */
                        GlobalSiteTag.create = function create(properties) {
                            return new GlobalSiteTag(properties);
                        };
    
                        /**
                         * Encodes the specified GlobalSiteTag message. Does not implicitly {@link google.analytics.admin.v1alpha.GlobalSiteTag.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGlobalSiteTag} message GlobalSiteTag message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalSiteTag.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.snippet != null && Object.hasOwnProperty.call(message, "snippet"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.snippet);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GlobalSiteTag message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GlobalSiteTag.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGlobalSiteTag} message GlobalSiteTag message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalSiteTag.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GlobalSiteTag message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GlobalSiteTag} GlobalSiteTag
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalSiteTag.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GlobalSiteTag();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.snippet = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GlobalSiteTag message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GlobalSiteTag} GlobalSiteTag
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalSiteTag.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GlobalSiteTag message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GlobalSiteTag.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.snippet != null && message.hasOwnProperty("snippet"))
                                if (!$util.isString(message.snippet))
                                    return "snippet: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GlobalSiteTag message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GlobalSiteTag} GlobalSiteTag
                         */
                        GlobalSiteTag.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GlobalSiteTag)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GlobalSiteTag();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.snippet != null)
                                message.snippet = String(object.snippet);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GlobalSiteTag message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.GlobalSiteTag} message GlobalSiteTag
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GlobalSiteTag.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.snippet = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.snippet != null && message.hasOwnProperty("snippet"))
                                object.snippet = message.snippet;
                            return object;
                        };
    
                        /**
                         * Converts this GlobalSiteTag to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GlobalSiteTag.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GlobalSiteTag
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GlobalSiteTag
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GlobalSiteTag.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GlobalSiteTag";
                        };
    
                        return GlobalSiteTag;
                    })();
    
                    v1alpha.GoogleAdsLink = (function() {
    
                        /**
                         * Properties of a GoogleAdsLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGoogleAdsLink
                         * @property {string|null} [name] GoogleAdsLink name
                         * @property {string|null} [customerId] GoogleAdsLink customerId
                         * @property {boolean|null} [canManageClients] GoogleAdsLink canManageClients
                         * @property {google.protobuf.IBoolValue|null} [adsPersonalizationEnabled] GoogleAdsLink adsPersonalizationEnabled
                         * @property {google.protobuf.ITimestamp|null} [createTime] GoogleAdsLink createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] GoogleAdsLink updateTime
                         * @property {string|null} [creatorEmailAddress] GoogleAdsLink creatorEmailAddress
                         */
    
                        /**
                         * Constructs a new GoogleAdsLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GoogleAdsLink.
                         * @implements IGoogleAdsLink
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGoogleAdsLink=} [properties] Properties to set
                         */
                        function GoogleAdsLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GoogleAdsLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.name = "";
    
                        /**
                         * GoogleAdsLink customerId.
                         * @member {string} customerId
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.customerId = "";
    
                        /**
                         * GoogleAdsLink canManageClients.
                         * @member {boolean} canManageClients
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.canManageClients = false;
    
                        /**
                         * GoogleAdsLink adsPersonalizationEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} adsPersonalizationEnabled
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.adsPersonalizationEnabled = null;
    
                        /**
                         * GoogleAdsLink createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.createTime = null;
    
                        /**
                         * GoogleAdsLink updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.updateTime = null;
    
                        /**
                         * GoogleAdsLink creatorEmailAddress.
                         * @member {string} creatorEmailAddress
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.creatorEmailAddress = "";
    
                        /**
                         * Creates a new GoogleAdsLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGoogleAdsLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GoogleAdsLink} GoogleAdsLink instance
                         */
                        GoogleAdsLink.create = function create(properties) {
                            return new GoogleAdsLink(properties);
                        };
    
                        /**
                         * Encodes the specified GoogleAdsLink message. Does not implicitly {@link google.analytics.admin.v1alpha.GoogleAdsLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGoogleAdsLink} message GoogleAdsLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.customerId != null && Object.hasOwnProperty.call(message, "customerId"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.customerId);
                            if (message.canManageClients != null && Object.hasOwnProperty.call(message, "canManageClients"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.canManageClients);
                            if (message.adsPersonalizationEnabled != null && Object.hasOwnProperty.call(message, "adsPersonalizationEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.adsPersonalizationEnabled, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.creatorEmailAddress != null && Object.hasOwnProperty.call(message, "creatorEmailAddress"))
                                writer.uint32(/* id 9, wireType 2 =*/74).string(message.creatorEmailAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GoogleAdsLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GoogleAdsLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGoogleAdsLink} message GoogleAdsLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GoogleAdsLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GoogleAdsLink} GoogleAdsLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GoogleAdsLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.customerId = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.canManageClients = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 8: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 9: {
                                        message.creatorEmailAddress = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GoogleAdsLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GoogleAdsLink} GoogleAdsLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GoogleAdsLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.canManageClients != null && message.hasOwnProperty("canManageClients"))
                                if (typeof message.canManageClients !== "boolean")
                                    return "canManageClients: boolean expected";
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.adsPersonalizationEnabled);
                                if (error)
                                    return "adsPersonalizationEnabled." + error;
                            }
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            if (message.creatorEmailAddress != null && message.hasOwnProperty("creatorEmailAddress"))
                                if (!$util.isString(message.creatorEmailAddress))
                                    return "creatorEmailAddress: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GoogleAdsLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GoogleAdsLink} GoogleAdsLink
                         */
                        GoogleAdsLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GoogleAdsLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GoogleAdsLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.canManageClients != null)
                                message.canManageClients = Boolean(object.canManageClients);
                            if (object.adsPersonalizationEnabled != null) {
                                if (typeof object.adsPersonalizationEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.GoogleAdsLink.adsPersonalizationEnabled: object expected");
                                message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.fromObject(object.adsPersonalizationEnabled);
                            }
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.GoogleAdsLink.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.GoogleAdsLink.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            if (object.creatorEmailAddress != null)
                                message.creatorEmailAddress = String(object.creatorEmailAddress);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GoogleAdsLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.GoogleAdsLink} message GoogleAdsLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.customerId = "";
                                object.canManageClients = false;
                                object.adsPersonalizationEnabled = null;
                                object.createTime = null;
                                object.updateTime = null;
                                object.creatorEmailAddress = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.canManageClients != null && message.hasOwnProperty("canManageClients"))
                                object.canManageClients = message.canManageClients;
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled"))
                                object.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.toObject(message.adsPersonalizationEnabled, options);
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.creatorEmailAddress != null && message.hasOwnProperty("creatorEmailAddress"))
                                object.creatorEmailAddress = message.creatorEmailAddress;
                            return object;
                        };
    
                        /**
                         * Converts this GoogleAdsLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GoogleAdsLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GoogleAdsLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GoogleAdsLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GoogleAdsLink";
                        };
    
                        return GoogleAdsLink;
                    })();
    
                    v1alpha.DataSharingSettings = (function() {
    
                        /**
                         * Properties of a DataSharingSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDataSharingSettings
                         * @property {string|null} [name] DataSharingSettings name
                         * @property {boolean|null} [sharingWithGoogleSupportEnabled] DataSharingSettings sharingWithGoogleSupportEnabled
                         * @property {boolean|null} [sharingWithGoogleAssignedSalesEnabled] DataSharingSettings sharingWithGoogleAssignedSalesEnabled
                         * @property {boolean|null} [sharingWithGoogleAnySalesEnabled] DataSharingSettings sharingWithGoogleAnySalesEnabled
                         * @property {boolean|null} [sharingWithGoogleProductsEnabled] DataSharingSettings sharingWithGoogleProductsEnabled
                         * @property {boolean|null} [sharingWithOthersEnabled] DataSharingSettings sharingWithOthersEnabled
                         */
    
                        /**
                         * Constructs a new DataSharingSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DataSharingSettings.
                         * @implements IDataSharingSettings
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDataSharingSettings=} [properties] Properties to set
                         */
                        function DataSharingSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DataSharingSettings name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.name = "";
    
                        /**
                         * DataSharingSettings sharingWithGoogleSupportEnabled.
                         * @member {boolean} sharingWithGoogleSupportEnabled
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleSupportEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithGoogleAssignedSalesEnabled.
                         * @member {boolean} sharingWithGoogleAssignedSalesEnabled
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleAssignedSalesEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithGoogleAnySalesEnabled.
                         * @member {boolean} sharingWithGoogleAnySalesEnabled
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleAnySalesEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithGoogleProductsEnabled.
                         * @member {boolean} sharingWithGoogleProductsEnabled
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleProductsEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithOthersEnabled.
                         * @member {boolean} sharingWithOthersEnabled
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithOthersEnabled = false;
    
                        /**
                         * Creates a new DataSharingSettings instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataSharingSettings=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DataSharingSettings} DataSharingSettings instance
                         */
                        DataSharingSettings.create = function create(properties) {
                            return new DataSharingSettings(properties);
                        };
    
                        /**
                         * Encodes the specified DataSharingSettings message. Does not implicitly {@link google.analytics.admin.v1alpha.DataSharingSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataSharingSettings} message DataSharingSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataSharingSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.sharingWithGoogleSupportEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleSupportEnabled"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.sharingWithGoogleSupportEnabled);
                            if (message.sharingWithGoogleAssignedSalesEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleAssignedSalesEnabled"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.sharingWithGoogleAssignedSalesEnabled);
                            if (message.sharingWithGoogleAnySalesEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleAnySalesEnabled"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.sharingWithGoogleAnySalesEnabled);
                            if (message.sharingWithGoogleProductsEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleProductsEnabled"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.sharingWithGoogleProductsEnabled);
                            if (message.sharingWithOthersEnabled != null && Object.hasOwnProperty.call(message, "sharingWithOthersEnabled"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.sharingWithOthersEnabled);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DataSharingSettings message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DataSharingSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataSharingSettings} message DataSharingSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataSharingSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DataSharingSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DataSharingSettings} DataSharingSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataSharingSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DataSharingSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.sharingWithGoogleSupportEnabled = reader.bool();
                                        break;
                                    }
                                case 3: {
                                        message.sharingWithGoogleAssignedSalesEnabled = reader.bool();
                                        break;
                                    }
                                case 4: {
                                        message.sharingWithGoogleAnySalesEnabled = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.sharingWithGoogleProductsEnabled = reader.bool();
                                        break;
                                    }
                                case 6: {
                                        message.sharingWithOthersEnabled = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DataSharingSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DataSharingSettings} DataSharingSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataSharingSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DataSharingSettings message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DataSharingSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.sharingWithGoogleSupportEnabled != null && message.hasOwnProperty("sharingWithGoogleSupportEnabled"))
                                if (typeof message.sharingWithGoogleSupportEnabled !== "boolean")
                                    return "sharingWithGoogleSupportEnabled: boolean expected";
                            if (message.sharingWithGoogleAssignedSalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAssignedSalesEnabled"))
                                if (typeof message.sharingWithGoogleAssignedSalesEnabled !== "boolean")
                                    return "sharingWithGoogleAssignedSalesEnabled: boolean expected";
                            if (message.sharingWithGoogleAnySalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAnySalesEnabled"))
                                if (typeof message.sharingWithGoogleAnySalesEnabled !== "boolean")
                                    return "sharingWithGoogleAnySalesEnabled: boolean expected";
                            if (message.sharingWithGoogleProductsEnabled != null && message.hasOwnProperty("sharingWithGoogleProductsEnabled"))
                                if (typeof message.sharingWithGoogleProductsEnabled !== "boolean")
                                    return "sharingWithGoogleProductsEnabled: boolean expected";
                            if (message.sharingWithOthersEnabled != null && message.hasOwnProperty("sharingWithOthersEnabled"))
                                if (typeof message.sharingWithOthersEnabled !== "boolean")
                                    return "sharingWithOthersEnabled: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a DataSharingSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DataSharingSettings} DataSharingSettings
                         */
                        DataSharingSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DataSharingSettings)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DataSharingSettings();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.sharingWithGoogleSupportEnabled != null)
                                message.sharingWithGoogleSupportEnabled = Boolean(object.sharingWithGoogleSupportEnabled);
                            if (object.sharingWithGoogleAssignedSalesEnabled != null)
                                message.sharingWithGoogleAssignedSalesEnabled = Boolean(object.sharingWithGoogleAssignedSalesEnabled);
                            if (object.sharingWithGoogleAnySalesEnabled != null)
                                message.sharingWithGoogleAnySalesEnabled = Boolean(object.sharingWithGoogleAnySalesEnabled);
                            if (object.sharingWithGoogleProductsEnabled != null)
                                message.sharingWithGoogleProductsEnabled = Boolean(object.sharingWithGoogleProductsEnabled);
                            if (object.sharingWithOthersEnabled != null)
                                message.sharingWithOthersEnabled = Boolean(object.sharingWithOthersEnabled);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DataSharingSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.DataSharingSettings} message DataSharingSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DataSharingSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.sharingWithGoogleSupportEnabled = false;
                                object.sharingWithGoogleAssignedSalesEnabled = false;
                                object.sharingWithGoogleAnySalesEnabled = false;
                                object.sharingWithGoogleProductsEnabled = false;
                                object.sharingWithOthersEnabled = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.sharingWithGoogleSupportEnabled != null && message.hasOwnProperty("sharingWithGoogleSupportEnabled"))
                                object.sharingWithGoogleSupportEnabled = message.sharingWithGoogleSupportEnabled;
                            if (message.sharingWithGoogleAssignedSalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAssignedSalesEnabled"))
                                object.sharingWithGoogleAssignedSalesEnabled = message.sharingWithGoogleAssignedSalesEnabled;
                            if (message.sharingWithGoogleAnySalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAnySalesEnabled"))
                                object.sharingWithGoogleAnySalesEnabled = message.sharingWithGoogleAnySalesEnabled;
                            if (message.sharingWithGoogleProductsEnabled != null && message.hasOwnProperty("sharingWithGoogleProductsEnabled"))
                                object.sharingWithGoogleProductsEnabled = message.sharingWithGoogleProductsEnabled;
                            if (message.sharingWithOthersEnabled != null && message.hasOwnProperty("sharingWithOthersEnabled"))
                                object.sharingWithOthersEnabled = message.sharingWithOthersEnabled;
                            return object;
                        };
    
                        /**
                         * Converts this DataSharingSettings to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DataSharingSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DataSharingSettings
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DataSharingSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DataSharingSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DataSharingSettings";
                        };
    
                        return DataSharingSettings;
                    })();
    
                    v1alpha.AccountSummary = (function() {
    
                        /**
                         * Properties of an AccountSummary.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccountSummary
                         * @property {string|null} [name] AccountSummary name
                         * @property {string|null} [account] AccountSummary account
                         * @property {string|null} [displayName] AccountSummary displayName
                         * @property {Array.<google.analytics.admin.v1alpha.IPropertySummary>|null} [propertySummaries] AccountSummary propertySummaries
                         */
    
                        /**
                         * Constructs a new AccountSummary.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccountSummary.
                         * @implements IAccountSummary
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccountSummary=} [properties] Properties to set
                         */
                        function AccountSummary(properties) {
                            this.propertySummaries = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccountSummary name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.name = "";
    
                        /**
                         * AccountSummary account.
                         * @member {string} account
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.account = "";
    
                        /**
                         * AccountSummary displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.displayName = "";
    
                        /**
                         * AccountSummary propertySummaries.
                         * @member {Array.<google.analytics.admin.v1alpha.IPropertySummary>} propertySummaries
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.propertySummaries = $util.emptyArray;
    
                        /**
                         * Creates a new AccountSummary instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccountSummary=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccountSummary} AccountSummary instance
                         */
                        AccountSummary.create = function create(properties) {
                            return new AccountSummary(properties);
                        };
    
                        /**
                         * Encodes the specified AccountSummary message. Does not implicitly {@link google.analytics.admin.v1alpha.AccountSummary.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccountSummary} message AccountSummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountSummary.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.account);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.propertySummaries != null && message.propertySummaries.length)
                                for (var i = 0; i < message.propertySummaries.length; ++i)
                                    $root.google.analytics.admin.v1alpha.PropertySummary.encode(message.propertySummaries[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccountSummary message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccountSummary.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccountSummary} message AccountSummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountSummary.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccountSummary message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccountSummary} AccountSummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountSummary.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccountSummary();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.account = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        if (!(message.propertySummaries && message.propertySummaries.length))
                                            message.propertySummaries = [];
                                        message.propertySummaries.push($root.google.analytics.admin.v1alpha.PropertySummary.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccountSummary message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccountSummary} AccountSummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountSummary.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccountSummary message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountSummary.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.account != null && message.hasOwnProperty("account"))
                                if (!$util.isString(message.account))
                                    return "account: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.propertySummaries != null && message.hasOwnProperty("propertySummaries")) {
                                if (!Array.isArray(message.propertySummaries))
                                    return "propertySummaries: array expected";
                                for (var i = 0; i < message.propertySummaries.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.PropertySummary.verify(message.propertySummaries[i]);
                                    if (error)
                                        return "propertySummaries." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccountSummary message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccountSummary} AccountSummary
                         */
                        AccountSummary.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccountSummary)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccountSummary();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.account != null)
                                message.account = String(object.account);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.propertySummaries) {
                                if (!Array.isArray(object.propertySummaries))
                                    throw TypeError(".google.analytics.admin.v1alpha.AccountSummary.propertySummaries: array expected");
                                message.propertySummaries = [];
                                for (var i = 0; i < object.propertySummaries.length; ++i) {
                                    if (typeof object.propertySummaries[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.AccountSummary.propertySummaries: object expected");
                                    message.propertySummaries[i] = $root.google.analytics.admin.v1alpha.PropertySummary.fromObject(object.propertySummaries[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccountSummary message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccountSummary} message AccountSummary
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountSummary.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.propertySummaries = [];
                            if (options.defaults) {
                                object.name = "";
                                object.account = "";
                                object.displayName = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = message.account;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.propertySummaries && message.propertySummaries.length) {
                                object.propertySummaries = [];
                                for (var j = 0; j < message.propertySummaries.length; ++j)
                                    object.propertySummaries[j] = $root.google.analytics.admin.v1alpha.PropertySummary.toObject(message.propertySummaries[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccountSummary to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountSummary.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccountSummary
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccountSummary
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccountSummary.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccountSummary";
                        };
    
                        return AccountSummary;
                    })();
    
                    v1alpha.PropertySummary = (function() {
    
                        /**
                         * Properties of a PropertySummary.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IPropertySummary
                         * @property {string|null} [property] PropertySummary property
                         * @property {string|null} [displayName] PropertySummary displayName
                         * @property {google.analytics.admin.v1alpha.PropertyType|null} [propertyType] PropertySummary propertyType
                         * @property {string|null} [parent] PropertySummary parent
                         */
    
                        /**
                         * Constructs a new PropertySummary.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a PropertySummary.
                         * @implements IPropertySummary
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IPropertySummary=} [properties] Properties to set
                         */
                        function PropertySummary(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PropertySummary property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.property = "";
    
                        /**
                         * PropertySummary displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.displayName = "";
    
                        /**
                         * PropertySummary propertyType.
                         * @member {google.analytics.admin.v1alpha.PropertyType} propertyType
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.propertyType = 0;
    
                        /**
                         * PropertySummary parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.parent = "";
    
                        /**
                         * Creates a new PropertySummary instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.IPropertySummary=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.PropertySummary} PropertySummary instance
                         */
                        PropertySummary.create = function create(properties) {
                            return new PropertySummary(properties);
                        };
    
                        /**
                         * Encodes the specified PropertySummary message. Does not implicitly {@link google.analytics.admin.v1alpha.PropertySummary.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.IPropertySummary} message PropertySummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PropertySummary.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.displayName);
                            if (message.propertyType != null && Object.hasOwnProperty.call(message, "propertyType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.propertyType);
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.parent);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PropertySummary message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.PropertySummary.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.IPropertySummary} message PropertySummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PropertySummary.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PropertySummary message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.PropertySummary} PropertySummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PropertySummary.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.PropertySummary();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.propertyType = reader.int32();
                                        break;
                                    }
                                case 4: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PropertySummary message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.PropertySummary} PropertySummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PropertySummary.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PropertySummary message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PropertySummary.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                switch (message.propertyType) {
                                default:
                                    return "propertyType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a PropertySummary message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.PropertySummary} PropertySummary
                         */
                        PropertySummary.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.PropertySummary)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.PropertySummary();
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            switch (object.propertyType) {
                            default:
                                if (typeof object.propertyType === "number") {
                                    message.propertyType = object.propertyType;
                                    break;
                                }
                                break;
                            case "PROPERTY_TYPE_UNSPECIFIED":
                            case 0:
                                message.propertyType = 0;
                                break;
                            case "PROPERTY_TYPE_ORDINARY":
                            case 1:
                                message.propertyType = 1;
                                break;
                            case "PROPERTY_TYPE_SUBPROPERTY":
                            case 2:
                                message.propertyType = 2;
                                break;
                            case "PROPERTY_TYPE_ROLLUP":
                            case 3:
                                message.propertyType = 3;
                                break;
                            }
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PropertySummary message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1alpha.PropertySummary} message PropertySummary
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PropertySummary.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = "";
                                object.displayName = "";
                                object.propertyType = options.enums === String ? "PROPERTY_TYPE_UNSPECIFIED" : 0;
                                object.parent = "";
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                object.propertyType = options.enums === String ? $root.google.analytics.admin.v1alpha.PropertyType[message.propertyType] === undefined ? message.propertyType : $root.google.analytics.admin.v1alpha.PropertyType[message.propertyType] : message.propertyType;
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            return object;
                        };
    
                        /**
                         * Converts this PropertySummary to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PropertySummary.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PropertySummary
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.PropertySummary
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PropertySummary.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.PropertySummary";
                        };
    
                        return PropertySummary;
                    })();
    
                    v1alpha.MeasurementProtocolSecret = (function() {
    
                        /**
                         * Properties of a MeasurementProtocolSecret.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IMeasurementProtocolSecret
                         * @property {string|null} [name] MeasurementProtocolSecret name
                         * @property {string|null} [displayName] MeasurementProtocolSecret displayName
                         * @property {string|null} [secretValue] MeasurementProtocolSecret secretValue
                         */
    
                        /**
                         * Constructs a new MeasurementProtocolSecret.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a MeasurementProtocolSecret.
                         * @implements IMeasurementProtocolSecret
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IMeasurementProtocolSecret=} [properties] Properties to set
                         */
                        function MeasurementProtocolSecret(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MeasurementProtocolSecret name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @instance
                         */
                        MeasurementProtocolSecret.prototype.name = "";
    
                        /**
                         * MeasurementProtocolSecret displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @instance
                         */
                        MeasurementProtocolSecret.prototype.displayName = "";
    
                        /**
                         * MeasurementProtocolSecret secretValue.
                         * @member {string} secretValue
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @instance
                         */
                        MeasurementProtocolSecret.prototype.secretValue = "";
    
                        /**
                         * Creates a new MeasurementProtocolSecret instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1alpha.IMeasurementProtocolSecret=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.MeasurementProtocolSecret} MeasurementProtocolSecret instance
                         */
                        MeasurementProtocolSecret.create = function create(properties) {
                            return new MeasurementProtocolSecret(properties);
                        };
    
                        /**
                         * Encodes the specified MeasurementProtocolSecret message. Does not implicitly {@link google.analytics.admin.v1alpha.MeasurementProtocolSecret.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1alpha.IMeasurementProtocolSecret} message MeasurementProtocolSecret message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MeasurementProtocolSecret.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.displayName);
                            if (message.secretValue != null && Object.hasOwnProperty.call(message, "secretValue"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.secretValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MeasurementProtocolSecret message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.MeasurementProtocolSecret.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1alpha.IMeasurementProtocolSecret} message MeasurementProtocolSecret message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MeasurementProtocolSecret.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MeasurementProtocolSecret message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.MeasurementProtocolSecret} MeasurementProtocolSecret
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MeasurementProtocolSecret.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.secretValue = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MeasurementProtocolSecret message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.MeasurementProtocolSecret} MeasurementProtocolSecret
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MeasurementProtocolSecret.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MeasurementProtocolSecret message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MeasurementProtocolSecret.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.secretValue != null && message.hasOwnProperty("secretValue"))
                                if (!$util.isString(message.secretValue))
                                    return "secretValue: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a MeasurementProtocolSecret message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.MeasurementProtocolSecret} MeasurementProtocolSecret
                         */
                        MeasurementProtocolSecret.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.secretValue != null)
                                message.secretValue = String(object.secretValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MeasurementProtocolSecret message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1alpha.MeasurementProtocolSecret} message MeasurementProtocolSecret
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MeasurementProtocolSecret.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.displayName = "";
                                object.secretValue = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.secretValue != null && message.hasOwnProperty("secretValue"))
                                object.secretValue = message.secretValue;
                            return object;
                        };
    
                        /**
                         * Converts this MeasurementProtocolSecret to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MeasurementProtocolSecret.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MeasurementProtocolSecret
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.MeasurementProtocolSecret
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MeasurementProtocolSecret.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.MeasurementProtocolSecret";
                        };
    
                        return MeasurementProtocolSecret;
                    })();
    
                    v1alpha.ChangeHistoryEvent = (function() {
    
                        /**
                         * Properties of a ChangeHistoryEvent.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IChangeHistoryEvent
                         * @property {string|null} [id] ChangeHistoryEvent id
                         * @property {google.protobuf.ITimestamp|null} [changeTime] ChangeHistoryEvent changeTime
                         * @property {google.analytics.admin.v1alpha.ActorType|null} [actorType] ChangeHistoryEvent actorType
                         * @property {string|null} [userActorEmail] ChangeHistoryEvent userActorEmail
                         * @property {boolean|null} [changesFiltered] ChangeHistoryEvent changesFiltered
                         * @property {Array.<google.analytics.admin.v1alpha.IChangeHistoryChange>|null} [changes] ChangeHistoryEvent changes
                         */
    
                        /**
                         * Constructs a new ChangeHistoryEvent.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ChangeHistoryEvent.
                         * @implements IChangeHistoryEvent
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryEvent=} [properties] Properties to set
                         */
                        function ChangeHistoryEvent(properties) {
                            this.changes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChangeHistoryEvent id.
                         * @member {string} id
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.id = "";
    
                        /**
                         * ChangeHistoryEvent changeTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} changeTime
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.changeTime = null;
    
                        /**
                         * ChangeHistoryEvent actorType.
                         * @member {google.analytics.admin.v1alpha.ActorType} actorType
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.actorType = 0;
    
                        /**
                         * ChangeHistoryEvent userActorEmail.
                         * @member {string} userActorEmail
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.userActorEmail = "";
    
                        /**
                         * ChangeHistoryEvent changesFiltered.
                         * @member {boolean} changesFiltered
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.changesFiltered = false;
    
                        /**
                         * ChangeHistoryEvent changes.
                         * @member {Array.<google.analytics.admin.v1alpha.IChangeHistoryChange>} changes
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.changes = $util.emptyArray;
    
                        /**
                         * Creates a new ChangeHistoryEvent instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryEvent=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryEvent} ChangeHistoryEvent instance
                         */
                        ChangeHistoryEvent.create = function create(properties) {
                            return new ChangeHistoryEvent(properties);
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryEvent message. Does not implicitly {@link google.analytics.admin.v1alpha.ChangeHistoryEvent.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryEvent} message ChangeHistoryEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryEvent.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
                            if (message.changeTime != null && Object.hasOwnProperty.call(message, "changeTime"))
                                $root.google.protobuf.Timestamp.encode(message.changeTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.actorType != null && Object.hasOwnProperty.call(message, "actorType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.actorType);
                            if (message.userActorEmail != null && Object.hasOwnProperty.call(message, "userActorEmail"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.userActorEmail);
                            if (message.changesFiltered != null && Object.hasOwnProperty.call(message, "changesFiltered"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.changesFiltered);
                            if (message.changes != null && message.changes.length)
                                for (var i = 0; i < message.changes.length; ++i)
                                    $root.google.analytics.admin.v1alpha.ChangeHistoryChange.encode(message.changes[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryEvent message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChangeHistoryEvent.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryEvent} message ChangeHistoryEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryEvent.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChangeHistoryEvent message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryEvent} ChangeHistoryEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryEvent.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChangeHistoryEvent();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.changeTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.actorType = reader.int32();
                                        break;
                                    }
                                case 4: {
                                        message.userActorEmail = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.changesFiltered = reader.bool();
                                        break;
                                    }
                                case 6: {
                                        if (!(message.changes && message.changes.length))
                                            message.changes = [];
                                        message.changes.push($root.google.analytics.admin.v1alpha.ChangeHistoryChange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChangeHistoryEvent message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryEvent} ChangeHistoryEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryEvent.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChangeHistoryEvent message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeHistoryEvent.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.id != null && message.hasOwnProperty("id"))
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            if (message.changeTime != null && message.hasOwnProperty("changeTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.changeTime);
                                if (error)
                                    return "changeTime." + error;
                            }
                            if (message.actorType != null && message.hasOwnProperty("actorType"))
                                switch (message.actorType) {
                                default:
                                    return "actorType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.userActorEmail != null && message.hasOwnProperty("userActorEmail"))
                                if (!$util.isString(message.userActorEmail))
                                    return "userActorEmail: string expected";
                            if (message.changesFiltered != null && message.hasOwnProperty("changesFiltered"))
                                if (typeof message.changesFiltered !== "boolean")
                                    return "changesFiltered: boolean expected";
                            if (message.changes != null && message.hasOwnProperty("changes")) {
                                if (!Array.isArray(message.changes))
                                    return "changes: array expected";
                                for (var i = 0; i < message.changes.length; ++i) {
                                    var error = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.verify(message.changes[i]);
                                    if (error)
                                        return "changes." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ChangeHistoryEvent message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryEvent} ChangeHistoryEvent
                         */
                        ChangeHistoryEvent.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ChangeHistoryEvent)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ChangeHistoryEvent();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.changeTime != null) {
                                if (typeof object.changeTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryEvent.changeTime: object expected");
                                message.changeTime = $root.google.protobuf.Timestamp.fromObject(object.changeTime);
                            }
                            switch (object.actorType) {
                            default:
                                if (typeof object.actorType === "number") {
                                    message.actorType = object.actorType;
                                    break;
                                }
                                break;
                            case "ACTOR_TYPE_UNSPECIFIED":
                            case 0:
                                message.actorType = 0;
                                break;
                            case "USER":
                            case 1:
                                message.actorType = 1;
                                break;
                            case "SYSTEM":
                            case 2:
                                message.actorType = 2;
                                break;
                            case "SUPPORT":
                            case 3:
                                message.actorType = 3;
                                break;
                            }
                            if (object.userActorEmail != null)
                                message.userActorEmail = String(object.userActorEmail);
                            if (object.changesFiltered != null)
                                message.changesFiltered = Boolean(object.changesFiltered);
                            if (object.changes) {
                                if (!Array.isArray(object.changes))
                                    throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryEvent.changes: array expected");
                                message.changes = [];
                                for (var i = 0; i < object.changes.length; ++i) {
                                    if (typeof object.changes[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryEvent.changes: object expected");
                                    message.changes[i] = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.fromObject(object.changes[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChangeHistoryEvent message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.ChangeHistoryEvent} message ChangeHistoryEvent
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeHistoryEvent.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.changes = [];
                            if (options.defaults) {
                                object.id = "";
                                object.changeTime = null;
                                object.actorType = options.enums === String ? "ACTOR_TYPE_UNSPECIFIED" : 0;
                                object.userActorEmail = "";
                                object.changesFiltered = false;
                            }
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = message.id;
                            if (message.changeTime != null && message.hasOwnProperty("changeTime"))
                                object.changeTime = $root.google.protobuf.Timestamp.toObject(message.changeTime, options);
                            if (message.actorType != null && message.hasOwnProperty("actorType"))
                                object.actorType = options.enums === String ? $root.google.analytics.admin.v1alpha.ActorType[message.actorType] === undefined ? message.actorType : $root.google.analytics.admin.v1alpha.ActorType[message.actorType] : message.actorType;
                            if (message.userActorEmail != null && message.hasOwnProperty("userActorEmail"))
                                object.userActorEmail = message.userActorEmail;
                            if (message.changesFiltered != null && message.hasOwnProperty("changesFiltered"))
                                object.changesFiltered = message.changesFiltered;
                            if (message.changes && message.changes.length) {
                                object.changes = [];
                                for (var j = 0; j < message.changes.length; ++j)
                                    object.changes[j] = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.toObject(message.changes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ChangeHistoryEvent to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeHistoryEvent.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChangeHistoryEvent
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryEvent
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChangeHistoryEvent.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChangeHistoryEvent";
                        };
    
                        return ChangeHistoryEvent;
                    })();
    
                    v1alpha.ChangeHistoryChange = (function() {
    
                        /**
                         * Properties of a ChangeHistoryChange.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IChangeHistoryChange
                         * @property {string|null} [resource] ChangeHistoryChange resource
                         * @property {google.analytics.admin.v1alpha.ActionType|null} [action] ChangeHistoryChange action
                         * @property {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource|null} [resourceBeforeChange] ChangeHistoryChange resourceBeforeChange
                         * @property {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource|null} [resourceAfterChange] ChangeHistoryChange resourceAfterChange
                         */
    
                        /**
                         * Constructs a new ChangeHistoryChange.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ChangeHistoryChange.
                         * @implements IChangeHistoryChange
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryChange=} [properties] Properties to set
                         */
                        function ChangeHistoryChange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChangeHistoryChange resource.
                         * @member {string} resource
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.resource = "";
    
                        /**
                         * ChangeHistoryChange action.
                         * @member {google.analytics.admin.v1alpha.ActionType} action
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.action = 0;
    
                        /**
                         * ChangeHistoryChange resourceBeforeChange.
                         * @member {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource|null|undefined} resourceBeforeChange
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.resourceBeforeChange = null;
    
                        /**
                         * ChangeHistoryChange resourceAfterChange.
                         * @member {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource|null|undefined} resourceAfterChange
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.resourceAfterChange = null;
    
                        /**
                         * Creates a new ChangeHistoryChange instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryChange=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange} ChangeHistoryChange instance
                         */
                        ChangeHistoryChange.create = function create(properties) {
                            return new ChangeHistoryChange(properties);
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryChange message. Does not implicitly {@link google.analytics.admin.v1alpha.ChangeHistoryChange.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryChange} message ChangeHistoryChange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryChange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resource);
                            if (message.action != null && Object.hasOwnProperty.call(message, "action"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.action);
                            if (message.resourceBeforeChange != null && Object.hasOwnProperty.call(message, "resourceBeforeChange"))
                                $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.encode(message.resourceBeforeChange, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.resourceAfterChange != null && Object.hasOwnProperty.call(message, "resourceAfterChange"))
                                $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.encode(message.resourceAfterChange, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryChange message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChangeHistoryChange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1alpha.IChangeHistoryChange} message ChangeHistoryChange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryChange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChangeHistoryChange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange} ChangeHistoryChange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryChange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChangeHistoryChange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.action = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.resourceBeforeChange = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.resourceAfterChange = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChangeHistoryChange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange} ChangeHistoryChange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryChange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChangeHistoryChange message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeHistoryChange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.action != null && message.hasOwnProperty("action"))
                                switch (message.action) {
                                default:
                                    return "action: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.resourceBeforeChange != null && message.hasOwnProperty("resourceBeforeChange")) {
                                var error = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.verify(message.resourceBeforeChange);
                                if (error)
                                    return "resourceBeforeChange." + error;
                            }
                            if (message.resourceAfterChange != null && message.hasOwnProperty("resourceAfterChange")) {
                                var error = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.verify(message.resourceAfterChange);
                                if (error)
                                    return "resourceAfterChange." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ChangeHistoryChange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange} ChangeHistoryChange
                         */
                        ChangeHistoryChange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ChangeHistoryChange)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ChangeHistoryChange();
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            switch (object.action) {
                            default:
                                if (typeof object.action === "number") {
                                    message.action = object.action;
                                    break;
                                }
                                break;
                            case "ACTION_TYPE_UNSPECIFIED":
                            case 0:
                                message.action = 0;
                                break;
                            case "CREATED":
                            case 1:
                                message.action = 1;
                                break;
                            case "UPDATED":
                            case 2:
                                message.action = 2;
                                break;
                            case "DELETED":
                            case 3:
                                message.action = 3;
                                break;
                            }
                            if (object.resourceBeforeChange != null) {
                                if (typeof object.resourceBeforeChange !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.resourceBeforeChange: object expected");
                                message.resourceBeforeChange = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.fromObject(object.resourceBeforeChange);
                            }
                            if (object.resourceAfterChange != null) {
                                if (typeof object.resourceAfterChange !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.resourceAfterChange: object expected");
                                message.resourceAfterChange = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.fromObject(object.resourceAfterChange);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChangeHistoryChange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1alpha.ChangeHistoryChange} message ChangeHistoryChange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeHistoryChange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.action = options.enums === String ? "ACTION_TYPE_UNSPECIFIED" : 0;
                                object.resourceBeforeChange = null;
                                object.resourceAfterChange = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.action != null && message.hasOwnProperty("action"))
                                object.action = options.enums === String ? $root.google.analytics.admin.v1alpha.ActionType[message.action] === undefined ? message.action : $root.google.analytics.admin.v1alpha.ActionType[message.action] : message.action;
                            if (message.resourceBeforeChange != null && message.hasOwnProperty("resourceBeforeChange"))
                                object.resourceBeforeChange = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.toObject(message.resourceBeforeChange, options);
                            if (message.resourceAfterChange != null && message.hasOwnProperty("resourceAfterChange"))
                                object.resourceAfterChange = $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.toObject(message.resourceAfterChange, options);
                            return object;
                        };
    
                        /**
                         * Converts this ChangeHistoryChange to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeHistoryChange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChangeHistoryChange
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChangeHistoryChange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChangeHistoryChange";
                        };
    
                        ChangeHistoryChange.ChangeHistoryResource = (function() {
    
                            /**
                             * Properties of a ChangeHistoryResource.
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                             * @interface IChangeHistoryResource
                             * @property {google.analytics.admin.v1alpha.IAccount|null} [account] ChangeHistoryResource account
                             * @property {google.analytics.admin.v1alpha.IProperty|null} [property] ChangeHistoryResource property
                             * @property {google.analytics.admin.v1alpha.IFirebaseLink|null} [firebaseLink] ChangeHistoryResource firebaseLink
                             * @property {google.analytics.admin.v1alpha.IGoogleAdsLink|null} [googleAdsLink] ChangeHistoryResource googleAdsLink
                             * @property {google.analytics.admin.v1alpha.IGoogleSignalsSettings|null} [googleSignalsSettings] ChangeHistoryResource googleSignalsSettings
                             * @property {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null} [displayVideo_360AdvertiserLink] ChangeHistoryResource displayVideo_360AdvertiserLink
                             * @property {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal|null} [displayVideo_360AdvertiserLinkProposal] ChangeHistoryResource displayVideo_360AdvertiserLinkProposal
                             * @property {google.analytics.admin.v1alpha.IConversionEvent|null} [conversionEvent] ChangeHistoryResource conversionEvent
                             * @property {google.analytics.admin.v1alpha.IMeasurementProtocolSecret|null} [measurementProtocolSecret] ChangeHistoryResource measurementProtocolSecret
                             * @property {google.analytics.admin.v1alpha.ICustomDimension|null} [customDimension] ChangeHistoryResource customDimension
                             * @property {google.analytics.admin.v1alpha.ICustomMetric|null} [customMetric] ChangeHistoryResource customMetric
                             * @property {google.analytics.admin.v1alpha.IDataRetentionSettings|null} [dataRetentionSettings] ChangeHistoryResource dataRetentionSettings
                             * @property {google.analytics.admin.v1alpha.ISearchAds360Link|null} [searchAds_360Link] ChangeHistoryResource searchAds_360Link
                             * @property {google.analytics.admin.v1alpha.IDataStream|null} [dataStream] ChangeHistoryResource dataStream
                             * @property {google.analytics.admin.v1alpha.IAttributionSettings|null} [attributionSettings] ChangeHistoryResource attributionSettings
                             * @property {google.analytics.admin.v1alpha.IExpandedDataSet|null} [expandedDataSet] ChangeHistoryResource expandedDataSet
                             * @property {google.analytics.admin.v1alpha.IChannelGroup|null} [channelGroup] ChangeHistoryResource channelGroup
                             * @property {google.analytics.admin.v1alpha.IBigQueryLink|null} [bigqueryLink] ChangeHistoryResource bigqueryLink
                             * @property {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings|null} [enhancedMeasurementSettings] ChangeHistoryResource enhancedMeasurementSettings
                             * @property {google.analytics.admin.v1alpha.IAdSenseLink|null} [adsenseLink] ChangeHistoryResource adsenseLink
                             * @property {google.analytics.admin.v1alpha.IAudience|null} [audience] ChangeHistoryResource audience
                             * @property {google.analytics.admin.v1alpha.IEventCreateRule|null} [eventCreateRule] ChangeHistoryResource eventCreateRule
                             */
    
                            /**
                             * Constructs a new ChangeHistoryResource.
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange
                             * @classdesc Represents a ChangeHistoryResource.
                             * @implements IChangeHistoryResource
                             * @constructor
                             * @param {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource=} [properties] Properties to set
                             */
                            function ChangeHistoryResource(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * ChangeHistoryResource account.
                             * @member {google.analytics.admin.v1alpha.IAccount|null|undefined} account
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.account = null;
    
                            /**
                             * ChangeHistoryResource property.
                             * @member {google.analytics.admin.v1alpha.IProperty|null|undefined} property
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.property = null;
    
                            /**
                             * ChangeHistoryResource firebaseLink.
                             * @member {google.analytics.admin.v1alpha.IFirebaseLink|null|undefined} firebaseLink
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.firebaseLink = null;
    
                            /**
                             * ChangeHistoryResource googleAdsLink.
                             * @member {google.analytics.admin.v1alpha.IGoogleAdsLink|null|undefined} googleAdsLink
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.googleAdsLink = null;
    
                            /**
                             * ChangeHistoryResource googleSignalsSettings.
                             * @member {google.analytics.admin.v1alpha.IGoogleSignalsSettings|null|undefined} googleSignalsSettings
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.googleSignalsSettings = null;
    
                            /**
                             * ChangeHistoryResource displayVideo_360AdvertiserLink.
                             * @member {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink|null|undefined} displayVideo_360AdvertiserLink
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.displayVideo_360AdvertiserLink = null;
    
                            /**
                             * ChangeHistoryResource displayVideo_360AdvertiserLinkProposal.
                             * @member {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal|null|undefined} displayVideo_360AdvertiserLinkProposal
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.displayVideo_360AdvertiserLinkProposal = null;
    
                            /**
                             * ChangeHistoryResource conversionEvent.
                             * @member {google.analytics.admin.v1alpha.IConversionEvent|null|undefined} conversionEvent
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.conversionEvent = null;
    
                            /**
                             * ChangeHistoryResource measurementProtocolSecret.
                             * @member {google.analytics.admin.v1alpha.IMeasurementProtocolSecret|null|undefined} measurementProtocolSecret
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.measurementProtocolSecret = null;
    
                            /**
                             * ChangeHistoryResource customDimension.
                             * @member {google.analytics.admin.v1alpha.ICustomDimension|null|undefined} customDimension
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.customDimension = null;
    
                            /**
                             * ChangeHistoryResource customMetric.
                             * @member {google.analytics.admin.v1alpha.ICustomMetric|null|undefined} customMetric
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.customMetric = null;
    
                            /**
                             * ChangeHistoryResource dataRetentionSettings.
                             * @member {google.analytics.admin.v1alpha.IDataRetentionSettings|null|undefined} dataRetentionSettings
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.dataRetentionSettings = null;
    
                            /**
                             * ChangeHistoryResource searchAds_360Link.
                             * @member {google.analytics.admin.v1alpha.ISearchAds360Link|null|undefined} searchAds_360Link
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.searchAds_360Link = null;
    
                            /**
                             * ChangeHistoryResource dataStream.
                             * @member {google.analytics.admin.v1alpha.IDataStream|null|undefined} dataStream
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.dataStream = null;
    
                            /**
                             * ChangeHistoryResource attributionSettings.
                             * @member {google.analytics.admin.v1alpha.IAttributionSettings|null|undefined} attributionSettings
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.attributionSettings = null;
    
                            /**
                             * ChangeHistoryResource expandedDataSet.
                             * @member {google.analytics.admin.v1alpha.IExpandedDataSet|null|undefined} expandedDataSet
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.expandedDataSet = null;
    
                            /**
                             * ChangeHistoryResource channelGroup.
                             * @member {google.analytics.admin.v1alpha.IChannelGroup|null|undefined} channelGroup
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.channelGroup = null;
    
                            /**
                             * ChangeHistoryResource bigqueryLink.
                             * @member {google.analytics.admin.v1alpha.IBigQueryLink|null|undefined} bigqueryLink
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.bigqueryLink = null;
    
                            /**
                             * ChangeHistoryResource enhancedMeasurementSettings.
                             * @member {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings|null|undefined} enhancedMeasurementSettings
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.enhancedMeasurementSettings = null;
    
                            /**
                             * ChangeHistoryResource adsenseLink.
                             * @member {google.analytics.admin.v1alpha.IAdSenseLink|null|undefined} adsenseLink
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.adsenseLink = null;
    
                            /**
                             * ChangeHistoryResource audience.
                             * @member {google.analytics.admin.v1alpha.IAudience|null|undefined} audience
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.audience = null;
    
                            /**
                             * ChangeHistoryResource eventCreateRule.
                             * @member {google.analytics.admin.v1alpha.IEventCreateRule|null|undefined} eventCreateRule
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.eventCreateRule = null;
    
                            // OneOf field names bound to virtual getters and setters
                            var $oneOfFields;
    
                            /**
                             * ChangeHistoryResource resource.
                             * @member {"account"|"property"|"firebaseLink"|"googleAdsLink"|"googleSignalsSettings"|"displayVideo_360AdvertiserLink"|"displayVideo_360AdvertiserLinkProposal"|"conversionEvent"|"measurementProtocolSecret"|"customDimension"|"customMetric"|"dataRetentionSettings"|"searchAds_360Link"|"dataStream"|"attributionSettings"|"expandedDataSet"|"channelGroup"|"bigqueryLink"|"enhancedMeasurementSettings"|"adsenseLink"|"audience"|"eventCreateRule"|undefined} resource
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            Object.defineProperty(ChangeHistoryResource.prototype, "resource", {
                                get: $util.oneOfGetter($oneOfFields = ["account", "property", "firebaseLink", "googleAdsLink", "googleSignalsSettings", "displayVideo_360AdvertiserLink", "displayVideo_360AdvertiserLinkProposal", "conversionEvent", "measurementProtocolSecret", "customDimension", "customMetric", "dataRetentionSettings", "searchAds_360Link", "dataStream", "attributionSettings", "expandedDataSet", "channelGroup", "bigqueryLink", "enhancedMeasurementSettings", "adsenseLink", "audience", "eventCreateRule"]),
                                set: $util.oneOfSetter($oneOfFields)
                            });
    
                            /**
                             * Creates a new ChangeHistoryResource instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource instance
                             */
                            ChangeHistoryResource.create = function create(properties) {
                                return new ChangeHistoryResource(properties);
                            };
    
                            /**
                             * Encodes the specified ChangeHistoryResource message. Does not implicitly {@link google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource} message ChangeHistoryResource message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ChangeHistoryResource.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                    $root.google.analytics.admin.v1alpha.Account.encode(message.account, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                    $root.google.analytics.admin.v1alpha.Property.encode(message.property, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.firebaseLink != null && Object.hasOwnProperty.call(message, "firebaseLink"))
                                    $root.google.analytics.admin.v1alpha.FirebaseLink.encode(message.firebaseLink, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                                if (message.googleAdsLink != null && Object.hasOwnProperty.call(message, "googleAdsLink"))
                                    $root.google.analytics.admin.v1alpha.GoogleAdsLink.encode(message.googleAdsLink, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                                if (message.googleSignalsSettings != null && Object.hasOwnProperty.call(message, "googleSignalsSettings"))
                                    $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.encode(message.googleSignalsSettings, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                                if (message.displayVideo_360AdvertiserLink != null && Object.hasOwnProperty.call(message, "displayVideo_360AdvertiserLink"))
                                    $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.encode(message.displayVideo_360AdvertiserLink, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                                if (message.displayVideo_360AdvertiserLinkProposal != null && Object.hasOwnProperty.call(message, "displayVideo_360AdvertiserLinkProposal"))
                                    $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.encode(message.displayVideo_360AdvertiserLinkProposal, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                                if (message.conversionEvent != null && Object.hasOwnProperty.call(message, "conversionEvent"))
                                    $root.google.analytics.admin.v1alpha.ConversionEvent.encode(message.conversionEvent, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                                if (message.measurementProtocolSecret != null && Object.hasOwnProperty.call(message, "measurementProtocolSecret"))
                                    $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.encode(message.measurementProtocolSecret, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                                if (message.customDimension != null && Object.hasOwnProperty.call(message, "customDimension"))
                                    $root.google.analytics.admin.v1alpha.CustomDimension.encode(message.customDimension, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
                                if (message.customMetric != null && Object.hasOwnProperty.call(message, "customMetric"))
                                    $root.google.analytics.admin.v1alpha.CustomMetric.encode(message.customMetric, writer.uint32(/* id 14, wireType 2 =*/114).fork()).ldelim();
                                if (message.dataRetentionSettings != null && Object.hasOwnProperty.call(message, "dataRetentionSettings"))
                                    $root.google.analytics.admin.v1alpha.DataRetentionSettings.encode(message.dataRetentionSettings, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                                if (message.searchAds_360Link != null && Object.hasOwnProperty.call(message, "searchAds_360Link"))
                                    $root.google.analytics.admin.v1alpha.SearchAds360Link.encode(message.searchAds_360Link, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
                                if (message.dataStream != null && Object.hasOwnProperty.call(message, "dataStream"))
                                    $root.google.analytics.admin.v1alpha.DataStream.encode(message.dataStream, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                                if (message.attributionSettings != null && Object.hasOwnProperty.call(message, "attributionSettings"))
                                    $root.google.analytics.admin.v1alpha.AttributionSettings.encode(message.attributionSettings, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                                if (message.expandedDataSet != null && Object.hasOwnProperty.call(message, "expandedDataSet"))
                                    $root.google.analytics.admin.v1alpha.ExpandedDataSet.encode(message.expandedDataSet, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                                if (message.channelGroup != null && Object.hasOwnProperty.call(message, "channelGroup"))
                                    $root.google.analytics.admin.v1alpha.ChannelGroup.encode(message.channelGroup, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                                if (message.bigqueryLink != null && Object.hasOwnProperty.call(message, "bigqueryLink"))
                                    $root.google.analytics.admin.v1alpha.BigQueryLink.encode(message.bigqueryLink, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                                if (message.enhancedMeasurementSettings != null && Object.hasOwnProperty.call(message, "enhancedMeasurementSettings"))
                                    $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.encode(message.enhancedMeasurementSettings, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                                if (message.adsenseLink != null && Object.hasOwnProperty.call(message, "adsenseLink"))
                                    $root.google.analytics.admin.v1alpha.AdSenseLink.encode(message.adsenseLink, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                                if (message.audience != null && Object.hasOwnProperty.call(message, "audience"))
                                    $root.google.analytics.admin.v1alpha.Audience.encode(message.audience, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                                if (message.eventCreateRule != null && Object.hasOwnProperty.call(message, "eventCreateRule"))
                                    $root.google.analytics.admin.v1alpha.EventCreateRule.encode(message.eventCreateRule, writer.uint32(/* id 29, wireType 2 =*/234).fork()).ldelim();
                                return writer;
                            };
    
                            /**
                             * Encodes the specified ChangeHistoryResource message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChangeHistoryChange.IChangeHistoryResource} message ChangeHistoryResource message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ChangeHistoryResource.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a ChangeHistoryResource message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ChangeHistoryResource.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.account = $root.google.analytics.admin.v1alpha.Account.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 2: {
                                            message.property = $root.google.analytics.admin.v1alpha.Property.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 6: {
                                            message.firebaseLink = $root.google.analytics.admin.v1alpha.FirebaseLink.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 7: {
                                            message.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 8: {
                                            message.googleSignalsSettings = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 9: {
                                            message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 10: {
                                            message.displayVideo_360AdvertiserLinkProposal = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 11: {
                                            message.conversionEvent = $root.google.analytics.admin.v1alpha.ConversionEvent.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 12: {
                                            message.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 13: {
                                            message.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 14: {
                                            message.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 15: {
                                            message.dataRetentionSettings = $root.google.analytics.admin.v1alpha.DataRetentionSettings.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 16: {
                                            message.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 18: {
                                            message.dataStream = $root.google.analytics.admin.v1alpha.DataStream.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 20: {
                                            message.attributionSettings = $root.google.analytics.admin.v1alpha.AttributionSettings.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 21: {
                                            message.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 22: {
                                            message.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 23: {
                                            message.bigqueryLink = $root.google.analytics.admin.v1alpha.BigQueryLink.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 24: {
                                            message.enhancedMeasurementSettings = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 27: {
                                            message.adsenseLink = $root.google.analytics.admin.v1alpha.AdSenseLink.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 28: {
                                            message.audience = $root.google.analytics.admin.v1alpha.Audience.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 29: {
                                            message.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.decode(reader, reader.uint32());
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a ChangeHistoryResource message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ChangeHistoryResource.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a ChangeHistoryResource message.
                             * @function verify
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            ChangeHistoryResource.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                var properties = {};
                                if (message.account != null && message.hasOwnProperty("account")) {
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.Account.verify(message.account);
                                        if (error)
                                            return "account." + error;
                                    }
                                }
                                if (message.property != null && message.hasOwnProperty("property")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.Property.verify(message.property);
                                        if (error)
                                            return "property." + error;
                                    }
                                }
                                if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.FirebaseLink.verify(message.firebaseLink);
                                        if (error)
                                            return "firebaseLink." + error;
                                    }
                                }
                                if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.GoogleAdsLink.verify(message.googleAdsLink);
                                        if (error)
                                            return "googleAdsLink." + error;
                                    }
                                }
                                if (message.googleSignalsSettings != null && message.hasOwnProperty("googleSignalsSettings")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.verify(message.googleSignalsSettings);
                                        if (error)
                                            return "googleSignalsSettings." + error;
                                    }
                                }
                                if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.verify(message.displayVideo_360AdvertiserLink);
                                        if (error)
                                            return "displayVideo_360AdvertiserLink." + error;
                                    }
                                }
                                if (message.displayVideo_360AdvertiserLinkProposal != null && message.hasOwnProperty("displayVideo_360AdvertiserLinkProposal")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.verify(message.displayVideo_360AdvertiserLinkProposal);
                                        if (error)
                                            return "displayVideo_360AdvertiserLinkProposal." + error;
                                    }
                                }
                                if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.ConversionEvent.verify(message.conversionEvent);
                                        if (error)
                                            return "conversionEvent." + error;
                                    }
                                }
                                if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.verify(message.measurementProtocolSecret);
                                        if (error)
                                            return "measurementProtocolSecret." + error;
                                    }
                                }
                                if (message.customDimension != null && message.hasOwnProperty("customDimension")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.CustomDimension.verify(message.customDimension);
                                        if (error)
                                            return "customDimension." + error;
                                    }
                                }
                                if (message.customMetric != null && message.hasOwnProperty("customMetric")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.CustomMetric.verify(message.customMetric);
                                        if (error)
                                            return "customMetric." + error;
                                    }
                                }
                                if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.DataRetentionSettings.verify(message.dataRetentionSettings);
                                        if (error)
                                            return "dataRetentionSettings." + error;
                                    }
                                }
                                if (message.searchAds_360Link != null && message.hasOwnProperty("searchAds_360Link")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.SearchAds360Link.verify(message.searchAds_360Link);
                                        if (error)
                                            return "searchAds_360Link." + error;
                                    }
                                }
                                if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.DataStream.verify(message.dataStream);
                                        if (error)
                                            return "dataStream." + error;
                                    }
                                }
                                if (message.attributionSettings != null && message.hasOwnProperty("attributionSettings")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.AttributionSettings.verify(message.attributionSettings);
                                        if (error)
                                            return "attributionSettings." + error;
                                    }
                                }
                                if (message.expandedDataSet != null && message.hasOwnProperty("expandedDataSet")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.ExpandedDataSet.verify(message.expandedDataSet);
                                        if (error)
                                            return "expandedDataSet." + error;
                                    }
                                }
                                if (message.channelGroup != null && message.hasOwnProperty("channelGroup")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.ChannelGroup.verify(message.channelGroup);
                                        if (error)
                                            return "channelGroup." + error;
                                    }
                                }
                                if (message.bigqueryLink != null && message.hasOwnProperty("bigqueryLink")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.BigQueryLink.verify(message.bigqueryLink);
                                        if (error)
                                            return "bigqueryLink." + error;
                                    }
                                }
                                if (message.enhancedMeasurementSettings != null && message.hasOwnProperty("enhancedMeasurementSettings")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.verify(message.enhancedMeasurementSettings);
                                        if (error)
                                            return "enhancedMeasurementSettings." + error;
                                    }
                                }
                                if (message.adsenseLink != null && message.hasOwnProperty("adsenseLink")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.AdSenseLink.verify(message.adsenseLink);
                                        if (error)
                                            return "adsenseLink." + error;
                                    }
                                }
                                if (message.audience != null && message.hasOwnProperty("audience")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.Audience.verify(message.audience);
                                        if (error)
                                            return "audience." + error;
                                    }
                                }
                                if (message.eventCreateRule != null && message.hasOwnProperty("eventCreateRule")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1alpha.EventCreateRule.verify(message.eventCreateRule);
                                        if (error)
                                            return "eventCreateRule." + error;
                                    }
                                }
                                return null;
                            };
    
                            /**
                             * Creates a ChangeHistoryResource message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource
                             */
                            ChangeHistoryResource.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource)
                                    return object;
                                var message = new $root.google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource();
                                if (object.account != null) {
                                    if (typeof object.account !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.account: object expected");
                                    message.account = $root.google.analytics.admin.v1alpha.Account.fromObject(object.account);
                                }
                                if (object.property != null) {
                                    if (typeof object.property !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.property: object expected");
                                    message.property = $root.google.analytics.admin.v1alpha.Property.fromObject(object.property);
                                }
                                if (object.firebaseLink != null) {
                                    if (typeof object.firebaseLink !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.firebaseLink: object expected");
                                    message.firebaseLink = $root.google.analytics.admin.v1alpha.FirebaseLink.fromObject(object.firebaseLink);
                                }
                                if (object.googleAdsLink != null) {
                                    if (typeof object.googleAdsLink !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.googleAdsLink: object expected");
                                    message.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.fromObject(object.googleAdsLink);
                                }
                                if (object.googleSignalsSettings != null) {
                                    if (typeof object.googleSignalsSettings !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.googleSignalsSettings: object expected");
                                    message.googleSignalsSettings = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.fromObject(object.googleSignalsSettings);
                                }
                                if (object.displayVideo_360AdvertiserLink != null) {
                                    if (typeof object.displayVideo_360AdvertiserLink !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.displayVideo_360AdvertiserLink: object expected");
                                    message.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.fromObject(object.displayVideo_360AdvertiserLink);
                                }
                                if (object.displayVideo_360AdvertiserLinkProposal != null) {
                                    if (typeof object.displayVideo_360AdvertiserLinkProposal !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.displayVideo_360AdvertiserLinkProposal: object expected");
                                    message.displayVideo_360AdvertiserLinkProposal = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.fromObject(object.displayVideo_360AdvertiserLinkProposal);
                                }
                                if (object.conversionEvent != null) {
                                    if (typeof object.conversionEvent !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.conversionEvent: object expected");
                                    message.conversionEvent = $root.google.analytics.admin.v1alpha.ConversionEvent.fromObject(object.conversionEvent);
                                }
                                if (object.measurementProtocolSecret != null) {
                                    if (typeof object.measurementProtocolSecret !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.measurementProtocolSecret: object expected");
                                    message.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecret);
                                }
                                if (object.customDimension != null) {
                                    if (typeof object.customDimension !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.customDimension: object expected");
                                    message.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.fromObject(object.customDimension);
                                }
                                if (object.customMetric != null) {
                                    if (typeof object.customMetric !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.customMetric: object expected");
                                    message.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.fromObject(object.customMetric);
                                }
                                if (object.dataRetentionSettings != null) {
                                    if (typeof object.dataRetentionSettings !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.dataRetentionSettings: object expected");
                                    message.dataRetentionSettings = $root.google.analytics.admin.v1alpha.DataRetentionSettings.fromObject(object.dataRetentionSettings);
                                }
                                if (object.searchAds_360Link != null) {
                                    if (typeof object.searchAds_360Link !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.searchAds_360Link: object expected");
                                    message.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.fromObject(object.searchAds_360Link);
                                }
                                if (object.dataStream != null) {
                                    if (typeof object.dataStream !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.dataStream: object expected");
                                    message.dataStream = $root.google.analytics.admin.v1alpha.DataStream.fromObject(object.dataStream);
                                }
                                if (object.attributionSettings != null) {
                                    if (typeof object.attributionSettings !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.attributionSettings: object expected");
                                    message.attributionSettings = $root.google.analytics.admin.v1alpha.AttributionSettings.fromObject(object.attributionSettings);
                                }
                                if (object.expandedDataSet != null) {
                                    if (typeof object.expandedDataSet !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.expandedDataSet: object expected");
                                    message.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.fromObject(object.expandedDataSet);
                                }
                                if (object.channelGroup != null) {
                                    if (typeof object.channelGroup !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.channelGroup: object expected");
                                    message.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.fromObject(object.channelGroup);
                                }
                                if (object.bigqueryLink != null) {
                                    if (typeof object.bigqueryLink !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.bigqueryLink: object expected");
                                    message.bigqueryLink = $root.google.analytics.admin.v1alpha.BigQueryLink.fromObject(object.bigqueryLink);
                                }
                                if (object.enhancedMeasurementSettings != null) {
                                    if (typeof object.enhancedMeasurementSettings !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.enhancedMeasurementSettings: object expected");
                                    message.enhancedMeasurementSettings = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.fromObject(object.enhancedMeasurementSettings);
                                }
                                if (object.adsenseLink != null) {
                                    if (typeof object.adsenseLink !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.adsenseLink: object expected");
                                    message.adsenseLink = $root.google.analytics.admin.v1alpha.AdSenseLink.fromObject(object.adsenseLink);
                                }
                                if (object.audience != null) {
                                    if (typeof object.audience !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.audience: object expected");
                                    message.audience = $root.google.analytics.admin.v1alpha.Audience.fromObject(object.audience);
                                }
                                if (object.eventCreateRule != null) {
                                    if (typeof object.eventCreateRule !== "object")
                                        throw TypeError(".google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource.eventCreateRule: object expected");
                                    message.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.fromObject(object.eventCreateRule);
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a ChangeHistoryResource message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource} message ChangeHistoryResource
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            ChangeHistoryResource.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (message.account != null && message.hasOwnProperty("account")) {
                                    object.account = $root.google.analytics.admin.v1alpha.Account.toObject(message.account, options);
                                    if (options.oneofs)
                                        object.resource = "account";
                                }
                                if (message.property != null && message.hasOwnProperty("property")) {
                                    object.property = $root.google.analytics.admin.v1alpha.Property.toObject(message.property, options);
                                    if (options.oneofs)
                                        object.resource = "property";
                                }
                                if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink")) {
                                    object.firebaseLink = $root.google.analytics.admin.v1alpha.FirebaseLink.toObject(message.firebaseLink, options);
                                    if (options.oneofs)
                                        object.resource = "firebaseLink";
                                }
                                if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                    object.googleAdsLink = $root.google.analytics.admin.v1alpha.GoogleAdsLink.toObject(message.googleAdsLink, options);
                                    if (options.oneofs)
                                        object.resource = "googleAdsLink";
                                }
                                if (message.googleSignalsSettings != null && message.hasOwnProperty("googleSignalsSettings")) {
                                    object.googleSignalsSettings = $root.google.analytics.admin.v1alpha.GoogleSignalsSettings.toObject(message.googleSignalsSettings, options);
                                    if (options.oneofs)
                                        object.resource = "googleSignalsSettings";
                                }
                                if (message.displayVideo_360AdvertiserLink != null && message.hasOwnProperty("displayVideo_360AdvertiserLink")) {
                                    object.displayVideo_360AdvertiserLink = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.toObject(message.displayVideo_360AdvertiserLink, options);
                                    if (options.oneofs)
                                        object.resource = "displayVideo_360AdvertiserLink";
                                }
                                if (message.displayVideo_360AdvertiserLinkProposal != null && message.hasOwnProperty("displayVideo_360AdvertiserLinkProposal")) {
                                    object.displayVideo_360AdvertiserLinkProposal = $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.toObject(message.displayVideo_360AdvertiserLinkProposal, options);
                                    if (options.oneofs)
                                        object.resource = "displayVideo_360AdvertiserLinkProposal";
                                }
                                if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent")) {
                                    object.conversionEvent = $root.google.analytics.admin.v1alpha.ConversionEvent.toObject(message.conversionEvent, options);
                                    if (options.oneofs)
                                        object.resource = "conversionEvent";
                                }
                                if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                    object.measurementProtocolSecret = $root.google.analytics.admin.v1alpha.MeasurementProtocolSecret.toObject(message.measurementProtocolSecret, options);
                                    if (options.oneofs)
                                        object.resource = "measurementProtocolSecret";
                                }
                                if (message.customDimension != null && message.hasOwnProperty("customDimension")) {
                                    object.customDimension = $root.google.analytics.admin.v1alpha.CustomDimension.toObject(message.customDimension, options);
                                    if (options.oneofs)
                                        object.resource = "customDimension";
                                }
                                if (message.customMetric != null && message.hasOwnProperty("customMetric")) {
                                    object.customMetric = $root.google.analytics.admin.v1alpha.CustomMetric.toObject(message.customMetric, options);
                                    if (options.oneofs)
                                        object.resource = "customMetric";
                                }
                                if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings")) {
                                    object.dataRetentionSettings = $root.google.analytics.admin.v1alpha.DataRetentionSettings.toObject(message.dataRetentionSettings, options);
                                    if (options.oneofs)
                                        object.resource = "dataRetentionSettings";
                                }
                                if (message.searchAds_360Link != null && message.hasOwnProperty("searchAds_360Link")) {
                                    object.searchAds_360Link = $root.google.analytics.admin.v1alpha.SearchAds360Link.toObject(message.searchAds_360Link, options);
                                    if (options.oneofs)
                                        object.resource = "searchAds_360Link";
                                }
                                if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                    object.dataStream = $root.google.analytics.admin.v1alpha.DataStream.toObject(message.dataStream, options);
                                    if (options.oneofs)
                                        object.resource = "dataStream";
                                }
                                if (message.attributionSettings != null && message.hasOwnProperty("attributionSettings")) {
                                    object.attributionSettings = $root.google.analytics.admin.v1alpha.AttributionSettings.toObject(message.attributionSettings, options);
                                    if (options.oneofs)
                                        object.resource = "attributionSettings";
                                }
                                if (message.expandedDataSet != null && message.hasOwnProperty("expandedDataSet")) {
                                    object.expandedDataSet = $root.google.analytics.admin.v1alpha.ExpandedDataSet.toObject(message.expandedDataSet, options);
                                    if (options.oneofs)
                                        object.resource = "expandedDataSet";
                                }
                                if (message.channelGroup != null && message.hasOwnProperty("channelGroup")) {
                                    object.channelGroup = $root.google.analytics.admin.v1alpha.ChannelGroup.toObject(message.channelGroup, options);
                                    if (options.oneofs)
                                        object.resource = "channelGroup";
                                }
                                if (message.bigqueryLink != null && message.hasOwnProperty("bigqueryLink")) {
                                    object.bigqueryLink = $root.google.analytics.admin.v1alpha.BigQueryLink.toObject(message.bigqueryLink, options);
                                    if (options.oneofs)
                                        object.resource = "bigqueryLink";
                                }
                                if (message.enhancedMeasurementSettings != null && message.hasOwnProperty("enhancedMeasurementSettings")) {
                                    object.enhancedMeasurementSettings = $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings.toObject(message.enhancedMeasurementSettings, options);
                                    if (options.oneofs)
                                        object.resource = "enhancedMeasurementSettings";
                                }
                                if (message.adsenseLink != null && message.hasOwnProperty("adsenseLink")) {
                                    object.adsenseLink = $root.google.analytics.admin.v1alpha.AdSenseLink.toObject(message.adsenseLink, options);
                                    if (options.oneofs)
                                        object.resource = "adsenseLink";
                                }
                                if (message.audience != null && message.hasOwnProperty("audience")) {
                                    object.audience = $root.google.analytics.admin.v1alpha.Audience.toObject(message.audience, options);
                                    if (options.oneofs)
                                        object.resource = "audience";
                                }
                                if (message.eventCreateRule != null && message.hasOwnProperty("eventCreateRule")) {
                                    object.eventCreateRule = $root.google.analytics.admin.v1alpha.EventCreateRule.toObject(message.eventCreateRule, options);
                                    if (options.oneofs)
                                        object.resource = "eventCreateRule";
                                }
                                return object;
                            };
    
                            /**
                             * Converts this ChangeHistoryResource to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            ChangeHistoryResource.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for ChangeHistoryResource
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            ChangeHistoryResource.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1alpha.ChangeHistoryChange.ChangeHistoryResource";
                            };
    
                            return ChangeHistoryResource;
                        })();
    
                        return ChangeHistoryChange;
                    })();
    
                    v1alpha.DisplayVideo360AdvertiserLink = (function() {
    
                        /**
                         * Properties of a DisplayVideo360AdvertiserLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDisplayVideo360AdvertiserLink
                         * @property {string|null} [name] DisplayVideo360AdvertiserLink name
                         * @property {string|null} [advertiserId] DisplayVideo360AdvertiserLink advertiserId
                         * @property {string|null} [advertiserDisplayName] DisplayVideo360AdvertiserLink advertiserDisplayName
                         * @property {google.protobuf.IBoolValue|null} [adsPersonalizationEnabled] DisplayVideo360AdvertiserLink adsPersonalizationEnabled
                         * @property {google.protobuf.IBoolValue|null} [campaignDataSharingEnabled] DisplayVideo360AdvertiserLink campaignDataSharingEnabled
                         * @property {google.protobuf.IBoolValue|null} [costDataSharingEnabled] DisplayVideo360AdvertiserLink costDataSharingEnabled
                         */
    
                        /**
                         * Constructs a new DisplayVideo360AdvertiserLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DisplayVideo360AdvertiserLink.
                         * @implements IDisplayVideo360AdvertiserLink
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink=} [properties] Properties to set
                         */
                        function DisplayVideo360AdvertiserLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisplayVideo360AdvertiserLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @instance
                         */
                        DisplayVideo360AdvertiserLink.prototype.name = "";
    
                        /**
                         * DisplayVideo360AdvertiserLink advertiserId.
                         * @member {string} advertiserId
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @instance
                         */
                        DisplayVideo360AdvertiserLink.prototype.advertiserId = "";
    
                        /**
                         * DisplayVideo360AdvertiserLink advertiserDisplayName.
                         * @member {string} advertiserDisplayName
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @instance
                         */
                        DisplayVideo360AdvertiserLink.prototype.advertiserDisplayName = "";
    
                        /**
                         * DisplayVideo360AdvertiserLink adsPersonalizationEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} adsPersonalizationEnabled
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @instance
                         */
                        DisplayVideo360AdvertiserLink.prototype.adsPersonalizationEnabled = null;
    
                        /**
                         * DisplayVideo360AdvertiserLink campaignDataSharingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} campaignDataSharingEnabled
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @instance
                         */
                        DisplayVideo360AdvertiserLink.prototype.campaignDataSharingEnabled = null;
    
                        /**
                         * DisplayVideo360AdvertiserLink costDataSharingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} costDataSharingEnabled
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @instance
                         */
                        DisplayVideo360AdvertiserLink.prototype.costDataSharingEnabled = null;
    
                        /**
                         * Creates a new DisplayVideo360AdvertiserLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} DisplayVideo360AdvertiserLink instance
                         */
                        DisplayVideo360AdvertiserLink.create = function create(properties) {
                            return new DisplayVideo360AdvertiserLink(properties);
                        };
    
                        /**
                         * Encodes the specified DisplayVideo360AdvertiserLink message. Does not implicitly {@link google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink} message DisplayVideo360AdvertiserLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayVideo360AdvertiserLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.advertiserId != null && Object.hasOwnProperty.call(message, "advertiserId"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.advertiserId);
                            if (message.advertiserDisplayName != null && Object.hasOwnProperty.call(message, "advertiserDisplayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.advertiserDisplayName);
                            if (message.adsPersonalizationEnabled != null && Object.hasOwnProperty.call(message, "adsPersonalizationEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.adsPersonalizationEnabled, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.campaignDataSharingEnabled != null && Object.hasOwnProperty.call(message, "campaignDataSharingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.campaignDataSharingEnabled, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.costDataSharingEnabled != null && Object.hasOwnProperty.call(message, "costDataSharingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.costDataSharingEnabled, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisplayVideo360AdvertiserLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLink} message DisplayVideo360AdvertiserLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayVideo360AdvertiserLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisplayVideo360AdvertiserLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} DisplayVideo360AdvertiserLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayVideo360AdvertiserLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.advertiserId = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.advertiserDisplayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 6: {
                                        message.costDataSharingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisplayVideo360AdvertiserLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} DisplayVideo360AdvertiserLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayVideo360AdvertiserLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisplayVideo360AdvertiserLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayVideo360AdvertiserLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.advertiserId != null && message.hasOwnProperty("advertiserId"))
                                if (!$util.isString(message.advertiserId))
                                    return "advertiserId: string expected";
                            if (message.advertiserDisplayName != null && message.hasOwnProperty("advertiserDisplayName"))
                                if (!$util.isString(message.advertiserDisplayName))
                                    return "advertiserDisplayName: string expected";
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.adsPersonalizationEnabled);
                                if (error)
                                    return "adsPersonalizationEnabled." + error;
                            }
                            if (message.campaignDataSharingEnabled != null && message.hasOwnProperty("campaignDataSharingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.campaignDataSharingEnabled);
                                if (error)
                                    return "campaignDataSharingEnabled." + error;
                            }
                            if (message.costDataSharingEnabled != null && message.hasOwnProperty("costDataSharingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.costDataSharingEnabled);
                                if (error)
                                    return "costDataSharingEnabled." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisplayVideo360AdvertiserLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} DisplayVideo360AdvertiserLink
                         */
                        DisplayVideo360AdvertiserLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.advertiserId != null)
                                message.advertiserId = String(object.advertiserId);
                            if (object.advertiserDisplayName != null)
                                message.advertiserDisplayName = String(object.advertiserDisplayName);
                            if (object.adsPersonalizationEnabled != null) {
                                if (typeof object.adsPersonalizationEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.adsPersonalizationEnabled: object expected");
                                message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.fromObject(object.adsPersonalizationEnabled);
                            }
                            if (object.campaignDataSharingEnabled != null) {
                                if (typeof object.campaignDataSharingEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.campaignDataSharingEnabled: object expected");
                                message.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.fromObject(object.campaignDataSharingEnabled);
                            }
                            if (object.costDataSharingEnabled != null) {
                                if (typeof object.costDataSharingEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink.costDataSharingEnabled: object expected");
                                message.costDataSharingEnabled = $root.google.protobuf.BoolValue.fromObject(object.costDataSharingEnabled);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisplayVideo360AdvertiserLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink} message DisplayVideo360AdvertiserLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayVideo360AdvertiserLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.advertiserId = "";
                                object.advertiserDisplayName = "";
                                object.adsPersonalizationEnabled = null;
                                object.campaignDataSharingEnabled = null;
                                object.costDataSharingEnabled = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.advertiserId != null && message.hasOwnProperty("advertiserId"))
                                object.advertiserId = message.advertiserId;
                            if (message.advertiserDisplayName != null && message.hasOwnProperty("advertiserDisplayName"))
                                object.advertiserDisplayName = message.advertiserDisplayName;
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled"))
                                object.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.toObject(message.adsPersonalizationEnabled, options);
                            if (message.campaignDataSharingEnabled != null && message.hasOwnProperty("campaignDataSharingEnabled"))
                                object.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.toObject(message.campaignDataSharingEnabled, options);
                            if (message.costDataSharingEnabled != null && message.hasOwnProperty("costDataSharingEnabled"))
                                object.costDataSharingEnabled = $root.google.protobuf.BoolValue.toObject(message.costDataSharingEnabled, options);
                            return object;
                        };
    
                        /**
                         * Converts this DisplayVideo360AdvertiserLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayVideo360AdvertiserLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisplayVideo360AdvertiserLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisplayVideo360AdvertiserLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLink";
                        };
    
                        return DisplayVideo360AdvertiserLink;
                    })();
    
                    v1alpha.DisplayVideo360AdvertiserLinkProposal = (function() {
    
                        /**
                         * Properties of a DisplayVideo360AdvertiserLinkProposal.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDisplayVideo360AdvertiserLinkProposal
                         * @property {string|null} [name] DisplayVideo360AdvertiserLinkProposal name
                         * @property {string|null} [advertiserId] DisplayVideo360AdvertiserLinkProposal advertiserId
                         * @property {google.analytics.admin.v1alpha.ILinkProposalStatusDetails|null} [linkProposalStatusDetails] DisplayVideo360AdvertiserLinkProposal linkProposalStatusDetails
                         * @property {string|null} [advertiserDisplayName] DisplayVideo360AdvertiserLinkProposal advertiserDisplayName
                         * @property {string|null} [validationEmail] DisplayVideo360AdvertiserLinkProposal validationEmail
                         * @property {google.protobuf.IBoolValue|null} [adsPersonalizationEnabled] DisplayVideo360AdvertiserLinkProposal adsPersonalizationEnabled
                         * @property {google.protobuf.IBoolValue|null} [campaignDataSharingEnabled] DisplayVideo360AdvertiserLinkProposal campaignDataSharingEnabled
                         * @property {google.protobuf.IBoolValue|null} [costDataSharingEnabled] DisplayVideo360AdvertiserLinkProposal costDataSharingEnabled
                         */
    
                        /**
                         * Constructs a new DisplayVideo360AdvertiserLinkProposal.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DisplayVideo360AdvertiserLinkProposal.
                         * @implements IDisplayVideo360AdvertiserLinkProposal
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal=} [properties] Properties to set
                         */
                        function DisplayVideo360AdvertiserLinkProposal(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.name = "";
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal advertiserId.
                         * @member {string} advertiserId
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.advertiserId = "";
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal linkProposalStatusDetails.
                         * @member {google.analytics.admin.v1alpha.ILinkProposalStatusDetails|null|undefined} linkProposalStatusDetails
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.linkProposalStatusDetails = null;
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal advertiserDisplayName.
                         * @member {string} advertiserDisplayName
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.advertiserDisplayName = "";
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal validationEmail.
                         * @member {string} validationEmail
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.validationEmail = "";
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal adsPersonalizationEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} adsPersonalizationEnabled
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.adsPersonalizationEnabled = null;
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal campaignDataSharingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} campaignDataSharingEnabled
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.campaignDataSharingEnabled = null;
    
                        /**
                         * DisplayVideo360AdvertiserLinkProposal costDataSharingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} costDataSharingEnabled
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.costDataSharingEnabled = null;
    
                        /**
                         * Creates a new DisplayVideo360AdvertiserLinkProposal instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} DisplayVideo360AdvertiserLinkProposal instance
                         */
                        DisplayVideo360AdvertiserLinkProposal.create = function create(properties) {
                            return new DisplayVideo360AdvertiserLinkProposal(properties);
                        };
    
                        /**
                         * Encodes the specified DisplayVideo360AdvertiserLinkProposal message. Does not implicitly {@link google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal} message DisplayVideo360AdvertiserLinkProposal message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayVideo360AdvertiserLinkProposal.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.advertiserId != null && Object.hasOwnProperty.call(message, "advertiserId"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.advertiserId);
                            if (message.linkProposalStatusDetails != null && Object.hasOwnProperty.call(message, "linkProposalStatusDetails"))
                                $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails.encode(message.linkProposalStatusDetails, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.advertiserDisplayName != null && Object.hasOwnProperty.call(message, "advertiserDisplayName"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.advertiserDisplayName);
                            if (message.validationEmail != null && Object.hasOwnProperty.call(message, "validationEmail"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.validationEmail);
                            if (message.adsPersonalizationEnabled != null && Object.hasOwnProperty.call(message, "adsPersonalizationEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.adsPersonalizationEnabled, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.campaignDataSharingEnabled != null && Object.hasOwnProperty.call(message, "campaignDataSharingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.campaignDataSharingEnabled, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.costDataSharingEnabled != null && Object.hasOwnProperty.call(message, "costDataSharingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.costDataSharingEnabled, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisplayVideo360AdvertiserLinkProposal message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDisplayVideo360AdvertiserLinkProposal} message DisplayVideo360AdvertiserLinkProposal message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayVideo360AdvertiserLinkProposal.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisplayVideo360AdvertiserLinkProposal message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} DisplayVideo360AdvertiserLinkProposal
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayVideo360AdvertiserLinkProposal.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.advertiserId = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.linkProposalStatusDetails = $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.advertiserDisplayName = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.validationEmail = reader.string();
                                        break;
                                    }
                                case 6: {
                                        message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 8: {
                                        message.costDataSharingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisplayVideo360AdvertiserLinkProposal message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} DisplayVideo360AdvertiserLinkProposal
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayVideo360AdvertiserLinkProposal.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisplayVideo360AdvertiserLinkProposal message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayVideo360AdvertiserLinkProposal.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.advertiserId != null && message.hasOwnProperty("advertiserId"))
                                if (!$util.isString(message.advertiserId))
                                    return "advertiserId: string expected";
                            if (message.linkProposalStatusDetails != null && message.hasOwnProperty("linkProposalStatusDetails")) {
                                var error = $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails.verify(message.linkProposalStatusDetails);
                                if (error)
                                    return "linkProposalStatusDetails." + error;
                            }
                            if (message.advertiserDisplayName != null && message.hasOwnProperty("advertiserDisplayName"))
                                if (!$util.isString(message.advertiserDisplayName))
                                    return "advertiserDisplayName: string expected";
                            if (message.validationEmail != null && message.hasOwnProperty("validationEmail"))
                                if (!$util.isString(message.validationEmail))
                                    return "validationEmail: string expected";
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.adsPersonalizationEnabled);
                                if (error)
                                    return "adsPersonalizationEnabled." + error;
                            }
                            if (message.campaignDataSharingEnabled != null && message.hasOwnProperty("campaignDataSharingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.campaignDataSharingEnabled);
                                if (error)
                                    return "campaignDataSharingEnabled." + error;
                            }
                            if (message.costDataSharingEnabled != null && message.hasOwnProperty("costDataSharingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.costDataSharingEnabled);
                                if (error)
                                    return "costDataSharingEnabled." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisplayVideo360AdvertiserLinkProposal message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} DisplayVideo360AdvertiserLinkProposal
                         */
                        DisplayVideo360AdvertiserLinkProposal.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.advertiserId != null)
                                message.advertiserId = String(object.advertiserId);
                            if (object.linkProposalStatusDetails != null) {
                                if (typeof object.linkProposalStatusDetails !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.linkProposalStatusDetails: object expected");
                                message.linkProposalStatusDetails = $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails.fromObject(object.linkProposalStatusDetails);
                            }
                            if (object.advertiserDisplayName != null)
                                message.advertiserDisplayName = String(object.advertiserDisplayName);
                            if (object.validationEmail != null)
                                message.validationEmail = String(object.validationEmail);
                            if (object.adsPersonalizationEnabled != null) {
                                if (typeof object.adsPersonalizationEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.adsPersonalizationEnabled: object expected");
                                message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.fromObject(object.adsPersonalizationEnabled);
                            }
                            if (object.campaignDataSharingEnabled != null) {
                                if (typeof object.campaignDataSharingEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.campaignDataSharingEnabled: object expected");
                                message.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.fromObject(object.campaignDataSharingEnabled);
                            }
                            if (object.costDataSharingEnabled != null) {
                                if (typeof object.costDataSharingEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal.costDataSharingEnabled: object expected");
                                message.costDataSharingEnabled = $root.google.protobuf.BoolValue.fromObject(object.costDataSharingEnabled);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisplayVideo360AdvertiserLinkProposal message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal} message DisplayVideo360AdvertiserLinkProposal
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayVideo360AdvertiserLinkProposal.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.advertiserId = "";
                                object.linkProposalStatusDetails = null;
                                object.advertiserDisplayName = "";
                                object.validationEmail = "";
                                object.adsPersonalizationEnabled = null;
                                object.campaignDataSharingEnabled = null;
                                object.costDataSharingEnabled = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.advertiserId != null && message.hasOwnProperty("advertiserId"))
                                object.advertiserId = message.advertiserId;
                            if (message.linkProposalStatusDetails != null && message.hasOwnProperty("linkProposalStatusDetails"))
                                object.linkProposalStatusDetails = $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails.toObject(message.linkProposalStatusDetails, options);
                            if (message.advertiserDisplayName != null && message.hasOwnProperty("advertiserDisplayName"))
                                object.advertiserDisplayName = message.advertiserDisplayName;
                            if (message.validationEmail != null && message.hasOwnProperty("validationEmail"))
                                object.validationEmail = message.validationEmail;
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled"))
                                object.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.toObject(message.adsPersonalizationEnabled, options);
                            if (message.campaignDataSharingEnabled != null && message.hasOwnProperty("campaignDataSharingEnabled"))
                                object.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.toObject(message.campaignDataSharingEnabled, options);
                            if (message.costDataSharingEnabled != null && message.hasOwnProperty("costDataSharingEnabled"))
                                object.costDataSharingEnabled = $root.google.protobuf.BoolValue.toObject(message.costDataSharingEnabled, options);
                            return object;
                        };
    
                        /**
                         * Converts this DisplayVideo360AdvertiserLinkProposal to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayVideo360AdvertiserLinkProposal.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisplayVideo360AdvertiserLinkProposal
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisplayVideo360AdvertiserLinkProposal.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DisplayVideo360AdvertiserLinkProposal";
                        };
    
                        return DisplayVideo360AdvertiserLinkProposal;
                    })();
    
                    v1alpha.SearchAds360Link = (function() {
    
                        /**
                         * Properties of a SearchAds360Link.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ISearchAds360Link
                         * @property {string|null} [name] SearchAds360Link name
                         * @property {string|null} [advertiserId] SearchAds360Link advertiserId
                         * @property {google.protobuf.IBoolValue|null} [campaignDataSharingEnabled] SearchAds360Link campaignDataSharingEnabled
                         * @property {google.protobuf.IBoolValue|null} [costDataSharingEnabled] SearchAds360Link costDataSharingEnabled
                         * @property {string|null} [advertiserDisplayName] SearchAds360Link advertiserDisplayName
                         * @property {google.protobuf.IBoolValue|null} [adsPersonalizationEnabled] SearchAds360Link adsPersonalizationEnabled
                         * @property {google.protobuf.IBoolValue|null} [siteStatsSharingEnabled] SearchAds360Link siteStatsSharingEnabled
                         */
    
                        /**
                         * Constructs a new SearchAds360Link.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a SearchAds360Link.
                         * @implements ISearchAds360Link
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ISearchAds360Link=} [properties] Properties to set
                         */
                        function SearchAds360Link(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SearchAds360Link name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         */
                        SearchAds360Link.prototype.name = "";
    
                        /**
                         * SearchAds360Link advertiserId.
                         * @member {string} advertiserId
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         */
                        SearchAds360Link.prototype.advertiserId = "";
    
                        /**
                         * SearchAds360Link campaignDataSharingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} campaignDataSharingEnabled
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         */
                        SearchAds360Link.prototype.campaignDataSharingEnabled = null;
    
                        /**
                         * SearchAds360Link costDataSharingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} costDataSharingEnabled
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         */
                        SearchAds360Link.prototype.costDataSharingEnabled = null;
    
                        /**
                         * SearchAds360Link advertiserDisplayName.
                         * @member {string} advertiserDisplayName
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         */
                        SearchAds360Link.prototype.advertiserDisplayName = "";
    
                        /**
                         * SearchAds360Link adsPersonalizationEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} adsPersonalizationEnabled
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         */
                        SearchAds360Link.prototype.adsPersonalizationEnabled = null;
    
                        /**
                         * SearchAds360Link siteStatsSharingEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} siteStatsSharingEnabled
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         */
                        SearchAds360Link.prototype.siteStatsSharingEnabled = null;
    
                        /**
                         * Creates a new SearchAds360Link instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchAds360Link=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.SearchAds360Link} SearchAds360Link instance
                         */
                        SearchAds360Link.create = function create(properties) {
                            return new SearchAds360Link(properties);
                        };
    
                        /**
                         * Encodes the specified SearchAds360Link message. Does not implicitly {@link google.analytics.admin.v1alpha.SearchAds360Link.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchAds360Link} message SearchAds360Link message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchAds360Link.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.advertiserId != null && Object.hasOwnProperty.call(message, "advertiserId"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.advertiserId);
                            if (message.campaignDataSharingEnabled != null && Object.hasOwnProperty.call(message, "campaignDataSharingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.campaignDataSharingEnabled, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.costDataSharingEnabled != null && Object.hasOwnProperty.call(message, "costDataSharingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.costDataSharingEnabled, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.advertiserDisplayName != null && Object.hasOwnProperty.call(message, "advertiserDisplayName"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.advertiserDisplayName);
                            if (message.adsPersonalizationEnabled != null && Object.hasOwnProperty.call(message, "adsPersonalizationEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.adsPersonalizationEnabled, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.siteStatsSharingEnabled != null && Object.hasOwnProperty.call(message, "siteStatsSharingEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.siteStatsSharingEnabled, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SearchAds360Link message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.SearchAds360Link.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {google.analytics.admin.v1alpha.ISearchAds360Link} message SearchAds360Link message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchAds360Link.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SearchAds360Link message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.SearchAds360Link} SearchAds360Link
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchAds360Link.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.SearchAds360Link();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.advertiserId = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.costDataSharingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.advertiserDisplayName = reader.string();
                                        break;
                                    }
                                case 6: {
                                        message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.siteStatsSharingEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SearchAds360Link message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.SearchAds360Link} SearchAds360Link
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchAds360Link.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SearchAds360Link message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchAds360Link.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.advertiserId != null && message.hasOwnProperty("advertiserId"))
                                if (!$util.isString(message.advertiserId))
                                    return "advertiserId: string expected";
                            if (message.campaignDataSharingEnabled != null && message.hasOwnProperty("campaignDataSharingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.campaignDataSharingEnabled);
                                if (error)
                                    return "campaignDataSharingEnabled." + error;
                            }
                            if (message.costDataSharingEnabled != null && message.hasOwnProperty("costDataSharingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.costDataSharingEnabled);
                                if (error)
                                    return "costDataSharingEnabled." + error;
                            }
                            if (message.advertiserDisplayName != null && message.hasOwnProperty("advertiserDisplayName"))
                                if (!$util.isString(message.advertiserDisplayName))
                                    return "advertiserDisplayName: string expected";
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.adsPersonalizationEnabled);
                                if (error)
                                    return "adsPersonalizationEnabled." + error;
                            }
                            if (message.siteStatsSharingEnabled != null && message.hasOwnProperty("siteStatsSharingEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.siteStatsSharingEnabled);
                                if (error)
                                    return "siteStatsSharingEnabled." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SearchAds360Link message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.SearchAds360Link} SearchAds360Link
                         */
                        SearchAds360Link.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.SearchAds360Link)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.SearchAds360Link();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.advertiserId != null)
                                message.advertiserId = String(object.advertiserId);
                            if (object.campaignDataSharingEnabled != null) {
                                if (typeof object.campaignDataSharingEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchAds360Link.campaignDataSharingEnabled: object expected");
                                message.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.fromObject(object.campaignDataSharingEnabled);
                            }
                            if (object.costDataSharingEnabled != null) {
                                if (typeof object.costDataSharingEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchAds360Link.costDataSharingEnabled: object expected");
                                message.costDataSharingEnabled = $root.google.protobuf.BoolValue.fromObject(object.costDataSharingEnabled);
                            }
                            if (object.advertiserDisplayName != null)
                                message.advertiserDisplayName = String(object.advertiserDisplayName);
                            if (object.adsPersonalizationEnabled != null) {
                                if (typeof object.adsPersonalizationEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchAds360Link.adsPersonalizationEnabled: object expected");
                                message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.fromObject(object.adsPersonalizationEnabled);
                            }
                            if (object.siteStatsSharingEnabled != null) {
                                if (typeof object.siteStatsSharingEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.SearchAds360Link.siteStatsSharingEnabled: object expected");
                                message.siteStatsSharingEnabled = $root.google.protobuf.BoolValue.fromObject(object.siteStatsSharingEnabled);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SearchAds360Link message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {google.analytics.admin.v1alpha.SearchAds360Link} message SearchAds360Link
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchAds360Link.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.advertiserId = "";
                                object.campaignDataSharingEnabled = null;
                                object.costDataSharingEnabled = null;
                                object.advertiserDisplayName = "";
                                object.adsPersonalizationEnabled = null;
                                object.siteStatsSharingEnabled = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.advertiserId != null && message.hasOwnProperty("advertiserId"))
                                object.advertiserId = message.advertiserId;
                            if (message.campaignDataSharingEnabled != null && message.hasOwnProperty("campaignDataSharingEnabled"))
                                object.campaignDataSharingEnabled = $root.google.protobuf.BoolValue.toObject(message.campaignDataSharingEnabled, options);
                            if (message.costDataSharingEnabled != null && message.hasOwnProperty("costDataSharingEnabled"))
                                object.costDataSharingEnabled = $root.google.protobuf.BoolValue.toObject(message.costDataSharingEnabled, options);
                            if (message.advertiserDisplayName != null && message.hasOwnProperty("advertiserDisplayName"))
                                object.advertiserDisplayName = message.advertiserDisplayName;
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled"))
                                object.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.toObject(message.adsPersonalizationEnabled, options);
                            if (message.siteStatsSharingEnabled != null && message.hasOwnProperty("siteStatsSharingEnabled"))
                                object.siteStatsSharingEnabled = $root.google.protobuf.BoolValue.toObject(message.siteStatsSharingEnabled, options);
                            return object;
                        };
    
                        /**
                         * Converts this SearchAds360Link to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchAds360Link.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SearchAds360Link
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.SearchAds360Link
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SearchAds360Link.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.SearchAds360Link";
                        };
    
                        return SearchAds360Link;
                    })();
    
                    v1alpha.LinkProposalStatusDetails = (function() {
    
                        /**
                         * Properties of a LinkProposalStatusDetails.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ILinkProposalStatusDetails
                         * @property {google.analytics.admin.v1alpha.LinkProposalInitiatingProduct|null} [linkProposalInitiatingProduct] LinkProposalStatusDetails linkProposalInitiatingProduct
                         * @property {string|null} [requestorEmail] LinkProposalStatusDetails requestorEmail
                         * @property {google.analytics.admin.v1alpha.LinkProposalState|null} [linkProposalState] LinkProposalStatusDetails linkProposalState
                         */
    
                        /**
                         * Constructs a new LinkProposalStatusDetails.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a LinkProposalStatusDetails.
                         * @implements ILinkProposalStatusDetails
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ILinkProposalStatusDetails=} [properties] Properties to set
                         */
                        function LinkProposalStatusDetails(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LinkProposalStatusDetails linkProposalInitiatingProduct.
                         * @member {google.analytics.admin.v1alpha.LinkProposalInitiatingProduct} linkProposalInitiatingProduct
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @instance
                         */
                        LinkProposalStatusDetails.prototype.linkProposalInitiatingProduct = 0;
    
                        /**
                         * LinkProposalStatusDetails requestorEmail.
                         * @member {string} requestorEmail
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @instance
                         */
                        LinkProposalStatusDetails.prototype.requestorEmail = "";
    
                        /**
                         * LinkProposalStatusDetails linkProposalState.
                         * @member {google.analytics.admin.v1alpha.LinkProposalState} linkProposalState
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @instance
                         */
                        LinkProposalStatusDetails.prototype.linkProposalState = 0;
    
                        /**
                         * Creates a new LinkProposalStatusDetails instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {google.analytics.admin.v1alpha.ILinkProposalStatusDetails=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.LinkProposalStatusDetails} LinkProposalStatusDetails instance
                         */
                        LinkProposalStatusDetails.create = function create(properties) {
                            return new LinkProposalStatusDetails(properties);
                        };
    
                        /**
                         * Encodes the specified LinkProposalStatusDetails message. Does not implicitly {@link google.analytics.admin.v1alpha.LinkProposalStatusDetails.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {google.analytics.admin.v1alpha.ILinkProposalStatusDetails} message LinkProposalStatusDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LinkProposalStatusDetails.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.linkProposalInitiatingProduct != null && Object.hasOwnProperty.call(message, "linkProposalInitiatingProduct"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.linkProposalInitiatingProduct);
                            if (message.requestorEmail != null && Object.hasOwnProperty.call(message, "requestorEmail"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.requestorEmail);
                            if (message.linkProposalState != null && Object.hasOwnProperty.call(message, "linkProposalState"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.linkProposalState);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LinkProposalStatusDetails message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.LinkProposalStatusDetails.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {google.analytics.admin.v1alpha.ILinkProposalStatusDetails} message LinkProposalStatusDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LinkProposalStatusDetails.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LinkProposalStatusDetails message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.LinkProposalStatusDetails} LinkProposalStatusDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LinkProposalStatusDetails.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.linkProposalInitiatingProduct = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.requestorEmail = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.linkProposalState = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LinkProposalStatusDetails message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.LinkProposalStatusDetails} LinkProposalStatusDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LinkProposalStatusDetails.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LinkProposalStatusDetails message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LinkProposalStatusDetails.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.linkProposalInitiatingProduct != null && message.hasOwnProperty("linkProposalInitiatingProduct"))
                                switch (message.linkProposalInitiatingProduct) {
                                default:
                                    return "linkProposalInitiatingProduct: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.requestorEmail != null && message.hasOwnProperty("requestorEmail"))
                                if (!$util.isString(message.requestorEmail))
                                    return "requestorEmail: string expected";
                            if (message.linkProposalState != null && message.hasOwnProperty("linkProposalState"))
                                switch (message.linkProposalState) {
                                default:
                                    return "linkProposalState: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            return null;
                        };
    
                        /**
                         * Creates a LinkProposalStatusDetails message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.LinkProposalStatusDetails} LinkProposalStatusDetails
                         */
                        LinkProposalStatusDetails.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.LinkProposalStatusDetails();
                            switch (object.linkProposalInitiatingProduct) {
                            default:
                                if (typeof object.linkProposalInitiatingProduct === "number") {
                                    message.linkProposalInitiatingProduct = object.linkProposalInitiatingProduct;
                                    break;
                                }
                                break;
                            case "LINK_PROPOSAL_INITIATING_PRODUCT_UNSPECIFIED":
                            case 0:
                                message.linkProposalInitiatingProduct = 0;
                                break;
                            case "GOOGLE_ANALYTICS":
                            case 1:
                                message.linkProposalInitiatingProduct = 1;
                                break;
                            case "LINKED_PRODUCT":
                            case 2:
                                message.linkProposalInitiatingProduct = 2;
                                break;
                            }
                            if (object.requestorEmail != null)
                                message.requestorEmail = String(object.requestorEmail);
                            switch (object.linkProposalState) {
                            default:
                                if (typeof object.linkProposalState === "number") {
                                    message.linkProposalState = object.linkProposalState;
                                    break;
                                }
                                break;
                            case "LINK_PROPOSAL_STATE_UNSPECIFIED":
                            case 0:
                                message.linkProposalState = 0;
                                break;
                            case "AWAITING_REVIEW_FROM_GOOGLE_ANALYTICS":
                            case 1:
                                message.linkProposalState = 1;
                                break;
                            case "AWAITING_REVIEW_FROM_LINKED_PRODUCT":
                            case 2:
                                message.linkProposalState = 2;
                                break;
                            case "WITHDRAWN":
                            case 3:
                                message.linkProposalState = 3;
                                break;
                            case "DECLINED":
                            case 4:
                                message.linkProposalState = 4;
                                break;
                            case "EXPIRED":
                            case 5:
                                message.linkProposalState = 5;
                                break;
                            case "OBSOLETE":
                            case 6:
                                message.linkProposalState = 6;
                                break;
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LinkProposalStatusDetails message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {google.analytics.admin.v1alpha.LinkProposalStatusDetails} message LinkProposalStatusDetails
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LinkProposalStatusDetails.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.linkProposalInitiatingProduct = options.enums === String ? "LINK_PROPOSAL_INITIATING_PRODUCT_UNSPECIFIED" : 0;
                                object.requestorEmail = "";
                                object.linkProposalState = options.enums === String ? "LINK_PROPOSAL_STATE_UNSPECIFIED" : 0;
                            }
                            if (message.linkProposalInitiatingProduct != null && message.hasOwnProperty("linkProposalInitiatingProduct"))
                                object.linkProposalInitiatingProduct = options.enums === String ? $root.google.analytics.admin.v1alpha.LinkProposalInitiatingProduct[message.linkProposalInitiatingProduct] === undefined ? message.linkProposalInitiatingProduct : $root.google.analytics.admin.v1alpha.LinkProposalInitiatingProduct[message.linkProposalInitiatingProduct] : message.linkProposalInitiatingProduct;
                            if (message.requestorEmail != null && message.hasOwnProperty("requestorEmail"))
                                object.requestorEmail = message.requestorEmail;
                            if (message.linkProposalState != null && message.hasOwnProperty("linkProposalState"))
                                object.linkProposalState = options.enums === String ? $root.google.analytics.admin.v1alpha.LinkProposalState[message.linkProposalState] === undefined ? message.linkProposalState : $root.google.analytics.admin.v1alpha.LinkProposalState[message.linkProposalState] : message.linkProposalState;
                            return object;
                        };
    
                        /**
                         * Converts this LinkProposalStatusDetails to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LinkProposalStatusDetails.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LinkProposalStatusDetails
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.LinkProposalStatusDetails
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LinkProposalStatusDetails.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.LinkProposalStatusDetails";
                        };
    
                        return LinkProposalStatusDetails;
                    })();
    
                    v1alpha.ConversionEvent = (function() {
    
                        /**
                         * Properties of a ConversionEvent.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IConversionEvent
                         * @property {string|null} [name] ConversionEvent name
                         * @property {string|null} [eventName] ConversionEvent eventName
                         * @property {google.protobuf.ITimestamp|null} [createTime] ConversionEvent createTime
                         * @property {boolean|null} [deletable] ConversionEvent deletable
                         * @property {boolean|null} [custom] ConversionEvent custom
                         */
    
                        /**
                         * Constructs a new ConversionEvent.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ConversionEvent.
                         * @implements IConversionEvent
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IConversionEvent=} [properties] Properties to set
                         */
                        function ConversionEvent(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ConversionEvent name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.name = "";
    
                        /**
                         * ConversionEvent eventName.
                         * @member {string} eventName
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.eventName = "";
    
                        /**
                         * ConversionEvent createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.createTime = null;
    
                        /**
                         * ConversionEvent deletable.
                         * @member {boolean} deletable
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.deletable = false;
    
                        /**
                         * ConversionEvent custom.
                         * @member {boolean} custom
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.custom = false;
    
                        /**
                         * Creates a new ConversionEvent instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.IConversionEvent=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ConversionEvent} ConversionEvent instance
                         */
                        ConversionEvent.create = function create(properties) {
                            return new ConversionEvent(properties);
                        };
    
                        /**
                         * Encodes the specified ConversionEvent message. Does not implicitly {@link google.analytics.admin.v1alpha.ConversionEvent.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.IConversionEvent} message ConversionEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionEvent.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.eventName != null && Object.hasOwnProperty.call(message, "eventName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.eventName);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.deletable != null && Object.hasOwnProperty.call(message, "deletable"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.deletable);
                            if (message.custom != null && Object.hasOwnProperty.call(message, "custom"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.custom);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ConversionEvent message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ConversionEvent.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.IConversionEvent} message ConversionEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionEvent.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ConversionEvent message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ConversionEvent} ConversionEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionEvent.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ConversionEvent();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.eventName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.deletable = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.custom = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ConversionEvent message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ConversionEvent} ConversionEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionEvent.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ConversionEvent message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionEvent.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                if (!$util.isString(message.eventName))
                                    return "eventName: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.deletable != null && message.hasOwnProperty("deletable"))
                                if (typeof message.deletable !== "boolean")
                                    return "deletable: boolean expected";
                            if (message.custom != null && message.hasOwnProperty("custom"))
                                if (typeof message.custom !== "boolean")
                                    return "custom: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a ConversionEvent message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ConversionEvent} ConversionEvent
                         */
                        ConversionEvent.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ConversionEvent)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ConversionEvent();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.eventName != null)
                                message.eventName = String(object.eventName);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.ConversionEvent.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.deletable != null)
                                message.deletable = Boolean(object.deletable);
                            if (object.custom != null)
                                message.custom = Boolean(object.custom);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ConversionEvent message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1alpha.ConversionEvent} message ConversionEvent
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionEvent.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.eventName = "";
                                object.createTime = null;
                                object.deletable = false;
                                object.custom = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                object.eventName = message.eventName;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.deletable != null && message.hasOwnProperty("deletable"))
                                object.deletable = message.deletable;
                            if (message.custom != null && message.hasOwnProperty("custom"))
                                object.custom = message.custom;
                            return object;
                        };
    
                        /**
                         * Converts this ConversionEvent to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionEvent.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ConversionEvent
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ConversionEvent
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ConversionEvent.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ConversionEvent";
                        };
    
                        return ConversionEvent;
                    })();
    
                    v1alpha.GoogleSignalsSettings = (function() {
    
                        /**
                         * Properties of a GoogleSignalsSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IGoogleSignalsSettings
                         * @property {string|null} [name] GoogleSignalsSettings name
                         * @property {google.analytics.admin.v1alpha.GoogleSignalsState|null} [state] GoogleSignalsSettings state
                         * @property {google.analytics.admin.v1alpha.GoogleSignalsConsent|null} [consent] GoogleSignalsSettings consent
                         */
    
                        /**
                         * Constructs a new GoogleSignalsSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a GoogleSignalsSettings.
                         * @implements IGoogleSignalsSettings
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IGoogleSignalsSettings=} [properties] Properties to set
                         */
                        function GoogleSignalsSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GoogleSignalsSettings name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @instance
                         */
                        GoogleSignalsSettings.prototype.name = "";
    
                        /**
                         * GoogleSignalsSettings state.
                         * @member {google.analytics.admin.v1alpha.GoogleSignalsState} state
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @instance
                         */
                        GoogleSignalsSettings.prototype.state = 0;
    
                        /**
                         * GoogleSignalsSettings consent.
                         * @member {google.analytics.admin.v1alpha.GoogleSignalsConsent} consent
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @instance
                         */
                        GoogleSignalsSettings.prototype.consent = 0;
    
                        /**
                         * Creates a new GoogleSignalsSettings instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGoogleSignalsSettings=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.GoogleSignalsSettings} GoogleSignalsSettings instance
                         */
                        GoogleSignalsSettings.create = function create(properties) {
                            return new GoogleSignalsSettings(properties);
                        };
    
                        /**
                         * Encodes the specified GoogleSignalsSettings message. Does not implicitly {@link google.analytics.admin.v1alpha.GoogleSignalsSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGoogleSignalsSettings} message GoogleSignalsSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleSignalsSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.state);
                            if (message.consent != null && Object.hasOwnProperty.call(message, "consent"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.consent);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GoogleSignalsSettings message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.GoogleSignalsSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IGoogleSignalsSettings} message GoogleSignalsSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleSignalsSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GoogleSignalsSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.GoogleSignalsSettings} GoogleSignalsSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleSignalsSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.GoogleSignalsSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.state = reader.int32();
                                        break;
                                    }
                                case 4: {
                                        message.consent = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GoogleSignalsSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.GoogleSignalsSettings} GoogleSignalsSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleSignalsSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GoogleSignalsSettings message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleSignalsSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.state != null && message.hasOwnProperty("state"))
                                switch (message.state) {
                                default:
                                    return "state: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.consent != null && message.hasOwnProperty("consent"))
                                switch (message.consent) {
                                default:
                                    return "consent: enum value expected";
                                case 0:
                                case 2:
                                case 1:
                                    break;
                                }
                            return null;
                        };
    
                        /**
                         * Creates a GoogleSignalsSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.GoogleSignalsSettings} GoogleSignalsSettings
                         */
                        GoogleSignalsSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.GoogleSignalsSettings)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.GoogleSignalsSettings();
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.state) {
                            default:
                                if (typeof object.state === "number") {
                                    message.state = object.state;
                                    break;
                                }
                                break;
                            case "GOOGLE_SIGNALS_STATE_UNSPECIFIED":
                            case 0:
                                message.state = 0;
                                break;
                            case "GOOGLE_SIGNALS_ENABLED":
                            case 1:
                                message.state = 1;
                                break;
                            case "GOOGLE_SIGNALS_DISABLED":
                            case 2:
                                message.state = 2;
                                break;
                            }
                            switch (object.consent) {
                            default:
                                if (typeof object.consent === "number") {
                                    message.consent = object.consent;
                                    break;
                                }
                                break;
                            case "GOOGLE_SIGNALS_CONSENT_UNSPECIFIED":
                            case 0:
                                message.consent = 0;
                                break;
                            case "GOOGLE_SIGNALS_CONSENT_CONSENTED":
                            case 2:
                                message.consent = 2;
                                break;
                            case "GOOGLE_SIGNALS_CONSENT_NOT_CONSENTED":
                            case 1:
                                message.consent = 1;
                                break;
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GoogleSignalsSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.GoogleSignalsSettings} message GoogleSignalsSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleSignalsSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.state = options.enums === String ? "GOOGLE_SIGNALS_STATE_UNSPECIFIED" : 0;
                                object.consent = options.enums === String ? "GOOGLE_SIGNALS_CONSENT_UNSPECIFIED" : 0;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.state != null && message.hasOwnProperty("state"))
                                object.state = options.enums === String ? $root.google.analytics.admin.v1alpha.GoogleSignalsState[message.state] === undefined ? message.state : $root.google.analytics.admin.v1alpha.GoogleSignalsState[message.state] : message.state;
                            if (message.consent != null && message.hasOwnProperty("consent"))
                                object.consent = options.enums === String ? $root.google.analytics.admin.v1alpha.GoogleSignalsConsent[message.consent] === undefined ? message.consent : $root.google.analytics.admin.v1alpha.GoogleSignalsConsent[message.consent] : message.consent;
                            return object;
                        };
    
                        /**
                         * Converts this GoogleSignalsSettings to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleSignalsSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GoogleSignalsSettings
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.GoogleSignalsSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GoogleSignalsSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.GoogleSignalsSettings";
                        };
    
                        return GoogleSignalsSettings;
                    })();
    
                    v1alpha.CustomDimension = (function() {
    
                        /**
                         * Properties of a CustomDimension.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICustomDimension
                         * @property {string|null} [name] CustomDimension name
                         * @property {string|null} [parameterName] CustomDimension parameterName
                         * @property {string|null} [displayName] CustomDimension displayName
                         * @property {string|null} [description] CustomDimension description
                         * @property {google.analytics.admin.v1alpha.CustomDimension.DimensionScope|null} [scope] CustomDimension scope
                         * @property {boolean|null} [disallowAdsPersonalization] CustomDimension disallowAdsPersonalization
                         */
    
                        /**
                         * Constructs a new CustomDimension.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CustomDimension.
                         * @implements ICustomDimension
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICustomDimension=} [properties] Properties to set
                         */
                        function CustomDimension(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CustomDimension name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.name = "";
    
                        /**
                         * CustomDimension parameterName.
                         * @member {string} parameterName
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.parameterName = "";
    
                        /**
                         * CustomDimension displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.displayName = "";
    
                        /**
                         * CustomDimension description.
                         * @member {string} description
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.description = "";
    
                        /**
                         * CustomDimension scope.
                         * @member {google.analytics.admin.v1alpha.CustomDimension.DimensionScope} scope
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.scope = 0;
    
                        /**
                         * CustomDimension disallowAdsPersonalization.
                         * @member {boolean} disallowAdsPersonalization
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.disallowAdsPersonalization = false;
    
                        /**
                         * Creates a new CustomDimension instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICustomDimension=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CustomDimension} CustomDimension instance
                         */
                        CustomDimension.create = function create(properties) {
                            return new CustomDimension(properties);
                        };
    
                        /**
                         * Encodes the specified CustomDimension message. Does not implicitly {@link google.analytics.admin.v1alpha.CustomDimension.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICustomDimension} message CustomDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomDimension.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.parameterName != null && Object.hasOwnProperty.call(message, "parameterName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parameterName);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.description);
                            if (message.scope != null && Object.hasOwnProperty.call(message, "scope"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.scope);
                            if (message.disallowAdsPersonalization != null && Object.hasOwnProperty.call(message, "disallowAdsPersonalization"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.disallowAdsPersonalization);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CustomDimension message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CustomDimension.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICustomDimension} message CustomDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomDimension.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CustomDimension message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CustomDimension} CustomDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomDimension.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CustomDimension();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.parameterName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.scope = reader.int32();
                                        break;
                                    }
                                case 6: {
                                        message.disallowAdsPersonalization = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CustomDimension message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CustomDimension} CustomDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomDimension.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CustomDimension message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomDimension.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                if (!$util.isString(message.parameterName))
                                    return "parameterName: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.description != null && message.hasOwnProperty("description"))
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                switch (message.scope) {
                                default:
                                    return "scope: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.disallowAdsPersonalization != null && message.hasOwnProperty("disallowAdsPersonalization"))
                                if (typeof message.disallowAdsPersonalization !== "boolean")
                                    return "disallowAdsPersonalization: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a CustomDimension message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CustomDimension} CustomDimension
                         */
                        CustomDimension.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CustomDimension)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CustomDimension();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.parameterName != null)
                                message.parameterName = String(object.parameterName);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.description != null)
                                message.description = String(object.description);
                            switch (object.scope) {
                            default:
                                if (typeof object.scope === "number") {
                                    message.scope = object.scope;
                                    break;
                                }
                                break;
                            case "DIMENSION_SCOPE_UNSPECIFIED":
                            case 0:
                                message.scope = 0;
                                break;
                            case "EVENT":
                            case 1:
                                message.scope = 1;
                                break;
                            case "USER":
                            case 2:
                                message.scope = 2;
                                break;
                            case "ITEM":
                            case 3:
                                message.scope = 3;
                                break;
                            }
                            if (object.disallowAdsPersonalization != null)
                                message.disallowAdsPersonalization = Boolean(object.disallowAdsPersonalization);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CustomDimension message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1alpha.CustomDimension} message CustomDimension
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomDimension.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.parameterName = "";
                                object.displayName = "";
                                object.description = "";
                                object.scope = options.enums === String ? "DIMENSION_SCOPE_UNSPECIFIED" : 0;
                                object.disallowAdsPersonalization = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                object.parameterName = message.parameterName;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = message.description;
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                object.scope = options.enums === String ? $root.google.analytics.admin.v1alpha.CustomDimension.DimensionScope[message.scope] === undefined ? message.scope : $root.google.analytics.admin.v1alpha.CustomDimension.DimensionScope[message.scope] : message.scope;
                            if (message.disallowAdsPersonalization != null && message.hasOwnProperty("disallowAdsPersonalization"))
                                object.disallowAdsPersonalization = message.disallowAdsPersonalization;
                            return object;
                        };
    
                        /**
                         * Converts this CustomDimension to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomDimension.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CustomDimension
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CustomDimension
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CustomDimension.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CustomDimension";
                        };
    
                        /**
                         * DimensionScope enum.
                         * @name google.analytics.admin.v1alpha.CustomDimension.DimensionScope
                         * @enum {number}
                         * @property {number} DIMENSION_SCOPE_UNSPECIFIED=0 DIMENSION_SCOPE_UNSPECIFIED value
                         * @property {number} EVENT=1 EVENT value
                         * @property {number} USER=2 USER value
                         * @property {number} ITEM=3 ITEM value
                         */
                        CustomDimension.DimensionScope = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "DIMENSION_SCOPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EVENT"] = 1;
                            values[valuesById[2] = "USER"] = 2;
                            values[valuesById[3] = "ITEM"] = 3;
                            return values;
                        })();
    
                        return CustomDimension;
                    })();
    
                    v1alpha.CustomMetric = (function() {
    
                        /**
                         * Properties of a CustomMetric.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface ICustomMetric
                         * @property {string|null} [name] CustomMetric name
                         * @property {string|null} [parameterName] CustomMetric parameterName
                         * @property {string|null} [displayName] CustomMetric displayName
                         * @property {string|null} [description] CustomMetric description
                         * @property {google.analytics.admin.v1alpha.CustomMetric.MeasurementUnit|null} [measurementUnit] CustomMetric measurementUnit
                         * @property {google.analytics.admin.v1alpha.CustomMetric.MetricScope|null} [scope] CustomMetric scope
                         * @property {Array.<google.analytics.admin.v1alpha.CustomMetric.RestrictedMetricType>|null} [restrictedMetricType] CustomMetric restrictedMetricType
                         */
    
                        /**
                         * Constructs a new CustomMetric.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a CustomMetric.
                         * @implements ICustomMetric
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.ICustomMetric=} [properties] Properties to set
                         */
                        function CustomMetric(properties) {
                            this.restrictedMetricType = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CustomMetric name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.name = "";
    
                        /**
                         * CustomMetric parameterName.
                         * @member {string} parameterName
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.parameterName = "";
    
                        /**
                         * CustomMetric displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.displayName = "";
    
                        /**
                         * CustomMetric description.
                         * @member {string} description
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.description = "";
    
                        /**
                         * CustomMetric measurementUnit.
                         * @member {google.analytics.admin.v1alpha.CustomMetric.MeasurementUnit} measurementUnit
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.measurementUnit = 0;
    
                        /**
                         * CustomMetric scope.
                         * @member {google.analytics.admin.v1alpha.CustomMetric.MetricScope} scope
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.scope = 0;
    
                        /**
                         * CustomMetric restrictedMetricType.
                         * @member {Array.<google.analytics.admin.v1alpha.CustomMetric.RestrictedMetricType>} restrictedMetricType
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.restrictedMetricType = $util.emptyArray;
    
                        /**
                         * Creates a new CustomMetric instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICustomMetric=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.CustomMetric} CustomMetric instance
                         */
                        CustomMetric.create = function create(properties) {
                            return new CustomMetric(properties);
                        };
    
                        /**
                         * Encodes the specified CustomMetric message. Does not implicitly {@link google.analytics.admin.v1alpha.CustomMetric.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICustomMetric} message CustomMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomMetric.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.parameterName != null && Object.hasOwnProperty.call(message, "parameterName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parameterName);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.description);
                            if (message.measurementUnit != null && Object.hasOwnProperty.call(message, "measurementUnit"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.measurementUnit);
                            if (message.scope != null && Object.hasOwnProperty.call(message, "scope"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.scope);
                            if (message.restrictedMetricType != null && message.restrictedMetricType.length) {
                                writer.uint32(/* id 8, wireType 2 =*/66).fork();
                                for (var i = 0; i < message.restrictedMetricType.length; ++i)
                                    writer.int32(message.restrictedMetricType[i]);
                                writer.ldelim();
                            }
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CustomMetric message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.CustomMetric.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.ICustomMetric} message CustomMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomMetric.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CustomMetric message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.CustomMetric} CustomMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomMetric.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.CustomMetric();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.parameterName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.measurementUnit = reader.int32();
                                        break;
                                    }
                                case 6: {
                                        message.scope = reader.int32();
                                        break;
                                    }
                                case 8: {
                                        if (!(message.restrictedMetricType && message.restrictedMetricType.length))
                                            message.restrictedMetricType = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.restrictedMetricType.push(reader.int32());
                                        } else
                                            message.restrictedMetricType.push(reader.int32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CustomMetric message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.CustomMetric} CustomMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomMetric.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CustomMetric message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomMetric.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                if (!$util.isString(message.parameterName))
                                    return "parameterName: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.description != null && message.hasOwnProperty("description"))
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            if (message.measurementUnit != null && message.hasOwnProperty("measurementUnit"))
                                switch (message.measurementUnit) {
                                default:
                                    return "measurementUnit: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                    break;
                                }
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                switch (message.scope) {
                                default:
                                    return "scope: enum value expected";
                                case 0:
                                case 1:
                                    break;
                                }
                            if (message.restrictedMetricType != null && message.hasOwnProperty("restrictedMetricType")) {
                                if (!Array.isArray(message.restrictedMetricType))
                                    return "restrictedMetricType: array expected";
                                for (var i = 0; i < message.restrictedMetricType.length; ++i)
                                    switch (message.restrictedMetricType[i]) {
                                    default:
                                        return "restrictedMetricType: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                        break;
                                    }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CustomMetric message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.CustomMetric} CustomMetric
                         */
                        CustomMetric.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.CustomMetric)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.CustomMetric();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.parameterName != null)
                                message.parameterName = String(object.parameterName);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.description != null)
                                message.description = String(object.description);
                            switch (object.measurementUnit) {
                            default:
                                if (typeof object.measurementUnit === "number") {
                                    message.measurementUnit = object.measurementUnit;
                                    break;
                                }
                                break;
                            case "MEASUREMENT_UNIT_UNSPECIFIED":
                            case 0:
                                message.measurementUnit = 0;
                                break;
                            case "STANDARD":
                            case 1:
                                message.measurementUnit = 1;
                                break;
                            case "CURRENCY":
                            case 2:
                                message.measurementUnit = 2;
                                break;
                            case "FEET":
                            case 3:
                                message.measurementUnit = 3;
                                break;
                            case "METERS":
                            case 4:
                                message.measurementUnit = 4;
                                break;
                            case "KILOMETERS":
                            case 5:
                                message.measurementUnit = 5;
                                break;
                            case "MILES":
                            case 6:
                                message.measurementUnit = 6;
                                break;
                            case "MILLISECONDS":
                            case 7:
                                message.measurementUnit = 7;
                                break;
                            case "SECONDS":
                            case 8:
                                message.measurementUnit = 8;
                                break;
                            case "MINUTES":
                            case 9:
                                message.measurementUnit = 9;
                                break;
                            case "HOURS":
                            case 10:
                                message.measurementUnit = 10;
                                break;
                            }
                            switch (object.scope) {
                            default:
                                if (typeof object.scope === "number") {
                                    message.scope = object.scope;
                                    break;
                                }
                                break;
                            case "METRIC_SCOPE_UNSPECIFIED":
                            case 0:
                                message.scope = 0;
                                break;
                            case "EVENT":
                            case 1:
                                message.scope = 1;
                                break;
                            }
                            if (object.restrictedMetricType) {
                                if (!Array.isArray(object.restrictedMetricType))
                                    throw TypeError(".google.analytics.admin.v1alpha.CustomMetric.restrictedMetricType: array expected");
                                message.restrictedMetricType = [];
                                for (var i = 0; i < object.restrictedMetricType.length; ++i)
                                    switch (object.restrictedMetricType[i]) {
                                    default:
                                        if (typeof object.restrictedMetricType[i] === "number") {
                                            message.restrictedMetricType[i] = object.restrictedMetricType[i];
                                            break;
                                        }
                                    case "RESTRICTED_METRIC_TYPE_UNSPECIFIED":
                                    case 0:
                                        message.restrictedMetricType[i] = 0;
                                        break;
                                    case "COST_DATA":
                                    case 1:
                                        message.restrictedMetricType[i] = 1;
                                        break;
                                    case "REVENUE_DATA":
                                    case 2:
                                        message.restrictedMetricType[i] = 2;
                                        break;
                                    }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CustomMetric message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1alpha.CustomMetric} message CustomMetric
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomMetric.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.restrictedMetricType = [];
                            if (options.defaults) {
                                object.name = "";
                                object.parameterName = "";
                                object.displayName = "";
                                object.description = "";
                                object.measurementUnit = options.enums === String ? "MEASUREMENT_UNIT_UNSPECIFIED" : 0;
                                object.scope = options.enums === String ? "METRIC_SCOPE_UNSPECIFIED" : 0;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                object.parameterName = message.parameterName;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = message.description;
                            if (message.measurementUnit != null && message.hasOwnProperty("measurementUnit"))
                                object.measurementUnit = options.enums === String ? $root.google.analytics.admin.v1alpha.CustomMetric.MeasurementUnit[message.measurementUnit] === undefined ? message.measurementUnit : $root.google.analytics.admin.v1alpha.CustomMetric.MeasurementUnit[message.measurementUnit] : message.measurementUnit;
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                object.scope = options.enums === String ? $root.google.analytics.admin.v1alpha.CustomMetric.MetricScope[message.scope] === undefined ? message.scope : $root.google.analytics.admin.v1alpha.CustomMetric.MetricScope[message.scope] : message.scope;
                            if (message.restrictedMetricType && message.restrictedMetricType.length) {
                                object.restrictedMetricType = [];
                                for (var j = 0; j < message.restrictedMetricType.length; ++j)
                                    object.restrictedMetricType[j] = options.enums === String ? $root.google.analytics.admin.v1alpha.CustomMetric.RestrictedMetricType[message.restrictedMetricType[j]] === undefined ? message.restrictedMetricType[j] : $root.google.analytics.admin.v1alpha.CustomMetric.RestrictedMetricType[message.restrictedMetricType[j]] : message.restrictedMetricType[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CustomMetric to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomMetric.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CustomMetric
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.CustomMetric
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CustomMetric.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.CustomMetric";
                        };
    
                        /**
                         * MeasurementUnit enum.
                         * @name google.analytics.admin.v1alpha.CustomMetric.MeasurementUnit
                         * @enum {number}
                         * @property {number} MEASUREMENT_UNIT_UNSPECIFIED=0 MEASUREMENT_UNIT_UNSPECIFIED value
                         * @property {number} STANDARD=1 STANDARD value
                         * @property {number} CURRENCY=2 CURRENCY value
                         * @property {number} FEET=3 FEET value
                         * @property {number} METERS=4 METERS value
                         * @property {number} KILOMETERS=5 KILOMETERS value
                         * @property {number} MILES=6 MILES value
                         * @property {number} MILLISECONDS=7 MILLISECONDS value
                         * @property {number} SECONDS=8 SECONDS value
                         * @property {number} MINUTES=9 MINUTES value
                         * @property {number} HOURS=10 HOURS value
                         */
                        CustomMetric.MeasurementUnit = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "MEASUREMENT_UNIT_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "STANDARD"] = 1;
                            values[valuesById[2] = "CURRENCY"] = 2;
                            values[valuesById[3] = "FEET"] = 3;
                            values[valuesById[4] = "METERS"] = 4;
                            values[valuesById[5] = "KILOMETERS"] = 5;
                            values[valuesById[6] = "MILES"] = 6;
                            values[valuesById[7] = "MILLISECONDS"] = 7;
                            values[valuesById[8] = "SECONDS"] = 8;
                            values[valuesById[9] = "MINUTES"] = 9;
                            values[valuesById[10] = "HOURS"] = 10;
                            return values;
                        })();
    
                        /**
                         * MetricScope enum.
                         * @name google.analytics.admin.v1alpha.CustomMetric.MetricScope
                         * @enum {number}
                         * @property {number} METRIC_SCOPE_UNSPECIFIED=0 METRIC_SCOPE_UNSPECIFIED value
                         * @property {number} EVENT=1 EVENT value
                         */
                        CustomMetric.MetricScope = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "METRIC_SCOPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EVENT"] = 1;
                            return values;
                        })();
    
                        /**
                         * RestrictedMetricType enum.
                         * @name google.analytics.admin.v1alpha.CustomMetric.RestrictedMetricType
                         * @enum {number}
                         * @property {number} RESTRICTED_METRIC_TYPE_UNSPECIFIED=0 RESTRICTED_METRIC_TYPE_UNSPECIFIED value
                         * @property {number} COST_DATA=1 COST_DATA value
                         * @property {number} REVENUE_DATA=2 REVENUE_DATA value
                         */
                        CustomMetric.RestrictedMetricType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "RESTRICTED_METRIC_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "COST_DATA"] = 1;
                            values[valuesById[2] = "REVENUE_DATA"] = 2;
                            return values;
                        })();
    
                        return CustomMetric;
                    })();
    
                    v1alpha.DataRetentionSettings = (function() {
    
                        /**
                         * Properties of a DataRetentionSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IDataRetentionSettings
                         * @property {string|null} [name] DataRetentionSettings name
                         * @property {google.analytics.admin.v1alpha.DataRetentionSettings.RetentionDuration|null} [eventDataRetention] DataRetentionSettings eventDataRetention
                         * @property {boolean|null} [resetUserDataOnNewActivity] DataRetentionSettings resetUserDataOnNewActivity
                         */
    
                        /**
                         * Constructs a new DataRetentionSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a DataRetentionSettings.
                         * @implements IDataRetentionSettings
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IDataRetentionSettings=} [properties] Properties to set
                         */
                        function DataRetentionSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DataRetentionSettings name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @instance
                         */
                        DataRetentionSettings.prototype.name = "";
    
                        /**
                         * DataRetentionSettings eventDataRetention.
                         * @member {google.analytics.admin.v1alpha.DataRetentionSettings.RetentionDuration} eventDataRetention
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @instance
                         */
                        DataRetentionSettings.prototype.eventDataRetention = 0;
    
                        /**
                         * DataRetentionSettings resetUserDataOnNewActivity.
                         * @member {boolean} resetUserDataOnNewActivity
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @instance
                         */
                        DataRetentionSettings.prototype.resetUserDataOnNewActivity = false;
    
                        /**
                         * Creates a new DataRetentionSettings instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataRetentionSettings=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.DataRetentionSettings} DataRetentionSettings instance
                         */
                        DataRetentionSettings.create = function create(properties) {
                            return new DataRetentionSettings(properties);
                        };
    
                        /**
                         * Encodes the specified DataRetentionSettings message. Does not implicitly {@link google.analytics.admin.v1alpha.DataRetentionSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataRetentionSettings} message DataRetentionSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataRetentionSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.eventDataRetention != null && Object.hasOwnProperty.call(message, "eventDataRetention"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.eventDataRetention);
                            if (message.resetUserDataOnNewActivity != null && Object.hasOwnProperty.call(message, "resetUserDataOnNewActivity"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.resetUserDataOnNewActivity);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DataRetentionSettings message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.DataRetentionSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IDataRetentionSettings} message DataRetentionSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataRetentionSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DataRetentionSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.DataRetentionSettings} DataRetentionSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataRetentionSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.DataRetentionSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.eventDataRetention = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.resetUserDataOnNewActivity = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DataRetentionSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.DataRetentionSettings} DataRetentionSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataRetentionSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DataRetentionSettings message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DataRetentionSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.eventDataRetention != null && message.hasOwnProperty("eventDataRetention"))
                                switch (message.eventDataRetention) {
                                default:
                                    return "eventDataRetention: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.resetUserDataOnNewActivity != null && message.hasOwnProperty("resetUserDataOnNewActivity"))
                                if (typeof message.resetUserDataOnNewActivity !== "boolean")
                                    return "resetUserDataOnNewActivity: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a DataRetentionSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.DataRetentionSettings} DataRetentionSettings
                         */
                        DataRetentionSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.DataRetentionSettings)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.DataRetentionSettings();
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.eventDataRetention) {
                            default:
                                if (typeof object.eventDataRetention === "number") {
                                    message.eventDataRetention = object.eventDataRetention;
                                    break;
                                }
                                break;
                            case "RETENTION_DURATION_UNSPECIFIED":
                            case 0:
                                message.eventDataRetention = 0;
                                break;
                            case "TWO_MONTHS":
                            case 1:
                                message.eventDataRetention = 1;
                                break;
                            case "FOURTEEN_MONTHS":
                            case 3:
                                message.eventDataRetention = 3;
                                break;
                            case "TWENTY_SIX_MONTHS":
                            case 4:
                                message.eventDataRetention = 4;
                                break;
                            case "THIRTY_EIGHT_MONTHS":
                            case 5:
                                message.eventDataRetention = 5;
                                break;
                            case "FIFTY_MONTHS":
                            case 6:
                                message.eventDataRetention = 6;
                                break;
                            }
                            if (object.resetUserDataOnNewActivity != null)
                                message.resetUserDataOnNewActivity = Boolean(object.resetUserDataOnNewActivity);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DataRetentionSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.DataRetentionSettings} message DataRetentionSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DataRetentionSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.eventDataRetention = options.enums === String ? "RETENTION_DURATION_UNSPECIFIED" : 0;
                                object.resetUserDataOnNewActivity = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.eventDataRetention != null && message.hasOwnProperty("eventDataRetention"))
                                object.eventDataRetention = options.enums === String ? $root.google.analytics.admin.v1alpha.DataRetentionSettings.RetentionDuration[message.eventDataRetention] === undefined ? message.eventDataRetention : $root.google.analytics.admin.v1alpha.DataRetentionSettings.RetentionDuration[message.eventDataRetention] : message.eventDataRetention;
                            if (message.resetUserDataOnNewActivity != null && message.hasOwnProperty("resetUserDataOnNewActivity"))
                                object.resetUserDataOnNewActivity = message.resetUserDataOnNewActivity;
                            return object;
                        };
    
                        /**
                         * Converts this DataRetentionSettings to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DataRetentionSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DataRetentionSettings
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.DataRetentionSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DataRetentionSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.DataRetentionSettings";
                        };
    
                        /**
                         * RetentionDuration enum.
                         * @name google.analytics.admin.v1alpha.DataRetentionSettings.RetentionDuration
                         * @enum {number}
                         * @property {number} RETENTION_DURATION_UNSPECIFIED=0 RETENTION_DURATION_UNSPECIFIED value
                         * @property {number} TWO_MONTHS=1 TWO_MONTHS value
                         * @property {number} FOURTEEN_MONTHS=3 FOURTEEN_MONTHS value
                         * @property {number} TWENTY_SIX_MONTHS=4 TWENTY_SIX_MONTHS value
                         * @property {number} THIRTY_EIGHT_MONTHS=5 THIRTY_EIGHT_MONTHS value
                         * @property {number} FIFTY_MONTHS=6 FIFTY_MONTHS value
                         */
                        DataRetentionSettings.RetentionDuration = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "RETENTION_DURATION_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "TWO_MONTHS"] = 1;
                            values[valuesById[3] = "FOURTEEN_MONTHS"] = 3;
                            values[valuesById[4] = "TWENTY_SIX_MONTHS"] = 4;
                            values[valuesById[5] = "THIRTY_EIGHT_MONTHS"] = 5;
                            values[valuesById[6] = "FIFTY_MONTHS"] = 6;
                            return values;
                        })();
    
                        return DataRetentionSettings;
                    })();
    
                    v1alpha.AttributionSettings = (function() {
    
                        /**
                         * Properties of an AttributionSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAttributionSettings
                         * @property {string|null} [name] AttributionSettings name
                         * @property {google.analytics.admin.v1alpha.AttributionSettings.AcquisitionConversionEventLookbackWindow|null} [acquisitionConversionEventLookbackWindow] AttributionSettings acquisitionConversionEventLookbackWindow
                         * @property {google.analytics.admin.v1alpha.AttributionSettings.OtherConversionEventLookbackWindow|null} [otherConversionEventLookbackWindow] AttributionSettings otherConversionEventLookbackWindow
                         * @property {google.analytics.admin.v1alpha.AttributionSettings.ReportingAttributionModel|null} [reportingAttributionModel] AttributionSettings reportingAttributionModel
                         */
    
                        /**
                         * Constructs a new AttributionSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AttributionSettings.
                         * @implements IAttributionSettings
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAttributionSettings=} [properties] Properties to set
                         */
                        function AttributionSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AttributionSettings name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @instance
                         */
                        AttributionSettings.prototype.name = "";
    
                        /**
                         * AttributionSettings acquisitionConversionEventLookbackWindow.
                         * @member {google.analytics.admin.v1alpha.AttributionSettings.AcquisitionConversionEventLookbackWindow} acquisitionConversionEventLookbackWindow
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @instance
                         */
                        AttributionSettings.prototype.acquisitionConversionEventLookbackWindow = 0;
    
                        /**
                         * AttributionSettings otherConversionEventLookbackWindow.
                         * @member {google.analytics.admin.v1alpha.AttributionSettings.OtherConversionEventLookbackWindow} otherConversionEventLookbackWindow
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @instance
                         */
                        AttributionSettings.prototype.otherConversionEventLookbackWindow = 0;
    
                        /**
                         * AttributionSettings reportingAttributionModel.
                         * @member {google.analytics.admin.v1alpha.AttributionSettings.ReportingAttributionModel} reportingAttributionModel
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @instance
                         */
                        AttributionSettings.prototype.reportingAttributionModel = 0;
    
                        /**
                         * Creates a new AttributionSettings instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAttributionSettings=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AttributionSettings} AttributionSettings instance
                         */
                        AttributionSettings.create = function create(properties) {
                            return new AttributionSettings(properties);
                        };
    
                        /**
                         * Encodes the specified AttributionSettings message. Does not implicitly {@link google.analytics.admin.v1alpha.AttributionSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAttributionSettings} message AttributionSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttributionSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.acquisitionConversionEventLookbackWindow != null && Object.hasOwnProperty.call(message, "acquisitionConversionEventLookbackWindow"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.acquisitionConversionEventLookbackWindow);
                            if (message.otherConversionEventLookbackWindow != null && Object.hasOwnProperty.call(message, "otherConversionEventLookbackWindow"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.otherConversionEventLookbackWindow);
                            if (message.reportingAttributionModel != null && Object.hasOwnProperty.call(message, "reportingAttributionModel"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.reportingAttributionModel);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AttributionSettings message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AttributionSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAttributionSettings} message AttributionSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttributionSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AttributionSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AttributionSettings} AttributionSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttributionSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AttributionSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.acquisitionConversionEventLookbackWindow = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.otherConversionEventLookbackWindow = reader.int32();
                                        break;
                                    }
                                case 4: {
                                        message.reportingAttributionModel = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AttributionSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AttributionSettings} AttributionSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttributionSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AttributionSettings message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttributionSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.acquisitionConversionEventLookbackWindow != null && message.hasOwnProperty("acquisitionConversionEventLookbackWindow"))
                                switch (message.acquisitionConversionEventLookbackWindow) {
                                default:
                                    return "acquisitionConversionEventLookbackWindow: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.otherConversionEventLookbackWindow != null && message.hasOwnProperty("otherConversionEventLookbackWindow"))
                                switch (message.otherConversionEventLookbackWindow) {
                                default:
                                    return "otherConversionEventLookbackWindow: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.reportingAttributionModel != null && message.hasOwnProperty("reportingAttributionModel"))
                                switch (message.reportingAttributionModel) {
                                default:
                                    return "reportingAttributionModel: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                    break;
                                }
                            return null;
                        };
    
                        /**
                         * Creates an AttributionSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AttributionSettings} AttributionSettings
                         */
                        AttributionSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AttributionSettings)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AttributionSettings();
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.acquisitionConversionEventLookbackWindow) {
                            default:
                                if (typeof object.acquisitionConversionEventLookbackWindow === "number") {
                                    message.acquisitionConversionEventLookbackWindow = object.acquisitionConversionEventLookbackWindow;
                                    break;
                                }
                                break;
                            case "ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED":
                            case 0:
                                message.acquisitionConversionEventLookbackWindow = 0;
                                break;
                            case "ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_7_DAYS":
                            case 1:
                                message.acquisitionConversionEventLookbackWindow = 1;
                                break;
                            case "ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS":
                            case 2:
                                message.acquisitionConversionEventLookbackWindow = 2;
                                break;
                            }
                            switch (object.otherConversionEventLookbackWindow) {
                            default:
                                if (typeof object.otherConversionEventLookbackWindow === "number") {
                                    message.otherConversionEventLookbackWindow = object.otherConversionEventLookbackWindow;
                                    break;
                                }
                                break;
                            case "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED":
                            case 0:
                                message.otherConversionEventLookbackWindow = 0;
                                break;
                            case "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS":
                            case 1:
                                message.otherConversionEventLookbackWindow = 1;
                                break;
                            case "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_60_DAYS":
                            case 2:
                                message.otherConversionEventLookbackWindow = 2;
                                break;
                            case "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_90_DAYS":
                            case 3:
                                message.otherConversionEventLookbackWindow = 3;
                                break;
                            }
                            switch (object.reportingAttributionModel) {
                            default:
                                if (typeof object.reportingAttributionModel === "number") {
                                    message.reportingAttributionModel = object.reportingAttributionModel;
                                    break;
                                }
                                break;
                            case "REPORTING_ATTRIBUTION_MODEL_UNSPECIFIED":
                            case 0:
                                message.reportingAttributionModel = 0;
                                break;
                            case "CROSS_CHANNEL_DATA_DRIVEN":
                            case 1:
                                message.reportingAttributionModel = 1;
                                break;
                            case "CROSS_CHANNEL_LAST_CLICK":
                            case 2:
                                message.reportingAttributionModel = 2;
                                break;
                            case "CROSS_CHANNEL_FIRST_CLICK":
                            case 3:
                                message.reportingAttributionModel = 3;
                                break;
                            case "CROSS_CHANNEL_LINEAR":
                            case 4:
                                message.reportingAttributionModel = 4;
                                break;
                            case "CROSS_CHANNEL_POSITION_BASED":
                            case 5:
                                message.reportingAttributionModel = 5;
                                break;
                            case "CROSS_CHANNEL_TIME_DECAY":
                            case 6:
                                message.reportingAttributionModel = 6;
                                break;
                            case "ADS_PREFERRED_LAST_CLICK":
                            case 7:
                                message.reportingAttributionModel = 7;
                                break;
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AttributionSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.AttributionSettings} message AttributionSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttributionSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.acquisitionConversionEventLookbackWindow = options.enums === String ? "ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED" : 0;
                                object.otherConversionEventLookbackWindow = options.enums === String ? "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED" : 0;
                                object.reportingAttributionModel = options.enums === String ? "REPORTING_ATTRIBUTION_MODEL_UNSPECIFIED" : 0;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.acquisitionConversionEventLookbackWindow != null && message.hasOwnProperty("acquisitionConversionEventLookbackWindow"))
                                object.acquisitionConversionEventLookbackWindow = options.enums === String ? $root.google.analytics.admin.v1alpha.AttributionSettings.AcquisitionConversionEventLookbackWindow[message.acquisitionConversionEventLookbackWindow] === undefined ? message.acquisitionConversionEventLookbackWindow : $root.google.analytics.admin.v1alpha.AttributionSettings.AcquisitionConversionEventLookbackWindow[message.acquisitionConversionEventLookbackWindow] : message.acquisitionConversionEventLookbackWindow;
                            if (message.otherConversionEventLookbackWindow != null && message.hasOwnProperty("otherConversionEventLookbackWindow"))
                                object.otherConversionEventLookbackWindow = options.enums === String ? $root.google.analytics.admin.v1alpha.AttributionSettings.OtherConversionEventLookbackWindow[message.otherConversionEventLookbackWindow] === undefined ? message.otherConversionEventLookbackWindow : $root.google.analytics.admin.v1alpha.AttributionSettings.OtherConversionEventLookbackWindow[message.otherConversionEventLookbackWindow] : message.otherConversionEventLookbackWindow;
                            if (message.reportingAttributionModel != null && message.hasOwnProperty("reportingAttributionModel"))
                                object.reportingAttributionModel = options.enums === String ? $root.google.analytics.admin.v1alpha.AttributionSettings.ReportingAttributionModel[message.reportingAttributionModel] === undefined ? message.reportingAttributionModel : $root.google.analytics.admin.v1alpha.AttributionSettings.ReportingAttributionModel[message.reportingAttributionModel] : message.reportingAttributionModel;
                            return object;
                        };
    
                        /**
                         * Converts this AttributionSettings to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttributionSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AttributionSettings
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AttributionSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AttributionSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AttributionSettings";
                        };
    
                        /**
                         * AcquisitionConversionEventLookbackWindow enum.
                         * @name google.analytics.admin.v1alpha.AttributionSettings.AcquisitionConversionEventLookbackWindow
                         * @enum {number}
                         * @property {number} ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED=0 ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED value
                         * @property {number} ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_7_DAYS=1 ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_7_DAYS value
                         * @property {number} ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS=2 ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS value
                         */
                        AttributionSettings.AcquisitionConversionEventLookbackWindow = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_7_DAYS"] = 1;
                            values[valuesById[2] = "ACQUISITION_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS"] = 2;
                            return values;
                        })();
    
                        /**
                         * OtherConversionEventLookbackWindow enum.
                         * @name google.analytics.admin.v1alpha.AttributionSettings.OtherConversionEventLookbackWindow
                         * @enum {number}
                         * @property {number} OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED=0 OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED value
                         * @property {number} OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS=1 OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS value
                         * @property {number} OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_60_DAYS=2 OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_60_DAYS value
                         * @property {number} OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_90_DAYS=3 OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_90_DAYS value
                         */
                        AttributionSettings.OtherConversionEventLookbackWindow = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_30_DAYS"] = 1;
                            values[valuesById[2] = "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_60_DAYS"] = 2;
                            values[valuesById[3] = "OTHER_CONVERSION_EVENT_LOOKBACK_WINDOW_90_DAYS"] = 3;
                            return values;
                        })();
    
                        /**
                         * ReportingAttributionModel enum.
                         * @name google.analytics.admin.v1alpha.AttributionSettings.ReportingAttributionModel
                         * @enum {number}
                         * @property {number} REPORTING_ATTRIBUTION_MODEL_UNSPECIFIED=0 REPORTING_ATTRIBUTION_MODEL_UNSPECIFIED value
                         * @property {number} CROSS_CHANNEL_DATA_DRIVEN=1 CROSS_CHANNEL_DATA_DRIVEN value
                         * @property {number} CROSS_CHANNEL_LAST_CLICK=2 CROSS_CHANNEL_LAST_CLICK value
                         * @property {number} CROSS_CHANNEL_FIRST_CLICK=3 CROSS_CHANNEL_FIRST_CLICK value
                         * @property {number} CROSS_CHANNEL_LINEAR=4 CROSS_CHANNEL_LINEAR value
                         * @property {number} CROSS_CHANNEL_POSITION_BASED=5 CROSS_CHANNEL_POSITION_BASED value
                         * @property {number} CROSS_CHANNEL_TIME_DECAY=6 CROSS_CHANNEL_TIME_DECAY value
                         * @property {number} ADS_PREFERRED_LAST_CLICK=7 ADS_PREFERRED_LAST_CLICK value
                         */
                        AttributionSettings.ReportingAttributionModel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "REPORTING_ATTRIBUTION_MODEL_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "CROSS_CHANNEL_DATA_DRIVEN"] = 1;
                            values[valuesById[2] = "CROSS_CHANNEL_LAST_CLICK"] = 2;
                            values[valuesById[3] = "CROSS_CHANNEL_FIRST_CLICK"] = 3;
                            values[valuesById[4] = "CROSS_CHANNEL_LINEAR"] = 4;
                            values[valuesById[5] = "CROSS_CHANNEL_POSITION_BASED"] = 5;
                            values[valuesById[6] = "CROSS_CHANNEL_TIME_DECAY"] = 6;
                            values[valuesById[7] = "ADS_PREFERRED_LAST_CLICK"] = 7;
                            return values;
                        })();
    
                        return AttributionSettings;
                    })();
    
                    v1alpha.AccessBinding = (function() {
    
                        /**
                         * Properties of an AccessBinding.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAccessBinding
                         * @property {string|null} [user] AccessBinding user
                         * @property {string|null} [name] AccessBinding name
                         * @property {Array.<string>|null} [roles] AccessBinding roles
                         */
    
                        /**
                         * Constructs a new AccessBinding.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AccessBinding.
                         * @implements IAccessBinding
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAccessBinding=} [properties] Properties to set
                         */
                        function AccessBinding(properties) {
                            this.roles = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessBinding user.
                         * @member {string|null|undefined} user
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @instance
                         */
                        AccessBinding.prototype.user = null;
    
                        /**
                         * AccessBinding name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @instance
                         */
                        AccessBinding.prototype.name = "";
    
                        /**
                         * AccessBinding roles.
                         * @member {Array.<string>} roles
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @instance
                         */
                        AccessBinding.prototype.roles = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessBinding accessTarget.
                         * @member {"user"|undefined} accessTarget
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @instance
                         */
                        Object.defineProperty(AccessBinding.prototype, "accessTarget", {
                            get: $util.oneOfGetter($oneOfFields = ["user"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessBinding instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessBinding=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AccessBinding} AccessBinding instance
                         */
                        AccessBinding.create = function create(properties) {
                            return new AccessBinding(properties);
                        };
    
                        /**
                         * Encodes the specified AccessBinding message. Does not implicitly {@link google.analytics.admin.v1alpha.AccessBinding.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessBinding} message AccessBinding message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessBinding.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.user != null && Object.hasOwnProperty.call(message, "user"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.user);
                            if (message.roles != null && message.roles.length)
                                for (var i = 0; i < message.roles.length; ++i)
                                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.roles[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessBinding message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AccessBinding.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAccessBinding} message AccessBinding message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessBinding.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessBinding message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AccessBinding} AccessBinding
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessBinding.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AccessBinding();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2: {
                                        message.user = reader.string();
                                        break;
                                    }
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.roles && message.roles.length))
                                            message.roles = [];
                                        message.roles.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessBinding message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AccessBinding} AccessBinding
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessBinding.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessBinding message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessBinding.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.user != null && message.hasOwnProperty("user")) {
                                properties.accessTarget = 1;
                                if (!$util.isString(message.user))
                                    return "user: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.roles != null && message.hasOwnProperty("roles")) {
                                if (!Array.isArray(message.roles))
                                    return "roles: array expected";
                                for (var i = 0; i < message.roles.length; ++i)
                                    if (!$util.isString(message.roles[i]))
                                        return "roles: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessBinding message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AccessBinding} AccessBinding
                         */
                        AccessBinding.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AccessBinding)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AccessBinding();
                            if (object.user != null)
                                message.user = String(object.user);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.roles) {
                                if (!Array.isArray(object.roles))
                                    throw TypeError(".google.analytics.admin.v1alpha.AccessBinding.roles: array expected");
                                message.roles = [];
                                for (var i = 0; i < object.roles.length; ++i)
                                    message.roles[i] = String(object.roles[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessBinding message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {google.analytics.admin.v1alpha.AccessBinding} message AccessBinding
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessBinding.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.roles = [];
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.user != null && message.hasOwnProperty("user")) {
                                object.user = message.user;
                                if (options.oneofs)
                                    object.accessTarget = "user";
                            }
                            if (message.roles && message.roles.length) {
                                object.roles = [];
                                for (var j = 0; j < message.roles.length; ++j)
                                    object.roles[j] = message.roles[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessBinding to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessBinding.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessBinding
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AccessBinding
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessBinding.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AccessBinding";
                        };
    
                        return AccessBinding;
                    })();
    
                    v1alpha.BigQueryLink = (function() {
    
                        /**
                         * Properties of a BigQueryLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IBigQueryLink
                         * @property {string|null} [name] BigQueryLink name
                         * @property {string|null} [project] BigQueryLink project
                         * @property {google.protobuf.ITimestamp|null} [createTime] BigQueryLink createTime
                         * @property {boolean|null} [dailyExportEnabled] BigQueryLink dailyExportEnabled
                         * @property {boolean|null} [streamingExportEnabled] BigQueryLink streamingExportEnabled
                         * @property {boolean|null} [intradayExportEnabled] BigQueryLink intradayExportEnabled
                         * @property {boolean|null} [includeAdvertisingId] BigQueryLink includeAdvertisingId
                         * @property {Array.<string>|null} [exportStreams] BigQueryLink exportStreams
                         * @property {Array.<string>|null} [excludedEvents] BigQueryLink excludedEvents
                         */
    
                        /**
                         * Constructs a new BigQueryLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a BigQueryLink.
                         * @implements IBigQueryLink
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IBigQueryLink=} [properties] Properties to set
                         */
                        function BigQueryLink(properties) {
                            this.exportStreams = [];
                            this.excludedEvents = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BigQueryLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.name = "";
    
                        /**
                         * BigQueryLink project.
                         * @member {string} project
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.project = "";
    
                        /**
                         * BigQueryLink createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.createTime = null;
    
                        /**
                         * BigQueryLink dailyExportEnabled.
                         * @member {boolean} dailyExportEnabled
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.dailyExportEnabled = false;
    
                        /**
                         * BigQueryLink streamingExportEnabled.
                         * @member {boolean} streamingExportEnabled
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.streamingExportEnabled = false;
    
                        /**
                         * BigQueryLink intradayExportEnabled.
                         * @member {boolean} intradayExportEnabled
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.intradayExportEnabled = false;
    
                        /**
                         * BigQueryLink includeAdvertisingId.
                         * @member {boolean} includeAdvertisingId
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.includeAdvertisingId = false;
    
                        /**
                         * BigQueryLink exportStreams.
                         * @member {Array.<string>} exportStreams
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.exportStreams = $util.emptyArray;
    
                        /**
                         * BigQueryLink excludedEvents.
                         * @member {Array.<string>} excludedEvents
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         */
                        BigQueryLink.prototype.excludedEvents = $util.emptyArray;
    
                        /**
                         * Creates a new BigQueryLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBigQueryLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.BigQueryLink} BigQueryLink instance
                         */
                        BigQueryLink.create = function create(properties) {
                            return new BigQueryLink(properties);
                        };
    
                        /**
                         * Encodes the specified BigQueryLink message. Does not implicitly {@link google.analytics.admin.v1alpha.BigQueryLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBigQueryLink} message BigQueryLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BigQueryLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.project);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.dailyExportEnabled != null && Object.hasOwnProperty.call(message, "dailyExportEnabled"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.dailyExportEnabled);
                            if (message.streamingExportEnabled != null && Object.hasOwnProperty.call(message, "streamingExportEnabled"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.streamingExportEnabled);
                            if (message.includeAdvertisingId != null && Object.hasOwnProperty.call(message, "includeAdvertisingId"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.includeAdvertisingId);
                            if (message.exportStreams != null && message.exportStreams.length)
                                for (var i = 0; i < message.exportStreams.length; ++i)
                                    writer.uint32(/* id 7, wireType 2 =*/58).string(message.exportStreams[i]);
                            if (message.excludedEvents != null && message.excludedEvents.length)
                                for (var i = 0; i < message.excludedEvents.length; ++i)
                                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.excludedEvents[i]);
                            if (message.intradayExportEnabled != null && Object.hasOwnProperty.call(message, "intradayExportEnabled"))
                                writer.uint32(/* id 9, wireType 0 =*/72).bool(message.intradayExportEnabled);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BigQueryLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.BigQueryLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IBigQueryLink} message BigQueryLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BigQueryLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BigQueryLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.BigQueryLink} BigQueryLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BigQueryLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.BigQueryLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.dailyExportEnabled = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.streamingExportEnabled = reader.bool();
                                        break;
                                    }
                                case 9: {
                                        message.intradayExportEnabled = reader.bool();
                                        break;
                                    }
                                case 6: {
                                        message.includeAdvertisingId = reader.bool();
                                        break;
                                    }
                                case 7: {
                                        if (!(message.exportStreams && message.exportStreams.length))
                                            message.exportStreams = [];
                                        message.exportStreams.push(reader.string());
                                        break;
                                    }
                                case 8: {
                                        if (!(message.excludedEvents && message.excludedEvents.length))
                                            message.excludedEvents = [];
                                        message.excludedEvents.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BigQueryLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.BigQueryLink} BigQueryLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BigQueryLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BigQueryLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BigQueryLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.dailyExportEnabled != null && message.hasOwnProperty("dailyExportEnabled"))
                                if (typeof message.dailyExportEnabled !== "boolean")
                                    return "dailyExportEnabled: boolean expected";
                            if (message.streamingExportEnabled != null && message.hasOwnProperty("streamingExportEnabled"))
                                if (typeof message.streamingExportEnabled !== "boolean")
                                    return "streamingExportEnabled: boolean expected";
                            if (message.intradayExportEnabled != null && message.hasOwnProperty("intradayExportEnabled"))
                                if (typeof message.intradayExportEnabled !== "boolean")
                                    return "intradayExportEnabled: boolean expected";
                            if (message.includeAdvertisingId != null && message.hasOwnProperty("includeAdvertisingId"))
                                if (typeof message.includeAdvertisingId !== "boolean")
                                    return "includeAdvertisingId: boolean expected";
                            if (message.exportStreams != null && message.hasOwnProperty("exportStreams")) {
                                if (!Array.isArray(message.exportStreams))
                                    return "exportStreams: array expected";
                                for (var i = 0; i < message.exportStreams.length; ++i)
                                    if (!$util.isString(message.exportStreams[i]))
                                        return "exportStreams: string[] expected";
                            }
                            if (message.excludedEvents != null && message.hasOwnProperty("excludedEvents")) {
                                if (!Array.isArray(message.excludedEvents))
                                    return "excludedEvents: array expected";
                                for (var i = 0; i < message.excludedEvents.length; ++i)
                                    if (!$util.isString(message.excludedEvents[i]))
                                        return "excludedEvents: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BigQueryLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.BigQueryLink} BigQueryLink
                         */
                        BigQueryLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.BigQueryLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.BigQueryLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1alpha.BigQueryLink.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.dailyExportEnabled != null)
                                message.dailyExportEnabled = Boolean(object.dailyExportEnabled);
                            if (object.streamingExportEnabled != null)
                                message.streamingExportEnabled = Boolean(object.streamingExportEnabled);
                            if (object.intradayExportEnabled != null)
                                message.intradayExportEnabled = Boolean(object.intradayExportEnabled);
                            if (object.includeAdvertisingId != null)
                                message.includeAdvertisingId = Boolean(object.includeAdvertisingId);
                            if (object.exportStreams) {
                                if (!Array.isArray(object.exportStreams))
                                    throw TypeError(".google.analytics.admin.v1alpha.BigQueryLink.exportStreams: array expected");
                                message.exportStreams = [];
                                for (var i = 0; i < object.exportStreams.length; ++i)
                                    message.exportStreams[i] = String(object.exportStreams[i]);
                            }
                            if (object.excludedEvents) {
                                if (!Array.isArray(object.excludedEvents))
                                    throw TypeError(".google.analytics.admin.v1alpha.BigQueryLink.excludedEvents: array expected");
                                message.excludedEvents = [];
                                for (var i = 0; i < object.excludedEvents.length; ++i)
                                    message.excludedEvents[i] = String(object.excludedEvents[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BigQueryLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.BigQueryLink} message BigQueryLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BigQueryLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.exportStreams = [];
                                object.excludedEvents = [];
                            }
                            if (options.defaults) {
                                object.name = "";
                                object.project = "";
                                object.createTime = null;
                                object.dailyExportEnabled = false;
                                object.streamingExportEnabled = false;
                                object.includeAdvertisingId = false;
                                object.intradayExportEnabled = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.dailyExportEnabled != null && message.hasOwnProperty("dailyExportEnabled"))
                                object.dailyExportEnabled = message.dailyExportEnabled;
                            if (message.streamingExportEnabled != null && message.hasOwnProperty("streamingExportEnabled"))
                                object.streamingExportEnabled = message.streamingExportEnabled;
                            if (message.includeAdvertisingId != null && message.hasOwnProperty("includeAdvertisingId"))
                                object.includeAdvertisingId = message.includeAdvertisingId;
                            if (message.exportStreams && message.exportStreams.length) {
                                object.exportStreams = [];
                                for (var j = 0; j < message.exportStreams.length; ++j)
                                    object.exportStreams[j] = message.exportStreams[j];
                            }
                            if (message.excludedEvents && message.excludedEvents.length) {
                                object.excludedEvents = [];
                                for (var j = 0; j < message.excludedEvents.length; ++j)
                                    object.excludedEvents[j] = message.excludedEvents[j];
                            }
                            if (message.intradayExportEnabled != null && message.hasOwnProperty("intradayExportEnabled"))
                                object.intradayExportEnabled = message.intradayExportEnabled;
                            return object;
                        };
    
                        /**
                         * Converts this BigQueryLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BigQueryLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BigQueryLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.BigQueryLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BigQueryLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.BigQueryLink";
                        };
    
                        return BigQueryLink;
                    })();
    
                    v1alpha.EnhancedMeasurementSettings = (function() {
    
                        /**
                         * Properties of an EnhancedMeasurementSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IEnhancedMeasurementSettings
                         * @property {string|null} [name] EnhancedMeasurementSettings name
                         * @property {boolean|null} [streamEnabled] EnhancedMeasurementSettings streamEnabled
                         * @property {boolean|null} [scrollsEnabled] EnhancedMeasurementSettings scrollsEnabled
                         * @property {boolean|null} [outboundClicksEnabled] EnhancedMeasurementSettings outboundClicksEnabled
                         * @property {boolean|null} [siteSearchEnabled] EnhancedMeasurementSettings siteSearchEnabled
                         * @property {boolean|null} [videoEngagementEnabled] EnhancedMeasurementSettings videoEngagementEnabled
                         * @property {boolean|null} [fileDownloadsEnabled] EnhancedMeasurementSettings fileDownloadsEnabled
                         * @property {boolean|null} [pageChangesEnabled] EnhancedMeasurementSettings pageChangesEnabled
                         * @property {boolean|null} [formInteractionsEnabled] EnhancedMeasurementSettings formInteractionsEnabled
                         * @property {string|null} [searchQueryParameter] EnhancedMeasurementSettings searchQueryParameter
                         * @property {string|null} [uriQueryParameter] EnhancedMeasurementSettings uriQueryParameter
                         */
    
                        /**
                         * Constructs a new EnhancedMeasurementSettings.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an EnhancedMeasurementSettings.
                         * @implements IEnhancedMeasurementSettings
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings=} [properties] Properties to set
                         */
                        function EnhancedMeasurementSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * EnhancedMeasurementSettings name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.name = "";
    
                        /**
                         * EnhancedMeasurementSettings streamEnabled.
                         * @member {boolean} streamEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.streamEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings scrollsEnabled.
                         * @member {boolean} scrollsEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.scrollsEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings outboundClicksEnabled.
                         * @member {boolean} outboundClicksEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.outboundClicksEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings siteSearchEnabled.
                         * @member {boolean} siteSearchEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.siteSearchEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings videoEngagementEnabled.
                         * @member {boolean} videoEngagementEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.videoEngagementEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings fileDownloadsEnabled.
                         * @member {boolean} fileDownloadsEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.fileDownloadsEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings pageChangesEnabled.
                         * @member {boolean} pageChangesEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.pageChangesEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings formInteractionsEnabled.
                         * @member {boolean} formInteractionsEnabled
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.formInteractionsEnabled = false;
    
                        /**
                         * EnhancedMeasurementSettings searchQueryParameter.
                         * @member {string} searchQueryParameter
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.searchQueryParameter = "";
    
                        /**
                         * EnhancedMeasurementSettings uriQueryParameter.
                         * @member {string} uriQueryParameter
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         */
                        EnhancedMeasurementSettings.prototype.uriQueryParameter = "";
    
                        /**
                         * Creates a new EnhancedMeasurementSettings instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.EnhancedMeasurementSettings} EnhancedMeasurementSettings instance
                         */
                        EnhancedMeasurementSettings.create = function create(properties) {
                            return new EnhancedMeasurementSettings(properties);
                        };
    
                        /**
                         * Encodes the specified EnhancedMeasurementSettings message. Does not implicitly {@link google.analytics.admin.v1alpha.EnhancedMeasurementSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings} message EnhancedMeasurementSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnhancedMeasurementSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.streamEnabled != null && Object.hasOwnProperty.call(message, "streamEnabled"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.streamEnabled);
                            if (message.scrollsEnabled != null && Object.hasOwnProperty.call(message, "scrollsEnabled"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.scrollsEnabled);
                            if (message.outboundClicksEnabled != null && Object.hasOwnProperty.call(message, "outboundClicksEnabled"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.outboundClicksEnabled);
                            if (message.siteSearchEnabled != null && Object.hasOwnProperty.call(message, "siteSearchEnabled"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.siteSearchEnabled);
                            if (message.videoEngagementEnabled != null && Object.hasOwnProperty.call(message, "videoEngagementEnabled"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.videoEngagementEnabled);
                            if (message.fileDownloadsEnabled != null && Object.hasOwnProperty.call(message, "fileDownloadsEnabled"))
                                writer.uint32(/* id 7, wireType 0 =*/56).bool(message.fileDownloadsEnabled);
                            if (message.pageChangesEnabled != null && Object.hasOwnProperty.call(message, "pageChangesEnabled"))
                                writer.uint32(/* id 8, wireType 0 =*/64).bool(message.pageChangesEnabled);
                            if (message.formInteractionsEnabled != null && Object.hasOwnProperty.call(message, "formInteractionsEnabled"))
                                writer.uint32(/* id 9, wireType 0 =*/72).bool(message.formInteractionsEnabled);
                            if (message.searchQueryParameter != null && Object.hasOwnProperty.call(message, "searchQueryParameter"))
                                writer.uint32(/* id 10, wireType 2 =*/82).string(message.searchQueryParameter);
                            if (message.uriQueryParameter != null && Object.hasOwnProperty.call(message, "uriQueryParameter"))
                                writer.uint32(/* id 11, wireType 2 =*/90).string(message.uriQueryParameter);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified EnhancedMeasurementSettings message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.EnhancedMeasurementSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.IEnhancedMeasurementSettings} message EnhancedMeasurementSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnhancedMeasurementSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an EnhancedMeasurementSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.EnhancedMeasurementSettings} EnhancedMeasurementSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnhancedMeasurementSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.streamEnabled = reader.bool();
                                        break;
                                    }
                                case 3: {
                                        message.scrollsEnabled = reader.bool();
                                        break;
                                    }
                                case 4: {
                                        message.outboundClicksEnabled = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.siteSearchEnabled = reader.bool();
                                        break;
                                    }
                                case 6: {
                                        message.videoEngagementEnabled = reader.bool();
                                        break;
                                    }
                                case 7: {
                                        message.fileDownloadsEnabled = reader.bool();
                                        break;
                                    }
                                case 8: {
                                        message.pageChangesEnabled = reader.bool();
                                        break;
                                    }
                                case 9: {
                                        message.formInteractionsEnabled = reader.bool();
                                        break;
                                    }
                                case 10: {
                                        message.searchQueryParameter = reader.string();
                                        break;
                                    }
                                case 11: {
                                        message.uriQueryParameter = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an EnhancedMeasurementSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.EnhancedMeasurementSettings} EnhancedMeasurementSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnhancedMeasurementSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an EnhancedMeasurementSettings message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        EnhancedMeasurementSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.streamEnabled != null && message.hasOwnProperty("streamEnabled"))
                                if (typeof message.streamEnabled !== "boolean")
                                    return "streamEnabled: boolean expected";
                            if (message.scrollsEnabled != null && message.hasOwnProperty("scrollsEnabled"))
                                if (typeof message.scrollsEnabled !== "boolean")
                                    return "scrollsEnabled: boolean expected";
                            if (message.outboundClicksEnabled != null && message.hasOwnProperty("outboundClicksEnabled"))
                                if (typeof message.outboundClicksEnabled !== "boolean")
                                    return "outboundClicksEnabled: boolean expected";
                            if (message.siteSearchEnabled != null && message.hasOwnProperty("siteSearchEnabled"))
                                if (typeof message.siteSearchEnabled !== "boolean")
                                    return "siteSearchEnabled: boolean expected";
                            if (message.videoEngagementEnabled != null && message.hasOwnProperty("videoEngagementEnabled"))
                                if (typeof message.videoEngagementEnabled !== "boolean")
                                    return "videoEngagementEnabled: boolean expected";
                            if (message.fileDownloadsEnabled != null && message.hasOwnProperty("fileDownloadsEnabled"))
                                if (typeof message.fileDownloadsEnabled !== "boolean")
                                    return "fileDownloadsEnabled: boolean expected";
                            if (message.pageChangesEnabled != null && message.hasOwnProperty("pageChangesEnabled"))
                                if (typeof message.pageChangesEnabled !== "boolean")
                                    return "pageChangesEnabled: boolean expected";
                            if (message.formInteractionsEnabled != null && message.hasOwnProperty("formInteractionsEnabled"))
                                if (typeof message.formInteractionsEnabled !== "boolean")
                                    return "formInteractionsEnabled: boolean expected";
                            if (message.searchQueryParameter != null && message.hasOwnProperty("searchQueryParameter"))
                                if (!$util.isString(message.searchQueryParameter))
                                    return "searchQueryParameter: string expected";
                            if (message.uriQueryParameter != null && message.hasOwnProperty("uriQueryParameter"))
                                if (!$util.isString(message.uriQueryParameter))
                                    return "uriQueryParameter: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an EnhancedMeasurementSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.EnhancedMeasurementSettings} EnhancedMeasurementSettings
                         */
                        EnhancedMeasurementSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.EnhancedMeasurementSettings();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.streamEnabled != null)
                                message.streamEnabled = Boolean(object.streamEnabled);
                            if (object.scrollsEnabled != null)
                                message.scrollsEnabled = Boolean(object.scrollsEnabled);
                            if (object.outboundClicksEnabled != null)
                                message.outboundClicksEnabled = Boolean(object.outboundClicksEnabled);
                            if (object.siteSearchEnabled != null)
                                message.siteSearchEnabled = Boolean(object.siteSearchEnabled);
                            if (object.videoEngagementEnabled != null)
                                message.videoEngagementEnabled = Boolean(object.videoEngagementEnabled);
                            if (object.fileDownloadsEnabled != null)
                                message.fileDownloadsEnabled = Boolean(object.fileDownloadsEnabled);
                            if (object.pageChangesEnabled != null)
                                message.pageChangesEnabled = Boolean(object.pageChangesEnabled);
                            if (object.formInteractionsEnabled != null)
                                message.formInteractionsEnabled = Boolean(object.formInteractionsEnabled);
                            if (object.searchQueryParameter != null)
                                message.searchQueryParameter = String(object.searchQueryParameter);
                            if (object.uriQueryParameter != null)
                                message.uriQueryParameter = String(object.uriQueryParameter);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an EnhancedMeasurementSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {google.analytics.admin.v1alpha.EnhancedMeasurementSettings} message EnhancedMeasurementSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        EnhancedMeasurementSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.streamEnabled = false;
                                object.scrollsEnabled = false;
                                object.outboundClicksEnabled = false;
                                object.siteSearchEnabled = false;
                                object.videoEngagementEnabled = false;
                                object.fileDownloadsEnabled = false;
                                object.pageChangesEnabled = false;
                                object.formInteractionsEnabled = false;
                                object.searchQueryParameter = "";
                                object.uriQueryParameter = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.streamEnabled != null && message.hasOwnProperty("streamEnabled"))
                                object.streamEnabled = message.streamEnabled;
                            if (message.scrollsEnabled != null && message.hasOwnProperty("scrollsEnabled"))
                                object.scrollsEnabled = message.scrollsEnabled;
                            if (message.outboundClicksEnabled != null && message.hasOwnProperty("outboundClicksEnabled"))
                                object.outboundClicksEnabled = message.outboundClicksEnabled;
                            if (message.siteSearchEnabled != null && message.hasOwnProperty("siteSearchEnabled"))
                                object.siteSearchEnabled = message.siteSearchEnabled;
                            if (message.videoEngagementEnabled != null && message.hasOwnProperty("videoEngagementEnabled"))
                                object.videoEngagementEnabled = message.videoEngagementEnabled;
                            if (message.fileDownloadsEnabled != null && message.hasOwnProperty("fileDownloadsEnabled"))
                                object.fileDownloadsEnabled = message.fileDownloadsEnabled;
                            if (message.pageChangesEnabled != null && message.hasOwnProperty("pageChangesEnabled"))
                                object.pageChangesEnabled = message.pageChangesEnabled;
                            if (message.formInteractionsEnabled != null && message.hasOwnProperty("formInteractionsEnabled"))
                                object.formInteractionsEnabled = message.formInteractionsEnabled;
                            if (message.searchQueryParameter != null && message.hasOwnProperty("searchQueryParameter"))
                                object.searchQueryParameter = message.searchQueryParameter;
                            if (message.uriQueryParameter != null && message.hasOwnProperty("uriQueryParameter"))
                                object.uriQueryParameter = message.uriQueryParameter;
                            return object;
                        };
    
                        /**
                         * Converts this EnhancedMeasurementSettings to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        EnhancedMeasurementSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for EnhancedMeasurementSettings
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.EnhancedMeasurementSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        EnhancedMeasurementSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.EnhancedMeasurementSettings";
                        };
    
                        return EnhancedMeasurementSettings;
                    })();
    
                    v1alpha.ConnectedSiteTag = (function() {
    
                        /**
                         * Properties of a ConnectedSiteTag.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IConnectedSiteTag
                         * @property {string|null} [displayName] ConnectedSiteTag displayName
                         * @property {string|null} [tagId] ConnectedSiteTag tagId
                         */
    
                        /**
                         * Constructs a new ConnectedSiteTag.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents a ConnectedSiteTag.
                         * @implements IConnectedSiteTag
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IConnectedSiteTag=} [properties] Properties to set
                         */
                        function ConnectedSiteTag(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ConnectedSiteTag displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @instance
                         */
                        ConnectedSiteTag.prototype.displayName = "";
    
                        /**
                         * ConnectedSiteTag tagId.
                         * @member {string} tagId
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @instance
                         */
                        ConnectedSiteTag.prototype.tagId = "";
    
                        /**
                         * Creates a new ConnectedSiteTag instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.IConnectedSiteTag=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.ConnectedSiteTag} ConnectedSiteTag instance
                         */
                        ConnectedSiteTag.create = function create(properties) {
                            return new ConnectedSiteTag(properties);
                        };
    
                        /**
                         * Encodes the specified ConnectedSiteTag message. Does not implicitly {@link google.analytics.admin.v1alpha.ConnectedSiteTag.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.IConnectedSiteTag} message ConnectedSiteTag message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConnectedSiteTag.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.displayName);
                            if (message.tagId != null && Object.hasOwnProperty.call(message, "tagId"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.tagId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ConnectedSiteTag message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.ConnectedSiteTag.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.IConnectedSiteTag} message ConnectedSiteTag message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConnectedSiteTag.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ConnectedSiteTag message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.ConnectedSiteTag} ConnectedSiteTag
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConnectedSiteTag.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.ConnectedSiteTag();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.tagId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ConnectedSiteTag message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.ConnectedSiteTag} ConnectedSiteTag
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConnectedSiteTag.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ConnectedSiteTag message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConnectedSiteTag.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.tagId != null && message.hasOwnProperty("tagId"))
                                if (!$util.isString(message.tagId))
                                    return "tagId: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ConnectedSiteTag message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.ConnectedSiteTag} ConnectedSiteTag
                         */
                        ConnectedSiteTag.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.ConnectedSiteTag)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.ConnectedSiteTag();
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.tagId != null)
                                message.tagId = String(object.tagId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ConnectedSiteTag message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {google.analytics.admin.v1alpha.ConnectedSiteTag} message ConnectedSiteTag
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConnectedSiteTag.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.displayName = "";
                                object.tagId = "";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.tagId != null && message.hasOwnProperty("tagId"))
                                object.tagId = message.tagId;
                            return object;
                        };
    
                        /**
                         * Converts this ConnectedSiteTag to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConnectedSiteTag.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ConnectedSiteTag
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.ConnectedSiteTag
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ConnectedSiteTag.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.ConnectedSiteTag";
                        };
    
                        return ConnectedSiteTag;
                    })();
    
                    v1alpha.AdSenseLink = (function() {
    
                        /**
                         * Properties of an AdSenseLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @interface IAdSenseLink
                         * @property {string|null} [name] AdSenseLink name
                         * @property {string|null} [adClientCode] AdSenseLink adClientCode
                         */
    
                        /**
                         * Constructs a new AdSenseLink.
                         * @memberof google.analytics.admin.v1alpha
                         * @classdesc Represents an AdSenseLink.
                         * @implements IAdSenseLink
                         * @constructor
                         * @param {google.analytics.admin.v1alpha.IAdSenseLink=} [properties] Properties to set
                         */
                        function AdSenseLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AdSenseLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @instance
                         */
                        AdSenseLink.prototype.name = "";
    
                        /**
                         * AdSenseLink adClientCode.
                         * @member {string} adClientCode
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @instance
                         */
                        AdSenseLink.prototype.adClientCode = "";
    
                        /**
                         * Creates a new AdSenseLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAdSenseLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1alpha.AdSenseLink} AdSenseLink instance
                         */
                        AdSenseLink.create = function create(properties) {
                            return new AdSenseLink(properties);
                        };
    
                        /**
                         * Encodes the specified AdSenseLink message. Does not implicitly {@link google.analytics.admin.v1alpha.AdSenseLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAdSenseLink} message AdSenseLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdSenseLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.adClientCode != null && Object.hasOwnProperty.call(message, "adClientCode"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.adClientCode);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AdSenseLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1alpha.AdSenseLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.IAdSenseLink} message AdSenseLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdSenseLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AdSenseLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1alpha.AdSenseLink} AdSenseLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdSenseLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1alpha.AdSenseLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.adClientCode = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AdSenseLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1alpha.AdSenseLink} AdSenseLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdSenseLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AdSenseLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdSenseLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.adClientCode != null && message.hasOwnProperty("adClientCode"))
                                if (!$util.isString(message.adClientCode))
                                    return "adClientCode: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AdSenseLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1alpha.AdSenseLink} AdSenseLink
                         */
                        AdSenseLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1alpha.AdSenseLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1alpha.AdSenseLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.adClientCode != null)
                                message.adClientCode = String(object.adClientCode);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AdSenseLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {google.analytics.admin.v1alpha.AdSenseLink} message AdSenseLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdSenseLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.adClientCode = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.adClientCode != null && message.hasOwnProperty("adClientCode"))
                                object.adClientCode = message.adClientCode;
                            return object;
                        };
    
                        /**
                         * Converts this AdSenseLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdSenseLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AdSenseLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1alpha.AdSenseLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AdSenseLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1alpha.AdSenseLink";
                        };
    
                        return AdSenseLink;
                    })();
    
                    return v1alpha;
                })();
    
                admin.v1beta = (function() {
    
                    /**
                     * Namespace v1beta.
                     * @memberof google.analytics.admin
                     * @namespace
                     */
                    var v1beta = {};
    
                    v1beta.AccessDimension = (function() {
    
                        /**
                         * Properties of an AccessDimension.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessDimension
                         * @property {string|null} [dimensionName] AccessDimension dimensionName
                         */
    
                        /**
                         * Constructs a new AccessDimension.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessDimension.
                         * @implements IAccessDimension
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessDimension=} [properties] Properties to set
                         */
                        function AccessDimension(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDimension dimensionName.
                         * @member {string} dimensionName
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @instance
                         */
                        AccessDimension.prototype.dimensionName = "";
    
                        /**
                         * Creates a new AccessDimension instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimension=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessDimension} AccessDimension instance
                         */
                        AccessDimension.create = function create(properties) {
                            return new AccessDimension(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDimension message. Does not implicitly {@link google.analytics.admin.v1beta.AccessDimension.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimension} message AccessDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimension.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionName != null && Object.hasOwnProperty.call(message, "dimensionName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.dimensionName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDimension message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessDimension.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimension} message AccessDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimension.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDimension message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessDimension} AccessDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimension.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessDimension();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dimensionName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDimension message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessDimension} AccessDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimension.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDimension message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDimension.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                if (!$util.isString(message.dimensionName))
                                    return "dimensionName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDimension message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessDimension} AccessDimension
                         */
                        AccessDimension.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessDimension)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessDimension();
                            if (object.dimensionName != null)
                                message.dimensionName = String(object.dimensionName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDimension message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessDimension} message AccessDimension
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDimension.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.dimensionName = "";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                object.dimensionName = message.dimensionName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDimension to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDimension.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDimension
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessDimension
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDimension.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessDimension";
                        };
    
                        return AccessDimension;
                    })();
    
                    v1beta.AccessMetric = (function() {
    
                        /**
                         * Properties of an AccessMetric.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessMetric
                         * @property {string|null} [metricName] AccessMetric metricName
                         */
    
                        /**
                         * Constructs a new AccessMetric.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessMetric.
                         * @implements IAccessMetric
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessMetric=} [properties] Properties to set
                         */
                        function AccessMetric(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessMetric metricName.
                         * @member {string} metricName
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @instance
                         */
                        AccessMetric.prototype.metricName = "";
    
                        /**
                         * Creates a new AccessMetric instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetric=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessMetric} AccessMetric instance
                         */
                        AccessMetric.create = function create(properties) {
                            return new AccessMetric(properties);
                        };
    
                        /**
                         * Encodes the specified AccessMetric message. Does not implicitly {@link google.analytics.admin.v1beta.AccessMetric.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetric} message AccessMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetric.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metricName != null && Object.hasOwnProperty.call(message, "metricName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.metricName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessMetric message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessMetric.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetric} message AccessMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetric.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessMetric message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessMetric} AccessMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetric.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessMetric();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.metricName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessMetric message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessMetric} AccessMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetric.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessMetric message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessMetric.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                if (!$util.isString(message.metricName))
                                    return "metricName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessMetric message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessMetric} AccessMetric
                         */
                        AccessMetric.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessMetric)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessMetric();
                            if (object.metricName != null)
                                message.metricName = String(object.metricName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessMetric message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessMetric} message AccessMetric
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessMetric.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.metricName = "";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                object.metricName = message.metricName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessMetric to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessMetric.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessMetric
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessMetric
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessMetric.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessMetric";
                        };
    
                        return AccessMetric;
                    })();
    
                    v1beta.AccessDateRange = (function() {
    
                        /**
                         * Properties of an AccessDateRange.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessDateRange
                         * @property {string|null} [startDate] AccessDateRange startDate
                         * @property {string|null} [endDate] AccessDateRange endDate
                         */
    
                        /**
                         * Constructs a new AccessDateRange.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessDateRange.
                         * @implements IAccessDateRange
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessDateRange=} [properties] Properties to set
                         */
                        function AccessDateRange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDateRange startDate.
                         * @member {string} startDate
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @instance
                         */
                        AccessDateRange.prototype.startDate = "";
    
                        /**
                         * AccessDateRange endDate.
                         * @member {string} endDate
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @instance
                         */
                        AccessDateRange.prototype.endDate = "";
    
                        /**
                         * Creates a new AccessDateRange instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDateRange=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessDateRange} AccessDateRange instance
                         */
                        AccessDateRange.create = function create(properties) {
                            return new AccessDateRange(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDateRange message. Does not implicitly {@link google.analytics.admin.v1beta.AccessDateRange.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDateRange} message AccessDateRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDateRange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.startDate != null && Object.hasOwnProperty.call(message, "startDate"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.startDate);
                            if (message.endDate != null && Object.hasOwnProperty.call(message, "endDate"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.endDate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDateRange message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessDateRange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDateRange} message AccessDateRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDateRange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDateRange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessDateRange} AccessDateRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDateRange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessDateRange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.startDate = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.endDate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDateRange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessDateRange} AccessDateRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDateRange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDateRange message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDateRange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                if (!$util.isString(message.startDate))
                                    return "startDate: string expected";
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                if (!$util.isString(message.endDate))
                                    return "endDate: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDateRange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessDateRange} AccessDateRange
                         */
                        AccessDateRange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessDateRange)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessDateRange();
                            if (object.startDate != null)
                                message.startDate = String(object.startDate);
                            if (object.endDate != null)
                                message.endDate = String(object.endDate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDateRange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessDateRange} message AccessDateRange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDateRange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.startDate = "";
                                object.endDate = "";
                            }
                            if (message.startDate != null && message.hasOwnProperty("startDate"))
                                object.startDate = message.startDate;
                            if (message.endDate != null && message.hasOwnProperty("endDate"))
                                object.endDate = message.endDate;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDateRange to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDateRange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDateRange
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessDateRange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDateRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessDateRange";
                        };
    
                        return AccessDateRange;
                    })();
    
                    v1beta.AccessFilterExpression = (function() {
    
                        /**
                         * Properties of an AccessFilterExpression.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessFilterExpression
                         * @property {google.analytics.admin.v1beta.IAccessFilterExpressionList|null} [andGroup] AccessFilterExpression andGroup
                         * @property {google.analytics.admin.v1beta.IAccessFilterExpressionList|null} [orGroup] AccessFilterExpression orGroup
                         * @property {google.analytics.admin.v1beta.IAccessFilterExpression|null} [notExpression] AccessFilterExpression notExpression
                         * @property {google.analytics.admin.v1beta.IAccessFilter|null} [accessFilter] AccessFilterExpression accessFilter
                         */
    
                        /**
                         * Constructs a new AccessFilterExpression.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessFilterExpression.
                         * @implements IAccessFilterExpression
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpression=} [properties] Properties to set
                         */
                        function AccessFilterExpression(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessFilterExpression andGroup.
                         * @member {google.analytics.admin.v1beta.IAccessFilterExpressionList|null|undefined} andGroup
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.andGroup = null;
    
                        /**
                         * AccessFilterExpression orGroup.
                         * @member {google.analytics.admin.v1beta.IAccessFilterExpressionList|null|undefined} orGroup
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.orGroup = null;
    
                        /**
                         * AccessFilterExpression notExpression.
                         * @member {google.analytics.admin.v1beta.IAccessFilterExpression|null|undefined} notExpression
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.notExpression = null;
    
                        /**
                         * AccessFilterExpression accessFilter.
                         * @member {google.analytics.admin.v1beta.IAccessFilter|null|undefined} accessFilter
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @instance
                         */
                        AccessFilterExpression.prototype.accessFilter = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessFilterExpression oneExpression.
                         * @member {"andGroup"|"orGroup"|"notExpression"|"accessFilter"|undefined} oneExpression
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @instance
                         */
                        Object.defineProperty(AccessFilterExpression.prototype, "oneExpression", {
                            get: $util.oneOfGetter($oneOfFields = ["andGroup", "orGroup", "notExpression", "accessFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessFilterExpression instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpression=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpression} AccessFilterExpression instance
                         */
                        AccessFilterExpression.create = function create(properties) {
                            return new AccessFilterExpression(properties);
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpression message. Does not implicitly {@link google.analytics.admin.v1beta.AccessFilterExpression.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpression} message AccessFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpression.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.andGroup != null && Object.hasOwnProperty.call(message, "andGroup"))
                                $root.google.analytics.admin.v1beta.AccessFilterExpressionList.encode(message.andGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.orGroup != null && Object.hasOwnProperty.call(message, "orGroup"))
                                $root.google.analytics.admin.v1beta.AccessFilterExpressionList.encode(message.orGroup, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.notExpression != null && Object.hasOwnProperty.call(message, "notExpression"))
                                $root.google.analytics.admin.v1beta.AccessFilterExpression.encode(message.notExpression, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.accessFilter != null && Object.hasOwnProperty.call(message, "accessFilter"))
                                $root.google.analytics.admin.v1beta.AccessFilter.encode(message.accessFilter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpression message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessFilterExpression.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpression} message AccessFilterExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpression.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessFilterExpression message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpression} AccessFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpression.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessFilterExpression();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.andGroup = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.orGroup = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.notExpression = $root.google.analytics.admin.v1beta.AccessFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.accessFilter = $root.google.analytics.admin.v1beta.AccessFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessFilterExpression message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpression} AccessFilterExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpression.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessFilterExpression message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessFilterExpression.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.verify(message.andGroup);
                                    if (error)
                                        return "andGroup." + error;
                                }
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                if (properties.oneExpression === 1)
                                    return "oneExpression: multiple values";
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.verify(message.orGroup);
                                    if (error)
                                        return "orGroup." + error;
                                }
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                if (properties.oneExpression === 1)
                                    return "oneExpression: multiple values";
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessFilterExpression.verify(message.notExpression);
                                    if (error)
                                        return "notExpression." + error;
                                }
                            }
                            if (message.accessFilter != null && message.hasOwnProperty("accessFilter")) {
                                if (properties.oneExpression === 1)
                                    return "oneExpression: multiple values";
                                properties.oneExpression = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessFilter.verify(message.accessFilter);
                                    if (error)
                                        return "accessFilter." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessFilterExpression message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpression} AccessFilterExpression
                         */
                        AccessFilterExpression.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessFilterExpression)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessFilterExpression();
                            if (object.andGroup != null) {
                                if (typeof object.andGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilterExpression.andGroup: object expected");
                                message.andGroup = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.fromObject(object.andGroup);
                            }
                            if (object.orGroup != null) {
                                if (typeof object.orGroup !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilterExpression.orGroup: object expected");
                                message.orGroup = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.fromObject(object.orGroup);
                            }
                            if (object.notExpression != null) {
                                if (typeof object.notExpression !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilterExpression.notExpression: object expected");
                                message.notExpression = $root.google.analytics.admin.v1beta.AccessFilterExpression.fromObject(object.notExpression);
                            }
                            if (object.accessFilter != null) {
                                if (typeof object.accessFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilterExpression.accessFilter: object expected");
                                message.accessFilter = $root.google.analytics.admin.v1beta.AccessFilter.fromObject(object.accessFilter);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessFilterExpression message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessFilterExpression} message AccessFilterExpression
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessFilterExpression.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.andGroup != null && message.hasOwnProperty("andGroup")) {
                                object.andGroup = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.toObject(message.andGroup, options);
                                if (options.oneofs)
                                    object.oneExpression = "andGroup";
                            }
                            if (message.orGroup != null && message.hasOwnProperty("orGroup")) {
                                object.orGroup = $root.google.analytics.admin.v1beta.AccessFilterExpressionList.toObject(message.orGroup, options);
                                if (options.oneofs)
                                    object.oneExpression = "orGroup";
                            }
                            if (message.notExpression != null && message.hasOwnProperty("notExpression")) {
                                object.notExpression = $root.google.analytics.admin.v1beta.AccessFilterExpression.toObject(message.notExpression, options);
                                if (options.oneofs)
                                    object.oneExpression = "notExpression";
                            }
                            if (message.accessFilter != null && message.hasOwnProperty("accessFilter")) {
                                object.accessFilter = $root.google.analytics.admin.v1beta.AccessFilter.toObject(message.accessFilter, options);
                                if (options.oneofs)
                                    object.oneExpression = "accessFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessFilterExpression to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessFilterExpression.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessFilterExpression
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpression
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessFilterExpression.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessFilterExpression";
                        };
    
                        return AccessFilterExpression;
                    })();
    
                    v1beta.AccessFilterExpressionList = (function() {
    
                        /**
                         * Properties of an AccessFilterExpressionList.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessFilterExpressionList
                         * @property {Array.<google.analytics.admin.v1beta.IAccessFilterExpression>|null} [expressions] AccessFilterExpressionList expressions
                         */
    
                        /**
                         * Constructs a new AccessFilterExpressionList.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessFilterExpressionList.
                         * @implements IAccessFilterExpressionList
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpressionList=} [properties] Properties to set
                         */
                        function AccessFilterExpressionList(properties) {
                            this.expressions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessFilterExpressionList expressions.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessFilterExpression>} expressions
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @instance
                         */
                        AccessFilterExpressionList.prototype.expressions = $util.emptyArray;
    
                        /**
                         * Creates a new AccessFilterExpressionList instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpressionList=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpressionList} AccessFilterExpressionList instance
                         */
                        AccessFilterExpressionList.create = function create(properties) {
                            return new AccessFilterExpressionList(properties);
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpressionList message. Does not implicitly {@link google.analytics.admin.v1beta.AccessFilterExpressionList.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpressionList} message AccessFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpressionList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.expressions != null && message.expressions.length)
                                for (var i = 0; i < message.expressions.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessFilterExpression.encode(message.expressions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessFilterExpressionList message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessFilterExpressionList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilterExpressionList} message AccessFilterExpressionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilterExpressionList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessFilterExpressionList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpressionList} AccessFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpressionList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessFilterExpressionList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.expressions && message.expressions.length))
                                            message.expressions = [];
                                        message.expressions.push($root.google.analytics.admin.v1beta.AccessFilterExpression.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessFilterExpressionList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpressionList} AccessFilterExpressionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilterExpressionList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessFilterExpressionList message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessFilterExpressionList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.expressions != null && message.hasOwnProperty("expressions")) {
                                if (!Array.isArray(message.expressions))
                                    return "expressions: array expected";
                                for (var i = 0; i < message.expressions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessFilterExpression.verify(message.expressions[i]);
                                    if (error)
                                        return "expressions." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessFilterExpressionList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessFilterExpressionList} AccessFilterExpressionList
                         */
                        AccessFilterExpressionList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessFilterExpressionList)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessFilterExpressionList();
                            if (object.expressions) {
                                if (!Array.isArray(object.expressions))
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilterExpressionList.expressions: array expected");
                                message.expressions = [];
                                for (var i = 0; i < object.expressions.length; ++i) {
                                    if (typeof object.expressions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.AccessFilterExpressionList.expressions: object expected");
                                    message.expressions[i] = $root.google.analytics.admin.v1beta.AccessFilterExpression.fromObject(object.expressions[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessFilterExpressionList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessFilterExpressionList} message AccessFilterExpressionList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessFilterExpressionList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.expressions = [];
                            if (message.expressions && message.expressions.length) {
                                object.expressions = [];
                                for (var j = 0; j < message.expressions.length; ++j)
                                    object.expressions[j] = $root.google.analytics.admin.v1beta.AccessFilterExpression.toObject(message.expressions[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessFilterExpressionList to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessFilterExpressionList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessFilterExpressionList
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessFilterExpressionList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessFilterExpressionList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessFilterExpressionList";
                        };
    
                        return AccessFilterExpressionList;
                    })();
    
                    v1beta.AccessFilter = (function() {
    
                        /**
                         * Properties of an AccessFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessFilter
                         * @property {google.analytics.admin.v1beta.IAccessStringFilter|null} [stringFilter] AccessFilter stringFilter
                         * @property {google.analytics.admin.v1beta.IAccessInListFilter|null} [inListFilter] AccessFilter inListFilter
                         * @property {google.analytics.admin.v1beta.IAccessNumericFilter|null} [numericFilter] AccessFilter numericFilter
                         * @property {google.analytics.admin.v1beta.IAccessBetweenFilter|null} [betweenFilter] AccessFilter betweenFilter
                         * @property {string|null} [fieldName] AccessFilter fieldName
                         */
    
                        /**
                         * Constructs a new AccessFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessFilter.
                         * @implements IAccessFilter
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessFilter=} [properties] Properties to set
                         */
                        function AccessFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessFilter stringFilter.
                         * @member {google.analytics.admin.v1beta.IAccessStringFilter|null|undefined} stringFilter
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.stringFilter = null;
    
                        /**
                         * AccessFilter inListFilter.
                         * @member {google.analytics.admin.v1beta.IAccessInListFilter|null|undefined} inListFilter
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.inListFilter = null;
    
                        /**
                         * AccessFilter numericFilter.
                         * @member {google.analytics.admin.v1beta.IAccessNumericFilter|null|undefined} numericFilter
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.numericFilter = null;
    
                        /**
                         * AccessFilter betweenFilter.
                         * @member {google.analytics.admin.v1beta.IAccessBetweenFilter|null|undefined} betweenFilter
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.betweenFilter = null;
    
                        /**
                         * AccessFilter fieldName.
                         * @member {string} fieldName
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @instance
                         */
                        AccessFilter.prototype.fieldName = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessFilter oneFilter.
                         * @member {"stringFilter"|"inListFilter"|"numericFilter"|"betweenFilter"|undefined} oneFilter
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @instance
                         */
                        Object.defineProperty(AccessFilter.prototype, "oneFilter", {
                            get: $util.oneOfGetter($oneOfFields = ["stringFilter", "inListFilter", "numericFilter", "betweenFilter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessFilter} AccessFilter instance
                         */
                        AccessFilter.create = function create(properties) {
                            return new AccessFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessFilter message. Does not implicitly {@link google.analytics.admin.v1beta.AccessFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilter} message AccessFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fieldName != null && Object.hasOwnProperty.call(message, "fieldName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fieldName);
                            if (message.stringFilter != null && Object.hasOwnProperty.call(message, "stringFilter"))
                                $root.google.analytics.admin.v1beta.AccessStringFilter.encode(message.stringFilter, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.inListFilter != null && Object.hasOwnProperty.call(message, "inListFilter"))
                                $root.google.analytics.admin.v1beta.AccessInListFilter.encode(message.inListFilter, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.numericFilter != null && Object.hasOwnProperty.call(message, "numericFilter"))
                                $root.google.analytics.admin.v1beta.AccessNumericFilter.encode(message.numericFilter, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.betweenFilter != null && Object.hasOwnProperty.call(message, "betweenFilter"))
                                $root.google.analytics.admin.v1beta.AccessBetweenFilter.encode(message.betweenFilter, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessFilter} message AccessFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessFilter} AccessFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2: {
                                        message.stringFilter = $root.google.analytics.admin.v1beta.AccessStringFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.inListFilter = $root.google.analytics.admin.v1beta.AccessInListFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.numericFilter = $root.google.analytics.admin.v1beta.AccessNumericFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.betweenFilter = $root.google.analytics.admin.v1beta.AccessBetweenFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.fieldName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessFilter} AccessFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessStringFilter.verify(message.stringFilter);
                                    if (error)
                                        return "stringFilter." + error;
                                }
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessInListFilter.verify(message.inListFilter);
                                    if (error)
                                        return "inListFilter." + error;
                                }
                            }
                            if (message.numericFilter != null && message.hasOwnProperty("numericFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessNumericFilter.verify(message.numericFilter);
                                    if (error)
                                        return "numericFilter." + error;
                                }
                            }
                            if (message.betweenFilter != null && message.hasOwnProperty("betweenFilter")) {
                                if (properties.oneFilter === 1)
                                    return "oneFilter: multiple values";
                                properties.oneFilter = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessBetweenFilter.verify(message.betweenFilter);
                                    if (error)
                                        return "betweenFilter." + error;
                                }
                            }
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                if (!$util.isString(message.fieldName))
                                    return "fieldName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessFilter} AccessFilter
                         */
                        AccessFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessFilter();
                            if (object.stringFilter != null) {
                                if (typeof object.stringFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilter.stringFilter: object expected");
                                message.stringFilter = $root.google.analytics.admin.v1beta.AccessStringFilter.fromObject(object.stringFilter);
                            }
                            if (object.inListFilter != null) {
                                if (typeof object.inListFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilter.inListFilter: object expected");
                                message.inListFilter = $root.google.analytics.admin.v1beta.AccessInListFilter.fromObject(object.inListFilter);
                            }
                            if (object.numericFilter != null) {
                                if (typeof object.numericFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilter.numericFilter: object expected");
                                message.numericFilter = $root.google.analytics.admin.v1beta.AccessNumericFilter.fromObject(object.numericFilter);
                            }
                            if (object.betweenFilter != null) {
                                if (typeof object.betweenFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessFilter.betweenFilter: object expected");
                                message.betweenFilter = $root.google.analytics.admin.v1beta.AccessBetweenFilter.fromObject(object.betweenFilter);
                            }
                            if (object.fieldName != null)
                                message.fieldName = String(object.fieldName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessFilter} message AccessFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.fieldName = "";
                            if (message.fieldName != null && message.hasOwnProperty("fieldName"))
                                object.fieldName = message.fieldName;
                            if (message.stringFilter != null && message.hasOwnProperty("stringFilter")) {
                                object.stringFilter = $root.google.analytics.admin.v1beta.AccessStringFilter.toObject(message.stringFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "stringFilter";
                            }
                            if (message.inListFilter != null && message.hasOwnProperty("inListFilter")) {
                                object.inListFilter = $root.google.analytics.admin.v1beta.AccessInListFilter.toObject(message.inListFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "inListFilter";
                            }
                            if (message.numericFilter != null && message.hasOwnProperty("numericFilter")) {
                                object.numericFilter = $root.google.analytics.admin.v1beta.AccessNumericFilter.toObject(message.numericFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "numericFilter";
                            }
                            if (message.betweenFilter != null && message.hasOwnProperty("betweenFilter")) {
                                object.betweenFilter = $root.google.analytics.admin.v1beta.AccessBetweenFilter.toObject(message.betweenFilter, options);
                                if (options.oneofs)
                                    object.oneFilter = "betweenFilter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessFilter";
                        };
    
                        return AccessFilter;
                    })();
    
                    v1beta.AccessStringFilter = (function() {
    
                        /**
                         * Properties of an AccessStringFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessStringFilter
                         * @property {google.analytics.admin.v1beta.AccessStringFilter.MatchType|null} [matchType] AccessStringFilter matchType
                         * @property {string|null} [value] AccessStringFilter value
                         * @property {boolean|null} [caseSensitive] AccessStringFilter caseSensitive
                         */
    
                        /**
                         * Constructs a new AccessStringFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessStringFilter.
                         * @implements IAccessStringFilter
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessStringFilter=} [properties] Properties to set
                         */
                        function AccessStringFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessStringFilter matchType.
                         * @member {google.analytics.admin.v1beta.AccessStringFilter.MatchType} matchType
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @instance
                         */
                        AccessStringFilter.prototype.matchType = 0;
    
                        /**
                         * AccessStringFilter value.
                         * @member {string} value
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @instance
                         */
                        AccessStringFilter.prototype.value = "";
    
                        /**
                         * AccessStringFilter caseSensitive.
                         * @member {boolean} caseSensitive
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @instance
                         */
                        AccessStringFilter.prototype.caseSensitive = false;
    
                        /**
                         * Creates a new AccessStringFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessStringFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessStringFilter} AccessStringFilter instance
                         */
                        AccessStringFilter.create = function create(properties) {
                            return new AccessStringFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessStringFilter message. Does not implicitly {@link google.analytics.admin.v1beta.AccessStringFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessStringFilter} message AccessStringFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessStringFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.matchType != null && Object.hasOwnProperty.call(message, "matchType"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.matchType);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.value);
                            if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.caseSensitive);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessStringFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessStringFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessStringFilter} message AccessStringFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessStringFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessStringFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessStringFilter} AccessStringFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessStringFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessStringFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.matchType = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.value = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.caseSensitive = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessStringFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessStringFilter} AccessStringFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessStringFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessStringFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessStringFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                switch (message.matchType) {
                                default:
                                    return "matchType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value"))
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                if (typeof message.caseSensitive !== "boolean")
                                    return "caseSensitive: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessStringFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessStringFilter} AccessStringFilter
                         */
                        AccessStringFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessStringFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessStringFilter();
                            switch (object.matchType) {
                            default:
                                if (typeof object.matchType === "number") {
                                    message.matchType = object.matchType;
                                    break;
                                }
                                break;
                            case "MATCH_TYPE_UNSPECIFIED":
                            case 0:
                                message.matchType = 0;
                                break;
                            case "EXACT":
                            case 1:
                                message.matchType = 1;
                                break;
                            case "BEGINS_WITH":
                            case 2:
                                message.matchType = 2;
                                break;
                            case "ENDS_WITH":
                            case 3:
                                message.matchType = 3;
                                break;
                            case "CONTAINS":
                            case 4:
                                message.matchType = 4;
                                break;
                            case "FULL_REGEXP":
                            case 5:
                                message.matchType = 5;
                                break;
                            case "PARTIAL_REGEXP":
                            case 6:
                                message.matchType = 6;
                                break;
                            }
                            if (object.value != null)
                                message.value = String(object.value);
                            if (object.caseSensitive != null)
                                message.caseSensitive = Boolean(object.caseSensitive);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessStringFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessStringFilter} message AccessStringFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessStringFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.matchType = options.enums === String ? "MATCH_TYPE_UNSPECIFIED" : 0;
                                object.value = "";
                                object.caseSensitive = false;
                            }
                            if (message.matchType != null && message.hasOwnProperty("matchType"))
                                object.matchType = options.enums === String ? $root.google.analytics.admin.v1beta.AccessStringFilter.MatchType[message.matchType] === undefined ? message.matchType : $root.google.analytics.admin.v1beta.AccessStringFilter.MatchType[message.matchType] : message.matchType;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = message.value;
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                object.caseSensitive = message.caseSensitive;
                            return object;
                        };
    
                        /**
                         * Converts this AccessStringFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessStringFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessStringFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessStringFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessStringFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessStringFilter";
                        };
    
                        /**
                         * MatchType enum.
                         * @name google.analytics.admin.v1beta.AccessStringFilter.MatchType
                         * @enum {number}
                         * @property {number} MATCH_TYPE_UNSPECIFIED=0 MATCH_TYPE_UNSPECIFIED value
                         * @property {number} EXACT=1 EXACT value
                         * @property {number} BEGINS_WITH=2 BEGINS_WITH value
                         * @property {number} ENDS_WITH=3 ENDS_WITH value
                         * @property {number} CONTAINS=4 CONTAINS value
                         * @property {number} FULL_REGEXP=5 FULL_REGEXP value
                         * @property {number} PARTIAL_REGEXP=6 PARTIAL_REGEXP value
                         */
                        AccessStringFilter.MatchType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "MATCH_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EXACT"] = 1;
                            values[valuesById[2] = "BEGINS_WITH"] = 2;
                            values[valuesById[3] = "ENDS_WITH"] = 3;
                            values[valuesById[4] = "CONTAINS"] = 4;
                            values[valuesById[5] = "FULL_REGEXP"] = 5;
                            values[valuesById[6] = "PARTIAL_REGEXP"] = 6;
                            return values;
                        })();
    
                        return AccessStringFilter;
                    })();
    
                    v1beta.AccessInListFilter = (function() {
    
                        /**
                         * Properties of an AccessInListFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessInListFilter
                         * @property {Array.<string>|null} [values] AccessInListFilter values
                         * @property {boolean|null} [caseSensitive] AccessInListFilter caseSensitive
                         */
    
                        /**
                         * Constructs a new AccessInListFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessInListFilter.
                         * @implements IAccessInListFilter
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessInListFilter=} [properties] Properties to set
                         */
                        function AccessInListFilter(properties) {
                            this.values = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessInListFilter values.
                         * @member {Array.<string>} values
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @instance
                         */
                        AccessInListFilter.prototype.values = $util.emptyArray;
    
                        /**
                         * AccessInListFilter caseSensitive.
                         * @member {boolean} caseSensitive
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @instance
                         */
                        AccessInListFilter.prototype.caseSensitive = false;
    
                        /**
                         * Creates a new AccessInListFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessInListFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessInListFilter} AccessInListFilter instance
                         */
                        AccessInListFilter.create = function create(properties) {
                            return new AccessInListFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessInListFilter message. Does not implicitly {@link google.analytics.admin.v1beta.AccessInListFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessInListFilter} message AccessInListFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessInListFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.values != null && message.values.length)
                                for (var i = 0; i < message.values.length; ++i)
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.values[i]);
                            if (message.caseSensitive != null && Object.hasOwnProperty.call(message, "caseSensitive"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.caseSensitive);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessInListFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessInListFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessInListFilter} message AccessInListFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessInListFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessInListFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessInListFilter} AccessInListFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessInListFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessInListFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.values && message.values.length))
                                            message.values = [];
                                        message.values.push(reader.string());
                                        break;
                                    }
                                case 2: {
                                        message.caseSensitive = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessInListFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessInListFilter} AccessInListFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessInListFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessInListFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessInListFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.values != null && message.hasOwnProperty("values")) {
                                if (!Array.isArray(message.values))
                                    return "values: array expected";
                                for (var i = 0; i < message.values.length; ++i)
                                    if (!$util.isString(message.values[i]))
                                        return "values: string[] expected";
                            }
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                if (typeof message.caseSensitive !== "boolean")
                                    return "caseSensitive: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessInListFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessInListFilter} AccessInListFilter
                         */
                        AccessInListFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessInListFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessInListFilter();
                            if (object.values) {
                                if (!Array.isArray(object.values))
                                    throw TypeError(".google.analytics.admin.v1beta.AccessInListFilter.values: array expected");
                                message.values = [];
                                for (var i = 0; i < object.values.length; ++i)
                                    message.values[i] = String(object.values[i]);
                            }
                            if (object.caseSensitive != null)
                                message.caseSensitive = Boolean(object.caseSensitive);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessInListFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessInListFilter} message AccessInListFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessInListFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.values = [];
                            if (options.defaults)
                                object.caseSensitive = false;
                            if (message.values && message.values.length) {
                                object.values = [];
                                for (var j = 0; j < message.values.length; ++j)
                                    object.values[j] = message.values[j];
                            }
                            if (message.caseSensitive != null && message.hasOwnProperty("caseSensitive"))
                                object.caseSensitive = message.caseSensitive;
                            return object;
                        };
    
                        /**
                         * Converts this AccessInListFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessInListFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessInListFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessInListFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessInListFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessInListFilter";
                        };
    
                        return AccessInListFilter;
                    })();
    
                    v1beta.AccessNumericFilter = (function() {
    
                        /**
                         * Properties of an AccessNumericFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessNumericFilter
                         * @property {google.analytics.admin.v1beta.AccessNumericFilter.Operation|null} [operation] AccessNumericFilter operation
                         * @property {google.analytics.admin.v1beta.INumericValue|null} [value] AccessNumericFilter value
                         */
    
                        /**
                         * Constructs a new AccessNumericFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessNumericFilter.
                         * @implements IAccessNumericFilter
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessNumericFilter=} [properties] Properties to set
                         */
                        function AccessNumericFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessNumericFilter operation.
                         * @member {google.analytics.admin.v1beta.AccessNumericFilter.Operation} operation
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @instance
                         */
                        AccessNumericFilter.prototype.operation = 0;
    
                        /**
                         * AccessNumericFilter value.
                         * @member {google.analytics.admin.v1beta.INumericValue|null|undefined} value
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @instance
                         */
                        AccessNumericFilter.prototype.value = null;
    
                        /**
                         * Creates a new AccessNumericFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessNumericFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessNumericFilter} AccessNumericFilter instance
                         */
                        AccessNumericFilter.create = function create(properties) {
                            return new AccessNumericFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessNumericFilter message. Does not implicitly {@link google.analytics.admin.v1beta.AccessNumericFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessNumericFilter} message AccessNumericFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessNumericFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.operation);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                $root.google.analytics.admin.v1beta.NumericValue.encode(message.value, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessNumericFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessNumericFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessNumericFilter} message AccessNumericFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessNumericFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessNumericFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessNumericFilter} AccessNumericFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessNumericFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessNumericFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.operation = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.value = $root.google.analytics.admin.v1beta.NumericValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessNumericFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessNumericFilter} AccessNumericFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessNumericFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessNumericFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessNumericFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                switch (message.operation) {
                                default:
                                    return "operation: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                    break;
                                }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                var error = $root.google.analytics.admin.v1beta.NumericValue.verify(message.value);
                                if (error)
                                    return "value." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessNumericFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessNumericFilter} AccessNumericFilter
                         */
                        AccessNumericFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessNumericFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessNumericFilter();
                            switch (object.operation) {
                            default:
                                if (typeof object.operation === "number") {
                                    message.operation = object.operation;
                                    break;
                                }
                                break;
                            case "OPERATION_UNSPECIFIED":
                            case 0:
                                message.operation = 0;
                                break;
                            case "EQUAL":
                            case 1:
                                message.operation = 1;
                                break;
                            case "LESS_THAN":
                            case 2:
                                message.operation = 2;
                                break;
                            case "LESS_THAN_OR_EQUAL":
                            case 3:
                                message.operation = 3;
                                break;
                            case "GREATER_THAN":
                            case 4:
                                message.operation = 4;
                                break;
                            case "GREATER_THAN_OR_EQUAL":
                            case 5:
                                message.operation = 5;
                                break;
                            }
                            if (object.value != null) {
                                if (typeof object.value !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessNumericFilter.value: object expected");
                                message.value = $root.google.analytics.admin.v1beta.NumericValue.fromObject(object.value);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessNumericFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessNumericFilter} message AccessNumericFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessNumericFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = options.enums === String ? "OPERATION_UNSPECIFIED" : 0;
                                object.value = null;
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = options.enums === String ? $root.google.analytics.admin.v1beta.AccessNumericFilter.Operation[message.operation] === undefined ? message.operation : $root.google.analytics.admin.v1beta.AccessNumericFilter.Operation[message.operation] : message.operation;
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = $root.google.analytics.admin.v1beta.NumericValue.toObject(message.value, options);
                            return object;
                        };
    
                        /**
                         * Converts this AccessNumericFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessNumericFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessNumericFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessNumericFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessNumericFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessNumericFilter";
                        };
    
                        /**
                         * Operation enum.
                         * @name google.analytics.admin.v1beta.AccessNumericFilter.Operation
                         * @enum {number}
                         * @property {number} OPERATION_UNSPECIFIED=0 OPERATION_UNSPECIFIED value
                         * @property {number} EQUAL=1 EQUAL value
                         * @property {number} LESS_THAN=2 LESS_THAN value
                         * @property {number} LESS_THAN_OR_EQUAL=3 LESS_THAN_OR_EQUAL value
                         * @property {number} GREATER_THAN=4 GREATER_THAN value
                         * @property {number} GREATER_THAN_OR_EQUAL=5 GREATER_THAN_OR_EQUAL value
                         */
                        AccessNumericFilter.Operation = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "OPERATION_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EQUAL"] = 1;
                            values[valuesById[2] = "LESS_THAN"] = 2;
                            values[valuesById[3] = "LESS_THAN_OR_EQUAL"] = 3;
                            values[valuesById[4] = "GREATER_THAN"] = 4;
                            values[valuesById[5] = "GREATER_THAN_OR_EQUAL"] = 5;
                            return values;
                        })();
    
                        return AccessNumericFilter;
                    })();
    
                    v1beta.AccessBetweenFilter = (function() {
    
                        /**
                         * Properties of an AccessBetweenFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessBetweenFilter
                         * @property {google.analytics.admin.v1beta.INumericValue|null} [fromValue] AccessBetweenFilter fromValue
                         * @property {google.analytics.admin.v1beta.INumericValue|null} [toValue] AccessBetweenFilter toValue
                         */
    
                        /**
                         * Constructs a new AccessBetweenFilter.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessBetweenFilter.
                         * @implements IAccessBetweenFilter
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessBetweenFilter=} [properties] Properties to set
                         */
                        function AccessBetweenFilter(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessBetweenFilter fromValue.
                         * @member {google.analytics.admin.v1beta.INumericValue|null|undefined} fromValue
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @instance
                         */
                        AccessBetweenFilter.prototype.fromValue = null;
    
                        /**
                         * AccessBetweenFilter toValue.
                         * @member {google.analytics.admin.v1beta.INumericValue|null|undefined} toValue
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @instance
                         */
                        AccessBetweenFilter.prototype.toValue = null;
    
                        /**
                         * Creates a new AccessBetweenFilter instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessBetweenFilter=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessBetweenFilter} AccessBetweenFilter instance
                         */
                        AccessBetweenFilter.create = function create(properties) {
                            return new AccessBetweenFilter(properties);
                        };
    
                        /**
                         * Encodes the specified AccessBetweenFilter message. Does not implicitly {@link google.analytics.admin.v1beta.AccessBetweenFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessBetweenFilter} message AccessBetweenFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessBetweenFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fromValue != null && Object.hasOwnProperty.call(message, "fromValue"))
                                $root.google.analytics.admin.v1beta.NumericValue.encode(message.fromValue, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.toValue != null && Object.hasOwnProperty.call(message, "toValue"))
                                $root.google.analytics.admin.v1beta.NumericValue.encode(message.toValue, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessBetweenFilter message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessBetweenFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessBetweenFilter} message AccessBetweenFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessBetweenFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessBetweenFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessBetweenFilter} AccessBetweenFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessBetweenFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessBetweenFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.fromValue = $root.google.analytics.admin.v1beta.NumericValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.toValue = $root.google.analytics.admin.v1beta.NumericValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessBetweenFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessBetweenFilter} AccessBetweenFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessBetweenFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessBetweenFilter message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessBetweenFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.fromValue != null && message.hasOwnProperty("fromValue")) {
                                var error = $root.google.analytics.admin.v1beta.NumericValue.verify(message.fromValue);
                                if (error)
                                    return "fromValue." + error;
                            }
                            if (message.toValue != null && message.hasOwnProperty("toValue")) {
                                var error = $root.google.analytics.admin.v1beta.NumericValue.verify(message.toValue);
                                if (error)
                                    return "toValue." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessBetweenFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessBetweenFilter} AccessBetweenFilter
                         */
                        AccessBetweenFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessBetweenFilter)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessBetweenFilter();
                            if (object.fromValue != null) {
                                if (typeof object.fromValue !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessBetweenFilter.fromValue: object expected");
                                message.fromValue = $root.google.analytics.admin.v1beta.NumericValue.fromObject(object.fromValue);
                            }
                            if (object.toValue != null) {
                                if (typeof object.toValue !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessBetweenFilter.toValue: object expected");
                                message.toValue = $root.google.analytics.admin.v1beta.NumericValue.fromObject(object.toValue);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessBetweenFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessBetweenFilter} message AccessBetweenFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessBetweenFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.fromValue = null;
                                object.toValue = null;
                            }
                            if (message.fromValue != null && message.hasOwnProperty("fromValue"))
                                object.fromValue = $root.google.analytics.admin.v1beta.NumericValue.toObject(message.fromValue, options);
                            if (message.toValue != null && message.hasOwnProperty("toValue"))
                                object.toValue = $root.google.analytics.admin.v1beta.NumericValue.toObject(message.toValue, options);
                            return object;
                        };
    
                        /**
                         * Converts this AccessBetweenFilter to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessBetweenFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessBetweenFilter
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessBetweenFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessBetweenFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessBetweenFilter";
                        };
    
                        return AccessBetweenFilter;
                    })();
    
                    v1beta.NumericValue = (function() {
    
                        /**
                         * Properties of a NumericValue.
                         * @memberof google.analytics.admin.v1beta
                         * @interface INumericValue
                         * @property {number|Long|null} [int64Value] NumericValue int64Value
                         * @property {number|null} [doubleValue] NumericValue doubleValue
                         */
    
                        /**
                         * Constructs a new NumericValue.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a NumericValue.
                         * @implements INumericValue
                         * @constructor
                         * @param {google.analytics.admin.v1beta.INumericValue=} [properties] Properties to set
                         */
                        function NumericValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NumericValue int64Value.
                         * @member {number|Long|null|undefined} int64Value
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @instance
                         */
                        NumericValue.prototype.int64Value = null;
    
                        /**
                         * NumericValue doubleValue.
                         * @member {number|null|undefined} doubleValue
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @instance
                         */
                        NumericValue.prototype.doubleValue = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NumericValue oneValue.
                         * @member {"int64Value"|"doubleValue"|undefined} oneValue
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @instance
                         */
                        Object.defineProperty(NumericValue.prototype, "oneValue", {
                            get: $util.oneOfGetter($oneOfFields = ["int64Value", "doubleValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NumericValue instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1beta.INumericValue=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.NumericValue} NumericValue instance
                         */
                        NumericValue.create = function create(properties) {
                            return new NumericValue(properties);
                        };
    
                        /**
                         * Encodes the specified NumericValue message. Does not implicitly {@link google.analytics.admin.v1beta.NumericValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1beta.INumericValue} message NumericValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NumericValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.int64Value != null && Object.hasOwnProperty.call(message, "int64Value"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.int64Value);
                            if (message.doubleValue != null && Object.hasOwnProperty.call(message, "doubleValue"))
                                writer.uint32(/* id 2, wireType 1 =*/17).double(message.doubleValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NumericValue message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.NumericValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1beta.INumericValue} message NumericValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NumericValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NumericValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.NumericValue} NumericValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NumericValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.NumericValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.int64Value = reader.int64();
                                        break;
                                    }
                                case 2: {
                                        message.doubleValue = reader.double();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NumericValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.NumericValue} NumericValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NumericValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NumericValue message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NumericValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                properties.oneValue = 1;
                                if (!$util.isInteger(message.int64Value) && !(message.int64Value && $util.isInteger(message.int64Value.low) && $util.isInteger(message.int64Value.high)))
                                    return "int64Value: integer|Long expected";
                            }
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                if (properties.oneValue === 1)
                                    return "oneValue: multiple values";
                                properties.oneValue = 1;
                                if (typeof message.doubleValue !== "number")
                                    return "doubleValue: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NumericValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.NumericValue} NumericValue
                         */
                        NumericValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.NumericValue)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.NumericValue();
                            if (object.int64Value != null)
                                if ($util.Long)
                                    (message.int64Value = $util.Long.fromValue(object.int64Value)).unsigned = false;
                                else if (typeof object.int64Value === "string")
                                    message.int64Value = parseInt(object.int64Value, 10);
                                else if (typeof object.int64Value === "number")
                                    message.int64Value = object.int64Value;
                                else if (typeof object.int64Value === "object")
                                    message.int64Value = new $util.LongBits(object.int64Value.low >>> 0, object.int64Value.high >>> 0).toNumber();
                            if (object.doubleValue != null)
                                message.doubleValue = Number(object.doubleValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NumericValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {google.analytics.admin.v1beta.NumericValue} message NumericValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NumericValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.int64Value != null && message.hasOwnProperty("int64Value")) {
                                if (typeof message.int64Value === "number")
                                    object.int64Value = options.longs === String ? String(message.int64Value) : message.int64Value;
                                else
                                    object.int64Value = options.longs === String ? $util.Long.prototype.toString.call(message.int64Value) : options.longs === Number ? new $util.LongBits(message.int64Value.low >>> 0, message.int64Value.high >>> 0).toNumber() : message.int64Value;
                                if (options.oneofs)
                                    object.oneValue = "int64Value";
                            }
                            if (message.doubleValue != null && message.hasOwnProperty("doubleValue")) {
                                object.doubleValue = options.json && !isFinite(message.doubleValue) ? String(message.doubleValue) : message.doubleValue;
                                if (options.oneofs)
                                    object.oneValue = "doubleValue";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NumericValue to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NumericValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NumericValue
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.NumericValue
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NumericValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.NumericValue";
                        };
    
                        return NumericValue;
                    })();
    
                    v1beta.AccessOrderBy = (function() {
    
                        /**
                         * Properties of an AccessOrderBy.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessOrderBy
                         * @property {google.analytics.admin.v1beta.AccessOrderBy.IMetricOrderBy|null} [metric] AccessOrderBy metric
                         * @property {google.analytics.admin.v1beta.AccessOrderBy.IDimensionOrderBy|null} [dimension] AccessOrderBy dimension
                         * @property {boolean|null} [desc] AccessOrderBy desc
                         */
    
                        /**
                         * Constructs a new AccessOrderBy.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessOrderBy.
                         * @implements IAccessOrderBy
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessOrderBy=} [properties] Properties to set
                         */
                        function AccessOrderBy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessOrderBy metric.
                         * @member {google.analytics.admin.v1beta.AccessOrderBy.IMetricOrderBy|null|undefined} metric
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @instance
                         */
                        AccessOrderBy.prototype.metric = null;
    
                        /**
                         * AccessOrderBy dimension.
                         * @member {google.analytics.admin.v1beta.AccessOrderBy.IDimensionOrderBy|null|undefined} dimension
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @instance
                         */
                        AccessOrderBy.prototype.dimension = null;
    
                        /**
                         * AccessOrderBy desc.
                         * @member {boolean} desc
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @instance
                         */
                        AccessOrderBy.prototype.desc = false;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessOrderBy oneOrderBy.
                         * @member {"metric"|"dimension"|undefined} oneOrderBy
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @instance
                         */
                        Object.defineProperty(AccessOrderBy.prototype, "oneOrderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["metric", "dimension"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessOrderBy instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessOrderBy=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessOrderBy} AccessOrderBy instance
                         */
                        AccessOrderBy.create = function create(properties) {
                            return new AccessOrderBy(properties);
                        };
    
                        /**
                         * Encodes the specified AccessOrderBy message. Does not implicitly {@link google.analytics.admin.v1beta.AccessOrderBy.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessOrderBy} message AccessOrderBy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessOrderBy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metric != null && Object.hasOwnProperty.call(message, "metric"))
                                $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy.encode(message.metric, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.dimension != null && Object.hasOwnProperty.call(message, "dimension"))
                                $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.encode(message.dimension, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.desc != null && Object.hasOwnProperty.call(message, "desc"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.desc);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessOrderBy message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessOrderBy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessOrderBy} message AccessOrderBy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessOrderBy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessOrderBy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessOrderBy} AccessOrderBy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessOrderBy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessOrderBy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.metric = $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.dimension = $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.desc = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessOrderBy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessOrderBy} AccessOrderBy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessOrderBy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessOrderBy message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessOrderBy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                properties.oneOrderBy = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy.verify(message.metric);
                                    if (error)
                                        return "metric." + error;
                                }
                            }
                            if (message.dimension != null && message.hasOwnProperty("dimension")) {
                                if (properties.oneOrderBy === 1)
                                    return "oneOrderBy: multiple values";
                                properties.oneOrderBy = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.verify(message.dimension);
                                    if (error)
                                        return "dimension." + error;
                                }
                            }
                            if (message.desc != null && message.hasOwnProperty("desc"))
                                if (typeof message.desc !== "boolean")
                                    return "desc: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessOrderBy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessOrderBy} AccessOrderBy
                         */
                        AccessOrderBy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessOrderBy)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessOrderBy();
                            if (object.metric != null) {
                                if (typeof object.metric !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessOrderBy.metric: object expected");
                                message.metric = $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy.fromObject(object.metric);
                            }
                            if (object.dimension != null) {
                                if (typeof object.dimension !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessOrderBy.dimension: object expected");
                                message.dimension = $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.fromObject(object.dimension);
                            }
                            if (object.desc != null)
                                message.desc = Boolean(object.desc);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessOrderBy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessOrderBy} message AccessOrderBy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessOrderBy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.desc = false;
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                object.metric = $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy.toObject(message.metric, options);
                                if (options.oneofs)
                                    object.oneOrderBy = "metric";
                            }
                            if (message.dimension != null && message.hasOwnProperty("dimension")) {
                                object.dimension = $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.toObject(message.dimension, options);
                                if (options.oneofs)
                                    object.oneOrderBy = "dimension";
                            }
                            if (message.desc != null && message.hasOwnProperty("desc"))
                                object.desc = message.desc;
                            return object;
                        };
    
                        /**
                         * Converts this AccessOrderBy to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessOrderBy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessOrderBy
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessOrderBy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessOrderBy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessOrderBy";
                        };
    
                        AccessOrderBy.MetricOrderBy = (function() {
    
                            /**
                             * Properties of a MetricOrderBy.
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy
                             * @interface IMetricOrderBy
                             * @property {string|null} [metricName] MetricOrderBy metricName
                             */
    
                            /**
                             * Constructs a new MetricOrderBy.
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy
                             * @classdesc Represents a MetricOrderBy.
                             * @implements IMetricOrderBy
                             * @constructor
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IMetricOrderBy=} [properties] Properties to set
                             */
                            function MetricOrderBy(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * MetricOrderBy metricName.
                             * @member {string} metricName
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @instance
                             */
                            MetricOrderBy.prototype.metricName = "";
    
                            /**
                             * Creates a new MetricOrderBy instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IMetricOrderBy=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy} MetricOrderBy instance
                             */
                            MetricOrderBy.create = function create(properties) {
                                return new MetricOrderBy(properties);
                            };
    
                            /**
                             * Encodes the specified MetricOrderBy message. Does not implicitly {@link google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IMetricOrderBy} message MetricOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MetricOrderBy.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.metricName != null && Object.hasOwnProperty.call(message, "metricName"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.metricName);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified MetricOrderBy message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IMetricOrderBy} message MetricOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            MetricOrderBy.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a MetricOrderBy message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy} MetricOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MetricOrderBy.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.metricName = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a MetricOrderBy message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy} MetricOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            MetricOrderBy.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a MetricOrderBy message.
                             * @function verify
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            MetricOrderBy.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.metricName != null && message.hasOwnProperty("metricName"))
                                    if (!$util.isString(message.metricName))
                                        return "metricName: string expected";
                                return null;
                            };
    
                            /**
                             * Creates a MetricOrderBy message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy} MetricOrderBy
                             */
                            MetricOrderBy.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy)
                                    return object;
                                var message = new $root.google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy();
                                if (object.metricName != null)
                                    message.metricName = String(object.metricName);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a MetricOrderBy message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy} message MetricOrderBy
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            MetricOrderBy.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults)
                                    object.metricName = "";
                                if (message.metricName != null && message.hasOwnProperty("metricName"))
                                    object.metricName = message.metricName;
                                return object;
                            };
    
                            /**
                             * Converts this MetricOrderBy to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            MetricOrderBy.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for MetricOrderBy
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            MetricOrderBy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessOrderBy.MetricOrderBy";
                            };
    
                            return MetricOrderBy;
                        })();
    
                        AccessOrderBy.DimensionOrderBy = (function() {
    
                            /**
                             * Properties of a DimensionOrderBy.
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy
                             * @interface IDimensionOrderBy
                             * @property {string|null} [dimensionName] DimensionOrderBy dimensionName
                             * @property {google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.OrderType|null} [orderType] DimensionOrderBy orderType
                             */
    
                            /**
                             * Constructs a new DimensionOrderBy.
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy
                             * @classdesc Represents a DimensionOrderBy.
                             * @implements IDimensionOrderBy
                             * @constructor
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IDimensionOrderBy=} [properties] Properties to set
                             */
                            function DimensionOrderBy(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * DimensionOrderBy dimensionName.
                             * @member {string} dimensionName
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @instance
                             */
                            DimensionOrderBy.prototype.dimensionName = "";
    
                            /**
                             * DimensionOrderBy orderType.
                             * @member {google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.OrderType} orderType
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @instance
                             */
                            DimensionOrderBy.prototype.orderType = 0;
    
                            /**
                             * Creates a new DimensionOrderBy instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IDimensionOrderBy=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy} DimensionOrderBy instance
                             */
                            DimensionOrderBy.create = function create(properties) {
                                return new DimensionOrderBy(properties);
                            };
    
                            /**
                             * Encodes the specified DimensionOrderBy message. Does not implicitly {@link google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IDimensionOrderBy} message DimensionOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DimensionOrderBy.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.dimensionName != null && Object.hasOwnProperty.call(message, "dimensionName"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.dimensionName);
                                if (message.orderType != null && Object.hasOwnProperty.call(message, "orderType"))
                                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.orderType);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified DimensionOrderBy message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.IDimensionOrderBy} message DimensionOrderBy message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            DimensionOrderBy.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a DimensionOrderBy message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy} DimensionOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DimensionOrderBy.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.dimensionName = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.orderType = reader.int32();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a DimensionOrderBy message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy} DimensionOrderBy
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            DimensionOrderBy.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a DimensionOrderBy message.
                             * @function verify
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            DimensionOrderBy.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                    if (!$util.isString(message.dimensionName))
                                        return "dimensionName: string expected";
                                if (message.orderType != null && message.hasOwnProperty("orderType"))
                                    switch (message.orderType) {
                                    default:
                                        return "orderType: enum value expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                                return null;
                            };
    
                            /**
                             * Creates a DimensionOrderBy message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy} DimensionOrderBy
                             */
                            DimensionOrderBy.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy)
                                    return object;
                                var message = new $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy();
                                if (object.dimensionName != null)
                                    message.dimensionName = String(object.dimensionName);
                                switch (object.orderType) {
                                default:
                                    if (typeof object.orderType === "number") {
                                        message.orderType = object.orderType;
                                        break;
                                    }
                                    break;
                                case "ORDER_TYPE_UNSPECIFIED":
                                case 0:
                                    message.orderType = 0;
                                    break;
                                case "ALPHANUMERIC":
                                case 1:
                                    message.orderType = 1;
                                    break;
                                case "CASE_INSENSITIVE_ALPHANUMERIC":
                                case 2:
                                    message.orderType = 2;
                                    break;
                                case "NUMERIC":
                                case 3:
                                    message.orderType = 3;
                                    break;
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a DimensionOrderBy message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy} message DimensionOrderBy
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            DimensionOrderBy.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.dimensionName = "";
                                    object.orderType = options.enums === String ? "ORDER_TYPE_UNSPECIFIED" : 0;
                                }
                                if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                    object.dimensionName = message.dimensionName;
                                if (message.orderType != null && message.hasOwnProperty("orderType"))
                                    object.orderType = options.enums === String ? $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.OrderType[message.orderType] === undefined ? message.orderType : $root.google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.OrderType[message.orderType] : message.orderType;
                                return object;
                            };
    
                            /**
                             * Converts this DimensionOrderBy to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            DimensionOrderBy.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for DimensionOrderBy
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            DimensionOrderBy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy";
                            };
    
                            /**
                             * OrderType enum.
                             * @name google.analytics.admin.v1beta.AccessOrderBy.DimensionOrderBy.OrderType
                             * @enum {number}
                             * @property {number} ORDER_TYPE_UNSPECIFIED=0 ORDER_TYPE_UNSPECIFIED value
                             * @property {number} ALPHANUMERIC=1 ALPHANUMERIC value
                             * @property {number} CASE_INSENSITIVE_ALPHANUMERIC=2 CASE_INSENSITIVE_ALPHANUMERIC value
                             * @property {number} NUMERIC=3 NUMERIC value
                             */
                            DimensionOrderBy.OrderType = (function() {
                                var valuesById = {}, values = Object.create(valuesById);
                                values[valuesById[0] = "ORDER_TYPE_UNSPECIFIED"] = 0;
                                values[valuesById[1] = "ALPHANUMERIC"] = 1;
                                values[valuesById[2] = "CASE_INSENSITIVE_ALPHANUMERIC"] = 2;
                                values[valuesById[3] = "NUMERIC"] = 3;
                                return values;
                            })();
    
                            return DimensionOrderBy;
                        })();
    
                        return AccessOrderBy;
                    })();
    
                    v1beta.AccessDimensionHeader = (function() {
    
                        /**
                         * Properties of an AccessDimensionHeader.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessDimensionHeader
                         * @property {string|null} [dimensionName] AccessDimensionHeader dimensionName
                         */
    
                        /**
                         * Constructs a new AccessDimensionHeader.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessDimensionHeader.
                         * @implements IAccessDimensionHeader
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessDimensionHeader=} [properties] Properties to set
                         */
                        function AccessDimensionHeader(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDimensionHeader dimensionName.
                         * @member {string} dimensionName
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @instance
                         */
                        AccessDimensionHeader.prototype.dimensionName = "";
    
                        /**
                         * Creates a new AccessDimensionHeader instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimensionHeader=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessDimensionHeader} AccessDimensionHeader instance
                         */
                        AccessDimensionHeader.create = function create(properties) {
                            return new AccessDimensionHeader(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDimensionHeader message. Does not implicitly {@link google.analytics.admin.v1beta.AccessDimensionHeader.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimensionHeader} message AccessDimensionHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionHeader.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionName != null && Object.hasOwnProperty.call(message, "dimensionName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.dimensionName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDimensionHeader message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessDimensionHeader.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimensionHeader} message AccessDimensionHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionHeader.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDimensionHeader message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessDimensionHeader} AccessDimensionHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionHeader.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessDimensionHeader();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dimensionName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDimensionHeader message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessDimensionHeader} AccessDimensionHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionHeader.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDimensionHeader message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDimensionHeader.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                if (!$util.isString(message.dimensionName))
                                    return "dimensionName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDimensionHeader message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessDimensionHeader} AccessDimensionHeader
                         */
                        AccessDimensionHeader.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessDimensionHeader)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessDimensionHeader();
                            if (object.dimensionName != null)
                                message.dimensionName = String(object.dimensionName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDimensionHeader message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessDimensionHeader} message AccessDimensionHeader
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDimensionHeader.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.dimensionName = "";
                            if (message.dimensionName != null && message.hasOwnProperty("dimensionName"))
                                object.dimensionName = message.dimensionName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDimensionHeader to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDimensionHeader.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDimensionHeader
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessDimensionHeader
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDimensionHeader.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessDimensionHeader";
                        };
    
                        return AccessDimensionHeader;
                    })();
    
                    v1beta.AccessMetricHeader = (function() {
    
                        /**
                         * Properties of an AccessMetricHeader.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessMetricHeader
                         * @property {string|null} [metricName] AccessMetricHeader metricName
                         */
    
                        /**
                         * Constructs a new AccessMetricHeader.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessMetricHeader.
                         * @implements IAccessMetricHeader
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessMetricHeader=} [properties] Properties to set
                         */
                        function AccessMetricHeader(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessMetricHeader metricName.
                         * @member {string} metricName
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @instance
                         */
                        AccessMetricHeader.prototype.metricName = "";
    
                        /**
                         * Creates a new AccessMetricHeader instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetricHeader=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessMetricHeader} AccessMetricHeader instance
                         */
                        AccessMetricHeader.create = function create(properties) {
                            return new AccessMetricHeader(properties);
                        };
    
                        /**
                         * Encodes the specified AccessMetricHeader message. Does not implicitly {@link google.analytics.admin.v1beta.AccessMetricHeader.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetricHeader} message AccessMetricHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricHeader.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metricName != null && Object.hasOwnProperty.call(message, "metricName"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.metricName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessMetricHeader message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessMetricHeader.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetricHeader} message AccessMetricHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricHeader.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessMetricHeader message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessMetricHeader} AccessMetricHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricHeader.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessMetricHeader();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.metricName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessMetricHeader message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessMetricHeader} AccessMetricHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricHeader.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessMetricHeader message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessMetricHeader.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                if (!$util.isString(message.metricName))
                                    return "metricName: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessMetricHeader message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessMetricHeader} AccessMetricHeader
                         */
                        AccessMetricHeader.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessMetricHeader)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessMetricHeader();
                            if (object.metricName != null)
                                message.metricName = String(object.metricName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessMetricHeader message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessMetricHeader} message AccessMetricHeader
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessMetricHeader.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.metricName = "";
                            if (message.metricName != null && message.hasOwnProperty("metricName"))
                                object.metricName = message.metricName;
                            return object;
                        };
    
                        /**
                         * Converts this AccessMetricHeader to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessMetricHeader.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessMetricHeader
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessMetricHeader
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessMetricHeader.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessMetricHeader";
                        };
    
                        return AccessMetricHeader;
                    })();
    
                    v1beta.AccessRow = (function() {
    
                        /**
                         * Properties of an AccessRow.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessRow
                         * @property {Array.<google.analytics.admin.v1beta.IAccessDimensionValue>|null} [dimensionValues] AccessRow dimensionValues
                         * @property {Array.<google.analytics.admin.v1beta.IAccessMetricValue>|null} [metricValues] AccessRow metricValues
                         */
    
                        /**
                         * Constructs a new AccessRow.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessRow.
                         * @implements IAccessRow
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessRow=} [properties] Properties to set
                         */
                        function AccessRow(properties) {
                            this.dimensionValues = [];
                            this.metricValues = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessRow dimensionValues.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessDimensionValue>} dimensionValues
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @instance
                         */
                        AccessRow.prototype.dimensionValues = $util.emptyArray;
    
                        /**
                         * AccessRow metricValues.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessMetricValue>} metricValues
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @instance
                         */
                        AccessRow.prototype.metricValues = $util.emptyArray;
    
                        /**
                         * Creates a new AccessRow instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessRow=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessRow} AccessRow instance
                         */
                        AccessRow.create = function create(properties) {
                            return new AccessRow(properties);
                        };
    
                        /**
                         * Encodes the specified AccessRow message. Does not implicitly {@link google.analytics.admin.v1beta.AccessRow.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessRow} message AccessRow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessRow.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionValues != null && message.dimensionValues.length)
                                for (var i = 0; i < message.dimensionValues.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessDimensionValue.encode(message.dimensionValues[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.metricValues != null && message.metricValues.length)
                                for (var i = 0; i < message.metricValues.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessMetricValue.encode(message.metricValues[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessRow message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessRow.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessRow} message AccessRow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessRow.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessRow message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessRow} AccessRow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessRow.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessRow();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.dimensionValues && message.dimensionValues.length))
                                            message.dimensionValues = [];
                                        message.dimensionValues.push($root.google.analytics.admin.v1beta.AccessDimensionValue.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        if (!(message.metricValues && message.metricValues.length))
                                            message.metricValues = [];
                                        message.metricValues.push($root.google.analytics.admin.v1beta.AccessMetricValue.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessRow message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessRow} AccessRow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessRow.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessRow message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessRow.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionValues != null && message.hasOwnProperty("dimensionValues")) {
                                if (!Array.isArray(message.dimensionValues))
                                    return "dimensionValues: array expected";
                                for (var i = 0; i < message.dimensionValues.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessDimensionValue.verify(message.dimensionValues[i]);
                                    if (error)
                                        return "dimensionValues." + error;
                                }
                            }
                            if (message.metricValues != null && message.hasOwnProperty("metricValues")) {
                                if (!Array.isArray(message.metricValues))
                                    return "metricValues: array expected";
                                for (var i = 0; i < message.metricValues.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessMetricValue.verify(message.metricValues[i]);
                                    if (error)
                                        return "metricValues." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessRow message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessRow} AccessRow
                         */
                        AccessRow.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessRow)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessRow();
                            if (object.dimensionValues) {
                                if (!Array.isArray(object.dimensionValues))
                                    throw TypeError(".google.analytics.admin.v1beta.AccessRow.dimensionValues: array expected");
                                message.dimensionValues = [];
                                for (var i = 0; i < object.dimensionValues.length; ++i) {
                                    if (typeof object.dimensionValues[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.AccessRow.dimensionValues: object expected");
                                    message.dimensionValues[i] = $root.google.analytics.admin.v1beta.AccessDimensionValue.fromObject(object.dimensionValues[i]);
                                }
                            }
                            if (object.metricValues) {
                                if (!Array.isArray(object.metricValues))
                                    throw TypeError(".google.analytics.admin.v1beta.AccessRow.metricValues: array expected");
                                message.metricValues = [];
                                for (var i = 0; i < object.metricValues.length; ++i) {
                                    if (typeof object.metricValues[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.AccessRow.metricValues: object expected");
                                    message.metricValues[i] = $root.google.analytics.admin.v1beta.AccessMetricValue.fromObject(object.metricValues[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessRow message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessRow} message AccessRow
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessRow.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dimensionValues = [];
                                object.metricValues = [];
                            }
                            if (message.dimensionValues && message.dimensionValues.length) {
                                object.dimensionValues = [];
                                for (var j = 0; j < message.dimensionValues.length; ++j)
                                    object.dimensionValues[j] = $root.google.analytics.admin.v1beta.AccessDimensionValue.toObject(message.dimensionValues[j], options);
                            }
                            if (message.metricValues && message.metricValues.length) {
                                object.metricValues = [];
                                for (var j = 0; j < message.metricValues.length; ++j)
                                    object.metricValues[j] = $root.google.analytics.admin.v1beta.AccessMetricValue.toObject(message.metricValues[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessRow to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessRow.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessRow
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessRow
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessRow.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessRow";
                        };
    
                        return AccessRow;
                    })();
    
                    v1beta.AccessDimensionValue = (function() {
    
                        /**
                         * Properties of an AccessDimensionValue.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessDimensionValue
                         * @property {string|null} [value] AccessDimensionValue value
                         */
    
                        /**
                         * Constructs a new AccessDimensionValue.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessDimensionValue.
                         * @implements IAccessDimensionValue
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessDimensionValue=} [properties] Properties to set
                         */
                        function AccessDimensionValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessDimensionValue value.
                         * @member {string} value
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @instance
                         */
                        AccessDimensionValue.prototype.value = "";
    
                        /**
                         * Creates a new AccessDimensionValue instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimensionValue=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessDimensionValue} AccessDimensionValue instance
                         */
                        AccessDimensionValue.create = function create(properties) {
                            return new AccessDimensionValue(properties);
                        };
    
                        /**
                         * Encodes the specified AccessDimensionValue message. Does not implicitly {@link google.analytics.admin.v1beta.AccessDimensionValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimensionValue} message AccessDimensionValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessDimensionValue message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessDimensionValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessDimensionValue} message AccessDimensionValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessDimensionValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessDimensionValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessDimensionValue} AccessDimensionValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessDimensionValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessDimensionValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessDimensionValue} AccessDimensionValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessDimensionValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessDimensionValue message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessDimensionValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value"))
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessDimensionValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessDimensionValue} AccessDimensionValue
                         */
                        AccessDimensionValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessDimensionValue)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessDimensionValue();
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessDimensionValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessDimensionValue} message AccessDimensionValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessDimensionValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = "";
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = message.value;
                            return object;
                        };
    
                        /**
                         * Converts this AccessDimensionValue to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessDimensionValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessDimensionValue
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessDimensionValue
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessDimensionValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessDimensionValue";
                        };
    
                        return AccessDimensionValue;
                    })();
    
                    v1beta.AccessMetricValue = (function() {
    
                        /**
                         * Properties of an AccessMetricValue.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessMetricValue
                         * @property {string|null} [value] AccessMetricValue value
                         */
    
                        /**
                         * Constructs a new AccessMetricValue.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessMetricValue.
                         * @implements IAccessMetricValue
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessMetricValue=} [properties] Properties to set
                         */
                        function AccessMetricValue(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessMetricValue value.
                         * @member {string} value
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @instance
                         */
                        AccessMetricValue.prototype.value = "";
    
                        /**
                         * Creates a new AccessMetricValue instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetricValue=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessMetricValue} AccessMetricValue instance
                         */
                        AccessMetricValue.create = function create(properties) {
                            return new AccessMetricValue(properties);
                        };
    
                        /**
                         * Encodes the specified AccessMetricValue message. Does not implicitly {@link google.analytics.admin.v1beta.AccessMetricValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetricValue} message AccessMetricValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessMetricValue message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessMetricValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessMetricValue} message AccessMetricValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessMetricValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessMetricValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessMetricValue} AccessMetricValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessMetricValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessMetricValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessMetricValue} AccessMetricValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessMetricValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessMetricValue message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessMetricValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.value != null && message.hasOwnProperty("value"))
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessMetricValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessMetricValue} AccessMetricValue
                         */
                        AccessMetricValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessMetricValue)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessMetricValue();
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessMetricValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessMetricValue} message AccessMetricValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessMetricValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.value = "";
                            if (message.value != null && message.hasOwnProperty("value"))
                                object.value = message.value;
                            return object;
                        };
    
                        /**
                         * Converts this AccessMetricValue to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessMetricValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessMetricValue
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessMetricValue
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessMetricValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessMetricValue";
                        };
    
                        return AccessMetricValue;
                    })();
    
                    v1beta.AccessQuota = (function() {
    
                        /**
                         * Properties of an AccessQuota.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessQuota
                         * @property {google.analytics.admin.v1beta.IAccessQuotaStatus|null} [tokensPerDay] AccessQuota tokensPerDay
                         * @property {google.analytics.admin.v1beta.IAccessQuotaStatus|null} [tokensPerHour] AccessQuota tokensPerHour
                         * @property {google.analytics.admin.v1beta.IAccessQuotaStatus|null} [concurrentRequests] AccessQuota concurrentRequests
                         * @property {google.analytics.admin.v1beta.IAccessQuotaStatus|null} [serverErrorsPerProjectPerHour] AccessQuota serverErrorsPerProjectPerHour
                         * @property {google.analytics.admin.v1beta.IAccessQuotaStatus|null} [tokensPerProjectPerHour] AccessQuota tokensPerProjectPerHour
                         */
    
                        /**
                         * Constructs a new AccessQuota.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessQuota.
                         * @implements IAccessQuota
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessQuota=} [properties] Properties to set
                         */
                        function AccessQuota(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessQuota tokensPerDay.
                         * @member {google.analytics.admin.v1beta.IAccessQuotaStatus|null|undefined} tokensPerDay
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.tokensPerDay = null;
    
                        /**
                         * AccessQuota tokensPerHour.
                         * @member {google.analytics.admin.v1beta.IAccessQuotaStatus|null|undefined} tokensPerHour
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.tokensPerHour = null;
    
                        /**
                         * AccessQuota concurrentRequests.
                         * @member {google.analytics.admin.v1beta.IAccessQuotaStatus|null|undefined} concurrentRequests
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.concurrentRequests = null;
    
                        /**
                         * AccessQuota serverErrorsPerProjectPerHour.
                         * @member {google.analytics.admin.v1beta.IAccessQuotaStatus|null|undefined} serverErrorsPerProjectPerHour
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.serverErrorsPerProjectPerHour = null;
    
                        /**
                         * AccessQuota tokensPerProjectPerHour.
                         * @member {google.analytics.admin.v1beta.IAccessQuotaStatus|null|undefined} tokensPerProjectPerHour
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @instance
                         */
                        AccessQuota.prototype.tokensPerProjectPerHour = null;
    
                        /**
                         * Creates a new AccessQuota instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessQuota=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessQuota} AccessQuota instance
                         */
                        AccessQuota.create = function create(properties) {
                            return new AccessQuota(properties);
                        };
    
                        /**
                         * Encodes the specified AccessQuota message. Does not implicitly {@link google.analytics.admin.v1beta.AccessQuota.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessQuota} message AccessQuota message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuota.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tokensPerDay != null && Object.hasOwnProperty.call(message, "tokensPerDay"))
                                $root.google.analytics.admin.v1beta.AccessQuotaStatus.encode(message.tokensPerDay, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.tokensPerHour != null && Object.hasOwnProperty.call(message, "tokensPerHour"))
                                $root.google.analytics.admin.v1beta.AccessQuotaStatus.encode(message.tokensPerHour, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.concurrentRequests != null && Object.hasOwnProperty.call(message, "concurrentRequests"))
                                $root.google.analytics.admin.v1beta.AccessQuotaStatus.encode(message.concurrentRequests, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.serverErrorsPerProjectPerHour != null && Object.hasOwnProperty.call(message, "serverErrorsPerProjectPerHour"))
                                $root.google.analytics.admin.v1beta.AccessQuotaStatus.encode(message.serverErrorsPerProjectPerHour, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.tokensPerProjectPerHour != null && Object.hasOwnProperty.call(message, "tokensPerProjectPerHour"))
                                $root.google.analytics.admin.v1beta.AccessQuotaStatus.encode(message.tokensPerProjectPerHour, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessQuota message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessQuota.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessQuota} message AccessQuota message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuota.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessQuota message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessQuota} AccessQuota
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuota.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessQuota();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.tokensPerDay = $root.google.analytics.admin.v1beta.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.tokensPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.concurrentRequests = $root.google.analytics.admin.v1beta.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.serverErrorsPerProjectPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.tokensPerProjectPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessQuota message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessQuota} AccessQuota
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuota.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessQuota message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessQuota.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.tokensPerDay != null && message.hasOwnProperty("tokensPerDay")) {
                                var error = $root.google.analytics.admin.v1beta.AccessQuotaStatus.verify(message.tokensPerDay);
                                if (error)
                                    return "tokensPerDay." + error;
                            }
                            if (message.tokensPerHour != null && message.hasOwnProperty("tokensPerHour")) {
                                var error = $root.google.analytics.admin.v1beta.AccessQuotaStatus.verify(message.tokensPerHour);
                                if (error)
                                    return "tokensPerHour." + error;
                            }
                            if (message.concurrentRequests != null && message.hasOwnProperty("concurrentRequests")) {
                                var error = $root.google.analytics.admin.v1beta.AccessQuotaStatus.verify(message.concurrentRequests);
                                if (error)
                                    return "concurrentRequests." + error;
                            }
                            if (message.serverErrorsPerProjectPerHour != null && message.hasOwnProperty("serverErrorsPerProjectPerHour")) {
                                var error = $root.google.analytics.admin.v1beta.AccessQuotaStatus.verify(message.serverErrorsPerProjectPerHour);
                                if (error)
                                    return "serverErrorsPerProjectPerHour." + error;
                            }
                            if (message.tokensPerProjectPerHour != null && message.hasOwnProperty("tokensPerProjectPerHour")) {
                                var error = $root.google.analytics.admin.v1beta.AccessQuotaStatus.verify(message.tokensPerProjectPerHour);
                                if (error)
                                    return "tokensPerProjectPerHour." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessQuota message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessQuota} AccessQuota
                         */
                        AccessQuota.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessQuota)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessQuota();
                            if (object.tokensPerDay != null) {
                                if (typeof object.tokensPerDay !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessQuota.tokensPerDay: object expected");
                                message.tokensPerDay = $root.google.analytics.admin.v1beta.AccessQuotaStatus.fromObject(object.tokensPerDay);
                            }
                            if (object.tokensPerHour != null) {
                                if (typeof object.tokensPerHour !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessQuota.tokensPerHour: object expected");
                                message.tokensPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.fromObject(object.tokensPerHour);
                            }
                            if (object.concurrentRequests != null) {
                                if (typeof object.concurrentRequests !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessQuota.concurrentRequests: object expected");
                                message.concurrentRequests = $root.google.analytics.admin.v1beta.AccessQuotaStatus.fromObject(object.concurrentRequests);
                            }
                            if (object.serverErrorsPerProjectPerHour != null) {
                                if (typeof object.serverErrorsPerProjectPerHour !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessQuota.serverErrorsPerProjectPerHour: object expected");
                                message.serverErrorsPerProjectPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.fromObject(object.serverErrorsPerProjectPerHour);
                            }
                            if (object.tokensPerProjectPerHour != null) {
                                if (typeof object.tokensPerProjectPerHour !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.AccessQuota.tokensPerProjectPerHour: object expected");
                                message.tokensPerProjectPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.fromObject(object.tokensPerProjectPerHour);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessQuota message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessQuota} message AccessQuota
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessQuota.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.tokensPerDay = null;
                                object.tokensPerHour = null;
                                object.concurrentRequests = null;
                                object.serverErrorsPerProjectPerHour = null;
                                object.tokensPerProjectPerHour = null;
                            }
                            if (message.tokensPerDay != null && message.hasOwnProperty("tokensPerDay"))
                                object.tokensPerDay = $root.google.analytics.admin.v1beta.AccessQuotaStatus.toObject(message.tokensPerDay, options);
                            if (message.tokensPerHour != null && message.hasOwnProperty("tokensPerHour"))
                                object.tokensPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.toObject(message.tokensPerHour, options);
                            if (message.concurrentRequests != null && message.hasOwnProperty("concurrentRequests"))
                                object.concurrentRequests = $root.google.analytics.admin.v1beta.AccessQuotaStatus.toObject(message.concurrentRequests, options);
                            if (message.serverErrorsPerProjectPerHour != null && message.hasOwnProperty("serverErrorsPerProjectPerHour"))
                                object.serverErrorsPerProjectPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.toObject(message.serverErrorsPerProjectPerHour, options);
                            if (message.tokensPerProjectPerHour != null && message.hasOwnProperty("tokensPerProjectPerHour"))
                                object.tokensPerProjectPerHour = $root.google.analytics.admin.v1beta.AccessQuotaStatus.toObject(message.tokensPerProjectPerHour, options);
                            return object;
                        };
    
                        /**
                         * Converts this AccessQuota to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessQuota.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessQuota
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessQuota
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessQuota.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessQuota";
                        };
    
                        return AccessQuota;
                    })();
    
                    v1beta.AccessQuotaStatus = (function() {
    
                        /**
                         * Properties of an AccessQuotaStatus.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccessQuotaStatus
                         * @property {number|null} [consumed] AccessQuotaStatus consumed
                         * @property {number|null} [remaining] AccessQuotaStatus remaining
                         */
    
                        /**
                         * Constructs a new AccessQuotaStatus.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccessQuotaStatus.
                         * @implements IAccessQuotaStatus
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccessQuotaStatus=} [properties] Properties to set
                         */
                        function AccessQuotaStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessQuotaStatus consumed.
                         * @member {number} consumed
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @instance
                         */
                        AccessQuotaStatus.prototype.consumed = 0;
    
                        /**
                         * AccessQuotaStatus remaining.
                         * @member {number} remaining
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @instance
                         */
                        AccessQuotaStatus.prototype.remaining = 0;
    
                        /**
                         * Creates a new AccessQuotaStatus instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessQuotaStatus=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccessQuotaStatus} AccessQuotaStatus instance
                         */
                        AccessQuotaStatus.create = function create(properties) {
                            return new AccessQuotaStatus(properties);
                        };
    
                        /**
                         * Encodes the specified AccessQuotaStatus message. Does not implicitly {@link google.analytics.admin.v1beta.AccessQuotaStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessQuotaStatus} message AccessQuotaStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuotaStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.consumed != null && Object.hasOwnProperty.call(message, "consumed"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.consumed);
                            if (message.remaining != null && Object.hasOwnProperty.call(message, "remaining"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.remaining);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessQuotaStatus message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccessQuotaStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccessQuotaStatus} message AccessQuotaStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessQuotaStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessQuotaStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccessQuotaStatus} AccessQuotaStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuotaStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccessQuotaStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.consumed = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.remaining = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessQuotaStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccessQuotaStatus} AccessQuotaStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessQuotaStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessQuotaStatus message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessQuotaStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.consumed != null && message.hasOwnProperty("consumed"))
                                if (!$util.isInteger(message.consumed))
                                    return "consumed: integer expected";
                            if (message.remaining != null && message.hasOwnProperty("remaining"))
                                if (!$util.isInteger(message.remaining))
                                    return "remaining: integer expected";
                            return null;
                        };
    
                        /**
                         * Creates an AccessQuotaStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccessQuotaStatus} AccessQuotaStatus
                         */
                        AccessQuotaStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccessQuotaStatus)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccessQuotaStatus();
                            if (object.consumed != null)
                                message.consumed = object.consumed | 0;
                            if (object.remaining != null)
                                message.remaining = object.remaining | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessQuotaStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {google.analytics.admin.v1beta.AccessQuotaStatus} message AccessQuotaStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessQuotaStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.consumed = 0;
                                object.remaining = 0;
                            }
                            if (message.consumed != null && message.hasOwnProperty("consumed"))
                                object.consumed = message.consumed;
                            if (message.remaining != null && message.hasOwnProperty("remaining"))
                                object.remaining = message.remaining;
                            return object;
                        };
    
                        /**
                         * Converts this AccessQuotaStatus to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessQuotaStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessQuotaStatus
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccessQuotaStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessQuotaStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccessQuotaStatus";
                        };
    
                        return AccessQuotaStatus;
                    })();
    
                    v1beta.AnalyticsAdminService = (function() {
    
                        /**
                         * Constructs a new AnalyticsAdminService service.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AnalyticsAdminService
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AnalyticsAdminService(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (AnalyticsAdminService.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AnalyticsAdminService;
    
                        /**
                         * Creates new AnalyticsAdminService service using the specified rpc implementation.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AnalyticsAdminService} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AnalyticsAdminService.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getAccount}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetAccountCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.Account} [response] Account
                         */
    
                        /**
                         * Calls GetAccount.
                         * @function getAccount
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetAccountRequest} request GetAccountRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetAccountCallback} callback Node-style callback called with the error, if any, and Account
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getAccount = function getAccount(request, callback) {
                            return this.rpcCall(getAccount, $root.google.analytics.admin.v1beta.GetAccountRequest, $root.google.analytics.admin.v1beta.Account, request, callback);
                        }, "name", { value: "GetAccount" });
    
                        /**
                         * Calls GetAccount.
                         * @function getAccount
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetAccountRequest} request GetAccountRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.Account>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listAccounts}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListAccountsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListAccountsResponse} [response] ListAccountsResponse
                         */
    
                        /**
                         * Calls ListAccounts.
                         * @function listAccounts
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListAccountsRequest} request ListAccountsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListAccountsCallback} callback Node-style callback called with the error, if any, and ListAccountsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listAccounts = function listAccounts(request, callback) {
                            return this.rpcCall(listAccounts, $root.google.analytics.admin.v1beta.ListAccountsRequest, $root.google.analytics.admin.v1beta.ListAccountsResponse, request, callback);
                        }, "name", { value: "ListAccounts" });
    
                        /**
                         * Calls ListAccounts.
                         * @function listAccounts
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListAccountsRequest} request ListAccountsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListAccountsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|deleteAccount}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef DeleteAccountCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteAccount.
                         * @function deleteAccount
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteAccountRequest} request DeleteAccountRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.DeleteAccountCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteAccount = function deleteAccount(request, callback) {
                            return this.rpcCall(deleteAccount, $root.google.analytics.admin.v1beta.DeleteAccountRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteAccount" });
    
                        /**
                         * Calls DeleteAccount.
                         * @function deleteAccount
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteAccountRequest} request DeleteAccountRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateAccount}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdateAccountCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.Account} [response] Account
                         */
    
                        /**
                         * Calls UpdateAccount.
                         * @function updateAccount
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateAccountRequest} request UpdateAccountRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdateAccountCallback} callback Node-style callback called with the error, if any, and Account
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateAccount = function updateAccount(request, callback) {
                            return this.rpcCall(updateAccount, $root.google.analytics.admin.v1beta.UpdateAccountRequest, $root.google.analytics.admin.v1beta.Account, request, callback);
                        }, "name", { value: "UpdateAccount" });
    
                        /**
                         * Calls UpdateAccount.
                         * @function updateAccount
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateAccountRequest} request UpdateAccountRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.Account>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|provisionAccountTicket}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ProvisionAccountTicketCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ProvisionAccountTicketResponse} [response] ProvisionAccountTicketResponse
                         */
    
                        /**
                         * Calls ProvisionAccountTicket.
                         * @function provisionAccountTicket
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketRequest} request ProvisionAccountTicketRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ProvisionAccountTicketCallback} callback Node-style callback called with the error, if any, and ProvisionAccountTicketResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.provisionAccountTicket = function provisionAccountTicket(request, callback) {
                            return this.rpcCall(provisionAccountTicket, $root.google.analytics.admin.v1beta.ProvisionAccountTicketRequest, $root.google.analytics.admin.v1beta.ProvisionAccountTicketResponse, request, callback);
                        }, "name", { value: "ProvisionAccountTicket" });
    
                        /**
                         * Calls ProvisionAccountTicket.
                         * @function provisionAccountTicket
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketRequest} request ProvisionAccountTicketRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ProvisionAccountTicketResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listAccountSummaries}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListAccountSummariesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListAccountSummariesResponse} [response] ListAccountSummariesResponse
                         */
    
                        /**
                         * Calls ListAccountSummaries.
                         * @function listAccountSummaries
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesRequest} request ListAccountSummariesRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListAccountSummariesCallback} callback Node-style callback called with the error, if any, and ListAccountSummariesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listAccountSummaries = function listAccountSummaries(request, callback) {
                            return this.rpcCall(listAccountSummaries, $root.google.analytics.admin.v1beta.ListAccountSummariesRequest, $root.google.analytics.admin.v1beta.ListAccountSummariesResponse, request, callback);
                        }, "name", { value: "ListAccountSummaries" });
    
                        /**
                         * Calls ListAccountSummaries.
                         * @function listAccountSummaries
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesRequest} request ListAccountSummariesRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListAccountSummariesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getProperty}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetPropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.Property} [response] Property
                         */
    
                        /**
                         * Calls GetProperty.
                         * @function getProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetPropertyRequest} request GetPropertyRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetPropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getProperty = function getProperty(request, callback) {
                            return this.rpcCall(getProperty, $root.google.analytics.admin.v1beta.GetPropertyRequest, $root.google.analytics.admin.v1beta.Property, request, callback);
                        }, "name", { value: "GetProperty" });
    
                        /**
                         * Calls GetProperty.
                         * @function getProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetPropertyRequest} request GetPropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listProperties}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListPropertiesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListPropertiesResponse} [response] ListPropertiesResponse
                         */
    
                        /**
                         * Calls ListProperties.
                         * @function listProperties
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListPropertiesRequest} request ListPropertiesRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListPropertiesCallback} callback Node-style callback called with the error, if any, and ListPropertiesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listProperties = function listProperties(request, callback) {
                            return this.rpcCall(listProperties, $root.google.analytics.admin.v1beta.ListPropertiesRequest, $root.google.analytics.admin.v1beta.ListPropertiesResponse, request, callback);
                        }, "name", { value: "ListProperties" });
    
                        /**
                         * Calls ListProperties.
                         * @function listProperties
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListPropertiesRequest} request ListPropertiesRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListPropertiesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createProperty}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreatePropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.Property} [response] Property
                         */
    
                        /**
                         * Calls CreateProperty.
                         * @function createProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreatePropertyRequest} request CreatePropertyRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreatePropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createProperty = function createProperty(request, callback) {
                            return this.rpcCall(createProperty, $root.google.analytics.admin.v1beta.CreatePropertyRequest, $root.google.analytics.admin.v1beta.Property, request, callback);
                        }, "name", { value: "CreateProperty" });
    
                        /**
                         * Calls CreateProperty.
                         * @function createProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreatePropertyRequest} request CreatePropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|deleteProperty}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef DeletePropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.Property} [response] Property
                         */
    
                        /**
                         * Calls DeleteProperty.
                         * @function deleteProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeletePropertyRequest} request DeletePropertyRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.DeletePropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteProperty = function deleteProperty(request, callback) {
                            return this.rpcCall(deleteProperty, $root.google.analytics.admin.v1beta.DeletePropertyRequest, $root.google.analytics.admin.v1beta.Property, request, callback);
                        }, "name", { value: "DeleteProperty" });
    
                        /**
                         * Calls DeleteProperty.
                         * @function deleteProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeletePropertyRequest} request DeletePropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateProperty}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdatePropertyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.Property} [response] Property
                         */
    
                        /**
                         * Calls UpdateProperty.
                         * @function updateProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdatePropertyRequest} request UpdatePropertyRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdatePropertyCallback} callback Node-style callback called with the error, if any, and Property
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateProperty = function updateProperty(request, callback) {
                            return this.rpcCall(updateProperty, $root.google.analytics.admin.v1beta.UpdatePropertyRequest, $root.google.analytics.admin.v1beta.Property, request, callback);
                        }, "name", { value: "UpdateProperty" });
    
                        /**
                         * Calls UpdateProperty.
                         * @function updateProperty
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdatePropertyRequest} request UpdatePropertyRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.Property>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createFirebaseLink}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreateFirebaseLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.FirebaseLink} [response] FirebaseLink
                         */
    
                        /**
                         * Calls CreateFirebaseLink.
                         * @function createFirebaseLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateFirebaseLinkRequest} request CreateFirebaseLinkRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreateFirebaseLinkCallback} callback Node-style callback called with the error, if any, and FirebaseLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createFirebaseLink = function createFirebaseLink(request, callback) {
                            return this.rpcCall(createFirebaseLink, $root.google.analytics.admin.v1beta.CreateFirebaseLinkRequest, $root.google.analytics.admin.v1beta.FirebaseLink, request, callback);
                        }, "name", { value: "CreateFirebaseLink" });
    
                        /**
                         * Calls CreateFirebaseLink.
                         * @function createFirebaseLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateFirebaseLinkRequest} request CreateFirebaseLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.FirebaseLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|deleteFirebaseLink}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef DeleteFirebaseLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteFirebaseLink.
                         * @function deleteFirebaseLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteFirebaseLinkRequest} request DeleteFirebaseLinkRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.DeleteFirebaseLinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteFirebaseLink = function deleteFirebaseLink(request, callback) {
                            return this.rpcCall(deleteFirebaseLink, $root.google.analytics.admin.v1beta.DeleteFirebaseLinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteFirebaseLink" });
    
                        /**
                         * Calls DeleteFirebaseLink.
                         * @function deleteFirebaseLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteFirebaseLinkRequest} request DeleteFirebaseLinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listFirebaseLinks}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListFirebaseLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListFirebaseLinksResponse} [response] ListFirebaseLinksResponse
                         */
    
                        /**
                         * Calls ListFirebaseLinks.
                         * @function listFirebaseLinks
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksRequest} request ListFirebaseLinksRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListFirebaseLinksCallback} callback Node-style callback called with the error, if any, and ListFirebaseLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listFirebaseLinks = function listFirebaseLinks(request, callback) {
                            return this.rpcCall(listFirebaseLinks, $root.google.analytics.admin.v1beta.ListFirebaseLinksRequest, $root.google.analytics.admin.v1beta.ListFirebaseLinksResponse, request, callback);
                        }, "name", { value: "ListFirebaseLinks" });
    
                        /**
                         * Calls ListFirebaseLinks.
                         * @function listFirebaseLinks
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksRequest} request ListFirebaseLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListFirebaseLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createGoogleAdsLink}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreateGoogleAdsLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.GoogleAdsLink} [response] GoogleAdsLink
                         */
    
                        /**
                         * Calls CreateGoogleAdsLink.
                         * @function createGoogleAdsLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateGoogleAdsLinkRequest} request CreateGoogleAdsLinkRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreateGoogleAdsLinkCallback} callback Node-style callback called with the error, if any, and GoogleAdsLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createGoogleAdsLink = function createGoogleAdsLink(request, callback) {
                            return this.rpcCall(createGoogleAdsLink, $root.google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest, $root.google.analytics.admin.v1beta.GoogleAdsLink, request, callback);
                        }, "name", { value: "CreateGoogleAdsLink" });
    
                        /**
                         * Calls CreateGoogleAdsLink.
                         * @function createGoogleAdsLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateGoogleAdsLinkRequest} request CreateGoogleAdsLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.GoogleAdsLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateGoogleAdsLink}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdateGoogleAdsLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.GoogleAdsLink} [response] GoogleAdsLink
                         */
    
                        /**
                         * Calls UpdateGoogleAdsLink.
                         * @function updateGoogleAdsLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateGoogleAdsLinkRequest} request UpdateGoogleAdsLinkRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdateGoogleAdsLinkCallback} callback Node-style callback called with the error, if any, and GoogleAdsLink
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateGoogleAdsLink = function updateGoogleAdsLink(request, callback) {
                            return this.rpcCall(updateGoogleAdsLink, $root.google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest, $root.google.analytics.admin.v1beta.GoogleAdsLink, request, callback);
                        }, "name", { value: "UpdateGoogleAdsLink" });
    
                        /**
                         * Calls UpdateGoogleAdsLink.
                         * @function updateGoogleAdsLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateGoogleAdsLinkRequest} request UpdateGoogleAdsLinkRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.GoogleAdsLink>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|deleteGoogleAdsLink}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef DeleteGoogleAdsLinkCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteGoogleAdsLink.
                         * @function deleteGoogleAdsLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteGoogleAdsLinkRequest} request DeleteGoogleAdsLinkRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.DeleteGoogleAdsLinkCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteGoogleAdsLink = function deleteGoogleAdsLink(request, callback) {
                            return this.rpcCall(deleteGoogleAdsLink, $root.google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteGoogleAdsLink" });
    
                        /**
                         * Calls DeleteGoogleAdsLink.
                         * @function deleteGoogleAdsLink
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteGoogleAdsLinkRequest} request DeleteGoogleAdsLinkRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listGoogleAdsLinks}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListGoogleAdsLinksCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListGoogleAdsLinksResponse} [response] ListGoogleAdsLinksResponse
                         */
    
                        /**
                         * Calls ListGoogleAdsLinks.
                         * @function listGoogleAdsLinks
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksRequest} request ListGoogleAdsLinksRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListGoogleAdsLinksCallback} callback Node-style callback called with the error, if any, and ListGoogleAdsLinksResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listGoogleAdsLinks = function listGoogleAdsLinks(request, callback) {
                            return this.rpcCall(listGoogleAdsLinks, $root.google.analytics.admin.v1beta.ListGoogleAdsLinksRequest, $root.google.analytics.admin.v1beta.ListGoogleAdsLinksResponse, request, callback);
                        }, "name", { value: "ListGoogleAdsLinks" });
    
                        /**
                         * Calls ListGoogleAdsLinks.
                         * @function listGoogleAdsLinks
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksRequest} request ListGoogleAdsLinksRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListGoogleAdsLinksResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getDataSharingSettings}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetDataSharingSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.DataSharingSettings} [response] DataSharingSettings
                         */
    
                        /**
                         * Calls GetDataSharingSettings.
                         * @function getDataSharingSettings
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetDataSharingSettingsRequest} request GetDataSharingSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetDataSharingSettingsCallback} callback Node-style callback called with the error, if any, and DataSharingSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDataSharingSettings = function getDataSharingSettings(request, callback) {
                            return this.rpcCall(getDataSharingSettings, $root.google.analytics.admin.v1beta.GetDataSharingSettingsRequest, $root.google.analytics.admin.v1beta.DataSharingSettings, request, callback);
                        }, "name", { value: "GetDataSharingSettings" });
    
                        /**
                         * Calls GetDataSharingSettings.
                         * @function getDataSharingSettings
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetDataSharingSettingsRequest} request GetDataSharingSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.DataSharingSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.MeasurementProtocolSecret} [response] MeasurementProtocolSecret
                         */
    
                        /**
                         * Calls GetMeasurementProtocolSecret.
                         * @function getMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetMeasurementProtocolSecretRequest} request GetMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and MeasurementProtocolSecret
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getMeasurementProtocolSecret = function getMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(getMeasurementProtocolSecret, $root.google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest, $root.google.analytics.admin.v1beta.MeasurementProtocolSecret, request, callback);
                        }, "name", { value: "GetMeasurementProtocolSecret" });
    
                        /**
                         * Calls GetMeasurementProtocolSecret.
                         * @function getMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetMeasurementProtocolSecretRequest} request GetMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.MeasurementProtocolSecret>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listMeasurementProtocolSecrets}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListMeasurementProtocolSecretsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse} [response] ListMeasurementProtocolSecretsResponse
                         */
    
                        /**
                         * Calls ListMeasurementProtocolSecrets.
                         * @function listMeasurementProtocolSecrets
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsRequest} request ListMeasurementProtocolSecretsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListMeasurementProtocolSecretsCallback} callback Node-style callback called with the error, if any, and ListMeasurementProtocolSecretsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listMeasurementProtocolSecrets = function listMeasurementProtocolSecrets(request, callback) {
                            return this.rpcCall(listMeasurementProtocolSecrets, $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest, $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse, request, callback);
                        }, "name", { value: "ListMeasurementProtocolSecrets" });
    
                        /**
                         * Calls ListMeasurementProtocolSecrets.
                         * @function listMeasurementProtocolSecrets
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsRequest} request ListMeasurementProtocolSecretsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreateMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.MeasurementProtocolSecret} [response] MeasurementProtocolSecret
                         */
    
                        /**
                         * Calls CreateMeasurementProtocolSecret.
                         * @function createMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateMeasurementProtocolSecretRequest} request CreateMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreateMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and MeasurementProtocolSecret
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createMeasurementProtocolSecret = function createMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(createMeasurementProtocolSecret, $root.google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest, $root.google.analytics.admin.v1beta.MeasurementProtocolSecret, request, callback);
                        }, "name", { value: "CreateMeasurementProtocolSecret" });
    
                        /**
                         * Calls CreateMeasurementProtocolSecret.
                         * @function createMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateMeasurementProtocolSecretRequest} request CreateMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.MeasurementProtocolSecret>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|deleteMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef DeleteMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteMeasurementProtocolSecret.
                         * @function deleteMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteMeasurementProtocolSecretRequest} request DeleteMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.DeleteMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteMeasurementProtocolSecret = function deleteMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(deleteMeasurementProtocolSecret, $root.google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteMeasurementProtocolSecret" });
    
                        /**
                         * Calls DeleteMeasurementProtocolSecret.
                         * @function deleteMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteMeasurementProtocolSecretRequest} request DeleteMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateMeasurementProtocolSecret}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdateMeasurementProtocolSecretCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.MeasurementProtocolSecret} [response] MeasurementProtocolSecret
                         */
    
                        /**
                         * Calls UpdateMeasurementProtocolSecret.
                         * @function updateMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateMeasurementProtocolSecretRequest} request UpdateMeasurementProtocolSecretRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdateMeasurementProtocolSecretCallback} callback Node-style callback called with the error, if any, and MeasurementProtocolSecret
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateMeasurementProtocolSecret = function updateMeasurementProtocolSecret(request, callback) {
                            return this.rpcCall(updateMeasurementProtocolSecret, $root.google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest, $root.google.analytics.admin.v1beta.MeasurementProtocolSecret, request, callback);
                        }, "name", { value: "UpdateMeasurementProtocolSecret" });
    
                        /**
                         * Calls UpdateMeasurementProtocolSecret.
                         * @function updateMeasurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateMeasurementProtocolSecretRequest} request UpdateMeasurementProtocolSecretRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.MeasurementProtocolSecret>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|acknowledgeUserDataCollection}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef AcknowledgeUserDataCollectionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse} [response] AcknowledgeUserDataCollectionResponse
                         */
    
                        /**
                         * Calls AcknowledgeUserDataCollection.
                         * @function acknowledgeUserDataCollection
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionRequest} request AcknowledgeUserDataCollectionRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.AcknowledgeUserDataCollectionCallback} callback Node-style callback called with the error, if any, and AcknowledgeUserDataCollectionResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.acknowledgeUserDataCollection = function acknowledgeUserDataCollection(request, callback) {
                            return this.rpcCall(acknowledgeUserDataCollection, $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest, $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse, request, callback);
                        }, "name", { value: "AcknowledgeUserDataCollection" });
    
                        /**
                         * Calls AcknowledgeUserDataCollection.
                         * @function acknowledgeUserDataCollection
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionRequest} request AcknowledgeUserDataCollectionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|searchChangeHistoryEvents}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef SearchChangeHistoryEventsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse} [response] SearchChangeHistoryEventsResponse
                         */
    
                        /**
                         * Calls SearchChangeHistoryEvents.
                         * @function searchChangeHistoryEvents
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsRequest} request SearchChangeHistoryEventsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.SearchChangeHistoryEventsCallback} callback Node-style callback called with the error, if any, and SearchChangeHistoryEventsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.searchChangeHistoryEvents = function searchChangeHistoryEvents(request, callback) {
                            return this.rpcCall(searchChangeHistoryEvents, $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest, $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse, request, callback);
                        }, "name", { value: "SearchChangeHistoryEvents" });
    
                        /**
                         * Calls SearchChangeHistoryEvents.
                         * @function searchChangeHistoryEvents
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsRequest} request SearchChangeHistoryEventsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createConversionEvent}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreateConversionEventCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ConversionEvent} [response] ConversionEvent
                         */
    
                        /**
                         * Calls CreateConversionEvent.
                         * @function createConversionEvent
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateConversionEventRequest} request CreateConversionEventRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreateConversionEventCallback} callback Node-style callback called with the error, if any, and ConversionEvent
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createConversionEvent = function createConversionEvent(request, callback) {
                            return this.rpcCall(createConversionEvent, $root.google.analytics.admin.v1beta.CreateConversionEventRequest, $root.google.analytics.admin.v1beta.ConversionEvent, request, callback);
                        }, "name", { value: "CreateConversionEvent" });
    
                        /**
                         * Calls CreateConversionEvent.
                         * @function createConversionEvent
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateConversionEventRequest} request CreateConversionEventRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ConversionEvent>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getConversionEvent}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetConversionEventCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ConversionEvent} [response] ConversionEvent
                         */
    
                        /**
                         * Calls GetConversionEvent.
                         * @function getConversionEvent
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetConversionEventRequest} request GetConversionEventRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetConversionEventCallback} callback Node-style callback called with the error, if any, and ConversionEvent
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getConversionEvent = function getConversionEvent(request, callback) {
                            return this.rpcCall(getConversionEvent, $root.google.analytics.admin.v1beta.GetConversionEventRequest, $root.google.analytics.admin.v1beta.ConversionEvent, request, callback);
                        }, "name", { value: "GetConversionEvent" });
    
                        /**
                         * Calls GetConversionEvent.
                         * @function getConversionEvent
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetConversionEventRequest} request GetConversionEventRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ConversionEvent>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|deleteConversionEvent}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef DeleteConversionEventCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteConversionEvent.
                         * @function deleteConversionEvent
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteConversionEventRequest} request DeleteConversionEventRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.DeleteConversionEventCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteConversionEvent = function deleteConversionEvent(request, callback) {
                            return this.rpcCall(deleteConversionEvent, $root.google.analytics.admin.v1beta.DeleteConversionEventRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteConversionEvent" });
    
                        /**
                         * Calls DeleteConversionEvent.
                         * @function deleteConversionEvent
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteConversionEventRequest} request DeleteConversionEventRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listConversionEvents}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListConversionEventsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListConversionEventsResponse} [response] ListConversionEventsResponse
                         */
    
                        /**
                         * Calls ListConversionEvents.
                         * @function listConversionEvents
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListConversionEventsRequest} request ListConversionEventsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListConversionEventsCallback} callback Node-style callback called with the error, if any, and ListConversionEventsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listConversionEvents = function listConversionEvents(request, callback) {
                            return this.rpcCall(listConversionEvents, $root.google.analytics.admin.v1beta.ListConversionEventsRequest, $root.google.analytics.admin.v1beta.ListConversionEventsResponse, request, callback);
                        }, "name", { value: "ListConversionEvents" });
    
                        /**
                         * Calls ListConversionEvents.
                         * @function listConversionEvents
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListConversionEventsRequest} request ListConversionEventsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListConversionEventsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createCustomDimension}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreateCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.CustomDimension} [response] CustomDimension
                         */
    
                        /**
                         * Calls CreateCustomDimension.
                         * @function createCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateCustomDimensionRequest} request CreateCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreateCustomDimensionCallback} callback Node-style callback called with the error, if any, and CustomDimension
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createCustomDimension = function createCustomDimension(request, callback) {
                            return this.rpcCall(createCustomDimension, $root.google.analytics.admin.v1beta.CreateCustomDimensionRequest, $root.google.analytics.admin.v1beta.CustomDimension, request, callback);
                        }, "name", { value: "CreateCustomDimension" });
    
                        /**
                         * Calls CreateCustomDimension.
                         * @function createCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateCustomDimensionRequest} request CreateCustomDimensionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.CustomDimension>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateCustomDimension}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdateCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.CustomDimension} [response] CustomDimension
                         */
    
                        /**
                         * Calls UpdateCustomDimension.
                         * @function updateCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateCustomDimensionRequest} request UpdateCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdateCustomDimensionCallback} callback Node-style callback called with the error, if any, and CustomDimension
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateCustomDimension = function updateCustomDimension(request, callback) {
                            return this.rpcCall(updateCustomDimension, $root.google.analytics.admin.v1beta.UpdateCustomDimensionRequest, $root.google.analytics.admin.v1beta.CustomDimension, request, callback);
                        }, "name", { value: "UpdateCustomDimension" });
    
                        /**
                         * Calls UpdateCustomDimension.
                         * @function updateCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateCustomDimensionRequest} request UpdateCustomDimensionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.CustomDimension>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listCustomDimensions}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListCustomDimensionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListCustomDimensionsResponse} [response] ListCustomDimensionsResponse
                         */
    
                        /**
                         * Calls ListCustomDimensions.
                         * @function listCustomDimensions
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsRequest} request ListCustomDimensionsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListCustomDimensionsCallback} callback Node-style callback called with the error, if any, and ListCustomDimensionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listCustomDimensions = function listCustomDimensions(request, callback) {
                            return this.rpcCall(listCustomDimensions, $root.google.analytics.admin.v1beta.ListCustomDimensionsRequest, $root.google.analytics.admin.v1beta.ListCustomDimensionsResponse, request, callback);
                        }, "name", { value: "ListCustomDimensions" });
    
                        /**
                         * Calls ListCustomDimensions.
                         * @function listCustomDimensions
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsRequest} request ListCustomDimensionsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListCustomDimensionsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|archiveCustomDimension}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ArchiveCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls ArchiveCustomDimension.
                         * @function archiveCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IArchiveCustomDimensionRequest} request ArchiveCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ArchiveCustomDimensionCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.archiveCustomDimension = function archiveCustomDimension(request, callback) {
                            return this.rpcCall(archiveCustomDimension, $root.google.analytics.admin.v1beta.ArchiveCustomDimensionRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "ArchiveCustomDimension" });
    
                        /**
                         * Calls ArchiveCustomDimension.
                         * @function archiveCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IArchiveCustomDimensionRequest} request ArchiveCustomDimensionRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getCustomDimension}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetCustomDimensionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.CustomDimension} [response] CustomDimension
                         */
    
                        /**
                         * Calls GetCustomDimension.
                         * @function getCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetCustomDimensionRequest} request GetCustomDimensionRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetCustomDimensionCallback} callback Node-style callback called with the error, if any, and CustomDimension
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getCustomDimension = function getCustomDimension(request, callback) {
                            return this.rpcCall(getCustomDimension, $root.google.analytics.admin.v1beta.GetCustomDimensionRequest, $root.google.analytics.admin.v1beta.CustomDimension, request, callback);
                        }, "name", { value: "GetCustomDimension" });
    
                        /**
                         * Calls GetCustomDimension.
                         * @function getCustomDimension
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetCustomDimensionRequest} request GetCustomDimensionRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.CustomDimension>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createCustomMetric}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreateCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.CustomMetric} [response] CustomMetric
                         */
    
                        /**
                         * Calls CreateCustomMetric.
                         * @function createCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateCustomMetricRequest} request CreateCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreateCustomMetricCallback} callback Node-style callback called with the error, if any, and CustomMetric
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createCustomMetric = function createCustomMetric(request, callback) {
                            return this.rpcCall(createCustomMetric, $root.google.analytics.admin.v1beta.CreateCustomMetricRequest, $root.google.analytics.admin.v1beta.CustomMetric, request, callback);
                        }, "name", { value: "CreateCustomMetric" });
    
                        /**
                         * Calls CreateCustomMetric.
                         * @function createCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateCustomMetricRequest} request CreateCustomMetricRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.CustomMetric>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateCustomMetric}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdateCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.CustomMetric} [response] CustomMetric
                         */
    
                        /**
                         * Calls UpdateCustomMetric.
                         * @function updateCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateCustomMetricRequest} request UpdateCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdateCustomMetricCallback} callback Node-style callback called with the error, if any, and CustomMetric
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateCustomMetric = function updateCustomMetric(request, callback) {
                            return this.rpcCall(updateCustomMetric, $root.google.analytics.admin.v1beta.UpdateCustomMetricRequest, $root.google.analytics.admin.v1beta.CustomMetric, request, callback);
                        }, "name", { value: "UpdateCustomMetric" });
    
                        /**
                         * Calls UpdateCustomMetric.
                         * @function updateCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateCustomMetricRequest} request UpdateCustomMetricRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.CustomMetric>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listCustomMetrics}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListCustomMetricsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListCustomMetricsResponse} [response] ListCustomMetricsResponse
                         */
    
                        /**
                         * Calls ListCustomMetrics.
                         * @function listCustomMetrics
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsRequest} request ListCustomMetricsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListCustomMetricsCallback} callback Node-style callback called with the error, if any, and ListCustomMetricsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listCustomMetrics = function listCustomMetrics(request, callback) {
                            return this.rpcCall(listCustomMetrics, $root.google.analytics.admin.v1beta.ListCustomMetricsRequest, $root.google.analytics.admin.v1beta.ListCustomMetricsResponse, request, callback);
                        }, "name", { value: "ListCustomMetrics" });
    
                        /**
                         * Calls ListCustomMetrics.
                         * @function listCustomMetrics
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsRequest} request ListCustomMetricsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListCustomMetricsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|archiveCustomMetric}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ArchiveCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls ArchiveCustomMetric.
                         * @function archiveCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IArchiveCustomMetricRequest} request ArchiveCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ArchiveCustomMetricCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.archiveCustomMetric = function archiveCustomMetric(request, callback) {
                            return this.rpcCall(archiveCustomMetric, $root.google.analytics.admin.v1beta.ArchiveCustomMetricRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "ArchiveCustomMetric" });
    
                        /**
                         * Calls ArchiveCustomMetric.
                         * @function archiveCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IArchiveCustomMetricRequest} request ArchiveCustomMetricRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getCustomMetric}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetCustomMetricCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.CustomMetric} [response] CustomMetric
                         */
    
                        /**
                         * Calls GetCustomMetric.
                         * @function getCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetCustomMetricRequest} request GetCustomMetricRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetCustomMetricCallback} callback Node-style callback called with the error, if any, and CustomMetric
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getCustomMetric = function getCustomMetric(request, callback) {
                            return this.rpcCall(getCustomMetric, $root.google.analytics.admin.v1beta.GetCustomMetricRequest, $root.google.analytics.admin.v1beta.CustomMetric, request, callback);
                        }, "name", { value: "GetCustomMetric" });
    
                        /**
                         * Calls GetCustomMetric.
                         * @function getCustomMetric
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetCustomMetricRequest} request GetCustomMetricRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.CustomMetric>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getDataRetentionSettings}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetDataRetentionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.DataRetentionSettings} [response] DataRetentionSettings
                         */
    
                        /**
                         * Calls GetDataRetentionSettings.
                         * @function getDataRetentionSettings
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetDataRetentionSettingsRequest} request GetDataRetentionSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetDataRetentionSettingsCallback} callback Node-style callback called with the error, if any, and DataRetentionSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDataRetentionSettings = function getDataRetentionSettings(request, callback) {
                            return this.rpcCall(getDataRetentionSettings, $root.google.analytics.admin.v1beta.GetDataRetentionSettingsRequest, $root.google.analytics.admin.v1beta.DataRetentionSettings, request, callback);
                        }, "name", { value: "GetDataRetentionSettings" });
    
                        /**
                         * Calls GetDataRetentionSettings.
                         * @function getDataRetentionSettings
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetDataRetentionSettingsRequest} request GetDataRetentionSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.DataRetentionSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateDataRetentionSettings}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdateDataRetentionSettingsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.DataRetentionSettings} [response] DataRetentionSettings
                         */
    
                        /**
                         * Calls UpdateDataRetentionSettings.
                         * @function updateDataRetentionSettings
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateDataRetentionSettingsRequest} request UpdateDataRetentionSettingsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdateDataRetentionSettingsCallback} callback Node-style callback called with the error, if any, and DataRetentionSettings
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateDataRetentionSettings = function updateDataRetentionSettings(request, callback) {
                            return this.rpcCall(updateDataRetentionSettings, $root.google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest, $root.google.analytics.admin.v1beta.DataRetentionSettings, request, callback);
                        }, "name", { value: "UpdateDataRetentionSettings" });
    
                        /**
                         * Calls UpdateDataRetentionSettings.
                         * @function updateDataRetentionSettings
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateDataRetentionSettingsRequest} request UpdateDataRetentionSettingsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.DataRetentionSettings>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|createDataStream}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef CreateDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.DataStream} [response] DataStream
                         */
    
                        /**
                         * Calls CreateDataStream.
                         * @function createDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateDataStreamRequest} request CreateDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.CreateDataStreamCallback} callback Node-style callback called with the error, if any, and DataStream
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.createDataStream = function createDataStream(request, callback) {
                            return this.rpcCall(createDataStream, $root.google.analytics.admin.v1beta.CreateDataStreamRequest, $root.google.analytics.admin.v1beta.DataStream, request, callback);
                        }, "name", { value: "CreateDataStream" });
    
                        /**
                         * Calls CreateDataStream.
                         * @function createDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.ICreateDataStreamRequest} request CreateDataStreamRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.DataStream>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|deleteDataStream}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef DeleteDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.protobuf.Empty} [response] Empty
                         */
    
                        /**
                         * Calls DeleteDataStream.
                         * @function deleteDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteDataStreamRequest} request DeleteDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.DeleteDataStreamCallback} callback Node-style callback called with the error, if any, and Empty
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.deleteDataStream = function deleteDataStream(request, callback) {
                            return this.rpcCall(deleteDataStream, $root.google.analytics.admin.v1beta.DeleteDataStreamRequest, $root.google.protobuf.Empty, request, callback);
                        }, "name", { value: "DeleteDataStream" });
    
                        /**
                         * Calls DeleteDataStream.
                         * @function deleteDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IDeleteDataStreamRequest} request DeleteDataStreamRequest message or plain object
                         * @returns {Promise<google.protobuf.Empty>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|updateDataStream}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef UpdateDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.DataStream} [response] DataStream
                         */
    
                        /**
                         * Calls UpdateDataStream.
                         * @function updateDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateDataStreamRequest} request UpdateDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.UpdateDataStreamCallback} callback Node-style callback called with the error, if any, and DataStream
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.updateDataStream = function updateDataStream(request, callback) {
                            return this.rpcCall(updateDataStream, $root.google.analytics.admin.v1beta.UpdateDataStreamRequest, $root.google.analytics.admin.v1beta.DataStream, request, callback);
                        }, "name", { value: "UpdateDataStream" });
    
                        /**
                         * Calls UpdateDataStream.
                         * @function updateDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IUpdateDataStreamRequest} request UpdateDataStreamRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.DataStream>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|listDataStreams}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef ListDataStreamsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.ListDataStreamsResponse} [response] ListDataStreamsResponse
                         */
    
                        /**
                         * Calls ListDataStreams.
                         * @function listDataStreams
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListDataStreamsRequest} request ListDataStreamsRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.ListDataStreamsCallback} callback Node-style callback called with the error, if any, and ListDataStreamsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.listDataStreams = function listDataStreams(request, callback) {
                            return this.rpcCall(listDataStreams, $root.google.analytics.admin.v1beta.ListDataStreamsRequest, $root.google.analytics.admin.v1beta.ListDataStreamsResponse, request, callback);
                        }, "name", { value: "ListDataStreams" });
    
                        /**
                         * Calls ListDataStreams.
                         * @function listDataStreams
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IListDataStreamsRequest} request ListDataStreamsRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.ListDataStreamsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|getDataStream}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef GetDataStreamCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.DataStream} [response] DataStream
                         */
    
                        /**
                         * Calls GetDataStream.
                         * @function getDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetDataStreamRequest} request GetDataStreamRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.GetDataStreamCallback} callback Node-style callback called with the error, if any, and DataStream
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.getDataStream = function getDataStream(request, callback) {
                            return this.rpcCall(getDataStream, $root.google.analytics.admin.v1beta.GetDataStreamRequest, $root.google.analytics.admin.v1beta.DataStream, request, callback);
                        }, "name", { value: "GetDataStream" });
    
                        /**
                         * Calls GetDataStream.
                         * @function getDataStream
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IGetDataStreamRequest} request GetDataStreamRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.DataStream>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.analytics.admin.v1beta.AnalyticsAdminService|runAccessReport}.
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @typedef RunAccessReportCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.analytics.admin.v1beta.RunAccessReportResponse} [response] RunAccessReportResponse
                         */
    
                        /**
                         * Calls RunAccessReport.
                         * @function runAccessReport
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IRunAccessReportRequest} request RunAccessReportRequest message or plain object
                         * @param {google.analytics.admin.v1beta.AnalyticsAdminService.RunAccessReportCallback} callback Node-style callback called with the error, if any, and RunAccessReportResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AnalyticsAdminService.prototype.runAccessReport = function runAccessReport(request, callback) {
                            return this.rpcCall(runAccessReport, $root.google.analytics.admin.v1beta.RunAccessReportRequest, $root.google.analytics.admin.v1beta.RunAccessReportResponse, request, callback);
                        }, "name", { value: "RunAccessReport" });
    
                        /**
                         * Calls RunAccessReport.
                         * @function runAccessReport
                         * @memberof google.analytics.admin.v1beta.AnalyticsAdminService
                         * @instance
                         * @param {google.analytics.admin.v1beta.IRunAccessReportRequest} request RunAccessReportRequest message or plain object
                         * @returns {Promise<google.analytics.admin.v1beta.RunAccessReportResponse>} Promise
                         * @variation 2
                         */
    
                        return AnalyticsAdminService;
                    })();
    
                    v1beta.RunAccessReportRequest = (function() {
    
                        /**
                         * Properties of a RunAccessReportRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IRunAccessReportRequest
                         * @property {string|null} [entity] RunAccessReportRequest entity
                         * @property {Array.<google.analytics.admin.v1beta.IAccessDimension>|null} [dimensions] RunAccessReportRequest dimensions
                         * @property {Array.<google.analytics.admin.v1beta.IAccessMetric>|null} [metrics] RunAccessReportRequest metrics
                         * @property {Array.<google.analytics.admin.v1beta.IAccessDateRange>|null} [dateRanges] RunAccessReportRequest dateRanges
                         * @property {google.analytics.admin.v1beta.IAccessFilterExpression|null} [dimensionFilter] RunAccessReportRequest dimensionFilter
                         * @property {google.analytics.admin.v1beta.IAccessFilterExpression|null} [metricFilter] RunAccessReportRequest metricFilter
                         * @property {number|Long|null} [offset] RunAccessReportRequest offset
                         * @property {number|Long|null} [limit] RunAccessReportRequest limit
                         * @property {string|null} [timeZone] RunAccessReportRequest timeZone
                         * @property {Array.<google.analytics.admin.v1beta.IAccessOrderBy>|null} [orderBys] RunAccessReportRequest orderBys
                         * @property {boolean|null} [returnEntityQuota] RunAccessReportRequest returnEntityQuota
                         */
    
                        /**
                         * Constructs a new RunAccessReportRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a RunAccessReportRequest.
                         * @implements IRunAccessReportRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IRunAccessReportRequest=} [properties] Properties to set
                         */
                        function RunAccessReportRequest(properties) {
                            this.dimensions = [];
                            this.metrics = [];
                            this.dateRanges = [];
                            this.orderBys = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RunAccessReportRequest entity.
                         * @member {string} entity
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.entity = "";
    
                        /**
                         * RunAccessReportRequest dimensions.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessDimension>} dimensions
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.dimensions = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest metrics.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessMetric>} metrics
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.metrics = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest dateRanges.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessDateRange>} dateRanges
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.dateRanges = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest dimensionFilter.
                         * @member {google.analytics.admin.v1beta.IAccessFilterExpression|null|undefined} dimensionFilter
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.dimensionFilter = null;
    
                        /**
                         * RunAccessReportRequest metricFilter.
                         * @member {google.analytics.admin.v1beta.IAccessFilterExpression|null|undefined} metricFilter
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.metricFilter = null;
    
                        /**
                         * RunAccessReportRequest offset.
                         * @member {number|Long} offset
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.offset = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                        /**
                         * RunAccessReportRequest limit.
                         * @member {number|Long} limit
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.limit = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                        /**
                         * RunAccessReportRequest timeZone.
                         * @member {string} timeZone
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.timeZone = "";
    
                        /**
                         * RunAccessReportRequest orderBys.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessOrderBy>} orderBys
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.orderBys = $util.emptyArray;
    
                        /**
                         * RunAccessReportRequest returnEntityQuota.
                         * @member {boolean} returnEntityQuota
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         */
                        RunAccessReportRequest.prototype.returnEntityQuota = false;
    
                        /**
                         * Creates a new RunAccessReportRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IRunAccessReportRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.RunAccessReportRequest} RunAccessReportRequest instance
                         */
                        RunAccessReportRequest.create = function create(properties) {
                            return new RunAccessReportRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RunAccessReportRequest message. Does not implicitly {@link google.analytics.admin.v1beta.RunAccessReportRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IRunAccessReportRequest} message RunAccessReportRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.entity != null && Object.hasOwnProperty.call(message, "entity"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.entity);
                            if (message.dimensions != null && message.dimensions.length)
                                for (var i = 0; i < message.dimensions.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessDimension.encode(message.dimensions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.metrics != null && message.metrics.length)
                                for (var i = 0; i < message.metrics.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessMetric.encode(message.metrics[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.dateRanges != null && message.dateRanges.length)
                                for (var i = 0; i < message.dateRanges.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessDateRange.encode(message.dateRanges[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.dimensionFilter != null && Object.hasOwnProperty.call(message, "dimensionFilter"))
                                $root.google.analytics.admin.v1beta.AccessFilterExpression.encode(message.dimensionFilter, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.metricFilter != null && Object.hasOwnProperty.call(message, "metricFilter"))
                                $root.google.analytics.admin.v1beta.AccessFilterExpression.encode(message.metricFilter, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.offset != null && Object.hasOwnProperty.call(message, "offset"))
                                writer.uint32(/* id 7, wireType 0 =*/56).int64(message.offset);
                            if (message.limit != null && Object.hasOwnProperty.call(message, "limit"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int64(message.limit);
                            if (message.timeZone != null && Object.hasOwnProperty.call(message, "timeZone"))
                                writer.uint32(/* id 9, wireType 2 =*/74).string(message.timeZone);
                            if (message.orderBys != null && message.orderBys.length)
                                for (var i = 0; i < message.orderBys.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessOrderBy.encode(message.orderBys[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                            if (message.returnEntityQuota != null && Object.hasOwnProperty.call(message, "returnEntityQuota"))
                                writer.uint32(/* id 11, wireType 0 =*/88).bool(message.returnEntityQuota);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RunAccessReportRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.RunAccessReportRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IRunAccessReportRequest} message RunAccessReportRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RunAccessReportRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.RunAccessReportRequest} RunAccessReportRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.RunAccessReportRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.entity = reader.string();
                                        break;
                                    }
                                case 2: {
                                        if (!(message.dimensions && message.dimensions.length))
                                            message.dimensions = [];
                                        message.dimensions.push($root.google.analytics.admin.v1beta.AccessDimension.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3: {
                                        if (!(message.metrics && message.metrics.length))
                                            message.metrics = [];
                                        message.metrics.push($root.google.analytics.admin.v1beta.AccessMetric.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 4: {
                                        if (!(message.dateRanges && message.dateRanges.length))
                                            message.dateRanges = [];
                                        message.dateRanges.push($root.google.analytics.admin.v1beta.AccessDateRange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 5: {
                                        message.dimensionFilter = $root.google.analytics.admin.v1beta.AccessFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 6: {
                                        message.metricFilter = $root.google.analytics.admin.v1beta.AccessFilterExpression.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.offset = reader.int64();
                                        break;
                                    }
                                case 8: {
                                        message.limit = reader.int64();
                                        break;
                                    }
                                case 9: {
                                        message.timeZone = reader.string();
                                        break;
                                    }
                                case 10: {
                                        if (!(message.orderBys && message.orderBys.length))
                                            message.orderBys = [];
                                        message.orderBys.push($root.google.analytics.admin.v1beta.AccessOrderBy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 11: {
                                        message.returnEntityQuota = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RunAccessReportRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.RunAccessReportRequest} RunAccessReportRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RunAccessReportRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RunAccessReportRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.entity != null && message.hasOwnProperty("entity"))
                                if (!$util.isString(message.entity))
                                    return "entity: string expected";
                            if (message.dimensions != null && message.hasOwnProperty("dimensions")) {
                                if (!Array.isArray(message.dimensions))
                                    return "dimensions: array expected";
                                for (var i = 0; i < message.dimensions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessDimension.verify(message.dimensions[i]);
                                    if (error)
                                        return "dimensions." + error;
                                }
                            }
                            if (message.metrics != null && message.hasOwnProperty("metrics")) {
                                if (!Array.isArray(message.metrics))
                                    return "metrics: array expected";
                                for (var i = 0; i < message.metrics.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessMetric.verify(message.metrics[i]);
                                    if (error)
                                        return "metrics." + error;
                                }
                            }
                            if (message.dateRanges != null && message.hasOwnProperty("dateRanges")) {
                                if (!Array.isArray(message.dateRanges))
                                    return "dateRanges: array expected";
                                for (var i = 0; i < message.dateRanges.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessDateRange.verify(message.dateRanges[i]);
                                    if (error)
                                        return "dateRanges." + error;
                                }
                            }
                            if (message.dimensionFilter != null && message.hasOwnProperty("dimensionFilter")) {
                                var error = $root.google.analytics.admin.v1beta.AccessFilterExpression.verify(message.dimensionFilter);
                                if (error)
                                    return "dimensionFilter." + error;
                            }
                            if (message.metricFilter != null && message.hasOwnProperty("metricFilter")) {
                                var error = $root.google.analytics.admin.v1beta.AccessFilterExpression.verify(message.metricFilter);
                                if (error)
                                    return "metricFilter." + error;
                            }
                            if (message.offset != null && message.hasOwnProperty("offset"))
                                if (!$util.isInteger(message.offset) && !(message.offset && $util.isInteger(message.offset.low) && $util.isInteger(message.offset.high)))
                                    return "offset: integer|Long expected";
                            if (message.limit != null && message.hasOwnProperty("limit"))
                                if (!$util.isInteger(message.limit) && !(message.limit && $util.isInteger(message.limit.low) && $util.isInteger(message.limit.high)))
                                    return "limit: integer|Long expected";
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                if (!$util.isString(message.timeZone))
                                    return "timeZone: string expected";
                            if (message.orderBys != null && message.hasOwnProperty("orderBys")) {
                                if (!Array.isArray(message.orderBys))
                                    return "orderBys: array expected";
                                for (var i = 0; i < message.orderBys.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessOrderBy.verify(message.orderBys[i]);
                                    if (error)
                                        return "orderBys." + error;
                                }
                            }
                            if (message.returnEntityQuota != null && message.hasOwnProperty("returnEntityQuota"))
                                if (typeof message.returnEntityQuota !== "boolean")
                                    return "returnEntityQuota: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a RunAccessReportRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.RunAccessReportRequest} RunAccessReportRequest
                         */
                        RunAccessReportRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.RunAccessReportRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.RunAccessReportRequest();
                            if (object.entity != null)
                                message.entity = String(object.entity);
                            if (object.dimensions) {
                                if (!Array.isArray(object.dimensions))
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.dimensions: array expected");
                                message.dimensions = [];
                                for (var i = 0; i < object.dimensions.length; ++i) {
                                    if (typeof object.dimensions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.dimensions: object expected");
                                    message.dimensions[i] = $root.google.analytics.admin.v1beta.AccessDimension.fromObject(object.dimensions[i]);
                                }
                            }
                            if (object.metrics) {
                                if (!Array.isArray(object.metrics))
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.metrics: array expected");
                                message.metrics = [];
                                for (var i = 0; i < object.metrics.length; ++i) {
                                    if (typeof object.metrics[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.metrics: object expected");
                                    message.metrics[i] = $root.google.analytics.admin.v1beta.AccessMetric.fromObject(object.metrics[i]);
                                }
                            }
                            if (object.dateRanges) {
                                if (!Array.isArray(object.dateRanges))
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.dateRanges: array expected");
                                message.dateRanges = [];
                                for (var i = 0; i < object.dateRanges.length; ++i) {
                                    if (typeof object.dateRanges[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.dateRanges: object expected");
                                    message.dateRanges[i] = $root.google.analytics.admin.v1beta.AccessDateRange.fromObject(object.dateRanges[i]);
                                }
                            }
                            if (object.dimensionFilter != null) {
                                if (typeof object.dimensionFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.dimensionFilter: object expected");
                                message.dimensionFilter = $root.google.analytics.admin.v1beta.AccessFilterExpression.fromObject(object.dimensionFilter);
                            }
                            if (object.metricFilter != null) {
                                if (typeof object.metricFilter !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.metricFilter: object expected");
                                message.metricFilter = $root.google.analytics.admin.v1beta.AccessFilterExpression.fromObject(object.metricFilter);
                            }
                            if (object.offset != null)
                                if ($util.Long)
                                    (message.offset = $util.Long.fromValue(object.offset)).unsigned = false;
                                else if (typeof object.offset === "string")
                                    message.offset = parseInt(object.offset, 10);
                                else if (typeof object.offset === "number")
                                    message.offset = object.offset;
                                else if (typeof object.offset === "object")
                                    message.offset = new $util.LongBits(object.offset.low >>> 0, object.offset.high >>> 0).toNumber();
                            if (object.limit != null)
                                if ($util.Long)
                                    (message.limit = $util.Long.fromValue(object.limit)).unsigned = false;
                                else if (typeof object.limit === "string")
                                    message.limit = parseInt(object.limit, 10);
                                else if (typeof object.limit === "number")
                                    message.limit = object.limit;
                                else if (typeof object.limit === "object")
                                    message.limit = new $util.LongBits(object.limit.low >>> 0, object.limit.high >>> 0).toNumber();
                            if (object.timeZone != null)
                                message.timeZone = String(object.timeZone);
                            if (object.orderBys) {
                                if (!Array.isArray(object.orderBys))
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.orderBys: array expected");
                                message.orderBys = [];
                                for (var i = 0; i < object.orderBys.length; ++i) {
                                    if (typeof object.orderBys[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.RunAccessReportRequest.orderBys: object expected");
                                    message.orderBys[i] = $root.google.analytics.admin.v1beta.AccessOrderBy.fromObject(object.orderBys[i]);
                                }
                            }
                            if (object.returnEntityQuota != null)
                                message.returnEntityQuota = Boolean(object.returnEntityQuota);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RunAccessReportRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.RunAccessReportRequest} message RunAccessReportRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RunAccessReportRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dimensions = [];
                                object.metrics = [];
                                object.dateRanges = [];
                                object.orderBys = [];
                            }
                            if (options.defaults) {
                                object.entity = "";
                                object.dimensionFilter = null;
                                object.metricFilter = null;
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.offset = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.offset = options.longs === String ? "0" : 0;
                                if ($util.Long) {
                                    var long = new $util.Long(0, 0, false);
                                    object.limit = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                                } else
                                    object.limit = options.longs === String ? "0" : 0;
                                object.timeZone = "";
                                object.returnEntityQuota = false;
                            }
                            if (message.entity != null && message.hasOwnProperty("entity"))
                                object.entity = message.entity;
                            if (message.dimensions && message.dimensions.length) {
                                object.dimensions = [];
                                for (var j = 0; j < message.dimensions.length; ++j)
                                    object.dimensions[j] = $root.google.analytics.admin.v1beta.AccessDimension.toObject(message.dimensions[j], options);
                            }
                            if (message.metrics && message.metrics.length) {
                                object.metrics = [];
                                for (var j = 0; j < message.metrics.length; ++j)
                                    object.metrics[j] = $root.google.analytics.admin.v1beta.AccessMetric.toObject(message.metrics[j], options);
                            }
                            if (message.dateRanges && message.dateRanges.length) {
                                object.dateRanges = [];
                                for (var j = 0; j < message.dateRanges.length; ++j)
                                    object.dateRanges[j] = $root.google.analytics.admin.v1beta.AccessDateRange.toObject(message.dateRanges[j], options);
                            }
                            if (message.dimensionFilter != null && message.hasOwnProperty("dimensionFilter"))
                                object.dimensionFilter = $root.google.analytics.admin.v1beta.AccessFilterExpression.toObject(message.dimensionFilter, options);
                            if (message.metricFilter != null && message.hasOwnProperty("metricFilter"))
                                object.metricFilter = $root.google.analytics.admin.v1beta.AccessFilterExpression.toObject(message.metricFilter, options);
                            if (message.offset != null && message.hasOwnProperty("offset"))
                                if (typeof message.offset === "number")
                                    object.offset = options.longs === String ? String(message.offset) : message.offset;
                                else
                                    object.offset = options.longs === String ? $util.Long.prototype.toString.call(message.offset) : options.longs === Number ? new $util.LongBits(message.offset.low >>> 0, message.offset.high >>> 0).toNumber() : message.offset;
                            if (message.limit != null && message.hasOwnProperty("limit"))
                                if (typeof message.limit === "number")
                                    object.limit = options.longs === String ? String(message.limit) : message.limit;
                                else
                                    object.limit = options.longs === String ? $util.Long.prototype.toString.call(message.limit) : options.longs === Number ? new $util.LongBits(message.limit.low >>> 0, message.limit.high >>> 0).toNumber() : message.limit;
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                object.timeZone = message.timeZone;
                            if (message.orderBys && message.orderBys.length) {
                                object.orderBys = [];
                                for (var j = 0; j < message.orderBys.length; ++j)
                                    object.orderBys[j] = $root.google.analytics.admin.v1beta.AccessOrderBy.toObject(message.orderBys[j], options);
                            }
                            if (message.returnEntityQuota != null && message.hasOwnProperty("returnEntityQuota"))
                                object.returnEntityQuota = message.returnEntityQuota;
                            return object;
                        };
    
                        /**
                         * Converts this RunAccessReportRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RunAccessReportRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RunAccessReportRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.RunAccessReportRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RunAccessReportRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.RunAccessReportRequest";
                        };
    
                        return RunAccessReportRequest;
                    })();
    
                    v1beta.RunAccessReportResponse = (function() {
    
                        /**
                         * Properties of a RunAccessReportResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IRunAccessReportResponse
                         * @property {Array.<google.analytics.admin.v1beta.IAccessDimensionHeader>|null} [dimensionHeaders] RunAccessReportResponse dimensionHeaders
                         * @property {Array.<google.analytics.admin.v1beta.IAccessMetricHeader>|null} [metricHeaders] RunAccessReportResponse metricHeaders
                         * @property {Array.<google.analytics.admin.v1beta.IAccessRow>|null} [rows] RunAccessReportResponse rows
                         * @property {number|null} [rowCount] RunAccessReportResponse rowCount
                         * @property {google.analytics.admin.v1beta.IAccessQuota|null} [quota] RunAccessReportResponse quota
                         */
    
                        /**
                         * Constructs a new RunAccessReportResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a RunAccessReportResponse.
                         * @implements IRunAccessReportResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IRunAccessReportResponse=} [properties] Properties to set
                         */
                        function RunAccessReportResponse(properties) {
                            this.dimensionHeaders = [];
                            this.metricHeaders = [];
                            this.rows = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RunAccessReportResponse dimensionHeaders.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessDimensionHeader>} dimensionHeaders
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.dimensionHeaders = $util.emptyArray;
    
                        /**
                         * RunAccessReportResponse metricHeaders.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessMetricHeader>} metricHeaders
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.metricHeaders = $util.emptyArray;
    
                        /**
                         * RunAccessReportResponse rows.
                         * @member {Array.<google.analytics.admin.v1beta.IAccessRow>} rows
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.rows = $util.emptyArray;
    
                        /**
                         * RunAccessReportResponse rowCount.
                         * @member {number} rowCount
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.rowCount = 0;
    
                        /**
                         * RunAccessReportResponse quota.
                         * @member {google.analytics.admin.v1beta.IAccessQuota|null|undefined} quota
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @instance
                         */
                        RunAccessReportResponse.prototype.quota = null;
    
                        /**
                         * Creates a new RunAccessReportResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IRunAccessReportResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.RunAccessReportResponse} RunAccessReportResponse instance
                         */
                        RunAccessReportResponse.create = function create(properties) {
                            return new RunAccessReportResponse(properties);
                        };
    
                        /**
                         * Encodes the specified RunAccessReportResponse message. Does not implicitly {@link google.analytics.admin.v1beta.RunAccessReportResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IRunAccessReportResponse} message RunAccessReportResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dimensionHeaders != null && message.dimensionHeaders.length)
                                for (var i = 0; i < message.dimensionHeaders.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessDimensionHeader.encode(message.dimensionHeaders[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.metricHeaders != null && message.metricHeaders.length)
                                for (var i = 0; i < message.metricHeaders.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessMetricHeader.encode(message.metricHeaders[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.rows != null && message.rows.length)
                                for (var i = 0; i < message.rows.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccessRow.encode(message.rows[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.rowCount != null && Object.hasOwnProperty.call(message, "rowCount"))
                                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.rowCount);
                            if (message.quota != null && Object.hasOwnProperty.call(message, "quota"))
                                $root.google.analytics.admin.v1beta.AccessQuota.encode(message.quota, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RunAccessReportResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.RunAccessReportResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IRunAccessReportResponse} message RunAccessReportResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RunAccessReportResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RunAccessReportResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.RunAccessReportResponse} RunAccessReportResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.RunAccessReportResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.dimensionHeaders && message.dimensionHeaders.length))
                                            message.dimensionHeaders = [];
                                        message.dimensionHeaders.push($root.google.analytics.admin.v1beta.AccessDimensionHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        if (!(message.metricHeaders && message.metricHeaders.length))
                                            message.metricHeaders = [];
                                        message.metricHeaders.push($root.google.analytics.admin.v1beta.AccessMetricHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3: {
                                        if (!(message.rows && message.rows.length))
                                            message.rows = [];
                                        message.rows.push($root.google.analytics.admin.v1beta.AccessRow.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 4: {
                                        message.rowCount = reader.int32();
                                        break;
                                    }
                                case 5: {
                                        message.quota = $root.google.analytics.admin.v1beta.AccessQuota.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RunAccessReportResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.RunAccessReportResponse} RunAccessReportResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RunAccessReportResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RunAccessReportResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RunAccessReportResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dimensionHeaders != null && message.hasOwnProperty("dimensionHeaders")) {
                                if (!Array.isArray(message.dimensionHeaders))
                                    return "dimensionHeaders: array expected";
                                for (var i = 0; i < message.dimensionHeaders.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessDimensionHeader.verify(message.dimensionHeaders[i]);
                                    if (error)
                                        return "dimensionHeaders." + error;
                                }
                            }
                            if (message.metricHeaders != null && message.hasOwnProperty("metricHeaders")) {
                                if (!Array.isArray(message.metricHeaders))
                                    return "metricHeaders: array expected";
                                for (var i = 0; i < message.metricHeaders.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessMetricHeader.verify(message.metricHeaders[i]);
                                    if (error)
                                        return "metricHeaders." + error;
                                }
                            }
                            if (message.rows != null && message.hasOwnProperty("rows")) {
                                if (!Array.isArray(message.rows))
                                    return "rows: array expected";
                                for (var i = 0; i < message.rows.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccessRow.verify(message.rows[i]);
                                    if (error)
                                        return "rows." + error;
                                }
                            }
                            if (message.rowCount != null && message.hasOwnProperty("rowCount"))
                                if (!$util.isInteger(message.rowCount))
                                    return "rowCount: integer expected";
                            if (message.quota != null && message.hasOwnProperty("quota")) {
                                var error = $root.google.analytics.admin.v1beta.AccessQuota.verify(message.quota);
                                if (error)
                                    return "quota." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RunAccessReportResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.RunAccessReportResponse} RunAccessReportResponse
                         */
                        RunAccessReportResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.RunAccessReportResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.RunAccessReportResponse();
                            if (object.dimensionHeaders) {
                                if (!Array.isArray(object.dimensionHeaders))
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportResponse.dimensionHeaders: array expected");
                                message.dimensionHeaders = [];
                                for (var i = 0; i < object.dimensionHeaders.length; ++i) {
                                    if (typeof object.dimensionHeaders[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.RunAccessReportResponse.dimensionHeaders: object expected");
                                    message.dimensionHeaders[i] = $root.google.analytics.admin.v1beta.AccessDimensionHeader.fromObject(object.dimensionHeaders[i]);
                                }
                            }
                            if (object.metricHeaders) {
                                if (!Array.isArray(object.metricHeaders))
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportResponse.metricHeaders: array expected");
                                message.metricHeaders = [];
                                for (var i = 0; i < object.metricHeaders.length; ++i) {
                                    if (typeof object.metricHeaders[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.RunAccessReportResponse.metricHeaders: object expected");
                                    message.metricHeaders[i] = $root.google.analytics.admin.v1beta.AccessMetricHeader.fromObject(object.metricHeaders[i]);
                                }
                            }
                            if (object.rows) {
                                if (!Array.isArray(object.rows))
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportResponse.rows: array expected");
                                message.rows = [];
                                for (var i = 0; i < object.rows.length; ++i) {
                                    if (typeof object.rows[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.RunAccessReportResponse.rows: object expected");
                                    message.rows[i] = $root.google.analytics.admin.v1beta.AccessRow.fromObject(object.rows[i]);
                                }
                            }
                            if (object.rowCount != null)
                                message.rowCount = object.rowCount | 0;
                            if (object.quota != null) {
                                if (typeof object.quota !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.RunAccessReportResponse.quota: object expected");
                                message.quota = $root.google.analytics.admin.v1beta.AccessQuota.fromObject(object.quota);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RunAccessReportResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.RunAccessReportResponse} message RunAccessReportResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RunAccessReportResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dimensionHeaders = [];
                                object.metricHeaders = [];
                                object.rows = [];
                            }
                            if (options.defaults) {
                                object.rowCount = 0;
                                object.quota = null;
                            }
                            if (message.dimensionHeaders && message.dimensionHeaders.length) {
                                object.dimensionHeaders = [];
                                for (var j = 0; j < message.dimensionHeaders.length; ++j)
                                    object.dimensionHeaders[j] = $root.google.analytics.admin.v1beta.AccessDimensionHeader.toObject(message.dimensionHeaders[j], options);
                            }
                            if (message.metricHeaders && message.metricHeaders.length) {
                                object.metricHeaders = [];
                                for (var j = 0; j < message.metricHeaders.length; ++j)
                                    object.metricHeaders[j] = $root.google.analytics.admin.v1beta.AccessMetricHeader.toObject(message.metricHeaders[j], options);
                            }
                            if (message.rows && message.rows.length) {
                                object.rows = [];
                                for (var j = 0; j < message.rows.length; ++j)
                                    object.rows[j] = $root.google.analytics.admin.v1beta.AccessRow.toObject(message.rows[j], options);
                            }
                            if (message.rowCount != null && message.hasOwnProperty("rowCount"))
                                object.rowCount = message.rowCount;
                            if (message.quota != null && message.hasOwnProperty("quota"))
                                object.quota = $root.google.analytics.admin.v1beta.AccessQuota.toObject(message.quota, options);
                            return object;
                        };
    
                        /**
                         * Converts this RunAccessReportResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RunAccessReportResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RunAccessReportResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.RunAccessReportResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RunAccessReportResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.RunAccessReportResponse";
                        };
    
                        return RunAccessReportResponse;
                    })();
    
                    v1beta.GetAccountRequest = (function() {
    
                        /**
                         * Properties of a GetAccountRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetAccountRequest
                         * @property {string|null} [name] GetAccountRequest name
                         */
    
                        /**
                         * Constructs a new GetAccountRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetAccountRequest.
                         * @implements IGetAccountRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetAccountRequest=} [properties] Properties to set
                         */
                        function GetAccountRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAccountRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @instance
                         */
                        GetAccountRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetAccountRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetAccountRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetAccountRequest} GetAccountRequest instance
                         */
                        GetAccountRequest.create = function create(properties) {
                            return new GetAccountRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAccountRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetAccountRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetAccountRequest} message GetAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAccountRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetAccountRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetAccountRequest} message GetAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAccountRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAccountRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetAccountRequest} GetAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetAccountRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAccountRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetAccountRequest} GetAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAccountRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAccountRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAccountRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAccountRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetAccountRequest} GetAccountRequest
                         */
                        GetAccountRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetAccountRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetAccountRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAccountRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetAccountRequest} message GetAccountRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAccountRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetAccountRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAccountRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAccountRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetAccountRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAccountRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetAccountRequest";
                        };
    
                        return GetAccountRequest;
                    })();
    
                    v1beta.ListAccountsRequest = (function() {
    
                        /**
                         * Properties of a ListAccountsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListAccountsRequest
                         * @property {number|null} [pageSize] ListAccountsRequest pageSize
                         * @property {string|null} [pageToken] ListAccountsRequest pageToken
                         * @property {boolean|null} [showDeleted] ListAccountsRequest showDeleted
                         */
    
                        /**
                         * Constructs a new ListAccountsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListAccountsRequest.
                         * @implements IListAccountsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListAccountsRequest=} [properties] Properties to set
                         */
                        function ListAccountsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @instance
                         */
                        ListAccountsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListAccountsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @instance
                         */
                        ListAccountsRequest.prototype.pageToken = "";
    
                        /**
                         * ListAccountsRequest showDeleted.
                         * @member {boolean} showDeleted
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @instance
                         */
                        ListAccountsRequest.prototype.showDeleted = false;
    
                        /**
                         * Creates a new ListAccountsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListAccountsRequest} ListAccountsRequest instance
                         */
                        ListAccountsRequest.create = function create(properties) {
                            return new ListAccountsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountsRequest} message ListAccountsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.pageToken);
                            if (message.showDeleted != null && Object.hasOwnProperty.call(message, "showDeleted"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.showDeleted);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountsRequest} message ListAccountsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListAccountsRequest} ListAccountsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListAccountsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.showDeleted = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListAccountsRequest} ListAccountsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                if (typeof message.showDeleted !== "boolean")
                                    return "showDeleted: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListAccountsRequest} ListAccountsRequest
                         */
                        ListAccountsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListAccountsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListAccountsRequest();
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.showDeleted != null)
                                message.showDeleted = Boolean(object.showDeleted);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListAccountsRequest} message ListAccountsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.pageSize = 0;
                                object.pageToken = "";
                                object.showDeleted = false;
                            }
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                object.showDeleted = message.showDeleted;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListAccountsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListAccountsRequest";
                        };
    
                        return ListAccountsRequest;
                    })();
    
                    v1beta.ListAccountsResponse = (function() {
    
                        /**
                         * Properties of a ListAccountsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListAccountsResponse
                         * @property {Array.<google.analytics.admin.v1beta.IAccount>|null} [accounts] ListAccountsResponse accounts
                         * @property {string|null} [nextPageToken] ListAccountsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListAccountsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListAccountsResponse.
                         * @implements IListAccountsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListAccountsResponse=} [properties] Properties to set
                         */
                        function ListAccountsResponse(properties) {
                            this.accounts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountsResponse accounts.
                         * @member {Array.<google.analytics.admin.v1beta.IAccount>} accounts
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @instance
                         */
                        ListAccountsResponse.prototype.accounts = $util.emptyArray;
    
                        /**
                         * ListAccountsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @instance
                         */
                        ListAccountsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListAccountsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListAccountsResponse} ListAccountsResponse instance
                         */
                        ListAccountsResponse.create = function create(properties) {
                            return new ListAccountsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountsResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountsResponse} message ListAccountsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accounts != null && message.accounts.length)
                                for (var i = 0; i < message.accounts.length; ++i)
                                    $root.google.analytics.admin.v1beta.Account.encode(message.accounts[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountsResponse} message ListAccountsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListAccountsResponse} ListAccountsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListAccountsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accounts && message.accounts.length))
                                            message.accounts = [];
                                        message.accounts.push($root.google.analytics.admin.v1beta.Account.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListAccountsResponse} ListAccountsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accounts != null && message.hasOwnProperty("accounts")) {
                                if (!Array.isArray(message.accounts))
                                    return "accounts: array expected";
                                for (var i = 0; i < message.accounts.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.Account.verify(message.accounts[i]);
                                    if (error)
                                        return "accounts." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListAccountsResponse} ListAccountsResponse
                         */
                        ListAccountsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListAccountsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListAccountsResponse();
                            if (object.accounts) {
                                if (!Array.isArray(object.accounts))
                                    throw TypeError(".google.analytics.admin.v1beta.ListAccountsResponse.accounts: array expected");
                                message.accounts = [];
                                for (var i = 0; i < object.accounts.length; ++i) {
                                    if (typeof object.accounts[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListAccountsResponse.accounts: object expected");
                                    message.accounts[i] = $root.google.analytics.admin.v1beta.Account.fromObject(object.accounts[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListAccountsResponse} message ListAccountsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accounts = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.accounts && message.accounts.length) {
                                object.accounts = [];
                                for (var j = 0; j < message.accounts.length; ++j)
                                    object.accounts[j] = $root.google.analytics.admin.v1beta.Account.toObject(message.accounts[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListAccountsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListAccountsResponse";
                        };
    
                        return ListAccountsResponse;
                    })();
    
                    v1beta.DeleteAccountRequest = (function() {
    
                        /**
                         * Properties of a DeleteAccountRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDeleteAccountRequest
                         * @property {string|null} [name] DeleteAccountRequest name
                         */
    
                        /**
                         * Constructs a new DeleteAccountRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DeleteAccountRequest.
                         * @implements IDeleteAccountRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDeleteAccountRequest=} [properties] Properties to set
                         */
                        function DeleteAccountRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAccountRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @instance
                         */
                        DeleteAccountRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteAccountRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteAccountRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DeleteAccountRequest} DeleteAccountRequest instance
                         */
                        DeleteAccountRequest.create = function create(properties) {
                            return new DeleteAccountRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAccountRequest message. Does not implicitly {@link google.analytics.admin.v1beta.DeleteAccountRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteAccountRequest} message DeleteAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccountRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAccountRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DeleteAccountRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteAccountRequest} message DeleteAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccountRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAccountRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DeleteAccountRequest} DeleteAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccountRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DeleteAccountRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAccountRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DeleteAccountRequest} DeleteAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccountRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAccountRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAccountRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAccountRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DeleteAccountRequest} DeleteAccountRequest
                         */
                        DeleteAccountRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DeleteAccountRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DeleteAccountRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAccountRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.DeleteAccountRequest} message DeleteAccountRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAccountRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAccountRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAccountRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAccountRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DeleteAccountRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAccountRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DeleteAccountRequest";
                        };
    
                        return DeleteAccountRequest;
                    })();
    
                    v1beta.UpdateAccountRequest = (function() {
    
                        /**
                         * Properties of an UpdateAccountRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdateAccountRequest
                         * @property {google.analytics.admin.v1beta.IAccount|null} [account] UpdateAccountRequest account
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateAccountRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateAccountRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdateAccountRequest.
                         * @implements IUpdateAccountRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdateAccountRequest=} [properties] Properties to set
                         */
                        function UpdateAccountRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateAccountRequest account.
                         * @member {google.analytics.admin.v1beta.IAccount|null|undefined} account
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @instance
                         */
                        UpdateAccountRequest.prototype.account = null;
    
                        /**
                         * UpdateAccountRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @instance
                         */
                        UpdateAccountRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateAccountRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateAccountRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdateAccountRequest} UpdateAccountRequest instance
                         */
                        UpdateAccountRequest.create = function create(properties) {
                            return new UpdateAccountRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateAccountRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdateAccountRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateAccountRequest} message UpdateAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccountRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                $root.google.analytics.admin.v1beta.Account.encode(message.account, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateAccountRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdateAccountRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateAccountRequest} message UpdateAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccountRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateAccountRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdateAccountRequest} UpdateAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccountRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdateAccountRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.account = $root.google.analytics.admin.v1beta.Account.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateAccountRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdateAccountRequest} UpdateAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccountRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateAccountRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateAccountRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.account != null && message.hasOwnProperty("account")) {
                                var error = $root.google.analytics.admin.v1beta.Account.verify(message.account);
                                if (error)
                                    return "account." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateAccountRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdateAccountRequest} UpdateAccountRequest
                         */
                        UpdateAccountRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdateAccountRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdateAccountRequest();
                            if (object.account != null) {
                                if (typeof object.account !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateAccountRequest.account: object expected");
                                message.account = $root.google.analytics.admin.v1beta.Account.fromObject(object.account);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateAccountRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateAccountRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdateAccountRequest} message UpdateAccountRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateAccountRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.account = null;
                                object.updateMask = null;
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = $root.google.analytics.admin.v1beta.Account.toObject(message.account, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateAccountRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateAccountRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateAccountRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdateAccountRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateAccountRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdateAccountRequest";
                        };
    
                        return UpdateAccountRequest;
                    })();
    
                    v1beta.ProvisionAccountTicketRequest = (function() {
    
                        /**
                         * Properties of a ProvisionAccountTicketRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IProvisionAccountTicketRequest
                         * @property {google.analytics.admin.v1beta.IAccount|null} [account] ProvisionAccountTicketRequest account
                         * @property {string|null} [redirectUri] ProvisionAccountTicketRequest redirectUri
                         */
    
                        /**
                         * Constructs a new ProvisionAccountTicketRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ProvisionAccountTicketRequest.
                         * @implements IProvisionAccountTicketRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketRequest=} [properties] Properties to set
                         */
                        function ProvisionAccountTicketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProvisionAccountTicketRequest account.
                         * @member {google.analytics.admin.v1beta.IAccount|null|undefined} account
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @instance
                         */
                        ProvisionAccountTicketRequest.prototype.account = null;
    
                        /**
                         * ProvisionAccountTicketRequest redirectUri.
                         * @member {string} redirectUri
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @instance
                         */
                        ProvisionAccountTicketRequest.prototype.redirectUri = "";
    
                        /**
                         * Creates a new ProvisionAccountTicketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest instance
                         */
                        ProvisionAccountTicketRequest.create = function create(properties) {
                            return new ProvisionAccountTicketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ProvisionAccountTicketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketRequest} message ProvisionAccountTicketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                $root.google.analytics.admin.v1beta.Account.encode(message.account, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.redirectUri != null && Object.hasOwnProperty.call(message, "redirectUri"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.redirectUri);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ProvisionAccountTicketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketRequest} message ProvisionAccountTicketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ProvisionAccountTicketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.account = $root.google.analytics.admin.v1beta.Account.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.redirectUri = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProvisionAccountTicketRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProvisionAccountTicketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.account != null && message.hasOwnProperty("account")) {
                                var error = $root.google.analytics.admin.v1beta.Account.verify(message.account);
                                if (error)
                                    return "account." + error;
                            }
                            if (message.redirectUri != null && message.hasOwnProperty("redirectUri"))
                                if (!$util.isString(message.redirectUri))
                                    return "redirectUri: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ProvisionAccountTicketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketRequest} ProvisionAccountTicketRequest
                         */
                        ProvisionAccountTicketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ProvisionAccountTicketRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ProvisionAccountTicketRequest();
                            if (object.account != null) {
                                if (typeof object.account !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.ProvisionAccountTicketRequest.account: object expected");
                                message.account = $root.google.analytics.admin.v1beta.Account.fromObject(object.account);
                            }
                            if (object.redirectUri != null)
                                message.redirectUri = String(object.redirectUri);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProvisionAccountTicketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ProvisionAccountTicketRequest} message ProvisionAccountTicketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProvisionAccountTicketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.account = null;
                                object.redirectUri = "";
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = $root.google.analytics.admin.v1beta.Account.toObject(message.account, options);
                            if (message.redirectUri != null && message.hasOwnProperty("redirectUri"))
                                object.redirectUri = message.redirectUri;
                            return object;
                        };
    
                        /**
                         * Converts this ProvisionAccountTicketRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProvisionAccountTicketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProvisionAccountTicketRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProvisionAccountTicketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ProvisionAccountTicketRequest";
                        };
    
                        return ProvisionAccountTicketRequest;
                    })();
    
                    v1beta.ProvisionAccountTicketResponse = (function() {
    
                        /**
                         * Properties of a ProvisionAccountTicketResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IProvisionAccountTicketResponse
                         * @property {string|null} [accountTicketId] ProvisionAccountTicketResponse accountTicketId
                         */
    
                        /**
                         * Constructs a new ProvisionAccountTicketResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ProvisionAccountTicketResponse.
                         * @implements IProvisionAccountTicketResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketResponse=} [properties] Properties to set
                         */
                        function ProvisionAccountTicketResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProvisionAccountTicketResponse accountTicketId.
                         * @member {string} accountTicketId
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @instance
                         */
                        ProvisionAccountTicketResponse.prototype.accountTicketId = "";
    
                        /**
                         * Creates a new ProvisionAccountTicketResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse instance
                         */
                        ProvisionAccountTicketResponse.create = function create(properties) {
                            return new ProvisionAccountTicketResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ProvisionAccountTicketResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketResponse} message ProvisionAccountTicketResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accountTicketId != null && Object.hasOwnProperty.call(message, "accountTicketId"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.accountTicketId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProvisionAccountTicketResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ProvisionAccountTicketResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IProvisionAccountTicketResponse} message ProvisionAccountTicketResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProvisionAccountTicketResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ProvisionAccountTicketResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.accountTicketId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProvisionAccountTicketResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProvisionAccountTicketResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProvisionAccountTicketResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProvisionAccountTicketResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accountTicketId != null && message.hasOwnProperty("accountTicketId"))
                                if (!$util.isString(message.accountTicketId))
                                    return "accountTicketId: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ProvisionAccountTicketResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ProvisionAccountTicketResponse} ProvisionAccountTicketResponse
                         */
                        ProvisionAccountTicketResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ProvisionAccountTicketResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ProvisionAccountTicketResponse();
                            if (object.accountTicketId != null)
                                message.accountTicketId = String(object.accountTicketId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProvisionAccountTicketResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ProvisionAccountTicketResponse} message ProvisionAccountTicketResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProvisionAccountTicketResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.accountTicketId = "";
                            if (message.accountTicketId != null && message.hasOwnProperty("accountTicketId"))
                                object.accountTicketId = message.accountTicketId;
                            return object;
                        };
    
                        /**
                         * Converts this ProvisionAccountTicketResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProvisionAccountTicketResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProvisionAccountTicketResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ProvisionAccountTicketResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProvisionAccountTicketResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ProvisionAccountTicketResponse";
                        };
    
                        return ProvisionAccountTicketResponse;
                    })();
    
                    v1beta.GetPropertyRequest = (function() {
    
                        /**
                         * Properties of a GetPropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetPropertyRequest
                         * @property {string|null} [name] GetPropertyRequest name
                         */
    
                        /**
                         * Constructs a new GetPropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetPropertyRequest.
                         * @implements IGetPropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetPropertyRequest=} [properties] Properties to set
                         */
                        function GetPropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetPropertyRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @instance
                         */
                        GetPropertyRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetPropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetPropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetPropertyRequest} GetPropertyRequest instance
                         */
                        GetPropertyRequest.create = function create(properties) {
                            return new GetPropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetPropertyRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetPropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetPropertyRequest} message GetPropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetPropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetPropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetPropertyRequest} message GetPropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetPropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetPropertyRequest} GetPropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetPropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetPropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetPropertyRequest} GetPropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetPropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetPropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetPropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetPropertyRequest} GetPropertyRequest
                         */
                        GetPropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetPropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetPropertyRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetPropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetPropertyRequest} message GetPropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetPropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetPropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetPropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetPropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetPropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetPropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetPropertyRequest";
                        };
    
                        return GetPropertyRequest;
                    })();
    
                    v1beta.ListPropertiesRequest = (function() {
    
                        /**
                         * Properties of a ListPropertiesRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListPropertiesRequest
                         * @property {string|null} [filter] ListPropertiesRequest filter
                         * @property {number|null} [pageSize] ListPropertiesRequest pageSize
                         * @property {string|null} [pageToken] ListPropertiesRequest pageToken
                         * @property {boolean|null} [showDeleted] ListPropertiesRequest showDeleted
                         */
    
                        /**
                         * Constructs a new ListPropertiesRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListPropertiesRequest.
                         * @implements IListPropertiesRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListPropertiesRequest=} [properties] Properties to set
                         */
                        function ListPropertiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPropertiesRequest filter.
                         * @member {string} filter
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.filter = "";
    
                        /**
                         * ListPropertiesRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.pageSize = 0;
    
                        /**
                         * ListPropertiesRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.pageToken = "";
    
                        /**
                         * ListPropertiesRequest showDeleted.
                         * @member {boolean} showDeleted
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @instance
                         */
                        ListPropertiesRequest.prototype.showDeleted = false;
    
                        /**
                         * Creates a new ListPropertiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListPropertiesRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListPropertiesRequest} ListPropertiesRequest instance
                         */
                        ListPropertiesRequest.create = function create(properties) {
                            return new ListPropertiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPropertiesRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListPropertiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListPropertiesRequest} message ListPropertiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.filter);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            if (message.showDeleted != null && Object.hasOwnProperty.call(message, "showDeleted"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.showDeleted);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPropertiesRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListPropertiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListPropertiesRequest} message ListPropertiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPropertiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListPropertiesRequest} ListPropertiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListPropertiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.showDeleted = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPropertiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListPropertiesRequest} ListPropertiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPropertiesRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPropertiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.filter != null && message.hasOwnProperty("filter"))
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                if (typeof message.showDeleted !== "boolean")
                                    return "showDeleted: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListPropertiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListPropertiesRequest} ListPropertiesRequest
                         */
                        ListPropertiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListPropertiesRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListPropertiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.showDeleted != null)
                                message.showDeleted = Boolean(object.showDeleted);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPropertiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListPropertiesRequest} message ListPropertiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPropertiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.filter = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                                object.showDeleted = false;
                            }
                            if (message.filter != null && message.hasOwnProperty("filter"))
                                object.filter = message.filter;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            if (message.showDeleted != null && message.hasOwnProperty("showDeleted"))
                                object.showDeleted = message.showDeleted;
                            return object;
                        };
    
                        /**
                         * Converts this ListPropertiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPropertiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPropertiesRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListPropertiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPropertiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListPropertiesRequest";
                        };
    
                        return ListPropertiesRequest;
                    })();
    
                    v1beta.ListPropertiesResponse = (function() {
    
                        /**
                         * Properties of a ListPropertiesResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListPropertiesResponse
                         * @property {Array.<google.analytics.admin.v1beta.IProperty>|null} [properties] ListPropertiesResponse properties
                         * @property {string|null} [nextPageToken] ListPropertiesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListPropertiesResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListPropertiesResponse.
                         * @implements IListPropertiesResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListPropertiesResponse=} [properties] Properties to set
                         */
                        function ListPropertiesResponse(properties) {
                            this.properties = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPropertiesResponse properties.
                         * @member {Array.<google.analytics.admin.v1beta.IProperty>} properties
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @instance
                         */
                        ListPropertiesResponse.prototype.properties = $util.emptyArray;
    
                        /**
                         * ListPropertiesResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @instance
                         */
                        ListPropertiesResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListPropertiesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListPropertiesResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListPropertiesResponse} ListPropertiesResponse instance
                         */
                        ListPropertiesResponse.create = function create(properties) {
                            return new ListPropertiesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListPropertiesResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListPropertiesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListPropertiesResponse} message ListPropertiesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.properties != null && message.properties.length)
                                for (var i = 0; i < message.properties.length; ++i)
                                    $root.google.analytics.admin.v1beta.Property.encode(message.properties[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPropertiesResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListPropertiesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListPropertiesResponse} message ListPropertiesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPropertiesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPropertiesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListPropertiesResponse} ListPropertiesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListPropertiesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.properties && message.properties.length))
                                            message.properties = [];
                                        message.properties.push($root.google.analytics.admin.v1beta.Property.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPropertiesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListPropertiesResponse} ListPropertiesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPropertiesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPropertiesResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPropertiesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.properties != null && message.hasOwnProperty("properties")) {
                                if (!Array.isArray(message.properties))
                                    return "properties: array expected";
                                for (var i = 0; i < message.properties.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.Property.verify(message.properties[i]);
                                    if (error)
                                        return "properties." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListPropertiesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListPropertiesResponse} ListPropertiesResponse
                         */
                        ListPropertiesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListPropertiesResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListPropertiesResponse();
                            if (object.properties) {
                                if (!Array.isArray(object.properties))
                                    throw TypeError(".google.analytics.admin.v1beta.ListPropertiesResponse.properties: array expected");
                                message.properties = [];
                                for (var i = 0; i < object.properties.length; ++i) {
                                    if (typeof object.properties[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListPropertiesResponse.properties: object expected");
                                    message.properties[i] = $root.google.analytics.admin.v1beta.Property.fromObject(object.properties[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPropertiesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListPropertiesResponse} message ListPropertiesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPropertiesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.properties = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.properties && message.properties.length) {
                                object.properties = [];
                                for (var j = 0; j < message.properties.length; ++j)
                                    object.properties[j] = $root.google.analytics.admin.v1beta.Property.toObject(message.properties[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListPropertiesResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPropertiesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPropertiesResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListPropertiesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPropertiesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListPropertiesResponse";
                        };
    
                        return ListPropertiesResponse;
                    })();
    
                    v1beta.UpdatePropertyRequest = (function() {
    
                        /**
                         * Properties of an UpdatePropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdatePropertyRequest
                         * @property {google.analytics.admin.v1beta.IProperty|null} [property] UpdatePropertyRequest property
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdatePropertyRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdatePropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdatePropertyRequest.
                         * @implements IUpdatePropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdatePropertyRequest=} [properties] Properties to set
                         */
                        function UpdatePropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdatePropertyRequest property.
                         * @member {google.analytics.admin.v1beta.IProperty|null|undefined} property
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @instance
                         */
                        UpdatePropertyRequest.prototype.property = null;
    
                        /**
                         * UpdatePropertyRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @instance
                         */
                        UpdatePropertyRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdatePropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdatePropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdatePropertyRequest} UpdatePropertyRequest instance
                         */
                        UpdatePropertyRequest.create = function create(properties) {
                            return new UpdatePropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdatePropertyRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdatePropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdatePropertyRequest} message UpdatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                $root.google.analytics.admin.v1beta.Property.encode(message.property, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdatePropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdatePropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdatePropertyRequest} message UpdatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdatePropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdatePropertyRequest} UpdatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdatePropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = $root.google.analytics.admin.v1beta.Property.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdatePropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdatePropertyRequest} UpdatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdatePropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdatePropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property")) {
                                var error = $root.google.analytics.admin.v1beta.Property.verify(message.property);
                                if (error)
                                    return "property." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdatePropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdatePropertyRequest} UpdatePropertyRequest
                         */
                        UpdatePropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdatePropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdatePropertyRequest();
                            if (object.property != null) {
                                if (typeof object.property !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdatePropertyRequest.property: object expected");
                                message.property = $root.google.analytics.admin.v1beta.Property.fromObject(object.property);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdatePropertyRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdatePropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdatePropertyRequest} message UpdatePropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdatePropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = null;
                                object.updateMask = null;
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = $root.google.analytics.admin.v1beta.Property.toObject(message.property, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdatePropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdatePropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdatePropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdatePropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdatePropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdatePropertyRequest";
                        };
    
                        return UpdatePropertyRequest;
                    })();
    
                    v1beta.CreatePropertyRequest = (function() {
    
                        /**
                         * Properties of a CreatePropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreatePropertyRequest
                         * @property {google.analytics.admin.v1beta.IProperty|null} [property] CreatePropertyRequest property
                         */
    
                        /**
                         * Constructs a new CreatePropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreatePropertyRequest.
                         * @implements ICreatePropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreatePropertyRequest=} [properties] Properties to set
                         */
                        function CreatePropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreatePropertyRequest property.
                         * @member {google.analytics.admin.v1beta.IProperty|null|undefined} property
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @instance
                         */
                        CreatePropertyRequest.prototype.property = null;
    
                        /**
                         * Creates a new CreatePropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreatePropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreatePropertyRequest} CreatePropertyRequest instance
                         */
                        CreatePropertyRequest.create = function create(properties) {
                            return new CreatePropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreatePropertyRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreatePropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreatePropertyRequest} message CreatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreatePropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                $root.google.analytics.admin.v1beta.Property.encode(message.property, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreatePropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreatePropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreatePropertyRequest} message CreatePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreatePropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreatePropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreatePropertyRequest} CreatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreatePropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreatePropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = $root.google.analytics.admin.v1beta.Property.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreatePropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreatePropertyRequest} CreatePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreatePropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreatePropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreatePropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property")) {
                                var error = $root.google.analytics.admin.v1beta.Property.verify(message.property);
                                if (error)
                                    return "property." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreatePropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreatePropertyRequest} CreatePropertyRequest
                         */
                        CreatePropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreatePropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreatePropertyRequest();
                            if (object.property != null) {
                                if (typeof object.property !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreatePropertyRequest.property: object expected");
                                message.property = $root.google.analytics.admin.v1beta.Property.fromObject(object.property);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreatePropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreatePropertyRequest} message CreatePropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreatePropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.property = null;
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = $root.google.analytics.admin.v1beta.Property.toObject(message.property, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreatePropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreatePropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreatePropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreatePropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreatePropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreatePropertyRequest";
                        };
    
                        return CreatePropertyRequest;
                    })();
    
                    v1beta.DeletePropertyRequest = (function() {
    
                        /**
                         * Properties of a DeletePropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDeletePropertyRequest
                         * @property {string|null} [name] DeletePropertyRequest name
                         */
    
                        /**
                         * Constructs a new DeletePropertyRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DeletePropertyRequest.
                         * @implements IDeletePropertyRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDeletePropertyRequest=} [properties] Properties to set
                         */
                        function DeletePropertyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeletePropertyRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @instance
                         */
                        DeletePropertyRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeletePropertyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeletePropertyRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DeletePropertyRequest} DeletePropertyRequest instance
                         */
                        DeletePropertyRequest.create = function create(properties) {
                            return new DeletePropertyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeletePropertyRequest message. Does not implicitly {@link google.analytics.admin.v1beta.DeletePropertyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeletePropertyRequest} message DeletePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePropertyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeletePropertyRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DeletePropertyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeletePropertyRequest} message DeletePropertyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePropertyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeletePropertyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DeletePropertyRequest} DeletePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePropertyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DeletePropertyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeletePropertyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DeletePropertyRequest} DeletePropertyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePropertyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeletePropertyRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeletePropertyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeletePropertyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DeletePropertyRequest} DeletePropertyRequest
                         */
                        DeletePropertyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DeletePropertyRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DeletePropertyRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeletePropertyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.DeletePropertyRequest} message DeletePropertyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeletePropertyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeletePropertyRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeletePropertyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeletePropertyRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DeletePropertyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeletePropertyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DeletePropertyRequest";
                        };
    
                        return DeletePropertyRequest;
                    })();
    
                    v1beta.CreateFirebaseLinkRequest = (function() {
    
                        /**
                         * Properties of a CreateFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreateFirebaseLinkRequest
                         * @property {string|null} [parent] CreateFirebaseLinkRequest parent
                         * @property {google.analytics.admin.v1beta.IFirebaseLink|null} [firebaseLink] CreateFirebaseLinkRequest firebaseLink
                         */
    
                        /**
                         * Constructs a new CreateFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreateFirebaseLinkRequest.
                         * @implements ICreateFirebaseLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreateFirebaseLinkRequest=} [properties] Properties to set
                         */
                        function CreateFirebaseLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateFirebaseLinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @instance
                         */
                        CreateFirebaseLinkRequest.prototype.parent = "";
    
                        /**
                         * CreateFirebaseLinkRequest firebaseLink.
                         * @member {google.analytics.admin.v1beta.IFirebaseLink|null|undefined} firebaseLink
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @instance
                         */
                        CreateFirebaseLinkRequest.prototype.firebaseLink = null;
    
                        /**
                         * Creates a new CreateFirebaseLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateFirebaseLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest instance
                         */
                        CreateFirebaseLinkRequest.create = function create(properties) {
                            return new CreateFirebaseLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateFirebaseLinkRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreateFirebaseLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateFirebaseLinkRequest} message CreateFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateFirebaseLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.firebaseLink != null && Object.hasOwnProperty.call(message, "firebaseLink"))
                                $root.google.analytics.admin.v1beta.FirebaseLink.encode(message.firebaseLink, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateFirebaseLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreateFirebaseLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateFirebaseLinkRequest} message CreateFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateFirebaseLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateFirebaseLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateFirebaseLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreateFirebaseLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.firebaseLink = $root.google.analytics.admin.v1beta.FirebaseLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateFirebaseLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateFirebaseLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateFirebaseLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateFirebaseLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink")) {
                                var error = $root.google.analytics.admin.v1beta.FirebaseLink.verify(message.firebaseLink);
                                if (error)
                                    return "firebaseLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateFirebaseLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreateFirebaseLinkRequest} CreateFirebaseLinkRequest
                         */
                        CreateFirebaseLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreateFirebaseLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreateFirebaseLinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.firebaseLink != null) {
                                if (typeof object.firebaseLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreateFirebaseLinkRequest.firebaseLink: object expected");
                                message.firebaseLink = $root.google.analytics.admin.v1beta.FirebaseLink.fromObject(object.firebaseLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateFirebaseLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreateFirebaseLinkRequest} message CreateFirebaseLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateFirebaseLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.firebaseLink = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink"))
                                object.firebaseLink = $root.google.analytics.admin.v1beta.FirebaseLink.toObject(message.firebaseLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateFirebaseLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateFirebaseLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateFirebaseLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreateFirebaseLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateFirebaseLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreateFirebaseLinkRequest";
                        };
    
                        return CreateFirebaseLinkRequest;
                    })();
    
                    v1beta.DeleteFirebaseLinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDeleteFirebaseLinkRequest
                         * @property {string|null} [name] DeleteFirebaseLinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteFirebaseLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DeleteFirebaseLinkRequest.
                         * @implements IDeleteFirebaseLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDeleteFirebaseLinkRequest=} [properties] Properties to set
                         */
                        function DeleteFirebaseLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteFirebaseLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @instance
                         */
                        DeleteFirebaseLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteFirebaseLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteFirebaseLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest instance
                         */
                        DeleteFirebaseLinkRequest.create = function create(properties) {
                            return new DeleteFirebaseLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteFirebaseLinkRequest message. Does not implicitly {@link google.analytics.admin.v1beta.DeleteFirebaseLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteFirebaseLinkRequest} message DeleteFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirebaseLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteFirebaseLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DeleteFirebaseLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteFirebaseLinkRequest} message DeleteFirebaseLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirebaseLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteFirebaseLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirebaseLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DeleteFirebaseLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteFirebaseLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirebaseLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteFirebaseLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteFirebaseLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteFirebaseLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DeleteFirebaseLinkRequest} DeleteFirebaseLinkRequest
                         */
                        DeleteFirebaseLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DeleteFirebaseLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DeleteFirebaseLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteFirebaseLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.DeleteFirebaseLinkRequest} message DeleteFirebaseLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteFirebaseLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteFirebaseLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteFirebaseLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteFirebaseLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DeleteFirebaseLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteFirebaseLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DeleteFirebaseLinkRequest";
                        };
    
                        return DeleteFirebaseLinkRequest;
                    })();
    
                    v1beta.ListFirebaseLinksRequest = (function() {
    
                        /**
                         * Properties of a ListFirebaseLinksRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListFirebaseLinksRequest
                         * @property {string|null} [parent] ListFirebaseLinksRequest parent
                         * @property {number|null} [pageSize] ListFirebaseLinksRequest pageSize
                         * @property {string|null} [pageToken] ListFirebaseLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListFirebaseLinksRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListFirebaseLinksRequest.
                         * @implements IListFirebaseLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksRequest=} [properties] Properties to set
                         */
                        function ListFirebaseLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListFirebaseLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @instance
                         */
                        ListFirebaseLinksRequest.prototype.parent = "";
    
                        /**
                         * ListFirebaseLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @instance
                         */
                        ListFirebaseLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListFirebaseLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @instance
                         */
                        ListFirebaseLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListFirebaseLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksRequest} ListFirebaseLinksRequest instance
                         */
                        ListFirebaseLinksRequest.create = function create(properties) {
                            return new ListFirebaseLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListFirebaseLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksRequest} message ListFirebaseLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListFirebaseLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksRequest} message ListFirebaseLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksRequest} ListFirebaseLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListFirebaseLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksRequest} ListFirebaseLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListFirebaseLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListFirebaseLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListFirebaseLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksRequest} ListFirebaseLinksRequest
                         */
                        ListFirebaseLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListFirebaseLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListFirebaseLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListFirebaseLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListFirebaseLinksRequest} message ListFirebaseLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListFirebaseLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListFirebaseLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListFirebaseLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListFirebaseLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListFirebaseLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListFirebaseLinksRequest";
                        };
    
                        return ListFirebaseLinksRequest;
                    })();
    
                    v1beta.ListFirebaseLinksResponse = (function() {
    
                        /**
                         * Properties of a ListFirebaseLinksResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListFirebaseLinksResponse
                         * @property {Array.<google.analytics.admin.v1beta.IFirebaseLink>|null} [firebaseLinks] ListFirebaseLinksResponse firebaseLinks
                         * @property {string|null} [nextPageToken] ListFirebaseLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListFirebaseLinksResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListFirebaseLinksResponse.
                         * @implements IListFirebaseLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksResponse=} [properties] Properties to set
                         */
                        function ListFirebaseLinksResponse(properties) {
                            this.firebaseLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListFirebaseLinksResponse firebaseLinks.
                         * @member {Array.<google.analytics.admin.v1beta.IFirebaseLink>} firebaseLinks
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @instance
                         */
                        ListFirebaseLinksResponse.prototype.firebaseLinks = $util.emptyArray;
    
                        /**
                         * ListFirebaseLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @instance
                         */
                        ListFirebaseLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListFirebaseLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksResponse} ListFirebaseLinksResponse instance
                         */
                        ListFirebaseLinksResponse.create = function create(properties) {
                            return new ListFirebaseLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListFirebaseLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksResponse} message ListFirebaseLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.firebaseLinks != null && message.firebaseLinks.length)
                                for (var i = 0; i < message.firebaseLinks.length; ++i)
                                    $root.google.analytics.admin.v1beta.FirebaseLink.encode(message.firebaseLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListFirebaseLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListFirebaseLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListFirebaseLinksResponse} message ListFirebaseLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirebaseLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksResponse} ListFirebaseLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListFirebaseLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.firebaseLinks && message.firebaseLinks.length))
                                            message.firebaseLinks = [];
                                        message.firebaseLinks.push($root.google.analytics.admin.v1beta.FirebaseLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListFirebaseLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksResponse} ListFirebaseLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirebaseLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListFirebaseLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListFirebaseLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firebaseLinks != null && message.hasOwnProperty("firebaseLinks")) {
                                if (!Array.isArray(message.firebaseLinks))
                                    return "firebaseLinks: array expected";
                                for (var i = 0; i < message.firebaseLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.FirebaseLink.verify(message.firebaseLinks[i]);
                                    if (error)
                                        return "firebaseLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListFirebaseLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListFirebaseLinksResponse} ListFirebaseLinksResponse
                         */
                        ListFirebaseLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListFirebaseLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListFirebaseLinksResponse();
                            if (object.firebaseLinks) {
                                if (!Array.isArray(object.firebaseLinks))
                                    throw TypeError(".google.analytics.admin.v1beta.ListFirebaseLinksResponse.firebaseLinks: array expected");
                                message.firebaseLinks = [];
                                for (var i = 0; i < object.firebaseLinks.length; ++i) {
                                    if (typeof object.firebaseLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListFirebaseLinksResponse.firebaseLinks: object expected");
                                    message.firebaseLinks[i] = $root.google.analytics.admin.v1beta.FirebaseLink.fromObject(object.firebaseLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListFirebaseLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListFirebaseLinksResponse} message ListFirebaseLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListFirebaseLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.firebaseLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.firebaseLinks && message.firebaseLinks.length) {
                                object.firebaseLinks = [];
                                for (var j = 0; j < message.firebaseLinks.length; ++j)
                                    object.firebaseLinks[j] = $root.google.analytics.admin.v1beta.FirebaseLink.toObject(message.firebaseLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListFirebaseLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListFirebaseLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListFirebaseLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListFirebaseLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListFirebaseLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListFirebaseLinksResponse";
                        };
    
                        return ListFirebaseLinksResponse;
                    })();
    
                    v1beta.CreateGoogleAdsLinkRequest = (function() {
    
                        /**
                         * Properties of a CreateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreateGoogleAdsLinkRequest
                         * @property {string|null} [parent] CreateGoogleAdsLinkRequest parent
                         * @property {google.analytics.admin.v1beta.IGoogleAdsLink|null} [googleAdsLink] CreateGoogleAdsLinkRequest googleAdsLink
                         */
    
                        /**
                         * Constructs a new CreateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreateGoogleAdsLinkRequest.
                         * @implements ICreateGoogleAdsLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreateGoogleAdsLinkRequest=} [properties] Properties to set
                         */
                        function CreateGoogleAdsLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateGoogleAdsLinkRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @instance
                         */
                        CreateGoogleAdsLinkRequest.prototype.parent = "";
    
                        /**
                         * CreateGoogleAdsLinkRequest googleAdsLink.
                         * @member {google.analytics.admin.v1beta.IGoogleAdsLink|null|undefined} googleAdsLink
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @instance
                         */
                        CreateGoogleAdsLinkRequest.prototype.googleAdsLink = null;
    
                        /**
                         * Creates a new CreateGoogleAdsLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateGoogleAdsLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest instance
                         */
                        CreateGoogleAdsLinkRequest.create = function create(properties) {
                            return new CreateGoogleAdsLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateGoogleAdsLinkRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateGoogleAdsLinkRequest} message CreateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateGoogleAdsLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.googleAdsLink != null && Object.hasOwnProperty.call(message, "googleAdsLink"))
                                $root.google.analytics.admin.v1beta.GoogleAdsLink.encode(message.googleAdsLink, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateGoogleAdsLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateGoogleAdsLinkRequest} message CreateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateGoogleAdsLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateGoogleAdsLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateGoogleAdsLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateGoogleAdsLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateGoogleAdsLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateGoogleAdsLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateGoogleAdsLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                var error = $root.google.analytics.admin.v1beta.GoogleAdsLink.verify(message.googleAdsLink);
                                if (error)
                                    return "googleAdsLink." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateGoogleAdsLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest} CreateGoogleAdsLinkRequest
                         */
                        CreateGoogleAdsLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.googleAdsLink != null) {
                                if (typeof object.googleAdsLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest.googleAdsLink: object expected");
                                message.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.fromObject(object.googleAdsLink);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateGoogleAdsLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest} message CreateGoogleAdsLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateGoogleAdsLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.googleAdsLink = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink"))
                                object.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.toObject(message.googleAdsLink, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateGoogleAdsLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateGoogleAdsLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateGoogleAdsLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateGoogleAdsLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreateGoogleAdsLinkRequest";
                        };
    
                        return CreateGoogleAdsLinkRequest;
                    })();
    
                    v1beta.UpdateGoogleAdsLinkRequest = (function() {
    
                        /**
                         * Properties of an UpdateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdateGoogleAdsLinkRequest
                         * @property {google.analytics.admin.v1beta.IGoogleAdsLink|null} [googleAdsLink] UpdateGoogleAdsLinkRequest googleAdsLink
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateGoogleAdsLinkRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdateGoogleAdsLinkRequest.
                         * @implements IUpdateGoogleAdsLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdateGoogleAdsLinkRequest=} [properties] Properties to set
                         */
                        function UpdateGoogleAdsLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateGoogleAdsLinkRequest googleAdsLink.
                         * @member {google.analytics.admin.v1beta.IGoogleAdsLink|null|undefined} googleAdsLink
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @instance
                         */
                        UpdateGoogleAdsLinkRequest.prototype.googleAdsLink = null;
    
                        /**
                         * UpdateGoogleAdsLinkRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @instance
                         */
                        UpdateGoogleAdsLinkRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateGoogleAdsLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateGoogleAdsLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest instance
                         */
                        UpdateGoogleAdsLinkRequest.create = function create(properties) {
                            return new UpdateGoogleAdsLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateGoogleAdsLinkRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateGoogleAdsLinkRequest} message UpdateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateGoogleAdsLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleAdsLink != null && Object.hasOwnProperty.call(message, "googleAdsLink"))
                                $root.google.analytics.admin.v1beta.GoogleAdsLink.encode(message.googleAdsLink, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateGoogleAdsLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateGoogleAdsLinkRequest} message UpdateGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateGoogleAdsLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateGoogleAdsLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateGoogleAdsLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateGoogleAdsLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateGoogleAdsLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateGoogleAdsLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateGoogleAdsLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                var error = $root.google.analytics.admin.v1beta.GoogleAdsLink.verify(message.googleAdsLink);
                                if (error)
                                    return "googleAdsLink." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateGoogleAdsLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest} UpdateGoogleAdsLinkRequest
                         */
                        UpdateGoogleAdsLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest();
                            if (object.googleAdsLink != null) {
                                if (typeof object.googleAdsLink !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest.googleAdsLink: object expected");
                                message.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.fromObject(object.googleAdsLink);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateGoogleAdsLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest} message UpdateGoogleAdsLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateGoogleAdsLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.googleAdsLink = null;
                                object.updateMask = null;
                            }
                            if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink"))
                                object.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.toObject(message.googleAdsLink, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateGoogleAdsLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateGoogleAdsLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateGoogleAdsLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateGoogleAdsLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdateGoogleAdsLinkRequest";
                        };
    
                        return UpdateGoogleAdsLinkRequest;
                    })();
    
                    v1beta.DeleteGoogleAdsLinkRequest = (function() {
    
                        /**
                         * Properties of a DeleteGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDeleteGoogleAdsLinkRequest
                         * @property {string|null} [name] DeleteGoogleAdsLinkRequest name
                         */
    
                        /**
                         * Constructs a new DeleteGoogleAdsLinkRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DeleteGoogleAdsLinkRequest.
                         * @implements IDeleteGoogleAdsLinkRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDeleteGoogleAdsLinkRequest=} [properties] Properties to set
                         */
                        function DeleteGoogleAdsLinkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGoogleAdsLinkRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @instance
                         */
                        DeleteGoogleAdsLinkRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteGoogleAdsLinkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteGoogleAdsLinkRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest instance
                         */
                        DeleteGoogleAdsLinkRequest.create = function create(properties) {
                            return new DeleteGoogleAdsLinkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGoogleAdsLinkRequest message. Does not implicitly {@link google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteGoogleAdsLinkRequest} message DeleteGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGoogleAdsLinkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGoogleAdsLinkRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteGoogleAdsLinkRequest} message DeleteGoogleAdsLinkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGoogleAdsLinkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGoogleAdsLinkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGoogleAdsLinkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGoogleAdsLinkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGoogleAdsLinkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGoogleAdsLinkRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGoogleAdsLinkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGoogleAdsLinkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest} DeleteGoogleAdsLinkRequest
                         */
                        DeleteGoogleAdsLinkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGoogleAdsLinkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest} message DeleteGoogleAdsLinkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGoogleAdsLinkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGoogleAdsLinkRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGoogleAdsLinkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGoogleAdsLinkRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGoogleAdsLinkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DeleteGoogleAdsLinkRequest";
                        };
    
                        return DeleteGoogleAdsLinkRequest;
                    })();
    
                    v1beta.ListGoogleAdsLinksRequest = (function() {
    
                        /**
                         * Properties of a ListGoogleAdsLinksRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListGoogleAdsLinksRequest
                         * @property {string|null} [parent] ListGoogleAdsLinksRequest parent
                         * @property {number|null} [pageSize] ListGoogleAdsLinksRequest pageSize
                         * @property {string|null} [pageToken] ListGoogleAdsLinksRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListGoogleAdsLinksRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListGoogleAdsLinksRequest.
                         * @implements IListGoogleAdsLinksRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksRequest=} [properties] Properties to set
                         */
                        function ListGoogleAdsLinksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGoogleAdsLinksRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @instance
                         */
                        ListGoogleAdsLinksRequest.prototype.parent = "";
    
                        /**
                         * ListGoogleAdsLinksRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @instance
                         */
                        ListGoogleAdsLinksRequest.prototype.pageSize = 0;
    
                        /**
                         * ListGoogleAdsLinksRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @instance
                         */
                        ListGoogleAdsLinksRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListGoogleAdsLinksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest instance
                         */
                        ListGoogleAdsLinksRequest.create = function create(properties) {
                            return new ListGoogleAdsLinksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListGoogleAdsLinksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksRequest} message ListGoogleAdsLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListGoogleAdsLinksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksRequest} message ListGoogleAdsLinksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListGoogleAdsLinksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGoogleAdsLinksRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGoogleAdsLinksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListGoogleAdsLinksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksRequest} ListGoogleAdsLinksRequest
                         */
                        ListGoogleAdsLinksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListGoogleAdsLinksRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListGoogleAdsLinksRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGoogleAdsLinksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListGoogleAdsLinksRequest} message ListGoogleAdsLinksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGoogleAdsLinksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListGoogleAdsLinksRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGoogleAdsLinksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGoogleAdsLinksRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGoogleAdsLinksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListGoogleAdsLinksRequest";
                        };
    
                        return ListGoogleAdsLinksRequest;
                    })();
    
                    v1beta.ListGoogleAdsLinksResponse = (function() {
    
                        /**
                         * Properties of a ListGoogleAdsLinksResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListGoogleAdsLinksResponse
                         * @property {Array.<google.analytics.admin.v1beta.IGoogleAdsLink>|null} [googleAdsLinks] ListGoogleAdsLinksResponse googleAdsLinks
                         * @property {string|null} [nextPageToken] ListGoogleAdsLinksResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListGoogleAdsLinksResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListGoogleAdsLinksResponse.
                         * @implements IListGoogleAdsLinksResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksResponse=} [properties] Properties to set
                         */
                        function ListGoogleAdsLinksResponse(properties) {
                            this.googleAdsLinks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGoogleAdsLinksResponse googleAdsLinks.
                         * @member {Array.<google.analytics.admin.v1beta.IGoogleAdsLink>} googleAdsLinks
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @instance
                         */
                        ListGoogleAdsLinksResponse.prototype.googleAdsLinks = $util.emptyArray;
    
                        /**
                         * ListGoogleAdsLinksResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @instance
                         */
                        ListGoogleAdsLinksResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListGoogleAdsLinksResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse instance
                         */
                        ListGoogleAdsLinksResponse.create = function create(properties) {
                            return new ListGoogleAdsLinksResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListGoogleAdsLinksResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksResponse} message ListGoogleAdsLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleAdsLinks != null && message.googleAdsLinks.length)
                                for (var i = 0; i < message.googleAdsLinks.length; ++i)
                                    $root.google.analytics.admin.v1beta.GoogleAdsLink.encode(message.googleAdsLinks[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGoogleAdsLinksResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListGoogleAdsLinksResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListGoogleAdsLinksResponse} message ListGoogleAdsLinksResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGoogleAdsLinksResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListGoogleAdsLinksResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.googleAdsLinks && message.googleAdsLinks.length))
                                            message.googleAdsLinks = [];
                                        message.googleAdsLinks.push($root.google.analytics.admin.v1beta.GoogleAdsLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGoogleAdsLinksResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGoogleAdsLinksResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGoogleAdsLinksResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGoogleAdsLinksResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.googleAdsLinks != null && message.hasOwnProperty("googleAdsLinks")) {
                                if (!Array.isArray(message.googleAdsLinks))
                                    return "googleAdsLinks: array expected";
                                for (var i = 0; i < message.googleAdsLinks.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.GoogleAdsLink.verify(message.googleAdsLinks[i]);
                                    if (error)
                                        return "googleAdsLinks." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListGoogleAdsLinksResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListGoogleAdsLinksResponse} ListGoogleAdsLinksResponse
                         */
                        ListGoogleAdsLinksResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListGoogleAdsLinksResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListGoogleAdsLinksResponse();
                            if (object.googleAdsLinks) {
                                if (!Array.isArray(object.googleAdsLinks))
                                    throw TypeError(".google.analytics.admin.v1beta.ListGoogleAdsLinksResponse.googleAdsLinks: array expected");
                                message.googleAdsLinks = [];
                                for (var i = 0; i < object.googleAdsLinks.length; ++i) {
                                    if (typeof object.googleAdsLinks[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListGoogleAdsLinksResponse.googleAdsLinks: object expected");
                                    message.googleAdsLinks[i] = $root.google.analytics.admin.v1beta.GoogleAdsLink.fromObject(object.googleAdsLinks[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGoogleAdsLinksResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListGoogleAdsLinksResponse} message ListGoogleAdsLinksResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGoogleAdsLinksResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.googleAdsLinks = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.googleAdsLinks && message.googleAdsLinks.length) {
                                object.googleAdsLinks = [];
                                for (var j = 0; j < message.googleAdsLinks.length; ++j)
                                    object.googleAdsLinks[j] = $root.google.analytics.admin.v1beta.GoogleAdsLink.toObject(message.googleAdsLinks[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListGoogleAdsLinksResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGoogleAdsLinksResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGoogleAdsLinksResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListGoogleAdsLinksResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGoogleAdsLinksResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListGoogleAdsLinksResponse";
                        };
    
                        return ListGoogleAdsLinksResponse;
                    })();
    
                    v1beta.GetDataSharingSettingsRequest = (function() {
    
                        /**
                         * Properties of a GetDataSharingSettingsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetDataSharingSettingsRequest
                         * @property {string|null} [name] GetDataSharingSettingsRequest name
                         */
    
                        /**
                         * Constructs a new GetDataSharingSettingsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetDataSharingSettingsRequest.
                         * @implements IGetDataSharingSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetDataSharingSettingsRequest=} [properties] Properties to set
                         */
                        function GetDataSharingSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDataSharingSettingsRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @instance
                         */
                        GetDataSharingSettingsRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDataSharingSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataSharingSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest instance
                         */
                        GetDataSharingSettingsRequest.create = function create(properties) {
                            return new GetDataSharingSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDataSharingSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetDataSharingSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataSharingSettingsRequest} message GetDataSharingSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataSharingSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDataSharingSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetDataSharingSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataSharingSettingsRequest} message GetDataSharingSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataSharingSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDataSharingSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataSharingSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetDataSharingSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDataSharingSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataSharingSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDataSharingSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDataSharingSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDataSharingSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetDataSharingSettingsRequest} GetDataSharingSettingsRequest
                         */
                        GetDataSharingSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetDataSharingSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetDataSharingSettingsRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDataSharingSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetDataSharingSettingsRequest} message GetDataSharingSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDataSharingSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDataSharingSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDataSharingSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDataSharingSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetDataSharingSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDataSharingSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetDataSharingSettingsRequest";
                        };
    
                        return GetDataSharingSettingsRequest;
                    })();
    
                    v1beta.ListAccountSummariesRequest = (function() {
    
                        /**
                         * Properties of a ListAccountSummariesRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListAccountSummariesRequest
                         * @property {number|null} [pageSize] ListAccountSummariesRequest pageSize
                         * @property {string|null} [pageToken] ListAccountSummariesRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListAccountSummariesRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListAccountSummariesRequest.
                         * @implements IListAccountSummariesRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesRequest=} [properties] Properties to set
                         */
                        function ListAccountSummariesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountSummariesRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @instance
                         */
                        ListAccountSummariesRequest.prototype.pageSize = 0;
    
                        /**
                         * ListAccountSummariesRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @instance
                         */
                        ListAccountSummariesRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListAccountSummariesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesRequest} ListAccountSummariesRequest instance
                         */
                        ListAccountSummariesRequest.create = function create(properties) {
                            return new ListAccountSummariesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountSummariesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesRequest} message ListAccountSummariesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountSummariesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesRequest} message ListAccountSummariesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountSummariesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesRequest} ListAccountSummariesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListAccountSummariesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 2: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountSummariesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesRequest} ListAccountSummariesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountSummariesRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountSummariesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountSummariesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesRequest} ListAccountSummariesRequest
                         */
                        ListAccountSummariesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListAccountSummariesRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListAccountSummariesRequest();
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountSummariesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListAccountSummariesRequest} message ListAccountSummariesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountSummariesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountSummariesRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountSummariesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountSummariesRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountSummariesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListAccountSummariesRequest";
                        };
    
                        return ListAccountSummariesRequest;
                    })();
    
                    v1beta.ListAccountSummariesResponse = (function() {
    
                        /**
                         * Properties of a ListAccountSummariesResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListAccountSummariesResponse
                         * @property {Array.<google.analytics.admin.v1beta.IAccountSummary>|null} [accountSummaries] ListAccountSummariesResponse accountSummaries
                         * @property {string|null} [nextPageToken] ListAccountSummariesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListAccountSummariesResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListAccountSummariesResponse.
                         * @implements IListAccountSummariesResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesResponse=} [properties] Properties to set
                         */
                        function ListAccountSummariesResponse(properties) {
                            this.accountSummaries = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAccountSummariesResponse accountSummaries.
                         * @member {Array.<google.analytics.admin.v1beta.IAccountSummary>} accountSummaries
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @instance
                         */
                        ListAccountSummariesResponse.prototype.accountSummaries = $util.emptyArray;
    
                        /**
                         * ListAccountSummariesResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @instance
                         */
                        ListAccountSummariesResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListAccountSummariesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesResponse} ListAccountSummariesResponse instance
                         */
                        ListAccountSummariesResponse.create = function create(properties) {
                            return new ListAccountSummariesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountSummariesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesResponse} message ListAccountSummariesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.accountSummaries != null && message.accountSummaries.length)
                                for (var i = 0; i < message.accountSummaries.length; ++i)
                                    $root.google.analytics.admin.v1beta.AccountSummary.encode(message.accountSummaries[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAccountSummariesResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListAccountSummariesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListAccountSummariesResponse} message ListAccountSummariesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAccountSummariesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAccountSummariesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesResponse} ListAccountSummariesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListAccountSummariesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.accountSummaries && message.accountSummaries.length))
                                            message.accountSummaries = [];
                                        message.accountSummaries.push($root.google.analytics.admin.v1beta.AccountSummary.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAccountSummariesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesResponse} ListAccountSummariesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAccountSummariesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAccountSummariesResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAccountSummariesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.accountSummaries != null && message.hasOwnProperty("accountSummaries")) {
                                if (!Array.isArray(message.accountSummaries))
                                    return "accountSummaries: array expected";
                                for (var i = 0; i < message.accountSummaries.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.AccountSummary.verify(message.accountSummaries[i]);
                                    if (error)
                                        return "accountSummaries." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAccountSummariesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListAccountSummariesResponse} ListAccountSummariesResponse
                         */
                        ListAccountSummariesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListAccountSummariesResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListAccountSummariesResponse();
                            if (object.accountSummaries) {
                                if (!Array.isArray(object.accountSummaries))
                                    throw TypeError(".google.analytics.admin.v1beta.ListAccountSummariesResponse.accountSummaries: array expected");
                                message.accountSummaries = [];
                                for (var i = 0; i < object.accountSummaries.length; ++i) {
                                    if (typeof object.accountSummaries[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListAccountSummariesResponse.accountSummaries: object expected");
                                    message.accountSummaries[i] = $root.google.analytics.admin.v1beta.AccountSummary.fromObject(object.accountSummaries[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAccountSummariesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListAccountSummariesResponse} message ListAccountSummariesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAccountSummariesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.accountSummaries = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.accountSummaries && message.accountSummaries.length) {
                                object.accountSummaries = [];
                                for (var j = 0; j < message.accountSummaries.length; ++j)
                                    object.accountSummaries[j] = $root.google.analytics.admin.v1beta.AccountSummary.toObject(message.accountSummaries[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListAccountSummariesResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAccountSummariesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAccountSummariesResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListAccountSummariesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAccountSummariesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListAccountSummariesResponse";
                        };
    
                        return ListAccountSummariesResponse;
                    })();
    
                    v1beta.AcknowledgeUserDataCollectionRequest = (function() {
    
                        /**
                         * Properties of an AcknowledgeUserDataCollectionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAcknowledgeUserDataCollectionRequest
                         * @property {string|null} [property] AcknowledgeUserDataCollectionRequest property
                         * @property {string|null} [acknowledgement] AcknowledgeUserDataCollectionRequest acknowledgement
                         */
    
                        /**
                         * Constructs a new AcknowledgeUserDataCollectionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AcknowledgeUserDataCollectionRequest.
                         * @implements IAcknowledgeUserDataCollectionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionRequest=} [properties] Properties to set
                         */
                        function AcknowledgeUserDataCollectionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AcknowledgeUserDataCollectionRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @instance
                         */
                        AcknowledgeUserDataCollectionRequest.prototype.property = "";
    
                        /**
                         * AcknowledgeUserDataCollectionRequest acknowledgement.
                         * @member {string} acknowledgement
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @instance
                         */
                        AcknowledgeUserDataCollectionRequest.prototype.acknowledgement = "";
    
                        /**
                         * Creates a new AcknowledgeUserDataCollectionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest instance
                         */
                        AcknowledgeUserDataCollectionRequest.create = function create(properties) {
                            return new AcknowledgeUserDataCollectionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionRequest message. Does not implicitly {@link google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionRequest} message AcknowledgeUserDataCollectionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            if (message.acknowledgement != null && Object.hasOwnProperty.call(message, "acknowledgement"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.acknowledgement);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionRequest} message AcknowledgeUserDataCollectionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.acknowledgement = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcknowledgeUserDataCollectionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcknowledgeUserDataCollectionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.acknowledgement != null && message.hasOwnProperty("acknowledgement"))
                                if (!$util.isString(message.acknowledgement))
                                    return "acknowledgement: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AcknowledgeUserDataCollectionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest} AcknowledgeUserDataCollectionRequest
                         */
                        AcknowledgeUserDataCollectionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest();
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.acknowledgement != null)
                                message.acknowledgement = String(object.acknowledgement);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AcknowledgeUserDataCollectionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest} message AcknowledgeUserDataCollectionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcknowledgeUserDataCollectionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = "";
                                object.acknowledgement = "";
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.acknowledgement != null && message.hasOwnProperty("acknowledgement"))
                                object.acknowledgement = message.acknowledgement;
                            return object;
                        };
    
                        /**
                         * Converts this AcknowledgeUserDataCollectionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcknowledgeUserDataCollectionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcknowledgeUserDataCollectionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcknowledgeUserDataCollectionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AcknowledgeUserDataCollectionRequest";
                        };
    
                        return AcknowledgeUserDataCollectionRequest;
                    })();
    
                    v1beta.AcknowledgeUserDataCollectionResponse = (function() {
    
                        /**
                         * Properties of an AcknowledgeUserDataCollectionResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAcknowledgeUserDataCollectionResponse
                         */
    
                        /**
                         * Constructs a new AcknowledgeUserDataCollectionResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AcknowledgeUserDataCollectionResponse.
                         * @implements IAcknowledgeUserDataCollectionResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionResponse=} [properties] Properties to set
                         */
                        function AcknowledgeUserDataCollectionResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new AcknowledgeUserDataCollectionResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse instance
                         */
                        AcknowledgeUserDataCollectionResponse.create = function create(properties) {
                            return new AcknowledgeUserDataCollectionResponse(properties);
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionResponse message. Does not implicitly {@link google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionResponse} message AcknowledgeUserDataCollectionResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcknowledgeUserDataCollectionResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IAcknowledgeUserDataCollectionResponse} message AcknowledgeUserDataCollectionResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcknowledgeUserDataCollectionResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcknowledgeUserDataCollectionResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcknowledgeUserDataCollectionResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcknowledgeUserDataCollectionResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcknowledgeUserDataCollectionResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates an AcknowledgeUserDataCollectionResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse} AcknowledgeUserDataCollectionResponse
                         */
                        AcknowledgeUserDataCollectionResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse)
                                return object;
                            return new $root.google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse();
                        };
    
                        /**
                         * Creates a plain object from an AcknowledgeUserDataCollectionResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse} message AcknowledgeUserDataCollectionResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcknowledgeUserDataCollectionResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this AcknowledgeUserDataCollectionResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcknowledgeUserDataCollectionResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcknowledgeUserDataCollectionResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcknowledgeUserDataCollectionResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AcknowledgeUserDataCollectionResponse";
                        };
    
                        return AcknowledgeUserDataCollectionResponse;
                    })();
    
                    v1beta.SearchChangeHistoryEventsRequest = (function() {
    
                        /**
                         * Properties of a SearchChangeHistoryEventsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ISearchChangeHistoryEventsRequest
                         * @property {string|null} [account] SearchChangeHistoryEventsRequest account
                         * @property {string|null} [property] SearchChangeHistoryEventsRequest property
                         * @property {Array.<google.analytics.admin.v1beta.ChangeHistoryResourceType>|null} [resourceType] SearchChangeHistoryEventsRequest resourceType
                         * @property {Array.<google.analytics.admin.v1beta.ActionType>|null} [action] SearchChangeHistoryEventsRequest action
                         * @property {Array.<string>|null} [actorEmail] SearchChangeHistoryEventsRequest actorEmail
                         * @property {google.protobuf.ITimestamp|null} [earliestChangeTime] SearchChangeHistoryEventsRequest earliestChangeTime
                         * @property {google.protobuf.ITimestamp|null} [latestChangeTime] SearchChangeHistoryEventsRequest latestChangeTime
                         * @property {number|null} [pageSize] SearchChangeHistoryEventsRequest pageSize
                         * @property {string|null} [pageToken] SearchChangeHistoryEventsRequest pageToken
                         */
    
                        /**
                         * Constructs a new SearchChangeHistoryEventsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a SearchChangeHistoryEventsRequest.
                         * @implements ISearchChangeHistoryEventsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsRequest=} [properties] Properties to set
                         */
                        function SearchChangeHistoryEventsRequest(properties) {
                            this.resourceType = [];
                            this.action = [];
                            this.actorEmail = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SearchChangeHistoryEventsRequest account.
                         * @member {string} account
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.account = "";
    
                        /**
                         * SearchChangeHistoryEventsRequest property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.property = "";
    
                        /**
                         * SearchChangeHistoryEventsRequest resourceType.
                         * @member {Array.<google.analytics.admin.v1beta.ChangeHistoryResourceType>} resourceType
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.resourceType = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsRequest action.
                         * @member {Array.<google.analytics.admin.v1beta.ActionType>} action
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.action = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsRequest actorEmail.
                         * @member {Array.<string>} actorEmail
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.actorEmail = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsRequest earliestChangeTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} earliestChangeTime
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.earliestChangeTime = null;
    
                        /**
                         * SearchChangeHistoryEventsRequest latestChangeTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} latestChangeTime
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.latestChangeTime = null;
    
                        /**
                         * SearchChangeHistoryEventsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.pageSize = 0;
    
                        /**
                         * SearchChangeHistoryEventsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         */
                        SearchChangeHistoryEventsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new SearchChangeHistoryEventsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest instance
                         */
                        SearchChangeHistoryEventsRequest.create = function create(properties) {
                            return new SearchChangeHistoryEventsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsRequest} message SearchChangeHistoryEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.account);
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.property);
                            if (message.resourceType != null && message.resourceType.length) {
                                writer.uint32(/* id 3, wireType 2 =*/26).fork();
                                for (var i = 0; i < message.resourceType.length; ++i)
                                    writer.int32(message.resourceType[i]);
                                writer.ldelim();
                            }
                            if (message.action != null && message.action.length) {
                                writer.uint32(/* id 4, wireType 2 =*/34).fork();
                                for (var i = 0; i < message.action.length; ++i)
                                    writer.int32(message.action[i]);
                                writer.ldelim();
                            }
                            if (message.actorEmail != null && message.actorEmail.length)
                                for (var i = 0; i < message.actorEmail.length; ++i)
                                    writer.uint32(/* id 5, wireType 2 =*/42).string(message.actorEmail[i]);
                            if (message.earliestChangeTime != null && Object.hasOwnProperty.call(message, "earliestChangeTime"))
                                $root.google.protobuf.Timestamp.encode(message.earliestChangeTime, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.latestChangeTime != null && Object.hasOwnProperty.call(message, "latestChangeTime"))
                                $root.google.protobuf.Timestamp.encode(message.latestChangeTime, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 9, wireType 2 =*/74).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsRequest} message SearchChangeHistoryEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.account = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 3: {
                                        if (!(message.resourceType && message.resourceType.length))
                                            message.resourceType = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.resourceType.push(reader.int32());
                                        } else
                                            message.resourceType.push(reader.int32());
                                        break;
                                    }
                                case 4: {
                                        if (!(message.action && message.action.length))
                                            message.action = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.action.push(reader.int32());
                                        } else
                                            message.action.push(reader.int32());
                                        break;
                                    }
                                case 5: {
                                        if (!(message.actorEmail && message.actorEmail.length))
                                            message.actorEmail = [];
                                        message.actorEmail.push(reader.string());
                                        break;
                                    }
                                case 6: {
                                        message.earliestChangeTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.latestChangeTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 8: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 9: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SearchChangeHistoryEventsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchChangeHistoryEventsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.account != null && message.hasOwnProperty("account"))
                                if (!$util.isString(message.account))
                                    return "account: string expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.resourceType != null && message.hasOwnProperty("resourceType")) {
                                if (!Array.isArray(message.resourceType))
                                    return "resourceType: array expected";
                                for (var i = 0; i < message.resourceType.length; ++i)
                                    switch (message.resourceType[i]) {
                                    default:
                                        return "resourceType: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 6:
                                    case 7:
                                    case 8:
                                    case 9:
                                    case 10:
                                    case 13:
                                    case 14:
                                    case 15:
                                    case 18:
                                    case 20:
                                        break;
                                    }
                            }
                            if (message.action != null && message.hasOwnProperty("action")) {
                                if (!Array.isArray(message.action))
                                    return "action: array expected";
                                for (var i = 0; i < message.action.length; ++i)
                                    switch (message.action[i]) {
                                    default:
                                        return "action: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                    case 3:
                                        break;
                                    }
                            }
                            if (message.actorEmail != null && message.hasOwnProperty("actorEmail")) {
                                if (!Array.isArray(message.actorEmail))
                                    return "actorEmail: array expected";
                                for (var i = 0; i < message.actorEmail.length; ++i)
                                    if (!$util.isString(message.actorEmail[i]))
                                        return "actorEmail: string[] expected";
                            }
                            if (message.earliestChangeTime != null && message.hasOwnProperty("earliestChangeTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.earliestChangeTime);
                                if (error)
                                    return "earliestChangeTime." + error;
                            }
                            if (message.latestChangeTime != null && message.hasOwnProperty("latestChangeTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.latestChangeTime);
                                if (error)
                                    return "latestChangeTime." + error;
                            }
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SearchChangeHistoryEventsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest} SearchChangeHistoryEventsRequest
                         */
                        SearchChangeHistoryEventsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest();
                            if (object.account != null)
                                message.account = String(object.account);
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.resourceType) {
                                if (!Array.isArray(object.resourceType))
                                    throw TypeError(".google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest.resourceType: array expected");
                                message.resourceType = [];
                                for (var i = 0; i < object.resourceType.length; ++i)
                                    switch (object.resourceType[i]) {
                                    default:
                                        if (typeof object.resourceType[i] === "number") {
                                            message.resourceType[i] = object.resourceType[i];
                                            break;
                                        }
                                    case "CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED":
                                    case 0:
                                        message.resourceType[i] = 0;
                                        break;
                                    case "ACCOUNT":
                                    case 1:
                                        message.resourceType[i] = 1;
                                        break;
                                    case "PROPERTY":
                                    case 2:
                                        message.resourceType[i] = 2;
                                        break;
                                    case "FIREBASE_LINK":
                                    case 6:
                                        message.resourceType[i] = 6;
                                        break;
                                    case "GOOGLE_ADS_LINK":
                                    case 7:
                                        message.resourceType[i] = 7;
                                        break;
                                    case "GOOGLE_SIGNALS_SETTINGS":
                                    case 8:
                                        message.resourceType[i] = 8;
                                        break;
                                    case "CONVERSION_EVENT":
                                    case 9:
                                        message.resourceType[i] = 9;
                                        break;
                                    case "MEASUREMENT_PROTOCOL_SECRET":
                                    case 10:
                                        message.resourceType[i] = 10;
                                        break;
                                    case "DATA_RETENTION_SETTINGS":
                                    case 13:
                                        message.resourceType[i] = 13;
                                        break;
                                    case "DISPLAY_VIDEO_360_ADVERTISER_LINK":
                                    case 14:
                                        message.resourceType[i] = 14;
                                        break;
                                    case "DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL":
                                    case 15:
                                        message.resourceType[i] = 15;
                                        break;
                                    case "DATA_STREAM":
                                    case 18:
                                        message.resourceType[i] = 18;
                                        break;
                                    case "ATTRIBUTION_SETTINGS":
                                    case 20:
                                        message.resourceType[i] = 20;
                                        break;
                                    }
                            }
                            if (object.action) {
                                if (!Array.isArray(object.action))
                                    throw TypeError(".google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest.action: array expected");
                                message.action = [];
                                for (var i = 0; i < object.action.length; ++i)
                                    switch (object.action[i]) {
                                    default:
                                        if (typeof object.action[i] === "number") {
                                            message.action[i] = object.action[i];
                                            break;
                                        }
                                    case "ACTION_TYPE_UNSPECIFIED":
                                    case 0:
                                        message.action[i] = 0;
                                        break;
                                    case "CREATED":
                                    case 1:
                                        message.action[i] = 1;
                                        break;
                                    case "UPDATED":
                                    case 2:
                                        message.action[i] = 2;
                                        break;
                                    case "DELETED":
                                    case 3:
                                        message.action[i] = 3;
                                        break;
                                    }
                            }
                            if (object.actorEmail) {
                                if (!Array.isArray(object.actorEmail))
                                    throw TypeError(".google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest.actorEmail: array expected");
                                message.actorEmail = [];
                                for (var i = 0; i < object.actorEmail.length; ++i)
                                    message.actorEmail[i] = String(object.actorEmail[i]);
                            }
                            if (object.earliestChangeTime != null) {
                                if (typeof object.earliestChangeTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest.earliestChangeTime: object expected");
                                message.earliestChangeTime = $root.google.protobuf.Timestamp.fromObject(object.earliestChangeTime);
                            }
                            if (object.latestChangeTime != null) {
                                if (typeof object.latestChangeTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest.latestChangeTime: object expected");
                                message.latestChangeTime = $root.google.protobuf.Timestamp.fromObject(object.latestChangeTime);
                            }
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SearchChangeHistoryEventsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest} message SearchChangeHistoryEventsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchChangeHistoryEventsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.resourceType = [];
                                object.action = [];
                                object.actorEmail = [];
                            }
                            if (options.defaults) {
                                object.account = "";
                                object.property = "";
                                object.earliestChangeTime = null;
                                object.latestChangeTime = null;
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = message.account;
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.resourceType && message.resourceType.length) {
                                object.resourceType = [];
                                for (var j = 0; j < message.resourceType.length; ++j)
                                    object.resourceType[j] = options.enums === String ? $root.google.analytics.admin.v1beta.ChangeHistoryResourceType[message.resourceType[j]] === undefined ? message.resourceType[j] : $root.google.analytics.admin.v1beta.ChangeHistoryResourceType[message.resourceType[j]] : message.resourceType[j];
                            }
                            if (message.action && message.action.length) {
                                object.action = [];
                                for (var j = 0; j < message.action.length; ++j)
                                    object.action[j] = options.enums === String ? $root.google.analytics.admin.v1beta.ActionType[message.action[j]] === undefined ? message.action[j] : $root.google.analytics.admin.v1beta.ActionType[message.action[j]] : message.action[j];
                            }
                            if (message.actorEmail && message.actorEmail.length) {
                                object.actorEmail = [];
                                for (var j = 0; j < message.actorEmail.length; ++j)
                                    object.actorEmail[j] = message.actorEmail[j];
                            }
                            if (message.earliestChangeTime != null && message.hasOwnProperty("earliestChangeTime"))
                                object.earliestChangeTime = $root.google.protobuf.Timestamp.toObject(message.earliestChangeTime, options);
                            if (message.latestChangeTime != null && message.hasOwnProperty("latestChangeTime"))
                                object.latestChangeTime = $root.google.protobuf.Timestamp.toObject(message.latestChangeTime, options);
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this SearchChangeHistoryEventsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchChangeHistoryEventsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SearchChangeHistoryEventsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SearchChangeHistoryEventsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.SearchChangeHistoryEventsRequest";
                        };
    
                        return SearchChangeHistoryEventsRequest;
                    })();
    
                    v1beta.SearchChangeHistoryEventsResponse = (function() {
    
                        /**
                         * Properties of a SearchChangeHistoryEventsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ISearchChangeHistoryEventsResponse
                         * @property {Array.<google.analytics.admin.v1beta.IChangeHistoryEvent>|null} [changeHistoryEvents] SearchChangeHistoryEventsResponse changeHistoryEvents
                         * @property {string|null} [nextPageToken] SearchChangeHistoryEventsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new SearchChangeHistoryEventsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a SearchChangeHistoryEventsResponse.
                         * @implements ISearchChangeHistoryEventsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsResponse=} [properties] Properties to set
                         */
                        function SearchChangeHistoryEventsResponse(properties) {
                            this.changeHistoryEvents = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SearchChangeHistoryEventsResponse changeHistoryEvents.
                         * @member {Array.<google.analytics.admin.v1beta.IChangeHistoryEvent>} changeHistoryEvents
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @instance
                         */
                        SearchChangeHistoryEventsResponse.prototype.changeHistoryEvents = $util.emptyArray;
    
                        /**
                         * SearchChangeHistoryEventsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @instance
                         */
                        SearchChangeHistoryEventsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new SearchChangeHistoryEventsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse instance
                         */
                        SearchChangeHistoryEventsResponse.create = function create(properties) {
                            return new SearchChangeHistoryEventsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsResponse message. Does not implicitly {@link google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsResponse} message SearchChangeHistoryEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.changeHistoryEvents != null && message.changeHistoryEvents.length)
                                for (var i = 0; i < message.changeHistoryEvents.length; ++i)
                                    $root.google.analytics.admin.v1beta.ChangeHistoryEvent.encode(message.changeHistoryEvents[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SearchChangeHistoryEventsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ISearchChangeHistoryEventsResponse} message SearchChangeHistoryEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SearchChangeHistoryEventsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.changeHistoryEvents && message.changeHistoryEvents.length))
                                            message.changeHistoryEvents = [];
                                        message.changeHistoryEvents.push($root.google.analytics.admin.v1beta.ChangeHistoryEvent.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SearchChangeHistoryEventsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SearchChangeHistoryEventsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SearchChangeHistoryEventsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SearchChangeHistoryEventsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.changeHistoryEvents != null && message.hasOwnProperty("changeHistoryEvents")) {
                                if (!Array.isArray(message.changeHistoryEvents))
                                    return "changeHistoryEvents: array expected";
                                for (var i = 0; i < message.changeHistoryEvents.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.ChangeHistoryEvent.verify(message.changeHistoryEvents[i]);
                                    if (error)
                                        return "changeHistoryEvents." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SearchChangeHistoryEventsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse} SearchChangeHistoryEventsResponse
                         */
                        SearchChangeHistoryEventsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse();
                            if (object.changeHistoryEvents) {
                                if (!Array.isArray(object.changeHistoryEvents))
                                    throw TypeError(".google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse.changeHistoryEvents: array expected");
                                message.changeHistoryEvents = [];
                                for (var i = 0; i < object.changeHistoryEvents.length; ++i) {
                                    if (typeof object.changeHistoryEvents[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse.changeHistoryEvents: object expected");
                                    message.changeHistoryEvents[i] = $root.google.analytics.admin.v1beta.ChangeHistoryEvent.fromObject(object.changeHistoryEvents[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SearchChangeHistoryEventsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse} message SearchChangeHistoryEventsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SearchChangeHistoryEventsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.changeHistoryEvents = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.changeHistoryEvents && message.changeHistoryEvents.length) {
                                object.changeHistoryEvents = [];
                                for (var j = 0; j < message.changeHistoryEvents.length; ++j)
                                    object.changeHistoryEvents[j] = $root.google.analytics.admin.v1beta.ChangeHistoryEvent.toObject(message.changeHistoryEvents[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this SearchChangeHistoryEventsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SearchChangeHistoryEventsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SearchChangeHistoryEventsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SearchChangeHistoryEventsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.SearchChangeHistoryEventsResponse";
                        };
    
                        return SearchChangeHistoryEventsResponse;
                    })();
    
                    v1beta.GetMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of a GetMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetMeasurementProtocolSecretRequest
                         * @property {string|null} [name] GetMeasurementProtocolSecretRequest name
                         */
    
                        /**
                         * Constructs a new GetMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetMeasurementProtocolSecretRequest.
                         * @implements IGetMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function GetMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetMeasurementProtocolSecretRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @instance
                         */
                        GetMeasurementProtocolSecretRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest instance
                         */
                        GetMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new GetMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetMeasurementProtocolSecretRequest} message GetMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetMeasurementProtocolSecretRequest} message GetMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest} GetMeasurementProtocolSecretRequest
                         */
                        GetMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest} message GetMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetMeasurementProtocolSecretRequest";
                        };
    
                        return GetMeasurementProtocolSecretRequest;
                    })();
    
                    v1beta.CreateMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of a CreateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreateMeasurementProtocolSecretRequest
                         * @property {string|null} [parent] CreateMeasurementProtocolSecretRequest parent
                         * @property {google.analytics.admin.v1beta.IMeasurementProtocolSecret|null} [measurementProtocolSecret] CreateMeasurementProtocolSecretRequest measurementProtocolSecret
                         */
    
                        /**
                         * Constructs a new CreateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreateMeasurementProtocolSecretRequest.
                         * @implements ICreateMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function CreateMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateMeasurementProtocolSecretRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        CreateMeasurementProtocolSecretRequest.prototype.parent = "";
    
                        /**
                         * CreateMeasurementProtocolSecretRequest measurementProtocolSecret.
                         * @member {google.analytics.admin.v1beta.IMeasurementProtocolSecret|null|undefined} measurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        CreateMeasurementProtocolSecretRequest.prototype.measurementProtocolSecret = null;
    
                        /**
                         * Creates a new CreateMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest instance
                         */
                        CreateMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new CreateMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateMeasurementProtocolSecretRequest} message CreateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.measurementProtocolSecret != null && Object.hasOwnProperty.call(message, "measurementProtocolSecret"))
                                $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.encode(message.measurementProtocolSecret, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateMeasurementProtocolSecretRequest} message CreateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                var error = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.verify(message.measurementProtocolSecret);
                                if (error)
                                    return "measurementProtocolSecret." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest} CreateMeasurementProtocolSecretRequest
                         */
                        CreateMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.measurementProtocolSecret != null) {
                                if (typeof object.measurementProtocolSecret !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest.measurementProtocolSecret: object expected");
                                message.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecret);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest} message CreateMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.measurementProtocolSecret = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret"))
                                object.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.toObject(message.measurementProtocolSecret, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreateMeasurementProtocolSecretRequest";
                        };
    
                        return CreateMeasurementProtocolSecretRequest;
                    })();
    
                    v1beta.DeleteMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of a DeleteMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDeleteMeasurementProtocolSecretRequest
                         * @property {string|null} [name] DeleteMeasurementProtocolSecretRequest name
                         */
    
                        /**
                         * Constructs a new DeleteMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DeleteMeasurementProtocolSecretRequest.
                         * @implements IDeleteMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDeleteMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function DeleteMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteMeasurementProtocolSecretRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @instance
                         */
                        DeleteMeasurementProtocolSecretRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest instance
                         */
                        DeleteMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new DeleteMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteMeasurementProtocolSecretRequest} message DeleteMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteMeasurementProtocolSecretRequest} message DeleteMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest} DeleteMeasurementProtocolSecretRequest
                         */
                        DeleteMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest} message DeleteMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DeleteMeasurementProtocolSecretRequest";
                        };
    
                        return DeleteMeasurementProtocolSecretRequest;
                    })();
    
                    v1beta.UpdateMeasurementProtocolSecretRequest = (function() {
    
                        /**
                         * Properties of an UpdateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdateMeasurementProtocolSecretRequest
                         * @property {google.analytics.admin.v1beta.IMeasurementProtocolSecret|null} [measurementProtocolSecret] UpdateMeasurementProtocolSecretRequest measurementProtocolSecret
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateMeasurementProtocolSecretRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateMeasurementProtocolSecretRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdateMeasurementProtocolSecretRequest.
                         * @implements IUpdateMeasurementProtocolSecretRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         */
                        function UpdateMeasurementProtocolSecretRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateMeasurementProtocolSecretRequest measurementProtocolSecret.
                         * @member {google.analytics.admin.v1beta.IMeasurementProtocolSecret|null|undefined} measurementProtocolSecret
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        UpdateMeasurementProtocolSecretRequest.prototype.measurementProtocolSecret = null;
    
                        /**
                         * UpdateMeasurementProtocolSecretRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @instance
                         */
                        UpdateMeasurementProtocolSecretRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateMeasurementProtocolSecretRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateMeasurementProtocolSecretRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest instance
                         */
                        UpdateMeasurementProtocolSecretRequest.create = function create(properties) {
                            return new UpdateMeasurementProtocolSecretRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateMeasurementProtocolSecretRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateMeasurementProtocolSecretRequest} message UpdateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateMeasurementProtocolSecretRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.measurementProtocolSecret != null && Object.hasOwnProperty.call(message, "measurementProtocolSecret"))
                                $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.encode(message.measurementProtocolSecret, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateMeasurementProtocolSecretRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateMeasurementProtocolSecretRequest} message UpdateMeasurementProtocolSecretRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateMeasurementProtocolSecretRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateMeasurementProtocolSecretRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateMeasurementProtocolSecretRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateMeasurementProtocolSecretRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateMeasurementProtocolSecretRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateMeasurementProtocolSecretRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateMeasurementProtocolSecretRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                var error = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.verify(message.measurementProtocolSecret);
                                if (error)
                                    return "measurementProtocolSecret." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateMeasurementProtocolSecretRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest} UpdateMeasurementProtocolSecretRequest
                         */
                        UpdateMeasurementProtocolSecretRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest();
                            if (object.measurementProtocolSecret != null) {
                                if (typeof object.measurementProtocolSecret !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest.measurementProtocolSecret: object expected");
                                message.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecret);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateMeasurementProtocolSecretRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest} message UpdateMeasurementProtocolSecretRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateMeasurementProtocolSecretRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.measurementProtocolSecret = null;
                                object.updateMask = null;
                            }
                            if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret"))
                                object.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.toObject(message.measurementProtocolSecret, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateMeasurementProtocolSecretRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateMeasurementProtocolSecretRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateMeasurementProtocolSecretRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateMeasurementProtocolSecretRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdateMeasurementProtocolSecretRequest";
                        };
    
                        return UpdateMeasurementProtocolSecretRequest;
                    })();
    
                    v1beta.ListMeasurementProtocolSecretsRequest = (function() {
    
                        /**
                         * Properties of a ListMeasurementProtocolSecretsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListMeasurementProtocolSecretsRequest
                         * @property {string|null} [parent] ListMeasurementProtocolSecretsRequest parent
                         * @property {number|null} [pageSize] ListMeasurementProtocolSecretsRequest pageSize
                         * @property {string|null} [pageToken] ListMeasurementProtocolSecretsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListMeasurementProtocolSecretsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListMeasurementProtocolSecretsRequest.
                         * @implements IListMeasurementProtocolSecretsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsRequest=} [properties] Properties to set
                         */
                        function ListMeasurementProtocolSecretsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListMeasurementProtocolSecretsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @instance
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.parent = "";
    
                        /**
                         * ListMeasurementProtocolSecretsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @instance
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListMeasurementProtocolSecretsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @instance
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListMeasurementProtocolSecretsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest instance
                         */
                        ListMeasurementProtocolSecretsRequest.create = function create(properties) {
                            return new ListMeasurementProtocolSecretsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsRequest} message ListMeasurementProtocolSecretsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsRequest} message ListMeasurementProtocolSecretsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListMeasurementProtocolSecretsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMeasurementProtocolSecretsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListMeasurementProtocolSecretsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest} ListMeasurementProtocolSecretsRequest
                         */
                        ListMeasurementProtocolSecretsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListMeasurementProtocolSecretsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest} message ListMeasurementProtocolSecretsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMeasurementProtocolSecretsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListMeasurementProtocolSecretsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMeasurementProtocolSecretsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListMeasurementProtocolSecretsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListMeasurementProtocolSecretsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListMeasurementProtocolSecretsRequest";
                        };
    
                        return ListMeasurementProtocolSecretsRequest;
                    })();
    
                    v1beta.ListMeasurementProtocolSecretsResponse = (function() {
    
                        /**
                         * Properties of a ListMeasurementProtocolSecretsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListMeasurementProtocolSecretsResponse
                         * @property {Array.<google.analytics.admin.v1beta.IMeasurementProtocolSecret>|null} [measurementProtocolSecrets] ListMeasurementProtocolSecretsResponse measurementProtocolSecrets
                         * @property {string|null} [nextPageToken] ListMeasurementProtocolSecretsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListMeasurementProtocolSecretsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListMeasurementProtocolSecretsResponse.
                         * @implements IListMeasurementProtocolSecretsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsResponse=} [properties] Properties to set
                         */
                        function ListMeasurementProtocolSecretsResponse(properties) {
                            this.measurementProtocolSecrets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListMeasurementProtocolSecretsResponse measurementProtocolSecrets.
                         * @member {Array.<google.analytics.admin.v1beta.IMeasurementProtocolSecret>} measurementProtocolSecrets
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @instance
                         */
                        ListMeasurementProtocolSecretsResponse.prototype.measurementProtocolSecrets = $util.emptyArray;
    
                        /**
                         * ListMeasurementProtocolSecretsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @instance
                         */
                        ListMeasurementProtocolSecretsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListMeasurementProtocolSecretsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse instance
                         */
                        ListMeasurementProtocolSecretsResponse.create = function create(properties) {
                            return new ListMeasurementProtocolSecretsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsResponse} message ListMeasurementProtocolSecretsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.measurementProtocolSecrets != null && message.measurementProtocolSecrets.length)
                                for (var i = 0; i < message.measurementProtocolSecrets.length; ++i)
                                    $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.encode(message.measurementProtocolSecrets[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListMeasurementProtocolSecretsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListMeasurementProtocolSecretsResponse} message ListMeasurementProtocolSecretsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMeasurementProtocolSecretsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.measurementProtocolSecrets && message.measurementProtocolSecrets.length))
                                            message.measurementProtocolSecrets = [];
                                        message.measurementProtocolSecrets.push($root.google.analytics.admin.v1beta.MeasurementProtocolSecret.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListMeasurementProtocolSecretsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMeasurementProtocolSecretsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListMeasurementProtocolSecretsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMeasurementProtocolSecretsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.measurementProtocolSecrets != null && message.hasOwnProperty("measurementProtocolSecrets")) {
                                if (!Array.isArray(message.measurementProtocolSecrets))
                                    return "measurementProtocolSecrets: array expected";
                                for (var i = 0; i < message.measurementProtocolSecrets.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.verify(message.measurementProtocolSecrets[i]);
                                    if (error)
                                        return "measurementProtocolSecrets." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListMeasurementProtocolSecretsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse} ListMeasurementProtocolSecretsResponse
                         */
                        ListMeasurementProtocolSecretsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse();
                            if (object.measurementProtocolSecrets) {
                                if (!Array.isArray(object.measurementProtocolSecrets))
                                    throw TypeError(".google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse.measurementProtocolSecrets: array expected");
                                message.measurementProtocolSecrets = [];
                                for (var i = 0; i < object.measurementProtocolSecrets.length; ++i) {
                                    if (typeof object.measurementProtocolSecrets[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse.measurementProtocolSecrets: object expected");
                                    message.measurementProtocolSecrets[i] = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecrets[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListMeasurementProtocolSecretsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse} message ListMeasurementProtocolSecretsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMeasurementProtocolSecretsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.measurementProtocolSecrets = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.measurementProtocolSecrets && message.measurementProtocolSecrets.length) {
                                object.measurementProtocolSecrets = [];
                                for (var j = 0; j < message.measurementProtocolSecrets.length; ++j)
                                    object.measurementProtocolSecrets[j] = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.toObject(message.measurementProtocolSecrets[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListMeasurementProtocolSecretsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMeasurementProtocolSecretsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListMeasurementProtocolSecretsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListMeasurementProtocolSecretsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListMeasurementProtocolSecretsResponse";
                        };
    
                        return ListMeasurementProtocolSecretsResponse;
                    })();
    
                    v1beta.CreateConversionEventRequest = (function() {
    
                        /**
                         * Properties of a CreateConversionEventRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreateConversionEventRequest
                         * @property {google.analytics.admin.v1beta.IConversionEvent|null} [conversionEvent] CreateConversionEventRequest conversionEvent
                         * @property {string|null} [parent] CreateConversionEventRequest parent
                         */
    
                        /**
                         * Constructs a new CreateConversionEventRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreateConversionEventRequest.
                         * @implements ICreateConversionEventRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreateConversionEventRequest=} [properties] Properties to set
                         */
                        function CreateConversionEventRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateConversionEventRequest conversionEvent.
                         * @member {google.analytics.admin.v1beta.IConversionEvent|null|undefined} conversionEvent
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @instance
                         */
                        CreateConversionEventRequest.prototype.conversionEvent = null;
    
                        /**
                         * CreateConversionEventRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @instance
                         */
                        CreateConversionEventRequest.prototype.parent = "";
    
                        /**
                         * Creates a new CreateConversionEventRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateConversionEventRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreateConversionEventRequest} CreateConversionEventRequest instance
                         */
                        CreateConversionEventRequest.create = function create(properties) {
                            return new CreateConversionEventRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateConversionEventRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreateConversionEventRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateConversionEventRequest} message CreateConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConversionEventRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.conversionEvent != null && Object.hasOwnProperty.call(message, "conversionEvent"))
                                $root.google.analytics.admin.v1beta.ConversionEvent.encode(message.conversionEvent, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parent);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateConversionEventRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreateConversionEventRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateConversionEventRequest} message CreateConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateConversionEventRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateConversionEventRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreateConversionEventRequest} CreateConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConversionEventRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreateConversionEventRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.conversionEvent = $root.google.analytics.admin.v1beta.ConversionEvent.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateConversionEventRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreateConversionEventRequest} CreateConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateConversionEventRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateConversionEventRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateConversionEventRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent")) {
                                var error = $root.google.analytics.admin.v1beta.ConversionEvent.verify(message.conversionEvent);
                                if (error)
                                    return "conversionEvent." + error;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a CreateConversionEventRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreateConversionEventRequest} CreateConversionEventRequest
                         */
                        CreateConversionEventRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreateConversionEventRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreateConversionEventRequest();
                            if (object.conversionEvent != null) {
                                if (typeof object.conversionEvent !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreateConversionEventRequest.conversionEvent: object expected");
                                message.conversionEvent = $root.google.analytics.admin.v1beta.ConversionEvent.fromObject(object.conversionEvent);
                            }
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateConversionEventRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreateConversionEventRequest} message CreateConversionEventRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateConversionEventRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.conversionEvent = null;
                                object.parent = "";
                            }
                            if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent"))
                                object.conversionEvent = $root.google.analytics.admin.v1beta.ConversionEvent.toObject(message.conversionEvent, options);
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            return object;
                        };
    
                        /**
                         * Converts this CreateConversionEventRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateConversionEventRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateConversionEventRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreateConversionEventRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateConversionEventRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreateConversionEventRequest";
                        };
    
                        return CreateConversionEventRequest;
                    })();
    
                    v1beta.GetConversionEventRequest = (function() {
    
                        /**
                         * Properties of a GetConversionEventRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetConversionEventRequest
                         * @property {string|null} [name] GetConversionEventRequest name
                         */
    
                        /**
                         * Constructs a new GetConversionEventRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetConversionEventRequest.
                         * @implements IGetConversionEventRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetConversionEventRequest=} [properties] Properties to set
                         */
                        function GetConversionEventRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetConversionEventRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @instance
                         */
                        GetConversionEventRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetConversionEventRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetConversionEventRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetConversionEventRequest} GetConversionEventRequest instance
                         */
                        GetConversionEventRequest.create = function create(properties) {
                            return new GetConversionEventRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetConversionEventRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetConversionEventRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetConversionEventRequest} message GetConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetConversionEventRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetConversionEventRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetConversionEventRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetConversionEventRequest} message GetConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetConversionEventRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetConversionEventRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetConversionEventRequest} GetConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetConversionEventRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetConversionEventRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetConversionEventRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetConversionEventRequest} GetConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetConversionEventRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetConversionEventRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetConversionEventRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetConversionEventRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetConversionEventRequest} GetConversionEventRequest
                         */
                        GetConversionEventRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetConversionEventRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetConversionEventRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetConversionEventRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetConversionEventRequest} message GetConversionEventRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetConversionEventRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetConversionEventRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetConversionEventRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetConversionEventRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetConversionEventRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetConversionEventRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetConversionEventRequest";
                        };
    
                        return GetConversionEventRequest;
                    })();
    
                    v1beta.DeleteConversionEventRequest = (function() {
    
                        /**
                         * Properties of a DeleteConversionEventRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDeleteConversionEventRequest
                         * @property {string|null} [name] DeleteConversionEventRequest name
                         */
    
                        /**
                         * Constructs a new DeleteConversionEventRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DeleteConversionEventRequest.
                         * @implements IDeleteConversionEventRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDeleteConversionEventRequest=} [properties] Properties to set
                         */
                        function DeleteConversionEventRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteConversionEventRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @instance
                         */
                        DeleteConversionEventRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteConversionEventRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteConversionEventRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DeleteConversionEventRequest} DeleteConversionEventRequest instance
                         */
                        DeleteConversionEventRequest.create = function create(properties) {
                            return new DeleteConversionEventRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteConversionEventRequest message. Does not implicitly {@link google.analytics.admin.v1beta.DeleteConversionEventRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteConversionEventRequest} message DeleteConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteConversionEventRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteConversionEventRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DeleteConversionEventRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteConversionEventRequest} message DeleteConversionEventRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteConversionEventRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteConversionEventRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DeleteConversionEventRequest} DeleteConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteConversionEventRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DeleteConversionEventRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteConversionEventRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DeleteConversionEventRequest} DeleteConversionEventRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteConversionEventRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteConversionEventRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteConversionEventRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteConversionEventRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DeleteConversionEventRequest} DeleteConversionEventRequest
                         */
                        DeleteConversionEventRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DeleteConversionEventRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DeleteConversionEventRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteConversionEventRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.DeleteConversionEventRequest} message DeleteConversionEventRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteConversionEventRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteConversionEventRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteConversionEventRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteConversionEventRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DeleteConversionEventRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteConversionEventRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DeleteConversionEventRequest";
                        };
    
                        return DeleteConversionEventRequest;
                    })();
    
                    v1beta.ListConversionEventsRequest = (function() {
    
                        /**
                         * Properties of a ListConversionEventsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListConversionEventsRequest
                         * @property {string|null} [parent] ListConversionEventsRequest parent
                         * @property {number|null} [pageSize] ListConversionEventsRequest pageSize
                         * @property {string|null} [pageToken] ListConversionEventsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListConversionEventsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListConversionEventsRequest.
                         * @implements IListConversionEventsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListConversionEventsRequest=} [properties] Properties to set
                         */
                        function ListConversionEventsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListConversionEventsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @instance
                         */
                        ListConversionEventsRequest.prototype.parent = "";
    
                        /**
                         * ListConversionEventsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @instance
                         */
                        ListConversionEventsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListConversionEventsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @instance
                         */
                        ListConversionEventsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListConversionEventsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListConversionEventsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsRequest} ListConversionEventsRequest instance
                         */
                        ListConversionEventsRequest.create = function create(properties) {
                            return new ListConversionEventsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListConversionEventsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListConversionEventsRequest} message ListConversionEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListConversionEventsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListConversionEventsRequest} message ListConversionEventsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListConversionEventsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsRequest} ListConversionEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListConversionEventsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListConversionEventsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsRequest} ListConversionEventsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListConversionEventsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListConversionEventsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListConversionEventsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsRequest} ListConversionEventsRequest
                         */
                        ListConversionEventsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListConversionEventsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListConversionEventsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListConversionEventsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListConversionEventsRequest} message ListConversionEventsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListConversionEventsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListConversionEventsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListConversionEventsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListConversionEventsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListConversionEventsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListConversionEventsRequest";
                        };
    
                        return ListConversionEventsRequest;
                    })();
    
                    v1beta.ListConversionEventsResponse = (function() {
    
                        /**
                         * Properties of a ListConversionEventsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListConversionEventsResponse
                         * @property {Array.<google.analytics.admin.v1beta.IConversionEvent>|null} [conversionEvents] ListConversionEventsResponse conversionEvents
                         * @property {string|null} [nextPageToken] ListConversionEventsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListConversionEventsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListConversionEventsResponse.
                         * @implements IListConversionEventsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListConversionEventsResponse=} [properties] Properties to set
                         */
                        function ListConversionEventsResponse(properties) {
                            this.conversionEvents = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListConversionEventsResponse conversionEvents.
                         * @member {Array.<google.analytics.admin.v1beta.IConversionEvent>} conversionEvents
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @instance
                         */
                        ListConversionEventsResponse.prototype.conversionEvents = $util.emptyArray;
    
                        /**
                         * ListConversionEventsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @instance
                         */
                        ListConversionEventsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListConversionEventsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListConversionEventsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsResponse} ListConversionEventsResponse instance
                         */
                        ListConversionEventsResponse.create = function create(properties) {
                            return new ListConversionEventsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListConversionEventsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListConversionEventsResponse} message ListConversionEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.conversionEvents != null && message.conversionEvents.length)
                                for (var i = 0; i < message.conversionEvents.length; ++i)
                                    $root.google.analytics.admin.v1beta.ConversionEvent.encode(message.conversionEvents[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListConversionEventsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListConversionEventsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListConversionEventsResponse} message ListConversionEventsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListConversionEventsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListConversionEventsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsResponse} ListConversionEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListConversionEventsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.conversionEvents && message.conversionEvents.length))
                                            message.conversionEvents = [];
                                        message.conversionEvents.push($root.google.analytics.admin.v1beta.ConversionEvent.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListConversionEventsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsResponse} ListConversionEventsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListConversionEventsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListConversionEventsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListConversionEventsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.conversionEvents != null && message.hasOwnProperty("conversionEvents")) {
                                if (!Array.isArray(message.conversionEvents))
                                    return "conversionEvents: array expected";
                                for (var i = 0; i < message.conversionEvents.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.ConversionEvent.verify(message.conversionEvents[i]);
                                    if (error)
                                        return "conversionEvents." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListConversionEventsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListConversionEventsResponse} ListConversionEventsResponse
                         */
                        ListConversionEventsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListConversionEventsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListConversionEventsResponse();
                            if (object.conversionEvents) {
                                if (!Array.isArray(object.conversionEvents))
                                    throw TypeError(".google.analytics.admin.v1beta.ListConversionEventsResponse.conversionEvents: array expected");
                                message.conversionEvents = [];
                                for (var i = 0; i < object.conversionEvents.length; ++i) {
                                    if (typeof object.conversionEvents[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListConversionEventsResponse.conversionEvents: object expected");
                                    message.conversionEvents[i] = $root.google.analytics.admin.v1beta.ConversionEvent.fromObject(object.conversionEvents[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListConversionEventsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListConversionEventsResponse} message ListConversionEventsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListConversionEventsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.conversionEvents = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.conversionEvents && message.conversionEvents.length) {
                                object.conversionEvents = [];
                                for (var j = 0; j < message.conversionEvents.length; ++j)
                                    object.conversionEvents[j] = $root.google.analytics.admin.v1beta.ConversionEvent.toObject(message.conversionEvents[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListConversionEventsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListConversionEventsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListConversionEventsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListConversionEventsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListConversionEventsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListConversionEventsResponse";
                        };
    
                        return ListConversionEventsResponse;
                    })();
    
                    v1beta.CreateCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of a CreateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreateCustomDimensionRequest
                         * @property {string|null} [parent] CreateCustomDimensionRequest parent
                         * @property {google.analytics.admin.v1beta.ICustomDimension|null} [customDimension] CreateCustomDimensionRequest customDimension
                         */
    
                        /**
                         * Constructs a new CreateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreateCustomDimensionRequest.
                         * @implements ICreateCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreateCustomDimensionRequest=} [properties] Properties to set
                         */
                        function CreateCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateCustomDimensionRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @instance
                         */
                        CreateCustomDimensionRequest.prototype.parent = "";
    
                        /**
                         * CreateCustomDimensionRequest customDimension.
                         * @member {google.analytics.admin.v1beta.ICustomDimension|null|undefined} customDimension
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @instance
                         */
                        CreateCustomDimensionRequest.prototype.customDimension = null;
    
                        /**
                         * Creates a new CreateCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreateCustomDimensionRequest} CreateCustomDimensionRequest instance
                         */
                        CreateCustomDimensionRequest.create = function create(properties) {
                            return new CreateCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreateCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateCustomDimensionRequest} message CreateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.customDimension != null && Object.hasOwnProperty.call(message, "customDimension"))
                                $root.google.analytics.admin.v1beta.CustomDimension.encode(message.customDimension, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreateCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateCustomDimensionRequest} message CreateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreateCustomDimensionRequest} CreateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreateCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.customDimension = $root.google.analytics.admin.v1beta.CustomDimension.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreateCustomDimensionRequest} CreateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.customDimension != null && message.hasOwnProperty("customDimension")) {
                                var error = $root.google.analytics.admin.v1beta.CustomDimension.verify(message.customDimension);
                                if (error)
                                    return "customDimension." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreateCustomDimensionRequest} CreateCustomDimensionRequest
                         */
                        CreateCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreateCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreateCustomDimensionRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.customDimension != null) {
                                if (typeof object.customDimension !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreateCustomDimensionRequest.customDimension: object expected");
                                message.customDimension = $root.google.analytics.admin.v1beta.CustomDimension.fromObject(object.customDimension);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreateCustomDimensionRequest} message CreateCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.customDimension = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.customDimension != null && message.hasOwnProperty("customDimension"))
                                object.customDimension = $root.google.analytics.admin.v1beta.CustomDimension.toObject(message.customDimension, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreateCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreateCustomDimensionRequest";
                        };
    
                        return CreateCustomDimensionRequest;
                    })();
    
                    v1beta.UpdateCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of an UpdateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdateCustomDimensionRequest
                         * @property {google.analytics.admin.v1beta.ICustomDimension|null} [customDimension] UpdateCustomDimensionRequest customDimension
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateCustomDimensionRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdateCustomDimensionRequest.
                         * @implements IUpdateCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdateCustomDimensionRequest=} [properties] Properties to set
                         */
                        function UpdateCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateCustomDimensionRequest customDimension.
                         * @member {google.analytics.admin.v1beta.ICustomDimension|null|undefined} customDimension
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @instance
                         */
                        UpdateCustomDimensionRequest.prototype.customDimension = null;
    
                        /**
                         * UpdateCustomDimensionRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @instance
                         */
                        UpdateCustomDimensionRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest instance
                         */
                        UpdateCustomDimensionRequest.create = function create(properties) {
                            return new UpdateCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdateCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateCustomDimensionRequest} message UpdateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customDimension != null && Object.hasOwnProperty.call(message, "customDimension"))
                                $root.google.analytics.admin.v1beta.CustomDimension.encode(message.customDimension, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdateCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateCustomDimensionRequest} message UpdateCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdateCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.customDimension = $root.google.analytics.admin.v1beta.CustomDimension.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customDimension != null && message.hasOwnProperty("customDimension")) {
                                var error = $root.google.analytics.admin.v1beta.CustomDimension.verify(message.customDimension);
                                if (error)
                                    return "customDimension." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdateCustomDimensionRequest} UpdateCustomDimensionRequest
                         */
                        UpdateCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdateCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdateCustomDimensionRequest();
                            if (object.customDimension != null) {
                                if (typeof object.customDimension !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateCustomDimensionRequest.customDimension: object expected");
                                message.customDimension = $root.google.analytics.admin.v1beta.CustomDimension.fromObject(object.customDimension);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateCustomDimensionRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdateCustomDimensionRequest} message UpdateCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customDimension = null;
                                object.updateMask = null;
                            }
                            if (message.customDimension != null && message.hasOwnProperty("customDimension"))
                                object.customDimension = $root.google.analytics.admin.v1beta.CustomDimension.toObject(message.customDimension, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdateCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdateCustomDimensionRequest";
                        };
    
                        return UpdateCustomDimensionRequest;
                    })();
    
                    v1beta.ListCustomDimensionsRequest = (function() {
    
                        /**
                         * Properties of a ListCustomDimensionsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListCustomDimensionsRequest
                         * @property {string|null} [parent] ListCustomDimensionsRequest parent
                         * @property {number|null} [pageSize] ListCustomDimensionsRequest pageSize
                         * @property {string|null} [pageToken] ListCustomDimensionsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListCustomDimensionsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListCustomDimensionsRequest.
                         * @implements IListCustomDimensionsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsRequest=} [properties] Properties to set
                         */
                        function ListCustomDimensionsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomDimensionsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @instance
                         */
                        ListCustomDimensionsRequest.prototype.parent = "";
    
                        /**
                         * ListCustomDimensionsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @instance
                         */
                        ListCustomDimensionsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListCustomDimensionsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @instance
                         */
                        ListCustomDimensionsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListCustomDimensionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsRequest} ListCustomDimensionsRequest instance
                         */
                        ListCustomDimensionsRequest.create = function create(properties) {
                            return new ListCustomDimensionsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomDimensionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsRequest} message ListCustomDimensionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomDimensionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsRequest} message ListCustomDimensionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsRequest} ListCustomDimensionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListCustomDimensionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsRequest} ListCustomDimensionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomDimensionsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomDimensionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomDimensionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsRequest} ListCustomDimensionsRequest
                         */
                        ListCustomDimensionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListCustomDimensionsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListCustomDimensionsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomDimensionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListCustomDimensionsRequest} message ListCustomDimensionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomDimensionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomDimensionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomDimensionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomDimensionsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomDimensionsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListCustomDimensionsRequest";
                        };
    
                        return ListCustomDimensionsRequest;
                    })();
    
                    v1beta.ListCustomDimensionsResponse = (function() {
    
                        /**
                         * Properties of a ListCustomDimensionsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListCustomDimensionsResponse
                         * @property {Array.<google.analytics.admin.v1beta.ICustomDimension>|null} [customDimensions] ListCustomDimensionsResponse customDimensions
                         * @property {string|null} [nextPageToken] ListCustomDimensionsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListCustomDimensionsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListCustomDimensionsResponse.
                         * @implements IListCustomDimensionsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsResponse=} [properties] Properties to set
                         */
                        function ListCustomDimensionsResponse(properties) {
                            this.customDimensions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomDimensionsResponse customDimensions.
                         * @member {Array.<google.analytics.admin.v1beta.ICustomDimension>} customDimensions
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @instance
                         */
                        ListCustomDimensionsResponse.prototype.customDimensions = $util.emptyArray;
    
                        /**
                         * ListCustomDimensionsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @instance
                         */
                        ListCustomDimensionsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListCustomDimensionsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsResponse} ListCustomDimensionsResponse instance
                         */
                        ListCustomDimensionsResponse.create = function create(properties) {
                            return new ListCustomDimensionsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomDimensionsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsResponse} message ListCustomDimensionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customDimensions != null && message.customDimensions.length)
                                for (var i = 0; i < message.customDimensions.length; ++i)
                                    $root.google.analytics.admin.v1beta.CustomDimension.encode(message.customDimensions[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomDimensionsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomDimensionsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomDimensionsResponse} message ListCustomDimensionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomDimensionsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsResponse} ListCustomDimensionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListCustomDimensionsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.customDimensions && message.customDimensions.length))
                                            message.customDimensions = [];
                                        message.customDimensions.push($root.google.analytics.admin.v1beta.CustomDimension.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomDimensionsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsResponse} ListCustomDimensionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomDimensionsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomDimensionsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomDimensionsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customDimensions != null && message.hasOwnProperty("customDimensions")) {
                                if (!Array.isArray(message.customDimensions))
                                    return "customDimensions: array expected";
                                for (var i = 0; i < message.customDimensions.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.CustomDimension.verify(message.customDimensions[i]);
                                    if (error)
                                        return "customDimensions." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomDimensionsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListCustomDimensionsResponse} ListCustomDimensionsResponse
                         */
                        ListCustomDimensionsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListCustomDimensionsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListCustomDimensionsResponse();
                            if (object.customDimensions) {
                                if (!Array.isArray(object.customDimensions))
                                    throw TypeError(".google.analytics.admin.v1beta.ListCustomDimensionsResponse.customDimensions: array expected");
                                message.customDimensions = [];
                                for (var i = 0; i < object.customDimensions.length; ++i) {
                                    if (typeof object.customDimensions[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListCustomDimensionsResponse.customDimensions: object expected");
                                    message.customDimensions[i] = $root.google.analytics.admin.v1beta.CustomDimension.fromObject(object.customDimensions[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomDimensionsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListCustomDimensionsResponse} message ListCustomDimensionsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomDimensionsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.customDimensions = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.customDimensions && message.customDimensions.length) {
                                object.customDimensions = [];
                                for (var j = 0; j < message.customDimensions.length; ++j)
                                    object.customDimensions[j] = $root.google.analytics.admin.v1beta.CustomDimension.toObject(message.customDimensions[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomDimensionsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomDimensionsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomDimensionsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListCustomDimensionsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomDimensionsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListCustomDimensionsResponse";
                        };
    
                        return ListCustomDimensionsResponse;
                    })();
    
                    v1beta.ArchiveCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of an ArchiveCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IArchiveCustomDimensionRequest
                         * @property {string|null} [name] ArchiveCustomDimensionRequest name
                         */
    
                        /**
                         * Constructs a new ArchiveCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an ArchiveCustomDimensionRequest.
                         * @implements IArchiveCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IArchiveCustomDimensionRequest=} [properties] Properties to set
                         */
                        function ArchiveCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ArchiveCustomDimensionRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @instance
                         */
                        ArchiveCustomDimensionRequest.prototype.name = "";
    
                        /**
                         * Creates a new ArchiveCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IArchiveCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest instance
                         */
                        ArchiveCustomDimensionRequest.create = function create(properties) {
                            return new ArchiveCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ArchiveCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IArchiveCustomDimensionRequest} message ArchiveCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ArchiveCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IArchiveCustomDimensionRequest} message ArchiveCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ArchiveCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ArchiveCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ArchiveCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ArchiveCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ArchiveCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ArchiveCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomDimensionRequest} ArchiveCustomDimensionRequest
                         */
                        ArchiveCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ArchiveCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ArchiveCustomDimensionRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ArchiveCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ArchiveCustomDimensionRequest} message ArchiveCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ArchiveCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this ArchiveCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ArchiveCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ArchiveCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ArchiveCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ArchiveCustomDimensionRequest";
                        };
    
                        return ArchiveCustomDimensionRequest;
                    })();
    
                    v1beta.GetCustomDimensionRequest = (function() {
    
                        /**
                         * Properties of a GetCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetCustomDimensionRequest
                         * @property {string|null} [name] GetCustomDimensionRequest name
                         */
    
                        /**
                         * Constructs a new GetCustomDimensionRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetCustomDimensionRequest.
                         * @implements IGetCustomDimensionRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetCustomDimensionRequest=} [properties] Properties to set
                         */
                        function GetCustomDimensionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetCustomDimensionRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @instance
                         */
                        GetCustomDimensionRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetCustomDimensionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetCustomDimensionRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetCustomDimensionRequest} GetCustomDimensionRequest instance
                         */
                        GetCustomDimensionRequest.create = function create(properties) {
                            return new GetCustomDimensionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetCustomDimensionRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetCustomDimensionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetCustomDimensionRequest} message GetCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomDimensionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetCustomDimensionRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetCustomDimensionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetCustomDimensionRequest} message GetCustomDimensionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomDimensionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetCustomDimensionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetCustomDimensionRequest} GetCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomDimensionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetCustomDimensionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetCustomDimensionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetCustomDimensionRequest} GetCustomDimensionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomDimensionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetCustomDimensionRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomDimensionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetCustomDimensionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetCustomDimensionRequest} GetCustomDimensionRequest
                         */
                        GetCustomDimensionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetCustomDimensionRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetCustomDimensionRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetCustomDimensionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetCustomDimensionRequest} message GetCustomDimensionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomDimensionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetCustomDimensionRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomDimensionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetCustomDimensionRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetCustomDimensionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetCustomDimensionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetCustomDimensionRequest";
                        };
    
                        return GetCustomDimensionRequest;
                    })();
    
                    v1beta.CreateCustomMetricRequest = (function() {
    
                        /**
                         * Properties of a CreateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreateCustomMetricRequest
                         * @property {string|null} [parent] CreateCustomMetricRequest parent
                         * @property {google.analytics.admin.v1beta.ICustomMetric|null} [customMetric] CreateCustomMetricRequest customMetric
                         */
    
                        /**
                         * Constructs a new CreateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreateCustomMetricRequest.
                         * @implements ICreateCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreateCustomMetricRequest=} [properties] Properties to set
                         */
                        function CreateCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateCustomMetricRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @instance
                         */
                        CreateCustomMetricRequest.prototype.parent = "";
    
                        /**
                         * CreateCustomMetricRequest customMetric.
                         * @member {google.analytics.admin.v1beta.ICustomMetric|null|undefined} customMetric
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @instance
                         */
                        CreateCustomMetricRequest.prototype.customMetric = null;
    
                        /**
                         * Creates a new CreateCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreateCustomMetricRequest} CreateCustomMetricRequest instance
                         */
                        CreateCustomMetricRequest.create = function create(properties) {
                            return new CreateCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreateCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateCustomMetricRequest} message CreateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.customMetric != null && Object.hasOwnProperty.call(message, "customMetric"))
                                $root.google.analytics.admin.v1beta.CustomMetric.encode(message.customMetric, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreateCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateCustomMetricRequest} message CreateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreateCustomMetricRequest} CreateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreateCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.customMetric = $root.google.analytics.admin.v1beta.CustomMetric.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreateCustomMetricRequest} CreateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.customMetric != null && message.hasOwnProperty("customMetric")) {
                                var error = $root.google.analytics.admin.v1beta.CustomMetric.verify(message.customMetric);
                                if (error)
                                    return "customMetric." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreateCustomMetricRequest} CreateCustomMetricRequest
                         */
                        CreateCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreateCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreateCustomMetricRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.customMetric != null) {
                                if (typeof object.customMetric !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreateCustomMetricRequest.customMetric: object expected");
                                message.customMetric = $root.google.analytics.admin.v1beta.CustomMetric.fromObject(object.customMetric);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreateCustomMetricRequest} message CreateCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.customMetric = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.customMetric != null && message.hasOwnProperty("customMetric"))
                                object.customMetric = $root.google.analytics.admin.v1beta.CustomMetric.toObject(message.customMetric, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreateCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreateCustomMetricRequest";
                        };
    
                        return CreateCustomMetricRequest;
                    })();
    
                    v1beta.UpdateCustomMetricRequest = (function() {
    
                        /**
                         * Properties of an UpdateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdateCustomMetricRequest
                         * @property {google.analytics.admin.v1beta.ICustomMetric|null} [customMetric] UpdateCustomMetricRequest customMetric
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateCustomMetricRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdateCustomMetricRequest.
                         * @implements IUpdateCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdateCustomMetricRequest=} [properties] Properties to set
                         */
                        function UpdateCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateCustomMetricRequest customMetric.
                         * @member {google.analytics.admin.v1beta.ICustomMetric|null|undefined} customMetric
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @instance
                         */
                        UpdateCustomMetricRequest.prototype.customMetric = null;
    
                        /**
                         * UpdateCustomMetricRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @instance
                         */
                        UpdateCustomMetricRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdateCustomMetricRequest} UpdateCustomMetricRequest instance
                         */
                        UpdateCustomMetricRequest.create = function create(properties) {
                            return new UpdateCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdateCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateCustomMetricRequest} message UpdateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customMetric != null && Object.hasOwnProperty.call(message, "customMetric"))
                                $root.google.analytics.admin.v1beta.CustomMetric.encode(message.customMetric, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdateCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateCustomMetricRequest} message UpdateCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdateCustomMetricRequest} UpdateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdateCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.customMetric = $root.google.analytics.admin.v1beta.CustomMetric.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdateCustomMetricRequest} UpdateCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customMetric != null && message.hasOwnProperty("customMetric")) {
                                var error = $root.google.analytics.admin.v1beta.CustomMetric.verify(message.customMetric);
                                if (error)
                                    return "customMetric." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdateCustomMetricRequest} UpdateCustomMetricRequest
                         */
                        UpdateCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdateCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdateCustomMetricRequest();
                            if (object.customMetric != null) {
                                if (typeof object.customMetric !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateCustomMetricRequest.customMetric: object expected");
                                message.customMetric = $root.google.analytics.admin.v1beta.CustomMetric.fromObject(object.customMetric);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateCustomMetricRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdateCustomMetricRequest} message UpdateCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.customMetric = null;
                                object.updateMask = null;
                            }
                            if (message.customMetric != null && message.hasOwnProperty("customMetric"))
                                object.customMetric = $root.google.analytics.admin.v1beta.CustomMetric.toObject(message.customMetric, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdateCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdateCustomMetricRequest";
                        };
    
                        return UpdateCustomMetricRequest;
                    })();
    
                    v1beta.ListCustomMetricsRequest = (function() {
    
                        /**
                         * Properties of a ListCustomMetricsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListCustomMetricsRequest
                         * @property {string|null} [parent] ListCustomMetricsRequest parent
                         * @property {number|null} [pageSize] ListCustomMetricsRequest pageSize
                         * @property {string|null} [pageToken] ListCustomMetricsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListCustomMetricsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListCustomMetricsRequest.
                         * @implements IListCustomMetricsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsRequest=} [properties] Properties to set
                         */
                        function ListCustomMetricsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomMetricsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @instance
                         */
                        ListCustomMetricsRequest.prototype.parent = "";
    
                        /**
                         * ListCustomMetricsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @instance
                         */
                        ListCustomMetricsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListCustomMetricsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @instance
                         */
                        ListCustomMetricsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListCustomMetricsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsRequest} ListCustomMetricsRequest instance
                         */
                        ListCustomMetricsRequest.create = function create(properties) {
                            return new ListCustomMetricsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomMetricsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsRequest} message ListCustomMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomMetricsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsRequest} message ListCustomMetricsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomMetricsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsRequest} ListCustomMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListCustomMetricsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomMetricsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsRequest} ListCustomMetricsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomMetricsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomMetricsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomMetricsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsRequest} ListCustomMetricsRequest
                         */
                        ListCustomMetricsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListCustomMetricsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListCustomMetricsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomMetricsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListCustomMetricsRequest} message ListCustomMetricsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomMetricsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomMetricsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomMetricsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomMetricsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomMetricsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListCustomMetricsRequest";
                        };
    
                        return ListCustomMetricsRequest;
                    })();
    
                    v1beta.ListCustomMetricsResponse = (function() {
    
                        /**
                         * Properties of a ListCustomMetricsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListCustomMetricsResponse
                         * @property {Array.<google.analytics.admin.v1beta.ICustomMetric>|null} [customMetrics] ListCustomMetricsResponse customMetrics
                         * @property {string|null} [nextPageToken] ListCustomMetricsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListCustomMetricsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListCustomMetricsResponse.
                         * @implements IListCustomMetricsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsResponse=} [properties] Properties to set
                         */
                        function ListCustomMetricsResponse(properties) {
                            this.customMetrics = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListCustomMetricsResponse customMetrics.
                         * @member {Array.<google.analytics.admin.v1beta.ICustomMetric>} customMetrics
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @instance
                         */
                        ListCustomMetricsResponse.prototype.customMetrics = $util.emptyArray;
    
                        /**
                         * ListCustomMetricsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @instance
                         */
                        ListCustomMetricsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListCustomMetricsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsResponse} ListCustomMetricsResponse instance
                         */
                        ListCustomMetricsResponse.create = function create(properties) {
                            return new ListCustomMetricsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomMetricsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsResponse} message ListCustomMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customMetrics != null && message.customMetrics.length)
                                for (var i = 0; i < message.customMetrics.length; ++i)
                                    $root.google.analytics.admin.v1beta.CustomMetric.encode(message.customMetrics[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListCustomMetricsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListCustomMetricsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListCustomMetricsResponse} message ListCustomMetricsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListCustomMetricsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListCustomMetricsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsResponse} ListCustomMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListCustomMetricsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.customMetrics && message.customMetrics.length))
                                            message.customMetrics = [];
                                        message.customMetrics.push($root.google.analytics.admin.v1beta.CustomMetric.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListCustomMetricsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsResponse} ListCustomMetricsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListCustomMetricsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListCustomMetricsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListCustomMetricsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.customMetrics != null && message.hasOwnProperty("customMetrics")) {
                                if (!Array.isArray(message.customMetrics))
                                    return "customMetrics: array expected";
                                for (var i = 0; i < message.customMetrics.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.CustomMetric.verify(message.customMetrics[i]);
                                    if (error)
                                        return "customMetrics." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListCustomMetricsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListCustomMetricsResponse} ListCustomMetricsResponse
                         */
                        ListCustomMetricsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListCustomMetricsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListCustomMetricsResponse();
                            if (object.customMetrics) {
                                if (!Array.isArray(object.customMetrics))
                                    throw TypeError(".google.analytics.admin.v1beta.ListCustomMetricsResponse.customMetrics: array expected");
                                message.customMetrics = [];
                                for (var i = 0; i < object.customMetrics.length; ++i) {
                                    if (typeof object.customMetrics[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListCustomMetricsResponse.customMetrics: object expected");
                                    message.customMetrics[i] = $root.google.analytics.admin.v1beta.CustomMetric.fromObject(object.customMetrics[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListCustomMetricsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListCustomMetricsResponse} message ListCustomMetricsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListCustomMetricsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.customMetrics = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.customMetrics && message.customMetrics.length) {
                                object.customMetrics = [];
                                for (var j = 0; j < message.customMetrics.length; ++j)
                                    object.customMetrics[j] = $root.google.analytics.admin.v1beta.CustomMetric.toObject(message.customMetrics[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListCustomMetricsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListCustomMetricsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListCustomMetricsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListCustomMetricsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListCustomMetricsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListCustomMetricsResponse";
                        };
    
                        return ListCustomMetricsResponse;
                    })();
    
                    v1beta.ArchiveCustomMetricRequest = (function() {
    
                        /**
                         * Properties of an ArchiveCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IArchiveCustomMetricRequest
                         * @property {string|null} [name] ArchiveCustomMetricRequest name
                         */
    
                        /**
                         * Constructs a new ArchiveCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an ArchiveCustomMetricRequest.
                         * @implements IArchiveCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IArchiveCustomMetricRequest=} [properties] Properties to set
                         */
                        function ArchiveCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ArchiveCustomMetricRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @instance
                         */
                        ArchiveCustomMetricRequest.prototype.name = "";
    
                        /**
                         * Creates a new ArchiveCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IArchiveCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest instance
                         */
                        ArchiveCustomMetricRequest.create = function create(properties) {
                            return new ArchiveCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ArchiveCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IArchiveCustomMetricRequest} message ArchiveCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ArchiveCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ArchiveCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IArchiveCustomMetricRequest} message ArchiveCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ArchiveCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ArchiveCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ArchiveCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ArchiveCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ArchiveCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ArchiveCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ArchiveCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ArchiveCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ArchiveCustomMetricRequest} ArchiveCustomMetricRequest
                         */
                        ArchiveCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ArchiveCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ArchiveCustomMetricRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ArchiveCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ArchiveCustomMetricRequest} message ArchiveCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ArchiveCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this ArchiveCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ArchiveCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ArchiveCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ArchiveCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ArchiveCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ArchiveCustomMetricRequest";
                        };
    
                        return ArchiveCustomMetricRequest;
                    })();
    
                    v1beta.GetCustomMetricRequest = (function() {
    
                        /**
                         * Properties of a GetCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetCustomMetricRequest
                         * @property {string|null} [name] GetCustomMetricRequest name
                         */
    
                        /**
                         * Constructs a new GetCustomMetricRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetCustomMetricRequest.
                         * @implements IGetCustomMetricRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetCustomMetricRequest=} [properties] Properties to set
                         */
                        function GetCustomMetricRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetCustomMetricRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @instance
                         */
                        GetCustomMetricRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetCustomMetricRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetCustomMetricRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetCustomMetricRequest} GetCustomMetricRequest instance
                         */
                        GetCustomMetricRequest.create = function create(properties) {
                            return new GetCustomMetricRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetCustomMetricRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetCustomMetricRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetCustomMetricRequest} message GetCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomMetricRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetCustomMetricRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetCustomMetricRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetCustomMetricRequest} message GetCustomMetricRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetCustomMetricRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetCustomMetricRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetCustomMetricRequest} GetCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomMetricRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetCustomMetricRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetCustomMetricRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetCustomMetricRequest} GetCustomMetricRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetCustomMetricRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetCustomMetricRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetCustomMetricRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetCustomMetricRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetCustomMetricRequest} GetCustomMetricRequest
                         */
                        GetCustomMetricRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetCustomMetricRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetCustomMetricRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetCustomMetricRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetCustomMetricRequest} message GetCustomMetricRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetCustomMetricRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetCustomMetricRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetCustomMetricRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetCustomMetricRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetCustomMetricRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetCustomMetricRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetCustomMetricRequest";
                        };
    
                        return GetCustomMetricRequest;
                    })();
    
                    v1beta.GetDataRetentionSettingsRequest = (function() {
    
                        /**
                         * Properties of a GetDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetDataRetentionSettingsRequest
                         * @property {string|null} [name] GetDataRetentionSettingsRequest name
                         */
    
                        /**
                         * Constructs a new GetDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetDataRetentionSettingsRequest.
                         * @implements IGetDataRetentionSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetDataRetentionSettingsRequest=} [properties] Properties to set
                         */
                        function GetDataRetentionSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDataRetentionSettingsRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @instance
                         */
                        GetDataRetentionSettingsRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDataRetentionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataRetentionSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest instance
                         */
                        GetDataRetentionSettingsRequest.create = function create(properties) {
                            return new GetDataRetentionSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDataRetentionSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataRetentionSettingsRequest} message GetDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataRetentionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDataRetentionSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataRetentionSettingsRequest} message GetDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataRetentionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDataRetentionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataRetentionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetDataRetentionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDataRetentionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataRetentionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDataRetentionSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDataRetentionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDataRetentionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetDataRetentionSettingsRequest} GetDataRetentionSettingsRequest
                         */
                        GetDataRetentionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetDataRetentionSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetDataRetentionSettingsRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDataRetentionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetDataRetentionSettingsRequest} message GetDataRetentionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDataRetentionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDataRetentionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDataRetentionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDataRetentionSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetDataRetentionSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDataRetentionSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetDataRetentionSettingsRequest";
                        };
    
                        return GetDataRetentionSettingsRequest;
                    })();
    
                    v1beta.UpdateDataRetentionSettingsRequest = (function() {
    
                        /**
                         * Properties of an UpdateDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdateDataRetentionSettingsRequest
                         * @property {google.analytics.admin.v1beta.IDataRetentionSettings|null} [dataRetentionSettings] UpdateDataRetentionSettingsRequest dataRetentionSettings
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateDataRetentionSettingsRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateDataRetentionSettingsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdateDataRetentionSettingsRequest.
                         * @implements IUpdateDataRetentionSettingsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdateDataRetentionSettingsRequest=} [properties] Properties to set
                         */
                        function UpdateDataRetentionSettingsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateDataRetentionSettingsRequest dataRetentionSettings.
                         * @member {google.analytics.admin.v1beta.IDataRetentionSettings|null|undefined} dataRetentionSettings
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @instance
                         */
                        UpdateDataRetentionSettingsRequest.prototype.dataRetentionSettings = null;
    
                        /**
                         * UpdateDataRetentionSettingsRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @instance
                         */
                        UpdateDataRetentionSettingsRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateDataRetentionSettingsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateDataRetentionSettingsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest instance
                         */
                        UpdateDataRetentionSettingsRequest.create = function create(properties) {
                            return new UpdateDataRetentionSettingsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateDataRetentionSettingsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateDataRetentionSettingsRequest} message UpdateDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataRetentionSettingsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dataRetentionSettings != null && Object.hasOwnProperty.call(message, "dataRetentionSettings"))
                                $root.google.analytics.admin.v1beta.DataRetentionSettings.encode(message.dataRetentionSettings, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateDataRetentionSettingsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateDataRetentionSettingsRequest} message UpdateDataRetentionSettingsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataRetentionSettingsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateDataRetentionSettingsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataRetentionSettingsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dataRetentionSettings = $root.google.analytics.admin.v1beta.DataRetentionSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateDataRetentionSettingsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataRetentionSettingsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateDataRetentionSettingsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateDataRetentionSettingsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings")) {
                                var error = $root.google.analytics.admin.v1beta.DataRetentionSettings.verify(message.dataRetentionSettings);
                                if (error)
                                    return "dataRetentionSettings." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateDataRetentionSettingsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest} UpdateDataRetentionSettingsRequest
                         */
                        UpdateDataRetentionSettingsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest();
                            if (object.dataRetentionSettings != null) {
                                if (typeof object.dataRetentionSettings !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest.dataRetentionSettings: object expected");
                                message.dataRetentionSettings = $root.google.analytics.admin.v1beta.DataRetentionSettings.fromObject(object.dataRetentionSettings);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateDataRetentionSettingsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest} message UpdateDataRetentionSettingsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateDataRetentionSettingsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.dataRetentionSettings = null;
                                object.updateMask = null;
                            }
                            if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings"))
                                object.dataRetentionSettings = $root.google.analytics.admin.v1beta.DataRetentionSettings.toObject(message.dataRetentionSettings, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateDataRetentionSettingsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateDataRetentionSettingsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateDataRetentionSettingsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateDataRetentionSettingsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdateDataRetentionSettingsRequest";
                        };
    
                        return UpdateDataRetentionSettingsRequest;
                    })();
    
                    v1beta.CreateDataStreamRequest = (function() {
    
                        /**
                         * Properties of a CreateDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICreateDataStreamRequest
                         * @property {string|null} [parent] CreateDataStreamRequest parent
                         * @property {google.analytics.admin.v1beta.IDataStream|null} [dataStream] CreateDataStreamRequest dataStream
                         */
    
                        /**
                         * Constructs a new CreateDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CreateDataStreamRequest.
                         * @implements ICreateDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICreateDataStreamRequest=} [properties] Properties to set
                         */
                        function CreateDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateDataStreamRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @instance
                         */
                        CreateDataStreamRequest.prototype.parent = "";
    
                        /**
                         * CreateDataStreamRequest dataStream.
                         * @member {google.analytics.admin.v1beta.IDataStream|null|undefined} dataStream
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @instance
                         */
                        CreateDataStreamRequest.prototype.dataStream = null;
    
                        /**
                         * Creates a new CreateDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CreateDataStreamRequest} CreateDataStreamRequest instance
                         */
                        CreateDataStreamRequest.create = function create(properties) {
                            return new CreateDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1beta.CreateDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateDataStreamRequest} message CreateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.dataStream != null && Object.hasOwnProperty.call(message, "dataStream"))
                                $root.google.analytics.admin.v1beta.DataStream.encode(message.dataStream, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CreateDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ICreateDataStreamRequest} message CreateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CreateDataStreamRequest} CreateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CreateDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.dataStream = $root.google.analytics.admin.v1beta.DataStream.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CreateDataStreamRequest} CreateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                var error = $root.google.analytics.admin.v1beta.DataStream.verify(message.dataStream);
                                if (error)
                                    return "dataStream." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CreateDataStreamRequest} CreateDataStreamRequest
                         */
                        CreateDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CreateDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CreateDataStreamRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.dataStream != null) {
                                if (typeof object.dataStream !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.CreateDataStreamRequest.dataStream: object expected");
                                message.dataStream = $root.google.analytics.admin.v1beta.DataStream.fromObject(object.dataStream);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.CreateDataStreamRequest} message CreateDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.dataStream = null;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.dataStream != null && message.hasOwnProperty("dataStream"))
                                object.dataStream = $root.google.analytics.admin.v1beta.DataStream.toObject(message.dataStream, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CreateDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CreateDataStreamRequest";
                        };
    
                        return CreateDataStreamRequest;
                    })();
    
                    v1beta.DeleteDataStreamRequest = (function() {
    
                        /**
                         * Properties of a DeleteDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDeleteDataStreamRequest
                         * @property {string|null} [name] DeleteDataStreamRequest name
                         */
    
                        /**
                         * Constructs a new DeleteDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DeleteDataStreamRequest.
                         * @implements IDeleteDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDeleteDataStreamRequest=} [properties] Properties to set
                         */
                        function DeleteDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteDataStreamRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @instance
                         */
                        DeleteDataStreamRequest.prototype.name = "";
    
                        /**
                         * Creates a new DeleteDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DeleteDataStreamRequest} DeleteDataStreamRequest instance
                         */
                        DeleteDataStreamRequest.create = function create(properties) {
                            return new DeleteDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1beta.DeleteDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteDataStreamRequest} message DeleteDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DeleteDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IDeleteDataStreamRequest} message DeleteDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DeleteDataStreamRequest} DeleteDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DeleteDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DeleteDataStreamRequest} DeleteDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DeleteDataStreamRequest} DeleteDataStreamRequest
                         */
                        DeleteDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DeleteDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DeleteDataStreamRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.DeleteDataStreamRequest} message DeleteDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DeleteDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DeleteDataStreamRequest";
                        };
    
                        return DeleteDataStreamRequest;
                    })();
    
                    v1beta.UpdateDataStreamRequest = (function() {
    
                        /**
                         * Properties of an UpdateDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IUpdateDataStreamRequest
                         * @property {google.analytics.admin.v1beta.IDataStream|null} [dataStream] UpdateDataStreamRequest dataStream
                         * @property {google.protobuf.IFieldMask|null} [updateMask] UpdateDataStreamRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an UpdateDataStreamRequest.
                         * @implements IUpdateDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IUpdateDataStreamRequest=} [properties] Properties to set
                         */
                        function UpdateDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateDataStreamRequest dataStream.
                         * @member {google.analytics.admin.v1beta.IDataStream|null|undefined} dataStream
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @instance
                         */
                        UpdateDataStreamRequest.prototype.dataStream = null;
    
                        /**
                         * UpdateDataStreamRequest updateMask.
                         * @member {google.protobuf.IFieldMask|null|undefined} updateMask
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @instance
                         */
                        UpdateDataStreamRequest.prototype.updateMask = null;
    
                        /**
                         * Creates a new UpdateDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.UpdateDataStreamRequest} UpdateDataStreamRequest instance
                         */
                        UpdateDataStreamRequest.create = function create(properties) {
                            return new UpdateDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1beta.UpdateDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateDataStreamRequest} message UpdateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dataStream != null && Object.hasOwnProperty.call(message, "dataStream"))
                                $root.google.analytics.admin.v1beta.DataStream.encode(message.dataStream, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                $root.google.protobuf.FieldMask.encode(message.updateMask, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.UpdateDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IUpdateDataStreamRequest} message UpdateDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.UpdateDataStreamRequest} UpdateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.UpdateDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.dataStream = $root.google.analytics.admin.v1beta.DataStream.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.updateMask = $root.google.protobuf.FieldMask.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.UpdateDataStreamRequest} UpdateDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                var error = $root.google.analytics.admin.v1beta.DataStream.verify(message.dataStream);
                                if (error)
                                    return "dataStream." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                var error = $root.google.protobuf.FieldMask.verify(message.updateMask);
                                if (error)
                                    return "updateMask." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.UpdateDataStreamRequest} UpdateDataStreamRequest
                         */
                        UpdateDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.UpdateDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.UpdateDataStreamRequest();
                            if (object.dataStream != null) {
                                if (typeof object.dataStream !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateDataStreamRequest.dataStream: object expected");
                                message.dataStream = $root.google.analytics.admin.v1beta.DataStream.fromObject(object.dataStream);
                            }
                            if (object.updateMask != null) {
                                if (typeof object.updateMask !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.UpdateDataStreamRequest.updateMask: object expected");
                                message.updateMask = $root.google.protobuf.FieldMask.fromObject(object.updateMask);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.UpdateDataStreamRequest} message UpdateDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.dataStream = null;
                                object.updateMask = null;
                            }
                            if (message.dataStream != null && message.hasOwnProperty("dataStream"))
                                object.dataStream = $root.google.analytics.admin.v1beta.DataStream.toObject(message.dataStream, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask"))
                                object.updateMask = $root.google.protobuf.FieldMask.toObject(message.updateMask, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.UpdateDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.UpdateDataStreamRequest";
                        };
    
                        return UpdateDataStreamRequest;
                    })();
    
                    v1beta.ListDataStreamsRequest = (function() {
    
                        /**
                         * Properties of a ListDataStreamsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListDataStreamsRequest
                         * @property {string|null} [parent] ListDataStreamsRequest parent
                         * @property {number|null} [pageSize] ListDataStreamsRequest pageSize
                         * @property {string|null} [pageToken] ListDataStreamsRequest pageToken
                         */
    
                        /**
                         * Constructs a new ListDataStreamsRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListDataStreamsRequest.
                         * @implements IListDataStreamsRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListDataStreamsRequest=} [properties] Properties to set
                         */
                        function ListDataStreamsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDataStreamsRequest parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @instance
                         */
                        ListDataStreamsRequest.prototype.parent = "";
    
                        /**
                         * ListDataStreamsRequest pageSize.
                         * @member {number} pageSize
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @instance
                         */
                        ListDataStreamsRequest.prototype.pageSize = 0;
    
                        /**
                         * ListDataStreamsRequest pageToken.
                         * @member {string} pageToken
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @instance
                         */
                        ListDataStreamsRequest.prototype.pageToken = "";
    
                        /**
                         * Creates a new ListDataStreamsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListDataStreamsRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsRequest} ListDataStreamsRequest instance
                         */
                        ListDataStreamsRequest.create = function create(properties) {
                            return new ListDataStreamsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsRequest message. Does not implicitly {@link google.analytics.admin.v1beta.ListDataStreamsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListDataStreamsRequest} message ListDataStreamsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.parent);
                            if (message.pageSize != null && Object.hasOwnProperty.call(message, "pageSize"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.pageSize);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListDataStreamsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IListDataStreamsRequest} message ListDataStreamsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDataStreamsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsRequest} ListDataStreamsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListDataStreamsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.pageSize = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDataStreamsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsRequest} ListDataStreamsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDataStreamsRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDataStreamsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                if (!$util.isInteger(message.pageSize))
                                    return "pageSize: integer expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDataStreamsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsRequest} ListDataStreamsRequest
                         */
                        ListDataStreamsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListDataStreamsRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListDataStreamsRequest();
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.pageSize != null)
                                message.pageSize = object.pageSize | 0;
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDataStreamsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.ListDataStreamsRequest} message ListDataStreamsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDataStreamsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parent = "";
                                object.pageSize = 0;
                                object.pageToken = "";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.pageSize != null && message.hasOwnProperty("pageSize"))
                                object.pageSize = message.pageSize;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken"))
                                object.pageToken = message.pageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDataStreamsRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDataStreamsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDataStreamsRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDataStreamsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListDataStreamsRequest";
                        };
    
                        return ListDataStreamsRequest;
                    })();
    
                    v1beta.ListDataStreamsResponse = (function() {
    
                        /**
                         * Properties of a ListDataStreamsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IListDataStreamsResponse
                         * @property {Array.<google.analytics.admin.v1beta.IDataStream>|null} [dataStreams] ListDataStreamsResponse dataStreams
                         * @property {string|null} [nextPageToken] ListDataStreamsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new ListDataStreamsResponse.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ListDataStreamsResponse.
                         * @implements IListDataStreamsResponse
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IListDataStreamsResponse=} [properties] Properties to set
                         */
                        function ListDataStreamsResponse(properties) {
                            this.dataStreams = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDataStreamsResponse dataStreams.
                         * @member {Array.<google.analytics.admin.v1beta.IDataStream>} dataStreams
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @instance
                         */
                        ListDataStreamsResponse.prototype.dataStreams = $util.emptyArray;
    
                        /**
                         * ListDataStreamsResponse nextPageToken.
                         * @member {string} nextPageToken
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @instance
                         */
                        ListDataStreamsResponse.prototype.nextPageToken = "";
    
                        /**
                         * Creates a new ListDataStreamsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListDataStreamsResponse=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsResponse} ListDataStreamsResponse instance
                         */
                        ListDataStreamsResponse.create = function create(properties) {
                            return new ListDataStreamsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsResponse message. Does not implicitly {@link google.analytics.admin.v1beta.ListDataStreamsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListDataStreamsResponse} message ListDataStreamsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dataStreams != null && message.dataStreams.length)
                                for (var i = 0; i < message.dataStreams.length; ++i)
                                    $root.google.analytics.admin.v1beta.DataStream.encode(message.dataStreams[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.nextPageToken);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDataStreamsResponse message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ListDataStreamsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.IListDataStreamsResponse} message ListDataStreamsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDataStreamsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDataStreamsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsResponse} ListDataStreamsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ListDataStreamsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        if (!(message.dataStreams && message.dataStreams.length))
                                            message.dataStreams = [];
                                        message.dataStreams.push($root.google.analytics.admin.v1beta.DataStream.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 2: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDataStreamsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsResponse} ListDataStreamsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDataStreamsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDataStreamsResponse message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDataStreamsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dataStreams != null && message.hasOwnProperty("dataStreams")) {
                                if (!Array.isArray(message.dataStreams))
                                    return "dataStreams: array expected";
                                for (var i = 0; i < message.dataStreams.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.DataStream.verify(message.dataStreams[i]);
                                    if (error)
                                        return "dataStreams." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDataStreamsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ListDataStreamsResponse} ListDataStreamsResponse
                         */
                        ListDataStreamsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ListDataStreamsResponse)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ListDataStreamsResponse();
                            if (object.dataStreams) {
                                if (!Array.isArray(object.dataStreams))
                                    throw TypeError(".google.analytics.admin.v1beta.ListDataStreamsResponse.dataStreams: array expected");
                                message.dataStreams = [];
                                for (var i = 0; i < object.dataStreams.length; ++i) {
                                    if (typeof object.dataStreams[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ListDataStreamsResponse.dataStreams: object expected");
                                    message.dataStreams[i] = $root.google.analytics.admin.v1beta.DataStream.fromObject(object.dataStreams[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDataStreamsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {google.analytics.admin.v1beta.ListDataStreamsResponse} message ListDataStreamsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDataStreamsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.dataStreams = [];
                            if (options.defaults)
                                object.nextPageToken = "";
                            if (message.dataStreams && message.dataStreams.length) {
                                object.dataStreams = [];
                                for (var j = 0; j < message.dataStreams.length; ++j)
                                    object.dataStreams[j] = $root.google.analytics.admin.v1beta.DataStream.toObject(message.dataStreams[j], options);
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken"))
                                object.nextPageToken = message.nextPageToken;
                            return object;
                        };
    
                        /**
                         * Converts this ListDataStreamsResponse to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDataStreamsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDataStreamsResponse
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ListDataStreamsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDataStreamsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ListDataStreamsResponse";
                        };
    
                        return ListDataStreamsResponse;
                    })();
    
                    v1beta.GetDataStreamRequest = (function() {
    
                        /**
                         * Properties of a GetDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGetDataStreamRequest
                         * @property {string|null} [name] GetDataStreamRequest name
                         */
    
                        /**
                         * Constructs a new GetDataStreamRequest.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GetDataStreamRequest.
                         * @implements IGetDataStreamRequest
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGetDataStreamRequest=} [properties] Properties to set
                         */
                        function GetDataStreamRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDataStreamRequest name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @instance
                         */
                        GetDataStreamRequest.prototype.name = "";
    
                        /**
                         * Creates a new GetDataStreamRequest instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataStreamRequest=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GetDataStreamRequest} GetDataStreamRequest instance
                         */
                        GetDataStreamRequest.create = function create(properties) {
                            return new GetDataStreamRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDataStreamRequest message. Does not implicitly {@link google.analytics.admin.v1beta.GetDataStreamRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataStreamRequest} message GetDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataStreamRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDataStreamRequest message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GetDataStreamRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.IGetDataStreamRequest} message GetDataStreamRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDataStreamRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDataStreamRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GetDataStreamRequest} GetDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataStreamRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GetDataStreamRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDataStreamRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GetDataStreamRequest} GetDataStreamRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDataStreamRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDataStreamRequest message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDataStreamRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDataStreamRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GetDataStreamRequest} GetDataStreamRequest
                         */
                        GetDataStreamRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GetDataStreamRequest)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GetDataStreamRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDataStreamRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {google.analytics.admin.v1beta.GetDataStreamRequest} message GetDataStreamRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDataStreamRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.name = "";
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            return object;
                        };
    
                        /**
                         * Converts this GetDataStreamRequest to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDataStreamRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDataStreamRequest
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GetDataStreamRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDataStreamRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GetDataStreamRequest";
                        };
    
                        return GetDataStreamRequest;
                    })();
    
                    /**
                     * IndustryCategory enum.
                     * @name google.analytics.admin.v1beta.IndustryCategory
                     * @enum {number}
                     * @property {number} INDUSTRY_CATEGORY_UNSPECIFIED=0 INDUSTRY_CATEGORY_UNSPECIFIED value
                     * @property {number} AUTOMOTIVE=1 AUTOMOTIVE value
                     * @property {number} BUSINESS_AND_INDUSTRIAL_MARKETS=2 BUSINESS_AND_INDUSTRIAL_MARKETS value
                     * @property {number} FINANCE=3 FINANCE value
                     * @property {number} HEALTHCARE=4 HEALTHCARE value
                     * @property {number} TECHNOLOGY=5 TECHNOLOGY value
                     * @property {number} TRAVEL=6 TRAVEL value
                     * @property {number} OTHER=7 OTHER value
                     * @property {number} ARTS_AND_ENTERTAINMENT=8 ARTS_AND_ENTERTAINMENT value
                     * @property {number} BEAUTY_AND_FITNESS=9 BEAUTY_AND_FITNESS value
                     * @property {number} BOOKS_AND_LITERATURE=10 BOOKS_AND_LITERATURE value
                     * @property {number} FOOD_AND_DRINK=11 FOOD_AND_DRINK value
                     * @property {number} GAMES=12 GAMES value
                     * @property {number} HOBBIES_AND_LEISURE=13 HOBBIES_AND_LEISURE value
                     * @property {number} HOME_AND_GARDEN=14 HOME_AND_GARDEN value
                     * @property {number} INTERNET_AND_TELECOM=15 INTERNET_AND_TELECOM value
                     * @property {number} LAW_AND_GOVERNMENT=16 LAW_AND_GOVERNMENT value
                     * @property {number} NEWS=17 NEWS value
                     * @property {number} ONLINE_COMMUNITIES=18 ONLINE_COMMUNITIES value
                     * @property {number} PEOPLE_AND_SOCIETY=19 PEOPLE_AND_SOCIETY value
                     * @property {number} PETS_AND_ANIMALS=20 PETS_AND_ANIMALS value
                     * @property {number} REAL_ESTATE=21 REAL_ESTATE value
                     * @property {number} REFERENCE=22 REFERENCE value
                     * @property {number} SCIENCE=23 SCIENCE value
                     * @property {number} SPORTS=24 SPORTS value
                     * @property {number} JOBS_AND_EDUCATION=25 JOBS_AND_EDUCATION value
                     * @property {number} SHOPPING=26 SHOPPING value
                     */
                    v1beta.IndustryCategory = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "INDUSTRY_CATEGORY_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "AUTOMOTIVE"] = 1;
                        values[valuesById[2] = "BUSINESS_AND_INDUSTRIAL_MARKETS"] = 2;
                        values[valuesById[3] = "FINANCE"] = 3;
                        values[valuesById[4] = "HEALTHCARE"] = 4;
                        values[valuesById[5] = "TECHNOLOGY"] = 5;
                        values[valuesById[6] = "TRAVEL"] = 6;
                        values[valuesById[7] = "OTHER"] = 7;
                        values[valuesById[8] = "ARTS_AND_ENTERTAINMENT"] = 8;
                        values[valuesById[9] = "BEAUTY_AND_FITNESS"] = 9;
                        values[valuesById[10] = "BOOKS_AND_LITERATURE"] = 10;
                        values[valuesById[11] = "FOOD_AND_DRINK"] = 11;
                        values[valuesById[12] = "GAMES"] = 12;
                        values[valuesById[13] = "HOBBIES_AND_LEISURE"] = 13;
                        values[valuesById[14] = "HOME_AND_GARDEN"] = 14;
                        values[valuesById[15] = "INTERNET_AND_TELECOM"] = 15;
                        values[valuesById[16] = "LAW_AND_GOVERNMENT"] = 16;
                        values[valuesById[17] = "NEWS"] = 17;
                        values[valuesById[18] = "ONLINE_COMMUNITIES"] = 18;
                        values[valuesById[19] = "PEOPLE_AND_SOCIETY"] = 19;
                        values[valuesById[20] = "PETS_AND_ANIMALS"] = 20;
                        values[valuesById[21] = "REAL_ESTATE"] = 21;
                        values[valuesById[22] = "REFERENCE"] = 22;
                        values[valuesById[23] = "SCIENCE"] = 23;
                        values[valuesById[24] = "SPORTS"] = 24;
                        values[valuesById[25] = "JOBS_AND_EDUCATION"] = 25;
                        values[valuesById[26] = "SHOPPING"] = 26;
                        return values;
                    })();
    
                    /**
                     * ServiceLevel enum.
                     * @name google.analytics.admin.v1beta.ServiceLevel
                     * @enum {number}
                     * @property {number} SERVICE_LEVEL_UNSPECIFIED=0 SERVICE_LEVEL_UNSPECIFIED value
                     * @property {number} GOOGLE_ANALYTICS_STANDARD=1 GOOGLE_ANALYTICS_STANDARD value
                     * @property {number} GOOGLE_ANALYTICS_360=2 GOOGLE_ANALYTICS_360 value
                     */
                    v1beta.ServiceLevel = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "SERVICE_LEVEL_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "GOOGLE_ANALYTICS_STANDARD"] = 1;
                        values[valuesById[2] = "GOOGLE_ANALYTICS_360"] = 2;
                        return values;
                    })();
    
                    /**
                     * ActorType enum.
                     * @name google.analytics.admin.v1beta.ActorType
                     * @enum {number}
                     * @property {number} ACTOR_TYPE_UNSPECIFIED=0 ACTOR_TYPE_UNSPECIFIED value
                     * @property {number} USER=1 USER value
                     * @property {number} SYSTEM=2 SYSTEM value
                     * @property {number} SUPPORT=3 SUPPORT value
                     */
                    v1beta.ActorType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "ACTOR_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "USER"] = 1;
                        values[valuesById[2] = "SYSTEM"] = 2;
                        values[valuesById[3] = "SUPPORT"] = 3;
                        return values;
                    })();
    
                    /**
                     * ActionType enum.
                     * @name google.analytics.admin.v1beta.ActionType
                     * @enum {number}
                     * @property {number} ACTION_TYPE_UNSPECIFIED=0 ACTION_TYPE_UNSPECIFIED value
                     * @property {number} CREATED=1 CREATED value
                     * @property {number} UPDATED=2 UPDATED value
                     * @property {number} DELETED=3 DELETED value
                     */
                    v1beta.ActionType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "ACTION_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "CREATED"] = 1;
                        values[valuesById[2] = "UPDATED"] = 2;
                        values[valuesById[3] = "DELETED"] = 3;
                        return values;
                    })();
    
                    /**
                     * ChangeHistoryResourceType enum.
                     * @name google.analytics.admin.v1beta.ChangeHistoryResourceType
                     * @enum {number}
                     * @property {number} CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED=0 CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED value
                     * @property {number} ACCOUNT=1 ACCOUNT value
                     * @property {number} PROPERTY=2 PROPERTY value
                     * @property {number} FIREBASE_LINK=6 FIREBASE_LINK value
                     * @property {number} GOOGLE_ADS_LINK=7 GOOGLE_ADS_LINK value
                     * @property {number} GOOGLE_SIGNALS_SETTINGS=8 GOOGLE_SIGNALS_SETTINGS value
                     * @property {number} CONVERSION_EVENT=9 CONVERSION_EVENT value
                     * @property {number} MEASUREMENT_PROTOCOL_SECRET=10 MEASUREMENT_PROTOCOL_SECRET value
                     * @property {number} DATA_RETENTION_SETTINGS=13 DATA_RETENTION_SETTINGS value
                     * @property {number} DISPLAY_VIDEO_360_ADVERTISER_LINK=14 DISPLAY_VIDEO_360_ADVERTISER_LINK value
                     * @property {number} DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL=15 DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL value
                     * @property {number} DATA_STREAM=18 DATA_STREAM value
                     * @property {number} ATTRIBUTION_SETTINGS=20 ATTRIBUTION_SETTINGS value
                     */
                    v1beta.ChangeHistoryResourceType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "CHANGE_HISTORY_RESOURCE_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "ACCOUNT"] = 1;
                        values[valuesById[2] = "PROPERTY"] = 2;
                        values[valuesById[6] = "FIREBASE_LINK"] = 6;
                        values[valuesById[7] = "GOOGLE_ADS_LINK"] = 7;
                        values[valuesById[8] = "GOOGLE_SIGNALS_SETTINGS"] = 8;
                        values[valuesById[9] = "CONVERSION_EVENT"] = 9;
                        values[valuesById[10] = "MEASUREMENT_PROTOCOL_SECRET"] = 10;
                        values[valuesById[13] = "DATA_RETENTION_SETTINGS"] = 13;
                        values[valuesById[14] = "DISPLAY_VIDEO_360_ADVERTISER_LINK"] = 14;
                        values[valuesById[15] = "DISPLAY_VIDEO_360_ADVERTISER_LINK_PROPOSAL"] = 15;
                        values[valuesById[18] = "DATA_STREAM"] = 18;
                        values[valuesById[20] = "ATTRIBUTION_SETTINGS"] = 20;
                        return values;
                    })();
    
                    /**
                     * PropertyType enum.
                     * @name google.analytics.admin.v1beta.PropertyType
                     * @enum {number}
                     * @property {number} PROPERTY_TYPE_UNSPECIFIED=0 PROPERTY_TYPE_UNSPECIFIED value
                     * @property {number} PROPERTY_TYPE_ORDINARY=1 PROPERTY_TYPE_ORDINARY value
                     * @property {number} PROPERTY_TYPE_SUBPROPERTY=2 PROPERTY_TYPE_SUBPROPERTY value
                     * @property {number} PROPERTY_TYPE_ROLLUP=3 PROPERTY_TYPE_ROLLUP value
                     */
                    v1beta.PropertyType = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "PROPERTY_TYPE_UNSPECIFIED"] = 0;
                        values[valuesById[1] = "PROPERTY_TYPE_ORDINARY"] = 1;
                        values[valuesById[2] = "PROPERTY_TYPE_SUBPROPERTY"] = 2;
                        values[valuesById[3] = "PROPERTY_TYPE_ROLLUP"] = 3;
                        return values;
                    })();
    
                    v1beta.Account = (function() {
    
                        /**
                         * Properties of an Account.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccount
                         * @property {string|null} [name] Account name
                         * @property {google.protobuf.ITimestamp|null} [createTime] Account createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] Account updateTime
                         * @property {string|null} [displayName] Account displayName
                         * @property {string|null} [regionCode] Account regionCode
                         * @property {boolean|null} [deleted] Account deleted
                         */
    
                        /**
                         * Constructs a new Account.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an Account.
                         * @implements IAccount
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccount=} [properties] Properties to set
                         */
                        function Account(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Account name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.Account
                         * @instance
                         */
                        Account.prototype.name = "";
    
                        /**
                         * Account createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1beta.Account
                         * @instance
                         */
                        Account.prototype.createTime = null;
    
                        /**
                         * Account updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1beta.Account
                         * @instance
                         */
                        Account.prototype.updateTime = null;
    
                        /**
                         * Account displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.Account
                         * @instance
                         */
                        Account.prototype.displayName = "";
    
                        /**
                         * Account regionCode.
                         * @member {string} regionCode
                         * @memberof google.analytics.admin.v1beta.Account
                         * @instance
                         */
                        Account.prototype.regionCode = "";
    
                        /**
                         * Account deleted.
                         * @member {boolean} deleted
                         * @memberof google.analytics.admin.v1beta.Account
                         * @instance
                         */
                        Account.prototype.deleted = false;
    
                        /**
                         * Creates a new Account instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccount=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.Account} Account instance
                         */
                        Account.create = function create(properties) {
                            return new Account(properties);
                        };
    
                        /**
                         * Encodes the specified Account message. Does not implicitly {@link google.analytics.admin.v1beta.Account.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccount} message Account message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Account.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.displayName);
                            if (message.regionCode != null && Object.hasOwnProperty.call(message, "regionCode"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.regionCode);
                            if (message.deleted != null && Object.hasOwnProperty.call(message, "deleted"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.deleted);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Account message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.Account.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccount} message Account message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Account.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Account message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.Account} Account
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Account.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.Account();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.regionCode = reader.string();
                                        break;
                                    }
                                case 6: {
                                        message.deleted = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Account message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.Account} Account
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Account.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Account message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Account.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.regionCode != null && message.hasOwnProperty("regionCode"))
                                if (!$util.isString(message.regionCode))
                                    return "regionCode: string expected";
                            if (message.deleted != null && message.hasOwnProperty("deleted"))
                                if (typeof message.deleted !== "boolean")
                                    return "deleted: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates an Account message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.Account} Account
                         */
                        Account.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.Account)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.Account();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.Account.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.Account.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.regionCode != null)
                                message.regionCode = String(object.regionCode);
                            if (object.deleted != null)
                                message.deleted = Boolean(object.deleted);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Account message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {google.analytics.admin.v1beta.Account} message Account
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Account.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.createTime = null;
                                object.updateTime = null;
                                object.displayName = "";
                                object.regionCode = "";
                                object.deleted = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.regionCode != null && message.hasOwnProperty("regionCode"))
                                object.regionCode = message.regionCode;
                            if (message.deleted != null && message.hasOwnProperty("deleted"))
                                object.deleted = message.deleted;
                            return object;
                        };
    
                        /**
                         * Converts this Account to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.Account
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Account.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Account
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.Account
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Account.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.Account";
                        };
    
                        return Account;
                    })();
    
                    v1beta.Property = (function() {
    
                        /**
                         * Properties of a Property.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IProperty
                         * @property {string|null} [name] Property name
                         * @property {google.analytics.admin.v1beta.PropertyType|null} [propertyType] Property propertyType
                         * @property {google.protobuf.ITimestamp|null} [createTime] Property createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] Property updateTime
                         * @property {string|null} [parent] Property parent
                         * @property {string|null} [displayName] Property displayName
                         * @property {google.analytics.admin.v1beta.IndustryCategory|null} [industryCategory] Property industryCategory
                         * @property {string|null} [timeZone] Property timeZone
                         * @property {string|null} [currencyCode] Property currencyCode
                         * @property {google.analytics.admin.v1beta.ServiceLevel|null} [serviceLevel] Property serviceLevel
                         * @property {google.protobuf.ITimestamp|null} [deleteTime] Property deleteTime
                         * @property {google.protobuf.ITimestamp|null} [expireTime] Property expireTime
                         * @property {string|null} [account] Property account
                         */
    
                        /**
                         * Constructs a new Property.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a Property.
                         * @implements IProperty
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IProperty=} [properties] Properties to set
                         */
                        function Property(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Property name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.name = "";
    
                        /**
                         * Property propertyType.
                         * @member {google.analytics.admin.v1beta.PropertyType} propertyType
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.propertyType = 0;
    
                        /**
                         * Property createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.createTime = null;
    
                        /**
                         * Property updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.updateTime = null;
    
                        /**
                         * Property parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.parent = "";
    
                        /**
                         * Property displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.displayName = "";
    
                        /**
                         * Property industryCategory.
                         * @member {google.analytics.admin.v1beta.IndustryCategory} industryCategory
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.industryCategory = 0;
    
                        /**
                         * Property timeZone.
                         * @member {string} timeZone
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.timeZone = "";
    
                        /**
                         * Property currencyCode.
                         * @member {string} currencyCode
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.currencyCode = "";
    
                        /**
                         * Property serviceLevel.
                         * @member {google.analytics.admin.v1beta.ServiceLevel} serviceLevel
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.serviceLevel = 0;
    
                        /**
                         * Property deleteTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} deleteTime
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.deleteTime = null;
    
                        /**
                         * Property expireTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} expireTime
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.expireTime = null;
    
                        /**
                         * Property account.
                         * @member {string} account
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         */
                        Property.prototype.account = "";
    
                        /**
                         * Creates a new Property instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {google.analytics.admin.v1beta.IProperty=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.Property} Property instance
                         */
                        Property.create = function create(properties) {
                            return new Property(properties);
                        };
    
                        /**
                         * Encodes the specified Property message. Does not implicitly {@link google.analytics.admin.v1beta.Property.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {google.analytics.admin.v1beta.IProperty} message Property message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Property.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parent);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 5, wireType 2 =*/42).string(message.displayName);
                            if (message.industryCategory != null && Object.hasOwnProperty.call(message, "industryCategory"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.industryCategory);
                            if (message.timeZone != null && Object.hasOwnProperty.call(message, "timeZone"))
                                writer.uint32(/* id 7, wireType 2 =*/58).string(message.timeZone);
                            if (message.currencyCode != null && Object.hasOwnProperty.call(message, "currencyCode"))
                                writer.uint32(/* id 8, wireType 2 =*/66).string(message.currencyCode);
                            if (message.serviceLevel != null && Object.hasOwnProperty.call(message, "serviceLevel"))
                                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.serviceLevel);
                            if (message.deleteTime != null && Object.hasOwnProperty.call(message, "deleteTime"))
                                $root.google.protobuf.Timestamp.encode(message.deleteTime, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                            if (message.expireTime != null && Object.hasOwnProperty.call(message, "expireTime"))
                                $root.google.protobuf.Timestamp.encode(message.expireTime, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                writer.uint32(/* id 13, wireType 2 =*/106).string(message.account);
                            if (message.propertyType != null && Object.hasOwnProperty.call(message, "propertyType"))
                                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.propertyType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Property message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.Property.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {google.analytics.admin.v1beta.IProperty} message Property message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Property.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Property message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.Property} Property
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Property.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.Property();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 14: {
                                        message.propertyType = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 2: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 6: {
                                        message.industryCategory = reader.int32();
                                        break;
                                    }
                                case 7: {
                                        message.timeZone = reader.string();
                                        break;
                                    }
                                case 8: {
                                        message.currencyCode = reader.string();
                                        break;
                                    }
                                case 10: {
                                        message.serviceLevel = reader.int32();
                                        break;
                                    }
                                case 11: {
                                        message.deleteTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 12: {
                                        message.expireTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 13: {
                                        message.account = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Property message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.Property} Property
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Property.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Property message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Property.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                switch (message.propertyType) {
                                default:
                                    return "propertyType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.industryCategory != null && message.hasOwnProperty("industryCategory"))
                                switch (message.industryCategory) {
                                default:
                                    return "industryCategory: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                    break;
                                }
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                if (!$util.isString(message.timeZone))
                                    return "timeZone: string expected";
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                if (!$util.isString(message.currencyCode))
                                    return "currencyCode: string expected";
                            if (message.serviceLevel != null && message.hasOwnProperty("serviceLevel"))
                                switch (message.serviceLevel) {
                                default:
                                    return "serviceLevel: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.deleteTime != null && message.hasOwnProperty("deleteTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.deleteTime);
                                if (error)
                                    return "deleteTime." + error;
                            }
                            if (message.expireTime != null && message.hasOwnProperty("expireTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.expireTime);
                                if (error)
                                    return "expireTime." + error;
                            }
                            if (message.account != null && message.hasOwnProperty("account"))
                                if (!$util.isString(message.account))
                                    return "account: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a Property message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.Property} Property
                         */
                        Property.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.Property)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.Property();
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.propertyType) {
                            default:
                                if (typeof object.propertyType === "number") {
                                    message.propertyType = object.propertyType;
                                    break;
                                }
                                break;
                            case "PROPERTY_TYPE_UNSPECIFIED":
                            case 0:
                                message.propertyType = 0;
                                break;
                            case "PROPERTY_TYPE_ORDINARY":
                            case 1:
                                message.propertyType = 1;
                                break;
                            case "PROPERTY_TYPE_SUBPROPERTY":
                            case 2:
                                message.propertyType = 2;
                                break;
                            case "PROPERTY_TYPE_ROLLUP":
                            case 3:
                                message.propertyType = 3;
                                break;
                            }
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.Property.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.Property.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            switch (object.industryCategory) {
                            default:
                                if (typeof object.industryCategory === "number") {
                                    message.industryCategory = object.industryCategory;
                                    break;
                                }
                                break;
                            case "INDUSTRY_CATEGORY_UNSPECIFIED":
                            case 0:
                                message.industryCategory = 0;
                                break;
                            case "AUTOMOTIVE":
                            case 1:
                                message.industryCategory = 1;
                                break;
                            case "BUSINESS_AND_INDUSTRIAL_MARKETS":
                            case 2:
                                message.industryCategory = 2;
                                break;
                            case "FINANCE":
                            case 3:
                                message.industryCategory = 3;
                                break;
                            case "HEALTHCARE":
                            case 4:
                                message.industryCategory = 4;
                                break;
                            case "TECHNOLOGY":
                            case 5:
                                message.industryCategory = 5;
                                break;
                            case "TRAVEL":
                            case 6:
                                message.industryCategory = 6;
                                break;
                            case "OTHER":
                            case 7:
                                message.industryCategory = 7;
                                break;
                            case "ARTS_AND_ENTERTAINMENT":
                            case 8:
                                message.industryCategory = 8;
                                break;
                            case "BEAUTY_AND_FITNESS":
                            case 9:
                                message.industryCategory = 9;
                                break;
                            case "BOOKS_AND_LITERATURE":
                            case 10:
                                message.industryCategory = 10;
                                break;
                            case "FOOD_AND_DRINK":
                            case 11:
                                message.industryCategory = 11;
                                break;
                            case "GAMES":
                            case 12:
                                message.industryCategory = 12;
                                break;
                            case "HOBBIES_AND_LEISURE":
                            case 13:
                                message.industryCategory = 13;
                                break;
                            case "HOME_AND_GARDEN":
                            case 14:
                                message.industryCategory = 14;
                                break;
                            case "INTERNET_AND_TELECOM":
                            case 15:
                                message.industryCategory = 15;
                                break;
                            case "LAW_AND_GOVERNMENT":
                            case 16:
                                message.industryCategory = 16;
                                break;
                            case "NEWS":
                            case 17:
                                message.industryCategory = 17;
                                break;
                            case "ONLINE_COMMUNITIES":
                            case 18:
                                message.industryCategory = 18;
                                break;
                            case "PEOPLE_AND_SOCIETY":
                            case 19:
                                message.industryCategory = 19;
                                break;
                            case "PETS_AND_ANIMALS":
                            case 20:
                                message.industryCategory = 20;
                                break;
                            case "REAL_ESTATE":
                            case 21:
                                message.industryCategory = 21;
                                break;
                            case "REFERENCE":
                            case 22:
                                message.industryCategory = 22;
                                break;
                            case "SCIENCE":
                            case 23:
                                message.industryCategory = 23;
                                break;
                            case "SPORTS":
                            case 24:
                                message.industryCategory = 24;
                                break;
                            case "JOBS_AND_EDUCATION":
                            case 25:
                                message.industryCategory = 25;
                                break;
                            case "SHOPPING":
                            case 26:
                                message.industryCategory = 26;
                                break;
                            }
                            if (object.timeZone != null)
                                message.timeZone = String(object.timeZone);
                            if (object.currencyCode != null)
                                message.currencyCode = String(object.currencyCode);
                            switch (object.serviceLevel) {
                            default:
                                if (typeof object.serviceLevel === "number") {
                                    message.serviceLevel = object.serviceLevel;
                                    break;
                                }
                                break;
                            case "SERVICE_LEVEL_UNSPECIFIED":
                            case 0:
                                message.serviceLevel = 0;
                                break;
                            case "GOOGLE_ANALYTICS_STANDARD":
                            case 1:
                                message.serviceLevel = 1;
                                break;
                            case "GOOGLE_ANALYTICS_360":
                            case 2:
                                message.serviceLevel = 2;
                                break;
                            }
                            if (object.deleteTime != null) {
                                if (typeof object.deleteTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.Property.deleteTime: object expected");
                                message.deleteTime = $root.google.protobuf.Timestamp.fromObject(object.deleteTime);
                            }
                            if (object.expireTime != null) {
                                if (typeof object.expireTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.Property.expireTime: object expected");
                                message.expireTime = $root.google.protobuf.Timestamp.fromObject(object.expireTime);
                            }
                            if (object.account != null)
                                message.account = String(object.account);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Property message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {google.analytics.admin.v1beta.Property} message Property
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Property.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.parent = "";
                                object.createTime = null;
                                object.updateTime = null;
                                object.displayName = "";
                                object.industryCategory = options.enums === String ? "INDUSTRY_CATEGORY_UNSPECIFIED" : 0;
                                object.timeZone = "";
                                object.currencyCode = "";
                                object.serviceLevel = options.enums === String ? "SERVICE_LEVEL_UNSPECIFIED" : 0;
                                object.deleteTime = null;
                                object.expireTime = null;
                                object.account = "";
                                object.propertyType = options.enums === String ? "PROPERTY_TYPE_UNSPECIFIED" : 0;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.industryCategory != null && message.hasOwnProperty("industryCategory"))
                                object.industryCategory = options.enums === String ? $root.google.analytics.admin.v1beta.IndustryCategory[message.industryCategory] === undefined ? message.industryCategory : $root.google.analytics.admin.v1beta.IndustryCategory[message.industryCategory] : message.industryCategory;
                            if (message.timeZone != null && message.hasOwnProperty("timeZone"))
                                object.timeZone = message.timeZone;
                            if (message.currencyCode != null && message.hasOwnProperty("currencyCode"))
                                object.currencyCode = message.currencyCode;
                            if (message.serviceLevel != null && message.hasOwnProperty("serviceLevel"))
                                object.serviceLevel = options.enums === String ? $root.google.analytics.admin.v1beta.ServiceLevel[message.serviceLevel] === undefined ? message.serviceLevel : $root.google.analytics.admin.v1beta.ServiceLevel[message.serviceLevel] : message.serviceLevel;
                            if (message.deleteTime != null && message.hasOwnProperty("deleteTime"))
                                object.deleteTime = $root.google.protobuf.Timestamp.toObject(message.deleteTime, options);
                            if (message.expireTime != null && message.hasOwnProperty("expireTime"))
                                object.expireTime = $root.google.protobuf.Timestamp.toObject(message.expireTime, options);
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = message.account;
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                object.propertyType = options.enums === String ? $root.google.analytics.admin.v1beta.PropertyType[message.propertyType] === undefined ? message.propertyType : $root.google.analytics.admin.v1beta.PropertyType[message.propertyType] : message.propertyType;
                            return object;
                        };
    
                        /**
                         * Converts this Property to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.Property
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Property.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Property
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.Property
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Property.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.Property";
                        };
    
                        return Property;
                    })();
    
                    v1beta.DataStream = (function() {
    
                        /**
                         * Properties of a DataStream.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDataStream
                         * @property {google.analytics.admin.v1beta.DataStream.IWebStreamData|null} [webStreamData] DataStream webStreamData
                         * @property {google.analytics.admin.v1beta.DataStream.IAndroidAppStreamData|null} [androidAppStreamData] DataStream androidAppStreamData
                         * @property {google.analytics.admin.v1beta.DataStream.IIosAppStreamData|null} [iosAppStreamData] DataStream iosAppStreamData
                         * @property {string|null} [name] DataStream name
                         * @property {google.analytics.admin.v1beta.DataStream.DataStreamType|null} [type] DataStream type
                         * @property {string|null} [displayName] DataStream displayName
                         * @property {google.protobuf.ITimestamp|null} [createTime] DataStream createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] DataStream updateTime
                         */
    
                        /**
                         * Constructs a new DataStream.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DataStream.
                         * @implements IDataStream
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDataStream=} [properties] Properties to set
                         */
                        function DataStream(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DataStream webStreamData.
                         * @member {google.analytics.admin.v1beta.DataStream.IWebStreamData|null|undefined} webStreamData
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.webStreamData = null;
    
                        /**
                         * DataStream androidAppStreamData.
                         * @member {google.analytics.admin.v1beta.DataStream.IAndroidAppStreamData|null|undefined} androidAppStreamData
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.androidAppStreamData = null;
    
                        /**
                         * DataStream iosAppStreamData.
                         * @member {google.analytics.admin.v1beta.DataStream.IIosAppStreamData|null|undefined} iosAppStreamData
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.iosAppStreamData = null;
    
                        /**
                         * DataStream name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.name = "";
    
                        /**
                         * DataStream type.
                         * @member {google.analytics.admin.v1beta.DataStream.DataStreamType} type
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.type = 0;
    
                        /**
                         * DataStream displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.displayName = "";
    
                        /**
                         * DataStream createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.createTime = null;
    
                        /**
                         * DataStream updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        DataStream.prototype.updateTime = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DataStream streamData.
                         * @member {"webStreamData"|"androidAppStreamData"|"iosAppStreamData"|undefined} streamData
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         */
                        Object.defineProperty(DataStream.prototype, "streamData", {
                            get: $util.oneOfGetter($oneOfFields = ["webStreamData", "androidAppStreamData", "iosAppStreamData"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DataStream instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataStream=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DataStream} DataStream instance
                         */
                        DataStream.create = function create(properties) {
                            return new DataStream(properties);
                        };
    
                        /**
                         * Encodes the specified DataStream message. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataStream} message DataStream message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataStream.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.webStreamData != null && Object.hasOwnProperty.call(message, "webStreamData"))
                                $root.google.analytics.admin.v1beta.DataStream.WebStreamData.encode(message.webStreamData, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            if (message.androidAppStreamData != null && Object.hasOwnProperty.call(message, "androidAppStreamData"))
                                $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData.encode(message.androidAppStreamData, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.iosAppStreamData != null && Object.hasOwnProperty.call(message, "iosAppStreamData"))
                                $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData.encode(message.iosAppStreamData, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DataStream message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataStream} message DataStream message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataStream.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DataStream message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DataStream} DataStream
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataStream.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DataStream();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 6: {
                                        message.webStreamData = $root.google.analytics.admin.v1beta.DataStream.WebStreamData.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.androidAppStreamData = $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 8: {
                                        message.iosAppStreamData = $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.type = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 5: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DataStream message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DataStream} DataStream
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataStream.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DataStream message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DataStream.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.webStreamData != null && message.hasOwnProperty("webStreamData")) {
                                properties.streamData = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.DataStream.WebStreamData.verify(message.webStreamData);
                                    if (error)
                                        return "webStreamData." + error;
                                }
                            }
                            if (message.androidAppStreamData != null && message.hasOwnProperty("androidAppStreamData")) {
                                if (properties.streamData === 1)
                                    return "streamData: multiple values";
                                properties.streamData = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData.verify(message.androidAppStreamData);
                                    if (error)
                                        return "androidAppStreamData." + error;
                                }
                            }
                            if (message.iosAppStreamData != null && message.hasOwnProperty("iosAppStreamData")) {
                                if (properties.streamData === 1)
                                    return "streamData: multiple values";
                                properties.streamData = 1;
                                {
                                    var error = $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData.verify(message.iosAppStreamData);
                                    if (error)
                                        return "iosAppStreamData." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.type != null && message.hasOwnProperty("type"))
                                switch (message.type) {
                                default:
                                    return "type: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DataStream message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DataStream} DataStream
                         */
                        DataStream.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DataStream)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DataStream();
                            if (object.webStreamData != null) {
                                if (typeof object.webStreamData !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.DataStream.webStreamData: object expected");
                                message.webStreamData = $root.google.analytics.admin.v1beta.DataStream.WebStreamData.fromObject(object.webStreamData);
                            }
                            if (object.androidAppStreamData != null) {
                                if (typeof object.androidAppStreamData !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.DataStream.androidAppStreamData: object expected");
                                message.androidAppStreamData = $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData.fromObject(object.androidAppStreamData);
                            }
                            if (object.iosAppStreamData != null) {
                                if (typeof object.iosAppStreamData !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.DataStream.iosAppStreamData: object expected");
                                message.iosAppStreamData = $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData.fromObject(object.iosAppStreamData);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.type) {
                            default:
                                if (typeof object.type === "number") {
                                    message.type = object.type;
                                    break;
                                }
                                break;
                            case "DATA_STREAM_TYPE_UNSPECIFIED":
                            case 0:
                                message.type = 0;
                                break;
                            case "WEB_DATA_STREAM":
                            case 1:
                                message.type = 1;
                                break;
                            case "ANDROID_APP_DATA_STREAM":
                            case 2:
                                message.type = 2;
                                break;
                            case "IOS_APP_DATA_STREAM":
                            case 3:
                                message.type = 3;
                                break;
                            }
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.DataStream.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.DataStream.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DataStream message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {google.analytics.admin.v1beta.DataStream} message DataStream
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DataStream.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.type = options.enums === String ? "DATA_STREAM_TYPE_UNSPECIFIED" : 0;
                                object.displayName = "";
                                object.createTime = null;
                                object.updateTime = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.type != null && message.hasOwnProperty("type"))
                                object.type = options.enums === String ? $root.google.analytics.admin.v1beta.DataStream.DataStreamType[message.type] === undefined ? message.type : $root.google.analytics.admin.v1beta.DataStream.DataStreamType[message.type] : message.type;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.webStreamData != null && message.hasOwnProperty("webStreamData")) {
                                object.webStreamData = $root.google.analytics.admin.v1beta.DataStream.WebStreamData.toObject(message.webStreamData, options);
                                if (options.oneofs)
                                    object.streamData = "webStreamData";
                            }
                            if (message.androidAppStreamData != null && message.hasOwnProperty("androidAppStreamData")) {
                                object.androidAppStreamData = $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData.toObject(message.androidAppStreamData, options);
                                if (options.oneofs)
                                    object.streamData = "androidAppStreamData";
                            }
                            if (message.iosAppStreamData != null && message.hasOwnProperty("iosAppStreamData")) {
                                object.iosAppStreamData = $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData.toObject(message.iosAppStreamData, options);
                                if (options.oneofs)
                                    object.streamData = "iosAppStreamData";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DataStream to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DataStream.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DataStream
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DataStream
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DataStream.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DataStream";
                        };
    
                        DataStream.WebStreamData = (function() {
    
                            /**
                             * Properties of a WebStreamData.
                             * @memberof google.analytics.admin.v1beta.DataStream
                             * @interface IWebStreamData
                             * @property {string|null} [measurementId] WebStreamData measurementId
                             * @property {string|null} [firebaseAppId] WebStreamData firebaseAppId
                             * @property {string|null} [defaultUri] WebStreamData defaultUri
                             */
    
                            /**
                             * Constructs a new WebStreamData.
                             * @memberof google.analytics.admin.v1beta.DataStream
                             * @classdesc Represents a WebStreamData.
                             * @implements IWebStreamData
                             * @constructor
                             * @param {google.analytics.admin.v1beta.DataStream.IWebStreamData=} [properties] Properties to set
                             */
                            function WebStreamData(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * WebStreamData measurementId.
                             * @member {string} measurementId
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @instance
                             */
                            WebStreamData.prototype.measurementId = "";
    
                            /**
                             * WebStreamData firebaseAppId.
                             * @member {string} firebaseAppId
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @instance
                             */
                            WebStreamData.prototype.firebaseAppId = "";
    
                            /**
                             * WebStreamData defaultUri.
                             * @member {string} defaultUri
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @instance
                             */
                            WebStreamData.prototype.defaultUri = "";
    
                            /**
                             * Creates a new WebStreamData instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IWebStreamData=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1beta.DataStream.WebStreamData} WebStreamData instance
                             */
                            WebStreamData.create = function create(properties) {
                                return new WebStreamData(properties);
                            };
    
                            /**
                             * Encodes the specified WebStreamData message. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.WebStreamData.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IWebStreamData} message WebStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            WebStreamData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.measurementId != null && Object.hasOwnProperty.call(message, "measurementId"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.measurementId);
                                if (message.firebaseAppId != null && Object.hasOwnProperty.call(message, "firebaseAppId"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.firebaseAppId);
                                if (message.defaultUri != null && Object.hasOwnProperty.call(message, "defaultUri"))
                                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.defaultUri);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified WebStreamData message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.WebStreamData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IWebStreamData} message WebStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            WebStreamData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a WebStreamData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1beta.DataStream.WebStreamData} WebStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            WebStreamData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DataStream.WebStreamData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.measurementId = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.firebaseAppId = reader.string();
                                            break;
                                        }
                                    case 3: {
                                            message.defaultUri = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a WebStreamData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1beta.DataStream.WebStreamData} WebStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            WebStreamData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a WebStreamData message.
                             * @function verify
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            WebStreamData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.measurementId != null && message.hasOwnProperty("measurementId"))
                                    if (!$util.isString(message.measurementId))
                                        return "measurementId: string expected";
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    if (!$util.isString(message.firebaseAppId))
                                        return "firebaseAppId: string expected";
                                if (message.defaultUri != null && message.hasOwnProperty("defaultUri"))
                                    if (!$util.isString(message.defaultUri))
                                        return "defaultUri: string expected";
                                return null;
                            };
    
                            /**
                             * Creates a WebStreamData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1beta.DataStream.WebStreamData} WebStreamData
                             */
                            WebStreamData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1beta.DataStream.WebStreamData)
                                    return object;
                                var message = new $root.google.analytics.admin.v1beta.DataStream.WebStreamData();
                                if (object.measurementId != null)
                                    message.measurementId = String(object.measurementId);
                                if (object.firebaseAppId != null)
                                    message.firebaseAppId = String(object.firebaseAppId);
                                if (object.defaultUri != null)
                                    message.defaultUri = String(object.defaultUri);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a WebStreamData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.WebStreamData} message WebStreamData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            WebStreamData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.measurementId = "";
                                    object.firebaseAppId = "";
                                    object.defaultUri = "";
                                }
                                if (message.measurementId != null && message.hasOwnProperty("measurementId"))
                                    object.measurementId = message.measurementId;
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    object.firebaseAppId = message.firebaseAppId;
                                if (message.defaultUri != null && message.hasOwnProperty("defaultUri"))
                                    object.defaultUri = message.defaultUri;
                                return object;
                            };
    
                            /**
                             * Converts this WebStreamData to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            WebStreamData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for WebStreamData
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1beta.DataStream.WebStreamData
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            WebStreamData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1beta.DataStream.WebStreamData";
                            };
    
                            return WebStreamData;
                        })();
    
                        DataStream.AndroidAppStreamData = (function() {
    
                            /**
                             * Properties of an AndroidAppStreamData.
                             * @memberof google.analytics.admin.v1beta.DataStream
                             * @interface IAndroidAppStreamData
                             * @property {string|null} [firebaseAppId] AndroidAppStreamData firebaseAppId
                             * @property {string|null} [packageName] AndroidAppStreamData packageName
                             */
    
                            /**
                             * Constructs a new AndroidAppStreamData.
                             * @memberof google.analytics.admin.v1beta.DataStream
                             * @classdesc Represents an AndroidAppStreamData.
                             * @implements IAndroidAppStreamData
                             * @constructor
                             * @param {google.analytics.admin.v1beta.DataStream.IAndroidAppStreamData=} [properties] Properties to set
                             */
                            function AndroidAppStreamData(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * AndroidAppStreamData firebaseAppId.
                             * @member {string} firebaseAppId
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @instance
                             */
                            AndroidAppStreamData.prototype.firebaseAppId = "";
    
                            /**
                             * AndroidAppStreamData packageName.
                             * @member {string} packageName
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @instance
                             */
                            AndroidAppStreamData.prototype.packageName = "";
    
                            /**
                             * Creates a new AndroidAppStreamData instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IAndroidAppStreamData=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1beta.DataStream.AndroidAppStreamData} AndroidAppStreamData instance
                             */
                            AndroidAppStreamData.create = function create(properties) {
                                return new AndroidAppStreamData(properties);
                            };
    
                            /**
                             * Encodes the specified AndroidAppStreamData message. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.AndroidAppStreamData.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IAndroidAppStreamData} message AndroidAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AndroidAppStreamData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.firebaseAppId != null && Object.hasOwnProperty.call(message, "firebaseAppId"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.firebaseAppId);
                                if (message.packageName != null && Object.hasOwnProperty.call(message, "packageName"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.packageName);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified AndroidAppStreamData message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.AndroidAppStreamData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IAndroidAppStreamData} message AndroidAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            AndroidAppStreamData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an AndroidAppStreamData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1beta.DataStream.AndroidAppStreamData} AndroidAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AndroidAppStreamData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.firebaseAppId = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.packageName = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an AndroidAppStreamData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1beta.DataStream.AndroidAppStreamData} AndroidAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            AndroidAppStreamData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an AndroidAppStreamData message.
                             * @function verify
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            AndroidAppStreamData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    if (!$util.isString(message.firebaseAppId))
                                        return "firebaseAppId: string expected";
                                if (message.packageName != null && message.hasOwnProperty("packageName"))
                                    if (!$util.isString(message.packageName))
                                        return "packageName: string expected";
                                return null;
                            };
    
                            /**
                             * Creates an AndroidAppStreamData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1beta.DataStream.AndroidAppStreamData} AndroidAppStreamData
                             */
                            AndroidAppStreamData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData)
                                    return object;
                                var message = new $root.google.analytics.admin.v1beta.DataStream.AndroidAppStreamData();
                                if (object.firebaseAppId != null)
                                    message.firebaseAppId = String(object.firebaseAppId);
                                if (object.packageName != null)
                                    message.packageName = String(object.packageName);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an AndroidAppStreamData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.AndroidAppStreamData} message AndroidAppStreamData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            AndroidAppStreamData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.firebaseAppId = "";
                                    object.packageName = "";
                                }
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    object.firebaseAppId = message.firebaseAppId;
                                if (message.packageName != null && message.hasOwnProperty("packageName"))
                                    object.packageName = message.packageName;
                                return object;
                            };
    
                            /**
                             * Converts this AndroidAppStreamData to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            AndroidAppStreamData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for AndroidAppStreamData
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1beta.DataStream.AndroidAppStreamData
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            AndroidAppStreamData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1beta.DataStream.AndroidAppStreamData";
                            };
    
                            return AndroidAppStreamData;
                        })();
    
                        DataStream.IosAppStreamData = (function() {
    
                            /**
                             * Properties of an IosAppStreamData.
                             * @memberof google.analytics.admin.v1beta.DataStream
                             * @interface IIosAppStreamData
                             * @property {string|null} [firebaseAppId] IosAppStreamData firebaseAppId
                             * @property {string|null} [bundleId] IosAppStreamData bundleId
                             */
    
                            /**
                             * Constructs a new IosAppStreamData.
                             * @memberof google.analytics.admin.v1beta.DataStream
                             * @classdesc Represents an IosAppStreamData.
                             * @implements IIosAppStreamData
                             * @constructor
                             * @param {google.analytics.admin.v1beta.DataStream.IIosAppStreamData=} [properties] Properties to set
                             */
                            function IosAppStreamData(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * IosAppStreamData firebaseAppId.
                             * @member {string} firebaseAppId
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @instance
                             */
                            IosAppStreamData.prototype.firebaseAppId = "";
    
                            /**
                             * IosAppStreamData bundleId.
                             * @member {string} bundleId
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @instance
                             */
                            IosAppStreamData.prototype.bundleId = "";
    
                            /**
                             * Creates a new IosAppStreamData instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IIosAppStreamData=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1beta.DataStream.IosAppStreamData} IosAppStreamData instance
                             */
                            IosAppStreamData.create = function create(properties) {
                                return new IosAppStreamData(properties);
                            };
    
                            /**
                             * Encodes the specified IosAppStreamData message. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.IosAppStreamData.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IIosAppStreamData} message IosAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            IosAppStreamData.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.firebaseAppId != null && Object.hasOwnProperty.call(message, "firebaseAppId"))
                                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.firebaseAppId);
                                if (message.bundleId != null && Object.hasOwnProperty.call(message, "bundleId"))
                                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.bundleId);
                                return writer;
                            };
    
                            /**
                             * Encodes the specified IosAppStreamData message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DataStream.IosAppStreamData.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IIosAppStreamData} message IosAppStreamData message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            IosAppStreamData.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes an IosAppStreamData message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1beta.DataStream.IosAppStreamData} IosAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            IosAppStreamData.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.firebaseAppId = reader.string();
                                            break;
                                        }
                                    case 2: {
                                            message.bundleId = reader.string();
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes an IosAppStreamData message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1beta.DataStream.IosAppStreamData} IosAppStreamData
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            IosAppStreamData.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies an IosAppStreamData message.
                             * @function verify
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            IosAppStreamData.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    if (!$util.isString(message.firebaseAppId))
                                        return "firebaseAppId: string expected";
                                if (message.bundleId != null && message.hasOwnProperty("bundleId"))
                                    if (!$util.isString(message.bundleId))
                                        return "bundleId: string expected";
                                return null;
                            };
    
                            /**
                             * Creates an IosAppStreamData message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1beta.DataStream.IosAppStreamData} IosAppStreamData
                             */
                            IosAppStreamData.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData)
                                    return object;
                                var message = new $root.google.analytics.admin.v1beta.DataStream.IosAppStreamData();
                                if (object.firebaseAppId != null)
                                    message.firebaseAppId = String(object.firebaseAppId);
                                if (object.bundleId != null)
                                    message.bundleId = String(object.bundleId);
                                return message;
                            };
    
                            /**
                             * Creates a plain object from an IosAppStreamData message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {google.analytics.admin.v1beta.DataStream.IosAppStreamData} message IosAppStreamData
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            IosAppStreamData.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (options.defaults) {
                                    object.firebaseAppId = "";
                                    object.bundleId = "";
                                }
                                if (message.firebaseAppId != null && message.hasOwnProperty("firebaseAppId"))
                                    object.firebaseAppId = message.firebaseAppId;
                                if (message.bundleId != null && message.hasOwnProperty("bundleId"))
                                    object.bundleId = message.bundleId;
                                return object;
                            };
    
                            /**
                             * Converts this IosAppStreamData to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            IosAppStreamData.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for IosAppStreamData
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1beta.DataStream.IosAppStreamData
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            IosAppStreamData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1beta.DataStream.IosAppStreamData";
                            };
    
                            return IosAppStreamData;
                        })();
    
                        /**
                         * DataStreamType enum.
                         * @name google.analytics.admin.v1beta.DataStream.DataStreamType
                         * @enum {number}
                         * @property {number} DATA_STREAM_TYPE_UNSPECIFIED=0 DATA_STREAM_TYPE_UNSPECIFIED value
                         * @property {number} WEB_DATA_STREAM=1 WEB_DATA_STREAM value
                         * @property {number} ANDROID_APP_DATA_STREAM=2 ANDROID_APP_DATA_STREAM value
                         * @property {number} IOS_APP_DATA_STREAM=3 IOS_APP_DATA_STREAM value
                         */
                        DataStream.DataStreamType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "DATA_STREAM_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "WEB_DATA_STREAM"] = 1;
                            values[valuesById[2] = "ANDROID_APP_DATA_STREAM"] = 2;
                            values[valuesById[3] = "IOS_APP_DATA_STREAM"] = 3;
                            return values;
                        })();
    
                        return DataStream;
                    })();
    
                    v1beta.FirebaseLink = (function() {
    
                        /**
                         * Properties of a FirebaseLink.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IFirebaseLink
                         * @property {string|null} [name] FirebaseLink name
                         * @property {string|null} [project] FirebaseLink project
                         * @property {google.protobuf.ITimestamp|null} [createTime] FirebaseLink createTime
                         */
    
                        /**
                         * Constructs a new FirebaseLink.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a FirebaseLink.
                         * @implements IFirebaseLink
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IFirebaseLink=} [properties] Properties to set
                         */
                        function FirebaseLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirebaseLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @instance
                         */
                        FirebaseLink.prototype.name = "";
    
                        /**
                         * FirebaseLink project.
                         * @member {string} project
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @instance
                         */
                        FirebaseLink.prototype.project = "";
    
                        /**
                         * FirebaseLink createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @instance
                         */
                        FirebaseLink.prototype.createTime = null;
    
                        /**
                         * Creates a new FirebaseLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1beta.IFirebaseLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.FirebaseLink} FirebaseLink instance
                         */
                        FirebaseLink.create = function create(properties) {
                            return new FirebaseLink(properties);
                        };
    
                        /**
                         * Encodes the specified FirebaseLink message. Does not implicitly {@link google.analytics.admin.v1beta.FirebaseLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1beta.IFirebaseLink} message FirebaseLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirebaseLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.project);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirebaseLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.FirebaseLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1beta.IFirebaseLink} message FirebaseLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirebaseLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirebaseLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.FirebaseLink} FirebaseLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirebaseLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.FirebaseLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirebaseLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.FirebaseLink} FirebaseLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirebaseLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirebaseLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirebaseLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirebaseLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.FirebaseLink} FirebaseLink
                         */
                        FirebaseLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.FirebaseLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.FirebaseLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.FirebaseLink.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirebaseLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {google.analytics.admin.v1beta.FirebaseLink} message FirebaseLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirebaseLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.project = "";
                                object.createTime = null;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            return object;
                        };
    
                        /**
                         * Converts this FirebaseLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirebaseLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirebaseLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.FirebaseLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirebaseLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.FirebaseLink";
                        };
    
                        return FirebaseLink;
                    })();
    
                    v1beta.GoogleAdsLink = (function() {
    
                        /**
                         * Properties of a GoogleAdsLink.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IGoogleAdsLink
                         * @property {string|null} [name] GoogleAdsLink name
                         * @property {string|null} [customerId] GoogleAdsLink customerId
                         * @property {boolean|null} [canManageClients] GoogleAdsLink canManageClients
                         * @property {google.protobuf.IBoolValue|null} [adsPersonalizationEnabled] GoogleAdsLink adsPersonalizationEnabled
                         * @property {google.protobuf.ITimestamp|null} [createTime] GoogleAdsLink createTime
                         * @property {google.protobuf.ITimestamp|null} [updateTime] GoogleAdsLink updateTime
                         * @property {string|null} [creatorEmailAddress] GoogleAdsLink creatorEmailAddress
                         */
    
                        /**
                         * Constructs a new GoogleAdsLink.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a GoogleAdsLink.
                         * @implements IGoogleAdsLink
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IGoogleAdsLink=} [properties] Properties to set
                         */
                        function GoogleAdsLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GoogleAdsLink name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.name = "";
    
                        /**
                         * GoogleAdsLink customerId.
                         * @member {string} customerId
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.customerId = "";
    
                        /**
                         * GoogleAdsLink canManageClients.
                         * @member {boolean} canManageClients
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.canManageClients = false;
    
                        /**
                         * GoogleAdsLink adsPersonalizationEnabled.
                         * @member {google.protobuf.IBoolValue|null|undefined} adsPersonalizationEnabled
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.adsPersonalizationEnabled = null;
    
                        /**
                         * GoogleAdsLink createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.createTime = null;
    
                        /**
                         * GoogleAdsLink updateTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} updateTime
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.updateTime = null;
    
                        /**
                         * GoogleAdsLink creatorEmailAddress.
                         * @member {string} creatorEmailAddress
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         */
                        GoogleAdsLink.prototype.creatorEmailAddress = "";
    
                        /**
                         * Creates a new GoogleAdsLink instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1beta.IGoogleAdsLink=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.GoogleAdsLink} GoogleAdsLink instance
                         */
                        GoogleAdsLink.create = function create(properties) {
                            return new GoogleAdsLink(properties);
                        };
    
                        /**
                         * Encodes the specified GoogleAdsLink message. Does not implicitly {@link google.analytics.admin.v1beta.GoogleAdsLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1beta.IGoogleAdsLink} message GoogleAdsLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.customerId != null && Object.hasOwnProperty.call(message, "customerId"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.customerId);
                            if (message.canManageClients != null && Object.hasOwnProperty.call(message, "canManageClients"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.canManageClients);
                            if (message.adsPersonalizationEnabled != null && Object.hasOwnProperty.call(message, "adsPersonalizationEnabled"))
                                $root.google.protobuf.BoolValue.encode(message.adsPersonalizationEnabled, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                            if (message.updateTime != null && Object.hasOwnProperty.call(message, "updateTime"))
                                $root.google.protobuf.Timestamp.encode(message.updateTime, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                            if (message.creatorEmailAddress != null && Object.hasOwnProperty.call(message, "creatorEmailAddress"))
                                writer.uint32(/* id 9, wireType 2 =*/74).string(message.creatorEmailAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GoogleAdsLink message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.GoogleAdsLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1beta.IGoogleAdsLink} message GoogleAdsLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GoogleAdsLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GoogleAdsLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.GoogleAdsLink} GoogleAdsLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.GoogleAdsLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.customerId = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.canManageClients = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 7: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 8: {
                                        message.updateTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 9: {
                                        message.creatorEmailAddress = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GoogleAdsLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.GoogleAdsLink} GoogleAdsLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GoogleAdsLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GoogleAdsLink message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GoogleAdsLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                if (!$util.isString(message.customerId))
                                    return "customerId: string expected";
                            if (message.canManageClients != null && message.hasOwnProperty("canManageClients"))
                                if (typeof message.canManageClients !== "boolean")
                                    return "canManageClients: boolean expected";
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled")) {
                                var error = $root.google.protobuf.BoolValue.verify(message.adsPersonalizationEnabled);
                                if (error)
                                    return "adsPersonalizationEnabled." + error;
                            }
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.updateTime != null && message.hasOwnProperty("updateTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.updateTime);
                                if (error)
                                    return "updateTime." + error;
                            }
                            if (message.creatorEmailAddress != null && message.hasOwnProperty("creatorEmailAddress"))
                                if (!$util.isString(message.creatorEmailAddress))
                                    return "creatorEmailAddress: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GoogleAdsLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.GoogleAdsLink} GoogleAdsLink
                         */
                        GoogleAdsLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.GoogleAdsLink)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.GoogleAdsLink();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.customerId != null)
                                message.customerId = String(object.customerId);
                            if (object.canManageClients != null)
                                message.canManageClients = Boolean(object.canManageClients);
                            if (object.adsPersonalizationEnabled != null) {
                                if (typeof object.adsPersonalizationEnabled !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.GoogleAdsLink.adsPersonalizationEnabled: object expected");
                                message.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.fromObject(object.adsPersonalizationEnabled);
                            }
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.GoogleAdsLink.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.updateTime != null) {
                                if (typeof object.updateTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.GoogleAdsLink.updateTime: object expected");
                                message.updateTime = $root.google.protobuf.Timestamp.fromObject(object.updateTime);
                            }
                            if (object.creatorEmailAddress != null)
                                message.creatorEmailAddress = String(object.creatorEmailAddress);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GoogleAdsLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {google.analytics.admin.v1beta.GoogleAdsLink} message GoogleAdsLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GoogleAdsLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.customerId = "";
                                object.canManageClients = false;
                                object.adsPersonalizationEnabled = null;
                                object.createTime = null;
                                object.updateTime = null;
                                object.creatorEmailAddress = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.customerId != null && message.hasOwnProperty("customerId"))
                                object.customerId = message.customerId;
                            if (message.canManageClients != null && message.hasOwnProperty("canManageClients"))
                                object.canManageClients = message.canManageClients;
                            if (message.adsPersonalizationEnabled != null && message.hasOwnProperty("adsPersonalizationEnabled"))
                                object.adsPersonalizationEnabled = $root.google.protobuf.BoolValue.toObject(message.adsPersonalizationEnabled, options);
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.updateTime != null && message.hasOwnProperty("updateTime"))
                                object.updateTime = $root.google.protobuf.Timestamp.toObject(message.updateTime, options);
                            if (message.creatorEmailAddress != null && message.hasOwnProperty("creatorEmailAddress"))
                                object.creatorEmailAddress = message.creatorEmailAddress;
                            return object;
                        };
    
                        /**
                         * Converts this GoogleAdsLink to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GoogleAdsLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GoogleAdsLink
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.GoogleAdsLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GoogleAdsLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.GoogleAdsLink";
                        };
    
                        return GoogleAdsLink;
                    })();
    
                    v1beta.DataSharingSettings = (function() {
    
                        /**
                         * Properties of a DataSharingSettings.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDataSharingSettings
                         * @property {string|null} [name] DataSharingSettings name
                         * @property {boolean|null} [sharingWithGoogleSupportEnabled] DataSharingSettings sharingWithGoogleSupportEnabled
                         * @property {boolean|null} [sharingWithGoogleAssignedSalesEnabled] DataSharingSettings sharingWithGoogleAssignedSalesEnabled
                         * @property {boolean|null} [sharingWithGoogleAnySalesEnabled] DataSharingSettings sharingWithGoogleAnySalesEnabled
                         * @property {boolean|null} [sharingWithGoogleProductsEnabled] DataSharingSettings sharingWithGoogleProductsEnabled
                         * @property {boolean|null} [sharingWithOthersEnabled] DataSharingSettings sharingWithOthersEnabled
                         */
    
                        /**
                         * Constructs a new DataSharingSettings.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DataSharingSettings.
                         * @implements IDataSharingSettings
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDataSharingSettings=} [properties] Properties to set
                         */
                        function DataSharingSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DataSharingSettings name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.name = "";
    
                        /**
                         * DataSharingSettings sharingWithGoogleSupportEnabled.
                         * @member {boolean} sharingWithGoogleSupportEnabled
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleSupportEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithGoogleAssignedSalesEnabled.
                         * @member {boolean} sharingWithGoogleAssignedSalesEnabled
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleAssignedSalesEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithGoogleAnySalesEnabled.
                         * @member {boolean} sharingWithGoogleAnySalesEnabled
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleAnySalesEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithGoogleProductsEnabled.
                         * @member {boolean} sharingWithGoogleProductsEnabled
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithGoogleProductsEnabled = false;
    
                        /**
                         * DataSharingSettings sharingWithOthersEnabled.
                         * @member {boolean} sharingWithOthersEnabled
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @instance
                         */
                        DataSharingSettings.prototype.sharingWithOthersEnabled = false;
    
                        /**
                         * Creates a new DataSharingSettings instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataSharingSettings=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DataSharingSettings} DataSharingSettings instance
                         */
                        DataSharingSettings.create = function create(properties) {
                            return new DataSharingSettings(properties);
                        };
    
                        /**
                         * Encodes the specified DataSharingSettings message. Does not implicitly {@link google.analytics.admin.v1beta.DataSharingSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataSharingSettings} message DataSharingSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataSharingSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.sharingWithGoogleSupportEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleSupportEnabled"))
                                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.sharingWithGoogleSupportEnabled);
                            if (message.sharingWithGoogleAssignedSalesEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleAssignedSalesEnabled"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.sharingWithGoogleAssignedSalesEnabled);
                            if (message.sharingWithGoogleAnySalesEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleAnySalesEnabled"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.sharingWithGoogleAnySalesEnabled);
                            if (message.sharingWithGoogleProductsEnabled != null && Object.hasOwnProperty.call(message, "sharingWithGoogleProductsEnabled"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.sharingWithGoogleProductsEnabled);
                            if (message.sharingWithOthersEnabled != null && Object.hasOwnProperty.call(message, "sharingWithOthersEnabled"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.sharingWithOthersEnabled);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DataSharingSettings message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DataSharingSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataSharingSettings} message DataSharingSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataSharingSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DataSharingSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DataSharingSettings} DataSharingSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataSharingSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DataSharingSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.sharingWithGoogleSupportEnabled = reader.bool();
                                        break;
                                    }
                                case 3: {
                                        message.sharingWithGoogleAssignedSalesEnabled = reader.bool();
                                        break;
                                    }
                                case 4: {
                                        message.sharingWithGoogleAnySalesEnabled = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.sharingWithGoogleProductsEnabled = reader.bool();
                                        break;
                                    }
                                case 6: {
                                        message.sharingWithOthersEnabled = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DataSharingSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DataSharingSettings} DataSharingSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataSharingSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DataSharingSettings message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DataSharingSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.sharingWithGoogleSupportEnabled != null && message.hasOwnProperty("sharingWithGoogleSupportEnabled"))
                                if (typeof message.sharingWithGoogleSupportEnabled !== "boolean")
                                    return "sharingWithGoogleSupportEnabled: boolean expected";
                            if (message.sharingWithGoogleAssignedSalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAssignedSalesEnabled"))
                                if (typeof message.sharingWithGoogleAssignedSalesEnabled !== "boolean")
                                    return "sharingWithGoogleAssignedSalesEnabled: boolean expected";
                            if (message.sharingWithGoogleAnySalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAnySalesEnabled"))
                                if (typeof message.sharingWithGoogleAnySalesEnabled !== "boolean")
                                    return "sharingWithGoogleAnySalesEnabled: boolean expected";
                            if (message.sharingWithGoogleProductsEnabled != null && message.hasOwnProperty("sharingWithGoogleProductsEnabled"))
                                if (typeof message.sharingWithGoogleProductsEnabled !== "boolean")
                                    return "sharingWithGoogleProductsEnabled: boolean expected";
                            if (message.sharingWithOthersEnabled != null && message.hasOwnProperty("sharingWithOthersEnabled"))
                                if (typeof message.sharingWithOthersEnabled !== "boolean")
                                    return "sharingWithOthersEnabled: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a DataSharingSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DataSharingSettings} DataSharingSettings
                         */
                        DataSharingSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DataSharingSettings)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DataSharingSettings();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.sharingWithGoogleSupportEnabled != null)
                                message.sharingWithGoogleSupportEnabled = Boolean(object.sharingWithGoogleSupportEnabled);
                            if (object.sharingWithGoogleAssignedSalesEnabled != null)
                                message.sharingWithGoogleAssignedSalesEnabled = Boolean(object.sharingWithGoogleAssignedSalesEnabled);
                            if (object.sharingWithGoogleAnySalesEnabled != null)
                                message.sharingWithGoogleAnySalesEnabled = Boolean(object.sharingWithGoogleAnySalesEnabled);
                            if (object.sharingWithGoogleProductsEnabled != null)
                                message.sharingWithGoogleProductsEnabled = Boolean(object.sharingWithGoogleProductsEnabled);
                            if (object.sharingWithOthersEnabled != null)
                                message.sharingWithOthersEnabled = Boolean(object.sharingWithOthersEnabled);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DataSharingSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.DataSharingSettings} message DataSharingSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DataSharingSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.sharingWithGoogleSupportEnabled = false;
                                object.sharingWithGoogleAssignedSalesEnabled = false;
                                object.sharingWithGoogleAnySalesEnabled = false;
                                object.sharingWithGoogleProductsEnabled = false;
                                object.sharingWithOthersEnabled = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.sharingWithGoogleSupportEnabled != null && message.hasOwnProperty("sharingWithGoogleSupportEnabled"))
                                object.sharingWithGoogleSupportEnabled = message.sharingWithGoogleSupportEnabled;
                            if (message.sharingWithGoogleAssignedSalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAssignedSalesEnabled"))
                                object.sharingWithGoogleAssignedSalesEnabled = message.sharingWithGoogleAssignedSalesEnabled;
                            if (message.sharingWithGoogleAnySalesEnabled != null && message.hasOwnProperty("sharingWithGoogleAnySalesEnabled"))
                                object.sharingWithGoogleAnySalesEnabled = message.sharingWithGoogleAnySalesEnabled;
                            if (message.sharingWithGoogleProductsEnabled != null && message.hasOwnProperty("sharingWithGoogleProductsEnabled"))
                                object.sharingWithGoogleProductsEnabled = message.sharingWithGoogleProductsEnabled;
                            if (message.sharingWithOthersEnabled != null && message.hasOwnProperty("sharingWithOthersEnabled"))
                                object.sharingWithOthersEnabled = message.sharingWithOthersEnabled;
                            return object;
                        };
    
                        /**
                         * Converts this DataSharingSettings to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DataSharingSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DataSharingSettings
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DataSharingSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DataSharingSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DataSharingSettings";
                        };
    
                        return DataSharingSettings;
                    })();
    
                    v1beta.AccountSummary = (function() {
    
                        /**
                         * Properties of an AccountSummary.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IAccountSummary
                         * @property {string|null} [name] AccountSummary name
                         * @property {string|null} [account] AccountSummary account
                         * @property {string|null} [displayName] AccountSummary displayName
                         * @property {Array.<google.analytics.admin.v1beta.IPropertySummary>|null} [propertySummaries] AccountSummary propertySummaries
                         */
    
                        /**
                         * Constructs a new AccountSummary.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents an AccountSummary.
                         * @implements IAccountSummary
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IAccountSummary=} [properties] Properties to set
                         */
                        function AccountSummary(properties) {
                            this.propertySummaries = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccountSummary name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.name = "";
    
                        /**
                         * AccountSummary account.
                         * @member {string} account
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.account = "";
    
                        /**
                         * AccountSummary displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.displayName = "";
    
                        /**
                         * AccountSummary propertySummaries.
                         * @member {Array.<google.analytics.admin.v1beta.IPropertySummary>} propertySummaries
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @instance
                         */
                        AccountSummary.prototype.propertySummaries = $util.emptyArray;
    
                        /**
                         * Creates a new AccountSummary instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccountSummary=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.AccountSummary} AccountSummary instance
                         */
                        AccountSummary.create = function create(properties) {
                            return new AccountSummary(properties);
                        };
    
                        /**
                         * Encodes the specified AccountSummary message. Does not implicitly {@link google.analytics.admin.v1beta.AccountSummary.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccountSummary} message AccountSummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountSummary.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.account);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.propertySummaries != null && message.propertySummaries.length)
                                for (var i = 0; i < message.propertySummaries.length; ++i)
                                    $root.google.analytics.admin.v1beta.PropertySummary.encode(message.propertySummaries[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccountSummary message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.AccountSummary.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1beta.IAccountSummary} message AccountSummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccountSummary.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccountSummary message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.AccountSummary} AccountSummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountSummary.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.AccountSummary();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.account = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        if (!(message.propertySummaries && message.propertySummaries.length))
                                            message.propertySummaries = [];
                                        message.propertySummaries.push($root.google.analytics.admin.v1beta.PropertySummary.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccountSummary message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.AccountSummary} AccountSummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccountSummary.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccountSummary message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccountSummary.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.account != null && message.hasOwnProperty("account"))
                                if (!$util.isString(message.account))
                                    return "account: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.propertySummaries != null && message.hasOwnProperty("propertySummaries")) {
                                if (!Array.isArray(message.propertySummaries))
                                    return "propertySummaries: array expected";
                                for (var i = 0; i < message.propertySummaries.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.PropertySummary.verify(message.propertySummaries[i]);
                                    if (error)
                                        return "propertySummaries." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccountSummary message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.AccountSummary} AccountSummary
                         */
                        AccountSummary.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.AccountSummary)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.AccountSummary();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.account != null)
                                message.account = String(object.account);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.propertySummaries) {
                                if (!Array.isArray(object.propertySummaries))
                                    throw TypeError(".google.analytics.admin.v1beta.AccountSummary.propertySummaries: array expected");
                                message.propertySummaries = [];
                                for (var i = 0; i < object.propertySummaries.length; ++i) {
                                    if (typeof object.propertySummaries[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.AccountSummary.propertySummaries: object expected");
                                    message.propertySummaries[i] = $root.google.analytics.admin.v1beta.PropertySummary.fromObject(object.propertySummaries[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccountSummary message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {google.analytics.admin.v1beta.AccountSummary} message AccountSummary
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccountSummary.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.propertySummaries = [];
                            if (options.defaults) {
                                object.name = "";
                                object.account = "";
                                object.displayName = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.account != null && message.hasOwnProperty("account"))
                                object.account = message.account;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.propertySummaries && message.propertySummaries.length) {
                                object.propertySummaries = [];
                                for (var j = 0; j < message.propertySummaries.length; ++j)
                                    object.propertySummaries[j] = $root.google.analytics.admin.v1beta.PropertySummary.toObject(message.propertySummaries[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccountSummary to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccountSummary.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccountSummary
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.AccountSummary
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccountSummary.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.AccountSummary";
                        };
    
                        return AccountSummary;
                    })();
    
                    v1beta.PropertySummary = (function() {
    
                        /**
                         * Properties of a PropertySummary.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IPropertySummary
                         * @property {string|null} [property] PropertySummary property
                         * @property {string|null} [displayName] PropertySummary displayName
                         * @property {google.analytics.admin.v1beta.PropertyType|null} [propertyType] PropertySummary propertyType
                         * @property {string|null} [parent] PropertySummary parent
                         */
    
                        /**
                         * Constructs a new PropertySummary.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a PropertySummary.
                         * @implements IPropertySummary
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IPropertySummary=} [properties] Properties to set
                         */
                        function PropertySummary(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PropertySummary property.
                         * @member {string} property
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.property = "";
    
                        /**
                         * PropertySummary displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.displayName = "";
    
                        /**
                         * PropertySummary propertyType.
                         * @member {google.analytics.admin.v1beta.PropertyType} propertyType
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.propertyType = 0;
    
                        /**
                         * PropertySummary parent.
                         * @member {string} parent
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @instance
                         */
                        PropertySummary.prototype.parent = "";
    
                        /**
                         * Creates a new PropertySummary instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1beta.IPropertySummary=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.PropertySummary} PropertySummary instance
                         */
                        PropertySummary.create = function create(properties) {
                            return new PropertySummary(properties);
                        };
    
                        /**
                         * Encodes the specified PropertySummary message. Does not implicitly {@link google.analytics.admin.v1beta.PropertySummary.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1beta.IPropertySummary} message PropertySummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PropertySummary.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.property);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.displayName);
                            if (message.propertyType != null && Object.hasOwnProperty.call(message, "propertyType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.propertyType);
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.parent);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PropertySummary message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.PropertySummary.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1beta.IPropertySummary} message PropertySummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PropertySummary.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PropertySummary message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.PropertySummary} PropertySummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PropertySummary.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.PropertySummary();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.property = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.propertyType = reader.int32();
                                        break;
                                    }
                                case 4: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PropertySummary message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.PropertySummary} PropertySummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PropertySummary.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PropertySummary message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PropertySummary.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.property != null && message.hasOwnProperty("property"))
                                if (!$util.isString(message.property))
                                    return "property: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                switch (message.propertyType) {
                                default:
                                    return "propertyType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a PropertySummary message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.PropertySummary} PropertySummary
                         */
                        PropertySummary.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.PropertySummary)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.PropertySummary();
                            if (object.property != null)
                                message.property = String(object.property);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            switch (object.propertyType) {
                            default:
                                if (typeof object.propertyType === "number") {
                                    message.propertyType = object.propertyType;
                                    break;
                                }
                                break;
                            case "PROPERTY_TYPE_UNSPECIFIED":
                            case 0:
                                message.propertyType = 0;
                                break;
                            case "PROPERTY_TYPE_ORDINARY":
                            case 1:
                                message.propertyType = 1;
                                break;
                            case "PROPERTY_TYPE_SUBPROPERTY":
                            case 2:
                                message.propertyType = 2;
                                break;
                            case "PROPERTY_TYPE_ROLLUP":
                            case 3:
                                message.propertyType = 3;
                                break;
                            }
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PropertySummary message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {google.analytics.admin.v1beta.PropertySummary} message PropertySummary
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PropertySummary.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.property = "";
                                object.displayName = "";
                                object.propertyType = options.enums === String ? "PROPERTY_TYPE_UNSPECIFIED" : 0;
                                object.parent = "";
                            }
                            if (message.property != null && message.hasOwnProperty("property"))
                                object.property = message.property;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.propertyType != null && message.hasOwnProperty("propertyType"))
                                object.propertyType = options.enums === String ? $root.google.analytics.admin.v1beta.PropertyType[message.propertyType] === undefined ? message.propertyType : $root.google.analytics.admin.v1beta.PropertyType[message.propertyType] : message.propertyType;
                            if (message.parent != null && message.hasOwnProperty("parent"))
                                object.parent = message.parent;
                            return object;
                        };
    
                        /**
                         * Converts this PropertySummary to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PropertySummary.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PropertySummary
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.PropertySummary
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PropertySummary.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.PropertySummary";
                        };
    
                        return PropertySummary;
                    })();
    
                    v1beta.MeasurementProtocolSecret = (function() {
    
                        /**
                         * Properties of a MeasurementProtocolSecret.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IMeasurementProtocolSecret
                         * @property {string|null} [name] MeasurementProtocolSecret name
                         * @property {string|null} [displayName] MeasurementProtocolSecret displayName
                         * @property {string|null} [secretValue] MeasurementProtocolSecret secretValue
                         */
    
                        /**
                         * Constructs a new MeasurementProtocolSecret.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a MeasurementProtocolSecret.
                         * @implements IMeasurementProtocolSecret
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IMeasurementProtocolSecret=} [properties] Properties to set
                         */
                        function MeasurementProtocolSecret(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MeasurementProtocolSecret name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @instance
                         */
                        MeasurementProtocolSecret.prototype.name = "";
    
                        /**
                         * MeasurementProtocolSecret displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @instance
                         */
                        MeasurementProtocolSecret.prototype.displayName = "";
    
                        /**
                         * MeasurementProtocolSecret secretValue.
                         * @member {string} secretValue
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @instance
                         */
                        MeasurementProtocolSecret.prototype.secretValue = "";
    
                        /**
                         * Creates a new MeasurementProtocolSecret instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1beta.IMeasurementProtocolSecret=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.MeasurementProtocolSecret} MeasurementProtocolSecret instance
                         */
                        MeasurementProtocolSecret.create = function create(properties) {
                            return new MeasurementProtocolSecret(properties);
                        };
    
                        /**
                         * Encodes the specified MeasurementProtocolSecret message. Does not implicitly {@link google.analytics.admin.v1beta.MeasurementProtocolSecret.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1beta.IMeasurementProtocolSecret} message MeasurementProtocolSecret message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MeasurementProtocolSecret.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.displayName);
                            if (message.secretValue != null && Object.hasOwnProperty.call(message, "secretValue"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.secretValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MeasurementProtocolSecret message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.MeasurementProtocolSecret.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1beta.IMeasurementProtocolSecret} message MeasurementProtocolSecret message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MeasurementProtocolSecret.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MeasurementProtocolSecret message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.MeasurementProtocolSecret} MeasurementProtocolSecret
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MeasurementProtocolSecret.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.MeasurementProtocolSecret();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.secretValue = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MeasurementProtocolSecret message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.MeasurementProtocolSecret} MeasurementProtocolSecret
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MeasurementProtocolSecret.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MeasurementProtocolSecret message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MeasurementProtocolSecret.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.secretValue != null && message.hasOwnProperty("secretValue"))
                                if (!$util.isString(message.secretValue))
                                    return "secretValue: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a MeasurementProtocolSecret message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.MeasurementProtocolSecret} MeasurementProtocolSecret
                         */
                        MeasurementProtocolSecret.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.MeasurementProtocolSecret)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.MeasurementProtocolSecret();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.secretValue != null)
                                message.secretValue = String(object.secretValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MeasurementProtocolSecret message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {google.analytics.admin.v1beta.MeasurementProtocolSecret} message MeasurementProtocolSecret
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MeasurementProtocolSecret.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.displayName = "";
                                object.secretValue = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.secretValue != null && message.hasOwnProperty("secretValue"))
                                object.secretValue = message.secretValue;
                            return object;
                        };
    
                        /**
                         * Converts this MeasurementProtocolSecret to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MeasurementProtocolSecret.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MeasurementProtocolSecret
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.MeasurementProtocolSecret
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MeasurementProtocolSecret.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.MeasurementProtocolSecret";
                        };
    
                        return MeasurementProtocolSecret;
                    })();
    
                    v1beta.ChangeHistoryEvent = (function() {
    
                        /**
                         * Properties of a ChangeHistoryEvent.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IChangeHistoryEvent
                         * @property {string|null} [id] ChangeHistoryEvent id
                         * @property {google.protobuf.ITimestamp|null} [changeTime] ChangeHistoryEvent changeTime
                         * @property {google.analytics.admin.v1beta.ActorType|null} [actorType] ChangeHistoryEvent actorType
                         * @property {string|null} [userActorEmail] ChangeHistoryEvent userActorEmail
                         * @property {boolean|null} [changesFiltered] ChangeHistoryEvent changesFiltered
                         * @property {Array.<google.analytics.admin.v1beta.IChangeHistoryChange>|null} [changes] ChangeHistoryEvent changes
                         */
    
                        /**
                         * Constructs a new ChangeHistoryEvent.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ChangeHistoryEvent.
                         * @implements IChangeHistoryEvent
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IChangeHistoryEvent=} [properties] Properties to set
                         */
                        function ChangeHistoryEvent(properties) {
                            this.changes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChangeHistoryEvent id.
                         * @member {string} id
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.id = "";
    
                        /**
                         * ChangeHistoryEvent changeTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} changeTime
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.changeTime = null;
    
                        /**
                         * ChangeHistoryEvent actorType.
                         * @member {google.analytics.admin.v1beta.ActorType} actorType
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.actorType = 0;
    
                        /**
                         * ChangeHistoryEvent userActorEmail.
                         * @member {string} userActorEmail
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.userActorEmail = "";
    
                        /**
                         * ChangeHistoryEvent changesFiltered.
                         * @member {boolean} changesFiltered
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.changesFiltered = false;
    
                        /**
                         * ChangeHistoryEvent changes.
                         * @member {Array.<google.analytics.admin.v1beta.IChangeHistoryChange>} changes
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @instance
                         */
                        ChangeHistoryEvent.prototype.changes = $util.emptyArray;
    
                        /**
                         * Creates a new ChangeHistoryEvent instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.IChangeHistoryEvent=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryEvent} ChangeHistoryEvent instance
                         */
                        ChangeHistoryEvent.create = function create(properties) {
                            return new ChangeHistoryEvent(properties);
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryEvent message. Does not implicitly {@link google.analytics.admin.v1beta.ChangeHistoryEvent.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.IChangeHistoryEvent} message ChangeHistoryEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryEvent.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
                            if (message.changeTime != null && Object.hasOwnProperty.call(message, "changeTime"))
                                $root.google.protobuf.Timestamp.encode(message.changeTime, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                            if (message.actorType != null && Object.hasOwnProperty.call(message, "actorType"))
                                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.actorType);
                            if (message.userActorEmail != null && Object.hasOwnProperty.call(message, "userActorEmail"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.userActorEmail);
                            if (message.changesFiltered != null && Object.hasOwnProperty.call(message, "changesFiltered"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.changesFiltered);
                            if (message.changes != null && message.changes.length)
                                for (var i = 0; i < message.changes.length; ++i)
                                    $root.google.analytics.admin.v1beta.ChangeHistoryChange.encode(message.changes[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryEvent message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ChangeHistoryEvent.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.IChangeHistoryEvent} message ChangeHistoryEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryEvent.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChangeHistoryEvent message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryEvent} ChangeHistoryEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryEvent.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ChangeHistoryEvent();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.changeTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3: {
                                        message.actorType = reader.int32();
                                        break;
                                    }
                                case 4: {
                                        message.userActorEmail = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.changesFiltered = reader.bool();
                                        break;
                                    }
                                case 6: {
                                        if (!(message.changes && message.changes.length))
                                            message.changes = [];
                                        message.changes.push($root.google.analytics.admin.v1beta.ChangeHistoryChange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChangeHistoryEvent message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryEvent} ChangeHistoryEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryEvent.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChangeHistoryEvent message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeHistoryEvent.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.id != null && message.hasOwnProperty("id"))
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            if (message.changeTime != null && message.hasOwnProperty("changeTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.changeTime);
                                if (error)
                                    return "changeTime." + error;
                            }
                            if (message.actorType != null && message.hasOwnProperty("actorType"))
                                switch (message.actorType) {
                                default:
                                    return "actorType: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.userActorEmail != null && message.hasOwnProperty("userActorEmail"))
                                if (!$util.isString(message.userActorEmail))
                                    return "userActorEmail: string expected";
                            if (message.changesFiltered != null && message.hasOwnProperty("changesFiltered"))
                                if (typeof message.changesFiltered !== "boolean")
                                    return "changesFiltered: boolean expected";
                            if (message.changes != null && message.hasOwnProperty("changes")) {
                                if (!Array.isArray(message.changes))
                                    return "changes: array expected";
                                for (var i = 0; i < message.changes.length; ++i) {
                                    var error = $root.google.analytics.admin.v1beta.ChangeHistoryChange.verify(message.changes[i]);
                                    if (error)
                                        return "changes." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ChangeHistoryEvent message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryEvent} ChangeHistoryEvent
                         */
                        ChangeHistoryEvent.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ChangeHistoryEvent)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ChangeHistoryEvent();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.changeTime != null) {
                                if (typeof object.changeTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryEvent.changeTime: object expected");
                                message.changeTime = $root.google.protobuf.Timestamp.fromObject(object.changeTime);
                            }
                            switch (object.actorType) {
                            default:
                                if (typeof object.actorType === "number") {
                                    message.actorType = object.actorType;
                                    break;
                                }
                                break;
                            case "ACTOR_TYPE_UNSPECIFIED":
                            case 0:
                                message.actorType = 0;
                                break;
                            case "USER":
                            case 1:
                                message.actorType = 1;
                                break;
                            case "SYSTEM":
                            case 2:
                                message.actorType = 2;
                                break;
                            case "SUPPORT":
                            case 3:
                                message.actorType = 3;
                                break;
                            }
                            if (object.userActorEmail != null)
                                message.userActorEmail = String(object.userActorEmail);
                            if (object.changesFiltered != null)
                                message.changesFiltered = Boolean(object.changesFiltered);
                            if (object.changes) {
                                if (!Array.isArray(object.changes))
                                    throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryEvent.changes: array expected");
                                message.changes = [];
                                for (var i = 0; i < object.changes.length; ++i) {
                                    if (typeof object.changes[i] !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryEvent.changes: object expected");
                                    message.changes[i] = $root.google.analytics.admin.v1beta.ChangeHistoryChange.fromObject(object.changes[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChangeHistoryEvent message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.ChangeHistoryEvent} message ChangeHistoryEvent
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeHistoryEvent.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.changes = [];
                            if (options.defaults) {
                                object.id = "";
                                object.changeTime = null;
                                object.actorType = options.enums === String ? "ACTOR_TYPE_UNSPECIFIED" : 0;
                                object.userActorEmail = "";
                                object.changesFiltered = false;
                            }
                            if (message.id != null && message.hasOwnProperty("id"))
                                object.id = message.id;
                            if (message.changeTime != null && message.hasOwnProperty("changeTime"))
                                object.changeTime = $root.google.protobuf.Timestamp.toObject(message.changeTime, options);
                            if (message.actorType != null && message.hasOwnProperty("actorType"))
                                object.actorType = options.enums === String ? $root.google.analytics.admin.v1beta.ActorType[message.actorType] === undefined ? message.actorType : $root.google.analytics.admin.v1beta.ActorType[message.actorType] : message.actorType;
                            if (message.userActorEmail != null && message.hasOwnProperty("userActorEmail"))
                                object.userActorEmail = message.userActorEmail;
                            if (message.changesFiltered != null && message.hasOwnProperty("changesFiltered"))
                                object.changesFiltered = message.changesFiltered;
                            if (message.changes && message.changes.length) {
                                object.changes = [];
                                for (var j = 0; j < message.changes.length; ++j)
                                    object.changes[j] = $root.google.analytics.admin.v1beta.ChangeHistoryChange.toObject(message.changes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ChangeHistoryEvent to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeHistoryEvent.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChangeHistoryEvent
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryEvent
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChangeHistoryEvent.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ChangeHistoryEvent";
                        };
    
                        return ChangeHistoryEvent;
                    })();
    
                    v1beta.ChangeHistoryChange = (function() {
    
                        /**
                         * Properties of a ChangeHistoryChange.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IChangeHistoryChange
                         * @property {string|null} [resource] ChangeHistoryChange resource
                         * @property {google.analytics.admin.v1beta.ActionType|null} [action] ChangeHistoryChange action
                         * @property {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource|null} [resourceBeforeChange] ChangeHistoryChange resourceBeforeChange
                         * @property {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource|null} [resourceAfterChange] ChangeHistoryChange resourceAfterChange
                         */
    
                        /**
                         * Constructs a new ChangeHistoryChange.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ChangeHistoryChange.
                         * @implements IChangeHistoryChange
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IChangeHistoryChange=} [properties] Properties to set
                         */
                        function ChangeHistoryChange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ChangeHistoryChange resource.
                         * @member {string} resource
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.resource = "";
    
                        /**
                         * ChangeHistoryChange action.
                         * @member {google.analytics.admin.v1beta.ActionType} action
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.action = 0;
    
                        /**
                         * ChangeHistoryChange resourceBeforeChange.
                         * @member {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource|null|undefined} resourceBeforeChange
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.resourceBeforeChange = null;
    
                        /**
                         * ChangeHistoryChange resourceAfterChange.
                         * @member {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource|null|undefined} resourceAfterChange
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @instance
                         */
                        ChangeHistoryChange.prototype.resourceAfterChange = null;
    
                        /**
                         * Creates a new ChangeHistoryChange instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1beta.IChangeHistoryChange=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryChange} ChangeHistoryChange instance
                         */
                        ChangeHistoryChange.create = function create(properties) {
                            return new ChangeHistoryChange(properties);
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryChange message. Does not implicitly {@link google.analytics.admin.v1beta.ChangeHistoryChange.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1beta.IChangeHistoryChange} message ChangeHistoryChange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryChange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.resource);
                            if (message.action != null && Object.hasOwnProperty.call(message, "action"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.action);
                            if (message.resourceBeforeChange != null && Object.hasOwnProperty.call(message, "resourceBeforeChange"))
                                $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.encode(message.resourceBeforeChange, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.resourceAfterChange != null && Object.hasOwnProperty.call(message, "resourceAfterChange"))
                                $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.encode(message.resourceAfterChange, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ChangeHistoryChange message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ChangeHistoryChange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1beta.IChangeHistoryChange} message ChangeHistoryChange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ChangeHistoryChange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ChangeHistoryChange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryChange} ChangeHistoryChange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryChange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ChangeHistoryChange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.action = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.resourceBeforeChange = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.resourceAfterChange = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ChangeHistoryChange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryChange} ChangeHistoryChange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ChangeHistoryChange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ChangeHistoryChange message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ChangeHistoryChange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.action != null && message.hasOwnProperty("action"))
                                switch (message.action) {
                                default:
                                    return "action: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                    break;
                                }
                            if (message.resourceBeforeChange != null && message.hasOwnProperty("resourceBeforeChange")) {
                                var error = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.verify(message.resourceBeforeChange);
                                if (error)
                                    return "resourceBeforeChange." + error;
                            }
                            if (message.resourceAfterChange != null && message.hasOwnProperty("resourceAfterChange")) {
                                var error = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.verify(message.resourceAfterChange);
                                if (error)
                                    return "resourceAfterChange." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ChangeHistoryChange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ChangeHistoryChange} ChangeHistoryChange
                         */
                        ChangeHistoryChange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ChangeHistoryChange)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ChangeHistoryChange();
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            switch (object.action) {
                            default:
                                if (typeof object.action === "number") {
                                    message.action = object.action;
                                    break;
                                }
                                break;
                            case "ACTION_TYPE_UNSPECIFIED":
                            case 0:
                                message.action = 0;
                                break;
                            case "CREATED":
                            case 1:
                                message.action = 1;
                                break;
                            case "UPDATED":
                            case 2:
                                message.action = 2;
                                break;
                            case "DELETED":
                            case 3:
                                message.action = 3;
                                break;
                            }
                            if (object.resourceBeforeChange != null) {
                                if (typeof object.resourceBeforeChange !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.resourceBeforeChange: object expected");
                                message.resourceBeforeChange = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.fromObject(object.resourceBeforeChange);
                            }
                            if (object.resourceAfterChange != null) {
                                if (typeof object.resourceAfterChange !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.resourceAfterChange: object expected");
                                message.resourceAfterChange = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.fromObject(object.resourceAfterChange);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ChangeHistoryChange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {google.analytics.admin.v1beta.ChangeHistoryChange} message ChangeHistoryChange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ChangeHistoryChange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.action = options.enums === String ? "ACTION_TYPE_UNSPECIFIED" : 0;
                                object.resourceBeforeChange = null;
                                object.resourceAfterChange = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.action != null && message.hasOwnProperty("action"))
                                object.action = options.enums === String ? $root.google.analytics.admin.v1beta.ActionType[message.action] === undefined ? message.action : $root.google.analytics.admin.v1beta.ActionType[message.action] : message.action;
                            if (message.resourceBeforeChange != null && message.hasOwnProperty("resourceBeforeChange"))
                                object.resourceBeforeChange = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.toObject(message.resourceBeforeChange, options);
                            if (message.resourceAfterChange != null && message.hasOwnProperty("resourceAfterChange"))
                                object.resourceAfterChange = $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.toObject(message.resourceAfterChange, options);
                            return object;
                        };
    
                        /**
                         * Converts this ChangeHistoryChange to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ChangeHistoryChange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ChangeHistoryChange
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ChangeHistoryChange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ChangeHistoryChange";
                        };
    
                        ChangeHistoryChange.ChangeHistoryResource = (function() {
    
                            /**
                             * Properties of a ChangeHistoryResource.
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                             * @interface IChangeHistoryResource
                             * @property {google.analytics.admin.v1beta.IAccount|null} [account] ChangeHistoryResource account
                             * @property {google.analytics.admin.v1beta.IProperty|null} [property] ChangeHistoryResource property
                             * @property {google.analytics.admin.v1beta.IFirebaseLink|null} [firebaseLink] ChangeHistoryResource firebaseLink
                             * @property {google.analytics.admin.v1beta.IGoogleAdsLink|null} [googleAdsLink] ChangeHistoryResource googleAdsLink
                             * @property {google.analytics.admin.v1beta.IConversionEvent|null} [conversionEvent] ChangeHistoryResource conversionEvent
                             * @property {google.analytics.admin.v1beta.IMeasurementProtocolSecret|null} [measurementProtocolSecret] ChangeHistoryResource measurementProtocolSecret
                             * @property {google.analytics.admin.v1beta.IDataRetentionSettings|null} [dataRetentionSettings] ChangeHistoryResource dataRetentionSettings
                             * @property {google.analytics.admin.v1beta.IDataStream|null} [dataStream] ChangeHistoryResource dataStream
                             */
    
                            /**
                             * Constructs a new ChangeHistoryResource.
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange
                             * @classdesc Represents a ChangeHistoryResource.
                             * @implements IChangeHistoryResource
                             * @constructor
                             * @param {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource=} [properties] Properties to set
                             */
                            function ChangeHistoryResource(properties) {
                                if (properties)
                                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                        if (properties[keys[i]] != null)
                                            this[keys[i]] = properties[keys[i]];
                            }
    
                            /**
                             * ChangeHistoryResource account.
                             * @member {google.analytics.admin.v1beta.IAccount|null|undefined} account
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.account = null;
    
                            /**
                             * ChangeHistoryResource property.
                             * @member {google.analytics.admin.v1beta.IProperty|null|undefined} property
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.property = null;
    
                            /**
                             * ChangeHistoryResource firebaseLink.
                             * @member {google.analytics.admin.v1beta.IFirebaseLink|null|undefined} firebaseLink
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.firebaseLink = null;
    
                            /**
                             * ChangeHistoryResource googleAdsLink.
                             * @member {google.analytics.admin.v1beta.IGoogleAdsLink|null|undefined} googleAdsLink
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.googleAdsLink = null;
    
                            /**
                             * ChangeHistoryResource conversionEvent.
                             * @member {google.analytics.admin.v1beta.IConversionEvent|null|undefined} conversionEvent
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.conversionEvent = null;
    
                            /**
                             * ChangeHistoryResource measurementProtocolSecret.
                             * @member {google.analytics.admin.v1beta.IMeasurementProtocolSecret|null|undefined} measurementProtocolSecret
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.measurementProtocolSecret = null;
    
                            /**
                             * ChangeHistoryResource dataRetentionSettings.
                             * @member {google.analytics.admin.v1beta.IDataRetentionSettings|null|undefined} dataRetentionSettings
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.dataRetentionSettings = null;
    
                            /**
                             * ChangeHistoryResource dataStream.
                             * @member {google.analytics.admin.v1beta.IDataStream|null|undefined} dataStream
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            ChangeHistoryResource.prototype.dataStream = null;
    
                            // OneOf field names bound to virtual getters and setters
                            var $oneOfFields;
    
                            /**
                             * ChangeHistoryResource resource.
                             * @member {"account"|"property"|"firebaseLink"|"googleAdsLink"|"conversionEvent"|"measurementProtocolSecret"|"dataRetentionSettings"|"dataStream"|undefined} resource
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             */
                            Object.defineProperty(ChangeHistoryResource.prototype, "resource", {
                                get: $util.oneOfGetter($oneOfFields = ["account", "property", "firebaseLink", "googleAdsLink", "conversionEvent", "measurementProtocolSecret", "dataRetentionSettings", "dataStream"]),
                                set: $util.oneOfSetter($oneOfFields)
                            });
    
                            /**
                             * Creates a new ChangeHistoryResource instance using the specified properties.
                             * @function create
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource=} [properties] Properties to set
                             * @returns {google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource instance
                             */
                            ChangeHistoryResource.create = function create(properties) {
                                return new ChangeHistoryResource(properties);
                            };
    
                            /**
                             * Encodes the specified ChangeHistoryResource message. Does not implicitly {@link google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.verify|verify} messages.
                             * @function encode
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource} message ChangeHistoryResource message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ChangeHistoryResource.encode = function encode(message, writer) {
                                if (!writer)
                                    writer = $Writer.create();
                                if (message.account != null && Object.hasOwnProperty.call(message, "account"))
                                    $root.google.analytics.admin.v1beta.Account.encode(message.account, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                                if (message.property != null && Object.hasOwnProperty.call(message, "property"))
                                    $root.google.analytics.admin.v1beta.Property.encode(message.property, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                                if (message.firebaseLink != null && Object.hasOwnProperty.call(message, "firebaseLink"))
                                    $root.google.analytics.admin.v1beta.FirebaseLink.encode(message.firebaseLink, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                                if (message.googleAdsLink != null && Object.hasOwnProperty.call(message, "googleAdsLink"))
                                    $root.google.analytics.admin.v1beta.GoogleAdsLink.encode(message.googleAdsLink, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                                if (message.conversionEvent != null && Object.hasOwnProperty.call(message, "conversionEvent"))
                                    $root.google.analytics.admin.v1beta.ConversionEvent.encode(message.conversionEvent, writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                                if (message.measurementProtocolSecret != null && Object.hasOwnProperty.call(message, "measurementProtocolSecret"))
                                    $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.encode(message.measurementProtocolSecret, writer.uint32(/* id 12, wireType 2 =*/98).fork()).ldelim();
                                if (message.dataRetentionSettings != null && Object.hasOwnProperty.call(message, "dataRetentionSettings"))
                                    $root.google.analytics.admin.v1beta.DataRetentionSettings.encode(message.dataRetentionSettings, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
                                if (message.dataStream != null && Object.hasOwnProperty.call(message, "dataStream"))
                                    $root.google.analytics.admin.v1beta.DataStream.encode(message.dataStream, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
                                return writer;
                            };
    
                            /**
                             * Encodes the specified ChangeHistoryResource message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.verify|verify} messages.
                             * @function encodeDelimited
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1beta.ChangeHistoryChange.IChangeHistoryResource} message ChangeHistoryResource message or plain object to encode
                             * @param {$protobuf.Writer} [writer] Writer to encode to
                             * @returns {$protobuf.Writer} Writer
                             */
                            ChangeHistoryResource.encodeDelimited = function encodeDelimited(message, writer) {
                                return this.encode(message, writer).ldelim();
                            };
    
                            /**
                             * Decodes a ChangeHistoryResource message from the specified reader or buffer.
                             * @function decode
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @param {number} [length] Message length if known beforehand
                             * @returns {google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ChangeHistoryResource.decode = function decode(reader, length) {
                                if (!(reader instanceof $Reader))
                                    reader = $Reader.create(reader);
                                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource();
                                while (reader.pos < end) {
                                    var tag = reader.uint32();
                                    switch (tag >>> 3) {
                                    case 1: {
                                            message.account = $root.google.analytics.admin.v1beta.Account.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 2: {
                                            message.property = $root.google.analytics.admin.v1beta.Property.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 6: {
                                            message.firebaseLink = $root.google.analytics.admin.v1beta.FirebaseLink.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 7: {
                                            message.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 11: {
                                            message.conversionEvent = $root.google.analytics.admin.v1beta.ConversionEvent.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 12: {
                                            message.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 15: {
                                            message.dataRetentionSettings = $root.google.analytics.admin.v1beta.DataRetentionSettings.decode(reader, reader.uint32());
                                            break;
                                        }
                                    case 18: {
                                            message.dataStream = $root.google.analytics.admin.v1beta.DataStream.decode(reader, reader.uint32());
                                            break;
                                        }
                                    default:
                                        reader.skipType(tag & 7);
                                        break;
                                    }
                                }
                                return message;
                            };
    
                            /**
                             * Decodes a ChangeHistoryResource message from the specified reader or buffer, length delimited.
                             * @function decodeDelimited
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                             * @returns {google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource
                             * @throws {Error} If the payload is not a reader or valid buffer
                             * @throws {$protobuf.util.ProtocolError} If required fields are missing
                             */
                            ChangeHistoryResource.decodeDelimited = function decodeDelimited(reader) {
                                if (!(reader instanceof $Reader))
                                    reader = new $Reader(reader);
                                return this.decode(reader, reader.uint32());
                            };
    
                            /**
                             * Verifies a ChangeHistoryResource message.
                             * @function verify
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {Object.<string,*>} message Plain object to verify
                             * @returns {string|null} `null` if valid, otherwise the reason why it is not
                             */
                            ChangeHistoryResource.verify = function verify(message) {
                                if (typeof message !== "object" || message === null)
                                    return "object expected";
                                var properties = {};
                                if (message.account != null && message.hasOwnProperty("account")) {
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.Account.verify(message.account);
                                        if (error)
                                            return "account." + error;
                                    }
                                }
                                if (message.property != null && message.hasOwnProperty("property")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.Property.verify(message.property);
                                        if (error)
                                            return "property." + error;
                                    }
                                }
                                if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.FirebaseLink.verify(message.firebaseLink);
                                        if (error)
                                            return "firebaseLink." + error;
                                    }
                                }
                                if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.GoogleAdsLink.verify(message.googleAdsLink);
                                        if (error)
                                            return "googleAdsLink." + error;
                                    }
                                }
                                if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.ConversionEvent.verify(message.conversionEvent);
                                        if (error)
                                            return "conversionEvent." + error;
                                    }
                                }
                                if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.verify(message.measurementProtocolSecret);
                                        if (error)
                                            return "measurementProtocolSecret." + error;
                                    }
                                }
                                if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.DataRetentionSettings.verify(message.dataRetentionSettings);
                                        if (error)
                                            return "dataRetentionSettings." + error;
                                    }
                                }
                                if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                    if (properties.resource === 1)
                                        return "resource: multiple values";
                                    properties.resource = 1;
                                    {
                                        var error = $root.google.analytics.admin.v1beta.DataStream.verify(message.dataStream);
                                        if (error)
                                            return "dataStream." + error;
                                    }
                                }
                                return null;
                            };
    
                            /**
                             * Creates a ChangeHistoryResource message from a plain object. Also converts values to their respective internal types.
                             * @function fromObject
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {Object.<string,*>} object Plain object
                             * @returns {google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource} ChangeHistoryResource
                             */
                            ChangeHistoryResource.fromObject = function fromObject(object) {
                                if (object instanceof $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource)
                                    return object;
                                var message = new $root.google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource();
                                if (object.account != null) {
                                    if (typeof object.account !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.account: object expected");
                                    message.account = $root.google.analytics.admin.v1beta.Account.fromObject(object.account);
                                }
                                if (object.property != null) {
                                    if (typeof object.property !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.property: object expected");
                                    message.property = $root.google.analytics.admin.v1beta.Property.fromObject(object.property);
                                }
                                if (object.firebaseLink != null) {
                                    if (typeof object.firebaseLink !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.firebaseLink: object expected");
                                    message.firebaseLink = $root.google.analytics.admin.v1beta.FirebaseLink.fromObject(object.firebaseLink);
                                }
                                if (object.googleAdsLink != null) {
                                    if (typeof object.googleAdsLink !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.googleAdsLink: object expected");
                                    message.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.fromObject(object.googleAdsLink);
                                }
                                if (object.conversionEvent != null) {
                                    if (typeof object.conversionEvent !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.conversionEvent: object expected");
                                    message.conversionEvent = $root.google.analytics.admin.v1beta.ConversionEvent.fromObject(object.conversionEvent);
                                }
                                if (object.measurementProtocolSecret != null) {
                                    if (typeof object.measurementProtocolSecret !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.measurementProtocolSecret: object expected");
                                    message.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.fromObject(object.measurementProtocolSecret);
                                }
                                if (object.dataRetentionSettings != null) {
                                    if (typeof object.dataRetentionSettings !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.dataRetentionSettings: object expected");
                                    message.dataRetentionSettings = $root.google.analytics.admin.v1beta.DataRetentionSettings.fromObject(object.dataRetentionSettings);
                                }
                                if (object.dataStream != null) {
                                    if (typeof object.dataStream !== "object")
                                        throw TypeError(".google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource.dataStream: object expected");
                                    message.dataStream = $root.google.analytics.admin.v1beta.DataStream.fromObject(object.dataStream);
                                }
                                return message;
                            };
    
                            /**
                             * Creates a plain object from a ChangeHistoryResource message. Also converts values to other types if specified.
                             * @function toObject
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource} message ChangeHistoryResource
                             * @param {$protobuf.IConversionOptions} [options] Conversion options
                             * @returns {Object.<string,*>} Plain object
                             */
                            ChangeHistoryResource.toObject = function toObject(message, options) {
                                if (!options)
                                    options = {};
                                var object = {};
                                if (message.account != null && message.hasOwnProperty("account")) {
                                    object.account = $root.google.analytics.admin.v1beta.Account.toObject(message.account, options);
                                    if (options.oneofs)
                                        object.resource = "account";
                                }
                                if (message.property != null && message.hasOwnProperty("property")) {
                                    object.property = $root.google.analytics.admin.v1beta.Property.toObject(message.property, options);
                                    if (options.oneofs)
                                        object.resource = "property";
                                }
                                if (message.firebaseLink != null && message.hasOwnProperty("firebaseLink")) {
                                    object.firebaseLink = $root.google.analytics.admin.v1beta.FirebaseLink.toObject(message.firebaseLink, options);
                                    if (options.oneofs)
                                        object.resource = "firebaseLink";
                                }
                                if (message.googleAdsLink != null && message.hasOwnProperty("googleAdsLink")) {
                                    object.googleAdsLink = $root.google.analytics.admin.v1beta.GoogleAdsLink.toObject(message.googleAdsLink, options);
                                    if (options.oneofs)
                                        object.resource = "googleAdsLink";
                                }
                                if (message.conversionEvent != null && message.hasOwnProperty("conversionEvent")) {
                                    object.conversionEvent = $root.google.analytics.admin.v1beta.ConversionEvent.toObject(message.conversionEvent, options);
                                    if (options.oneofs)
                                        object.resource = "conversionEvent";
                                }
                                if (message.measurementProtocolSecret != null && message.hasOwnProperty("measurementProtocolSecret")) {
                                    object.measurementProtocolSecret = $root.google.analytics.admin.v1beta.MeasurementProtocolSecret.toObject(message.measurementProtocolSecret, options);
                                    if (options.oneofs)
                                        object.resource = "measurementProtocolSecret";
                                }
                                if (message.dataRetentionSettings != null && message.hasOwnProperty("dataRetentionSettings")) {
                                    object.dataRetentionSettings = $root.google.analytics.admin.v1beta.DataRetentionSettings.toObject(message.dataRetentionSettings, options);
                                    if (options.oneofs)
                                        object.resource = "dataRetentionSettings";
                                }
                                if (message.dataStream != null && message.hasOwnProperty("dataStream")) {
                                    object.dataStream = $root.google.analytics.admin.v1beta.DataStream.toObject(message.dataStream, options);
                                    if (options.oneofs)
                                        object.resource = "dataStream";
                                }
                                return object;
                            };
    
                            /**
                             * Converts this ChangeHistoryResource to JSON.
                             * @function toJSON
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @instance
                             * @returns {Object.<string,*>} JSON object
                             */
                            ChangeHistoryResource.prototype.toJSON = function toJSON() {
                                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                            };
    
                            /**
                             * Gets the default type url for ChangeHistoryResource
                             * @function getTypeUrl
                             * @memberof google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource
                             * @static
                             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                             * @returns {string} The default type url
                             */
                            ChangeHistoryResource.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                                if (typeUrlPrefix === undefined) {
                                    typeUrlPrefix = "type.googleapis.com";
                                }
                                return typeUrlPrefix + "/google.analytics.admin.v1beta.ChangeHistoryChange.ChangeHistoryResource";
                            };
    
                            return ChangeHistoryResource;
                        })();
    
                        return ChangeHistoryChange;
                    })();
    
                    v1beta.ConversionEvent = (function() {
    
                        /**
                         * Properties of a ConversionEvent.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IConversionEvent
                         * @property {string|null} [name] ConversionEvent name
                         * @property {string|null} [eventName] ConversionEvent eventName
                         * @property {google.protobuf.ITimestamp|null} [createTime] ConversionEvent createTime
                         * @property {boolean|null} [deletable] ConversionEvent deletable
                         * @property {boolean|null} [custom] ConversionEvent custom
                         */
    
                        /**
                         * Constructs a new ConversionEvent.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a ConversionEvent.
                         * @implements IConversionEvent
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IConversionEvent=} [properties] Properties to set
                         */
                        function ConversionEvent(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ConversionEvent name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.name = "";
    
                        /**
                         * ConversionEvent eventName.
                         * @member {string} eventName
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.eventName = "";
    
                        /**
                         * ConversionEvent createTime.
                         * @member {google.protobuf.ITimestamp|null|undefined} createTime
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.createTime = null;
    
                        /**
                         * ConversionEvent deletable.
                         * @member {boolean} deletable
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.deletable = false;
    
                        /**
                         * ConversionEvent custom.
                         * @member {boolean} custom
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @instance
                         */
                        ConversionEvent.prototype.custom = false;
    
                        /**
                         * Creates a new ConversionEvent instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.IConversionEvent=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.ConversionEvent} ConversionEvent instance
                         */
                        ConversionEvent.create = function create(properties) {
                            return new ConversionEvent(properties);
                        };
    
                        /**
                         * Encodes the specified ConversionEvent message. Does not implicitly {@link google.analytics.admin.v1beta.ConversionEvent.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.IConversionEvent} message ConversionEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionEvent.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.eventName != null && Object.hasOwnProperty.call(message, "eventName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.eventName);
                            if (message.createTime != null && Object.hasOwnProperty.call(message, "createTime"))
                                $root.google.protobuf.Timestamp.encode(message.createTime, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                            if (message.deletable != null && Object.hasOwnProperty.call(message, "deletable"))
                                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.deletable);
                            if (message.custom != null && Object.hasOwnProperty.call(message, "custom"))
                                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.custom);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ConversionEvent message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.ConversionEvent.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.IConversionEvent} message ConversionEvent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConversionEvent.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ConversionEvent message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.ConversionEvent} ConversionEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionEvent.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.ConversionEvent();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.eventName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.createTime = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 4: {
                                        message.deletable = reader.bool();
                                        break;
                                    }
                                case 5: {
                                        message.custom = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ConversionEvent message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.ConversionEvent} ConversionEvent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConversionEvent.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ConversionEvent message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConversionEvent.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                if (!$util.isString(message.eventName))
                                    return "eventName: string expected";
                            if (message.createTime != null && message.hasOwnProperty("createTime")) {
                                var error = $root.google.protobuf.Timestamp.verify(message.createTime);
                                if (error)
                                    return "createTime." + error;
                            }
                            if (message.deletable != null && message.hasOwnProperty("deletable"))
                                if (typeof message.deletable !== "boolean")
                                    return "deletable: boolean expected";
                            if (message.custom != null && message.hasOwnProperty("custom"))
                                if (typeof message.custom !== "boolean")
                                    return "custom: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a ConversionEvent message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.ConversionEvent} ConversionEvent
                         */
                        ConversionEvent.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.ConversionEvent)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.ConversionEvent();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.eventName != null)
                                message.eventName = String(object.eventName);
                            if (object.createTime != null) {
                                if (typeof object.createTime !== "object")
                                    throw TypeError(".google.analytics.admin.v1beta.ConversionEvent.createTime: object expected");
                                message.createTime = $root.google.protobuf.Timestamp.fromObject(object.createTime);
                            }
                            if (object.deletable != null)
                                message.deletable = Boolean(object.deletable);
                            if (object.custom != null)
                                message.custom = Boolean(object.custom);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ConversionEvent message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {google.analytics.admin.v1beta.ConversionEvent} message ConversionEvent
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConversionEvent.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.eventName = "";
                                object.createTime = null;
                                object.deletable = false;
                                object.custom = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.eventName != null && message.hasOwnProperty("eventName"))
                                object.eventName = message.eventName;
                            if (message.createTime != null && message.hasOwnProperty("createTime"))
                                object.createTime = $root.google.protobuf.Timestamp.toObject(message.createTime, options);
                            if (message.deletable != null && message.hasOwnProperty("deletable"))
                                object.deletable = message.deletable;
                            if (message.custom != null && message.hasOwnProperty("custom"))
                                object.custom = message.custom;
                            return object;
                        };
    
                        /**
                         * Converts this ConversionEvent to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConversionEvent.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ConversionEvent
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.ConversionEvent
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ConversionEvent.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.ConversionEvent";
                        };
    
                        return ConversionEvent;
                    })();
    
                    v1beta.CustomDimension = (function() {
    
                        /**
                         * Properties of a CustomDimension.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICustomDimension
                         * @property {string|null} [name] CustomDimension name
                         * @property {string|null} [parameterName] CustomDimension parameterName
                         * @property {string|null} [displayName] CustomDimension displayName
                         * @property {string|null} [description] CustomDimension description
                         * @property {google.analytics.admin.v1beta.CustomDimension.DimensionScope|null} [scope] CustomDimension scope
                         * @property {boolean|null} [disallowAdsPersonalization] CustomDimension disallowAdsPersonalization
                         */
    
                        /**
                         * Constructs a new CustomDimension.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CustomDimension.
                         * @implements ICustomDimension
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICustomDimension=} [properties] Properties to set
                         */
                        function CustomDimension(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CustomDimension name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.name = "";
    
                        /**
                         * CustomDimension parameterName.
                         * @member {string} parameterName
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.parameterName = "";
    
                        /**
                         * CustomDimension displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.displayName = "";
    
                        /**
                         * CustomDimension description.
                         * @member {string} description
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.description = "";
    
                        /**
                         * CustomDimension scope.
                         * @member {google.analytics.admin.v1beta.CustomDimension.DimensionScope} scope
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.scope = 0;
    
                        /**
                         * CustomDimension disallowAdsPersonalization.
                         * @member {boolean} disallowAdsPersonalization
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @instance
                         */
                        CustomDimension.prototype.disallowAdsPersonalization = false;
    
                        /**
                         * Creates a new CustomDimension instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.ICustomDimension=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CustomDimension} CustomDimension instance
                         */
                        CustomDimension.create = function create(properties) {
                            return new CustomDimension(properties);
                        };
    
                        /**
                         * Encodes the specified CustomDimension message. Does not implicitly {@link google.analytics.admin.v1beta.CustomDimension.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.ICustomDimension} message CustomDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomDimension.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.parameterName != null && Object.hasOwnProperty.call(message, "parameterName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parameterName);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.description);
                            if (message.scope != null && Object.hasOwnProperty.call(message, "scope"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.scope);
                            if (message.disallowAdsPersonalization != null && Object.hasOwnProperty.call(message, "disallowAdsPersonalization"))
                                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.disallowAdsPersonalization);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CustomDimension message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CustomDimension.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.ICustomDimension} message CustomDimension message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomDimension.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CustomDimension message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CustomDimension} CustomDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomDimension.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CustomDimension();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.parameterName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.scope = reader.int32();
                                        break;
                                    }
                                case 6: {
                                        message.disallowAdsPersonalization = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CustomDimension message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CustomDimension} CustomDimension
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomDimension.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CustomDimension message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomDimension.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                if (!$util.isString(message.parameterName))
                                    return "parameterName: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.description != null && message.hasOwnProperty("description"))
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                switch (message.scope) {
                                default:
                                    return "scope: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                    break;
                                }
                            if (message.disallowAdsPersonalization != null && message.hasOwnProperty("disallowAdsPersonalization"))
                                if (typeof message.disallowAdsPersonalization !== "boolean")
                                    return "disallowAdsPersonalization: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a CustomDimension message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CustomDimension} CustomDimension
                         */
                        CustomDimension.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CustomDimension)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CustomDimension();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.parameterName != null)
                                message.parameterName = String(object.parameterName);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.description != null)
                                message.description = String(object.description);
                            switch (object.scope) {
                            default:
                                if (typeof object.scope === "number") {
                                    message.scope = object.scope;
                                    break;
                                }
                                break;
                            case "DIMENSION_SCOPE_UNSPECIFIED":
                            case 0:
                                message.scope = 0;
                                break;
                            case "EVENT":
                            case 1:
                                message.scope = 1;
                                break;
                            case "USER":
                            case 2:
                                message.scope = 2;
                                break;
                            }
                            if (object.disallowAdsPersonalization != null)
                                message.disallowAdsPersonalization = Boolean(object.disallowAdsPersonalization);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CustomDimension message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {google.analytics.admin.v1beta.CustomDimension} message CustomDimension
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomDimension.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.parameterName = "";
                                object.displayName = "";
                                object.description = "";
                                object.scope = options.enums === String ? "DIMENSION_SCOPE_UNSPECIFIED" : 0;
                                object.disallowAdsPersonalization = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                object.parameterName = message.parameterName;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = message.description;
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                object.scope = options.enums === String ? $root.google.analytics.admin.v1beta.CustomDimension.DimensionScope[message.scope] === undefined ? message.scope : $root.google.analytics.admin.v1beta.CustomDimension.DimensionScope[message.scope] : message.scope;
                            if (message.disallowAdsPersonalization != null && message.hasOwnProperty("disallowAdsPersonalization"))
                                object.disallowAdsPersonalization = message.disallowAdsPersonalization;
                            return object;
                        };
    
                        /**
                         * Converts this CustomDimension to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomDimension.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CustomDimension
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CustomDimension
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CustomDimension.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CustomDimension";
                        };
    
                        /**
                         * DimensionScope enum.
                         * @name google.analytics.admin.v1beta.CustomDimension.DimensionScope
                         * @enum {number}
                         * @property {number} DIMENSION_SCOPE_UNSPECIFIED=0 DIMENSION_SCOPE_UNSPECIFIED value
                         * @property {number} EVENT=1 EVENT value
                         * @property {number} USER=2 USER value
                         */
                        CustomDimension.DimensionScope = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "DIMENSION_SCOPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EVENT"] = 1;
                            values[valuesById[2] = "USER"] = 2;
                            return values;
                        })();
    
                        return CustomDimension;
                    })();
    
                    v1beta.CustomMetric = (function() {
    
                        /**
                         * Properties of a CustomMetric.
                         * @memberof google.analytics.admin.v1beta
                         * @interface ICustomMetric
                         * @property {string|null} [name] CustomMetric name
                         * @property {string|null} [parameterName] CustomMetric parameterName
                         * @property {string|null} [displayName] CustomMetric displayName
                         * @property {string|null} [description] CustomMetric description
                         * @property {google.analytics.admin.v1beta.CustomMetric.MeasurementUnit|null} [measurementUnit] CustomMetric measurementUnit
                         * @property {google.analytics.admin.v1beta.CustomMetric.MetricScope|null} [scope] CustomMetric scope
                         * @property {Array.<google.analytics.admin.v1beta.CustomMetric.RestrictedMetricType>|null} [restrictedMetricType] CustomMetric restrictedMetricType
                         */
    
                        /**
                         * Constructs a new CustomMetric.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a CustomMetric.
                         * @implements ICustomMetric
                         * @constructor
                         * @param {google.analytics.admin.v1beta.ICustomMetric=} [properties] Properties to set
                         */
                        function CustomMetric(properties) {
                            this.restrictedMetricType = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CustomMetric name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.name = "";
    
                        /**
                         * CustomMetric parameterName.
                         * @member {string} parameterName
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.parameterName = "";
    
                        /**
                         * CustomMetric displayName.
                         * @member {string} displayName
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.displayName = "";
    
                        /**
                         * CustomMetric description.
                         * @member {string} description
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.description = "";
    
                        /**
                         * CustomMetric measurementUnit.
                         * @member {google.analytics.admin.v1beta.CustomMetric.MeasurementUnit} measurementUnit
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.measurementUnit = 0;
    
                        /**
                         * CustomMetric scope.
                         * @member {google.analytics.admin.v1beta.CustomMetric.MetricScope} scope
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.scope = 0;
    
                        /**
                         * CustomMetric restrictedMetricType.
                         * @member {Array.<google.analytics.admin.v1beta.CustomMetric.RestrictedMetricType>} restrictedMetricType
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         */
                        CustomMetric.prototype.restrictedMetricType = $util.emptyArray;
    
                        /**
                         * Creates a new CustomMetric instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.ICustomMetric=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.CustomMetric} CustomMetric instance
                         */
                        CustomMetric.create = function create(properties) {
                            return new CustomMetric(properties);
                        };
    
                        /**
                         * Encodes the specified CustomMetric message. Does not implicitly {@link google.analytics.admin.v1beta.CustomMetric.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.ICustomMetric} message CustomMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomMetric.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.parameterName != null && Object.hasOwnProperty.call(message, "parameterName"))
                                writer.uint32(/* id 2, wireType 2 =*/18).string(message.parameterName);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 3, wireType 2 =*/26).string(message.displayName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 4, wireType 2 =*/34).string(message.description);
                            if (message.measurementUnit != null && Object.hasOwnProperty.call(message, "measurementUnit"))
                                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.measurementUnit);
                            if (message.scope != null && Object.hasOwnProperty.call(message, "scope"))
                                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.scope);
                            if (message.restrictedMetricType != null && message.restrictedMetricType.length) {
                                writer.uint32(/* id 8, wireType 2 =*/66).fork();
                                for (var i = 0; i < message.restrictedMetricType.length; ++i)
                                    writer.int32(message.restrictedMetricType[i]);
                                writer.ldelim();
                            }
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CustomMetric message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.CustomMetric.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.ICustomMetric} message CustomMetric message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomMetric.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CustomMetric message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.CustomMetric} CustomMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomMetric.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.CustomMetric();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.parameterName = reader.string();
                                        break;
                                    }
                                case 3: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 4: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 5: {
                                        message.measurementUnit = reader.int32();
                                        break;
                                    }
                                case 6: {
                                        message.scope = reader.int32();
                                        break;
                                    }
                                case 8: {
                                        if (!(message.restrictedMetricType && message.restrictedMetricType.length))
                                            message.restrictedMetricType = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.restrictedMetricType.push(reader.int32());
                                        } else
                                            message.restrictedMetricType.push(reader.int32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CustomMetric message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.CustomMetric} CustomMetric
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomMetric.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CustomMetric message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomMetric.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                if (!$util.isString(message.parameterName))
                                    return "parameterName: string expected";
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            if (message.description != null && message.hasOwnProperty("description"))
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            if (message.measurementUnit != null && message.hasOwnProperty("measurementUnit"))
                                switch (message.measurementUnit) {
                                default:
                                    return "measurementUnit: enum value expected";
                                case 0:
                                case 1:
                                case 2:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                case 7:
                                case 8:
                                case 9:
                                case 10:
                                    break;
                                }
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                switch (message.scope) {
                                default:
                                    return "scope: enum value expected";
                                case 0:
                                case 1:
                                    break;
                                }
                            if (message.restrictedMetricType != null && message.hasOwnProperty("restrictedMetricType")) {
                                if (!Array.isArray(message.restrictedMetricType))
                                    return "restrictedMetricType: array expected";
                                for (var i = 0; i < message.restrictedMetricType.length; ++i)
                                    switch (message.restrictedMetricType[i]) {
                                    default:
                                        return "restrictedMetricType: enum value[] expected";
                                    case 0:
                                    case 1:
                                    case 2:
                                        break;
                                    }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CustomMetric message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.CustomMetric} CustomMetric
                         */
                        CustomMetric.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.CustomMetric)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.CustomMetric();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.parameterName != null)
                                message.parameterName = String(object.parameterName);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.description != null)
                                message.description = String(object.description);
                            switch (object.measurementUnit) {
                            default:
                                if (typeof object.measurementUnit === "number") {
                                    message.measurementUnit = object.measurementUnit;
                                    break;
                                }
                                break;
                            case "MEASUREMENT_UNIT_UNSPECIFIED":
                            case 0:
                                message.measurementUnit = 0;
                                break;
                            case "STANDARD":
                            case 1:
                                message.measurementUnit = 1;
                                break;
                            case "CURRENCY":
                            case 2:
                                message.measurementUnit = 2;
                                break;
                            case "FEET":
                            case 3:
                                message.measurementUnit = 3;
                                break;
                            case "METERS":
                            case 4:
                                message.measurementUnit = 4;
                                break;
                            case "KILOMETERS":
                            case 5:
                                message.measurementUnit = 5;
                                break;
                            case "MILES":
                            case 6:
                                message.measurementUnit = 6;
                                break;
                            case "MILLISECONDS":
                            case 7:
                                message.measurementUnit = 7;
                                break;
                            case "SECONDS":
                            case 8:
                                message.measurementUnit = 8;
                                break;
                            case "MINUTES":
                            case 9:
                                message.measurementUnit = 9;
                                break;
                            case "HOURS":
                            case 10:
                                message.measurementUnit = 10;
                                break;
                            }
                            switch (object.scope) {
                            default:
                                if (typeof object.scope === "number") {
                                    message.scope = object.scope;
                                    break;
                                }
                                break;
                            case "METRIC_SCOPE_UNSPECIFIED":
                            case 0:
                                message.scope = 0;
                                break;
                            case "EVENT":
                            case 1:
                                message.scope = 1;
                                break;
                            }
                            if (object.restrictedMetricType) {
                                if (!Array.isArray(object.restrictedMetricType))
                                    throw TypeError(".google.analytics.admin.v1beta.CustomMetric.restrictedMetricType: array expected");
                                message.restrictedMetricType = [];
                                for (var i = 0; i < object.restrictedMetricType.length; ++i)
                                    switch (object.restrictedMetricType[i]) {
                                    default:
                                        if (typeof object.restrictedMetricType[i] === "number") {
                                            message.restrictedMetricType[i] = object.restrictedMetricType[i];
                                            break;
                                        }
                                    case "RESTRICTED_METRIC_TYPE_UNSPECIFIED":
                                    case 0:
                                        message.restrictedMetricType[i] = 0;
                                        break;
                                    case "COST_DATA":
                                    case 1:
                                        message.restrictedMetricType[i] = 1;
                                        break;
                                    case "REVENUE_DATA":
                                    case 2:
                                        message.restrictedMetricType[i] = 2;
                                        break;
                                    }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CustomMetric message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {google.analytics.admin.v1beta.CustomMetric} message CustomMetric
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomMetric.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.restrictedMetricType = [];
                            if (options.defaults) {
                                object.name = "";
                                object.parameterName = "";
                                object.displayName = "";
                                object.description = "";
                                object.measurementUnit = options.enums === String ? "MEASUREMENT_UNIT_UNSPECIFIED" : 0;
                                object.scope = options.enums === String ? "METRIC_SCOPE_UNSPECIFIED" : 0;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.parameterName != null && message.hasOwnProperty("parameterName"))
                                object.parameterName = message.parameterName;
                            if (message.displayName != null && message.hasOwnProperty("displayName"))
                                object.displayName = message.displayName;
                            if (message.description != null && message.hasOwnProperty("description"))
                                object.description = message.description;
                            if (message.measurementUnit != null && message.hasOwnProperty("measurementUnit"))
                                object.measurementUnit = options.enums === String ? $root.google.analytics.admin.v1beta.CustomMetric.MeasurementUnit[message.measurementUnit] === undefined ? message.measurementUnit : $root.google.analytics.admin.v1beta.CustomMetric.MeasurementUnit[message.measurementUnit] : message.measurementUnit;
                            if (message.scope != null && message.hasOwnProperty("scope"))
                                object.scope = options.enums === String ? $root.google.analytics.admin.v1beta.CustomMetric.MetricScope[message.scope] === undefined ? message.scope : $root.google.analytics.admin.v1beta.CustomMetric.MetricScope[message.scope] : message.scope;
                            if (message.restrictedMetricType && message.restrictedMetricType.length) {
                                object.restrictedMetricType = [];
                                for (var j = 0; j < message.restrictedMetricType.length; ++j)
                                    object.restrictedMetricType[j] = options.enums === String ? $root.google.analytics.admin.v1beta.CustomMetric.RestrictedMetricType[message.restrictedMetricType[j]] === undefined ? message.restrictedMetricType[j] : $root.google.analytics.admin.v1beta.CustomMetric.RestrictedMetricType[message.restrictedMetricType[j]] : message.restrictedMetricType[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CustomMetric to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomMetric.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CustomMetric
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.CustomMetric
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CustomMetric.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.CustomMetric";
                        };
    
                        /**
                         * MeasurementUnit enum.
                         * @name google.analytics.admin.v1beta.CustomMetric.MeasurementUnit
                         * @enum {number}
                         * @property {number} MEASUREMENT_UNIT_UNSPECIFIED=0 MEASUREMENT_UNIT_UNSPECIFIED value
                         * @property {number} STANDARD=1 STANDARD value
                         * @property {number} CURRENCY=2 CURRENCY value
                         * @property {number} FEET=3 FEET value
                         * @property {number} METERS=4 METERS value
                         * @property {number} KILOMETERS=5 KILOMETERS value
                         * @property {number} MILES=6 MILES value
                         * @property {number} MILLISECONDS=7 MILLISECONDS value
                         * @property {number} SECONDS=8 SECONDS value
                         * @property {number} MINUTES=9 MINUTES value
                         * @property {number} HOURS=10 HOURS value
                         */
                        CustomMetric.MeasurementUnit = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "MEASUREMENT_UNIT_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "STANDARD"] = 1;
                            values[valuesById[2] = "CURRENCY"] = 2;
                            values[valuesById[3] = "FEET"] = 3;
                            values[valuesById[4] = "METERS"] = 4;
                            values[valuesById[5] = "KILOMETERS"] = 5;
                            values[valuesById[6] = "MILES"] = 6;
                            values[valuesById[7] = "MILLISECONDS"] = 7;
                            values[valuesById[8] = "SECONDS"] = 8;
                            values[valuesById[9] = "MINUTES"] = 9;
                            values[valuesById[10] = "HOURS"] = 10;
                            return values;
                        })();
    
                        /**
                         * MetricScope enum.
                         * @name google.analytics.admin.v1beta.CustomMetric.MetricScope
                         * @enum {number}
                         * @property {number} METRIC_SCOPE_UNSPECIFIED=0 METRIC_SCOPE_UNSPECIFIED value
                         * @property {number} EVENT=1 EVENT value
                         */
                        CustomMetric.MetricScope = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "METRIC_SCOPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "EVENT"] = 1;
                            return values;
                        })();
    
                        /**
                         * RestrictedMetricType enum.
                         * @name google.analytics.admin.v1beta.CustomMetric.RestrictedMetricType
                         * @enum {number}
                         * @property {number} RESTRICTED_METRIC_TYPE_UNSPECIFIED=0 RESTRICTED_METRIC_TYPE_UNSPECIFIED value
                         * @property {number} COST_DATA=1 COST_DATA value
                         * @property {number} REVENUE_DATA=2 REVENUE_DATA value
                         */
                        CustomMetric.RestrictedMetricType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "RESTRICTED_METRIC_TYPE_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "COST_DATA"] = 1;
                            values[valuesById[2] = "REVENUE_DATA"] = 2;
                            return values;
                        })();
    
                        return CustomMetric;
                    })();
    
                    v1beta.DataRetentionSettings = (function() {
    
                        /**
                         * Properties of a DataRetentionSettings.
                         * @memberof google.analytics.admin.v1beta
                         * @interface IDataRetentionSettings
                         * @property {string|null} [name] DataRetentionSettings name
                         * @property {google.analytics.admin.v1beta.DataRetentionSettings.RetentionDuration|null} [eventDataRetention] DataRetentionSettings eventDataRetention
                         * @property {boolean|null} [resetUserDataOnNewActivity] DataRetentionSettings resetUserDataOnNewActivity
                         */
    
                        /**
                         * Constructs a new DataRetentionSettings.
                         * @memberof google.analytics.admin.v1beta
                         * @classdesc Represents a DataRetentionSettings.
                         * @implements IDataRetentionSettings
                         * @constructor
                         * @param {google.analytics.admin.v1beta.IDataRetentionSettings=} [properties] Properties to set
                         */
                        function DataRetentionSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DataRetentionSettings name.
                         * @member {string} name
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @instance
                         */
                        DataRetentionSettings.prototype.name = "";
    
                        /**
                         * DataRetentionSettings eventDataRetention.
                         * @member {google.analytics.admin.v1beta.DataRetentionSettings.RetentionDuration} eventDataRetention
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @instance
                         */
                        DataRetentionSettings.prototype.eventDataRetention = 0;
    
                        /**
                         * DataRetentionSettings resetUserDataOnNewActivity.
                         * @member {boolean} resetUserDataOnNewActivity
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @instance
                         */
                        DataRetentionSettings.prototype.resetUserDataOnNewActivity = false;
    
                        /**
                         * Creates a new DataRetentionSettings instance using the specified properties.
                         * @function create
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataRetentionSettings=} [properties] Properties to set
                         * @returns {google.analytics.admin.v1beta.DataRetentionSettings} DataRetentionSettings instance
                         */
                        DataRetentionSettings.create = function create(properties) {
                            return new DataRetentionSettings(properties);
                        };
    
                        /**
                         * Encodes the specified DataRetentionSettings message. Does not implicitly {@link google.analytics.admin.v1beta.DataRetentionSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataRetentionSettings} message DataRetentionSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataRetentionSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                            if (message.eventDataRetention != null && Object.hasOwnProperty.call(message, "eventDataRetention"))
                                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.eventDataRetention);
                            if (message.resetUserDataOnNewActivity != null && Object.hasOwnProperty.call(message, "resetUserDataOnNewActivity"))
                                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.resetUserDataOnNewActivity);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DataRetentionSettings message, length delimited. Does not implicitly {@link google.analytics.admin.v1beta.DataRetentionSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.IDataRetentionSettings} message DataRetentionSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DataRetentionSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DataRetentionSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.analytics.admin.v1beta.DataRetentionSettings} DataRetentionSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataRetentionSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.analytics.admin.v1beta.DataRetentionSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2: {
                                        message.eventDataRetention = reader.int32();
                                        break;
                                    }
                                case 3: {
                                        message.resetUserDataOnNewActivity = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DataRetentionSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.analytics.admin.v1beta.DataRetentionSettings} DataRetentionSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DataRetentionSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DataRetentionSettings message.
                         * @function verify
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DataRetentionSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.name != null && message.hasOwnProperty("name"))
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            if (message.eventDataRetention != null && message.hasOwnProperty("eventDataRetention"))
                                switch (message.eventDataRetention) {
                                default:
                                    return "eventDataRetention: enum value expected";
                                case 0:
                                case 1:
                                case 3:
                                case 4:
                                case 5:
                                case 6:
                                    break;
                                }
                            if (message.resetUserDataOnNewActivity != null && message.hasOwnProperty("resetUserDataOnNewActivity"))
                                if (typeof message.resetUserDataOnNewActivity !== "boolean")
                                    return "resetUserDataOnNewActivity: boolean expected";
                            return null;
                        };
    
                        /**
                         * Creates a DataRetentionSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.analytics.admin.v1beta.DataRetentionSettings} DataRetentionSettings
                         */
                        DataRetentionSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.analytics.admin.v1beta.DataRetentionSettings)
                                return object;
                            var message = new $root.google.analytics.admin.v1beta.DataRetentionSettings();
                            if (object.name != null)
                                message.name = String(object.name);
                            switch (object.eventDataRetention) {
                            default:
                                if (typeof object.eventDataRetention === "number") {
                                    message.eventDataRetention = object.eventDataRetention;
                                    break;
                                }
                                break;
                            case "RETENTION_DURATION_UNSPECIFIED":
                            case 0:
                                message.eventDataRetention = 0;
                                break;
                            case "TWO_MONTHS":
                            case 1:
                                message.eventDataRetention = 1;
                                break;
                            case "FOURTEEN_MONTHS":
                            case 3:
                                message.eventDataRetention = 3;
                                break;
                            case "TWENTY_SIX_MONTHS":
                            case 4:
                                message.eventDataRetention = 4;
                                break;
                            case "THIRTY_EIGHT_MONTHS":
                            case 5:
                                message.eventDataRetention = 5;
                                break;
                            case "FIFTY_MONTHS":
                            case 6:
                                message.eventDataRetention = 6;
                                break;
                            }
                            if (object.resetUserDataOnNewActivity != null)
                                message.resetUserDataOnNewActivity = Boolean(object.resetUserDataOnNewActivity);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DataRetentionSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {google.analytics.admin.v1beta.DataRetentionSettings} message DataRetentionSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DataRetentionSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.name = "";
                                object.eventDataRetention = options.enums === String ? "RETENTION_DURATION_UNSPECIFIED" : 0;
                                object.resetUserDataOnNewActivity = false;
                            }
                            if (message.name != null && message.hasOwnProperty("name"))
                                object.name = message.name;
                            if (message.eventDataRetention != null && message.hasOwnProperty("eventDataRetention"))
                                object.eventDataRetention = options.enums === String ? $root.google.analytics.admin.v1beta.DataRetentionSettings.RetentionDuration[message.eventDataRetention] === undefined ? message.eventDataRetention : $root.google.analytics.admin.v1beta.DataRetentionSettings.RetentionDuration[message.eventDataRetention] : message.eventDataRetention;
                            if (message.resetUserDataOnNewActivity != null && message.hasOwnProperty("resetUserDataOnNewActivity"))
                                object.resetUserDataOnNewActivity = message.resetUserDataOnNewActivity;
                            return object;
                        };
    
                        /**
                         * Converts this DataRetentionSettings to JSON.
                         * @function toJSON
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DataRetentionSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DataRetentionSettings
                         * @function getTypeUrl
                         * @memberof google.analytics.admin.v1beta.DataRetentionSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DataRetentionSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.analytics.admin.v1beta.DataRetentionSettings";
                        };
    
                        /**
                         * RetentionDuration enum.
                         * @name google.analytics.admin.v1beta.DataRetentionSettings.RetentionDuration
                         * @enum {number}
                         * @property {number} RETENTION_DURATION_UNSPECIFIED=0 RETENTION_DURATION_UNSPECIFIED value
                         * @property {number} TWO_MONTHS=1 TWO_MONTHS value
                         * @property {number} FOURTEEN_MONTHS=3 FOURTEEN_MONTHS value
                         * @property {number} TWENTY_SIX_MONTHS=4 TWENTY_SIX_MONTHS value
                         * @property {number} THIRTY_EIGHT_MONTHS=5 THIRTY_EIGHT_MONTHS value
                         * @property {number} FIFTY_MONTHS=6 FIFTY_MONTHS value
                         */
                        DataRetentionSettings.RetentionDuration = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "RETENTION_DURATION_UNSPECIFIED"] = 0;
                            values[valuesById[1] = "TWO_MONTHS"] = 1;
                            values[valuesById[3] = "FOURTEEN_MONTHS"] = 3;
                            values[valuesById[4] = "TWENTY_SIX_MONTHS"] = 4;
                            values[valuesById[5] = "THIRTY_EIGHT_MONTHS"] = 5;
                            values[valuesById[6] = "FIFTY_MONTHS"] = 6;
                            return values;
                        })();
    
                        return DataRetentionSettings;
                    })();
    
                    return v1beta;
                })();
    
                return admin;
            })();
    
            return analytics;
        })();
    
        google.api = (function() {
    
            /**
             * Namespace api.
             * @memberof google
             * @namespace
             */
            var api = {};
    
            /**
             * FieldBehavior enum.
             * @name google.api.FieldBehavior
             * @enum {number}
             * @property {number} FIELD_BEHAVIOR_UNSPECIFIED=0 FIELD_BEHAVIOR_UNSPECIFIED value
             * @property {number} OPTIONAL=1 OPTIONAL value
             * @property {number} REQUIRED=2 REQUIRED value
             * @property {number} OUTPUT_ONLY=3 OUTPUT_ONLY value
             * @property {number} INPUT_ONLY=4 INPUT_ONLY value
             * @property {number} IMMUTABLE=5 IMMUTABLE value
             * @property {number} UNORDERED_LIST=6 UNORDERED_LIST value
             * @property {number} NON_EMPTY_DEFAULT=7 NON_EMPTY_DEFAULT value
             */
            api.FieldBehavior = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[0] = "FIELD_BEHAVIOR_UNSPECIFIED"] = 0;
                values[valuesById[1] = "OPTIONAL"] = 1;
                values[valuesById[2] = "REQUIRED"] = 2;
                values[valuesById[3] = "OUTPUT_ONLY"] = 3;
                values[valuesById[4] = "INPUT_ONLY"] = 4;
                values[valuesById[5] = "IMMUTABLE"] = 5;
                values[valuesById[6] = "UNORDERED_LIST"] = 6;
                values[valuesById[7] = "NON_EMPTY_DEFAULT"] = 7;
                return values;
            })();
    
            api.ResourceDescriptor = (function() {
    
                /**
                 * Properties of a ResourceDescriptor.
                 * @memberof google.api
                 * @interface IResourceDescriptor
                 * @property {string|null} [type] ResourceDescriptor type
                 * @property {Array.<string>|null} [pattern] ResourceDescriptor pattern
                 * @property {string|null} [nameField] ResourceDescriptor nameField
                 * @property {google.api.ResourceDescriptor.History|null} [history] ResourceDescriptor history
                 * @property {string|null} [plural] ResourceDescriptor plural
                 * @property {string|null} [singular] ResourceDescriptor singular
                 * @property {Array.<google.api.ResourceDescriptor.Style>|null} [style] ResourceDescriptor style
                 */
    
                /**
                 * Constructs a new ResourceDescriptor.
                 * @memberof google.api
                 * @classdesc Represents a ResourceDescriptor.
                 * @implements IResourceDescriptor
                 * @constructor
                 * @param {google.api.IResourceDescriptor=} [properties] Properties to set
                 */
                function ResourceDescriptor(properties) {
                    this.pattern = [];
                    this.style = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ResourceDescriptor type.
                 * @member {string} type
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.type = "";
    
                /**
                 * ResourceDescriptor pattern.
                 * @member {Array.<string>} pattern
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.pattern = $util.emptyArray;
    
                /**
                 * ResourceDescriptor nameField.
                 * @member {string} nameField
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.nameField = "";
    
                /**
                 * ResourceDescriptor history.
                 * @member {google.api.ResourceDescriptor.History} history
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.history = 0;
    
                /**
                 * ResourceDescriptor plural.
                 * @member {string} plural
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.plural = "";
    
                /**
                 * ResourceDescriptor singular.
                 * @member {string} singular
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.singular = "";
    
                /**
                 * ResourceDescriptor style.
                 * @member {Array.<google.api.ResourceDescriptor.Style>} style
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.style = $util.emptyArray;
    
                /**
                 * Creates a new ResourceDescriptor instance using the specified properties.
                 * @function create
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.IResourceDescriptor=} [properties] Properties to set
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor instance
                 */
                ResourceDescriptor.create = function create(properties) {
                    return new ResourceDescriptor(properties);
                };
    
                /**
                 * Encodes the specified ResourceDescriptor message. Does not implicitly {@link google.api.ResourceDescriptor.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.IResourceDescriptor} message ResourceDescriptor message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceDescriptor.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
                    if (message.pattern != null && message.pattern.length)
                        for (var i = 0; i < message.pattern.length; ++i)
                            writer.uint32(/* id 2, wireType 2 =*/18).string(message.pattern[i]);
                    if (message.nameField != null && Object.hasOwnProperty.call(message, "nameField"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.nameField);
                    if (message.history != null && Object.hasOwnProperty.call(message, "history"))
                        writer.uint32(/* id 4, wireType 0 =*/32).int32(message.history);
                    if (message.plural != null && Object.hasOwnProperty.call(message, "plural"))
                        writer.uint32(/* id 5, wireType 2 =*/42).string(message.plural);
                    if (message.singular != null && Object.hasOwnProperty.call(message, "singular"))
                        writer.uint32(/* id 6, wireType 2 =*/50).string(message.singular);
                    if (message.style != null && message.style.length) {
                        writer.uint32(/* id 10, wireType 2 =*/82).fork();
                        for (var i = 0; i < message.style.length; ++i)
                            writer.int32(message.style[i]);
                        writer.ldelim();
                    }
                    return writer;
                };
    
                /**
                 * Encodes the specified ResourceDescriptor message, length delimited. Does not implicitly {@link google.api.ResourceDescriptor.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.IResourceDescriptor} message ResourceDescriptor message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceDescriptor.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ResourceDescriptor message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceDescriptor.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.ResourceDescriptor();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.type = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.pattern && message.pattern.length))
                                    message.pattern = [];
                                message.pattern.push(reader.string());
                                break;
                            }
                        case 3: {
                                message.nameField = reader.string();
                                break;
                            }
                        case 4: {
                                message.history = reader.int32();
                                break;
                            }
                        case 5: {
                                message.plural = reader.string();
                                break;
                            }
                        case 6: {
                                message.singular = reader.string();
                                break;
                            }
                        case 10: {
                                if (!(message.style && message.style.length))
                                    message.style = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message.style.push(reader.int32());
                                } else
                                    message.style.push(reader.int32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ResourceDescriptor message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceDescriptor.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ResourceDescriptor message.
                 * @function verify
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ResourceDescriptor.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.type != null && message.hasOwnProperty("type"))
                        if (!$util.isString(message.type))
                            return "type: string expected";
                    if (message.pattern != null && message.hasOwnProperty("pattern")) {
                        if (!Array.isArray(message.pattern))
                            return "pattern: array expected";
                        for (var i = 0; i < message.pattern.length; ++i)
                            if (!$util.isString(message.pattern[i]))
                                return "pattern: string[] expected";
                    }
                    if (message.nameField != null && message.hasOwnProperty("nameField"))
                        if (!$util.isString(message.nameField))
                            return "nameField: string expected";
                    if (message.history != null && message.hasOwnProperty("history"))
                        switch (message.history) {
                        default:
                            return "history: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.plural != null && message.hasOwnProperty("plural"))
                        if (!$util.isString(message.plural))
                            return "plural: string expected";
                    if (message.singular != null && message.hasOwnProperty("singular"))
                        if (!$util.isString(message.singular))
                            return "singular: string expected";
                    if (message.style != null && message.hasOwnProperty("style")) {
                        if (!Array.isArray(message.style))
                            return "style: array expected";
                        for (var i = 0; i < message.style.length; ++i)
                            switch (message.style[i]) {
                            default:
                                return "style: enum value[] expected";
                            case 0:
                            case 1:
                                break;
                            }
                    }
                    return null;
                };
    
                /**
                 * Creates a ResourceDescriptor message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor
                 */
                ResourceDescriptor.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.ResourceDescriptor)
                        return object;
                    var message = new $root.google.api.ResourceDescriptor();
                    if (object.type != null)
                        message.type = String(object.type);
                    if (object.pattern) {
                        if (!Array.isArray(object.pattern))
                            throw TypeError(".google.api.ResourceDescriptor.pattern: array expected");
                        message.pattern = [];
                        for (var i = 0; i < object.pattern.length; ++i)
                            message.pattern[i] = String(object.pattern[i]);
                    }
                    if (object.nameField != null)
                        message.nameField = String(object.nameField);
                    switch (object.history) {
                    default:
                        if (typeof object.history === "number") {
                            message.history = object.history;
                            break;
                        }
                        break;
                    case "HISTORY_UNSPECIFIED":
                    case 0:
                        message.history = 0;
                        break;
                    case "ORIGINALLY_SINGLE_PATTERN":
                    case 1:
                        message.history = 1;
                        break;
                    case "FUTURE_MULTI_PATTERN":
                    case 2:
                        message.history = 2;
                        break;
                    }
                    if (object.plural != null)
                        message.plural = String(object.plural);
                    if (object.singular != null)
                        message.singular = String(object.singular);
                    if (object.style) {
                        if (!Array.isArray(object.style))
                            throw TypeError(".google.api.ResourceDescriptor.style: array expected");
                        message.style = [];
                        for (var i = 0; i < object.style.length; ++i)
                            switch (object.style[i]) {
                            default:
                                if (typeof object.style[i] === "number") {
                                    message.style[i] = object.style[i];
                                    break;
                                }
                            case "STYLE_UNSPECIFIED":
                            case 0:
                                message.style[i] = 0;
                                break;
                            case "DECLARATIVE_FRIENDLY":
                            case 1:
                                message.style[i] = 1;
                                break;
                            }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a ResourceDescriptor message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.ResourceDescriptor} message ResourceDescriptor
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ResourceDescriptor.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.pattern = [];
                        object.style = [];
                    }
                    if (options.defaults) {
                        object.type = "";
                        object.nameField = "";
                        object.history = options.enums === String ? "HISTORY_UNSPECIFIED" : 0;
                        object.plural = "";
                        object.singular = "";
                    }
                    if (message.type != null && message.hasOwnProperty("type"))
                        object.type = message.type;
                    if (message.pattern && message.pattern.length) {
                        object.pattern = [];
                        for (var j = 0; j < message.pattern.length; ++j)
                            object.pattern[j] = message.pattern[j];
                    }
                    if (message.nameField != null && message.hasOwnProperty("nameField"))
                        object.nameField = message.nameField;
                    if (message.history != null && message.hasOwnProperty("history"))
                        object.history = options.enums === String ? $root.google.api.ResourceDescriptor.History[message.history] === undefined ? message.history : $root.google.api.ResourceDescriptor.History[message.history] : message.history;
                    if (message.plural != null && message.hasOwnProperty("plural"))
                        object.plural = message.plural;
                    if (message.singular != null && message.hasOwnProperty("singular"))
                        object.singular = message.singular;
                    if (message.style && message.style.length) {
                        object.style = [];
                        for (var j = 0; j < message.style.length; ++j)
                            object.style[j] = options.enums === String ? $root.google.api.ResourceDescriptor.Style[message.style[j]] === undefined ? message.style[j] : $root.google.api.ResourceDescriptor.Style[message.style[j]] : message.style[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this ResourceDescriptor to JSON.
                 * @function toJSON
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ResourceDescriptor.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ResourceDescriptor
                 * @function getTypeUrl
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ResourceDescriptor.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.ResourceDescriptor";
                };
    
                /**
                 * History enum.
                 * @name google.api.ResourceDescriptor.History
                 * @enum {number}
                 * @property {number} HISTORY_UNSPECIFIED=0 HISTORY_UNSPECIFIED value
                 * @property {number} ORIGINALLY_SINGLE_PATTERN=1 ORIGINALLY_SINGLE_PATTERN value
                 * @property {number} FUTURE_MULTI_PATTERN=2 FUTURE_MULTI_PATTERN value
                 */
                ResourceDescriptor.History = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "HISTORY_UNSPECIFIED"] = 0;
                    values[valuesById[1] = "ORIGINALLY_SINGLE_PATTERN"] = 1;
                    values[valuesById[2] = "FUTURE_MULTI_PATTERN"] = 2;
                    return values;
                })();
    
                /**
                 * Style enum.
                 * @name google.api.ResourceDescriptor.Style
                 * @enum {number}
                 * @property {number} STYLE_UNSPECIFIED=0 STYLE_UNSPECIFIED value
                 * @property {number} DECLARATIVE_FRIENDLY=1 DECLARATIVE_FRIENDLY value
                 */
                ResourceDescriptor.Style = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "STYLE_UNSPECIFIED"] = 0;
                    values[valuesById[1] = "DECLARATIVE_FRIENDLY"] = 1;
                    return values;
                })();
    
                return ResourceDescriptor;
            })();
    
            api.ResourceReference = (function() {
    
                /**
                 * Properties of a ResourceReference.
                 * @memberof google.api
                 * @interface IResourceReference
                 * @property {string|null} [type] ResourceReference type
                 * @property {string|null} [childType] ResourceReference childType
                 */
    
                /**
                 * Constructs a new ResourceReference.
                 * @memberof google.api
                 * @classdesc Represents a ResourceReference.
                 * @implements IResourceReference
                 * @constructor
                 * @param {google.api.IResourceReference=} [properties] Properties to set
                 */
                function ResourceReference(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ResourceReference type.
                 * @member {string} type
                 * @memberof google.api.ResourceReference
                 * @instance
                 */
                ResourceReference.prototype.type = "";
    
                /**
                 * ResourceReference childType.
                 * @member {string} childType
                 * @memberof google.api.ResourceReference
                 * @instance
                 */
                ResourceReference.prototype.childType = "";
    
                /**
                 * Creates a new ResourceReference instance using the specified properties.
                 * @function create
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.IResourceReference=} [properties] Properties to set
                 * @returns {google.api.ResourceReference} ResourceReference instance
                 */
                ResourceReference.create = function create(properties) {
                    return new ResourceReference(properties);
                };
    
                /**
                 * Encodes the specified ResourceReference message. Does not implicitly {@link google.api.ResourceReference.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.IResourceReference} message ResourceReference message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceReference.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
                    if (message.childType != null && Object.hasOwnProperty.call(message, "childType"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.childType);
                    return writer;
                };
    
                /**
                 * Encodes the specified ResourceReference message, length delimited. Does not implicitly {@link google.api.ResourceReference.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.IResourceReference} message ResourceReference message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceReference.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ResourceReference message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.ResourceReference} ResourceReference
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceReference.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.ResourceReference();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.type = reader.string();
                                break;
                            }
                        case 2: {
                                message.childType = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ResourceReference message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.ResourceReference} ResourceReference
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceReference.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ResourceReference message.
                 * @function verify
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ResourceReference.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.type != null && message.hasOwnProperty("type"))
                        if (!$util.isString(message.type))
                            return "type: string expected";
                    if (message.childType != null && message.hasOwnProperty("childType"))
                        if (!$util.isString(message.childType))
                            return "childType: string expected";
                    return null;
                };
    
                /**
                 * Creates a ResourceReference message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.ResourceReference} ResourceReference
                 */
                ResourceReference.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.ResourceReference)
                        return object;
                    var message = new $root.google.api.ResourceReference();
                    if (object.type != null)
                        message.type = String(object.type);
                    if (object.childType != null)
                        message.childType = String(object.childType);
                    return message;
                };
    
                /**
                 * Creates a plain object from a ResourceReference message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.ResourceReference} message ResourceReference
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ResourceReference.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.type = "";
                        object.childType = "";
                    }
                    if (message.type != null && message.hasOwnProperty("type"))
                        object.type = message.type;
                    if (message.childType != null && message.hasOwnProperty("childType"))
                        object.childType = message.childType;
                    return object;
                };
    
                /**
                 * Converts this ResourceReference to JSON.
                 * @function toJSON
                 * @memberof google.api.ResourceReference
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ResourceReference.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ResourceReference
                 * @function getTypeUrl
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ResourceReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.ResourceReference";
                };
    
                return ResourceReference;
            })();
    
            api.Http = (function() {
    
                /**
                 * Properties of a Http.
                 * @memberof google.api
                 * @interface IHttp
                 * @property {Array.<google.api.IHttpRule>|null} [rules] Http rules
                 * @property {boolean|null} [fullyDecodeReservedExpansion] Http fullyDecodeReservedExpansion
                 */
    
                /**
                 * Constructs a new Http.
                 * @memberof google.api
                 * @classdesc Represents a Http.
                 * @implements IHttp
                 * @constructor
                 * @param {google.api.IHttp=} [properties] Properties to set
                 */
                function Http(properties) {
                    this.rules = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Http rules.
                 * @member {Array.<google.api.IHttpRule>} rules
                 * @memberof google.api.Http
                 * @instance
                 */
                Http.prototype.rules = $util.emptyArray;
    
                /**
                 * Http fullyDecodeReservedExpansion.
                 * @member {boolean} fullyDecodeReservedExpansion
                 * @memberof google.api.Http
                 * @instance
                 */
                Http.prototype.fullyDecodeReservedExpansion = false;
    
                /**
                 * Creates a new Http instance using the specified properties.
                 * @function create
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.IHttp=} [properties] Properties to set
                 * @returns {google.api.Http} Http instance
                 */
                Http.create = function create(properties) {
                    return new Http(properties);
                };
    
                /**
                 * Encodes the specified Http message. Does not implicitly {@link google.api.Http.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.IHttp} message Http message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Http.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.rules != null && message.rules.length)
                        for (var i = 0; i < message.rules.length; ++i)
                            $root.google.api.HttpRule.encode(message.rules[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    if (message.fullyDecodeReservedExpansion != null && Object.hasOwnProperty.call(message, "fullyDecodeReservedExpansion"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.fullyDecodeReservedExpansion);
                    return writer;
                };
    
                /**
                 * Encodes the specified Http message, length delimited. Does not implicitly {@link google.api.Http.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.IHttp} message Http message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Http.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a Http message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.Http
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.Http} Http
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Http.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.Http();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.rules && message.rules.length))
                                    message.rules = [];
                                message.rules.push($root.google.api.HttpRule.decode(reader, reader.uint32()));
                                break;
                            }
                        case 2: {
                                message.fullyDecodeReservedExpansion = reader.bool();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a Http message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.Http
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.Http} Http
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Http.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a Http message.
                 * @function verify
                 * @memberof google.api.Http
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Http.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.rules != null && message.hasOwnProperty("rules")) {
                        if (!Array.isArray(message.rules))
                            return "rules: array expected";
                        for (var i = 0; i < message.rules.length; ++i) {
                            var error = $root.google.api.HttpRule.verify(message.rules[i]);
                            if (error)
                                return "rules." + error;
                        }
                    }
                    if (message.fullyDecodeReservedExpansion != null && message.hasOwnProperty("fullyDecodeReservedExpansion"))
                        if (typeof message.fullyDecodeReservedExpansion !== "boolean")
                            return "fullyDecodeReservedExpansion: boolean expected";
                    return null;
                };
    
                /**
                 * Creates a Http message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.Http
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.Http} Http
                 */
                Http.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.Http)
                        return object;
                    var message = new $root.google.api.Http();
                    if (object.rules) {
                        if (!Array.isArray(object.rules))
                            throw TypeError(".google.api.Http.rules: array expected");
                        message.rules = [];
                        for (var i = 0; i < object.rules.length; ++i) {
                            if (typeof object.rules[i] !== "object")
                                throw TypeError(".google.api.Http.rules: object expected");
                            message.rules[i] = $root.google.api.HttpRule.fromObject(object.rules[i]);
                        }
                    }
                    if (object.fullyDecodeReservedExpansion != null)
                        message.fullyDecodeReservedExpansion = Boolean(object.fullyDecodeReservedExpansion);
                    return message;
                };
    
                /**
                 * Creates a plain object from a Http message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.Http} message Http
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Http.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.rules = [];
                    if (options.defaults)
                        object.fullyDecodeReservedExpansion = false;
                    if (message.rules && message.rules.length) {
                        object.rules = [];
                        for (var j = 0; j < message.rules.length; ++j)
                            object.rules[j] = $root.google.api.HttpRule.toObject(message.rules[j], options);
                    }
                    if (message.fullyDecodeReservedExpansion != null && message.hasOwnProperty("fullyDecodeReservedExpansion"))
                        object.fullyDecodeReservedExpansion = message.fullyDecodeReservedExpansion;
                    return object;
                };
    
                /**
                 * Converts this Http to JSON.
                 * @function toJSON
                 * @memberof google.api.Http
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Http.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Http
                 * @function getTypeUrl
                 * @memberof google.api.Http
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Http.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.Http";
                };
    
                return Http;
            })();
    
            api.HttpRule = (function() {
    
                /**
                 * Properties of a HttpRule.
                 * @memberof google.api
                 * @interface IHttpRule
                 * @property {string|null} [selector] HttpRule selector
                 * @property {string|null} [get] HttpRule get
                 * @property {string|null} [put] HttpRule put
                 * @property {string|null} [post] HttpRule post
                 * @property {string|null} ["delete"] HttpRule delete
                 * @property {string|null} [patch] HttpRule patch
                 * @property {google.api.ICustomHttpPattern|null} [custom] HttpRule custom
                 * @property {string|null} [body] HttpRule body
                 * @property {string|null} [responseBody] HttpRule responseBody
                 * @property {Array.<google.api.IHttpRule>|null} [additionalBindings] HttpRule additionalBindings
                 */
    
                /**
                 * Constructs a new HttpRule.
                 * @memberof google.api
                 * @classdesc Represents a HttpRule.
                 * @implements IHttpRule
                 * @constructor
                 * @param {google.api.IHttpRule=} [properties] Properties to set
                 */
                function HttpRule(properties) {
                    this.additionalBindings = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * HttpRule selector.
                 * @member {string} selector
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.selector = "";
    
                /**
                 * HttpRule get.
                 * @member {string|null|undefined} get
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.get = null;
    
                /**
                 * HttpRule put.
                 * @member {string|null|undefined} put
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.put = null;
    
                /**
                 * HttpRule post.
                 * @member {string|null|undefined} post
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.post = null;
    
                /**
                 * HttpRule delete.
                 * @member {string|null|undefined} delete
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype["delete"] = null;
    
                /**
                 * HttpRule patch.
                 * @member {string|null|undefined} patch
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.patch = null;
    
                /**
                 * HttpRule custom.
                 * @member {google.api.ICustomHttpPattern|null|undefined} custom
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.custom = null;
    
                /**
                 * HttpRule body.
                 * @member {string} body
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.body = "";
    
                /**
                 * HttpRule responseBody.
                 * @member {string} responseBody
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.responseBody = "";
    
                /**
                 * HttpRule additionalBindings.
                 * @member {Array.<google.api.IHttpRule>} additionalBindings
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.additionalBindings = $util.emptyArray;
    
                // OneOf field names bound to virtual getters and setters
                var $oneOfFields;
    
                /**
                 * HttpRule pattern.
                 * @member {"get"|"put"|"post"|"delete"|"patch"|"custom"|undefined} pattern
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                Object.defineProperty(HttpRule.prototype, "pattern", {
                    get: $util.oneOfGetter($oneOfFields = ["get", "put", "post", "delete", "patch", "custom"]),
                    set: $util.oneOfSetter($oneOfFields)
                });
    
                /**
                 * Creates a new HttpRule instance using the specified properties.
                 * @function create
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.IHttpRule=} [properties] Properties to set
                 * @returns {google.api.HttpRule} HttpRule instance
                 */
                HttpRule.create = function create(properties) {
                    return new HttpRule(properties);
                };
    
                /**
                 * Encodes the specified HttpRule message. Does not implicitly {@link google.api.HttpRule.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.IHttpRule} message HttpRule message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                HttpRule.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.selector != null && Object.hasOwnProperty.call(message, "selector"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.selector);
                    if (message.get != null && Object.hasOwnProperty.call(message, "get"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.get);
                    if (message.put != null && Object.hasOwnProperty.call(message, "put"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.put);
                    if (message.post != null && Object.hasOwnProperty.call(message, "post"))
                        writer.uint32(/* id 4, wireType 2 =*/34).string(message.post);
                    if (message["delete"] != null && Object.hasOwnProperty.call(message, "delete"))
                        writer.uint32(/* id 5, wireType 2 =*/42).string(message["delete"]);
                    if (message.patch != null && Object.hasOwnProperty.call(message, "patch"))
                        writer.uint32(/* id 6, wireType 2 =*/50).string(message.patch);
                    if (message.body != null && Object.hasOwnProperty.call(message, "body"))
                        writer.uint32(/* id 7, wireType 2 =*/58).string(message.body);
                    if (message.custom != null && Object.hasOwnProperty.call(message, "custom"))
                        $root.google.api.CustomHttpPattern.encode(message.custom, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.additionalBindings != null && message.additionalBindings.length)
                        for (var i = 0; i < message.additionalBindings.length; ++i)
                            $root.google.api.HttpRule.encode(message.additionalBindings[i], writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                    if (message.responseBody != null && Object.hasOwnProperty.call(message, "responseBody"))
                        writer.uint32(/* id 12, wireType 2 =*/98).string(message.responseBody);
                    return writer;
                };
    
                /**
                 * Encodes the specified HttpRule message, length delimited. Does not implicitly {@link google.api.HttpRule.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.IHttpRule} message HttpRule message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                HttpRule.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a HttpRule message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.HttpRule} HttpRule
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                HttpRule.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.HttpRule();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.selector = reader.string();
                                break;
                            }
                        case 2: {
                                message.get = reader.string();
                                break;
                            }
                        case 3: {
                                message.put = reader.string();
                                break;
                            }
                        case 4: {
                                message.post = reader.string();
                                break;
                            }
                        case 5: {
                                message["delete"] = reader.string();
                                break;
                            }
                        case 6: {
                                message.patch = reader.string();
                                break;
                            }
                        case 8: {
                                message.custom = $root.google.api.CustomHttpPattern.decode(reader, reader.uint32());
                                break;
                            }
                        case 7: {
                                message.body = reader.string();
                                break;
                            }
                        case 12: {
                                message.responseBody = reader.string();
                                break;
                            }
                        case 11: {
                                if (!(message.additionalBindings && message.additionalBindings.length))
                                    message.additionalBindings = [];
                                message.additionalBindings.push($root.google.api.HttpRule.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a HttpRule message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.HttpRule} HttpRule
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                HttpRule.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a HttpRule message.
                 * @function verify
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                HttpRule.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    var properties = {};
                    if (message.selector != null && message.hasOwnProperty("selector"))
                        if (!$util.isString(message.selector))
                            return "selector: string expected";
                    if (message.get != null && message.hasOwnProperty("get")) {
                        properties.pattern = 1;
                        if (!$util.isString(message.get))
                            return "get: string expected";
                    }
                    if (message.put != null && message.hasOwnProperty("put")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message.put))
                            return "put: string expected";
                    }
                    if (message.post != null && message.hasOwnProperty("post")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message.post))
                            return "post: string expected";
                    }
                    if (message["delete"] != null && message.hasOwnProperty("delete")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message["delete"]))
                            return "delete: string expected";
                    }
                    if (message.patch != null && message.hasOwnProperty("patch")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message.patch))
                            return "patch: string expected";
                    }
                    if (message.custom != null && message.hasOwnProperty("custom")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        {
                            var error = $root.google.api.CustomHttpPattern.verify(message.custom);
                            if (error)
                                return "custom." + error;
                        }
                    }
                    if (message.body != null && message.hasOwnProperty("body"))
                        if (!$util.isString(message.body))
                            return "body: string expected";
                    if (message.responseBody != null && message.hasOwnProperty("responseBody"))
                        if (!$util.isString(message.responseBody))
                            return "responseBody: string expected";
                    if (message.additionalBindings != null && message.hasOwnProperty("additionalBindings")) {
                        if (!Array.isArray(message.additionalBindings))
                            return "additionalBindings: array expected";
                        for (var i = 0; i < message.additionalBindings.length; ++i) {
                            var error = $root.google.api.HttpRule.verify(message.additionalBindings[i]);
                            if (error)
                                return "additionalBindings." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a HttpRule message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.HttpRule} HttpRule
                 */
                HttpRule.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.HttpRule)
                        return object;
                    var message = new $root.google.api.HttpRule();
                    if (object.selector != null)
                        message.selector = String(object.selector);
                    if (object.get != null)
                        message.get = String(object.get);
                    if (object.put != null)
                        message.put = String(object.put);
                    if (object.post != null)
                        message.post = String(object.post);
                    if (object["delete"] != null)
                        message["delete"] = String(object["delete"]);
                    if (object.patch != null)
                        message.patch = String(object.patch);
                    if (object.custom != null) {
                        if (typeof object.custom !== "object")
                            throw TypeError(".google.api.HttpRule.custom: object expected");
                        message.custom = $root.google.api.CustomHttpPattern.fromObject(object.custom);
                    }
                    if (object.body != null)
                        message.body = String(object.body);
                    if (object.responseBody != null)
                        message.responseBody = String(object.responseBody);
                    if (object.additionalBindings) {
                        if (!Array.isArray(object.additionalBindings))
                            throw TypeError(".google.api.HttpRule.additionalBindings: array expected");
                        message.additionalBindings = [];
                        for (var i = 0; i < object.additionalBindings.length; ++i) {
                            if (typeof object.additionalBindings[i] !== "object")
                                throw TypeError(".google.api.HttpRule.additionalBindings: object expected");
                            message.additionalBindings[i] = $root.google.api.HttpRule.fromObject(object.additionalBindings[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a HttpRule message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.HttpRule} message HttpRule
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                HttpRule.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.additionalBindings = [];
                    if (options.defaults) {
                        object.selector = "";
                        object.body = "";
                        object.responseBody = "";
                    }
                    if (message.selector != null && message.hasOwnProperty("selector"))
                        object.selector = message.selector;
                    if (message.get != null && message.hasOwnProperty("get")) {
                        object.get = message.get;
                        if (options.oneofs)
                            object.pattern = "get";
                    }
                    if (message.put != null && message.hasOwnProperty("put")) {
                        object.put = message.put;
                        if (options.oneofs)
                            object.pattern = "put";
                    }
                    if (message.post != null && message.hasOwnProperty("post")) {
                        object.post = message.post;
                        if (options.oneofs)
                            object.pattern = "post";
                    }
                    if (message["delete"] != null && message.hasOwnProperty("delete")) {
                        object["delete"] = message["delete"];
                        if (options.oneofs)
                            object.pattern = "delete";
                    }
                    if (message.patch != null && message.hasOwnProperty("patch")) {
                        object.patch = message.patch;
                        if (options.oneofs)
                            object.pattern = "patch";
                    }
                    if (message.body != null && message.hasOwnProperty("body"))
                        object.body = message.body;
                    if (message.custom != null && message.hasOwnProperty("custom")) {
                        object.custom = $root.google.api.CustomHttpPattern.toObject(message.custom, options);
                        if (options.oneofs)
                            object.pattern = "custom";
                    }
                    if (message.additionalBindings && message.additionalBindings.length) {
                        object.additionalBindings = [];
                        for (var j = 0; j < message.additionalBindings.length; ++j)
                            object.additionalBindings[j] = $root.google.api.HttpRule.toObject(message.additionalBindings[j], options);
                    }
                    if (message.responseBody != null && message.hasOwnProperty("responseBody"))
                        object.responseBody = message.responseBody;
                    return object;
                };
    
                /**
                 * Converts this HttpRule to JSON.
                 * @function toJSON
                 * @memberof google.api.HttpRule
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                HttpRule.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for HttpRule
                 * @function getTypeUrl
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                HttpRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.HttpRule";
                };
    
                return HttpRule;
            })();
    
            api.CustomHttpPattern = (function() {
    
                /**
                 * Properties of a CustomHttpPattern.
                 * @memberof google.api
                 * @interface ICustomHttpPattern
                 * @property {string|null} [kind] CustomHttpPattern kind
                 * @property {string|null} [path] CustomHttpPattern path
                 */
    
                /**
                 * Constructs a new CustomHttpPattern.
                 * @memberof google.api
                 * @classdesc Represents a CustomHttpPattern.
                 * @implements ICustomHttpPattern
                 * @constructor
                 * @param {google.api.ICustomHttpPattern=} [properties] Properties to set
                 */
                function CustomHttpPattern(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * CustomHttpPattern kind.
                 * @member {string} kind
                 * @memberof google.api.CustomHttpPattern
                 * @instance
                 */
                CustomHttpPattern.prototype.kind = "";
    
                /**
                 * CustomHttpPattern path.
                 * @member {string} path
                 * @memberof google.api.CustomHttpPattern
                 * @instance
                 */
                CustomHttpPattern.prototype.path = "";
    
                /**
                 * Creates a new CustomHttpPattern instance using the specified properties.
                 * @function create
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.ICustomHttpPattern=} [properties] Properties to set
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern instance
                 */
                CustomHttpPattern.create = function create(properties) {
                    return new CustomHttpPattern(properties);
                };
    
                /**
                 * Encodes the specified CustomHttpPattern message. Does not implicitly {@link google.api.CustomHttpPattern.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.ICustomHttpPattern} message CustomHttpPattern message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CustomHttpPattern.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.kind);
                    if (message.path != null && Object.hasOwnProperty.call(message, "path"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.path);
                    return writer;
                };
    
                /**
                 * Encodes the specified CustomHttpPattern message, length delimited. Does not implicitly {@link google.api.CustomHttpPattern.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.ICustomHttpPattern} message CustomHttpPattern message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CustomHttpPattern.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a CustomHttpPattern message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CustomHttpPattern.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.CustomHttpPattern();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.kind = reader.string();
                                break;
                            }
                        case 2: {
                                message.path = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a CustomHttpPattern message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CustomHttpPattern.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a CustomHttpPattern message.
                 * @function verify
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                CustomHttpPattern.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.kind != null && message.hasOwnProperty("kind"))
                        if (!$util.isString(message.kind))
                            return "kind: string expected";
                    if (message.path != null && message.hasOwnProperty("path"))
                        if (!$util.isString(message.path))
                            return "path: string expected";
                    return null;
                };
    
                /**
                 * Creates a CustomHttpPattern message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern
                 */
                CustomHttpPattern.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.CustomHttpPattern)
                        return object;
                    var message = new $root.google.api.CustomHttpPattern();
                    if (object.kind != null)
                        message.kind = String(object.kind);
                    if (object.path != null)
                        message.path = String(object.path);
                    return message;
                };
    
                /**
                 * Creates a plain object from a CustomHttpPattern message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.CustomHttpPattern} message CustomHttpPattern
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                CustomHttpPattern.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.kind = "";
                        object.path = "";
                    }
                    if (message.kind != null && message.hasOwnProperty("kind"))
                        object.kind = message.kind;
                    if (message.path != null && message.hasOwnProperty("path"))
                        object.path = message.path;
                    return object;
                };
    
                /**
                 * Converts this CustomHttpPattern to JSON.
                 * @function toJSON
                 * @memberof google.api.CustomHttpPattern
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                CustomHttpPattern.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for CustomHttpPattern
                 * @function getTypeUrl
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                CustomHttpPattern.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.CustomHttpPattern";
                };
    
                return CustomHttpPattern;
            })();
    
            api.CommonLanguageSettings = (function() {
    
                /**
                 * Properties of a CommonLanguageSettings.
                 * @memberof google.api
                 * @interface ICommonLanguageSettings
                 * @property {string|null} [referenceDocsUri] CommonLanguageSettings referenceDocsUri
                 * @property {Array.<google.api.ClientLibraryDestination>|null} [destinations] CommonLanguageSettings destinations
                 */
    
                /**
                 * Constructs a new CommonLanguageSettings.
                 * @memberof google.api
                 * @classdesc Represents a CommonLanguageSettings.
                 * @implements ICommonLanguageSettings
                 * @constructor
                 * @param {google.api.ICommonLanguageSettings=} [properties] Properties to set
                 */
                function CommonLanguageSettings(properties) {
                    this.destinations = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * CommonLanguageSettings referenceDocsUri.
                 * @member {string} referenceDocsUri
                 * @memberof google.api.CommonLanguageSettings
                 * @instance
                 */
                CommonLanguageSettings.prototype.referenceDocsUri = "";
    
                /**
                 * CommonLanguageSettings destinations.
                 * @member {Array.<google.api.ClientLibraryDestination>} destinations
                 * @memberof google.api.CommonLanguageSettings
                 * @instance
                 */
                CommonLanguageSettings.prototype.destinations = $util.emptyArray;
    
                /**
                 * Creates a new CommonLanguageSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {google.api.ICommonLanguageSettings=} [properties] Properties to set
                 * @returns {google.api.CommonLanguageSettings} CommonLanguageSettings instance
                 */
                CommonLanguageSettings.create = function create(properties) {
                    return new CommonLanguageSettings(properties);
                };
    
                /**
                 * Encodes the specified CommonLanguageSettings message. Does not implicitly {@link google.api.CommonLanguageSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {google.api.ICommonLanguageSettings} message CommonLanguageSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CommonLanguageSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.referenceDocsUri != null && Object.hasOwnProperty.call(message, "referenceDocsUri"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.referenceDocsUri);
                    if (message.destinations != null && message.destinations.length) {
                        writer.uint32(/* id 2, wireType 2 =*/18).fork();
                        for (var i = 0; i < message.destinations.length; ++i)
                            writer.int32(message.destinations[i]);
                        writer.ldelim();
                    }
                    return writer;
                };
    
                /**
                 * Encodes the specified CommonLanguageSettings message, length delimited. Does not implicitly {@link google.api.CommonLanguageSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {google.api.ICommonLanguageSettings} message CommonLanguageSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CommonLanguageSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a CommonLanguageSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.CommonLanguageSettings} CommonLanguageSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CommonLanguageSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.CommonLanguageSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.referenceDocsUri = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.destinations && message.destinations.length))
                                    message.destinations = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message.destinations.push(reader.int32());
                                } else
                                    message.destinations.push(reader.int32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a CommonLanguageSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.CommonLanguageSettings} CommonLanguageSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CommonLanguageSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a CommonLanguageSettings message.
                 * @function verify
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                CommonLanguageSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.referenceDocsUri != null && message.hasOwnProperty("referenceDocsUri"))
                        if (!$util.isString(message.referenceDocsUri))
                            return "referenceDocsUri: string expected";
                    if (message.destinations != null && message.hasOwnProperty("destinations")) {
                        if (!Array.isArray(message.destinations))
                            return "destinations: array expected";
                        for (var i = 0; i < message.destinations.length; ++i)
                            switch (message.destinations[i]) {
                            default:
                                return "destinations: enum value[] expected";
                            case 0:
                            case 10:
                            case 20:
                                break;
                            }
                    }
                    return null;
                };
    
                /**
                 * Creates a CommonLanguageSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.CommonLanguageSettings} CommonLanguageSettings
                 */
                CommonLanguageSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.CommonLanguageSettings)
                        return object;
                    var message = new $root.google.api.CommonLanguageSettings();
                    if (object.referenceDocsUri != null)
                        message.referenceDocsUri = String(object.referenceDocsUri);
                    if (object.destinations) {
                        if (!Array.isArray(object.destinations))
                            throw TypeError(".google.api.CommonLanguageSettings.destinations: array expected");
                        message.destinations = [];
                        for (var i = 0; i < object.destinations.length; ++i)
                            switch (object.destinations[i]) {
                            default:
                                if (typeof object.destinations[i] === "number") {
                                    message.destinations[i] = object.destinations[i];
                                    break;
                                }
                            case "CLIENT_LIBRARY_DESTINATION_UNSPECIFIED":
                            case 0:
                                message.destinations[i] = 0;
                                break;
                            case "GITHUB":
                            case 10:
                                message.destinations[i] = 10;
                                break;
                            case "PACKAGE_MANAGER":
                            case 20:
                                message.destinations[i] = 20;
                                break;
                            }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a CommonLanguageSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {google.api.CommonLanguageSettings} message CommonLanguageSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                CommonLanguageSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.destinations = [];
                    if (options.defaults)
                        object.referenceDocsUri = "";
                    if (message.referenceDocsUri != null && message.hasOwnProperty("referenceDocsUri"))
                        object.referenceDocsUri = message.referenceDocsUri;
                    if (message.destinations && message.destinations.length) {
                        object.destinations = [];
                        for (var j = 0; j < message.destinations.length; ++j)
                            object.destinations[j] = options.enums === String ? $root.google.api.ClientLibraryDestination[message.destinations[j]] === undefined ? message.destinations[j] : $root.google.api.ClientLibraryDestination[message.destinations[j]] : message.destinations[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this CommonLanguageSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.CommonLanguageSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                CommonLanguageSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for CommonLanguageSettings
                 * @function getTypeUrl
                 * @memberof google.api.CommonLanguageSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                CommonLanguageSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.CommonLanguageSettings";
                };
    
                return CommonLanguageSettings;
            })();
    
            api.ClientLibrarySettings = (function() {
    
                /**
                 * Properties of a ClientLibrarySettings.
                 * @memberof google.api
                 * @interface IClientLibrarySettings
                 * @property {string|null} [version] ClientLibrarySettings version
                 * @property {google.api.LaunchStage|null} [launchStage] ClientLibrarySettings launchStage
                 * @property {boolean|null} [restNumericEnums] ClientLibrarySettings restNumericEnums
                 * @property {google.api.IJavaSettings|null} [javaSettings] ClientLibrarySettings javaSettings
                 * @property {google.api.ICppSettings|null} [cppSettings] ClientLibrarySettings cppSettings
                 * @property {google.api.IPhpSettings|null} [phpSettings] ClientLibrarySettings phpSettings
                 * @property {google.api.IPythonSettings|null} [pythonSettings] ClientLibrarySettings pythonSettings
                 * @property {google.api.INodeSettings|null} [nodeSettings] ClientLibrarySettings nodeSettings
                 * @property {google.api.IDotnetSettings|null} [dotnetSettings] ClientLibrarySettings dotnetSettings
                 * @property {google.api.IRubySettings|null} [rubySettings] ClientLibrarySettings rubySettings
                 * @property {google.api.IGoSettings|null} [goSettings] ClientLibrarySettings goSettings
                 */
    
                /**
                 * Constructs a new ClientLibrarySettings.
                 * @memberof google.api
                 * @classdesc Represents a ClientLibrarySettings.
                 * @implements IClientLibrarySettings
                 * @constructor
                 * @param {google.api.IClientLibrarySettings=} [properties] Properties to set
                 */
                function ClientLibrarySettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ClientLibrarySettings version.
                 * @member {string} version
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.version = "";
    
                /**
                 * ClientLibrarySettings launchStage.
                 * @member {google.api.LaunchStage} launchStage
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.launchStage = 0;
    
                /**
                 * ClientLibrarySettings restNumericEnums.
                 * @member {boolean} restNumericEnums
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.restNumericEnums = false;
    
                /**
                 * ClientLibrarySettings javaSettings.
                 * @member {google.api.IJavaSettings|null|undefined} javaSettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.javaSettings = null;
    
                /**
                 * ClientLibrarySettings cppSettings.
                 * @member {google.api.ICppSettings|null|undefined} cppSettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.cppSettings = null;
    
                /**
                 * ClientLibrarySettings phpSettings.
                 * @member {google.api.IPhpSettings|null|undefined} phpSettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.phpSettings = null;
    
                /**
                 * ClientLibrarySettings pythonSettings.
                 * @member {google.api.IPythonSettings|null|undefined} pythonSettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.pythonSettings = null;
    
                /**
                 * ClientLibrarySettings nodeSettings.
                 * @member {google.api.INodeSettings|null|undefined} nodeSettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.nodeSettings = null;
    
                /**
                 * ClientLibrarySettings dotnetSettings.
                 * @member {google.api.IDotnetSettings|null|undefined} dotnetSettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.dotnetSettings = null;
    
                /**
                 * ClientLibrarySettings rubySettings.
                 * @member {google.api.IRubySettings|null|undefined} rubySettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.rubySettings = null;
    
                /**
                 * ClientLibrarySettings goSettings.
                 * @member {google.api.IGoSettings|null|undefined} goSettings
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 */
                ClientLibrarySettings.prototype.goSettings = null;
    
                /**
                 * Creates a new ClientLibrarySettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {google.api.IClientLibrarySettings=} [properties] Properties to set
                 * @returns {google.api.ClientLibrarySettings} ClientLibrarySettings instance
                 */
                ClientLibrarySettings.create = function create(properties) {
                    return new ClientLibrarySettings(properties);
                };
    
                /**
                 * Encodes the specified ClientLibrarySettings message. Does not implicitly {@link google.api.ClientLibrarySettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {google.api.IClientLibrarySettings} message ClientLibrarySettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ClientLibrarySettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.version);
                    if (message.launchStage != null && Object.hasOwnProperty.call(message, "launchStage"))
                        writer.uint32(/* id 2, wireType 0 =*/16).int32(message.launchStage);
                    if (message.restNumericEnums != null && Object.hasOwnProperty.call(message, "restNumericEnums"))
                        writer.uint32(/* id 3, wireType 0 =*/24).bool(message.restNumericEnums);
                    if (message.javaSettings != null && Object.hasOwnProperty.call(message, "javaSettings"))
                        $root.google.api.JavaSettings.encode(message.javaSettings, writer.uint32(/* id 21, wireType 2 =*/170).fork()).ldelim();
                    if (message.cppSettings != null && Object.hasOwnProperty.call(message, "cppSettings"))
                        $root.google.api.CppSettings.encode(message.cppSettings, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
                    if (message.phpSettings != null && Object.hasOwnProperty.call(message, "phpSettings"))
                        $root.google.api.PhpSettings.encode(message.phpSettings, writer.uint32(/* id 23, wireType 2 =*/186).fork()).ldelim();
                    if (message.pythonSettings != null && Object.hasOwnProperty.call(message, "pythonSettings"))
                        $root.google.api.PythonSettings.encode(message.pythonSettings, writer.uint32(/* id 24, wireType 2 =*/194).fork()).ldelim();
                    if (message.nodeSettings != null && Object.hasOwnProperty.call(message, "nodeSettings"))
                        $root.google.api.NodeSettings.encode(message.nodeSettings, writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
                    if (message.dotnetSettings != null && Object.hasOwnProperty.call(message, "dotnetSettings"))
                        $root.google.api.DotnetSettings.encode(message.dotnetSettings, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
                    if (message.rubySettings != null && Object.hasOwnProperty.call(message, "rubySettings"))
                        $root.google.api.RubySettings.encode(message.rubySettings, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
                    if (message.goSettings != null && Object.hasOwnProperty.call(message, "goSettings"))
                        $root.google.api.GoSettings.encode(message.goSettings, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified ClientLibrarySettings message, length delimited. Does not implicitly {@link google.api.ClientLibrarySettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {google.api.IClientLibrarySettings} message ClientLibrarySettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ClientLibrarySettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ClientLibrarySettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.ClientLibrarySettings} ClientLibrarySettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ClientLibrarySettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.ClientLibrarySettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.version = reader.string();
                                break;
                            }
                        case 2: {
                                message.launchStage = reader.int32();
                                break;
                            }
                        case 3: {
                                message.restNumericEnums = reader.bool();
                                break;
                            }
                        case 21: {
                                message.javaSettings = $root.google.api.JavaSettings.decode(reader, reader.uint32());
                                break;
                            }
                        case 22: {
                                message.cppSettings = $root.google.api.CppSettings.decode(reader, reader.uint32());
                                break;
                            }
                        case 23: {
                                message.phpSettings = $root.google.api.PhpSettings.decode(reader, reader.uint32());
                                break;
                            }
                        case 24: {
                                message.pythonSettings = $root.google.api.PythonSettings.decode(reader, reader.uint32());
                                break;
                            }
                        case 25: {
                                message.nodeSettings = $root.google.api.NodeSettings.decode(reader, reader.uint32());
                                break;
                            }
                        case 26: {
                                message.dotnetSettings = $root.google.api.DotnetSettings.decode(reader, reader.uint32());
                                break;
                            }
                        case 27: {
                                message.rubySettings = $root.google.api.RubySettings.decode(reader, reader.uint32());
                                break;
                            }
                        case 28: {
                                message.goSettings = $root.google.api.GoSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ClientLibrarySettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.ClientLibrarySettings} ClientLibrarySettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ClientLibrarySettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ClientLibrarySettings message.
                 * @function verify
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ClientLibrarySettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.version != null && message.hasOwnProperty("version"))
                        if (!$util.isString(message.version))
                            return "version: string expected";
                    if (message.launchStage != null && message.hasOwnProperty("launchStage"))
                        switch (message.launchStage) {
                        default:
                            return "launchStage: enum value expected";
                        case 0:
                        case 6:
                        case 7:
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                            break;
                        }
                    if (message.restNumericEnums != null && message.hasOwnProperty("restNumericEnums"))
                        if (typeof message.restNumericEnums !== "boolean")
                            return "restNumericEnums: boolean expected";
                    if (message.javaSettings != null && message.hasOwnProperty("javaSettings")) {
                        var error = $root.google.api.JavaSettings.verify(message.javaSettings);
                        if (error)
                            return "javaSettings." + error;
                    }
                    if (message.cppSettings != null && message.hasOwnProperty("cppSettings")) {
                        var error = $root.google.api.CppSettings.verify(message.cppSettings);
                        if (error)
                            return "cppSettings." + error;
                    }
                    if (message.phpSettings != null && message.hasOwnProperty("phpSettings")) {
                        var error = $root.google.api.PhpSettings.verify(message.phpSettings);
                        if (error)
                            return "phpSettings." + error;
                    }
                    if (message.pythonSettings != null && message.hasOwnProperty("pythonSettings")) {
                        var error = $root.google.api.PythonSettings.verify(message.pythonSettings);
                        if (error)
                            return "pythonSettings." + error;
                    }
                    if (message.nodeSettings != null && message.hasOwnProperty("nodeSettings")) {
                        var error = $root.google.api.NodeSettings.verify(message.nodeSettings);
                        if (error)
                            return "nodeSettings." + error;
                    }
                    if (message.dotnetSettings != null && message.hasOwnProperty("dotnetSettings")) {
                        var error = $root.google.api.DotnetSettings.verify(message.dotnetSettings);
                        if (error)
                            return "dotnetSettings." + error;
                    }
                    if (message.rubySettings != null && message.hasOwnProperty("rubySettings")) {
                        var error = $root.google.api.RubySettings.verify(message.rubySettings);
                        if (error)
                            return "rubySettings." + error;
                    }
                    if (message.goSettings != null && message.hasOwnProperty("goSettings")) {
                        var error = $root.google.api.GoSettings.verify(message.goSettings);
                        if (error)
                            return "goSettings." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a ClientLibrarySettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.ClientLibrarySettings} ClientLibrarySettings
                 */
                ClientLibrarySettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.ClientLibrarySettings)
                        return object;
                    var message = new $root.google.api.ClientLibrarySettings();
                    if (object.version != null)
                        message.version = String(object.version);
                    switch (object.launchStage) {
                    default:
                        if (typeof object.launchStage === "number") {
                            message.launchStage = object.launchStage;
                            break;
                        }
                        break;
                    case "LAUNCH_STAGE_UNSPECIFIED":
                    case 0:
                        message.launchStage = 0;
                        break;
                    case "UNIMPLEMENTED":
                    case 6:
                        message.launchStage = 6;
                        break;
                    case "PRELAUNCH":
                    case 7:
                        message.launchStage = 7;
                        break;
                    case "EARLY_ACCESS":
                    case 1:
                        message.launchStage = 1;
                        break;
                    case "ALPHA":
                    case 2:
                        message.launchStage = 2;
                        break;
                    case "BETA":
                    case 3:
                        message.launchStage = 3;
                        break;
                    case "GA":
                    case 4:
                        message.launchStage = 4;
                        break;
                    case "DEPRECATED":
                    case 5:
                        message.launchStage = 5;
                        break;
                    }
                    if (object.restNumericEnums != null)
                        message.restNumericEnums = Boolean(object.restNumericEnums);
                    if (object.javaSettings != null) {
                        if (typeof object.javaSettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.javaSettings: object expected");
                        message.javaSettings = $root.google.api.JavaSettings.fromObject(object.javaSettings);
                    }
                    if (object.cppSettings != null) {
                        if (typeof object.cppSettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.cppSettings: object expected");
                        message.cppSettings = $root.google.api.CppSettings.fromObject(object.cppSettings);
                    }
                    if (object.phpSettings != null) {
                        if (typeof object.phpSettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.phpSettings: object expected");
                        message.phpSettings = $root.google.api.PhpSettings.fromObject(object.phpSettings);
                    }
                    if (object.pythonSettings != null) {
                        if (typeof object.pythonSettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.pythonSettings: object expected");
                        message.pythonSettings = $root.google.api.PythonSettings.fromObject(object.pythonSettings);
                    }
                    if (object.nodeSettings != null) {
                        if (typeof object.nodeSettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.nodeSettings: object expected");
                        message.nodeSettings = $root.google.api.NodeSettings.fromObject(object.nodeSettings);
                    }
                    if (object.dotnetSettings != null) {
                        if (typeof object.dotnetSettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.dotnetSettings: object expected");
                        message.dotnetSettings = $root.google.api.DotnetSettings.fromObject(object.dotnetSettings);
                    }
                    if (object.rubySettings != null) {
                        if (typeof object.rubySettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.rubySettings: object expected");
                        message.rubySettings = $root.google.api.RubySettings.fromObject(object.rubySettings);
                    }
                    if (object.goSettings != null) {
                        if (typeof object.goSettings !== "object")
                            throw TypeError(".google.api.ClientLibrarySettings.goSettings: object expected");
                        message.goSettings = $root.google.api.GoSettings.fromObject(object.goSettings);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a ClientLibrarySettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {google.api.ClientLibrarySettings} message ClientLibrarySettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ClientLibrarySettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.version = "";
                        object.launchStage = options.enums === String ? "LAUNCH_STAGE_UNSPECIFIED" : 0;
                        object.restNumericEnums = false;
                        object.javaSettings = null;
                        object.cppSettings = null;
                        object.phpSettings = null;
                        object.pythonSettings = null;
                        object.nodeSettings = null;
                        object.dotnetSettings = null;
                        object.rubySettings = null;
                        object.goSettings = null;
                    }
                    if (message.version != null && message.hasOwnProperty("version"))
                        object.version = message.version;
                    if (message.launchStage != null && message.hasOwnProperty("launchStage"))
                        object.launchStage = options.enums === String ? $root.google.api.LaunchStage[message.launchStage] === undefined ? message.launchStage : $root.google.api.LaunchStage[message.launchStage] : message.launchStage;
                    if (message.restNumericEnums != null && message.hasOwnProperty("restNumericEnums"))
                        object.restNumericEnums = message.restNumericEnums;
                    if (message.javaSettings != null && message.hasOwnProperty("javaSettings"))
                        object.javaSettings = $root.google.api.JavaSettings.toObject(message.javaSettings, options);
                    if (message.cppSettings != null && message.hasOwnProperty("cppSettings"))
                        object.cppSettings = $root.google.api.CppSettings.toObject(message.cppSettings, options);
                    if (message.phpSettings != null && message.hasOwnProperty("phpSettings"))
                        object.phpSettings = $root.google.api.PhpSettings.toObject(message.phpSettings, options);
                    if (message.pythonSettings != null && message.hasOwnProperty("pythonSettings"))
                        object.pythonSettings = $root.google.api.PythonSettings.toObject(message.pythonSettings, options);
                    if (message.nodeSettings != null && message.hasOwnProperty("nodeSettings"))
                        object.nodeSettings = $root.google.api.NodeSettings.toObject(message.nodeSettings, options);
                    if (message.dotnetSettings != null && message.hasOwnProperty("dotnetSettings"))
                        object.dotnetSettings = $root.google.api.DotnetSettings.toObject(message.dotnetSettings, options);
                    if (message.rubySettings != null && message.hasOwnProperty("rubySettings"))
                        object.rubySettings = $root.google.api.RubySettings.toObject(message.rubySettings, options);
                    if (message.goSettings != null && message.hasOwnProperty("goSettings"))
                        object.goSettings = $root.google.api.GoSettings.toObject(message.goSettings, options);
                    return object;
                };
    
                /**
                 * Converts this ClientLibrarySettings to JSON.
                 * @function toJSON
                 * @memberof google.api.ClientLibrarySettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ClientLibrarySettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ClientLibrarySettings
                 * @function getTypeUrl
                 * @memberof google.api.ClientLibrarySettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ClientLibrarySettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.ClientLibrarySettings";
                };
    
                return ClientLibrarySettings;
            })();
    
            api.Publishing = (function() {
    
                /**
                 * Properties of a Publishing.
                 * @memberof google.api
                 * @interface IPublishing
                 * @property {Array.<google.api.IMethodSettings>|null} [methodSettings] Publishing methodSettings
                 * @property {string|null} [newIssueUri] Publishing newIssueUri
                 * @property {string|null} [documentationUri] Publishing documentationUri
                 * @property {string|null} [apiShortName] Publishing apiShortName
                 * @property {string|null} [githubLabel] Publishing githubLabel
                 * @property {Array.<string>|null} [codeownerGithubTeams] Publishing codeownerGithubTeams
                 * @property {string|null} [docTagPrefix] Publishing docTagPrefix
                 * @property {google.api.ClientLibraryOrganization|null} [organization] Publishing organization
                 * @property {Array.<google.api.IClientLibrarySettings>|null} [librarySettings] Publishing librarySettings
                 */
    
                /**
                 * Constructs a new Publishing.
                 * @memberof google.api
                 * @classdesc Represents a Publishing.
                 * @implements IPublishing
                 * @constructor
                 * @param {google.api.IPublishing=} [properties] Properties to set
                 */
                function Publishing(properties) {
                    this.methodSettings = [];
                    this.codeownerGithubTeams = [];
                    this.librarySettings = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Publishing methodSettings.
                 * @member {Array.<google.api.IMethodSettings>} methodSettings
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.methodSettings = $util.emptyArray;
    
                /**
                 * Publishing newIssueUri.
                 * @member {string} newIssueUri
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.newIssueUri = "";
    
                /**
                 * Publishing documentationUri.
                 * @member {string} documentationUri
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.documentationUri = "";
    
                /**
                 * Publishing apiShortName.
                 * @member {string} apiShortName
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.apiShortName = "";
    
                /**
                 * Publishing githubLabel.
                 * @member {string} githubLabel
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.githubLabel = "";
    
                /**
                 * Publishing codeownerGithubTeams.
                 * @member {Array.<string>} codeownerGithubTeams
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.codeownerGithubTeams = $util.emptyArray;
    
                /**
                 * Publishing docTagPrefix.
                 * @member {string} docTagPrefix
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.docTagPrefix = "";
    
                /**
                 * Publishing organization.
                 * @member {google.api.ClientLibraryOrganization} organization
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.organization = 0;
    
                /**
                 * Publishing librarySettings.
                 * @member {Array.<google.api.IClientLibrarySettings>} librarySettings
                 * @memberof google.api.Publishing
                 * @instance
                 */
                Publishing.prototype.librarySettings = $util.emptyArray;
    
                /**
                 * Creates a new Publishing instance using the specified properties.
                 * @function create
                 * @memberof google.api.Publishing
                 * @static
                 * @param {google.api.IPublishing=} [properties] Properties to set
                 * @returns {google.api.Publishing} Publishing instance
                 */
                Publishing.create = function create(properties) {
                    return new Publishing(properties);
                };
    
                /**
                 * Encodes the specified Publishing message. Does not implicitly {@link google.api.Publishing.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.Publishing
                 * @static
                 * @param {google.api.IPublishing} message Publishing message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Publishing.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.methodSettings != null && message.methodSettings.length)
                        for (var i = 0; i < message.methodSettings.length; ++i)
                            $root.google.api.MethodSettings.encode(message.methodSettings[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.newIssueUri != null && Object.hasOwnProperty.call(message, "newIssueUri"))
                        writer.uint32(/* id 101, wireType 2 =*/810).string(message.newIssueUri);
                    if (message.documentationUri != null && Object.hasOwnProperty.call(message, "documentationUri"))
                        writer.uint32(/* id 102, wireType 2 =*/818).string(message.documentationUri);
                    if (message.apiShortName != null && Object.hasOwnProperty.call(message, "apiShortName"))
                        writer.uint32(/* id 103, wireType 2 =*/826).string(message.apiShortName);
                    if (message.githubLabel != null && Object.hasOwnProperty.call(message, "githubLabel"))
                        writer.uint32(/* id 104, wireType 2 =*/834).string(message.githubLabel);
                    if (message.codeownerGithubTeams != null && message.codeownerGithubTeams.length)
                        for (var i = 0; i < message.codeownerGithubTeams.length; ++i)
                            writer.uint32(/* id 105, wireType 2 =*/842).string(message.codeownerGithubTeams[i]);
                    if (message.docTagPrefix != null && Object.hasOwnProperty.call(message, "docTagPrefix"))
                        writer.uint32(/* id 106, wireType 2 =*/850).string(message.docTagPrefix);
                    if (message.organization != null && Object.hasOwnProperty.call(message, "organization"))
                        writer.uint32(/* id 107, wireType 0 =*/856).int32(message.organization);
                    if (message.librarySettings != null && message.librarySettings.length)
                        for (var i = 0; i < message.librarySettings.length; ++i)
                            $root.google.api.ClientLibrarySettings.encode(message.librarySettings[i], writer.uint32(/* id 109, wireType 2 =*/874).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified Publishing message, length delimited. Does not implicitly {@link google.api.Publishing.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.Publishing
                 * @static
                 * @param {google.api.IPublishing} message Publishing message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Publishing.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a Publishing message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.Publishing
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.Publishing} Publishing
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Publishing.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.Publishing();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 2: {
                                if (!(message.methodSettings && message.methodSettings.length))
                                    message.methodSettings = [];
                                message.methodSettings.push($root.google.api.MethodSettings.decode(reader, reader.uint32()));
                                break;
                            }
                        case 101: {
                                message.newIssueUri = reader.string();
                                break;
                            }
                        case 102: {
                                message.documentationUri = reader.string();
                                break;
                            }
                        case 103: {
                                message.apiShortName = reader.string();
                                break;
                            }
                        case 104: {
                                message.githubLabel = reader.string();
                                break;
                            }
                        case 105: {
                                if (!(message.codeownerGithubTeams && message.codeownerGithubTeams.length))
                                    message.codeownerGithubTeams = [];
                                message.codeownerGithubTeams.push(reader.string());
                                break;
                            }
                        case 106: {
                                message.docTagPrefix = reader.string();
                                break;
                            }
                        case 107: {
                                message.organization = reader.int32();
                                break;
                            }
                        case 109: {
                                if (!(message.librarySettings && message.librarySettings.length))
                                    message.librarySettings = [];
                                message.librarySettings.push($root.google.api.ClientLibrarySettings.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a Publishing message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.Publishing
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.Publishing} Publishing
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Publishing.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a Publishing message.
                 * @function verify
                 * @memberof google.api.Publishing
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Publishing.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.methodSettings != null && message.hasOwnProperty("methodSettings")) {
                        if (!Array.isArray(message.methodSettings))
                            return "methodSettings: array expected";
                        for (var i = 0; i < message.methodSettings.length; ++i) {
                            var error = $root.google.api.MethodSettings.verify(message.methodSettings[i]);
                            if (error)
                                return "methodSettings." + error;
                        }
                    }
                    if (message.newIssueUri != null && message.hasOwnProperty("newIssueUri"))
                        if (!$util.isString(message.newIssueUri))
                            return "newIssueUri: string expected";
                    if (message.documentationUri != null && message.hasOwnProperty("documentationUri"))
                        if (!$util.isString(message.documentationUri))
                            return "documentationUri: string expected";
                    if (message.apiShortName != null && message.hasOwnProperty("apiShortName"))
                        if (!$util.isString(message.apiShortName))
                            return "apiShortName: string expected";
                    if (message.githubLabel != null && message.hasOwnProperty("githubLabel"))
                        if (!$util.isString(message.githubLabel))
                            return "githubLabel: string expected";
                    if (message.codeownerGithubTeams != null && message.hasOwnProperty("codeownerGithubTeams")) {
                        if (!Array.isArray(message.codeownerGithubTeams))
                            return "codeownerGithubTeams: array expected";
                        for (var i = 0; i < message.codeownerGithubTeams.length; ++i)
                            if (!$util.isString(message.codeownerGithubTeams[i]))
                                return "codeownerGithubTeams: string[] expected";
                    }
                    if (message.docTagPrefix != null && message.hasOwnProperty("docTagPrefix"))
                        if (!$util.isString(message.docTagPrefix))
                            return "docTagPrefix: string expected";
                    if (message.organization != null && message.hasOwnProperty("organization"))
                        switch (message.organization) {
                        default:
                            return "organization: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                            break;
                        }
                    if (message.librarySettings != null && message.hasOwnProperty("librarySettings")) {
                        if (!Array.isArray(message.librarySettings))
                            return "librarySettings: array expected";
                        for (var i = 0; i < message.librarySettings.length; ++i) {
                            var error = $root.google.api.ClientLibrarySettings.verify(message.librarySettings[i]);
                            if (error)
                                return "librarySettings." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a Publishing message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.Publishing
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.Publishing} Publishing
                 */
                Publishing.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.Publishing)
                        return object;
                    var message = new $root.google.api.Publishing();
                    if (object.methodSettings) {
                        if (!Array.isArray(object.methodSettings))
                            throw TypeError(".google.api.Publishing.methodSettings: array expected");
                        message.methodSettings = [];
                        for (var i = 0; i < object.methodSettings.length; ++i) {
                            if (typeof object.methodSettings[i] !== "object")
                                throw TypeError(".google.api.Publishing.methodSettings: object expected");
                            message.methodSettings[i] = $root.google.api.MethodSettings.fromObject(object.methodSettings[i]);
                        }
                    }
                    if (object.newIssueUri != null)
                        message.newIssueUri = String(object.newIssueUri);
                    if (object.documentationUri != null)
                        message.documentationUri = String(object.documentationUri);
                    if (object.apiShortName != null)
                        message.apiShortName = String(object.apiShortName);
                    if (object.githubLabel != null)
                        message.githubLabel = String(object.githubLabel);
                    if (object.codeownerGithubTeams) {
                        if (!Array.isArray(object.codeownerGithubTeams))
                            throw TypeError(".google.api.Publishing.codeownerGithubTeams: array expected");
                        message.codeownerGithubTeams = [];
                        for (var i = 0; i < object.codeownerGithubTeams.length; ++i)
                            message.codeownerGithubTeams[i] = String(object.codeownerGithubTeams[i]);
                    }
                    if (object.docTagPrefix != null)
                        message.docTagPrefix = String(object.docTagPrefix);
                    switch (object.organization) {
                    default:
                        if (typeof object.organization === "number") {
                            message.organization = object.organization;
                            break;
                        }
                        break;
                    case "CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED":
                    case 0:
                        message.organization = 0;
                        break;
                    case "CLOUD":
                    case 1:
                        message.organization = 1;
                        break;
                    case "ADS":
                    case 2:
                        message.organization = 2;
                        break;
                    case "PHOTOS":
                    case 3:
                        message.organization = 3;
                        break;
                    case "STREET_VIEW":
                    case 4:
                        message.organization = 4;
                        break;
                    }
                    if (object.librarySettings) {
                        if (!Array.isArray(object.librarySettings))
                            throw TypeError(".google.api.Publishing.librarySettings: array expected");
                        message.librarySettings = [];
                        for (var i = 0; i < object.librarySettings.length; ++i) {
                            if (typeof object.librarySettings[i] !== "object")
                                throw TypeError(".google.api.Publishing.librarySettings: object expected");
                            message.librarySettings[i] = $root.google.api.ClientLibrarySettings.fromObject(object.librarySettings[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a Publishing message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.Publishing
                 * @static
                 * @param {google.api.Publishing} message Publishing
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Publishing.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.methodSettings = [];
                        object.codeownerGithubTeams = [];
                        object.librarySettings = [];
                    }
                    if (options.defaults) {
                        object.newIssueUri = "";
                        object.documentationUri = "";
                        object.apiShortName = "";
                        object.githubLabel = "";
                        object.docTagPrefix = "";
                        object.organization = options.enums === String ? "CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED" : 0;
                    }
                    if (message.methodSettings && message.methodSettings.length) {
                        object.methodSettings = [];
                        for (var j = 0; j < message.methodSettings.length; ++j)
                            object.methodSettings[j] = $root.google.api.MethodSettings.toObject(message.methodSettings[j], options);
                    }
                    if (message.newIssueUri != null && message.hasOwnProperty("newIssueUri"))
                        object.newIssueUri = message.newIssueUri;
                    if (message.documentationUri != null && message.hasOwnProperty("documentationUri"))
                        object.documentationUri = message.documentationUri;
                    if (message.apiShortName != null && message.hasOwnProperty("apiShortName"))
                        object.apiShortName = message.apiShortName;
                    if (message.githubLabel != null && message.hasOwnProperty("githubLabel"))
                        object.githubLabel = message.githubLabel;
                    if (message.codeownerGithubTeams && message.codeownerGithubTeams.length) {
                        object.codeownerGithubTeams = [];
                        for (var j = 0; j < message.codeownerGithubTeams.length; ++j)
                            object.codeownerGithubTeams[j] = message.codeownerGithubTeams[j];
                    }
                    if (message.docTagPrefix != null && message.hasOwnProperty("docTagPrefix"))
                        object.docTagPrefix = message.docTagPrefix;
                    if (message.organization != null && message.hasOwnProperty("organization"))
                        object.organization = options.enums === String ? $root.google.api.ClientLibraryOrganization[message.organization] === undefined ? message.organization : $root.google.api.ClientLibraryOrganization[message.organization] : message.organization;
                    if (message.librarySettings && message.librarySettings.length) {
                        object.librarySettings = [];
                        for (var j = 0; j < message.librarySettings.length; ++j)
                            object.librarySettings[j] = $root.google.api.ClientLibrarySettings.toObject(message.librarySettings[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this Publishing to JSON.
                 * @function toJSON
                 * @memberof google.api.Publishing
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Publishing.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Publishing
                 * @function getTypeUrl
                 * @memberof google.api.Publishing
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Publishing.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.Publishing";
                };
    
                return Publishing;
            })();
    
            api.JavaSettings = (function() {
    
                /**
                 * Properties of a JavaSettings.
                 * @memberof google.api
                 * @interface IJavaSettings
                 * @property {string|null} [libraryPackage] JavaSettings libraryPackage
                 * @property {Object.<string,string>|null} [serviceClassNames] JavaSettings serviceClassNames
                 * @property {google.api.ICommonLanguageSettings|null} [common] JavaSettings common
                 */
    
                /**
                 * Constructs a new JavaSettings.
                 * @memberof google.api
                 * @classdesc Represents a JavaSettings.
                 * @implements IJavaSettings
                 * @constructor
                 * @param {google.api.IJavaSettings=} [properties] Properties to set
                 */
                function JavaSettings(properties) {
                    this.serviceClassNames = {};
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * JavaSettings libraryPackage.
                 * @member {string} libraryPackage
                 * @memberof google.api.JavaSettings
                 * @instance
                 */
                JavaSettings.prototype.libraryPackage = "";
    
                /**
                 * JavaSettings serviceClassNames.
                 * @member {Object.<string,string>} serviceClassNames
                 * @memberof google.api.JavaSettings
                 * @instance
                 */
                JavaSettings.prototype.serviceClassNames = $util.emptyObject;
    
                /**
                 * JavaSettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.JavaSettings
                 * @instance
                 */
                JavaSettings.prototype.common = null;
    
                /**
                 * Creates a new JavaSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {google.api.IJavaSettings=} [properties] Properties to set
                 * @returns {google.api.JavaSettings} JavaSettings instance
                 */
                JavaSettings.create = function create(properties) {
                    return new JavaSettings(properties);
                };
    
                /**
                 * Encodes the specified JavaSettings message. Does not implicitly {@link google.api.JavaSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {google.api.IJavaSettings} message JavaSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                JavaSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.libraryPackage != null && Object.hasOwnProperty.call(message, "libraryPackage"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.libraryPackage);
                    if (message.serviceClassNames != null && Object.hasOwnProperty.call(message, "serviceClassNames"))
                        for (var keys = Object.keys(message.serviceClassNames), i = 0; i < keys.length; ++i)
                            writer.uint32(/* id 2, wireType 2 =*/18).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.serviceClassNames[keys[i]]).ldelim();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified JavaSettings message, length delimited. Does not implicitly {@link google.api.JavaSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {google.api.IJavaSettings} message JavaSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                JavaSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a JavaSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.JavaSettings} JavaSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                JavaSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.JavaSettings(), key, value;
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.libraryPackage = reader.string();
                                break;
                            }
                        case 2: {
                                if (message.serviceClassNames === $util.emptyObject)
                                    message.serviceClassNames = {};
                                var end2 = reader.uint32() + reader.pos;
                                key = "";
                                value = "";
                                while (reader.pos < end2) {
                                    var tag2 = reader.uint32();
                                    switch (tag2 >>> 3) {
                                    case 1:
                                        key = reader.string();
                                        break;
                                    case 2:
                                        value = reader.string();
                                        break;
                                    default:
                                        reader.skipType(tag2 & 7);
                                        break;
                                    }
                                }
                                message.serviceClassNames[key] = value;
                                break;
                            }
                        case 3: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a JavaSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.JavaSettings} JavaSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                JavaSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a JavaSettings message.
                 * @function verify
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                JavaSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.libraryPackage != null && message.hasOwnProperty("libraryPackage"))
                        if (!$util.isString(message.libraryPackage))
                            return "libraryPackage: string expected";
                    if (message.serviceClassNames != null && message.hasOwnProperty("serviceClassNames")) {
                        if (!$util.isObject(message.serviceClassNames))
                            return "serviceClassNames: object expected";
                        var key = Object.keys(message.serviceClassNames);
                        for (var i = 0; i < key.length; ++i)
                            if (!$util.isString(message.serviceClassNames[key[i]]))
                                return "serviceClassNames: string{k:string} expected";
                    }
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a JavaSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.JavaSettings} JavaSettings
                 */
                JavaSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.JavaSettings)
                        return object;
                    var message = new $root.google.api.JavaSettings();
                    if (object.libraryPackage != null)
                        message.libraryPackage = String(object.libraryPackage);
                    if (object.serviceClassNames) {
                        if (typeof object.serviceClassNames !== "object")
                            throw TypeError(".google.api.JavaSettings.serviceClassNames: object expected");
                        message.serviceClassNames = {};
                        for (var keys = Object.keys(object.serviceClassNames), i = 0; i < keys.length; ++i)
                            message.serviceClassNames[keys[i]] = String(object.serviceClassNames[keys[i]]);
                    }
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.JavaSettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a JavaSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {google.api.JavaSettings} message JavaSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                JavaSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.objects || options.defaults)
                        object.serviceClassNames = {};
                    if (options.defaults) {
                        object.libraryPackage = "";
                        object.common = null;
                    }
                    if (message.libraryPackage != null && message.hasOwnProperty("libraryPackage"))
                        object.libraryPackage = message.libraryPackage;
                    var keys2;
                    if (message.serviceClassNames && (keys2 = Object.keys(message.serviceClassNames)).length) {
                        object.serviceClassNames = {};
                        for (var j = 0; j < keys2.length; ++j)
                            object.serviceClassNames[keys2[j]] = message.serviceClassNames[keys2[j]];
                    }
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this JavaSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.JavaSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                JavaSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for JavaSettings
                 * @function getTypeUrl
                 * @memberof google.api.JavaSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                JavaSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.JavaSettings";
                };
    
                return JavaSettings;
            })();
    
            api.CppSettings = (function() {
    
                /**
                 * Properties of a CppSettings.
                 * @memberof google.api
                 * @interface ICppSettings
                 * @property {google.api.ICommonLanguageSettings|null} [common] CppSettings common
                 */
    
                /**
                 * Constructs a new CppSettings.
                 * @memberof google.api
                 * @classdesc Represents a CppSettings.
                 * @implements ICppSettings
                 * @constructor
                 * @param {google.api.ICppSettings=} [properties] Properties to set
                 */
                function CppSettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * CppSettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.CppSettings
                 * @instance
                 */
                CppSettings.prototype.common = null;
    
                /**
                 * Creates a new CppSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {google.api.ICppSettings=} [properties] Properties to set
                 * @returns {google.api.CppSettings} CppSettings instance
                 */
                CppSettings.create = function create(properties) {
                    return new CppSettings(properties);
                };
    
                /**
                 * Encodes the specified CppSettings message. Does not implicitly {@link google.api.CppSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {google.api.ICppSettings} message CppSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CppSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified CppSettings message, length delimited. Does not implicitly {@link google.api.CppSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {google.api.ICppSettings} message CppSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CppSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a CppSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.CppSettings} CppSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CppSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.CppSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a CppSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.CppSettings} CppSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CppSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a CppSettings message.
                 * @function verify
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                CppSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a CppSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.CppSettings} CppSettings
                 */
                CppSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.CppSettings)
                        return object;
                    var message = new $root.google.api.CppSettings();
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.CppSettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a CppSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {google.api.CppSettings} message CppSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                CppSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.common = null;
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this CppSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.CppSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                CppSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for CppSettings
                 * @function getTypeUrl
                 * @memberof google.api.CppSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                CppSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.CppSettings";
                };
    
                return CppSettings;
            })();
    
            api.PhpSettings = (function() {
    
                /**
                 * Properties of a PhpSettings.
                 * @memberof google.api
                 * @interface IPhpSettings
                 * @property {google.api.ICommonLanguageSettings|null} [common] PhpSettings common
                 */
    
                /**
                 * Constructs a new PhpSettings.
                 * @memberof google.api
                 * @classdesc Represents a PhpSettings.
                 * @implements IPhpSettings
                 * @constructor
                 * @param {google.api.IPhpSettings=} [properties] Properties to set
                 */
                function PhpSettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * PhpSettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.PhpSettings
                 * @instance
                 */
                PhpSettings.prototype.common = null;
    
                /**
                 * Creates a new PhpSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {google.api.IPhpSettings=} [properties] Properties to set
                 * @returns {google.api.PhpSettings} PhpSettings instance
                 */
                PhpSettings.create = function create(properties) {
                    return new PhpSettings(properties);
                };
    
                /**
                 * Encodes the specified PhpSettings message. Does not implicitly {@link google.api.PhpSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {google.api.IPhpSettings} message PhpSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                PhpSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified PhpSettings message, length delimited. Does not implicitly {@link google.api.PhpSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {google.api.IPhpSettings} message PhpSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                PhpSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a PhpSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.PhpSettings} PhpSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                PhpSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.PhpSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a PhpSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.PhpSettings} PhpSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                PhpSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a PhpSettings message.
                 * @function verify
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                PhpSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a PhpSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.PhpSettings} PhpSettings
                 */
                PhpSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.PhpSettings)
                        return object;
                    var message = new $root.google.api.PhpSettings();
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.PhpSettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a PhpSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {google.api.PhpSettings} message PhpSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                PhpSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.common = null;
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this PhpSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.PhpSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                PhpSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for PhpSettings
                 * @function getTypeUrl
                 * @memberof google.api.PhpSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                PhpSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.PhpSettings";
                };
    
                return PhpSettings;
            })();
    
            api.PythonSettings = (function() {
    
                /**
                 * Properties of a PythonSettings.
                 * @memberof google.api
                 * @interface IPythonSettings
                 * @property {google.api.ICommonLanguageSettings|null} [common] PythonSettings common
                 */
    
                /**
                 * Constructs a new PythonSettings.
                 * @memberof google.api
                 * @classdesc Represents a PythonSettings.
                 * @implements IPythonSettings
                 * @constructor
                 * @param {google.api.IPythonSettings=} [properties] Properties to set
                 */
                function PythonSettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * PythonSettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.PythonSettings
                 * @instance
                 */
                PythonSettings.prototype.common = null;
    
                /**
                 * Creates a new PythonSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {google.api.IPythonSettings=} [properties] Properties to set
                 * @returns {google.api.PythonSettings} PythonSettings instance
                 */
                PythonSettings.create = function create(properties) {
                    return new PythonSettings(properties);
                };
    
                /**
                 * Encodes the specified PythonSettings message. Does not implicitly {@link google.api.PythonSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {google.api.IPythonSettings} message PythonSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                PythonSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified PythonSettings message, length delimited. Does not implicitly {@link google.api.PythonSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {google.api.IPythonSettings} message PythonSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                PythonSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a PythonSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.PythonSettings} PythonSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                PythonSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.PythonSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a PythonSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.PythonSettings} PythonSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                PythonSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a PythonSettings message.
                 * @function verify
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                PythonSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a PythonSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.PythonSettings} PythonSettings
                 */
                PythonSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.PythonSettings)
                        return object;
                    var message = new $root.google.api.PythonSettings();
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.PythonSettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a PythonSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {google.api.PythonSettings} message PythonSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                PythonSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.common = null;
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this PythonSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.PythonSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                PythonSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for PythonSettings
                 * @function getTypeUrl
                 * @memberof google.api.PythonSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                PythonSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.PythonSettings";
                };
    
                return PythonSettings;
            })();
    
            api.NodeSettings = (function() {
    
                /**
                 * Properties of a NodeSettings.
                 * @memberof google.api
                 * @interface INodeSettings
                 * @property {google.api.ICommonLanguageSettings|null} [common] NodeSettings common
                 */
    
                /**
                 * Constructs a new NodeSettings.
                 * @memberof google.api
                 * @classdesc Represents a NodeSettings.
                 * @implements INodeSettings
                 * @constructor
                 * @param {google.api.INodeSettings=} [properties] Properties to set
                 */
                function NodeSettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * NodeSettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.NodeSettings
                 * @instance
                 */
                NodeSettings.prototype.common = null;
    
                /**
                 * Creates a new NodeSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {google.api.INodeSettings=} [properties] Properties to set
                 * @returns {google.api.NodeSettings} NodeSettings instance
                 */
                NodeSettings.create = function create(properties) {
                    return new NodeSettings(properties);
                };
    
                /**
                 * Encodes the specified NodeSettings message. Does not implicitly {@link google.api.NodeSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {google.api.INodeSettings} message NodeSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                NodeSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified NodeSettings message, length delimited. Does not implicitly {@link google.api.NodeSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {google.api.INodeSettings} message NodeSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                NodeSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a NodeSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.NodeSettings} NodeSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                NodeSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.NodeSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a NodeSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.NodeSettings} NodeSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                NodeSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a NodeSettings message.
                 * @function verify
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                NodeSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a NodeSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.NodeSettings} NodeSettings
                 */
                NodeSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.NodeSettings)
                        return object;
                    var message = new $root.google.api.NodeSettings();
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.NodeSettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a NodeSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {google.api.NodeSettings} message NodeSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                NodeSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.common = null;
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this NodeSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.NodeSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                NodeSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for NodeSettings
                 * @function getTypeUrl
                 * @memberof google.api.NodeSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                NodeSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.NodeSettings";
                };
    
                return NodeSettings;
            })();
    
            api.DotnetSettings = (function() {
    
                /**
                 * Properties of a DotnetSettings.
                 * @memberof google.api
                 * @interface IDotnetSettings
                 * @property {google.api.ICommonLanguageSettings|null} [common] DotnetSettings common
                 */
    
                /**
                 * Constructs a new DotnetSettings.
                 * @memberof google.api
                 * @classdesc Represents a DotnetSettings.
                 * @implements IDotnetSettings
                 * @constructor
                 * @param {google.api.IDotnetSettings=} [properties] Properties to set
                 */
                function DotnetSettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * DotnetSettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.DotnetSettings
                 * @instance
                 */
                DotnetSettings.prototype.common = null;
    
                /**
                 * Creates a new DotnetSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {google.api.IDotnetSettings=} [properties] Properties to set
                 * @returns {google.api.DotnetSettings} DotnetSettings instance
                 */
                DotnetSettings.create = function create(properties) {
                    return new DotnetSettings(properties);
                };
    
                /**
                 * Encodes the specified DotnetSettings message. Does not implicitly {@link google.api.DotnetSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {google.api.IDotnetSettings} message DotnetSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DotnetSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified DotnetSettings message, length delimited. Does not implicitly {@link google.api.DotnetSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {google.api.IDotnetSettings} message DotnetSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DotnetSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a DotnetSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.DotnetSettings} DotnetSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DotnetSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.DotnetSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a DotnetSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.DotnetSettings} DotnetSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DotnetSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a DotnetSettings message.
                 * @function verify
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                DotnetSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a DotnetSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.DotnetSettings} DotnetSettings
                 */
                DotnetSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.DotnetSettings)
                        return object;
                    var message = new $root.google.api.DotnetSettings();
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.DotnetSettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a DotnetSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {google.api.DotnetSettings} message DotnetSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                DotnetSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.common = null;
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this DotnetSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.DotnetSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                DotnetSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for DotnetSettings
                 * @function getTypeUrl
                 * @memberof google.api.DotnetSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                DotnetSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.DotnetSettings";
                };
    
                return DotnetSettings;
            })();
    
            api.RubySettings = (function() {
    
                /**
                 * Properties of a RubySettings.
                 * @memberof google.api
                 * @interface IRubySettings
                 * @property {google.api.ICommonLanguageSettings|null} [common] RubySettings common
                 */
    
                /**
                 * Constructs a new RubySettings.
                 * @memberof google.api
                 * @classdesc Represents a RubySettings.
                 * @implements IRubySettings
                 * @constructor
                 * @param {google.api.IRubySettings=} [properties] Properties to set
                 */
                function RubySettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * RubySettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.RubySettings
                 * @instance
                 */
                RubySettings.prototype.common = null;
    
                /**
                 * Creates a new RubySettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {google.api.IRubySettings=} [properties] Properties to set
                 * @returns {google.api.RubySettings} RubySettings instance
                 */
                RubySettings.create = function create(properties) {
                    return new RubySettings(properties);
                };
    
                /**
                 * Encodes the specified RubySettings message. Does not implicitly {@link google.api.RubySettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {google.api.IRubySettings} message RubySettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                RubySettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified RubySettings message, length delimited. Does not implicitly {@link google.api.RubySettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {google.api.IRubySettings} message RubySettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                RubySettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a RubySettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.RubySettings} RubySettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                RubySettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.RubySettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a RubySettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.RubySettings} RubySettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                RubySettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a RubySettings message.
                 * @function verify
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                RubySettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a RubySettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.RubySettings} RubySettings
                 */
                RubySettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.RubySettings)
                        return object;
                    var message = new $root.google.api.RubySettings();
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.RubySettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a RubySettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {google.api.RubySettings} message RubySettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                RubySettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.common = null;
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this RubySettings to JSON.
                 * @function toJSON
                 * @memberof google.api.RubySettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                RubySettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for RubySettings
                 * @function getTypeUrl
                 * @memberof google.api.RubySettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                RubySettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.RubySettings";
                };
    
                return RubySettings;
            })();
    
            api.GoSettings = (function() {
    
                /**
                 * Properties of a GoSettings.
                 * @memberof google.api
                 * @interface IGoSettings
                 * @property {google.api.ICommonLanguageSettings|null} [common] GoSettings common
                 */
    
                /**
                 * Constructs a new GoSettings.
                 * @memberof google.api
                 * @classdesc Represents a GoSettings.
                 * @implements IGoSettings
                 * @constructor
                 * @param {google.api.IGoSettings=} [properties] Properties to set
                 */
                function GoSettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * GoSettings common.
                 * @member {google.api.ICommonLanguageSettings|null|undefined} common
                 * @memberof google.api.GoSettings
                 * @instance
                 */
                GoSettings.prototype.common = null;
    
                /**
                 * Creates a new GoSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {google.api.IGoSettings=} [properties] Properties to set
                 * @returns {google.api.GoSettings} GoSettings instance
                 */
                GoSettings.create = function create(properties) {
                    return new GoSettings(properties);
                };
    
                /**
                 * Encodes the specified GoSettings message. Does not implicitly {@link google.api.GoSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {google.api.IGoSettings} message GoSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                GoSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.common != null && Object.hasOwnProperty.call(message, "common"))
                        $root.google.api.CommonLanguageSettings.encode(message.common, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified GoSettings message, length delimited. Does not implicitly {@link google.api.GoSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {google.api.IGoSettings} message GoSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                GoSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a GoSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.GoSettings} GoSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                GoSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.GoSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.common = $root.google.api.CommonLanguageSettings.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a GoSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.GoSettings} GoSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                GoSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a GoSettings message.
                 * @function verify
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                GoSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.common != null && message.hasOwnProperty("common")) {
                        var error = $root.google.api.CommonLanguageSettings.verify(message.common);
                        if (error)
                            return "common." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a GoSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.GoSettings} GoSettings
                 */
                GoSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.GoSettings)
                        return object;
                    var message = new $root.google.api.GoSettings();
                    if (object.common != null) {
                        if (typeof object.common !== "object")
                            throw TypeError(".google.api.GoSettings.common: object expected");
                        message.common = $root.google.api.CommonLanguageSettings.fromObject(object.common);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a GoSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {google.api.GoSettings} message GoSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                GoSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.common = null;
                    if (message.common != null && message.hasOwnProperty("common"))
                        object.common = $root.google.api.CommonLanguageSettings.toObject(message.common, options);
                    return object;
                };
    
                /**
                 * Converts this GoSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.GoSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                GoSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for GoSettings
                 * @function getTypeUrl
                 * @memberof google.api.GoSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                GoSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.GoSettings";
                };
    
                return GoSettings;
            })();
    
            api.MethodSettings = (function() {
    
                /**
                 * Properties of a MethodSettings.
                 * @memberof google.api
                 * @interface IMethodSettings
                 * @property {string|null} [selector] MethodSettings selector
                 * @property {google.api.MethodSettings.ILongRunning|null} [longRunning] MethodSettings longRunning
                 */
    
                /**
                 * Constructs a new MethodSettings.
                 * @memberof google.api
                 * @classdesc Represents a MethodSettings.
                 * @implements IMethodSettings
                 * @constructor
                 * @param {google.api.IMethodSettings=} [properties] Properties to set
                 */
                function MethodSettings(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * MethodSettings selector.
                 * @member {string} selector
                 * @memberof google.api.MethodSettings
                 * @instance
                 */
                MethodSettings.prototype.selector = "";
    
                /**
                 * MethodSettings longRunning.
                 * @member {google.api.MethodSettings.ILongRunning|null|undefined} longRunning
                 * @memberof google.api.MethodSettings
                 * @instance
                 */
                MethodSettings.prototype.longRunning = null;
    
                /**
                 * Creates a new MethodSettings instance using the specified properties.
                 * @function create
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {google.api.IMethodSettings=} [properties] Properties to set
                 * @returns {google.api.MethodSettings} MethodSettings instance
                 */
                MethodSettings.create = function create(properties) {
                    return new MethodSettings(properties);
                };
    
                /**
                 * Encodes the specified MethodSettings message. Does not implicitly {@link google.api.MethodSettings.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {google.api.IMethodSettings} message MethodSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodSettings.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.selector != null && Object.hasOwnProperty.call(message, "selector"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.selector);
                    if (message.longRunning != null && Object.hasOwnProperty.call(message, "longRunning"))
                        $root.google.api.MethodSettings.LongRunning.encode(message.longRunning, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified MethodSettings message, length delimited. Does not implicitly {@link google.api.MethodSettings.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {google.api.IMethodSettings} message MethodSettings message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodSettings.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a MethodSettings message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.MethodSettings} MethodSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodSettings.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.MethodSettings();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.selector = reader.string();
                                break;
                            }
                        case 2: {
                                message.longRunning = $root.google.api.MethodSettings.LongRunning.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a MethodSettings message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.MethodSettings} MethodSettings
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodSettings.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a MethodSettings message.
                 * @function verify
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                MethodSettings.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.selector != null && message.hasOwnProperty("selector"))
                        if (!$util.isString(message.selector))
                            return "selector: string expected";
                    if (message.longRunning != null && message.hasOwnProperty("longRunning")) {
                        var error = $root.google.api.MethodSettings.LongRunning.verify(message.longRunning);
                        if (error)
                            return "longRunning." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a MethodSettings message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.MethodSettings} MethodSettings
                 */
                MethodSettings.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.MethodSettings)
                        return object;
                    var message = new $root.google.api.MethodSettings();
                    if (object.selector != null)
                        message.selector = String(object.selector);
                    if (object.longRunning != null) {
                        if (typeof object.longRunning !== "object")
                            throw TypeError(".google.api.MethodSettings.longRunning: object expected");
                        message.longRunning = $root.google.api.MethodSettings.LongRunning.fromObject(object.longRunning);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a MethodSettings message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {google.api.MethodSettings} message MethodSettings
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                MethodSettings.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.selector = "";
                        object.longRunning = null;
                    }
                    if (message.selector != null && message.hasOwnProperty("selector"))
                        object.selector = message.selector;
                    if (message.longRunning != null && message.hasOwnProperty("longRunning"))
                        object.longRunning = $root.google.api.MethodSettings.LongRunning.toObject(message.longRunning, options);
                    return object;
                };
    
                /**
                 * Converts this MethodSettings to JSON.
                 * @function toJSON
                 * @memberof google.api.MethodSettings
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                MethodSettings.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for MethodSettings
                 * @function getTypeUrl
                 * @memberof google.api.MethodSettings
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                MethodSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.MethodSettings";
                };
    
                MethodSettings.LongRunning = (function() {
    
                    /**
                     * Properties of a LongRunning.
                     * @memberof google.api.MethodSettings
                     * @interface ILongRunning
                     * @property {google.protobuf.IDuration|null} [initialPollDelay] LongRunning initialPollDelay
                     * @property {number|null} [pollDelayMultiplier] LongRunning pollDelayMultiplier
                     * @property {google.protobuf.IDuration|null} [maxPollDelay] LongRunning maxPollDelay
                     * @property {google.protobuf.IDuration|null} [totalPollTimeout] LongRunning totalPollTimeout
                     */
    
                    /**
                     * Constructs a new LongRunning.
                     * @memberof google.api.MethodSettings
                     * @classdesc Represents a LongRunning.
                     * @implements ILongRunning
                     * @constructor
                     * @param {google.api.MethodSettings.ILongRunning=} [properties] Properties to set
                     */
                    function LongRunning(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * LongRunning initialPollDelay.
                     * @member {google.protobuf.IDuration|null|undefined} initialPollDelay
                     * @memberof google.api.MethodSettings.LongRunning
                     * @instance
                     */
                    LongRunning.prototype.initialPollDelay = null;
    
                    /**
                     * LongRunning pollDelayMultiplier.
                     * @member {number} pollDelayMultiplier
                     * @memberof google.api.MethodSettings.LongRunning
                     * @instance
                     */
                    LongRunning.prototype.pollDelayMultiplier = 0;
    
                    /**
                     * LongRunning maxPollDelay.
                     * @member {google.protobuf.IDuration|null|undefined} maxPollDelay
                     * @memberof google.api.MethodSettings.LongRunning
                     * @instance
                     */
                    LongRunning.prototype.maxPollDelay = null;
    
                    /**
                     * LongRunning totalPollTimeout.
                     * @member {google.protobuf.IDuration|null|undefined} totalPollTimeout
                     * @memberof google.api.MethodSettings.LongRunning
                     * @instance
                     */
                    LongRunning.prototype.totalPollTimeout = null;
    
                    /**
                     * Creates a new LongRunning instance using the specified properties.
                     * @function create
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {google.api.MethodSettings.ILongRunning=} [properties] Properties to set
                     * @returns {google.api.MethodSettings.LongRunning} LongRunning instance
                     */
                    LongRunning.create = function create(properties) {
                        return new LongRunning(properties);
                    };
    
                    /**
                     * Encodes the specified LongRunning message. Does not implicitly {@link google.api.MethodSettings.LongRunning.verify|verify} messages.
                     * @function encode
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {google.api.MethodSettings.ILongRunning} message LongRunning message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    LongRunning.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.initialPollDelay != null && Object.hasOwnProperty.call(message, "initialPollDelay"))
                            $root.google.protobuf.Duration.encode(message.initialPollDelay, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                        if (message.pollDelayMultiplier != null && Object.hasOwnProperty.call(message, "pollDelayMultiplier"))
                            writer.uint32(/* id 2, wireType 5 =*/21).float(message.pollDelayMultiplier);
                        if (message.maxPollDelay != null && Object.hasOwnProperty.call(message, "maxPollDelay"))
                            $root.google.protobuf.Duration.encode(message.maxPollDelay, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                        if (message.totalPollTimeout != null && Object.hasOwnProperty.call(message, "totalPollTimeout"))
                            $root.google.protobuf.Duration.encode(message.totalPollTimeout, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                        return writer;
                    };
    
                    /**
                     * Encodes the specified LongRunning message, length delimited. Does not implicitly {@link google.api.MethodSettings.LongRunning.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {google.api.MethodSettings.ILongRunning} message LongRunning message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    LongRunning.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a LongRunning message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.api.MethodSettings.LongRunning} LongRunning
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    LongRunning.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.MethodSettings.LongRunning();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.initialPollDelay = $root.google.protobuf.Duration.decode(reader, reader.uint32());
                                    break;
                                }
                            case 2: {
                                    message.pollDelayMultiplier = reader.float();
                                    break;
                                }
                            case 3: {
                                    message.maxPollDelay = $root.google.protobuf.Duration.decode(reader, reader.uint32());
                                    break;
                                }
                            case 4: {
                                    message.totalPollTimeout = $root.google.protobuf.Duration.decode(reader, reader.uint32());
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes a LongRunning message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.api.MethodSettings.LongRunning} LongRunning
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    LongRunning.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a LongRunning message.
                     * @function verify
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    LongRunning.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.initialPollDelay != null && message.hasOwnProperty("initialPollDelay")) {
                            var error = $root.google.protobuf.Duration.verify(message.initialPollDelay);
                            if (error)
                                return "initialPollDelay." + error;
                        }
                        if (message.pollDelayMultiplier != null && message.hasOwnProperty("pollDelayMultiplier"))
                            if (typeof message.pollDelayMultiplier !== "number")
                                return "pollDelayMultiplier: number expected";
                        if (message.maxPollDelay != null && message.hasOwnProperty("maxPollDelay")) {
                            var error = $root.google.protobuf.Duration.verify(message.maxPollDelay);
                            if (error)
                                return "maxPollDelay." + error;
                        }
                        if (message.totalPollTimeout != null && message.hasOwnProperty("totalPollTimeout")) {
                            var error = $root.google.protobuf.Duration.verify(message.totalPollTimeout);
                            if (error)
                                return "totalPollTimeout." + error;
                        }
                        return null;
                    };
    
                    /**
                     * Creates a LongRunning message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.api.MethodSettings.LongRunning} LongRunning
                     */
                    LongRunning.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.api.MethodSettings.LongRunning)
                            return object;
                        var message = new $root.google.api.MethodSettings.LongRunning();
                        if (object.initialPollDelay != null) {
                            if (typeof object.initialPollDelay !== "object")
                                throw TypeError(".google.api.MethodSettings.LongRunning.initialPollDelay: object expected");
                            message.initialPollDelay = $root.google.protobuf.Duration.fromObject(object.initialPollDelay);
                        }
                        if (object.pollDelayMultiplier != null)
                            message.pollDelayMultiplier = Number(object.pollDelayMultiplier);
                        if (object.maxPollDelay != null) {
                            if (typeof object.maxPollDelay !== "object")
                                throw TypeError(".google.api.MethodSettings.LongRunning.maxPollDelay: object expected");
                            message.maxPollDelay = $root.google.protobuf.Duration.fromObject(object.maxPollDelay);
                        }
                        if (object.totalPollTimeout != null) {
                            if (typeof object.totalPollTimeout !== "object")
                                throw TypeError(".google.api.MethodSettings.LongRunning.totalPollTimeout: object expected");
                            message.totalPollTimeout = $root.google.protobuf.Duration.fromObject(object.totalPollTimeout);
                        }
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a LongRunning message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {google.api.MethodSettings.LongRunning} message LongRunning
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    LongRunning.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.initialPollDelay = null;
                            object.pollDelayMultiplier = 0;
                            object.maxPollDelay = null;
                            object.totalPollTimeout = null;
                        }
                        if (message.initialPollDelay != null && message.hasOwnProperty("initialPollDelay"))
                            object.initialPollDelay = $root.google.protobuf.Duration.toObject(message.initialPollDelay, options);
                        if (message.pollDelayMultiplier != null && message.hasOwnProperty("pollDelayMultiplier"))
                            object.pollDelayMultiplier = options.json && !isFinite(message.pollDelayMultiplier) ? String(message.pollDelayMultiplier) : message.pollDelayMultiplier;
                        if (message.maxPollDelay != null && message.hasOwnProperty("maxPollDelay"))
                            object.maxPollDelay = $root.google.protobuf.Duration.toObject(message.maxPollDelay, options);
                        if (message.totalPollTimeout != null && message.hasOwnProperty("totalPollTimeout"))
                            object.totalPollTimeout = $root.google.protobuf.Duration.toObject(message.totalPollTimeout, options);
                        return object;
                    };
    
                    /**
                     * Converts this LongRunning to JSON.
                     * @function toJSON
                     * @memberof google.api.MethodSettings.LongRunning
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    LongRunning.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for LongRunning
                     * @function getTypeUrl
                     * @memberof google.api.MethodSettings.LongRunning
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    LongRunning.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.api.MethodSettings.LongRunning";
                    };
    
                    return LongRunning;
                })();
    
                return MethodSettings;
            })();
    
            /**
             * ClientLibraryOrganization enum.
             * @name google.api.ClientLibraryOrganization
             * @enum {number}
             * @property {number} CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED=0 CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED value
             * @property {number} CLOUD=1 CLOUD value
             * @property {number} ADS=2 ADS value
             * @property {number} PHOTOS=3 PHOTOS value
             * @property {number} STREET_VIEW=4 STREET_VIEW value
             */
            api.ClientLibraryOrganization = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[0] = "CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED"] = 0;
                values[valuesById[1] = "CLOUD"] = 1;
                values[valuesById[2] = "ADS"] = 2;
                values[valuesById[3] = "PHOTOS"] = 3;
                values[valuesById[4] = "STREET_VIEW"] = 4;
                return values;
            })();
    
            /**
             * ClientLibraryDestination enum.
             * @name google.api.ClientLibraryDestination
             * @enum {number}
             * @property {number} CLIENT_LIBRARY_DESTINATION_UNSPECIFIED=0 CLIENT_LIBRARY_DESTINATION_UNSPECIFIED value
             * @property {number} GITHUB=10 GITHUB value
             * @property {number} PACKAGE_MANAGER=20 PACKAGE_MANAGER value
             */
            api.ClientLibraryDestination = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[0] = "CLIENT_LIBRARY_DESTINATION_UNSPECIFIED"] = 0;
                values[valuesById[10] = "GITHUB"] = 10;
                values[valuesById[20] = "PACKAGE_MANAGER"] = 20;
                return values;
            })();
    
            /**
             * LaunchStage enum.
             * @name google.api.LaunchStage
             * @enum {number}
             * @property {number} LAUNCH_STAGE_UNSPECIFIED=0 LAUNCH_STAGE_UNSPECIFIED value
             * @property {number} UNIMPLEMENTED=6 UNIMPLEMENTED value
             * @property {number} PRELAUNCH=7 PRELAUNCH value
             * @property {number} EARLY_ACCESS=1 EARLY_ACCESS value
             * @property {number} ALPHA=2 ALPHA value
             * @property {number} BETA=3 BETA value
             * @property {number} GA=4 GA value
             * @property {number} DEPRECATED=5 DEPRECATED value
             */
            api.LaunchStage = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[0] = "LAUNCH_STAGE_UNSPECIFIED"] = 0;
                values[valuesById[6] = "UNIMPLEMENTED"] = 6;
                values[valuesById[7] = "PRELAUNCH"] = 7;
                values[valuesById[1] = "EARLY_ACCESS"] = 1;
                values[valuesById[2] = "ALPHA"] = 2;
                values[valuesById[3] = "BETA"] = 3;
                values[valuesById[4] = "GA"] = 4;
                values[valuesById[5] = "DEPRECATED"] = 5;
                return values;
            })();
    
            return api;
        })();
    
        google.protobuf = (function() {
    
            /**
             * Namespace protobuf.
             * @memberof google
             * @namespace
             */
            var protobuf = {};
    
            protobuf.FileDescriptorSet = (function() {
    
                /**
                 * Properties of a FileDescriptorSet.
                 * @memberof google.protobuf
                 * @interface IFileDescriptorSet
                 * @property {Array.<google.protobuf.IFileDescriptorProto>|null} [file] FileDescriptorSet file
                 */
    
                /**
                 * Constructs a new FileDescriptorSet.
                 * @memberof google.protobuf
                 * @classdesc Represents a FileDescriptorSet.
                 * @implements IFileDescriptorSet
                 * @constructor
                 * @param {google.protobuf.IFileDescriptorSet=} [properties] Properties to set
                 */
                function FileDescriptorSet(properties) {
                    this.file = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FileDescriptorSet file.
                 * @member {Array.<google.protobuf.IFileDescriptorProto>} file
                 * @memberof google.protobuf.FileDescriptorSet
                 * @instance
                 */
                FileDescriptorSet.prototype.file = $util.emptyArray;
    
                /**
                 * Creates a new FileDescriptorSet instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.IFileDescriptorSet=} [properties] Properties to set
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet instance
                 */
                FileDescriptorSet.create = function create(properties) {
                    return new FileDescriptorSet(properties);
                };
    
                /**
                 * Encodes the specified FileDescriptorSet message. Does not implicitly {@link google.protobuf.FileDescriptorSet.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.IFileDescriptorSet} message FileDescriptorSet message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorSet.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.file != null && message.file.length)
                        for (var i = 0; i < message.file.length; ++i)
                            $root.google.protobuf.FileDescriptorProto.encode(message.file[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified FileDescriptorSet message, length delimited. Does not implicitly {@link google.protobuf.FileDescriptorSet.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.IFileDescriptorSet} message FileDescriptorSet message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorSet.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FileDescriptorSet message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorSet.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileDescriptorSet();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.file && message.file.length))
                                    message.file = [];
                                message.file.push($root.google.protobuf.FileDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FileDescriptorSet message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorSet.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FileDescriptorSet message.
                 * @function verify
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FileDescriptorSet.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.file != null && message.hasOwnProperty("file")) {
                        if (!Array.isArray(message.file))
                            return "file: array expected";
                        for (var i = 0; i < message.file.length; ++i) {
                            var error = $root.google.protobuf.FileDescriptorProto.verify(message.file[i]);
                            if (error)
                                return "file." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a FileDescriptorSet message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
                 */
                FileDescriptorSet.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FileDescriptorSet)
                        return object;
                    var message = new $root.google.protobuf.FileDescriptorSet();
                    if (object.file) {
                        if (!Array.isArray(object.file))
                            throw TypeError(".google.protobuf.FileDescriptorSet.file: array expected");
                        message.file = [];
                        for (var i = 0; i < object.file.length; ++i) {
                            if (typeof object.file[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorSet.file: object expected");
                            message.file[i] = $root.google.protobuf.FileDescriptorProto.fromObject(object.file[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a FileDescriptorSet message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.FileDescriptorSet} message FileDescriptorSet
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FileDescriptorSet.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.file = [];
                    if (message.file && message.file.length) {
                        object.file = [];
                        for (var j = 0; j < message.file.length; ++j)
                            object.file[j] = $root.google.protobuf.FileDescriptorProto.toObject(message.file[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this FileDescriptorSet to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FileDescriptorSet
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FileDescriptorSet.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FileDescriptorSet
                 * @function getTypeUrl
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FileDescriptorSet.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FileDescriptorSet";
                };
    
                return FileDescriptorSet;
            })();
    
            protobuf.FileDescriptorProto = (function() {
    
                /**
                 * Properties of a FileDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IFileDescriptorProto
                 * @property {string|null} [name] FileDescriptorProto name
                 * @property {string|null} ["package"] FileDescriptorProto package
                 * @property {Array.<string>|null} [dependency] FileDescriptorProto dependency
                 * @property {Array.<number>|null} [publicDependency] FileDescriptorProto publicDependency
                 * @property {Array.<number>|null} [weakDependency] FileDescriptorProto weakDependency
                 * @property {Array.<google.protobuf.IDescriptorProto>|null} [messageType] FileDescriptorProto messageType
                 * @property {Array.<google.protobuf.IEnumDescriptorProto>|null} [enumType] FileDescriptorProto enumType
                 * @property {Array.<google.protobuf.IServiceDescriptorProto>|null} [service] FileDescriptorProto service
                 * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [extension] FileDescriptorProto extension
                 * @property {google.protobuf.IFileOptions|null} [options] FileDescriptorProto options
                 * @property {google.protobuf.ISourceCodeInfo|null} [sourceCodeInfo] FileDescriptorProto sourceCodeInfo
                 * @property {string|null} [syntax] FileDescriptorProto syntax
                 * @property {string|null} [edition] FileDescriptorProto edition
                 */
    
                /**
                 * Constructs a new FileDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a FileDescriptorProto.
                 * @implements IFileDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IFileDescriptorProto=} [properties] Properties to set
                 */
                function FileDescriptorProto(properties) {
                    this.dependency = [];
                    this.publicDependency = [];
                    this.weakDependency = [];
                    this.messageType = [];
                    this.enumType = [];
                    this.service = [];
                    this.extension = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FileDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.name = "";
    
                /**
                 * FileDescriptorProto package.
                 * @member {string} package
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype["package"] = "";
    
                /**
                 * FileDescriptorProto dependency.
                 * @member {Array.<string>} dependency
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.dependency = $util.emptyArray;
    
                /**
                 * FileDescriptorProto publicDependency.
                 * @member {Array.<number>} publicDependency
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.publicDependency = $util.emptyArray;
    
                /**
                 * FileDescriptorProto weakDependency.
                 * @member {Array.<number>} weakDependency
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.weakDependency = $util.emptyArray;
    
                /**
                 * FileDescriptorProto messageType.
                 * @member {Array.<google.protobuf.IDescriptorProto>} messageType
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.messageType = $util.emptyArray;
    
                /**
                 * FileDescriptorProto enumType.
                 * @member {Array.<google.protobuf.IEnumDescriptorProto>} enumType
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.enumType = $util.emptyArray;
    
                /**
                 * FileDescriptorProto service.
                 * @member {Array.<google.protobuf.IServiceDescriptorProto>} service
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.service = $util.emptyArray;
    
                /**
                 * FileDescriptorProto extension.
                 * @member {Array.<google.protobuf.IFieldDescriptorProto>} extension
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.extension = $util.emptyArray;
    
                /**
                 * FileDescriptorProto options.
                 * @member {google.protobuf.IFileOptions|null|undefined} options
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.options = null;
    
                /**
                 * FileDescriptorProto sourceCodeInfo.
                 * @member {google.protobuf.ISourceCodeInfo|null|undefined} sourceCodeInfo
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.sourceCodeInfo = null;
    
                /**
                 * FileDescriptorProto syntax.
                 * @member {string} syntax
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.syntax = "";
    
                /**
                 * FileDescriptorProto edition.
                 * @member {string} edition
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.edition = "";
    
                /**
                 * Creates a new FileDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.IFileDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto instance
                 */
                FileDescriptorProto.create = function create(properties) {
                    return new FileDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified FileDescriptorProto message. Does not implicitly {@link google.protobuf.FileDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.IFileDescriptorProto} message FileDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message["package"] != null && Object.hasOwnProperty.call(message, "package"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message["package"]);
                    if (message.dependency != null && message.dependency.length)
                        for (var i = 0; i < message.dependency.length; ++i)
                            writer.uint32(/* id 3, wireType 2 =*/26).string(message.dependency[i]);
                    if (message.messageType != null && message.messageType.length)
                        for (var i = 0; i < message.messageType.length; ++i)
                            $root.google.protobuf.DescriptorProto.encode(message.messageType[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.enumType != null && message.enumType.length)
                        for (var i = 0; i < message.enumType.length; ++i)
                            $root.google.protobuf.EnumDescriptorProto.encode(message.enumType[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                    if (message.service != null && message.service.length)
                        for (var i = 0; i < message.service.length; ++i)
                            $root.google.protobuf.ServiceDescriptorProto.encode(message.service[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                    if (message.extension != null && message.extension.length)
                        for (var i = 0; i < message.extension.length; ++i)
                            $root.google.protobuf.FieldDescriptorProto.encode(message.extension[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.FileOptions.encode(message.options, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.sourceCodeInfo != null && Object.hasOwnProperty.call(message, "sourceCodeInfo"))
                        $root.google.protobuf.SourceCodeInfo.encode(message.sourceCodeInfo, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                    if (message.publicDependency != null && message.publicDependency.length)
                        for (var i = 0; i < message.publicDependency.length; ++i)
                            writer.uint32(/* id 10, wireType 0 =*/80).int32(message.publicDependency[i]);
                    if (message.weakDependency != null && message.weakDependency.length)
                        for (var i = 0; i < message.weakDependency.length; ++i)
                            writer.uint32(/* id 11, wireType 0 =*/88).int32(message.weakDependency[i]);
                    if (message.syntax != null && Object.hasOwnProperty.call(message, "syntax"))
                        writer.uint32(/* id 12, wireType 2 =*/98).string(message.syntax);
                    if (message.edition != null && Object.hasOwnProperty.call(message, "edition"))
                        writer.uint32(/* id 13, wireType 2 =*/106).string(message.edition);
                    return writer;
                };
    
                /**
                 * Encodes the specified FileDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.FileDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.IFileDescriptorProto} message FileDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FileDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message["package"] = reader.string();
                                break;
                            }
                        case 3: {
                                if (!(message.dependency && message.dependency.length))
                                    message.dependency = [];
                                message.dependency.push(reader.string());
                                break;
                            }
                        case 10: {
                                if (!(message.publicDependency && message.publicDependency.length))
                                    message.publicDependency = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message.publicDependency.push(reader.int32());
                                } else
                                    message.publicDependency.push(reader.int32());
                                break;
                            }
                        case 11: {
                                if (!(message.weakDependency && message.weakDependency.length))
                                    message.weakDependency = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message.weakDependency.push(reader.int32());
                                } else
                                    message.weakDependency.push(reader.int32());
                                break;
                            }
                        case 4: {
                                if (!(message.messageType && message.messageType.length))
                                    message.messageType = [];
                                message.messageType.push($root.google.protobuf.DescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 5: {
                                if (!(message.enumType && message.enumType.length))
                                    message.enumType = [];
                                message.enumType.push($root.google.protobuf.EnumDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 6: {
                                if (!(message.service && message.service.length))
                                    message.service = [];
                                message.service.push($root.google.protobuf.ServiceDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 7: {
                                if (!(message.extension && message.extension.length))
                                    message.extension = [];
                                message.extension.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 8: {
                                message.options = $root.google.protobuf.FileOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 9: {
                                message.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.decode(reader, reader.uint32());
                                break;
                            }
                        case 12: {
                                message.syntax = reader.string();
                                break;
                            }
                        case 13: {
                                message.edition = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FileDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FileDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FileDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message["package"] != null && message.hasOwnProperty("package"))
                        if (!$util.isString(message["package"]))
                            return "package: string expected";
                    if (message.dependency != null && message.hasOwnProperty("dependency")) {
                        if (!Array.isArray(message.dependency))
                            return "dependency: array expected";
                        for (var i = 0; i < message.dependency.length; ++i)
                            if (!$util.isString(message.dependency[i]))
                                return "dependency: string[] expected";
                    }
                    if (message.publicDependency != null && message.hasOwnProperty("publicDependency")) {
                        if (!Array.isArray(message.publicDependency))
                            return "publicDependency: array expected";
                        for (var i = 0; i < message.publicDependency.length; ++i)
                            if (!$util.isInteger(message.publicDependency[i]))
                                return "publicDependency: integer[] expected";
                    }
                    if (message.weakDependency != null && message.hasOwnProperty("weakDependency")) {
                        if (!Array.isArray(message.weakDependency))
                            return "weakDependency: array expected";
                        for (var i = 0; i < message.weakDependency.length; ++i)
                            if (!$util.isInteger(message.weakDependency[i]))
                                return "weakDependency: integer[] expected";
                    }
                    if (message.messageType != null && message.hasOwnProperty("messageType")) {
                        if (!Array.isArray(message.messageType))
                            return "messageType: array expected";
                        for (var i = 0; i < message.messageType.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.verify(message.messageType[i]);
                            if (error)
                                return "messageType." + error;
                        }
                    }
                    if (message.enumType != null && message.hasOwnProperty("enumType")) {
                        if (!Array.isArray(message.enumType))
                            return "enumType: array expected";
                        for (var i = 0; i < message.enumType.length; ++i) {
                            var error = $root.google.protobuf.EnumDescriptorProto.verify(message.enumType[i]);
                            if (error)
                                return "enumType." + error;
                        }
                    }
                    if (message.service != null && message.hasOwnProperty("service")) {
                        if (!Array.isArray(message.service))
                            return "service: array expected";
                        for (var i = 0; i < message.service.length; ++i) {
                            var error = $root.google.protobuf.ServiceDescriptorProto.verify(message.service[i]);
                            if (error)
                                return "service." + error;
                        }
                    }
                    if (message.extension != null && message.hasOwnProperty("extension")) {
                        if (!Array.isArray(message.extension))
                            return "extension: array expected";
                        for (var i = 0; i < message.extension.length; ++i) {
                            var error = $root.google.protobuf.FieldDescriptorProto.verify(message.extension[i]);
                            if (error)
                                return "extension." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.FileOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.sourceCodeInfo != null && message.hasOwnProperty("sourceCodeInfo")) {
                        var error = $root.google.protobuf.SourceCodeInfo.verify(message.sourceCodeInfo);
                        if (error)
                            return "sourceCodeInfo." + error;
                    }
                    if (message.syntax != null && message.hasOwnProperty("syntax"))
                        if (!$util.isString(message.syntax))
                            return "syntax: string expected";
                    if (message.edition != null && message.hasOwnProperty("edition"))
                        if (!$util.isString(message.edition))
                            return "edition: string expected";
                    return null;
                };
    
                /**
                 * Creates a FileDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
                 */
                FileDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FileDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.FileDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object["package"] != null)
                        message["package"] = String(object["package"]);
                    if (object.dependency) {
                        if (!Array.isArray(object.dependency))
                            throw TypeError(".google.protobuf.FileDescriptorProto.dependency: array expected");
                        message.dependency = [];
                        for (var i = 0; i < object.dependency.length; ++i)
                            message.dependency[i] = String(object.dependency[i]);
                    }
                    if (object.publicDependency) {
                        if (!Array.isArray(object.publicDependency))
                            throw TypeError(".google.protobuf.FileDescriptorProto.publicDependency: array expected");
                        message.publicDependency = [];
                        for (var i = 0; i < object.publicDependency.length; ++i)
                            message.publicDependency[i] = object.publicDependency[i] | 0;
                    }
                    if (object.weakDependency) {
                        if (!Array.isArray(object.weakDependency))
                            throw TypeError(".google.protobuf.FileDescriptorProto.weakDependency: array expected");
                        message.weakDependency = [];
                        for (var i = 0; i < object.weakDependency.length; ++i)
                            message.weakDependency[i] = object.weakDependency[i] | 0;
                    }
                    if (object.messageType) {
                        if (!Array.isArray(object.messageType))
                            throw TypeError(".google.protobuf.FileDescriptorProto.messageType: array expected");
                        message.messageType = [];
                        for (var i = 0; i < object.messageType.length; ++i) {
                            if (typeof object.messageType[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.messageType: object expected");
                            message.messageType[i] = $root.google.protobuf.DescriptorProto.fromObject(object.messageType[i]);
                        }
                    }
                    if (object.enumType) {
                        if (!Array.isArray(object.enumType))
                            throw TypeError(".google.protobuf.FileDescriptorProto.enumType: array expected");
                        message.enumType = [];
                        for (var i = 0; i < object.enumType.length; ++i) {
                            if (typeof object.enumType[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.enumType: object expected");
                            message.enumType[i] = $root.google.protobuf.EnumDescriptorProto.fromObject(object.enumType[i]);
                        }
                    }
                    if (object.service) {
                        if (!Array.isArray(object.service))
                            throw TypeError(".google.protobuf.FileDescriptorProto.service: array expected");
                        message.service = [];
                        for (var i = 0; i < object.service.length; ++i) {
                            if (typeof object.service[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.service: object expected");
                            message.service[i] = $root.google.protobuf.ServiceDescriptorProto.fromObject(object.service[i]);
                        }
                    }
                    if (object.extension) {
                        if (!Array.isArray(object.extension))
                            throw TypeError(".google.protobuf.FileDescriptorProto.extension: array expected");
                        message.extension = [];
                        for (var i = 0; i < object.extension.length; ++i) {
                            if (typeof object.extension[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.extension: object expected");
                            message.extension[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.extension[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.FileOptions.fromObject(object.options);
                    }
                    if (object.sourceCodeInfo != null) {
                        if (typeof object.sourceCodeInfo !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.sourceCodeInfo: object expected");
                        message.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.fromObject(object.sourceCodeInfo);
                    }
                    if (object.syntax != null)
                        message.syntax = String(object.syntax);
                    if (object.edition != null)
                        message.edition = String(object.edition);
                    return message;
                };
    
                /**
                 * Creates a plain object from a FileDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.FileDescriptorProto} message FileDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FileDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.dependency = [];
                        object.messageType = [];
                        object.enumType = [];
                        object.service = [];
                        object.extension = [];
                        object.publicDependency = [];
                        object.weakDependency = [];
                    }
                    if (options.defaults) {
                        object.name = "";
                        object["package"] = "";
                        object.options = null;
                        object.sourceCodeInfo = null;
                        object.syntax = "";
                        object.edition = "";
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message["package"] != null && message.hasOwnProperty("package"))
                        object["package"] = message["package"];
                    if (message.dependency && message.dependency.length) {
                        object.dependency = [];
                        for (var j = 0; j < message.dependency.length; ++j)
                            object.dependency[j] = message.dependency[j];
                    }
                    if (message.messageType && message.messageType.length) {
                        object.messageType = [];
                        for (var j = 0; j < message.messageType.length; ++j)
                            object.messageType[j] = $root.google.protobuf.DescriptorProto.toObject(message.messageType[j], options);
                    }
                    if (message.enumType && message.enumType.length) {
                        object.enumType = [];
                        for (var j = 0; j < message.enumType.length; ++j)
                            object.enumType[j] = $root.google.protobuf.EnumDescriptorProto.toObject(message.enumType[j], options);
                    }
                    if (message.service && message.service.length) {
                        object.service = [];
                        for (var j = 0; j < message.service.length; ++j)
                            object.service[j] = $root.google.protobuf.ServiceDescriptorProto.toObject(message.service[j], options);
                    }
                    if (message.extension && message.extension.length) {
                        object.extension = [];
                        for (var j = 0; j < message.extension.length; ++j)
                            object.extension[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.extension[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.FileOptions.toObject(message.options, options);
                    if (message.sourceCodeInfo != null && message.hasOwnProperty("sourceCodeInfo"))
                        object.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.toObject(message.sourceCodeInfo, options);
                    if (message.publicDependency && message.publicDependency.length) {
                        object.publicDependency = [];
                        for (var j = 0; j < message.publicDependency.length; ++j)
                            object.publicDependency[j] = message.publicDependency[j];
                    }
                    if (message.weakDependency && message.weakDependency.length) {
                        object.weakDependency = [];
                        for (var j = 0; j < message.weakDependency.length; ++j)
                            object.weakDependency[j] = message.weakDependency[j];
                    }
                    if (message.syntax != null && message.hasOwnProperty("syntax"))
                        object.syntax = message.syntax;
                    if (message.edition != null && message.hasOwnProperty("edition"))
                        object.edition = message.edition;
                    return object;
                };
    
                /**
                 * Converts this FileDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FileDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FileDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FileDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FileDescriptorProto";
                };
    
                return FileDescriptorProto;
            })();
    
            protobuf.DescriptorProto = (function() {
    
                /**
                 * Properties of a DescriptorProto.
                 * @memberof google.protobuf
                 * @interface IDescriptorProto
                 * @property {string|null} [name] DescriptorProto name
                 * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [field] DescriptorProto field
                 * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [extension] DescriptorProto extension
                 * @property {Array.<google.protobuf.IDescriptorProto>|null} [nestedType] DescriptorProto nestedType
                 * @property {Array.<google.protobuf.IEnumDescriptorProto>|null} [enumType] DescriptorProto enumType
                 * @property {Array.<google.protobuf.DescriptorProto.IExtensionRange>|null} [extensionRange] DescriptorProto extensionRange
                 * @property {Array.<google.protobuf.IOneofDescriptorProto>|null} [oneofDecl] DescriptorProto oneofDecl
                 * @property {google.protobuf.IMessageOptions|null} [options] DescriptorProto options
                 * @property {Array.<google.protobuf.DescriptorProto.IReservedRange>|null} [reservedRange] DescriptorProto reservedRange
                 * @property {Array.<string>|null} [reservedName] DescriptorProto reservedName
                 */
    
                /**
                 * Constructs a new DescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a DescriptorProto.
                 * @implements IDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IDescriptorProto=} [properties] Properties to set
                 */
                function DescriptorProto(properties) {
                    this.field = [];
                    this.extension = [];
                    this.nestedType = [];
                    this.enumType = [];
                    this.extensionRange = [];
                    this.oneofDecl = [];
                    this.reservedRange = [];
                    this.reservedName = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * DescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.name = "";
    
                /**
                 * DescriptorProto field.
                 * @member {Array.<google.protobuf.IFieldDescriptorProto>} field
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.field = $util.emptyArray;
    
                /**
                 * DescriptorProto extension.
                 * @member {Array.<google.protobuf.IFieldDescriptorProto>} extension
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.extension = $util.emptyArray;
    
                /**
                 * DescriptorProto nestedType.
                 * @member {Array.<google.protobuf.IDescriptorProto>} nestedType
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.nestedType = $util.emptyArray;
    
                /**
                 * DescriptorProto enumType.
                 * @member {Array.<google.protobuf.IEnumDescriptorProto>} enumType
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.enumType = $util.emptyArray;
    
                /**
                 * DescriptorProto extensionRange.
                 * @member {Array.<google.protobuf.DescriptorProto.IExtensionRange>} extensionRange
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.extensionRange = $util.emptyArray;
    
                /**
                 * DescriptorProto oneofDecl.
                 * @member {Array.<google.protobuf.IOneofDescriptorProto>} oneofDecl
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.oneofDecl = $util.emptyArray;
    
                /**
                 * DescriptorProto options.
                 * @member {google.protobuf.IMessageOptions|null|undefined} options
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.options = null;
    
                /**
                 * DescriptorProto reservedRange.
                 * @member {Array.<google.protobuf.DescriptorProto.IReservedRange>} reservedRange
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.reservedRange = $util.emptyArray;
    
                /**
                 * DescriptorProto reservedName.
                 * @member {Array.<string>} reservedName
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.reservedName = $util.emptyArray;
    
                /**
                 * Creates a new DescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.IDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto instance
                 */
                DescriptorProto.create = function create(properties) {
                    return new DescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified DescriptorProto message. Does not implicitly {@link google.protobuf.DescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.IDescriptorProto} message DescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.field != null && message.field.length)
                        for (var i = 0; i < message.field.length; ++i)
                            $root.google.protobuf.FieldDescriptorProto.encode(message.field[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.nestedType != null && message.nestedType.length)
                        for (var i = 0; i < message.nestedType.length; ++i)
                            $root.google.protobuf.DescriptorProto.encode(message.nestedType[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    if (message.enumType != null && message.enumType.length)
                        for (var i = 0; i < message.enumType.length; ++i)
                            $root.google.protobuf.EnumDescriptorProto.encode(message.enumType[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.extensionRange != null && message.extensionRange.length)
                        for (var i = 0; i < message.extensionRange.length; ++i)
                            $root.google.protobuf.DescriptorProto.ExtensionRange.encode(message.extensionRange[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                    if (message.extension != null && message.extension.length)
                        for (var i = 0; i < message.extension.length; ++i)
                            $root.google.protobuf.FieldDescriptorProto.encode(message.extension[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.MessageOptions.encode(message.options, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                    if (message.oneofDecl != null && message.oneofDecl.length)
                        for (var i = 0; i < message.oneofDecl.length; ++i)
                            $root.google.protobuf.OneofDescriptorProto.encode(message.oneofDecl[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.reservedRange != null && message.reservedRange.length)
                        for (var i = 0; i < message.reservedRange.length; ++i)
                            $root.google.protobuf.DescriptorProto.ReservedRange.encode(message.reservedRange[i], writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                    if (message.reservedName != null && message.reservedName.length)
                        for (var i = 0; i < message.reservedName.length; ++i)
                            writer.uint32(/* id 10, wireType 2 =*/82).string(message.reservedName[i]);
                    return writer;
                };
    
                /**
                 * Encodes the specified DescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.IDescriptorProto} message DescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a DescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.field && message.field.length))
                                    message.field = [];
                                message.field.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 6: {
                                if (!(message.extension && message.extension.length))
                                    message.extension = [];
                                message.extension.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                if (!(message.nestedType && message.nestedType.length))
                                    message.nestedType = [];
                                message.nestedType.push($root.google.protobuf.DescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 4: {
                                if (!(message.enumType && message.enumType.length))
                                    message.enumType = [];
                                message.enumType.push($root.google.protobuf.EnumDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 5: {
                                if (!(message.extensionRange && message.extensionRange.length))
                                    message.extensionRange = [];
                                message.extensionRange.push($root.google.protobuf.DescriptorProto.ExtensionRange.decode(reader, reader.uint32()));
                                break;
                            }
                        case 8: {
                                if (!(message.oneofDecl && message.oneofDecl.length))
                                    message.oneofDecl = [];
                                message.oneofDecl.push($root.google.protobuf.OneofDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 7: {
                                message.options = $root.google.protobuf.MessageOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 9: {
                                if (!(message.reservedRange && message.reservedRange.length))
                                    message.reservedRange = [];
                                message.reservedRange.push($root.google.protobuf.DescriptorProto.ReservedRange.decode(reader, reader.uint32()));
                                break;
                            }
                        case 10: {
                                if (!(message.reservedName && message.reservedName.length))
                                    message.reservedName = [];
                                message.reservedName.push(reader.string());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a DescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a DescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                DescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.field != null && message.hasOwnProperty("field")) {
                        if (!Array.isArray(message.field))
                            return "field: array expected";
                        for (var i = 0; i < message.field.length; ++i) {
                            var error = $root.google.protobuf.FieldDescriptorProto.verify(message.field[i]);
                            if (error)
                                return "field." + error;
                        }
                    }
                    if (message.extension != null && message.hasOwnProperty("extension")) {
                        if (!Array.isArray(message.extension))
                            return "extension: array expected";
                        for (var i = 0; i < message.extension.length; ++i) {
                            var error = $root.google.protobuf.FieldDescriptorProto.verify(message.extension[i]);
                            if (error)
                                return "extension." + error;
                        }
                    }
                    if (message.nestedType != null && message.hasOwnProperty("nestedType")) {
                        if (!Array.isArray(message.nestedType))
                            return "nestedType: array expected";
                        for (var i = 0; i < message.nestedType.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.verify(message.nestedType[i]);
                            if (error)
                                return "nestedType." + error;
                        }
                    }
                    if (message.enumType != null && message.hasOwnProperty("enumType")) {
                        if (!Array.isArray(message.enumType))
                            return "enumType: array expected";
                        for (var i = 0; i < message.enumType.length; ++i) {
                            var error = $root.google.protobuf.EnumDescriptorProto.verify(message.enumType[i]);
                            if (error)
                                return "enumType." + error;
                        }
                    }
                    if (message.extensionRange != null && message.hasOwnProperty("extensionRange")) {
                        if (!Array.isArray(message.extensionRange))
                            return "extensionRange: array expected";
                        for (var i = 0; i < message.extensionRange.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.ExtensionRange.verify(message.extensionRange[i]);
                            if (error)
                                return "extensionRange." + error;
                        }
                    }
                    if (message.oneofDecl != null && message.hasOwnProperty("oneofDecl")) {
                        if (!Array.isArray(message.oneofDecl))
                            return "oneofDecl: array expected";
                        for (var i = 0; i < message.oneofDecl.length; ++i) {
                            var error = $root.google.protobuf.OneofDescriptorProto.verify(message.oneofDecl[i]);
                            if (error)
                                return "oneofDecl." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.MessageOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.reservedRange != null && message.hasOwnProperty("reservedRange")) {
                        if (!Array.isArray(message.reservedRange))
                            return "reservedRange: array expected";
                        for (var i = 0; i < message.reservedRange.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.ReservedRange.verify(message.reservedRange[i]);
                            if (error)
                                return "reservedRange." + error;
                        }
                    }
                    if (message.reservedName != null && message.hasOwnProperty("reservedName")) {
                        if (!Array.isArray(message.reservedName))
                            return "reservedName: array expected";
                        for (var i = 0; i < message.reservedName.length; ++i)
                            if (!$util.isString(message.reservedName[i]))
                                return "reservedName: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates a DescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto
                 */
                DescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.DescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.DescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.field) {
                        if (!Array.isArray(object.field))
                            throw TypeError(".google.protobuf.DescriptorProto.field: array expected");
                        message.field = [];
                        for (var i = 0; i < object.field.length; ++i) {
                            if (typeof object.field[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.field: object expected");
                            message.field[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.field[i]);
                        }
                    }
                    if (object.extension) {
                        if (!Array.isArray(object.extension))
                            throw TypeError(".google.protobuf.DescriptorProto.extension: array expected");
                        message.extension = [];
                        for (var i = 0; i < object.extension.length; ++i) {
                            if (typeof object.extension[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.extension: object expected");
                            message.extension[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.extension[i]);
                        }
                    }
                    if (object.nestedType) {
                        if (!Array.isArray(object.nestedType))
                            throw TypeError(".google.protobuf.DescriptorProto.nestedType: array expected");
                        message.nestedType = [];
                        for (var i = 0; i < object.nestedType.length; ++i) {
                            if (typeof object.nestedType[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.nestedType: object expected");
                            message.nestedType[i] = $root.google.protobuf.DescriptorProto.fromObject(object.nestedType[i]);
                        }
                    }
                    if (object.enumType) {
                        if (!Array.isArray(object.enumType))
                            throw TypeError(".google.protobuf.DescriptorProto.enumType: array expected");
                        message.enumType = [];
                        for (var i = 0; i < object.enumType.length; ++i) {
                            if (typeof object.enumType[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.enumType: object expected");
                            message.enumType[i] = $root.google.protobuf.EnumDescriptorProto.fromObject(object.enumType[i]);
                        }
                    }
                    if (object.extensionRange) {
                        if (!Array.isArray(object.extensionRange))
                            throw TypeError(".google.protobuf.DescriptorProto.extensionRange: array expected");
                        message.extensionRange = [];
                        for (var i = 0; i < object.extensionRange.length; ++i) {
                            if (typeof object.extensionRange[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.extensionRange: object expected");
                            message.extensionRange[i] = $root.google.protobuf.DescriptorProto.ExtensionRange.fromObject(object.extensionRange[i]);
                        }
                    }
                    if (object.oneofDecl) {
                        if (!Array.isArray(object.oneofDecl))
                            throw TypeError(".google.protobuf.DescriptorProto.oneofDecl: array expected");
                        message.oneofDecl = [];
                        for (var i = 0; i < object.oneofDecl.length; ++i) {
                            if (typeof object.oneofDecl[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.oneofDecl: object expected");
                            message.oneofDecl[i] = $root.google.protobuf.OneofDescriptorProto.fromObject(object.oneofDecl[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.MessageOptions.fromObject(object.options);
                    }
                    if (object.reservedRange) {
                        if (!Array.isArray(object.reservedRange))
                            throw TypeError(".google.protobuf.DescriptorProto.reservedRange: array expected");
                        message.reservedRange = [];
                        for (var i = 0; i < object.reservedRange.length; ++i) {
                            if (typeof object.reservedRange[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.reservedRange: object expected");
                            message.reservedRange[i] = $root.google.protobuf.DescriptorProto.ReservedRange.fromObject(object.reservedRange[i]);
                        }
                    }
                    if (object.reservedName) {
                        if (!Array.isArray(object.reservedName))
                            throw TypeError(".google.protobuf.DescriptorProto.reservedName: array expected");
                        message.reservedName = [];
                        for (var i = 0; i < object.reservedName.length; ++i)
                            message.reservedName[i] = String(object.reservedName[i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a DescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.DescriptorProto} message DescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                DescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.field = [];
                        object.nestedType = [];
                        object.enumType = [];
                        object.extensionRange = [];
                        object.extension = [];
                        object.oneofDecl = [];
                        object.reservedRange = [];
                        object.reservedName = [];
                    }
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.field && message.field.length) {
                        object.field = [];
                        for (var j = 0; j < message.field.length; ++j)
                            object.field[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.field[j], options);
                    }
                    if (message.nestedType && message.nestedType.length) {
                        object.nestedType = [];
                        for (var j = 0; j < message.nestedType.length; ++j)
                            object.nestedType[j] = $root.google.protobuf.DescriptorProto.toObject(message.nestedType[j], options);
                    }
                    if (message.enumType && message.enumType.length) {
                        object.enumType = [];
                        for (var j = 0; j < message.enumType.length; ++j)
                            object.enumType[j] = $root.google.protobuf.EnumDescriptorProto.toObject(message.enumType[j], options);
                    }
                    if (message.extensionRange && message.extensionRange.length) {
                        object.extensionRange = [];
                        for (var j = 0; j < message.extensionRange.length; ++j)
                            object.extensionRange[j] = $root.google.protobuf.DescriptorProto.ExtensionRange.toObject(message.extensionRange[j], options);
                    }
                    if (message.extension && message.extension.length) {
                        object.extension = [];
                        for (var j = 0; j < message.extension.length; ++j)
                            object.extension[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.extension[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.MessageOptions.toObject(message.options, options);
                    if (message.oneofDecl && message.oneofDecl.length) {
                        object.oneofDecl = [];
                        for (var j = 0; j < message.oneofDecl.length; ++j)
                            object.oneofDecl[j] = $root.google.protobuf.OneofDescriptorProto.toObject(message.oneofDecl[j], options);
                    }
                    if (message.reservedRange && message.reservedRange.length) {
                        object.reservedRange = [];
                        for (var j = 0; j < message.reservedRange.length; ++j)
                            object.reservedRange[j] = $root.google.protobuf.DescriptorProto.ReservedRange.toObject(message.reservedRange[j], options);
                    }
                    if (message.reservedName && message.reservedName.length) {
                        object.reservedName = [];
                        for (var j = 0; j < message.reservedName.length; ++j)
                            object.reservedName[j] = message.reservedName[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this DescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                DescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for DescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                DescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.DescriptorProto";
                };
    
                DescriptorProto.ExtensionRange = (function() {
    
                    /**
                     * Properties of an ExtensionRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @interface IExtensionRange
                     * @property {number|null} [start] ExtensionRange start
                     * @property {number|null} [end] ExtensionRange end
                     * @property {google.protobuf.IExtensionRangeOptions|null} [options] ExtensionRange options
                     */
    
                    /**
                     * Constructs a new ExtensionRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @classdesc Represents an ExtensionRange.
                     * @implements IExtensionRange
                     * @constructor
                     * @param {google.protobuf.DescriptorProto.IExtensionRange=} [properties] Properties to set
                     */
                    function ExtensionRange(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * ExtensionRange start.
                     * @member {number} start
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     */
                    ExtensionRange.prototype.start = 0;
    
                    /**
                     * ExtensionRange end.
                     * @member {number} end
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     */
                    ExtensionRange.prototype.end = 0;
    
                    /**
                     * ExtensionRange options.
                     * @member {google.protobuf.IExtensionRangeOptions|null|undefined} options
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     */
                    ExtensionRange.prototype.options = null;
    
                    /**
                     * Creates a new ExtensionRange instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IExtensionRange=} [properties] Properties to set
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange instance
                     */
                    ExtensionRange.create = function create(properties) {
                        return new ExtensionRange(properties);
                    };
    
                    /**
                     * Encodes the specified ExtensionRange message. Does not implicitly {@link google.protobuf.DescriptorProto.ExtensionRange.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IExtensionRange} message ExtensionRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ExtensionRange.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                            writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                        if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                            $root.google.protobuf.ExtensionRangeOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                        return writer;
                    };
    
                    /**
                     * Encodes the specified ExtensionRange message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.ExtensionRange.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IExtensionRange} message ExtensionRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ExtensionRange.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes an ExtensionRange message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ExtensionRange.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto.ExtensionRange();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.start = reader.int32();
                                    break;
                                }
                            case 2: {
                                    message.end = reader.int32();
                                    break;
                                }
                            case 3: {
                                    message.options = $root.google.protobuf.ExtensionRangeOptions.decode(reader, reader.uint32());
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes an ExtensionRange message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ExtensionRange.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies an ExtensionRange message.
                     * @function verify
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    ExtensionRange.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.start != null && message.hasOwnProperty("start"))
                            if (!$util.isInteger(message.start))
                                return "start: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        if (message.options != null && message.hasOwnProperty("options")) {
                            var error = $root.google.protobuf.ExtensionRangeOptions.verify(message.options);
                            if (error)
                                return "options." + error;
                        }
                        return null;
                    };
    
                    /**
                     * Creates an ExtensionRange message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                     */
                    ExtensionRange.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.DescriptorProto.ExtensionRange)
                            return object;
                        var message = new $root.google.protobuf.DescriptorProto.ExtensionRange();
                        if (object.start != null)
                            message.start = object.start | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        if (object.options != null) {
                            if (typeof object.options !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.ExtensionRange.options: object expected");
                            message.options = $root.google.protobuf.ExtensionRangeOptions.fromObject(object.options);
                        }
                        return message;
                    };
    
                    /**
                     * Creates a plain object from an ExtensionRange message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.ExtensionRange} message ExtensionRange
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    ExtensionRange.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.start = 0;
                            object.end = 0;
                            object.options = null;
                        }
                        if (message.start != null && message.hasOwnProperty("start"))
                            object.start = message.start;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        if (message.options != null && message.hasOwnProperty("options"))
                            object.options = $root.google.protobuf.ExtensionRangeOptions.toObject(message.options, options);
                        return object;
                    };
    
                    /**
                     * Converts this ExtensionRange to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    ExtensionRange.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for ExtensionRange
                     * @function getTypeUrl
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    ExtensionRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.DescriptorProto.ExtensionRange";
                    };
    
                    return ExtensionRange;
                })();
    
                DescriptorProto.ReservedRange = (function() {
    
                    /**
                     * Properties of a ReservedRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @interface IReservedRange
                     * @property {number|null} [start] ReservedRange start
                     * @property {number|null} [end] ReservedRange end
                     */
    
                    /**
                     * Constructs a new ReservedRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @classdesc Represents a ReservedRange.
                     * @implements IReservedRange
                     * @constructor
                     * @param {google.protobuf.DescriptorProto.IReservedRange=} [properties] Properties to set
                     */
                    function ReservedRange(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * ReservedRange start.
                     * @member {number} start
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @instance
                     */
                    ReservedRange.prototype.start = 0;
    
                    /**
                     * ReservedRange end.
                     * @member {number} end
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @instance
                     */
                    ReservedRange.prototype.end = 0;
    
                    /**
                     * Creates a new ReservedRange instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IReservedRange=} [properties] Properties to set
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange instance
                     */
                    ReservedRange.create = function create(properties) {
                        return new ReservedRange(properties);
                    };
    
                    /**
                     * Encodes the specified ReservedRange message. Does not implicitly {@link google.protobuf.DescriptorProto.ReservedRange.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IReservedRange} message ReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ReservedRange.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                            writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified ReservedRange message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.ReservedRange.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IReservedRange} message ReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ReservedRange.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a ReservedRange message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ReservedRange.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto.ReservedRange();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.start = reader.int32();
                                    break;
                                }
                            case 2: {
                                    message.end = reader.int32();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes a ReservedRange message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ReservedRange.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a ReservedRange message.
                     * @function verify
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    ReservedRange.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.start != null && message.hasOwnProperty("start"))
                            if (!$util.isInteger(message.start))
                                return "start: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        return null;
                    };
    
                    /**
                     * Creates a ReservedRange message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                     */
                    ReservedRange.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.DescriptorProto.ReservedRange)
                            return object;
                        var message = new $root.google.protobuf.DescriptorProto.ReservedRange();
                        if (object.start != null)
                            message.start = object.start | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a ReservedRange message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.ReservedRange} message ReservedRange
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    ReservedRange.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.start = 0;
                            object.end = 0;
                        }
                        if (message.start != null && message.hasOwnProperty("start"))
                            object.start = message.start;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        return object;
                    };
    
                    /**
                     * Converts this ReservedRange to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    ReservedRange.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for ReservedRange
                     * @function getTypeUrl
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    ReservedRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.DescriptorProto.ReservedRange";
                    };
    
                    return ReservedRange;
                })();
    
                return DescriptorProto;
            })();
    
            protobuf.ExtensionRangeOptions = (function() {
    
                /**
                 * Properties of an ExtensionRangeOptions.
                 * @memberof google.protobuf
                 * @interface IExtensionRangeOptions
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] ExtensionRangeOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new ExtensionRangeOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an ExtensionRangeOptions.
                 * @implements IExtensionRangeOptions
                 * @constructor
                 * @param {google.protobuf.IExtensionRangeOptions=} [properties] Properties to set
                 */
                function ExtensionRangeOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ExtensionRangeOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @instance
                 */
                ExtensionRangeOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new ExtensionRangeOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.IExtensionRangeOptions=} [properties] Properties to set
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions instance
                 */
                ExtensionRangeOptions.create = function create(properties) {
                    return new ExtensionRangeOptions(properties);
                };
    
                /**
                 * Encodes the specified ExtensionRangeOptions message. Does not implicitly {@link google.protobuf.ExtensionRangeOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.IExtensionRangeOptions} message ExtensionRangeOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ExtensionRangeOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified ExtensionRangeOptions message, length delimited. Does not implicitly {@link google.protobuf.ExtensionRangeOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.IExtensionRangeOptions} message ExtensionRangeOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ExtensionRangeOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an ExtensionRangeOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ExtensionRangeOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ExtensionRangeOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an ExtensionRangeOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ExtensionRangeOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an ExtensionRangeOptions message.
                 * @function verify
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ExtensionRangeOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an ExtensionRangeOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions
                 */
                ExtensionRangeOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.ExtensionRangeOptions)
                        return object;
                    var message = new $root.google.protobuf.ExtensionRangeOptions();
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.ExtensionRangeOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.ExtensionRangeOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an ExtensionRangeOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.ExtensionRangeOptions} message ExtensionRangeOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ExtensionRangeOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this ExtensionRangeOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ExtensionRangeOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ExtensionRangeOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ExtensionRangeOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.ExtensionRangeOptions";
                };
    
                return ExtensionRangeOptions;
            })();
    
            protobuf.FieldDescriptorProto = (function() {
    
                /**
                 * Properties of a FieldDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IFieldDescriptorProto
                 * @property {string|null} [name] FieldDescriptorProto name
                 * @property {number|null} [number] FieldDescriptorProto number
                 * @property {google.protobuf.FieldDescriptorProto.Label|null} [label] FieldDescriptorProto label
                 * @property {google.protobuf.FieldDescriptorProto.Type|null} [type] FieldDescriptorProto type
                 * @property {string|null} [typeName] FieldDescriptorProto typeName
                 * @property {string|null} [extendee] FieldDescriptorProto extendee
                 * @property {string|null} [defaultValue] FieldDescriptorProto defaultValue
                 * @property {number|null} [oneofIndex] FieldDescriptorProto oneofIndex
                 * @property {string|null} [jsonName] FieldDescriptorProto jsonName
                 * @property {google.protobuf.IFieldOptions|null} [options] FieldDescriptorProto options
                 * @property {boolean|null} [proto3Optional] FieldDescriptorProto proto3Optional
                 */
    
                /**
                 * Constructs a new FieldDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a FieldDescriptorProto.
                 * @implements IFieldDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IFieldDescriptorProto=} [properties] Properties to set
                 */
                function FieldDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FieldDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.name = "";
    
                /**
                 * FieldDescriptorProto number.
                 * @member {number} number
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.number = 0;
    
                /**
                 * FieldDescriptorProto label.
                 * @member {google.protobuf.FieldDescriptorProto.Label} label
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.label = 1;
    
                /**
                 * FieldDescriptorProto type.
                 * @member {google.protobuf.FieldDescriptorProto.Type} type
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.type = 1;
    
                /**
                 * FieldDescriptorProto typeName.
                 * @member {string} typeName
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.typeName = "";
    
                /**
                 * FieldDescriptorProto extendee.
                 * @member {string} extendee
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.extendee = "";
    
                /**
                 * FieldDescriptorProto defaultValue.
                 * @member {string} defaultValue
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.defaultValue = "";
    
                /**
                 * FieldDescriptorProto oneofIndex.
                 * @member {number} oneofIndex
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.oneofIndex = 0;
    
                /**
                 * FieldDescriptorProto jsonName.
                 * @member {string} jsonName
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.jsonName = "";
    
                /**
                 * FieldDescriptorProto options.
                 * @member {google.protobuf.IFieldOptions|null|undefined} options
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.options = null;
    
                /**
                 * FieldDescriptorProto proto3Optional.
                 * @member {boolean} proto3Optional
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.proto3Optional = false;
    
                /**
                 * Creates a new FieldDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.IFieldDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto instance
                 */
                FieldDescriptorProto.create = function create(properties) {
                    return new FieldDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified FieldDescriptorProto message. Does not implicitly {@link google.protobuf.FieldDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.IFieldDescriptorProto} message FieldDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.extendee != null && Object.hasOwnProperty.call(message, "extendee"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.extendee);
                    if (message.number != null && Object.hasOwnProperty.call(message, "number"))
                        writer.uint32(/* id 3, wireType 0 =*/24).int32(message.number);
                    if (message.label != null && Object.hasOwnProperty.call(message, "label"))
                        writer.uint32(/* id 4, wireType 0 =*/32).int32(message.label);
                    if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                        writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                    if (message.typeName != null && Object.hasOwnProperty.call(message, "typeName"))
                        writer.uint32(/* id 6, wireType 2 =*/50).string(message.typeName);
                    if (message.defaultValue != null && Object.hasOwnProperty.call(message, "defaultValue"))
                        writer.uint32(/* id 7, wireType 2 =*/58).string(message.defaultValue);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.FieldOptions.encode(message.options, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.oneofIndex != null && Object.hasOwnProperty.call(message, "oneofIndex"))
                        writer.uint32(/* id 9, wireType 0 =*/72).int32(message.oneofIndex);
                    if (message.jsonName != null && Object.hasOwnProperty.call(message, "jsonName"))
                        writer.uint32(/* id 10, wireType 2 =*/82).string(message.jsonName);
                    if (message.proto3Optional != null && Object.hasOwnProperty.call(message, "proto3Optional"))
                        writer.uint32(/* id 17, wireType 0 =*/136).bool(message.proto3Optional);
                    return writer;
                };
    
                /**
                 * Encodes the specified FieldDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.FieldDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.IFieldDescriptorProto} message FieldDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FieldDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 3: {
                                message.number = reader.int32();
                                break;
                            }
                        case 4: {
                                message.label = reader.int32();
                                break;
                            }
                        case 5: {
                                message.type = reader.int32();
                                break;
                            }
                        case 6: {
                                message.typeName = reader.string();
                                break;
                            }
                        case 2: {
                                message.extendee = reader.string();
                                break;
                            }
                        case 7: {
                                message.defaultValue = reader.string();
                                break;
                            }
                        case 9: {
                                message.oneofIndex = reader.int32();
                                break;
                            }
                        case 10: {
                                message.jsonName = reader.string();
                                break;
                            }
                        case 8: {
                                message.options = $root.google.protobuf.FieldOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 17: {
                                message.proto3Optional = reader.bool();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FieldDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FieldDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FieldDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.number != null && message.hasOwnProperty("number"))
                        if (!$util.isInteger(message.number))
                            return "number: integer expected";
                    if (message.label != null && message.hasOwnProperty("label"))
                        switch (message.label) {
                        default:
                            return "label: enum value expected";
                        case 1:
                        case 2:
                        case 3:
                            break;
                        }
                    if (message.type != null && message.hasOwnProperty("type"))
                        switch (message.type) {
                        default:
                            return "type: enum value expected";
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                        case 8:
                        case 9:
                        case 10:
                        case 11:
                        case 12:
                        case 13:
                        case 14:
                        case 15:
                        case 16:
                        case 17:
                        case 18:
                            break;
                        }
                    if (message.typeName != null && message.hasOwnProperty("typeName"))
                        if (!$util.isString(message.typeName))
                            return "typeName: string expected";
                    if (message.extendee != null && message.hasOwnProperty("extendee"))
                        if (!$util.isString(message.extendee))
                            return "extendee: string expected";
                    if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                        if (!$util.isString(message.defaultValue))
                            return "defaultValue: string expected";
                    if (message.oneofIndex != null && message.hasOwnProperty("oneofIndex"))
                        if (!$util.isInteger(message.oneofIndex))
                            return "oneofIndex: integer expected";
                    if (message.jsonName != null && message.hasOwnProperty("jsonName"))
                        if (!$util.isString(message.jsonName))
                            return "jsonName: string expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.FieldOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.proto3Optional != null && message.hasOwnProperty("proto3Optional"))
                        if (typeof message.proto3Optional !== "boolean")
                            return "proto3Optional: boolean expected";
                    return null;
                };
    
                /**
                 * Creates a FieldDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
                 */
                FieldDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FieldDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.FieldDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.number != null)
                        message.number = object.number | 0;
                    switch (object.label) {
                    default:
                        if (typeof object.label === "number") {
                            message.label = object.label;
                            break;
                        }
                        break;
                    case "LABEL_OPTIONAL":
                    case 1:
                        message.label = 1;
                        break;
                    case "LABEL_REQUIRED":
                    case 2:
                        message.label = 2;
                        break;
                    case "LABEL_REPEATED":
                    case 3:
                        message.label = 3;
                        break;
                    }
                    switch (object.type) {
                    default:
                        if (typeof object.type === "number") {
                            message.type = object.type;
                            break;
                        }
                        break;
                    case "TYPE_DOUBLE":
                    case 1:
                        message.type = 1;
                        break;
                    case "TYPE_FLOAT":
                    case 2:
                        message.type = 2;
                        break;
                    case "TYPE_INT64":
                    case 3:
                        message.type = 3;
                        break;
                    case "TYPE_UINT64":
                    case 4:
                        message.type = 4;
                        break;
                    case "TYPE_INT32":
                    case 5:
                        message.type = 5;
                        break;
                    case "TYPE_FIXED64":
                    case 6:
                        message.type = 6;
                        break;
                    case "TYPE_FIXED32":
                    case 7:
                        message.type = 7;
                        break;
                    case "TYPE_BOOL":
                    case 8:
                        message.type = 8;
                        break;
                    case "TYPE_STRING":
                    case 9:
                        message.type = 9;
                        break;
                    case "TYPE_GROUP":
                    case 10:
                        message.type = 10;
                        break;
                    case "TYPE_MESSAGE":
                    case 11:
                        message.type = 11;
                        break;
                    case "TYPE_BYTES":
                    case 12:
                        message.type = 12;
                        break;
                    case "TYPE_UINT32":
                    case 13:
                        message.type = 13;
                        break;
                    case "TYPE_ENUM":
                    case 14:
                        message.type = 14;
                        break;
                    case "TYPE_SFIXED32":
                    case 15:
                        message.type = 15;
                        break;
                    case "TYPE_SFIXED64":
                    case 16:
                        message.type = 16;
                        break;
                    case "TYPE_SINT32":
                    case 17:
                        message.type = 17;
                        break;
                    case "TYPE_SINT64":
                    case 18:
                        message.type = 18;
                        break;
                    }
                    if (object.typeName != null)
                        message.typeName = String(object.typeName);
                    if (object.extendee != null)
                        message.extendee = String(object.extendee);
                    if (object.defaultValue != null)
                        message.defaultValue = String(object.defaultValue);
                    if (object.oneofIndex != null)
                        message.oneofIndex = object.oneofIndex | 0;
                    if (object.jsonName != null)
                        message.jsonName = String(object.jsonName);
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.FieldDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.FieldOptions.fromObject(object.options);
                    }
                    if (object.proto3Optional != null)
                        message.proto3Optional = Boolean(object.proto3Optional);
                    return message;
                };
    
                /**
                 * Creates a plain object from a FieldDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.FieldDescriptorProto} message FieldDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FieldDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.extendee = "";
                        object.number = 0;
                        object.label = options.enums === String ? "LABEL_OPTIONAL" : 1;
                        object.type = options.enums === String ? "TYPE_DOUBLE" : 1;
                        object.typeName = "";
                        object.defaultValue = "";
                        object.options = null;
                        object.oneofIndex = 0;
                        object.jsonName = "";
                        object.proto3Optional = false;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.extendee != null && message.hasOwnProperty("extendee"))
                        object.extendee = message.extendee;
                    if (message.number != null && message.hasOwnProperty("number"))
                        object.number = message.number;
                    if (message.label != null && message.hasOwnProperty("label"))
                        object.label = options.enums === String ? $root.google.protobuf.FieldDescriptorProto.Label[message.label] === undefined ? message.label : $root.google.protobuf.FieldDescriptorProto.Label[message.label] : message.label;
                    if (message.type != null && message.hasOwnProperty("type"))
                        object.type = options.enums === String ? $root.google.protobuf.FieldDescriptorProto.Type[message.type] === undefined ? message.type : $root.google.protobuf.FieldDescriptorProto.Type[message.type] : message.type;
                    if (message.typeName != null && message.hasOwnProperty("typeName"))
                        object.typeName = message.typeName;
                    if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                        object.defaultValue = message.defaultValue;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.FieldOptions.toObject(message.options, options);
                    if (message.oneofIndex != null && message.hasOwnProperty("oneofIndex"))
                        object.oneofIndex = message.oneofIndex;
                    if (message.jsonName != null && message.hasOwnProperty("jsonName"))
                        object.jsonName = message.jsonName;
                    if (message.proto3Optional != null && message.hasOwnProperty("proto3Optional"))
                        object.proto3Optional = message.proto3Optional;
                    return object;
                };
    
                /**
                 * Converts this FieldDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FieldDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FieldDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FieldDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FieldDescriptorProto";
                };
    
                /**
                 * Type enum.
                 * @name google.protobuf.FieldDescriptorProto.Type
                 * @enum {number}
                 * @property {number} TYPE_DOUBLE=1 TYPE_DOUBLE value
                 * @property {number} TYPE_FLOAT=2 TYPE_FLOAT value
                 * @property {number} TYPE_INT64=3 TYPE_INT64 value
                 * @property {number} TYPE_UINT64=4 TYPE_UINT64 value
                 * @property {number} TYPE_INT32=5 TYPE_INT32 value
                 * @property {number} TYPE_FIXED64=6 TYPE_FIXED64 value
                 * @property {number} TYPE_FIXED32=7 TYPE_FIXED32 value
                 * @property {number} TYPE_BOOL=8 TYPE_BOOL value
                 * @property {number} TYPE_STRING=9 TYPE_STRING value
                 * @property {number} TYPE_GROUP=10 TYPE_GROUP value
                 * @property {number} TYPE_MESSAGE=11 TYPE_MESSAGE value
                 * @property {number} TYPE_BYTES=12 TYPE_BYTES value
                 * @property {number} TYPE_UINT32=13 TYPE_UINT32 value
                 * @property {number} TYPE_ENUM=14 TYPE_ENUM value
                 * @property {number} TYPE_SFIXED32=15 TYPE_SFIXED32 value
                 * @property {number} TYPE_SFIXED64=16 TYPE_SFIXED64 value
                 * @property {number} TYPE_SINT32=17 TYPE_SINT32 value
                 * @property {number} TYPE_SINT64=18 TYPE_SINT64 value
                 */
                FieldDescriptorProto.Type = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[1] = "TYPE_DOUBLE"] = 1;
                    values[valuesById[2] = "TYPE_FLOAT"] = 2;
                    values[valuesById[3] = "TYPE_INT64"] = 3;
                    values[valuesById[4] = "TYPE_UINT64"] = 4;
                    values[valuesById[5] = "TYPE_INT32"] = 5;
                    values[valuesById[6] = "TYPE_FIXED64"] = 6;
                    values[valuesById[7] = "TYPE_FIXED32"] = 7;
                    values[valuesById[8] = "TYPE_BOOL"] = 8;
                    values[valuesById[9] = "TYPE_STRING"] = 9;
                    values[valuesById[10] = "TYPE_GROUP"] = 10;
                    values[valuesById[11] = "TYPE_MESSAGE"] = 11;
                    values[valuesById[12] = "TYPE_BYTES"] = 12;
                    values[valuesById[13] = "TYPE_UINT32"] = 13;
                    values[valuesById[14] = "TYPE_ENUM"] = 14;
                    values[valuesById[15] = "TYPE_SFIXED32"] = 15;
                    values[valuesById[16] = "TYPE_SFIXED64"] = 16;
                    values[valuesById[17] = "TYPE_SINT32"] = 17;
                    values[valuesById[18] = "TYPE_SINT64"] = 18;
                    return values;
                })();
    
                /**
                 * Label enum.
                 * @name google.protobuf.FieldDescriptorProto.Label
                 * @enum {number}
                 * @property {number} LABEL_OPTIONAL=1 LABEL_OPTIONAL value
                 * @property {number} LABEL_REQUIRED=2 LABEL_REQUIRED value
                 * @property {number} LABEL_REPEATED=3 LABEL_REPEATED value
                 */
                FieldDescriptorProto.Label = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[1] = "LABEL_OPTIONAL"] = 1;
                    values[valuesById[2] = "LABEL_REQUIRED"] = 2;
                    values[valuesById[3] = "LABEL_REPEATED"] = 3;
                    return values;
                })();
    
                return FieldDescriptorProto;
            })();
    
            protobuf.OneofDescriptorProto = (function() {
    
                /**
                 * Properties of an OneofDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IOneofDescriptorProto
                 * @property {string|null} [name] OneofDescriptorProto name
                 * @property {google.protobuf.IOneofOptions|null} [options] OneofDescriptorProto options
                 */
    
                /**
                 * Constructs a new OneofDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents an OneofDescriptorProto.
                 * @implements IOneofDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IOneofDescriptorProto=} [properties] Properties to set
                 */
                function OneofDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * OneofDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @instance
                 */
                OneofDescriptorProto.prototype.name = "";
    
                /**
                 * OneofDescriptorProto options.
                 * @member {google.protobuf.IOneofOptions|null|undefined} options
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @instance
                 */
                OneofDescriptorProto.prototype.options = null;
    
                /**
                 * Creates a new OneofDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.IOneofDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto instance
                 */
                OneofDescriptorProto.create = function create(properties) {
                    return new OneofDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified OneofDescriptorProto message. Does not implicitly {@link google.protobuf.OneofDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.IOneofDescriptorProto} message OneofDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.OneofOptions.encode(message.options, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified OneofDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.OneofDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.IOneofDescriptorProto} message OneofDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an OneofDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.OneofDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message.options = $root.google.protobuf.OneofOptions.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an OneofDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an OneofDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                OneofDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.OneofOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates an OneofDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
                 */
                OneofDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.OneofDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.OneofDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.OneofDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.OneofOptions.fromObject(object.options);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an OneofDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.OneofDescriptorProto} message OneofDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                OneofDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.OneofOptions.toObject(message.options, options);
                    return object;
                };
    
                /**
                 * Converts this OneofDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                OneofDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for OneofDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                OneofDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.OneofDescriptorProto";
                };
    
                return OneofDescriptorProto;
            })();
    
            protobuf.EnumDescriptorProto = (function() {
    
                /**
                 * Properties of an EnumDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IEnumDescriptorProto
                 * @property {string|null} [name] EnumDescriptorProto name
                 * @property {Array.<google.protobuf.IEnumValueDescriptorProto>|null} [value] EnumDescriptorProto value
                 * @property {google.protobuf.IEnumOptions|null} [options] EnumDescriptorProto options
                 * @property {Array.<google.protobuf.EnumDescriptorProto.IEnumReservedRange>|null} [reservedRange] EnumDescriptorProto reservedRange
                 * @property {Array.<string>|null} [reservedName] EnumDescriptorProto reservedName
                 */
    
                /**
                 * Constructs a new EnumDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumDescriptorProto.
                 * @implements IEnumDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IEnumDescriptorProto=} [properties] Properties to set
                 */
                function EnumDescriptorProto(properties) {
                    this.value = [];
                    this.reservedRange = [];
                    this.reservedName = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.name = "";
    
                /**
                 * EnumDescriptorProto value.
                 * @member {Array.<google.protobuf.IEnumValueDescriptorProto>} value
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.value = $util.emptyArray;
    
                /**
                 * EnumDescriptorProto options.
                 * @member {google.protobuf.IEnumOptions|null|undefined} options
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.options = null;
    
                /**
                 * EnumDescriptorProto reservedRange.
                 * @member {Array.<google.protobuf.EnumDescriptorProto.IEnumReservedRange>} reservedRange
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.reservedRange = $util.emptyArray;
    
                /**
                 * EnumDescriptorProto reservedName.
                 * @member {Array.<string>} reservedName
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.reservedName = $util.emptyArray;
    
                /**
                 * Creates a new EnumDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto instance
                 */
                EnumDescriptorProto.create = function create(properties) {
                    return new EnumDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified EnumDescriptorProto message. Does not implicitly {@link google.protobuf.EnumDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumDescriptorProto} message EnumDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.value != null && message.value.length)
                        for (var i = 0; i < message.value.length; ++i)
                            $root.google.protobuf.EnumValueDescriptorProto.encode(message.value[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.EnumOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    if (message.reservedRange != null && message.reservedRange.length)
                        for (var i = 0; i < message.reservedRange.length; ++i)
                            $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.encode(message.reservedRange[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.reservedName != null && message.reservedName.length)
                        for (var i = 0; i < message.reservedName.length; ++i)
                            writer.uint32(/* id 5, wireType 2 =*/42).string(message.reservedName[i]);
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.EnumDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumDescriptorProto} message EnumDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.value && message.value.length))
                                    message.value = [];
                                message.value.push($root.google.protobuf.EnumValueDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                message.options = $root.google.protobuf.EnumOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 4: {
                                if (!(message.reservedRange && message.reservedRange.length))
                                    message.reservedRange = [];
                                message.reservedRange.push($root.google.protobuf.EnumDescriptorProto.EnumReservedRange.decode(reader, reader.uint32()));
                                break;
                            }
                        case 5: {
                                if (!(message.reservedName && message.reservedName.length))
                                    message.reservedName = [];
                                message.reservedName.push(reader.string());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.value != null && message.hasOwnProperty("value")) {
                        if (!Array.isArray(message.value))
                            return "value: array expected";
                        for (var i = 0; i < message.value.length; ++i) {
                            var error = $root.google.protobuf.EnumValueDescriptorProto.verify(message.value[i]);
                            if (error)
                                return "value." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.EnumOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.reservedRange != null && message.hasOwnProperty("reservedRange")) {
                        if (!Array.isArray(message.reservedRange))
                            return "reservedRange: array expected";
                        for (var i = 0; i < message.reservedRange.length; ++i) {
                            var error = $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.verify(message.reservedRange[i]);
                            if (error)
                                return "reservedRange." + error;
                        }
                    }
                    if (message.reservedName != null && message.hasOwnProperty("reservedName")) {
                        if (!Array.isArray(message.reservedName))
                            return "reservedName: array expected";
                        for (var i = 0; i < message.reservedName.length; ++i)
                            if (!$util.isString(message.reservedName[i]))
                                return "reservedName: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
                 */
                EnumDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.EnumDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.value) {
                        if (!Array.isArray(object.value))
                            throw TypeError(".google.protobuf.EnumDescriptorProto.value: array expected");
                        message.value = [];
                        for (var i = 0; i < object.value.length; ++i) {
                            if (typeof object.value[i] !== "object")
                                throw TypeError(".google.protobuf.EnumDescriptorProto.value: object expected");
                            message.value[i] = $root.google.protobuf.EnumValueDescriptorProto.fromObject(object.value[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.EnumDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.EnumOptions.fromObject(object.options);
                    }
                    if (object.reservedRange) {
                        if (!Array.isArray(object.reservedRange))
                            throw TypeError(".google.protobuf.EnumDescriptorProto.reservedRange: array expected");
                        message.reservedRange = [];
                        for (var i = 0; i < object.reservedRange.length; ++i) {
                            if (typeof object.reservedRange[i] !== "object")
                                throw TypeError(".google.protobuf.EnumDescriptorProto.reservedRange: object expected");
                            message.reservedRange[i] = $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.fromObject(object.reservedRange[i]);
                        }
                    }
                    if (object.reservedName) {
                        if (!Array.isArray(object.reservedName))
                            throw TypeError(".google.protobuf.EnumDescriptorProto.reservedName: array expected");
                        message.reservedName = [];
                        for (var i = 0; i < object.reservedName.length; ++i)
                            message.reservedName[i] = String(object.reservedName[i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.EnumDescriptorProto} message EnumDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.value = [];
                        object.reservedRange = [];
                        object.reservedName = [];
                    }
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.value && message.value.length) {
                        object.value = [];
                        for (var j = 0; j < message.value.length; ++j)
                            object.value[j] = $root.google.protobuf.EnumValueDescriptorProto.toObject(message.value[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.EnumOptions.toObject(message.options, options);
                    if (message.reservedRange && message.reservedRange.length) {
                        object.reservedRange = [];
                        for (var j = 0; j < message.reservedRange.length; ++j)
                            object.reservedRange[j] = $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.toObject(message.reservedRange[j], options);
                    }
                    if (message.reservedName && message.reservedName.length) {
                        object.reservedName = [];
                        for (var j = 0; j < message.reservedName.length; ++j)
                            object.reservedName[j] = message.reservedName[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this EnumDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumDescriptorProto";
                };
    
                EnumDescriptorProto.EnumReservedRange = (function() {
    
                    /**
                     * Properties of an EnumReservedRange.
                     * @memberof google.protobuf.EnumDescriptorProto
                     * @interface IEnumReservedRange
                     * @property {number|null} [start] EnumReservedRange start
                     * @property {number|null} [end] EnumReservedRange end
                     */
    
                    /**
                     * Constructs a new EnumReservedRange.
                     * @memberof google.protobuf.EnumDescriptorProto
                     * @classdesc Represents an EnumReservedRange.
                     * @implements IEnumReservedRange
                     * @constructor
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange=} [properties] Properties to set
                     */
                    function EnumReservedRange(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * EnumReservedRange start.
                     * @member {number} start
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @instance
                     */
                    EnumReservedRange.prototype.start = 0;
    
                    /**
                     * EnumReservedRange end.
                     * @member {number} end
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @instance
                     */
                    EnumReservedRange.prototype.end = 0;
    
                    /**
                     * Creates a new EnumReservedRange instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange=} [properties] Properties to set
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange instance
                     */
                    EnumReservedRange.create = function create(properties) {
                        return new EnumReservedRange(properties);
                    };
    
                    /**
                     * Encodes the specified EnumReservedRange message. Does not implicitly {@link google.protobuf.EnumDescriptorProto.EnumReservedRange.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange} message EnumReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    EnumReservedRange.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                            writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified EnumReservedRange message, length delimited. Does not implicitly {@link google.protobuf.EnumDescriptorProto.EnumReservedRange.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange} message EnumReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    EnumReservedRange.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes an EnumReservedRange message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    EnumReservedRange.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumDescriptorProto.EnumReservedRange();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.start = reader.int32();
                                    break;
                                }
                            case 2: {
                                    message.end = reader.int32();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes an EnumReservedRange message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    EnumReservedRange.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies an EnumReservedRange message.
                     * @function verify
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    EnumReservedRange.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.start != null && message.hasOwnProperty("start"))
                            if (!$util.isInteger(message.start))
                                return "start: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        return null;
                    };
    
                    /**
                     * Creates an EnumReservedRange message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange
                     */
                    EnumReservedRange.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.EnumDescriptorProto.EnumReservedRange)
                            return object;
                        var message = new $root.google.protobuf.EnumDescriptorProto.EnumReservedRange();
                        if (object.start != null)
                            message.start = object.start | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        return message;
                    };
    
                    /**
                     * Creates a plain object from an EnumReservedRange message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.EnumReservedRange} message EnumReservedRange
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    EnumReservedRange.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.start = 0;
                            object.end = 0;
                        }
                        if (message.start != null && message.hasOwnProperty("start"))
                            object.start = message.start;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        return object;
                    };
    
                    /**
                     * Converts this EnumReservedRange to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    EnumReservedRange.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for EnumReservedRange
                     * @function getTypeUrl
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    EnumReservedRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.EnumDescriptorProto.EnumReservedRange";
                    };
    
                    return EnumReservedRange;
                })();
    
                return EnumDescriptorProto;
            })();
    
            protobuf.EnumValueDescriptorProto = (function() {
    
                /**
                 * Properties of an EnumValueDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IEnumValueDescriptorProto
                 * @property {string|null} [name] EnumValueDescriptorProto name
                 * @property {number|null} [number] EnumValueDescriptorProto number
                 * @property {google.protobuf.IEnumValueOptions|null} [options] EnumValueDescriptorProto options
                 */
    
                /**
                 * Constructs a new EnumValueDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumValueDescriptorProto.
                 * @implements IEnumValueDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IEnumValueDescriptorProto=} [properties] Properties to set
                 */
                function EnumValueDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumValueDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 */
                EnumValueDescriptorProto.prototype.name = "";
    
                /**
                 * EnumValueDescriptorProto number.
                 * @member {number} number
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 */
                EnumValueDescriptorProto.prototype.number = 0;
    
                /**
                 * EnumValueDescriptorProto options.
                 * @member {google.protobuf.IEnumValueOptions|null|undefined} options
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 */
                EnumValueDescriptorProto.prototype.options = null;
    
                /**
                 * Creates a new EnumValueDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumValueDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto instance
                 */
                EnumValueDescriptorProto.create = function create(properties) {
                    return new EnumValueDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified EnumValueDescriptorProto message. Does not implicitly {@link google.protobuf.EnumValueDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumValueDescriptorProto} message EnumValueDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.number != null && Object.hasOwnProperty.call(message, "number"))
                        writer.uint32(/* id 2, wireType 0 =*/16).int32(message.number);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.EnumValueOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumValueDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.EnumValueDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumValueDescriptorProto} message EnumValueDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumValueDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumValueDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message.number = reader.int32();
                                break;
                            }
                        case 3: {
                                message.options = $root.google.protobuf.EnumValueOptions.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumValueDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumValueDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumValueDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.number != null && message.hasOwnProperty("number"))
                        if (!$util.isInteger(message.number))
                            return "number: integer expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.EnumValueOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumValueDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
                 */
                EnumValueDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumValueDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.EnumValueDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.number != null)
                        message.number = object.number | 0;
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.EnumValueDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.EnumValueOptions.fromObject(object.options);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumValueDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.EnumValueDescriptorProto} message EnumValueDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumValueDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.number = 0;
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.number != null && message.hasOwnProperty("number"))
                        object.number = message.number;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.EnumValueOptions.toObject(message.options, options);
                    return object;
                };
    
                /**
                 * Converts this EnumValueDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumValueDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumValueDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumValueDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumValueDescriptorProto";
                };
    
                return EnumValueDescriptorProto;
            })();
    
            protobuf.ServiceDescriptorProto = (function() {
    
                /**
                 * Properties of a ServiceDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IServiceDescriptorProto
                 * @property {string|null} [name] ServiceDescriptorProto name
                 * @property {Array.<google.protobuf.IMethodDescriptorProto>|null} [method] ServiceDescriptorProto method
                 * @property {google.protobuf.IServiceOptions|null} [options] ServiceDescriptorProto options
                 */
    
                /**
                 * Constructs a new ServiceDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a ServiceDescriptorProto.
                 * @implements IServiceDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IServiceDescriptorProto=} [properties] Properties to set
                 */
                function ServiceDescriptorProto(properties) {
                    this.method = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ServiceDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 */
                ServiceDescriptorProto.prototype.name = "";
    
                /**
                 * ServiceDescriptorProto method.
                 * @member {Array.<google.protobuf.IMethodDescriptorProto>} method
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 */
                ServiceDescriptorProto.prototype.method = $util.emptyArray;
    
                /**
                 * ServiceDescriptorProto options.
                 * @member {google.protobuf.IServiceOptions|null|undefined} options
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 */
                ServiceDescriptorProto.prototype.options = null;
    
                /**
                 * Creates a new ServiceDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.IServiceDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto instance
                 */
                ServiceDescriptorProto.create = function create(properties) {
                    return new ServiceDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified ServiceDescriptorProto message. Does not implicitly {@link google.protobuf.ServiceDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.IServiceDescriptorProto} message ServiceDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.method != null && message.method.length)
                        for (var i = 0; i < message.method.length; ++i)
                            $root.google.protobuf.MethodDescriptorProto.encode(message.method[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.ServiceOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified ServiceDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.ServiceDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.IServiceDescriptorProto} message ServiceDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ServiceDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ServiceDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.method && message.method.length))
                                    message.method = [];
                                message.method.push($root.google.protobuf.MethodDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                message.options = $root.google.protobuf.ServiceOptions.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ServiceDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ServiceDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ServiceDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.method != null && message.hasOwnProperty("method")) {
                        if (!Array.isArray(message.method))
                            return "method: array expected";
                        for (var i = 0; i < message.method.length; ++i) {
                            var error = $root.google.protobuf.MethodDescriptorProto.verify(message.method[i]);
                            if (error)
                                return "method." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.ServiceOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a ServiceDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
                 */
                ServiceDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.ServiceDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.ServiceDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.method) {
                        if (!Array.isArray(object.method))
                            throw TypeError(".google.protobuf.ServiceDescriptorProto.method: array expected");
                        message.method = [];
                        for (var i = 0; i < object.method.length; ++i) {
                            if (typeof object.method[i] !== "object")
                                throw TypeError(".google.protobuf.ServiceDescriptorProto.method: object expected");
                            message.method[i] = $root.google.protobuf.MethodDescriptorProto.fromObject(object.method[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.ServiceDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.ServiceOptions.fromObject(object.options);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a ServiceDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.ServiceDescriptorProto} message ServiceDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ServiceDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.method = [];
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.method && message.method.length) {
                        object.method = [];
                        for (var j = 0; j < message.method.length; ++j)
                            object.method[j] = $root.google.protobuf.MethodDescriptorProto.toObject(message.method[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.ServiceOptions.toObject(message.options, options);
                    return object;
                };
    
                /**
                 * Converts this ServiceDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ServiceDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ServiceDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ServiceDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.ServiceDescriptorProto";
                };
    
                return ServiceDescriptorProto;
            })();
    
            protobuf.MethodDescriptorProto = (function() {
    
                /**
                 * Properties of a MethodDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IMethodDescriptorProto
                 * @property {string|null} [name] MethodDescriptorProto name
                 * @property {string|null} [inputType] MethodDescriptorProto inputType
                 * @property {string|null} [outputType] MethodDescriptorProto outputType
                 * @property {google.protobuf.IMethodOptions|null} [options] MethodDescriptorProto options
                 * @property {boolean|null} [clientStreaming] MethodDescriptorProto clientStreaming
                 * @property {boolean|null} [serverStreaming] MethodDescriptorProto serverStreaming
                 */
    
                /**
                 * Constructs a new MethodDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a MethodDescriptorProto.
                 * @implements IMethodDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IMethodDescriptorProto=} [properties] Properties to set
                 */
                function MethodDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * MethodDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.name = "";
    
                /**
                 * MethodDescriptorProto inputType.
                 * @member {string} inputType
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.inputType = "";
    
                /**
                 * MethodDescriptorProto outputType.
                 * @member {string} outputType
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.outputType = "";
    
                /**
                 * MethodDescriptorProto options.
                 * @member {google.protobuf.IMethodOptions|null|undefined} options
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.options = null;
    
                /**
                 * MethodDescriptorProto clientStreaming.
                 * @member {boolean} clientStreaming
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.clientStreaming = false;
    
                /**
                 * MethodDescriptorProto serverStreaming.
                 * @member {boolean} serverStreaming
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.serverStreaming = false;
    
                /**
                 * Creates a new MethodDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.IMethodDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto instance
                 */
                MethodDescriptorProto.create = function create(properties) {
                    return new MethodDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified MethodDescriptorProto message. Does not implicitly {@link google.protobuf.MethodDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.IMethodDescriptorProto} message MethodDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.inputType != null && Object.hasOwnProperty.call(message, "inputType"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.inputType);
                    if (message.outputType != null && Object.hasOwnProperty.call(message, "outputType"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.outputType);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.MethodOptions.encode(message.options, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.clientStreaming != null && Object.hasOwnProperty.call(message, "clientStreaming"))
                        writer.uint32(/* id 5, wireType 0 =*/40).bool(message.clientStreaming);
                    if (message.serverStreaming != null && Object.hasOwnProperty.call(message, "serverStreaming"))
                        writer.uint32(/* id 6, wireType 0 =*/48).bool(message.serverStreaming);
                    return writer;
                };
    
                /**
                 * Encodes the specified MethodDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.MethodDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.IMethodDescriptorProto} message MethodDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a MethodDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MethodDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message.inputType = reader.string();
                                break;
                            }
                        case 3: {
                                message.outputType = reader.string();
                                break;
                            }
                        case 4: {
                                message.options = $root.google.protobuf.MethodOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 5: {
                                message.clientStreaming = reader.bool();
                                break;
                            }
                        case 6: {
                                message.serverStreaming = reader.bool();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a MethodDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a MethodDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                MethodDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.inputType != null && message.hasOwnProperty("inputType"))
                        if (!$util.isString(message.inputType))
                            return "inputType: string expected";
                    if (message.outputType != null && message.hasOwnProperty("outputType"))
                        if (!$util.isString(message.outputType))
                            return "outputType: string expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.MethodOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.clientStreaming != null && message.hasOwnProperty("clientStreaming"))
                        if (typeof message.clientStreaming !== "boolean")
                            return "clientStreaming: boolean expected";
                    if (message.serverStreaming != null && message.hasOwnProperty("serverStreaming"))
                        if (typeof message.serverStreaming !== "boolean")
                            return "serverStreaming: boolean expected";
                    return null;
                };
    
                /**
                 * Creates a MethodDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
                 */
                MethodDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.MethodDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.MethodDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.inputType != null)
                        message.inputType = String(object.inputType);
                    if (object.outputType != null)
                        message.outputType = String(object.outputType);
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.MethodDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.MethodOptions.fromObject(object.options);
                    }
                    if (object.clientStreaming != null)
                        message.clientStreaming = Boolean(object.clientStreaming);
                    if (object.serverStreaming != null)
                        message.serverStreaming = Boolean(object.serverStreaming);
                    return message;
                };
    
                /**
                 * Creates a plain object from a MethodDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.MethodDescriptorProto} message MethodDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                MethodDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.inputType = "";
                        object.outputType = "";
                        object.options = null;
                        object.clientStreaming = false;
                        object.serverStreaming = false;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.inputType != null && message.hasOwnProperty("inputType"))
                        object.inputType = message.inputType;
                    if (message.outputType != null && message.hasOwnProperty("outputType"))
                        object.outputType = message.outputType;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.MethodOptions.toObject(message.options, options);
                    if (message.clientStreaming != null && message.hasOwnProperty("clientStreaming"))
                        object.clientStreaming = message.clientStreaming;
                    if (message.serverStreaming != null && message.hasOwnProperty("serverStreaming"))
                        object.serverStreaming = message.serverStreaming;
                    return object;
                };
    
                /**
                 * Converts this MethodDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                MethodDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for MethodDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                MethodDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.MethodDescriptorProto";
                };
    
                return MethodDescriptorProto;
            })();
    
            protobuf.FileOptions = (function() {
    
                /**
                 * Properties of a FileOptions.
                 * @memberof google.protobuf
                 * @interface IFileOptions
                 * @property {string|null} [javaPackage] FileOptions javaPackage
                 * @property {string|null} [javaOuterClassname] FileOptions javaOuterClassname
                 * @property {boolean|null} [javaMultipleFiles] FileOptions javaMultipleFiles
                 * @property {boolean|null} [javaGenerateEqualsAndHash] FileOptions javaGenerateEqualsAndHash
                 * @property {boolean|null} [javaStringCheckUtf8] FileOptions javaStringCheckUtf8
                 * @property {google.protobuf.FileOptions.OptimizeMode|null} [optimizeFor] FileOptions optimizeFor
                 * @property {string|null} [goPackage] FileOptions goPackage
                 * @property {boolean|null} [ccGenericServices] FileOptions ccGenericServices
                 * @property {boolean|null} [javaGenericServices] FileOptions javaGenericServices
                 * @property {boolean|null} [pyGenericServices] FileOptions pyGenericServices
                 * @property {boolean|null} [phpGenericServices] FileOptions phpGenericServices
                 * @property {boolean|null} [deprecated] FileOptions deprecated
                 * @property {boolean|null} [ccEnableArenas] FileOptions ccEnableArenas
                 * @property {string|null} [objcClassPrefix] FileOptions objcClassPrefix
                 * @property {string|null} [csharpNamespace] FileOptions csharpNamespace
                 * @property {string|null} [swiftPrefix] FileOptions swiftPrefix
                 * @property {string|null} [phpClassPrefix] FileOptions phpClassPrefix
                 * @property {string|null} [phpNamespace] FileOptions phpNamespace
                 * @property {string|null} [phpMetadataNamespace] FileOptions phpMetadataNamespace
                 * @property {string|null} [rubyPackage] FileOptions rubyPackage
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] FileOptions uninterpretedOption
                 * @property {Array.<google.api.IResourceDescriptor>|null} [".google.api.resourceDefinition"] FileOptions .google.api.resourceDefinition
                 */
    
                /**
                 * Constructs a new FileOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a FileOptions.
                 * @implements IFileOptions
                 * @constructor
                 * @param {google.protobuf.IFileOptions=} [properties] Properties to set
                 */
                function FileOptions(properties) {
                    this.uninterpretedOption = [];
                    this[".google.api.resourceDefinition"] = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FileOptions javaPackage.
                 * @member {string} javaPackage
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaPackage = "";
    
                /**
                 * FileOptions javaOuterClassname.
                 * @member {string} javaOuterClassname
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaOuterClassname = "";
    
                /**
                 * FileOptions javaMultipleFiles.
                 * @member {boolean} javaMultipleFiles
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaMultipleFiles = false;
    
                /**
                 * FileOptions javaGenerateEqualsAndHash.
                 * @member {boolean} javaGenerateEqualsAndHash
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaGenerateEqualsAndHash = false;
    
                /**
                 * FileOptions javaStringCheckUtf8.
                 * @member {boolean} javaStringCheckUtf8
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaStringCheckUtf8 = false;
    
                /**
                 * FileOptions optimizeFor.
                 * @member {google.protobuf.FileOptions.OptimizeMode} optimizeFor
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.optimizeFor = 1;
    
                /**
                 * FileOptions goPackage.
                 * @member {string} goPackage
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.goPackage = "";
    
                /**
                 * FileOptions ccGenericServices.
                 * @member {boolean} ccGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.ccGenericServices = false;
    
                /**
                 * FileOptions javaGenericServices.
                 * @member {boolean} javaGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaGenericServices = false;
    
                /**
                 * FileOptions pyGenericServices.
                 * @member {boolean} pyGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.pyGenericServices = false;
    
                /**
                 * FileOptions phpGenericServices.
                 * @member {boolean} phpGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpGenericServices = false;
    
                /**
                 * FileOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.deprecated = false;
    
                /**
                 * FileOptions ccEnableArenas.
                 * @member {boolean} ccEnableArenas
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.ccEnableArenas = true;
    
                /**
                 * FileOptions objcClassPrefix.
                 * @member {string} objcClassPrefix
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.objcClassPrefix = "";
    
                /**
                 * FileOptions csharpNamespace.
                 * @member {string} csharpNamespace
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.csharpNamespace = "";
    
                /**
                 * FileOptions swiftPrefix.
                 * @member {string} swiftPrefix
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.swiftPrefix = "";
    
                /**
                 * FileOptions phpClassPrefix.
                 * @member {string} phpClassPrefix
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpClassPrefix = "";
    
                /**
                 * FileOptions phpNamespace.
                 * @member {string} phpNamespace
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpNamespace = "";
    
                /**
                 * FileOptions phpMetadataNamespace.
                 * @member {string} phpMetadataNamespace
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpMetadataNamespace = "";
    
                /**
                 * FileOptions rubyPackage.
                 * @member {string} rubyPackage
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.rubyPackage = "";
    
                /**
                 * FileOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * FileOptions .google.api.resourceDefinition.
                 * @member {Array.<google.api.IResourceDescriptor>} .google.api.resourceDefinition
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype[".google.api.resourceDefinition"] = $util.emptyArray;
    
                /**
                 * Creates a new FileOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.IFileOptions=} [properties] Properties to set
                 * @returns {google.protobuf.FileOptions} FileOptions instance
                 */
                FileOptions.create = function create(properties) {
                    return new FileOptions(properties);
                };
    
                /**
                 * Encodes the specified FileOptions message. Does not implicitly {@link google.protobuf.FileOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.IFileOptions} message FileOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.javaPackage != null && Object.hasOwnProperty.call(message, "javaPackage"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.javaPackage);
                    if (message.javaOuterClassname != null && Object.hasOwnProperty.call(message, "javaOuterClassname"))
                        writer.uint32(/* id 8, wireType 2 =*/66).string(message.javaOuterClassname);
                    if (message.optimizeFor != null && Object.hasOwnProperty.call(message, "optimizeFor"))
                        writer.uint32(/* id 9, wireType 0 =*/72).int32(message.optimizeFor);
                    if (message.javaMultipleFiles != null && Object.hasOwnProperty.call(message, "javaMultipleFiles"))
                        writer.uint32(/* id 10, wireType 0 =*/80).bool(message.javaMultipleFiles);
                    if (message.goPackage != null && Object.hasOwnProperty.call(message, "goPackage"))
                        writer.uint32(/* id 11, wireType 2 =*/90).string(message.goPackage);
                    if (message.ccGenericServices != null && Object.hasOwnProperty.call(message, "ccGenericServices"))
                        writer.uint32(/* id 16, wireType 0 =*/128).bool(message.ccGenericServices);
                    if (message.javaGenericServices != null && Object.hasOwnProperty.call(message, "javaGenericServices"))
                        writer.uint32(/* id 17, wireType 0 =*/136).bool(message.javaGenericServices);
                    if (message.pyGenericServices != null && Object.hasOwnProperty.call(message, "pyGenericServices"))
                        writer.uint32(/* id 18, wireType 0 =*/144).bool(message.pyGenericServices);
                    if (message.javaGenerateEqualsAndHash != null && Object.hasOwnProperty.call(message, "javaGenerateEqualsAndHash"))
                        writer.uint32(/* id 20, wireType 0 =*/160).bool(message.javaGenerateEqualsAndHash);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 23, wireType 0 =*/184).bool(message.deprecated);
                    if (message.javaStringCheckUtf8 != null && Object.hasOwnProperty.call(message, "javaStringCheckUtf8"))
                        writer.uint32(/* id 27, wireType 0 =*/216).bool(message.javaStringCheckUtf8);
                    if (message.ccEnableArenas != null && Object.hasOwnProperty.call(message, "ccEnableArenas"))
                        writer.uint32(/* id 31, wireType 0 =*/248).bool(message.ccEnableArenas);
                    if (message.objcClassPrefix != null && Object.hasOwnProperty.call(message, "objcClassPrefix"))
                        writer.uint32(/* id 36, wireType 2 =*/290).string(message.objcClassPrefix);
                    if (message.csharpNamespace != null && Object.hasOwnProperty.call(message, "csharpNamespace"))
                        writer.uint32(/* id 37, wireType 2 =*/298).string(message.csharpNamespace);
                    if (message.swiftPrefix != null && Object.hasOwnProperty.call(message, "swiftPrefix"))
                        writer.uint32(/* id 39, wireType 2 =*/314).string(message.swiftPrefix);
                    if (message.phpClassPrefix != null && Object.hasOwnProperty.call(message, "phpClassPrefix"))
                        writer.uint32(/* id 40, wireType 2 =*/322).string(message.phpClassPrefix);
                    if (message.phpNamespace != null && Object.hasOwnProperty.call(message, "phpNamespace"))
                        writer.uint32(/* id 41, wireType 2 =*/330).string(message.phpNamespace);
                    if (message.phpGenericServices != null && Object.hasOwnProperty.call(message, "phpGenericServices"))
                        writer.uint32(/* id 42, wireType 0 =*/336).bool(message.phpGenericServices);
                    if (message.phpMetadataNamespace != null && Object.hasOwnProperty.call(message, "phpMetadataNamespace"))
                        writer.uint32(/* id 44, wireType 2 =*/354).string(message.phpMetadataNamespace);
                    if (message.rubyPackage != null && Object.hasOwnProperty.call(message, "rubyPackage"))
                        writer.uint32(/* id 45, wireType 2 =*/362).string(message.rubyPackage);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.resourceDefinition"] != null && message[".google.api.resourceDefinition"].length)
                        for (var i = 0; i < message[".google.api.resourceDefinition"].length; ++i)
                            $root.google.api.ResourceDescriptor.encode(message[".google.api.resourceDefinition"][i], writer.uint32(/* id 1053, wireType 2 =*/8426).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified FileOptions message, length delimited. Does not implicitly {@link google.protobuf.FileOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.IFileOptions} message FileOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FileOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FileOptions} FileOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.javaPackage = reader.string();
                                break;
                            }
                        case 8: {
                                message.javaOuterClassname = reader.string();
                                break;
                            }
                        case 10: {
                                message.javaMultipleFiles = reader.bool();
                                break;
                            }
                        case 20: {
                                message.javaGenerateEqualsAndHash = reader.bool();
                                break;
                            }
                        case 27: {
                                message.javaStringCheckUtf8 = reader.bool();
                                break;
                            }
                        case 9: {
                                message.optimizeFor = reader.int32();
                                break;
                            }
                        case 11: {
                                message.goPackage = reader.string();
                                break;
                            }
                        case 16: {
                                message.ccGenericServices = reader.bool();
                                break;
                            }
                        case 17: {
                                message.javaGenericServices = reader.bool();
                                break;
                            }
                        case 18: {
                                message.pyGenericServices = reader.bool();
                                break;
                            }
                        case 42: {
                                message.phpGenericServices = reader.bool();
                                break;
                            }
                        case 23: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 31: {
                                message.ccEnableArenas = reader.bool();
                                break;
                            }
                        case 36: {
                                message.objcClassPrefix = reader.string();
                                break;
                            }
                        case 37: {
                                message.csharpNamespace = reader.string();
                                break;
                            }
                        case 39: {
                                message.swiftPrefix = reader.string();
                                break;
                            }
                        case 40: {
                                message.phpClassPrefix = reader.string();
                                break;
                            }
                        case 41: {
                                message.phpNamespace = reader.string();
                                break;
                            }
                        case 44: {
                                message.phpMetadataNamespace = reader.string();
                                break;
                            }
                        case 45: {
                                message.rubyPackage = reader.string();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1053: {
                                if (!(message[".google.api.resourceDefinition"] && message[".google.api.resourceDefinition"].length))
                                    message[".google.api.resourceDefinition"] = [];
                                message[".google.api.resourceDefinition"].push($root.google.api.ResourceDescriptor.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FileOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FileOptions} FileOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FileOptions message.
                 * @function verify
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FileOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.javaPackage != null && message.hasOwnProperty("javaPackage"))
                        if (!$util.isString(message.javaPackage))
                            return "javaPackage: string expected";
                    if (message.javaOuterClassname != null && message.hasOwnProperty("javaOuterClassname"))
                        if (!$util.isString(message.javaOuterClassname))
                            return "javaOuterClassname: string expected";
                    if (message.javaMultipleFiles != null && message.hasOwnProperty("javaMultipleFiles"))
                        if (typeof message.javaMultipleFiles !== "boolean")
                            return "javaMultipleFiles: boolean expected";
                    if (message.javaGenerateEqualsAndHash != null && message.hasOwnProperty("javaGenerateEqualsAndHash"))
                        if (typeof message.javaGenerateEqualsAndHash !== "boolean")
                            return "javaGenerateEqualsAndHash: boolean expected";
                    if (message.javaStringCheckUtf8 != null && message.hasOwnProperty("javaStringCheckUtf8"))
                        if (typeof message.javaStringCheckUtf8 !== "boolean")
                            return "javaStringCheckUtf8: boolean expected";
                    if (message.optimizeFor != null && message.hasOwnProperty("optimizeFor"))
                        switch (message.optimizeFor) {
                        default:
                            return "optimizeFor: enum value expected";
                        case 1:
                        case 2:
                        case 3:
                            break;
                        }
                    if (message.goPackage != null && message.hasOwnProperty("goPackage"))
                        if (!$util.isString(message.goPackage))
                            return "goPackage: string expected";
                    if (message.ccGenericServices != null && message.hasOwnProperty("ccGenericServices"))
                        if (typeof message.ccGenericServices !== "boolean")
                            return "ccGenericServices: boolean expected";
                    if (message.javaGenericServices != null && message.hasOwnProperty("javaGenericServices"))
                        if (typeof message.javaGenericServices !== "boolean")
                            return "javaGenericServices: boolean expected";
                    if (message.pyGenericServices != null && message.hasOwnProperty("pyGenericServices"))
                        if (typeof message.pyGenericServices !== "boolean")
                            return "pyGenericServices: boolean expected";
                    if (message.phpGenericServices != null && message.hasOwnProperty("phpGenericServices"))
                        if (typeof message.phpGenericServices !== "boolean")
                            return "phpGenericServices: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.ccEnableArenas != null && message.hasOwnProperty("ccEnableArenas"))
                        if (typeof message.ccEnableArenas !== "boolean")
                            return "ccEnableArenas: boolean expected";
                    if (message.objcClassPrefix != null && message.hasOwnProperty("objcClassPrefix"))
                        if (!$util.isString(message.objcClassPrefix))
                            return "objcClassPrefix: string expected";
                    if (message.csharpNamespace != null && message.hasOwnProperty("csharpNamespace"))
                        if (!$util.isString(message.csharpNamespace))
                            return "csharpNamespace: string expected";
                    if (message.swiftPrefix != null && message.hasOwnProperty("swiftPrefix"))
                        if (!$util.isString(message.swiftPrefix))
                            return "swiftPrefix: string expected";
                    if (message.phpClassPrefix != null && message.hasOwnProperty("phpClassPrefix"))
                        if (!$util.isString(message.phpClassPrefix))
                            return "phpClassPrefix: string expected";
                    if (message.phpNamespace != null && message.hasOwnProperty("phpNamespace"))
                        if (!$util.isString(message.phpNamespace))
                            return "phpNamespace: string expected";
                    if (message.phpMetadataNamespace != null && message.hasOwnProperty("phpMetadataNamespace"))
                        if (!$util.isString(message.phpMetadataNamespace))
                            return "phpMetadataNamespace: string expected";
                    if (message.rubyPackage != null && message.hasOwnProperty("rubyPackage"))
                        if (!$util.isString(message.rubyPackage))
                            return "rubyPackage: string expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.resourceDefinition"] != null && message.hasOwnProperty(".google.api.resourceDefinition")) {
                        if (!Array.isArray(message[".google.api.resourceDefinition"]))
                            return ".google.api.resourceDefinition: array expected";
                        for (var i = 0; i < message[".google.api.resourceDefinition"].length; ++i) {
                            var error = $root.google.api.ResourceDescriptor.verify(message[".google.api.resourceDefinition"][i]);
                            if (error)
                                return ".google.api.resourceDefinition." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a FileOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FileOptions} FileOptions
                 */
                FileOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FileOptions)
                        return object;
                    var message = new $root.google.protobuf.FileOptions();
                    if (object.javaPackage != null)
                        message.javaPackage = String(object.javaPackage);
                    if (object.javaOuterClassname != null)
                        message.javaOuterClassname = String(object.javaOuterClassname);
                    if (object.javaMultipleFiles != null)
                        message.javaMultipleFiles = Boolean(object.javaMultipleFiles);
                    if (object.javaGenerateEqualsAndHash != null)
                        message.javaGenerateEqualsAndHash = Boolean(object.javaGenerateEqualsAndHash);
                    if (object.javaStringCheckUtf8 != null)
                        message.javaStringCheckUtf8 = Boolean(object.javaStringCheckUtf8);
                    switch (object.optimizeFor) {
                    default:
                        if (typeof object.optimizeFor === "number") {
                            message.optimizeFor = object.optimizeFor;
                            break;
                        }
                        break;
                    case "SPEED":
                    case 1:
                        message.optimizeFor = 1;
                        break;
                    case "CODE_SIZE":
                    case 2:
                        message.optimizeFor = 2;
                        break;
                    case "LITE_RUNTIME":
                    case 3:
                        message.optimizeFor = 3;
                        break;
                    }
                    if (object.goPackage != null)
                        message.goPackage = String(object.goPackage);
                    if (object.ccGenericServices != null)
                        message.ccGenericServices = Boolean(object.ccGenericServices);
                    if (object.javaGenericServices != null)
                        message.javaGenericServices = Boolean(object.javaGenericServices);
                    if (object.pyGenericServices != null)
                        message.pyGenericServices = Boolean(object.pyGenericServices);
                    if (object.phpGenericServices != null)
                        message.phpGenericServices = Boolean(object.phpGenericServices);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.ccEnableArenas != null)
                        message.ccEnableArenas = Boolean(object.ccEnableArenas);
                    if (object.objcClassPrefix != null)
                        message.objcClassPrefix = String(object.objcClassPrefix);
                    if (object.csharpNamespace != null)
                        message.csharpNamespace = String(object.csharpNamespace);
                    if (object.swiftPrefix != null)
                        message.swiftPrefix = String(object.swiftPrefix);
                    if (object.phpClassPrefix != null)
                        message.phpClassPrefix = String(object.phpClassPrefix);
                    if (object.phpNamespace != null)
                        message.phpNamespace = String(object.phpNamespace);
                    if (object.phpMetadataNamespace != null)
                        message.phpMetadataNamespace = String(object.phpMetadataNamespace);
                    if (object.rubyPackage != null)
                        message.rubyPackage = String(object.rubyPackage);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.FileOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.FileOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.resourceDefinition"]) {
                        if (!Array.isArray(object[".google.api.resourceDefinition"]))
                            throw TypeError(".google.protobuf.FileOptions..google.api.resourceDefinition: array expected");
                        message[".google.api.resourceDefinition"] = [];
                        for (var i = 0; i < object[".google.api.resourceDefinition"].length; ++i) {
                            if (typeof object[".google.api.resourceDefinition"][i] !== "object")
                                throw TypeError(".google.protobuf.FileOptions..google.api.resourceDefinition: object expected");
                            message[".google.api.resourceDefinition"][i] = $root.google.api.ResourceDescriptor.fromObject(object[".google.api.resourceDefinition"][i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a FileOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.FileOptions} message FileOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FileOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.uninterpretedOption = [];
                        object[".google.api.resourceDefinition"] = [];
                    }
                    if (options.defaults) {
                        object.javaPackage = "";
                        object.javaOuterClassname = "";
                        object.optimizeFor = options.enums === String ? "SPEED" : 1;
                        object.javaMultipleFiles = false;
                        object.goPackage = "";
                        object.ccGenericServices = false;
                        object.javaGenericServices = false;
                        object.pyGenericServices = false;
                        object.javaGenerateEqualsAndHash = false;
                        object.deprecated = false;
                        object.javaStringCheckUtf8 = false;
                        object.ccEnableArenas = true;
                        object.objcClassPrefix = "";
                        object.csharpNamespace = "";
                        object.swiftPrefix = "";
                        object.phpClassPrefix = "";
                        object.phpNamespace = "";
                        object.phpGenericServices = false;
                        object.phpMetadataNamespace = "";
                        object.rubyPackage = "";
                    }
                    if (message.javaPackage != null && message.hasOwnProperty("javaPackage"))
                        object.javaPackage = message.javaPackage;
                    if (message.javaOuterClassname != null && message.hasOwnProperty("javaOuterClassname"))
                        object.javaOuterClassname = message.javaOuterClassname;
                    if (message.optimizeFor != null && message.hasOwnProperty("optimizeFor"))
                        object.optimizeFor = options.enums === String ? $root.google.protobuf.FileOptions.OptimizeMode[message.optimizeFor] === undefined ? message.optimizeFor : $root.google.protobuf.FileOptions.OptimizeMode[message.optimizeFor] : message.optimizeFor;
                    if (message.javaMultipleFiles != null && message.hasOwnProperty("javaMultipleFiles"))
                        object.javaMultipleFiles = message.javaMultipleFiles;
                    if (message.goPackage != null && message.hasOwnProperty("goPackage"))
                        object.goPackage = message.goPackage;
                    if (message.ccGenericServices != null && message.hasOwnProperty("ccGenericServices"))
                        object.ccGenericServices = message.ccGenericServices;
                    if (message.javaGenericServices != null && message.hasOwnProperty("javaGenericServices"))
                        object.javaGenericServices = message.javaGenericServices;
                    if (message.pyGenericServices != null && message.hasOwnProperty("pyGenericServices"))
                        object.pyGenericServices = message.pyGenericServices;
                    if (message.javaGenerateEqualsAndHash != null && message.hasOwnProperty("javaGenerateEqualsAndHash"))
                        object.javaGenerateEqualsAndHash = message.javaGenerateEqualsAndHash;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.javaStringCheckUtf8 != null && message.hasOwnProperty("javaStringCheckUtf8"))
                        object.javaStringCheckUtf8 = message.javaStringCheckUtf8;
                    if (message.ccEnableArenas != null && message.hasOwnProperty("ccEnableArenas"))
                        object.ccEnableArenas = message.ccEnableArenas;
                    if (message.objcClassPrefix != null && message.hasOwnProperty("objcClassPrefix"))
                        object.objcClassPrefix = message.objcClassPrefix;
                    if (message.csharpNamespace != null && message.hasOwnProperty("csharpNamespace"))
                        object.csharpNamespace = message.csharpNamespace;
                    if (message.swiftPrefix != null && message.hasOwnProperty("swiftPrefix"))
                        object.swiftPrefix = message.swiftPrefix;
                    if (message.phpClassPrefix != null && message.hasOwnProperty("phpClassPrefix"))
                        object.phpClassPrefix = message.phpClassPrefix;
                    if (message.phpNamespace != null && message.hasOwnProperty("phpNamespace"))
                        object.phpNamespace = message.phpNamespace;
                    if (message.phpGenericServices != null && message.hasOwnProperty("phpGenericServices"))
                        object.phpGenericServices = message.phpGenericServices;
                    if (message.phpMetadataNamespace != null && message.hasOwnProperty("phpMetadataNamespace"))
                        object.phpMetadataNamespace = message.phpMetadataNamespace;
                    if (message.rubyPackage != null && message.hasOwnProperty("rubyPackage"))
                        object.rubyPackage = message.rubyPackage;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.resourceDefinition"] && message[".google.api.resourceDefinition"].length) {
                        object[".google.api.resourceDefinition"] = [];
                        for (var j = 0; j < message[".google.api.resourceDefinition"].length; ++j)
                            object[".google.api.resourceDefinition"][j] = $root.google.api.ResourceDescriptor.toObject(message[".google.api.resourceDefinition"][j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this FileOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FileOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FileOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FileOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FileOptions";
                };
    
                /**
                 * OptimizeMode enum.
                 * @name google.protobuf.FileOptions.OptimizeMode
                 * @enum {number}
                 * @property {number} SPEED=1 SPEED value
                 * @property {number} CODE_SIZE=2 CODE_SIZE value
                 * @property {number} LITE_RUNTIME=3 LITE_RUNTIME value
                 */
                FileOptions.OptimizeMode = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[1] = "SPEED"] = 1;
                    values[valuesById[2] = "CODE_SIZE"] = 2;
                    values[valuesById[3] = "LITE_RUNTIME"] = 3;
                    return values;
                })();
    
                return FileOptions;
            })();
    
            protobuf.MessageOptions = (function() {
    
                /**
                 * Properties of a MessageOptions.
                 * @memberof google.protobuf
                 * @interface IMessageOptions
                 * @property {boolean|null} [messageSetWireFormat] MessageOptions messageSetWireFormat
                 * @property {boolean|null} [noStandardDescriptorAccessor] MessageOptions noStandardDescriptorAccessor
                 * @property {boolean|null} [deprecated] MessageOptions deprecated
                 * @property {boolean|null} [mapEntry] MessageOptions mapEntry
                 * @property {boolean|null} [deprecatedLegacyJsonFieldConflicts] MessageOptions deprecatedLegacyJsonFieldConflicts
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] MessageOptions uninterpretedOption
                 * @property {google.api.IResourceDescriptor|null} [".google.api.resource"] MessageOptions .google.api.resource
                 */
    
                /**
                 * Constructs a new MessageOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a MessageOptions.
                 * @implements IMessageOptions
                 * @constructor
                 * @param {google.protobuf.IMessageOptions=} [properties] Properties to set
                 */
                function MessageOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * MessageOptions messageSetWireFormat.
                 * @member {boolean} messageSetWireFormat
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.messageSetWireFormat = false;
    
                /**
                 * MessageOptions noStandardDescriptorAccessor.
                 * @member {boolean} noStandardDescriptorAccessor
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.noStandardDescriptorAccessor = false;
    
                /**
                 * MessageOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.deprecated = false;
    
                /**
                 * MessageOptions mapEntry.
                 * @member {boolean} mapEntry
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.mapEntry = false;
    
                /**
                 * MessageOptions deprecatedLegacyJsonFieldConflicts.
                 * @member {boolean} deprecatedLegacyJsonFieldConflicts
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.deprecatedLegacyJsonFieldConflicts = false;
    
                /**
                 * MessageOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * MessageOptions .google.api.resource.
                 * @member {google.api.IResourceDescriptor|null|undefined} .google.api.resource
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype[".google.api.resource"] = null;
    
                /**
                 * Creates a new MessageOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.IMessageOptions=} [properties] Properties to set
                 * @returns {google.protobuf.MessageOptions} MessageOptions instance
                 */
                MessageOptions.create = function create(properties) {
                    return new MessageOptions(properties);
                };
    
                /**
                 * Encodes the specified MessageOptions message. Does not implicitly {@link google.protobuf.MessageOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.IMessageOptions} message MessageOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MessageOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.messageSetWireFormat != null && Object.hasOwnProperty.call(message, "messageSetWireFormat"))
                        writer.uint32(/* id 1, wireType 0 =*/8).bool(message.messageSetWireFormat);
                    if (message.noStandardDescriptorAccessor != null && Object.hasOwnProperty.call(message, "noStandardDescriptorAccessor"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.noStandardDescriptorAccessor);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                    if (message.mapEntry != null && Object.hasOwnProperty.call(message, "mapEntry"))
                        writer.uint32(/* id 7, wireType 0 =*/56).bool(message.mapEntry);
                    if (message.deprecatedLegacyJsonFieldConflicts != null && Object.hasOwnProperty.call(message, "deprecatedLegacyJsonFieldConflicts"))
                        writer.uint32(/* id 11, wireType 0 =*/88).bool(message.deprecatedLegacyJsonFieldConflicts);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.resource"] != null && Object.hasOwnProperty.call(message, ".google.api.resource"))
                        $root.google.api.ResourceDescriptor.encode(message[".google.api.resource"], writer.uint32(/* id 1053, wireType 2 =*/8426).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified MessageOptions message, length delimited. Does not implicitly {@link google.protobuf.MessageOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.IMessageOptions} message MessageOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MessageOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a MessageOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.MessageOptions} MessageOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MessageOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MessageOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.messageSetWireFormat = reader.bool();
                                break;
                            }
                        case 2: {
                                message.noStandardDescriptorAccessor = reader.bool();
                                break;
                            }
                        case 3: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 7: {
                                message.mapEntry = reader.bool();
                                break;
                            }
                        case 11: {
                                message.deprecatedLegacyJsonFieldConflicts = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1053: {
                                message[".google.api.resource"] = $root.google.api.ResourceDescriptor.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a MessageOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.MessageOptions} MessageOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MessageOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a MessageOptions message.
                 * @function verify
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                MessageOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.messageSetWireFormat != null && message.hasOwnProperty("messageSetWireFormat"))
                        if (typeof message.messageSetWireFormat !== "boolean")
                            return "messageSetWireFormat: boolean expected";
                    if (message.noStandardDescriptorAccessor != null && message.hasOwnProperty("noStandardDescriptorAccessor"))
                        if (typeof message.noStandardDescriptorAccessor !== "boolean")
                            return "noStandardDescriptorAccessor: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.mapEntry != null && message.hasOwnProperty("mapEntry"))
                        if (typeof message.mapEntry !== "boolean")
                            return "mapEntry: boolean expected";
                    if (message.deprecatedLegacyJsonFieldConflicts != null && message.hasOwnProperty("deprecatedLegacyJsonFieldConflicts"))
                        if (typeof message.deprecatedLegacyJsonFieldConflicts !== "boolean")
                            return "deprecatedLegacyJsonFieldConflicts: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.resource"] != null && message.hasOwnProperty(".google.api.resource")) {
                        var error = $root.google.api.ResourceDescriptor.verify(message[".google.api.resource"]);
                        if (error)
                            return ".google.api.resource." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a MessageOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.MessageOptions} MessageOptions
                 */
                MessageOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.MessageOptions)
                        return object;
                    var message = new $root.google.protobuf.MessageOptions();
                    if (object.messageSetWireFormat != null)
                        message.messageSetWireFormat = Boolean(object.messageSetWireFormat);
                    if (object.noStandardDescriptorAccessor != null)
                        message.noStandardDescriptorAccessor = Boolean(object.noStandardDescriptorAccessor);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.mapEntry != null)
                        message.mapEntry = Boolean(object.mapEntry);
                    if (object.deprecatedLegacyJsonFieldConflicts != null)
                        message.deprecatedLegacyJsonFieldConflicts = Boolean(object.deprecatedLegacyJsonFieldConflicts);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.MessageOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.MessageOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.resource"] != null) {
                        if (typeof object[".google.api.resource"] !== "object")
                            throw TypeError(".google.protobuf.MessageOptions..google.api.resource: object expected");
                        message[".google.api.resource"] = $root.google.api.ResourceDescriptor.fromObject(object[".google.api.resource"]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a MessageOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.MessageOptions} message MessageOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                MessageOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults) {
                        object.messageSetWireFormat = false;
                        object.noStandardDescriptorAccessor = false;
                        object.deprecated = false;
                        object.mapEntry = false;
                        object.deprecatedLegacyJsonFieldConflicts = false;
                        object[".google.api.resource"] = null;
                    }
                    if (message.messageSetWireFormat != null && message.hasOwnProperty("messageSetWireFormat"))
                        object.messageSetWireFormat = message.messageSetWireFormat;
                    if (message.noStandardDescriptorAccessor != null && message.hasOwnProperty("noStandardDescriptorAccessor"))
                        object.noStandardDescriptorAccessor = message.noStandardDescriptorAccessor;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.mapEntry != null && message.hasOwnProperty("mapEntry"))
                        object.mapEntry = message.mapEntry;
                    if (message.deprecatedLegacyJsonFieldConflicts != null && message.hasOwnProperty("deprecatedLegacyJsonFieldConflicts"))
                        object.deprecatedLegacyJsonFieldConflicts = message.deprecatedLegacyJsonFieldConflicts;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.resource"] != null && message.hasOwnProperty(".google.api.resource"))
                        object[".google.api.resource"] = $root.google.api.ResourceDescriptor.toObject(message[".google.api.resource"], options);
                    return object;
                };
    
                /**
                 * Converts this MessageOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                MessageOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for MessageOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                MessageOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.MessageOptions";
                };
    
                return MessageOptions;
            })();
    
            protobuf.FieldOptions = (function() {
    
                /**
                 * Properties of a FieldOptions.
                 * @memberof google.protobuf
                 * @interface IFieldOptions
                 * @property {google.protobuf.FieldOptions.CType|null} [ctype] FieldOptions ctype
                 * @property {boolean|null} [packed] FieldOptions packed
                 * @property {google.protobuf.FieldOptions.JSType|null} [jstype] FieldOptions jstype
                 * @property {boolean|null} [lazy] FieldOptions lazy
                 * @property {boolean|null} [unverifiedLazy] FieldOptions unverifiedLazy
                 * @property {boolean|null} [deprecated] FieldOptions deprecated
                 * @property {boolean|null} [weak] FieldOptions weak
                 * @property {boolean|null} [debugRedact] FieldOptions debugRedact
                 * @property {google.protobuf.FieldOptions.OptionRetention|null} [retention] FieldOptions retention
                 * @property {google.protobuf.FieldOptions.OptionTargetType|null} [target] FieldOptions target
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] FieldOptions uninterpretedOption
                 * @property {Array.<google.api.FieldBehavior>|null} [".google.api.fieldBehavior"] FieldOptions .google.api.fieldBehavior
                 * @property {google.api.IResourceReference|null} [".google.api.resourceReference"] FieldOptions .google.api.resourceReference
                 */
    
                /**
                 * Constructs a new FieldOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a FieldOptions.
                 * @implements IFieldOptions
                 * @constructor
                 * @param {google.protobuf.IFieldOptions=} [properties] Properties to set
                 */
                function FieldOptions(properties) {
                    this.uninterpretedOption = [];
                    this[".google.api.fieldBehavior"] = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FieldOptions ctype.
                 * @member {google.protobuf.FieldOptions.CType} ctype
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.ctype = 0;
    
                /**
                 * FieldOptions packed.
                 * @member {boolean} packed
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.packed = false;
    
                /**
                 * FieldOptions jstype.
                 * @member {google.protobuf.FieldOptions.JSType} jstype
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.jstype = 0;
    
                /**
                 * FieldOptions lazy.
                 * @member {boolean} lazy
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.lazy = false;
    
                /**
                 * FieldOptions unverifiedLazy.
                 * @member {boolean} unverifiedLazy
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.unverifiedLazy = false;
    
                /**
                 * FieldOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.deprecated = false;
    
                /**
                 * FieldOptions weak.
                 * @member {boolean} weak
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.weak = false;
    
                /**
                 * FieldOptions debugRedact.
                 * @member {boolean} debugRedact
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.debugRedact = false;
    
                /**
                 * FieldOptions retention.
                 * @member {google.protobuf.FieldOptions.OptionRetention} retention
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.retention = 0;
    
                /**
                 * FieldOptions target.
                 * @member {google.protobuf.FieldOptions.OptionTargetType} target
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.target = 0;
    
                /**
                 * FieldOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * FieldOptions .google.api.fieldBehavior.
                 * @member {Array.<google.api.FieldBehavior>} .google.api.fieldBehavior
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype[".google.api.fieldBehavior"] = $util.emptyArray;
    
                /**
                 * FieldOptions .google.api.resourceReference.
                 * @member {google.api.IResourceReference|null|undefined} .google.api.resourceReference
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype[".google.api.resourceReference"] = null;
    
                /**
                 * Creates a new FieldOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.IFieldOptions=} [properties] Properties to set
                 * @returns {google.protobuf.FieldOptions} FieldOptions instance
                 */
                FieldOptions.create = function create(properties) {
                    return new FieldOptions(properties);
                };
    
                /**
                 * Encodes the specified FieldOptions message. Does not implicitly {@link google.protobuf.FieldOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.IFieldOptions} message FieldOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.ctype != null && Object.hasOwnProperty.call(message, "ctype"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int32(message.ctype);
                    if (message.packed != null && Object.hasOwnProperty.call(message, "packed"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.packed);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                    if (message.lazy != null && Object.hasOwnProperty.call(message, "lazy"))
                        writer.uint32(/* id 5, wireType 0 =*/40).bool(message.lazy);
                    if (message.jstype != null && Object.hasOwnProperty.call(message, "jstype"))
                        writer.uint32(/* id 6, wireType 0 =*/48).int32(message.jstype);
                    if (message.weak != null && Object.hasOwnProperty.call(message, "weak"))
                        writer.uint32(/* id 10, wireType 0 =*/80).bool(message.weak);
                    if (message.unverifiedLazy != null && Object.hasOwnProperty.call(message, "unverifiedLazy"))
                        writer.uint32(/* id 15, wireType 0 =*/120).bool(message.unverifiedLazy);
                    if (message.debugRedact != null && Object.hasOwnProperty.call(message, "debugRedact"))
                        writer.uint32(/* id 16, wireType 0 =*/128).bool(message.debugRedact);
                    if (message.retention != null && Object.hasOwnProperty.call(message, "retention"))
                        writer.uint32(/* id 17, wireType 0 =*/136).int32(message.retention);
                    if (message.target != null && Object.hasOwnProperty.call(message, "target"))
                        writer.uint32(/* id 18, wireType 0 =*/144).int32(message.target);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.fieldBehavior"] != null && message[".google.api.fieldBehavior"].length) {
                        writer.uint32(/* id 1052, wireType 2 =*/8418).fork();
                        for (var i = 0; i < message[".google.api.fieldBehavior"].length; ++i)
                            writer.int32(message[".google.api.fieldBehavior"][i]);
                        writer.ldelim();
                    }
                    if (message[".google.api.resourceReference"] != null && Object.hasOwnProperty.call(message, ".google.api.resourceReference"))
                        $root.google.api.ResourceReference.encode(message[".google.api.resourceReference"], writer.uint32(/* id 1055, wireType 2 =*/8442).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified FieldOptions message, length delimited. Does not implicitly {@link google.protobuf.FieldOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.IFieldOptions} message FieldOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FieldOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FieldOptions} FieldOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.ctype = reader.int32();
                                break;
                            }
                        case 2: {
                                message.packed = reader.bool();
                                break;
                            }
                        case 6: {
                                message.jstype = reader.int32();
                                break;
                            }
                        case 5: {
                                message.lazy = reader.bool();
                                break;
                            }
                        case 15: {
                                message.unverifiedLazy = reader.bool();
                                break;
                            }
                        case 3: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 10: {
                                message.weak = reader.bool();
                                break;
                            }
                        case 16: {
                                message.debugRedact = reader.bool();
                                break;
                            }
                        case 17: {
                                message.retention = reader.int32();
                                break;
                            }
                        case 18: {
                                message.target = reader.int32();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1052: {
                                if (!(message[".google.api.fieldBehavior"] && message[".google.api.fieldBehavior"].length))
                                    message[".google.api.fieldBehavior"] = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message[".google.api.fieldBehavior"].push(reader.int32());
                                } else
                                    message[".google.api.fieldBehavior"].push(reader.int32());
                                break;
                            }
                        case 1055: {
                                message[".google.api.resourceReference"] = $root.google.api.ResourceReference.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FieldOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FieldOptions} FieldOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FieldOptions message.
                 * @function verify
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FieldOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.ctype != null && message.hasOwnProperty("ctype"))
                        switch (message.ctype) {
                        default:
                            return "ctype: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.packed != null && message.hasOwnProperty("packed"))
                        if (typeof message.packed !== "boolean")
                            return "packed: boolean expected";
                    if (message.jstype != null && message.hasOwnProperty("jstype"))
                        switch (message.jstype) {
                        default:
                            return "jstype: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.lazy != null && message.hasOwnProperty("lazy"))
                        if (typeof message.lazy !== "boolean")
                            return "lazy: boolean expected";
                    if (message.unverifiedLazy != null && message.hasOwnProperty("unverifiedLazy"))
                        if (typeof message.unverifiedLazy !== "boolean")
                            return "unverifiedLazy: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.weak != null && message.hasOwnProperty("weak"))
                        if (typeof message.weak !== "boolean")
                            return "weak: boolean expected";
                    if (message.debugRedact != null && message.hasOwnProperty("debugRedact"))
                        if (typeof message.debugRedact !== "boolean")
                            return "debugRedact: boolean expected";
                    if (message.retention != null && message.hasOwnProperty("retention"))
                        switch (message.retention) {
                        default:
                            return "retention: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.target != null && message.hasOwnProperty("target"))
                        switch (message.target) {
                        default:
                            return "target: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                        case 8:
                        case 9:
                            break;
                        }
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.fieldBehavior"] != null && message.hasOwnProperty(".google.api.fieldBehavior")) {
                        if (!Array.isArray(message[".google.api.fieldBehavior"]))
                            return ".google.api.fieldBehavior: array expected";
                        for (var i = 0; i < message[".google.api.fieldBehavior"].length; ++i)
                            switch (message[".google.api.fieldBehavior"][i]) {
                            default:
                                return ".google.api.fieldBehavior: enum value[] expected";
                            case 0:
                            case 1:
                            case 2:
                            case 3:
                            case 4:
                            case 5:
                            case 6:
                            case 7:
                                break;
                            }
                    }
                    if (message[".google.api.resourceReference"] != null && message.hasOwnProperty(".google.api.resourceReference")) {
                        var error = $root.google.api.ResourceReference.verify(message[".google.api.resourceReference"]);
                        if (error)
                            return ".google.api.resourceReference." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a FieldOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FieldOptions} FieldOptions
                 */
                FieldOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FieldOptions)
                        return object;
                    var message = new $root.google.protobuf.FieldOptions();
                    switch (object.ctype) {
                    default:
                        if (typeof object.ctype === "number") {
                            message.ctype = object.ctype;
                            break;
                        }
                        break;
                    case "STRING":
                    case 0:
                        message.ctype = 0;
                        break;
                    case "CORD":
                    case 1:
                        message.ctype = 1;
                        break;
                    case "STRING_PIECE":
                    case 2:
                        message.ctype = 2;
                        break;
                    }
                    if (object.packed != null)
                        message.packed = Boolean(object.packed);
                    switch (object.jstype) {
                    default:
                        if (typeof object.jstype === "number") {
                            message.jstype = object.jstype;
                            break;
                        }
                        break;
                    case "JS_NORMAL":
                    case 0:
                        message.jstype = 0;
                        break;
                    case "JS_STRING":
                    case 1:
                        message.jstype = 1;
                        break;
                    case "JS_NUMBER":
                    case 2:
                        message.jstype = 2;
                        break;
                    }
                    if (object.lazy != null)
                        message.lazy = Boolean(object.lazy);
                    if (object.unverifiedLazy != null)
                        message.unverifiedLazy = Boolean(object.unverifiedLazy);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.weak != null)
                        message.weak = Boolean(object.weak);
                    if (object.debugRedact != null)
                        message.debugRedact = Boolean(object.debugRedact);
                    switch (object.retention) {
                    default:
                        if (typeof object.retention === "number") {
                            message.retention = object.retention;
                            break;
                        }
                        break;
                    case "RETENTION_UNKNOWN":
                    case 0:
                        message.retention = 0;
                        break;
                    case "RETENTION_RUNTIME":
                    case 1:
                        message.retention = 1;
                        break;
                    case "RETENTION_SOURCE":
                    case 2:
                        message.retention = 2;
                        break;
                    }
                    switch (object.target) {
                    default:
                        if (typeof object.target === "number") {
                            message.target = object.target;
                            break;
                        }
                        break;
                    case "TARGET_TYPE_UNKNOWN":
                    case 0:
                        message.target = 0;
                        break;
                    case "TARGET_TYPE_FILE":
                    case 1:
                        message.target = 1;
                        break;
                    case "TARGET_TYPE_EXTENSION_RANGE":
                    case 2:
                        message.target = 2;
                        break;
                    case "TARGET_TYPE_MESSAGE":
                    case 3:
                        message.target = 3;
                        break;
                    case "TARGET_TYPE_FIELD":
                    case 4:
                        message.target = 4;
                        break;
                    case "TARGET_TYPE_ONEOF":
                    case 5:
                        message.target = 5;
                        break;
                    case "TARGET_TYPE_ENUM":
                    case 6:
                        message.target = 6;
                        break;
                    case "TARGET_TYPE_ENUM_ENTRY":
                    case 7:
                        message.target = 7;
                        break;
                    case "TARGET_TYPE_SERVICE":
                    case 8:
                        message.target = 8;
                        break;
                    case "TARGET_TYPE_METHOD":
                    case 9:
                        message.target = 9;
                        break;
                    }
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.FieldOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.FieldOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.fieldBehavior"]) {
                        if (!Array.isArray(object[".google.api.fieldBehavior"]))
                            throw TypeError(".google.protobuf.FieldOptions..google.api.fieldBehavior: array expected");
                        message[".google.api.fieldBehavior"] = [];
                        for (var i = 0; i < object[".google.api.fieldBehavior"].length; ++i)
                            switch (object[".google.api.fieldBehavior"][i]) {
                            default:
                                if (typeof object[".google.api.fieldBehavior"][i] === "number") {
                                    message[".google.api.fieldBehavior"][i] = object[".google.api.fieldBehavior"][i];
                                    break;
                                }
                            case "FIELD_BEHAVIOR_UNSPECIFIED":
                            case 0:
                                message[".google.api.fieldBehavior"][i] = 0;
                                break;
                            case "OPTIONAL":
                            case 1:
                                message[".google.api.fieldBehavior"][i] = 1;
                                break;
                            case "REQUIRED":
                            case 2:
                                message[".google.api.fieldBehavior"][i] = 2;
                                break;
                            case "OUTPUT_ONLY":
                            case 3:
                                message[".google.api.fieldBehavior"][i] = 3;
                                break;
                            case "INPUT_ONLY":
                            case 4:
                                message[".google.api.fieldBehavior"][i] = 4;
                                break;
                            case "IMMUTABLE":
                            case 5:
                                message[".google.api.fieldBehavior"][i] = 5;
                                break;
                            case "UNORDERED_LIST":
                            case 6:
                                message[".google.api.fieldBehavior"][i] = 6;
                                break;
                            case "NON_EMPTY_DEFAULT":
                            case 7:
                                message[".google.api.fieldBehavior"][i] = 7;
                                break;
                            }
                    }
                    if (object[".google.api.resourceReference"] != null) {
                        if (typeof object[".google.api.resourceReference"] !== "object")
                            throw TypeError(".google.protobuf.FieldOptions..google.api.resourceReference: object expected");
                        message[".google.api.resourceReference"] = $root.google.api.ResourceReference.fromObject(object[".google.api.resourceReference"]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a FieldOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.FieldOptions} message FieldOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FieldOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.uninterpretedOption = [];
                        object[".google.api.fieldBehavior"] = [];
                    }
                    if (options.defaults) {
                        object.ctype = options.enums === String ? "STRING" : 0;
                        object.packed = false;
                        object.deprecated = false;
                        object.lazy = false;
                        object.jstype = options.enums === String ? "JS_NORMAL" : 0;
                        object.weak = false;
                        object.unverifiedLazy = false;
                        object.debugRedact = false;
                        object.retention = options.enums === String ? "RETENTION_UNKNOWN" : 0;
                        object.target = options.enums === String ? "TARGET_TYPE_UNKNOWN" : 0;
                        object[".google.api.resourceReference"] = null;
                    }
                    if (message.ctype != null && message.hasOwnProperty("ctype"))
                        object.ctype = options.enums === String ? $root.google.protobuf.FieldOptions.CType[message.ctype] === undefined ? message.ctype : $root.google.protobuf.FieldOptions.CType[message.ctype] : message.ctype;
                    if (message.packed != null && message.hasOwnProperty("packed"))
                        object.packed = message.packed;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.lazy != null && message.hasOwnProperty("lazy"))
                        object.lazy = message.lazy;
                    if (message.jstype != null && message.hasOwnProperty("jstype"))
                        object.jstype = options.enums === String ? $root.google.protobuf.FieldOptions.JSType[message.jstype] === undefined ? message.jstype : $root.google.protobuf.FieldOptions.JSType[message.jstype] : message.jstype;
                    if (message.weak != null && message.hasOwnProperty("weak"))
                        object.weak = message.weak;
                    if (message.unverifiedLazy != null && message.hasOwnProperty("unverifiedLazy"))
                        object.unverifiedLazy = message.unverifiedLazy;
                    if (message.debugRedact != null && message.hasOwnProperty("debugRedact"))
                        object.debugRedact = message.debugRedact;
                    if (message.retention != null && message.hasOwnProperty("retention"))
                        object.retention = options.enums === String ? $root.google.protobuf.FieldOptions.OptionRetention[message.retention] === undefined ? message.retention : $root.google.protobuf.FieldOptions.OptionRetention[message.retention] : message.retention;
                    if (message.target != null && message.hasOwnProperty("target"))
                        object.target = options.enums === String ? $root.google.protobuf.FieldOptions.OptionTargetType[message.target] === undefined ? message.target : $root.google.protobuf.FieldOptions.OptionTargetType[message.target] : message.target;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.fieldBehavior"] && message[".google.api.fieldBehavior"].length) {
                        object[".google.api.fieldBehavior"] = [];
                        for (var j = 0; j < message[".google.api.fieldBehavior"].length; ++j)
                            object[".google.api.fieldBehavior"][j] = options.enums === String ? $root.google.api.FieldBehavior[message[".google.api.fieldBehavior"][j]] === undefined ? message[".google.api.fieldBehavior"][j] : $root.google.api.FieldBehavior[message[".google.api.fieldBehavior"][j]] : message[".google.api.fieldBehavior"][j];
                    }
                    if (message[".google.api.resourceReference"] != null && message.hasOwnProperty(".google.api.resourceReference"))
                        object[".google.api.resourceReference"] = $root.google.api.ResourceReference.toObject(message[".google.api.resourceReference"], options);
                    return object;
                };
    
                /**
                 * Converts this FieldOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FieldOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FieldOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FieldOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FieldOptions";
                };
    
                /**
                 * CType enum.
                 * @name google.protobuf.FieldOptions.CType
                 * @enum {number}
                 * @property {number} STRING=0 STRING value
                 * @property {number} CORD=1 CORD value
                 * @property {number} STRING_PIECE=2 STRING_PIECE value
                 */
                FieldOptions.CType = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "STRING"] = 0;
                    values[valuesById[1] = "CORD"] = 1;
                    values[valuesById[2] = "STRING_PIECE"] = 2;
                    return values;
                })();
    
                /**
                 * JSType enum.
                 * @name google.protobuf.FieldOptions.JSType
                 * @enum {number}
                 * @property {number} JS_NORMAL=0 JS_NORMAL value
                 * @property {number} JS_STRING=1 JS_STRING value
                 * @property {number} JS_NUMBER=2 JS_NUMBER value
                 */
                FieldOptions.JSType = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "JS_NORMAL"] = 0;
                    values[valuesById[1] = "JS_STRING"] = 1;
                    values[valuesById[2] = "JS_NUMBER"] = 2;
                    return values;
                })();
    
                /**
                 * OptionRetention enum.
                 * @name google.protobuf.FieldOptions.OptionRetention
                 * @enum {number}
                 * @property {number} RETENTION_UNKNOWN=0 RETENTION_UNKNOWN value
                 * @property {number} RETENTION_RUNTIME=1 RETENTION_RUNTIME value
                 * @property {number} RETENTION_SOURCE=2 RETENTION_SOURCE value
                 */
                FieldOptions.OptionRetention = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "RETENTION_UNKNOWN"] = 0;
                    values[valuesById[1] = "RETENTION_RUNTIME"] = 1;
                    values[valuesById[2] = "RETENTION_SOURCE"] = 2;
                    return values;
                })();
    
                /**
                 * OptionTargetType enum.
                 * @name google.protobuf.FieldOptions.OptionTargetType
                 * @enum {number}
                 * @property {number} TARGET_TYPE_UNKNOWN=0 TARGET_TYPE_UNKNOWN value
                 * @property {number} TARGET_TYPE_FILE=1 TARGET_TYPE_FILE value
                 * @property {number} TARGET_TYPE_EXTENSION_RANGE=2 TARGET_TYPE_EXTENSION_RANGE value
                 * @property {number} TARGET_TYPE_MESSAGE=3 TARGET_TYPE_MESSAGE value
                 * @property {number} TARGET_TYPE_FIELD=4 TARGET_TYPE_FIELD value
                 * @property {number} TARGET_TYPE_ONEOF=5 TARGET_TYPE_ONEOF value
                 * @property {number} TARGET_TYPE_ENUM=6 TARGET_TYPE_ENUM value
                 * @property {number} TARGET_TYPE_ENUM_ENTRY=7 TARGET_TYPE_ENUM_ENTRY value
                 * @property {number} TARGET_TYPE_SERVICE=8 TARGET_TYPE_SERVICE value
                 * @property {number} TARGET_TYPE_METHOD=9 TARGET_TYPE_METHOD value
                 */
                FieldOptions.OptionTargetType = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "TARGET_TYPE_UNKNOWN"] = 0;
                    values[valuesById[1] = "TARGET_TYPE_FILE"] = 1;
                    values[valuesById[2] = "TARGET_TYPE_EXTENSION_RANGE"] = 2;
                    values[valuesById[3] = "TARGET_TYPE_MESSAGE"] = 3;
                    values[valuesById[4] = "TARGET_TYPE_FIELD"] = 4;
                    values[valuesById[5] = "TARGET_TYPE_ONEOF"] = 5;
                    values[valuesById[6] = "TARGET_TYPE_ENUM"] = 6;
                    values[valuesById[7] = "TARGET_TYPE_ENUM_ENTRY"] = 7;
                    values[valuesById[8] = "TARGET_TYPE_SERVICE"] = 8;
                    values[valuesById[9] = "TARGET_TYPE_METHOD"] = 9;
                    return values;
                })();
    
                return FieldOptions;
            })();
    
            protobuf.OneofOptions = (function() {
    
                /**
                 * Properties of an OneofOptions.
                 * @memberof google.protobuf
                 * @interface IOneofOptions
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] OneofOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new OneofOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an OneofOptions.
                 * @implements IOneofOptions
                 * @constructor
                 * @param {google.protobuf.IOneofOptions=} [properties] Properties to set
                 */
                function OneofOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * OneofOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.OneofOptions
                 * @instance
                 */
                OneofOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new OneofOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.IOneofOptions=} [properties] Properties to set
                 * @returns {google.protobuf.OneofOptions} OneofOptions instance
                 */
                OneofOptions.create = function create(properties) {
                    return new OneofOptions(properties);
                };
    
                /**
                 * Encodes the specified OneofOptions message. Does not implicitly {@link google.protobuf.OneofOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.IOneofOptions} message OneofOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified OneofOptions message, length delimited. Does not implicitly {@link google.protobuf.OneofOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.IOneofOptions} message OneofOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an OneofOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.OneofOptions} OneofOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.OneofOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an OneofOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.OneofOptions} OneofOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an OneofOptions message.
                 * @function verify
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                OneofOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an OneofOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.OneofOptions} OneofOptions
                 */
                OneofOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.OneofOptions)
                        return object;
                    var message = new $root.google.protobuf.OneofOptions();
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.OneofOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.OneofOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an OneofOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.OneofOptions} message OneofOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                OneofOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this OneofOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.OneofOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                OneofOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for OneofOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                OneofOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.OneofOptions";
                };
    
                return OneofOptions;
            })();
    
            protobuf.EnumOptions = (function() {
    
                /**
                 * Properties of an EnumOptions.
                 * @memberof google.protobuf
                 * @interface IEnumOptions
                 * @property {boolean|null} [allowAlias] EnumOptions allowAlias
                 * @property {boolean|null} [deprecated] EnumOptions deprecated
                 * @property {boolean|null} [deprecatedLegacyJsonFieldConflicts] EnumOptions deprecatedLegacyJsonFieldConflicts
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] EnumOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new EnumOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumOptions.
                 * @implements IEnumOptions
                 * @constructor
                 * @param {google.protobuf.IEnumOptions=} [properties] Properties to set
                 */
                function EnumOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumOptions allowAlias.
                 * @member {boolean} allowAlias
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 */
                EnumOptions.prototype.allowAlias = false;
    
                /**
                 * EnumOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 */
                EnumOptions.prototype.deprecated = false;
    
                /**
                 * EnumOptions deprecatedLegacyJsonFieldConflicts.
                 * @member {boolean} deprecatedLegacyJsonFieldConflicts
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 */
                EnumOptions.prototype.deprecatedLegacyJsonFieldConflicts = false;
    
                /**
                 * EnumOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 */
                EnumOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new EnumOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.IEnumOptions=} [properties] Properties to set
                 * @returns {google.protobuf.EnumOptions} EnumOptions instance
                 */
                EnumOptions.create = function create(properties) {
                    return new EnumOptions(properties);
                };
    
                /**
                 * Encodes the specified EnumOptions message. Does not implicitly {@link google.protobuf.EnumOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.IEnumOptions} message EnumOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.allowAlias != null && Object.hasOwnProperty.call(message, "allowAlias"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.allowAlias);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                    if (message.deprecatedLegacyJsonFieldConflicts != null && Object.hasOwnProperty.call(message, "deprecatedLegacyJsonFieldConflicts"))
                        writer.uint32(/* id 6, wireType 0 =*/48).bool(message.deprecatedLegacyJsonFieldConflicts);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumOptions message, length delimited. Does not implicitly {@link google.protobuf.EnumOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.IEnumOptions} message EnumOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumOptions} EnumOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 2: {
                                message.allowAlias = reader.bool();
                                break;
                            }
                        case 3: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 6: {
                                message.deprecatedLegacyJsonFieldConflicts = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumOptions} EnumOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumOptions message.
                 * @function verify
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.allowAlias != null && message.hasOwnProperty("allowAlias"))
                        if (typeof message.allowAlias !== "boolean")
                            return "allowAlias: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.deprecatedLegacyJsonFieldConflicts != null && message.hasOwnProperty("deprecatedLegacyJsonFieldConflicts"))
                        if (typeof message.deprecatedLegacyJsonFieldConflicts !== "boolean")
                            return "deprecatedLegacyJsonFieldConflicts: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumOptions} EnumOptions
                 */
                EnumOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumOptions)
                        return object;
                    var message = new $root.google.protobuf.EnumOptions();
                    if (object.allowAlias != null)
                        message.allowAlias = Boolean(object.allowAlias);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.deprecatedLegacyJsonFieldConflicts != null)
                        message.deprecatedLegacyJsonFieldConflicts = Boolean(object.deprecatedLegacyJsonFieldConflicts);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.EnumOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.EnumOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.EnumOptions} message EnumOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults) {
                        object.allowAlias = false;
                        object.deprecated = false;
                        object.deprecatedLegacyJsonFieldConflicts = false;
                    }
                    if (message.allowAlias != null && message.hasOwnProperty("allowAlias"))
                        object.allowAlias = message.allowAlias;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.deprecatedLegacyJsonFieldConflicts != null && message.hasOwnProperty("deprecatedLegacyJsonFieldConflicts"))
                        object.deprecatedLegacyJsonFieldConflicts = message.deprecatedLegacyJsonFieldConflicts;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this EnumOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumOptions";
                };
    
                return EnumOptions;
            })();
    
            protobuf.EnumValueOptions = (function() {
    
                /**
                 * Properties of an EnumValueOptions.
                 * @memberof google.protobuf
                 * @interface IEnumValueOptions
                 * @property {boolean|null} [deprecated] EnumValueOptions deprecated
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] EnumValueOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new EnumValueOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumValueOptions.
                 * @implements IEnumValueOptions
                 * @constructor
                 * @param {google.protobuf.IEnumValueOptions=} [properties] Properties to set
                 */
                function EnumValueOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumValueOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.EnumValueOptions
                 * @instance
                 */
                EnumValueOptions.prototype.deprecated = false;
    
                /**
                 * EnumValueOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.EnumValueOptions
                 * @instance
                 */
                EnumValueOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new EnumValueOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.IEnumValueOptions=} [properties] Properties to set
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions instance
                 */
                EnumValueOptions.create = function create(properties) {
                    return new EnumValueOptions(properties);
                };
    
                /**
                 * Encodes the specified EnumValueOptions message. Does not implicitly {@link google.protobuf.EnumValueOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.IEnumValueOptions} message EnumValueOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 1, wireType 0 =*/8).bool(message.deprecated);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumValueOptions message, length delimited. Does not implicitly {@link google.protobuf.EnumValueOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.IEnumValueOptions} message EnumValueOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumValueOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumValueOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumValueOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumValueOptions message.
                 * @function verify
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumValueOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumValueOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
                 */
                EnumValueOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumValueOptions)
                        return object;
                    var message = new $root.google.protobuf.EnumValueOptions();
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.EnumValueOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.EnumValueOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumValueOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.EnumValueOptions} message EnumValueOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumValueOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults)
                        object.deprecated = false;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this EnumValueOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumValueOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumValueOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumValueOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumValueOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumValueOptions";
                };
    
                return EnumValueOptions;
            })();
    
            protobuf.ServiceOptions = (function() {
    
                /**
                 * Properties of a ServiceOptions.
                 * @memberof google.protobuf
                 * @interface IServiceOptions
                 * @property {boolean|null} [deprecated] ServiceOptions deprecated
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] ServiceOptions uninterpretedOption
                 * @property {string|null} [".google.api.defaultHost"] ServiceOptions .google.api.defaultHost
                 * @property {string|null} [".google.api.oauthScopes"] ServiceOptions .google.api.oauthScopes
                 */
    
                /**
                 * Constructs a new ServiceOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a ServiceOptions.
                 * @implements IServiceOptions
                 * @constructor
                 * @param {google.protobuf.IServiceOptions=} [properties] Properties to set
                 */
                function ServiceOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ServiceOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype.deprecated = false;
    
                /**
                 * ServiceOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * ServiceOptions .google.api.defaultHost.
                 * @member {string} .google.api.defaultHost
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype[".google.api.defaultHost"] = "";
    
                /**
                 * ServiceOptions .google.api.oauthScopes.
                 * @member {string} .google.api.oauthScopes
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype[".google.api.oauthScopes"] = "";
    
                /**
                 * Creates a new ServiceOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.IServiceOptions=} [properties] Properties to set
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions instance
                 */
                ServiceOptions.create = function create(properties) {
                    return new ServiceOptions(properties);
                };
    
                /**
                 * Encodes the specified ServiceOptions message. Does not implicitly {@link google.protobuf.ServiceOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.IServiceOptions} message ServiceOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 33, wireType 0 =*/264).bool(message.deprecated);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.defaultHost"] != null && Object.hasOwnProperty.call(message, ".google.api.defaultHost"))
                        writer.uint32(/* id 1049, wireType 2 =*/8394).string(message[".google.api.defaultHost"]);
                    if (message[".google.api.oauthScopes"] != null && Object.hasOwnProperty.call(message, ".google.api.oauthScopes"))
                        writer.uint32(/* id 1050, wireType 2 =*/8402).string(message[".google.api.oauthScopes"]);
                    return writer;
                };
    
                /**
                 * Encodes the specified ServiceOptions message, length delimited. Does not implicitly {@link google.protobuf.ServiceOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.IServiceOptions} message ServiceOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ServiceOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ServiceOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 33: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1049: {
                                message[".google.api.defaultHost"] = reader.string();
                                break;
                            }
                        case 1050: {
                                message[".google.api.oauthScopes"] = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ServiceOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ServiceOptions message.
                 * @function verify
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ServiceOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.defaultHost"] != null && message.hasOwnProperty(".google.api.defaultHost"))
                        if (!$util.isString(message[".google.api.defaultHost"]))
                            return ".google.api.defaultHost: string expected";
                    if (message[".google.api.oauthScopes"] != null && message.hasOwnProperty(".google.api.oauthScopes"))
                        if (!$util.isString(message[".google.api.oauthScopes"]))
                            return ".google.api.oauthScopes: string expected";
                    return null;
                };
    
                /**
                 * Creates a ServiceOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions
                 */
                ServiceOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.ServiceOptions)
                        return object;
                    var message = new $root.google.protobuf.ServiceOptions();
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.ServiceOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.ServiceOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.defaultHost"] != null)
                        message[".google.api.defaultHost"] = String(object[".google.api.defaultHost"]);
                    if (object[".google.api.oauthScopes"] != null)
                        message[".google.api.oauthScopes"] = String(object[".google.api.oauthScopes"]);
                    return message;
                };
    
                /**
                 * Creates a plain object from a ServiceOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.ServiceOptions} message ServiceOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ServiceOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults) {
                        object.deprecated = false;
                        object[".google.api.defaultHost"] = "";
                        object[".google.api.oauthScopes"] = "";
                    }
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.defaultHost"] != null && message.hasOwnProperty(".google.api.defaultHost"))
                        object[".google.api.defaultHost"] = message[".google.api.defaultHost"];
                    if (message[".google.api.oauthScopes"] != null && message.hasOwnProperty(".google.api.oauthScopes"))
                        object[".google.api.oauthScopes"] = message[".google.api.oauthScopes"];
                    return object;
                };
    
                /**
                 * Converts this ServiceOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ServiceOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ServiceOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ServiceOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.ServiceOptions";
                };
    
                return ServiceOptions;
            })();
    
            protobuf.MethodOptions = (function() {
    
                /**
                 * Properties of a MethodOptions.
                 * @memberof google.protobuf
                 * @interface IMethodOptions
                 * @property {boolean|null} [deprecated] MethodOptions deprecated
                 * @property {google.protobuf.MethodOptions.IdempotencyLevel|null} [idempotencyLevel] MethodOptions idempotencyLevel
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] MethodOptions uninterpretedOption
                 * @property {google.api.IHttpRule|null} [".google.api.http"] MethodOptions .google.api.http
                 * @property {Array.<string>|null} [".google.api.methodSignature"] MethodOptions .google.api.methodSignature
                 */
    
                /**
                 * Constructs a new MethodOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a MethodOptions.
                 * @implements IMethodOptions
                 * @constructor
                 * @param {google.protobuf.IMethodOptions=} [properties] Properties to set
                 */
                function MethodOptions(properties) {
                    this.uninterpretedOption = [];
                    this[".google.api.methodSignature"] = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * MethodOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype.deprecated = false;
    
                /**
                 * MethodOptions idempotencyLevel.
                 * @member {google.protobuf.MethodOptions.IdempotencyLevel} idempotencyLevel
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype.idempotencyLevel = 0;
    
                /**
                 * MethodOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * MethodOptions .google.api.http.
                 * @member {google.api.IHttpRule|null|undefined} .google.api.http
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype[".google.api.http"] = null;
    
                /**
                 * MethodOptions .google.api.methodSignature.
                 * @member {Array.<string>} .google.api.methodSignature
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype[".google.api.methodSignature"] = $util.emptyArray;
    
                /**
                 * Creates a new MethodOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.IMethodOptions=} [properties] Properties to set
                 * @returns {google.protobuf.MethodOptions} MethodOptions instance
                 */
                MethodOptions.create = function create(properties) {
                    return new MethodOptions(properties);
                };
    
                /**
                 * Encodes the specified MethodOptions message. Does not implicitly {@link google.protobuf.MethodOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.IMethodOptions} message MethodOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 33, wireType 0 =*/264).bool(message.deprecated);
                    if (message.idempotencyLevel != null && Object.hasOwnProperty.call(message, "idempotencyLevel"))
                        writer.uint32(/* id 34, wireType 0 =*/272).int32(message.idempotencyLevel);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.methodSignature"] != null && message[".google.api.methodSignature"].length)
                        for (var i = 0; i < message[".google.api.methodSignature"].length; ++i)
                            writer.uint32(/* id 1051, wireType 2 =*/8410).string(message[".google.api.methodSignature"][i]);
                    if (message[".google.api.http"] != null && Object.hasOwnProperty.call(message, ".google.api.http"))
                        $root.google.api.HttpRule.encode(message[".google.api.http"], writer.uint32(/* id 72295728, wireType 2 =*/578365826).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified MethodOptions message, length delimited. Does not implicitly {@link google.protobuf.MethodOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.IMethodOptions} message MethodOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a MethodOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.MethodOptions} MethodOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MethodOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 33: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 34: {
                                message.idempotencyLevel = reader.int32();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 72295728: {
                                message[".google.api.http"] = $root.google.api.HttpRule.decode(reader, reader.uint32());
                                break;
                            }
                        case 1051: {
                                if (!(message[".google.api.methodSignature"] && message[".google.api.methodSignature"].length))
                                    message[".google.api.methodSignature"] = [];
                                message[".google.api.methodSignature"].push(reader.string());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a MethodOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.MethodOptions} MethodOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a MethodOptions message.
                 * @function verify
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                MethodOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.idempotencyLevel != null && message.hasOwnProperty("idempotencyLevel"))
                        switch (message.idempotencyLevel) {
                        default:
                            return "idempotencyLevel: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.http"] != null && message.hasOwnProperty(".google.api.http")) {
                        var error = $root.google.api.HttpRule.verify(message[".google.api.http"]);
                        if (error)
                            return ".google.api.http." + error;
                    }
                    if (message[".google.api.methodSignature"] != null && message.hasOwnProperty(".google.api.methodSignature")) {
                        if (!Array.isArray(message[".google.api.methodSignature"]))
                            return ".google.api.methodSignature: array expected";
                        for (var i = 0; i < message[".google.api.methodSignature"].length; ++i)
                            if (!$util.isString(message[".google.api.methodSignature"][i]))
                                return ".google.api.methodSignature: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates a MethodOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.MethodOptions} MethodOptions
                 */
                MethodOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.MethodOptions)
                        return object;
                    var message = new $root.google.protobuf.MethodOptions();
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    switch (object.idempotencyLevel) {
                    default:
                        if (typeof object.idempotencyLevel === "number") {
                            message.idempotencyLevel = object.idempotencyLevel;
                            break;
                        }
                        break;
                    case "IDEMPOTENCY_UNKNOWN":
                    case 0:
                        message.idempotencyLevel = 0;
                        break;
                    case "NO_SIDE_EFFECTS":
                    case 1:
                        message.idempotencyLevel = 1;
                        break;
                    case "IDEMPOTENT":
                    case 2:
                        message.idempotencyLevel = 2;
                        break;
                    }
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.MethodOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.MethodOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.http"] != null) {
                        if (typeof object[".google.api.http"] !== "object")
                            throw TypeError(".google.protobuf.MethodOptions..google.api.http: object expected");
                        message[".google.api.http"] = $root.google.api.HttpRule.fromObject(object[".google.api.http"]);
                    }
                    if (object[".google.api.methodSignature"]) {
                        if (!Array.isArray(object[".google.api.methodSignature"]))
                            throw TypeError(".google.protobuf.MethodOptions..google.api.methodSignature: array expected");
                        message[".google.api.methodSignature"] = [];
                        for (var i = 0; i < object[".google.api.methodSignature"].length; ++i)
                            message[".google.api.methodSignature"][i] = String(object[".google.api.methodSignature"][i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a MethodOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.MethodOptions} message MethodOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                MethodOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.uninterpretedOption = [];
                        object[".google.api.methodSignature"] = [];
                    }
                    if (options.defaults) {
                        object.deprecated = false;
                        object.idempotencyLevel = options.enums === String ? "IDEMPOTENCY_UNKNOWN" : 0;
                        object[".google.api.http"] = null;
                    }
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.idempotencyLevel != null && message.hasOwnProperty("idempotencyLevel"))
                        object.idempotencyLevel = options.enums === String ? $root.google.protobuf.MethodOptions.IdempotencyLevel[message.idempotencyLevel] === undefined ? message.idempotencyLevel : $root.google.protobuf.MethodOptions.IdempotencyLevel[message.idempotencyLevel] : message.idempotencyLevel;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.methodSignature"] && message[".google.api.methodSignature"].length) {
                        object[".google.api.methodSignature"] = [];
                        for (var j = 0; j < message[".google.api.methodSignature"].length; ++j)
                            object[".google.api.methodSignature"][j] = message[".google.api.methodSignature"][j];
                    }
                    if (message[".google.api.http"] != null && message.hasOwnProperty(".google.api.http"))
                        object[".google.api.http"] = $root.google.api.HttpRule.toObject(message[".google.api.http"], options);
                    return object;
                };
    
                /**
                 * Converts this MethodOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                MethodOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for MethodOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                MethodOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.MethodOptions";
                };
    
                /**
                 * IdempotencyLevel enum.
                 * @name google.protobuf.MethodOptions.IdempotencyLevel
                 * @enum {number}
                 * @property {number} IDEMPOTENCY_UNKNOWN=0 IDEMPOTENCY_UNKNOWN value
                 * @property {number} NO_SIDE_EFFECTS=1 NO_SIDE_EFFECTS value
                 * @property {number} IDEMPOTENT=2 IDEMPOTENT value
                 */
                MethodOptions.IdempotencyLevel = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "IDEMPOTENCY_UNKNOWN"] = 0;
                    values[valuesById[1] = "NO_SIDE_EFFECTS"] = 1;
                    values[valuesById[2] = "IDEMPOTENT"] = 2;
                    return values;
                })();
    
                return MethodOptions;
            })();
    
            protobuf.UninterpretedOption = (function() {
    
                /**
                 * Properties of an UninterpretedOption.
                 * @memberof google.protobuf
                 * @interface IUninterpretedOption
                 * @property {Array.<google.protobuf.UninterpretedOption.INamePart>|null} [name] UninterpretedOption name
                 * @property {string|null} [identifierValue] UninterpretedOption identifierValue
                 * @property {number|Long|null} [positiveIntValue] UninterpretedOption positiveIntValue
                 * @property {number|Long|null} [negativeIntValue] UninterpretedOption negativeIntValue
                 * @property {number|null} [doubleValue] UninterpretedOption doubleValue
                 * @property {Uint8Array|null} [stringValue] UninterpretedOption stringValue
                 * @property {string|null} [aggregateValue] UninterpretedOption aggregateValue
                 */
    
                /**
                 * Constructs a new UninterpretedOption.
                 * @memberof google.protobuf
                 * @classdesc Represents an UninterpretedOption.
                 * @implements IUninterpretedOption
                 * @constructor
                 * @param {google.protobuf.IUninterpretedOption=} [properties] Properties to set
                 */
                function UninterpretedOption(properties) {
                    this.name = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * UninterpretedOption name.
                 * @member {Array.<google.protobuf.UninterpretedOption.INamePart>} name
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.name = $util.emptyArray;
    
                /**
                 * UninterpretedOption identifierValue.
                 * @member {string} identifierValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.identifierValue = "";
    
                /**
                 * UninterpretedOption positiveIntValue.
                 * @member {number|Long} positiveIntValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.positiveIntValue = $util.Long ? $util.Long.fromBits(0,0,true) : 0;
    
                /**
                 * UninterpretedOption negativeIntValue.
                 * @member {number|Long} negativeIntValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.negativeIntValue = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                /**
                 * UninterpretedOption doubleValue.
                 * @member {number} doubleValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.doubleValue = 0;
    
                /**
                 * UninterpretedOption stringValue.
                 * @member {Uint8Array} stringValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.stringValue = $util.newBuffer([]);
    
                /**
                 * UninterpretedOption aggregateValue.
                 * @member {string} aggregateValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.aggregateValue = "";
    
                /**
                 * Creates a new UninterpretedOption instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.IUninterpretedOption=} [properties] Properties to set
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption instance
                 */
                UninterpretedOption.create = function create(properties) {
                    return new UninterpretedOption(properties);
                };
    
                /**
                 * Encodes the specified UninterpretedOption message. Does not implicitly {@link google.protobuf.UninterpretedOption.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.IUninterpretedOption} message UninterpretedOption message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UninterpretedOption.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && message.name.length)
                        for (var i = 0; i < message.name.length; ++i)
                            $root.google.protobuf.UninterpretedOption.NamePart.encode(message.name[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.identifierValue != null && Object.hasOwnProperty.call(message, "identifierValue"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.identifierValue);
                    if (message.positiveIntValue != null && Object.hasOwnProperty.call(message, "positiveIntValue"))
                        writer.uint32(/* id 4, wireType 0 =*/32).uint64(message.positiveIntValue);
                    if (message.negativeIntValue != null && Object.hasOwnProperty.call(message, "negativeIntValue"))
                        writer.uint32(/* id 5, wireType 0 =*/40).int64(message.negativeIntValue);
                    if (message.doubleValue != null && Object.hasOwnProperty.call(message, "doubleValue"))
                        writer.uint32(/* id 6, wireType 1 =*/49).double(message.doubleValue);
                    if (message.stringValue != null && Object.hasOwnProperty.call(message, "stringValue"))
                        writer.uint32(/* id 7, wireType 2 =*/58).bytes(message.stringValue);
                    if (message.aggregateValue != null && Object.hasOwnProperty.call(message, "aggregateValue"))
                        writer.uint32(/* id 8, wireType 2 =*/66).string(message.aggregateValue);
                    return writer;
                };
    
                /**
                 * Encodes the specified UninterpretedOption message, length delimited. Does not implicitly {@link google.protobuf.UninterpretedOption.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.IUninterpretedOption} message UninterpretedOption message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UninterpretedOption.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an UninterpretedOption message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UninterpretedOption.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UninterpretedOption();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 2: {
                                if (!(message.name && message.name.length))
                                    message.name = [];
                                message.name.push($root.google.protobuf.UninterpretedOption.NamePart.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                message.identifierValue = reader.string();
                                break;
                            }
                        case 4: {
                                message.positiveIntValue = reader.uint64();
                                break;
                            }
                        case 5: {
                                message.negativeIntValue = reader.int64();
                                break;
                            }
                        case 6: {
                                message.doubleValue = reader.double();
                                break;
                            }
                        case 7: {
                                message.stringValue = reader.bytes();
                                break;
                            }
                        case 8: {
                                message.aggregateValue = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an UninterpretedOption message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UninterpretedOption.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an UninterpretedOption message.
                 * @function verify
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                UninterpretedOption.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name")) {
                        if (!Array.isArray(message.name))
                            return "name: array expected";
                        for (var i = 0; i < message.name.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.NamePart.verify(message.name[i]);
                            if (error)
                                return "name." + error;
                        }
                    }
                    if (message.identifierValue != null && message.hasOwnProperty("identifierValue"))
                        if (!$util.isString(message.identifierValue))
                            return "identifierValue: string expected";
                    if (message.positiveIntValue != null && message.hasOwnProperty("positiveIntValue"))
                        if (!$util.isInteger(message.positiveIntValue) && !(message.positiveIntValue && $util.isInteger(message.positiveIntValue.low) && $util.isInteger(message.positiveIntValue.high)))
                            return "positiveIntValue: integer|Long expected";
                    if (message.negativeIntValue != null && message.hasOwnProperty("negativeIntValue"))
                        if (!$util.isInteger(message.negativeIntValue) && !(message.negativeIntValue && $util.isInteger(message.negativeIntValue.low) && $util.isInteger(message.negativeIntValue.high)))
                            return "negativeIntValue: integer|Long expected";
                    if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                        if (typeof message.doubleValue !== "number")
                            return "doubleValue: number expected";
                    if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                        if (!(message.stringValue && typeof message.stringValue.length === "number" || $util.isString(message.stringValue)))
                            return "stringValue: buffer expected";
                    if (message.aggregateValue != null && message.hasOwnProperty("aggregateValue"))
                        if (!$util.isString(message.aggregateValue))
                            return "aggregateValue: string expected";
                    return null;
                };
    
                /**
                 * Creates an UninterpretedOption message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
                 */
                UninterpretedOption.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.UninterpretedOption)
                        return object;
                    var message = new $root.google.protobuf.UninterpretedOption();
                    if (object.name) {
                        if (!Array.isArray(object.name))
                            throw TypeError(".google.protobuf.UninterpretedOption.name: array expected");
                        message.name = [];
                        for (var i = 0; i < object.name.length; ++i) {
                            if (typeof object.name[i] !== "object")
                                throw TypeError(".google.protobuf.UninterpretedOption.name: object expected");
                            message.name[i] = $root.google.protobuf.UninterpretedOption.NamePart.fromObject(object.name[i]);
                        }
                    }
                    if (object.identifierValue != null)
                        message.identifierValue = String(object.identifierValue);
                    if (object.positiveIntValue != null)
                        if ($util.Long)
                            (message.positiveIntValue = $util.Long.fromValue(object.positiveIntValue)).unsigned = true;
                        else if (typeof object.positiveIntValue === "string")
                            message.positiveIntValue = parseInt(object.positiveIntValue, 10);
                        else if (typeof object.positiveIntValue === "number")
                            message.positiveIntValue = object.positiveIntValue;
                        else if (typeof object.positiveIntValue === "object")
                            message.positiveIntValue = new $util.LongBits(object.positiveIntValue.low >>> 0, object.positiveIntValue.high >>> 0).toNumber(true);
                    if (object.negativeIntValue != null)
                        if ($util.Long)
                            (message.negativeIntValue = $util.Long.fromValue(object.negativeIntValue)).unsigned = false;
                        else if (typeof object.negativeIntValue === "string")
                            message.negativeIntValue = parseInt(object.negativeIntValue, 10);
                        else if (typeof object.negativeIntValue === "number")
                            message.negativeIntValue = object.negativeIntValue;
                        else if (typeof object.negativeIntValue === "object")
                            message.negativeIntValue = new $util.LongBits(object.negativeIntValue.low >>> 0, object.negativeIntValue.high >>> 0).toNumber();
                    if (object.doubleValue != null)
                        message.doubleValue = Number(object.doubleValue);
                    if (object.stringValue != null)
                        if (typeof object.stringValue === "string")
                            $util.base64.decode(object.stringValue, message.stringValue = $util.newBuffer($util.base64.length(object.stringValue)), 0);
                        else if (object.stringValue.length >= 0)
                            message.stringValue = object.stringValue;
                    if (object.aggregateValue != null)
                        message.aggregateValue = String(object.aggregateValue);
                    return message;
                };
    
                /**
                 * Creates a plain object from an UninterpretedOption message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.UninterpretedOption} message UninterpretedOption
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                UninterpretedOption.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.name = [];
                    if (options.defaults) {
                        object.identifierValue = "";
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, true);
                            object.positiveIntValue = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.positiveIntValue = options.longs === String ? "0" : 0;
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, false);
                            object.negativeIntValue = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.negativeIntValue = options.longs === String ? "0" : 0;
                        object.doubleValue = 0;
                        if (options.bytes === String)
                            object.stringValue = "";
                        else {
                            object.stringValue = [];
                            if (options.bytes !== Array)
                                object.stringValue = $util.newBuffer(object.stringValue);
                        }
                        object.aggregateValue = "";
                    }
                    if (message.name && message.name.length) {
                        object.name = [];
                        for (var j = 0; j < message.name.length; ++j)
                            object.name[j] = $root.google.protobuf.UninterpretedOption.NamePart.toObject(message.name[j], options);
                    }
                    if (message.identifierValue != null && message.hasOwnProperty("identifierValue"))
                        object.identifierValue = message.identifierValue;
                    if (message.positiveIntValue != null && message.hasOwnProperty("positiveIntValue"))
                        if (typeof message.positiveIntValue === "number")
                            object.positiveIntValue = options.longs === String ? String(message.positiveIntValue) : message.positiveIntValue;
                        else
                            object.positiveIntValue = options.longs === String ? $util.Long.prototype.toString.call(message.positiveIntValue) : options.longs === Number ? new $util.LongBits(message.positiveIntValue.low >>> 0, message.positiveIntValue.high >>> 0).toNumber(true) : message.positiveIntValue;
                    if (message.negativeIntValue != null && message.hasOwnProperty("negativeIntValue"))
                        if (typeof message.negativeIntValue === "number")
                            object.negativeIntValue = options.longs === String ? String(message.negativeIntValue) : message.negativeIntValue;
                        else
                            object.negativeIntValue = options.longs === String ? $util.Long.prototype.toString.call(message.negativeIntValue) : options.longs === Number ? new $util.LongBits(message.negativeIntValue.low >>> 0, message.negativeIntValue.high >>> 0).toNumber() : message.negativeIntValue;
                    if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                        object.doubleValue = options.json && !isFinite(message.doubleValue) ? String(message.doubleValue) : message.doubleValue;
                    if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                        object.stringValue = options.bytes === String ? $util.base64.encode(message.stringValue, 0, message.stringValue.length) : options.bytes === Array ? Array.prototype.slice.call(message.stringValue) : message.stringValue;
                    if (message.aggregateValue != null && message.hasOwnProperty("aggregateValue"))
                        object.aggregateValue = message.aggregateValue;
                    return object;
                };
    
                /**
                 * Converts this UninterpretedOption to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                UninterpretedOption.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for UninterpretedOption
                 * @function getTypeUrl
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                UninterpretedOption.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.UninterpretedOption";
                };
    
                UninterpretedOption.NamePart = (function() {
    
                    /**
                     * Properties of a NamePart.
                     * @memberof google.protobuf.UninterpretedOption
                     * @interface INamePart
                     * @property {string} namePart NamePart namePart
                     * @property {boolean} isExtension NamePart isExtension
                     */
    
                    /**
                     * Constructs a new NamePart.
                     * @memberof google.protobuf.UninterpretedOption
                     * @classdesc Represents a NamePart.
                     * @implements INamePart
                     * @constructor
                     * @param {google.protobuf.UninterpretedOption.INamePart=} [properties] Properties to set
                     */
                    function NamePart(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * NamePart namePart.
                     * @member {string} namePart
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @instance
                     */
                    NamePart.prototype.namePart = "";
    
                    /**
                     * NamePart isExtension.
                     * @member {boolean} isExtension
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @instance
                     */
                    NamePart.prototype.isExtension = false;
    
                    /**
                     * Creates a new NamePart instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.INamePart=} [properties] Properties to set
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart instance
                     */
                    NamePart.create = function create(properties) {
                        return new NamePart(properties);
                    };
    
                    /**
                     * Encodes the specified NamePart message. Does not implicitly {@link google.protobuf.UninterpretedOption.NamePart.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.INamePart} message NamePart message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    NamePart.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.namePart);
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.isExtension);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified NamePart message, length delimited. Does not implicitly {@link google.protobuf.UninterpretedOption.NamePart.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.INamePart} message NamePart message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    NamePart.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a NamePart message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    NamePart.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UninterpretedOption.NamePart();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.namePart = reader.string();
                                    break;
                                }
                            case 2: {
                                    message.isExtension = reader.bool();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        if (!message.hasOwnProperty("namePart"))
                            throw $util.ProtocolError("missing required 'namePart'", { instance: message });
                        if (!message.hasOwnProperty("isExtension"))
                            throw $util.ProtocolError("missing required 'isExtension'", { instance: message });
                        return message;
                    };
    
                    /**
                     * Decodes a NamePart message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    NamePart.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a NamePart message.
                     * @function verify
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    NamePart.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (!$util.isString(message.namePart))
                            return "namePart: string expected";
                        if (typeof message.isExtension !== "boolean")
                            return "isExtension: boolean expected";
                        return null;
                    };
    
                    /**
                     * Creates a NamePart message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                     */
                    NamePart.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.UninterpretedOption.NamePart)
                            return object;
                        var message = new $root.google.protobuf.UninterpretedOption.NamePart();
                        if (object.namePart != null)
                            message.namePart = String(object.namePart);
                        if (object.isExtension != null)
                            message.isExtension = Boolean(object.isExtension);
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a NamePart message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.NamePart} message NamePart
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    NamePart.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.namePart = "";
                            object.isExtension = false;
                        }
                        if (message.namePart != null && message.hasOwnProperty("namePart"))
                            object.namePart = message.namePart;
                        if (message.isExtension != null && message.hasOwnProperty("isExtension"))
                            object.isExtension = message.isExtension;
                        return object;
                    };
    
                    /**
                     * Converts this NamePart to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    NamePart.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for NamePart
                     * @function getTypeUrl
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    NamePart.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.UninterpretedOption.NamePart";
                    };
    
                    return NamePart;
                })();
    
                return UninterpretedOption;
            })();
    
            protobuf.SourceCodeInfo = (function() {
    
                /**
                 * Properties of a SourceCodeInfo.
                 * @memberof google.protobuf
                 * @interface ISourceCodeInfo
                 * @property {Array.<google.protobuf.SourceCodeInfo.ILocation>|null} [location] SourceCodeInfo location
                 */
    
                /**
                 * Constructs a new SourceCodeInfo.
                 * @memberof google.protobuf
                 * @classdesc Represents a SourceCodeInfo.
                 * @implements ISourceCodeInfo
                 * @constructor
                 * @param {google.protobuf.ISourceCodeInfo=} [properties] Properties to set
                 */
                function SourceCodeInfo(properties) {
                    this.location = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * SourceCodeInfo location.
                 * @member {Array.<google.protobuf.SourceCodeInfo.ILocation>} location
                 * @memberof google.protobuf.SourceCodeInfo
                 * @instance
                 */
                SourceCodeInfo.prototype.location = $util.emptyArray;
    
                /**
                 * Creates a new SourceCodeInfo instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.ISourceCodeInfo=} [properties] Properties to set
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo instance
                 */
                SourceCodeInfo.create = function create(properties) {
                    return new SourceCodeInfo(properties);
                };
    
                /**
                 * Encodes the specified SourceCodeInfo message. Does not implicitly {@link google.protobuf.SourceCodeInfo.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.ISourceCodeInfo} message SourceCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SourceCodeInfo.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.location != null && message.location.length)
                        for (var i = 0; i < message.location.length; ++i)
                            $root.google.protobuf.SourceCodeInfo.Location.encode(message.location[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified SourceCodeInfo message, length delimited. Does not implicitly {@link google.protobuf.SourceCodeInfo.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.ISourceCodeInfo} message SourceCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SourceCodeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a SourceCodeInfo message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SourceCodeInfo.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.SourceCodeInfo();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.location && message.location.length))
                                    message.location = [];
                                message.location.push($root.google.protobuf.SourceCodeInfo.Location.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a SourceCodeInfo message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SourceCodeInfo.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a SourceCodeInfo message.
                 * @function verify
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                SourceCodeInfo.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.location != null && message.hasOwnProperty("location")) {
                        if (!Array.isArray(message.location))
                            return "location: array expected";
                        for (var i = 0; i < message.location.length; ++i) {
                            var error = $root.google.protobuf.SourceCodeInfo.Location.verify(message.location[i]);
                            if (error)
                                return "location." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a SourceCodeInfo message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
                 */
                SourceCodeInfo.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.SourceCodeInfo)
                        return object;
                    var message = new $root.google.protobuf.SourceCodeInfo();
                    if (object.location) {
                        if (!Array.isArray(object.location))
                            throw TypeError(".google.protobuf.SourceCodeInfo.location: array expected");
                        message.location = [];
                        for (var i = 0; i < object.location.length; ++i) {
                            if (typeof object.location[i] !== "object")
                                throw TypeError(".google.protobuf.SourceCodeInfo.location: object expected");
                            message.location[i] = $root.google.protobuf.SourceCodeInfo.Location.fromObject(object.location[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a SourceCodeInfo message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.SourceCodeInfo} message SourceCodeInfo
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                SourceCodeInfo.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.location = [];
                    if (message.location && message.location.length) {
                        object.location = [];
                        for (var j = 0; j < message.location.length; ++j)
                            object.location[j] = $root.google.protobuf.SourceCodeInfo.Location.toObject(message.location[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this SourceCodeInfo to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.SourceCodeInfo
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                SourceCodeInfo.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for SourceCodeInfo
                 * @function getTypeUrl
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                SourceCodeInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.SourceCodeInfo";
                };
    
                SourceCodeInfo.Location = (function() {
    
                    /**
                     * Properties of a Location.
                     * @memberof google.protobuf.SourceCodeInfo
                     * @interface ILocation
                     * @property {Array.<number>|null} [path] Location path
                     * @property {Array.<number>|null} [span] Location span
                     * @property {string|null} [leadingComments] Location leadingComments
                     * @property {string|null} [trailingComments] Location trailingComments
                     * @property {Array.<string>|null} [leadingDetachedComments] Location leadingDetachedComments
                     */
    
                    /**
                     * Constructs a new Location.
                     * @memberof google.protobuf.SourceCodeInfo
                     * @classdesc Represents a Location.
                     * @implements ILocation
                     * @constructor
                     * @param {google.protobuf.SourceCodeInfo.ILocation=} [properties] Properties to set
                     */
                    function Location(properties) {
                        this.path = [];
                        this.span = [];
                        this.leadingDetachedComments = [];
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * Location path.
                     * @member {Array.<number>} path
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.path = $util.emptyArray;
    
                    /**
                     * Location span.
                     * @member {Array.<number>} span
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.span = $util.emptyArray;
    
                    /**
                     * Location leadingComments.
                     * @member {string} leadingComments
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.leadingComments = "";
    
                    /**
                     * Location trailingComments.
                     * @member {string} trailingComments
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.trailingComments = "";
    
                    /**
                     * Location leadingDetachedComments.
                     * @member {Array.<string>} leadingDetachedComments
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.leadingDetachedComments = $util.emptyArray;
    
                    /**
                     * Creates a new Location instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.ILocation=} [properties] Properties to set
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location instance
                     */
                    Location.create = function create(properties) {
                        return new Location(properties);
                    };
    
                    /**
                     * Encodes the specified Location message. Does not implicitly {@link google.protobuf.SourceCodeInfo.Location.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.ILocation} message Location message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Location.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.path != null && message.path.length) {
                            writer.uint32(/* id 1, wireType 2 =*/10).fork();
                            for (var i = 0; i < message.path.length; ++i)
                                writer.int32(message.path[i]);
                            writer.ldelim();
                        }
                        if (message.span != null && message.span.length) {
                            writer.uint32(/* id 2, wireType 2 =*/18).fork();
                            for (var i = 0; i < message.span.length; ++i)
                                writer.int32(message.span[i]);
                            writer.ldelim();
                        }
                        if (message.leadingComments != null && Object.hasOwnProperty.call(message, "leadingComments"))
                            writer.uint32(/* id 3, wireType 2 =*/26).string(message.leadingComments);
                        if (message.trailingComments != null && Object.hasOwnProperty.call(message, "trailingComments"))
                            writer.uint32(/* id 4, wireType 2 =*/34).string(message.trailingComments);
                        if (message.leadingDetachedComments != null && message.leadingDetachedComments.length)
                            for (var i = 0; i < message.leadingDetachedComments.length; ++i)
                                writer.uint32(/* id 6, wireType 2 =*/50).string(message.leadingDetachedComments[i]);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified Location message, length delimited. Does not implicitly {@link google.protobuf.SourceCodeInfo.Location.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.ILocation} message Location message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Location.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a Location message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Location.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.SourceCodeInfo.Location();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    if (!(message.path && message.path.length))
                                        message.path = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.path.push(reader.int32());
                                    } else
                                        message.path.push(reader.int32());
                                    break;
                                }
                            case 2: {
                                    if (!(message.span && message.span.length))
                                        message.span = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.span.push(reader.int32());
                                    } else
                                        message.span.push(reader.int32());
                                    break;
                                }
                            case 3: {
                                    message.leadingComments = reader.string();
                                    break;
                                }
                            case 4: {
                                    message.trailingComments = reader.string();
                                    break;
                                }
                            case 6: {
                                    if (!(message.leadingDetachedComments && message.leadingDetachedComments.length))
                                        message.leadingDetachedComments = [];
                                    message.leadingDetachedComments.push(reader.string());
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes a Location message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Location.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a Location message.
                     * @function verify
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    Location.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.path != null && message.hasOwnProperty("path")) {
                            if (!Array.isArray(message.path))
                                return "path: array expected";
                            for (var i = 0; i < message.path.length; ++i)
                                if (!$util.isInteger(message.path[i]))
                                    return "path: integer[] expected";
                        }
                        if (message.span != null && message.hasOwnProperty("span")) {
                            if (!Array.isArray(message.span))
                                return "span: array expected";
                            for (var i = 0; i < message.span.length; ++i)
                                if (!$util.isInteger(message.span[i]))
                                    return "span: integer[] expected";
                        }
                        if (message.leadingComments != null && message.hasOwnProperty("leadingComments"))
                            if (!$util.isString(message.leadingComments))
                                return "leadingComments: string expected";
                        if (message.trailingComments != null && message.hasOwnProperty("trailingComments"))
                            if (!$util.isString(message.trailingComments))
                                return "trailingComments: string expected";
                        if (message.leadingDetachedComments != null && message.hasOwnProperty("leadingDetachedComments")) {
                            if (!Array.isArray(message.leadingDetachedComments))
                                return "leadingDetachedComments: array expected";
                            for (var i = 0; i < message.leadingDetachedComments.length; ++i)
                                if (!$util.isString(message.leadingDetachedComments[i]))
                                    return "leadingDetachedComments: string[] expected";
                        }
                        return null;
                    };
    
                    /**
                     * Creates a Location message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location
                     */
                    Location.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.SourceCodeInfo.Location)
                            return object;
                        var message = new $root.google.protobuf.SourceCodeInfo.Location();
                        if (object.path) {
                            if (!Array.isArray(object.path))
                                throw TypeError(".google.protobuf.SourceCodeInfo.Location.path: array expected");
                            message.path = [];
                            for (var i = 0; i < object.path.length; ++i)
                                message.path[i] = object.path[i] | 0;
                        }
                        if (object.span) {
                            if (!Array.isArray(object.span))
                                throw TypeError(".google.protobuf.SourceCodeInfo.Location.span: array expected");
                            message.span = [];
                            for (var i = 0; i < object.span.length; ++i)
                                message.span[i] = object.span[i] | 0;
                        }
                        if (object.leadingComments != null)
                            message.leadingComments = String(object.leadingComments);
                        if (object.trailingComments != null)
                            message.trailingComments = String(object.trailingComments);
                        if (object.leadingDetachedComments) {
                            if (!Array.isArray(object.leadingDetachedComments))
                                throw TypeError(".google.protobuf.SourceCodeInfo.Location.leadingDetachedComments: array expected");
                            message.leadingDetachedComments = [];
                            for (var i = 0; i < object.leadingDetachedComments.length; ++i)
                                message.leadingDetachedComments[i] = String(object.leadingDetachedComments[i]);
                        }
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a Location message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.Location} message Location
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    Location.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.arrays || options.defaults) {
                            object.path = [];
                            object.span = [];
                            object.leadingDetachedComments = [];
                        }
                        if (options.defaults) {
                            object.leadingComments = "";
                            object.trailingComments = "";
                        }
                        if (message.path && message.path.length) {
                            object.path = [];
                            for (var j = 0; j < message.path.length; ++j)
                                object.path[j] = message.path[j];
                        }
                        if (message.span && message.span.length) {
                            object.span = [];
                            for (var j = 0; j < message.span.length; ++j)
                                object.span[j] = message.span[j];
                        }
                        if (message.leadingComments != null && message.hasOwnProperty("leadingComments"))
                            object.leadingComments = message.leadingComments;
                        if (message.trailingComments != null && message.hasOwnProperty("trailingComments"))
                            object.trailingComments = message.trailingComments;
                        if (message.leadingDetachedComments && message.leadingDetachedComments.length) {
                            object.leadingDetachedComments = [];
                            for (var j = 0; j < message.leadingDetachedComments.length; ++j)
                                object.leadingDetachedComments[j] = message.leadingDetachedComments[j];
                        }
                        return object;
                    };
    
                    /**
                     * Converts this Location to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    Location.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for Location
                     * @function getTypeUrl
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    Location.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.SourceCodeInfo.Location";
                    };
    
                    return Location;
                })();
    
                return SourceCodeInfo;
            })();
    
            protobuf.GeneratedCodeInfo = (function() {
    
                /**
                 * Properties of a GeneratedCodeInfo.
                 * @memberof google.protobuf
                 * @interface IGeneratedCodeInfo
                 * @property {Array.<google.protobuf.GeneratedCodeInfo.IAnnotation>|null} [annotation] GeneratedCodeInfo annotation
                 */
    
                /**
                 * Constructs a new GeneratedCodeInfo.
                 * @memberof google.protobuf
                 * @classdesc Represents a GeneratedCodeInfo.
                 * @implements IGeneratedCodeInfo
                 * @constructor
                 * @param {google.protobuf.IGeneratedCodeInfo=} [properties] Properties to set
                 */
                function GeneratedCodeInfo(properties) {
                    this.annotation = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * GeneratedCodeInfo annotation.
                 * @member {Array.<google.protobuf.GeneratedCodeInfo.IAnnotation>} annotation
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @instance
                 */
                GeneratedCodeInfo.prototype.annotation = $util.emptyArray;
    
                /**
                 * Creates a new GeneratedCodeInfo instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.IGeneratedCodeInfo=} [properties] Properties to set
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo instance
                 */
                GeneratedCodeInfo.create = function create(properties) {
                    return new GeneratedCodeInfo(properties);
                };
    
                /**
                 * Encodes the specified GeneratedCodeInfo message. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.IGeneratedCodeInfo} message GeneratedCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                GeneratedCodeInfo.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.annotation != null && message.annotation.length)
                        for (var i = 0; i < message.annotation.length; ++i)
                            $root.google.protobuf.GeneratedCodeInfo.Annotation.encode(message.annotation[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified GeneratedCodeInfo message, length delimited. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.IGeneratedCodeInfo} message GeneratedCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                GeneratedCodeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a GeneratedCodeInfo message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                GeneratedCodeInfo.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.GeneratedCodeInfo();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.annotation && message.annotation.length))
                                    message.annotation = [];
                                message.annotation.push($root.google.protobuf.GeneratedCodeInfo.Annotation.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a GeneratedCodeInfo message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                GeneratedCodeInfo.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a GeneratedCodeInfo message.
                 * @function verify
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                GeneratedCodeInfo.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.annotation != null && message.hasOwnProperty("annotation")) {
                        if (!Array.isArray(message.annotation))
                            return "annotation: array expected";
                        for (var i = 0; i < message.annotation.length; ++i) {
                            var error = $root.google.protobuf.GeneratedCodeInfo.Annotation.verify(message.annotation[i]);
                            if (error)
                                return "annotation." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a GeneratedCodeInfo message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
                 */
                GeneratedCodeInfo.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.GeneratedCodeInfo)
                        return object;
                    var message = new $root.google.protobuf.GeneratedCodeInfo();
                    if (object.annotation) {
                        if (!Array.isArray(object.annotation))
                            throw TypeError(".google.protobuf.GeneratedCodeInfo.annotation: array expected");
                        message.annotation = [];
                        for (var i = 0; i < object.annotation.length; ++i) {
                            if (typeof object.annotation[i] !== "object")
                                throw TypeError(".google.protobuf.GeneratedCodeInfo.annotation: object expected");
                            message.annotation[i] = $root.google.protobuf.GeneratedCodeInfo.Annotation.fromObject(object.annotation[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a GeneratedCodeInfo message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.GeneratedCodeInfo} message GeneratedCodeInfo
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                GeneratedCodeInfo.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.annotation = [];
                    if (message.annotation && message.annotation.length) {
                        object.annotation = [];
                        for (var j = 0; j < message.annotation.length; ++j)
                            object.annotation[j] = $root.google.protobuf.GeneratedCodeInfo.Annotation.toObject(message.annotation[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this GeneratedCodeInfo to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                GeneratedCodeInfo.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for GeneratedCodeInfo
                 * @function getTypeUrl
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                GeneratedCodeInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.GeneratedCodeInfo";
                };
    
                GeneratedCodeInfo.Annotation = (function() {
    
                    /**
                     * Properties of an Annotation.
                     * @memberof google.protobuf.GeneratedCodeInfo
                     * @interface IAnnotation
                     * @property {Array.<number>|null} [path] Annotation path
                     * @property {string|null} [sourceFile] Annotation sourceFile
                     * @property {number|null} [begin] Annotation begin
                     * @property {number|null} [end] Annotation end
                     * @property {google.protobuf.GeneratedCodeInfo.Annotation.Semantic|null} [semantic] Annotation semantic
                     */
    
                    /**
                     * Constructs a new Annotation.
                     * @memberof google.protobuf.GeneratedCodeInfo
                     * @classdesc Represents an Annotation.
                     * @implements IAnnotation
                     * @constructor
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation=} [properties] Properties to set
                     */
                    function Annotation(properties) {
                        this.path = [];
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * Annotation path.
                     * @member {Array.<number>} path
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.path = $util.emptyArray;
    
                    /**
                     * Annotation sourceFile.
                     * @member {string} sourceFile
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.sourceFile = "";
    
                    /**
                     * Annotation begin.
                     * @member {number} begin
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.begin = 0;
    
                    /**
                     * Annotation end.
                     * @member {number} end
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.end = 0;
    
                    /**
                     * Annotation semantic.
                     * @member {google.protobuf.GeneratedCodeInfo.Annotation.Semantic} semantic
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.semantic = 0;
    
                    /**
                     * Creates a new Annotation instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation=} [properties] Properties to set
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation instance
                     */
                    Annotation.create = function create(properties) {
                        return new Annotation(properties);
                    };
    
                    /**
                     * Encodes the specified Annotation message. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.Annotation.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation} message Annotation message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Annotation.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.path != null && message.path.length) {
                            writer.uint32(/* id 1, wireType 2 =*/10).fork();
                            for (var i = 0; i < message.path.length; ++i)
                                writer.int32(message.path[i]);
                            writer.ldelim();
                        }
                        if (message.sourceFile != null && Object.hasOwnProperty.call(message, "sourceFile"))
                            writer.uint32(/* id 2, wireType 2 =*/18).string(message.sourceFile);
                        if (message.begin != null && Object.hasOwnProperty.call(message, "begin"))
                            writer.uint32(/* id 3, wireType 0 =*/24).int32(message.begin);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 4, wireType 0 =*/32).int32(message.end);
                        if (message.semantic != null && Object.hasOwnProperty.call(message, "semantic"))
                            writer.uint32(/* id 5, wireType 0 =*/40).int32(message.semantic);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified Annotation message, length delimited. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.Annotation.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation} message Annotation message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Annotation.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes an Annotation message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Annotation.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.GeneratedCodeInfo.Annotation();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    if (!(message.path && message.path.length))
                                        message.path = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.path.push(reader.int32());
                                    } else
                                        message.path.push(reader.int32());
                                    break;
                                }
                            case 2: {
                                    message.sourceFile = reader.string();
                                    break;
                                }
                            case 3: {
                                    message.begin = reader.int32();
                                    break;
                                }
                            case 4: {
                                    message.end = reader.int32();
                                    break;
                                }
                            case 5: {
                                    message.semantic = reader.int32();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes an Annotation message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Annotation.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies an Annotation message.
                     * @function verify
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    Annotation.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.path != null && message.hasOwnProperty("path")) {
                            if (!Array.isArray(message.path))
                                return "path: array expected";
                            for (var i = 0; i < message.path.length; ++i)
                                if (!$util.isInteger(message.path[i]))
                                    return "path: integer[] expected";
                        }
                        if (message.sourceFile != null && message.hasOwnProperty("sourceFile"))
                            if (!$util.isString(message.sourceFile))
                                return "sourceFile: string expected";
                        if (message.begin != null && message.hasOwnProperty("begin"))
                            if (!$util.isInteger(message.begin))
                                return "begin: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        if (message.semantic != null && message.hasOwnProperty("semantic"))
                            switch (message.semantic) {
                            default:
                                return "semantic: enum value expected";
                            case 0:
                            case 1:
                            case 2:
                                break;
                            }
                        return null;
                    };
    
                    /**
                     * Creates an Annotation message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                     */
                    Annotation.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.GeneratedCodeInfo.Annotation)
                            return object;
                        var message = new $root.google.protobuf.GeneratedCodeInfo.Annotation();
                        if (object.path) {
                            if (!Array.isArray(object.path))
                                throw TypeError(".google.protobuf.GeneratedCodeInfo.Annotation.path: array expected");
                            message.path = [];
                            for (var i = 0; i < object.path.length; ++i)
                                message.path[i] = object.path[i] | 0;
                        }
                        if (object.sourceFile != null)
                            message.sourceFile = String(object.sourceFile);
                        if (object.begin != null)
                            message.begin = object.begin | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        switch (object.semantic) {
                        default:
                            if (typeof object.semantic === "number") {
                                message.semantic = object.semantic;
                                break;
                            }
                            break;
                        case "NONE":
                        case 0:
                            message.semantic = 0;
                            break;
                        case "SET":
                        case 1:
                            message.semantic = 1;
                            break;
                        case "ALIAS":
                        case 2:
                            message.semantic = 2;
                            break;
                        }
                        return message;
                    };
    
                    /**
                     * Creates a plain object from an Annotation message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.Annotation} message Annotation
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    Annotation.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.arrays || options.defaults)
                            object.path = [];
                        if (options.defaults) {
                            object.sourceFile = "";
                            object.begin = 0;
                            object.end = 0;
                            object.semantic = options.enums === String ? "NONE" : 0;
                        }
                        if (message.path && message.path.length) {
                            object.path = [];
                            for (var j = 0; j < message.path.length; ++j)
                                object.path[j] = message.path[j];
                        }
                        if (message.sourceFile != null && message.hasOwnProperty("sourceFile"))
                            object.sourceFile = message.sourceFile;
                        if (message.begin != null && message.hasOwnProperty("begin"))
                            object.begin = message.begin;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        if (message.semantic != null && message.hasOwnProperty("semantic"))
                            object.semantic = options.enums === String ? $root.google.protobuf.GeneratedCodeInfo.Annotation.Semantic[message.semantic] === undefined ? message.semantic : $root.google.protobuf.GeneratedCodeInfo.Annotation.Semantic[message.semantic] : message.semantic;
                        return object;
                    };
    
                    /**
                     * Converts this Annotation to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    Annotation.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for Annotation
                     * @function getTypeUrl
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    Annotation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.GeneratedCodeInfo.Annotation";
                    };
    
                    /**
                     * Semantic enum.
                     * @name google.protobuf.GeneratedCodeInfo.Annotation.Semantic
                     * @enum {number}
                     * @property {number} NONE=0 NONE value
                     * @property {number} SET=1 SET value
                     * @property {number} ALIAS=2 ALIAS value
                     */
                    Annotation.Semantic = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "NONE"] = 0;
                        values[valuesById[1] = "SET"] = 1;
                        values[valuesById[2] = "ALIAS"] = 2;
                        return values;
                    })();
    
                    return Annotation;
                })();
    
                return GeneratedCodeInfo;
            })();
    
            protobuf.Duration = (function() {
    
                /**
                 * Properties of a Duration.
                 * @memberof google.protobuf
                 * @interface IDuration
                 * @property {number|Long|null} [seconds] Duration seconds
                 * @property {number|null} [nanos] Duration nanos
                 */
    
                /**
                 * Constructs a new Duration.
                 * @memberof google.protobuf
                 * @classdesc Represents a Duration.
                 * @implements IDuration
                 * @constructor
                 * @param {google.protobuf.IDuration=} [properties] Properties to set
                 */
                function Duration(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Duration seconds.
                 * @member {number|Long} seconds
                 * @memberof google.protobuf.Duration
                 * @instance
                 */
                Duration.prototype.seconds = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                /**
                 * Duration nanos.
                 * @member {number} nanos
                 * @memberof google.protobuf.Duration
                 * @instance
                 */
                Duration.prototype.nanos = 0;
    
                /**
                 * Creates a new Duration instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {google.protobuf.IDuration=} [properties] Properties to set
                 * @returns {google.protobuf.Duration} Duration instance
                 */
                Duration.create = function create(properties) {
                    return new Duration(properties);
                };
    
                /**
                 * Encodes the specified Duration message. Does not implicitly {@link google.protobuf.Duration.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {google.protobuf.IDuration} message Duration message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Duration.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.seconds != null && Object.hasOwnProperty.call(message, "seconds"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int64(message.seconds);
                    if (message.nanos != null && Object.hasOwnProperty.call(message, "nanos"))
                        writer.uint32(/* id 2, wireType 0 =*/16).int32(message.nanos);
                    return writer;
                };
    
                /**
                 * Encodes the specified Duration message, length delimited. Does not implicitly {@link google.protobuf.Duration.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {google.protobuf.IDuration} message Duration message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Duration.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a Duration message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.Duration} Duration
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Duration.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Duration();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.seconds = reader.int64();
                                break;
                            }
                        case 2: {
                                message.nanos = reader.int32();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a Duration message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.Duration} Duration
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Duration.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a Duration message.
                 * @function verify
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Duration.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.seconds != null && message.hasOwnProperty("seconds"))
                        if (!$util.isInteger(message.seconds) && !(message.seconds && $util.isInteger(message.seconds.low) && $util.isInteger(message.seconds.high)))
                            return "seconds: integer|Long expected";
                    if (message.nanos != null && message.hasOwnProperty("nanos"))
                        if (!$util.isInteger(message.nanos))
                            return "nanos: integer expected";
                    return null;
                };
    
                /**
                 * Creates a Duration message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.Duration} Duration
                 */
                Duration.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.Duration)
                        return object;
                    var message = new $root.google.protobuf.Duration();
                    if (object.seconds != null)
                        if ($util.Long)
                            (message.seconds = $util.Long.fromValue(object.seconds)).unsigned = false;
                        else if (typeof object.seconds === "string")
                            message.seconds = parseInt(object.seconds, 10);
                        else if (typeof object.seconds === "number")
                            message.seconds = object.seconds;
                        else if (typeof object.seconds === "object")
                            message.seconds = new $util.LongBits(object.seconds.low >>> 0, object.seconds.high >>> 0).toNumber();
                    if (object.nanos != null)
                        message.nanos = object.nanos | 0;
                    return message;
                };
    
                /**
                 * Creates a plain object from a Duration message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {google.protobuf.Duration} message Duration
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Duration.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, false);
                            object.seconds = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.seconds = options.longs === String ? "0" : 0;
                        object.nanos = 0;
                    }
                    if (message.seconds != null && message.hasOwnProperty("seconds"))
                        if (typeof message.seconds === "number")
                            object.seconds = options.longs === String ? String(message.seconds) : message.seconds;
                        else
                            object.seconds = options.longs === String ? $util.Long.prototype.toString.call(message.seconds) : options.longs === Number ? new $util.LongBits(message.seconds.low >>> 0, message.seconds.high >>> 0).toNumber() : message.seconds;
                    if (message.nanos != null && message.hasOwnProperty("nanos"))
                        object.nanos = message.nanos;
                    return object;
                };
    
                /**
                 * Converts this Duration to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.Duration
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Duration.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Duration
                 * @function getTypeUrl
                 * @memberof google.protobuf.Duration
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Duration.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.Duration";
                };
    
                return Duration;
            })();
    
            protobuf.Timestamp = (function() {
    
                /**
                 * Properties of a Timestamp.
                 * @memberof google.protobuf
                 * @interface ITimestamp
                 * @property {number|Long|null} [seconds] Timestamp seconds
                 * @property {number|null} [nanos] Timestamp nanos
                 */
    
                /**
                 * Constructs a new Timestamp.
                 * @memberof google.protobuf
                 * @classdesc Represents a Timestamp.
                 * @implements ITimestamp
                 * @constructor
                 * @param {google.protobuf.ITimestamp=} [properties] Properties to set
                 */
                function Timestamp(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Timestamp seconds.
                 * @member {number|Long} seconds
                 * @memberof google.protobuf.Timestamp
                 * @instance
                 */
                Timestamp.prototype.seconds = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                /**
                 * Timestamp nanos.
                 * @member {number} nanos
                 * @memberof google.protobuf.Timestamp
                 * @instance
                 */
                Timestamp.prototype.nanos = 0;
    
                /**
                 * Creates a new Timestamp instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {google.protobuf.ITimestamp=} [properties] Properties to set
                 * @returns {google.protobuf.Timestamp} Timestamp instance
                 */
                Timestamp.create = function create(properties) {
                    return new Timestamp(properties);
                };
    
                /**
                 * Encodes the specified Timestamp message. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {google.protobuf.ITimestamp} message Timestamp message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Timestamp.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.seconds != null && Object.hasOwnProperty.call(message, "seconds"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int64(message.seconds);
                    if (message.nanos != null && Object.hasOwnProperty.call(message, "nanos"))
                        writer.uint32(/* id 2, wireType 0 =*/16).int32(message.nanos);
                    return writer;
                };
    
                /**
                 * Encodes the specified Timestamp message, length delimited. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {google.protobuf.ITimestamp} message Timestamp message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Timestamp.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a Timestamp message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.Timestamp} Timestamp
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Timestamp.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Timestamp();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.seconds = reader.int64();
                                break;
                            }
                        case 2: {
                                message.nanos = reader.int32();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a Timestamp message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.Timestamp} Timestamp
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Timestamp.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a Timestamp message.
                 * @function verify
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Timestamp.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.seconds != null && message.hasOwnProperty("seconds"))
                        if (!$util.isInteger(message.seconds) && !(message.seconds && $util.isInteger(message.seconds.low) && $util.isInteger(message.seconds.high)))
                            return "seconds: integer|Long expected";
                    if (message.nanos != null && message.hasOwnProperty("nanos"))
                        if (!$util.isInteger(message.nanos))
                            return "nanos: integer expected";
                    return null;
                };
    
                /**
                 * Creates a Timestamp message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.Timestamp} Timestamp
                 */
                Timestamp.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.Timestamp)
                        return object;
                    var message = new $root.google.protobuf.Timestamp();
                    if (object.seconds != null)
                        if ($util.Long)
                            (message.seconds = $util.Long.fromValue(object.seconds)).unsigned = false;
                        else if (typeof object.seconds === "string")
                            message.seconds = parseInt(object.seconds, 10);
                        else if (typeof object.seconds === "number")
                            message.seconds = object.seconds;
                        else if (typeof object.seconds === "object")
                            message.seconds = new $util.LongBits(object.seconds.low >>> 0, object.seconds.high >>> 0).toNumber();
                    if (object.nanos != null)
                        message.nanos = object.nanos | 0;
                    return message;
                };
    
                /**
                 * Creates a plain object from a Timestamp message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {google.protobuf.Timestamp} message Timestamp
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Timestamp.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, false);
                            object.seconds = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.seconds = options.longs === String ? "0" : 0;
                        object.nanos = 0;
                    }
                    if (message.seconds != null && message.hasOwnProperty("seconds"))
                        if (typeof message.seconds === "number")
                            object.seconds = options.longs === String ? String(message.seconds) : message.seconds;
                        else
                            object.seconds = options.longs === String ? $util.Long.prototype.toString.call(message.seconds) : options.longs === Number ? new $util.LongBits(message.seconds.low >>> 0, message.seconds.high >>> 0).toNumber() : message.seconds;
                    if (message.nanos != null && message.hasOwnProperty("nanos"))
                        object.nanos = message.nanos;
                    return object;
                };
    
                /**
                 * Converts this Timestamp to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.Timestamp
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Timestamp.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Timestamp
                 * @function getTypeUrl
                 * @memberof google.protobuf.Timestamp
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Timestamp.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.Timestamp";
                };
    
                return Timestamp;
            })();
    
            protobuf.DoubleValue = (function() {
    
                /**
                 * Properties of a DoubleValue.
                 * @memberof google.protobuf
                 * @interface IDoubleValue
                 * @property {number|null} [value] DoubleValue value
                 */
    
                /**
                 * Constructs a new DoubleValue.
                 * @memberof google.protobuf
                 * @classdesc Represents a DoubleValue.
                 * @implements IDoubleValue
                 * @constructor
                 * @param {google.protobuf.IDoubleValue=} [properties] Properties to set
                 */
                function DoubleValue(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * DoubleValue value.
                 * @member {number} value
                 * @memberof google.protobuf.DoubleValue
                 * @instance
                 */
                DoubleValue.prototype.value = 0;
    
                /**
                 * Creates a new DoubleValue instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {google.protobuf.IDoubleValue=} [properties] Properties to set
                 * @returns {google.protobuf.DoubleValue} DoubleValue instance
                 */
                DoubleValue.create = function create(properties) {
                    return new DoubleValue(properties);
                };
    
                /**
                 * Encodes the specified DoubleValue message. Does not implicitly {@link google.protobuf.DoubleValue.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {google.protobuf.IDoubleValue} message DoubleValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DoubleValue.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 1 =*/9).double(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified DoubleValue message, length delimited. Does not implicitly {@link google.protobuf.DoubleValue.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {google.protobuf.IDoubleValue} message DoubleValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DoubleValue.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a DoubleValue message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.DoubleValue} DoubleValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DoubleValue.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DoubleValue();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.double();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a DoubleValue message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.DoubleValue} DoubleValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DoubleValue.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a DoubleValue message.
                 * @function verify
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                DoubleValue.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (typeof message.value !== "number")
                            return "value: number expected";
                    return null;
                };
    
                /**
                 * Creates a DoubleValue message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.DoubleValue} DoubleValue
                 */
                DoubleValue.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.DoubleValue)
                        return object;
                    var message = new $root.google.protobuf.DoubleValue();
                    if (object.value != null)
                        message.value = Number(object.value);
                    return message;
                };
    
                /**
                 * Creates a plain object from a DoubleValue message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {google.protobuf.DoubleValue} message DoubleValue
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                DoubleValue.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.value = 0;
                    if (message.value != null && message.hasOwnProperty("value"))
                        object.value = options.json && !isFinite(message.value) ? String(message.value) : message.value;
                    return object;
                };
    
                /**
                 * Converts this DoubleValue to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.DoubleValue
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                DoubleValue.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for DoubleValue
                 * @function getTypeUrl
                 * @memberof google.protobuf.DoubleValue
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                DoubleValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.DoubleValue";
                };
    
                return DoubleValue;
            })();
    
            protobuf.FloatValue = (function() {
    
                /**
                 * Properties of a FloatValue.
                 * @memberof google.protobuf
                 * @interface IFloatValue
                 * @property {number|null} [value] FloatValue value
                 */
    
                /**
                 * Constructs a new FloatValue.
                 * @memberof google.protobuf
                 * @classdesc Represents a FloatValue.
                 * @implements IFloatValue
                 * @constructor
                 * @param {google.protobuf.IFloatValue=} [properties] Properties to set
                 */
                function FloatValue(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FloatValue value.
                 * @member {number} value
                 * @memberof google.protobuf.FloatValue
                 * @instance
                 */
                FloatValue.prototype.value = 0;
    
                /**
                 * Creates a new FloatValue instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {google.protobuf.IFloatValue=} [properties] Properties to set
                 * @returns {google.protobuf.FloatValue} FloatValue instance
                 */
                FloatValue.create = function create(properties) {
                    return new FloatValue(properties);
                };
    
                /**
                 * Encodes the specified FloatValue message. Does not implicitly {@link google.protobuf.FloatValue.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {google.protobuf.IFloatValue} message FloatValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FloatValue.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 5 =*/13).float(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified FloatValue message, length delimited. Does not implicitly {@link google.protobuf.FloatValue.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {google.protobuf.IFloatValue} message FloatValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FloatValue.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FloatValue message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FloatValue} FloatValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FloatValue.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FloatValue();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.float();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FloatValue message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FloatValue} FloatValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FloatValue.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FloatValue message.
                 * @function verify
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FloatValue.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (typeof message.value !== "number")
                            return "value: number expected";
                    return null;
                };
    
                /**
                 * Creates a FloatValue message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FloatValue} FloatValue
                 */
                FloatValue.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FloatValue)
                        return object;
                    var message = new $root.google.protobuf.FloatValue();
                    if (object.value != null)
                        message.value = Number(object.value);
                    return message;
                };
    
                /**
                 * Creates a plain object from a FloatValue message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {google.protobuf.FloatValue} message FloatValue
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FloatValue.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.value = 0;
                    if (message.value != null && message.hasOwnProperty("value"))
                        object.value = options.json && !isFinite(message.value) ? String(message.value) : message.value;
                    return object;
                };
    
                /**
                 * Converts this FloatValue to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FloatValue
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FloatValue.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FloatValue
                 * @function getTypeUrl
                 * @memberof google.protobuf.FloatValue
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FloatValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FloatValue";
                };
    
                return FloatValue;
            })();
    
            protobuf.Int64Value = (function() {
    
                /**
                 * Properties of an Int64Value.
                 * @memberof google.protobuf
                 * @interface IInt64Value
                 * @property {number|Long|null} [value] Int64Value value
                 */
    
                /**
                 * Constructs a new Int64Value.
                 * @memberof google.protobuf
                 * @classdesc Represents an Int64Value.
                 * @implements IInt64Value
                 * @constructor
                 * @param {google.protobuf.IInt64Value=} [properties] Properties to set
                 */
                function Int64Value(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Int64Value value.
                 * @member {number|Long} value
                 * @memberof google.protobuf.Int64Value
                 * @instance
                 */
                Int64Value.prototype.value = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                /**
                 * Creates a new Int64Value instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {google.protobuf.IInt64Value=} [properties] Properties to set
                 * @returns {google.protobuf.Int64Value} Int64Value instance
                 */
                Int64Value.create = function create(properties) {
                    return new Int64Value(properties);
                };
    
                /**
                 * Encodes the specified Int64Value message. Does not implicitly {@link google.protobuf.Int64Value.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {google.protobuf.IInt64Value} message Int64Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Int64Value.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int64(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified Int64Value message, length delimited. Does not implicitly {@link google.protobuf.Int64Value.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {google.protobuf.IInt64Value} message Int64Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Int64Value.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an Int64Value message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.Int64Value} Int64Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Int64Value.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Int64Value();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.int64();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an Int64Value message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.Int64Value} Int64Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Int64Value.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an Int64Value message.
                 * @function verify
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Int64Value.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (!$util.isInteger(message.value) && !(message.value && $util.isInteger(message.value.low) && $util.isInteger(message.value.high)))
                            return "value: integer|Long expected";
                    return null;
                };
    
                /**
                 * Creates an Int64Value message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.Int64Value} Int64Value
                 */
                Int64Value.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.Int64Value)
                        return object;
                    var message = new $root.google.protobuf.Int64Value();
                    if (object.value != null)
                        if ($util.Long)
                            (message.value = $util.Long.fromValue(object.value)).unsigned = false;
                        else if (typeof object.value === "string")
                            message.value = parseInt(object.value, 10);
                        else if (typeof object.value === "number")
                            message.value = object.value;
                        else if (typeof object.value === "object")
                            message.value = new $util.LongBits(object.value.low >>> 0, object.value.high >>> 0).toNumber();
                    return message;
                };
    
                /**
                 * Creates a plain object from an Int64Value message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {google.protobuf.Int64Value} message Int64Value
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Int64Value.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, false);
                            object.value = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.value = options.longs === String ? "0" : 0;
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (typeof message.value === "number")
                            object.value = options.longs === String ? String(message.value) : message.value;
                        else
                            object.value = options.longs === String ? $util.Long.prototype.toString.call(message.value) : options.longs === Number ? new $util.LongBits(message.value.low >>> 0, message.value.high >>> 0).toNumber() : message.value;
                    return object;
                };
    
                /**
                 * Converts this Int64Value to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.Int64Value
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Int64Value.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Int64Value
                 * @function getTypeUrl
                 * @memberof google.protobuf.Int64Value
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Int64Value.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.Int64Value";
                };
    
                return Int64Value;
            })();
    
            protobuf.UInt64Value = (function() {
    
                /**
                 * Properties of a UInt64Value.
                 * @memberof google.protobuf
                 * @interface IUInt64Value
                 * @property {number|Long|null} [value] UInt64Value value
                 */
    
                /**
                 * Constructs a new UInt64Value.
                 * @memberof google.protobuf
                 * @classdesc Represents a UInt64Value.
                 * @implements IUInt64Value
                 * @constructor
                 * @param {google.protobuf.IUInt64Value=} [properties] Properties to set
                 */
                function UInt64Value(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * UInt64Value value.
                 * @member {number|Long} value
                 * @memberof google.protobuf.UInt64Value
                 * @instance
                 */
                UInt64Value.prototype.value = $util.Long ? $util.Long.fromBits(0,0,true) : 0;
    
                /**
                 * Creates a new UInt64Value instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {google.protobuf.IUInt64Value=} [properties] Properties to set
                 * @returns {google.protobuf.UInt64Value} UInt64Value instance
                 */
                UInt64Value.create = function create(properties) {
                    return new UInt64Value(properties);
                };
    
                /**
                 * Encodes the specified UInt64Value message. Does not implicitly {@link google.protobuf.UInt64Value.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {google.protobuf.IUInt64Value} message UInt64Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UInt64Value.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 0 =*/8).uint64(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified UInt64Value message, length delimited. Does not implicitly {@link google.protobuf.UInt64Value.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {google.protobuf.IUInt64Value} message UInt64Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UInt64Value.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a UInt64Value message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.UInt64Value} UInt64Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UInt64Value.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UInt64Value();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.uint64();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a UInt64Value message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.UInt64Value} UInt64Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UInt64Value.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a UInt64Value message.
                 * @function verify
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                UInt64Value.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (!$util.isInteger(message.value) && !(message.value && $util.isInteger(message.value.low) && $util.isInteger(message.value.high)))
                            return "value: integer|Long expected";
                    return null;
                };
    
                /**
                 * Creates a UInt64Value message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.UInt64Value} UInt64Value
                 */
                UInt64Value.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.UInt64Value)
                        return object;
                    var message = new $root.google.protobuf.UInt64Value();
                    if (object.value != null)
                        if ($util.Long)
                            (message.value = $util.Long.fromValue(object.value)).unsigned = true;
                        else if (typeof object.value === "string")
                            message.value = parseInt(object.value, 10);
                        else if (typeof object.value === "number")
                            message.value = object.value;
                        else if (typeof object.value === "object")
                            message.value = new $util.LongBits(object.value.low >>> 0, object.value.high >>> 0).toNumber(true);
                    return message;
                };
    
                /**
                 * Creates a plain object from a UInt64Value message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {google.protobuf.UInt64Value} message UInt64Value
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                UInt64Value.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, true);
                            object.value = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.value = options.longs === String ? "0" : 0;
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (typeof message.value === "number")
                            object.value = options.longs === String ? String(message.value) : message.value;
                        else
                            object.value = options.longs === String ? $util.Long.prototype.toString.call(message.value) : options.longs === Number ? new $util.LongBits(message.value.low >>> 0, message.value.high >>> 0).toNumber(true) : message.value;
                    return object;
                };
    
                /**
                 * Converts this UInt64Value to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.UInt64Value
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                UInt64Value.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for UInt64Value
                 * @function getTypeUrl
                 * @memberof google.protobuf.UInt64Value
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                UInt64Value.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.UInt64Value";
                };
    
                return UInt64Value;
            })();
    
            protobuf.Int32Value = (function() {
    
                /**
                 * Properties of an Int32Value.
                 * @memberof google.protobuf
                 * @interface IInt32Value
                 * @property {number|null} [value] Int32Value value
                 */
    
                /**
                 * Constructs a new Int32Value.
                 * @memberof google.protobuf
                 * @classdesc Represents an Int32Value.
                 * @implements IInt32Value
                 * @constructor
                 * @param {google.protobuf.IInt32Value=} [properties] Properties to set
                 */
                function Int32Value(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Int32Value value.
                 * @member {number} value
                 * @memberof google.protobuf.Int32Value
                 * @instance
                 */
                Int32Value.prototype.value = 0;
    
                /**
                 * Creates a new Int32Value instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {google.protobuf.IInt32Value=} [properties] Properties to set
                 * @returns {google.protobuf.Int32Value} Int32Value instance
                 */
                Int32Value.create = function create(properties) {
                    return new Int32Value(properties);
                };
    
                /**
                 * Encodes the specified Int32Value message. Does not implicitly {@link google.protobuf.Int32Value.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {google.protobuf.IInt32Value} message Int32Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Int32Value.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int32(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified Int32Value message, length delimited. Does not implicitly {@link google.protobuf.Int32Value.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {google.protobuf.IInt32Value} message Int32Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Int32Value.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an Int32Value message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.Int32Value} Int32Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Int32Value.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Int32Value();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.int32();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an Int32Value message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.Int32Value} Int32Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Int32Value.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an Int32Value message.
                 * @function verify
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Int32Value.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (!$util.isInteger(message.value))
                            return "value: integer expected";
                    return null;
                };
    
                /**
                 * Creates an Int32Value message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.Int32Value} Int32Value
                 */
                Int32Value.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.Int32Value)
                        return object;
                    var message = new $root.google.protobuf.Int32Value();
                    if (object.value != null)
                        message.value = object.value | 0;
                    return message;
                };
    
                /**
                 * Creates a plain object from an Int32Value message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {google.protobuf.Int32Value} message Int32Value
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Int32Value.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.value = 0;
                    if (message.value != null && message.hasOwnProperty("value"))
                        object.value = message.value;
                    return object;
                };
    
                /**
                 * Converts this Int32Value to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.Int32Value
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Int32Value.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Int32Value
                 * @function getTypeUrl
                 * @memberof google.protobuf.Int32Value
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Int32Value.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.Int32Value";
                };
    
                return Int32Value;
            })();
    
            protobuf.UInt32Value = (function() {
    
                /**
                 * Properties of a UInt32Value.
                 * @memberof google.protobuf
                 * @interface IUInt32Value
                 * @property {number|null} [value] UInt32Value value
                 */
    
                /**
                 * Constructs a new UInt32Value.
                 * @memberof google.protobuf
                 * @classdesc Represents a UInt32Value.
                 * @implements IUInt32Value
                 * @constructor
                 * @param {google.protobuf.IUInt32Value=} [properties] Properties to set
                 */
                function UInt32Value(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * UInt32Value value.
                 * @member {number} value
                 * @memberof google.protobuf.UInt32Value
                 * @instance
                 */
                UInt32Value.prototype.value = 0;
    
                /**
                 * Creates a new UInt32Value instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {google.protobuf.IUInt32Value=} [properties] Properties to set
                 * @returns {google.protobuf.UInt32Value} UInt32Value instance
                 */
                UInt32Value.create = function create(properties) {
                    return new UInt32Value(properties);
                };
    
                /**
                 * Encodes the specified UInt32Value message. Does not implicitly {@link google.protobuf.UInt32Value.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {google.protobuf.IUInt32Value} message UInt32Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UInt32Value.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 0 =*/8).uint32(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified UInt32Value message, length delimited. Does not implicitly {@link google.protobuf.UInt32Value.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {google.protobuf.IUInt32Value} message UInt32Value message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UInt32Value.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a UInt32Value message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.UInt32Value} UInt32Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UInt32Value.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UInt32Value();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.uint32();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a UInt32Value message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.UInt32Value} UInt32Value
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UInt32Value.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a UInt32Value message.
                 * @function verify
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                UInt32Value.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (!$util.isInteger(message.value))
                            return "value: integer expected";
                    return null;
                };
    
                /**
                 * Creates a UInt32Value message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.UInt32Value} UInt32Value
                 */
                UInt32Value.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.UInt32Value)
                        return object;
                    var message = new $root.google.protobuf.UInt32Value();
                    if (object.value != null)
                        message.value = object.value >>> 0;
                    return message;
                };
    
                /**
                 * Creates a plain object from a UInt32Value message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {google.protobuf.UInt32Value} message UInt32Value
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                UInt32Value.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.value = 0;
                    if (message.value != null && message.hasOwnProperty("value"))
                        object.value = message.value;
                    return object;
                };
    
                /**
                 * Converts this UInt32Value to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.UInt32Value
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                UInt32Value.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for UInt32Value
                 * @function getTypeUrl
                 * @memberof google.protobuf.UInt32Value
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                UInt32Value.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.UInt32Value";
                };
    
                return UInt32Value;
            })();
    
            protobuf.BoolValue = (function() {
    
                /**
                 * Properties of a BoolValue.
                 * @memberof google.protobuf
                 * @interface IBoolValue
                 * @property {boolean|null} [value] BoolValue value
                 */
    
                /**
                 * Constructs a new BoolValue.
                 * @memberof google.protobuf
                 * @classdesc Represents a BoolValue.
                 * @implements IBoolValue
                 * @constructor
                 * @param {google.protobuf.IBoolValue=} [properties] Properties to set
                 */
                function BoolValue(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * BoolValue value.
                 * @member {boolean} value
                 * @memberof google.protobuf.BoolValue
                 * @instance
                 */
                BoolValue.prototype.value = false;
    
                /**
                 * Creates a new BoolValue instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {google.protobuf.IBoolValue=} [properties] Properties to set
                 * @returns {google.protobuf.BoolValue} BoolValue instance
                 */
                BoolValue.create = function create(properties) {
                    return new BoolValue(properties);
                };
    
                /**
                 * Encodes the specified BoolValue message. Does not implicitly {@link google.protobuf.BoolValue.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {google.protobuf.IBoolValue} message BoolValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                BoolValue.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 0 =*/8).bool(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified BoolValue message, length delimited. Does not implicitly {@link google.protobuf.BoolValue.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {google.protobuf.IBoolValue} message BoolValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                BoolValue.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a BoolValue message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.BoolValue} BoolValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                BoolValue.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.BoolValue();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.bool();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a BoolValue message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.BoolValue} BoolValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                BoolValue.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a BoolValue message.
                 * @function verify
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                BoolValue.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (typeof message.value !== "boolean")
                            return "value: boolean expected";
                    return null;
                };
    
                /**
                 * Creates a BoolValue message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.BoolValue} BoolValue
                 */
                BoolValue.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.BoolValue)
                        return object;
                    var message = new $root.google.protobuf.BoolValue();
                    if (object.value != null)
                        message.value = Boolean(object.value);
                    return message;
                };
    
                /**
                 * Creates a plain object from a BoolValue message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {google.protobuf.BoolValue} message BoolValue
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                BoolValue.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.value = false;
                    if (message.value != null && message.hasOwnProperty("value"))
                        object.value = message.value;
                    return object;
                };
    
                /**
                 * Converts this BoolValue to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.BoolValue
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                BoolValue.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for BoolValue
                 * @function getTypeUrl
                 * @memberof google.protobuf.BoolValue
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                BoolValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.BoolValue";
                };
    
                return BoolValue;
            })();
    
            protobuf.StringValue = (function() {
    
                /**
                 * Properties of a StringValue.
                 * @memberof google.protobuf
                 * @interface IStringValue
                 * @property {string|null} [value] StringValue value
                 */
    
                /**
                 * Constructs a new StringValue.
                 * @memberof google.protobuf
                 * @classdesc Represents a StringValue.
                 * @implements IStringValue
                 * @constructor
                 * @param {google.protobuf.IStringValue=} [properties] Properties to set
                 */
                function StringValue(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * StringValue value.
                 * @member {string} value
                 * @memberof google.protobuf.StringValue
                 * @instance
                 */
                StringValue.prototype.value = "";
    
                /**
                 * Creates a new StringValue instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {google.protobuf.IStringValue=} [properties] Properties to set
                 * @returns {google.protobuf.StringValue} StringValue instance
                 */
                StringValue.create = function create(properties) {
                    return new StringValue(properties);
                };
    
                /**
                 * Encodes the specified StringValue message. Does not implicitly {@link google.protobuf.StringValue.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {google.protobuf.IStringValue} message StringValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                StringValue.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified StringValue message, length delimited. Does not implicitly {@link google.protobuf.StringValue.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {google.protobuf.IStringValue} message StringValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                StringValue.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a StringValue message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.StringValue} StringValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                StringValue.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.StringValue();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a StringValue message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.StringValue} StringValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                StringValue.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a StringValue message.
                 * @function verify
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                StringValue.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (!$util.isString(message.value))
                            return "value: string expected";
                    return null;
                };
    
                /**
                 * Creates a StringValue message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.StringValue} StringValue
                 */
                StringValue.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.StringValue)
                        return object;
                    var message = new $root.google.protobuf.StringValue();
                    if (object.value != null)
                        message.value = String(object.value);
                    return message;
                };
    
                /**
                 * Creates a plain object from a StringValue message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {google.protobuf.StringValue} message StringValue
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                StringValue.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.value = "";
                    if (message.value != null && message.hasOwnProperty("value"))
                        object.value = message.value;
                    return object;
                };
    
                /**
                 * Converts this StringValue to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.StringValue
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                StringValue.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for StringValue
                 * @function getTypeUrl
                 * @memberof google.protobuf.StringValue
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                StringValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.StringValue";
                };
    
                return StringValue;
            })();
    
            protobuf.BytesValue = (function() {
    
                /**
                 * Properties of a BytesValue.
                 * @memberof google.protobuf
                 * @interface IBytesValue
                 * @property {Uint8Array|null} [value] BytesValue value
                 */
    
                /**
                 * Constructs a new BytesValue.
                 * @memberof google.protobuf
                 * @classdesc Represents a BytesValue.
                 * @implements IBytesValue
                 * @constructor
                 * @param {google.protobuf.IBytesValue=} [properties] Properties to set
                 */
                function BytesValue(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * BytesValue value.
                 * @member {Uint8Array} value
                 * @memberof google.protobuf.BytesValue
                 * @instance
                 */
                BytesValue.prototype.value = $util.newBuffer([]);
    
                /**
                 * Creates a new BytesValue instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {google.protobuf.IBytesValue=} [properties] Properties to set
                 * @returns {google.protobuf.BytesValue} BytesValue instance
                 */
                BytesValue.create = function create(properties) {
                    return new BytesValue(properties);
                };
    
                /**
                 * Encodes the specified BytesValue message. Does not implicitly {@link google.protobuf.BytesValue.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {google.protobuf.IBytesValue} message BytesValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                BytesValue.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                        writer.uint32(/* id 1, wireType 2 =*/10).bytes(message.value);
                    return writer;
                };
    
                /**
                 * Encodes the specified BytesValue message, length delimited. Does not implicitly {@link google.protobuf.BytesValue.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {google.protobuf.IBytesValue} message BytesValue message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                BytesValue.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a BytesValue message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.BytesValue} BytesValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                BytesValue.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.BytesValue();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.value = reader.bytes();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a BytesValue message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.BytesValue} BytesValue
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                BytesValue.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a BytesValue message.
                 * @function verify
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                BytesValue.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.value != null && message.hasOwnProperty("value"))
                        if (!(message.value && typeof message.value.length === "number" || $util.isString(message.value)))
                            return "value: buffer expected";
                    return null;
                };
    
                /**
                 * Creates a BytesValue message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.BytesValue} BytesValue
                 */
                BytesValue.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.BytesValue)
                        return object;
                    var message = new $root.google.protobuf.BytesValue();
                    if (object.value != null)
                        if (typeof object.value === "string")
                            $util.base64.decode(object.value, message.value = $util.newBuffer($util.base64.length(object.value)), 0);
                        else if (object.value.length >= 0)
                            message.value = object.value;
                    return message;
                };
    
                /**
                 * Creates a plain object from a BytesValue message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {google.protobuf.BytesValue} message BytesValue
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                BytesValue.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        if (options.bytes === String)
                            object.value = "";
                        else {
                            object.value = [];
                            if (options.bytes !== Array)
                                object.value = $util.newBuffer(object.value);
                        }
                    if (message.value != null && message.hasOwnProperty("value"))
                        object.value = options.bytes === String ? $util.base64.encode(message.value, 0, message.value.length) : options.bytes === Array ? Array.prototype.slice.call(message.value) : message.value;
                    return object;
                };
    
                /**
                 * Converts this BytesValue to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.BytesValue
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                BytesValue.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for BytesValue
                 * @function getTypeUrl
                 * @memberof google.protobuf.BytesValue
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                BytesValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.BytesValue";
                };
    
                return BytesValue;
            })();
    
            protobuf.Empty = (function() {
    
                /**
                 * Properties of an Empty.
                 * @memberof google.protobuf
                 * @interface IEmpty
                 */
    
                /**
                 * Constructs a new Empty.
                 * @memberof google.protobuf
                 * @classdesc Represents an Empty.
                 * @implements IEmpty
                 * @constructor
                 * @param {google.protobuf.IEmpty=} [properties] Properties to set
                 */
                function Empty(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Creates a new Empty instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {google.protobuf.IEmpty=} [properties] Properties to set
                 * @returns {google.protobuf.Empty} Empty instance
                 */
                Empty.create = function create(properties) {
                    return new Empty(properties);
                };
    
                /**
                 * Encodes the specified Empty message. Does not implicitly {@link google.protobuf.Empty.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {google.protobuf.IEmpty} message Empty message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Empty.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    return writer;
                };
    
                /**
                 * Encodes the specified Empty message, length delimited. Does not implicitly {@link google.protobuf.Empty.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {google.protobuf.IEmpty} message Empty message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Empty.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an Empty message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.Empty} Empty
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Empty.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Empty();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an Empty message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.Empty} Empty
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Empty.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an Empty message.
                 * @function verify
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Empty.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    return null;
                };
    
                /**
                 * Creates an Empty message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.Empty} Empty
                 */
                Empty.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.Empty)
                        return object;
                    return new $root.google.protobuf.Empty();
                };
    
                /**
                 * Creates a plain object from an Empty message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {google.protobuf.Empty} message Empty
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Empty.toObject = function toObject() {
                    return {};
                };
    
                /**
                 * Converts this Empty to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.Empty
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Empty.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Empty
                 * @function getTypeUrl
                 * @memberof google.protobuf.Empty
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Empty.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.Empty";
                };
    
                return Empty;
            })();
    
            protobuf.FieldMask = (function() {
    
                /**
                 * Properties of a FieldMask.
                 * @memberof google.protobuf
                 * @interface IFieldMask
                 * @property {Array.<string>|null} [paths] FieldMask paths
                 */
    
                /**
                 * Constructs a new FieldMask.
                 * @memberof google.protobuf
                 * @classdesc Represents a FieldMask.
                 * @implements IFieldMask
                 * @constructor
                 * @param {google.protobuf.IFieldMask=} [properties] Properties to set
                 */
                function FieldMask(properties) {
                    this.paths = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FieldMask paths.
                 * @member {Array.<string>} paths
                 * @memberof google.protobuf.FieldMask
                 * @instance
                 */
                FieldMask.prototype.paths = $util.emptyArray;
    
                /**
                 * Creates a new FieldMask instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {google.protobuf.IFieldMask=} [properties] Properties to set
                 * @returns {google.protobuf.FieldMask} FieldMask instance
                 */
                FieldMask.create = function create(properties) {
                    return new FieldMask(properties);
                };
    
                /**
                 * Encodes the specified FieldMask message. Does not implicitly {@link google.protobuf.FieldMask.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {google.protobuf.IFieldMask} message FieldMask message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldMask.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.paths != null && message.paths.length)
                        for (var i = 0; i < message.paths.length; ++i)
                            writer.uint32(/* id 1, wireType 2 =*/10).string(message.paths[i]);
                    return writer;
                };
    
                /**
                 * Encodes the specified FieldMask message, length delimited. Does not implicitly {@link google.protobuf.FieldMask.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {google.protobuf.IFieldMask} message FieldMask message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldMask.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FieldMask message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FieldMask} FieldMask
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldMask.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldMask();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.paths && message.paths.length))
                                    message.paths = [];
                                message.paths.push(reader.string());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FieldMask message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FieldMask} FieldMask
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldMask.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FieldMask message.
                 * @function verify
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FieldMask.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.paths != null && message.hasOwnProperty("paths")) {
                        if (!Array.isArray(message.paths))
                            return "paths: array expected";
                        for (var i = 0; i < message.paths.length; ++i)
                            if (!$util.isString(message.paths[i]))
                                return "paths: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates a FieldMask message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FieldMask} FieldMask
                 */
                FieldMask.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FieldMask)
                        return object;
                    var message = new $root.google.protobuf.FieldMask();
                    if (object.paths) {
                        if (!Array.isArray(object.paths))
                            throw TypeError(".google.protobuf.FieldMask.paths: array expected");
                        message.paths = [];
                        for (var i = 0; i < object.paths.length; ++i)
                            message.paths[i] = String(object.paths[i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a FieldMask message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {google.protobuf.FieldMask} message FieldMask
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FieldMask.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.paths = [];
                    if (message.paths && message.paths.length) {
                        object.paths = [];
                        for (var j = 0; j < message.paths.length; ++j)
                            object.paths[j] = message.paths[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this FieldMask to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FieldMask
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FieldMask.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FieldMask
                 * @function getTypeUrl
                 * @memberof google.protobuf.FieldMask
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FieldMask.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FieldMask";
                };
    
                return FieldMask;
            })();
    
            return protobuf;
        })();
    
        return google;
    })();

    return $root;
});
